/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 96;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 95,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 94,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 93,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 92,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(896), /*)*//*default:*//*Label 157*/ GIMT_Encode4(413889),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3382),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36377),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50605),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(52434),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(52516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(52598),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(60344),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72123), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(79315), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(86839), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(96783),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97274),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(97765),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98033),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98183),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(98674), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(98707),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(107517),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(108567), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(111536), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(125062),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(126413),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(127405),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(128397),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(129889), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(131381),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(132373),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(133365),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(134357),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(135349),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(136341),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(137333), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138038),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(138743), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(139448), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(139499),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(249235), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(260555),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(260845),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(262282),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(262402), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(262643),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(264541),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(266195),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(268974),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(269754),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(270147), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(270923),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(271053), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(271546), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(279323), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(280368),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(280852),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(281336),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(281766),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(282196),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(282626), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(283056),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(284854),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(285592),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(289688), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(305961), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(306577),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(310084),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(310332),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(310520),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(311497),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(312474),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(316782),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(320468),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(320788),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(321108), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(321965),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(322247),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(322625),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(323003),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(323353),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(323703),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(324406), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(325109),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(325513),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(325917),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(326321),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(326725),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(327540),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(327706),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(327805), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(327821),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(333193),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(360590), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(363508), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(365828), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(365980), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(366654),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(366814),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(367128),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(367282), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(367773),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(368073),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(368564),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(369055), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(369546),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(370672),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(371288),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(375010), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(375626),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(391233), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(391533),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(391547),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(391568), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(391593), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(391903),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(392074),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(392245),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(392416),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(392587), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(393716),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(393919),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(394122),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(394325), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3230 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(394528), GIMT_Encode4(0),
     /*   3238 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(394668),
     /*   3242 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(395208),
     /*   3246 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(397031),
     /*   3250 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(397286),
     /*   3254 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(397541),
     /*   3258 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(397687),
     /*   3262 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(397866),
     /*   3266 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(399516),
     /*   3270 */ /*AArch64::G_FCMEQZ*//*Label 129*/ GIMT_Encode4(399855),
     /*   3274 */ /*AArch64::G_FCMGE*//*Label 130*/ GIMT_Encode4(400085),
     /*   3278 */ /*AArch64::G_FCMGEZ*//*Label 131*/ GIMT_Encode4(400749),
     /*   3282 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(400979),
     /*   3286 */ /*AArch64::G_FCMGTZ*//*Label 133*/ GIMT_Encode4(401643),
     /*   3290 */ /*AArch64::G_FCMLEZ*//*Label 134*/ GIMT_Encode4(401873),
     /*   3294 */ /*AArch64::G_FCMLTZ*//*Label 135*/ GIMT_Encode4(402103),
     /*   3298 */ /*AArch64::G_REV16*//*Label 136*/ GIMT_Encode4(402333),
     /*   3302 */ /*AArch64::G_REV32*//*Label 137*/ GIMT_Encode4(402487),
     /*   3306 */ /*AArch64::G_REV64*//*Label 138*/ GIMT_Encode4(402663),
     /*   3310 */ /*AArch64::G_SADDLP*//*Label 139*/ GIMT_Encode4(402937),
     /*   3314 */ /*AArch64::G_SADDLV*//*Label 140*/ GIMT_Encode4(403143),
     /*   3318 */ /*AArch64::G_SDOT*//*Label 141*/ GIMT_Encode4(403542),
     /*   3322 */ /*AArch64::G_SITOF*//*Label 142*/ GIMT_Encode4(403912),
     /*   3326 */ /*AArch64::G_SMULL*//*Label 143*/ GIMT_Encode4(404029),
     /*   3330 */ /*AArch64::G_TRN1*//*Label 144*/ GIMT_Encode4(405262),
     /*   3334 */ /*AArch64::G_TRN2*//*Label 145*/ GIMT_Encode4(406042),
     /*   3338 */ /*AArch64::G_UADDLP*//*Label 146*/ GIMT_Encode4(406822),
     /*   3342 */ /*AArch64::G_UADDLV*//*Label 147*/ GIMT_Encode4(407028),
     /*   3346 */ /*AArch64::G_UDOT*//*Label 148*/ GIMT_Encode4(407895),
     /*   3350 */ /*AArch64::G_UITOF*//*Label 149*/ GIMT_Encode4(408265),
     /*   3354 */ /*AArch64::G_UMULL*//*Label 150*/ GIMT_Encode4(408382),
     /*   3358 */ /*AArch64::G_UZP1*//*Label 151*/ GIMT_Encode4(409615),
     /*   3362 */ /*AArch64::G_UZP2*//*Label 152*/ GIMT_Encode4(410395),
     /*   3366 */ /*AArch64::G_VASHR*//*Label 153*/ GIMT_Encode4(411175),
     /*   3370 */ /*AArch64::G_VLSHR*//*Label 154*/ GIMT_Encode4(411873),
     /*   3374 */ /*AArch64::G_ZIP1*//*Label 155*/ GIMT_Encode4(412329),
     /*   3378 */ /*AArch64::G_ZIP2*//*Label 156*/ GIMT_Encode4(413109),
     /*   3382 */ // Label 0: @3382
     /*   3382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 171*/ GIMT_Encode4(36376),
     /*   3393 */ /*GILLT_s32*//*Label 158*/ GIMT_Encode4(3481),
     /*   3397 */ /*GILLT_s64*//*Label 159*/ GIMT_Encode4(6260), GIMT_Encode4(0),
     /*   3405 */ /*GILLT_v2s32*//*Label 160*/ GIMT_Encode4(11588),
     /*   3409 */ /*GILLT_v2s64*//*Label 161*/ GIMT_Encode4(15196),
     /*   3413 */ /*GILLT_v4s16*//*Label 162*/ GIMT_Encode4(21098),
     /*   3417 */ /*GILLT_v4s32*//*Label 163*/ GIMT_Encode4(24596),
     /*   3421 */ /*GILLT_v8s8*//*Label 164*/ GIMT_Encode4(30774),
     /*   3425 */ /*GILLT_v8s16*//*Label 165*/ GIMT_Encode4(31624),
     /*   3429 */ /*GILLT_v16s8*//*Label 166*/ GIMT_Encode4(35202), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3449 */ /*GILLT_nxv2s64*//*Label 167*/ GIMT_Encode4(35926), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3461 */ /*GILLT_nxv4s32*//*Label 168*/ GIMT_Encode4(36298), GIMT_Encode4(0),
     /*   3469 */ /*GILLT_nxv8s16*//*Label 169*/ GIMT_Encode4(36324), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv16s8*//*Label 170*/ GIMT_Encode4(36350),
     /*   3481 */ // Label 158: @3481
     /*   3481 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(6259),
     /*   3486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3492 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3525), // Rule ID 13132 //
     /*   3497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3512 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3523 */     GIR_RootConstrainSelectedInstOperands,
     /*   3524 */     // GIR_Coverage, 13132,
     /*   3524 */     GIR_EraseRootFromParent_Done,
     /*   3525 */   // Label 173: @3525
     /*   3525 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3677), // Rule ID 13559 //
     /*   3530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3557 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3560 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3565 */     // MIs[2] pattern
     /*   3565 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3568 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3579 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3579 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3582 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3586 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3605 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3608 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3612 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3620 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3676 */     // GIR_Coverage, 13559,
     /*   3676 */     GIR_EraseRootFromParent_Done,
     /*   3677 */   // Label 174: @3677
     /*   3677 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3829), // Rule ID 15410 //
     /*   3682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3709 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3712 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3717 */     // MIs[2] pattern
     /*   3717 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3720 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3731 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3757 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3764 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3811 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3828 */     // GIR_Coverage, 15410,
     /*   3828 */     GIR_EraseRootFromParent_Done,
     /*   3829 */   // Label 175: @3829
     /*   3829 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3981), // Rule ID 15422 //
     /*   3834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3861 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3864 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3869 */     // MIs[2] pattern
     /*   3869 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3872 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3883 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3883 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3886 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3890 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3897 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3900 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3904 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3909 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3912 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3916 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3953 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3963 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3980 */     // GIR_Coverage, 15422,
     /*   3980 */     GIR_EraseRootFromParent_Done,
     /*   3981 */   // Label 176: @3981
     /*   3981 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4133), // Rule ID 15434 //
     /*   3986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4013 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4016 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4021 */     // MIs[2] pattern
     /*   4021 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4024 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4035 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4035 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4038 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4042 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4061 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4064 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4068 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4105 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4132 */     // GIR_Coverage, 15434,
     /*   4132 */     GIR_EraseRootFromParent_Done,
     /*   4133 */   // Label 177: @4133
     /*   4133 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4166), // Rule ID 91 //
     /*   4138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4153 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4164 */     GIR_RootConstrainSelectedInstOperands,
     /*   4165 */     // GIR_Coverage, 91,
     /*   4165 */     GIR_EraseRootFromParent_Done,
     /*   4166 */   // Label 178: @4166
     /*   4166 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4318), // Rule ID 2656 //
     /*   4171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4202 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4205 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4210 */     // MIs[2] pattern
     /*   4210 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4213 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4220 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4220 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4223 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4227 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4246 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4249 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4253 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4300 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4317 */     // GIR_Coverage, 2656,
     /*   4317 */     GIR_EraseRootFromParent_Done,
     /*   4318 */   // Label 179: @4318
     /*   4318 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4470), // Rule ID 9890 //
     /*   4323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4354 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4357 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4362 */     // MIs[2] pattern
     /*   4362 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4365 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4372 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4372 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4375 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4379 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4398 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4401 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4405 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4452 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4469 */     // GIR_Coverage, 9890,
     /*   4469 */     GIR_EraseRootFromParent_Done,
     /*   4470 */   // Label 180: @4470
     /*   4470 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4622), // Rule ID 9902 //
     /*   4475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4506 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4509 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4514 */     // MIs[2] pattern
     /*   4514 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4517 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4524 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4550 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4553 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4557 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4621 */     // GIR_Coverage, 9902,
     /*   4621 */     GIR_EraseRootFromParent_Done,
     /*   4622 */   // Label 181: @4622
     /*   4622 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4774), // Rule ID 9914 //
     /*   4627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4666 */     // MIs[2] pattern
     /*   4666 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4669 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4676 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4773 */     // GIR_Coverage, 9914,
     /*   4773 */     GIR_EraseRootFromParent_Done,
     /*   4774 */   // Label 182: @4774
     /*   4774 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4931), // Rule ID 15453 //
     /*   4779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4806 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4809 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4818 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4825 */     // MIs[2] pred
     /*   4825 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4836 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4836 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4839 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4843 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4862 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4869 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4930 */     // GIR_Coverage, 15453,
     /*   4930 */     GIR_EraseRootFromParent_Done,
     /*   4931 */   // Label 183: @4931
     /*   4931 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5088), // Rule ID 15454 //
     /*   4936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4963 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4966 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4982 */     // MIs[2] pred
     /*   4982 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4993 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4993 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4996 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5000 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5019 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5026 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5034 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5070 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5087 */     // GIR_Coverage, 15454,
     /*   5087 */     GIR_EraseRootFromParent_Done,
     /*   5088 */   // Label 184: @5088
     /*   5088 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5245), // Rule ID 15455 //
     /*   5093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5120 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5123 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5139 */     // MIs[2] pred
     /*   5139 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5150 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5244 */     // GIR_Coverage, 15455,
     /*   5244 */     GIR_EraseRootFromParent_Done,
     /*   5245 */   // Label 185: @5245
     /*   5245 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5402), // Rule ID 15456 //
     /*   5250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5277 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5280 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5289 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5296 */     // MIs[2] pred
     /*   5296 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5307 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5336 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5340 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5401 */     // GIR_Coverage, 15456,
     /*   5401 */     GIR_EraseRootFromParent_Done,
     /*   5402 */   // Label 186: @5402
     /*   5402 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5559), // Rule ID 10006 //
     /*   5407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5438 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5441 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5450 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5457 */     // MIs[2] pred
     /*   5457 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5464 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5531 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5558 */     // GIR_Coverage, 10006,
     /*   5558 */     GIR_EraseRootFromParent_Done,
     /*   5559 */   // Label 187: @5559
     /*   5559 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5716), // Rule ID 10007 //
     /*   5564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5595 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5598 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5607 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5614 */     // MIs[2] pred
     /*   5614 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5621 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5647 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5688 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5698 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5715 */     // GIR_Coverage, 10007,
     /*   5715 */     GIR_EraseRootFromParent_Done,
     /*   5716 */   // Label 188: @5716
     /*   5716 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5873), // Rule ID 10008 //
     /*   5721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5752 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5755 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5771 */     // MIs[2] pred
     /*   5771 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5778 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5778 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5781 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5785 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5804 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5807 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5811 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5845 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5855 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5872 */     // GIR_Coverage, 10008,
     /*   5872 */     GIR_EraseRootFromParent_Done,
     /*   5873 */   // Label 189: @5873
     /*   5873 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6030), // Rule ID 10009 //
     /*   5878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5909 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5912 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5928 */     // MIs[2] pred
     /*   5928 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5935 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5961 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6029 */     // GIR_Coverage, 10009,
     /*   6029 */     GIR_EraseRootFromParent_Done,
     /*   6030 */   // Label 190: @6030
     /*   6030 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6063), // Rule ID 13136 //
     /*   6035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6050 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6061 */     GIR_RootConstrainSelectedInstOperands,
     /*   6062 */     // GIR_Coverage, 13136,
     /*   6062 */     GIR_EraseRootFromParent_Done,
     /*   6063 */   // Label 191: @6063
     /*   6063 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6099), // Rule ID 13699 //
     /*   6068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6083 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6097 */     GIR_RootConstrainSelectedInstOperands,
     /*   6098 */     // GIR_Coverage, 13699,
     /*   6098 */     GIR_EraseRootFromParent_Done,
     /*   6099 */   // Label 192: @6099
     /*   6099 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6132), // Rule ID 97 //
     /*   6104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6119 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6130 */     GIR_RootConstrainSelectedInstOperands,
     /*   6131 */     // GIR_Coverage, 97,
     /*   6131 */     GIR_EraseRootFromParent_Done,
     /*   6132 */   // Label 193: @6132
     /*   6132 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6168), // Rule ID 3913 //
     /*   6137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6152 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6166 */     GIR_RootConstrainSelectedInstOperands,
     /*   6167 */     // GIR_Coverage, 3913,
     /*   6167 */     GIR_EraseRootFromParent_Done,
     /*   6168 */   // Label 194: @6168
     /*   6168 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6201), // Rule ID 13134 //
     /*   6173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6188 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6199 */     GIR_RootConstrainSelectedInstOperands,
     /*   6200 */     // GIR_Coverage, 13134,
     /*   6200 */     GIR_EraseRootFromParent_Done,
     /*   6201 */   // Label 195: @6201
     /*   6201 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6234), // Rule ID 95 //
     /*   6206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6221 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6232 */     GIR_RootConstrainSelectedInstOperands,
     /*   6233 */     // GIR_Coverage, 95,
     /*   6233 */     GIR_EraseRootFromParent_Done,
     /*   6234 */   // Label 196: @6234
     /*   6234 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6258), // Rule ID 93 //
     /*   6239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6251 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6256 */     GIR_RootConstrainSelectedInstOperands,
     /*   6257 */     // GIR_Coverage, 93,
     /*   6257 */     GIR_Done,
     /*   6258 */   // Label 197: @6258
     /*   6258 */   GIM_Reject,
     /*   6259 */ // Label 172: @6259
     /*   6259 */ GIM_Reject,
     /*   6260 */ // Label 159: @6260
     /*   6260 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11587),
     /*   6265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6271 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6407), // Rule ID 5364 //
     /*   6276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6309 */     // MIs[1] Operand 2
     /*   6309 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6336 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6340 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6344 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6349 */     // MIs[3] Operand 2
     /*   6349 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6362 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6406 */     // GIR_Coverage, 5364,
     /*   6406 */     GIR_EraseRootFromParent_Done,
     /*   6407 */   // Label 199: @6407
     /*   6407 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6543), // Rule ID 5363 //
     /*   6412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6445 */     // MIs[1] Operand 2
     /*   6445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6476 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6480 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6485 */     // MIs[3] Operand 2
     /*   6485 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6496 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6498 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6542 */     // GIR_Coverage, 5363,
     /*   6542 */     GIR_EraseRootFromParent_Done,
     /*   6543 */   // Label 200: @6543
     /*   6543 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6679), // Rule ID 5373 //
     /*   6548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6581 */     // MIs[1] Operand 2
     /*   6581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6621 */     // MIs[3] Operand 2
     /*   6621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6634 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6678 */     // GIR_Coverage, 5373,
     /*   6678 */     GIR_EraseRootFromParent_Done,
     /*   6679 */   // Label 201: @6679
     /*   6679 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6815), // Rule ID 5362 //
     /*   6684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6717 */     // MIs[1] Operand 2
     /*   6717 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6740 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6744 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6748 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6752 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6757 */     // MIs[3] Operand 2
     /*   6757 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6768 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6770 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6814 */     // GIR_Coverage, 5362,
     /*   6814 */     GIR_EraseRootFromParent_Done,
     /*   6815 */   // Label 202: @6815
     /*   6815 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6951), // Rule ID 5361 //
     /*   6820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6853 */     // MIs[1] Operand 2
     /*   6853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6884 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6888 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6893 */     // MIs[3] Operand 2
     /*   6893 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6904 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6906 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6933 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6950 */     // GIR_Coverage, 5361,
     /*   6950 */     GIR_EraseRootFromParent_Done,
     /*   6951 */   // Label 203: @6951
     /*   6951 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7019), // Rule ID 6878 //
     /*   6956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6981 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   6989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   6997 */     // MIs[2] Rn
     /*   6997 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7002 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7008 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7017 */     GIR_RootConstrainSelectedInstOperands,
     /*   7018 */     // GIR_Coverage, 6878,
     /*   7018 */     GIR_EraseRootFromParent_Done,
     /*   7019 */   // Label 204: @7019
     /*   7019 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7087), // Rule ID 13854 //
     /*   7024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7049 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7065 */     // MIs[2] Rn
     /*   7065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7070 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7076 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7085 */     GIR_RootConstrainSelectedInstOperands,
     /*   7086 */     // GIR_Coverage, 13854,
     /*   7086 */     GIR_EraseRootFromParent_Done,
     /*   7087 */   // Label 205: @7087
     /*   7087 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7120), // Rule ID 13133 //
     /*   7092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7107 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7118 */     GIR_RootConstrainSelectedInstOperands,
     /*   7119 */     // GIR_Coverage, 13133,
     /*   7119 */     GIR_EraseRootFromParent_Done,
     /*   7120 */   // Label 206: @7120
     /*   7120 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7253), // Rule ID 3965 //
     /*   7125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7162 */     // MIs[2] Operand 2
     /*   7162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7181 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7185 */     // MIs[3] Operand 1
     /*   7185 */     // No operand predicates
     /*   7185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7191 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7203 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7251 */     GIR_RootConstrainSelectedInstOperands,
     /*   7252 */     // GIR_Coverage, 3965,
     /*   7252 */     GIR_EraseRootFromParent_Done,
     /*   7253 */   // Label 207: @7253
     /*   7253 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7348), // Rule ID 3963 //
     /*   7258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7303 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7307 */     // MIs[3] Operand 1
     /*   7307 */     // No operand predicates
     /*   7307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7313 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7325 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7346 */     GIR_RootConstrainSelectedInstOperands,
     /*   7347 */     // GIR_Coverage, 3963,
     /*   7347 */     GIR_EraseRootFromParent_Done,
     /*   7348 */   // Label 208: @7348
     /*   7348 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7443), // Rule ID 3964 //
     /*   7353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7402 */     // MIs[3] Operand 1
     /*   7402 */     // No operand predicates
     /*   7402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7408 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7420 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7441 */     GIR_RootConstrainSelectedInstOperands,
     /*   7442 */     // GIR_Coverage, 3964,
     /*   7442 */     GIR_EraseRootFromParent_Done,
     /*   7443 */   // Label 209: @7443
     /*   7443 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7476), // Rule ID 92 //
     /*   7448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7463 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7474 */     GIR_RootConstrainSelectedInstOperands,
     /*   7475 */     // GIR_Coverage, 92,
     /*   7475 */     GIR_EraseRootFromParent_Done,
     /*   7476 */   // Label 210: @7476
     /*   7476 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7609), // Rule ID 13709 //
     /*   7481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7522 */     // MIs[2] Operand 2
     /*   7522 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7545 */     // MIs[3] Operand 1
     /*   7545 */     // No operand predicates
     /*   7545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7547 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7547 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7550 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7554 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7559 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7578 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7607 */     GIR_RootConstrainSelectedInstOperands,
     /*   7608 */     // GIR_Coverage, 13709,
     /*   7608 */     GIR_EraseRootFromParent_Done,
     /*   7609 */   // Label 211: @7609
     /*   7609 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7704), // Rule ID 13707 //
     /*   7614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7667 */     // MIs[3] Operand 1
     /*   7667 */     // No operand predicates
     /*   7667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7669 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7681 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7702 */     GIR_RootConstrainSelectedInstOperands,
     /*   7703 */     // GIR_Coverage, 13707,
     /*   7703 */     GIR_EraseRootFromParent_Done,
     /*   7704 */   // Label 212: @7704
     /*   7704 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7799), // Rule ID 13708 //
     /*   7709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7758 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7762 */     // MIs[3] Operand 1
     /*   7762 */     // No operand predicates
     /*   7762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7764 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7776 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7797 */     GIR_RootConstrainSelectedInstOperands,
     /*   7798 */     // GIR_Coverage, 13708,
     /*   7798 */     GIR_EraseRootFromParent_Done,
     /*   7799 */   // Label 213: @7799
     /*   7799 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7881), // Rule ID 13144 //
     /*   7804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7853 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7864 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7879 */     GIR_RootConstrainSelectedInstOperands,
     /*   7880 */     // GIR_Coverage, 13144,
     /*   7880 */     GIR_EraseRootFromParent_Done,
     /*   7881 */   // Label 214: @7881
     /*   7881 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7963), // Rule ID 13145 //
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7935 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7946 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7961 */     GIR_RootConstrainSelectedInstOperands,
     /*   7962 */     // GIR_Coverage, 13145,
     /*   7962 */     GIR_EraseRootFromParent_Done,
     /*   7963 */   // Label 215: @7963
     /*   7963 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8045), // Rule ID 123 //
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8028 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8043 */     GIR_RootConstrainSelectedInstOperands,
     /*   8044 */     // GIR_Coverage, 123,
     /*   8044 */     GIR_EraseRootFromParent_Done,
     /*   8045 */   // Label 216: @8045
     /*   8045 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8127), // Rule ID 125 //
     /*   8050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8110 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8125 */     GIR_RootConstrainSelectedInstOperands,
     /*   8126 */     // GIR_Coverage, 125,
     /*   8126 */     GIR_EraseRootFromParent_Done,
     /*   8127 */   // Label 217: @8127
     /*   8127 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8185), // Rule ID 13554 //
     /*   8132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8147 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8150 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8155 */     // MIs[1] pattern
     /*   8155 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8158 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8169 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8183 */     GIR_RootConstrainSelectedInstOperands,
     /*   8184 */     // GIR_Coverage, 13554,
     /*   8184 */     GIR_EraseRootFromParent_Done,
     /*   8185 */   // Label 218: @8185
     /*   8185 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8243), // Rule ID 15405 //
     /*   8190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8213 */     // MIs[1] pattern
     /*   8213 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8216 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8227 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8241 */     GIR_RootConstrainSelectedInstOperands,
     /*   8242 */     // GIR_Coverage, 15405,
     /*   8242 */     GIR_EraseRootFromParent_Done,
     /*   8243 */   // Label 219: @8243
     /*   8243 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8301), // Rule ID 15417 //
     /*   8248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8263 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8266 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8271 */     // MIs[1] pattern
     /*   8271 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8274 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8285 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8299 */     GIR_RootConstrainSelectedInstOperands,
     /*   8300 */     // GIR_Coverage, 15417,
     /*   8300 */     GIR_EraseRootFromParent_Done,
     /*   8301 */   // Label 220: @8301
     /*   8301 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8359), // Rule ID 15429 //
     /*   8306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8321 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8324 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8329 */     // MIs[1] pattern
     /*   8329 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8332 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8343 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8357 */     GIR_RootConstrainSelectedInstOperands,
     /*   8358 */     // GIR_Coverage, 15429,
     /*   8358 */     GIR_EraseRootFromParent_Done,
     /*   8359 */   // Label 221: @8359
     /*   8359 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8417), // Rule ID 2653 //
     /*   8364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8383 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8386 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8391 */     // MIs[1] pattern
     /*   8391 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8394 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8401 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8415 */     GIR_RootConstrainSelectedInstOperands,
     /*   8416 */     // GIR_Coverage, 2653,
     /*   8416 */     GIR_EraseRootFromParent_Done,
     /*   8417 */   // Label 222: @8417
     /*   8417 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8475), // Rule ID 9887 //
     /*   8422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8441 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8444 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8449 */     // MIs[1] pattern
     /*   8449 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8452 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8459 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8473 */     GIR_RootConstrainSelectedInstOperands,
     /*   8474 */     // GIR_Coverage, 9887,
     /*   8474 */     GIR_EraseRootFromParent_Done,
     /*   8475 */   // Label 223: @8475
     /*   8475 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8533), // Rule ID 9899 //
     /*   8480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8499 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8502 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8507 */     // MIs[1] pattern
     /*   8507 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8510 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8517 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8531 */     GIR_RootConstrainSelectedInstOperands,
     /*   8532 */     // GIR_Coverage, 9899,
     /*   8532 */     GIR_EraseRootFromParent_Done,
     /*   8533 */   // Label 224: @8533
     /*   8533 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8591), // Rule ID 9911 //
     /*   8538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8557 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8560 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8565 */     // MIs[1] pattern
     /*   8565 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8568 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8589 */     GIR_RootConstrainSelectedInstOperands,
     /*   8590 */     // GIR_Coverage, 9911,
     /*   8590 */     GIR_EraseRootFromParent_Done,
     /*   8591 */   // Label 225: @8591
     /*   8591 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8754), // Rule ID 13826 //
     /*   8596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8638 */     // MIs[1] Operand 2
     /*   8638 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8655 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8655 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8658 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8662 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8681 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8684 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8688 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8718 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8736 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8753 */     // GIR_Coverage, 13826,
     /*   8753 */     GIR_EraseRootFromParent_Done,
     /*   8754 */   // Label 226: @8754
     /*   8754 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8917), // Rule ID 13823 //
     /*   8759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8801 */     // MIs[1] Operand 2
     /*   8801 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8818 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8818 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8821 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8825 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8832 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8835 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8839 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8844 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8851 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8899 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8916 */     // GIR_Coverage, 13823,
     /*   8916 */     GIR_EraseRootFromParent_Done,
     /*   8917 */   // Label 227: @8917
     /*   8917 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9067), // Rule ID 13832 //
     /*   8922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8955 */     // MIs[1] Operand 2
     /*   8955 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8972 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8972 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8975 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8979 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8998 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9001 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9005 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9066 */     // GIR_Coverage, 13832,
     /*   9066 */     GIR_EraseRootFromParent_Done,
     /*   9067 */   // Label 228: @9067
     /*   9067 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9217), // Rule ID 13835 //
     /*   9072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9105 */     // MIs[1] Operand 2
     /*   9105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9122 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9216 */     // GIR_Coverage, 13835,
     /*   9216 */     GIR_EraseRootFromParent_Done,
     /*   9217 */   // Label 229: @9217
     /*   9217 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9367), // Rule ID 13831 //
     /*   9222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9255 */     // MIs[1] Operand 2
     /*   9255 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9272 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9301 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9366 */     // GIR_Coverage, 13831,
     /*   9366 */     GIR_EraseRootFromParent_Done,
     /*   9367 */   // Label 230: @9367
     /*   9367 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9530), // Rule ID 5346 //
     /*   9372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9418 */     // MIs[1] Operand 2
     /*   9418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9431 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9431 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9434 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9438 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9457 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9460 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9464 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9512 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9529 */     // GIR_Coverage, 5346,
     /*   9529 */     GIR_EraseRootFromParent_Done,
     /*   9530 */   // Label 231: @9530
     /*   9530 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9693), // Rule ID 5343 //
     /*   9535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9581 */     // MIs[1] Operand 2
     /*   9581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9594 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9594 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9597 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9601 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9620 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9627 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9630 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9675 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9692 */     // GIR_Coverage, 5343,
     /*   9692 */     GIR_EraseRootFromParent_Done,
     /*   9693 */   // Label 232: @9693
     /*   9693 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9843), // Rule ID 5370 //
     /*   9698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9735 */     // MIs[1] Operand 2
     /*   9735 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9748 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9842 */     // GIR_Coverage, 5370,
     /*   9842 */     GIR_EraseRootFromParent_Done,
     /*   9843 */   // Label 233: @9843
     /*   9843 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9993), // Rule ID 5376 //
     /*   9848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9885 */     // MIs[1] Operand 2
     /*   9885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9898 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9992 */     // GIR_Coverage, 5376,
     /*   9992 */     GIR_EraseRootFromParent_Done,
     /*   9993 */   // Label 234: @9993
     /*   9993 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10143), // Rule ID 5369 //
     /*   9998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10035 */     // MIs[1] Operand 2
     /*  10035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10048 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10048 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10051 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10055 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10074 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10081 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10125 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10142 */     // GIR_Coverage, 5369,
     /*  10142 */     GIR_EraseRootFromParent_Done,
     /*  10143 */   // Label 235: @10143
     /*  10143 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10176), // Rule ID 13137 //
     /*  10148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10163 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10174 */     GIR_RootConstrainSelectedInstOperands,
     /*  10175 */     // GIR_Coverage, 13137,
     /*  10175 */     GIR_EraseRootFromParent_Done,
     /*  10176 */   // Label 236: @10176
     /*  10176 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10212), // Rule ID 13700 //
     /*  10181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10196 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10210 */     GIR_RootConstrainSelectedInstOperands,
     /*  10211 */     // GIR_Coverage, 13700,
     /*  10211 */     GIR_EraseRootFromParent_Done,
     /*  10212 */   // Label 237: @10212
     /*  10212 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10245), // Rule ID 98 //
     /*  10217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10232 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10243 */     GIR_RootConstrainSelectedInstOperands,
     /*  10244 */     // GIR_Coverage, 98,
     /*  10244 */     GIR_EraseRootFromParent_Done,
     /*  10245 */   // Label 238: @10245
     /*  10245 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10281), // Rule ID 3914 //
     /*  10250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10265 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10279 */     GIR_RootConstrainSelectedInstOperands,
     /*  10280 */     // GIR_Coverage, 3914,
     /*  10280 */     GIR_EraseRootFromParent_Done,
     /*  10281 */   // Label 239: @10281
     /*  10281 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10314), // Rule ID 13135 //
     /*  10286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10301 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10312 */     GIR_RootConstrainSelectedInstOperands,
     /*  10313 */     // GIR_Coverage, 13135,
     /*  10313 */     GIR_EraseRootFromParent_Done,
     /*  10314 */   // Label 240: @10314
     /*  10314 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10377), // Rule ID 15445 //
     /*  10319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10334 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10337 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10353 */     // MIs[1] pred
     /*  10353 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10364 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10375 */     GIR_RootConstrainSelectedInstOperands,
     /*  10376 */     // GIR_Coverage, 15445,
     /*  10376 */     GIR_EraseRootFromParent_Done,
     /*  10377 */   // Label 241: @10377
     /*  10377 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10440), // Rule ID 15446 //
     /*  10382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10397 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10400 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10416 */     // MIs[1] pred
     /*  10416 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10427 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10438 */     GIR_RootConstrainSelectedInstOperands,
     /*  10439 */     // GIR_Coverage, 15446,
     /*  10439 */     GIR_EraseRootFromParent_Done,
     /*  10440 */   // Label 242: @10440
     /*  10440 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10503), // Rule ID 15447 //
     /*  10445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10460 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10463 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10479 */     // MIs[1] pred
     /*  10479 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10490 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10501 */     GIR_RootConstrainSelectedInstOperands,
     /*  10502 */     // GIR_Coverage, 15447,
     /*  10502 */     GIR_EraseRootFromParent_Done,
     /*  10503 */   // Label 243: @10503
     /*  10503 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10566), // Rule ID 15448 //
     /*  10508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10523 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10526 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10542 */     // MIs[1] pred
     /*  10542 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10553 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10564 */     GIR_RootConstrainSelectedInstOperands,
     /*  10565 */     // GIR_Coverage, 15448,
     /*  10565 */     GIR_EraseRootFromParent_Done,
     /*  10566 */   // Label 244: @10566
     /*  10566 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10599), // Rule ID 96 //
     /*  10571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10586 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10597 */     GIR_RootConstrainSelectedInstOperands,
     /*  10598 */     // GIR_Coverage, 96,
     /*  10598 */     GIR_EraseRootFromParent_Done,
     /*  10599 */   // Label 245: @10599
     /*  10599 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10662), // Rule ID 9998 //
     /*  10604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10623 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10626 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10642 */     // MIs[1] pred
     /*  10642 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10649 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10660 */     GIR_RootConstrainSelectedInstOperands,
     /*  10661 */     // GIR_Coverage, 9998,
     /*  10661 */     GIR_EraseRootFromParent_Done,
     /*  10662 */   // Label 246: @10662
     /*  10662 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10725), // Rule ID 9999 //
     /*  10667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10686 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10689 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10705 */     // MIs[1] pred
     /*  10705 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10712 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10723 */     GIR_RootConstrainSelectedInstOperands,
     /*  10724 */     // GIR_Coverage, 9999,
     /*  10724 */     GIR_EraseRootFromParent_Done,
     /*  10725 */   // Label 247: @10725
     /*  10725 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10788), // Rule ID 10000 //
     /*  10730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10749 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10752 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10768 */     // MIs[1] pred
     /*  10768 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10775 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10786 */     GIR_RootConstrainSelectedInstOperands,
     /*  10787 */     // GIR_Coverage, 10000,
     /*  10787 */     GIR_EraseRootFromParent_Done,
     /*  10788 */   // Label 248: @10788
     /*  10788 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(10851), // Rule ID 10001 //
     /*  10793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10812 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10815 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10831 */     // MIs[1] pred
     /*  10831 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10838 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10849 */     GIR_RootConstrainSelectedInstOperands,
     /*  10850 */     // GIR_Coverage, 10001,
     /*  10850 */     GIR_EraseRootFromParent_Done,
     /*  10851 */   // Label 249: @10851
     /*  10851 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10907), // Rule ID 13243 //
     /*  10856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10871 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10874 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10894 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10905 */     GIR_RootConstrainSelectedInstOperands,
     /*  10906 */     // GIR_Coverage, 13243,
     /*  10906 */     GIR_EraseRootFromParent_Done,
     /*  10907 */   // Label 250: @10907
     /*  10907 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10963), // Rule ID 13255 //
     /*  10912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10927 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10930 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10950 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10961 */     GIR_RootConstrainSelectedInstOperands,
     /*  10962 */     // GIR_Coverage, 13255,
     /*  10962 */     GIR_EraseRootFromParent_Done,
     /*  10963 */   // Label 251: @10963
     /*  10963 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11030), // Rule ID 13461 //
     /*  10968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10992 */     // MIs[1] imm
     /*  10992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  10996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11004 */     // MIs[2] Operand 1
     /*  11004 */     // No operand predicates
     /*  11004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11014 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11028 */     GIR_RootConstrainSelectedInstOperands,
     /*  11029 */     // GIR_Coverage, 13461,
     /*  11029 */     GIR_EraseRootFromParent_Done,
     /*  11030 */   // Label 252: @11030
     /*  11030 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11097), // Rule ID 13464 //
     /*  11035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11059 */     // MIs[1] imm
     /*  11059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11071 */     // MIs[2] Operand 1
     /*  11071 */     // No operand predicates
     /*  11071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11081 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11095 */     GIR_RootConstrainSelectedInstOperands,
     /*  11096 */     // GIR_Coverage, 13464,
     /*  11096 */     GIR_EraseRootFromParent_Done,
     /*  11097 */   // Label 253: @11097
     /*  11097 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11153), // Rule ID 997 //
     /*  11102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11121 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11124 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11140 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11151 */     GIR_RootConstrainSelectedInstOperands,
     /*  11152 */     // GIR_Coverage, 997,
     /*  11152 */     GIR_EraseRootFromParent_Done,
     /*  11153 */   // Label 254: @11153
     /*  11153 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11209), // Rule ID 1058 //
     /*  11158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11177 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11180 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11196 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11207 */     GIR_RootConstrainSelectedInstOperands,
     /*  11208 */     // GIR_Coverage, 1058,
     /*  11208 */     GIR_EraseRootFromParent_Done,
     /*  11209 */   // Label 255: @11209
     /*  11209 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11276), // Rule ID 2121 //
     /*  11214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11242 */     // MIs[1] imm
     /*  11242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11254 */     // MIs[2] Operand 1
     /*  11254 */     // No operand predicates
     /*  11254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11260 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11274 */     GIR_RootConstrainSelectedInstOperands,
     /*  11275 */     // GIR_Coverage, 2121,
     /*  11275 */     GIR_EraseRootFromParent_Done,
     /*  11276 */   // Label 256: @11276
     /*  11276 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11343), // Rule ID 2130 //
     /*  11281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11309 */     // MIs[1] imm
     /*  11309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11321 */     // MIs[2] Operand 1
     /*  11321 */     // No operand predicates
     /*  11321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11327 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11341 */     GIR_RootConstrainSelectedInstOperands,
     /*  11342 */     // GIR_Coverage, 2130,
     /*  11342 */     GIR_EraseRootFromParent_Done,
     /*  11343 */   // Label 257: @11343
     /*  11343 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11391), // Rule ID 13242 //
     /*  11348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11378 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11389 */     GIR_RootConstrainSelectedInstOperands,
     /*  11390 */     // GIR_Coverage, 13242,
     /*  11390 */     GIR_EraseRootFromParent_Done,
     /*  11391 */   // Label 258: @11391
     /*  11391 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11439), // Rule ID 13254 //
     /*  11396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11426 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11437 */     GIR_RootConstrainSelectedInstOperands,
     /*  11438 */     // GIR_Coverage, 13254,
     /*  11438 */     GIR_EraseRootFromParent_Done,
     /*  11439 */   // Label 259: @11439
     /*  11439 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11487), // Rule ID 996 //
     /*  11444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11474 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11485 */     GIR_RootConstrainSelectedInstOperands,
     /*  11486 */     // GIR_Coverage, 996,
     /*  11486 */     GIR_EraseRootFromParent_Done,
     /*  11487 */   // Label 260: @11487
     /*  11487 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11535), // Rule ID 1057 //
     /*  11492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11522 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11533 */     GIR_RootConstrainSelectedInstOperands,
     /*  11534 */     // GIR_Coverage, 1057,
     /*  11534 */     GIR_EraseRootFromParent_Done,
     /*  11535 */   // Label 261: @11535
     /*  11535 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11559), // Rule ID 94 //
     /*  11540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11552 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 94,
     /*  11558 */     GIR_Done,
     /*  11559 */   // Label 262: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11586), // Rule ID 1607 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11579 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11584 */     GIR_RootConstrainSelectedInstOperands,
     /*  11585 */     // GIR_Coverage, 1607,
     /*  11585 */     GIR_Done,
     /*  11586 */   // Label 263: @11586
     /*  11586 */   GIM_Reject,
     /*  11587 */ // Label 198: @11587
     /*  11587 */ GIM_Reject,
     /*  11588 */ // Label 160: @11588
     /*  11588 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(15195),
     /*  11593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11599 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(11787), // Rule ID 6899 //
     /*  11604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11641 */     // MIs[2] Operand 2
     /*  11641 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     // MIs[3] Rn
     /*  11660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11665 */     // MIs[3] Operand 2
     /*  11665 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11684 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11688 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11692 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11696 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11700 */     // MIs[5] Rn
     /*  11700 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11705 */     // MIs[5] Operand 2
     /*  11705 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11716 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11720 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11724 */     // MIs[6] Rn
     /*  11724 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11729 */     // MIs[6] Operand 2
     /*  11729 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11740 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11742 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11786 */     // GIR_Coverage, 6899,
     /*  11786 */     GIR_EraseRootFromParent_Done,
     /*  11787 */   // Label 265: @11787
     /*  11787 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(11975), // Rule ID 13865 //
     /*  11792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11829 */     // MIs[2] Operand 2
     /*  11829 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     // MIs[3] Rn
     /*  11848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11853 */     // MIs[3] Operand 2
     /*  11853 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11868 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11872 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11876 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11880 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11884 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11888 */     // MIs[5] Rn
     /*  11888 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11893 */     // MIs[5] Operand 2
     /*  11893 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11904 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11908 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11912 */     // MIs[6] Rn
     /*  11912 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11917 */     // MIs[6] Operand 2
     /*  11917 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11930 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11974 */     // GIR_Coverage, 13865,
     /*  11974 */     GIR_EraseRootFromParent_Done,
     /*  11975 */   // Label 266: @11975
     /*  11975 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12111), // Rule ID 5360 //
     /*  11980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12013 */     // MIs[1] Operand 2
     /*  12013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12040 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12044 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12048 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12053 */     // MIs[3] Operand 2
     /*  12053 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12066 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12110 */     // GIR_Coverage, 5360,
     /*  12110 */     GIR_EraseRootFromParent_Done,
     /*  12111 */   // Label 267: @12111
     /*  12111 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12247), // Rule ID 5359 //
     /*  12116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12149 */     // MIs[1] Operand 2
     /*  12149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12189 */     // MIs[3] Operand 2
     /*  12189 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12202 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12246 */     // GIR_Coverage, 5359,
     /*  12246 */     GIR_EraseRootFromParent_Done,
     /*  12247 */   // Label 268: @12247
     /*  12247 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12383), // Rule ID 5372 //
     /*  12252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12285 */     // MIs[1] Operand 2
     /*  12285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12316 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12320 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12325 */     // MIs[3] Operand 2
     /*  12325 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12338 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12382 */     // GIR_Coverage, 5372,
     /*  12382 */     GIR_EraseRootFromParent_Done,
     /*  12383 */   // Label 269: @12383
     /*  12383 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12519), // Rule ID 5358 //
     /*  12388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12421 */     // MIs[1] Operand 2
     /*  12421 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12452 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12461 */     // MIs[3] Operand 2
     /*  12461 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12474 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12518 */     // GIR_Coverage, 5358,
     /*  12518 */     GIR_EraseRootFromParent_Done,
     /*  12519 */   // Label 270: @12519
     /*  12519 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12655), // Rule ID 5357 //
     /*  12524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12557 */     // MIs[1] Operand 2
     /*  12557 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12588 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12592 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12597 */     // MIs[3] Operand 2
     /*  12597 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12608 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12610 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12654 */     // GIR_Coverage, 5357,
     /*  12654 */     GIR_EraseRootFromParent_Done,
     /*  12655 */   // Label 271: @12655
     /*  12655 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12818), // Rule ID 13825 //
     /*  12660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12702 */     // MIs[1] Operand 2
     /*  12702 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12719 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12719 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12722 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12726 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12745 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12748 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12752 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12817 */     // GIR_Coverage, 13825,
     /*  12817 */     GIR_EraseRootFromParent_Done,
     /*  12818 */   // Label 272: @12818
     /*  12818 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12981), // Rule ID 13822 //
     /*  12823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12865 */     // MIs[1] Operand 2
     /*  12865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12882 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12882 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12885 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12889 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12896 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12899 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12903 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12908 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12915 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12963 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12980 */     // GIR_Coverage, 13822,
     /*  12980 */     GIR_EraseRootFromParent_Done,
     /*  12981 */   // Label 273: @12981
     /*  12981 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13131), // Rule ID 13830 //
     /*  12986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13019 */     // MIs[1] Operand 2
     /*  13019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13036 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13036 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13039 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13043 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13062 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13065 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13069 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13113 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13130 */     // GIR_Coverage, 13830,
     /*  13130 */     GIR_EraseRootFromParent_Done,
     /*  13131 */   // Label 274: @13131
     /*  13131 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13281), // Rule ID 13834 //
     /*  13136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13169 */     // MIs[1] Operand 2
     /*  13169 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13186 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13186 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13189 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13193 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13212 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13219 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13263 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13280 */     // GIR_Coverage, 13834,
     /*  13280 */     GIR_EraseRootFromParent_Done,
     /*  13281 */   // Label 275: @13281
     /*  13281 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13431), // Rule ID 13829 //
     /*  13286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13319 */     // MIs[1] Operand 2
     /*  13319 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13336 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13336 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13339 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13343 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13362 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13399 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13430 */     // GIR_Coverage, 13829,
     /*  13430 */     GIR_EraseRootFromParent_Done,
     /*  13431 */   // Label 276: @13431
     /*  13431 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13594), // Rule ID 5345 //
     /*  13436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13482 */     // MIs[1] Operand 2
     /*  13482 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13495 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13495 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13498 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13502 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13521 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13524 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13528 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13593 */     // GIR_Coverage, 5345,
     /*  13593 */     GIR_EraseRootFromParent_Done,
     /*  13594 */   // Label 277: @13594
     /*  13594 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13757), // Rule ID 5342 //
     /*  13599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13645 */     // MIs[1] Operand 2
     /*  13645 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13658 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13658 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13661 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13665 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13684 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13691 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13756 */     // GIR_Coverage, 5342,
     /*  13756 */     GIR_EraseRootFromParent_Done,
     /*  13757 */   // Label 278: @13757
     /*  13757 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13907), // Rule ID 5368 //
     /*  13762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13799 */     // MIs[1] Operand 2
     /*  13799 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13812 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13812 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13815 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13819 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13838 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13841 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13845 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13889 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13906 */     // GIR_Coverage, 5368,
     /*  13906 */     GIR_EraseRootFromParent_Done,
     /*  13907 */   // Label 279: @13907
     /*  13907 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14057), // Rule ID 5375 //
     /*  13912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13949 */     // MIs[1] Operand 2
     /*  13949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13962 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13962 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13965 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13969 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13988 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13995 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14039 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14056 */     // GIR_Coverage, 5375,
     /*  14056 */     GIR_EraseRootFromParent_Done,
     /*  14057 */   // Label 280: @14057
     /*  14057 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14207), // Rule ID 5367 //
     /*  14062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14099 */     // MIs[1] Operand 2
     /*  14099 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14112 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14112 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14115 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14119 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14138 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14141 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14145 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14206 */     // GIR_Coverage, 5367,
     /*  14206 */     GIR_EraseRootFromParent_Done,
     /*  14207 */   // Label 281: @14207
     /*  14207 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14276), // Rule ID 13277 //
     /*  14212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14227 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14230 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14259 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14274 */     GIR_RootConstrainSelectedInstOperands,
     /*  14275 */     // GIR_Coverage, 13277,
     /*  14275 */     GIR_EraseRootFromParent_Done,
     /*  14276 */   // Label 282: @14276
     /*  14276 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14345), // Rule ID 13289 //
     /*  14281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14296 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14299 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14308 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14328 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14343 */     GIR_RootConstrainSelectedInstOperands,
     /*  14344 */     // GIR_Coverage, 13289,
     /*  14344 */     GIR_EraseRootFromParent_Done,
     /*  14345 */   // Label 283: @14345
     /*  14345 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14401), // Rule ID 13239 //
     /*  14350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14365 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14368 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14388 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14399 */     GIR_RootConstrainSelectedInstOperands,
     /*  14400 */     // GIR_Coverage, 13239,
     /*  14400 */     GIR_EraseRootFromParent_Done,
     /*  14401 */   // Label 284: @14401
     /*  14401 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14457), // Rule ID 13251 //
     /*  14406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14421 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14424 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14444 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 13251,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 285: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14524), // Rule ID 13481 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14486 */     // MIs[1] imm
     /*  14486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14498 */     // MIs[2] Operand 1
     /*  14498 */     // No operand predicates
     /*  14498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14508 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14522 */     GIR_RootConstrainSelectedInstOperands,
     /*  14523 */     // GIR_Coverage, 13481,
     /*  14523 */     GIR_EraseRootFromParent_Done,
     /*  14524 */   // Label 286: @14524
     /*  14524 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14591), // Rule ID 13502 //
     /*  14529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14553 */     // MIs[1] imm
     /*  14553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14561 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14565 */     // MIs[2] Operand 1
     /*  14565 */     // No operand predicates
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14575 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14589 */     GIR_RootConstrainSelectedInstOperands,
     /*  14590 */     // GIR_Coverage, 13502,
     /*  14590 */     GIR_EraseRootFromParent_Done,
     /*  14591 */   // Label 287: @14591
     /*  14591 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14660), // Rule ID 1365 //
     /*  14596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14615 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14618 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14643 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14658 */     GIR_RootConstrainSelectedInstOperands,
     /*  14659 */     // GIR_Coverage, 1365,
     /*  14659 */     GIR_EraseRootFromParent_Done,
     /*  14660 */   // Label 288: @14660
     /*  14660 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14729), // Rule ID 1488 //
     /*  14665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14684 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14687 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14696 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14712 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14727 */     GIR_RootConstrainSelectedInstOperands,
     /*  14728 */     // GIR_Coverage, 1488,
     /*  14728 */     GIR_EraseRootFromParent_Done,
     /*  14729 */   // Label 289: @14729
     /*  14729 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14785), // Rule ID 993 //
     /*  14734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14753 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14756 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14772 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14783 */     GIR_RootConstrainSelectedInstOperands,
     /*  14784 */     // GIR_Coverage, 993,
     /*  14784 */     GIR_EraseRootFromParent_Done,
     /*  14785 */   // Label 290: @14785
     /*  14785 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14841), // Rule ID 1054 //
     /*  14790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14809 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14812 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14828 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14839 */     GIR_RootConstrainSelectedInstOperands,
     /*  14840 */     // GIR_Coverage, 1054,
     /*  14840 */     GIR_EraseRootFromParent_Done,
     /*  14841 */   // Label 291: @14841
     /*  14841 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14908), // Rule ID 2238 //
     /*  14846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14874 */     // MIs[1] imm
     /*  14874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14886 */     // MIs[2] Operand 1
     /*  14886 */     // No operand predicates
     /*  14886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14892 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14906 */     GIR_RootConstrainSelectedInstOperands,
     /*  14907 */     // GIR_Coverage, 2238,
     /*  14907 */     GIR_EraseRootFromParent_Done,
     /*  14908 */   // Label 292: @14908
     /*  14908 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14975), // Rule ID 2297 //
     /*  14913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14941 */     // MIs[1] imm
     /*  14941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14953 */     // MIs[2] Operand 1
     /*  14953 */     // No operand predicates
     /*  14953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14959 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14973 */     GIR_RootConstrainSelectedInstOperands,
     /*  14974 */     // GIR_Coverage, 2297,
     /*  14974 */     GIR_EraseRootFromParent_Done,
     /*  14975 */   // Label 293: @14975
     /*  14975 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15023), // Rule ID 13238 //
     /*  14980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  14995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15010 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15021 */     GIR_RootConstrainSelectedInstOperands,
     /*  15022 */     // GIR_Coverage, 13238,
     /*  15022 */     GIR_EraseRootFromParent_Done,
     /*  15023 */   // Label 294: @15023
     /*  15023 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15071), // Rule ID 13250 //
     /*  15028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15058 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15069 */     GIR_RootConstrainSelectedInstOperands,
     /*  15070 */     // GIR_Coverage, 13250,
     /*  15070 */     GIR_EraseRootFromParent_Done,
     /*  15071 */   // Label 295: @15071
     /*  15071 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15119), // Rule ID 992 //
     /*  15076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15106 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15117 */     GIR_RootConstrainSelectedInstOperands,
     /*  15118 */     // GIR_Coverage, 992,
     /*  15118 */     GIR_EraseRootFromParent_Done,
     /*  15119 */   // Label 296: @15119
     /*  15119 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15167), // Rule ID 1053 //
     /*  15124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15154 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15165 */     GIR_RootConstrainSelectedInstOperands,
     /*  15166 */     // GIR_Coverage, 1053,
     /*  15166 */     GIR_EraseRootFromParent_Done,
     /*  15167 */   // Label 297: @15167
     /*  15167 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15194), // Rule ID 1104 //
     /*  15172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15187 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15192 */     GIR_RootConstrainSelectedInstOperands,
     /*  15193 */     // GIR_Coverage, 1104,
     /*  15193 */     GIR_Done,
     /*  15194 */   // Label 298: @15194
     /*  15194 */   GIM_Reject,
     /*  15195 */ // Label 264: @15195
     /*  15195 */ GIM_Reject,
     /*  15196 */ // Label 161: @15196
     /*  15196 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(21097),
     /*  15201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15207 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15325), // Rule ID 13416 //
     /*  15212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15276 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15280 */     // MIs[4] Operand 1
     /*  15280 */     // No operand predicates
     /*  15280 */     // MIs[2] Operand 2
     /*  15280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15295 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15304 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15323 */     GIR_RootConstrainSelectedInstOperands,
     /*  15324 */     // GIR_Coverage, 13416,
     /*  15324 */     GIR_EraseRootFromParent_Done,
     /*  15325 */   // Label 300: @15325
     /*  15325 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15443), // Rule ID 13417 //
     /*  15330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15394 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15398 */     // MIs[4] Operand 1
     /*  15398 */     // No operand predicates
     /*  15398 */     // MIs[2] Operand 2
     /*  15398 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15413 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15422 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15441 */     GIR_RootConstrainSelectedInstOperands,
     /*  15442 */     // GIR_Coverage, 13417,
     /*  15442 */     GIR_EraseRootFromParent_Done,
     /*  15443 */   // Label 301: @15443
     /*  15443 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15561), // Rule ID 13446 //
     /*  15448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15512 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15516 */     // MIs[4] Operand 1
     /*  15516 */     // No operand predicates
     /*  15516 */     // MIs[2] Operand 2
     /*  15516 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15540 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15559 */     GIR_RootConstrainSelectedInstOperands,
     /*  15560 */     // GIR_Coverage, 13446,
     /*  15560 */     GIR_EraseRootFromParent_Done,
     /*  15561 */   // Label 302: @15561
     /*  15561 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15679), // Rule ID 13447 //
     /*  15566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15613 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15617 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15626 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15630 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15634 */     // MIs[4] Operand 1
     /*  15634 */     // No operand predicates
     /*  15634 */     // MIs[2] Operand 2
     /*  15634 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15649 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15658 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15677 */     GIR_RootConstrainSelectedInstOperands,
     /*  15678 */     // GIR_Coverage, 13447,
     /*  15678 */     GIR_EraseRootFromParent_Done,
     /*  15679 */   // Label 303: @15679
     /*  15679 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15797), // Rule ID 2042 //
     /*  15684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15752 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15756 */     // MIs[4] Operand 1
     /*  15756 */     // No operand predicates
     /*  15756 */     // MIs[2] Operand 2
     /*  15756 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15767 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15776 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15795 */     GIR_RootConstrainSelectedInstOperands,
     /*  15796 */     // GIR_Coverage, 2042,
     /*  15796 */     GIR_EraseRootFromParent_Done,
     /*  15797 */   // Label 304: @15797
     /*  15797 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15915), // Rule ID 13415 //
     /*  15802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15857 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15870 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15874 */     // MIs[4] Operand 1
     /*  15874 */     // No operand predicates
     /*  15874 */     // MIs[2] Operand 2
     /*  15874 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15885 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15894 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15913 */     GIR_RootConstrainSelectedInstOperands,
     /*  15914 */     // GIR_Coverage, 13415,
     /*  15914 */     GIR_EraseRootFromParent_Done,
     /*  15915 */   // Label 305: @15915
     /*  15915 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16033), // Rule ID 2094 //
     /*  15920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15971 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15975 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15988 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15992 */     // MIs[4] Operand 1
     /*  15992 */     // No operand predicates
     /*  15992 */     // MIs[2] Operand 2
     /*  15992 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16003 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16012 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16031 */     GIR_RootConstrainSelectedInstOperands,
     /*  16032 */     // GIR_Coverage, 2094,
     /*  16032 */     GIR_EraseRootFromParent_Done,
     /*  16033 */   // Label 306: @16033
     /*  16033 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16151), // Rule ID 13445 //
     /*  16038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16093 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16106 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16110 */     // MIs[4] Operand 1
     /*  16110 */     // No operand predicates
     /*  16110 */     // MIs[2] Operand 2
     /*  16110 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16121 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16130 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16149 */     GIR_RootConstrainSelectedInstOperands,
     /*  16150 */     // GIR_Coverage, 13445,
     /*  16150 */     GIR_EraseRootFromParent_Done,
     /*  16151 */   // Label 307: @16151
     /*  16151 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16238), // Rule ID 13321 //
     /*  16156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16183 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16186 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16195 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16219 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16236 */     GIR_RootConstrainSelectedInstOperands,
     /*  16237 */     // GIR_Coverage, 13321,
     /*  16237 */     GIR_EraseRootFromParent_Done,
     /*  16238 */   // Label 308: @16238
     /*  16238 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16325), // Rule ID 13345 //
     /*  16243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16270 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16273 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16282 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16306 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16323 */     GIR_RootConstrainSelectedInstOperands,
     /*  16324 */     // GIR_Coverage, 13345,
     /*  16324 */     GIR_EraseRootFromParent_Done,
     /*  16325 */   // Label 309: @16325
     /*  16325 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16412), // Rule ID 1699 //
     /*  16330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16361 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16364 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16373 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16393 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16410 */     GIR_RootConstrainSelectedInstOperands,
     /*  16411 */     // GIR_Coverage, 1699,
     /*  16411 */     GIR_EraseRootFromParent_Done,
     /*  16412 */   // Label 310: @16412
     /*  16412 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16499), // Rule ID 1777 //
     /*  16417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16448 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16451 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16460 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16480 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16497 */     GIR_RootConstrainSelectedInstOperands,
     /*  16498 */     // GIR_Coverage, 1777,
     /*  16498 */     GIR_EraseRootFromParent_Done,
     /*  16499 */   // Label 311: @16499
     /*  16499 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16614), // Rule ID 13411 //
     /*  16504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16568 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16572 */     // MIs[4] Operand 1
     /*  16572 */     // No operand predicates
     /*  16572 */     // MIs[2] Operand 2
     /*  16572 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16594 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16612 */     GIR_RootConstrainSelectedInstOperands,
     /*  16613 */     // GIR_Coverage, 13411,
     /*  16613 */     GIR_EraseRootFromParent_Done,
     /*  16614 */   // Label 312: @16614
     /*  16614 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16729), // Rule ID 13410 //
     /*  16619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16688 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16692 */     // MIs[4] Operand 1
     /*  16692 */     // No operand predicates
     /*  16692 */     // MIs[2] Operand 2
     /*  16692 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16709 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16727 */     GIR_RootConstrainSelectedInstOperands,
     /*  16728 */     // GIR_Coverage, 13410,
     /*  16728 */     GIR_EraseRootFromParent_Done,
     /*  16729 */   // Label 313: @16729
     /*  16729 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16844), // Rule ID 13441 //
     /*  16734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16777 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16798 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16802 */     // MIs[4] Operand 1
     /*  16802 */     // No operand predicates
     /*  16802 */     // MIs[2] Operand 2
     /*  16802 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16822 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16824 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16842 */     GIR_RootConstrainSelectedInstOperands,
     /*  16843 */     // GIR_Coverage, 13441,
     /*  16843 */     GIR_EraseRootFromParent_Done,
     /*  16844 */   // Label 314: @16844
     /*  16844 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16959), // Rule ID 13440 //
     /*  16849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16918 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16922 */     // MIs[4] Operand 1
     /*  16922 */     // No operand predicates
     /*  16922 */     // MIs[2] Operand 2
     /*  16922 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16939 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16957 */     GIR_RootConstrainSelectedInstOperands,
     /*  16958 */     // GIR_Coverage, 13440,
     /*  16958 */     GIR_EraseRootFromParent_Done,
     /*  16959 */   // Label 315: @16959
     /*  16959 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17028), // Rule ID 1801 //
     /*  16964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17011 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17026 */     GIR_RootConstrainSelectedInstOperands,
     /*  17027 */     // GIR_Coverage, 1801,
     /*  17027 */     GIR_EraseRootFromParent_Done,
     /*  17028 */   // Label 316: @17028
     /*  17028 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17097), // Rule ID 1800 //
     /*  17033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17080 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17095 */     GIR_RootConstrainSelectedInstOperands,
     /*  17096 */     // GIR_Coverage, 1800,
     /*  17096 */     GIR_EraseRootFromParent_Done,
     /*  17097 */   // Label 317: @17097
     /*  17097 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17166), // Rule ID 1717 //
     /*  17102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17149 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17164 */     GIR_RootConstrainSelectedInstOperands,
     /*  17165 */     // GIR_Coverage, 1717,
     /*  17165 */     GIR_EraseRootFromParent_Done,
     /*  17166 */   // Label 318: @17166
     /*  17166 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17235), // Rule ID 1799 //
     /*  17171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17218 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17233 */     GIR_RootConstrainSelectedInstOperands,
     /*  17234 */     // GIR_Coverage, 1799,
     /*  17234 */     GIR_EraseRootFromParent_Done,
     /*  17235 */   // Label 319: @17235
     /*  17235 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17304), // Rule ID 1798 //
     /*  17240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17287 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17302 */     GIR_RootConstrainSelectedInstOperands,
     /*  17303 */     // GIR_Coverage, 1798,
     /*  17303 */     GIR_EraseRootFromParent_Done,
     /*  17304 */   // Label 320: @17304
     /*  17304 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17419), // Rule ID 13409 //
     /*  17309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17364 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17377 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17381 */     // MIs[4] Operand 1
     /*  17381 */     // No operand predicates
     /*  17381 */     // MIs[2] Operand 2
     /*  17381 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17399 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17417 */     GIR_RootConstrainSelectedInstOperands,
     /*  17418 */     // GIR_Coverage, 13409,
     /*  17418 */     GIR_EraseRootFromParent_Done,
     /*  17419 */   // Label 321: @17419
     /*  17419 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17534), // Rule ID 2040 //
     /*  17424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17480 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17484 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17489 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17493 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17497 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17501 */     // MIs[4] Operand 1
     /*  17501 */     // No operand predicates
     /*  17501 */     // MIs[2] Operand 2
     /*  17501 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17512 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17514 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17532 */     GIR_RootConstrainSelectedInstOperands,
     /*  17533 */     // GIR_Coverage, 2040,
     /*  17533 */     GIR_EraseRootFromParent_Done,
     /*  17534 */   // Label 322: @17534
     /*  17534 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17649), // Rule ID 13439 //
     /*  17539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17590 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17594 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17599 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17603 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17607 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17611 */     // MIs[4] Operand 1
     /*  17611 */     // No operand predicates
     /*  17611 */     // MIs[2] Operand 2
     /*  17611 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17627 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17629 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17647 */     GIR_RootConstrainSelectedInstOperands,
     /*  17648 */     // GIR_Coverage, 13439,
     /*  17648 */     GIR_EraseRootFromParent_Done,
     /*  17649 */   // Label 323: @17649
     /*  17649 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17764), // Rule ID 2092 //
     /*  17654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17714 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17723 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17727 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17731 */     // MIs[4] Operand 1
     /*  17731 */     // No operand predicates
     /*  17731 */     // MIs[2] Operand 2
     /*  17731 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17742 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17744 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17762 */     GIR_RootConstrainSelectedInstOperands,
     /*  17763 */     // GIR_Coverage, 2092,
     /*  17763 */     GIR_EraseRootFromParent_Done,
     /*  17764 */   // Label 324: @17764
     /*  17764 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17831), // Rule ID 13333 //
     /*  17769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17812 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17829 */     GIR_RootConstrainSelectedInstOperands,
     /*  17830 */     // GIR_Coverage, 13333,
     /*  17830 */     GIR_EraseRootFromParent_Done,
     /*  17831 */   // Label 325: @17831
     /*  17831 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17898), // Rule ID 13363 //
     /*  17836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17879 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17896 */     GIR_RootConstrainSelectedInstOperands,
     /*  17897 */     // GIR_Coverage, 13363,
     /*  17897 */     GIR_EraseRootFromParent_Done,
     /*  17898 */   // Label 326: @17898
     /*  17898 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17965), // Rule ID 1729 //
     /*  17903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17946 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17963 */     GIR_RootConstrainSelectedInstOperands,
     /*  17964 */     // GIR_Coverage, 1729,
     /*  17964 */     GIR_EraseRootFromParent_Done,
     /*  17965 */   // Label 327: @17965
     /*  17965 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18032), // Rule ID 1819 //
     /*  17970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18013 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18030 */     GIR_RootConstrainSelectedInstOperands,
     /*  18031 */     // GIR_Coverage, 1819,
     /*  18031 */     GIR_EraseRootFromParent_Done,
     /*  18032 */   // Label 328: @18032
     /*  18032 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18113), // Rule ID 13319 //
     /*  18037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18064 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18067 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18076 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18096 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18111 */     GIR_RootConstrainSelectedInstOperands,
     /*  18112 */     // GIR_Coverage, 13319,
     /*  18112 */     GIR_EraseRootFromParent_Done,
     /*  18113 */   // Label 329: @18113
     /*  18113 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18194), // Rule ID 13343 //
     /*  18118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18145 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18148 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18157 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18177 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18192 */     GIR_RootConstrainSelectedInstOperands,
     /*  18193 */     // GIR_Coverage, 13343,
     /*  18193 */     GIR_EraseRootFromParent_Done,
     /*  18194 */   // Label 330: @18194
     /*  18194 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18275), // Rule ID 1697 //
     /*  18199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18242 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18258 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18273 */     GIR_RootConstrainSelectedInstOperands,
     /*  18274 */     // GIR_Coverage, 1697,
     /*  18274 */     GIR_EraseRootFromParent_Done,
     /*  18275 */   // Label 331: @18275
     /*  18275 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18356), // Rule ID 1775 //
     /*  18280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18311 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18314 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18323 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18339 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18354 */     GIR_RootConstrainSelectedInstOperands,
     /*  18355 */     // GIR_Coverage, 1775,
     /*  18355 */     GIR_EraseRootFromParent_Done,
     /*  18356 */   // Label 332: @18356
     /*  18356 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18448), // Rule ID 13414 //
     /*  18361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18413 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18417 */     // MIs[3] Operand 1
     /*  18417 */     // No operand predicates
     /*  18417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18428 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18446 */     GIR_RootConstrainSelectedInstOperands,
     /*  18447 */     // GIR_Coverage, 13414,
     /*  18447 */     GIR_EraseRootFromParent_Done,
     /*  18448 */   // Label 333: @18448
     /*  18448 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18540), // Rule ID 13413 //
     /*  18453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18514 */     // MIs[3] Operand 1
     /*  18514 */     // No operand predicates
     /*  18514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18520 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18538 */     GIR_RootConstrainSelectedInstOperands,
     /*  18539 */     // GIR_Coverage, 13413,
     /*  18539 */     GIR_EraseRootFromParent_Done,
     /*  18540 */   // Label 334: @18540
     /*  18540 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18632), // Rule ID 13444 //
     /*  18545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18597 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18601 */     // MIs[3] Operand 1
     /*  18601 */     // No operand predicates
     /*  18601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18612 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18630 */     GIR_RootConstrainSelectedInstOperands,
     /*  18631 */     // GIR_Coverage, 13444,
     /*  18631 */     GIR_EraseRootFromParent_Done,
     /*  18632 */   // Label 335: @18632
     /*  18632 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18724), // Rule ID 13443 //
     /*  18637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18698 */     // MIs[3] Operand 1
     /*  18698 */     // No operand predicates
     /*  18698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18704 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18722 */     GIR_RootConstrainSelectedInstOperands,
     /*  18723 */     // GIR_Coverage, 13443,
     /*  18723 */     GIR_EraseRootFromParent_Done,
     /*  18724 */   // Label 336: @18724
     /*  18724 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18816), // Rule ID 13412 //
     /*  18729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18785 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18789 */     // MIs[3] Operand 1
     /*  18789 */     // No operand predicates
     /*  18789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18796 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18814 */     GIR_RootConstrainSelectedInstOperands,
     /*  18815 */     // GIR_Coverage, 13412,
     /*  18815 */     GIR_EraseRootFromParent_Done,
     /*  18816 */   // Label 337: @18816
     /*  18816 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18908), // Rule ID 2041 //
     /*  18821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18882 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18886 */     // MIs[3] Operand 1
     /*  18886 */     // No operand predicates
     /*  18886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18888 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18906 */     GIR_RootConstrainSelectedInstOperands,
     /*  18907 */     // GIR_Coverage, 2041,
     /*  18907 */     GIR_EraseRootFromParent_Done,
     /*  18908 */   // Label 338: @18908
     /*  18908 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19000), // Rule ID 13442 //
     /*  18913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18973 */     // MIs[3] Operand 1
     /*  18973 */     // No operand predicates
     /*  18973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18980 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18998 */     GIR_RootConstrainSelectedInstOperands,
     /*  18999 */     // GIR_Coverage, 13442,
     /*  18999 */     GIR_EraseRootFromParent_Done,
     /*  19000 */   // Label 339: @19000
     /*  19000 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19092), // Rule ID 2093 //
     /*  19005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19066 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19070 */     // MIs[3] Operand 1
     /*  19070 */     // No operand predicates
     /*  19070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19072 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19090 */     GIR_RootConstrainSelectedInstOperands,
     /*  19091 */     // GIR_Coverage, 2093,
     /*  19091 */     GIR_EraseRootFromParent_Done,
     /*  19092 */   // Label 340: @19092
     /*  19092 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19143), // Rule ID 13357 //
     /*  19097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19129 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19141 */     GIR_RootConstrainSelectedInstOperands,
     /*  19142 */     // GIR_Coverage, 13357,
     /*  19142 */     GIR_EraseRootFromParent_Done,
     /*  19143 */   // Label 341: @19143
     /*  19143 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19194), // Rule ID 13327 //
     /*  19148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19180 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19192 */     GIR_RootConstrainSelectedInstOperands,
     /*  19193 */     // GIR_Coverage, 13327,
     /*  19193 */     GIR_EraseRootFromParent_Done,
     /*  19194 */   // Label 342: @19194
     /*  19194 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19245), // Rule ID 13356 //
     /*  19199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19231 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19243 */     GIR_RootConstrainSelectedInstOperands,
     /*  19244 */     // GIR_Coverage, 13356,
     /*  19244 */     GIR_EraseRootFromParent_Done,
     /*  19245 */   // Label 343: @19245
     /*  19245 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19296), // Rule ID 1813 //
     /*  19250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19282 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19294 */     GIR_RootConstrainSelectedInstOperands,
     /*  19295 */     // GIR_Coverage, 1813,
     /*  19295 */     GIR_EraseRootFromParent_Done,
     /*  19296 */   // Label 344: @19296
     /*  19296 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19347), // Rule ID 1723 //
     /*  19301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19333 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19345 */     GIR_RootConstrainSelectedInstOperands,
     /*  19346 */     // GIR_Coverage, 1723,
     /*  19346 */     GIR_EraseRootFromParent_Done,
     /*  19347 */   // Label 345: @19347
     /*  19347 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19398), // Rule ID 1812 //
     /*  19352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19384 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19396 */     GIR_RootConstrainSelectedInstOperands,
     /*  19397 */     // GIR_Coverage, 1812,
     /*  19397 */     GIR_EraseRootFromParent_Done,
     /*  19398 */   // Label 346: @19398
     /*  19398 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19454), // Rule ID 13245 //
     /*  19403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19418 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19421 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19441 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19452 */     GIR_RootConstrainSelectedInstOperands,
     /*  19453 */     // GIR_Coverage, 13245,
     /*  19453 */     GIR_EraseRootFromParent_Done,
     /*  19454 */   // Label 347: @19454
     /*  19454 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19510), // Rule ID 13257 //
     /*  19459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19474 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19477 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19497 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19508 */     GIR_RootConstrainSelectedInstOperands,
     /*  19509 */     // GIR_Coverage, 13257,
     /*  19509 */     GIR_EraseRootFromParent_Done,
     /*  19510 */   // Label 348: @19510
     /*  19510 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19577), // Rule ID 13485 //
     /*  19515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19539 */     // MIs[1] imm
     /*  19539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19551 */     // MIs[2] Operand 1
     /*  19551 */     // No operand predicates
     /*  19551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19561 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19575 */     GIR_RootConstrainSelectedInstOperands,
     /*  19576 */     // GIR_Coverage, 13485,
     /*  19576 */     GIR_EraseRootFromParent_Done,
     /*  19577 */   // Label 349: @19577
     /*  19577 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19644), // Rule ID 13506 //
     /*  19582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19606 */     // MIs[1] imm
     /*  19606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19618 */     // MIs[2] Operand 1
     /*  19618 */     // No operand predicates
     /*  19618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19628 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19642 */     GIR_RootConstrainSelectedInstOperands,
     /*  19643 */     // GIR_Coverage, 13506,
     /*  19643 */     GIR_EraseRootFromParent_Done,
     /*  19644 */   // Label 350: @19644
     /*  19644 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19700), // Rule ID 999 //
     /*  19649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19668 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19671 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19687 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19698 */     GIR_RootConstrainSelectedInstOperands,
     /*  19699 */     // GIR_Coverage, 999,
     /*  19699 */     GIR_EraseRootFromParent_Done,
     /*  19700 */   // Label 351: @19700
     /*  19700 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19756), // Rule ID 1060 //
     /*  19705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19743 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19754 */     GIR_RootConstrainSelectedInstOperands,
     /*  19755 */     // GIR_Coverage, 1060,
     /*  19755 */     GIR_EraseRootFromParent_Done,
     /*  19756 */   // Label 352: @19756
     /*  19756 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19823), // Rule ID 2242 //
     /*  19761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19789 */     // MIs[1] imm
     /*  19789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19801 */     // MIs[2] Operand 1
     /*  19801 */     // No operand predicates
     /*  19801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19807 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19821 */     GIR_RootConstrainSelectedInstOperands,
     /*  19822 */     // GIR_Coverage, 2242,
     /*  19822 */     GIR_EraseRootFromParent_Done,
     /*  19823 */   // Label 353: @19823
     /*  19823 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19890), // Rule ID 2301 //
     /*  19828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19856 */     // MIs[1] imm
     /*  19856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19868 */     // MIs[2] Operand 1
     /*  19868 */     // No operand predicates
     /*  19868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19874 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19888 */     GIR_RootConstrainSelectedInstOperands,
     /*  19889 */     // GIR_Coverage, 2301,
     /*  19889 */     GIR_EraseRootFromParent_Done,
     /*  19890 */   // Label 354: @19890
     /*  19890 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19960), // Rule ID 6895 //
     /*  19895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19933 */     // MIs[2] Rn
     /*  19933 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19938 */     // MIs[2] Rm
     /*  19938 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19945 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19958 */     GIR_RootConstrainSelectedInstOperands,
     /*  19959 */     // GIR_Coverage, 6895,
     /*  19959 */     GIR_EraseRootFromParent_Done,
     /*  19960 */   // Label 355: @19960
     /*  19960 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20030), // Rule ID 13861 //
     /*  19965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20003 */     // MIs[2] Rn
     /*  20003 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20008 */     // MIs[2] Rm
     /*  20008 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20015 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20028 */     GIR_RootConstrainSelectedInstOperands,
     /*  20029 */     // GIR_Coverage, 13861,
     /*  20029 */     GIR_EraseRootFromParent_Done,
     /*  20030 */   // Label 356: @20030
     /*  20030 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20093), // Rule ID 1797 //
     /*  20035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20078 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20091 */     GIR_RootConstrainSelectedInstOperands,
     /*  20092 */     // GIR_Coverage, 1797,
     /*  20092 */     GIR_EraseRootFromParent_Done,
     /*  20093 */   // Label 357: @20093
     /*  20093 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20156), // Rule ID 1796 //
     /*  20098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20141 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20154 */     GIR_RootConstrainSelectedInstOperands,
     /*  20155 */     // GIR_Coverage, 1796,
     /*  20155 */     GIR_EraseRootFromParent_Done,
     /*  20156 */   // Label 358: @20156
     /*  20156 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20219), // Rule ID 1716 //
     /*  20161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20204 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20217 */     GIR_RootConstrainSelectedInstOperands,
     /*  20218 */     // GIR_Coverage, 1716,
     /*  20218 */     GIR_EraseRootFromParent_Done,
     /*  20219 */   // Label 359: @20219
     /*  20219 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20282), // Rule ID 1795 //
     /*  20224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20267 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20280 */     GIR_RootConstrainSelectedInstOperands,
     /*  20281 */     // GIR_Coverage, 1795,
     /*  20281 */     GIR_EraseRootFromParent_Done,
     /*  20282 */   // Label 360: @20282
     /*  20282 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20345), // Rule ID 1794 //
     /*  20287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20330 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20343 */     GIR_RootConstrainSelectedInstOperands,
     /*  20344 */     // GIR_Coverage, 1794,
     /*  20344 */     GIR_EraseRootFromParent_Done,
     /*  20345 */   // Label 361: @20345
     /*  20345 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20406), // Rule ID 13332 //
     /*  20350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20389 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20404 */     GIR_RootConstrainSelectedInstOperands,
     /*  20405 */     // GIR_Coverage, 13332,
     /*  20405 */     GIR_EraseRootFromParent_Done,
     /*  20406 */   // Label 362: @20406
     /*  20406 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20467), // Rule ID 13362 //
     /*  20411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20450 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20465 */     GIR_RootConstrainSelectedInstOperands,
     /*  20466 */     // GIR_Coverage, 13362,
     /*  20466 */     GIR_EraseRootFromParent_Done,
     /*  20467 */   // Label 363: @20467
     /*  20467 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20515), // Rule ID 13355 //
     /*  20472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20502 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20513 */     GIR_RootConstrainSelectedInstOperands,
     /*  20514 */     // GIR_Coverage, 13355,
     /*  20514 */     GIR_EraseRootFromParent_Done,
     /*  20515 */   // Label 364: @20515
     /*  20515 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20563), // Rule ID 13244 //
     /*  20520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20550 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20561 */     GIR_RootConstrainSelectedInstOperands,
     /*  20562 */     // GIR_Coverage, 13244,
     /*  20562 */     GIR_EraseRootFromParent_Done,
     /*  20563 */   // Label 365: @20563
     /*  20563 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20611), // Rule ID 13326 //
     /*  20568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20598 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20609 */     GIR_RootConstrainSelectedInstOperands,
     /*  20610 */     // GIR_Coverage, 13326,
     /*  20610 */     GIR_EraseRootFromParent_Done,
     /*  20611 */   // Label 366: @20611
     /*  20611 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20659), // Rule ID 13256 //
     /*  20616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20646 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20657 */     GIR_RootConstrainSelectedInstOperands,
     /*  20658 */     // GIR_Coverage, 13256,
     /*  20658 */     GIR_EraseRootFromParent_Done,
     /*  20659 */   // Label 367: @20659
     /*  20659 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20707), // Rule ID 13354 //
     /*  20664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20694 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20705 */     GIR_RootConstrainSelectedInstOperands,
     /*  20706 */     // GIR_Coverage, 13354,
     /*  20706 */     GIR_EraseRootFromParent_Done,
     /*  20707 */   // Label 368: @20707
     /*  20707 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20768), // Rule ID 1728 //
     /*  20712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20751 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20766 */     GIR_RootConstrainSelectedInstOperands,
     /*  20767 */     // GIR_Coverage, 1728,
     /*  20767 */     GIR_EraseRootFromParent_Done,
     /*  20768 */   // Label 369: @20768
     /*  20768 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20829), // Rule ID 1818 //
     /*  20773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20812 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20827 */     GIR_RootConstrainSelectedInstOperands,
     /*  20828 */     // GIR_Coverage, 1818,
     /*  20828 */     GIR_EraseRootFromParent_Done,
     /*  20829 */   // Label 370: @20829
     /*  20829 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20877), // Rule ID 1811 //
     /*  20834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20864 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20875 */     GIR_RootConstrainSelectedInstOperands,
     /*  20876 */     // GIR_Coverage, 1811,
     /*  20876 */     GIR_EraseRootFromParent_Done,
     /*  20877 */   // Label 371: @20877
     /*  20877 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20925), // Rule ID 998 //
     /*  20882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20912 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20923 */     GIR_RootConstrainSelectedInstOperands,
     /*  20924 */     // GIR_Coverage, 998,
     /*  20924 */     GIR_EraseRootFromParent_Done,
     /*  20925 */   // Label 372: @20925
     /*  20925 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20973), // Rule ID 1722 //
     /*  20930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20960 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20971 */     GIR_RootConstrainSelectedInstOperands,
     /*  20972 */     // GIR_Coverage, 1722,
     /*  20972 */     GIR_EraseRootFromParent_Done,
     /*  20973 */   // Label 373: @20973
     /*  20973 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21021), // Rule ID 1059 //
     /*  20978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21019 */     GIR_RootConstrainSelectedInstOperands,
     /*  21020 */     // GIR_Coverage, 1059,
     /*  21020 */     GIR_EraseRootFromParent_Done,
     /*  21021 */   // Label 374: @21021
     /*  21021 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21069), // Rule ID 1810 //
     /*  21026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21056 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21067 */     GIR_RootConstrainSelectedInstOperands,
     /*  21068 */     // GIR_Coverage, 1810,
     /*  21068 */     GIR_EraseRootFromParent_Done,
     /*  21069 */   // Label 375: @21069
     /*  21069 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21096), // Rule ID 1106 //
     /*  21074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21089 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21094 */     GIR_RootConstrainSelectedInstOperands,
     /*  21095 */     // GIR_Coverage, 1106,
     /*  21095 */     GIR_Done,
     /*  21096 */   // Label 376: @21096
     /*  21096 */   GIM_Reject,
     /*  21097 */ // Label 299: @21097
     /*  21097 */ GIM_Reject,
     /*  21098 */ // Label 162: @21098
     /*  21098 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(24595),
     /*  21103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21109 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21245), // Rule ID 5356 //
     /*  21114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21147 */     // MIs[1] Operand 2
     /*  21147 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21178 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21182 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21187 */     // MIs[3] Operand 2
     /*  21187 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21198 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21200 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21244 */     // GIR_Coverage, 5356,
     /*  21244 */     GIR_EraseRootFromParent_Done,
     /*  21245 */   // Label 378: @21245
     /*  21245 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21381), // Rule ID 5355 //
     /*  21250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21283 */     // MIs[1] Operand 2
     /*  21283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21314 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21318 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21323 */     // MIs[3] Operand 2
     /*  21323 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21336 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21363 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21380 */     // GIR_Coverage, 5355,
     /*  21380 */     GIR_EraseRootFromParent_Done,
     /*  21381 */   // Label 379: @21381
     /*  21381 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21517), // Rule ID 5371 //
     /*  21386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21419 */     // MIs[1] Operand 2
     /*  21419 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21450 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21454 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21459 */     // MIs[3] Operand 2
     /*  21459 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21472 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21516 */     // GIR_Coverage, 5371,
     /*  21516 */     GIR_EraseRootFromParent_Done,
     /*  21517 */   // Label 380: @21517
     /*  21517 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21653), // Rule ID 5354 //
     /*  21522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21555 */     // MIs[1] Operand 2
     /*  21555 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21578 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21582 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21586 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21590 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21595 */     // MIs[3] Operand 2
     /*  21595 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21608 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21652 */     // GIR_Coverage, 5354,
     /*  21652 */     GIR_EraseRootFromParent_Done,
     /*  21653 */   // Label 381: @21653
     /*  21653 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21789), // Rule ID 5353 //
     /*  21658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21691 */     // MIs[1] Operand 2
     /*  21691 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21726 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21731 */     // MIs[3] Operand 2
     /*  21731 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21742 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21744 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21788 */     // GIR_Coverage, 5353,
     /*  21788 */     GIR_EraseRootFromParent_Done,
     /*  21789 */   // Label 382: @21789
     /*  21789 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21922), // Rule ID 13866 //
     /*  21794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21839 */     // MIs[1] Operand 2
     /*  21839 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21854 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21858 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21866 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21870 */     // MIs[5] Rn
     /*  21870 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21875 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21877 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21921 */     // GIR_Coverage, 13866,
     /*  21921 */     GIR_EraseRootFromParent_Done,
     /*  21922 */   // Label 383: @21922
     /*  21922 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22055), // Rule ID 6900 //
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  21980 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21984 */     // MIs[4] Rn
     /*  21984 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21989 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21993 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21997 */     // MIs[3] Operand 2
     /*  21997 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22008 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22010 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22054 */     // GIR_Coverage, 6900,
     /*  22054 */     GIR_EraseRootFromParent_Done,
     /*  22055 */   // Label 384: @22055
     /*  22055 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22218), // Rule ID 13824 //
     /*  22060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22102 */     // MIs[1] Operand 2
     /*  22102 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22119 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22119 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22122 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22126 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22145 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22148 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22152 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22155 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22200 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22217 */     // GIR_Coverage, 13824,
     /*  22217 */     GIR_EraseRootFromParent_Done,
     /*  22218 */   // Label 385: @22218
     /*  22218 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22381), // Rule ID 13821 //
     /*  22223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22265 */     // MIs[1] Operand 2
     /*  22265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22282 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22308 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22315 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22363 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22380 */     // GIR_Coverage, 13821,
     /*  22380 */     GIR_EraseRootFromParent_Done,
     /*  22381 */   // Label 386: @22381
     /*  22381 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22531), // Rule ID 13828 //
     /*  22386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22419 */     // MIs[1] Operand 2
     /*  22419 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22436 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22462 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22530 */     // GIR_Coverage, 13828,
     /*  22530 */     GIR_EraseRootFromParent_Done,
     /*  22531 */   // Label 387: @22531
     /*  22531 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22681), // Rule ID 13833 //
     /*  22536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22569 */     // MIs[1] Operand 2
     /*  22569 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22586 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22600 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22603 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22607 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22612 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22619 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22680 */     // GIR_Coverage, 13833,
     /*  22680 */     GIR_EraseRootFromParent_Done,
     /*  22681 */   // Label 388: @22681
     /*  22681 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22831), // Rule ID 13827 //
     /*  22686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22719 */     // MIs[1] Operand 2
     /*  22719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22736 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22736 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22739 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22743 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22762 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22765 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22769 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22782 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22813 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22830 */     // GIR_Coverage, 13827,
     /*  22830 */     GIR_EraseRootFromParent_Done,
     /*  22831 */   // Label 389: @22831
     /*  22831 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22994), // Rule ID 5344 //
     /*  22836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22882 */     // MIs[1] Operand 2
     /*  22882 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22895 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22909 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22912 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22916 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22921 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22928 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22936 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22976 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22993 */     // GIR_Coverage, 5344,
     /*  22993 */     GIR_EraseRootFromParent_Done,
     /*  22994 */   // Label 390: @22994
     /*  22994 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23157), // Rule ID 5341 //
     /*  22999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23045 */     // MIs[1] Operand 2
     /*  23045 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23058 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23058 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23061 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23065 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23084 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23091 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23156 */     // GIR_Coverage, 5341,
     /*  23156 */     GIR_EraseRootFromParent_Done,
     /*  23157 */   // Label 391: @23157
     /*  23157 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23307), // Rule ID 5366 //
     /*  23162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23199 */     // MIs[1] Operand 2
     /*  23199 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23212 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23212 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23215 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23219 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23238 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23241 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23245 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23275 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23289 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23306 */     // GIR_Coverage, 5366,
     /*  23306 */     GIR_EraseRootFromParent_Done,
     /*  23307 */   // Label 392: @23307
     /*  23307 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23457), // Rule ID 5374 //
     /*  23312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23349 */     // MIs[1] Operand 2
     /*  23349 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23362 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23362 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23365 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23369 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23388 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23395 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23403 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23456 */     // GIR_Coverage, 5374,
     /*  23456 */     GIR_EraseRootFromParent_Done,
     /*  23457 */   // Label 393: @23457
     /*  23457 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23607), // Rule ID 5365 //
     /*  23462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23499 */     // MIs[1] Operand 2
     /*  23499 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23512 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23512 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23515 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23519 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23538 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23541 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23545 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23575 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23606 */     // GIR_Coverage, 5365,
     /*  23606 */     GIR_EraseRootFromParent_Done,
     /*  23607 */   // Label 394: @23607
     /*  23607 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23676), // Rule ID 13273 //
     /*  23612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23627 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23630 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23659 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23674 */     GIR_RootConstrainSelectedInstOperands,
     /*  23675 */     // GIR_Coverage, 13273,
     /*  23675 */     GIR_EraseRootFromParent_Done,
     /*  23676 */   // Label 395: @23676
     /*  23676 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23745), // Rule ID 13285 //
     /*  23681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23728 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23743 */     GIR_RootConstrainSelectedInstOperands,
     /*  23744 */     // GIR_Coverage, 13285,
     /*  23744 */     GIR_EraseRootFromParent_Done,
     /*  23745 */   // Label 396: @23745
     /*  23745 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(23801), // Rule ID 13235 //
     /*  23750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23765 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23768 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23788 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23799 */     GIR_RootConstrainSelectedInstOperands,
     /*  23800 */     // GIR_Coverage, 13235,
     /*  23800 */     GIR_EraseRootFromParent_Done,
     /*  23801 */   // Label 397: @23801
     /*  23801 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23857), // Rule ID 13247 //
     /*  23806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23821 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23824 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23844 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23855 */     GIR_RootConstrainSelectedInstOperands,
     /*  23856 */     // GIR_Coverage, 13247,
     /*  23856 */     GIR_EraseRootFromParent_Done,
     /*  23857 */   // Label 398: @23857
     /*  23857 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23924), // Rule ID 13477 //
     /*  23862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23886 */     // MIs[1] imm
     /*  23886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23894 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23898 */     // MIs[2] Operand 1
     /*  23898 */     // No operand predicates
     /*  23898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23908 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23922 */     GIR_RootConstrainSelectedInstOperands,
     /*  23923 */     // GIR_Coverage, 13477,
     /*  23923 */     GIR_EraseRootFromParent_Done,
     /*  23924 */   // Label 399: @23924
     /*  23924 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23991), // Rule ID 13498 //
     /*  23929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23953 */     // MIs[1] imm
     /*  23953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23965 */     // MIs[2] Operand 1
     /*  23965 */     // No operand predicates
     /*  23965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23975 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  23978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23989 */     GIR_RootConstrainSelectedInstOperands,
     /*  23990 */     // GIR_Coverage, 13498,
     /*  23990 */     GIR_EraseRootFromParent_Done,
     /*  23991 */   // Label 400: @23991
     /*  23991 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24060), // Rule ID 1361 //
     /*  23996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24015 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24018 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24043 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24058 */     GIR_RootConstrainSelectedInstOperands,
     /*  24059 */     // GIR_Coverage, 1361,
     /*  24059 */     GIR_EraseRootFromParent_Done,
     /*  24060 */   // Label 401: @24060
     /*  24060 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24129), // Rule ID 1484 //
     /*  24065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24084 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24087 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24096 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24112 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24127 */     GIR_RootConstrainSelectedInstOperands,
     /*  24128 */     // GIR_Coverage, 1484,
     /*  24128 */     GIR_EraseRootFromParent_Done,
     /*  24129 */   // Label 402: @24129
     /*  24129 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24185), // Rule ID 989 //
     /*  24134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24153 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24156 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24172 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24183 */     GIR_RootConstrainSelectedInstOperands,
     /*  24184 */     // GIR_Coverage, 989,
     /*  24184 */     GIR_EraseRootFromParent_Done,
     /*  24185 */   // Label 403: @24185
     /*  24185 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24241), // Rule ID 1050 //
     /*  24190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24209 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24212 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24228 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24239 */     GIR_RootConstrainSelectedInstOperands,
     /*  24240 */     // GIR_Coverage, 1050,
     /*  24240 */     GIR_EraseRootFromParent_Done,
     /*  24241 */   // Label 404: @24241
     /*  24241 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24308), // Rule ID 2234 //
     /*  24246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24274 */     // MIs[1] imm
     /*  24274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24282 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24286 */     // MIs[2] Operand 1
     /*  24286 */     // No operand predicates
     /*  24286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24292 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24306 */     GIR_RootConstrainSelectedInstOperands,
     /*  24307 */     // GIR_Coverage, 2234,
     /*  24307 */     GIR_EraseRootFromParent_Done,
     /*  24308 */   // Label 405: @24308
     /*  24308 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24375), // Rule ID 2293 //
     /*  24313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24341 */     // MIs[1] imm
     /*  24341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24353 */     // MIs[2] Operand 1
     /*  24353 */     // No operand predicates
     /*  24353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24359 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24373 */     GIR_RootConstrainSelectedInstOperands,
     /*  24374 */     // GIR_Coverage, 2293,
     /*  24374 */     GIR_EraseRootFromParent_Done,
     /*  24375 */   // Label 406: @24375
     /*  24375 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24423), // Rule ID 13234 //
     /*  24380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24410 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24421 */     GIR_RootConstrainSelectedInstOperands,
     /*  24422 */     // GIR_Coverage, 13234,
     /*  24422 */     GIR_EraseRootFromParent_Done,
     /*  24423 */   // Label 407: @24423
     /*  24423 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24471), // Rule ID 13246 //
     /*  24428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24458 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24469 */     GIR_RootConstrainSelectedInstOperands,
     /*  24470 */     // GIR_Coverage, 13246,
     /*  24470 */     GIR_EraseRootFromParent_Done,
     /*  24471 */   // Label 408: @24471
     /*  24471 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24519), // Rule ID 988 //
     /*  24476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24506 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24517 */     GIR_RootConstrainSelectedInstOperands,
     /*  24518 */     // GIR_Coverage, 988,
     /*  24518 */     GIR_EraseRootFromParent_Done,
     /*  24519 */   // Label 409: @24519
     /*  24519 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24567), // Rule ID 1049 //
     /*  24524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24554 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24565 */     GIR_RootConstrainSelectedInstOperands,
     /*  24566 */     // GIR_Coverage, 1049,
     /*  24566 */     GIR_EraseRootFromParent_Done,
     /*  24567 */   // Label 410: @24567
     /*  24567 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24594), // Rule ID 1102 //
     /*  24572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24587 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24592 */     GIR_RootConstrainSelectedInstOperands,
     /*  24593 */     // GIR_Coverage, 1102,
     /*  24593 */     GIR_Done,
     /*  24594 */   // Label 411: @24594
     /*  24594 */   GIM_Reject,
     /*  24595 */ // Label 377: @24595
     /*  24595 */ GIM_Reject,
     /*  24596 */ // Label 163: @24596
     /*  24596 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(30773),
     /*  24601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24607 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24725), // Rule ID 13407 //
     /*  24612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24676 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24680 */     // MIs[4] Operand 1
     /*  24680 */     // No operand predicates
     /*  24680 */     // MIs[2] Operand 2
     /*  24680 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24695 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24704 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24723 */     GIR_RootConstrainSelectedInstOperands,
     /*  24724 */     // GIR_Coverage, 13407,
     /*  24724 */     GIR_EraseRootFromParent_Done,
     /*  24725 */   // Label 413: @24725
     /*  24725 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24843), // Rule ID 13408 //
     /*  24730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24798 */     // MIs[4] Operand 1
     /*  24798 */     // No operand predicates
     /*  24798 */     // MIs[2] Operand 2
     /*  24798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24822 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24841 */     GIR_RootConstrainSelectedInstOperands,
     /*  24842 */     // GIR_Coverage, 13408,
     /*  24842 */     GIR_EraseRootFromParent_Done,
     /*  24843 */   // Label 414: @24843
     /*  24843 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24961), // Rule ID 13437 //
     /*  24848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24891 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24912 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24916 */     // MIs[4] Operand 1
     /*  24916 */     // No operand predicates
     /*  24916 */     // MIs[2] Operand 2
     /*  24916 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24931 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24940 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24959 */     GIR_RootConstrainSelectedInstOperands,
     /*  24960 */     // GIR_Coverage, 13437,
     /*  24960 */     GIR_EraseRootFromParent_Done,
     /*  24961 */   // Label 415: @24961
     /*  24961 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25079), // Rule ID 13438 //
     /*  24966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25030 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25034 */     // MIs[4] Operand 1
     /*  25034 */     // No operand predicates
     /*  25034 */     // MIs[2] Operand 2
     /*  25034 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25049 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25058 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25077 */     GIR_RootConstrainSelectedInstOperands,
     /*  25078 */     // GIR_Coverage, 13438,
     /*  25078 */     GIR_EraseRootFromParent_Done,
     /*  25079 */   // Label 416: @25079
     /*  25079 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25197), // Rule ID 2039 //
     /*  25084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25156 */     // MIs[4] Operand 1
     /*  25156 */     // No operand predicates
     /*  25156 */     // MIs[2] Operand 2
     /*  25156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25167 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25176 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25195 */     GIR_RootConstrainSelectedInstOperands,
     /*  25196 */     // GIR_Coverage, 2039,
     /*  25196 */     GIR_EraseRootFromParent_Done,
     /*  25197 */   // Label 417: @25197
     /*  25197 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25315), // Rule ID 13406 //
     /*  25202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25274 */     // MIs[4] Operand 1
     /*  25274 */     // No operand predicates
     /*  25274 */     // MIs[2] Operand 2
     /*  25274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25294 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25313 */     GIR_RootConstrainSelectedInstOperands,
     /*  25314 */     // GIR_Coverage, 13406,
     /*  25314 */     GIR_EraseRootFromParent_Done,
     /*  25315 */   // Label 418: @25315
     /*  25315 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25433), // Rule ID 2091 //
     /*  25320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25371 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25375 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25380 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25384 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25388 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25392 */     // MIs[4] Operand 1
     /*  25392 */     // No operand predicates
     /*  25392 */     // MIs[2] Operand 2
     /*  25392 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25403 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25412 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25431 */     GIR_RootConstrainSelectedInstOperands,
     /*  25432 */     // GIR_Coverage, 2091,
     /*  25432 */     GIR_EraseRootFromParent_Done,
     /*  25433 */   // Label 419: @25433
     /*  25433 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25551), // Rule ID 13436 //
     /*  25438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25485 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25493 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25502 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25506 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25510 */     // MIs[4] Operand 1
     /*  25510 */     // No operand predicates
     /*  25510 */     // MIs[2] Operand 2
     /*  25510 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25530 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25549 */     GIR_RootConstrainSelectedInstOperands,
     /*  25550 */     // GIR_Coverage, 13436,
     /*  25550 */     GIR_EraseRootFromParent_Done,
     /*  25551 */   // Label 420: @25551
     /*  25551 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25638), // Rule ID 13317 //
     /*  25556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25583 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25586 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25595 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25619 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25636 */     GIR_RootConstrainSelectedInstOperands,
     /*  25637 */     // GIR_Coverage, 13317,
     /*  25637 */     GIR_EraseRootFromParent_Done,
     /*  25638 */   // Label 421: @25638
     /*  25638 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25725), // Rule ID 13341 //
     /*  25643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25670 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25673 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25682 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25706 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25723 */     GIR_RootConstrainSelectedInstOperands,
     /*  25724 */     // GIR_Coverage, 13341,
     /*  25724 */     GIR_EraseRootFromParent_Done,
     /*  25725 */   // Label 422: @25725
     /*  25725 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25812), // Rule ID 1695 //
     /*  25730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25761 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25764 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25773 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25810 */     GIR_RootConstrainSelectedInstOperands,
     /*  25811 */     // GIR_Coverage, 1695,
     /*  25811 */     GIR_EraseRootFromParent_Done,
     /*  25812 */   // Label 423: @25812
     /*  25812 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25899), // Rule ID 1773 //
     /*  25817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25848 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25851 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25860 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25880 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25897 */     GIR_RootConstrainSelectedInstOperands,
     /*  25898 */     // GIR_Coverage, 1773,
     /*  25898 */     GIR_EraseRootFromParent_Done,
     /*  25899 */   // Label 424: @25899
     /*  25899 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26014), // Rule ID 13402 //
     /*  25904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25947 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25955 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25964 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25968 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25972 */     // MIs[4] Operand 1
     /*  25972 */     // No operand predicates
     /*  25972 */     // MIs[2] Operand 2
     /*  25972 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25992 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25994 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26012 */     GIR_RootConstrainSelectedInstOperands,
     /*  26013 */     // GIR_Coverage, 13402,
     /*  26013 */     GIR_EraseRootFromParent_Done,
     /*  26014 */   // Label 425: @26014
     /*  26014 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26129), // Rule ID 13401 //
     /*  26019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26088 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26092 */     // MIs[4] Operand 1
     /*  26092 */     // No operand predicates
     /*  26092 */     // MIs[2] Operand 2
     /*  26092 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26107 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26109 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26127 */     GIR_RootConstrainSelectedInstOperands,
     /*  26128 */     // GIR_Coverage, 13401,
     /*  26128 */     GIR_EraseRootFromParent_Done,
     /*  26129 */   // Label 426: @26129
     /*  26129 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26244), // Rule ID 13432 //
     /*  26134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26198 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26202 */     // MIs[4] Operand 1
     /*  26202 */     // No operand predicates
     /*  26202 */     // MIs[2] Operand 2
     /*  26202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26224 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26242 */     GIR_RootConstrainSelectedInstOperands,
     /*  26243 */     // GIR_Coverage, 13432,
     /*  26243 */     GIR_EraseRootFromParent_Done,
     /*  26244 */   // Label 427: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26359), // Rule ID 13431 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26318 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26322 */     // MIs[4] Operand 1
     /*  26322 */     // No operand predicates
     /*  26322 */     // MIs[2] Operand 2
     /*  26322 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26339 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26357 */     GIR_RootConstrainSelectedInstOperands,
     /*  26358 */     // GIR_Coverage, 13431,
     /*  26358 */     GIR_EraseRootFromParent_Done,
     /*  26359 */   // Label 428: @26359
     /*  26359 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26428), // Rule ID 1793 //
     /*  26364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26411 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26426 */     GIR_RootConstrainSelectedInstOperands,
     /*  26427 */     // GIR_Coverage, 1793,
     /*  26427 */     GIR_EraseRootFromParent_Done,
     /*  26428 */   // Label 429: @26428
     /*  26428 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26497), // Rule ID 1792 //
     /*  26433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26480 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26495 */     GIR_RootConstrainSelectedInstOperands,
     /*  26496 */     // GIR_Coverage, 1792,
     /*  26496 */     GIR_EraseRootFromParent_Done,
     /*  26497 */   // Label 430: @26497
     /*  26497 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26566), // Rule ID 1715 //
     /*  26502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26549 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26564 */     GIR_RootConstrainSelectedInstOperands,
     /*  26565 */     // GIR_Coverage, 1715,
     /*  26565 */     GIR_EraseRootFromParent_Done,
     /*  26566 */   // Label 431: @26566
     /*  26566 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26635), // Rule ID 1791 //
     /*  26571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26618 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26633 */     GIR_RootConstrainSelectedInstOperands,
     /*  26634 */     // GIR_Coverage, 1791,
     /*  26634 */     GIR_EraseRootFromParent_Done,
     /*  26635 */   // Label 432: @26635
     /*  26635 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26704), // Rule ID 1790 //
     /*  26640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26687 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26702 */     GIR_RootConstrainSelectedInstOperands,
     /*  26703 */     // GIR_Coverage, 1790,
     /*  26703 */     GIR_EraseRootFromParent_Done,
     /*  26704 */   // Label 433: @26704
     /*  26704 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26819), // Rule ID 13400 //
     /*  26709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26777 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26781 */     // MIs[4] Operand 1
     /*  26781 */     // No operand predicates
     /*  26781 */     // MIs[2] Operand 2
     /*  26781 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26797 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26799 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26817 */     GIR_RootConstrainSelectedInstOperands,
     /*  26818 */     // GIR_Coverage, 13400,
     /*  26818 */     GIR_EraseRootFromParent_Done,
     /*  26819 */   // Label 434: @26819
     /*  26819 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26934), // Rule ID 2037 //
     /*  26824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26884 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26897 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26901 */     // MIs[4] Operand 1
     /*  26901 */     // No operand predicates
     /*  26901 */     // MIs[2] Operand 2
     /*  26901 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26912 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26914 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26932 */     GIR_RootConstrainSelectedInstOperands,
     /*  26933 */     // GIR_Coverage, 2037,
     /*  26933 */     GIR_EraseRootFromParent_Done,
     /*  26934 */   // Label 435: @26934
     /*  26934 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27049), // Rule ID 13430 //
     /*  26939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26999 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27003 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27007 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27011 */     // MIs[4] Operand 1
     /*  27011 */     // No operand predicates
     /*  27011 */     // MIs[2] Operand 2
     /*  27011 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27027 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27029 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27047 */     GIR_RootConstrainSelectedInstOperands,
     /*  27048 */     // GIR_Coverage, 13430,
     /*  27048 */     GIR_EraseRootFromParent_Done,
     /*  27049 */   // Label 436: @27049
     /*  27049 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27164), // Rule ID 2089 //
     /*  27054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27114 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27123 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27127 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27131 */     // MIs[4] Operand 1
     /*  27131 */     // No operand predicates
     /*  27131 */     // MIs[2] Operand 2
     /*  27131 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27142 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27144 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27162 */     GIR_RootConstrainSelectedInstOperands,
     /*  27163 */     // GIR_Coverage, 2089,
     /*  27163 */     GIR_EraseRootFromParent_Done,
     /*  27164 */   // Label 437: @27164
     /*  27164 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27231), // Rule ID 13331 //
     /*  27169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27212 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27229 */     GIR_RootConstrainSelectedInstOperands,
     /*  27230 */     // GIR_Coverage, 13331,
     /*  27230 */     GIR_EraseRootFromParent_Done,
     /*  27231 */   // Label 438: @27231
     /*  27231 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27298), // Rule ID 13361 //
     /*  27236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27279 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27296 */     GIR_RootConstrainSelectedInstOperands,
     /*  27297 */     // GIR_Coverage, 13361,
     /*  27297 */     GIR_EraseRootFromParent_Done,
     /*  27298 */   // Label 439: @27298
     /*  27298 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27365), // Rule ID 1727 //
     /*  27303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27346 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27363 */     GIR_RootConstrainSelectedInstOperands,
     /*  27364 */     // GIR_Coverage, 1727,
     /*  27364 */     GIR_EraseRootFromParent_Done,
     /*  27365 */   // Label 440: @27365
     /*  27365 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27432), // Rule ID 1817 //
     /*  27370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27413 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27430 */     GIR_RootConstrainSelectedInstOperands,
     /*  27431 */     // GIR_Coverage, 1817,
     /*  27431 */     GIR_EraseRootFromParent_Done,
     /*  27432 */   // Label 441: @27432
     /*  27432 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27513), // Rule ID 13315 //
     /*  27437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27464 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27467 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27476 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27496 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27511 */     GIR_RootConstrainSelectedInstOperands,
     /*  27512 */     // GIR_Coverage, 13315,
     /*  27512 */     GIR_EraseRootFromParent_Done,
     /*  27513 */   // Label 442: @27513
     /*  27513 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27594), // Rule ID 13339 //
     /*  27518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27545 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27548 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27557 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27577 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27592 */     GIR_RootConstrainSelectedInstOperands,
     /*  27593 */     // GIR_Coverage, 13339,
     /*  27593 */     GIR_EraseRootFromParent_Done,
     /*  27594 */   // Label 443: @27594
     /*  27594 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27675), // Rule ID 1693 //
     /*  27599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27630 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27633 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27642 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27658 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27673 */     GIR_RootConstrainSelectedInstOperands,
     /*  27674 */     // GIR_Coverage, 1693,
     /*  27674 */     GIR_EraseRootFromParent_Done,
     /*  27675 */   // Label 444: @27675
     /*  27675 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27756), // Rule ID 1771 //
     /*  27680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27711 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27714 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27723 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27739 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27754 */     GIR_RootConstrainSelectedInstOperands,
     /*  27755 */     // GIR_Coverage, 1771,
     /*  27755 */     GIR_EraseRootFromParent_Done,
     /*  27756 */   // Label 445: @27756
     /*  27756 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27848), // Rule ID 13405 //
     /*  27761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27817 */     // MIs[3] Operand 1
     /*  27817 */     // No operand predicates
     /*  27817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27828 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27846 */     GIR_RootConstrainSelectedInstOperands,
     /*  27847 */     // GIR_Coverage, 13405,
     /*  27847 */     GIR_EraseRootFromParent_Done,
     /*  27848 */   // Label 446: @27848
     /*  27848 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27940), // Rule ID 13404 //
     /*  27853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27914 */     // MIs[3] Operand 1
     /*  27914 */     // No operand predicates
     /*  27914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27920 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27938 */     GIR_RootConstrainSelectedInstOperands,
     /*  27939 */     // GIR_Coverage, 13404,
     /*  27939 */     GIR_EraseRootFromParent_Done,
     /*  27940 */   // Label 447: @27940
     /*  27940 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28032), // Rule ID 13435 //
     /*  27945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28001 */     // MIs[3] Operand 1
     /*  28001 */     // No operand predicates
     /*  28001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28012 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28030 */     GIR_RootConstrainSelectedInstOperands,
     /*  28031 */     // GIR_Coverage, 13435,
     /*  28031 */     GIR_EraseRootFromParent_Done,
     /*  28032 */   // Label 448: @28032
     /*  28032 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28124), // Rule ID 13434 //
     /*  28037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28098 */     // MIs[3] Operand 1
     /*  28098 */     // No operand predicates
     /*  28098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28104 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28122 */     GIR_RootConstrainSelectedInstOperands,
     /*  28123 */     // GIR_Coverage, 13434,
     /*  28123 */     GIR_EraseRootFromParent_Done,
     /*  28124 */   // Label 449: @28124
     /*  28124 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28216), // Rule ID 13403 //
     /*  28129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28189 */     // MIs[3] Operand 1
     /*  28189 */     // No operand predicates
     /*  28189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28196 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28214 */     GIR_RootConstrainSelectedInstOperands,
     /*  28215 */     // GIR_Coverage, 13403,
     /*  28215 */     GIR_EraseRootFromParent_Done,
     /*  28216 */   // Label 450: @28216
     /*  28216 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28308), // Rule ID 2038 //
     /*  28221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28286 */     // MIs[3] Operand 1
     /*  28286 */     // No operand predicates
     /*  28286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28288 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28306 */     GIR_RootConstrainSelectedInstOperands,
     /*  28307 */     // GIR_Coverage, 2038,
     /*  28307 */     GIR_EraseRootFromParent_Done,
     /*  28308 */   // Label 451: @28308
     /*  28308 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28400), // Rule ID 13433 //
     /*  28313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28373 */     // MIs[3] Operand 1
     /*  28373 */     // No operand predicates
     /*  28373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28380 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28398 */     GIR_RootConstrainSelectedInstOperands,
     /*  28399 */     // GIR_Coverage, 13433,
     /*  28399 */     GIR_EraseRootFromParent_Done,
     /*  28400 */   // Label 452: @28400
     /*  28400 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28492), // Rule ID 2090 //
     /*  28405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28470 */     // MIs[3] Operand 1
     /*  28470 */     // No operand predicates
     /*  28470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28472 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28490 */     GIR_RootConstrainSelectedInstOperands,
     /*  28491 */     // GIR_Coverage, 2090,
     /*  28491 */     GIR_EraseRootFromParent_Done,
     /*  28492 */   // Label 453: @28492
     /*  28492 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28543), // Rule ID 13353 //
     /*  28497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28529 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28541 */     GIR_RootConstrainSelectedInstOperands,
     /*  28542 */     // GIR_Coverage, 13353,
     /*  28542 */     GIR_EraseRootFromParent_Done,
     /*  28543 */   // Label 454: @28543
     /*  28543 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28594), // Rule ID 13325 //
     /*  28548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28580 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28592 */     GIR_RootConstrainSelectedInstOperands,
     /*  28593 */     // GIR_Coverage, 13325,
     /*  28593 */     GIR_EraseRootFromParent_Done,
     /*  28594 */   // Label 455: @28594
     /*  28594 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28645), // Rule ID 13352 //
     /*  28599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28631 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28643 */     GIR_RootConstrainSelectedInstOperands,
     /*  28644 */     // GIR_Coverage, 13352,
     /*  28644 */     GIR_EraseRootFromParent_Done,
     /*  28645 */   // Label 456: @28645
     /*  28645 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28696), // Rule ID 1809 //
     /*  28650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28682 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28694 */     GIR_RootConstrainSelectedInstOperands,
     /*  28695 */     // GIR_Coverage, 1809,
     /*  28695 */     GIR_EraseRootFromParent_Done,
     /*  28696 */   // Label 457: @28696
     /*  28696 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28747), // Rule ID 1721 //
     /*  28701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28733 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28745 */     GIR_RootConstrainSelectedInstOperands,
     /*  28746 */     // GIR_Coverage, 1721,
     /*  28746 */     GIR_EraseRootFromParent_Done,
     /*  28747 */   // Label 458: @28747
     /*  28747 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28798), // Rule ID 1808 //
     /*  28752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28784 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28796 */     GIR_RootConstrainSelectedInstOperands,
     /*  28797 */     // GIR_Coverage, 1808,
     /*  28797 */     GIR_EraseRootFromParent_Done,
     /*  28798 */   // Label 459: @28798
     /*  28798 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28867), // Rule ID 13279 //
     /*  28803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28818 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28821 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28830 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28850 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28865 */     GIR_RootConstrainSelectedInstOperands,
     /*  28866 */     // GIR_Coverage, 13279,
     /*  28866 */     GIR_EraseRootFromParent_Done,
     /*  28867 */   // Label 460: @28867
     /*  28867 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28936), // Rule ID 13291 //
     /*  28872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28887 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28890 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28899 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28919 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28934 */     GIR_RootConstrainSelectedInstOperands,
     /*  28935 */     // GIR_Coverage, 13291,
     /*  28935 */     GIR_EraseRootFromParent_Done,
     /*  28936 */   // Label 461: @28936
     /*  28936 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28992), // Rule ID 13241 //
     /*  28941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28979 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28990 */     GIR_RootConstrainSelectedInstOperands,
     /*  28991 */     // GIR_Coverage, 13241,
     /*  28991 */     GIR_EraseRootFromParent_Done,
     /*  28992 */   // Label 462: @28992
     /*  28992 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29048), // Rule ID 13253 //
     /*  28997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29035 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29046 */     GIR_RootConstrainSelectedInstOperands,
     /*  29047 */     // GIR_Coverage, 13253,
     /*  29047 */     GIR_EraseRootFromParent_Done,
     /*  29048 */   // Label 463: @29048
     /*  29048 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29115), // Rule ID 13483 //
     /*  29053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29077 */     // MIs[1] imm
     /*  29077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29089 */     // MIs[2] Operand 1
     /*  29089 */     // No operand predicates
     /*  29089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29099 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29113 */     GIR_RootConstrainSelectedInstOperands,
     /*  29114 */     // GIR_Coverage, 13483,
     /*  29114 */     GIR_EraseRootFromParent_Done,
     /*  29115 */   // Label 464: @29115
     /*  29115 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29182), // Rule ID 13504 //
     /*  29120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29144 */     // MIs[1] imm
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29156 */     // MIs[2] Operand 1
     /*  29156 */     // No operand predicates
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29166 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29180 */     GIR_RootConstrainSelectedInstOperands,
     /*  29181 */     // GIR_Coverage, 13504,
     /*  29181 */     GIR_EraseRootFromParent_Done,
     /*  29182 */   // Label 465: @29182
     /*  29182 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29251), // Rule ID 1367 //
     /*  29187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29206 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29209 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29218 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29234 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29249 */     GIR_RootConstrainSelectedInstOperands,
     /*  29250 */     // GIR_Coverage, 1367,
     /*  29250 */     GIR_EraseRootFromParent_Done,
     /*  29251 */   // Label 466: @29251
     /*  29251 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29320), // Rule ID 1490 //
     /*  29256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29303 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29318 */     GIR_RootConstrainSelectedInstOperands,
     /*  29319 */     // GIR_Coverage, 1490,
     /*  29319 */     GIR_EraseRootFromParent_Done,
     /*  29320 */   // Label 467: @29320
     /*  29320 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29376), // Rule ID 995 //
     /*  29325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29344 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29347 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29363 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29374 */     GIR_RootConstrainSelectedInstOperands,
     /*  29375 */     // GIR_Coverage, 995,
     /*  29375 */     GIR_EraseRootFromParent_Done,
     /*  29376 */   // Label 468: @29376
     /*  29376 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29432), // Rule ID 1056 //
     /*  29381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29400 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29403 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29419 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29430 */     GIR_RootConstrainSelectedInstOperands,
     /*  29431 */     // GIR_Coverage, 1056,
     /*  29431 */     GIR_EraseRootFromParent_Done,
     /*  29432 */   // Label 469: @29432
     /*  29432 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29499), // Rule ID 2240 //
     /*  29437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29465 */     // MIs[1] imm
     /*  29465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29473 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29477 */     // MIs[2] Operand 1
     /*  29477 */     // No operand predicates
     /*  29477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29483 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29497 */     GIR_RootConstrainSelectedInstOperands,
     /*  29498 */     // GIR_Coverage, 2240,
     /*  29498 */     GIR_EraseRootFromParent_Done,
     /*  29499 */   // Label 470: @29499
     /*  29499 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29566), // Rule ID 2299 //
     /*  29504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29532 */     // MIs[1] imm
     /*  29532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29544 */     // MIs[2] Operand 1
     /*  29544 */     // No operand predicates
     /*  29544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29550 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29564 */     GIR_RootConstrainSelectedInstOperands,
     /*  29565 */     // GIR_Coverage, 2299,
     /*  29565 */     GIR_EraseRootFromParent_Done,
     /*  29566 */   // Label 471: @29566
     /*  29566 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29636), // Rule ID 6896 //
     /*  29571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29609 */     // MIs[2] Rn
     /*  29609 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29614 */     // MIs[2] Rm
     /*  29614 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29621 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29634 */     GIR_RootConstrainSelectedInstOperands,
     /*  29635 */     // GIR_Coverage, 6896,
     /*  29635 */     GIR_EraseRootFromParent_Done,
     /*  29636 */   // Label 472: @29636
     /*  29636 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29706), // Rule ID 13862 //
     /*  29641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29679 */     // MIs[2] Rn
     /*  29679 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29684 */     // MIs[2] Rm
     /*  29684 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29691 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29704 */     GIR_RootConstrainSelectedInstOperands,
     /*  29705 */     // GIR_Coverage, 13862,
     /*  29705 */     GIR_EraseRootFromParent_Done,
     /*  29706 */   // Label 473: @29706
     /*  29706 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29769), // Rule ID 1789 //
     /*  29711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29754 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29767 */     GIR_RootConstrainSelectedInstOperands,
     /*  29768 */     // GIR_Coverage, 1789,
     /*  29768 */     GIR_EraseRootFromParent_Done,
     /*  29769 */   // Label 474: @29769
     /*  29769 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(29832), // Rule ID 1788 //
     /*  29774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29817 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29830 */     GIR_RootConstrainSelectedInstOperands,
     /*  29831 */     // GIR_Coverage, 1788,
     /*  29831 */     GIR_EraseRootFromParent_Done,
     /*  29832 */   // Label 475: @29832
     /*  29832 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(29895), // Rule ID 1714 //
     /*  29837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29880 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29893 */     GIR_RootConstrainSelectedInstOperands,
     /*  29894 */     // GIR_Coverage, 1714,
     /*  29894 */     GIR_EraseRootFromParent_Done,
     /*  29895 */   // Label 476: @29895
     /*  29895 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29958), // Rule ID 1787 //
     /*  29900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29943 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29956 */     GIR_RootConstrainSelectedInstOperands,
     /*  29957 */     // GIR_Coverage, 1787,
     /*  29957 */     GIR_EraseRootFromParent_Done,
     /*  29958 */   // Label 477: @29958
     /*  29958 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30021), // Rule ID 1786 //
     /*  29963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30006 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30019 */     GIR_RootConstrainSelectedInstOperands,
     /*  30020 */     // GIR_Coverage, 1786,
     /*  30020 */     GIR_EraseRootFromParent_Done,
     /*  30021 */   // Label 478: @30021
     /*  30021 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30082), // Rule ID 13330 //
     /*  30026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30065 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30080 */     GIR_RootConstrainSelectedInstOperands,
     /*  30081 */     // GIR_Coverage, 13330,
     /*  30081 */     GIR_EraseRootFromParent_Done,
     /*  30082 */   // Label 479: @30082
     /*  30082 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30143), // Rule ID 13360 //
     /*  30087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30126 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30141 */     GIR_RootConstrainSelectedInstOperands,
     /*  30142 */     // GIR_Coverage, 13360,
     /*  30142 */     GIR_EraseRootFromParent_Done,
     /*  30143 */   // Label 480: @30143
     /*  30143 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30191), // Rule ID 13351 //
     /*  30148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30178 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30189 */     GIR_RootConstrainSelectedInstOperands,
     /*  30190 */     // GIR_Coverage, 13351,
     /*  30190 */     GIR_EraseRootFromParent_Done,
     /*  30191 */   // Label 481: @30191
     /*  30191 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30239), // Rule ID 13240 //
     /*  30196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30226 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30237 */     GIR_RootConstrainSelectedInstOperands,
     /*  30238 */     // GIR_Coverage, 13240,
     /*  30238 */     GIR_EraseRootFromParent_Done,
     /*  30239 */   // Label 482: @30239
     /*  30239 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30287), // Rule ID 13324 //
     /*  30244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30274 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30285 */     GIR_RootConstrainSelectedInstOperands,
     /*  30286 */     // GIR_Coverage, 13324,
     /*  30286 */     GIR_EraseRootFromParent_Done,
     /*  30287 */   // Label 483: @30287
     /*  30287 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30335), // Rule ID 13252 //
     /*  30292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30322 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30333 */     GIR_RootConstrainSelectedInstOperands,
     /*  30334 */     // GIR_Coverage, 13252,
     /*  30334 */     GIR_EraseRootFromParent_Done,
     /*  30335 */   // Label 484: @30335
     /*  30335 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30383), // Rule ID 13350 //
     /*  30340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30370 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30381 */     GIR_RootConstrainSelectedInstOperands,
     /*  30382 */     // GIR_Coverage, 13350,
     /*  30382 */     GIR_EraseRootFromParent_Done,
     /*  30383 */   // Label 485: @30383
     /*  30383 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30444), // Rule ID 1726 //
     /*  30388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30427 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30442 */     GIR_RootConstrainSelectedInstOperands,
     /*  30443 */     // GIR_Coverage, 1726,
     /*  30443 */     GIR_EraseRootFromParent_Done,
     /*  30444 */   // Label 486: @30444
     /*  30444 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30505), // Rule ID 1816 //
     /*  30449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30488 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30503 */     GIR_RootConstrainSelectedInstOperands,
     /*  30504 */     // GIR_Coverage, 1816,
     /*  30504 */     GIR_EraseRootFromParent_Done,
     /*  30505 */   // Label 487: @30505
     /*  30505 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30553), // Rule ID 1807 //
     /*  30510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30540 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30551 */     GIR_RootConstrainSelectedInstOperands,
     /*  30552 */     // GIR_Coverage, 1807,
     /*  30552 */     GIR_EraseRootFromParent_Done,
     /*  30553 */   // Label 488: @30553
     /*  30553 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30601), // Rule ID 994 //
     /*  30558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30588 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30599 */     GIR_RootConstrainSelectedInstOperands,
     /*  30600 */     // GIR_Coverage, 994,
     /*  30600 */     GIR_EraseRootFromParent_Done,
     /*  30601 */   // Label 489: @30601
     /*  30601 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30649), // Rule ID 1720 //
     /*  30606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30636 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30647 */     GIR_RootConstrainSelectedInstOperands,
     /*  30648 */     // GIR_Coverage, 1720,
     /*  30648 */     GIR_EraseRootFromParent_Done,
     /*  30649 */   // Label 490: @30649
     /*  30649 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(30697), // Rule ID 1055 //
     /*  30654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30684 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30695 */     GIR_RootConstrainSelectedInstOperands,
     /*  30696 */     // GIR_Coverage, 1055,
     /*  30696 */     GIR_EraseRootFromParent_Done,
     /*  30697 */   // Label 491: @30697
     /*  30697 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30745), // Rule ID 1806 //
     /*  30702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30732 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30743 */     GIR_RootConstrainSelectedInstOperands,
     /*  30744 */     // GIR_Coverage, 1806,
     /*  30744 */     GIR_EraseRootFromParent_Done,
     /*  30745 */   // Label 492: @30745
     /*  30745 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30772), // Rule ID 1105 //
     /*  30750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30765 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30770 */     GIR_RootConstrainSelectedInstOperands,
     /*  30771 */     // GIR_Coverage, 1105,
     /*  30771 */     GIR_Done,
     /*  30772 */   // Label 493: @30772
     /*  30772 */   GIM_Reject,
     /*  30773 */ // Label 412: @30773
     /*  30773 */ GIM_Reject,
     /*  30774 */ // Label 164: @30774
     /*  30774 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31623),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30785 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30918), // Rule ID 13867 //
     /*  30790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30835 */     // MIs[1] Operand 2
     /*  30835 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30854 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30858 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30862 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30866 */     // MIs[5] Rn
     /*  30866 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30871 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30873 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30900 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30917 */     // GIR_Coverage, 13867,
     /*  30917 */     GIR_EraseRootFromParent_Done,
     /*  30918 */   // Label 495: @30918
     /*  30918 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31051), // Rule ID 6901 //
     /*  30923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  30976 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30980 */     // MIs[4] Rn
     /*  30980 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30985 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30989 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30993 */     // MIs[3] Operand 2
     /*  30993 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31004 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31006 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31033 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31050 */     // GIR_Coverage, 6901,
     /*  31050 */     GIR_EraseRootFromParent_Done,
     /*  31051 */   // Label 496: @31051
     /*  31051 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31120), // Rule ID 13269 //
     /*  31056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31071 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31074 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31083 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31103 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31118 */     GIR_RootConstrainSelectedInstOperands,
     /*  31119 */     // GIR_Coverage, 13269,
     /*  31119 */     GIR_EraseRootFromParent_Done,
     /*  31120 */   // Label 497: @31120
     /*  31120 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31189), // Rule ID 13281 //
     /*  31125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31140 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31143 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31172 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31187 */     GIR_RootConstrainSelectedInstOperands,
     /*  31188 */     // GIR_Coverage, 13281,
     /*  31188 */     GIR_EraseRootFromParent_Done,
     /*  31189 */   // Label 498: @31189
     /*  31189 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31256), // Rule ID 13473 //
     /*  31194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31218 */     // MIs[1] imm
     /*  31218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31230 */     // MIs[2] Operand 1
     /*  31230 */     // No operand predicates
     /*  31230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31240 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31254 */     GIR_RootConstrainSelectedInstOperands,
     /*  31255 */     // GIR_Coverage, 13473,
     /*  31255 */     GIR_EraseRootFromParent_Done,
     /*  31256 */   // Label 499: @31256
     /*  31256 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31323), // Rule ID 13494 //
     /*  31261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31285 */     // MIs[1] imm
     /*  31285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31297 */     // MIs[2] Operand 1
     /*  31297 */     // No operand predicates
     /*  31297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31307 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31321 */     GIR_RootConstrainSelectedInstOperands,
     /*  31322 */     // GIR_Coverage, 13494,
     /*  31322 */     GIR_EraseRootFromParent_Done,
     /*  31323 */   // Label 500: @31323
     /*  31323 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31392), // Rule ID 1357 //
     /*  31328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31347 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31350 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31359 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31375 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31390 */     GIR_RootConstrainSelectedInstOperands,
     /*  31391 */     // GIR_Coverage, 1357,
     /*  31391 */     GIR_EraseRootFromParent_Done,
     /*  31392 */   // Label 501: @31392
     /*  31392 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31461), // Rule ID 1480 //
     /*  31397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31416 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31419 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31444 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31459 */     GIR_RootConstrainSelectedInstOperands,
     /*  31460 */     // GIR_Coverage, 1480,
     /*  31460 */     GIR_EraseRootFromParent_Done,
     /*  31461 */   // Label 502: @31461
     /*  31461 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31528), // Rule ID 2230 //
     /*  31466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31494 */     // MIs[1] imm
     /*  31494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31506 */     // MIs[2] Operand 1
     /*  31506 */     // No operand predicates
     /*  31506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31512 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31526 */     GIR_RootConstrainSelectedInstOperands,
     /*  31527 */     // GIR_Coverage, 2230,
     /*  31527 */     GIR_EraseRootFromParent_Done,
     /*  31528 */   // Label 503: @31528
     /*  31528 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31595), // Rule ID 2289 //
     /*  31533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31561 */     // MIs[1] imm
     /*  31561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31569 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31573 */     // MIs[2] Operand 1
     /*  31573 */     // No operand predicates
     /*  31573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31579 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31593 */     GIR_RootConstrainSelectedInstOperands,
     /*  31594 */     // GIR_Coverage, 2289,
     /*  31594 */     GIR_EraseRootFromParent_Done,
     /*  31595 */   // Label 504: @31595
     /*  31595 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31622), // Rule ID 1100 //
     /*  31600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31615 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31620 */     GIR_RootConstrainSelectedInstOperands,
     /*  31621 */     // GIR_Coverage, 1100,
     /*  31621 */     GIR_Done,
     /*  31622 */   // Label 505: @31622
     /*  31622 */   GIM_Reject,
     /*  31623 */ // Label 494: @31623
     /*  31623 */ GIM_Reject,
     /*  31624 */ // Label 165: @31624
     /*  31624 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(35201),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31635 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31722), // Rule ID 13313 //
     /*  31640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31667 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31670 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31679 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31703 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31720 */     GIR_RootConstrainSelectedInstOperands,
     /*  31721 */     // GIR_Coverage, 13313,
     /*  31721 */     GIR_EraseRootFromParent_Done,
     /*  31722 */   // Label 507: @31722
     /*  31722 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31809), // Rule ID 13337 //
     /*  31727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31754 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31757 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31766 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31790 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31807 */     GIR_RootConstrainSelectedInstOperands,
     /*  31808 */     // GIR_Coverage, 13337,
     /*  31808 */     GIR_EraseRootFromParent_Done,
     /*  31809 */   // Label 508: @31809
     /*  31809 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31896), // Rule ID 1691 //
     /*  31814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31845 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31848 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31857 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31877 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31894 */     GIR_RootConstrainSelectedInstOperands,
     /*  31895 */     // GIR_Coverage, 1691,
     /*  31895 */     GIR_EraseRootFromParent_Done,
     /*  31896 */   // Label 509: @31896
     /*  31896 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31983), // Rule ID 1769 //
     /*  31901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31932 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31935 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31944 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31964 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31981 */     GIR_RootConstrainSelectedInstOperands,
     /*  31982 */     // GIR_Coverage, 1769,
     /*  31982 */     GIR_EraseRootFromParent_Done,
     /*  31983 */   // Label 510: @31983
     /*  31983 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32052), // Rule ID 1785 //
     /*  31988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32035 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32050 */     GIR_RootConstrainSelectedInstOperands,
     /*  32051 */     // GIR_Coverage, 1785,
     /*  32051 */     GIR_EraseRootFromParent_Done,
     /*  32052 */   // Label 511: @32052
     /*  32052 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32121), // Rule ID 1784 //
     /*  32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32104 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32119 */     GIR_RootConstrainSelectedInstOperands,
     /*  32120 */     // GIR_Coverage, 1784,
     /*  32120 */     GIR_EraseRootFromParent_Done,
     /*  32121 */   // Label 512: @32121
     /*  32121 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32190), // Rule ID 1713 //
     /*  32126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32173 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32188 */     GIR_RootConstrainSelectedInstOperands,
     /*  32189 */     // GIR_Coverage, 1713,
     /*  32189 */     GIR_EraseRootFromParent_Done,
     /*  32190 */   // Label 513: @32190
     /*  32190 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32259), // Rule ID 1783 //
     /*  32195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32242 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32257 */     GIR_RootConstrainSelectedInstOperands,
     /*  32258 */     // GIR_Coverage, 1783,
     /*  32258 */     GIR_EraseRootFromParent_Done,
     /*  32259 */   // Label 514: @32259
     /*  32259 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32328), // Rule ID 1782 //
     /*  32264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32311 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32326 */     GIR_RootConstrainSelectedInstOperands,
     /*  32327 */     // GIR_Coverage, 1782,
     /*  32327 */     GIR_EraseRootFromParent_Done,
     /*  32328 */   // Label 515: @32328
     /*  32328 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32395), // Rule ID 13329 //
     /*  32333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32376 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32393 */     GIR_RootConstrainSelectedInstOperands,
     /*  32394 */     // GIR_Coverage, 13329,
     /*  32394 */     GIR_EraseRootFromParent_Done,
     /*  32395 */   // Label 516: @32395
     /*  32395 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32462), // Rule ID 13359 //
     /*  32400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32443 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32460 */     GIR_RootConstrainSelectedInstOperands,
     /*  32461 */     // GIR_Coverage, 13359,
     /*  32461 */     GIR_EraseRootFromParent_Done,
     /*  32462 */   // Label 517: @32462
     /*  32462 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32529), // Rule ID 1725 //
     /*  32467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32510 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32527 */     GIR_RootConstrainSelectedInstOperands,
     /*  32528 */     // GIR_Coverage, 1725,
     /*  32528 */     GIR_EraseRootFromParent_Done,
     /*  32529 */   // Label 518: @32529
     /*  32529 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32596), // Rule ID 1815 //
     /*  32534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32577 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32594 */     GIR_RootConstrainSelectedInstOperands,
     /*  32595 */     // GIR_Coverage, 1815,
     /*  32595 */     GIR_EraseRootFromParent_Done,
     /*  32596 */   // Label 519: @32596
     /*  32596 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32677), // Rule ID 13311 //
     /*  32601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32628 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32631 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32640 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32660 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32675 */     GIR_RootConstrainSelectedInstOperands,
     /*  32676 */     // GIR_Coverage, 13311,
     /*  32676 */     GIR_EraseRootFromParent_Done,
     /*  32677 */   // Label 520: @32677
     /*  32677 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32758), // Rule ID 13335 //
     /*  32682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32709 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32712 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32721 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32741 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32756 */     GIR_RootConstrainSelectedInstOperands,
     /*  32757 */     // GIR_Coverage, 13335,
     /*  32757 */     GIR_EraseRootFromParent_Done,
     /*  32758 */   // Label 521: @32758
     /*  32758 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32839), // Rule ID 1689 //
     /*  32763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32794 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32797 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32806 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32822 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32837 */     GIR_RootConstrainSelectedInstOperands,
     /*  32838 */     // GIR_Coverage, 1689,
     /*  32838 */     GIR_EraseRootFromParent_Done,
     /*  32839 */   // Label 522: @32839
     /*  32839 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32920), // Rule ID 1767 //
     /*  32844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32875 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32878 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32887 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32903 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32918 */     GIR_RootConstrainSelectedInstOperands,
     /*  32919 */     // GIR_Coverage, 1767,
     /*  32919 */     GIR_EraseRootFromParent_Done,
     /*  32920 */   // Label 523: @32920
     /*  32920 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32971), // Rule ID 13349 //
     /*  32925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32957 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32969 */     GIR_RootConstrainSelectedInstOperands,
     /*  32970 */     // GIR_Coverage, 13349,
     /*  32970 */     GIR_EraseRootFromParent_Done,
     /*  32971 */   // Label 524: @32971
     /*  32971 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33022), // Rule ID 13323 //
     /*  32976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33008 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33020 */     GIR_RootConstrainSelectedInstOperands,
     /*  33021 */     // GIR_Coverage, 13323,
     /*  33021 */     GIR_EraseRootFromParent_Done,
     /*  33022 */   // Label 525: @33022
     /*  33022 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33073), // Rule ID 13348 //
     /*  33027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33059 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33071 */     GIR_RootConstrainSelectedInstOperands,
     /*  33072 */     // GIR_Coverage, 13348,
     /*  33072 */     GIR_EraseRootFromParent_Done,
     /*  33073 */   // Label 526: @33073
     /*  33073 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33124), // Rule ID 1805 //
     /*  33078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33110 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33122 */     GIR_RootConstrainSelectedInstOperands,
     /*  33123 */     // GIR_Coverage, 1805,
     /*  33123 */     GIR_EraseRootFromParent_Done,
     /*  33124 */   // Label 527: @33124
     /*  33124 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33175), // Rule ID 1719 //
     /*  33129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33161 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33173 */     GIR_RootConstrainSelectedInstOperands,
     /*  33174 */     // GIR_Coverage, 1719,
     /*  33174 */     GIR_EraseRootFromParent_Done,
     /*  33175 */   // Label 528: @33175
     /*  33175 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33226), // Rule ID 1804 //
     /*  33180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33212 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33224 */     GIR_RootConstrainSelectedInstOperands,
     /*  33225 */     // GIR_Coverage, 1804,
     /*  33225 */     GIR_EraseRootFromParent_Done,
     /*  33226 */   // Label 529: @33226
     /*  33226 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33295), // Rule ID 13275 //
     /*  33231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33246 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33249 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33278 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33293 */     GIR_RootConstrainSelectedInstOperands,
     /*  33294 */     // GIR_Coverage, 13275,
     /*  33294 */     GIR_EraseRootFromParent_Done,
     /*  33295 */   // Label 530: @33295
     /*  33295 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33364), // Rule ID 13287 //
     /*  33300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33315 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33318 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33327 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33347 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33362 */     GIR_RootConstrainSelectedInstOperands,
     /*  33363 */     // GIR_Coverage, 13287,
     /*  33363 */     GIR_EraseRootFromParent_Done,
     /*  33364 */   // Label 531: @33364
     /*  33364 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33420), // Rule ID 13237 //
     /*  33369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33384 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33387 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33407 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33418 */     GIR_RootConstrainSelectedInstOperands,
     /*  33419 */     // GIR_Coverage, 13237,
     /*  33419 */     GIR_EraseRootFromParent_Done,
     /*  33420 */   // Label 532: @33420
     /*  33420 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33476), // Rule ID 13249 //
     /*  33425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33440 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33443 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33463 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33474 */     GIR_RootConstrainSelectedInstOperands,
     /*  33475 */     // GIR_Coverage, 13249,
     /*  33475 */     GIR_EraseRootFromParent_Done,
     /*  33476 */   // Label 533: @33476
     /*  33476 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33543), // Rule ID 13479 //
     /*  33481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33505 */     // MIs[1] imm
     /*  33505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33517 */     // MIs[2] Operand 1
     /*  33517 */     // No operand predicates
     /*  33517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33527 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33541 */     GIR_RootConstrainSelectedInstOperands,
     /*  33542 */     // GIR_Coverage, 13479,
     /*  33542 */     GIR_EraseRootFromParent_Done,
     /*  33543 */   // Label 534: @33543
     /*  33543 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33610), // Rule ID 13500 //
     /*  33548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33572 */     // MIs[1] imm
     /*  33572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33584 */     // MIs[2] Operand 1
     /*  33584 */     // No operand predicates
     /*  33584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33594 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33608 */     GIR_RootConstrainSelectedInstOperands,
     /*  33609 */     // GIR_Coverage, 13500,
     /*  33609 */     GIR_EraseRootFromParent_Done,
     /*  33610 */   // Label 535: @33610
     /*  33610 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33679), // Rule ID 1363 //
     /*  33615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33634 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33637 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33646 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33662 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33677 */     GIR_RootConstrainSelectedInstOperands,
     /*  33678 */     // GIR_Coverage, 1363,
     /*  33678 */     GIR_EraseRootFromParent_Done,
     /*  33679 */   // Label 536: @33679
     /*  33679 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33748), // Rule ID 1486 //
     /*  33684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33703 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33706 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33715 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33731 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33746 */     GIR_RootConstrainSelectedInstOperands,
     /*  33747 */     // GIR_Coverage, 1486,
     /*  33747 */     GIR_EraseRootFromParent_Done,
     /*  33748 */   // Label 537: @33748
     /*  33748 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33804), // Rule ID 991 //
     /*  33753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33772 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33775 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33791 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33802 */     GIR_RootConstrainSelectedInstOperands,
     /*  33803 */     // GIR_Coverage, 991,
     /*  33803 */     GIR_EraseRootFromParent_Done,
     /*  33804 */   // Label 538: @33804
     /*  33804 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33860), // Rule ID 1052 //
     /*  33809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33828 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33831 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33847 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33858 */     GIR_RootConstrainSelectedInstOperands,
     /*  33859 */     // GIR_Coverage, 1052,
     /*  33859 */     GIR_EraseRootFromParent_Done,
     /*  33860 */   // Label 539: @33860
     /*  33860 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33927), // Rule ID 2236 //
     /*  33865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33893 */     // MIs[1] imm
     /*  33893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33905 */     // MIs[2] Operand 1
     /*  33905 */     // No operand predicates
     /*  33905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33911 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33925 */     GIR_RootConstrainSelectedInstOperands,
     /*  33926 */     // GIR_Coverage, 2236,
     /*  33926 */     GIR_EraseRootFromParent_Done,
     /*  33927 */   // Label 540: @33927
     /*  33927 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33994), // Rule ID 2295 //
     /*  33932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33960 */     // MIs[1] imm
     /*  33960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33972 */     // MIs[2] Operand 1
     /*  33972 */     // No operand predicates
     /*  33972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33978 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33992 */     GIR_RootConstrainSelectedInstOperands,
     /*  33993 */     // GIR_Coverage, 2295,
     /*  33993 */     GIR_EraseRootFromParent_Done,
     /*  33994 */   // Label 541: @33994
     /*  33994 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34064), // Rule ID 6897 //
     /*  33999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34037 */     // MIs[2] Rn
     /*  34037 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34042 */     // MIs[2] Rm
     /*  34042 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34049 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34062 */     GIR_RootConstrainSelectedInstOperands,
     /*  34063 */     // GIR_Coverage, 6897,
     /*  34063 */     GIR_EraseRootFromParent_Done,
     /*  34064 */   // Label 542: @34064
     /*  34064 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34134), // Rule ID 13863 //
     /*  34069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34107 */     // MIs[2] Rn
     /*  34107 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34112 */     // MIs[2] Rm
     /*  34112 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34119 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34132 */     GIR_RootConstrainSelectedInstOperands,
     /*  34133 */     // GIR_Coverage, 13863,
     /*  34133 */     GIR_EraseRootFromParent_Done,
     /*  34134 */   // Label 543: @34134
     /*  34134 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34197), // Rule ID 1781 //
     /*  34139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34182 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34195 */     GIR_RootConstrainSelectedInstOperands,
     /*  34196 */     // GIR_Coverage, 1781,
     /*  34196 */     GIR_EraseRootFromParent_Done,
     /*  34197 */   // Label 544: @34197
     /*  34197 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34260), // Rule ID 1780 //
     /*  34202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34245 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34258 */     GIR_RootConstrainSelectedInstOperands,
     /*  34259 */     // GIR_Coverage, 1780,
     /*  34259 */     GIR_EraseRootFromParent_Done,
     /*  34260 */   // Label 545: @34260
     /*  34260 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34323), // Rule ID 1712 //
     /*  34265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34308 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34321 */     GIR_RootConstrainSelectedInstOperands,
     /*  34322 */     // GIR_Coverage, 1712,
     /*  34322 */     GIR_EraseRootFromParent_Done,
     /*  34323 */   // Label 546: @34323
     /*  34323 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34386), // Rule ID 1779 //
     /*  34328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34371 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34384 */     GIR_RootConstrainSelectedInstOperands,
     /*  34385 */     // GIR_Coverage, 1779,
     /*  34385 */     GIR_EraseRootFromParent_Done,
     /*  34386 */   // Label 547: @34386
     /*  34386 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34449), // Rule ID 1778 //
     /*  34391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34434 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34447 */     GIR_RootConstrainSelectedInstOperands,
     /*  34448 */     // GIR_Coverage, 1778,
     /*  34448 */     GIR_EraseRootFromParent_Done,
     /*  34449 */   // Label 548: @34449
     /*  34449 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34510), // Rule ID 13328 //
     /*  34454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34493 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34508 */     GIR_RootConstrainSelectedInstOperands,
     /*  34509 */     // GIR_Coverage, 13328,
     /*  34509 */     GIR_EraseRootFromParent_Done,
     /*  34510 */   // Label 549: @34510
     /*  34510 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34571), // Rule ID 13358 //
     /*  34515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34554 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34569 */     GIR_RootConstrainSelectedInstOperands,
     /*  34570 */     // GIR_Coverage, 13358,
     /*  34570 */     GIR_EraseRootFromParent_Done,
     /*  34571 */   // Label 550: @34571
     /*  34571 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34619), // Rule ID 13347 //
     /*  34576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34606 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34617 */     GIR_RootConstrainSelectedInstOperands,
     /*  34618 */     // GIR_Coverage, 13347,
     /*  34618 */     GIR_EraseRootFromParent_Done,
     /*  34619 */   // Label 551: @34619
     /*  34619 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34667), // Rule ID 13236 //
     /*  34624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34654 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34665 */     GIR_RootConstrainSelectedInstOperands,
     /*  34666 */     // GIR_Coverage, 13236,
     /*  34666 */     GIR_EraseRootFromParent_Done,
     /*  34667 */   // Label 552: @34667
     /*  34667 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34715), // Rule ID 13322 //
     /*  34672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34702 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34713 */     GIR_RootConstrainSelectedInstOperands,
     /*  34714 */     // GIR_Coverage, 13322,
     /*  34714 */     GIR_EraseRootFromParent_Done,
     /*  34715 */   // Label 553: @34715
     /*  34715 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34763), // Rule ID 13248 //
     /*  34720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34750 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34761 */     GIR_RootConstrainSelectedInstOperands,
     /*  34762 */     // GIR_Coverage, 13248,
     /*  34762 */     GIR_EraseRootFromParent_Done,
     /*  34763 */   // Label 554: @34763
     /*  34763 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(34811), // Rule ID 13346 //
     /*  34768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34798 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34809 */     GIR_RootConstrainSelectedInstOperands,
     /*  34810 */     // GIR_Coverage, 13346,
     /*  34810 */     GIR_EraseRootFromParent_Done,
     /*  34811 */   // Label 555: @34811
     /*  34811 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(34872), // Rule ID 1724 //
     /*  34816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34855 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34870 */     GIR_RootConstrainSelectedInstOperands,
     /*  34871 */     // GIR_Coverage, 1724,
     /*  34871 */     GIR_EraseRootFromParent_Done,
     /*  34872 */   // Label 556: @34872
     /*  34872 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34933), // Rule ID 1814 //
     /*  34877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34916 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34931 */     GIR_RootConstrainSelectedInstOperands,
     /*  34932 */     // GIR_Coverage, 1814,
     /*  34932 */     GIR_EraseRootFromParent_Done,
     /*  34933 */   // Label 557: @34933
     /*  34933 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34981), // Rule ID 1803 //
     /*  34938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34968 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  34975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34979 */     GIR_RootConstrainSelectedInstOperands,
     /*  34980 */     // GIR_Coverage, 1803,
     /*  34980 */     GIR_EraseRootFromParent_Done,
     /*  34981 */   // Label 558: @34981
     /*  34981 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35029), // Rule ID 990 //
     /*  34986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35016 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35027 */     GIR_RootConstrainSelectedInstOperands,
     /*  35028 */     // GIR_Coverage, 990,
     /*  35028 */     GIR_EraseRootFromParent_Done,
     /*  35029 */   // Label 559: @35029
     /*  35029 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35077), // Rule ID 1718 //
     /*  35034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35064 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35075 */     GIR_RootConstrainSelectedInstOperands,
     /*  35076 */     // GIR_Coverage, 1718,
     /*  35076 */     GIR_EraseRootFromParent_Done,
     /*  35077 */   // Label 560: @35077
     /*  35077 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35125), // Rule ID 1051 //
     /*  35082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35112 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35123 */     GIR_RootConstrainSelectedInstOperands,
     /*  35124 */     // GIR_Coverage, 1051,
     /*  35124 */     GIR_EraseRootFromParent_Done,
     /*  35125 */   // Label 561: @35125
     /*  35125 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35173), // Rule ID 1802 //
     /*  35130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35160 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35171 */     GIR_RootConstrainSelectedInstOperands,
     /*  35172 */     // GIR_Coverage, 1802,
     /*  35172 */     GIR_EraseRootFromParent_Done,
     /*  35173 */   // Label 562: @35173
     /*  35173 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35200), // Rule ID 1103 //
     /*  35178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35193 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35198 */     GIR_RootConstrainSelectedInstOperands,
     /*  35199 */     // GIR_Coverage, 1103,
     /*  35199 */     GIR_Done,
     /*  35200 */   // Label 563: @35200
     /*  35200 */   GIM_Reject,
     /*  35201 */ // Label 506: @35201
     /*  35201 */ GIM_Reject,
     /*  35202 */ // Label 166: @35202
     /*  35202 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35925),
     /*  35207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35213 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35282), // Rule ID 13271 //
     /*  35218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35245 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35265 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35280 */     GIR_RootConstrainSelectedInstOperands,
     /*  35281 */     // GIR_Coverage, 13271,
     /*  35281 */     GIR_EraseRootFromParent_Done,
     /*  35282 */   // Label 565: @35282
     /*  35282 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35351), // Rule ID 13283 //
     /*  35287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35302 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35305 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35314 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35334 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35349 */     GIR_RootConstrainSelectedInstOperands,
     /*  35350 */     // GIR_Coverage, 13283,
     /*  35350 */     GIR_EraseRootFromParent_Done,
     /*  35351 */   // Label 566: @35351
     /*  35351 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35418), // Rule ID 13475 //
     /*  35356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35380 */     // MIs[1] imm
     /*  35380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35392 */     // MIs[2] Operand 1
     /*  35392 */     // No operand predicates
     /*  35392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35402 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35416 */     GIR_RootConstrainSelectedInstOperands,
     /*  35417 */     // GIR_Coverage, 13475,
     /*  35417 */     GIR_EraseRootFromParent_Done,
     /*  35418 */   // Label 567: @35418
     /*  35418 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35485), // Rule ID 13496 //
     /*  35423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35447 */     // MIs[1] imm
     /*  35447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35459 */     // MIs[2] Operand 1
     /*  35459 */     // No operand predicates
     /*  35459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35469 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35483 */     GIR_RootConstrainSelectedInstOperands,
     /*  35484 */     // GIR_Coverage, 13496,
     /*  35484 */     GIR_EraseRootFromParent_Done,
     /*  35485 */   // Label 568: @35485
     /*  35485 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35554), // Rule ID 1359 //
     /*  35490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35509 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35512 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35521 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35537 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35552 */     GIR_RootConstrainSelectedInstOperands,
     /*  35553 */     // GIR_Coverage, 1359,
     /*  35553 */     GIR_EraseRootFromParent_Done,
     /*  35554 */   // Label 569: @35554
     /*  35554 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35623), // Rule ID 1482 //
     /*  35559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35578 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35581 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35590 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35606 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35621 */     GIR_RootConstrainSelectedInstOperands,
     /*  35622 */     // GIR_Coverage, 1482,
     /*  35622 */     GIR_EraseRootFromParent_Done,
     /*  35623 */   // Label 570: @35623
     /*  35623 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35690), // Rule ID 2232 //
     /*  35628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35656 */     // MIs[1] imm
     /*  35656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35668 */     // MIs[2] Operand 1
     /*  35668 */     // No operand predicates
     /*  35668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35674 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35688 */     GIR_RootConstrainSelectedInstOperands,
     /*  35689 */     // GIR_Coverage, 2232,
     /*  35689 */     GIR_EraseRootFromParent_Done,
     /*  35690 */   // Label 571: @35690
     /*  35690 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35757), // Rule ID 2291 //
     /*  35695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35723 */     // MIs[1] imm
     /*  35723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35735 */     // MIs[2] Operand 1
     /*  35735 */     // No operand predicates
     /*  35735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35741 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35755 */     GIR_RootConstrainSelectedInstOperands,
     /*  35756 */     // GIR_Coverage, 2291,
     /*  35756 */     GIR_EraseRootFromParent_Done,
     /*  35757 */   // Label 572: @35757
     /*  35757 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(35827), // Rule ID 6898 //
     /*  35762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35800 */     // MIs[2] Rn
     /*  35800 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35805 */     // MIs[2] Rm
     /*  35805 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35812 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35825 */     GIR_RootConstrainSelectedInstOperands,
     /*  35826 */     // GIR_Coverage, 6898,
     /*  35826 */     GIR_EraseRootFromParent_Done,
     /*  35827 */   // Label 573: @35827
     /*  35827 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(35897), // Rule ID 13864 //
     /*  35832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35870 */     // MIs[2] Rn
     /*  35870 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35875 */     // MIs[2] Rm
     /*  35875 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35882 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35895 */     GIR_RootConstrainSelectedInstOperands,
     /*  35896 */     // GIR_Coverage, 13864,
     /*  35896 */     GIR_EraseRootFromParent_Done,
     /*  35897 */   // Label 574: @35897
     /*  35897 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(35924), // Rule ID 1101 //
     /*  35902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35917 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35922 */     GIR_RootConstrainSelectedInstOperands,
     /*  35923 */     // GIR_Coverage, 1101,
     /*  35923 */     GIR_Done,
     /*  35924 */   // Label 575: @35924
     /*  35924 */   GIM_Reject,
     /*  35925 */ // Label 564: @35925
     /*  35925 */ GIM_Reject,
     /*  35926 */ // Label 167: @35926
     /*  35926 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36297),
     /*  35931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35941 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36003), // Rule ID 15048 //
     /*  35946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  35973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  35977 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  35988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35990 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  35990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  35993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  35995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  35997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36001 */     GIR_RootConstrainSelectedInstOperands,
     /*  36002 */     // GIR_Coverage, 15048,
     /*  36002 */     GIR_EraseRootFromParent_Done,
     /*  36003 */   // Label 577: @36003
     /*  36003 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36065), // Rule ID 15047 //
     /*  36008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36039 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36052 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36063 */     GIR_RootConstrainSelectedInstOperands,
     /*  36064 */     // GIR_Coverage, 15047,
     /*  36064 */     GIR_EraseRootFromParent_Done,
     /*  36065 */   // Label 578: @36065
     /*  36065 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36127), // Rule ID 15046 //
     /*  36070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36101 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36114 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36125 */     GIR_RootConstrainSelectedInstOperands,
     /*  36126 */     // GIR_Coverage, 15046,
     /*  36126 */     GIR_EraseRootFromParent_Done,
     /*  36127 */   // Label 579: @36127
     /*  36127 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36189), // Rule ID 8837 //
     /*  36132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36163 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36176 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36187 */     GIR_RootConstrainSelectedInstOperands,
     /*  36188 */     // GIR_Coverage, 8837,
     /*  36188 */     GIR_EraseRootFromParent_Done,
     /*  36189 */   // Label 580: @36189
     /*  36189 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36235), // Rule ID 15049 //
     /*  36194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36209 */     // MIs[1] Operand 2
     /*  36209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36222 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36233 */     GIR_RootConstrainSelectedInstOperands,
     /*  36234 */     // GIR_Coverage, 15049,
     /*  36234 */     GIR_EraseRootFromParent_Done,
     /*  36235 */   // Label 581: @36235
     /*  36235 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36281), // Rule ID 8838 //
     /*  36240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36255 */     // MIs[1] Operand 2
     /*  36255 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36268 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36279 */     GIR_RootConstrainSelectedInstOperands,
     /*  36280 */     // GIR_Coverage, 8838,
     /*  36280 */     GIR_EraseRootFromParent_Done,
     /*  36281 */   // Label 582: @36281
     /*  36281 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36296), // Rule ID 2780 //
     /*  36286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36289 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36294 */     GIR_RootConstrainSelectedInstOperands,
     /*  36295 */     // GIR_Coverage, 2780,
     /*  36295 */     GIR_Done,
     /*  36296 */   // Label 583: @36296
     /*  36296 */   GIM_Reject,
     /*  36297 */ // Label 576: @36297
     /*  36297 */ GIM_Reject,
     /*  36298 */ // Label 168: @36298
     /*  36298 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36323), // Rule ID 2779 //
     /*  36303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36316 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36321 */   GIR_RootConstrainSelectedInstOperands,
     /*  36322 */   // GIR_Coverage, 2779,
     /*  36322 */   GIR_Done,
     /*  36323 */ // Label 584: @36323
     /*  36323 */ GIM_Reject,
     /*  36324 */ // Label 169: @36324
     /*  36324 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36349), // Rule ID 2778 //
     /*  36329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36342 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36347 */   GIR_RootConstrainSelectedInstOperands,
     /*  36348 */   // GIR_Coverage, 2778,
     /*  36348 */   GIR_Done,
     /*  36349 */ // Label 585: @36349
     /*  36349 */ GIM_Reject,
     /*  36350 */ // Label 170: @36350
     /*  36350 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36375), // Rule ID 2777 //
     /*  36355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36368 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36373 */   GIR_RootConstrainSelectedInstOperands,
     /*  36374 */   // GIR_Coverage, 2777,
     /*  36374 */   GIR_Done,
     /*  36375 */ // Label 586: @36375
     /*  36375 */ GIM_Reject,
     /*  36376 */ // Label 171: @36376
     /*  36376 */ GIM_Reject,
     /*  36377 */ // Label 1: @36377
     /*  36377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 600*/ GIMT_Encode4(50604),
     /*  36388 */ /*GILLT_s32*//*Label 587*/ GIMT_Encode4(36476),
     /*  36392 */ /*GILLT_s64*//*Label 588*/ GIMT_Encode4(37958), GIMT_Encode4(0),
     /*  36400 */ /*GILLT_v2s32*//*Label 589*/ GIMT_Encode4(41240),
     /*  36404 */ /*GILLT_v2s64*//*Label 590*/ GIMT_Encode4(42731),
     /*  36408 */ /*GILLT_v4s16*//*Label 591*/ GIMT_Encode4(45191),
     /*  36412 */ /*GILLT_v4s32*//*Label 592*/ GIMT_Encode4(46682),
     /*  36416 */ /*GILLT_v8s8*//*Label 593*/ GIMT_Encode4(49142),
     /*  36420 */ /*GILLT_v8s16*//*Label 594*/ GIMT_Encode4(49217),
     /*  36424 */ /*GILLT_v16s8*//*Label 595*/ GIMT_Encode4(50425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36444 */ /*GILLT_nxv2s64*//*Label 596*/ GIMT_Encode4(50500), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36456 */ /*GILLT_nxv4s32*//*Label 597*/ GIMT_Encode4(50526), GIMT_Encode4(0),
     /*  36464 */ /*GILLT_nxv8s16*//*Label 598*/ GIMT_Encode4(50552), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv16s8*//*Label 599*/ GIMT_Encode4(50578),
     /*  36476 */ // Label 587: @36476
     /*  36476 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(37957),
     /*  36481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36487 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36639), // Rule ID 9884 //
     /*  36492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36523 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36526 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36531 */     // MIs[2] pattern
     /*  36531 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36534 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36541 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36541 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36544 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36548 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36567 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36574 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36621 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36638 */     // GIR_Coverage, 9884,
     /*  36638 */     GIR_EraseRootFromParent_Done,
     /*  36639 */   // Label 602: @36639
     /*  36639 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36791), // Rule ID 9896 //
     /*  36644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36675 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36678 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36683 */     // MIs[2] pattern
     /*  36683 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36686 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36693 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36719 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36726 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36773 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36790 */     // GIR_Coverage, 9896,
     /*  36790 */     GIR_EraseRootFromParent_Done,
     /*  36791 */   // Label 603: @36791
     /*  36791 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36943), // Rule ID 9908 //
     /*  36796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36827 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36830 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36835 */     // MIs[2] pattern
     /*  36835 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36838 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36845 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36845 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36848 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36852 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36871 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36878 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36942 */     // GIR_Coverage, 9908,
     /*  36942 */     GIR_EraseRootFromParent_Done,
     /*  36943 */   // Label 604: @36943
     /*  36943 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37095), // Rule ID 9920 //
     /*  36948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36979 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36982 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  36987 */     // MIs[2] pattern
     /*  36987 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36990 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36997 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36997 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37000 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37004 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37023 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37030 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37094 */     // GIR_Coverage, 9920,
     /*  37094 */     GIR_EraseRootFromParent_Done,
     /*  37095 */   // Label 605: @37095
     /*  37095 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37157), // Rule ID 3945 //
     /*  37100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37136 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37155 */     GIR_RootConstrainSelectedInstOperands,
     /*  37156 */     // GIR_Coverage, 3945,
     /*  37156 */     GIR_EraseRootFromParent_Done,
     /*  37157 */   // Label 606: @37157
     /*  37157 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37314), // Rule ID 10022 //
     /*  37162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37193 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37196 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37212 */     // MIs[2] pred
     /*  37212 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37219 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37219 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37222 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37226 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37233 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37236 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37240 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37245 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37248 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37252 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37286 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37296 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37313 */     // GIR_Coverage, 10022,
     /*  37313 */     GIR_EraseRootFromParent_Done,
     /*  37314 */   // Label 607: @37314
     /*  37314 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37471), // Rule ID 10023 //
     /*  37319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37350 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37353 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37369 */     // MIs[2] pred
     /*  37369 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37376 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37402 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37470 */     // GIR_Coverage, 10023,
     /*  37470 */     GIR_EraseRootFromParent_Done,
     /*  37471 */   // Label 608: @37471
     /*  37471 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37628), // Rule ID 10024 //
     /*  37476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37507 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37510 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37526 */     // MIs[2] pred
     /*  37526 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37533 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37533 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37536 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37540 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37547 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37550 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37554 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37559 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37562 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37566 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37600 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37610 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37627 */     // GIR_Coverage, 10024,
     /*  37627 */     GIR_EraseRootFromParent_Done,
     /*  37628 */   // Label 609: @37628
     /*  37628 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37785), // Rule ID 10025 //
     /*  37633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37664 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37667 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37683 */     // MIs[2] pred
     /*  37683 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37690 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37716 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37723 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37784 */     // GIR_Coverage, 10025,
     /*  37784 */     GIR_EraseRootFromParent_Done,
     /*  37785 */   // Label 610: @37785
     /*  37785 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37821), // Rule ID 3910 //
     /*  37790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37805 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37810 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37819 */     GIR_RootConstrainSelectedInstOperands,
     /*  37820 */     // GIR_Coverage, 3910,
     /*  37820 */     GIR_EraseRootFromParent_Done,
     /*  37821 */   // Label 611: @37821
     /*  37821 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37854), // Rule ID 3915 //
     /*  37826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37841 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37852 */     GIR_RootConstrainSelectedInstOperands,
     /*  37853 */     // GIR_Coverage, 3915,
     /*  37853 */     GIR_EraseRootFromParent_Done,
     /*  37854 */   // Label 612: @37854
     /*  37854 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37890), // Rule ID 3904 //
     /*  37859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37874 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37888 */     GIR_RootConstrainSelectedInstOperands,
     /*  37889 */     // GIR_Coverage, 3904,
     /*  37889 */     GIR_EraseRootFromParent_Done,
     /*  37890 */   // Label 613: @37890
     /*  37890 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37926), // Rule ID 3908 //
     /*  37895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37910 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37924 */     GIR_RootConstrainSelectedInstOperands,
     /*  37925 */     // GIR_Coverage, 3908,
     /*  37925 */     GIR_EraseRootFromParent_Done,
     /*  37926 */   // Label 614: @37926
     /*  37926 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37956), // Rule ID 3906 //
     /*  37931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37943 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37948 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37954 */     GIR_RootConstrainSelectedInstOperands,
     /*  37955 */     // GIR_Coverage, 3906,
     /*  37955 */     GIR_Done,
     /*  37956 */   // Label 615: @37956
     /*  37956 */   GIM_Reject,
     /*  37957 */ // Label 601: @37957
     /*  37957 */ GIM_Reject,
     /*  37958 */ // Label 588: @37958
     /*  37958 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(41239),
     /*  37963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37969 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38105), // Rule ID 5388 //
     /*  37974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38007 */     // MIs[1] Operand 2
     /*  38007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38038 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38042 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38047 */     // MIs[3] Operand 2
     /*  38047 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38060 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38087 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38104 */     // GIR_Coverage, 5388,
     /*  38104 */     GIR_EraseRootFromParent_Done,
     /*  38105 */   // Label 617: @38105
     /*  38105 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38241), // Rule ID 5387 //
     /*  38110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38143 */     // MIs[1] Operand 2
     /*  38143 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38174 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38178 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38183 */     // MIs[3] Operand 2
     /*  38183 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38196 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38223 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38240 */     // GIR_Coverage, 5387,
     /*  38240 */     GIR_EraseRootFromParent_Done,
     /*  38241 */   // Label 618: @38241
     /*  38241 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38377), // Rule ID 5397 //
     /*  38246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38279 */     // MIs[1] Operand 2
     /*  38279 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38302 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38306 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38310 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38314 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38319 */     // MIs[3] Operand 2
     /*  38319 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38332 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38359 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38376 */     // GIR_Coverage, 5397,
     /*  38376 */     GIR_EraseRootFromParent_Done,
     /*  38377 */   // Label 619: @38377
     /*  38377 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38513), // Rule ID 5386 //
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38415 */     // MIs[1] Operand 2
     /*  38415 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38434 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38438 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38442 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38446 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38450 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38455 */     // MIs[3] Operand 2
     /*  38455 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38466 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38468 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38495 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38512 */     // GIR_Coverage, 5386,
     /*  38512 */     GIR_EraseRootFromParent_Done,
     /*  38513 */   // Label 620: @38513
     /*  38513 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38649), // Rule ID 5385 //
     /*  38518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38551 */     // MIs[1] Operand 2
     /*  38551 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38578 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38582 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38586 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38591 */     // MIs[3] Operand 2
     /*  38591 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38602 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38604 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38648 */     // GIR_Coverage, 5385,
     /*  38648 */     GIR_EraseRootFromParent_Done,
     /*  38649 */   // Label 621: @38649
     /*  38649 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38786), // Rule ID 3962 //
     /*  38654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38695 */     // MIs[2] Operand 2
     /*  38695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38714 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38718 */     // MIs[3] Operand 1
     /*  38718 */     // No operand predicates
     /*  38718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38720 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38720 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38723 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38727 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38732 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38751 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38784 */     GIR_RootConstrainSelectedInstOperands,
     /*  38785 */     // GIR_Coverage, 3962,
     /*  38785 */     GIR_EraseRootFromParent_Done,
     /*  38786 */   // Label 622: @38786
     /*  38786 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38885), // Rule ID 3960 //
     /*  38791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38844 */     // MIs[3] Operand 1
     /*  38844 */     // No operand predicates
     /*  38844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38846 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38858 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38883 */     GIR_RootConstrainSelectedInstOperands,
     /*  38884 */     // GIR_Coverage, 3960,
     /*  38884 */     GIR_EraseRootFromParent_Done,
     /*  38885 */   // Label 623: @38885
     /*  38885 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38984), // Rule ID 3961 //
     /*  38890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38943 */     // MIs[3] Operand 1
     /*  38943 */     // No operand predicates
     /*  38943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38945 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38957 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38982 */     GIR_RootConstrainSelectedInstOperands,
     /*  38983 */     // GIR_Coverage, 3961,
     /*  38983 */     GIR_EraseRootFromParent_Done,
     /*  38984 */   // Label 624: @38984
     /*  38984 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39070), // Rule ID 3955 //
     /*  38989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39049 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39068 */     GIR_RootConstrainSelectedInstOperands,
     /*  39069 */     // GIR_Coverage, 3955,
     /*  39069 */     GIR_EraseRootFromParent_Done,
     /*  39070 */   // Label 625: @39070
     /*  39070 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39156), // Rule ID 3956 //
     /*  39075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39128 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39135 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39154 */     GIR_RootConstrainSelectedInstOperands,
     /*  39155 */     // GIR_Coverage, 3956,
     /*  39155 */     GIR_EraseRootFromParent_Done,
     /*  39156 */   // Label 626: @39156
     /*  39156 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39289), // Rule ID 3968 //
     /*  39161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39202 */     // MIs[2] Operand 2
     /*  39202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39225 */     // MIs[3] Operand 1
     /*  39225 */     // No operand predicates
     /*  39225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39227 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39239 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39287 */     GIR_RootConstrainSelectedInstOperands,
     /*  39288 */     // GIR_Coverage, 3968,
     /*  39288 */     GIR_EraseRootFromParent_Done,
     /*  39289 */   // Label 627: @39289
     /*  39289 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39384), // Rule ID 3966 //
     /*  39294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39343 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39347 */     // MIs[3] Operand 1
     /*  39347 */     // No operand predicates
     /*  39347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39349 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39361 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39382 */     GIR_RootConstrainSelectedInstOperands,
     /*  39383 */     // GIR_Coverage, 3966,
     /*  39383 */     GIR_EraseRootFromParent_Done,
     /*  39384 */   // Label 628: @39384
     /*  39384 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39479), // Rule ID 3967 //
     /*  39389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39442 */     // MIs[3] Operand 1
     /*  39442 */     // No operand predicates
     /*  39442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39444 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39456 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39477 */     GIR_RootConstrainSelectedInstOperands,
     /*  39478 */     // GIR_Coverage, 3967,
     /*  39478 */     GIR_EraseRootFromParent_Done,
     /*  39479 */   // Label 629: @39479
     /*  39479 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39561), // Rule ID 124 //
     /*  39484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39544 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39559 */     GIR_RootConstrainSelectedInstOperands,
     /*  39560 */     // GIR_Coverage, 124,
     /*  39560 */     GIR_EraseRootFromParent_Done,
     /*  39561 */   // Label 630: @39561
     /*  39561 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39643), // Rule ID 126 //
     /*  39566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39615 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39619 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39626 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39641 */     GIR_RootConstrainSelectedInstOperands,
     /*  39642 */     // GIR_Coverage, 126,
     /*  39642 */     GIR_EraseRootFromParent_Done,
     /*  39643 */   // Label 631: @39643
     /*  39643 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39705), // Rule ID 3946 //
     /*  39648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39684 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39703 */     GIR_RootConstrainSelectedInstOperands,
     /*  39704 */     // GIR_Coverage, 3946,
     /*  39704 */     GIR_EraseRootFromParent_Done,
     /*  39705 */   // Label 632: @39705
     /*  39705 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39763), // Rule ID 9881 //
     /*  39710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39732 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39737 */     // MIs[1] pattern
     /*  39737 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39740 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39747 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39761 */     GIR_RootConstrainSelectedInstOperands,
     /*  39762 */     // GIR_Coverage, 9881,
     /*  39762 */     GIR_EraseRootFromParent_Done,
     /*  39763 */   // Label 633: @39763
     /*  39763 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39821), // Rule ID 9893 //
     /*  39768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39795 */     // MIs[1] pattern
     /*  39795 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39798 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39805 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39819 */     GIR_RootConstrainSelectedInstOperands,
     /*  39820 */     // GIR_Coverage, 9893,
     /*  39820 */     GIR_EraseRootFromParent_Done,
     /*  39821 */   // Label 634: @39821
     /*  39821 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39879), // Rule ID 9905 //
     /*  39826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39845 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39848 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39853 */     // MIs[1] pattern
     /*  39853 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39856 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39863 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39877 */     GIR_RootConstrainSelectedInstOperands,
     /*  39878 */     // GIR_Coverage, 9905,
     /*  39878 */     GIR_EraseRootFromParent_Done,
     /*  39879 */   // Label 635: @39879
     /*  39879 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39937), // Rule ID 9917 //
     /*  39884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39903 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39906 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39911 */     // MIs[1] pattern
     /*  39911 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39914 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39921 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39935 */     GIR_RootConstrainSelectedInstOperands,
     /*  39936 */     // GIR_Coverage, 9917,
     /*  39936 */     GIR_EraseRootFromParent_Done,
     /*  39937 */   // Label 636: @39937
     /*  39937 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40100), // Rule ID 5352 //
     /*  39942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39988 */     // MIs[1] Operand 2
     /*  39988 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40001 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40001 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40004 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40008 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40027 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40034 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40047 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40082 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40099 */     // GIR_Coverage, 5352,
     /*  40099 */     GIR_EraseRootFromParent_Done,
     /*  40100 */   // Label 637: @40100
     /*  40100 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40263), // Rule ID 5349 //
     /*  40105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40151 */     // MIs[1] Operand 2
     /*  40151 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40164 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40164 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40167 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40171 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40190 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40262 */     // GIR_Coverage, 5349,
     /*  40262 */     GIR_EraseRootFromParent_Done,
     /*  40263 */   // Label 638: @40263
     /*  40263 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40413), // Rule ID 5394 //
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40305 */     // MIs[1] Operand 2
     /*  40305 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40318 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40351 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40395 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40412 */     // GIR_Coverage, 5394,
     /*  40412 */     GIR_EraseRootFromParent_Done,
     /*  40413 */   // Label 639: @40413
     /*  40413 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40563), // Rule ID 5400 //
     /*  40418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40455 */     // MIs[1] Operand 2
     /*  40455 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40468 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40468 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40471 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40475 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40494 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40497 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40501 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40531 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40562 */     // GIR_Coverage, 5400,
     /*  40562 */     GIR_EraseRootFromParent_Done,
     /*  40563 */   // Label 640: @40563
     /*  40563 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40713), // Rule ID 5393 //
     /*  40568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40605 */     // MIs[1] Operand 2
     /*  40605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40618 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40644 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40651 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40654 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40695 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40712 */     // GIR_Coverage, 5393,
     /*  40712 */     GIR_EraseRootFromParent_Done,
     /*  40713 */   // Label 641: @40713
     /*  40713 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40749), // Rule ID 3911 //
     /*  40718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40733 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40738 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40747 */     GIR_RootConstrainSelectedInstOperands,
     /*  40748 */     // GIR_Coverage, 3911,
     /*  40748 */     GIR_EraseRootFromParent_Done,
     /*  40749 */   // Label 642: @40749
     /*  40749 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40782), // Rule ID 3916 //
     /*  40754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40769 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40780 */     GIR_RootConstrainSelectedInstOperands,
     /*  40781 */     // GIR_Coverage, 3916,
     /*  40781 */     GIR_EraseRootFromParent_Done,
     /*  40782 */   // Label 643: @40782
     /*  40782 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40818), // Rule ID 3905 //
     /*  40787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40802 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40816 */     GIR_RootConstrainSelectedInstOperands,
     /*  40817 */     // GIR_Coverage, 3905,
     /*  40817 */     GIR_EraseRootFromParent_Done,
     /*  40818 */   // Label 644: @40818
     /*  40818 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40854), // Rule ID 3909 //
     /*  40823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40838 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40852 */     GIR_RootConstrainSelectedInstOperands,
     /*  40853 */     // GIR_Coverage, 3909,
     /*  40853 */     GIR_EraseRootFromParent_Done,
     /*  40854 */   // Label 645: @40854
     /*  40854 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40917), // Rule ID 10014 //
     /*  40859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40878 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40881 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40897 */     // MIs[1] pred
     /*  40897 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40904 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40915 */     GIR_RootConstrainSelectedInstOperands,
     /*  40916 */     // GIR_Coverage, 10014,
     /*  40916 */     GIR_EraseRootFromParent_Done,
     /*  40917 */   // Label 646: @40917
     /*  40917 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40980), // Rule ID 10015 //
     /*  40922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40941 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40944 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40960 */     // MIs[1] pred
     /*  40960 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40967 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40978 */     GIR_RootConstrainSelectedInstOperands,
     /*  40979 */     // GIR_Coverage, 10015,
     /*  40979 */     GIR_EraseRootFromParent_Done,
     /*  40980 */   // Label 647: @40980
     /*  40980 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41043), // Rule ID 10016 //
     /*  40985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41004 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41007 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41023 */     // MIs[1] pred
     /*  41023 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41030 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41041 */     GIR_RootConstrainSelectedInstOperands,
     /*  41042 */     // GIR_Coverage, 10016,
     /*  41042 */     GIR_EraseRootFromParent_Done,
     /*  41043 */   // Label 648: @41043
     /*  41043 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41106), // Rule ID 10017 //
     /*  41048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41067 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41070 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41079 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41086 */     // MIs[1] pred
     /*  41086 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41093 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41104 */     GIR_RootConstrainSelectedInstOperands,
     /*  41105 */     // GIR_Coverage, 10017,
     /*  41105 */     GIR_EraseRootFromParent_Done,
     /*  41106 */   // Label 649: @41106
     /*  41106 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41145), // Rule ID 1655 //
     /*  41111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41122 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41128 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41136 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41143 */     GIR_RootConstrainSelectedInstOperands,
     /*  41144 */     // GIR_Coverage, 1655,
     /*  41144 */     GIR_EraseRootFromParent_Done,
     /*  41145 */   // Label 650: @41145
     /*  41145 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41181), // Rule ID 5235 //
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41158 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41164 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41172 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41179 */     GIR_RootConstrainSelectedInstOperands,
     /*  41180 */     // GIR_Coverage, 5235,
     /*  41180 */     GIR_EraseRootFromParent_Done,
     /*  41181 */   // Label 651: @41181
     /*  41181 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41208), // Rule ID 1644 //
     /*  41186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41201 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41206 */     GIR_RootConstrainSelectedInstOperands,
     /*  41207 */     // GIR_Coverage, 1644,
     /*  41207 */     GIR_Done,
     /*  41208 */   // Label 652: @41208
     /*  41208 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41238), // Rule ID 3907 //
     /*  41213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41225 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41230 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41236 */     GIR_RootConstrainSelectedInstOperands,
     /*  41237 */     // GIR_Coverage, 3907,
     /*  41237 */     GIR_Done,
     /*  41238 */   // Label 653: @41238
     /*  41238 */   GIM_Reject,
     /*  41239 */ // Label 616: @41239
     /*  41239 */ GIM_Reject,
     /*  41240 */ // Label 589: @41240
     /*  41240 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42730),
     /*  41245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41255 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41387), // Rule ID 5384 //
     /*  41260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41289 */     // MIs[1] Operand 2
     /*  41289 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41312 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41316 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41320 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41324 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41329 */     // MIs[3] Operand 2
     /*  41329 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41340 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41342 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41386 */     // GIR_Coverage, 5384,
     /*  41386 */     GIR_EraseRootFromParent_Done,
     /*  41387 */   // Label 655: @41387
     /*  41387 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41519), // Rule ID 5383 //
     /*  41392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41421 */     // MIs[1] Operand 2
     /*  41421 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41452 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41461 */     // MIs[3] Operand 2
     /*  41461 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41474 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41518 */     // GIR_Coverage, 5383,
     /*  41518 */     GIR_EraseRootFromParent_Done,
     /*  41519 */   // Label 656: @41519
     /*  41519 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41651), // Rule ID 5396 //
     /*  41524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41553 */     // MIs[1] Operand 2
     /*  41553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41593 */     // MIs[3] Operand 2
     /*  41593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41606 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41650 */     // GIR_Coverage, 5396,
     /*  41650 */     GIR_EraseRootFromParent_Done,
     /*  41651 */   // Label 657: @41651
     /*  41651 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41783), // Rule ID 5382 //
     /*  41656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41685 */     // MIs[1] Operand 2
     /*  41685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41716 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41720 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41725 */     // MIs[3] Operand 2
     /*  41725 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41736 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41738 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41782 */     // GIR_Coverage, 5382,
     /*  41782 */     GIR_EraseRootFromParent_Done,
     /*  41783 */   // Label 658: @41783
     /*  41783 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41915), // Rule ID 5381 //
     /*  41788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41817 */     // MIs[1] Operand 2
     /*  41817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41852 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41857 */     // MIs[3] Operand 2
     /*  41857 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41870 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41914 */     // GIR_Coverage, 5381,
     /*  41914 */     GIR_EraseRootFromParent_Done,
     /*  41915 */   // Label 659: @41915
     /*  41915 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42074), // Rule ID 5351 //
     /*  41920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41962 */     // MIs[1] Operand 2
     /*  41962 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41975 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41975 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  41978 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41982 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  41992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42001 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42008 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42073 */     // GIR_Coverage, 5351,
     /*  42073 */     GIR_EraseRootFromParent_Done,
     /*  42074 */   // Label 660: @42074
     /*  42074 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42233), // Rule ID 5348 //
     /*  42079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42121 */     // MIs[1] Operand 2
     /*  42121 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42134 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42134 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42137 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42141 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42160 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42167 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42180 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42215 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42232 */     // GIR_Coverage, 5348,
     /*  42232 */     GIR_EraseRootFromParent_Done,
     /*  42233 */   // Label 661: @42233
     /*  42233 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42379), // Rule ID 5392 //
     /*  42238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42271 */     // MIs[1] Operand 2
     /*  42271 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42284 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42310 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42378 */     // GIR_Coverage, 5392,
     /*  42378 */     GIR_EraseRootFromParent_Done,
     /*  42379 */   // Label 662: @42379
     /*  42379 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42525), // Rule ID 5399 //
     /*  42384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42417 */     // MIs[1] Operand 2
     /*  42417 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42430 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42456 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42466 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42471 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42476 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42507 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42524 */     // GIR_Coverage, 5399,
     /*  42524 */     GIR_EraseRootFromParent_Done,
     /*  42525 */   // Label 663: @42525
     /*  42525 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42671), // Rule ID 5391 //
     /*  42530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42563 */     // MIs[1] Operand 2
     /*  42563 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42576 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42670 */     // GIR_Coverage, 5391,
     /*  42670 */     GIR_EraseRootFromParent_Done,
     /*  42671 */   // Label 664: @42671
     /*  42671 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42706), // Rule ID 969 //
     /*  42676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42689 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42697 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42704 */     GIR_RootConstrainSelectedInstOperands,
     /*  42705 */     // GIR_Coverage, 969,
     /*  42705 */     GIR_EraseRootFromParent_Done,
     /*  42706 */   // Label 665: @42706
     /*  42706 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42729), // Rule ID 1476 //
     /*  42711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42722 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42727 */     GIR_RootConstrainSelectedInstOperands,
     /*  42728 */     // GIR_Coverage, 1476,
     /*  42728 */     GIR_Done,
     /*  42729 */   // Label 666: @42729
     /*  42729 */   GIM_Reject,
     /*  42730 */ // Label 654: @42730
     /*  42730 */ GIM_Reject,
     /*  42731 */ // Label 590: @42731
     /*  42731 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(45190),
     /*  42736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42746 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42860), // Rule ID 2048 //
     /*  42751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42815 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42819 */     // MIs[4] Operand 1
     /*  42819 */     // No operand predicates
     /*  42819 */     // MIs[2] Operand 2
     /*  42819 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42830 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42839 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42858 */     GIR_RootConstrainSelectedInstOperands,
     /*  42859 */     // GIR_Coverage, 2048,
     /*  42859 */     GIR_EraseRootFromParent_Done,
     /*  42860 */   // Label 668: @42860
     /*  42860 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42974), // Rule ID 13423 //
     /*  42865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42916 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42921 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42925 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42929 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42933 */     // MIs[4] Operand 1
     /*  42933 */     // No operand predicates
     /*  42933 */     // MIs[2] Operand 2
     /*  42933 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42953 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42972 */     GIR_RootConstrainSelectedInstOperands,
     /*  42973 */     // GIR_Coverage, 13423,
     /*  42973 */     GIR_EraseRootFromParent_Done,
     /*  42974 */   // Label 669: @42974
     /*  42974 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43088), // Rule ID 2100 //
     /*  42979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43043 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43047 */     // MIs[4] Operand 1
     /*  43047 */     // No operand predicates
     /*  43047 */     // MIs[2] Operand 2
     /*  43047 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43067 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43086 */     GIR_RootConstrainSelectedInstOperands,
     /*  43087 */     // GIR_Coverage, 2100,
     /*  43087 */     GIR_EraseRootFromParent_Done,
     /*  43088 */   // Label 670: @43088
     /*  43088 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43202), // Rule ID 13453 //
     /*  43093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43144 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43153 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43157 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43161 */     // MIs[4] Operand 1
     /*  43161 */     // No operand predicates
     /*  43161 */     // MIs[2] Operand 2
     /*  43161 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43172 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43200 */     GIR_RootConstrainSelectedInstOperands,
     /*  43201 */     // GIR_Coverage, 13453,
     /*  43201 */     GIR_EraseRootFromParent_Done,
     /*  43202 */   // Label 671: @43202
     /*  43202 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43267), // Rule ID 1855 //
     /*  43207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43250 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43265 */     GIR_RootConstrainSelectedInstOperands,
     /*  43266 */     // GIR_Coverage, 1855,
     /*  43266 */     GIR_EraseRootFromParent_Done,
     /*  43267 */   // Label 672: @43267
     /*  43267 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43332), // Rule ID 1854 //
     /*  43272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43315 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43330 */     GIR_RootConstrainSelectedInstOperands,
     /*  43331 */     // GIR_Coverage, 1854,
     /*  43331 */     GIR_EraseRootFromParent_Done,
     /*  43332 */   // Label 673: @43332
     /*  43332 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43397), // Rule ID 1759 //
     /*  43337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43380 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43395 */     GIR_RootConstrainSelectedInstOperands,
     /*  43396 */     // GIR_Coverage, 1759,
     /*  43396 */     GIR_EraseRootFromParent_Done,
     /*  43397 */   // Label 674: @43397
     /*  43397 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43462), // Rule ID 1853 //
     /*  43402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43445 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43460 */     GIR_RootConstrainSelectedInstOperands,
     /*  43461 */     // GIR_Coverage, 1853,
     /*  43461 */     GIR_EraseRootFromParent_Done,
     /*  43462 */   // Label 675: @43462
     /*  43462 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43527), // Rule ID 1852 //
     /*  43467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43510 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43525 */     GIR_RootConstrainSelectedInstOperands,
     /*  43526 */     // GIR_Coverage, 1852,
     /*  43526 */     GIR_EraseRootFromParent_Done,
     /*  43527 */   // Label 676: @43527
     /*  43527 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43638), // Rule ID 13421 //
     /*  43532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43600 */     // MIs[4] Operand 1
     /*  43600 */     // No operand predicates
     /*  43600 */     // MIs[2] Operand 2
     /*  43600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43616 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43618 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43636 */     GIR_RootConstrainSelectedInstOperands,
     /*  43637 */     // GIR_Coverage, 13421,
     /*  43637 */     GIR_EraseRootFromParent_Done,
     /*  43638 */   // Label 677: @43638
     /*  43638 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(43749), // Rule ID 2046 //
     /*  43643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43695 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43699 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43712 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43716 */     // MIs[4] Operand 1
     /*  43716 */     // No operand predicates
     /*  43716 */     // MIs[2] Operand 2
     /*  43716 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43727 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43729 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43747 */     GIR_RootConstrainSelectedInstOperands,
     /*  43748 */     // GIR_Coverage, 2046,
     /*  43748 */     GIR_EraseRootFromParent_Done,
     /*  43749 */   // Label 678: @43749
     /*  43749 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(43860), // Rule ID 13451 //
     /*  43754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43797 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43801 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43805 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43818 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43822 */     // MIs[4] Operand 1
     /*  43822 */     // No operand predicates
     /*  43822 */     // MIs[2] Operand 2
     /*  43822 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43838 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43840 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43858 */     GIR_RootConstrainSelectedInstOperands,
     /*  43859 */     // GIR_Coverage, 13451,
     /*  43859 */     GIR_EraseRootFromParent_Done,
     /*  43860 */   // Label 679: @43860
     /*  43860 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(43971), // Rule ID 2098 //
     /*  43865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43930 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43934 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43938 */     // MIs[4] Operand 1
     /*  43938 */     // No operand predicates
     /*  43938 */     // MIs[2] Operand 2
     /*  43938 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43949 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43951 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43969 */     GIR_RootConstrainSelectedInstOperands,
     /*  43970 */     // GIR_Coverage, 2098,
     /*  43970 */     GIR_EraseRootFromParent_Done,
     /*  43971 */   // Label 680: @43971
     /*  43971 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44034), // Rule ID 1735 //
     /*  43976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44015 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44032 */     GIR_RootConstrainSelectedInstOperands,
     /*  44033 */     // GIR_Coverage, 1735,
     /*  44033 */     GIR_EraseRootFromParent_Done,
     /*  44034 */   // Label 681: @44034
     /*  44034 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44097), // Rule ID 1825 //
     /*  44039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44078 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44095 */     GIR_RootConstrainSelectedInstOperands,
     /*  44096 */     // GIR_Coverage, 1825,
     /*  44096 */     GIR_EraseRootFromParent_Done,
     /*  44097 */   // Label 682: @44097
     /*  44097 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44185), // Rule ID 13422 //
     /*  44102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44158 */     // MIs[3] Operand 1
     /*  44158 */     // No operand predicates
     /*  44158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44165 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44183 */     GIR_RootConstrainSelectedInstOperands,
     /*  44184 */     // GIR_Coverage, 13422,
     /*  44184 */     GIR_EraseRootFromParent_Done,
     /*  44185 */   // Label 683: @44185
     /*  44185 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44273), // Rule ID 2047 //
     /*  44190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44247 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44251 */     // MIs[3] Operand 1
     /*  44251 */     // No operand predicates
     /*  44251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44253 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44271 */     GIR_RootConstrainSelectedInstOperands,
     /*  44272 */     // GIR_Coverage, 2047,
     /*  44272 */     GIR_EraseRootFromParent_Done,
     /*  44273 */   // Label 684: @44273
     /*  44273 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44361), // Rule ID 13452 //
     /*  44278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44330 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44334 */     // MIs[3] Operand 1
     /*  44334 */     // No operand predicates
     /*  44334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44341 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44359 */     GIR_RootConstrainSelectedInstOperands,
     /*  44360 */     // GIR_Coverage, 13452,
     /*  44360 */     GIR_EraseRootFromParent_Done,
     /*  44361 */   // Label 685: @44361
     /*  44361 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44449), // Rule ID 2099 //
     /*  44366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44423 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44427 */     // MIs[3] Operand 1
     /*  44427 */     // No operand predicates
     /*  44427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44429 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44447 */     GIR_RootConstrainSelectedInstOperands,
     /*  44448 */     // GIR_Coverage, 2099,
     /*  44448 */     GIR_EraseRootFromParent_Done,
     /*  44449 */   // Label 686: @44449
     /*  44449 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44496), // Rule ID 1867 //
     /*  44454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44482 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44494 */     GIR_RootConstrainSelectedInstOperands,
     /*  44495 */     // GIR_Coverage, 1867,
     /*  44495 */     GIR_EraseRootFromParent_Done,
     /*  44496 */   // Label 687: @44496
     /*  44496 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44543), // Rule ID 1765 //
     /*  44501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44529 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44541 */     GIR_RootConstrainSelectedInstOperands,
     /*  44542 */     // GIR_Coverage, 1765,
     /*  44542 */     GIR_EraseRootFromParent_Done,
     /*  44543 */   // Label 688: @44543
     /*  44543 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44590), // Rule ID 1866 //
     /*  44548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44576 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44588 */     GIR_RootConstrainSelectedInstOperands,
     /*  44589 */     // GIR_Coverage, 1866,
     /*  44589 */     GIR_EraseRootFromParent_Done,
     /*  44590 */   // Label 689: @44590
     /*  44590 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44649), // Rule ID 1851 //
     /*  44595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44634 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44647 */     GIR_RootConstrainSelectedInstOperands,
     /*  44648 */     // GIR_Coverage, 1851,
     /*  44648 */     GIR_EraseRootFromParent_Done,
     /*  44649 */   // Label 690: @44649
     /*  44649 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44708), // Rule ID 1850 //
     /*  44654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44693 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44706 */     GIR_RootConstrainSelectedInstOperands,
     /*  44707 */     // GIR_Coverage, 1850,
     /*  44707 */     GIR_EraseRootFromParent_Done,
     /*  44708 */   // Label 691: @44708
     /*  44708 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44767), // Rule ID 1758 //
     /*  44713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44752 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44765 */     GIR_RootConstrainSelectedInstOperands,
     /*  44766 */     // GIR_Coverage, 1758,
     /*  44766 */     GIR_EraseRootFromParent_Done,
     /*  44767 */   // Label 692: @44767
     /*  44767 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44826), // Rule ID 1849 //
     /*  44772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44811 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44824 */     GIR_RootConstrainSelectedInstOperands,
     /*  44825 */     // GIR_Coverage, 1849,
     /*  44825 */     GIR_EraseRootFromParent_Done,
     /*  44826 */   // Label 693: @44826
     /*  44826 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44885), // Rule ID 1848 //
     /*  44831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44870 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44883 */     GIR_RootConstrainSelectedInstOperands,
     /*  44884 */     // GIR_Coverage, 1848,
     /*  44884 */     GIR_EraseRootFromParent_Done,
     /*  44885 */   // Label 694: @44885
     /*  44885 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44920), // Rule ID 971 //
     /*  44890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44911 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44918 */     GIR_RootConstrainSelectedInstOperands,
     /*  44919 */     // GIR_Coverage, 971,
     /*  44919 */     GIR_EraseRootFromParent_Done,
     /*  44920 */   // Label 695: @44920
     /*  44920 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44977), // Rule ID 1734 //
     /*  44925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44960 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  44975 */     GIR_RootConstrainSelectedInstOperands,
     /*  44976 */     // GIR_Coverage, 1734,
     /*  44976 */     GIR_EraseRootFromParent_Done,
     /*  44977 */   // Label 696: @44977
     /*  44977 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45034), // Rule ID 1824 //
     /*  44982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45017 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45032 */     GIR_RootConstrainSelectedInstOperands,
     /*  45033 */     // GIR_Coverage, 1824,
     /*  45033 */     GIR_EraseRootFromParent_Done,
     /*  45034 */   // Label 697: @45034
     /*  45034 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45078), // Rule ID 1865 //
     /*  45039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45065 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45076 */     GIR_RootConstrainSelectedInstOperands,
     /*  45077 */     // GIR_Coverage, 1865,
     /*  45077 */     GIR_EraseRootFromParent_Done,
     /*  45078 */   // Label 698: @45078
     /*  45078 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45122), // Rule ID 1764 //
     /*  45083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45109 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45120 */     GIR_RootConstrainSelectedInstOperands,
     /*  45121 */     // GIR_Coverage, 1764,
     /*  45121 */     GIR_EraseRootFromParent_Done,
     /*  45122 */   // Label 699: @45122
     /*  45122 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45166), // Rule ID 1864 //
     /*  45127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45153 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45164 */     GIR_RootConstrainSelectedInstOperands,
     /*  45165 */     // GIR_Coverage, 1864,
     /*  45165 */     GIR_EraseRootFromParent_Done,
     /*  45166 */   // Label 700: @45166
     /*  45166 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45189), // Rule ID 1478 //
     /*  45171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45182 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45187 */     GIR_RootConstrainSelectedInstOperands,
     /*  45188 */     // GIR_Coverage, 1478,
     /*  45188 */     GIR_Done,
     /*  45189 */   // Label 701: @45189
     /*  45189 */   GIM_Reject,
     /*  45190 */ // Label 667: @45190
     /*  45190 */ GIM_Reject,
     /*  45191 */ // Label 591: @45191
     /*  45191 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46681),
     /*  45196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45206 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45338), // Rule ID 5380 //
     /*  45211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45240 */     // MIs[1] Operand 2
     /*  45240 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45263 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45267 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45271 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45275 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45280 */     // MIs[3] Operand 2
     /*  45280 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45293 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45337 */     // GIR_Coverage, 5380,
     /*  45337 */     GIR_EraseRootFromParent_Done,
     /*  45338 */   // Label 703: @45338
     /*  45338 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45470), // Rule ID 5379 //
     /*  45343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45372 */     // MIs[1] Operand 2
     /*  45372 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45391 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45399 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45403 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45407 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45412 */     // MIs[3] Operand 2
     /*  45412 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45423 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45425 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45452 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45469 */     // GIR_Coverage, 5379,
     /*  45469 */     GIR_EraseRootFromParent_Done,
     /*  45470 */   // Label 704: @45470
     /*  45470 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45602), // Rule ID 5395 //
     /*  45475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45504 */     // MIs[1] Operand 2
     /*  45504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45527 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45531 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45535 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45539 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45544 */     // MIs[3] Operand 2
     /*  45544 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45555 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45557 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45601 */     // GIR_Coverage, 5395,
     /*  45601 */     GIR_EraseRootFromParent_Done,
     /*  45602 */   // Label 705: @45602
     /*  45602 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45734), // Rule ID 5378 //
     /*  45607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45636 */     // MIs[1] Operand 2
     /*  45636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45667 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45671 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45676 */     // MIs[3] Operand 2
     /*  45676 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45689 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45716 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45733 */     // GIR_Coverage, 5378,
     /*  45733 */     GIR_EraseRootFromParent_Done,
     /*  45734 */   // Label 706: @45734
     /*  45734 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45866), // Rule ID 5377 //
     /*  45739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45768 */     // MIs[1] Operand 2
     /*  45768 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45808 */     // MIs[3] Operand 2
     /*  45808 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45821 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45865 */     // GIR_Coverage, 5377,
     /*  45865 */     GIR_EraseRootFromParent_Done,
     /*  45866 */   // Label 707: @45866
     /*  45866 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46025), // Rule ID 5350 //
     /*  45871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45913 */     // MIs[1] Operand 2
     /*  45913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45926 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  45984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46024 */     // GIR_Coverage, 5350,
     /*  46024 */     GIR_EraseRootFromParent_Done,
     /*  46025 */   // Label 708: @46025
     /*  46025 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46184), // Rule ID 5347 //
     /*  46030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46072 */     // MIs[1] Operand 2
     /*  46072 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46085 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46085 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46088 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46092 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46111 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46166 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46183 */     // GIR_Coverage, 5347,
     /*  46183 */     GIR_EraseRootFromParent_Done,
     /*  46184 */   // Label 709: @46184
     /*  46184 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46330), // Rule ID 5390 //
     /*  46189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46222 */     // MIs[1] Operand 2
     /*  46222 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46235 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46235 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46238 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46242 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46249 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46252 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46256 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46261 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46268 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46271 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46298 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46329 */     // GIR_Coverage, 5390,
     /*  46329 */     GIR_EraseRootFromParent_Done,
     /*  46330 */   // Label 710: @46330
     /*  46330 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46476), // Rule ID 5398 //
     /*  46335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46368 */     // MIs[1] Operand 2
     /*  46368 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46381 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46381 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46384 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46388 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46395 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46402 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46407 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46414 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46427 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46458 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46475 */     // GIR_Coverage, 5398,
     /*  46475 */     GIR_EraseRootFromParent_Done,
     /*  46476 */   // Label 711: @46476
     /*  46476 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46622), // Rule ID 5389 //
     /*  46481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46514 */     // MIs[1] Operand 2
     /*  46514 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46527 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46541 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46544 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46548 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46553 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46560 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46621 */     // GIR_Coverage, 5389,
     /*  46621 */     GIR_EraseRootFromParent_Done,
     /*  46622 */   // Label 712: @46622
     /*  46622 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46657), // Rule ID 967 //
     /*  46627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46648 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46655 */     GIR_RootConstrainSelectedInstOperands,
     /*  46656 */     // GIR_Coverage, 967,
     /*  46656 */     GIR_EraseRootFromParent_Done,
     /*  46657 */   // Label 713: @46657
     /*  46657 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46680), // Rule ID 1474 //
     /*  46662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46673 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46678 */     GIR_RootConstrainSelectedInstOperands,
     /*  46679 */     // GIR_Coverage, 1474,
     /*  46679 */     GIR_Done,
     /*  46680 */   // Label 714: @46680
     /*  46680 */   GIM_Reject,
     /*  46681 */ // Label 702: @46681
     /*  46681 */ GIM_Reject,
     /*  46682 */ // Label 592: @46682
     /*  46682 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(49141),
     /*  46687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46697 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46811), // Rule ID 2045 //
     /*  46702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46749 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46753 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46758 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46762 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46766 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46770 */     // MIs[4] Operand 1
     /*  46770 */     // No operand predicates
     /*  46770 */     // MIs[2] Operand 2
     /*  46770 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46781 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46790 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46809 */     GIR_RootConstrainSelectedInstOperands,
     /*  46810 */     // GIR_Coverage, 2045,
     /*  46810 */     GIR_EraseRootFromParent_Done,
     /*  46811 */   // Label 716: @46811
     /*  46811 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46925), // Rule ID 13420 //
     /*  46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46859 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46863 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46876 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46880 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46884 */     // MIs[4] Operand 1
     /*  46884 */     // No operand predicates
     /*  46884 */     // MIs[2] Operand 2
     /*  46884 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46904 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46923 */     GIR_RootConstrainSelectedInstOperands,
     /*  46924 */     // GIR_Coverage, 13420,
     /*  46924 */     GIR_EraseRootFromParent_Done,
     /*  46925 */   // Label 717: @46925
     /*  46925 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47039), // Rule ID 2097 //
     /*  46930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46977 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46994 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46998 */     // MIs[4] Operand 1
     /*  46998 */     // No operand predicates
     /*  46998 */     // MIs[2] Operand 2
     /*  46998 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47009 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47018 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47037 */     GIR_RootConstrainSelectedInstOperands,
     /*  47038 */     // GIR_Coverage, 2097,
     /*  47038 */     GIR_EraseRootFromParent_Done,
     /*  47039 */   // Label 718: @47039
     /*  47039 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47153), // Rule ID 13450 //
     /*  47044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47087 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47091 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47095 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47108 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47112 */     // MIs[4] Operand 1
     /*  47112 */     // No operand predicates
     /*  47112 */     // MIs[2] Operand 2
     /*  47112 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47123 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47151 */     GIR_RootConstrainSelectedInstOperands,
     /*  47152 */     // GIR_Coverage, 13450,
     /*  47152 */     GIR_EraseRootFromParent_Done,
     /*  47153 */   // Label 719: @47153
     /*  47153 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47218), // Rule ID 1847 //
     /*  47158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47201 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47216 */     GIR_RootConstrainSelectedInstOperands,
     /*  47217 */     // GIR_Coverage, 1847,
     /*  47217 */     GIR_EraseRootFromParent_Done,
     /*  47218 */   // Label 720: @47218
     /*  47218 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47283), // Rule ID 1846 //
     /*  47223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47266 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47281 */     GIR_RootConstrainSelectedInstOperands,
     /*  47282 */     // GIR_Coverage, 1846,
     /*  47282 */     GIR_EraseRootFromParent_Done,
     /*  47283 */   // Label 721: @47283
     /*  47283 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47348), // Rule ID 1757 //
     /*  47288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47331 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47346 */     GIR_RootConstrainSelectedInstOperands,
     /*  47347 */     // GIR_Coverage, 1757,
     /*  47347 */     GIR_EraseRootFromParent_Done,
     /*  47348 */   // Label 722: @47348
     /*  47348 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47413), // Rule ID 1845 //
     /*  47353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47396 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47411 */     GIR_RootConstrainSelectedInstOperands,
     /*  47412 */     // GIR_Coverage, 1845,
     /*  47412 */     GIR_EraseRootFromParent_Done,
     /*  47413 */   // Label 723: @47413
     /*  47413 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47478), // Rule ID 1844 //
     /*  47418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47461 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47476 */     GIR_RootConstrainSelectedInstOperands,
     /*  47477 */     // GIR_Coverage, 1844,
     /*  47477 */     GIR_EraseRootFromParent_Done,
     /*  47478 */   // Label 724: @47478
     /*  47478 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47589), // Rule ID 13418 //
     /*  47483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47526 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47530 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47534 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47543 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47547 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47551 */     // MIs[4] Operand 1
     /*  47551 */     // No operand predicates
     /*  47551 */     // MIs[2] Operand 2
     /*  47551 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47569 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47587 */     GIR_RootConstrainSelectedInstOperands,
     /*  47588 */     // GIR_Coverage, 13418,
     /*  47588 */     GIR_EraseRootFromParent_Done,
     /*  47589 */   // Label 725: @47589
     /*  47589 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(47700), // Rule ID 2043 //
     /*  47594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47650 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47655 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47659 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47663 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47667 */     // MIs[4] Operand 1
     /*  47667 */     // No operand predicates
     /*  47667 */     // MIs[2] Operand 2
     /*  47667 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47678 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47680 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47698 */     GIR_RootConstrainSelectedInstOperands,
     /*  47699 */     // GIR_Coverage, 2043,
     /*  47699 */     GIR_EraseRootFromParent_Done,
     /*  47700 */   // Label 726: @47700
     /*  47700 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(47811), // Rule ID 13448 //
     /*  47705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47769 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47773 */     // MIs[4] Operand 1
     /*  47773 */     // No operand predicates
     /*  47773 */     // MIs[2] Operand 2
     /*  47773 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47789 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47791 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47809 */     GIR_RootConstrainSelectedInstOperands,
     /*  47810 */     // GIR_Coverage, 13448,
     /*  47810 */     GIR_EraseRootFromParent_Done,
     /*  47811 */   // Label 727: @47811
     /*  47811 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(47922), // Rule ID 2095 //
     /*  47816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47872 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47877 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47881 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47885 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47889 */     // MIs[4] Operand 1
     /*  47889 */     // No operand predicates
     /*  47889 */     // MIs[2] Operand 2
     /*  47889 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47902 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47920 */     GIR_RootConstrainSelectedInstOperands,
     /*  47921 */     // GIR_Coverage, 2095,
     /*  47921 */     GIR_EraseRootFromParent_Done,
     /*  47922 */   // Label 728: @47922
     /*  47922 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(47985), // Rule ID 1733 //
     /*  47927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47966 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47983 */     GIR_RootConstrainSelectedInstOperands,
     /*  47984 */     // GIR_Coverage, 1733,
     /*  47984 */     GIR_EraseRootFromParent_Done,
     /*  47985 */   // Label 729: @47985
     /*  47985 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48048), // Rule ID 1823 //
     /*  47990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48029 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48046 */     GIR_RootConstrainSelectedInstOperands,
     /*  48047 */     // GIR_Coverage, 1823,
     /*  48047 */     GIR_EraseRootFromParent_Done,
     /*  48048 */   // Label 730: @48048
     /*  48048 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48136), // Rule ID 13419 //
     /*  48053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48105 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48109 */     // MIs[3] Operand 1
     /*  48109 */     // No operand predicates
     /*  48109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48116 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48134 */     GIR_RootConstrainSelectedInstOperands,
     /*  48135 */     // GIR_Coverage, 13419,
     /*  48135 */     GIR_EraseRootFromParent_Done,
     /*  48136 */   // Label 731: @48136
     /*  48136 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48224), // Rule ID 2044 //
     /*  48141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48202 */     // MIs[3] Operand 1
     /*  48202 */     // No operand predicates
     /*  48202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48204 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48222 */     GIR_RootConstrainSelectedInstOperands,
     /*  48223 */     // GIR_Coverage, 2044,
     /*  48223 */     GIR_EraseRootFromParent_Done,
     /*  48224 */   // Label 732: @48224
     /*  48224 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48312), // Rule ID 13449 //
     /*  48229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48285 */     // MIs[3] Operand 1
     /*  48285 */     // No operand predicates
     /*  48285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48292 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48310 */     GIR_RootConstrainSelectedInstOperands,
     /*  48311 */     // GIR_Coverage, 13449,
     /*  48311 */     GIR_EraseRootFromParent_Done,
     /*  48312 */   // Label 733: @48312
     /*  48312 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48400), // Rule ID 2096 //
     /*  48317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48374 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48378 */     // MIs[3] Operand 1
     /*  48378 */     // No operand predicates
     /*  48378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48380 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48398 */     GIR_RootConstrainSelectedInstOperands,
     /*  48399 */     // GIR_Coverage, 2096,
     /*  48399 */     GIR_EraseRootFromParent_Done,
     /*  48400 */   // Label 734: @48400
     /*  48400 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48447), // Rule ID 1863 //
     /*  48405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48433 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48445 */     GIR_RootConstrainSelectedInstOperands,
     /*  48446 */     // GIR_Coverage, 1863,
     /*  48446 */     GIR_EraseRootFromParent_Done,
     /*  48447 */   // Label 735: @48447
     /*  48447 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48494), // Rule ID 1763 //
     /*  48452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48480 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48492 */     GIR_RootConstrainSelectedInstOperands,
     /*  48493 */     // GIR_Coverage, 1763,
     /*  48493 */     GIR_EraseRootFromParent_Done,
     /*  48494 */   // Label 736: @48494
     /*  48494 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48541), // Rule ID 1862 //
     /*  48499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48527 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48539 */     GIR_RootConstrainSelectedInstOperands,
     /*  48540 */     // GIR_Coverage, 1862,
     /*  48540 */     GIR_EraseRootFromParent_Done,
     /*  48541 */   // Label 737: @48541
     /*  48541 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48600), // Rule ID 1843 //
     /*  48546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48585 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48598 */     GIR_RootConstrainSelectedInstOperands,
     /*  48599 */     // GIR_Coverage, 1843,
     /*  48599 */     GIR_EraseRootFromParent_Done,
     /*  48600 */   // Label 738: @48600
     /*  48600 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48659), // Rule ID 1842 //
     /*  48605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48644 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48657 */     GIR_RootConstrainSelectedInstOperands,
     /*  48658 */     // GIR_Coverage, 1842,
     /*  48658 */     GIR_EraseRootFromParent_Done,
     /*  48659 */   // Label 739: @48659
     /*  48659 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48718), // Rule ID 1756 //
     /*  48664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48703 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48716 */     GIR_RootConstrainSelectedInstOperands,
     /*  48717 */     // GIR_Coverage, 1756,
     /*  48717 */     GIR_EraseRootFromParent_Done,
     /*  48718 */   // Label 740: @48718
     /*  48718 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48777), // Rule ID 1841 //
     /*  48723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48762 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48775 */     GIR_RootConstrainSelectedInstOperands,
     /*  48776 */     // GIR_Coverage, 1841,
     /*  48776 */     GIR_EraseRootFromParent_Done,
     /*  48777 */   // Label 741: @48777
     /*  48777 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(48836), // Rule ID 1840 //
     /*  48782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48821 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48834 */     GIR_RootConstrainSelectedInstOperands,
     /*  48835 */     // GIR_Coverage, 1840,
     /*  48835 */     GIR_EraseRootFromParent_Done,
     /*  48836 */   // Label 742: @48836
     /*  48836 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(48871), // Rule ID 970 //
     /*  48841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48862 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48869 */     GIR_RootConstrainSelectedInstOperands,
     /*  48870 */     // GIR_Coverage, 970,
     /*  48870 */     GIR_EraseRootFromParent_Done,
     /*  48871 */   // Label 743: @48871
     /*  48871 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(48928), // Rule ID 1732 //
     /*  48876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48911 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48926 */     GIR_RootConstrainSelectedInstOperands,
     /*  48927 */     // GIR_Coverage, 1732,
     /*  48927 */     GIR_EraseRootFromParent_Done,
     /*  48928 */   // Label 744: @48928
     /*  48928 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(48985), // Rule ID 1822 //
     /*  48933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48968 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48983 */     GIR_RootConstrainSelectedInstOperands,
     /*  48984 */     // GIR_Coverage, 1822,
     /*  48984 */     GIR_EraseRootFromParent_Done,
     /*  48985 */   // Label 745: @48985
     /*  48985 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49029), // Rule ID 1861 //
     /*  48990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49016 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49027 */     GIR_RootConstrainSelectedInstOperands,
     /*  49028 */     // GIR_Coverage, 1861,
     /*  49028 */     GIR_EraseRootFromParent_Done,
     /*  49029 */   // Label 746: @49029
     /*  49029 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49073), // Rule ID 1762 //
     /*  49034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49060 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49071 */     GIR_RootConstrainSelectedInstOperands,
     /*  49072 */     // GIR_Coverage, 1762,
     /*  49072 */     GIR_EraseRootFromParent_Done,
     /*  49073 */   // Label 747: @49073
     /*  49073 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49117), // Rule ID 1860 //
     /*  49078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49104 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49115 */     GIR_RootConstrainSelectedInstOperands,
     /*  49116 */     // GIR_Coverage, 1860,
     /*  49116 */     GIR_EraseRootFromParent_Done,
     /*  49117 */   // Label 748: @49117
     /*  49117 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49140), // Rule ID 1477 //
     /*  49122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49133 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49138 */     GIR_RootConstrainSelectedInstOperands,
     /*  49139 */     // GIR_Coverage, 1477,
     /*  49139 */     GIR_Done,
     /*  49140 */   // Label 749: @49140
     /*  49140 */   GIM_Reject,
     /*  49141 */ // Label 715: @49141
     /*  49141 */ GIM_Reject,
     /*  49142 */ // Label 593: @49142
     /*  49142 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49216),
     /*  49147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49157 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49192), // Rule ID 965 //
     /*  49162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49183 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49190 */     GIR_RootConstrainSelectedInstOperands,
     /*  49191 */     // GIR_Coverage, 965,
     /*  49191 */     GIR_EraseRootFromParent_Done,
     /*  49192 */   // Label 751: @49192
     /*  49192 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49215), // Rule ID 1472 //
     /*  49197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49208 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49213 */     GIR_RootConstrainSelectedInstOperands,
     /*  49214 */     // GIR_Coverage, 1472,
     /*  49214 */     GIR_Done,
     /*  49215 */   // Label 752: @49215
     /*  49215 */   GIM_Reject,
     /*  49216 */ // Label 750: @49216
     /*  49216 */ GIM_Reject,
     /*  49217 */ // Label 594: @49217
     /*  49217 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50424),
     /*  49222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49232 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49297), // Rule ID 1839 //
     /*  49237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49280 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49295 */     GIR_RootConstrainSelectedInstOperands,
     /*  49296 */     // GIR_Coverage, 1839,
     /*  49296 */     GIR_EraseRootFromParent_Done,
     /*  49297 */   // Label 754: @49297
     /*  49297 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49362), // Rule ID 1838 //
     /*  49302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49345 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49360 */     GIR_RootConstrainSelectedInstOperands,
     /*  49361 */     // GIR_Coverage, 1838,
     /*  49361 */     GIR_EraseRootFromParent_Done,
     /*  49362 */   // Label 755: @49362
     /*  49362 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49427), // Rule ID 1755 //
     /*  49367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49410 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49425 */     GIR_RootConstrainSelectedInstOperands,
     /*  49426 */     // GIR_Coverage, 1755,
     /*  49426 */     GIR_EraseRootFromParent_Done,
     /*  49427 */   // Label 756: @49427
     /*  49427 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49492), // Rule ID 1837 //
     /*  49432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49475 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49490 */     GIR_RootConstrainSelectedInstOperands,
     /*  49491 */     // GIR_Coverage, 1837,
     /*  49491 */     GIR_EraseRootFromParent_Done,
     /*  49492 */   // Label 757: @49492
     /*  49492 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49557), // Rule ID 1836 //
     /*  49497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49540 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49555 */     GIR_RootConstrainSelectedInstOperands,
     /*  49556 */     // GIR_Coverage, 1836,
     /*  49556 */     GIR_EraseRootFromParent_Done,
     /*  49557 */   // Label 758: @49557
     /*  49557 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49620), // Rule ID 1731 //
     /*  49562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49601 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49618 */     GIR_RootConstrainSelectedInstOperands,
     /*  49619 */     // GIR_Coverage, 1731,
     /*  49619 */     GIR_EraseRootFromParent_Done,
     /*  49620 */   // Label 759: @49620
     /*  49620 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49683), // Rule ID 1821 //
     /*  49625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49664 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49681 */     GIR_RootConstrainSelectedInstOperands,
     /*  49682 */     // GIR_Coverage, 1821,
     /*  49682 */     GIR_EraseRootFromParent_Done,
     /*  49683 */   // Label 760: @49683
     /*  49683 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49730), // Rule ID 1859 //
     /*  49688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49716 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49728 */     GIR_RootConstrainSelectedInstOperands,
     /*  49729 */     // GIR_Coverage, 1859,
     /*  49729 */     GIR_EraseRootFromParent_Done,
     /*  49730 */   // Label 761: @49730
     /*  49730 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49777), // Rule ID 1761 //
     /*  49735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49763 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49775 */     GIR_RootConstrainSelectedInstOperands,
     /*  49776 */     // GIR_Coverage, 1761,
     /*  49776 */     GIR_EraseRootFromParent_Done,
     /*  49777 */   // Label 762: @49777
     /*  49777 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(49824), // Rule ID 1858 //
     /*  49782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49810 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49822 */     GIR_RootConstrainSelectedInstOperands,
     /*  49823 */     // GIR_Coverage, 1858,
     /*  49823 */     GIR_EraseRootFromParent_Done,
     /*  49824 */   // Label 763: @49824
     /*  49824 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(49883), // Rule ID 1835 //
     /*  49829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49868 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49881 */     GIR_RootConstrainSelectedInstOperands,
     /*  49882 */     // GIR_Coverage, 1835,
     /*  49882 */     GIR_EraseRootFromParent_Done,
     /*  49883 */   // Label 764: @49883
     /*  49883 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(49942), // Rule ID 1834 //
     /*  49888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49927 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49940 */     GIR_RootConstrainSelectedInstOperands,
     /*  49941 */     // GIR_Coverage, 1834,
     /*  49941 */     GIR_EraseRootFromParent_Done,
     /*  49942 */   // Label 765: @49942
     /*  49942 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50001), // Rule ID 1754 //
     /*  49947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49986 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  49989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49999 */     GIR_RootConstrainSelectedInstOperands,
     /*  50000 */     // GIR_Coverage, 1754,
     /*  50000 */     GIR_EraseRootFromParent_Done,
     /*  50001 */   // Label 766: @50001
     /*  50001 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50060), // Rule ID 1833 //
     /*  50006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50045 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50058 */     GIR_RootConstrainSelectedInstOperands,
     /*  50059 */     // GIR_Coverage, 1833,
     /*  50059 */     GIR_EraseRootFromParent_Done,
     /*  50060 */   // Label 767: @50060
     /*  50060 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50119), // Rule ID 1832 //
     /*  50065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50104 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50117 */     GIR_RootConstrainSelectedInstOperands,
     /*  50118 */     // GIR_Coverage, 1832,
     /*  50118 */     GIR_EraseRootFromParent_Done,
     /*  50119 */   // Label 768: @50119
     /*  50119 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50154), // Rule ID 968 //
     /*  50124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50131 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50137 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50145 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50152 */     GIR_RootConstrainSelectedInstOperands,
     /*  50153 */     // GIR_Coverage, 968,
     /*  50153 */     GIR_EraseRootFromParent_Done,
     /*  50154 */   // Label 769: @50154
     /*  50154 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50211), // Rule ID 1730 //
     /*  50159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50194 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50209 */     GIR_RootConstrainSelectedInstOperands,
     /*  50210 */     // GIR_Coverage, 1730,
     /*  50210 */     GIR_EraseRootFromParent_Done,
     /*  50211 */   // Label 770: @50211
     /*  50211 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50268), // Rule ID 1820 //
     /*  50216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50251 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50266 */     GIR_RootConstrainSelectedInstOperands,
     /*  50267 */     // GIR_Coverage, 1820,
     /*  50267 */     GIR_EraseRootFromParent_Done,
     /*  50268 */   // Label 771: @50268
     /*  50268 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50312), // Rule ID 1857 //
     /*  50273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50299 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50310 */     GIR_RootConstrainSelectedInstOperands,
     /*  50311 */     // GIR_Coverage, 1857,
     /*  50311 */     GIR_EraseRootFromParent_Done,
     /*  50312 */   // Label 772: @50312
     /*  50312 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50356), // Rule ID 1760 //
     /*  50317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50343 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50354 */     GIR_RootConstrainSelectedInstOperands,
     /*  50355 */     // GIR_Coverage, 1760,
     /*  50355 */     GIR_EraseRootFromParent_Done,
     /*  50356 */   // Label 773: @50356
     /*  50356 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50400), // Rule ID 1856 //
     /*  50361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50387 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50398 */     GIR_RootConstrainSelectedInstOperands,
     /*  50399 */     // GIR_Coverage, 1856,
     /*  50399 */     GIR_EraseRootFromParent_Done,
     /*  50400 */   // Label 774: @50400
     /*  50400 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50423), // Rule ID 1475 //
     /*  50405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50416 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50421 */     GIR_RootConstrainSelectedInstOperands,
     /*  50422 */     // GIR_Coverage, 1475,
     /*  50422 */     GIR_Done,
     /*  50423 */   // Label 775: @50423
     /*  50423 */   GIM_Reject,
     /*  50424 */ // Label 753: @50424
     /*  50424 */ GIM_Reject,
     /*  50425 */ // Label 595: @50425
     /*  50425 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50499),
     /*  50430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50475), // Rule ID 966 //
     /*  50445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50466 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50473 */     GIR_RootConstrainSelectedInstOperands,
     /*  50474 */     // GIR_Coverage, 966,
     /*  50474 */     GIR_EraseRootFromParent_Done,
     /*  50475 */   // Label 777: @50475
     /*  50475 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50498), // Rule ID 1473 //
     /*  50480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50491 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50496 */     GIR_RootConstrainSelectedInstOperands,
     /*  50497 */     // GIR_Coverage, 1473,
     /*  50497 */     GIR_Done,
     /*  50498 */   // Label 778: @50498
     /*  50498 */   GIM_Reject,
     /*  50499 */ // Label 776: @50499
     /*  50499 */ GIM_Reject,
     /*  50500 */ // Label 596: @50500
     /*  50500 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50525), // Rule ID 7388 //
     /*  50505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50518 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50523 */   GIR_RootConstrainSelectedInstOperands,
     /*  50524 */   // GIR_Coverage, 7388,
     /*  50524 */   GIR_Done,
     /*  50525 */ // Label 779: @50525
     /*  50525 */ GIM_Reject,
     /*  50526 */ // Label 597: @50526
     /*  50526 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(50551), // Rule ID 7387 //
     /*  50531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50544 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50549 */   GIR_RootConstrainSelectedInstOperands,
     /*  50550 */   // GIR_Coverage, 7387,
     /*  50550 */   GIR_Done,
     /*  50551 */ // Label 780: @50551
     /*  50551 */ GIM_Reject,
     /*  50552 */ // Label 598: @50552
     /*  50552 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(50577), // Rule ID 7386 //
     /*  50557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50570 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50575 */   GIR_RootConstrainSelectedInstOperands,
     /*  50576 */   // GIR_Coverage, 7386,
     /*  50576 */   GIR_Done,
     /*  50577 */ // Label 781: @50577
     /*  50577 */ GIM_Reject,
     /*  50578 */ // Label 599: @50578
     /*  50578 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(50603), // Rule ID 7385 //
     /*  50583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50596 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50601 */   GIR_RootConstrainSelectedInstOperands,
     /*  50602 */   // GIR_Coverage, 7385,
     /*  50602 */   GIR_Done,
     /*  50603 */ // Label 782: @50603
     /*  50603 */ GIM_Reject,
     /*  50604 */ // Label 600: @50604
     /*  50604 */ GIM_Reject,
     /*  50605 */ // Label 2: @50605
     /*  50605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 791*/ GIMT_Encode4(52433),
     /*  50616 */ /*GILLT_s32*//*Label 783*/ GIMT_Encode4(50656),
     /*  50620 */ /*GILLT_s64*//*Label 784*/ GIMT_Encode4(50813), GIMT_Encode4(0),
     /*  50628 */ /*GILLT_v2s32*//*Label 785*/ GIMT_Encode4(51357), GIMT_Encode4(0),
     /*  50636 */ /*GILLT_v4s16*//*Label 786*/ GIMT_Encode4(51695),
     /*  50640 */ /*GILLT_v4s32*//*Label 787*/ GIMT_Encode4(52033),
     /*  50644 */ /*GILLT_v8s8*//*Label 788*/ GIMT_Encode4(52199),
     /*  50648 */ /*GILLT_v8s16*//*Label 789*/ GIMT_Encode4(52233),
     /*  50652 */ /*GILLT_v16s8*//*Label 790*/ GIMT_Encode4(52399),
     /*  50656 */ // Label 783: @50656
     /*  50656 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50812),
     /*  50661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50671 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(50726), // Rule ID 3947 //
     /*  50676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50707 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50724 */     GIR_RootConstrainSelectedInstOperands,
     /*  50725 */     // GIR_Coverage, 3947,
     /*  50725 */     GIR_EraseRootFromParent_Done,
     /*  50726 */   // Label 793: @50726
     /*  50726 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(50781), // Rule ID 13703 //
     /*  50731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50751 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50762 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50779 */     GIR_RootConstrainSelectedInstOperands,
     /*  50780 */     // GIR_Coverage, 13703,
     /*  50780 */     GIR_EraseRootFromParent_Done,
     /*  50781 */   // Label 794: @50781
     /*  50781 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(50811), // Rule ID 3943 //
     /*  50786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50794 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50809 */     GIR_RootConstrainSelectedInstOperands,
     /*  50810 */     // GIR_Coverage, 3943,
     /*  50810 */     GIR_EraseRootFromParent_Done,
     /*  50811 */   // Label 795: @50811
     /*  50811 */   GIM_Reject,
     /*  50812 */ // Label 792: @50812
     /*  50812 */ GIM_Reject,
     /*  50813 */ // Label 784: @50813
     /*  50813 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51356),
     /*  50818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50828 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(50883), // Rule ID 3948 //
     /*  50833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50849 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50864 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50881 */     GIR_RootConstrainSelectedInstOperands,
     /*  50882 */     // GIR_Coverage, 3948,
     /*  50882 */     GIR_EraseRootFromParent_Done,
     /*  50883 */   // Label 797: @50883
     /*  50883 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(50938), // Rule ID 13704 //
     /*  50888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50908 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50919 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50936 */     GIR_RootConstrainSelectedInstOperands,
     /*  50937 */     // GIR_Coverage, 13704,
     /*  50937 */     GIR_EraseRootFromParent_Done,
     /*  50938 */   // Label 798: @50938
     /*  50938 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51051), // Rule ID 3959 //
     /*  50943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  50951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50960 */     // MIs[1] Operand 2
     /*  50960 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  50971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50979 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  50983 */     // MIs[2] Operand 1
     /*  50983 */     // No operand predicates
     /*  50983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50985 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  50985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  50992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50997 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51016 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51049 */     GIR_RootConstrainSelectedInstOperands,
     /*  51050 */     // GIR_Coverage, 3959,
     /*  51050 */     GIR_EraseRootFromParent_Done,
     /*  51051 */   // Label 799: @51051
     /*  51051 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51126), // Rule ID 3957 //
     /*  51056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51085 */     // MIs[2] Operand 1
     /*  51085 */     // No operand predicates
     /*  51085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51087 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51099 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51124 */     GIR_RootConstrainSelectedInstOperands,
     /*  51125 */     // GIR_Coverage, 3957,
     /*  51125 */     GIR_EraseRootFromParent_Done,
     /*  51126 */   // Label 800: @51126
     /*  51126 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51201), // Rule ID 3958 //
     /*  51131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51160 */     // MIs[2] Operand 1
     /*  51160 */     // No operand predicates
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51199 */     GIR_RootConstrainSelectedInstOperands,
     /*  51200 */     // GIR_Coverage, 3958,
     /*  51200 */     GIR_EraseRootFromParent_Done,
     /*  51201 */   // Label 801: @51201
     /*  51201 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51263), // Rule ID 3951 //
     /*  51206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51242 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51261 */     GIR_RootConstrainSelectedInstOperands,
     /*  51262 */     // GIR_Coverage, 3951,
     /*  51262 */     GIR_EraseRootFromParent_Done,
     /*  51263 */   // Label 802: @51263
     /*  51263 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51325), // Rule ID 3954 //
     /*  51268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51304 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51323 */     GIR_RootConstrainSelectedInstOperands,
     /*  51324 */     // GIR_Coverage, 3954,
     /*  51324 */     GIR_EraseRootFromParent_Done,
     /*  51325 */   // Label 803: @51325
     /*  51325 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51355), // Rule ID 3944 //
     /*  51330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51338 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  51341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51353 */     GIR_RootConstrainSelectedInstOperands,
     /*  51354 */     // GIR_Coverage, 3944,
     /*  51354 */     GIR_EraseRootFromParent_Done,
     /*  51355 */   // Label 804: @51355
     /*  51355 */   GIM_Reject,
     /*  51356 */ // Label 796: @51356
     /*  51356 */ GIM_Reject,
     /*  51357 */ // Label 785: @51357
     /*  51357 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51694),
     /*  51362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  51365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51372 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(51458), // Rule ID 13397 //
     /*  51377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51421 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51425 */     // MIs[3] Operand 1
     /*  51425 */     // No operand predicates
     /*  51425 */     // MIs[1] Operand 2
     /*  51425 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51442 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51456 */     GIR_RootConstrainSelectedInstOperands,
     /*  51457 */     // GIR_Coverage, 13397,
     /*  51457 */     GIR_EraseRootFromParent_Done,
     /*  51458 */   // Label 806: @51458
     /*  51458 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(51544), // Rule ID 2034 //
     /*  51463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51515 */     // MIs[3] Operand 1
     /*  51515 */     // No operand predicates
     /*  51515 */     // MIs[1] Operand 2
     /*  51515 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51528 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51542 */     GIR_RootConstrainSelectedInstOperands,
     /*  51543 */     // GIR_Coverage, 2034,
     /*  51543 */     GIR_EraseRootFromParent_Done,
     /*  51544 */   // Label 807: @51544
     /*  51544 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(51607), // Rule ID 13398 //
     /*  51549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51585 */     // MIs[2] Operand 1
     /*  51585 */     // No operand predicates
     /*  51585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51591 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51605 */     GIR_RootConstrainSelectedInstOperands,
     /*  51606 */     // GIR_Coverage, 13398,
     /*  51606 */     GIR_EraseRootFromParent_Done,
     /*  51607 */   // Label 808: @51607
     /*  51607 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(51670), // Rule ID 2035 //
     /*  51612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51648 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51652 */     // MIs[2] Operand 1
     /*  51652 */     // No operand predicates
     /*  51652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51654 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51668 */     GIR_RootConstrainSelectedInstOperands,
     /*  51669 */     // GIR_Coverage, 2035,
     /*  51669 */     GIR_EraseRootFromParent_Done,
     /*  51670 */   // Label 809: @51670
     /*  51670 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(51693), // Rule ID 1352 //
     /*  51675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51686 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  51686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  51691 */     GIR_RootConstrainSelectedInstOperands,
     /*  51692 */     // GIR_Coverage, 1352,
     /*  51692 */     GIR_Done,
     /*  51693 */   // Label 810: @51693
     /*  51693 */   GIM_Reject,
     /*  51694 */ // Label 805: @51694
     /*  51694 */ GIM_Reject,
     /*  51695 */ // Label 786: @51695
     /*  51695 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52032),
     /*  51700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  51703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51710 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(51796), // Rule ID 13394 //
     /*  51715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51759 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51763 */     // MIs[3] Operand 1
     /*  51763 */     // No operand predicates
     /*  51763 */     // MIs[1] Operand 2
     /*  51763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51780 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51794 */     GIR_RootConstrainSelectedInstOperands,
     /*  51795 */     // GIR_Coverage, 13394,
     /*  51795 */     GIR_EraseRootFromParent_Done,
     /*  51796 */   // Label 812: @51796
     /*  51796 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(51882), // Rule ID 2031 //
     /*  51801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51853 */     // MIs[3] Operand 1
     /*  51853 */     // No operand predicates
     /*  51853 */     // MIs[1] Operand 2
     /*  51853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51866 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51880 */     GIR_RootConstrainSelectedInstOperands,
     /*  51881 */     // GIR_Coverage, 2031,
     /*  51881 */     GIR_EraseRootFromParent_Done,
     /*  51882 */   // Label 813: @51882
     /*  51882 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(51945), // Rule ID 13395 //
     /*  51887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51923 */     // MIs[2] Operand 1
     /*  51923 */     // No operand predicates
     /*  51923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51929 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51943 */     GIR_RootConstrainSelectedInstOperands,
     /*  51944 */     // GIR_Coverage, 13395,
     /*  51944 */     GIR_EraseRootFromParent_Done,
     /*  51945 */   // Label 814: @51945
     /*  51945 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52008), // Rule ID 2032 //
     /*  51950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51990 */     // MIs[2] Operand 1
     /*  51990 */     // No operand predicates
     /*  51990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51992 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52006 */     GIR_RootConstrainSelectedInstOperands,
     /*  52007 */     // GIR_Coverage, 2032,
     /*  52007 */     GIR_EraseRootFromParent_Done,
     /*  52008 */   // Label 815: @52008
     /*  52008 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52031), // Rule ID 1350 //
     /*  52013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52024 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52029 */     GIR_RootConstrainSelectedInstOperands,
     /*  52030 */     // GIR_Coverage, 1350,
     /*  52030 */     GIR_Done,
     /*  52031 */   // Label 816: @52031
     /*  52031 */   GIM_Reject,
     /*  52032 */ // Label 811: @52032
     /*  52032 */ GIM_Reject,
     /*  52033 */ // Label 787: @52033
     /*  52033 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52198),
     /*  52038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52048 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52111), // Rule ID 13399 //
     /*  52053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52089 */     // MIs[2] Operand 1
     /*  52089 */     // No operand predicates
     /*  52089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52095 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52109 */     GIR_RootConstrainSelectedInstOperands,
     /*  52110 */     // GIR_Coverage, 13399,
     /*  52110 */     GIR_EraseRootFromParent_Done,
     /*  52111 */   // Label 818: @52111
     /*  52111 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52174), // Rule ID 2036 //
     /*  52116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52156 */     // MIs[2] Operand 1
     /*  52156 */     // No operand predicates
     /*  52156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52158 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52172 */     GIR_RootConstrainSelectedInstOperands,
     /*  52173 */     // GIR_Coverage, 2036,
     /*  52173 */     GIR_EraseRootFromParent_Done,
     /*  52174 */   // Label 819: @52174
     /*  52174 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52197), // Rule ID 1353 //
     /*  52179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52190 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52195 */     GIR_RootConstrainSelectedInstOperands,
     /*  52196 */     // GIR_Coverage, 1353,
     /*  52196 */     GIR_Done,
     /*  52197 */   // Label 820: @52197
     /*  52197 */   GIM_Reject,
     /*  52198 */ // Label 817: @52198
     /*  52198 */ GIM_Reject,
     /*  52199 */ // Label 788: @52199
     /*  52199 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52232), // Rule ID 1348 //
     /*  52204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52225 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52230 */   GIR_RootConstrainSelectedInstOperands,
     /*  52231 */   // GIR_Coverage, 1348,
     /*  52231 */   GIR_Done,
     /*  52232 */ // Label 821: @52232
     /*  52232 */ GIM_Reject,
     /*  52233 */ // Label 789: @52233
     /*  52233 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52398),
     /*  52238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52248 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52311), // Rule ID 13396 //
     /*  52253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52289 */     // MIs[2] Operand 1
     /*  52289 */     // No operand predicates
     /*  52289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52295 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52309 */     GIR_RootConstrainSelectedInstOperands,
     /*  52310 */     // GIR_Coverage, 13396,
     /*  52310 */     GIR_EraseRootFromParent_Done,
     /*  52311 */   // Label 823: @52311
     /*  52311 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52374), // Rule ID 2033 //
     /*  52316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52356 */     // MIs[2] Operand 1
     /*  52356 */     // No operand predicates
     /*  52356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52358 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52372 */     GIR_RootConstrainSelectedInstOperands,
     /*  52373 */     // GIR_Coverage, 2033,
     /*  52373 */     GIR_EraseRootFromParent_Done,
     /*  52374 */   // Label 824: @52374
     /*  52374 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(52397), // Rule ID 1351 //
     /*  52379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52390 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  52390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  52395 */     GIR_RootConstrainSelectedInstOperands,
     /*  52396 */     // GIR_Coverage, 1351,
     /*  52396 */     GIR_Done,
     /*  52397 */   // Label 825: @52397
     /*  52397 */   GIM_Reject,
     /*  52398 */ // Label 822: @52398
     /*  52398 */ GIM_Reject,
     /*  52399 */ // Label 790: @52399
     /*  52399 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(52432), // Rule ID 1349 //
     /*  52404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52425 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  52425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  52430 */   GIR_RootConstrainSelectedInstOperands,
     /*  52431 */   // GIR_Coverage, 1349,
     /*  52431 */   GIR_Done,
     /*  52432 */ // Label 826: @52432
     /*  52432 */ GIM_Reject,
     /*  52433 */ // Label 791: @52433
     /*  52433 */ GIM_Reject,
     /*  52434 */ // Label 3: @52434
     /*  52434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 829*/ GIMT_Encode4(52515),
     /*  52445 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(52453),
     /*  52449 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(52484),
     /*  52453 */ // Label 827: @52453
     /*  52453 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(52483), // Rule ID 117 //
     /*  52458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52476 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  52481 */   GIR_RootConstrainSelectedInstOperands,
     /*  52482 */   // GIR_Coverage, 117,
     /*  52482 */   GIR_Done,
     /*  52483 */ // Label 830: @52483
     /*  52483 */ GIM_Reject,
     /*  52484 */ // Label 828: @52484
     /*  52484 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(52514), // Rule ID 118 //
     /*  52489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52507 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  52512 */   GIR_RootConstrainSelectedInstOperands,
     /*  52513 */   // GIR_Coverage, 118,
     /*  52513 */   GIR_Done,
     /*  52514 */ // Label 831: @52514
     /*  52514 */ GIM_Reject,
     /*  52515 */ // Label 829: @52515
     /*  52515 */ GIM_Reject,
     /*  52516 */ // Label 4: @52516
     /*  52516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 834*/ GIMT_Encode4(52597),
     /*  52527 */ /*GILLT_s32*//*Label 832*/ GIMT_Encode4(52535),
     /*  52531 */ /*GILLT_s64*//*Label 833*/ GIMT_Encode4(52566),
     /*  52535 */ // Label 832: @52535
     /*  52535 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(52565), // Rule ID 115 //
     /*  52540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52558 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  52563 */   GIR_RootConstrainSelectedInstOperands,
     /*  52564 */   // GIR_Coverage, 115,
     /*  52564 */   GIR_Done,
     /*  52565 */ // Label 835: @52565
     /*  52565 */ GIM_Reject,
     /*  52566 */ // Label 833: @52566
     /*  52566 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(52596), // Rule ID 116 //
     /*  52571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52589 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  52594 */   GIR_RootConstrainSelectedInstOperands,
     /*  52595 */   // GIR_Coverage, 116,
     /*  52595 */   GIR_Done,
     /*  52596 */ // Label 836: @52596
     /*  52596 */ GIM_Reject,
     /*  52597 */ // Label 834: @52597
     /*  52597 */ GIM_Reject,
     /*  52598 */ // Label 5: @52598
     /*  52598 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 855*/ GIMT_Encode4(60343),
     /*  52609 */ /*GILLT_s32*//*Label 837*/ GIMT_Encode4(52697),
     /*  52613 */ /*GILLT_s64*//*Label 838*/ GIMT_Encode4(53195), GIMT_Encode4(0),
     /*  52621 */ /*GILLT_v2s32*//*Label 839*/ GIMT_Encode4(54630),
     /*  52625 */ /*GILLT_v2s64*//*Label 840*/ GIMT_Encode4(54790),
     /*  52629 */ /*GILLT_v4s16*//*Label 841*/ GIMT_Encode4(54950),
     /*  52633 */ /*GILLT_v4s32*//*Label 842*/ GIMT_Encode4(55110),
     /*  52637 */ /*GILLT_v8s8*//*Label 843*/ GIMT_Encode4(55270),
     /*  52641 */ /*GILLT_v8s16*//*Label 844*/ GIMT_Encode4(55430),
     /*  52645 */ /*GILLT_v16s8*//*Label 845*/ GIMT_Encode4(55590),
     /*  52649 */ /*GILLT_nxv1s1*//*Label 846*/ GIMT_Encode4(55750),
     /*  52653 */ /*GILLT_nxv2s1*//*Label 847*/ GIMT_Encode4(56291), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52665 */ /*GILLT_nxv2s64*//*Label 848*/ GIMT_Encode4(56832),
     /*  52669 */ /*GILLT_nxv4s1*//*Label 849*/ GIMT_Encode4(57304), GIMT_Encode4(0),
     /*  52677 */ /*GILLT_nxv4s32*//*Label 850*/ GIMT_Encode4(57845),
     /*  52681 */ /*GILLT_nxv8s1*//*Label 851*/ GIMT_Encode4(58317),
     /*  52685 */ /*GILLT_nxv8s16*//*Label 852*/ GIMT_Encode4(58858),
     /*  52689 */ /*GILLT_nxv16s1*//*Label 853*/ GIMT_Encode4(59330),
     /*  52693 */ /*GILLT_nxv16s8*//*Label 854*/ GIMT_Encode4(59871),
     /*  52697 */ // Label 837: @52697
     /*  52697 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53194),
     /*  52702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52708 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(52763), // Rule ID 13156 //
     /*  52713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52750 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52761 */     GIR_RootConstrainSelectedInstOperands,
     /*  52762 */     // GIR_Coverage, 13156,
     /*  52762 */     GIR_EraseRootFromParent_Done,
     /*  52763 */   // Label 857: @52763
     /*  52763 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(52818), // Rule ID 162 //
     /*  52768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52805 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52816 */     GIR_RootConstrainSelectedInstOperands,
     /*  52817 */     // GIR_Coverage, 162,
     /*  52817 */     GIR_EraseRootFromParent_Done,
     /*  52818 */   // Label 858: @52818
     /*  52818 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(52887), // Rule ID 5647 //
     /*  52823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  52860 */     // MIs[2] Operand 1
     /*  52860 */     // No operand predicates
     /*  52860 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  52871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52873 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  52873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  52876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52885 */     GIR_RootConstrainSelectedInstOperands,
     /*  52886 */     // GIR_Coverage, 5647,
     /*  52886 */     GIR_EraseRootFromParent_Done,
     /*  52887 */   // Label 859: @52887
     /*  52887 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(52956), // Rule ID 5648 //
     /*  52892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52929 */     // MIs[2] Operand 1
     /*  52929 */     // No operand predicates
     /*  52929 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  52940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52942 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  52942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  52945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52954 */     GIR_RootConstrainSelectedInstOperands,
     /*  52955 */     // GIR_Coverage, 5648,
     /*  52955 */     GIR_EraseRootFromParent_Done,
     /*  52956 */   // Label 860: @52956
     /*  52956 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53009), // Rule ID 13154 //
     /*  52961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52986 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52996 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  52999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53007 */     GIR_RootConstrainSelectedInstOperands,
     /*  53008 */     // GIR_Coverage, 13154,
     /*  53008 */     GIR_EraseRootFromParent_Done,
     /*  53009 */   // Label 861: @53009
     /*  53009 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53062), // Rule ID 160 //
     /*  53014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53049 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53060 */     GIR_RootConstrainSelectedInstOperands,
     /*  53061 */     // GIR_Coverage, 160,
     /*  53061 */     GIR_EraseRootFromParent_Done,
     /*  53062 */   // Label 862: @53062
     /*  53062 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53103), // Rule ID 142 //
     /*  53067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53087 */     // MIs[1] Operand 1
     /*  53087 */     // No operand predicates
     /*  53087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53089 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53101 */     GIR_RootConstrainSelectedInstOperands,
     /*  53102 */     // GIR_Coverage, 142,
     /*  53102 */     GIR_EraseRootFromParent_Done,
     /*  53103 */   // Label 863: @53103
     /*  53103 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53136), // Rule ID 13152 //
     /*  53108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53123 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53134 */     GIR_RootConstrainSelectedInstOperands,
     /*  53135 */     // GIR_Coverage, 13152,
     /*  53135 */     GIR_EraseRootFromParent_Done,
     /*  53136 */   // Label 864: @53136
     /*  53136 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53169), // Rule ID 158 //
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53156 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53167 */     GIR_RootConstrainSelectedInstOperands,
     /*  53168 */     // GIR_Coverage, 158,
     /*  53168 */     GIR_EraseRootFromParent_Done,
     /*  53169 */   // Label 865: @53169
     /*  53169 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53193), // Rule ID 156 //
     /*  53174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53186 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53191 */     GIR_RootConstrainSelectedInstOperands,
     /*  53192 */     // GIR_Coverage, 156,
     /*  53192 */     GIR_Done,
     /*  53193 */   // Label 866: @53193
     /*  53193 */   GIM_Reject,
     /*  53194 */ // Label 856: @53194
     /*  53194 */ GIM_Reject,
     /*  53195 */ // Label 838: @53195
     /*  53195 */ GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54629),
     /*  53200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53206 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53261), // Rule ID 13157 //
     /*  53211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53248 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53259 */     GIR_RootConstrainSelectedInstOperands,
     /*  53260 */     // GIR_Coverage, 13157,
     /*  53260 */     GIR_EraseRootFromParent_Done,
     /*  53261 */   // Label 868: @53261
     /*  53261 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53316), // Rule ID 163 //
     /*  53266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53303 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53310 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53314 */     GIR_RootConstrainSelectedInstOperands,
     /*  53315 */     // GIR_Coverage, 163,
     /*  53315 */     GIR_EraseRootFromParent_Done,
     /*  53316 */   // Label 869: @53316
     /*  53316 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(53429), // Rule ID 5649 //
     /*  53321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53366 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53370 */     // MIs[3] Operand 1
     /*  53370 */     // No operand predicates
     /*  53370 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53383 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  53383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53428 */     // GIR_Coverage, 5649,
     /*  53428 */     GIR_EraseRootFromParent_Done,
     /*  53429 */   // Label 870: @53429
     /*  53429 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53542), // Rule ID 5650 //
     /*  53434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53483 */     // MIs[3] Operand 1
     /*  53483 */     // No operand predicates
     /*  53483 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53496 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  53496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53541 */     // GIR_Coverage, 5650,
     /*  53541 */     GIR_EraseRootFromParent_Done,
     /*  53542 */   // Label 871: @53542
     /*  53542 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(53641), // Rule ID 7067 //
     /*  53547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53559 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53562 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53567 */     // MIs[1] addr
     /*  53567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53576 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53593 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  53600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53640 */     // GIR_Coverage, 7067,
     /*  53640 */     GIR_EraseRootFromParent_Done,
     /*  53641 */   // Label 872: @53641
     /*  53641 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(53740), // Rule ID 7068 //
     /*  53646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53666 */     // MIs[1] addr
     /*  53666 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53675 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  53679 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53692 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  53699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53739 */     // GIR_Coverage, 7068,
     /*  53739 */     GIR_EraseRootFromParent_Done,
     /*  53740 */   // Label 873: @53740
     /*  53740 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(53839), // Rule ID 7069 //
     /*  53745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53765 */     // MIs[1] addr
     /*  53765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53774 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  53778 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  53789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53791 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  53798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53807 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53838 */     // GIR_Coverage, 7069,
     /*  53838 */     GIR_EraseRootFromParent_Done,
     /*  53839 */   // Label 874: @53839
     /*  53839 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(53938), // Rule ID 7074 //
     /*  53844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53864 */     // MIs[1] addr
     /*  53864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53873 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  53877 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53890 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  53897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53906 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53937 */     // GIR_Coverage, 7074,
     /*  53937 */     GIR_EraseRootFromParent_Done,
     /*  53938 */   // Label 875: @53938
     /*  53938 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54037), // Rule ID 7075 //
     /*  53943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53963 */     // MIs[1] addr
     /*  53963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53972 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  53976 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53989 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  53996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54005 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54036 */     // GIR_Coverage, 7075,
     /*  54036 */     GIR_EraseRootFromParent_Done,
     /*  54037 */   // Label 876: @54037
     /*  54037 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54136), // Rule ID 7076 //
     /*  54042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54054 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54057 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54062 */     // MIs[1] addr
     /*  54062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54071 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54075 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54088 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54104 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54135 */     // GIR_Coverage, 7076,
     /*  54135 */     GIR_EraseRootFromParent_Done,
     /*  54136 */   // Label 877: @54136
     /*  54136 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54189), // Rule ID 13155 //
     /*  54141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54176 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54187 */     GIR_RootConstrainSelectedInstOperands,
     /*  54188 */     // GIR_Coverage, 13155,
     /*  54188 */     GIR_EraseRootFromParent_Done,
     /*  54189 */   // Label 878: @54189
     /*  54189 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54242), // Rule ID 161 //
     /*  54194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54229 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54240 */     GIR_RootConstrainSelectedInstOperands,
     /*  54241 */     // GIR_Coverage, 161,
     /*  54241 */     GIR_EraseRootFromParent_Done,
     /*  54242 */   // Label 879: @54242
     /*  54242 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54342), // Rule ID 3996 //
     /*  54247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54255 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54266 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54278 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  54301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54306 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54312 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54341 */     // GIR_Coverage, 3996,
     /*  54341 */     GIR_EraseRootFromParent_Done,
     /*  54342 */   // Label 880: @54342
     /*  54342 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54383), // Rule ID 143 //
     /*  54347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54363 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  54367 */     // MIs[1] Operand 1
     /*  54367 */     // No operand predicates
     /*  54367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54369 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  54369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  54372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54376 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  54381 */     GIR_RootConstrainSelectedInstOperands,
     /*  54382 */     // GIR_Coverage, 143,
     /*  54382 */     GIR_EraseRootFromParent_Done,
     /*  54383 */   // Label 881: @54383
     /*  54383 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54416), // Rule ID 13153 //
     /*  54388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54403 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54414 */     GIR_RootConstrainSelectedInstOperands,
     /*  54415 */     // GIR_Coverage, 13153,
     /*  54415 */     GIR_EraseRootFromParent_Done,
     /*  54416 */   // Label 882: @54416
     /*  54416 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(54449), // Rule ID 159 //
     /*  54421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54436 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54447 */     GIR_RootConstrainSelectedInstOperands,
     /*  54448 */     // GIR_Coverage, 159,
     /*  54448 */     GIR_EraseRootFromParent_Done,
     /*  54449 */   // Label 883: @54449
     /*  54449 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(54513), // Rule ID 13808 //
     /*  54454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54486 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54500 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54505 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54511 */     GIR_RootConstrainSelectedInstOperands,
     /*  54512 */     // GIR_Coverage, 13808,
     /*  54512 */     GIR_EraseRootFromParent_Done,
     /*  54513 */   // Label 884: @54513
     /*  54513 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(54577), // Rule ID 5031 //
     /*  54518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54554 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54564 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54569 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54575 */     GIR_RootConstrainSelectedInstOperands,
     /*  54576 */     // GIR_Coverage, 5031,
     /*  54576 */     GIR_EraseRootFromParent_Done,
     /*  54577 */   // Label 885: @54577
     /*  54577 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(54601), // Rule ID 157 //
     /*  54582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54594 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  54599 */     GIR_RootConstrainSelectedInstOperands,
     /*  54600 */     // GIR_Coverage, 157,
     /*  54600 */     GIR_Done,
     /*  54601 */   // Label 886: @54601
     /*  54601 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(54628), // Rule ID 2484 //
     /*  54606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54621 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54626 */     GIR_RootConstrainSelectedInstOperands,
     /*  54627 */     // GIR_Coverage, 2484,
     /*  54627 */     GIR_Done,
     /*  54628 */   // Label 887: @54628
     /*  54628 */   GIM_Reject,
     /*  54629 */ // Label 867: @54629
     /*  54629 */ GIM_Reject,
     /*  54630 */ // Label 839: @54630
     /*  54630 */ GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(54789),
     /*  54635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54645 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(54705), // Rule ID 13807 //
     /*  54650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54692 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54697 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54703 */     GIR_RootConstrainSelectedInstOperands,
     /*  54704 */     // GIR_Coverage, 13807,
     /*  54704 */     GIR_EraseRootFromParent_Done,
     /*  54705 */   // Label 889: @54705
     /*  54705 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(54765), // Rule ID 5030 //
     /*  54710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54742 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54752 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54757 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54763 */     GIR_RootConstrainSelectedInstOperands,
     /*  54764 */     // GIR_Coverage, 5030,
     /*  54764 */     GIR_EraseRootFromParent_Done,
     /*  54765 */   // Label 890: @54765
     /*  54765 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(54788), // Rule ID 2483 //
     /*  54770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54781 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54786 */     GIR_RootConstrainSelectedInstOperands,
     /*  54787 */     // GIR_Coverage, 2483,
     /*  54787 */     GIR_Done,
     /*  54788 */   // Label 891: @54788
     /*  54788 */   GIM_Reject,
     /*  54789 */ // Label 888: @54789
     /*  54789 */ GIM_Reject,
     /*  54790 */ // Label 840: @54790
     /*  54790 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(54949),
     /*  54795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54805 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(54865), // Rule ID 13811 //
     /*  54810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54838 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54852 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54857 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54863 */     GIR_RootConstrainSelectedInstOperands,
     /*  54864 */     // GIR_Coverage, 13811,
     /*  54864 */     GIR_EraseRootFromParent_Done,
     /*  54865 */   // Label 893: @54865
     /*  54865 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(54925), // Rule ID 5034 //
     /*  54870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54912 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54917 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54923 */     GIR_RootConstrainSelectedInstOperands,
     /*  54924 */     // GIR_Coverage, 5034,
     /*  54924 */     GIR_EraseRootFromParent_Done,
     /*  54925 */   // Label 894: @54925
     /*  54925 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(54948), // Rule ID 2487 //
     /*  54930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54941 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  54946 */     GIR_RootConstrainSelectedInstOperands,
     /*  54947 */     // GIR_Coverage, 2487,
     /*  54947 */     GIR_Done,
     /*  54948 */   // Label 895: @54948
     /*  54948 */   GIM_Reject,
     /*  54949 */ // Label 892: @54949
     /*  54949 */ GIM_Reject,
     /*  54950 */ // Label 841: @54950
     /*  54950 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55109),
     /*  54955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54965 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55025), // Rule ID 13806 //
     /*  54970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54998 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55012 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55017 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55023 */     GIR_RootConstrainSelectedInstOperands,
     /*  55024 */     // GIR_Coverage, 13806,
     /*  55024 */     GIR_EraseRootFromParent_Done,
     /*  55025 */   // Label 897: @55025
     /*  55025 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55085), // Rule ID 5029 //
     /*  55030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55062 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55072 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55077 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55083 */     GIR_RootConstrainSelectedInstOperands,
     /*  55084 */     // GIR_Coverage, 5029,
     /*  55084 */     GIR_EraseRootFromParent_Done,
     /*  55085 */   // Label 898: @55085
     /*  55085 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55108), // Rule ID 2482 //
     /*  55090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55101 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55106 */     GIR_RootConstrainSelectedInstOperands,
     /*  55107 */     // GIR_Coverage, 2482,
     /*  55107 */     GIR_Done,
     /*  55108 */   // Label 899: @55108
     /*  55108 */   GIM_Reject,
     /*  55109 */ // Label 896: @55109
     /*  55109 */ GIM_Reject,
     /*  55110 */ // Label 842: @55110
     /*  55110 */ GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55269),
     /*  55115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55125 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55185), // Rule ID 13810 //
     /*  55130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55172 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55177 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55183 */     GIR_RootConstrainSelectedInstOperands,
     /*  55184 */     // GIR_Coverage, 13810,
     /*  55184 */     GIR_EraseRootFromParent_Done,
     /*  55185 */   // Label 901: @55185
     /*  55185 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55245), // Rule ID 5033 //
     /*  55190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55222 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55232 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55237 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55243 */     GIR_RootConstrainSelectedInstOperands,
     /*  55244 */     // GIR_Coverage, 5033,
     /*  55244 */     GIR_EraseRootFromParent_Done,
     /*  55245 */   // Label 902: @55245
     /*  55245 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55268), // Rule ID 2486 //
     /*  55250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55261 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55266 */     GIR_RootConstrainSelectedInstOperands,
     /*  55267 */     // GIR_Coverage, 2486,
     /*  55267 */     GIR_Done,
     /*  55268 */   // Label 903: @55268
     /*  55268 */   GIM_Reject,
     /*  55269 */ // Label 900: @55269
     /*  55269 */ GIM_Reject,
     /*  55270 */ // Label 843: @55270
     /*  55270 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55429),
     /*  55275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55285 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55345), // Rule ID 13292 //
     /*  55290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55318 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55332 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55343 */     GIR_RootConstrainSelectedInstOperands,
     /*  55344 */     // GIR_Coverage, 13292,
     /*  55344 */     GIR_EraseRootFromParent_Done,
     /*  55345 */   // Label 905: @55345
     /*  55345 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55405), // Rule ID 1597 //
     /*  55350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55382 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55388 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55392 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55403 */     GIR_RootConstrainSelectedInstOperands,
     /*  55404 */     // GIR_Coverage, 1597,
     /*  55404 */     GIR_EraseRootFromParent_Done,
     /*  55405 */   // Label 906: @55405
     /*  55405 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(55428), // Rule ID 1595 //
     /*  55410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55421 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55426 */     GIR_RootConstrainSelectedInstOperands,
     /*  55427 */     // GIR_Coverage, 1595,
     /*  55427 */     GIR_Done,
     /*  55428 */   // Label 907: @55428
     /*  55428 */   GIM_Reject,
     /*  55429 */ // Label 904: @55429
     /*  55429 */ GIM_Reject,
     /*  55430 */ // Label 844: @55430
     /*  55430 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(55589),
     /*  55435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55445 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(55505), // Rule ID 13809 //
     /*  55450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55478 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55484 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55492 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55497 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55503 */     GIR_RootConstrainSelectedInstOperands,
     /*  55504 */     // GIR_Coverage, 13809,
     /*  55504 */     GIR_EraseRootFromParent_Done,
     /*  55505 */   // Label 909: @55505
     /*  55505 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(55565), // Rule ID 5032 //
     /*  55510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55542 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55552 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55557 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55563 */     GIR_RootConstrainSelectedInstOperands,
     /*  55564 */     // GIR_Coverage, 5032,
     /*  55564 */     GIR_EraseRootFromParent_Done,
     /*  55565 */   // Label 910: @55565
     /*  55565 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(55588), // Rule ID 2485 //
     /*  55570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55581 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55586 */     GIR_RootConstrainSelectedInstOperands,
     /*  55587 */     // GIR_Coverage, 2485,
     /*  55587 */     GIR_Done,
     /*  55588 */   // Label 911: @55588
     /*  55588 */   GIM_Reject,
     /*  55589 */ // Label 908: @55589
     /*  55589 */ GIM_Reject,
     /*  55590 */ // Label 845: @55590
     /*  55590 */ GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(55749),
     /*  55595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55605 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(55665), // Rule ID 13293 //
     /*  55610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55638 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55644 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55652 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55663 */     GIR_RootConstrainSelectedInstOperands,
     /*  55664 */     // GIR_Coverage, 13293,
     /*  55664 */     GIR_EraseRootFromParent_Done,
     /*  55665 */   // Label 913: @55665
     /*  55665 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(55725), // Rule ID 1598 //
     /*  55670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55702 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55712 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55723 */     GIR_RootConstrainSelectedInstOperands,
     /*  55724 */     // GIR_Coverage, 1598,
     /*  55724 */     GIR_EraseRootFromParent_Done,
     /*  55725 */   // Label 914: @55725
     /*  55725 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(55748), // Rule ID 1596 //
     /*  55730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55741 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55746 */     GIR_RootConstrainSelectedInstOperands,
     /*  55747 */     // GIR_Coverage, 1596,
     /*  55747 */     GIR_Done,
     /*  55748 */   // Label 915: @55748
     /*  55748 */   GIM_Reject,
     /*  55749 */ // Label 912: @55749
     /*  55749 */ GIM_Reject,
     /*  55750 */ // Label 846: @55750
     /*  55750 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56290),
     /*  55755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55765 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(55822), // Rule ID 15003 //
     /*  55770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55807 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55820 */     GIR_RootConstrainSelectedInstOperands,
     /*  55821 */     // GIR_Coverage, 15003,
     /*  55821 */     GIR_EraseRootFromParent_Done,
     /*  55822 */   // Label 917: @55822
     /*  55822 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(55879), // Rule ID 15006 //
     /*  55827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55858 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55864 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55877 */     GIR_RootConstrainSelectedInstOperands,
     /*  55878 */     // GIR_Coverage, 15006,
     /*  55878 */     GIR_EraseRootFromParent_Done,
     /*  55879 */   // Label 918: @55879
     /*  55879 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(55936), // Rule ID 15002 //
     /*  55884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55915 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55921 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55934 */     GIR_RootConstrainSelectedInstOperands,
     /*  55935 */     // GIR_Coverage, 15002,
     /*  55935 */     GIR_EraseRootFromParent_Done,
     /*  55936 */   // Label 919: @55936
     /*  55936 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(55993), // Rule ID 15005 //
     /*  55941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55978 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55991 */     GIR_RootConstrainSelectedInstOperands,
     /*  55992 */     // GIR_Coverage, 15005,
     /*  55992 */     GIR_EraseRootFromParent_Done,
     /*  55993 */   // Label 920: @55993
     /*  55993 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56050), // Rule ID 15001 //
     /*  55998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56029 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56035 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56048 */     GIR_RootConstrainSelectedInstOperands,
     /*  56049 */     // GIR_Coverage, 15001,
     /*  56049 */     GIR_EraseRootFromParent_Done,
     /*  56050 */   // Label 921: @56050
     /*  56050 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56107), // Rule ID 15004 //
     /*  56055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56092 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56105 */     GIR_RootConstrainSelectedInstOperands,
     /*  56106 */     // GIR_Coverage, 15004,
     /*  56106 */     GIR_EraseRootFromParent_Done,
     /*  56107 */   // Label 922: @56107
     /*  56107 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56164), // Rule ID 8376 //
     /*  56112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56143 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56149 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56162 */     GIR_RootConstrainSelectedInstOperands,
     /*  56163 */     // GIR_Coverage, 8376,
     /*  56163 */     GIR_EraseRootFromParent_Done,
     /*  56164 */   // Label 923: @56164
     /*  56164 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56221), // Rule ID 8377 //
     /*  56169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56200 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56206 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56219 */     GIR_RootConstrainSelectedInstOperands,
     /*  56220 */     // GIR_Coverage, 8377,
     /*  56220 */     GIR_EraseRootFromParent_Done,
     /*  56221 */   // Label 924: @56221
     /*  56221 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56268), // Rule ID 10628 //
     /*  56226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56237 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56266 */     GIR_RootConstrainSelectedInstOperands,
     /*  56267 */     // GIR_Coverage, 10628,
     /*  56267 */     GIR_EraseRootFromParent_Done,
     /*  56268 */   // Label 925: @56268
     /*  56268 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56289), // Rule ID 2753 //
     /*  56273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56276 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56287 */     GIR_RootConstrainSelectedInstOperands,
     /*  56288 */     // GIR_Coverage, 2753,
     /*  56288 */     GIR_EraseRootFromParent_Done,
     /*  56289 */   // Label 926: @56289
     /*  56289 */   GIM_Reject,
     /*  56290 */ // Label 916: @56290
     /*  56290 */ GIM_Reject,
     /*  56291 */ // Label 847: @56291
     /*  56291 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56831),
     /*  56296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56306 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56363), // Rule ID 14994 //
     /*  56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56348 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56361 */     GIR_RootConstrainSelectedInstOperands,
     /*  56362 */     // GIR_Coverage, 14994,
     /*  56362 */     GIR_EraseRootFromParent_Done,
     /*  56363 */   // Label 928: @56363
     /*  56363 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(56420), // Rule ID 14997 //
     /*  56368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56405 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56418 */     GIR_RootConstrainSelectedInstOperands,
     /*  56419 */     // GIR_Coverage, 14997,
     /*  56419 */     GIR_EraseRootFromParent_Done,
     /*  56420 */   // Label 929: @56420
     /*  56420 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(56477), // Rule ID 14993 //
     /*  56425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56462 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56475 */     GIR_RootConstrainSelectedInstOperands,
     /*  56476 */     // GIR_Coverage, 14993,
     /*  56476 */     GIR_EraseRootFromParent_Done,
     /*  56477 */   // Label 930: @56477
     /*  56477 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(56534), // Rule ID 14996 //
     /*  56482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56513 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56519 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56532 */     GIR_RootConstrainSelectedInstOperands,
     /*  56533 */     // GIR_Coverage, 14996,
     /*  56533 */     GIR_EraseRootFromParent_Done,
     /*  56534 */   // Label 931: @56534
     /*  56534 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(56591), // Rule ID 14992 //
     /*  56539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56570 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56576 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56589 */     GIR_RootConstrainSelectedInstOperands,
     /*  56590 */     // GIR_Coverage, 14992,
     /*  56590 */     GIR_EraseRootFromParent_Done,
     /*  56591 */   // Label 932: @56591
     /*  56591 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(56648), // Rule ID 14995 //
     /*  56596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56627 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56633 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56646 */     GIR_RootConstrainSelectedInstOperands,
     /*  56647 */     // GIR_Coverage, 14995,
     /*  56647 */     GIR_EraseRootFromParent_Done,
     /*  56648 */   // Label 933: @56648
     /*  56648 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(56705), // Rule ID 8372 //
     /*  56653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56690 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56703 */     GIR_RootConstrainSelectedInstOperands,
     /*  56704 */     // GIR_Coverage, 8372,
     /*  56704 */     GIR_EraseRootFromParent_Done,
     /*  56705 */   // Label 934: @56705
     /*  56705 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(56762), // Rule ID 8373 //
     /*  56710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56747 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56760 */     GIR_RootConstrainSelectedInstOperands,
     /*  56761 */     // GIR_Coverage, 8373,
     /*  56761 */     GIR_EraseRootFromParent_Done,
     /*  56762 */   // Label 935: @56762
     /*  56762 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(56809), // Rule ID 10627 //
     /*  56767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56778 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  56778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56807 */     GIR_RootConstrainSelectedInstOperands,
     /*  56808 */     // GIR_Coverage, 10627,
     /*  56808 */     GIR_EraseRootFromParent_Done,
     /*  56809 */   // Label 936: @56809
     /*  56809 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(56830), // Rule ID 2752 //
     /*  56814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56817 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56828 */     GIR_RootConstrainSelectedInstOperands,
     /*  56829 */     // GIR_Coverage, 2752,
     /*  56829 */     GIR_EraseRootFromParent_Done,
     /*  56830 */   // Label 937: @56830
     /*  56830 */   GIM_Reject,
     /*  56831 */ // Label 927: @56831
     /*  56831 */ GIM_Reject,
     /*  56832 */ // Label 848: @56832
     /*  56832 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57303),
     /*  56837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56847 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(56902), // Rule ID 14934 //
     /*  56852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56889 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56900 */     GIR_RootConstrainSelectedInstOperands,
     /*  56901 */     // GIR_Coverage, 14934,
     /*  56901 */     GIR_EraseRootFromParent_Done,
     /*  56902 */   // Label 939: @56902
     /*  56902 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(56957), // Rule ID 14937 //
     /*  56907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56944 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56955 */     GIR_RootConstrainSelectedInstOperands,
     /*  56956 */     // GIR_Coverage, 14937,
     /*  56956 */     GIR_EraseRootFromParent_Done,
     /*  56957 */   // Label 940: @56957
     /*  56957 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57012), // Rule ID 14933 //
     /*  56962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56993 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56999 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57010 */     GIR_RootConstrainSelectedInstOperands,
     /*  57011 */     // GIR_Coverage, 14933,
     /*  57011 */     GIR_EraseRootFromParent_Done,
     /*  57012 */   // Label 941: @57012
     /*  57012 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57067), // Rule ID 14936 //
     /*  57017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57048 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57054 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57065 */     GIR_RootConstrainSelectedInstOperands,
     /*  57066 */     // GIR_Coverage, 14936,
     /*  57066 */     GIR_EraseRootFromParent_Done,
     /*  57067 */   // Label 942: @57067
     /*  57067 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57122), // Rule ID 14932 //
     /*  57072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57103 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57109 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57120 */     GIR_RootConstrainSelectedInstOperands,
     /*  57121 */     // GIR_Coverage, 14932,
     /*  57121 */     GIR_EraseRootFromParent_Done,
     /*  57122 */   // Label 943: @57122
     /*  57122 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57177), // Rule ID 14935 //
     /*  57127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57164 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57175 */     GIR_RootConstrainSelectedInstOperands,
     /*  57176 */     // GIR_Coverage, 14935,
     /*  57176 */     GIR_EraseRootFromParent_Done,
     /*  57177 */   // Label 944: @57177
     /*  57177 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57232), // Rule ID 7425 //
     /*  57182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57213 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57219 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57230 */     GIR_RootConstrainSelectedInstOperands,
     /*  57231 */     // GIR_Coverage, 7425,
     /*  57231 */     GIR_EraseRootFromParent_Done,
     /*  57232 */   // Label 945: @57232
     /*  57232 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57287), // Rule ID 7426 //
     /*  57237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57274 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57285 */     GIR_RootConstrainSelectedInstOperands,
     /*  57286 */     // GIR_Coverage, 7426,
     /*  57286 */     GIR_EraseRootFromParent_Done,
     /*  57287 */   // Label 946: @57287
     /*  57287 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57302), // Rule ID 3146 //
     /*  57292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57295 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57300 */     GIR_RootConstrainSelectedInstOperands,
     /*  57301 */     // GIR_Coverage, 3146,
     /*  57301 */     GIR_Done,
     /*  57302 */   // Label 947: @57302
     /*  57302 */   GIM_Reject,
     /*  57303 */ // Label 938: @57303
     /*  57303 */ GIM_Reject,
     /*  57304 */ // Label 849: @57304
     /*  57304 */ GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57844),
     /*  57309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57319 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57376), // Rule ID 14985 //
     /*  57324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57355 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57361 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57374 */     GIR_RootConstrainSelectedInstOperands,
     /*  57375 */     // GIR_Coverage, 14985,
     /*  57375 */     GIR_EraseRootFromParent_Done,
     /*  57376 */   // Label 949: @57376
     /*  57376 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57433), // Rule ID 14988 //
     /*  57381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57412 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57418 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57431 */     GIR_RootConstrainSelectedInstOperands,
     /*  57432 */     // GIR_Coverage, 14988,
     /*  57432 */     GIR_EraseRootFromParent_Done,
     /*  57433 */   // Label 950: @57433
     /*  57433 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(57490), // Rule ID 14984 //
     /*  57438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57475 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57488 */     GIR_RootConstrainSelectedInstOperands,
     /*  57489 */     // GIR_Coverage, 14984,
     /*  57489 */     GIR_EraseRootFromParent_Done,
     /*  57490 */   // Label 951: @57490
     /*  57490 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(57547), // Rule ID 14987 //
     /*  57495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57526 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57532 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57545 */     GIR_RootConstrainSelectedInstOperands,
     /*  57546 */     // GIR_Coverage, 14987,
     /*  57546 */     GIR_EraseRootFromParent_Done,
     /*  57547 */   // Label 952: @57547
     /*  57547 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(57604), // Rule ID 14983 //
     /*  57552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57583 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57589 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57602 */     GIR_RootConstrainSelectedInstOperands,
     /*  57603 */     // GIR_Coverage, 14983,
     /*  57603 */     GIR_EraseRootFromParent_Done,
     /*  57604 */   // Label 953: @57604
     /*  57604 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(57661), // Rule ID 14986 //
     /*  57609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57640 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57646 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57659 */     GIR_RootConstrainSelectedInstOperands,
     /*  57660 */     // GIR_Coverage, 14986,
     /*  57660 */     GIR_EraseRootFromParent_Done,
     /*  57661 */   // Label 954: @57661
     /*  57661 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(57718), // Rule ID 8368 //
     /*  57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57703 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57716 */     GIR_RootConstrainSelectedInstOperands,
     /*  57717 */     // GIR_Coverage, 8368,
     /*  57717 */     GIR_EraseRootFromParent_Done,
     /*  57718 */   // Label 955: @57718
     /*  57718 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(57775), // Rule ID 8369 //
     /*  57723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57754 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57760 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57773 */     GIR_RootConstrainSelectedInstOperands,
     /*  57774 */     // GIR_Coverage, 8369,
     /*  57774 */     GIR_EraseRootFromParent_Done,
     /*  57775 */   // Label 956: @57775
     /*  57775 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(57822), // Rule ID 10626 //
     /*  57780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57791 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  57791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  57798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57820 */     GIR_RootConstrainSelectedInstOperands,
     /*  57821 */     // GIR_Coverage, 10626,
     /*  57821 */     GIR_EraseRootFromParent_Done,
     /*  57822 */   // Label 957: @57822
     /*  57822 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(57843), // Rule ID 2751 //
     /*  57827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57830 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57841 */     GIR_RootConstrainSelectedInstOperands,
     /*  57842 */     // GIR_Coverage, 2751,
     /*  57842 */     GIR_EraseRootFromParent_Done,
     /*  57843 */   // Label 958: @57843
     /*  57843 */   GIM_Reject,
     /*  57844 */ // Label 948: @57844
     /*  57844 */ GIM_Reject,
     /*  57845 */ // Label 850: @57845
     /*  57845 */ GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58316),
     /*  57850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57860 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(57915), // Rule ID 14925 //
     /*  57865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57896 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57902 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57913 */     GIR_RootConstrainSelectedInstOperands,
     /*  57914 */     // GIR_Coverage, 14925,
     /*  57914 */     GIR_EraseRootFromParent_Done,
     /*  57915 */   // Label 960: @57915
     /*  57915 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(57970), // Rule ID 14928 //
     /*  57920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57951 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57957 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57968 */     GIR_RootConstrainSelectedInstOperands,
     /*  57969 */     // GIR_Coverage, 14928,
     /*  57969 */     GIR_EraseRootFromParent_Done,
     /*  57970 */   // Label 961: @57970
     /*  57970 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58025), // Rule ID 14924 //
     /*  57975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58006 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58012 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58023 */     GIR_RootConstrainSelectedInstOperands,
     /*  58024 */     // GIR_Coverage, 14924,
     /*  58024 */     GIR_EraseRootFromParent_Done,
     /*  58025 */   // Label 962: @58025
     /*  58025 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58080), // Rule ID 14927 //
     /*  58030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58067 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58078 */     GIR_RootConstrainSelectedInstOperands,
     /*  58079 */     // GIR_Coverage, 14927,
     /*  58079 */     GIR_EraseRootFromParent_Done,
     /*  58080 */   // Label 963: @58080
     /*  58080 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58135), // Rule ID 14923 //
     /*  58085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58116 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58122 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58133 */     GIR_RootConstrainSelectedInstOperands,
     /*  58134 */     // GIR_Coverage, 14923,
     /*  58134 */     GIR_EraseRootFromParent_Done,
     /*  58135 */   // Label 964: @58135
     /*  58135 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58190), // Rule ID 14926 //
     /*  58140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58171 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58177 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58188 */     GIR_RootConstrainSelectedInstOperands,
     /*  58189 */     // GIR_Coverage, 14926,
     /*  58189 */     GIR_EraseRootFromParent_Done,
     /*  58190 */   // Label 965: @58190
     /*  58190 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58245), // Rule ID 7421 //
     /*  58195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58226 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58232 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58243 */     GIR_RootConstrainSelectedInstOperands,
     /*  58244 */     // GIR_Coverage, 7421,
     /*  58244 */     GIR_EraseRootFromParent_Done,
     /*  58245 */   // Label 966: @58245
     /*  58245 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58300), // Rule ID 7422 //
     /*  58250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58281 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58287 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58298 */     GIR_RootConstrainSelectedInstOperands,
     /*  58299 */     // GIR_Coverage, 7422,
     /*  58299 */     GIR_EraseRootFromParent_Done,
     /*  58300 */   // Label 967: @58300
     /*  58300 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58315), // Rule ID 3145 //
     /*  58305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58308 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58313 */     GIR_RootConstrainSelectedInstOperands,
     /*  58314 */     // GIR_Coverage, 3145,
     /*  58314 */     GIR_Done,
     /*  58315 */   // Label 968: @58315
     /*  58315 */   GIM_Reject,
     /*  58316 */ // Label 959: @58316
     /*  58316 */ GIM_Reject,
     /*  58317 */ // Label 851: @58317
     /*  58317 */ GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58857),
     /*  58322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58332 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(58389), // Rule ID 14976 //
     /*  58337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58368 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58374 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58387 */     GIR_RootConstrainSelectedInstOperands,
     /*  58388 */     // GIR_Coverage, 14976,
     /*  58388 */     GIR_EraseRootFromParent_Done,
     /*  58389 */   // Label 970: @58389
     /*  58389 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(58446), // Rule ID 14979 //
     /*  58394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58425 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58431 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58444 */     GIR_RootConstrainSelectedInstOperands,
     /*  58445 */     // GIR_Coverage, 14979,
     /*  58445 */     GIR_EraseRootFromParent_Done,
     /*  58446 */   // Label 971: @58446
     /*  58446 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(58503), // Rule ID 14975 //
     /*  58451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58488 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58501 */     GIR_RootConstrainSelectedInstOperands,
     /*  58502 */     // GIR_Coverage, 14975,
     /*  58502 */     GIR_EraseRootFromParent_Done,
     /*  58503 */   // Label 972: @58503
     /*  58503 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(58560), // Rule ID 14978 //
     /*  58508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58539 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58545 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58558 */     GIR_RootConstrainSelectedInstOperands,
     /*  58559 */     // GIR_Coverage, 14978,
     /*  58559 */     GIR_EraseRootFromParent_Done,
     /*  58560 */   // Label 973: @58560
     /*  58560 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(58617), // Rule ID 14974 //
     /*  58565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58602 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58615 */     GIR_RootConstrainSelectedInstOperands,
     /*  58616 */     // GIR_Coverage, 14974,
     /*  58616 */     GIR_EraseRootFromParent_Done,
     /*  58617 */   // Label 974: @58617
     /*  58617 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(58674), // Rule ID 14977 //
     /*  58622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58653 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58659 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58672 */     GIR_RootConstrainSelectedInstOperands,
     /*  58673 */     // GIR_Coverage, 14977,
     /*  58673 */     GIR_EraseRootFromParent_Done,
     /*  58674 */   // Label 975: @58674
     /*  58674 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(58731), // Rule ID 8364 //
     /*  58679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58710 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58716 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58729 */     GIR_RootConstrainSelectedInstOperands,
     /*  58730 */     // GIR_Coverage, 8364,
     /*  58730 */     GIR_EraseRootFromParent_Done,
     /*  58731 */   // Label 976: @58731
     /*  58731 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(58788), // Rule ID 8365 //
     /*  58736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58767 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58773 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58786 */     GIR_RootConstrainSelectedInstOperands,
     /*  58787 */     // GIR_Coverage, 8365,
     /*  58787 */     GIR_EraseRootFromParent_Done,
     /*  58788 */   // Label 977: @58788
     /*  58788 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(58835), // Rule ID 10625 //
     /*  58793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58804 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  58804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  58811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58833 */     GIR_RootConstrainSelectedInstOperands,
     /*  58834 */     // GIR_Coverage, 10625,
     /*  58834 */     GIR_EraseRootFromParent_Done,
     /*  58835 */   // Label 978: @58835
     /*  58835 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(58856), // Rule ID 2750 //
     /*  58840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58843 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58854 */     GIR_RootConstrainSelectedInstOperands,
     /*  58855 */     // GIR_Coverage, 2750,
     /*  58855 */     GIR_EraseRootFromParent_Done,
     /*  58856 */   // Label 979: @58856
     /*  58856 */   GIM_Reject,
     /*  58857 */ // Label 969: @58857
     /*  58857 */ GIM_Reject,
     /*  58858 */ // Label 852: @58858
     /*  58858 */ GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59329),
     /*  58863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58873 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(58928), // Rule ID 14916 //
     /*  58878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58909 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58915 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58926 */     GIR_RootConstrainSelectedInstOperands,
     /*  58927 */     // GIR_Coverage, 14916,
     /*  58927 */     GIR_EraseRootFromParent_Done,
     /*  58928 */   // Label 981: @58928
     /*  58928 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(58983), // Rule ID 14919 //
     /*  58933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58970 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58981 */     GIR_RootConstrainSelectedInstOperands,
     /*  58982 */     // GIR_Coverage, 14919,
     /*  58982 */     GIR_EraseRootFromParent_Done,
     /*  58983 */   // Label 982: @58983
     /*  58983 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59038), // Rule ID 14915 //
     /*  58988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59019 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59025 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59036 */     GIR_RootConstrainSelectedInstOperands,
     /*  59037 */     // GIR_Coverage, 14915,
     /*  59037 */     GIR_EraseRootFromParent_Done,
     /*  59038 */   // Label 983: @59038
     /*  59038 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59093), // Rule ID 14918 //
     /*  59043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59080 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59091 */     GIR_RootConstrainSelectedInstOperands,
     /*  59092 */     // GIR_Coverage, 14918,
     /*  59092 */     GIR_EraseRootFromParent_Done,
     /*  59093 */   // Label 984: @59093
     /*  59093 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59148), // Rule ID 14914 //
     /*  59098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59129 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59135 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59146 */     GIR_RootConstrainSelectedInstOperands,
     /*  59147 */     // GIR_Coverage, 14914,
     /*  59147 */     GIR_EraseRootFromParent_Done,
     /*  59148 */   // Label 985: @59148
     /*  59148 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59203), // Rule ID 14917 //
     /*  59153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59184 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59190 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59201 */     GIR_RootConstrainSelectedInstOperands,
     /*  59202 */     // GIR_Coverage, 14917,
     /*  59202 */     GIR_EraseRootFromParent_Done,
     /*  59203 */   // Label 986: @59203
     /*  59203 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59258), // Rule ID 7417 //
     /*  59208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59239 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59245 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59256 */     GIR_RootConstrainSelectedInstOperands,
     /*  59257 */     // GIR_Coverage, 7417,
     /*  59257 */     GIR_EraseRootFromParent_Done,
     /*  59258 */   // Label 987: @59258
     /*  59258 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59313), // Rule ID 7418 //
     /*  59263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59294 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59300 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59311 */     GIR_RootConstrainSelectedInstOperands,
     /*  59312 */     // GIR_Coverage, 7418,
     /*  59312 */     GIR_EraseRootFromParent_Done,
     /*  59313 */   // Label 988: @59313
     /*  59313 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59328), // Rule ID 3144 //
     /*  59318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59321 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59326 */     GIR_RootConstrainSelectedInstOperands,
     /*  59327 */     // GIR_Coverage, 3144,
     /*  59327 */     GIR_Done,
     /*  59328 */   // Label 989: @59328
     /*  59328 */   GIM_Reject,
     /*  59329 */ // Label 980: @59329
     /*  59329 */ GIM_Reject,
     /*  59330 */ // Label 853: @59330
     /*  59330 */ GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59870),
     /*  59335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59345 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(59402), // Rule ID 14967 //
     /*  59350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59381 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59387 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59400 */     GIR_RootConstrainSelectedInstOperands,
     /*  59401 */     // GIR_Coverage, 14967,
     /*  59401 */     GIR_EraseRootFromParent_Done,
     /*  59402 */   // Label 991: @59402
     /*  59402 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(59459), // Rule ID 14970 //
     /*  59407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59438 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59444 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59457 */     GIR_RootConstrainSelectedInstOperands,
     /*  59458 */     // GIR_Coverage, 14970,
     /*  59458 */     GIR_EraseRootFromParent_Done,
     /*  59459 */   // Label 992: @59459
     /*  59459 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(59516), // Rule ID 14966 //
     /*  59464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59501 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59514 */     GIR_RootConstrainSelectedInstOperands,
     /*  59515 */     // GIR_Coverage, 14966,
     /*  59515 */     GIR_EraseRootFromParent_Done,
     /*  59516 */   // Label 993: @59516
     /*  59516 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(59573), // Rule ID 14969 //
     /*  59521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59552 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59558 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59571 */     GIR_RootConstrainSelectedInstOperands,
     /*  59572 */     // GIR_Coverage, 14969,
     /*  59572 */     GIR_EraseRootFromParent_Done,
     /*  59573 */   // Label 994: @59573
     /*  59573 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(59630), // Rule ID 14965 //
     /*  59578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59609 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59615 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59628 */     GIR_RootConstrainSelectedInstOperands,
     /*  59629 */     // GIR_Coverage, 14965,
     /*  59629 */     GIR_EraseRootFromParent_Done,
     /*  59630 */   // Label 995: @59630
     /*  59630 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(59687), // Rule ID 14968 //
     /*  59635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59666 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59672 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59685 */     GIR_RootConstrainSelectedInstOperands,
     /*  59686 */     // GIR_Coverage, 14968,
     /*  59686 */     GIR_EraseRootFromParent_Done,
     /*  59687 */   // Label 996: @59687
     /*  59687 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59744), // Rule ID 8360 //
     /*  59692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59729 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59742 */     GIR_RootConstrainSelectedInstOperands,
     /*  59743 */     // GIR_Coverage, 8360,
     /*  59743 */     GIR_EraseRootFromParent_Done,
     /*  59744 */   // Label 997: @59744
     /*  59744 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(59801), // Rule ID 8361 //
     /*  59749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59780 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59786 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59799 */     GIR_RootConstrainSelectedInstOperands,
     /*  59800 */     // GIR_Coverage, 8361,
     /*  59800 */     GIR_EraseRootFromParent_Done,
     /*  59801 */   // Label 998: @59801
     /*  59801 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(59848), // Rule ID 10624 //
     /*  59806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59817 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  59817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  59824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59846 */     GIR_RootConstrainSelectedInstOperands,
     /*  59847 */     // GIR_Coverage, 10624,
     /*  59847 */     GIR_EraseRootFromParent_Done,
     /*  59848 */   // Label 999: @59848
     /*  59848 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(59869), // Rule ID 2749 //
     /*  59853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59856 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59867 */     GIR_RootConstrainSelectedInstOperands,
     /*  59868 */     // GIR_Coverage, 2749,
     /*  59868 */     GIR_EraseRootFromParent_Done,
     /*  59869 */   // Label 1000: @59869
     /*  59869 */   GIM_Reject,
     /*  59870 */ // Label 990: @59870
     /*  59870 */ GIM_Reject,
     /*  59871 */ // Label 854: @59871
     /*  59871 */ GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60342),
     /*  59876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59886 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(59941), // Rule ID 14907 //
     /*  59891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59922 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59928 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59939 */     GIR_RootConstrainSelectedInstOperands,
     /*  59940 */     // GIR_Coverage, 14907,
     /*  59940 */     GIR_EraseRootFromParent_Done,
     /*  59941 */   // Label 1002: @59941
     /*  59941 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(59996), // Rule ID 14910 //
     /*  59946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59983 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59994 */     GIR_RootConstrainSelectedInstOperands,
     /*  59995 */     // GIR_Coverage, 14910,
     /*  59995 */     GIR_EraseRootFromParent_Done,
     /*  59996 */   // Label 1003: @59996
     /*  59996 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60051), // Rule ID 14906 //
     /*  60001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60032 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60038 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60049 */     GIR_RootConstrainSelectedInstOperands,
     /*  60050 */     // GIR_Coverage, 14906,
     /*  60050 */     GIR_EraseRootFromParent_Done,
     /*  60051 */   // Label 1004: @60051
     /*  60051 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60106), // Rule ID 14909 //
     /*  60056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60087 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60093 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60104 */     GIR_RootConstrainSelectedInstOperands,
     /*  60105 */     // GIR_Coverage, 14909,
     /*  60105 */     GIR_EraseRootFromParent_Done,
     /*  60106 */   // Label 1005: @60106
     /*  60106 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60161), // Rule ID 14905 //
     /*  60111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60142 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60148 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60159 */     GIR_RootConstrainSelectedInstOperands,
     /*  60160 */     // GIR_Coverage, 14905,
     /*  60160 */     GIR_EraseRootFromParent_Done,
     /*  60161 */   // Label 1006: @60161
     /*  60161 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60216), // Rule ID 14908 //
     /*  60166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60197 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60203 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60214 */     GIR_RootConstrainSelectedInstOperands,
     /*  60215 */     // GIR_Coverage, 14908,
     /*  60215 */     GIR_EraseRootFromParent_Done,
     /*  60216 */   // Label 1007: @60216
     /*  60216 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60271), // Rule ID 7413 //
     /*  60221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60252 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60258 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60269 */     GIR_RootConstrainSelectedInstOperands,
     /*  60270 */     // GIR_Coverage, 7413,
     /*  60270 */     GIR_EraseRootFromParent_Done,
     /*  60271 */   // Label 1008: @60271
     /*  60271 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60326), // Rule ID 7414 //
     /*  60276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60307 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60313 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60324 */     GIR_RootConstrainSelectedInstOperands,
     /*  60325 */     // GIR_Coverage, 7414,
     /*  60325 */     GIR_EraseRootFromParent_Done,
     /*  60326 */   // Label 1009: @60326
     /*  60326 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60341), // Rule ID 3143 //
     /*  60331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60334 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60339 */     GIR_RootConstrainSelectedInstOperands,
     /*  60340 */     // GIR_Coverage, 3143,
     /*  60340 */     GIR_Done,
     /*  60341 */   // Label 1010: @60341
     /*  60341 */   GIM_Reject,
     /*  60342 */ // Label 1001: @60342
     /*  60342 */ GIM_Reject,
     /*  60343 */ // Label 855: @60343
     /*  60343 */ GIM_Reject,
     /*  60344 */ // Label 6: @60344
     /*  60344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1029*/ GIMT_Encode4(72122),
     /*  60355 */ /*GILLT_s32*//*Label 1011*/ GIMT_Encode4(60443),
     /*  60359 */ /*GILLT_s64*//*Label 1012*/ GIMT_Encode4(60803), GIMT_Encode4(0),
     /*  60367 */ /*GILLT_v2s32*//*Label 1013*/ GIMT_Encode4(62702),
     /*  60371 */ /*GILLT_v2s64*//*Label 1014*/ GIMT_Encode4(64010),
     /*  60375 */ /*GILLT_v4s16*//*Label 1015*/ GIMT_Encode4(65318),
     /*  60379 */ /*GILLT_v4s32*//*Label 1016*/ GIMT_Encode4(66626),
     /*  60383 */ /*GILLT_v8s8*//*Label 1017*/ GIMT_Encode4(67934),
     /*  60387 */ /*GILLT_v8s16*//*Label 1018*/ GIMT_Encode4(69242),
     /*  60391 */ /*GILLT_v16s8*//*Label 1019*/ GIMT_Encode4(70550),
     /*  60395 */ /*GILLT_nxv1s1*//*Label 1020*/ GIMT_Encode4(71858),
     /*  60399 */ /*GILLT_nxv2s1*//*Label 1021*/ GIMT_Encode4(71890), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  60411 */ /*GILLT_nxv2s64*//*Label 1022*/ GIMT_Encode4(71922),
     /*  60415 */ /*GILLT_nxv4s1*//*Label 1023*/ GIMT_Encode4(71948), GIMT_Encode4(0),
     /*  60423 */ /*GILLT_nxv4s32*//*Label 1024*/ GIMT_Encode4(71980),
     /*  60427 */ /*GILLT_nxv8s1*//*Label 1025*/ GIMT_Encode4(72006),
     /*  60431 */ /*GILLT_nxv8s16*//*Label 1026*/ GIMT_Encode4(72038),
     /*  60435 */ /*GILLT_nxv16s1*//*Label 1027*/ GIMT_Encode4(72064),
     /*  60439 */ /*GILLT_nxv16s8*//*Label 1028*/ GIMT_Encode4(72096),
     /*  60443 */ // Label 1011: @60443
     /*  60443 */ GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(60802),
     /*  60448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60454 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(60509), // Rule ID 13176 //
     /*  60459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60496 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60507 */     GIR_RootConstrainSelectedInstOperands,
     /*  60508 */     // GIR_Coverage, 13176,
     /*  60508 */     GIR_EraseRootFromParent_Done,
     /*  60509 */   // Label 1031: @60509
     /*  60509 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(60564), // Rule ID 174 //
     /*  60514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60551 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60562 */     GIR_RootConstrainSelectedInstOperands,
     /*  60563 */     // GIR_Coverage, 174,
     /*  60563 */     GIR_EraseRootFromParent_Done,
     /*  60564 */   // Label 1032: @60564
     /*  60564 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(60605), // Rule ID 146 //
     /*  60569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  60573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60585 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  60589 */     // MIs[1] Operand 1
     /*  60589 */     // No operand predicates
     /*  60589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60591 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  60591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  60594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60598 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  60603 */     GIR_RootConstrainSelectedInstOperands,
     /*  60604 */     // GIR_Coverage, 146,
     /*  60604 */     GIR_EraseRootFromParent_Done,
     /*  60605 */   // Label 1033: @60605
     /*  60605 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(60638), // Rule ID 13178 //
     /*  60610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60625 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60636 */     GIR_RootConstrainSelectedInstOperands,
     /*  60637 */     // GIR_Coverage, 13178,
     /*  60637 */     GIR_EraseRootFromParent_Done,
     /*  60638 */   // Label 1034: @60638
     /*  60638 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(60671), // Rule ID 178 //
     /*  60643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60658 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60669 */     GIR_RootConstrainSelectedInstOperands,
     /*  60670 */     // GIR_Coverage, 178,
     /*  60670 */     GIR_EraseRootFromParent_Done,
     /*  60671 */   // Label 1035: @60671
     /*  60671 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(60724), // Rule ID 13174 //
     /*  60676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60701 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60711 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60722 */     GIR_RootConstrainSelectedInstOperands,
     /*  60723 */     // GIR_Coverage, 13174,
     /*  60723 */     GIR_EraseRootFromParent_Done,
     /*  60724 */   // Label 1036: @60724
     /*  60724 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(60777), // Rule ID 172 //
     /*  60729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60758 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60764 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60775 */     GIR_RootConstrainSelectedInstOperands,
     /*  60776 */     // GIR_Coverage, 172,
     /*  60776 */     GIR_EraseRootFromParent_Done,
     /*  60777 */   // Label 1037: @60777
     /*  60777 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60801), // Rule ID 176 //
     /*  60782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60794 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  60799 */     GIR_RootConstrainSelectedInstOperands,
     /*  60800 */     // GIR_Coverage, 176,
     /*  60800 */     GIR_Done,
     /*  60801 */   // Label 1038: @60801
     /*  60801 */   GIM_Reject,
     /*  60802 */ // Label 1030: @60802
     /*  60802 */ GIM_Reject,
     /*  60803 */ // Label 1012: @60803
     /*  60803 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(62701),
     /*  60808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60814 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60936), // Rule ID 4009 //
     /*  60819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  60847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60860 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60864 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  60875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  60879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60883 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  60887 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  60891 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  60895 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60899 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  60903 */     // MIs[4] Rn
     /*  60903 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60908 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  60912 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  60923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60925 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  60925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 4009,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1040: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61058), // Rule ID 13726 //
     /*  60941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60982 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60986 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  60997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61005 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61009 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61013 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61017 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61021 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61025 */     // MIs[4] Rn
     /*  61025 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61030 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61034 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61047 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61056 */     GIR_RootConstrainSelectedInstOperands,
     /*  61057 */     // GIR_Coverage, 13726,
     /*  61057 */     GIR_EraseRootFromParent_Done,
     /*  61058 */   // Label 1041: @61058
     /*  61058 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61113), // Rule ID 13177 //
     /*  61063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61100 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61111 */     GIR_RootConstrainSelectedInstOperands,
     /*  61112 */     // GIR_Coverage, 13177,
     /*  61112 */     GIR_EraseRootFromParent_Done,
     /*  61113 */   // Label 1042: @61113
     /*  61113 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61168), // Rule ID 175 //
     /*  61118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61155 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61166 */     GIR_RootConstrainSelectedInstOperands,
     /*  61167 */     // GIR_Coverage, 175,
     /*  61167 */     GIR_EraseRootFromParent_Done,
     /*  61168 */   // Label 1043: @61168
     /*  61168 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61277), // Rule ID 13526 //
     /*  61173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61246 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61251 */     // MIs[4] LHS
     /*  61251 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61256 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61258 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61275 */     GIR_RootConstrainSelectedInstOperands,
     /*  61276 */     // GIR_Coverage, 13526,
     /*  61276 */     GIR_EraseRootFromParent_Done,
     /*  61277 */   // Label 1044: @61277
     /*  61277 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61386), // Rule ID 13525 //
     /*  61282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61330 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61355 */     // MIs[4] LHS
     /*  61355 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61360 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61367 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61384 */     GIR_RootConstrainSelectedInstOperands,
     /*  61385 */     // GIR_Coverage, 13525,
     /*  61385 */     GIR_EraseRootFromParent_Done,
     /*  61386 */   // Label 1045: @61386
     /*  61386 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61495), // Rule ID 13528 //
     /*  61391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61444 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61456 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61460 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61464 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61469 */     // MIs[4] LHS
     /*  61469 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61474 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61476 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61493 */     GIR_RootConstrainSelectedInstOperands,
     /*  61494 */     // GIR_Coverage, 13528,
     /*  61494 */     GIR_EraseRootFromParent_Done,
     /*  61495 */   // Label 1046: @61495
     /*  61495 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61604), // Rule ID 13527 //
     /*  61500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61573 */     // MIs[4] LHS
     /*  61573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61578 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61585 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61602 */     GIR_RootConstrainSelectedInstOperands,
     /*  61603 */     // GIR_Coverage, 13527,
     /*  61603 */     GIR_EraseRootFromParent_Done,
     /*  61604 */   // Label 1047: @61604
     /*  61604 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(61713), // Rule ID 2471 //
     /*  61609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61666 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61670 */     // MIs[3] LHS
     /*  61670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61692 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61694 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61711 */     GIR_RootConstrainSelectedInstOperands,
     /*  61712 */     // GIR_Coverage, 2471,
     /*  61712 */     GIR_EraseRootFromParent_Done,
     /*  61713 */   // Label 1048: @61713
     /*  61713 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(61822), // Rule ID 13523 //
     /*  61718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61779 */     // MIs[3] LHS
     /*  61779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61788 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61794 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61801 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61803 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61820 */     GIR_RootConstrainSelectedInstOperands,
     /*  61821 */     // GIR_Coverage, 13523,
     /*  61821 */     GIR_EraseRootFromParent_Done,
     /*  61822 */   // Label 1049: @61822
     /*  61822 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(61931), // Rule ID 13522 //
     /*  61827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61889 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61893 */     // MIs[3] LHS
     /*  61893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61902 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61910 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61912 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61929 */     GIR_RootConstrainSelectedInstOperands,
     /*  61930 */     // GIR_Coverage, 13522,
     /*  61930 */     GIR_EraseRootFromParent_Done,
     /*  61931 */   // Label 1050: @61931
     /*  61931 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62040), // Rule ID 13524 //
     /*  61936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62002 */     // MIs[3] LHS
     /*  62002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62011 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62017 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62019 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62021 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62038 */     GIR_RootConstrainSelectedInstOperands,
     /*  62039 */     // GIR_Coverage, 13524,
     /*  62039 */     GIR_EraseRootFromParent_Done,
     /*  62040 */   // Label 1051: @62040
     /*  62040 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62081), // Rule ID 147 //
     /*  62045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62061 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62065 */     // MIs[1] Operand 1
     /*  62065 */     // No operand predicates
     /*  62065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62067 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62074 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62079 */     GIR_RootConstrainSelectedInstOperands,
     /*  62080 */     // GIR_Coverage, 147,
     /*  62080 */     GIR_EraseRootFromParent_Done,
     /*  62081 */   // Label 1052: @62081
     /*  62081 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62114), // Rule ID 13179 //
     /*  62086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62101 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62112 */     GIR_RootConstrainSelectedInstOperands,
     /*  62113 */     // GIR_Coverage, 13179,
     /*  62113 */     GIR_EraseRootFromParent_Done,
     /*  62114 */   // Label 1053: @62114
     /*  62114 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62147), // Rule ID 179 //
     /*  62119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62134 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62145 */     GIR_RootConstrainSelectedInstOperands,
     /*  62146 */     // GIR_Coverage, 179,
     /*  62146 */     GIR_EraseRootFromParent_Done,
     /*  62147 */   // Label 1054: @62147
     /*  62147 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62214), // Rule ID 13462 //
     /*  62152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62176 */     // MIs[1] imm
     /*  62176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62184 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62188 */     // MIs[2] Operand 1
     /*  62188 */     // No operand predicates
     /*  62188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62198 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62212 */     GIR_RootConstrainSelectedInstOperands,
     /*  62213 */     // GIR_Coverage, 13462,
     /*  62213 */     GIR_EraseRootFromParent_Done,
     /*  62214 */   // Label 1055: @62214
     /*  62214 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62281), // Rule ID 13465 //
     /*  62219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62243 */     // MIs[1] imm
     /*  62243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62251 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62255 */     // MIs[2] Operand 1
     /*  62255 */     // No operand predicates
     /*  62255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62265 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62279 */     GIR_RootConstrainSelectedInstOperands,
     /*  62280 */     // GIR_Coverage, 13465,
     /*  62280 */     GIR_EraseRootFromParent_Done,
     /*  62281 */   // Label 1056: @62281
     /*  62281 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62334), // Rule ID 13175 //
     /*  62286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62321 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62332 */     GIR_RootConstrainSelectedInstOperands,
     /*  62333 */     // GIR_Coverage, 13175,
     /*  62333 */     GIR_EraseRootFromParent_Done,
     /*  62334 */   // Label 1057: @62334
     /*  62334 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62401), // Rule ID 2122 //
     /*  62339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62367 */     // MIs[1] imm
     /*  62367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62375 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62379 */     // MIs[2] Operand 1
     /*  62379 */     // No operand predicates
     /*  62379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62385 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62399 */     GIR_RootConstrainSelectedInstOperands,
     /*  62400 */     // GIR_Coverage, 2122,
     /*  62400 */     GIR_EraseRootFromParent_Done,
     /*  62401 */   // Label 1058: @62401
     /*  62401 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62468), // Rule ID 2131 //
     /*  62406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62434 */     // MIs[1] imm
     /*  62434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62446 */     // MIs[2] Operand 1
     /*  62446 */     // No operand predicates
     /*  62446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62452 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62466 */     GIR_RootConstrainSelectedInstOperands,
     /*  62467 */     // GIR_Coverage, 2131,
     /*  62467 */     GIR_EraseRootFromParent_Done,
     /*  62468 */   // Label 1059: @62468
     /*  62468 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(62521), // Rule ID 173 //
     /*  62473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62508 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62519 */     GIR_RootConstrainSelectedInstOperands,
     /*  62520 */     // GIR_Coverage, 173,
     /*  62520 */     GIR_EraseRootFromParent_Done,
     /*  62521 */   // Label 1060: @62521
     /*  62521 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(62585), // Rule ID 13814 //
     /*  62526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62572 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62583 */     GIR_RootConstrainSelectedInstOperands,
     /*  62584 */     // GIR_Coverage, 13814,
     /*  62584 */     GIR_EraseRootFromParent_Done,
     /*  62585 */   // Label 1061: @62585
     /*  62585 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62649), // Rule ID 5043 //
     /*  62590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62626 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62636 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62641 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62647 */     GIR_RootConstrainSelectedInstOperands,
     /*  62648 */     // GIR_Coverage, 5043,
     /*  62648 */     GIR_EraseRootFromParent_Done,
     /*  62649 */   // Label 1062: @62649
     /*  62649 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(62673), // Rule ID 177 //
     /*  62654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62666 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  62671 */     GIR_RootConstrainSelectedInstOperands,
     /*  62672 */     // GIR_Coverage, 177,
     /*  62672 */     GIR_Done,
     /*  62673 */   // Label 1063: @62673
     /*  62673 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(62700), // Rule ID 5049 //
     /*  62678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62693 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  62698 */     GIR_RootConstrainSelectedInstOperands,
     /*  62699 */     // GIR_Coverage, 5049,
     /*  62699 */     GIR_Done,
     /*  62700 */   // Label 1064: @62700
     /*  62700 */   GIM_Reject,
     /*  62701 */ // Label 1039: @62701
     /*  62701 */ GIM_Reject,
     /*  62702 */ // Label 1013: @62702
     /*  62702 */ GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(64009),
     /*  62707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62713 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62822), // Rule ID 13519 //
     /*  62718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62766 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62787 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62791 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62796 */     // MIs[4] LHS
     /*  62796 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62801 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62803 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62820 */     GIR_RootConstrainSelectedInstOperands,
     /*  62821 */     // GIR_Coverage, 13519,
     /*  62821 */     GIR_EraseRootFromParent_Done,
     /*  62822 */   // Label 1066: @62822
     /*  62822 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62931), // Rule ID 13518 //
     /*  62827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62881 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62896 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62900 */     // MIs[4] LHS
     /*  62900 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62905 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62910 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62912 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62929 */     GIR_RootConstrainSelectedInstOperands,
     /*  62930 */     // GIR_Coverage, 13518,
     /*  62930 */     GIR_EraseRootFromParent_Done,
     /*  62931 */   // Label 1067: @62931
     /*  62931 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63040), // Rule ID 13521 //
     /*  62936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62989 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62995 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62997 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63001 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63005 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63009 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63014 */     // MIs[4] LHS
     /*  63014 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63019 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63021 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63038 */     GIR_RootConstrainSelectedInstOperands,
     /*  63039 */     // GIR_Coverage, 13521,
     /*  63039 */     GIR_EraseRootFromParent_Done,
     /*  63040 */   // Label 1068: @63040
     /*  63040 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63149), // Rule ID 13520 //
     /*  63045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63098 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63104 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63110 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63114 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63118 */     // MIs[4] LHS
     /*  63118 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63123 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63128 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63130 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63147 */     GIR_RootConstrainSelectedInstOperands,
     /*  63148 */     // GIR_Coverage, 13520,
     /*  63148 */     GIR_EraseRootFromParent_Done,
     /*  63149 */   // Label 1069: @63149
     /*  63149 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63258), // Rule ID 2470 //
     /*  63154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63211 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63215 */     // MIs[3] LHS
     /*  63215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63224 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63230 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63237 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63239 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63256 */     GIR_RootConstrainSelectedInstOperands,
     /*  63257 */     // GIR_Coverage, 2470,
     /*  63257 */     GIR_EraseRootFromParent_Done,
     /*  63258 */   // Label 1070: @63258
     /*  63258 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63367), // Rule ID 13516 //
     /*  63263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63324 */     // MIs[3] LHS
     /*  63324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63333 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63346 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63348 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63365 */     GIR_RootConstrainSelectedInstOperands,
     /*  63366 */     // GIR_Coverage, 13516,
     /*  63366 */     GIR_EraseRootFromParent_Done,
     /*  63367 */   // Label 1071: @63367
     /*  63367 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63476), // Rule ID 13515 //
     /*  63372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63438 */     // MIs[3] LHS
     /*  63438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63447 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63457 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63474 */     GIR_RootConstrainSelectedInstOperands,
     /*  63475 */     // GIR_Coverage, 13515,
     /*  63475 */     GIR_EraseRootFromParent_Done,
     /*  63476 */   // Label 1072: @63476
     /*  63476 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63585), // Rule ID 13517 //
     /*  63481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63543 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63547 */     // MIs[3] LHS
     /*  63547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63556 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63564 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63566 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63583 */     GIR_RootConstrainSelectedInstOperands,
     /*  63584 */     // GIR_Coverage, 13517,
     /*  63584 */     GIR_EraseRootFromParent_Done,
     /*  63585 */   // Label 1073: @63585
     /*  63585 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(63652), // Rule ID 13482 //
     /*  63590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63614 */     // MIs[1] imm
     /*  63614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63626 */     // MIs[2] Operand 1
     /*  63626 */     // No operand predicates
     /*  63626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63636 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63650 */     GIR_RootConstrainSelectedInstOperands,
     /*  63651 */     // GIR_Coverage, 13482,
     /*  63651 */     GIR_EraseRootFromParent_Done,
     /*  63652 */   // Label 1074: @63652
     /*  63652 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(63719), // Rule ID 13503 //
     /*  63657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63681 */     // MIs[1] imm
     /*  63681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63693 */     // MIs[2] Operand 1
     /*  63693 */     // No operand predicates
     /*  63693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63703 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63717 */     GIR_RootConstrainSelectedInstOperands,
     /*  63718 */     // GIR_Coverage, 13503,
     /*  63718 */     GIR_EraseRootFromParent_Done,
     /*  63719 */   // Label 1075: @63719
     /*  63719 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(63786), // Rule ID 2239 //
     /*  63724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63752 */     // MIs[1] imm
     /*  63752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63760 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63764 */     // MIs[2] Operand 1
     /*  63764 */     // No operand predicates
     /*  63764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63770 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63784 */     GIR_RootConstrainSelectedInstOperands,
     /*  63785 */     // GIR_Coverage, 2239,
     /*  63785 */     GIR_EraseRootFromParent_Done,
     /*  63786 */   // Label 1076: @63786
     /*  63786 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(63853), // Rule ID 2298 //
     /*  63791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63819 */     // MIs[1] imm
     /*  63819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63831 */     // MIs[2] Operand 1
     /*  63831 */     // No operand predicates
     /*  63831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63837 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63851 */     GIR_RootConstrainSelectedInstOperands,
     /*  63852 */     // GIR_Coverage, 2298,
     /*  63852 */     GIR_EraseRootFromParent_Done,
     /*  63853 */   // Label 1077: @63853
     /*  63853 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(63917), // Rule ID 13813 //
     /*  63858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63890 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63904 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63909 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63915 */     GIR_RootConstrainSelectedInstOperands,
     /*  63916 */     // GIR_Coverage, 13813,
     /*  63916 */     GIR_EraseRootFromParent_Done,
     /*  63917 */   // Label 1078: @63917
     /*  63917 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63981), // Rule ID 5042 //
     /*  63922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63958 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63968 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63973 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63979 */     GIR_RootConstrainSelectedInstOperands,
     /*  63980 */     // GIR_Coverage, 5042,
     /*  63980 */     GIR_EraseRootFromParent_Done,
     /*  63981 */   // Label 1079: @63981
     /*  63981 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64008), // Rule ID 5048 //
     /*  63986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64001 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64006 */     GIR_RootConstrainSelectedInstOperands,
     /*  64007 */     // GIR_Coverage, 5048,
     /*  64007 */     GIR_Done,
     /*  64008 */   // Label 1080: @64008
     /*  64008 */   GIM_Reject,
     /*  64009 */ // Label 1065: @64009
     /*  64009 */ GIM_Reject,
     /*  64010 */ // Label 1014: @64010
     /*  64010 */ GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(65317),
     /*  64015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64021 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64130), // Rule ID 13547 //
     /*  64026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64074 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64080 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64091 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64095 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64099 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64104 */     // MIs[4] LHS
     /*  64104 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64109 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64111 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64128 */     GIR_RootConstrainSelectedInstOperands,
     /*  64129 */     // GIR_Coverage, 13547,
     /*  64129 */     GIR_EraseRootFromParent_Done,
     /*  64130 */   // Label 1082: @64130
     /*  64130 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64239), // Rule ID 13546 //
     /*  64135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64183 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64200 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64204 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64208 */     // MIs[4] LHS
     /*  64208 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64213 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64218 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64220 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64237 */     GIR_RootConstrainSelectedInstOperands,
     /*  64238 */     // GIR_Coverage, 13546,
     /*  64238 */     GIR_EraseRootFromParent_Done,
     /*  64239 */   // Label 1083: @64239
     /*  64239 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64348), // Rule ID 13549 //
     /*  64244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64297 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64313 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64317 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64322 */     // MIs[4] LHS
     /*  64322 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64327 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64329 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64346 */     GIR_RootConstrainSelectedInstOperands,
     /*  64347 */     // GIR_Coverage, 13549,
     /*  64347 */     GIR_EraseRootFromParent_Done,
     /*  64348 */   // Label 1084: @64348
     /*  64348 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64457), // Rule ID 13548 //
     /*  64353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64406 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64422 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64426 */     // MIs[4] LHS
     /*  64426 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64431 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64436 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64438 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64455 */     GIR_RootConstrainSelectedInstOperands,
     /*  64456 */     // GIR_Coverage, 13548,
     /*  64456 */     GIR_EraseRootFromParent_Done,
     /*  64457 */   // Label 1085: @64457
     /*  64457 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64566), // Rule ID 2474 //
     /*  64462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64519 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64523 */     // MIs[3] LHS
     /*  64523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64532 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64538 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64545 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64547 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64564 */     GIR_RootConstrainSelectedInstOperands,
     /*  64565 */     // GIR_Coverage, 2474,
     /*  64565 */     GIR_EraseRootFromParent_Done,
     /*  64566 */   // Label 1086: @64566
     /*  64566 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(64675), // Rule ID 13544 //
     /*  64571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64628 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64632 */     // MIs[3] LHS
     /*  64632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64637 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64641 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64654 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64656 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64673 */     GIR_RootConstrainSelectedInstOperands,
     /*  64674 */     // GIR_Coverage, 13544,
     /*  64674 */     GIR_EraseRootFromParent_Done,
     /*  64675 */   // Label 1087: @64675
     /*  64675 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64784), // Rule ID 13543 //
     /*  64680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64746 */     // MIs[3] LHS
     /*  64746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64755 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64763 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64765 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64782 */     GIR_RootConstrainSelectedInstOperands,
     /*  64783 */     // GIR_Coverage, 13543,
     /*  64783 */     GIR_EraseRootFromParent_Done,
     /*  64784 */   // Label 1088: @64784
     /*  64784 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64893), // Rule ID 13545 //
     /*  64789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64851 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64855 */     // MIs[3] LHS
     /*  64855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64864 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64870 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64872 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64874 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64891 */     GIR_RootConstrainSelectedInstOperands,
     /*  64892 */     // GIR_Coverage, 13545,
     /*  64892 */     GIR_EraseRootFromParent_Done,
     /*  64893 */   // Label 1089: @64893
     /*  64893 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64960), // Rule ID 13486 //
     /*  64898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64922 */     // MIs[1] imm
     /*  64922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64934 */     // MIs[2] Operand 1
     /*  64934 */     // No operand predicates
     /*  64934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64944 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  64947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64958 */     GIR_RootConstrainSelectedInstOperands,
     /*  64959 */     // GIR_Coverage, 13486,
     /*  64959 */     GIR_EraseRootFromParent_Done,
     /*  64960 */   // Label 1090: @64960
     /*  64960 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65027), // Rule ID 13507 //
     /*  64965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64989 */     // MIs[1] imm
     /*  64989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65001 */     // MIs[2] Operand 1
     /*  65001 */     // No operand predicates
     /*  65001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65011 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65025 */     GIR_RootConstrainSelectedInstOperands,
     /*  65026 */     // GIR_Coverage, 13507,
     /*  65026 */     GIR_EraseRootFromParent_Done,
     /*  65027 */   // Label 1091: @65027
     /*  65027 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65094), // Rule ID 2243 //
     /*  65032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65060 */     // MIs[1] imm
     /*  65060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65072 */     // MIs[2] Operand 1
     /*  65072 */     // No operand predicates
     /*  65072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65078 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65092 */     GIR_RootConstrainSelectedInstOperands,
     /*  65093 */     // GIR_Coverage, 2243,
     /*  65093 */     GIR_EraseRootFromParent_Done,
     /*  65094 */   // Label 1092: @65094
     /*  65094 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65161), // Rule ID 2302 //
     /*  65099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65127 */     // MIs[1] imm
     /*  65127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65139 */     // MIs[2] Operand 1
     /*  65139 */     // No operand predicates
     /*  65139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65145 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65159 */     GIR_RootConstrainSelectedInstOperands,
     /*  65160 */     // GIR_Coverage, 2302,
     /*  65160 */     GIR_EraseRootFromParent_Done,
     /*  65161 */   // Label 1093: @65161
     /*  65161 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65225), // Rule ID 13817 //
     /*  65166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65212 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65223 */     GIR_RootConstrainSelectedInstOperands,
     /*  65224 */     // GIR_Coverage, 13817,
     /*  65224 */     GIR_EraseRootFromParent_Done,
     /*  65225 */   // Label 1094: @65225
     /*  65225 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65289), // Rule ID 5046 //
     /*  65230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65266 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65276 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65281 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65287 */     GIR_RootConstrainSelectedInstOperands,
     /*  65288 */     // GIR_Coverage, 5046,
     /*  65288 */     GIR_EraseRootFromParent_Done,
     /*  65289 */   // Label 1095: @65289
     /*  65289 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65316), // Rule ID 5052 //
     /*  65294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65309 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65314 */     GIR_RootConstrainSelectedInstOperands,
     /*  65315 */     // GIR_Coverage, 5052,
     /*  65315 */     GIR_Done,
     /*  65316 */   // Label 1096: @65316
     /*  65316 */   GIM_Reject,
     /*  65317 */ // Label 1081: @65317
     /*  65317 */ GIM_Reject,
     /*  65318 */ // Label 1015: @65318
     /*  65318 */ GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66625),
     /*  65323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65329 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(65438), // Rule ID 13512 //
     /*  65334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65382 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65388 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65399 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65403 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65407 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65412 */     // MIs[4] LHS
     /*  65412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65419 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65436 */     GIR_RootConstrainSelectedInstOperands,
     /*  65437 */     // GIR_Coverage, 13512,
     /*  65437 */     GIR_EraseRootFromParent_Done,
     /*  65438 */   // Label 1098: @65438
     /*  65438 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(65547), // Rule ID 13511 //
     /*  65443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65491 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65512 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65516 */     // MIs[4] LHS
     /*  65516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65521 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65526 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65528 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65545 */     GIR_RootConstrainSelectedInstOperands,
     /*  65546 */     // GIR_Coverage, 13511,
     /*  65546 */     GIR_EraseRootFromParent_Done,
     /*  65547 */   // Label 1099: @65547
     /*  65547 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(65656), // Rule ID 13514 //
     /*  65552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65605 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65613 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65617 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65621 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65630 */     // MIs[4] LHS
     /*  65630 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65635 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65637 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65654 */     GIR_RootConstrainSelectedInstOperands,
     /*  65655 */     // GIR_Coverage, 13514,
     /*  65655 */     GIR_EraseRootFromParent_Done,
     /*  65656 */   // Label 1100: @65656
     /*  65656 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65765), // Rule ID 13513 //
     /*  65661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65714 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65734 */     // MIs[4] LHS
     /*  65734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65739 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65744 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65746 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65763 */     GIR_RootConstrainSelectedInstOperands,
     /*  65764 */     // GIR_Coverage, 13513,
     /*  65764 */     GIR_EraseRootFromParent_Done,
     /*  65765 */   // Label 1101: @65765
     /*  65765 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65874), // Rule ID 2469 //
     /*  65770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65831 */     // MIs[3] LHS
     /*  65831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65853 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65855 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65872 */     GIR_RootConstrainSelectedInstOperands,
     /*  65873 */     // GIR_Coverage, 2469,
     /*  65873 */     GIR_EraseRootFromParent_Done,
     /*  65874 */   // Label 1102: @65874
     /*  65874 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65983), // Rule ID 13509 //
     /*  65879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65936 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65940 */     // MIs[3] LHS
     /*  65940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65945 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65949 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65955 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65962 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65964 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65981 */     GIR_RootConstrainSelectedInstOperands,
     /*  65982 */     // GIR_Coverage, 13509,
     /*  65982 */     GIR_EraseRootFromParent_Done,
     /*  65983 */   // Label 1103: @65983
     /*  65983 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66092), // Rule ID 13508 //
     /*  65988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66050 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66054 */     // MIs[3] LHS
     /*  66054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66059 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66063 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66069 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66071 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66073 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66090 */     GIR_RootConstrainSelectedInstOperands,
     /*  66091 */     // GIR_Coverage, 13508,
     /*  66091 */     GIR_EraseRootFromParent_Done,
     /*  66092 */   // Label 1104: @66092
     /*  66092 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66201), // Rule ID 13510 //
     /*  66097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66159 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66163 */     // MIs[3] LHS
     /*  66163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66172 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66180 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66182 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66199 */     GIR_RootConstrainSelectedInstOperands,
     /*  66200 */     // GIR_Coverage, 13510,
     /*  66200 */     GIR_EraseRootFromParent_Done,
     /*  66201 */   // Label 1105: @66201
     /*  66201 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66268), // Rule ID 13478 //
     /*  66206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66230 */     // MIs[1] imm
     /*  66230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66242 */     // MIs[2] Operand 1
     /*  66242 */     // No operand predicates
     /*  66242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66252 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66266 */     GIR_RootConstrainSelectedInstOperands,
     /*  66267 */     // GIR_Coverage, 13478,
     /*  66267 */     GIR_EraseRootFromParent_Done,
     /*  66268 */   // Label 1106: @66268
     /*  66268 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66335), // Rule ID 13499 //
     /*  66273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66297 */     // MIs[1] imm
     /*  66297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66305 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66309 */     // MIs[2] Operand 1
     /*  66309 */     // No operand predicates
     /*  66309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66319 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66333 */     GIR_RootConstrainSelectedInstOperands,
     /*  66334 */     // GIR_Coverage, 13499,
     /*  66334 */     GIR_EraseRootFromParent_Done,
     /*  66335 */   // Label 1107: @66335
     /*  66335 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66402), // Rule ID 2235 //
     /*  66340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66368 */     // MIs[1] imm
     /*  66368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66380 */     // MIs[2] Operand 1
     /*  66380 */     // No operand predicates
     /*  66380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66386 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66400 */     GIR_RootConstrainSelectedInstOperands,
     /*  66401 */     // GIR_Coverage, 2235,
     /*  66401 */     GIR_EraseRootFromParent_Done,
     /*  66402 */   // Label 1108: @66402
     /*  66402 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66469), // Rule ID 2294 //
     /*  66407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66435 */     // MIs[1] imm
     /*  66435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66443 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66447 */     // MIs[2] Operand 1
     /*  66447 */     // No operand predicates
     /*  66447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66453 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66467 */     GIR_RootConstrainSelectedInstOperands,
     /*  66468 */     // GIR_Coverage, 2294,
     /*  66468 */     GIR_EraseRootFromParent_Done,
     /*  66469 */   // Label 1109: @66469
     /*  66469 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66533), // Rule ID 13812 //
     /*  66474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66506 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66520 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66525 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66531 */     GIR_RootConstrainSelectedInstOperands,
     /*  66532 */     // GIR_Coverage, 13812,
     /*  66532 */     GIR_EraseRootFromParent_Done,
     /*  66533 */   // Label 1110: @66533
     /*  66533 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(66597), // Rule ID 5041 //
     /*  66538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66574 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66584 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66589 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66595 */     GIR_RootConstrainSelectedInstOperands,
     /*  66596 */     // GIR_Coverage, 5041,
     /*  66596 */     GIR_EraseRootFromParent_Done,
     /*  66597 */   // Label 1111: @66597
     /*  66597 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(66624), // Rule ID 5047 //
     /*  66602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66617 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66622 */     GIR_RootConstrainSelectedInstOperands,
     /*  66623 */     // GIR_Coverage, 5047,
     /*  66623 */     GIR_Done,
     /*  66624 */   // Label 1112: @66624
     /*  66624 */   GIM_Reject,
     /*  66625 */ // Label 1097: @66625
     /*  66625 */ GIM_Reject,
     /*  66626 */ // Label 1016: @66626
     /*  66626 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67933),
     /*  66631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66637 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66746), // Rule ID 13540 //
     /*  66642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66690 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66707 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66711 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66715 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66720 */     // MIs[4] LHS
     /*  66720 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66725 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66727 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66744 */     GIR_RootConstrainSelectedInstOperands,
     /*  66745 */     // GIR_Coverage, 13540,
     /*  66745 */     GIR_EraseRootFromParent_Done,
     /*  66746 */   // Label 1114: @66746
     /*  66746 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66855), // Rule ID 13539 //
     /*  66751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66820 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66824 */     // MIs[4] LHS
     /*  66824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66829 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66836 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66853 */     GIR_RootConstrainSelectedInstOperands,
     /*  66854 */     // GIR_Coverage, 13539,
     /*  66854 */     GIR_EraseRootFromParent_Done,
     /*  66855 */   // Label 1115: @66855
     /*  66855 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66964), // Rule ID 13542 //
     /*  66860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66913 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66921 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66925 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66929 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66938 */     // MIs[4] LHS
     /*  66938 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66943 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66945 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66962 */     GIR_RootConstrainSelectedInstOperands,
     /*  66963 */     // GIR_Coverage, 13542,
     /*  66963 */     GIR_EraseRootFromParent_Done,
     /*  66964 */   // Label 1116: @66964
     /*  66964 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67073), // Rule ID 13541 //
     /*  66969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67022 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67038 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67042 */     // MIs[4] LHS
     /*  67042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67047 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67052 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67054 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67071 */     GIR_RootConstrainSelectedInstOperands,
     /*  67072 */     // GIR_Coverage, 13541,
     /*  67072 */     GIR_EraseRootFromParent_Done,
     /*  67073 */   // Label 1117: @67073
     /*  67073 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67182), // Rule ID 2473 //
     /*  67078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67139 */     // MIs[3] LHS
     /*  67139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67148 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67161 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67163 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67180 */     GIR_RootConstrainSelectedInstOperands,
     /*  67181 */     // GIR_Coverage, 2473,
     /*  67181 */     GIR_EraseRootFromParent_Done,
     /*  67182 */   // Label 1118: @67182
     /*  67182 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67291), // Rule ID 13537 //
     /*  67187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67248 */     // MIs[3] LHS
     /*  67248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67257 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67270 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67272 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67289 */     GIR_RootConstrainSelectedInstOperands,
     /*  67290 */     // GIR_Coverage, 13537,
     /*  67290 */     GIR_EraseRootFromParent_Done,
     /*  67291 */   // Label 1119: @67291
     /*  67291 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67400), // Rule ID 13536 //
     /*  67296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67358 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67362 */     // MIs[3] LHS
     /*  67362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67367 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67371 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67379 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67381 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67398 */     GIR_RootConstrainSelectedInstOperands,
     /*  67399 */     // GIR_Coverage, 13536,
     /*  67399 */     GIR_EraseRootFromParent_Done,
     /*  67400 */   // Label 1120: @67400
     /*  67400 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67509), // Rule ID 13538 //
     /*  67405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67471 */     // MIs[3] LHS
     /*  67471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67480 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67486 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67490 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67507 */     GIR_RootConstrainSelectedInstOperands,
     /*  67508 */     // GIR_Coverage, 13538,
     /*  67508 */     GIR_EraseRootFromParent_Done,
     /*  67509 */   // Label 1121: @67509
     /*  67509 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(67576), // Rule ID 13484 //
     /*  67514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67538 */     // MIs[1] imm
     /*  67538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67546 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67550 */     // MIs[2] Operand 1
     /*  67550 */     // No operand predicates
     /*  67550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67560 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67574 */     GIR_RootConstrainSelectedInstOperands,
     /*  67575 */     // GIR_Coverage, 13484,
     /*  67575 */     GIR_EraseRootFromParent_Done,
     /*  67576 */   // Label 1122: @67576
     /*  67576 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(67643), // Rule ID 13505 //
     /*  67581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67605 */     // MIs[1] imm
     /*  67605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67617 */     // MIs[2] Operand 1
     /*  67617 */     // No operand predicates
     /*  67617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67627 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67641 */     GIR_RootConstrainSelectedInstOperands,
     /*  67642 */     // GIR_Coverage, 13505,
     /*  67642 */     GIR_EraseRootFromParent_Done,
     /*  67643 */   // Label 1123: @67643
     /*  67643 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(67710), // Rule ID 2241 //
     /*  67648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67676 */     // MIs[1] imm
     /*  67676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67688 */     // MIs[2] Operand 1
     /*  67688 */     // No operand predicates
     /*  67688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67694 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67708 */     GIR_RootConstrainSelectedInstOperands,
     /*  67709 */     // GIR_Coverage, 2241,
     /*  67709 */     GIR_EraseRootFromParent_Done,
     /*  67710 */   // Label 1124: @67710
     /*  67710 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(67777), // Rule ID 2300 //
     /*  67715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67743 */     // MIs[1] imm
     /*  67743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67755 */     // MIs[2] Operand 1
     /*  67755 */     // No operand predicates
     /*  67755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67761 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67775 */     GIR_RootConstrainSelectedInstOperands,
     /*  67776 */     // GIR_Coverage, 2300,
     /*  67776 */     GIR_EraseRootFromParent_Done,
     /*  67777 */   // Label 1125: @67777
     /*  67777 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(67841), // Rule ID 13816 //
     /*  67782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67814 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67828 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67833 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67839 */     GIR_RootConstrainSelectedInstOperands,
     /*  67840 */     // GIR_Coverage, 13816,
     /*  67840 */     GIR_EraseRootFromParent_Done,
     /*  67841 */   // Label 1126: @67841
     /*  67841 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67905), // Rule ID 5045 //
     /*  67846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67882 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67888 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67892 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67897 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67903 */     GIR_RootConstrainSelectedInstOperands,
     /*  67904 */     // GIR_Coverage, 5045,
     /*  67904 */     GIR_EraseRootFromParent_Done,
     /*  67905 */   // Label 1127: @67905
     /*  67905 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67932), // Rule ID 5051 //
     /*  67910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67925 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67930 */     GIR_RootConstrainSelectedInstOperands,
     /*  67931 */     // GIR_Coverage, 5051,
     /*  67931 */     GIR_Done,
     /*  67932 */   // Label 1128: @67932
     /*  67932 */   GIM_Reject,
     /*  67933 */ // Label 1113: @67933
     /*  67933 */ GIM_Reject,
     /*  67934 */ // Label 1017: @67934
     /*  67934 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(69241),
     /*  67939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67945 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68054), // Rule ID 13300 //
     /*  67950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67998 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68015 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68019 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68023 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68028 */     // MIs[4] Rd
     /*  68028 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68033 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68035 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68052 */     GIR_RootConstrainSelectedInstOperands,
     /*  68053 */     // GIR_Coverage, 13300,
     /*  68053 */     GIR_EraseRootFromParent_Done,
     /*  68054 */   // Label 1130: @68054
     /*  68054 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68163), // Rule ID 13299 //
     /*  68059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68107 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68124 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68128 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68132 */     // MIs[4] Rd
     /*  68132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68137 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68142 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68144 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68161 */     GIR_RootConstrainSelectedInstOperands,
     /*  68162 */     // GIR_Coverage, 13299,
     /*  68162 */     GIR_EraseRootFromParent_Done,
     /*  68163 */   // Label 1131: @68163
     /*  68163 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68272), // Rule ID 13302 //
     /*  68168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68229 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68233 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68237 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68246 */     // MIs[4] Rd
     /*  68246 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68251 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68253 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68270 */     GIR_RootConstrainSelectedInstOperands,
     /*  68271 */     // GIR_Coverage, 13302,
     /*  68271 */     GIR_EraseRootFromParent_Done,
     /*  68272 */   // Label 1132: @68272
     /*  68272 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68381), // Rule ID 13301 //
     /*  68277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68330 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68346 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68350 */     // MIs[4] Rd
     /*  68350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68362 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68379 */     GIR_RootConstrainSelectedInstOperands,
     /*  68380 */     // GIR_Coverage, 13301,
     /*  68380 */     GIR_EraseRootFromParent_Done,
     /*  68381 */   // Label 1133: @68381
     /*  68381 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68490), // Rule ID 1605 //
     /*  68386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68443 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68447 */     // MIs[3] Rd
     /*  68447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68456 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68471 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68488 */     GIR_RootConstrainSelectedInstOperands,
     /*  68489 */     // GIR_Coverage, 1605,
     /*  68489 */     GIR_EraseRootFromParent_Done,
     /*  68490 */   // Label 1134: @68490
     /*  68490 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68599), // Rule ID 13297 //
     /*  68495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68556 */     // MIs[3] Rd
     /*  68556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68565 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68580 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68597 */     GIR_RootConstrainSelectedInstOperands,
     /*  68598 */     // GIR_Coverage, 13297,
     /*  68598 */     GIR_EraseRootFromParent_Done,
     /*  68599 */   // Label 1135: @68599
     /*  68599 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(68708), // Rule ID 13296 //
     /*  68604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68666 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68670 */     // MIs[3] Rd
     /*  68670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68689 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68706 */     GIR_RootConstrainSelectedInstOperands,
     /*  68707 */     // GIR_Coverage, 13296,
     /*  68707 */     GIR_EraseRootFromParent_Done,
     /*  68708 */   // Label 1136: @68708
     /*  68708 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(68817), // Rule ID 13298 //
     /*  68713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68779 */     // MIs[3] Rd
     /*  68779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68788 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68794 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68798 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68815 */     GIR_RootConstrainSelectedInstOperands,
     /*  68816 */     // GIR_Coverage, 13298,
     /*  68816 */     GIR_EraseRootFromParent_Done,
     /*  68817 */   // Label 1137: @68817
     /*  68817 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68884), // Rule ID 13474 //
     /*  68822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68846 */     // MIs[1] imm
     /*  68846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68858 */     // MIs[2] Operand 1
     /*  68858 */     // No operand predicates
     /*  68858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68868 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  68871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68882 */     GIR_RootConstrainSelectedInstOperands,
     /*  68883 */     // GIR_Coverage, 13474,
     /*  68883 */     GIR_EraseRootFromParent_Done,
     /*  68884 */   // Label 1138: @68884
     /*  68884 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68951), // Rule ID 13495 //
     /*  68889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68913 */     // MIs[1] imm
     /*  68913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68921 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68925 */     // MIs[2] Operand 1
     /*  68925 */     // No operand predicates
     /*  68925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68935 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  68938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68949 */     GIR_RootConstrainSelectedInstOperands,
     /*  68950 */     // GIR_Coverage, 13495,
     /*  68950 */     GIR_EraseRootFromParent_Done,
     /*  68951 */   // Label 1139: @68951
     /*  68951 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69018), // Rule ID 2231 //
     /*  68956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68984 */     // MIs[1] imm
     /*  68984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68996 */     // MIs[2] Operand 1
     /*  68996 */     // No operand predicates
     /*  68996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69002 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69016 */     GIR_RootConstrainSelectedInstOperands,
     /*  69017 */     // GIR_Coverage, 2231,
     /*  69017 */     GIR_EraseRootFromParent_Done,
     /*  69018 */   // Label 1140: @69018
     /*  69018 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69085), // Rule ID 2290 //
     /*  69023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69051 */     // MIs[1] imm
     /*  69051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69059 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69063 */     // MIs[2] Operand 1
     /*  69063 */     // No operand predicates
     /*  69063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69069 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69083 */     GIR_RootConstrainSelectedInstOperands,
     /*  69084 */     // GIR_Coverage, 2290,
     /*  69084 */     GIR_EraseRootFromParent_Done,
     /*  69085 */   // Label 1141: @69085
     /*  69085 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69149), // Rule ID 13294 //
     /*  69090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69122 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69136 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69147 */     GIR_RootConstrainSelectedInstOperands,
     /*  69148 */     // GIR_Coverage, 13294,
     /*  69148 */     GIR_EraseRootFromParent_Done,
     /*  69149 */   // Label 1142: @69149
     /*  69149 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69213), // Rule ID 1601 //
     /*  69154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69190 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69200 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69211 */     GIR_RootConstrainSelectedInstOperands,
     /*  69212 */     // GIR_Coverage, 1601,
     /*  69212 */     GIR_EraseRootFromParent_Done,
     /*  69213 */   // Label 1143: @69213
     /*  69213 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69240), // Rule ID 1603 //
     /*  69218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69233 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69238 */     GIR_RootConstrainSelectedInstOperands,
     /*  69239 */     // GIR_Coverage, 1603,
     /*  69239 */     GIR_Done,
     /*  69240 */   // Label 1144: @69240
     /*  69240 */   GIM_Reject,
     /*  69241 */ // Label 1129: @69241
     /*  69241 */ GIM_Reject,
     /*  69242 */ // Label 1018: @69242
     /*  69242 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70549),
     /*  69247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69253 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69362), // Rule ID 13533 //
     /*  69258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69306 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69319 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69323 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69327 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69331 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69336 */     // MIs[4] LHS
     /*  69336 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69341 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69343 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69360 */     GIR_RootConstrainSelectedInstOperands,
     /*  69361 */     // GIR_Coverage, 13533,
     /*  69361 */     GIR_EraseRootFromParent_Done,
     /*  69362 */   // Label 1146: @69362
     /*  69362 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69471), // Rule ID 13532 //
     /*  69367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69428 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69432 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69436 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69440 */     // MIs[4] LHS
     /*  69440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69445 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69452 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69469 */     GIR_RootConstrainSelectedInstOperands,
     /*  69470 */     // GIR_Coverage, 13532,
     /*  69470 */     GIR_EraseRootFromParent_Done,
     /*  69471 */   // Label 1147: @69471
     /*  69471 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(69580), // Rule ID 13535 //
     /*  69476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69529 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69535 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69537 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69541 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69545 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69554 */     // MIs[4] LHS
     /*  69554 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69561 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69578 */     GIR_RootConstrainSelectedInstOperands,
     /*  69579 */     // GIR_Coverage, 13535,
     /*  69579 */     GIR_EraseRootFromParent_Done,
     /*  69580 */   // Label 1148: @69580
     /*  69580 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69689), // Rule ID 13534 //
     /*  69585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69638 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69644 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69646 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69650 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69654 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69658 */     // MIs[4] LHS
     /*  69658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69663 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69670 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69687 */     GIR_RootConstrainSelectedInstOperands,
     /*  69688 */     // GIR_Coverage, 13534,
     /*  69688 */     GIR_EraseRootFromParent_Done,
     /*  69689 */   // Label 1149: @69689
     /*  69689 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69798), // Rule ID 2472 //
     /*  69694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69751 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69755 */     // MIs[3] LHS
     /*  69755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69764 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69770 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69777 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69779 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69796 */     GIR_RootConstrainSelectedInstOperands,
     /*  69797 */     // GIR_Coverage, 2472,
     /*  69797 */     GIR_EraseRootFromParent_Done,
     /*  69798 */   // Label 1150: @69798
     /*  69798 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69907), // Rule ID 13530 //
     /*  69803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69864 */     // MIs[3] LHS
     /*  69864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69869 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69873 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69879 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69886 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69888 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69905 */     GIR_RootConstrainSelectedInstOperands,
     /*  69906 */     // GIR_Coverage, 13530,
     /*  69906 */     GIR_EraseRootFromParent_Done,
     /*  69907 */   // Label 1151: @69907
     /*  69907 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70016), // Rule ID 13529 //
     /*  69912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69974 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69978 */     // MIs[3] LHS
     /*  69978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69983 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69987 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69995 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69997 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70014 */     GIR_RootConstrainSelectedInstOperands,
     /*  70015 */     // GIR_Coverage, 13529,
     /*  70015 */     GIR_EraseRootFromParent_Done,
     /*  70016 */   // Label 1152: @70016
     /*  70016 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70125), // Rule ID 13531 //
     /*  70021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70083 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70087 */     // MIs[3] LHS
     /*  70087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70096 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70102 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70104 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70106 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70123 */     GIR_RootConstrainSelectedInstOperands,
     /*  70124 */     // GIR_Coverage, 13531,
     /*  70124 */     GIR_EraseRootFromParent_Done,
     /*  70125 */   // Label 1153: @70125
     /*  70125 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70192), // Rule ID 13480 //
     /*  70130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70154 */     // MIs[1] imm
     /*  70154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70166 */     // MIs[2] Operand 1
     /*  70166 */     // No operand predicates
     /*  70166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70176 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70190 */     GIR_RootConstrainSelectedInstOperands,
     /*  70191 */     // GIR_Coverage, 13480,
     /*  70191 */     GIR_EraseRootFromParent_Done,
     /*  70192 */   // Label 1154: @70192
     /*  70192 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70259), // Rule ID 13501 //
     /*  70197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70221 */     // MIs[1] imm
     /*  70221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70233 */     // MIs[2] Operand 1
     /*  70233 */     // No operand predicates
     /*  70233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70243 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70257 */     GIR_RootConstrainSelectedInstOperands,
     /*  70258 */     // GIR_Coverage, 13501,
     /*  70258 */     GIR_EraseRootFromParent_Done,
     /*  70259 */   // Label 1155: @70259
     /*  70259 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70326), // Rule ID 2237 //
     /*  70264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70292 */     // MIs[1] imm
     /*  70292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70304 */     // MIs[2] Operand 1
     /*  70304 */     // No operand predicates
     /*  70304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70310 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70324 */     GIR_RootConstrainSelectedInstOperands,
     /*  70325 */     // GIR_Coverage, 2237,
     /*  70325 */     GIR_EraseRootFromParent_Done,
     /*  70326 */   // Label 1156: @70326
     /*  70326 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70393), // Rule ID 2296 //
     /*  70331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70359 */     // MIs[1] imm
     /*  70359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70371 */     // MIs[2] Operand 1
     /*  70371 */     // No operand predicates
     /*  70371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70377 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70391 */     GIR_RootConstrainSelectedInstOperands,
     /*  70392 */     // GIR_Coverage, 2296,
     /*  70392 */     GIR_EraseRootFromParent_Done,
     /*  70393 */   // Label 1157: @70393
     /*  70393 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70457), // Rule ID 13815 //
     /*  70398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70430 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70436 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70444 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70449 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70455 */     GIR_RootConstrainSelectedInstOperands,
     /*  70456 */     // GIR_Coverage, 13815,
     /*  70456 */     GIR_EraseRootFromParent_Done,
     /*  70457 */   // Label 1158: @70457
     /*  70457 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(70521), // Rule ID 5044 //
     /*  70462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70498 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70508 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70513 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70519 */     GIR_RootConstrainSelectedInstOperands,
     /*  70520 */     // GIR_Coverage, 5044,
     /*  70520 */     GIR_EraseRootFromParent_Done,
     /*  70521 */   // Label 1159: @70521
     /*  70521 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(70548), // Rule ID 5050 //
     /*  70526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70541 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70546 */     GIR_RootConstrainSelectedInstOperands,
     /*  70547 */     // GIR_Coverage, 5050,
     /*  70547 */     GIR_Done,
     /*  70548 */   // Label 1160: @70548
     /*  70548 */   GIM_Reject,
     /*  70549 */ // Label 1145: @70549
     /*  70549 */ GIM_Reject,
     /*  70550 */ // Label 1019: @70550
     /*  70550 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71857),
     /*  70555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70561 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(70670), // Rule ID 13307 //
     /*  70566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70614 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70635 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70639 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70644 */     // MIs[4] Rd
     /*  70644 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70649 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70651 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70668 */     GIR_RootConstrainSelectedInstOperands,
     /*  70669 */     // GIR_Coverage, 13307,
     /*  70669 */     GIR_EraseRootFromParent_Done,
     /*  70670 */   // Label 1162: @70670
     /*  70670 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(70779), // Rule ID 13306 //
     /*  70675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70744 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70748 */     // MIs[4] Rd
     /*  70748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70753 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70760 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70777 */     GIR_RootConstrainSelectedInstOperands,
     /*  70778 */     // GIR_Coverage, 13306,
     /*  70778 */     GIR_EraseRootFromParent_Done,
     /*  70779 */   // Label 1163: @70779
     /*  70779 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(70888), // Rule ID 13309 //
     /*  70784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70837 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70845 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70849 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70853 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70862 */     // MIs[4] Rd
     /*  70862 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70867 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70869 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70886 */     GIR_RootConstrainSelectedInstOperands,
     /*  70887 */     // GIR_Coverage, 13309,
     /*  70887 */     GIR_EraseRootFromParent_Done,
     /*  70888 */   // Label 1164: @70888
     /*  70888 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(70997), // Rule ID 13308 //
     /*  70893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70946 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70962 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70966 */     // MIs[4] Rd
     /*  70966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70971 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70978 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70995 */     GIR_RootConstrainSelectedInstOperands,
     /*  70996 */     // GIR_Coverage, 13308,
     /*  70996 */     GIR_EraseRootFromParent_Done,
     /*  70997 */   // Label 1165: @70997
     /*  70997 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71106), // Rule ID 1606 //
     /*  71002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71059 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71063 */     // MIs[3] Rd
     /*  71063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71072 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71078 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71087 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71104 */     GIR_RootConstrainSelectedInstOperands,
     /*  71105 */     // GIR_Coverage, 1606,
     /*  71105 */     GIR_EraseRootFromParent_Done,
     /*  71106 */   // Label 1166: @71106
     /*  71106 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71215), // Rule ID 13304 //
     /*  71111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71172 */     // MIs[3] Rd
     /*  71172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71181 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71196 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71213 */     GIR_RootConstrainSelectedInstOperands,
     /*  71214 */     // GIR_Coverage, 13304,
     /*  71214 */     GIR_EraseRootFromParent_Done,
     /*  71215 */   // Label 1167: @71215
     /*  71215 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71324), // Rule ID 13303 //
     /*  71220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71282 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71286 */     // MIs[3] Rd
     /*  71286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71295 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71301 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71305 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71322 */     GIR_RootConstrainSelectedInstOperands,
     /*  71323 */     // GIR_Coverage, 13303,
     /*  71323 */     GIR_EraseRootFromParent_Done,
     /*  71324 */   // Label 1168: @71324
     /*  71324 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71433), // Rule ID 13305 //
     /*  71329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71395 */     // MIs[3] Rd
     /*  71395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71404 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71414 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71431 */     GIR_RootConstrainSelectedInstOperands,
     /*  71432 */     // GIR_Coverage, 13305,
     /*  71432 */     GIR_EraseRootFromParent_Done,
     /*  71433 */   // Label 1169: @71433
     /*  71433 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71500), // Rule ID 13476 //
     /*  71438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71462 */     // MIs[1] imm
     /*  71462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71474 */     // MIs[2] Operand 1
     /*  71474 */     // No operand predicates
     /*  71474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71484 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71498 */     GIR_RootConstrainSelectedInstOperands,
     /*  71499 */     // GIR_Coverage, 13476,
     /*  71499 */     GIR_EraseRootFromParent_Done,
     /*  71500 */   // Label 1170: @71500
     /*  71500 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(71567), // Rule ID 13497 //
     /*  71505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71529 */     // MIs[1] imm
     /*  71529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71541 */     // MIs[2] Operand 1
     /*  71541 */     // No operand predicates
     /*  71541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71551 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71565 */     GIR_RootConstrainSelectedInstOperands,
     /*  71566 */     // GIR_Coverage, 13497,
     /*  71566 */     GIR_EraseRootFromParent_Done,
     /*  71567 */   // Label 1171: @71567
     /*  71567 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(71634), // Rule ID 2233 //
     /*  71572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71600 */     // MIs[1] imm
     /*  71600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71612 */     // MIs[2] Operand 1
     /*  71612 */     // No operand predicates
     /*  71612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71618 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71632 */     GIR_RootConstrainSelectedInstOperands,
     /*  71633 */     // GIR_Coverage, 2233,
     /*  71633 */     GIR_EraseRootFromParent_Done,
     /*  71634 */   // Label 1172: @71634
     /*  71634 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(71701), // Rule ID 2292 //
     /*  71639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71667 */     // MIs[1] imm
     /*  71667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71679 */     // MIs[2] Operand 1
     /*  71679 */     // No operand predicates
     /*  71679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71685 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71699 */     GIR_RootConstrainSelectedInstOperands,
     /*  71700 */     // GIR_Coverage, 2292,
     /*  71700 */     GIR_EraseRootFromParent_Done,
     /*  71701 */   // Label 1173: @71701
     /*  71701 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(71765), // Rule ID 13295 //
     /*  71706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71738 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71752 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71763 */     GIR_RootConstrainSelectedInstOperands,
     /*  71764 */     // GIR_Coverage, 13295,
     /*  71764 */     GIR_EraseRootFromParent_Done,
     /*  71765 */   // Label 1174: @71765
     /*  71765 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(71829), // Rule ID 1602 //
     /*  71770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71806 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71816 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71827 */     GIR_RootConstrainSelectedInstOperands,
     /*  71828 */     // GIR_Coverage, 1602,
     /*  71828 */     GIR_EraseRootFromParent_Done,
     /*  71829 */   // Label 1175: @71829
     /*  71829 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(71856), // Rule ID 1604 //
     /*  71834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71849 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71854 */     GIR_RootConstrainSelectedInstOperands,
     /*  71855 */     // GIR_Coverage, 1604,
     /*  71855 */     GIR_Done,
     /*  71856 */   // Label 1176: @71856
     /*  71856 */   GIM_Reject,
     /*  71857 */ // Label 1161: @71857
     /*  71857 */ GIM_Reject,
     /*  71858 */ // Label 1020: @71858
     /*  71858 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(71889), // Rule ID 8399 //
     /*  71863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  71869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  71872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71876 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  71876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71881 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71883 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71885 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71887 */   GIR_RootConstrainSelectedInstOperands,
     /*  71888 */   // GIR_Coverage, 8399,
     /*  71888 */   GIR_EraseRootFromParent_Done,
     /*  71889 */ // Label 1177: @71889
     /*  71889 */ GIM_Reject,
     /*  71890 */ // Label 1021: @71890
     /*  71890 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(71921), // Rule ID 8398 //
     /*  71895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  71901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  71904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71908 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  71908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71913 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71917 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71919 */   GIR_RootConstrainSelectedInstOperands,
     /*  71920 */   // GIR_Coverage, 8398,
     /*  71920 */   GIR_EraseRootFromParent_Done,
     /*  71921 */ // Label 1178: @71921
     /*  71921 */ GIM_Reject,
     /*  71922 */ // Label 1022: @71922
     /*  71922 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(71947), // Rule ID 7408 //
     /*  71927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  71933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  71936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  71940 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  71940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  71945 */   GIR_RootConstrainSelectedInstOperands,
     /*  71946 */   // GIR_Coverage, 7408,
     /*  71946 */   GIR_Done,
     /*  71947 */ // Label 1179: @71947
     /*  71947 */ GIM_Reject,
     /*  71948 */ // Label 1023: @71948
     /*  71948 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(71979), // Rule ID 8397 //
     /*  71953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  71959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  71962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71966 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  71966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71971 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71973 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71975 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71977 */   GIR_RootConstrainSelectedInstOperands,
     /*  71978 */   // GIR_Coverage, 8397,
     /*  71978 */   GIR_EraseRootFromParent_Done,
     /*  71979 */ // Label 1180: @71979
     /*  71979 */ GIM_Reject,
     /*  71980 */ // Label 1024: @71980
     /*  71980 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72005), // Rule ID 7407 //
     /*  71985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  71991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  71994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  71998 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  71998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72003 */   GIR_RootConstrainSelectedInstOperands,
     /*  72004 */   // GIR_Coverage, 7407,
     /*  72004 */   GIR_Done,
     /*  72005 */ // Label 1181: @72005
     /*  72005 */ GIM_Reject,
     /*  72006 */ // Label 1025: @72006
     /*  72006 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72037), // Rule ID 8396 //
     /*  72011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72024 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72029 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72031 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72033 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72035 */   GIR_RootConstrainSelectedInstOperands,
     /*  72036 */   // GIR_Coverage, 8396,
     /*  72036 */   GIR_EraseRootFromParent_Done,
     /*  72037 */ // Label 1182: @72037
     /*  72037 */ GIM_Reject,
     /*  72038 */ // Label 1026: @72038
     /*  72038 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72063), // Rule ID 7406 //
     /*  72043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72056 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72061 */   GIR_RootConstrainSelectedInstOperands,
     /*  72062 */   // GIR_Coverage, 7406,
     /*  72062 */   GIR_Done,
     /*  72063 */ // Label 1183: @72063
     /*  72063 */ GIM_Reject,
     /*  72064 */ // Label 1027: @72064
     /*  72064 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72095), // Rule ID 8395 //
     /*  72069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72082 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72087 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72089 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72091 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72093 */   GIR_RootConstrainSelectedInstOperands,
     /*  72094 */   // GIR_Coverage, 8395,
     /*  72094 */   GIR_EraseRootFromParent_Done,
     /*  72095 */ // Label 1184: @72095
     /*  72095 */ GIM_Reject,
     /*  72096 */ // Label 1028: @72096
     /*  72096 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72121), // Rule ID 7405 //
     /*  72101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72114 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72119 */   GIR_RootConstrainSelectedInstOperands,
     /*  72120 */   // GIR_Coverage, 7405,
     /*  72120 */   GIR_Done,
     /*  72121 */ // Label 1185: @72121
     /*  72121 */ GIM_Reject,
     /*  72122 */ // Label 1029: @72122
     /*  72122 */ GIM_Reject,
     /*  72123 */ // Label 7: @72123
     /*  72123 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1204*/ GIMT_Encode4(79314),
     /*  72134 */ /*GILLT_s32*//*Label 1186*/ GIMT_Encode4(72222),
     /*  72138 */ /*GILLT_s64*//*Label 1187*/ GIMT_Encode4(72902), GIMT_Encode4(0),
     /*  72146 */ /*GILLT_v2s32*//*Label 1188*/ GIMT_Encode4(73745),
     /*  72150 */ /*GILLT_v2s64*//*Label 1189*/ GIMT_Encode4(73980),
     /*  72154 */ /*GILLT_v4s16*//*Label 1190*/ GIMT_Encode4(74669),
     /*  72158 */ /*GILLT_v4s32*//*Label 1191*/ GIMT_Encode4(74904),
     /*  72162 */ /*GILLT_v8s8*//*Label 1192*/ GIMT_Encode4(75593),
     /*  72166 */ /*GILLT_v8s16*//*Label 1193*/ GIMT_Encode4(75831),
     /*  72170 */ /*GILLT_v16s8*//*Label 1194*/ GIMT_Encode4(76520),
     /*  72174 */ /*GILLT_nxv1s1*//*Label 1195*/ GIMT_Encode4(77212),
     /*  72178 */ /*GILLT_nxv2s1*//*Label 1196*/ GIMT_Encode4(77262), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72190 */ /*GILLT_nxv2s64*//*Label 1197*/ GIMT_Encode4(77312),
     /*  72194 */ /*GILLT_nxv4s1*//*Label 1198*/ GIMT_Encode4(77775), GIMT_Encode4(0),
     /*  72202 */ /*GILLT_nxv4s32*//*Label 1199*/ GIMT_Encode4(77825),
     /*  72206 */ /*GILLT_nxv8s1*//*Label 1200*/ GIMT_Encode4(78288),
     /*  72210 */ /*GILLT_nxv8s16*//*Label 1201*/ GIMT_Encode4(78338),
     /*  72214 */ /*GILLT_nxv16s1*//*Label 1202*/ GIMT_Encode4(78801),
     /*  72218 */ /*GILLT_nxv16s8*//*Label 1203*/ GIMT_Encode4(78851),
     /*  72222 */ // Label 1186: @72222
     /*  72222 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(72901),
     /*  72227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72233 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(72291), // Rule ID 13165 //
     /*  72238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72276 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72289 */     GIR_RootConstrainSelectedInstOperands,
     /*  72290 */     // GIR_Coverage, 13165,
     /*  72290 */     GIR_EraseRootFromParent_Done,
     /*  72291 */   // Label 1206: @72291
     /*  72291 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(72346), // Rule ID 13164 //
     /*  72296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72333 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72344 */     GIR_RootConstrainSelectedInstOperands,
     /*  72345 */     // GIR_Coverage, 13164,
     /*  72345 */     GIR_EraseRootFromParent_Done,
     /*  72346 */   // Label 1207: @72346
     /*  72346 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(72404), // Rule ID 13162 //
     /*  72351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72389 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72402 */     GIR_RootConstrainSelectedInstOperands,
     /*  72403 */     // GIR_Coverage, 13162,
     /*  72403 */     GIR_EraseRootFromParent_Done,
     /*  72404 */   // Label 1208: @72404
     /*  72404 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(72462), // Rule ID 166 //
     /*  72409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72447 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72460 */     GIR_RootConstrainSelectedInstOperands,
     /*  72461 */     // GIR_Coverage, 166,
     /*  72461 */     GIR_EraseRootFromParent_Done,
     /*  72462 */   // Label 1209: @72462
     /*  72462 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(72520), // Rule ID 13163 //
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72492 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72505 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72518 */     GIR_RootConstrainSelectedInstOperands,
     /*  72519 */     // GIR_Coverage, 13163,
     /*  72519 */     GIR_EraseRootFromParent_Done,
     /*  72520 */   // Label 1210: @72520
     /*  72520 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(72575), // Rule ID 13166 //
     /*  72525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72549 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72562 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72573 */     GIR_RootConstrainSelectedInstOperands,
     /*  72574 */     // GIR_Coverage, 13166,
     /*  72574 */     GIR_EraseRootFromParent_Done,
     /*  72575 */   // Label 1211: @72575
     /*  72575 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(72616), // Rule ID 144 //
     /*  72580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  72584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72596 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  72600 */     // MIs[1] Operand 1
     /*  72600 */     // No operand predicates
     /*  72600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72602 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  72602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  72605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72609 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  72614 */     GIR_RootConstrainSelectedInstOperands,
     /*  72615 */     // GIR_Coverage, 144,
     /*  72615 */     GIR_EraseRootFromParent_Done,
     /*  72616 */   // Label 1212: @72616
     /*  72616 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(72649), // Rule ID 13172 //
     /*  72621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72636 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72647 */     GIR_RootConstrainSelectedInstOperands,
     /*  72648 */     // GIR_Coverage, 13172,
     /*  72648 */     GIR_EraseRootFromParent_Done,
     /*  72649 */   // Label 1213: @72649
     /*  72649 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(72682), // Rule ID 170 //
     /*  72654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72669 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72680 */     GIR_RootConstrainSelectedInstOperands,
     /*  72681 */     // GIR_Coverage, 170,
     /*  72681 */     GIR_EraseRootFromParent_Done,
     /*  72682 */   // Label 1214: @72682
     /*  72682 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(72735), // Rule ID 13158 //
     /*  72687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72712 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72722 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  72733 */     GIR_RootConstrainSelectedInstOperands,
     /*  72734 */     // GIR_Coverage, 13158,
     /*  72734 */     GIR_EraseRootFromParent_Done,
     /*  72735 */   // Label 1215: @72735
     /*  72735 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(72791), // Rule ID 164 //
     /*  72740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72776 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72789 */     GIR_RootConstrainSelectedInstOperands,
     /*  72790 */     // GIR_Coverage, 164,
     /*  72790 */     GIR_EraseRootFromParent_Done,
     /*  72791 */   // Label 1216: @72791
     /*  72791 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(72844), // Rule ID 13159 //
     /*  72796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72831 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  72842 */     GIR_RootConstrainSelectedInstOperands,
     /*  72843 */     // GIR_Coverage, 13159,
     /*  72843 */     GIR_EraseRootFromParent_Done,
     /*  72844 */   // Label 1217: @72844
     /*  72844 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(72876), // Rule ID 3994 //
     /*  72849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72861 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  72861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  72864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  72874 */     GIR_RootConstrainSelectedInstOperands,
     /*  72875 */     // GIR_Coverage, 3994,
     /*  72875 */     GIR_EraseRootFromParent_Done,
     /*  72876 */   // Label 1218: @72876
     /*  72876 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(72900), // Rule ID 168 //
     /*  72881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72893 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  72898 */     GIR_RootConstrainSelectedInstOperands,
     /*  72899 */     // GIR_Coverage, 168,
     /*  72899 */     GIR_Done,
     /*  72900 */   // Label 1219: @72900
     /*  72900 */   GIM_Reject,
     /*  72901 */ // Label 1205: @72901
     /*  72901 */ GIM_Reject,
     /*  72902 */ // Label 1187: @72902
     /*  72902 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73744),
     /*  72907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  72910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72913 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(72971), // Rule ID 13170 //
     /*  72918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  72934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  72938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  72956 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  72956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  72959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72969 */     GIR_RootConstrainSelectedInstOperands,
     /*  72970 */     // GIR_Coverage, 13170,
     /*  72970 */     GIR_EraseRootFromParent_Done,
     /*  72971 */   // Label 1221: @72971
     /*  72971 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73026), // Rule ID 13169 //
     /*  72976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  72992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  72996 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73013 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73020 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73024 */     GIR_RootConstrainSelectedInstOperands,
     /*  73025 */     // GIR_Coverage, 13169,
     /*  73025 */     GIR_EraseRootFromParent_Done,
     /*  73026 */   // Label 1222: @73026
     /*  73026 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73084), // Rule ID 13167 //
     /*  73031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73069 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73082 */     GIR_RootConstrainSelectedInstOperands,
     /*  73083 */     // GIR_Coverage, 13167,
     /*  73083 */     GIR_EraseRootFromParent_Done,
     /*  73084 */   // Label 1223: @73084
     /*  73084 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73142), // Rule ID 167 //
     /*  73089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73127 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73140 */     GIR_RootConstrainSelectedInstOperands,
     /*  73141 */     // GIR_Coverage, 167,
     /*  73141 */     GIR_EraseRootFromParent_Done,
     /*  73142 */   // Label 1224: @73142
     /*  73142 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73200), // Rule ID 13168 //
     /*  73147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73185 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73198 */     GIR_RootConstrainSelectedInstOperands,
     /*  73199 */     // GIR_Coverage, 13168,
     /*  73199 */     GIR_EraseRootFromParent_Done,
     /*  73200 */   // Label 1225: @73200
     /*  73200 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73255), // Rule ID 13171 //
     /*  73205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73242 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73253 */     GIR_RootConstrainSelectedInstOperands,
     /*  73254 */     // GIR_Coverage, 13171,
     /*  73254 */     GIR_EraseRootFromParent_Done,
     /*  73255 */   // Label 1226: @73255
     /*  73255 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73355), // Rule ID 1613 //
     /*  73260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73283 */     // MIs[1] Operand 1
     /*  73283 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  73300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  73304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73318 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73324 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73326 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73330 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73338 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73340 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  73340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  73343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73353 */     GIR_RootConstrainSelectedInstOperands,
     /*  73354 */     // GIR_Coverage, 1613,
     /*  73354 */     GIR_EraseRootFromParent_Done,
     /*  73355 */   // Label 1227: @73355
     /*  73355 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(73396), // Rule ID 145 //
     /*  73360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  73364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73376 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  73380 */     // MIs[1] Operand 1
     /*  73380 */     // No operand predicates
     /*  73380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73382 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  73382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  73385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73389 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  73394 */     GIR_RootConstrainSelectedInstOperands,
     /*  73395 */     // GIR_Coverage, 145,
     /*  73395 */     GIR_EraseRootFromParent_Done,
     /*  73396 */   // Label 1228: @73396
     /*  73396 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73429), // Rule ID 13173 //
     /*  73401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73416 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73427 */     GIR_RootConstrainSelectedInstOperands,
     /*  73428 */     // GIR_Coverage, 13173,
     /*  73428 */     GIR_EraseRootFromParent_Done,
     /*  73429 */   // Label 1229: @73429
     /*  73429 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(73462), // Rule ID 171 //
     /*  73434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73449 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73460 */     GIR_RootConstrainSelectedInstOperands,
     /*  73461 */     // GIR_Coverage, 171,
     /*  73461 */     GIR_EraseRootFromParent_Done,
     /*  73462 */   // Label 1230: @73462
     /*  73462 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(73515), // Rule ID 13160 //
     /*  73467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73492 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73502 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73513 */     GIR_RootConstrainSelectedInstOperands,
     /*  73514 */     // GIR_Coverage, 13160,
     /*  73514 */     GIR_EraseRootFromParent_Done,
     /*  73515 */   // Label 1231: @73515
     /*  73515 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(73571), // Rule ID 165 //
     /*  73520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73556 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73569 */     GIR_RootConstrainSelectedInstOperands,
     /*  73570 */     // GIR_Coverage, 165,
     /*  73570 */     GIR_EraseRootFromParent_Done,
     /*  73571 */   // Label 1232: @73571
     /*  73571 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(73624), // Rule ID 13161 //
     /*  73576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73611 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73622 */     GIR_RootConstrainSelectedInstOperands,
     /*  73623 */     // GIR_Coverage, 13161,
     /*  73623 */     GIR_EraseRootFromParent_Done,
     /*  73624 */   // Label 1233: @73624
     /*  73624 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(73656), // Rule ID 3995 //
     /*  73629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73641 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  73641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  73644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  73654 */     GIR_RootConstrainSelectedInstOperands,
     /*  73655 */     // GIR_Coverage, 3995,
     /*  73655 */     GIR_EraseRootFromParent_Done,
     /*  73656 */   // Label 1234: @73656
     /*  73656 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(73692), // Rule ID 4941 //
     /*  73661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73683 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  73683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73690 */     GIR_RootConstrainSelectedInstOperands,
     /*  73691 */     // GIR_Coverage, 4941,
     /*  73691 */     GIR_EraseRootFromParent_Done,
     /*  73692 */   // Label 1235: @73692
     /*  73692 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(73716), // Rule ID 169 //
     /*  73697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73709 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  73714 */     GIR_RootConstrainSelectedInstOperands,
     /*  73715 */     // GIR_Coverage, 169,
     /*  73715 */     GIR_Done,
     /*  73716 */   // Label 1236: @73716
     /*  73716 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(73743), // Rule ID 5037 //
     /*  73721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73736 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  73736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73741 */     GIR_RootConstrainSelectedInstOperands,
     /*  73742 */     // GIR_Coverage, 5037,
     /*  73742 */     GIR_Done,
     /*  73743 */   // Label 1237: @73743
     /*  73743 */   GIM_Reject,
     /*  73744 */ // Label 1220: @73744
     /*  73744 */ GIM_Reject,
     /*  73745 */ // Label 1188: @73745
     /*  73745 */ GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(73979),
     /*  73750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73760 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(73856), // Rule ID 1160 //
     /*  73765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73780 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73784 */     // MIs[1] Operand 1
     /*  73784 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73831 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73837 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73841 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  73841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73854 */     GIR_RootConstrainSelectedInstOperands,
     /*  73855 */     // GIR_Coverage, 1160,
     /*  73855 */     GIR_EraseRootFromParent_Done,
     /*  73856 */   // Label 1239: @73856
     /*  73856 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(73923), // Rule ID 4985 //
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73873 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73877 */     // MIs[1] Operand 1
     /*  73877 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  73886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73892 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  73894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  73898 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73908 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  73908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73921 */     GIR_RootConstrainSelectedInstOperands,
     /*  73922 */     // GIR_Coverage, 4985,
     /*  73922 */     GIR_EraseRootFromParent_Done,
     /*  73923 */   // Label 1240: @73923
     /*  73923 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(73955), // Rule ID 4939 //
     /*  73928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73936 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73946 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73953 */     GIR_RootConstrainSelectedInstOperands,
     /*  73954 */     // GIR_Coverage, 4939,
     /*  73954 */     GIR_EraseRootFromParent_Done,
     /*  73955 */   // Label 1241: @73955
     /*  73955 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(73978), // Rule ID 5036 //
     /*  73960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73971 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  73971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73976 */     GIR_RootConstrainSelectedInstOperands,
     /*  73977 */     // GIR_Coverage, 5036,
     /*  73977 */     GIR_Done,
     /*  73978 */   // Label 1242: @73978
     /*  73978 */   GIM_Reject,
     /*  73979 */ // Label 1238: @73979
     /*  73979 */ GIM_Reject,
     /*  73980 */ // Label 1189: @73980
     /*  73980 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74668),
     /*  73985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  73988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  73991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73995 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74091), // Rule ID 1162 //
     /*  74000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74019 */     // MIs[1] Operand 1
     /*  74019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74054 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74060 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74066 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74074 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74076 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74089 */     GIR_RootConstrainSelectedInstOperands,
     /*  74090 */     // GIR_Coverage, 1162,
     /*  74090 */     GIR_EraseRootFromParent_Done,
     /*  74091 */   // Label 1244: @74091
     /*  74091 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74158), // Rule ID 4987 //
     /*  74096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74112 */     // MIs[1] Operand 1
     /*  74112 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74121 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74133 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74139 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74143 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74156 */     GIR_RootConstrainSelectedInstOperands,
     /*  74157 */     // GIR_Coverage, 4987,
     /*  74157 */     GIR_EraseRootFromParent_Done,
     /*  74158 */   // Label 1245: @74158
     /*  74158 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74243), // Rule ID 13695 //
     /*  74163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74207 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74213 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74226 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74241 */     GIR_RootConstrainSelectedInstOperands,
     /*  74242 */     // GIR_Coverage, 13695,
     /*  74242 */     GIR_EraseRootFromParent_Done,
     /*  74243 */   // Label 1246: @74243
     /*  74243 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74328), // Rule ID 13694 //
     /*  74248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74297 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74311 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74326 */     GIR_RootConstrainSelectedInstOperands,
     /*  74327 */     // GIR_Coverage, 13694,
     /*  74327 */     GIR_EraseRootFromParent_Done,
     /*  74328 */   // Label 1247: @74328
     /*  74328 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74413), // Rule ID 13693 //
     /*  74333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74381 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74396 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74411 */     GIR_RootConstrainSelectedInstOperands,
     /*  74412 */     // GIR_Coverage, 13693,
     /*  74412 */     GIR_EraseRootFromParent_Done,
     /*  74413 */   // Label 1248: @74413
     /*  74413 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74498), // Rule ID 3822 //
     /*  74418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74471 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74477 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74481 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74496 */     GIR_RootConstrainSelectedInstOperands,
     /*  74497 */     // GIR_Coverage, 3822,
     /*  74497 */     GIR_EraseRootFromParent_Done,
     /*  74498 */   // Label 1249: @74498
     /*  74498 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74530), // Rule ID 4942 //
     /*  74503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74511 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74521 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  74521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  74524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74528 */     GIR_RootConstrainSelectedInstOperands,
     /*  74529 */     // GIR_Coverage, 4942,
     /*  74529 */     GIR_EraseRootFromParent_Done,
     /*  74530 */   // Label 1250: @74530
     /*  74530 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(74587), // Rule ID 3818 //
     /*  74535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74570 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  74585 */     GIR_RootConstrainSelectedInstOperands,
     /*  74586 */     // GIR_Coverage, 3818,
     /*  74586 */     GIR_EraseRootFromParent_Done,
     /*  74587 */   // Label 1251: @74587
     /*  74587 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74644), // Rule ID 13683 //
     /*  74592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74627 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  74642 */     GIR_RootConstrainSelectedInstOperands,
     /*  74643 */     // GIR_Coverage, 13683,
     /*  74643 */     GIR_EraseRootFromParent_Done,
     /*  74644 */   // Label 1252: @74644
     /*  74644 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74667), // Rule ID 5040 //
     /*  74649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74660 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  74660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  74665 */     GIR_RootConstrainSelectedInstOperands,
     /*  74666 */     // GIR_Coverage, 5040,
     /*  74666 */     GIR_Done,
     /*  74667 */   // Label 1253: @74667
     /*  74667 */   GIM_Reject,
     /*  74668 */ // Label 1243: @74668
     /*  74668 */ GIM_Reject,
     /*  74669 */ // Label 1190: @74669
     /*  74669 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(74903),
     /*  74674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74684 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(74780), // Rule ID 1158 //
     /*  74689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74708 */     // MIs[1] Operand 1
     /*  74708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74743 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74755 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74763 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74765 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  74765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74778 */     GIR_RootConstrainSelectedInstOperands,
     /*  74779 */     // GIR_Coverage, 1158,
     /*  74779 */     GIR_EraseRootFromParent_Done,
     /*  74780 */   // Label 1255: @74780
     /*  74780 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(74847), // Rule ID 4983 //
     /*  74785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74801 */     // MIs[1] Operand 1
     /*  74801 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74810 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74822 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74828 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74832 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  74832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74845 */     GIR_RootConstrainSelectedInstOperands,
     /*  74846 */     // GIR_Coverage, 4983,
     /*  74846 */     GIR_EraseRootFromParent_Done,
     /*  74847 */   // Label 1256: @74847
     /*  74847 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(74879), // Rule ID 4937 //
     /*  74852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74870 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  74870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74877 */     GIR_RootConstrainSelectedInstOperands,
     /*  74878 */     // GIR_Coverage, 4937,
     /*  74878 */     GIR_EraseRootFromParent_Done,
     /*  74879 */   // Label 1257: @74879
     /*  74879 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(74902), // Rule ID 5035 //
     /*  74884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74895 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  74895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74900 */     GIR_RootConstrainSelectedInstOperands,
     /*  74901 */     // GIR_Coverage, 5035,
     /*  74901 */     GIR_Done,
     /*  74902 */   // Label 1258: @74902
     /*  74902 */   GIM_Reject,
     /*  74903 */ // Label 1254: @74903
     /*  74903 */ GIM_Reject,
     /*  74904 */ // Label 1191: @74904
     /*  74904 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75592),
     /*  74909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74919 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75015), // Rule ID 1161 //
     /*  74924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74939 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74943 */     // MIs[1] Operand 1
     /*  74943 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74978 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74990 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74998 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75000 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75013 */     GIR_RootConstrainSelectedInstOperands,
     /*  75014 */     // GIR_Coverage, 1161,
     /*  75014 */     GIR_EraseRootFromParent_Done,
     /*  75015 */   // Label 1260: @75015
     /*  75015 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75082), // Rule ID 4986 //
     /*  75020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75036 */     // MIs[1] Operand 1
     /*  75036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75045 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75051 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75057 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75067 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75080 */     GIR_RootConstrainSelectedInstOperands,
     /*  75081 */     // GIR_Coverage, 4986,
     /*  75081 */     GIR_EraseRootFromParent_Done,
     /*  75082 */   // Label 1261: @75082
     /*  75082 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75167), // Rule ID 13692 //
     /*  75087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75131 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75137 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75150 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75165 */     GIR_RootConstrainSelectedInstOperands,
     /*  75166 */     // GIR_Coverage, 13692,
     /*  75166 */     GIR_EraseRootFromParent_Done,
     /*  75167 */   // Label 1262: @75167
     /*  75167 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75252), // Rule ID 13691 //
     /*  75172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75235 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75250 */     GIR_RootConstrainSelectedInstOperands,
     /*  75251 */     // GIR_Coverage, 13691,
     /*  75251 */     GIR_EraseRootFromParent_Done,
     /*  75252 */   // Label 1263: @75252
     /*  75252 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75337), // Rule ID 13690 //
     /*  75257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75305 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75311 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75320 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75335 */     GIR_RootConstrainSelectedInstOperands,
     /*  75336 */     // GIR_Coverage, 13690,
     /*  75336 */     GIR_EraseRootFromParent_Done,
     /*  75337 */   // Label 1264: @75337
     /*  75337 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75422), // Rule ID 3821 //
     /*  75342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75395 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75405 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75420 */     GIR_RootConstrainSelectedInstOperands,
     /*  75421 */     // GIR_Coverage, 3821,
     /*  75421 */     GIR_EraseRootFromParent_Done,
     /*  75422 */   // Label 1265: @75422
     /*  75422 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75454), // Rule ID 4940 //
     /*  75427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75445 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  75445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75452 */     GIR_RootConstrainSelectedInstOperands,
     /*  75453 */     // GIR_Coverage, 4940,
     /*  75453 */     GIR_EraseRootFromParent_Done,
     /*  75454 */   // Label 1266: @75454
     /*  75454 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(75511), // Rule ID 3817 //
     /*  75459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75494 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75509 */     GIR_RootConstrainSelectedInstOperands,
     /*  75510 */     // GIR_Coverage, 3817,
     /*  75510 */     GIR_EraseRootFromParent_Done,
     /*  75511 */   // Label 1267: @75511
     /*  75511 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75568), // Rule ID 13682 //
     /*  75516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75551 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75566 */     GIR_RootConstrainSelectedInstOperands,
     /*  75567 */     // GIR_Coverage, 13682,
     /*  75567 */     GIR_EraseRootFromParent_Done,
     /*  75568 */   // Label 1268: @75568
     /*  75568 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75591), // Rule ID 5039 //
     /*  75573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75584 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  75584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75589 */     GIR_RootConstrainSelectedInstOperands,
     /*  75590 */     // GIR_Coverage, 5039,
     /*  75590 */     GIR_Done,
     /*  75591 */   // Label 1269: @75591
     /*  75591 */   GIM_Reject,
     /*  75592 */ // Label 1259: @75592
     /*  75592 */ GIM_Reject,
     /*  75593 */ // Label 1192: @75593
     /*  75593 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(75830),
     /*  75598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75608 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75704), // Rule ID 1156 //
     /*  75613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75628 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75632 */     // MIs[1] Operand 1
     /*  75632 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75689 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75702 */     GIR_RootConstrainSelectedInstOperands,
     /*  75703 */     // GIR_Coverage, 1156,
     /*  75703 */     GIR_EraseRootFromParent_Done,
     /*  75704 */   // Label 1271: @75704
     /*  75704 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(75771), // Rule ID 4981 //
     /*  75709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75721 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75725 */     // MIs[1] Operand 1
     /*  75725 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75734 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75740 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75746 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75752 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75756 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  75756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75769 */     GIR_RootConstrainSelectedInstOperands,
     /*  75770 */     // GIR_Coverage, 4981,
     /*  75770 */     GIR_EraseRootFromParent_Done,
     /*  75771 */   // Label 1272: @75771
     /*  75771 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(75806), // Rule ID 972 //
     /*  75776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75793 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75797 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  75797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75804 */     GIR_RootConstrainSelectedInstOperands,
     /*  75805 */     // GIR_Coverage, 972,
     /*  75805 */     GIR_EraseRootFromParent_Done,
     /*  75806 */   // Label 1273: @75806
     /*  75806 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(75829), // Rule ID 1599 //
     /*  75811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75822 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75827 */     GIR_RootConstrainSelectedInstOperands,
     /*  75828 */     // GIR_Coverage, 1599,
     /*  75828 */     GIR_Done,
     /*  75829 */   // Label 1274: @75829
     /*  75829 */   GIM_Reject,
     /*  75830 */ // Label 1270: @75830
     /*  75830 */ GIM_Reject,
     /*  75831 */ // Label 1193: @75831
     /*  75831 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76519),
     /*  75836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75846 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(75942), // Rule ID 1159 //
     /*  75851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75866 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75870 */     // MIs[1] Operand 1
     /*  75870 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75905 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75911 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75913 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75917 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75927 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  75927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  75930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75940 */     GIR_RootConstrainSelectedInstOperands,
     /*  75941 */     // GIR_Coverage, 1159,
     /*  75941 */     GIR_EraseRootFromParent_Done,
     /*  75942 */   // Label 1276: @75942
     /*  75942 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76009), // Rule ID 4984 //
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75963 */     // MIs[1] Operand 1
     /*  75963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75972 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75978 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75984 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75990 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75994 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  75994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  75997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76007 */     GIR_RootConstrainSelectedInstOperands,
     /*  76008 */     // GIR_Coverage, 4984,
     /*  76008 */     GIR_EraseRootFromParent_Done,
     /*  76009 */   // Label 1277: @76009
     /*  76009 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(76094), // Rule ID 13689 //
     /*  76014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76058 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76064 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76077 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76092 */     GIR_RootConstrainSelectedInstOperands,
     /*  76093 */     // GIR_Coverage, 13689,
     /*  76093 */     GIR_EraseRootFromParent_Done,
     /*  76094 */   // Label 1278: @76094
     /*  76094 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76179), // Rule ID 13688 //
     /*  76099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76148 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76162 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76177 */     GIR_RootConstrainSelectedInstOperands,
     /*  76178 */     // GIR_Coverage, 13688,
     /*  76178 */     GIR_EraseRootFromParent_Done,
     /*  76179 */   // Label 1279: @76179
     /*  76179 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76264), // Rule ID 13687 //
     /*  76184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76232 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76247 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76262 */     GIR_RootConstrainSelectedInstOperands,
     /*  76263 */     // GIR_Coverage, 13687,
     /*  76263 */     GIR_EraseRootFromParent_Done,
     /*  76264 */   // Label 1280: @76264
     /*  76264 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76349), // Rule ID 3820 //
     /*  76269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76322 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76332 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76347 */     GIR_RootConstrainSelectedInstOperands,
     /*  76348 */     // GIR_Coverage, 3820,
     /*  76348 */     GIR_EraseRootFromParent_Done,
     /*  76349 */   // Label 1281: @76349
     /*  76349 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76381), // Rule ID 4938 //
     /*  76354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76362 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76368 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76372 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  76372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76379 */     GIR_RootConstrainSelectedInstOperands,
     /*  76380 */     // GIR_Coverage, 4938,
     /*  76380 */     GIR_EraseRootFromParent_Done,
     /*  76381 */   // Label 1282: @76381
     /*  76381 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76438), // Rule ID 3816 //
     /*  76386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76421 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76436 */     GIR_RootConstrainSelectedInstOperands,
     /*  76437 */     // GIR_Coverage, 3816,
     /*  76437 */     GIR_EraseRootFromParent_Done,
     /*  76438 */   // Label 1283: @76438
     /*  76438 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(76495), // Rule ID 13681 //
     /*  76443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76478 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76493 */     GIR_RootConstrainSelectedInstOperands,
     /*  76494 */     // GIR_Coverage, 13681,
     /*  76494 */     GIR_EraseRootFromParent_Done,
     /*  76495 */   // Label 1284: @76495
     /*  76495 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(76518), // Rule ID 5038 //
     /*  76500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76511 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  76511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76516 */     GIR_RootConstrainSelectedInstOperands,
     /*  76517 */     // GIR_Coverage, 5038,
     /*  76517 */     GIR_Done,
     /*  76518 */   // Label 1285: @76518
     /*  76518 */   GIM_Reject,
     /*  76519 */ // Label 1275: @76519
     /*  76519 */ GIM_Reject,
     /*  76520 */ // Label 1194: @76520
     /*  76520 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(77211),
     /*  76525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76535 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(76631), // Rule ID 1157 //
     /*  76540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76559 */     // MIs[1] Operand 1
     /*  76559 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76594 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76606 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76616 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  76616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76629 */     GIR_RootConstrainSelectedInstOperands,
     /*  76630 */     // GIR_Coverage, 1157,
     /*  76630 */     GIR_EraseRootFromParent_Done,
     /*  76631 */   // Label 1287: @76631
     /*  76631 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(76698), // Rule ID 4982 //
     /*  76636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76648 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76652 */     // MIs[1] Operand 1
     /*  76652 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76661 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76673 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76683 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  76683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76696 */     GIR_RootConstrainSelectedInstOperands,
     /*  76697 */     // GIR_Coverage, 4982,
     /*  76697 */     GIR_EraseRootFromParent_Done,
     /*  76698 */   // Label 1288: @76698
     /*  76698 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(76783), // Rule ID 13686 //
     /*  76703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76747 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76753 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76766 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76781 */     GIR_RootConstrainSelectedInstOperands,
     /*  76782 */     // GIR_Coverage, 13686,
     /*  76782 */     GIR_EraseRootFromParent_Done,
     /*  76783 */   // Label 1289: @76783
     /*  76783 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(76868), // Rule ID 13685 //
     /*  76788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76837 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76851 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76866 */     GIR_RootConstrainSelectedInstOperands,
     /*  76867 */     // GIR_Coverage, 13685,
     /*  76867 */     GIR_EraseRootFromParent_Done,
     /*  76868 */   // Label 1290: @76868
     /*  76868 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(76953), // Rule ID 13684 //
     /*  76873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76921 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76927 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76936 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76951 */     GIR_RootConstrainSelectedInstOperands,
     /*  76952 */     // GIR_Coverage, 13684,
     /*  76952 */     GIR_EraseRootFromParent_Done,
     /*  76953 */   // Label 1291: @76953
     /*  76953 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77038), // Rule ID 3819 //
     /*  76958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77011 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77017 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77021 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77036 */     GIR_RootConstrainSelectedInstOperands,
     /*  77037 */     // GIR_Coverage, 3819,
     /*  77037 */     GIR_EraseRootFromParent_Done,
     /*  77038 */   // Label 1292: @77038
     /*  77038 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77073), // Rule ID 973 //
     /*  77043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77054 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77064 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77071 */     GIR_RootConstrainSelectedInstOperands,
     /*  77072 */     // GIR_Coverage, 973,
     /*  77072 */     GIR_EraseRootFromParent_Done,
     /*  77073 */   // Label 1293: @77073
     /*  77073 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77130), // Rule ID 3815 //
     /*  77078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77113 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77128 */     GIR_RootConstrainSelectedInstOperands,
     /*  77129 */     // GIR_Coverage, 3815,
     /*  77129 */     GIR_EraseRootFromParent_Done,
     /*  77130 */   // Label 1294: @77130
     /*  77130 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77187), // Rule ID 13680 //
     /*  77135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77170 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77185 */     GIR_RootConstrainSelectedInstOperands,
     /*  77186 */     // GIR_Coverage, 13680,
     /*  77186 */     GIR_EraseRootFromParent_Done,
     /*  77187 */   // Label 1295: @77187
     /*  77187 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77210), // Rule ID 1600 //
     /*  77192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77203 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77208 */     GIR_RootConstrainSelectedInstOperands,
     /*  77209 */     // GIR_Coverage, 1600,
     /*  77209 */     GIR_Done,
     /*  77210 */   // Label 1296: @77210
     /*  77210 */   GIM_Reject,
     /*  77211 */ // Label 1286: @77211
     /*  77211 */ GIM_Reject,
     /*  77212 */ // Label 1195: @77212
     /*  77212 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77261), // Rule ID 8389 //
     /*  77217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77230 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77242 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77255 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77257 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77259 */   GIR_RootConstrainSelectedInstOperands,
     /*  77260 */   // GIR_Coverage, 8389,
     /*  77260 */   GIR_EraseRootFromParent_Done,
     /*  77261 */ // Label 1297: @77261
     /*  77261 */ GIM_Reject,
     /*  77262 */ // Label 1196: @77262
     /*  77262 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77311), // Rule ID 8388 //
     /*  77267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77280 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77292 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77307 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77309 */   GIR_RootConstrainSelectedInstOperands,
     /*  77310 */   // GIR_Coverage, 8388,
     /*  77310 */   GIR_EraseRootFromParent_Done,
     /*  77311 */ // Label 1298: @77311
     /*  77311 */ GIM_Reject,
     /*  77312 */ // Label 1197: @77312
     /*  77312 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77774),
     /*  77317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77327 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77398), // Rule ID 15532 //
     /*  77332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77381 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77396 */     GIR_RootConstrainSelectedInstOperands,
     /*  77397 */     // GIR_Coverage, 15532,
     /*  77397 */     GIR_EraseRootFromParent_Done,
     /*  77398 */   // Label 1300: @77398
     /*  77398 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(77469), // Rule ID 15531 //
     /*  77403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77452 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77467 */     GIR_RootConstrainSelectedInstOperands,
     /*  77468 */     // GIR_Coverage, 15531,
     /*  77468 */     GIR_EraseRootFromParent_Done,
     /*  77469 */   // Label 1301: @77469
     /*  77469 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(77540), // Rule ID 15530 //
     /*  77474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77523 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77538 */     GIR_RootConstrainSelectedInstOperands,
     /*  77539 */     // GIR_Coverage, 15530,
     /*  77539 */     GIR_EraseRootFromParent_Done,
     /*  77540 */   // Label 1302: @77540
     /*  77540 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(77611), // Rule ID 11799 //
     /*  77545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77594 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77609 */     GIR_RootConstrainSelectedInstOperands,
     /*  77610 */     // GIR_Coverage, 11799,
     /*  77610 */     GIR_EraseRootFromParent_Done,
     /*  77611 */   // Label 1303: @77611
     /*  77611 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(77672), // Rule ID 11823 //
     /*  77616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  77627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  77639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77643 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  77651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77653 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  77656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  77666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77670 */     GIR_RootConstrainSelectedInstOperands,
     /*  77671 */     // GIR_Coverage, 11823,
     /*  77671 */     GIR_EraseRootFromParent_Done,
     /*  77672 */   // Label 1304: @77672
     /*  77672 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(77715), // Rule ID 13647 //
     /*  77677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77698 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  77713 */     GIR_RootConstrainSelectedInstOperands,
     /*  77714 */     // GIR_Coverage, 13647,
     /*  77714 */     GIR_EraseRootFromParent_Done,
     /*  77715 */   // Label 1305: @77715
     /*  77715 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(77758), // Rule ID 3154 //
     /*  77720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77741 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77756 */     GIR_RootConstrainSelectedInstOperands,
     /*  77757 */     // GIR_Coverage, 3154,
     /*  77757 */     GIR_EraseRootFromParent_Done,
     /*  77758 */   // Label 1306: @77758
     /*  77758 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(77773), // Rule ID 7412 //
     /*  77763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77766 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  77771 */     GIR_RootConstrainSelectedInstOperands,
     /*  77772 */     // GIR_Coverage, 7412,
     /*  77772 */     GIR_Done,
     /*  77773 */   // Label 1307: @77773
     /*  77773 */   GIM_Reject,
     /*  77774 */ // Label 1299: @77774
     /*  77774 */ GIM_Reject,
     /*  77775 */ // Label 1198: @77775
     /*  77775 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(77824), // Rule ID 8387 //
     /*  77780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77793 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  77800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77805 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77822 */   GIR_RootConstrainSelectedInstOperands,
     /*  77823 */   // GIR_Coverage, 8387,
     /*  77823 */   GIR_EraseRootFromParent_Done,
     /*  77824 */ // Label 1308: @77824
     /*  77824 */ GIM_Reject,
     /*  77825 */ // Label 1199: @77825
     /*  77825 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78287),
     /*  77830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77840 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(77911), // Rule ID 15529 //
     /*  77845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77894 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77909 */     GIR_RootConstrainSelectedInstOperands,
     /*  77910 */     // GIR_Coverage, 15529,
     /*  77910 */     GIR_EraseRootFromParent_Done,
     /*  77911 */   // Label 1310: @77911
     /*  77911 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(77982), // Rule ID 15528 //
     /*  77916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77955 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77965 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77980 */     GIR_RootConstrainSelectedInstOperands,
     /*  77981 */     // GIR_Coverage, 15528,
     /*  77981 */     GIR_EraseRootFromParent_Done,
     /*  77982 */   // Label 1311: @77982
     /*  77982 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78053), // Rule ID 15527 //
     /*  77987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78036 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78051 */     GIR_RootConstrainSelectedInstOperands,
     /*  78052 */     // GIR_Coverage, 15527,
     /*  78052 */     GIR_EraseRootFromParent_Done,
     /*  78053 */   // Label 1312: @78053
     /*  78053 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78124), // Rule ID 11797 //
     /*  78058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78097 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78103 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78107 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78122 */     GIR_RootConstrainSelectedInstOperands,
     /*  78123 */     // GIR_Coverage, 11797,
     /*  78123 */     GIR_EraseRootFromParent_Done,
     /*  78124 */   // Label 1313: @78124
     /*  78124 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78185), // Rule ID 11821 //
     /*  78129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78156 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78166 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78183 */     GIR_RootConstrainSelectedInstOperands,
     /*  78184 */     // GIR_Coverage, 11821,
     /*  78184 */     GIR_EraseRootFromParent_Done,
     /*  78185 */   // Label 1314: @78185
     /*  78185 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78228), // Rule ID 13646 //
     /*  78190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78211 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78226 */     GIR_RootConstrainSelectedInstOperands,
     /*  78227 */     // GIR_Coverage, 13646,
     /*  78227 */     GIR_EraseRootFromParent_Done,
     /*  78228 */   // Label 1315: @78228
     /*  78228 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78271), // Rule ID 3152 //
     /*  78233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78254 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78269 */     GIR_RootConstrainSelectedInstOperands,
     /*  78270 */     // GIR_Coverage, 3152,
     /*  78270 */     GIR_EraseRootFromParent_Done,
     /*  78271 */   // Label 1316: @78271
     /*  78271 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78286), // Rule ID 7411 //
     /*  78276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78279 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78284 */     GIR_RootConstrainSelectedInstOperands,
     /*  78285 */     // GIR_Coverage, 7411,
     /*  78285 */     GIR_Done,
     /*  78286 */   // Label 1317: @78286
     /*  78286 */   GIM_Reject,
     /*  78287 */ // Label 1309: @78287
     /*  78287 */ GIM_Reject,
     /*  78288 */ // Label 1200: @78288
     /*  78288 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78337), // Rule ID 8386 //
     /*  78293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  78299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  78302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78306 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  78306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  78313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78318 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78331 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78333 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78335 */   GIR_RootConstrainSelectedInstOperands,
     /*  78336 */   // GIR_Coverage, 8386,
     /*  78336 */   GIR_EraseRootFromParent_Done,
     /*  78337 */ // Label 1318: @78337
     /*  78337 */ GIM_Reject,
     /*  78338 */ // Label 1201: @78338
     /*  78338 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78800),
     /*  78343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78353 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78424), // Rule ID 15526 //
     /*  78358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78397 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78403 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78407 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78422 */     GIR_RootConstrainSelectedInstOperands,
     /*  78423 */     // GIR_Coverage, 15526,
     /*  78423 */     GIR_EraseRootFromParent_Done,
     /*  78424 */   // Label 1320: @78424
     /*  78424 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(78495), // Rule ID 15525 //
     /*  78429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78468 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78478 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78493 */     GIR_RootConstrainSelectedInstOperands,
     /*  78494 */     // GIR_Coverage, 15525,
     /*  78494 */     GIR_EraseRootFromParent_Done,
     /*  78495 */   // Label 1321: @78495
     /*  78495 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(78566), // Rule ID 15524 //
     /*  78500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78539 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78549 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78564 */     GIR_RootConstrainSelectedInstOperands,
     /*  78565 */     // GIR_Coverage, 15524,
     /*  78565 */     GIR_EraseRootFromParent_Done,
     /*  78566 */   // Label 1322: @78566
     /*  78566 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(78637), // Rule ID 11795 //
     /*  78571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78610 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78620 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78635 */     GIR_RootConstrainSelectedInstOperands,
     /*  78636 */     // GIR_Coverage, 11795,
     /*  78636 */     GIR_EraseRootFromParent_Done,
     /*  78637 */   // Label 1323: @78637
     /*  78637 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78698), // Rule ID 11819 //
     /*  78642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78661 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  78665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78669 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78679 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78696 */     GIR_RootConstrainSelectedInstOperands,
     /*  78697 */     // GIR_Coverage, 11819,
     /*  78697 */     GIR_EraseRootFromParent_Done,
     /*  78698 */   // Label 1324: @78698
     /*  78698 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(78741), // Rule ID 13645 //
     /*  78703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78724 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78739 */     GIR_RootConstrainSelectedInstOperands,
     /*  78740 */     // GIR_Coverage, 13645,
     /*  78740 */     GIR_EraseRootFromParent_Done,
     /*  78741 */   // Label 1325: @78741
     /*  78741 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(78784), // Rule ID 3150 //
     /*  78746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78767 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78782 */     GIR_RootConstrainSelectedInstOperands,
     /*  78783 */     // GIR_Coverage, 3150,
     /*  78783 */     GIR_EraseRootFromParent_Done,
     /*  78784 */   // Label 1326: @78784
     /*  78784 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(78799), // Rule ID 7410 //
     /*  78789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78792 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  78792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78797 */     GIR_RootConstrainSelectedInstOperands,
     /*  78798 */     // GIR_Coverage, 7410,
     /*  78798 */     GIR_Done,
     /*  78799 */   // Label 1327: @78799
     /*  78799 */   GIM_Reject,
     /*  78800 */ // Label 1319: @78800
     /*  78800 */ GIM_Reject,
     /*  78801 */ // Label 1202: @78801
     /*  78801 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(78850), // Rule ID 8385 //
     /*  78806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  78812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  78815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78819 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  78819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  78826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78831 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78844 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78846 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78848 */   GIR_RootConstrainSelectedInstOperands,
     /*  78849 */   // GIR_Coverage, 8385,
     /*  78849 */   GIR_EraseRootFromParent_Done,
     /*  78850 */ // Label 1328: @78850
     /*  78850 */ GIM_Reject,
     /*  78851 */ // Label 1203: @78851
     /*  78851 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79313),
     /*  78856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78866 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(78937), // Rule ID 15523 //
     /*  78871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78910 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78920 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78935 */     GIR_RootConstrainSelectedInstOperands,
     /*  78936 */     // GIR_Coverage, 15523,
     /*  78936 */     GIR_EraseRootFromParent_Done,
     /*  78937 */   // Label 1330: @78937
     /*  78937 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79008), // Rule ID 15522 //
     /*  78942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78991 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79006 */     GIR_RootConstrainSelectedInstOperands,
     /*  79007 */     // GIR_Coverage, 15522,
     /*  79007 */     GIR_EraseRootFromParent_Done,
     /*  79008 */   // Label 1331: @79008
     /*  79008 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(79079), // Rule ID 15521 //
     /*  79013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79052 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79062 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79077 */     GIR_RootConstrainSelectedInstOperands,
     /*  79078 */     // GIR_Coverage, 15521,
     /*  79078 */     GIR_EraseRootFromParent_Done,
     /*  79079 */   // Label 1332: @79079
     /*  79079 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79150), // Rule ID 11793 //
     /*  79084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79123 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79133 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79148 */     GIR_RootConstrainSelectedInstOperands,
     /*  79149 */     // GIR_Coverage, 11793,
     /*  79149 */     GIR_EraseRootFromParent_Done,
     /*  79150 */   // Label 1333: @79150
     /*  79150 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79211), // Rule ID 11817 //
     /*  79155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79174 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79182 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79192 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79209 */     GIR_RootConstrainSelectedInstOperands,
     /*  79210 */     // GIR_Coverage, 11817,
     /*  79210 */     GIR_EraseRootFromParent_Done,
     /*  79211 */   // Label 1334: @79211
     /*  79211 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79254), // Rule ID 13644 //
     /*  79216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79237 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79252 */     GIR_RootConstrainSelectedInstOperands,
     /*  79253 */     // GIR_Coverage, 13644,
     /*  79253 */     GIR_EraseRootFromParent_Done,
     /*  79254 */   // Label 1335: @79254
     /*  79254 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79297), // Rule ID 3148 //
     /*  79259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79280 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79295 */     GIR_RootConstrainSelectedInstOperands,
     /*  79296 */     // GIR_Coverage, 3148,
     /*  79296 */     GIR_EraseRootFromParent_Done,
     /*  79297 */   // Label 1336: @79297
     /*  79297 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(79312), // Rule ID 7409 //
     /*  79302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79305 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  79305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79310 */     GIR_RootConstrainSelectedInstOperands,
     /*  79311 */     // GIR_Coverage, 7409,
     /*  79311 */     GIR_Done,
     /*  79312 */   // Label 1337: @79312
     /*  79312 */   GIM_Reject,
     /*  79313 */ // Label 1329: @79313
     /*  79313 */ GIM_Reject,
     /*  79314 */ // Label 1204: @79314
     /*  79314 */ GIM_Reject,
     /*  79315 */ // Label 8: @79315
     /*  79315 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(86838),
     /*  79320 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  79323 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1350*/ GIMT_Encode4(86837),
     /*  79334 */   /*GILLT_v2s64*//*Label 1339*/ GIMT_Encode4(79402), GIMT_Encode4(0),
     /*  79342 */   /*GILLT_v4s32*//*Label 1340*/ GIMT_Encode4(79923), GIMT_Encode4(0),
     /*  79350 */   /*GILLT_v8s16*//*Label 1341*/ GIMT_Encode4(82335),
     /*  79354 */   /*GILLT_v16s8*//*Label 1342*/ GIMT_Encode4(84744), GIMT_Encode4(0),
     /*  79362 */   /*GILLT_nxv2s1*//*Label 1343*/ GIMT_Encode4(86655), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  79378 */   /*GILLT_nxv4s1*//*Label 1344*/ GIMT_Encode4(86681),
     /*  79382 */   /*GILLT_nxv4s16*//*Label 1345*/ GIMT_Encode4(86707),
     /*  79386 */   /*GILLT_nxv4s32*//*Label 1346*/ GIMT_Encode4(86733),
     /*  79390 */   /*GILLT_nxv8s1*//*Label 1347*/ GIMT_Encode4(86759),
     /*  79394 */   /*GILLT_nxv8s16*//*Label 1348*/ GIMT_Encode4(86785),
     /*  79398 */   /*GILLT_nxv16s1*//*Label 1349*/ GIMT_Encode4(86811),
     /*  79402 */   // Label 1339: @79402
     /*  79402 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79922),
     /*  79407 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  79410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  79413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79421 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79483), // Rule ID 5755 //
     /*  79426 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79430 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79436 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79438 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79440 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  79440 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79443 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79447 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79452 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79456 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79458 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79461 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79463 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79466 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79469 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79472 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79482 */       // GIR_Coverage, 5755,
     /*  79482 */       GIR_EraseRootFromParent_Done,
     /*  79483 */     // Label 1352: @79483
     /*  79483 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79545), // Rule ID 5759 //
     /*  79488 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79492 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79498 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79500 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79502 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  79502 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79505 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79509 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79514 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79518 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79520 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79523 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79525 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79528 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79531 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79534 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79539 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79544 */       // GIR_Coverage, 5759,
     /*  79544 */       GIR_EraseRootFromParent_Done,
     /*  79545 */     // Label 1353: @79545
     /*  79545 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79603), // Rule ID 5756 //
     /*  79550 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79554 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79558 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79560 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  79560 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79563 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79567 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79572 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79574 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79577 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79579 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79582 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79584 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79587 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79592 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79597 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79602 */       // GIR_Coverage, 5756,
     /*  79602 */       GIR_EraseRootFromParent_Done,
     /*  79603 */     // Label 1354: @79603
     /*  79603 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79661), // Rule ID 5760 //
     /*  79608 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79612 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79616 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79618 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  79618 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79621 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79625 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79630 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79632 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79635 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79637 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79640 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79642 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79645 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79650 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79655 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79660 */       // GIR_Coverage, 5760,
     /*  79660 */       GIR_EraseRootFromParent_Done,
     /*  79661 */     // Label 1355: @79661
     /*  79661 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79791), // Rule ID 5754 //
     /*  79666 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79670 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79670 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79673 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79677 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79682 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79684 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79687 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79691 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79696 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79699 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79703 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79706 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79711 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79716 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79721 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79724 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79728 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79733 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79735 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79738 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79742 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79747 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79750 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79754 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79757 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79762 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79767 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79772 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79775 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79777 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79780 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79783 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79786 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79789 */       GIR_RootConstrainSelectedInstOperands,
     /*  79790 */       // GIR_Coverage, 5754,
     /*  79790 */       GIR_EraseRootFromParent_Done,
     /*  79791 */     // Label 1356: @79791
     /*  79791 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79921), // Rule ID 5758 //
     /*  79796 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79800 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79800 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79803 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79807 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79812 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79814 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79817 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79821 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79826 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79829 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79833 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79836 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79841 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79846 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79851 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79854 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79858 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79863 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79865 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79868 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79872 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79877 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79880 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79884 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79887 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79892 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79897 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79907 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79910 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79913 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79916 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79919 */       GIR_RootConstrainSelectedInstOperands,
     /*  79920 */       // GIR_Coverage, 5758,
     /*  79920 */       GIR_EraseRootFromParent_Done,
     /*  79921 */     // Label 1357: @79921
     /*  79921 */     GIM_Reject,
     /*  79922 */   // Label 1351: @79922
     /*  79922 */   GIM_Reject,
     /*  79923 */   // Label 1340: @79923
     /*  79923 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(82334),
     /*  79928 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  79931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  79934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79938 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80067), // Rule ID 5418 //
     /*  79943 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79947 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79951 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79955 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79959 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79963 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79967 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79971 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79975 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79979 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79983 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79987 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79992 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79996 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80002 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80004 */       // MIs[2] Operand 2
     /*  80004 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80015 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80017 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80017 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80020 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80024 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80029 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80032 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80036 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80044 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80057 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80065 */       GIR_RootConstrainSelectedInstOperands,
     /*  80066 */       // GIR_Coverage, 5418,
     /*  80066 */       GIR_EraseRootFromParent_Done,
     /*  80067 */     // Label 1359: @80067
     /*  80067 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80189), // Rule ID 5414 //
     /*  80072 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80080 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80084 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80088 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80092 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80096 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80100 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80104 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80108 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80112 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80116 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80121 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80126 */       // MIs[2] Operand 2
     /*  80126 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80137 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80139 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80139 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80142 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80146 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80151 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80154 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80158 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80161 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80166 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80171 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80174 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80176 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80179 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80183 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80187 */       GIR_RootConstrainSelectedInstOperands,
     /*  80188 */       // GIR_Coverage, 5414,
     /*  80188 */       GIR_EraseRootFromParent_Done,
     /*  80189 */     // Label 1360: @80189
     /*  80189 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80311), // Rule ID 5416 //
     /*  80194 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80198 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80202 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80206 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80210 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80214 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80218 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80222 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80226 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80230 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80234 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80238 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80243 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80248 */       // MIs[2] Operand 2
     /*  80248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80259 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80261 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80309 */       GIR_RootConstrainSelectedInstOperands,
     /*  80310 */       // GIR_Coverage, 5416,
     /*  80310 */       GIR_EraseRootFromParent_Done,
     /*  80311 */     // Label 1361: @80311
     /*  80311 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80413), // Rule ID 5564 //
     /*  80316 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80320 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80324 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80328 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80332 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80336 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80340 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80345 */       // MIs[2] Operand 2
     /*  80345 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80356 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  80360 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80364 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80368 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  80372 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80376 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80380 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80385 */       // MIs[4] Operand 2
     /*  80385 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  80396 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80398 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  80398 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  80401 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80403 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  80407 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  80411 */       GIR_RootConstrainSelectedInstOperands,
     /*  80412 */       // GIR_Coverage, 5564,
     /*  80412 */       GIR_EraseRootFromParent_Done,
     /*  80413 */     // Label 1362: @80413
     /*  80413 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80542), // Rule ID 6310 //
     /*  80418 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80422 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80426 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80430 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80433 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80438 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80442 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80446 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80451 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  80455 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80457 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  80457 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  80460 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  80464 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80469 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  80472 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  80474 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80477 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80481 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80486 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80488 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80491 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80495 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80500 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80503 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  80507 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80510 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80520 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80525 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  80528 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80530 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80533 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  80537 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80540 */       GIR_RootConstrainSelectedInstOperands,
     /*  80541 */       // GIR_Coverage, 6310,
     /*  80541 */       GIR_EraseRootFromParent_Done,
     /*  80542 */     // Label 1363: @80542
     /*  80542 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80584), // Rule ID 5765 //
     /*  80547 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80554 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80561 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  80561 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80564 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80566 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80571 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80574 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80579 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80582 */       GIR_RootConstrainSelectedInstOperands,
     /*  80583 */       // GIR_Coverage, 5765,
     /*  80583 */       GIR_EraseRootFromParent_Done,
     /*  80584 */     // Label 1364: @80584
     /*  80584 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80626), // Rule ID 5769 //
     /*  80589 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80596 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80603 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  80603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80608 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80613 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80616 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80621 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80624 */       GIR_RootConstrainSelectedInstOperands,
     /*  80625 */       // GIR_Coverage, 5769,
     /*  80625 */       GIR_EraseRootFromParent_Done,
     /*  80626 */     // Label 1365: @80626
     /*  80626 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80749), // Rule ID 2578 //
     /*  80631 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80634 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80638 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80642 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80646 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80649 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80654 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80658 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80662 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80667 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  80671 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80675 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80679 */       // MIs[2] Operand 1
     /*  80679 */       // No operand predicates
     /*  80679 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80681 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80681 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80684 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80688 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80695 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80698 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80702 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80707 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80710 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80714 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80717 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80732 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  80735 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80737 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80740 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80744 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  80747 */       GIR_RootConstrainSelectedInstOperands,
     /*  80748 */       // GIR_Coverage, 2578,
     /*  80748 */       GIR_EraseRootFromParent_Done,
     /*  80749 */     // Label 1366: @80749
     /*  80749 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80872), // Rule ID 6280 //
     /*  80754 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80757 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80761 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80765 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80769 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80773 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80777 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  80781 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80785 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80790 */       // MIs[2] imm
     /*  80790 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80794 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80798 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80802 */       // MIs[3] Operand 1
     /*  80802 */       // No operand predicates
     /*  80802 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80804 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80804 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80807 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80811 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80816 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80818 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80821 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80825 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80830 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80833 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80837 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80840 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80845 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80850 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80855 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80858 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80860 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80863 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80867 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80870 */       GIR_RootConstrainSelectedInstOperands,
     /*  80871 */       // GIR_Coverage, 6280,
     /*  80871 */       GIR_EraseRootFromParent_Done,
     /*  80872 */     // Label 1367: @80872
     /*  80872 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80992), // Rule ID 6316 //
     /*  80877 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80893 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80897 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80901 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80905 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80910 */       // MIs[2] imm
     /*  80910 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80914 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80918 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80922 */       // MIs[3] Operand 1
     /*  80922 */       // No operand predicates
     /*  80922 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80924 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  80924 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80927 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80931 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80936 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80938 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80941 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80945 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80950 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80953 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80957 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80960 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80965 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80970 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80975 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80978 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80980 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80983 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80987 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80990 */       GIR_RootConstrainSelectedInstOperands,
     /*  80991 */       // GIR_Coverage, 6316,
     /*  80991 */       GIR_EraseRootFromParent_Done,
     /*  80992 */     // Label 1368: @80992
     /*  80992 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81109), // Rule ID 2501 //
     /*  80997 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81000 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81004 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81008 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81012 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81015 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81020 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81024 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81028 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81033 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81038 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81040 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81040 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81043 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81047 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81052 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81054 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81057 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81061 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81066 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81069 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81073 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81076 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81081 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81086 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81091 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81094 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81096 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81099 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81103 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81107 */       GIR_RootConstrainSelectedInstOperands,
     /*  81108 */       // GIR_Coverage, 2501,
     /*  81108 */       GIR_EraseRootFromParent_Done,
     /*  81109 */     // Label 1369: @81109
     /*  81109 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81226), // Rule ID 5334 //
     /*  81114 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81117 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81121 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81125 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81129 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81132 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81137 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81141 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81145 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81150 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81155 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81157 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81157 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81160 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81164 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81169 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81171 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81174 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81178 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81183 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81186 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81190 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81193 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81198 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81203 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81208 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81211 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81213 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81216 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81220 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81224 */       GIR_RootConstrainSelectedInstOperands,
     /*  81225 */       // GIR_Coverage, 5334,
     /*  81225 */       GIR_EraseRootFromParent_Done,
     /*  81226 */     // Label 1370: @81226
     /*  81226 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81343), // Rule ID 5337 //
     /*  81231 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81234 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81238 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81242 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81246 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81249 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81254 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81258 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81262 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81267 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81272 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81274 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81274 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81277 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81281 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81286 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81288 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81291 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81295 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81300 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81307 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81333 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81337 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81341 */       GIR_RootConstrainSelectedInstOperands,
     /*  81342 */       // GIR_Coverage, 5337,
     /*  81342 */       GIR_EraseRootFromParent_Done,
     /*  81343 */     // Label 1371: @81343
     /*  81343 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81460), // Rule ID 5340 //
     /*  81348 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81351 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81355 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81359 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81363 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81366 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  81371 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81375 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81379 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81384 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81389 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81391 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81391 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81394 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81398 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81403 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81405 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81408 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81412 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81417 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81420 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81424 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81427 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81432 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81442 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  81445 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81447 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81450 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81454 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81458 */       GIR_RootConstrainSelectedInstOperands,
     /*  81459 */       // GIR_Coverage, 5340,
     /*  81459 */       GIR_EraseRootFromParent_Done,
     /*  81460 */     // Label 1372: @81460
     /*  81460 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81564), // Rule ID 2497 //
     /*  81465 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81468 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81472 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81476 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81480 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  81483 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  81488 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81492 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81497 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81499 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81499 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81502 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81506 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81511 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81513 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81516 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81520 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81525 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81528 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81532 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81535 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81550 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  81553 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81555 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81558 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81562 */       GIR_RootConstrainSelectedInstOperands,
     /*  81563 */       // GIR_Coverage, 2497,
     /*  81563 */       GIR_EraseRootFromParent_Done,
     /*  81564 */     // Label 1373: @81564
     /*  81564 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(81620), // Rule ID 5497 //
     /*  81569 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81573 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81577 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81586 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81590 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81594 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81598 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81603 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81605 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  81608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81610 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  81614 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  81618 */       GIR_RootConstrainSelectedInstOperands,
     /*  81619 */       // GIR_Coverage, 5497,
     /*  81619 */       GIR_EraseRootFromParent_Done,
     /*  81620 */     // Label 1374: @81620
     /*  81620 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81686), // Rule ID 5763 //
     /*  81625 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81629 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81633 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81639 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81641 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81643 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  81643 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81646 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81650 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81655 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81659 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81661 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81664 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81666 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81669 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81672 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81675 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81680 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81685 */       // GIR_Coverage, 5763,
     /*  81685 */       GIR_EraseRootFromParent_Done,
     /*  81686 */     // Label 1375: @81686
     /*  81686 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81752), // Rule ID 5767 //
     /*  81691 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81695 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81699 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81705 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81707 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81709 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  81709 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81712 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81716 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81721 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81725 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81727 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81730 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81732 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81735 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81738 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81741 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81746 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81751 */       // GIR_Coverage, 5767,
     /*  81751 */       GIR_EraseRootFromParent_Done,
     /*  81752 */     // Label 1376: @81752
     /*  81752 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81845), // Rule ID 4904 //
     /*  81757 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81761 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81765 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  81769 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81773 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81778 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81780 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81780 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81783 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81787 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81792 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81794 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81797 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81801 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81806 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81809 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81813 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81816 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81821 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81826 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81831 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  81834 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81836 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81839 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81843 */       GIR_RootConstrainSelectedInstOperands,
     /*  81844 */       // GIR_Coverage, 4904,
     /*  81844 */       GIR_EraseRootFromParent_Done,
     /*  81845 */     // Label 1377: @81845
     /*  81845 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81941), // Rule ID 4951 //
     /*  81850 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81853 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81857 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81861 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81865 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81874 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81876 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  81876 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81879 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81883 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81888 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81890 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81893 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81897 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81902 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81905 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81909 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81912 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  81930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81932 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81935 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81939 */       GIR_RootConstrainSelectedInstOperands,
     /*  81940 */       // GIR_Coverage, 4951,
     /*  81940 */       GIR_EraseRootFromParent_Done,
     /*  81941 */     // Label 1378: @81941
     /*  81941 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(82003), // Rule ID 5764 //
     /*  81946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81958 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81960 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  81960 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81963 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81967 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81972 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81974 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81977 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81979 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81982 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  81984 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81992 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81997 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82002 */       // GIR_Coverage, 5764,
     /*  82002 */       GIR_EraseRootFromParent_Done,
     /*  82003 */     // Label 1379: @82003
     /*  82003 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82065), // Rule ID 5768 //
     /*  82008 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82012 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82016 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82020 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82022 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82022 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82025 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82029 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82034 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82036 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82039 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82041 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82044 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82046 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82049 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82054 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82059 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82064 */       // GIR_Coverage, 5768,
     /*  82064 */       GIR_EraseRootFromParent_Done,
     /*  82065 */     // Label 1380: @82065
     /*  82065 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82199), // Rule ID 5762 //
     /*  82070 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82074 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82078 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82078 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82081 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82085 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82090 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82092 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82095 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82099 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82104 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82107 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82111 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82114 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82119 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82124 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82129 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82132 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82136 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82141 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82143 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82146 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82150 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82155 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82158 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82162 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82165 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82170 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82175 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82180 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82183 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82185 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82188 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82191 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82194 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82197 */       GIR_RootConstrainSelectedInstOperands,
     /*  82198 */       // GIR_Coverage, 5762,
     /*  82198 */       GIR_EraseRootFromParent_Done,
     /*  82199 */     // Label 1381: @82199
     /*  82199 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82333), // Rule ID 5766 //
     /*  82204 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82208 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82212 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82212 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82215 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82219 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82224 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82226 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82229 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82233 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82238 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82241 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82245 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82248 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82253 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82258 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82263 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82266 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82270 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82275 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82277 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82280 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82284 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82289 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82292 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82296 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82304 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82309 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82314 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82317 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82319 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82322 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82325 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82328 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82331 */       GIR_RootConstrainSelectedInstOperands,
     /*  82332 */       // GIR_Coverage, 5766,
     /*  82332 */       GIR_EraseRootFromParent_Done,
     /*  82333 */     // Label 1382: @82333
     /*  82333 */     GIM_Reject,
     /*  82334 */   // Label 1358: @82334
     /*  82334 */   GIM_Reject,
     /*  82335 */   // Label 1341: @82335
     /*  82335 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(84743),
     /*  82340 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  82343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  82346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82350 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82479), // Rule ID 5412 //
     /*  82355 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82359 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82363 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82367 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82371 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82375 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82379 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82383 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82387 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82391 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82395 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82399 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82404 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82408 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82414 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82416 */       // MIs[2] Operand 2
     /*  82416 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82427 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82429 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  82429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82441 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82461 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82464 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82466 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82469 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82473 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82477 */       GIR_RootConstrainSelectedInstOperands,
     /*  82478 */       // GIR_Coverage, 5412,
     /*  82478 */       GIR_EraseRootFromParent_Done,
     /*  82479 */     // Label 1384: @82479
     /*  82479 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82601), // Rule ID 5408 //
     /*  82484 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82488 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82492 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82496 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82500 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82504 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82508 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82512 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82516 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  82520 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82524 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82528 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82533 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82538 */       // MIs[2] Operand 2
     /*  82538 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82549 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82551 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82551 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82554 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82558 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82563 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82566 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82570 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82573 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82578 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82583 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  82586 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82588 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82591 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82595 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82599 */       GIR_RootConstrainSelectedInstOperands,
     /*  82600 */       // GIR_Coverage, 5408,
     /*  82600 */       GIR_EraseRootFromParent_Done,
     /*  82601 */     // Label 1385: @82601
     /*  82601 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82723), // Rule ID 5410 //
     /*  82606 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82610 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82614 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82618 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82622 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82626 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82630 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82634 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82638 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  82642 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82646 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82650 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82655 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82660 */       // MIs[2] Operand 2
     /*  82660 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82671 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82673 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82673 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82676 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82680 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82685 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82688 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82692 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82695 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82700 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82705 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82708 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82710 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82713 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82717 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82721 */       GIR_RootConstrainSelectedInstOperands,
     /*  82722 */       // GIR_Coverage, 5410,
     /*  82722 */       GIR_EraseRootFromParent_Done,
     /*  82723 */     // Label 1386: @82723
     /*  82723 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82825), // Rule ID 5563 //
     /*  82728 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82732 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82736 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82740 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82744 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82748 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82752 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82757 */       // MIs[2] Operand 2
     /*  82757 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82768 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  82772 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82776 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82780 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  82784 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82788 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82792 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82797 */       // MIs[4] Operand 2
     /*  82797 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  82808 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82810 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  82810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  82813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  82819 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  82823 */       GIR_RootConstrainSelectedInstOperands,
     /*  82824 */       // GIR_Coverage, 5563,
     /*  82824 */       GIR_EraseRootFromParent_Done,
     /*  82825 */     // Label 1387: @82825
     /*  82825 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82954), // Rule ID 6309 //
     /*  82830 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82834 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82838 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82842 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82845 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  82850 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82854 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  82858 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82863 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  82867 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82869 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  82869 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82872 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  82876 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82881 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  82884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  82886 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82889 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82893 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82898 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82900 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82903 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82907 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82912 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82915 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  82919 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82932 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82937 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  82940 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82942 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82945 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  82949 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82952 */       GIR_RootConstrainSelectedInstOperands,
     /*  82953 */       // GIR_Coverage, 6309,
     /*  82953 */       GIR_EraseRootFromParent_Done,
     /*  82954 */     // Label 1388: @82954
     /*  82954 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82996), // Rule ID 5773 //
     /*  82959 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82966 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82973 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  82973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82978 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82983 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82986 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  82991 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82994 */       GIR_RootConstrainSelectedInstOperands,
     /*  82995 */       // GIR_Coverage, 5773,
     /*  82995 */       GIR_EraseRootFromParent_Done,
     /*  82996 */     // Label 1389: @82996
     /*  82996 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83038), // Rule ID 5777 //
     /*  83001 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83008 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83015 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83015 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83018 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83020 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83025 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83028 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83033 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83036 */       GIR_RootConstrainSelectedInstOperands,
     /*  83037 */       // GIR_Coverage, 5777,
     /*  83037 */       GIR_EraseRootFromParent_Done,
     /*  83038 */     // Label 1390: @83038
     /*  83038 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83161), // Rule ID 2576 //
     /*  83043 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83046 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83050 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83054 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83058 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83061 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83066 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83070 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83074 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83079 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83083 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83087 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83091 */       // MIs[2] Operand 1
     /*  83091 */       // No operand predicates
     /*  83091 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83093 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83093 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83096 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83100 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83107 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83110 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83114 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83119 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83122 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83126 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83129 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83139 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83144 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83147 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83149 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83152 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83156 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83159 */       GIR_RootConstrainSelectedInstOperands,
     /*  83160 */       // GIR_Coverage, 2576,
     /*  83160 */       GIR_EraseRootFromParent_Done,
     /*  83161 */     // Label 1391: @83161
     /*  83161 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83284), // Rule ID 6279 //
     /*  83166 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83169 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83173 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83177 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83181 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83185 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83189 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83193 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83197 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83202 */       // MIs[2] imm
     /*  83202 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83206 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83210 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83214 */       // MIs[3] Operand 1
     /*  83214 */       // No operand predicates
     /*  83214 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83216 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83216 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83219 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83223 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83228 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83230 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83233 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83237 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83242 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83245 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83249 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83252 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83257 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83262 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83267 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83270 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83272 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83275 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83279 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83282 */       GIR_RootConstrainSelectedInstOperands,
     /*  83283 */       // GIR_Coverage, 6279,
     /*  83283 */       GIR_EraseRootFromParent_Done,
     /*  83284 */     // Label 1392: @83284
     /*  83284 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83404), // Rule ID 6315 //
     /*  83289 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83293 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83297 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83301 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83305 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83309 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83313 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83317 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83322 */       // MIs[2] imm
     /*  83322 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83326 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83330 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83334 */       // MIs[3] Operand 1
     /*  83334 */       // No operand predicates
     /*  83334 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83336 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83336 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83339 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83343 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83348 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83350 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83353 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83357 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83362 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83365 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83369 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83382 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83387 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83390 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83392 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83395 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83399 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83402 */       GIR_RootConstrainSelectedInstOperands,
     /*  83403 */       // GIR_Coverage, 6315,
     /*  83403 */       GIR_EraseRootFromParent_Done,
     /*  83404 */     // Label 1393: @83404
     /*  83404 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83521), // Rule ID 2500 //
     /*  83409 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83412 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83416 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83420 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83424 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83427 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  83432 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83436 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83440 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83445 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83450 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83452 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83452 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83455 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83459 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83464 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83466 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83469 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83473 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83478 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83481 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83485 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83488 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83493 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83498 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83503 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83506 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83508 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83511 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83515 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83519 */       GIR_RootConstrainSelectedInstOperands,
     /*  83520 */       // GIR_Coverage, 2500,
     /*  83520 */       GIR_EraseRootFromParent_Done,
     /*  83521 */     // Label 1394: @83521
     /*  83521 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83638), // Rule ID 5333 //
     /*  83526 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83529 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83533 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83537 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83541 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83544 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  83549 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83553 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83557 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83562 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83567 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83569 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83569 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83572 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83576 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83581 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83583 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83586 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83590 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83595 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83598 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83602 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83605 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83610 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83615 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83625 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83628 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83632 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83636 */       GIR_RootConstrainSelectedInstOperands,
     /*  83637 */       // GIR_Coverage, 5333,
     /*  83637 */       GIR_EraseRootFromParent_Done,
     /*  83638 */     // Label 1395: @83638
     /*  83638 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83755), // Rule ID 5336 //
     /*  83643 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83646 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83650 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83654 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83658 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83661 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  83666 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83670 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83674 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83679 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83684 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83686 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83686 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83689 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83693 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83700 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83703 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83707 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83712 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83715 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83719 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83732 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83737 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83740 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83742 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83745 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83749 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83753 */       GIR_RootConstrainSelectedInstOperands,
     /*  83754 */       // GIR_Coverage, 5336,
     /*  83754 */       GIR_EraseRootFromParent_Done,
     /*  83755 */     // Label 1396: @83755
     /*  83755 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83872), // Rule ID 5339 //
     /*  83760 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83763 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83767 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83771 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83775 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83778 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  83783 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83787 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83791 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83796 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83801 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83803 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83803 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83806 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83810 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83815 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83817 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83820 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83824 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83829 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83832 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83836 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83839 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83844 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83849 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83854 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  83857 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83859 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83862 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83866 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83870 */       GIR_RootConstrainSelectedInstOperands,
     /*  83871 */       // GIR_Coverage, 5339,
     /*  83871 */       GIR_EraseRootFromParent_Done,
     /*  83872 */     // Label 1397: @83872
     /*  83872 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83973), // Rule ID 4898 //
     /*  83877 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83889 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  83892 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  83897 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83901 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83906 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83908 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  83908 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83911 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83915 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83920 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83922 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83925 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83929 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83934 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83937 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83941 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83944 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83949 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83954 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83959 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  83962 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83964 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83967 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83971 */       GIR_RootConstrainSelectedInstOperands,
     /*  83972 */       // GIR_Coverage, 4898,
     /*  83972 */       GIR_EraseRootFromParent_Done,
     /*  83973 */     // Label 1398: @83973
     /*  83973 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84029), // Rule ID 5488 //
     /*  83978 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83982 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83986 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83995 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83999 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84003 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84007 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84012 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84014 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84014 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84017 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84019 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84023 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84027 */       GIR_RootConstrainSelectedInstOperands,
     /*  84028 */       // GIR_Coverage, 5488,
     /*  84028 */       GIR_EraseRootFromParent_Done,
     /*  84029 */     // Label 1399: @84029
     /*  84029 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84095), // Rule ID 5771 //
     /*  84034 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84038 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84042 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84048 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84050 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84052 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84052 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84055 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84059 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84064 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84068 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84070 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84073 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84075 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84078 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84081 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84084 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84089 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84094 */       // GIR_Coverage, 5771,
     /*  84094 */       GIR_EraseRootFromParent_Done,
     /*  84095 */     // Label 1400: @84095
     /*  84095 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84161), // Rule ID 5775 //
     /*  84100 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84104 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84108 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84114 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84116 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84118 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84118 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84121 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84125 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84130 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84134 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84136 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84139 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84141 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84144 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84147 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84150 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84155 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84160 */       // GIR_Coverage, 5775,
     /*  84160 */       GIR_EraseRootFromParent_Done,
     /*  84161 */     // Label 1401: @84161
     /*  84161 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84254), // Rule ID 4906 //
     /*  84166 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84170 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84174 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84178 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84182 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84187 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84189 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84189 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84192 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84196 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84201 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84203 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84206 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84210 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84215 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84218 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84222 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84225 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84230 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84235 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84240 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84243 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84245 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84248 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84252 */       GIR_RootConstrainSelectedInstOperands,
     /*  84253 */       // GIR_Coverage, 4906,
     /*  84253 */       GIR_EraseRootFromParent_Done,
     /*  84254 */     // Label 1402: @84254
     /*  84254 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84350), // Rule ID 4950 //
     /*  84259 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84262 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84266 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84270 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84274 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84278 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84283 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84285 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84285 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84288 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84292 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84297 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84299 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84302 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84306 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84311 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84314 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84318 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84326 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84336 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  84339 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84341 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84344 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84348 */       GIR_RootConstrainSelectedInstOperands,
     /*  84349 */       // GIR_Coverage, 4950,
     /*  84349 */       GIR_EraseRootFromParent_Done,
     /*  84350 */     // Label 1403: @84350
     /*  84350 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84412), // Rule ID 5772 //
     /*  84355 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84359 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84363 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84367 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84369 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  84369 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84372 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84376 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84381 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84383 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84386 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84388 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84391 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84401 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84406 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84411 */       // GIR_Coverage, 5772,
     /*  84411 */       GIR_EraseRootFromParent_Done,
     /*  84412 */     // Label 1404: @84412
     /*  84412 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84474), // Rule ID 5776 //
     /*  84417 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84421 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84425 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84429 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84431 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  84431 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84434 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84438 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84443 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84450 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84453 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84455 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84458 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84463 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84468 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84473 */       // GIR_Coverage, 5776,
     /*  84473 */       GIR_EraseRootFromParent_Done,
     /*  84474 */     // Label 1405: @84474
     /*  84474 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(84608), // Rule ID 5770 //
     /*  84479 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84483 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84487 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84487 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84490 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84494 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84499 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84501 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84504 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84508 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84513 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84516 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84520 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84523 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84528 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84533 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84538 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84541 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84545 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84550 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84552 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84555 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84559 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84564 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84567 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84571 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84579 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84584 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84589 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84592 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84594 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84597 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84603 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84606 */       GIR_RootConstrainSelectedInstOperands,
     /*  84607 */       // GIR_Coverage, 5770,
     /*  84607 */       GIR_EraseRootFromParent_Done,
     /*  84608 */     // Label 1406: @84608
     /*  84608 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(84742), // Rule ID 5774 //
     /*  84613 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84617 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84621 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84621 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84624 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84628 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84633 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84635 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84638 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84642 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84647 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84650 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84654 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84657 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84662 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84667 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84672 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84675 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84679 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84684 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84686 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84689 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84693 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84698 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84701 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84705 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84708 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84713 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84718 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84723 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84726 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84728 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84731 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84734 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84737 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84740 */       GIR_RootConstrainSelectedInstOperands,
     /*  84741 */       // GIR_Coverage, 5774,
     /*  84741 */       GIR_EraseRootFromParent_Done,
     /*  84742 */     // Label 1407: @84742
     /*  84742 */     GIM_Reject,
     /*  84743 */   // Label 1383: @84743
     /*  84743 */   GIM_Reject,
     /*  84744 */   // Label 1342: @84744
     /*  84744 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(86654),
     /*  84749 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  84755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84759 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(84888), // Rule ID 5406 //
     /*  84764 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84768 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84772 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84776 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84780 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84784 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84788 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84792 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84796 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84800 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84804 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84808 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84813 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84817 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84823 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84825 */       // MIs[2] Operand 2
     /*  84825 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84836 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84838 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  84838 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84841 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84845 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84850 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84853 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84857 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84865 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84870 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  84873 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84875 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84878 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84882 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84886 */       GIR_RootConstrainSelectedInstOperands,
     /*  84887 */       // GIR_Coverage, 5406,
     /*  84887 */       GIR_EraseRootFromParent_Done,
     /*  84888 */     // Label 1409: @84888
     /*  84888 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85010), // Rule ID 5402 //
     /*  84893 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84897 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84901 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84905 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84909 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84913 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84917 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84921 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84925 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  84929 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84933 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84937 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84942 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84947 */       // MIs[2] Operand 2
     /*  84947 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84958 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84960 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  84960 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84963 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84967 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84972 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84975 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84979 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84987 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84992 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  84995 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84997 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85000 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85004 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85008 */       GIR_RootConstrainSelectedInstOperands,
     /*  85009 */       // GIR_Coverage, 5402,
     /*  85009 */       GIR_EraseRootFromParent_Done,
     /*  85010 */     // Label 1410: @85010
     /*  85010 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(85132), // Rule ID 5404 //
     /*  85015 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85019 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85023 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85027 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85031 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85035 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85039 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85043 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85047 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85051 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85055 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85059 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85064 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85069 */       // MIs[2] Operand 2
     /*  85069 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85080 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85082 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85082 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85085 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85089 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85094 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85097 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85101 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85104 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85109 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85114 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85117 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85119 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85122 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85126 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85130 */       GIR_RootConstrainSelectedInstOperands,
     /*  85131 */       // GIR_Coverage, 5404,
     /*  85131 */       GIR_EraseRootFromParent_Done,
     /*  85132 */     // Label 1411: @85132
     /*  85132 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85234), // Rule ID 5562 //
     /*  85137 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85141 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85145 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85149 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85153 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85157 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85161 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85166 */       // MIs[2] Operand 2
     /*  85166 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85177 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85181 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85185 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85189 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85193 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85197 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85201 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85206 */       // MIs[4] Operand 2
     /*  85206 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85217 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85219 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85224 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85228 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85232 */       GIR_RootConstrainSelectedInstOperands,
     /*  85233 */       // GIR_Coverage, 5562,
     /*  85233 */       GIR_EraseRootFromParent_Done,
     /*  85234 */     // Label 1412: @85234
     /*  85234 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85363), // Rule ID 6308 //
     /*  85239 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85243 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85247 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85251 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85254 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85259 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85263 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85267 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85272 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85276 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85278 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85278 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85281 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85285 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85290 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  85293 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  85295 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85298 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85302 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85309 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85312 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85316 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85321 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  85328 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85336 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85341 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  85349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85351 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85354 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  85358 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85361 */       GIR_RootConstrainSelectedInstOperands,
     /*  85362 */       // GIR_Coverage, 6308,
     /*  85362 */       GIR_EraseRootFromParent_Done,
     /*  85363 */     // Label 1413: @85363
     /*  85363 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85405), // Rule ID 5781 //
     /*  85368 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85375 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85382 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  85382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85387 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  85392 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85395 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  85400 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85403 */       GIR_RootConstrainSelectedInstOperands,
     /*  85404 */       // GIR_Coverage, 5781,
     /*  85404 */       GIR_EraseRootFromParent_Done,
     /*  85405 */     // Label 1414: @85405
     /*  85405 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85528), // Rule ID 2574 //
     /*  85410 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85413 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85417 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85421 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85425 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85428 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85433 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85437 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85441 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85446 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  85450 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85454 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85458 */       // MIs[2] Operand 1
     /*  85458 */       // No operand predicates
     /*  85458 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85460 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85460 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85463 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85467 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85472 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85474 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85477 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85481 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85486 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85489 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85493 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85496 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85501 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85506 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85511 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  85514 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85516 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85519 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85523 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  85526 */       GIR_RootConstrainSelectedInstOperands,
     /*  85527 */       // GIR_Coverage, 2574,
     /*  85527 */       GIR_EraseRootFromParent_Done,
     /*  85528 */     // Label 1415: @85528
     /*  85528 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(85651), // Rule ID 6278 //
     /*  85533 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85536 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85540 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85544 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85548 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85552 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85556 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  85560 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85564 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85569 */       // MIs[2] imm
     /*  85569 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85573 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85577 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85581 */       // MIs[3] Operand 1
     /*  85581 */       // No operand predicates
     /*  85581 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85583 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85583 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85586 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85590 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85595 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85597 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85600 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85604 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85609 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85612 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85616 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85619 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85624 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85637 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85639 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85642 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85646 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85649 */       GIR_RootConstrainSelectedInstOperands,
     /*  85650 */       // GIR_Coverage, 6278,
     /*  85650 */       GIR_EraseRootFromParent_Done,
     /*  85651 */     // Label 1416: @85651
     /*  85651 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(85771), // Rule ID 6314 //
     /*  85656 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85660 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85664 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85668 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85672 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85676 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85680 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85684 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85689 */       // MIs[2] imm
     /*  85689 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85693 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85697 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85701 */       // MIs[3] Operand 1
     /*  85701 */       // No operand predicates
     /*  85701 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85703 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85703 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85706 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85710 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85715 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85717 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85720 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85724 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85729 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85732 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85736 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85754 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85757 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85766 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85769 */       GIR_RootConstrainSelectedInstOperands,
     /*  85770 */       // GIR_Coverage, 6314,
     /*  85770 */       GIR_EraseRootFromParent_Done,
     /*  85771 */     // Label 1417: @85771
     /*  85771 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(85888), // Rule ID 2499 //
     /*  85776 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85779 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85783 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85787 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85791 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85794 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  85799 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85803 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85807 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85812 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85817 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85819 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85819 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85822 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85826 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85831 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85833 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85836 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85840 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85845 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85848 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85852 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85855 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85865 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85870 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85873 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85875 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85878 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85882 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85886 */       GIR_RootConstrainSelectedInstOperands,
     /*  85887 */       // GIR_Coverage, 2499,
     /*  85887 */       GIR_EraseRootFromParent_Done,
     /*  85888 */     // Label 1418: @85888
     /*  85888 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(86005), // Rule ID 5332 //
     /*  85893 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85896 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85900 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85904 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85908 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85911 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  85916 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85920 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85924 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85929 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85934 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85936 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85936 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85939 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85943 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85948 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85962 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85969 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85972 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85995 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85999 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86003 */       GIR_RootConstrainSelectedInstOperands,
     /*  86004 */       // GIR_Coverage, 5332,
     /*  86004 */       GIR_EraseRootFromParent_Done,
     /*  86005 */     // Label 1419: @86005
     /*  86005 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86122), // Rule ID 5335 //
     /*  86010 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86013 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86017 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86021 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86025 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86028 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86033 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86037 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86041 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86046 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86051 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86053 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86053 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86056 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86060 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86065 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86067 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86070 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86074 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86079 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86082 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86086 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86099 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86104 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86107 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86109 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86112 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86116 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86120 */       GIR_RootConstrainSelectedInstOperands,
     /*  86121 */       // GIR_Coverage, 5335,
     /*  86121 */       GIR_EraseRootFromParent_Done,
     /*  86122 */     // Label 1420: @86122
     /*  86122 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86239), // Rule ID 5338 //
     /*  86127 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86130 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86134 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86138 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86142 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86145 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86150 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86154 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86158 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86163 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86168 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86170 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86170 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86173 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86177 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86182 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86184 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86187 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86191 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86196 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86199 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86203 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86206 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86211 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86216 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86226 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86229 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86233 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86237 */       GIR_RootConstrainSelectedInstOperands,
     /*  86238 */       // GIR_Coverage, 5338,
     /*  86238 */       GIR_EraseRootFromParent_Done,
     /*  86239 */     // Label 1421: @86239
     /*  86239 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86295), // Rule ID 5479 //
     /*  86244 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86248 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86252 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86256 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86261 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86265 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86269 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86273 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86278 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86280 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86280 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86283 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  86289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  86293 */       GIR_RootConstrainSelectedInstOperands,
     /*  86294 */       // GIR_Coverage, 5479,
     /*  86294 */       GIR_EraseRootFromParent_Done,
     /*  86295 */     // Label 1422: @86295
     /*  86295 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86361), // Rule ID 5779 //
     /*  86300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86308 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86314 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  86316 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86318 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  86318 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86321 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  86325 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86330 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  86334 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86336 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  86339 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86341 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86344 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86347 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86350 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86355 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86360 */       // GIR_Coverage, 5779,
     /*  86360 */       GIR_EraseRootFromParent_Done,
     /*  86361 */     // Label 1423: @86361
     /*  86361 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86457), // Rule ID 4949 //
     /*  86366 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86369 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86373 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86377 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86381 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86385 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86390 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86392 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  86392 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86395 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86399 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86406 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86409 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86413 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86418 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86421 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86425 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86428 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86433 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86438 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86443 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  86446 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86448 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86451 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86455 */       GIR_RootConstrainSelectedInstOperands,
     /*  86456 */       // GIR_Coverage, 4949,
     /*  86456 */       GIR_EraseRootFromParent_Done,
     /*  86457 */     // Label 1424: @86457
     /*  86457 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(86519), // Rule ID 5780 //
     /*  86462 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86466 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86470 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  86474 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86476 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  86476 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  86479 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86483 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86490 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86493 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86495 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86498 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86500 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86503 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86508 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86513 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86518 */       // GIR_Coverage, 5780,
     /*  86518 */       GIR_EraseRootFromParent_Done,
     /*  86519 */     // Label 1425: @86519
     /*  86519 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(86653), // Rule ID 5778 //
     /*  86524 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86528 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86532 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  86532 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  86535 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86539 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86544 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  86546 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  86549 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86553 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86558 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  86561 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  86565 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  86568 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86573 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86578 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86583 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86586 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86590 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86595 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86597 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86600 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86604 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86609 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86612 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86616 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86619 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86624 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86637 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86639 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86642 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86645 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86648 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86651 */       GIR_RootConstrainSelectedInstOperands,
     /*  86652 */       // GIR_Coverage, 5778,
     /*  86652 */       GIR_EraseRootFromParent_Done,
     /*  86653 */     // Label 1426: @86653
     /*  86653 */     GIM_Reject,
     /*  86654 */   // Label 1408: @86654
     /*  86654 */   GIM_Reject,
     /*  86655 */   // Label 1343: @86655
     /*  86655 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(86680), // Rule ID 9016 //
     /*  86660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86663 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  86666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  86669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86673 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  86673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  86678 */     GIR_RootConstrainSelectedInstOperands,
     /*  86679 */     // GIR_Coverage, 9016,
     /*  86679 */     GIR_Done,
     /*  86680 */   // Label 1427: @86680
     /*  86680 */   GIM_Reject,
     /*  86681 */   // Label 1344: @86681
     /*  86681 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(86706), // Rule ID 9017 //
     /*  86686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86689 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  86692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  86695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86699 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  86699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  86704 */     GIR_RootConstrainSelectedInstOperands,
     /*  86705 */     // GIR_Coverage, 9017,
     /*  86705 */     GIR_Done,
     /*  86706 */   // Label 1428: @86706
     /*  86706 */   GIM_Reject,
     /*  86707 */   // Label 1345: @86707
     /*  86707 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(86732), // Rule ID 9020 //
     /*  86712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  86718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  86721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86725 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  86725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86730 */     GIR_RootConstrainSelectedInstOperands,
     /*  86731 */     // GIR_Coverage, 9020,
     /*  86731 */     GIR_Done,
     /*  86732 */   // Label 1429: @86732
     /*  86732 */   GIM_Reject,
     /*  86733 */   // Label 1346: @86733
     /*  86733 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(86758), // Rule ID 9022 //
     /*  86738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86741 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  86744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  86747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86751 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  86751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86756 */     GIR_RootConstrainSelectedInstOperands,
     /*  86757 */     // GIR_Coverage, 9022,
     /*  86757 */     GIR_Done,
     /*  86758 */   // Label 1430: @86758
     /*  86758 */   GIM_Reject,
     /*  86759 */   // Label 1347: @86759
     /*  86759 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(86784), // Rule ID 9018 //
     /*  86764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86767 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  86770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  86773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86777 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  86777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  86782 */     GIR_RootConstrainSelectedInstOperands,
     /*  86783 */     // GIR_Coverage, 9018,
     /*  86783 */     GIR_Done,
     /*  86784 */   // Label 1431: @86784
     /*  86784 */   GIM_Reject,
     /*  86785 */   // Label 1348: @86785
     /*  86785 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(86810), // Rule ID 9021 //
     /*  86790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86793 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  86796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  86799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86803 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  86803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  86808 */     GIR_RootConstrainSelectedInstOperands,
     /*  86809 */     // GIR_Coverage, 9021,
     /*  86809 */     GIR_Done,
     /*  86810 */   // Label 1432: @86810
     /*  86810 */   GIM_Reject,
     /*  86811 */   // Label 1349: @86811
     /*  86811 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(86836), // Rule ID 9019 //
     /*  86816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86819 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  86822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  86825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86829 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  86829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  86834 */     GIR_RootConstrainSelectedInstOperands,
     /*  86835 */     // GIR_Coverage, 9019,
     /*  86835 */     GIR_Done,
     /*  86836 */   // Label 1433: @86836
     /*  86836 */   GIM_Reject,
     /*  86837 */   // Label 1350: @86837
     /*  86837 */   GIM_Reject,
     /*  86838 */ // Label 1338: @86838
     /*  86838 */ GIM_Reject,
     /*  86839 */ // Label 9: @86839
     /*  86839 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(96782),
     /*  86850 */ /*GILLT_s32*//*Label 1434*/ GIMT_Encode4(86938),
     /*  86854 */ /*GILLT_s64*//*Label 1435*/ GIMT_Encode4(87319),
     /*  86858 */ /*GILLT_s128*//*Label 1436*/ GIMT_Encode4(89294),
     /*  86862 */ /*GILLT_v2s32*//*Label 1437*/ GIMT_Encode4(89940),
     /*  86866 */ /*GILLT_v2s64*//*Label 1438*/ GIMT_Encode4(90855),
     /*  86870 */ /*GILLT_v4s16*//*Label 1439*/ GIMT_Encode4(91624),
     /*  86874 */ /*GILLT_v4s32*//*Label 1440*/ GIMT_Encode4(92539),
     /*  86878 */ /*GILLT_v8s8*//*Label 1441*/ GIMT_Encode4(93384),
     /*  86882 */ /*GILLT_v8s16*//*Label 1442*/ GIMT_Encode4(93945),
     /*  86886 */ /*GILLT_v16s8*//*Label 1443*/ GIMT_Encode4(94790), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86906 */ /*GILLT_nxv2s64*//*Label 1444*/ GIMT_Encode4(95242), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86918 */ /*GILLT_nxv4s32*//*Label 1445*/ GIMT_Encode4(95691), GIMT_Encode4(0),
     /*  86926 */ /*GILLT_nxv8s16*//*Label 1446*/ GIMT_Encode4(96140), GIMT_Encode4(0),
     /*  86934 */ /*GILLT_nxv16s8*//*Label 1447*/ GIMT_Encode4(96589),
     /*  86938 */ // Label 1434: @86938
     /*  86938 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(87318),
     /*  86943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86946 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(87016), // Rule ID 7027 //
     /*  86951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86963 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86966 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86973 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  86989 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  86989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  86992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87014 */     GIR_RootConstrainSelectedInstOperands,
     /*  87015 */     // GIR_Coverage, 7027,
     /*  87015 */     GIR_EraseRootFromParent_Done,
     /*  87016 */   // Label 1450: @87016
     /*  87016 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(87086), // Rule ID 7028 //
     /*  87021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87033 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87036 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87043 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87059 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87084 */     GIR_RootConstrainSelectedInstOperands,
     /*  87085 */     // GIR_Coverage, 7028,
     /*  87085 */     GIR_EraseRootFromParent_Done,
     /*  87086 */   // Label 1451: @87086
     /*  87086 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(87151), // Rule ID 7029 //
     /*  87091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87103 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87106 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87113 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87129 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87149 */     GIR_RootConstrainSelectedInstOperands,
     /*  87150 */     // GIR_Coverage, 7029,
     /*  87150 */     GIR_EraseRootFromParent_Done,
     /*  87151 */   // Label 1452: @87151
     /*  87151 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87216), // Rule ID 7030 //
     /*  87156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87168 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87171 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87178 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87194 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87214 */     GIR_RootConstrainSelectedInstOperands,
     /*  87215 */     // GIR_Coverage, 7030,
     /*  87215 */     GIR_EraseRootFromParent_Done,
     /*  87216 */   // Label 1453: @87216
     /*  87216 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87269), // Rule ID 5745 //
     /*  87221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87241 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87247 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87252 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87268 */     // GIR_Coverage, 5745,
     /*  87268 */     GIR_EraseRootFromParent_Done,
     /*  87269 */   // Label 1454: @87269
     /*  87269 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87293), // Rule ID 6640 //
     /*  87274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87282 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  87282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87292 */     // GIR_Coverage, 6640,
     /*  87292 */     GIR_Done,
     /*  87293 */   // Label 1455: @87293
     /*  87293 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87317), // Rule ID 6641 //
     /*  87298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87306 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  87306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87316 */     // GIR_Coverage, 6641,
     /*  87316 */     GIR_Done,
     /*  87317 */   // Label 1456: @87317
     /*  87317 */   GIM_Reject,
     /*  87318 */ // Label 1449: @87318
     /*  87318 */ GIM_Reject,
     /*  87319 */ // Label 1435: @87319
     /*  87319 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87392), // Rule ID 7031 //
     /*  87324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87339 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87342 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87349 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87352 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87358 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  87365 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  87365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  87368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87390 */   GIR_RootConstrainSelectedInstOperands,
     /*  87391 */   // GIR_Coverage, 7031,
     /*  87391 */   GIR_EraseRootFromParent_Done,
     /*  87392 */ // Label 1457: @87392
     /*  87392 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(87465), // Rule ID 7032 //
     /*  87397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87415 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87422 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87425 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87431 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  87438 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  87438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  87441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87463 */   GIR_RootConstrainSelectedInstOperands,
     /*  87464 */   // GIR_Coverage, 7032,
     /*  87464 */   GIR_EraseRootFromParent_Done,
     /*  87465 */ // Label 1458: @87465
     /*  87465 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(87533), // Rule ID 7033 //
     /*  87470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87477 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87481 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87488 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87495 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87498 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87504 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  87511 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  87514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87531 */   GIR_RootConstrainSelectedInstOperands,
     /*  87532 */   // GIR_Coverage, 7033,
     /*  87532 */   GIR_EraseRootFromParent_Done,
     /*  87533 */ // Label 1459: @87533
     /*  87533 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(87601), // Rule ID 7034 //
     /*  87538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87553 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87556 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87563 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87566 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87572 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  87579 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  87582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87599 */   GIR_RootConstrainSelectedInstOperands,
     /*  87600 */   // GIR_Coverage, 7034,
     /*  87600 */   GIR_EraseRootFromParent_Done,
     /*  87601 */ // Label 1460: @87601
     /*  87601 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(87657), // Rule ID 5747 //
     /*  87606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87621 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87625 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87629 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87635 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  87635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87640 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  87646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87656 */   // GIR_Coverage, 5747,
     /*  87656 */   GIR_EraseRootFromParent_Done,
     /*  87657 */ // Label 1461: @87657
     /*  87657 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(87687), // Rule ID 6615 //
     /*  87662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87676 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  87676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87686 */   // GIR_Coverage, 6615,
     /*  87686 */   GIR_Done,
     /*  87687 */ // Label 1462: @87687
     /*  87687 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(87717), // Rule ID 6616 //
     /*  87692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87706 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  87706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87716 */   // GIR_Coverage, 6616,
     /*  87716 */   GIR_Done,
     /*  87717 */ // Label 1463: @87717
     /*  87717 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(87747), // Rule ID 6617 //
     /*  87722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87736 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  87736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87746 */   // GIR_Coverage, 6617,
     /*  87746 */   GIR_Done,
     /*  87747 */ // Label 1464: @87747
     /*  87747 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(87777), // Rule ID 6618 //
     /*  87752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87766 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  87766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87776 */   // GIR_Coverage, 6618,
     /*  87776 */   GIR_Done,
     /*  87777 */ // Label 1465: @87777
     /*  87777 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(87807), // Rule ID 6619 //
     /*  87782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87796 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  87796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87806 */   // GIR_Coverage, 6619,
     /*  87806 */   GIR_Done,
     /*  87807 */ // Label 1466: @87807
     /*  87807 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(87837), // Rule ID 6620 //
     /*  87812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87826 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  87826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87836 */   // GIR_Coverage, 6620,
     /*  87836 */   GIR_Done,
     /*  87837 */ // Label 1467: @87837
     /*  87837 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(87887), // Rule ID 6626 //
     /*  87842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87856 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  87856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87868 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  87880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87885 */   GIR_RootConstrainSelectedInstOperands,
     /*  87886 */   // GIR_Coverage, 6626,
     /*  87886 */   GIR_EraseRootFromParent_Done,
     /*  87887 */ // Label 1468: @87887
     /*  87887 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(87937), // Rule ID 6627 //
     /*  87892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87906 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87918 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87935 */   GIR_RootConstrainSelectedInstOperands,
     /*  87936 */   // GIR_Coverage, 6627,
     /*  87936 */   GIR_EraseRootFromParent_Done,
     /*  87937 */ // Label 1469: @87937
     /*  87937 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(87987), // Rule ID 6628 //
     /*  87942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87956 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  87956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87968 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87985 */   GIR_RootConstrainSelectedInstOperands,
     /*  87986 */   // GIR_Coverage, 6628,
     /*  87986 */   GIR_EraseRootFromParent_Done,
     /*  87987 */ // Label 1470: @87987
     /*  87987 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88037), // Rule ID 6629 //
     /*  87992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88006 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88035 */   GIR_RootConstrainSelectedInstOperands,
     /*  88036 */   // GIR_Coverage, 6629,
     /*  88036 */   GIR_EraseRootFromParent_Done,
     /*  88037 */ // Label 1471: @88037
     /*  88037 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88087), // Rule ID 6630 //
     /*  88042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88056 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88068 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88085 */   GIR_RootConstrainSelectedInstOperands,
     /*  88086 */   // GIR_Coverage, 6630,
     /*  88086 */   GIR_EraseRootFromParent_Done,
     /*  88087 */ // Label 1472: @88087
     /*  88087 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88114), // Rule ID 6631 //
     /*  88092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88103 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88113 */   // GIR_Coverage, 6631,
     /*  88113 */   GIR_Done,
     /*  88114 */ // Label 1473: @88114
     /*  88114 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88141), // Rule ID 6632 //
     /*  88119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88130 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88140 */   // GIR_Coverage, 6632,
     /*  88140 */   GIR_Done,
     /*  88141 */ // Label 1474: @88141
     /*  88141 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88168), // Rule ID 6633 //
     /*  88146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88157 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88167 */   // GIR_Coverage, 6633,
     /*  88167 */   GIR_Done,
     /*  88168 */ // Label 1475: @88168
     /*  88168 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88195), // Rule ID 6642 //
     /*  88173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88184 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88194 */   // GIR_Coverage, 6642,
     /*  88194 */   GIR_Done,
     /*  88195 */ // Label 1476: @88195
     /*  88195 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88222), // Rule ID 6643 //
     /*  88200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88211 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88221 */   // GIR_Coverage, 6643,
     /*  88221 */   GIR_Done,
     /*  88222 */ // Label 1477: @88222
     /*  88222 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88249), // Rule ID 6644 //
     /*  88227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88238 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88248 */   // GIR_Coverage, 6644,
     /*  88248 */   GIR_Done,
     /*  88249 */ // Label 1478: @88249
     /*  88249 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88281), // Rule ID 6645 //
     /*  88254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88268 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88271 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88273 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88280 */   // GIR_Coverage, 6645,
     /*  88280 */   GIR_EraseRootFromParent_Done,
     /*  88281 */ // Label 1479: @88281
     /*  88281 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88313), // Rule ID 6646 //
     /*  88286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88300 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88303 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88305 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88312 */   // GIR_Coverage, 6646,
     /*  88312 */   GIR_EraseRootFromParent_Done,
     /*  88313 */ // Label 1480: @88313
     /*  88313 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(88345), // Rule ID 6647 //
     /*  88318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88332 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88335 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88337 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88344 */   // GIR_Coverage, 6647,
     /*  88344 */   GIR_EraseRootFromParent_Done,
     /*  88345 */ // Label 1481: @88345
     /*  88345 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(88377), // Rule ID 6648 //
     /*  88350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88364 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88367 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88376 */   // GIR_Coverage, 6648,
     /*  88376 */   GIR_EraseRootFromParent_Done,
     /*  88377 */ // Label 1482: @88377
     /*  88377 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(88409), // Rule ID 6649 //
     /*  88382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88396 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88399 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88408 */   // GIR_Coverage, 6649,
     /*  88408 */   GIR_EraseRootFromParent_Done,
     /*  88409 */ // Label 1483: @88409
     /*  88409 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(88435), // Rule ID 6650 //
     /*  88414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88428 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  88428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88433 */   GIR_RootConstrainSelectedInstOperands,
     /*  88434 */   // GIR_Coverage, 6650,
     /*  88434 */   GIR_Done,
     /*  88435 */ // Label 1484: @88435
     /*  88435 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(88461), // Rule ID 6651 //
     /*  88440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88454 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  88454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88459 */   GIR_RootConstrainSelectedInstOperands,
     /*  88460 */   // GIR_Coverage, 6651,
     /*  88460 */   GIR_Done,
     /*  88461 */ // Label 1485: @88461
     /*  88461 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(88487), // Rule ID 6652 //
     /*  88466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88480 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  88480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88485 */   GIR_RootConstrainSelectedInstOperands,
     /*  88486 */   // GIR_Coverage, 6652,
     /*  88486 */   GIR_Done,
     /*  88487 */ // Label 1486: @88487
     /*  88487 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(88513), // Rule ID 6653 //
     /*  88492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88506 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  88506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88511 */   GIR_RootConstrainSelectedInstOperands,
     /*  88512 */   // GIR_Coverage, 6653,
     /*  88512 */   GIR_Done,
     /*  88513 */ // Label 1487: @88513
     /*  88513 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(88539), // Rule ID 6654 //
     /*  88518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88532 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  88532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88537 */   GIR_RootConstrainSelectedInstOperands,
     /*  88538 */   // GIR_Coverage, 6654,
     /*  88538 */   GIR_Done,
     /*  88539 */ // Label 1488: @88539
     /*  88539 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(88568), // Rule ID 6655 //
     /*  88544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88555 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   // GIR_Coverage, 6655,
     /*  88567 */   GIR_EraseRootFromParent_Done,
     /*  88568 */ // Label 1489: @88568
     /*  88568 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(88597), // Rule ID 6656 //
     /*  88573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88584 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88587 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88589 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88596 */   // GIR_Coverage, 6656,
     /*  88596 */   GIR_EraseRootFromParent_Done,
     /*  88597 */ // Label 1490: @88597
     /*  88597 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(88629), // Rule ID 6710 //
     /*  88602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88616 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88628 */   // GIR_Coverage, 6710,
     /*  88628 */   GIR_EraseRootFromParent_Done,
     /*  88629 */ // Label 1491: @88629
     /*  88629 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(88661), // Rule ID 6711 //
     /*  88634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88648 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88651 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88653 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88660 */   // GIR_Coverage, 6711,
     /*  88660 */   GIR_EraseRootFromParent_Done,
     /*  88661 */ // Label 1492: @88661
     /*  88661 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(88693), // Rule ID 6712 //
     /*  88666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88680 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88683 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88685 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88692 */   // GIR_Coverage, 6712,
     /*  88692 */   GIR_EraseRootFromParent_Done,
     /*  88693 */ // Label 1493: @88693
     /*  88693 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(88725), // Rule ID 6713 //
     /*  88698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88712 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88724 */   // GIR_Coverage, 6713,
     /*  88724 */   GIR_EraseRootFromParent_Done,
     /*  88725 */ // Label 1494: @88725
     /*  88725 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(88757), // Rule ID 6714 //
     /*  88730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88744 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88756 */   // GIR_Coverage, 6714,
     /*  88756 */   GIR_EraseRootFromParent_Done,
     /*  88757 */ // Label 1495: @88757
     /*  88757 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(88783), // Rule ID 6715 //
     /*  88762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88776 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  88776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88781 */   GIR_RootConstrainSelectedInstOperands,
     /*  88782 */   // GIR_Coverage, 6715,
     /*  88782 */   GIR_Done,
     /*  88783 */ // Label 1496: @88783
     /*  88783 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(88809), // Rule ID 6716 //
     /*  88788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88802 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  88802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88807 */   GIR_RootConstrainSelectedInstOperands,
     /*  88808 */   // GIR_Coverage, 6716,
     /*  88808 */   GIR_Done,
     /*  88809 */ // Label 1497: @88809
     /*  88809 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(88835), // Rule ID 6717 //
     /*  88814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88828 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  88828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88833 */   GIR_RootConstrainSelectedInstOperands,
     /*  88834 */   // GIR_Coverage, 6717,
     /*  88834 */   GIR_Done,
     /*  88835 */ // Label 1498: @88835
     /*  88835 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(88861), // Rule ID 6718 //
     /*  88840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88854 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  88854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88859 */   GIR_RootConstrainSelectedInstOperands,
     /*  88860 */   // GIR_Coverage, 6718,
     /*  88860 */   GIR_Done,
     /*  88861 */ // Label 1499: @88861
     /*  88861 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(88887), // Rule ID 6719 //
     /*  88866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88880 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  88880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88885 */   GIR_RootConstrainSelectedInstOperands,
     /*  88886 */   // GIR_Coverage, 6719,
     /*  88886 */   GIR_Done,
     /*  88887 */ // Label 1500: @88887
     /*  88887 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(88916), // Rule ID 6720 //
     /*  88892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88903 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88915 */   // GIR_Coverage, 6720,
     /*  88915 */   GIR_EraseRootFromParent_Done,
     /*  88916 */ // Label 1501: @88916
     /*  88916 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(88945), // Rule ID 6721 //
     /*  88921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88932 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   // GIR_Coverage, 6721,
     /*  88944 */   GIR_EraseRootFromParent_Done,
     /*  88945 */ // Label 1502: @88945
     /*  88945 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(88977), // Rule ID 6722 //
     /*  88950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88964 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88976 */   // GIR_Coverage, 6722,
     /*  88976 */   GIR_EraseRootFromParent_Done,
     /*  88977 */ // Label 1503: @88977
     /*  88977 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89009), // Rule ID 6723 //
     /*  88982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88996 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89008 */   // GIR_Coverage, 6723,
     /*  89008 */   GIR_EraseRootFromParent_Done,
     /*  89009 */ // Label 1504: @89009
     /*  89009 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89041), // Rule ID 6724 //
     /*  89014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89028 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89031 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89033 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89035 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89040 */   // GIR_Coverage, 6724,
     /*  89040 */   GIR_EraseRootFromParent_Done,
     /*  89041 */ // Label 1505: @89041
     /*  89041 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89073), // Rule ID 6725 //
     /*  89046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89060 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89072 */   // GIR_Coverage, 6725,
     /*  89072 */   GIR_EraseRootFromParent_Done,
     /*  89073 */ // Label 1506: @89073
     /*  89073 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89105), // Rule ID 6726 //
     /*  89078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89092 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89104 */   // GIR_Coverage, 6726,
     /*  89104 */   GIR_EraseRootFromParent_Done,
     /*  89105 */ // Label 1507: @89105
     /*  89105 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89131), // Rule ID 6727 //
     /*  89110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89124 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89129 */   GIR_RootConstrainSelectedInstOperands,
     /*  89130 */   // GIR_Coverage, 6727,
     /*  89130 */   GIR_Done,
     /*  89131 */ // Label 1508: @89131
     /*  89131 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89157), // Rule ID 6728 //
     /*  89136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89150 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89155 */   GIR_RootConstrainSelectedInstOperands,
     /*  89156 */   // GIR_Coverage, 6728,
     /*  89156 */   GIR_Done,
     /*  89157 */ // Label 1509: @89157
     /*  89157 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89183), // Rule ID 6729 //
     /*  89162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89176 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89181 */   GIR_RootConstrainSelectedInstOperands,
     /*  89182 */   // GIR_Coverage, 6729,
     /*  89182 */   GIR_Done,
     /*  89183 */ // Label 1510: @89183
     /*  89183 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89209), // Rule ID 6730 //
     /*  89188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89202 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89207 */   GIR_RootConstrainSelectedInstOperands,
     /*  89208 */   // GIR_Coverage, 6730,
     /*  89208 */   GIR_Done,
     /*  89209 */ // Label 1511: @89209
     /*  89209 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89235), // Rule ID 6731 //
     /*  89214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89228 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89233 */   GIR_RootConstrainSelectedInstOperands,
     /*  89234 */   // GIR_Coverage, 6731,
     /*  89234 */   GIR_Done,
     /*  89235 */ // Label 1512: @89235
     /*  89235 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89264), // Rule ID 6732 //
     /*  89240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89251 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89263 */   // GIR_Coverage, 6732,
     /*  89263 */   GIR_EraseRootFromParent_Done,
     /*  89264 */ // Label 1513: @89264
     /*  89264 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89293), // Rule ID 6733 //
     /*  89269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89280 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89292 */   // GIR_Coverage, 6733,
     /*  89292 */   GIR_EraseRootFromParent_Done,
     /*  89293 */ // Label 1514: @89293
     /*  89293 */ GIM_Reject,
     /*  89294 */ // Label 1436: @89294
     /*  89294 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89326), // Rule ID 6747 //
     /*  89299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89313 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89316 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89318 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89325 */   // GIR_Coverage, 6747,
     /*  89325 */   GIR_EraseRootFromParent_Done,
     /*  89326 */ // Label 1515: @89326
     /*  89326 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(89358), // Rule ID 6748 //
     /*  89331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89345 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89348 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */   // GIR_Coverage, 6748,
     /*  89357 */   GIR_EraseRootFromParent_Done,
     /*  89358 */ // Label 1516: @89358
     /*  89358 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(89390), // Rule ID 6749 //
     /*  89363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89377 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89380 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89389 */   // GIR_Coverage, 6749,
     /*  89389 */   GIR_EraseRootFromParent_Done,
     /*  89390 */ // Label 1517: @89390
     /*  89390 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(89422), // Rule ID 6750 //
     /*  89395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89409 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89412 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89414 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89421 */   // GIR_Coverage, 6750,
     /*  89421 */   GIR_EraseRootFromParent_Done,
     /*  89422 */ // Label 1518: @89422
     /*  89422 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(89454), // Rule ID 6751 //
     /*  89427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89441 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89444 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89453 */   // GIR_Coverage, 6751,
     /*  89453 */   GIR_EraseRootFromParent_Done,
     /*  89454 */ // Label 1519: @89454
     /*  89454 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(89486), // Rule ID 6752 //
     /*  89459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89473 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89476 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89478 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89485 */   // GIR_Coverage, 6752,
     /*  89485 */   GIR_EraseRootFromParent_Done,
     /*  89486 */ // Label 1520: @89486
     /*  89486 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(89518), // Rule ID 6753 //
     /*  89491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89505 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89508 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89510 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89517 */   // GIR_Coverage, 6753,
     /*  89517 */   GIR_EraseRootFromParent_Done,
     /*  89518 */ // Label 1521: @89518
     /*  89518 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(89551), // Rule ID 6754 //
     /*  89523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89537 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  89537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89544 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89549 */   GIR_RootConstrainSelectedInstOperands,
     /*  89550 */   // GIR_Coverage, 6754,
     /*  89550 */   GIR_EraseRootFromParent_Done,
     /*  89551 */ // Label 1522: @89551
     /*  89551 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(89622), // Rule ID 6755 //
     /*  89556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89570 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  89570 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89573 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89577 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89582 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89600 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89620 */   GIR_RootConstrainSelectedInstOperands,
     /*  89621 */   // GIR_Coverage, 6755,
     /*  89621 */   GIR_EraseRootFromParent_Done,
     /*  89622 */ // Label 1523: @89622
     /*  89622 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(89693), // Rule ID 6756 //
     /*  89627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89641 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  89641 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89644 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89648 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89653 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89691 */   GIR_RootConstrainSelectedInstOperands,
     /*  89692 */   // GIR_Coverage, 6756,
     /*  89692 */   GIR_EraseRootFromParent_Done,
     /*  89693 */ // Label 1524: @89693
     /*  89693 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(89764), // Rule ID 6757 //
     /*  89698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89712 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  89712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89724 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89762 */   GIR_RootConstrainSelectedInstOperands,
     /*  89763 */   // GIR_Coverage, 6757,
     /*  89763 */   GIR_EraseRootFromParent_Done,
     /*  89764 */ // Label 1525: @89764
     /*  89764 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(89797), // Rule ID 6758 //
     /*  89769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89783 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  89783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89788 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89795 */   GIR_RootConstrainSelectedInstOperands,
     /*  89796 */   // GIR_Coverage, 6758,
     /*  89796 */   GIR_EraseRootFromParent_Done,
     /*  89797 */ // Label 1526: @89797
     /*  89797 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(89868), // Rule ID 6759 //
     /*  89802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89816 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  89816 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89819 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89823 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89828 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89866 */   GIR_RootConstrainSelectedInstOperands,
     /*  89867 */   // GIR_Coverage, 6759,
     /*  89867 */   GIR_EraseRootFromParent_Done,
     /*  89868 */ // Label 1527: @89868
     /*  89868 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(89939), // Rule ID 6760 //
     /*  89873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89887 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  89887 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89890 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89894 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89899 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89917 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89937 */   GIR_RootConstrainSelectedInstOperands,
     /*  89938 */   // GIR_Coverage, 6760,
     /*  89938 */   GIR_EraseRootFromParent_Done,
     /*  89939 */ // Label 1528: @89939
     /*  89939 */ GIM_Reject,
     /*  89940 */ // Label 1437: @89940
     /*  89940 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(89970), // Rule ID 6612 //
     /*  89945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89959 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89969 */   // GIR_Coverage, 6612,
     /*  89969 */   GIR_Done,
     /*  89970 */ // Label 1529: @89970
     /*  89970 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90000), // Rule ID 6614 //
     /*  89975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89989 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89999 */   // GIR_Coverage, 6614,
     /*  89999 */   GIR_Done,
     /*  90000 */ // Label 1530: @90000
     /*  90000 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90050), // Rule ID 6623 //
     /*  90005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90019 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90035 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90048 */   GIR_RootConstrainSelectedInstOperands,
     /*  90049 */   // GIR_Coverage, 6623,
     /*  90049 */   GIR_EraseRootFromParent_Done,
     /*  90050 */ // Label 1531: @90050
     /*  90050 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90100), // Rule ID 6625 //
     /*  90055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90069 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90085 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90098 */   GIR_RootConstrainSelectedInstOperands,
     /*  90099 */   // GIR_Coverage, 6625,
     /*  90099 */   GIR_EraseRootFromParent_Done,
     /*  90100 */ // Label 1532: @90100
     /*  90100 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90132), // Rule ID 6657 //
     /*  90105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90119 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90122 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90124 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90131 */   // GIR_Coverage, 6657,
     /*  90131 */   GIR_EraseRootFromParent_Done,
     /*  90132 */ // Label 1533: @90132
     /*  90132 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90164), // Rule ID 6658 //
     /*  90137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90151 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90163 */   // GIR_Coverage, 6658,
     /*  90163 */   GIR_EraseRootFromParent_Done,
     /*  90164 */ // Label 1534: @90164
     /*  90164 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90196), // Rule ID 6659 //
     /*  90169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90183 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90186 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90188 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90195 */   // GIR_Coverage, 6659,
     /*  90195 */   GIR_EraseRootFromParent_Done,
     /*  90196 */ // Label 1535: @90196
     /*  90196 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90228), // Rule ID 6660 //
     /*  90201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90215 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90218 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90220 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90227 */   // GIR_Coverage, 6660,
     /*  90227 */   GIR_EraseRootFromParent_Done,
     /*  90228 */ // Label 1536: @90228
     /*  90228 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90260), // Rule ID 6661 //
     /*  90233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90247 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90259 */   // GIR_Coverage, 6661,
     /*  90259 */   GIR_EraseRootFromParent_Done,
     /*  90260 */ // Label 1537: @90260
     /*  90260 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90292), // Rule ID 6662 //
     /*  90265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90279 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90282 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90284 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90291 */   // GIR_Coverage, 6662,
     /*  90291 */   GIR_EraseRootFromParent_Done,
     /*  90292 */ // Label 1538: @90292
     /*  90292 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90318), // Rule ID 6663 //
     /*  90297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90311 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  90311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90316 */   GIR_RootConstrainSelectedInstOperands,
     /*  90317 */   // GIR_Coverage, 6663,
     /*  90317 */   GIR_Done,
     /*  90318 */ // Label 1539: @90318
     /*  90318 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(90344), // Rule ID 6664 //
     /*  90323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90337 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  90337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90342 */   GIR_RootConstrainSelectedInstOperands,
     /*  90343 */   // GIR_Coverage, 6664,
     /*  90343 */   GIR_Done,
     /*  90344 */ // Label 1540: @90344
     /*  90344 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(90370), // Rule ID 6665 //
     /*  90349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90363 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  90363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90368 */   GIR_RootConstrainSelectedInstOperands,
     /*  90369 */   // GIR_Coverage, 6665,
     /*  90369 */   GIR_Done,
     /*  90370 */ // Label 1541: @90370
     /*  90370 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(90396), // Rule ID 6666 //
     /*  90375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90389 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  90389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90394 */   GIR_RootConstrainSelectedInstOperands,
     /*  90395 */   // GIR_Coverage, 6666,
     /*  90395 */   GIR_Done,
     /*  90396 */ // Label 1542: @90396
     /*  90396 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(90422), // Rule ID 6667 //
     /*  90401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90415 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  90415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90420 */   GIR_RootConstrainSelectedInstOperands,
     /*  90421 */   // GIR_Coverage, 6667,
     /*  90421 */   GIR_Done,
     /*  90422 */ // Label 1543: @90422
     /*  90422 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(90448), // Rule ID 6668 //
     /*  90427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90441 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  90441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90446 */   GIR_RootConstrainSelectedInstOperands,
     /*  90447 */   // GIR_Coverage, 6668,
     /*  90447 */   GIR_Done,
     /*  90448 */ // Label 1544: @90448
     /*  90448 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(90477), // Rule ID 6669 //
     /*  90453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90464 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90467 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90469 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90476 */   // GIR_Coverage, 6669,
     /*  90476 */   GIR_EraseRootFromParent_Done,
     /*  90477 */ // Label 1545: @90477
     /*  90477 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(90509), // Rule ID 6734 //
     /*  90482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90496 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90499 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90501 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90508 */   // GIR_Coverage, 6734,
     /*  90508 */   GIR_EraseRootFromParent_Done,
     /*  90509 */ // Label 1546: @90509
     /*  90509 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(90541), // Rule ID 6735 //
     /*  90514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90528 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90540 */   // GIR_Coverage, 6735,
     /*  90540 */   GIR_EraseRootFromParent_Done,
     /*  90541 */ // Label 1547: @90541
     /*  90541 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(90573), // Rule ID 6736 //
     /*  90546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90560 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90563 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90565 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90572 */   // GIR_Coverage, 6736,
     /*  90572 */   GIR_EraseRootFromParent_Done,
     /*  90573 */ // Label 1548: @90573
     /*  90573 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(90605), // Rule ID 6737 //
     /*  90578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90592 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90595 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90604 */   // GIR_Coverage, 6737,
     /*  90604 */   GIR_EraseRootFromParent_Done,
     /*  90605 */ // Label 1549: @90605
     /*  90605 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(90637), // Rule ID 6738 //
     /*  90610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90624 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90636 */   // GIR_Coverage, 6738,
     /*  90636 */   GIR_EraseRootFromParent_Done,
     /*  90637 */ // Label 1550: @90637
     /*  90637 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(90669), // Rule ID 6739 //
     /*  90642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90656 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90668 */   // GIR_Coverage, 6739,
     /*  90668 */   GIR_EraseRootFromParent_Done,
     /*  90669 */ // Label 1551: @90669
     /*  90669 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(90695), // Rule ID 6740 //
     /*  90674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90688 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  90688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90693 */   GIR_RootConstrainSelectedInstOperands,
     /*  90694 */   // GIR_Coverage, 6740,
     /*  90694 */   GIR_Done,
     /*  90695 */ // Label 1552: @90695
     /*  90695 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(90721), // Rule ID 6741 //
     /*  90700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90714 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  90714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90719 */   GIR_RootConstrainSelectedInstOperands,
     /*  90720 */   // GIR_Coverage, 6741,
     /*  90720 */   GIR_Done,
     /*  90721 */ // Label 1553: @90721
     /*  90721 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(90747), // Rule ID 6742 //
     /*  90726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90740 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  90740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90745 */   GIR_RootConstrainSelectedInstOperands,
     /*  90746 */   // GIR_Coverage, 6742,
     /*  90746 */   GIR_Done,
     /*  90747 */ // Label 1554: @90747
     /*  90747 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(90773), // Rule ID 6743 //
     /*  90752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90766 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  90766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90771 */   GIR_RootConstrainSelectedInstOperands,
     /*  90772 */   // GIR_Coverage, 6743,
     /*  90772 */   GIR_Done,
     /*  90773 */ // Label 1555: @90773
     /*  90773 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(90799), // Rule ID 6744 //
     /*  90778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90792 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  90792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90797 */   GIR_RootConstrainSelectedInstOperands,
     /*  90798 */   // GIR_Coverage, 6744,
     /*  90798 */   GIR_Done,
     /*  90799 */ // Label 1556: @90799
     /*  90799 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(90825), // Rule ID 6745 //
     /*  90804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90818 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  90818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90823 */   GIR_RootConstrainSelectedInstOperands,
     /*  90824 */   // GIR_Coverage, 6745,
     /*  90824 */   GIR_Done,
     /*  90825 */ // Label 1557: @90825
     /*  90825 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(90854), // Rule ID 6746 //
     /*  90830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90841 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90853 */   // GIR_Coverage, 6746,
     /*  90853 */   GIR_EraseRootFromParent_Done,
     /*  90854 */ // Label 1558: @90854
     /*  90854 */ GIM_Reject,
     /*  90855 */ // Label 1438: @90855
     /*  90855 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(90887), // Rule ID 6761 //
     /*  90860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90874 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90877 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90879 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90886 */   // GIR_Coverage, 6761,
     /*  90886 */   GIR_EraseRootFromParent_Done,
     /*  90887 */ // Label 1559: @90887
     /*  90887 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(90919), // Rule ID 6762 //
     /*  90892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90906 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90909 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90918 */   // GIR_Coverage, 6762,
     /*  90918 */   GIR_EraseRootFromParent_Done,
     /*  90919 */ // Label 1560: @90919
     /*  90919 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(90951), // Rule ID 6763 //
     /*  90924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90938 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90941 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90950 */   // GIR_Coverage, 6763,
     /*  90950 */   GIR_EraseRootFromParent_Done,
     /*  90951 */ // Label 1561: @90951
     /*  90951 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(90983), // Rule ID 6764 //
     /*  90956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90970 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90973 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90975 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90982 */   // GIR_Coverage, 6764,
     /*  90982 */   GIR_EraseRootFromParent_Done,
     /*  90983 */ // Label 1562: @90983
     /*  90983 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91015), // Rule ID 6765 //
     /*  90988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91002 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91014 */   // GIR_Coverage, 6765,
     /*  91014 */   GIR_EraseRootFromParent_Done,
     /*  91015 */ // Label 1563: @91015
     /*  91015 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91047), // Rule ID 6766 //
     /*  91020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91034 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91046 */   // GIR_Coverage, 6766,
     /*  91046 */   GIR_EraseRootFromParent_Done,
     /*  91047 */ // Label 1564: @91047
     /*  91047 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91080), // Rule ID 6767 //
     /*  91052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91066 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91078 */   GIR_RootConstrainSelectedInstOperands,
     /*  91079 */   // GIR_Coverage, 6767,
     /*  91079 */   GIR_EraseRootFromParent_Done,
     /*  91080 */ // Label 1565: @91080
     /*  91080 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91106), // Rule ID 6768 //
     /*  91085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91099 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91104 */   GIR_RootConstrainSelectedInstOperands,
     /*  91105 */   // GIR_Coverage, 6768,
     /*  91105 */   GIR_Done,
     /*  91106 */ // Label 1566: @91106
     /*  91106 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91132), // Rule ID 6769 //
     /*  91111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91125 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91130 */   GIR_RootConstrainSelectedInstOperands,
     /*  91131 */   // GIR_Coverage, 6769,
     /*  91131 */   GIR_Done,
     /*  91132 */ // Label 1567: @91132
     /*  91132 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91158), // Rule ID 6770 //
     /*  91137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91151 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91156 */   GIR_RootConstrainSelectedInstOperands,
     /*  91157 */   // GIR_Coverage, 6770,
     /*  91157 */   GIR_Done,
     /*  91158 */ // Label 1568: @91158
     /*  91158 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91184), // Rule ID 6771 //
     /*  91163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91177 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91182 */   GIR_RootConstrainSelectedInstOperands,
     /*  91183 */   // GIR_Coverage, 6771,
     /*  91183 */   GIR_Done,
     /*  91184 */ // Label 1569: @91184
     /*  91184 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91210), // Rule ID 6772 //
     /*  91189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91203 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91208 */   GIR_RootConstrainSelectedInstOperands,
     /*  91209 */   // GIR_Coverage, 6772,
     /*  91209 */   GIR_Done,
     /*  91210 */ // Label 1570: @91210
     /*  91210 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91239), // Rule ID 6773 //
     /*  91215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91226 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91238 */   // GIR_Coverage, 6773,
     /*  91238 */   GIR_EraseRootFromParent_Done,
     /*  91239 */ // Label 1571: @91239
     /*  91239 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91271), // Rule ID 6787 //
     /*  91244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91258 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91261 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91263 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91270 */   // GIR_Coverage, 6787,
     /*  91270 */   GIR_EraseRootFromParent_Done,
     /*  91271 */ // Label 1572: @91271
     /*  91271 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91303), // Rule ID 6788 //
     /*  91276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91290 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91293 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91302 */   // GIR_Coverage, 6788,
     /*  91302 */   GIR_EraseRootFromParent_Done,
     /*  91303 */ // Label 1573: @91303
     /*  91303 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91335), // Rule ID 6789 //
     /*  91308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91322 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91334 */   // GIR_Coverage, 6789,
     /*  91334 */   GIR_EraseRootFromParent_Done,
     /*  91335 */ // Label 1574: @91335
     /*  91335 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(91367), // Rule ID 6790 //
     /*  91340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91354 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91366 */   // GIR_Coverage, 6790,
     /*  91366 */   GIR_EraseRootFromParent_Done,
     /*  91367 */ // Label 1575: @91367
     /*  91367 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(91399), // Rule ID 6791 //
     /*  91372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91386 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91398 */   // GIR_Coverage, 6791,
     /*  91398 */   GIR_EraseRootFromParent_Done,
     /*  91399 */ // Label 1576: @91399
     /*  91399 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(91431), // Rule ID 6792 //
     /*  91404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91418 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91421 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91423 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91430 */   // GIR_Coverage, 6792,
     /*  91430 */   GIR_EraseRootFromParent_Done,
     /*  91431 */ // Label 1577: @91431
     /*  91431 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(91464), // Rule ID 6793 //
     /*  91436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91450 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91462 */   GIR_RootConstrainSelectedInstOperands,
     /*  91463 */   // GIR_Coverage, 6793,
     /*  91463 */   GIR_EraseRootFromParent_Done,
     /*  91464 */ // Label 1578: @91464
     /*  91464 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(91490), // Rule ID 6794 //
     /*  91469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91483 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  91483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91488 */   GIR_RootConstrainSelectedInstOperands,
     /*  91489 */   // GIR_Coverage, 6794,
     /*  91489 */   GIR_Done,
     /*  91490 */ // Label 1579: @91490
     /*  91490 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(91516), // Rule ID 6795 //
     /*  91495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91509 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  91509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91514 */   GIR_RootConstrainSelectedInstOperands,
     /*  91515 */   // GIR_Coverage, 6795,
     /*  91515 */   GIR_Done,
     /*  91516 */ // Label 1580: @91516
     /*  91516 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(91542), // Rule ID 6796 //
     /*  91521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91535 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  91535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91540 */   GIR_RootConstrainSelectedInstOperands,
     /*  91541 */   // GIR_Coverage, 6796,
     /*  91541 */   GIR_Done,
     /*  91542 */ // Label 1581: @91542
     /*  91542 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(91568), // Rule ID 6797 //
     /*  91547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91561 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  91561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91566 */   GIR_RootConstrainSelectedInstOperands,
     /*  91567 */   // GIR_Coverage, 6797,
     /*  91567 */   GIR_Done,
     /*  91568 */ // Label 1582: @91568
     /*  91568 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(91594), // Rule ID 6798 //
     /*  91573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91587 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  91587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91592 */   GIR_RootConstrainSelectedInstOperands,
     /*  91593 */   // GIR_Coverage, 6798,
     /*  91593 */   GIR_Done,
     /*  91594 */ // Label 1583: @91594
     /*  91594 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(91623), // Rule ID 6799 //
     /*  91599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91610 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91622 */   // GIR_Coverage, 6799,
     /*  91622 */   GIR_EraseRootFromParent_Done,
     /*  91623 */ // Label 1584: @91623
     /*  91623 */ GIM_Reject,
     /*  91624 */ // Label 1439: @91624
     /*  91624 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(91654), // Rule ID 6611 //
     /*  91629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91643 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91653 */   // GIR_Coverage, 6611,
     /*  91653 */   GIR_Done,
     /*  91654 */ // Label 1585: @91654
     /*  91654 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(91684), // Rule ID 6613 //
     /*  91659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91673 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91683 */   // GIR_Coverage, 6613,
     /*  91683 */   GIR_Done,
     /*  91684 */ // Label 1586: @91684
     /*  91684 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(91734), // Rule ID 6622 //
     /*  91689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91703 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91719 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91732 */   GIR_RootConstrainSelectedInstOperands,
     /*  91733 */   // GIR_Coverage, 6622,
     /*  91733 */   GIR_EraseRootFromParent_Done,
     /*  91734 */ // Label 1587: @91734
     /*  91734 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(91784), // Rule ID 6624 //
     /*  91739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91753 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91765 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91769 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91782 */   GIR_RootConstrainSelectedInstOperands,
     /*  91783 */   // GIR_Coverage, 6624,
     /*  91783 */   GIR_EraseRootFromParent_Done,
     /*  91784 */ // Label 1588: @91784
     /*  91784 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(91816), // Rule ID 6670 //
     /*  91789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91803 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91815 */   // GIR_Coverage, 6670,
     /*  91815 */   GIR_EraseRootFromParent_Done,
     /*  91816 */ // Label 1589: @91816
     /*  91816 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(91848), // Rule ID 6671 //
     /*  91821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91835 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91838 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91847 */   // GIR_Coverage, 6671,
     /*  91847 */   GIR_EraseRootFromParent_Done,
     /*  91848 */ // Label 1590: @91848
     /*  91848 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(91880), // Rule ID 6672 //
     /*  91853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91867 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91870 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91872 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91879 */   // GIR_Coverage, 6672,
     /*  91879 */   GIR_EraseRootFromParent_Done,
     /*  91880 */ // Label 1591: @91880
     /*  91880 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(91912), // Rule ID 6673 //
     /*  91885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91899 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91902 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91904 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91911 */   // GIR_Coverage, 6673,
     /*  91911 */   GIR_EraseRootFromParent_Done,
     /*  91912 */ // Label 1592: @91912
     /*  91912 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(91944), // Rule ID 6674 //
     /*  91917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91931 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91934 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91936 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91943 */   // GIR_Coverage, 6674,
     /*  91943 */   GIR_EraseRootFromParent_Done,
     /*  91944 */ // Label 1593: @91944
     /*  91944 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(91976), // Rule ID 6675 //
     /*  91949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91963 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91966 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91968 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91975 */   // GIR_Coverage, 6675,
     /*  91975 */   GIR_EraseRootFromParent_Done,
     /*  91976 */ // Label 1594: @91976
     /*  91976 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92002), // Rule ID 6676 //
     /*  91981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91995 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  91995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92000 */   GIR_RootConstrainSelectedInstOperands,
     /*  92001 */   // GIR_Coverage, 6676,
     /*  92001 */   GIR_Done,
     /*  92002 */ // Label 1595: @92002
     /*  92002 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92028), // Rule ID 6677 //
     /*  92007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92021 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92026 */   GIR_RootConstrainSelectedInstOperands,
     /*  92027 */   // GIR_Coverage, 6677,
     /*  92027 */   GIR_Done,
     /*  92028 */ // Label 1596: @92028
     /*  92028 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92054), // Rule ID 6678 //
     /*  92033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92047 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92052 */   GIR_RootConstrainSelectedInstOperands,
     /*  92053 */   // GIR_Coverage, 6678,
     /*  92053 */   GIR_Done,
     /*  92054 */ // Label 1597: @92054
     /*  92054 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92080), // Rule ID 6679 //
     /*  92059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92073 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92078 */   GIR_RootConstrainSelectedInstOperands,
     /*  92079 */   // GIR_Coverage, 6679,
     /*  92079 */   GIR_Done,
     /*  92080 */ // Label 1598: @92080
     /*  92080 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92106), // Rule ID 6680 //
     /*  92085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92099 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92104 */   GIR_RootConstrainSelectedInstOperands,
     /*  92105 */   // GIR_Coverage, 6680,
     /*  92105 */   GIR_Done,
     /*  92106 */ // Label 1599: @92106
     /*  92106 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92132), // Rule ID 6681 //
     /*  92111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92125 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92130 */   GIR_RootConstrainSelectedInstOperands,
     /*  92131 */   // GIR_Coverage, 6681,
     /*  92131 */   GIR_Done,
     /*  92132 */ // Label 1600: @92132
     /*  92132 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92161), // Rule ID 6682 //
     /*  92137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92148 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92160 */   // GIR_Coverage, 6682,
     /*  92160 */   GIR_EraseRootFromParent_Done,
     /*  92161 */ // Label 1601: @92161
     /*  92161 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92193), // Rule ID 6683 //
     /*  92166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92180 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92192 */   // GIR_Coverage, 6683,
     /*  92192 */   GIR_EraseRootFromParent_Done,
     /*  92193 */ // Label 1602: @92193
     /*  92193 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92225), // Rule ID 6684 //
     /*  92198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92212 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92224 */   // GIR_Coverage, 6684,
     /*  92224 */   GIR_EraseRootFromParent_Done,
     /*  92225 */ // Label 1603: @92225
     /*  92225 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92257), // Rule ID 6685 //
     /*  92230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92244 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92256 */   // GIR_Coverage, 6685,
     /*  92256 */   GIR_EraseRootFromParent_Done,
     /*  92257 */ // Label 1604: @92257
     /*  92257 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92289), // Rule ID 6686 //
     /*  92262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92276 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92288 */   // GIR_Coverage, 6686,
     /*  92288 */   GIR_EraseRootFromParent_Done,
     /*  92289 */ // Label 1605: @92289
     /*  92289 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92321), // Rule ID 6687 //
     /*  92294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92308 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92311 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92320 */   // GIR_Coverage, 6687,
     /*  92320 */   GIR_EraseRootFromParent_Done,
     /*  92321 */ // Label 1606: @92321
     /*  92321 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(92353), // Rule ID 6688 //
     /*  92326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92340 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92343 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92345 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92352 */   // GIR_Coverage, 6688,
     /*  92352 */   GIR_EraseRootFromParent_Done,
     /*  92353 */ // Label 1607: @92353
     /*  92353 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(92379), // Rule ID 6689 //
     /*  92358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92372 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  92372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92377 */   GIR_RootConstrainSelectedInstOperands,
     /*  92378 */   // GIR_Coverage, 6689,
     /*  92378 */   GIR_Done,
     /*  92379 */ // Label 1608: @92379
     /*  92379 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(92405), // Rule ID 6690 //
     /*  92384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92398 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  92398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92403 */   GIR_RootConstrainSelectedInstOperands,
     /*  92404 */   // GIR_Coverage, 6690,
     /*  92404 */   GIR_Done,
     /*  92405 */ // Label 1609: @92405
     /*  92405 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(92431), // Rule ID 6691 //
     /*  92410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92424 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  92424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92429 */   GIR_RootConstrainSelectedInstOperands,
     /*  92430 */   // GIR_Coverage, 6691,
     /*  92430 */   GIR_Done,
     /*  92431 */ // Label 1610: @92431
     /*  92431 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(92457), // Rule ID 6692 //
     /*  92436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92450 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  92450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92455 */   GIR_RootConstrainSelectedInstOperands,
     /*  92456 */   // GIR_Coverage, 6692,
     /*  92456 */   GIR_Done,
     /*  92457 */ // Label 1611: @92457
     /*  92457 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(92483), // Rule ID 6693 //
     /*  92462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92476 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  92476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92481 */   GIR_RootConstrainSelectedInstOperands,
     /*  92482 */   // GIR_Coverage, 6693,
     /*  92482 */   GIR_Done,
     /*  92483 */ // Label 1612: @92483
     /*  92483 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(92509), // Rule ID 6694 //
     /*  92488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92502 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  92502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92507 */   GIR_RootConstrainSelectedInstOperands,
     /*  92508 */   // GIR_Coverage, 6694,
     /*  92508 */   GIR_Done,
     /*  92509 */ // Label 1613: @92509
     /*  92509 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(92538), // Rule ID 6695 //
     /*  92514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92525 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92528 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92537 */   // GIR_Coverage, 6695,
     /*  92537 */   GIR_EraseRootFromParent_Done,
     /*  92538 */ // Label 1614: @92538
     /*  92538 */ GIM_Reject,
     /*  92539 */ // Label 1440: @92539
     /*  92539 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(92571), // Rule ID 6774 //
     /*  92544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92558 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92570 */   // GIR_Coverage, 6774,
     /*  92570 */   GIR_EraseRootFromParent_Done,
     /*  92571 */ // Label 1615: @92571
     /*  92571 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(92603), // Rule ID 6775 //
     /*  92576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92590 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92602 */   // GIR_Coverage, 6775,
     /*  92602 */   GIR_EraseRootFromParent_Done,
     /*  92603 */ // Label 1616: @92603
     /*  92603 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(92635), // Rule ID 6776 //
     /*  92608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92622 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92625 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92634 */   // GIR_Coverage, 6776,
     /*  92634 */   GIR_EraseRootFromParent_Done,
     /*  92635 */ // Label 1617: @92635
     /*  92635 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(92667), // Rule ID 6777 //
     /*  92640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92654 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92657 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92666 */   // GIR_Coverage, 6777,
     /*  92666 */   GIR_EraseRootFromParent_Done,
     /*  92667 */ // Label 1618: @92667
     /*  92667 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(92699), // Rule ID 6778 //
     /*  92672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92686 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92698 */   // GIR_Coverage, 6778,
     /*  92698 */   GIR_EraseRootFromParent_Done,
     /*  92699 */ // Label 1619: @92699
     /*  92699 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(92731), // Rule ID 6779 //
     /*  92704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92718 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92721 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92723 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92730 */   // GIR_Coverage, 6779,
     /*  92730 */   GIR_EraseRootFromParent_Done,
     /*  92731 */ // Label 1620: @92731
     /*  92731 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(92802), // Rule ID 6780 //
     /*  92736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92750 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  92750 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  92753 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92757 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92762 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  92771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92800 */   GIR_RootConstrainSelectedInstOperands,
     /*  92801 */   // GIR_Coverage, 6780,
     /*  92801 */   GIR_EraseRootFromParent_Done,
     /*  92802 */ // Label 1621: @92802
     /*  92802 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(92828), // Rule ID 6781 //
     /*  92807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92821 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  92821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92826 */   GIR_RootConstrainSelectedInstOperands,
     /*  92827 */   // GIR_Coverage, 6781,
     /*  92827 */   GIR_Done,
     /*  92828 */ // Label 1622: @92828
     /*  92828 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(92854), // Rule ID 6782 //
     /*  92833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92847 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  92847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92852 */   GIR_RootConstrainSelectedInstOperands,
     /*  92853 */   // GIR_Coverage, 6782,
     /*  92853 */   GIR_Done,
     /*  92854 */ // Label 1623: @92854
     /*  92854 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(92880), // Rule ID 6783 //
     /*  92859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92873 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  92873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  92878 */   GIR_RootConstrainSelectedInstOperands,
     /*  92879 */   // GIR_Coverage, 6783,
     /*  92879 */   GIR_Done,
     /*  92880 */ // Label 1624: @92880
     /*  92880 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(92906), // Rule ID 6784 //
     /*  92885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92899 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  92899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92904 */   GIR_RootConstrainSelectedInstOperands,
     /*  92905 */   // GIR_Coverage, 6784,
     /*  92905 */   GIR_Done,
     /*  92906 */ // Label 1625: @92906
     /*  92906 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(92932), // Rule ID 6785 //
     /*  92911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92925 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  92925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92930 */   GIR_RootConstrainSelectedInstOperands,
     /*  92931 */   // GIR_Coverage, 6785,
     /*  92931 */   GIR_Done,
     /*  92932 */ // Label 1626: @92932
     /*  92932 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(92961), // Rule ID 6786 //
     /*  92937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92948 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92960 */   // GIR_Coverage, 6786,
     /*  92960 */   GIR_EraseRootFromParent_Done,
     /*  92961 */ // Label 1627: @92961
     /*  92961 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(92993), // Rule ID 6800 //
     /*  92966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92980 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92992 */   // GIR_Coverage, 6800,
     /*  92992 */   GIR_EraseRootFromParent_Done,
     /*  92993 */ // Label 1628: @92993
     /*  92993 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93025), // Rule ID 6801 //
     /*  92998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93012 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93024 */   // GIR_Coverage, 6801,
     /*  93024 */   GIR_EraseRootFromParent_Done,
     /*  93025 */ // Label 1629: @93025
     /*  93025 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93057), // Rule ID 6802 //
     /*  93030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93044 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93056 */   // GIR_Coverage, 6802,
     /*  93056 */   GIR_EraseRootFromParent_Done,
     /*  93057 */ // Label 1630: @93057
     /*  93057 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93089), // Rule ID 6803 //
     /*  93062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93076 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93088 */   // GIR_Coverage, 6803,
     /*  93088 */   GIR_EraseRootFromParent_Done,
     /*  93089 */ // Label 1631: @93089
     /*  93089 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93121), // Rule ID 6804 //
     /*  93094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93108 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93120 */   // GIR_Coverage, 6804,
     /*  93120 */   GIR_EraseRootFromParent_Done,
     /*  93121 */ // Label 1632: @93121
     /*  93121 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93153), // Rule ID 6805 //
     /*  93126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93140 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93152 */   // GIR_Coverage, 6805,
     /*  93152 */   GIR_EraseRootFromParent_Done,
     /*  93153 */ // Label 1633: @93153
     /*  93153 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93224), // Rule ID 6806 //
     /*  93158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93172 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93172 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93175 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93179 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93184 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93202 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93222 */   GIR_RootConstrainSelectedInstOperands,
     /*  93223 */   // GIR_Coverage, 6806,
     /*  93223 */   GIR_EraseRootFromParent_Done,
     /*  93224 */ // Label 1634: @93224
     /*  93224 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93250), // Rule ID 6807 //
     /*  93229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93243 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93248 */   GIR_RootConstrainSelectedInstOperands,
     /*  93249 */   // GIR_Coverage, 6807,
     /*  93249 */   GIR_Done,
     /*  93250 */ // Label 1635: @93250
     /*  93250 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93276), // Rule ID 6808 //
     /*  93255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93269 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  93269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93274 */   GIR_RootConstrainSelectedInstOperands,
     /*  93275 */   // GIR_Coverage, 6808,
     /*  93275 */   GIR_Done,
     /*  93276 */ // Label 1636: @93276
     /*  93276 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93302), // Rule ID 6809 //
     /*  93281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93295 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  93295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93300 */   GIR_RootConstrainSelectedInstOperands,
     /*  93301 */   // GIR_Coverage, 6809,
     /*  93301 */   GIR_Done,
     /*  93302 */ // Label 1637: @93302
     /*  93302 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(93328), // Rule ID 6810 //
     /*  93307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93321 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  93321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93326 */   GIR_RootConstrainSelectedInstOperands,
     /*  93327 */   // GIR_Coverage, 6810,
     /*  93327 */   GIR_Done,
     /*  93328 */ // Label 1638: @93328
     /*  93328 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(93354), // Rule ID 6811 //
     /*  93333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93347 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  93347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93352 */   GIR_RootConstrainSelectedInstOperands,
     /*  93353 */   // GIR_Coverage, 6811,
     /*  93353 */   GIR_Done,
     /*  93354 */ // Label 1639: @93354
     /*  93354 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(93383), // Rule ID 6812 //
     /*  93359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93370 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93373 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93375 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93382 */   // GIR_Coverage, 6812,
     /*  93382 */   GIR_EraseRootFromParent_Done,
     /*  93383 */ // Label 1640: @93383
     /*  93383 */ GIM_Reject,
     /*  93384 */ // Label 1441: @93384
     /*  93384 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(93458), // Rule ID 5655 //
     /*  93389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  93404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  93408 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  93413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93415 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  93415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  93422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93427 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  93431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  93436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  93447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93457 */   // GIR_Coverage, 5655,
     /*  93457 */   GIR_EraseRootFromParent_Done,
     /*  93458 */ // Label 1641: @93458
     /*  93458 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(93488), // Rule ID 6610 //
     /*  93463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93477 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  93477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93487 */   // GIR_Coverage, 6610,
     /*  93487 */   GIR_Done,
     /*  93488 */ // Label 1642: @93488
     /*  93488 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(93538), // Rule ID 6621 //
     /*  93493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93507 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  93507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93519 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  93523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93536 */   GIR_RootConstrainSelectedInstOperands,
     /*  93537 */   // GIR_Coverage, 6621,
     /*  93537 */   GIR_EraseRootFromParent_Done,
     /*  93538 */ // Label 1643: @93538
     /*  93538 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(93570), // Rule ID 6696 //
     /*  93543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93557 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93560 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93562 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93569 */   // GIR_Coverage, 6696,
     /*  93569 */   GIR_EraseRootFromParent_Done,
     /*  93570 */ // Label 1644: @93570
     /*  93570 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(93602), // Rule ID 6697 //
     /*  93575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93589 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93592 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93594 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93601 */   // GIR_Coverage, 6697,
     /*  93601 */   GIR_EraseRootFromParent_Done,
     /*  93602 */ // Label 1645: @93602
     /*  93602 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(93634), // Rule ID 6698 //
     /*  93607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93621 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93624 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93626 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93633 */   // GIR_Coverage, 6698,
     /*  93633 */   GIR_EraseRootFromParent_Done,
     /*  93634 */ // Label 1646: @93634
     /*  93634 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(93666), // Rule ID 6699 //
     /*  93639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93653 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93656 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93658 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93665 */   // GIR_Coverage, 6699,
     /*  93665 */   GIR_EraseRootFromParent_Done,
     /*  93666 */ // Label 1647: @93666
     /*  93666 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(93698), // Rule ID 6700 //
     /*  93671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93685 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93688 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93690 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93697 */   // GIR_Coverage, 6700,
     /*  93697 */   GIR_EraseRootFromParent_Done,
     /*  93698 */ // Label 1648: @93698
     /*  93698 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(93730), // Rule ID 6701 //
     /*  93703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93717 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93720 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93722 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93729 */   // GIR_Coverage, 6701,
     /*  93729 */   GIR_EraseRootFromParent_Done,
     /*  93730 */ // Label 1649: @93730
     /*  93730 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(93762), // Rule ID 6702 //
     /*  93735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93749 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93752 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93754 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93756 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93761 */   // GIR_Coverage, 6702,
     /*  93761 */   GIR_EraseRootFromParent_Done,
     /*  93762 */ // Label 1650: @93762
     /*  93762 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(93788), // Rule ID 6703 //
     /*  93767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93781 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  93781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93786 */   GIR_RootConstrainSelectedInstOperands,
     /*  93787 */   // GIR_Coverage, 6703,
     /*  93787 */   GIR_Done,
     /*  93788 */ // Label 1651: @93788
     /*  93788 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(93814), // Rule ID 6704 //
     /*  93793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93807 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  93807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93812 */   GIR_RootConstrainSelectedInstOperands,
     /*  93813 */   // GIR_Coverage, 6704,
     /*  93813 */   GIR_Done,
     /*  93814 */ // Label 1652: @93814
     /*  93814 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(93840), // Rule ID 6705 //
     /*  93819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93833 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  93833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93838 */   GIR_RootConstrainSelectedInstOperands,
     /*  93839 */   // GIR_Coverage, 6705,
     /*  93839 */   GIR_Done,
     /*  93840 */ // Label 1653: @93840
     /*  93840 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(93866), // Rule ID 6706 //
     /*  93845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93859 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  93859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93864 */   GIR_RootConstrainSelectedInstOperands,
     /*  93865 */   // GIR_Coverage, 6706,
     /*  93865 */   GIR_Done,
     /*  93866 */ // Label 1654: @93866
     /*  93866 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(93892), // Rule ID 6707 //
     /*  93871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93885 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  93885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93890 */   GIR_RootConstrainSelectedInstOperands,
     /*  93891 */   // GIR_Coverage, 6707,
     /*  93891 */   GIR_Done,
     /*  93892 */ // Label 1655: @93892
     /*  93892 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(93918), // Rule ID 6708 //
     /*  93897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93911 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  93911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93916 */   GIR_RootConstrainSelectedInstOperands,
     /*  93917 */   // GIR_Coverage, 6708,
     /*  93917 */   GIR_Done,
     /*  93918 */ // Label 1656: @93918
     /*  93918 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(93944), // Rule ID 6709 //
     /*  93923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93937 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  93937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93942 */   GIR_RootConstrainSelectedInstOperands,
     /*  93943 */   // GIR_Coverage, 6709,
     /*  93943 */   GIR_Done,
     /*  93944 */ // Label 1657: @93944
     /*  93944 */ GIM_Reject,
     /*  93945 */ // Label 1442: @93945
     /*  93945 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(93977), // Rule ID 6813 //
     /*  93950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93964 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93976 */   // GIR_Coverage, 6813,
     /*  93976 */   GIR_EraseRootFromParent_Done,
     /*  93977 */ // Label 1658: @93977
     /*  93977 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94009), // Rule ID 6814 //
     /*  93982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93996 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94008 */   // GIR_Coverage, 6814,
     /*  94008 */   GIR_EraseRootFromParent_Done,
     /*  94009 */ // Label 1659: @94009
     /*  94009 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94041), // Rule ID 6815 //
     /*  94014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94028 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94031 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94033 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94035 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94040 */   // GIR_Coverage, 6815,
     /*  94040 */   GIR_EraseRootFromParent_Done,
     /*  94041 */ // Label 1660: @94041
     /*  94041 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94073), // Rule ID 6816 //
     /*  94046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94060 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94072 */   // GIR_Coverage, 6816,
     /*  94072 */   GIR_EraseRootFromParent_Done,
     /*  94073 */ // Label 1661: @94073
     /*  94073 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94105), // Rule ID 6817 //
     /*  94078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94092 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94104 */   // GIR_Coverage, 6817,
     /*  94104 */   GIR_EraseRootFromParent_Done,
     /*  94105 */ // Label 1662: @94105
     /*  94105 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94137), // Rule ID 6818 //
     /*  94110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94124 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94127 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94136 */   // GIR_Coverage, 6818,
     /*  94136 */   GIR_EraseRootFromParent_Done,
     /*  94137 */ // Label 1663: @94137
     /*  94137 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94208), // Rule ID 6819 //
     /*  94142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94156 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94156 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94159 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94163 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94168 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94186 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94206 */   GIR_RootConstrainSelectedInstOperands,
     /*  94207 */   // GIR_Coverage, 6819,
     /*  94207 */   GIR_EraseRootFromParent_Done,
     /*  94208 */ // Label 1664: @94208
     /*  94208 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94234), // Rule ID 6820 //
     /*  94213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94227 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94232 */   GIR_RootConstrainSelectedInstOperands,
     /*  94233 */   // GIR_Coverage, 6820,
     /*  94233 */   GIR_Done,
     /*  94234 */ // Label 1665: @94234
     /*  94234 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94260), // Rule ID 6821 //
     /*  94239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94253 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94258 */   GIR_RootConstrainSelectedInstOperands,
     /*  94259 */   // GIR_Coverage, 6821,
     /*  94259 */   GIR_Done,
     /*  94260 */ // Label 1666: @94260
     /*  94260 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94286), // Rule ID 6822 //
     /*  94265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94279 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  94279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94284 */   GIR_RootConstrainSelectedInstOperands,
     /*  94285 */   // GIR_Coverage, 6822,
     /*  94285 */   GIR_Done,
     /*  94286 */ // Label 1667: @94286
     /*  94286 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94312), // Rule ID 6823 //
     /*  94291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94305 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  94305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94310 */   GIR_RootConstrainSelectedInstOperands,
     /*  94311 */   // GIR_Coverage, 6823,
     /*  94311 */   GIR_Done,
     /*  94312 */ // Label 1668: @94312
     /*  94312 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(94338), // Rule ID 6824 //
     /*  94317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94331 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  94331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94336 */   GIR_RootConstrainSelectedInstOperands,
     /*  94337 */   // GIR_Coverage, 6824,
     /*  94337 */   GIR_Done,
     /*  94338 */ // Label 1669: @94338
     /*  94338 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(94367), // Rule ID 6825 //
     /*  94343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94354 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94366 */   // GIR_Coverage, 6825,
     /*  94366 */   GIR_EraseRootFromParent_Done,
     /*  94367 */ // Label 1670: @94367
     /*  94367 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(94399), // Rule ID 6826 //
     /*  94372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94386 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94398 */   // GIR_Coverage, 6826,
     /*  94398 */   GIR_EraseRootFromParent_Done,
     /*  94399 */ // Label 1671: @94399
     /*  94399 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(94431), // Rule ID 6827 //
     /*  94404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94418 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94421 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94423 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94430 */   // GIR_Coverage, 6827,
     /*  94430 */   GIR_EraseRootFromParent_Done,
     /*  94431 */ // Label 1672: @94431
     /*  94431 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(94463), // Rule ID 6828 //
     /*  94436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94450 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94453 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94462 */   // GIR_Coverage, 6828,
     /*  94462 */   GIR_EraseRootFromParent_Done,
     /*  94463 */ // Label 1673: @94463
     /*  94463 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(94495), // Rule ID 6829 //
     /*  94468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94482 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94485 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94494 */   // GIR_Coverage, 6829,
     /*  94494 */   GIR_EraseRootFromParent_Done,
     /*  94495 */ // Label 1674: @94495
     /*  94495 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94527), // Rule ID 6830 //
     /*  94500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94514 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94517 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94519 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94526 */   // GIR_Coverage, 6830,
     /*  94526 */   GIR_EraseRootFromParent_Done,
     /*  94527 */ // Label 1675: @94527
     /*  94527 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(94559), // Rule ID 6831 //
     /*  94532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94546 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94549 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94551 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94558 */   // GIR_Coverage, 6831,
     /*  94558 */   GIR_EraseRootFromParent_Done,
     /*  94559 */ // Label 1676: @94559
     /*  94559 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(94630), // Rule ID 6832 //
     /*  94564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94578 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94590 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94608 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94628 */   GIR_RootConstrainSelectedInstOperands,
     /*  94629 */   // GIR_Coverage, 6832,
     /*  94629 */   GIR_EraseRootFromParent_Done,
     /*  94630 */ // Label 1677: @94630
     /*  94630 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(94656), // Rule ID 6833 //
     /*  94635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94649 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  94649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94654 */   GIR_RootConstrainSelectedInstOperands,
     /*  94655 */   // GIR_Coverage, 6833,
     /*  94655 */   GIR_Done,
     /*  94656 */ // Label 1678: @94656
     /*  94656 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(94682), // Rule ID 6834 //
     /*  94661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94675 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  94675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94680 */   GIR_RootConstrainSelectedInstOperands,
     /*  94681 */   // GIR_Coverage, 6834,
     /*  94681 */   GIR_Done,
     /*  94682 */ // Label 1679: @94682
     /*  94682 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(94708), // Rule ID 6835 //
     /*  94687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94701 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  94701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94706 */   GIR_RootConstrainSelectedInstOperands,
     /*  94707 */   // GIR_Coverage, 6835,
     /*  94707 */   GIR_Done,
     /*  94708 */ // Label 1680: @94708
     /*  94708 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94734), // Rule ID 6836 //
     /*  94713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94727 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  94727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94732 */   GIR_RootConstrainSelectedInstOperands,
     /*  94733 */   // GIR_Coverage, 6836,
     /*  94733 */   GIR_Done,
     /*  94734 */ // Label 1681: @94734
     /*  94734 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(94760), // Rule ID 6837 //
     /*  94739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94753 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  94753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94758 */   GIR_RootConstrainSelectedInstOperands,
     /*  94759 */   // GIR_Coverage, 6837,
     /*  94759 */   GIR_Done,
     /*  94760 */ // Label 1682: @94760
     /*  94760 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(94789), // Rule ID 6838 //
     /*  94765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94776 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94779 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94781 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94788 */   // GIR_Coverage, 6838,
     /*  94788 */   GIR_EraseRootFromParent_Done,
     /*  94789 */ // Label 1683: @94789
     /*  94789 */ GIM_Reject,
     /*  94790 */ // Label 1443: @94790
     /*  94790 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(94822), // Rule ID 6839 //
     /*  94795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94809 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94821 */   // GIR_Coverage, 6839,
     /*  94821 */   GIR_EraseRootFromParent_Done,
     /*  94822 */ // Label 1684: @94822
     /*  94822 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94854), // Rule ID 6840 //
     /*  94827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94841 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94853 */   // GIR_Coverage, 6840,
     /*  94853 */   GIR_EraseRootFromParent_Done,
     /*  94854 */ // Label 1685: @94854
     /*  94854 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(94886), // Rule ID 6841 //
     /*  94859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94873 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94885 */   // GIR_Coverage, 6841,
     /*  94885 */   GIR_EraseRootFromParent_Done,
     /*  94886 */ // Label 1686: @94886
     /*  94886 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(94918), // Rule ID 6842 //
     /*  94891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94905 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94917 */   // GIR_Coverage, 6842,
     /*  94917 */   GIR_EraseRootFromParent_Done,
     /*  94918 */ // Label 1687: @94918
     /*  94918 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(94950), // Rule ID 6843 //
     /*  94923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94937 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94940 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94949 */   // GIR_Coverage, 6843,
     /*  94949 */   GIR_EraseRootFromParent_Done,
     /*  94950 */ // Label 1688: @94950
     /*  94950 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(94982), // Rule ID 6844 //
     /*  94955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94969 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94972 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94981 */   // GIR_Coverage, 6844,
     /*  94981 */   GIR_EraseRootFromParent_Done,
     /*  94982 */ // Label 1689: @94982
     /*  94982 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95014), // Rule ID 6845 //
     /*  94987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95001 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95004 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95006 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95013 */   // GIR_Coverage, 6845,
     /*  95013 */   GIR_EraseRootFromParent_Done,
     /*  95014 */ // Label 1690: @95014
     /*  95014 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95085), // Rule ID 6846 //
     /*  95019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95033 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95033 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95036 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95040 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95045 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95063 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95083 */   GIR_RootConstrainSelectedInstOperands,
     /*  95084 */   // GIR_Coverage, 6846,
     /*  95084 */   GIR_EraseRootFromParent_Done,
     /*  95085 */ // Label 1691: @95085
     /*  95085 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95111), // Rule ID 6847 //
     /*  95090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95104 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95109 */   GIR_RootConstrainSelectedInstOperands,
     /*  95110 */   // GIR_Coverage, 6847,
     /*  95110 */   GIR_Done,
     /*  95111 */ // Label 1692: @95111
     /*  95111 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95137), // Rule ID 6848 //
     /*  95116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95130 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95135 */   GIR_RootConstrainSelectedInstOperands,
     /*  95136 */   // GIR_Coverage, 6848,
     /*  95136 */   GIR_Done,
     /*  95137 */ // Label 1693: @95137
     /*  95137 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95163), // Rule ID 6849 //
     /*  95142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95156 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95161 */   GIR_RootConstrainSelectedInstOperands,
     /*  95162 */   // GIR_Coverage, 6849,
     /*  95162 */   GIR_Done,
     /*  95163 */ // Label 1694: @95163
     /*  95163 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95189), // Rule ID 6850 //
     /*  95168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95182 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95187 */   GIR_RootConstrainSelectedInstOperands,
     /*  95188 */   // GIR_Coverage, 6850,
     /*  95188 */   GIR_Done,
     /*  95189 */ // Label 1695: @95189
     /*  95189 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95215), // Rule ID 6851 //
     /*  95194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95208 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95213 */   GIR_RootConstrainSelectedInstOperands,
     /*  95214 */   // GIR_Coverage, 6851,
     /*  95214 */   GIR_Done,
     /*  95215 */ // Label 1696: @95215
     /*  95215 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95241), // Rule ID 6852 //
     /*  95220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95234 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95239 */   GIR_RootConstrainSelectedInstOperands,
     /*  95240 */   // GIR_Coverage, 6852,
     /*  95240 */   GIR_Done,
     /*  95241 */ // Label 1697: @95241
     /*  95241 */ GIM_Reject,
     /*  95242 */ // Label 1444: @95242
     /*  95242 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95274), // Rule ID 10505 //
     /*  95247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95261 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95273 */   // GIR_Coverage, 10505,
     /*  95273 */   GIR_EraseRootFromParent_Done,
     /*  95274 */ // Label 1698: @95274
     /*  95274 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95306), // Rule ID 10506 //
     /*  95279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95293 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95305 */   // GIR_Coverage, 10506,
     /*  95305 */   GIR_EraseRootFromParent_Done,
     /*  95306 */ // Label 1699: @95306
     /*  95306 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95338), // Rule ID 10507 //
     /*  95311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95325 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95337 */   // GIR_Coverage, 10507,
     /*  95337 */   GIR_EraseRootFromParent_Done,
     /*  95338 */ // Label 1700: @95338
     /*  95338 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(95370), // Rule ID 10508 //
     /*  95343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95357 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95369 */   // GIR_Coverage, 10508,
     /*  95369 */   GIR_EraseRootFromParent_Done,
     /*  95370 */ // Label 1701: @95370
     /*  95370 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(95402), // Rule ID 10509 //
     /*  95375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95389 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95401 */   // GIR_Coverage, 10509,
     /*  95401 */   GIR_EraseRootFromParent_Done,
     /*  95402 */ // Label 1702: @95402
     /*  95402 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(95434), // Rule ID 10510 //
     /*  95407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95421 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95433 */   // GIR_Coverage, 10510,
     /*  95433 */   GIR_EraseRootFromParent_Done,
     /*  95434 */ // Label 1703: @95434
     /*  95434 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(95466), // Rule ID 10523 //
     /*  95439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95453 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95465 */   // GIR_Coverage, 10523,
     /*  95465 */   GIR_EraseRootFromParent_Done,
     /*  95466 */ // Label 1704: @95466
     /*  95466 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(95498), // Rule ID 10524 //
     /*  95471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95485 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95497 */   // GIR_Coverage, 10524,
     /*  95497 */   GIR_EraseRootFromParent_Done,
     /*  95498 */ // Label 1705: @95498
     /*  95498 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(95530), // Rule ID 10525 //
     /*  95503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95517 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95529 */   // GIR_Coverage, 10525,
     /*  95529 */   GIR_EraseRootFromParent_Done,
     /*  95530 */ // Label 1706: @95530
     /*  95530 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(95562), // Rule ID 10526 //
     /*  95535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95549 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95552 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95561 */   // GIR_Coverage, 10526,
     /*  95561 */   GIR_EraseRootFromParent_Done,
     /*  95562 */ // Label 1707: @95562
     /*  95562 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(95594), // Rule ID 10527 //
     /*  95567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95581 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95584 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95586 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95593 */   // GIR_Coverage, 10527,
     /*  95593 */   GIR_EraseRootFromParent_Done,
     /*  95594 */ // Label 1708: @95594
     /*  95594 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(95626), // Rule ID 10528 //
     /*  95599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95613 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95616 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95618 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95625 */   // GIR_Coverage, 10528,
     /*  95625 */   GIR_EraseRootFromParent_Done,
     /*  95626 */ // Label 1709: @95626
     /*  95626 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(95658), // Rule ID 10533 //
     /*  95631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95645 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95648 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95650 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95657 */   // GIR_Coverage, 10533,
     /*  95657 */   GIR_EraseRootFromParent_Done,
     /*  95658 */ // Label 1710: @95658
     /*  95658 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(95690), // Rule ID 10534 //
     /*  95663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95677 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95680 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95682 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95689 */   // GIR_Coverage, 10534,
     /*  95689 */   GIR_EraseRootFromParent_Done,
     /*  95690 */ // Label 1711: @95690
     /*  95690 */ GIM_Reject,
     /*  95691 */ // Label 1445: @95691
     /*  95691 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(95723), // Rule ID 10499 //
     /*  95696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95710 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95722 */   // GIR_Coverage, 10499,
     /*  95722 */   GIR_EraseRootFromParent_Done,
     /*  95723 */ // Label 1712: @95723
     /*  95723 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(95755), // Rule ID 10500 //
     /*  95728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95742 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   // GIR_Coverage, 10500,
     /*  95754 */   GIR_EraseRootFromParent_Done,
     /*  95755 */ // Label 1713: @95755
     /*  95755 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(95787), // Rule ID 10501 //
     /*  95760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95774 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95786 */   // GIR_Coverage, 10501,
     /*  95786 */   GIR_EraseRootFromParent_Done,
     /*  95787 */ // Label 1714: @95787
     /*  95787 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(95819), // Rule ID 10502 //
     /*  95792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95806 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95818 */   // GIR_Coverage, 10502,
     /*  95818 */   GIR_EraseRootFromParent_Done,
     /*  95819 */ // Label 1715: @95819
     /*  95819 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95851), // Rule ID 10503 //
     /*  95824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95838 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95850 */   // GIR_Coverage, 10503,
     /*  95850 */   GIR_EraseRootFromParent_Done,
     /*  95851 */ // Label 1716: @95851
     /*  95851 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(95883), // Rule ID 10504 //
     /*  95856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95870 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95882 */   // GIR_Coverage, 10504,
     /*  95882 */   GIR_EraseRootFromParent_Done,
     /*  95883 */ // Label 1717: @95883
     /*  95883 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(95915), // Rule ID 10517 //
     /*  95888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95902 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95914 */   // GIR_Coverage, 10517,
     /*  95914 */   GIR_EraseRootFromParent_Done,
     /*  95915 */ // Label 1718: @95915
     /*  95915 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(95947), // Rule ID 10518 //
     /*  95920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95934 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95946 */   // GIR_Coverage, 10518,
     /*  95946 */   GIR_EraseRootFromParent_Done,
     /*  95947 */ // Label 1719: @95947
     /*  95947 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(95979), // Rule ID 10519 //
     /*  95952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95966 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95978 */   // GIR_Coverage, 10519,
     /*  95978 */   GIR_EraseRootFromParent_Done,
     /*  95979 */ // Label 1720: @95979
     /*  95979 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96011), // Rule ID 10520 //
     /*  95984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95998 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96010 */   // GIR_Coverage, 10520,
     /*  96010 */   GIR_EraseRootFromParent_Done,
     /*  96011 */ // Label 1721: @96011
     /*  96011 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96043), // Rule ID 10521 //
     /*  96016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96030 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96042 */   // GIR_Coverage, 10521,
     /*  96042 */   GIR_EraseRootFromParent_Done,
     /*  96043 */ // Label 1722: @96043
     /*  96043 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96075), // Rule ID 10522 //
     /*  96048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96062 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96074 */   // GIR_Coverage, 10522,
     /*  96074 */   GIR_EraseRootFromParent_Done,
     /*  96075 */ // Label 1723: @96075
     /*  96075 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96107), // Rule ID 10531 //
     /*  96080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96094 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96106 */   // GIR_Coverage, 10531,
     /*  96106 */   GIR_EraseRootFromParent_Done,
     /*  96107 */ // Label 1724: @96107
     /*  96107 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96139), // Rule ID 10532 //
     /*  96112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96126 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96138 */   // GIR_Coverage, 10532,
     /*  96138 */   GIR_EraseRootFromParent_Done,
     /*  96139 */ // Label 1725: @96139
     /*  96139 */ GIM_Reject,
     /*  96140 */ // Label 1446: @96140
     /*  96140 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96172), // Rule ID 10493 //
     /*  96145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96159 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96171 */   // GIR_Coverage, 10493,
     /*  96171 */   GIR_EraseRootFromParent_Done,
     /*  96172 */ // Label 1726: @96172
     /*  96172 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96204), // Rule ID 10494 //
     /*  96177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96191 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96203 */   // GIR_Coverage, 10494,
     /*  96203 */   GIR_EraseRootFromParent_Done,
     /*  96204 */ // Label 1727: @96204
     /*  96204 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96236), // Rule ID 10495 //
     /*  96209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96223 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96226 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96228 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96235 */   // GIR_Coverage, 10495,
     /*  96235 */   GIR_EraseRootFromParent_Done,
     /*  96236 */ // Label 1728: @96236
     /*  96236 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96268), // Rule ID 10496 //
     /*  96241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96255 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96258 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96260 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96267 */   // GIR_Coverage, 10496,
     /*  96267 */   GIR_EraseRootFromParent_Done,
     /*  96268 */ // Label 1729: @96268
     /*  96268 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96300), // Rule ID 10497 //
     /*  96273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96287 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96290 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96292 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96299 */   // GIR_Coverage, 10497,
     /*  96299 */   GIR_EraseRootFromParent_Done,
     /*  96300 */ // Label 1730: @96300
     /*  96300 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96332), // Rule ID 10498 //
     /*  96305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96319 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96322 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96331 */   // GIR_Coverage, 10498,
     /*  96331 */   GIR_EraseRootFromParent_Done,
     /*  96332 */ // Label 1731: @96332
     /*  96332 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(96364), // Rule ID 10511 //
     /*  96337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96351 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96354 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96356 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96363 */   // GIR_Coverage, 10511,
     /*  96363 */   GIR_EraseRootFromParent_Done,
     /*  96364 */ // Label 1732: @96364
     /*  96364 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(96396), // Rule ID 10512 //
     /*  96369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96383 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96386 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96395 */   // GIR_Coverage, 10512,
     /*  96395 */   GIR_EraseRootFromParent_Done,
     /*  96396 */ // Label 1733: @96396
     /*  96396 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(96428), // Rule ID 10513 //
     /*  96401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96415 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96418 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96420 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96427 */   // GIR_Coverage, 10513,
     /*  96427 */   GIR_EraseRootFromParent_Done,
     /*  96428 */ // Label 1734: @96428
     /*  96428 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(96460), // Rule ID 10514 //
     /*  96433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96447 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96450 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96452 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96459 */   // GIR_Coverage, 10514,
     /*  96459 */   GIR_EraseRootFromParent_Done,
     /*  96460 */ // Label 1735: @96460
     /*  96460 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(96492), // Rule ID 10515 //
     /*  96465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96479 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96482 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96484 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96491 */   // GIR_Coverage, 10515,
     /*  96491 */   GIR_EraseRootFromParent_Done,
     /*  96492 */ // Label 1736: @96492
     /*  96492 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(96524), // Rule ID 10516 //
     /*  96497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96511 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96514 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96516 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96523 */   // GIR_Coverage, 10516,
     /*  96523 */   GIR_EraseRootFromParent_Done,
     /*  96524 */ // Label 1737: @96524
     /*  96524 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(96556), // Rule ID 10529 //
     /*  96529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96543 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96546 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96548 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96555 */   // GIR_Coverage, 10529,
     /*  96555 */   GIR_EraseRootFromParent_Done,
     /*  96556 */ // Label 1738: @96556
     /*  96556 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(96588), // Rule ID 10530 //
     /*  96561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96575 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96578 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96580 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96587 */   // GIR_Coverage, 10530,
     /*  96587 */   GIR_EraseRootFromParent_Done,
     /*  96588 */ // Label 1739: @96588
     /*  96588 */ GIM_Reject,
     /*  96589 */ // Label 1447: @96589
     /*  96589 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96621), // Rule ID 10487 //
     /*  96594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96608 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96620 */   // GIR_Coverage, 10487,
     /*  96620 */   GIR_EraseRootFromParent_Done,
     /*  96621 */ // Label 1740: @96621
     /*  96621 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96653), // Rule ID 10488 //
     /*  96626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96640 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96652 */   // GIR_Coverage, 10488,
     /*  96652 */   GIR_EraseRootFromParent_Done,
     /*  96653 */ // Label 1741: @96653
     /*  96653 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96685), // Rule ID 10489 //
     /*  96658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96672 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96684 */   // GIR_Coverage, 10489,
     /*  96684 */   GIR_EraseRootFromParent_Done,
     /*  96685 */ // Label 1742: @96685
     /*  96685 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96717), // Rule ID 10490 //
     /*  96690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96704 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96716 */   // GIR_Coverage, 10490,
     /*  96716 */   GIR_EraseRootFromParent_Done,
     /*  96717 */ // Label 1743: @96717
     /*  96717 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(96749), // Rule ID 10491 //
     /*  96722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96736 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96748 */   // GIR_Coverage, 10491,
     /*  96748 */   GIR_EraseRootFromParent_Done,
     /*  96749 */ // Label 1744: @96749
     /*  96749 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(96781), // Rule ID 10492 //
     /*  96754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96768 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96780 */   // GIR_Coverage, 10492,
     /*  96780 */   GIR_EraseRootFromParent_Done,
     /*  96781 */ // Label 1745: @96781
     /*  96781 */ GIM_Reject,
     /*  96782 */ // Label 1448: @96782
     /*  96782 */ GIM_Reject,
     /*  96783 */ // Label 10: @96783
     /*  96783 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1754*/ GIMT_Encode4(97273),
     /*  96794 */ /*GILLT_s16*//*Label 1746*/ GIMT_Encode4(96834),
     /*  96798 */ /*GILLT_s32*//*Label 1747*/ GIMT_Encode4(96865),
     /*  96802 */ /*GILLT_s64*//*Label 1748*/ GIMT_Encode4(96896), GIMT_Encode4(0),
     /*  96810 */ /*GILLT_v2s32*//*Label 1749*/ GIMT_Encode4(96927),
     /*  96814 */ /*GILLT_v2s64*//*Label 1750*/ GIMT_Encode4(96958),
     /*  96818 */ /*GILLT_v4s16*//*Label 1751*/ GIMT_Encode4(96989),
     /*  96822 */ /*GILLT_v4s32*//*Label 1752*/ GIMT_Encode4(97020), GIMT_Encode4(0),
     /*  96830 */ /*GILLT_v8s16*//*Label 1753*/ GIMT_Encode4(97051),
     /*  96834 */ // Label 1746: @96834
     /*  96834 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96864), // Rule ID 564 //
     /*  96839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  96842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  96845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96853 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  96853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  96858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96862 */   GIR_RootConstrainSelectedInstOperands,
     /*  96863 */   // GIR_Coverage, 564,
     /*  96863 */   GIR_Done,
     /*  96864 */ // Label 1755: @96864
     /*  96864 */ GIM_Reject,
     /*  96865 */ // Label 1747: @96865
     /*  96865 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96895), // Rule ID 566 //
     /*  96870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  96876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96884 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  96884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  96889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96893 */   GIR_RootConstrainSelectedInstOperands,
     /*  96894 */   // GIR_Coverage, 566,
     /*  96894 */   GIR_Done,
     /*  96895 */ // Label 1756: @96895
     /*  96895 */ GIM_Reject,
     /*  96896 */ // Label 1748: @96896
     /*  96896 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96926), // Rule ID 568 //
     /*  96901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  96907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96915 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  96915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  96920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96924 */   GIR_RootConstrainSelectedInstOperands,
     /*  96925 */   // GIR_Coverage, 568,
     /*  96925 */   GIR_Done,
     /*  96926 */ // Label 1757: @96926
     /*  96926 */ GIM_Reject,
     /*  96927 */ // Label 1749: @96927
     /*  96927 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96957), // Rule ID 933 //
     /*  96932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  96938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96946 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  96946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  96951 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96955 */   GIR_RootConstrainSelectedInstOperands,
     /*  96956 */   // GIR_Coverage, 933,
     /*  96956 */   GIR_Done,
     /*  96957 */ // Label 1758: @96957
     /*  96957 */ GIM_Reject,
     /*  96958 */ // Label 1750: @96958
     /*  96958 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96988), // Rule ID 937 //
     /*  96963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  96969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96977 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  96977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  96982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96986 */   GIR_RootConstrainSelectedInstOperands,
     /*  96987 */   // GIR_Coverage, 937,
     /*  96987 */   GIR_Done,
     /*  96988 */ // Label 1759: @96988
     /*  96988 */ GIM_Reject,
     /*  96989 */ // Label 1751: @96989
     /*  96989 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97019), // Rule ID 929 //
     /*  96994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97008 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97017 */   GIR_RootConstrainSelectedInstOperands,
     /*  97018 */   // GIR_Coverage, 929,
     /*  97018 */   GIR_Done,
     /*  97019 */ // Label 1760: @97019
     /*  97019 */ GIM_Reject,
     /*  97020 */ // Label 1752: @97020
     /*  97020 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97050), // Rule ID 935 //
     /*  97025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97039 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97048 */   GIR_RootConstrainSelectedInstOperands,
     /*  97049 */   // GIR_Coverage, 935,
     /*  97049 */   GIR_Done,
     /*  97050 */ // Label 1761: @97050
     /*  97050 */ GIM_Reject,
     /*  97051 */ // Label 1753: @97051
     /*  97051 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97272),
     /*  97056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97067 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97086), // Rule ID 931 //
     /*  97072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97075 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97084 */     GIR_RootConstrainSelectedInstOperands,
     /*  97085 */     // GIR_Coverage, 931,
     /*  97085 */     GIR_Done,
     /*  97086 */   // Label 1763: @97086
     /*  97086 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97271), // Rule ID 6971 //
     /*  97091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97094 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97094 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97097 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97101 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97106 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97112 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97115 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97119 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97124 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97129 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97132 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97136 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97141 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97147 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97152 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97157 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97160 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97164 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97169 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97174 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97177 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97181 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97186 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97191 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97194 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97198 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97203 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97240 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97269 */     GIR_RootConstrainSelectedInstOperands,
     /*  97270 */     // GIR_Coverage, 6971,
     /*  97270 */     GIR_EraseRootFromParent_Done,
     /*  97271 */   // Label 1764: @97271
     /*  97271 */   GIM_Reject,
     /*  97272 */ // Label 1762: @97272
     /*  97272 */ GIM_Reject,
     /*  97273 */ // Label 1754: @97273
     /*  97273 */ GIM_Reject,
     /*  97274 */ // Label 11: @97274
     /*  97274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(97764),
     /*  97285 */ /*GILLT_s16*//*Label 1765*/ GIMT_Encode4(97325),
     /*  97289 */ /*GILLT_s32*//*Label 1766*/ GIMT_Encode4(97356),
     /*  97293 */ /*GILLT_s64*//*Label 1767*/ GIMT_Encode4(97387), GIMT_Encode4(0),
     /*  97301 */ /*GILLT_v2s32*//*Label 1768*/ GIMT_Encode4(97418),
     /*  97305 */ /*GILLT_v2s64*//*Label 1769*/ GIMT_Encode4(97449),
     /*  97309 */ /*GILLT_v4s16*//*Label 1770*/ GIMT_Encode4(97480),
     /*  97313 */ /*GILLT_v4s32*//*Label 1771*/ GIMT_Encode4(97511), GIMT_Encode4(0),
     /*  97321 */ /*GILLT_v8s16*//*Label 1772*/ GIMT_Encode4(97542),
     /*  97325 */ // Label 1765: @97325
     /*  97325 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97355), // Rule ID 528 //
     /*  97330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97344 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  97349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97353 */   GIR_RootConstrainSelectedInstOperands,
     /*  97354 */   // GIR_Coverage, 528,
     /*  97354 */   GIR_Done,
     /*  97355 */ // Label 1774: @97355
     /*  97355 */ GIM_Reject,
     /*  97356 */ // Label 1766: @97356
     /*  97356 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97386), // Rule ID 530 //
     /*  97361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97375 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  97380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97384 */   GIR_RootConstrainSelectedInstOperands,
     /*  97385 */   // GIR_Coverage, 530,
     /*  97385 */   GIR_Done,
     /*  97386 */ // Label 1775: @97386
     /*  97386 */ GIM_Reject,
     /*  97387 */ // Label 1767: @97387
     /*  97387 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97417), // Rule ID 532 //
     /*  97392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97406 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  97411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97415 */   GIR_RootConstrainSelectedInstOperands,
     /*  97416 */   // GIR_Coverage, 532,
     /*  97416 */   GIR_Done,
     /*  97417 */ // Label 1776: @97417
     /*  97417 */ GIM_Reject,
     /*  97418 */ // Label 1768: @97418
     /*  97418 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97448), // Rule ID 873 //
     /*  97423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97437 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  97442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97446 */   GIR_RootConstrainSelectedInstOperands,
     /*  97447 */   // GIR_Coverage, 873,
     /*  97447 */   GIR_Done,
     /*  97448 */ // Label 1777: @97448
     /*  97448 */ GIM_Reject,
     /*  97449 */ // Label 1769: @97449
     /*  97449 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97479), // Rule ID 877 //
     /*  97454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97468 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  97473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97477 */   GIR_RootConstrainSelectedInstOperands,
     /*  97478 */   // GIR_Coverage, 877,
     /*  97478 */   GIR_Done,
     /*  97479 */ // Label 1778: @97479
     /*  97479 */ GIM_Reject,
     /*  97480 */ // Label 1770: @97480
     /*  97480 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97510), // Rule ID 869 //
     /*  97485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97499 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  97504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97508 */   GIR_RootConstrainSelectedInstOperands,
     /*  97509 */   // GIR_Coverage, 869,
     /*  97509 */   GIR_Done,
     /*  97510 */ // Label 1779: @97510
     /*  97510 */ GIM_Reject,
     /*  97511 */ // Label 1771: @97511
     /*  97511 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97541), // Rule ID 875 //
     /*  97516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97530 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97539 */   GIR_RootConstrainSelectedInstOperands,
     /*  97540 */   // GIR_Coverage, 875,
     /*  97540 */   GIR_Done,
     /*  97541 */ // Label 1780: @97541
     /*  97541 */ GIM_Reject,
     /*  97542 */ // Label 1772: @97542
     /*  97542 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97763),
     /*  97547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97558 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97577), // Rule ID 871 //
     /*  97563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97566 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  97571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97575 */     GIR_RootConstrainSelectedInstOperands,
     /*  97576 */     // GIR_Coverage, 871,
     /*  97576 */     GIR_Done,
     /*  97577 */   // Label 1782: @97577
     /*  97577 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97762), // Rule ID 6965 //
     /*  97582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97585 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97585 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97588 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97592 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97597 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97603 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97606 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97610 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97615 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97620 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97623 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97627 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97632 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97638 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97643 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97648 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97651 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97655 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97660 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97665 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97668 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97672 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97677 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97694 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97725 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97760 */     GIR_RootConstrainSelectedInstOperands,
     /*  97761 */     // GIR_Coverage, 6965,
     /*  97761 */     GIR_EraseRootFromParent_Done,
     /*  97762 */   // Label 1783: @97762
     /*  97762 */   GIM_Reject,
     /*  97763 */ // Label 1781: @97763
     /*  97763 */ GIM_Reject,
     /*  97764 */ // Label 1773: @97764
     /*  97764 */ GIM_Reject,
     /*  97765 */ // Label 12: @97765
     /*  97765 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1786*/ GIMT_Encode4(98032),
     /*  97776 */ /*GILLT_s32*//*Label 1784*/ GIMT_Encode4(97784),
     /*  97780 */ /*GILLT_s64*//*Label 1785*/ GIMT_Encode4(97908),
     /*  97784 */ // Label 1784: @97784
     /*  97784 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(97827), // Rule ID 4775 //
     /*  97789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97799 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  97820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97825 */   GIR_RootConstrainSelectedInstOperands,
     /*  97826 */   // GIR_Coverage, 4775,
     /*  97826 */   GIR_EraseRootFromParent_Done,
     /*  97827 */ // Label 1787: @97827
     /*  97827 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(97867), // Rule ID 4781 //
     /*  97832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97839 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97851 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  97860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97865 */   GIR_RootConstrainSelectedInstOperands,
     /*  97866 */   // GIR_Coverage, 4781,
     /*  97866 */   GIR_EraseRootFromParent_Done,
     /*  97867 */ // Label 1788: @97867
     /*  97867 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(97907), // Rule ID 4783 //
     /*  97872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97879 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97891 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  97900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97905 */   GIR_RootConstrainSelectedInstOperands,
     /*  97906 */   // GIR_Coverage, 4783,
     /*  97906 */   GIR_EraseRootFromParent_Done,
     /*  97907 */ // Label 1789: @97907
     /*  97907 */ GIM_Reject,
     /*  97908 */ // Label 1785: @97908
     /*  97908 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(97951), // Rule ID 4777 //
     /*  97913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97923 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97935 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  97944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97949 */   GIR_RootConstrainSelectedInstOperands,
     /*  97950 */   // GIR_Coverage, 4777,
     /*  97950 */   GIR_EraseRootFromParent_Done,
     /*  97951 */ // Label 1790: @97951
     /*  97951 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(97991), // Rule ID 4785 //
     /*  97956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97963 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  97984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97989 */   GIR_RootConstrainSelectedInstOperands,
     /*  97990 */   // GIR_Coverage, 4785,
     /*  97990 */   GIR_EraseRootFromParent_Done,
     /*  97991 */ // Label 1791: @97991
     /*  97991 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98031), // Rule ID 4787 //
     /*  97996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98003 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98029 */   GIR_RootConstrainSelectedInstOperands,
     /*  98030 */   // GIR_Coverage, 4787,
     /*  98030 */   GIR_EraseRootFromParent_Done,
     /*  98031 */ // Label 1792: @98031
     /*  98031 */ GIM_Reject,
     /*  98032 */ // Label 1786: @98032
     /*  98032 */ GIM_Reject,
     /*  98033 */ // Label 13: @98033
     /*  98033 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98182),
     /*  98038 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98041 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(98181),
     /*  98052 */   /*GILLT_s16*//*Label 1794*/ GIMT_Encode4(98064),
     /*  98056 */   /*GILLT_s32*//*Label 1795*/ GIMT_Encode4(98105),
     /*  98060 */   /*GILLT_s64*//*Label 1796*/ GIMT_Encode4(98143),
     /*  98064 */   // Label 1794: @98064
     /*  98064 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(98104), // Rule ID 4779 //
     /*  98069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98076 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98102 */     GIR_RootConstrainSelectedInstOperands,
     /*  98103 */     // GIR_Coverage, 4779,
     /*  98103 */     GIR_EraseRootFromParent_Done,
     /*  98104 */   // Label 1798: @98104
     /*  98104 */   GIM_Reject,
     /*  98105 */   // Label 1795: @98105
     /*  98105 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98142), // Rule ID 4789 //
     /*  98110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98114 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98140 */     GIR_RootConstrainSelectedInstOperands,
     /*  98141 */     // GIR_Coverage, 4789,
     /*  98141 */     GIR_EraseRootFromParent_Done,
     /*  98142 */   // Label 1799: @98142
     /*  98142 */   GIM_Reject,
     /*  98143 */   // Label 1796: @98143
     /*  98143 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98180), // Rule ID 4791 //
     /*  98148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98152 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98178 */     GIR_RootConstrainSelectedInstOperands,
     /*  98179 */     // GIR_Coverage, 4791,
     /*  98179 */     GIR_EraseRootFromParent_Done,
     /*  98180 */   // Label 1800: @98180
     /*  98180 */   GIM_Reject,
     /*  98181 */   // Label 1797: @98181
     /*  98181 */   GIM_Reject,
     /*  98182 */ // Label 1793: @98182
     /*  98182 */ GIM_Reject,
     /*  98183 */ // Label 14: @98183
     /*  98183 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1809*/ GIMT_Encode4(98673),
     /*  98194 */ /*GILLT_s16*//*Label 1801*/ GIMT_Encode4(98234),
     /*  98198 */ /*GILLT_s32*//*Label 1802*/ GIMT_Encode4(98265),
     /*  98202 */ /*GILLT_s64*//*Label 1803*/ GIMT_Encode4(98296), GIMT_Encode4(0),
     /*  98210 */ /*GILLT_v2s32*//*Label 1804*/ GIMT_Encode4(98327),
     /*  98214 */ /*GILLT_v2s64*//*Label 1805*/ GIMT_Encode4(98358),
     /*  98218 */ /*GILLT_v4s16*//*Label 1806*/ GIMT_Encode4(98389),
     /*  98222 */ /*GILLT_v4s32*//*Label 1807*/ GIMT_Encode4(98420), GIMT_Encode4(0),
     /*  98230 */ /*GILLT_v8s16*//*Label 1808*/ GIMT_Encode4(98451),
     /*  98234 */ // Label 1801: @98234
     /*  98234 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(98264), // Rule ID 546 //
     /*  98239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98253 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  98258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98262 */   GIR_RootConstrainSelectedInstOperands,
     /*  98263 */   // GIR_Coverage, 546,
     /*  98263 */   GIR_Done,
     /*  98264 */ // Label 1810: @98264
     /*  98264 */ GIM_Reject,
     /*  98265 */ // Label 1802: @98265
     /*  98265 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(98295), // Rule ID 548 //
     /*  98270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98284 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  98289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98293 */   GIR_RootConstrainSelectedInstOperands,
     /*  98294 */   // GIR_Coverage, 548,
     /*  98294 */   GIR_Done,
     /*  98295 */ // Label 1811: @98295
     /*  98295 */ GIM_Reject,
     /*  98296 */ // Label 1803: @98296
     /*  98296 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(98326), // Rule ID 550 //
     /*  98301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98315 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  98320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98324 */   GIR_RootConstrainSelectedInstOperands,
     /*  98325 */   // GIR_Coverage, 550,
     /*  98325 */   GIR_Done,
     /*  98326 */ // Label 1812: @98326
     /*  98326 */ GIM_Reject,
     /*  98327 */ // Label 1804: @98327
     /*  98327 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(98357), // Rule ID 903 //
     /*  98332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98346 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  98351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98355 */   GIR_RootConstrainSelectedInstOperands,
     /*  98356 */   // GIR_Coverage, 903,
     /*  98356 */   GIR_Done,
     /*  98357 */ // Label 1813: @98357
     /*  98357 */ GIM_Reject,
     /*  98358 */ // Label 1805: @98358
     /*  98358 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(98388), // Rule ID 907 //
     /*  98363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98377 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  98382 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98386 */   GIR_RootConstrainSelectedInstOperands,
     /*  98387 */   // GIR_Coverage, 907,
     /*  98387 */   GIR_Done,
     /*  98388 */ // Label 1814: @98388
     /*  98388 */ GIM_Reject,
     /*  98389 */ // Label 1806: @98389
     /*  98389 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(98419), // Rule ID 899 //
     /*  98394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98408 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  98413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98417 */   GIR_RootConstrainSelectedInstOperands,
     /*  98418 */   // GIR_Coverage, 899,
     /*  98418 */   GIR_Done,
     /*  98419 */ // Label 1815: @98419
     /*  98419 */ GIM_Reject,
     /*  98420 */ // Label 1807: @98420
     /*  98420 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(98450), // Rule ID 905 //
     /*  98425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98439 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98444 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98448 */   GIR_RootConstrainSelectedInstOperands,
     /*  98449 */   // GIR_Coverage, 905,
     /*  98449 */   GIR_Done,
     /*  98450 */ // Label 1816: @98450
     /*  98450 */ GIM_Reject,
     /*  98451 */ // Label 1808: @98451
     /*  98451 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(98672),
     /*  98456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98467 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(98486), // Rule ID 901 //
     /*  98472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98475 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  98480 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98484 */     GIR_RootConstrainSelectedInstOperands,
     /*  98485 */     // GIR_Coverage, 901,
     /*  98485 */     GIR_Done,
     /*  98486 */   // Label 1818: @98486
     /*  98486 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(98671), // Rule ID 6967 //
     /*  98491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98494 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98494 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98497 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98501 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98506 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98512 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98515 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98519 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98524 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98529 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98532 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98536 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98541 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98547 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98552 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98557 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98560 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98564 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98569 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98574 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98577 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98581 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98586 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98603 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98637 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98669 */     GIR_RootConstrainSelectedInstOperands,
     /*  98670 */     // GIR_Coverage, 6967,
     /*  98670 */     GIR_EraseRootFromParent_Done,
     /*  98671 */   // Label 1819: @98671
     /*  98671 */   GIM_Reject,
     /*  98672 */ // Label 1817: @98672
     /*  98672 */ GIM_Reject,
     /*  98673 */ // Label 1809: @98673
     /*  98673 */ GIM_Reject,
     /*  98674 */ // Label 15: @98674
     /*  98674 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(98706), // Rule ID 3896 //
     /*  98679 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98686 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  98686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  98689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98691 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  98701 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  98704 */   GIR_RootConstrainSelectedInstOperands,
     /*  98705 */   // GIR_Coverage, 3896,
     /*  98705 */   GIR_EraseRootFromParent_Done,
     /*  98706 */ // Label 1820: @98706
     /*  98706 */ GIM_Reject,
     /*  98707 */ // Label 16: @98707
     /*  98707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1841*/ GIMT_Encode4(107516),
     /*  98718 */ /*GILLT_s8*//*Label 1821*/ GIMT_Encode4(98814),
     /*  98722 */ /*GILLT_s16*//*Label 1822*/ GIMT_Encode4(98990),
     /*  98726 */ /*GILLT_s32*//*Label 1823*/ GIMT_Encode4(99166),
     /*  98730 */ /*GILLT_s64*//*Label 1824*/ GIMT_Encode4(101464),
     /*  98734 */ /*GILLT_s128*//*Label 1825*/ GIMT_Encode4(104145),
     /*  98738 */ /*GILLT_v2s32*//*Label 1826*/ GIMT_Encode4(104354),
     /*  98742 */ /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(104732),
     /*  98746 */ /*GILLT_v4s16*//*Label 1828*/ GIMT_Encode4(105110),
     /*  98750 */ /*GILLT_v4s32*//*Label 1829*/ GIMT_Encode4(105488),
     /*  98754 */ /*GILLT_v8s8*//*Label 1830*/ GIMT_Encode4(105866),
     /*  98758 */ /*GILLT_v8s16*//*Label 1831*/ GIMT_Encode4(106074),
     /*  98762 */ /*GILLT_v16s8*//*Label 1832*/ GIMT_Encode4(106452), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98774 */ /*GILLT_nxv2s16*//*Label 1833*/ GIMT_Encode4(106660),
     /*  98778 */ /*GILLT_nxv2s32*//*Label 1834*/ GIMT_Encode4(106724),
     /*  98782 */ /*GILLT_nxv2s64*//*Label 1835*/ GIMT_Encode4(106788), GIMT_Encode4(0),
     /*  98790 */ /*GILLT_nxv4s16*//*Label 1836*/ GIMT_Encode4(106962),
     /*  98794 */ /*GILLT_nxv4s32*//*Label 1837*/ GIMT_Encode4(107026), GIMT_Encode4(0),
     /*  98802 */ /*GILLT_nxv8s16*//*Label 1838*/ GIMT_Encode4(107200),
     /*  98806 */ /*GILLT_nxv16s1*//*Label 1839*/ GIMT_Encode4(107374),
     /*  98810 */ /*GILLT_nxv16s8*//*Label 1840*/ GIMT_Encode4(107418),
     /*  98814 */ // Label 1821: @98814
     /*  98814 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(98989),
     /*  98819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  98830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98834 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(98875), // Rule ID 237 //
     /*  98839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98849 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  98849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  98852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98873 */     GIR_RootConstrainSelectedInstOperands,
     /*  98874 */     // GIR_Coverage, 237,
     /*  98874 */     GIR_EraseRootFromParent_Done,
     /*  98875 */   // Label 1843: @98875
     /*  98875 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(98916), // Rule ID 238 //
     /*  98880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98890 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  98890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  98893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98914 */     GIR_RootConstrainSelectedInstOperands,
     /*  98915 */     // GIR_Coverage, 238,
     /*  98915 */     GIR_EraseRootFromParent_Done,
     /*  98916 */   // Label 1844: @98916
     /*  98916 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(98952), // Rule ID 261 //
     /*  98921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  98931 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  98931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  98934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98950 */     GIR_RootConstrainSelectedInstOperands,
     /*  98951 */     // GIR_Coverage, 261,
     /*  98951 */     GIR_EraseRootFromParent_Done,
     /*  98952 */   // Label 1845: @98952
     /*  98952 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(98988), // Rule ID 282 //
     /*  98957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  98967 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  98967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  98970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98986 */     GIR_RootConstrainSelectedInstOperands,
     /*  98987 */     // GIR_Coverage, 282,
     /*  98987 */     GIR_EraseRootFromParent_Done,
     /*  98988 */   // Label 1846: @98988
     /*  98988 */   GIM_Reject,
     /*  98989 */ // Label 1842: @98989
     /*  98989 */ GIM_Reject,
     /*  98990 */ // Label 1822: @98990
     /*  98990 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99165),
     /*  98995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99010 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99051), // Rule ID 239 //
     /*  99015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99025 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99049 */     GIR_RootConstrainSelectedInstOperands,
     /*  99050 */     // GIR_Coverage, 239,
     /*  99050 */     GIR_EraseRootFromParent_Done,
     /*  99051 */   // Label 1848: @99051
     /*  99051 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99092), // Rule ID 240 //
     /*  99056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99066 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99090 */     GIR_RootConstrainSelectedInstOperands,
     /*  99091 */     // GIR_Coverage, 240,
     /*  99091 */     GIR_EraseRootFromParent_Done,
     /*  99092 */   // Label 1849: @99092
     /*  99092 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99128), // Rule ID 262 //
     /*  99097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99107 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99126 */     GIR_RootConstrainSelectedInstOperands,
     /*  99127 */     // GIR_Coverage, 262,
     /*  99127 */     GIR_EraseRootFromParent_Done,
     /*  99128 */   // Label 1850: @99128
     /*  99128 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99164), // Rule ID 283 //
     /*  99133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99143 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99162 */     GIR_RootConstrainSelectedInstOperands,
     /*  99163 */     // GIR_Coverage, 283,
     /*  99163 */     GIR_EraseRootFromParent_Done,
     /*  99164 */   // Label 1851: @99164
     /*  99164 */   GIM_Reject,
     /*  99165 */ // Label 1847: @99165
     /*  99165 */ GIM_Reject,
     /*  99166 */ // Label 1823: @99166
     /*  99166 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99219), // Rule ID 233 //
     /*  99171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99193 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99217 */   GIR_RootConstrainSelectedInstOperands,
     /*  99218 */   // GIR_Coverage, 233,
     /*  99218 */   GIR_EraseRootFromParent_Done,
     /*  99219 */ // Label 1852: @99219
     /*  99219 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99272), // Rule ID 234 //
     /*  99224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99227 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99246 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99270 */   GIR_RootConstrainSelectedInstOperands,
     /*  99271 */   // GIR_Coverage, 234,
     /*  99271 */   GIR_EraseRootFromParent_Done,
     /*  99272 */ // Label 1853: @99272
     /*  99272 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99328), // Rule ID 241 //
     /*  99277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99302 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  99305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99326 */   GIR_RootConstrainSelectedInstOperands,
     /*  99327 */   // GIR_Coverage, 241,
     /*  99327 */   GIR_EraseRootFromParent_Done,
     /*  99328 */ // Label 1854: @99328
     /*  99328 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99384), // Rule ID 242 //
     /*  99333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99336 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99339 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99358 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  99361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99382 */   GIR_RootConstrainSelectedInstOperands,
     /*  99383 */   // GIR_Coverage, 242,
     /*  99383 */   GIR_EraseRootFromParent_Done,
     /*  99384 */ // Label 1855: @99384
     /*  99384 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(99444), // Rule ID 4112 //
     /*  99389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99418 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99442 */   GIR_RootConstrainSelectedInstOperands,
     /*  99443 */   // GIR_Coverage, 4112,
     /*  99443 */   GIR_EraseRootFromParent_Done,
     /*  99444 */ // Label 1856: @99444
     /*  99444 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(99504), // Rule ID 4113 //
     /*  99449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99452 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99456 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99467 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99478 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99502 */   GIR_RootConstrainSelectedInstOperands,
     /*  99503 */   // GIR_Coverage, 4113,
     /*  99503 */   GIR_EraseRootFromParent_Done,
     /*  99504 */ // Label 1857: @99504
     /*  99504 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(99564), // Rule ID 4114 //
     /*  99509 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99512 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99527 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99531 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99538 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99562 */   GIR_RootConstrainSelectedInstOperands,
     /*  99563 */   // GIR_Coverage, 4114,
     /*  99563 */   GIR_EraseRootFromParent_Done,
     /*  99564 */ // Label 1858: @99564
     /*  99564 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(99624), // Rule ID 4115 //
     /*  99569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99572 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99598 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  99601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99622 */   GIR_RootConstrainSelectedInstOperands,
     /*  99623 */   // GIR_Coverage, 4115,
     /*  99623 */   GIR_EraseRootFromParent_Done,
     /*  99624 */ // Label 1859: @99624
     /*  99624 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(99684), // Rule ID 4116 //
     /*  99629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99632 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99658 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99682 */   GIR_RootConstrainSelectedInstOperands,
     /*  99683 */   // GIR_Coverage, 4116,
     /*  99683 */   GIR_EraseRootFromParent_Done,
     /*  99684 */ // Label 1860: @99684
     /*  99684 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(99744), // Rule ID 4117 //
     /*  99689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99692 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99696 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99711 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99718 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99742 */   GIR_RootConstrainSelectedInstOperands,
     /*  99743 */   // GIR_Coverage, 4117,
     /*  99743 */   GIR_EraseRootFromParent_Done,
     /*  99744 */ // Label 1861: @99744
     /*  99744 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(99792), // Rule ID 260 //
     /*  99749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99771 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99790 */   GIR_RootConstrainSelectedInstOperands,
     /*  99791 */   // GIR_Coverage, 260,
     /*  99791 */   GIR_EraseRootFromParent_Done,
     /*  99792 */ // Label 1862: @99792
     /*  99792 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(99843), // Rule ID 263 //
     /*  99797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99815 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99822 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  99825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99841 */   GIR_RootConstrainSelectedInstOperands,
     /*  99842 */   // GIR_Coverage, 263,
     /*  99842 */   GIR_EraseRootFromParent_Done,
     /*  99843 */ // Label 1863: @99843
     /*  99843 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(99902), // Rule ID 6995 //
     /*  99848 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99851 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99858 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99865 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99876 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  99876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99900 */   GIR_RootConstrainSelectedInstOperands,
     /*  99901 */   // GIR_Coverage, 6995,
     /*  99901 */   GIR_EraseRootFromParent_Done,
     /*  99902 */ // Label 1864: @99902
     /*  99902 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(99961), // Rule ID 6997 //
     /*  99907 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99917 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99935 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  99935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99959 */   GIR_RootConstrainSelectedInstOperands,
     /*  99960 */   // GIR_Coverage, 6997,
     /*  99960 */   GIR_EraseRootFromParent_Done,
     /*  99961 */ // Label 1865: @99961
     /*  99961 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100020), // Rule ID 7007 //
     /*  99966 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99976 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99994 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100018 */   GIR_RootConstrainSelectedInstOperands,
     /* 100019 */   // GIR_Coverage, 7007,
     /* 100019 */   GIR_EraseRootFromParent_Done,
     /* 100020 */ // Label 1866: @100020
     /* 100020 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100079), // Rule ID 7009 //
     /* 100025 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100035 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100053 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100077 */   GIR_RootConstrainSelectedInstOperands,
     /* 100078 */   // GIR_Coverage, 7009,
     /* 100078 */   GIR_EraseRootFromParent_Done,
     /* 100079 */ // Label 1867: @100079
     /* 100079 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100138), // Rule ID 7017 //
     /* 100084 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100087 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100094 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100112 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100136 */   GIR_RootConstrainSelectedInstOperands,
     /* 100137 */   // GIR_Coverage, 7017,
     /* 100137 */   GIR_EraseRootFromParent_Done,
     /* 100138 */ // Label 1868: @100138
     /* 100138 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100197), // Rule ID 7018 //
     /* 100143 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100153 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100171 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100195 */   GIR_RootConstrainSelectedInstOperands,
     /* 100196 */   // GIR_Coverage, 7018,
     /* 100196 */   GIR_EraseRootFromParent_Done,
     /* 100197 */ // Label 1869: @100197
     /* 100197 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100245), // Rule ID 281 //
     /* 100202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100205 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100217 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100224 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100239 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100243 */   GIR_RootConstrainSelectedInstOperands,
     /* 100244 */   // GIR_Coverage, 281,
     /* 100244 */   GIR_EraseRootFromParent_Done,
     /* 100245 */ // Label 1870: @100245
     /* 100245 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100296), // Rule ID 284 //
     /* 100250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100275 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 100278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100294 */   GIR_RootConstrainSelectedInstOperands,
     /* 100295 */   // GIR_Coverage, 284,
     /* 100295 */   GIR_EraseRootFromParent_Done,
     /* 100296 */ // Label 1871: @100296
     /* 100296 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100350), // Rule ID 6999 //
     /* 100301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100311 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100322 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100329 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100348 */   GIR_RootConstrainSelectedInstOperands,
     /* 100349 */   // GIR_Coverage, 6999,
     /* 100349 */   GIR_EraseRootFromParent_Done,
     /* 100350 */ // Label 1872: @100350
     /* 100350 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(100404), // Rule ID 7001 //
     /* 100355 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100365 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100383 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15809>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100402 */   GIR_RootConstrainSelectedInstOperands,
     /* 100403 */   // GIR_Coverage, 7001,
     /* 100403 */   GIR_EraseRootFromParent_Done,
     /* 100404 */ // Label 1873: @100404
     /* 100404 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(100458), // Rule ID 7011 //
     /* 100409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100419 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100430 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100437 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100456 */   GIR_RootConstrainSelectedInstOperands,
     /* 100457 */   // GIR_Coverage, 7011,
     /* 100457 */   GIR_EraseRootFromParent_Done,
     /* 100458 */ // Label 1874: @100458
     /* 100458 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(100512), // Rule ID 7013 //
     /* 100463 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100466 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100473 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100491 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15818>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100510 */   GIR_RootConstrainSelectedInstOperands,
     /* 100511 */   // GIR_Coverage, 7013,
     /* 100511 */   GIR_EraseRootFromParent_Done,
     /* 100512 */ // Label 1875: @100512
     /* 100512 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(100566), // Rule ID 7019 //
     /* 100517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100527 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100545 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100564 */   GIR_RootConstrainSelectedInstOperands,
     /* 100565 */   // GIR_Coverage, 7019,
     /* 100565 */   GIR_EraseRootFromParent_Done,
     /* 100566 */ // Label 1876: @100566
     /* 100566 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100620), // Rule ID 7020 //
     /* 100571 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100574 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100581 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100599 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15826>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100618 */   GIR_RootConstrainSelectedInstOperands,
     /* 100619 */   // GIR_Coverage, 7020,
     /* 100619 */   GIR_EraseRootFromParent_Done,
     /* 100620 */ // Label 1877: @100620
     /* 100620 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(100677), // Rule ID 7375 //
     /* 100625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100628 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100631 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100656 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15807>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 100659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100675 */   GIR_RootConstrainSelectedInstOperands,
     /* 100676 */   // GIR_Coverage, 7375,
     /* 100676 */   GIR_EraseRootFromParent_Done,
     /* 100677 */ // Label 1878: @100677
     /* 100677 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(100734), // Rule ID 7377 //
     /* 100682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100685 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100688 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100713 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15816>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 100716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100732 */   GIR_RootConstrainSelectedInstOperands,
     /* 100733 */   // GIR_Coverage, 7377,
     /* 100733 */   GIR_EraseRootFromParent_Done,
     /* 100734 */ // Label 1879: @100734
     /* 100734 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(100791), // Rule ID 7379 //
     /* 100739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100742 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100770 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15801>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 100773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100789 */   GIR_RootConstrainSelectedInstOperands,
     /* 100790 */   // GIR_Coverage, 7379,
     /* 100790 */   GIR_EraseRootFromParent_Done,
     /* 100791 */ // Label 1880: @100791
     /* 100791 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(100846), // Rule ID 4139 //
     /* 100796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100799 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100825 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100844 */   GIR_RootConstrainSelectedInstOperands,
     /* 100845 */   // GIR_Coverage, 4139,
     /* 100845 */   GIR_EraseRootFromParent_Done,
     /* 100846 */ // Label 1881: @100846
     /* 100846 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(100901), // Rule ID 4140 //
     /* 100851 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100854 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100858 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100880 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100899 */   GIR_RootConstrainSelectedInstOperands,
     /* 100900 */   // GIR_Coverage, 4140,
     /* 100900 */   GIR_EraseRootFromParent_Done,
     /* 100901 */ // Label 1882: @100901
     /* 100901 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(100956), // Rule ID 4141 //
     /* 100906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100909 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100935 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100950 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100954 */   GIR_RootConstrainSelectedInstOperands,
     /* 100955 */   // GIR_Coverage, 4141,
     /* 100955 */   GIR_EraseRootFromParent_Done,
     /* 100956 */ // Label 1883: @100956
     /* 100956 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101011), // Rule ID 4162 //
     /* 100961 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100964 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100968 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100990 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101009 */   GIR_RootConstrainSelectedInstOperands,
     /* 101010 */   // GIR_Coverage, 4162,
     /* 101010 */   GIR_EraseRootFromParent_Done,
     /* 101011 */ // Label 1884: @101011
     /* 101011 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101066), // Rule ID 4163 //
     /* 101016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101038 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101045 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101064 */   GIR_RootConstrainSelectedInstOperands,
     /* 101065 */   // GIR_Coverage, 4163,
     /* 101065 */   GIR_EraseRootFromParent_Done,
     /* 101066 */ // Label 1885: @101066
     /* 101066 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101121), // Rule ID 4164 //
     /* 101071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101074 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101089 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101093 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101100 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101119 */   GIR_RootConstrainSelectedInstOperands,
     /* 101120 */   // GIR_Coverage, 4164,
     /* 101120 */   GIR_EraseRootFromParent_Done,
     /* 101121 */ // Label 1886: @101121
     /* 101121 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101161), // Rule ID 6987 //
     /* 101126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101129 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101146 */   // MIs[0] ptr
     /* 101146 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101154 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15797>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101159 */   GIR_RootConstrainSelectedInstOperands,
     /* 101160 */   // GIR_Coverage, 6987,
     /* 101160 */   GIR_Done,
     /* 101161 */ // Label 1887: @101161
     /* 101161 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101201), // Rule ID 6988 //
     /* 101166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101169 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101186 */   // MIs[0] ptr
     /* 101186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101194 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15799>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 101199 */   GIR_RootConstrainSelectedInstOperands,
     /* 101200 */   // GIR_Coverage, 6988,
     /* 101200 */   GIR_Done,
     /* 101201 */ // Label 1888: @101201
     /* 101201 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101241), // Rule ID 6989 //
     /* 101206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101209 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101212 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101226 */   // MIs[0] ptr
     /* 101226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101234 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15801>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 101239 */   GIR_RootConstrainSelectedInstOperands,
     /* 101240 */   // GIR_Coverage, 6989,
     /* 101240 */   GIR_Done,
     /* 101241 */ // Label 1889: @101241
     /* 101241 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101278), // Rule ID 6991 //
     /* 101246 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101256 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101263 */   // MIs[0] ptr
     /* 101263 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101271 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15805>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101276 */   GIR_RootConstrainSelectedInstOperands,
     /* 101277 */   // GIR_Coverage, 6991,
     /* 101277 */   GIR_Done,
     /* 101278 */ // Label 1890: @101278
     /* 101278 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101315), // Rule ID 6993 //
     /* 101283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101300 */   // MIs[0] ptr
     /* 101300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101308 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15807>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101313 */   GIR_RootConstrainSelectedInstOperands,
     /* 101314 */   // GIR_Coverage, 6993,
     /* 101314 */   GIR_Done,
     /* 101315 */ // Label 1891: @101315
     /* 101315 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101352), // Rule ID 7003 //
     /* 101320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101337 */   // MIs[0] ptr
     /* 101337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101345 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15814>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101350 */   GIR_RootConstrainSelectedInstOperands,
     /* 101351 */   // GIR_Coverage, 7003,
     /* 101351 */   GIR_Done,
     /* 101352 */ // Label 1892: @101352
     /* 101352 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101389), // Rule ID 7005 //
     /* 101357 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101374 */   // MIs[0] ptr
     /* 101374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101382 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15816>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101387 */   GIR_RootConstrainSelectedInstOperands,
     /* 101388 */   // GIR_Coverage, 7005,
     /* 101388 */   GIR_Done,
     /* 101389 */ // Label 1893: @101389
     /* 101389 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101426), // Rule ID 7015 //
     /* 101394 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101411 */   // MIs[0] ptr
     /* 101411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101419 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15823>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101424 */   GIR_RootConstrainSelectedInstOperands,
     /* 101425 */   // GIR_Coverage, 7015,
     /* 101425 */   GIR_Done,
     /* 101426 */ // Label 1894: @101426
     /* 101426 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(101463), // Rule ID 7016 //
     /* 101431 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101448 */   // MIs[0] ptr
     /* 101448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101456 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15801>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101461 */   GIR_RootConstrainSelectedInstOperands,
     /* 101462 */   // GIR_Coverage, 7016,
     /* 101462 */   GIR_Done,
     /* 101463 */ // Label 1895: @101463
     /* 101463 */ GIM_Reject,
     /* 101464 */ // Label 1824: @101464
     /* 101464 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(101517), // Rule ID 235 //
     /* 101469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101491 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 101494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101511 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101515 */   GIR_RootConstrainSelectedInstOperands,
     /* 101516 */   // GIR_Coverage, 235,
     /* 101516 */   GIR_EraseRootFromParent_Done,
     /* 101517 */ // Label 1896: @101517
     /* 101517 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(101570), // Rule ID 236 //
     /* 101522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101525 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101544 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 101547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101568 */   GIR_RootConstrainSelectedInstOperands,
     /* 101569 */   // GIR_Coverage, 236,
     /* 101569 */   GIR_EraseRootFromParent_Done,
     /* 101570 */ // Label 1897: @101570
     /* 101570 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(101626), // Rule ID 243 //
     /* 101575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101600 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101624 */   GIR_RootConstrainSelectedInstOperands,
     /* 101625 */   // GIR_Coverage, 243,
     /* 101625 */   GIR_EraseRootFromParent_Done,
     /* 101626 */ // Label 1898: @101626
     /* 101626 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(101682), // Rule ID 244 //
     /* 101631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101656 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101680 */   GIR_RootConstrainSelectedInstOperands,
     /* 101681 */   // GIR_Coverage, 244,
     /* 101681 */   GIR_EraseRootFromParent_Done,
     /* 101682 */ // Label 1899: @101682
     /* 101682 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(101735), // Rule ID 4078 //
     /* 101687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101698 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101709 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101733 */   GIR_RootConstrainSelectedInstOperands,
     /* 101734 */   // GIR_Coverage, 4078,
     /* 101734 */   GIR_EraseRootFromParent_Done,
     /* 101735 */ // Label 1900: @101735
     /* 101735 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(101788), // Rule ID 4079 //
     /* 101740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101762 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101786 */   GIR_RootConstrainSelectedInstOperands,
     /* 101787 */   // GIR_Coverage, 4079,
     /* 101787 */   GIR_EraseRootFromParent_Done,
     /* 101788 */ // Label 1901: @101788
     /* 101788 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(101841), // Rule ID 4080 //
     /* 101793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101796 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101815 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101839 */   GIR_RootConstrainSelectedInstOperands,
     /* 101840 */   // GIR_Coverage, 4080,
     /* 101840 */   GIR_EraseRootFromParent_Done,
     /* 101841 */ // Label 1902: @101841
     /* 101841 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101894), // Rule ID 4081 //
     /* 101846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101868 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101892 */   GIR_RootConstrainSelectedInstOperands,
     /* 101893 */   // GIR_Coverage, 4081,
     /* 101893 */   GIR_EraseRootFromParent_Done,
     /* 101894 */ // Label 1903: @101894
     /* 101894 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(101986), // Rule ID 4104 //
     /* 101899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101902 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101906 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 101928 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 101935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101955 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101985 */   // GIR_Coverage, 4104,
     /* 101985 */   GIR_EraseRootFromParent_Done,
     /* 101986 */ // Label 1904: @101986
     /* 101986 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102078), // Rule ID 4105 //
     /* 101991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101994 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102020 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102047 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102072 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102077 */   // GIR_Coverage, 4105,
     /* 102077 */   GIR_EraseRootFromParent_Done,
     /* 102078 */ // Label 1905: @102078
     /* 102078 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102170), // Rule ID 4106 //
     /* 102083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102112 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102139 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102169 */   // GIR_Coverage, 4106,
     /* 102169 */   GIR_EraseRootFromParent_Done,
     /* 102170 */ // Label 1906: @102170
     /* 102170 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102262), // Rule ID 4107 //
     /* 102175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102178 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 102204 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 102211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102231 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102261 */   // GIR_Coverage, 4107,
     /* 102261 */   GIR_EraseRootFromParent_Done,
     /* 102262 */ // Label 1907: @102262
     /* 102262 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102354), // Rule ID 4108 //
     /* 102267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102270 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 102296 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102296 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102299 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 102303 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102323 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102353 */   // GIR_Coverage, 4108,
     /* 102353 */   GIR_EraseRootFromParent_Done,
     /* 102354 */ // Label 1908: @102354
     /* 102354 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102446), // Rule ID 4109 //
     /* 102359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 102388 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 102395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102415 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102445 */   // GIR_Coverage, 4109,
     /* 102445 */   GIR_EraseRootFromParent_Done,
     /* 102446 */ // Label 1909: @102446
     /* 102446 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102538), // Rule ID 4110 //
     /* 102451 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102454 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102480 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102507 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102537 */   // GIR_Coverage, 4110,
     /* 102537 */   GIR_EraseRootFromParent_Done,
     /* 102538 */ // Label 1910: @102538
     /* 102538 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102630), // Rule ID 4111 //
     /* 102543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102546 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102572 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102599 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102629 */   // GIR_Coverage, 4111,
     /* 102629 */   GIR_EraseRootFromParent_Done,
     /* 102630 */ // Label 1911: @102630
     /* 102630 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102678), // Rule ID 259 //
     /* 102635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102638 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102657 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102672 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102676 */   GIR_RootConstrainSelectedInstOperands,
     /* 102677 */   // GIR_Coverage, 259,
     /* 102677 */   GIR_EraseRootFromParent_Done,
     /* 102678 */ // Label 1912: @102678
     /* 102678 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102729), // Rule ID 264 //
     /* 102683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102686 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102708 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102727 */   GIR_RootConstrainSelectedInstOperands,
     /* 102728 */   // GIR_Coverage, 264,
     /* 102728 */   GIR_EraseRootFromParent_Done,
     /* 102729 */ // Label 1913: @102729
     /* 102729 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102788), // Rule ID 7023 //
     /* 102734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102744 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102762 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102786 */   GIR_RootConstrainSelectedInstOperands,
     /* 102787 */   // GIR_Coverage, 7023,
     /* 102787 */   GIR_EraseRootFromParent_Done,
     /* 102788 */ // Label 1914: @102788
     /* 102788 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102847), // Rule ID 7024 //
     /* 102793 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102796 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102803 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102821 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102845 */   GIR_RootConstrainSelectedInstOperands,
     /* 102846 */   // GIR_Coverage, 7024,
     /* 102846 */   GIR_EraseRootFromParent_Done,
     /* 102847 */ // Label 1915: @102847
     /* 102847 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102895), // Rule ID 280 //
     /* 102852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102874 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 102877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102893 */   GIR_RootConstrainSelectedInstOperands,
     /* 102894 */   // GIR_Coverage, 280,
     /* 102894 */   GIR_EraseRootFromParent_Done,
     /* 102895 */ // Label 1916: @102895
     /* 102895 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102946), // Rule ID 285 //
     /* 102900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102925 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102944 */   GIR_RootConstrainSelectedInstOperands,
     /* 102945 */   // GIR_Coverage, 285,
     /* 102945 */   GIR_EraseRootFromParent_Done,
     /* 102946 */ // Label 1917: @102946
     /* 102946 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103000), // Rule ID 7025 //
     /* 102951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102961 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102979 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102998 */   GIR_RootConstrainSelectedInstOperands,
     /* 102999 */   // GIR_Coverage, 7025,
     /* 102999 */   GIR_EraseRootFromParent_Done,
     /* 103000 */ // Label 1918: @103000
     /* 103000 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103054), // Rule ID 7026 //
     /* 103005 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103015 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103026 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103033 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103052 */   GIR_RootConstrainSelectedInstOperands,
     /* 103053 */   // GIR_Coverage, 7026,
     /* 103053 */   GIR_EraseRootFromParent_Done,
     /* 103054 */ // Label 1919: @103054
     /* 103054 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103111), // Rule ID 7380 //
     /* 103059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 103062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103090 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15803>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 103093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103109 */   GIR_RootConstrainSelectedInstOperands,
     /* 103110 */   // GIR_Coverage, 7380,
     /* 103110 */   GIR_EraseRootFromParent_Done,
     /* 103111 */ // Label 1920: @103111
     /* 103111 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103159), // Rule ID 4125 //
     /* 103116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103138 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103157 */   GIR_RootConstrainSelectedInstOperands,
     /* 103158 */   // GIR_Coverage, 4125,
     /* 103158 */   GIR_EraseRootFromParent_Done,
     /* 103159 */ // Label 1921: @103159
     /* 103159 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103207), // Rule ID 4126 //
     /* 103164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103186 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103205 */   GIR_RootConstrainSelectedInstOperands,
     /* 103206 */   // GIR_Coverage, 4126,
     /* 103206 */   GIR_EraseRootFromParent_Done,
     /* 103207 */ // Label 1922: @103207
     /* 103207 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103294), // Rule ID 4142 //
     /* 103212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103241 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103263 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103293 */   // GIR_Coverage, 4142,
     /* 103293 */   GIR_EraseRootFromParent_Done,
     /* 103294 */ // Label 1923: @103294
     /* 103294 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103381), // Rule ID 4143 //
     /* 103299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103302 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103306 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103328 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 103335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103350 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103380 */   // GIR_Coverage, 4143,
     /* 103380 */   GIR_EraseRootFromParent_Done,
     /* 103381 */ // Label 1924: @103381
     /* 103381 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103468), // Rule ID 4144 //
     /* 103386 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103389 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103415 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103437 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103467 */   // GIR_Coverage, 4144,
     /* 103467 */   GIR_EraseRootFromParent_Done,
     /* 103468 */ // Label 1925: @103468
     /* 103468 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103555), // Rule ID 4145 //
     /* 103473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103476 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103480 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103502 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103524 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103554 */   // GIR_Coverage, 4145,
     /* 103554 */   GIR_EraseRootFromParent_Done,
     /* 103555 */ // Label 1926: @103555
     /* 103555 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103603), // Rule ID 4153 //
     /* 103560 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103563 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103582 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103601 */   GIR_RootConstrainSelectedInstOperands,
     /* 103602 */   // GIR_Coverage, 4153,
     /* 103602 */   GIR_EraseRootFromParent_Done,
     /* 103603 */ // Label 1927: @103603
     /* 103603 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103651), // Rule ID 4154 //
     /* 103608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103630 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103649 */   GIR_RootConstrainSelectedInstOperands,
     /* 103650 */   // GIR_Coverage, 4154,
     /* 103650 */   GIR_EraseRootFromParent_Done,
     /* 103651 */ // Label 1928: @103651
     /* 103651 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103738), // Rule ID 4165 //
     /* 103656 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103659 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 103685 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 103692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103707 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103737 */   // GIR_Coverage, 4165,
     /* 103737 */   GIR_EraseRootFromParent_Done,
     /* 103738 */ // Label 1929: @103738
     /* 103738 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103825), // Rule ID 4166 //
     /* 103743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103746 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103750 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 103772 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 103779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103794 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103824 */   // GIR_Coverage, 4166,
     /* 103824 */   GIR_EraseRootFromParent_Done,
     /* 103825 */ // Label 1930: @103825
     /* 103825 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103912), // Rule ID 4167 //
     /* 103830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103859 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103881 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103911 */   // GIR_Coverage, 4167,
     /* 103911 */   GIR_EraseRootFromParent_Done,
     /* 103912 */ // Label 1931: @103912
     /* 103912 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103999), // Rule ID 4168 //
     /* 103917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103920 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103946 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103968 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103998 */   // GIR_Coverage, 4168,
     /* 103998 */   GIR_EraseRootFromParent_Done,
     /* 103999 */ // Label 1932: @103999
     /* 103999 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104039), // Rule ID 6990 //
     /* 104004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104007 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104010 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104024 */   // MIs[0] ptr
     /* 104024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104032 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15803>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104037 */   GIR_RootConstrainSelectedInstOperands,
     /* 104038 */   // GIR_Coverage, 6990,
     /* 104038 */   GIR_Done,
     /* 104039 */ // Label 1933: @104039
     /* 104039 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104076), // Rule ID 7021 //
     /* 104044 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104054 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104061 */   // MIs[0] ptr
     /* 104061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104069 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15831>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104074 */   GIR_RootConstrainSelectedInstOperands,
     /* 104075 */   // GIR_Coverage, 7021,
     /* 104075 */   GIR_Done,
     /* 104076 */ // Label 1934: @104076
     /* 104076 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104113), // Rule ID 7022 //
     /* 104081 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104098 */   // MIs[0] ptr
     /* 104098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104106 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15803>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104111 */   GIR_RootConstrainSelectedInstOperands,
     /* 104112 */   // GIR_Coverage, 7022,
     /* 104112 */   GIR_Done,
     /* 104113 */ // Label 1935: @104113
     /* 104113 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104144), // Rule ID 6370 //
     /* 104118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104121 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104129 */   // MIs[0] Rn
     /* 104129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104137 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104142 */   GIR_RootConstrainSelectedInstOperands,
     /* 104143 */   // GIR_Coverage, 6370,
     /* 104143 */   GIR_Done,
     /* 104144 */ // Label 1936: @104144
     /* 104144 */ GIM_Reject,
     /* 104145 */ // Label 1825: @104145
     /* 104145 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104353),
     /* 104150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104165 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104206), // Rule ID 245 //
     /* 104170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104180 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104204 */     GIR_RootConstrainSelectedInstOperands,
     /* 104205 */     // GIR_Coverage, 245,
     /* 104205 */     GIR_EraseRootFromParent_Done,
     /* 104206 */   // Label 1938: @104206
     /* 104206 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104247), // Rule ID 246 //
     /* 104211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104221 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104245 */     GIR_RootConstrainSelectedInstOperands,
     /* 104246 */     // GIR_Coverage, 246,
     /* 104246 */     GIR_EraseRootFromParent_Done,
     /* 104247 */   // Label 1939: @104247
     /* 104247 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104283), // Rule ID 265 //
     /* 104252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104262 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104281 */     GIR_RootConstrainSelectedInstOperands,
     /* 104282 */     // GIR_Coverage, 265,
     /* 104282 */     GIR_EraseRootFromParent_Done,
     /* 104283 */   // Label 1940: @104283
     /* 104283 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104319), // Rule ID 286 //
     /* 104288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104298 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104317 */     GIR_RootConstrainSelectedInstOperands,
     /* 104318 */     // GIR_Coverage, 286,
     /* 104318 */     GIR_EraseRootFromParent_Done,
     /* 104319 */   // Label 1941: @104319
     /* 104319 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104352), // Rule ID 4134 //
     /* 104324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104331 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104350 */     GIR_RootConstrainSelectedInstOperands,
     /* 104351 */     // GIR_Coverage, 4134,
     /* 104351 */     GIR_EraseRootFromParent_Done,
     /* 104352 */   // Label 1942: @104352
     /* 104352 */   GIM_Reject,
     /* 104353 */ // Label 1937: @104353
     /* 104353 */ GIM_Reject,
     /* 104354 */ // Label 1826: @104354
     /* 104354 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104731),
     /* 104359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104370 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104415), // Rule ID 4068 //
     /* 104375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104389 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104413 */     GIR_RootConstrainSelectedInstOperands,
     /* 104414 */     // GIR_Coverage, 4068,
     /* 104414 */     GIR_EraseRootFromParent_Done,
     /* 104415 */   // Label 1944: @104415
     /* 104415 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104460), // Rule ID 4069 //
     /* 104420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104434 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104458 */     GIR_RootConstrainSelectedInstOperands,
     /* 104459 */     // GIR_Coverage, 4069,
     /* 104459 */     GIR_EraseRootFromParent_Done,
     /* 104460 */   // Label 1945: @104460
     /* 104460 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104505), // Rule ID 4070 //
     /* 104465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104479 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104503 */     GIR_RootConstrainSelectedInstOperands,
     /* 104504 */     // GIR_Coverage, 4070,
     /* 104504 */     GIR_EraseRootFromParent_Done,
     /* 104505 */   // Label 1946: @104505
     /* 104505 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104550), // Rule ID 4071 //
     /* 104510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104524 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104548 */     GIR_RootConstrainSelectedInstOperands,
     /* 104549 */     // GIR_Coverage, 4071,
     /* 104549 */     GIR_EraseRootFromParent_Done,
     /* 104550 */   // Label 1947: @104550
     /* 104550 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104590), // Rule ID 4120 //
     /* 104555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104569 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 4120,
     /* 104589 */     GIR_EraseRootFromParent_Done,
     /* 104590 */   // Label 1948: @104590
     /* 104590 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104630), // Rule ID 4123 //
     /* 104595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104609 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104628 */     GIR_RootConstrainSelectedInstOperands,
     /* 104629 */     // GIR_Coverage, 4123,
     /* 104629 */     GIR_EraseRootFromParent_Done,
     /* 104630 */   // Label 1949: @104630
     /* 104630 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104670), // Rule ID 4148 //
     /* 104635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104649 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104668 */     GIR_RootConstrainSelectedInstOperands,
     /* 104669 */     // GIR_Coverage, 4148,
     /* 104669 */     GIR_EraseRootFromParent_Done,
     /* 104670 */   // Label 1950: @104670
     /* 104670 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104710), // Rule ID 4149 //
     /* 104675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104689 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104708 */     GIR_RootConstrainSelectedInstOperands,
     /* 104709 */     // GIR_Coverage, 4149,
     /* 104709 */     GIR_EraseRootFromParent_Done,
     /* 104710 */   // Label 1951: @104710
     /* 104710 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104730), // Rule ID 6369 //
     /* 104715 */     // MIs[0] Rn
     /* 104715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104723 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 104728 */     GIR_RootConstrainSelectedInstOperands,
     /* 104729 */     // GIR_Coverage, 6369,
     /* 104729 */     GIR_Done,
     /* 104730 */   // Label 1952: @104730
     /* 104730 */   GIM_Reject,
     /* 104731 */ // Label 1943: @104731
     /* 104731 */ GIM_Reject,
     /* 104732 */ // Label 1827: @104732
     /* 104732 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(105109),
     /* 104737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104748 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104793), // Rule ID 4082 //
     /* 104753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104767 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104791 */     GIR_RootConstrainSelectedInstOperands,
     /* 104792 */     // GIR_Coverage, 4082,
     /* 104792 */     GIR_EraseRootFromParent_Done,
     /* 104793 */   // Label 1954: @104793
     /* 104793 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104838), // Rule ID 4083 //
     /* 104798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104812 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104836 */     GIR_RootConstrainSelectedInstOperands,
     /* 104837 */     // GIR_Coverage, 4083,
     /* 104837 */     GIR_EraseRootFromParent_Done,
     /* 104838 */   // Label 1955: @104838
     /* 104838 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104883), // Rule ID 4084 //
     /* 104843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104857 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104881 */     GIR_RootConstrainSelectedInstOperands,
     /* 104882 */     // GIR_Coverage, 4084,
     /* 104882 */     GIR_EraseRootFromParent_Done,
     /* 104883 */   // Label 1956: @104883
     /* 104883 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104928), // Rule ID 4085 //
     /* 104888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104902 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104926 */     GIR_RootConstrainSelectedInstOperands,
     /* 104927 */     // GIR_Coverage, 4085,
     /* 104927 */     GIR_EraseRootFromParent_Done,
     /* 104928 */   // Label 1957: @104928
     /* 104928 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104968), // Rule ID 4128 //
     /* 104933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104947 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104966 */     GIR_RootConstrainSelectedInstOperands,
     /* 104967 */     // GIR_Coverage, 4128,
     /* 104967 */     GIR_EraseRootFromParent_Done,
     /* 104968 */   // Label 1958: @104968
     /* 104968 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105008), // Rule ID 4132 //
     /* 104973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104987 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105006 */     GIR_RootConstrainSelectedInstOperands,
     /* 105007 */     // GIR_Coverage, 4132,
     /* 105007 */     GIR_EraseRootFromParent_Done,
     /* 105008 */   // Label 1959: @105008
     /* 105008 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105048), // Rule ID 4155 //
     /* 105013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105027 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105046 */     GIR_RootConstrainSelectedInstOperands,
     /* 105047 */     // GIR_Coverage, 4155,
     /* 105047 */     GIR_EraseRootFromParent_Done,
     /* 105048 */   // Label 1960: @105048
     /* 105048 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105088), // Rule ID 4156 //
     /* 105053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105067 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105086 */     GIR_RootConstrainSelectedInstOperands,
     /* 105087 */     // GIR_Coverage, 4156,
     /* 105087 */     GIR_EraseRootFromParent_Done,
     /* 105088 */   // Label 1961: @105088
     /* 105088 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105108), // Rule ID 6366 //
     /* 105093 */     // MIs[0] Rn
     /* 105093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105101 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105106 */     GIR_RootConstrainSelectedInstOperands,
     /* 105107 */     // GIR_Coverage, 6366,
     /* 105107 */     GIR_Done,
     /* 105108 */   // Label 1962: @105108
     /* 105108 */   GIM_Reject,
     /* 105109 */ // Label 1953: @105109
     /* 105109 */ GIM_Reject,
     /* 105110 */ // Label 1828: @105110
     /* 105110 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105487),
     /* 105115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105118 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105126 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105171), // Rule ID 4074 //
     /* 105131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105145 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105169 */     GIR_RootConstrainSelectedInstOperands,
     /* 105170 */     // GIR_Coverage, 4074,
     /* 105170 */     GIR_EraseRootFromParent_Done,
     /* 105171 */   // Label 1964: @105171
     /* 105171 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105216), // Rule ID 4075 //
     /* 105176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105190 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105214 */     GIR_RootConstrainSelectedInstOperands,
     /* 105215 */     // GIR_Coverage, 4075,
     /* 105215 */     GIR_EraseRootFromParent_Done,
     /* 105216 */   // Label 1965: @105216
     /* 105216 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105261), // Rule ID 4076 //
     /* 105221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105235 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105259 */     GIR_RootConstrainSelectedInstOperands,
     /* 105260 */     // GIR_Coverage, 4076,
     /* 105260 */     GIR_EraseRootFromParent_Done,
     /* 105261 */   // Label 1966: @105261
     /* 105261 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(105306), // Rule ID 4077 //
     /* 105266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105280 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105304 */     GIR_RootConstrainSelectedInstOperands,
     /* 105305 */     // GIR_Coverage, 4077,
     /* 105305 */     GIR_EraseRootFromParent_Done,
     /* 105306 */   // Label 1967: @105306
     /* 105306 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(105346), // Rule ID 4122 //
     /* 105311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105325 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105344 */     GIR_RootConstrainSelectedInstOperands,
     /* 105345 */     // GIR_Coverage, 4122,
     /* 105345 */     GIR_EraseRootFromParent_Done,
     /* 105346 */   // Label 1968: @105346
     /* 105346 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(105386), // Rule ID 4124 //
     /* 105351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105365 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105384 */     GIR_RootConstrainSelectedInstOperands,
     /* 105385 */     // GIR_Coverage, 4124,
     /* 105385 */     GIR_EraseRootFromParent_Done,
     /* 105386 */   // Label 1969: @105386
     /* 105386 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(105426), // Rule ID 4150 //
     /* 105391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105405 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105424 */     GIR_RootConstrainSelectedInstOperands,
     /* 105425 */     // GIR_Coverage, 4150,
     /* 105425 */     GIR_EraseRootFromParent_Done,
     /* 105426 */   // Label 1970: @105426
     /* 105426 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(105466), // Rule ID 4152 //
     /* 105431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105445 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105464 */     GIR_RootConstrainSelectedInstOperands,
     /* 105465 */     // GIR_Coverage, 4152,
     /* 105465 */     GIR_EraseRootFromParent_Done,
     /* 105466 */   // Label 1971: @105466
     /* 105466 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(105486), // Rule ID 6368 //
     /* 105471 */     // MIs[0] Rn
     /* 105471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105479 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 105484 */     GIR_RootConstrainSelectedInstOperands,
     /* 105485 */     // GIR_Coverage, 6368,
     /* 105485 */     GIR_Done,
     /* 105486 */   // Label 1972: @105486
     /* 105486 */   GIM_Reject,
     /* 105487 */ // Label 1963: @105487
     /* 105487 */ GIM_Reject,
     /* 105488 */ // Label 1829: @105488
     /* 105488 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(105865),
     /* 105493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105504 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105549), // Rule ID 4086 //
     /* 105509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105523 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105547 */     GIR_RootConstrainSelectedInstOperands,
     /* 105548 */     // GIR_Coverage, 4086,
     /* 105548 */     GIR_EraseRootFromParent_Done,
     /* 105549 */   // Label 1974: @105549
     /* 105549 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(105594), // Rule ID 4087 //
     /* 105554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105568 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105592 */     GIR_RootConstrainSelectedInstOperands,
     /* 105593 */     // GIR_Coverage, 4087,
     /* 105593 */     GIR_EraseRootFromParent_Done,
     /* 105594 */   // Label 1975: @105594
     /* 105594 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105639), // Rule ID 4088 //
     /* 105599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105613 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105637 */     GIR_RootConstrainSelectedInstOperands,
     /* 105638 */     // GIR_Coverage, 4088,
     /* 105638 */     GIR_EraseRootFromParent_Done,
     /* 105639 */   // Label 1976: @105639
     /* 105639 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105684), // Rule ID 4089 //
     /* 105644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105658 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105682 */     GIR_RootConstrainSelectedInstOperands,
     /* 105683 */     // GIR_Coverage, 4089,
     /* 105683 */     GIR_EraseRootFromParent_Done,
     /* 105684 */   // Label 1977: @105684
     /* 105684 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(105724), // Rule ID 4127 //
     /* 105689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105703 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105722 */     GIR_RootConstrainSelectedInstOperands,
     /* 105723 */     // GIR_Coverage, 4127,
     /* 105723 */     GIR_EraseRootFromParent_Done,
     /* 105724 */   // Label 1978: @105724
     /* 105724 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105764), // Rule ID 4131 //
     /* 105729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105743 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105762 */     GIR_RootConstrainSelectedInstOperands,
     /* 105763 */     // GIR_Coverage, 4131,
     /* 105763 */     GIR_EraseRootFromParent_Done,
     /* 105764 */   // Label 1979: @105764
     /* 105764 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105804), // Rule ID 4157 //
     /* 105769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105783 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105802 */     GIR_RootConstrainSelectedInstOperands,
     /* 105803 */     // GIR_Coverage, 4157,
     /* 105803 */     GIR_EraseRootFromParent_Done,
     /* 105804 */   // Label 1980: @105804
     /* 105804 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105844), // Rule ID 4158 //
     /* 105809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105823 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105842 */     GIR_RootConstrainSelectedInstOperands,
     /* 105843 */     // GIR_Coverage, 4158,
     /* 105843 */     GIR_EraseRootFromParent_Done,
     /* 105844 */   // Label 1981: @105844
     /* 105844 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105864), // Rule ID 6365 //
     /* 105849 */     // MIs[0] Rn
     /* 105849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105857 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 105862 */     GIR_RootConstrainSelectedInstOperands,
     /* 105863 */     // GIR_Coverage, 6365,
     /* 105863 */     GIR_Done,
     /* 105864 */   // Label 1982: @105864
     /* 105864 */   GIM_Reject,
     /* 105865 */ // Label 1973: @105865
     /* 105865 */ GIM_Reject,
     /* 105866 */ // Label 1830: @105866
     /* 105866 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106073),
     /* 105871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105882 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105927), // Rule ID 4072 //
     /* 105887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105901 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105925 */     GIR_RootConstrainSelectedInstOperands,
     /* 105926 */     // GIR_Coverage, 4072,
     /* 105926 */     GIR_EraseRootFromParent_Done,
     /* 105927 */   // Label 1984: @105927
     /* 105927 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105972), // Rule ID 4073 //
     /* 105932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105946 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105970 */     GIR_RootConstrainSelectedInstOperands,
     /* 105971 */     // GIR_Coverage, 4073,
     /* 105971 */     GIR_EraseRootFromParent_Done,
     /* 105972 */   // Label 1985: @105972
     /* 105972 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106012), // Rule ID 4121 //
     /* 105977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105991 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106010 */     GIR_RootConstrainSelectedInstOperands,
     /* 106011 */     // GIR_Coverage, 4121,
     /* 106011 */     GIR_EraseRootFromParent_Done,
     /* 106012 */   // Label 1986: @106012
     /* 106012 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106052), // Rule ID 4151 //
     /* 106017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106031 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106050 */     GIR_RootConstrainSelectedInstOperands,
     /* 106051 */     // GIR_Coverage, 4151,
     /* 106051 */     GIR_EraseRootFromParent_Done,
     /* 106052 */   // Label 1987: @106052
     /* 106052 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106072), // Rule ID 6367 //
     /* 106057 */     // MIs[0] Rn
     /* 106057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106065 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106070 */     GIR_RootConstrainSelectedInstOperands,
     /* 106071 */     // GIR_Coverage, 6367,
     /* 106071 */     GIR_Done,
     /* 106072 */   // Label 1988: @106072
     /* 106072 */   GIM_Reject,
     /* 106073 */ // Label 1983: @106073
     /* 106073 */ GIM_Reject,
     /* 106074 */ // Label 1831: @106074
     /* 106074 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106451),
     /* 106079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106090 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106135), // Rule ID 4090 //
     /* 106095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106109 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106133 */     GIR_RootConstrainSelectedInstOperands,
     /* 106134 */     // GIR_Coverage, 4090,
     /* 106134 */     GIR_EraseRootFromParent_Done,
     /* 106135 */   // Label 1990: @106135
     /* 106135 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106180), // Rule ID 4091 //
     /* 106140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106154 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106178 */     GIR_RootConstrainSelectedInstOperands,
     /* 106179 */     // GIR_Coverage, 4091,
     /* 106179 */     GIR_EraseRootFromParent_Done,
     /* 106180 */   // Label 1991: @106180
     /* 106180 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(106225), // Rule ID 4092 //
     /* 106185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106199 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106223 */     GIR_RootConstrainSelectedInstOperands,
     /* 106224 */     // GIR_Coverage, 4092,
     /* 106224 */     GIR_EraseRootFromParent_Done,
     /* 106225 */   // Label 1992: @106225
     /* 106225 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(106270), // Rule ID 4093 //
     /* 106230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106244 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106268 */     GIR_RootConstrainSelectedInstOperands,
     /* 106269 */     // GIR_Coverage, 4093,
     /* 106269 */     GIR_EraseRootFromParent_Done,
     /* 106270 */   // Label 1993: @106270
     /* 106270 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(106310), // Rule ID 4130 //
     /* 106275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106289 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106308 */     GIR_RootConstrainSelectedInstOperands,
     /* 106309 */     // GIR_Coverage, 4130,
     /* 106309 */     GIR_EraseRootFromParent_Done,
     /* 106310 */   // Label 1994: @106310
     /* 106310 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(106350), // Rule ID 4133 //
     /* 106315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106329 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106348 */     GIR_RootConstrainSelectedInstOperands,
     /* 106349 */     // GIR_Coverage, 4133,
     /* 106349 */     GIR_EraseRootFromParent_Done,
     /* 106350 */   // Label 1995: @106350
     /* 106350 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(106390), // Rule ID 4159 //
     /* 106355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106369 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106388 */     GIR_RootConstrainSelectedInstOperands,
     /* 106389 */     // GIR_Coverage, 4159,
     /* 106389 */     GIR_EraseRootFromParent_Done,
     /* 106390 */   // Label 1996: @106390
     /* 106390 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(106430), // Rule ID 4161 //
     /* 106395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106409 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106428 */     GIR_RootConstrainSelectedInstOperands,
     /* 106429 */     // GIR_Coverage, 4161,
     /* 106429 */     GIR_EraseRootFromParent_Done,
     /* 106430 */   // Label 1997: @106430
     /* 106430 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(106450), // Rule ID 6364 //
     /* 106435 */     // MIs[0] Rn
     /* 106435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106443 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 106448 */     GIR_RootConstrainSelectedInstOperands,
     /* 106449 */     // GIR_Coverage, 6364,
     /* 106449 */     GIR_Done,
     /* 106450 */   // Label 1998: @106450
     /* 106450 */   GIM_Reject,
     /* 106451 */ // Label 1989: @106451
     /* 106451 */ GIM_Reject,
     /* 106452 */ // Label 1832: @106452
     /* 106452 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(106659),
     /* 106457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106468 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(106513), // Rule ID 4094 //
     /* 106473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106487 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106511 */     GIR_RootConstrainSelectedInstOperands,
     /* 106512 */     // GIR_Coverage, 4094,
     /* 106512 */     GIR_EraseRootFromParent_Done,
     /* 106513 */   // Label 2000: @106513
     /* 106513 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106558), // Rule ID 4095 //
     /* 106518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106532 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106556 */     GIR_RootConstrainSelectedInstOperands,
     /* 106557 */     // GIR_Coverage, 4095,
     /* 106557 */     GIR_EraseRootFromParent_Done,
     /* 106558 */   // Label 2001: @106558
     /* 106558 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(106598), // Rule ID 4129 //
     /* 106563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106577 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106596 */     GIR_RootConstrainSelectedInstOperands,
     /* 106597 */     // GIR_Coverage, 4129,
     /* 106597 */     GIR_EraseRootFromParent_Done,
     /* 106598 */   // Label 2002: @106598
     /* 106598 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(106638), // Rule ID 4160 //
     /* 106603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106617 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106636 */     GIR_RootConstrainSelectedInstOperands,
     /* 106637 */     // GIR_Coverage, 4160,
     /* 106637 */     GIR_EraseRootFromParent_Done,
     /* 106638 */   // Label 2003: @106638
     /* 106638 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(106658), // Rule ID 6363 //
     /* 106643 */     // MIs[0] Rn
     /* 106643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106651 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 106656 */     GIR_RootConstrainSelectedInstOperands,
     /* 106657 */     // GIR_Coverage, 6363,
     /* 106657 */     GIR_Done,
     /* 106658 */   // Label 2004: @106658
     /* 106658 */   GIM_Reject,
     /* 106659 */ // Label 1999: @106659
     /* 106659 */ GIM_Reject,
     /* 106660 */ // Label 1833: @106660
     /* 106660 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106723), // Rule ID 10889 //
     /* 106665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106679 */   // MIs[0] base
     /* 106679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106687 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106699 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 106707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106712 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106721 */   GIR_RootConstrainSelectedInstOperands,
     /* 106722 */   // GIR_Coverage, 10889,
     /* 106722 */   GIR_EraseRootFromParent_Done,
     /* 106723 */ // Label 2005: @106723
     /* 106723 */ GIM_Reject,
     /* 106724 */ // Label 1834: @106724
     /* 106724 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106787), // Rule ID 10895 //
     /* 106729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106735 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106743 */   // MIs[0] base
     /* 106743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106751 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106763 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 106771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106776 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106781 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106785 */   GIR_RootConstrainSelectedInstOperands,
     /* 106786 */   // GIR_Coverage, 10895,
     /* 106786 */   GIR_EraseRootFromParent_Done,
     /* 106787 */ // Label 2006: @106787
     /* 106787 */ GIM_Reject,
     /* 106788 */ // Label 1835: @106788
     /* 106788 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(106961),
     /* 106793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106796 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106808 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106856), // Rule ID 10880 //
     /* 106813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106820 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106845 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106854 */     GIR_RootConstrainSelectedInstOperands,
     /* 106855 */     // GIR_Coverage, 10880,
     /* 106855 */     GIR_EraseRootFromParent_Done,
     /* 106856 */   // Label 2008: @106856
     /* 106856 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106904), // Rule ID 10898 //
     /* 106861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106868 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106893 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106902 */     GIR_RootConstrainSelectedInstOperands,
     /* 106903 */     // GIR_Coverage, 10898,
     /* 106903 */     GIR_EraseRootFromParent_Done,
     /* 106904 */   // Label 2009: @106904
     /* 106904 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(106932), // Rule ID 10925 //
     /* 106909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106916 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106921 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106930 */     GIR_RootConstrainSelectedInstOperands,
     /* 106931 */     // GIR_Coverage, 10925,
     /* 106931 */     GIR_EraseRootFromParent_Done,
     /* 106932 */   // Label 2010: @106932
     /* 106932 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106960), // Rule ID 10937 //
     /* 106937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106944 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106949 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106958 */     GIR_RootConstrainSelectedInstOperands,
     /* 106959 */     // GIR_Coverage, 10937,
     /* 106959 */     GIR_EraseRootFromParent_Done,
     /* 106960 */   // Label 2011: @106960
     /* 106960 */   GIM_Reject,
     /* 106961 */ // Label 2007: @106961
     /* 106961 */ GIM_Reject,
     /* 106962 */ // Label 1836: @106962
     /* 106962 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107025), // Rule ID 10886 //
     /* 106967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106981 */   // MIs[0] base
     /* 106981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106989 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 106996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107001 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107014 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107023 */   GIR_RootConstrainSelectedInstOperands,
     /* 107024 */   // GIR_Coverage, 10886,
     /* 107024 */   GIR_EraseRootFromParent_Done,
     /* 107025 */ // Label 2012: @107025
     /* 107025 */ GIM_Reject,
     /* 107026 */ // Label 1837: @107026
     /* 107026 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107199),
     /* 107031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107046 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107094), // Rule ID 10868 //
     /* 107051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107058 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107083 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107092 */     GIR_RootConstrainSelectedInstOperands,
     /* 107093 */     // GIR_Coverage, 10868,
     /* 107093 */     GIR_EraseRootFromParent_Done,
     /* 107094 */   // Label 2014: @107094
     /* 107094 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107142), // Rule ID 10892 //
     /* 107099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107106 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107131 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107140 */     GIR_RootConstrainSelectedInstOperands,
     /* 107141 */     // GIR_Coverage, 10892,
     /* 107141 */     GIR_EraseRootFromParent_Done,
     /* 107142 */   // Label 2015: @107142
     /* 107142 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107170), // Rule ID 10921 //
     /* 107147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107154 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107159 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107168 */     GIR_RootConstrainSelectedInstOperands,
     /* 107169 */     // GIR_Coverage, 10921,
     /* 107169 */     GIR_EraseRootFromParent_Done,
     /* 107170 */   // Label 2016: @107170
     /* 107170 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107198), // Rule ID 10933 //
     /* 107175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107182 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107187 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107196 */     GIR_RootConstrainSelectedInstOperands,
     /* 107197 */     // GIR_Coverage, 10933,
     /* 107197 */     GIR_EraseRootFromParent_Done,
     /* 107198 */   // Label 2017: @107198
     /* 107198 */   GIM_Reject,
     /* 107199 */ // Label 2013: @107199
     /* 107199 */ GIM_Reject,
     /* 107200 */ // Label 1838: @107200
     /* 107200 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107373),
     /* 107205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107220 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107268), // Rule ID 10847 //
     /* 107225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107232 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107257 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107266 */     GIR_RootConstrainSelectedInstOperands,
     /* 107267 */     // GIR_Coverage, 10847,
     /* 107267 */     GIR_EraseRootFromParent_Done,
     /* 107268 */   // Label 2019: @107268
     /* 107268 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107316), // Rule ID 10883 //
     /* 107273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107280 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107305 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107314 */     GIR_RootConstrainSelectedInstOperands,
     /* 107315 */     // GIR_Coverage, 10883,
     /* 107315 */     GIR_EraseRootFromParent_Done,
     /* 107316 */   // Label 2020: @107316
     /* 107316 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107344), // Rule ID 10917 //
     /* 107321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107328 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107333 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107342 */     GIR_RootConstrainSelectedInstOperands,
     /* 107343 */     // GIR_Coverage, 10917,
     /* 107343 */     GIR_EraseRootFromParent_Done,
     /* 107344 */   // Label 2021: @107344
     /* 107344 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107372), // Rule ID 10929 //
     /* 107349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107356 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107361 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107370 */     GIR_RootConstrainSelectedInstOperands,
     /* 107371 */     // GIR_Coverage, 10929,
     /* 107371 */     GIR_EraseRootFromParent_Done,
     /* 107372 */   // Label 2022: @107372
     /* 107372 */   GIM_Reject,
     /* 107373 */ // Label 2018: @107373
     /* 107373 */ GIM_Reject,
     /* 107374 */ // Label 1839: @107374
     /* 107374 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107417), // Rule ID 2428 //
     /* 107379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 107393 */   // MIs[0] base
     /* 107393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107401 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 107404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 107406 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107415 */   GIR_RootConstrainSelectedInstOperands,
     /* 107416 */   // GIR_Coverage, 2428,
     /* 107416 */   GIR_EraseRootFromParent_Done,
     /* 107417 */ // Label 2023: @107417
     /* 107417 */ GIM_Reject,
     /* 107418 */ // Label 1840: @107418
     /* 107418 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107515),
     /* 107423 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107426 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107434 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107438 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107486), // Rule ID 10815 //
     /* 107443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107450 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 107457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 107470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107475 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107484 */     GIR_RootConstrainSelectedInstOperands,
     /* 107485 */     // GIR_Coverage, 10815,
     /* 107485 */     GIR_EraseRootFromParent_Done,
     /* 107486 */   // Label 2025: @107486
     /* 107486 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107514), // Rule ID 10913 //
     /* 107491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107498 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107503 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107512 */     GIR_RootConstrainSelectedInstOperands,
     /* 107513 */     // GIR_Coverage, 10913,
     /* 107513 */     GIR_EraseRootFromParent_Done,
     /* 107514 */   // Label 2026: @107514
     /* 107514 */   GIM_Reject,
     /* 107515 */ // Label 2024: @107515
     /* 107515 */ GIM_Reject,
     /* 107516 */ // Label 1841: @107516
     /* 107516 */ GIM_Reject,
     /* 107517 */ // Label 17: @107517
     /* 107517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2029*/ GIMT_Encode4(108566),
     /* 107528 */ /*GILLT_s32*//*Label 2027*/ GIMT_Encode4(107536),
     /* 107532 */ /*GILLT_s64*//*Label 2028*/ GIMT_Encode4(107950),
     /* 107536 */ // Label 2027: @107536
     /* 107536 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107949),
     /* 107541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107544 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107597), // Rule ID 247 //
     /* 107549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107571 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 107574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107595 */     GIR_RootConstrainSelectedInstOperands,
     /* 107596 */     // GIR_Coverage, 247,
     /* 107596 */     GIR_EraseRootFromParent_Done,
     /* 107597 */   // Label 2031: @107597
     /* 107597 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107650), // Rule ID 248 //
     /* 107602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 107624 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 107624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 107627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107648 */     GIR_RootConstrainSelectedInstOperands,
     /* 107649 */     // GIR_Coverage, 248,
     /* 107649 */     GIR_EraseRootFromParent_Done,
     /* 107650 */   // Label 2032: @107650
     /* 107650 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107703), // Rule ID 251 //
     /* 107655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107677 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 107677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 107680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107701 */     GIR_RootConstrainSelectedInstOperands,
     /* 107702 */     // GIR_Coverage, 251,
     /* 107702 */     GIR_EraseRootFromParent_Done,
     /* 107703 */   // Label 2033: @107703
     /* 107703 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107756), // Rule ID 252 //
     /* 107708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107730 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 107730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 107733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107754 */     GIR_RootConstrainSelectedInstOperands,
     /* 107755 */     // GIR_Coverage, 252,
     /* 107755 */     GIR_EraseRootFromParent_Done,
     /* 107756 */   // Label 2034: @107756
     /* 107756 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107804), // Rule ID 268 //
     /* 107761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107783 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 107783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 107786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107802 */     GIR_RootConstrainSelectedInstOperands,
     /* 107803 */     // GIR_Coverage, 268,
     /* 107803 */     GIR_EraseRootFromParent_Done,
     /* 107804 */   // Label 2035: @107804
     /* 107804 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107852), // Rule ID 270 //
     /* 107809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107831 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 107831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 107834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107850 */     GIR_RootConstrainSelectedInstOperands,
     /* 107851 */     // GIR_Coverage, 270,
     /* 107851 */     GIR_EraseRootFromParent_Done,
     /* 107852 */   // Label 2036: @107852
     /* 107852 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107900), // Rule ID 289 //
     /* 107857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107879 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 107882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107898 */     GIR_RootConstrainSelectedInstOperands,
     /* 107899 */     // GIR_Coverage, 289,
     /* 107899 */     GIR_EraseRootFromParent_Done,
     /* 107900 */   // Label 2037: @107900
     /* 107900 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(107948), // Rule ID 291 //
     /* 107905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107927 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 107930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107946 */     GIR_RootConstrainSelectedInstOperands,
     /* 107947 */     // GIR_Coverage, 291,
     /* 107947 */     GIR_EraseRootFromParent_Done,
     /* 107948 */   // Label 2038: @107948
     /* 107948 */   GIM_Reject,
     /* 107949 */ // Label 2030: @107949
     /* 107949 */ GIM_Reject,
     /* 107950 */ // Label 2028: @107950
     /* 107950 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108565),
     /* 107955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107958 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108011), // Rule ID 249 //
     /* 107963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107985 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 107988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108009 */     GIR_RootConstrainSelectedInstOperands,
     /* 108010 */     // GIR_Coverage, 249,
     /* 108010 */     GIR_EraseRootFromParent_Done,
     /* 108011 */   // Label 2040: @108011
     /* 108011 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108064), // Rule ID 250 //
     /* 108016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108038 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108062 */     GIR_RootConstrainSelectedInstOperands,
     /* 108063 */     // GIR_Coverage, 250,
     /* 108063 */     GIR_EraseRootFromParent_Done,
     /* 108064 */   // Label 2041: @108064
     /* 108064 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(108117), // Rule ID 253 //
     /* 108069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108091 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108115 */     GIR_RootConstrainSelectedInstOperands,
     /* 108116 */     // GIR_Coverage, 253,
     /* 108116 */     GIR_EraseRootFromParent_Done,
     /* 108117 */   // Label 2042: @108117
     /* 108117 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108170), // Rule ID 254 //
     /* 108122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108144 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 108147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108168 */     GIR_RootConstrainSelectedInstOperands,
     /* 108169 */     // GIR_Coverage, 254,
     /* 108169 */     GIR_EraseRootFromParent_Done,
     /* 108170 */   // Label 2043: @108170
     /* 108170 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108223), // Rule ID 255 //
     /* 108175 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 108197 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 108197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 108200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108221 */     GIR_RootConstrainSelectedInstOperands,
     /* 108222 */     // GIR_Coverage, 255,
     /* 108222 */     GIR_EraseRootFromParent_Done,
     /* 108223 */   // Label 2044: @108223
     /* 108223 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108276), // Rule ID 256 //
     /* 108228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 108250 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 108250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 108253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108274 */     GIR_RootConstrainSelectedInstOperands,
     /* 108275 */     // GIR_Coverage, 256,
     /* 108275 */     GIR_EraseRootFromParent_Done,
     /* 108276 */   // Label 2045: @108276
     /* 108276 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(108324), // Rule ID 269 //
     /* 108281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108303 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 108306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108322 */     GIR_RootConstrainSelectedInstOperands,
     /* 108323 */     // GIR_Coverage, 269,
     /* 108323 */     GIR_EraseRootFromParent_Done,
     /* 108324 */   // Label 2046: @108324
     /* 108324 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108372), // Rule ID 271 //
     /* 108329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108351 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 108354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108370 */     GIR_RootConstrainSelectedInstOperands,
     /* 108371 */     // GIR_Coverage, 271,
     /* 108371 */     GIR_EraseRootFromParent_Done,
     /* 108372 */   // Label 2047: @108372
     /* 108372 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108420), // Rule ID 272 //
     /* 108377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 108399 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 108399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 108402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108418 */     GIR_RootConstrainSelectedInstOperands,
     /* 108419 */     // GIR_Coverage, 272,
     /* 108419 */     GIR_EraseRootFromParent_Done,
     /* 108420 */   // Label 2048: @108420
     /* 108420 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108468), // Rule ID 290 //
     /* 108425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108447 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 108450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108466 */     GIR_RootConstrainSelectedInstOperands,
     /* 108467 */     // GIR_Coverage, 290,
     /* 108467 */     GIR_EraseRootFromParent_Done,
     /* 108468 */   // Label 2049: @108468
     /* 108468 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108516), // Rule ID 292 //
     /* 108473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108495 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 108498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108514 */     GIR_RootConstrainSelectedInstOperands,
     /* 108515 */     // GIR_Coverage, 292,
     /* 108515 */     GIR_EraseRootFromParent_Done,
     /* 108516 */   // Label 2050: @108516
     /* 108516 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108564), // Rule ID 293 //
     /* 108521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 108543 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 108546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108562 */     GIR_RootConstrainSelectedInstOperands,
     /* 108563 */     // GIR_Coverage, 293,
     /* 108563 */     GIR_EraseRootFromParent_Done,
     /* 108564 */   // Label 2051: @108564
     /* 108564 */   GIM_Reject,
     /* 108565 */ // Label 2039: @108565
     /* 108565 */ GIM_Reject,
     /* 108566 */ // Label 2029: @108566
     /* 108566 */ GIM_Reject,
     /* 108567 */ // Label 18: @108567
     /* 108567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2054*/ GIMT_Encode4(111535),
     /* 108578 */ /*GILLT_s32*//*Label 2052*/ GIMT_Encode4(108586),
     /* 108582 */ /*GILLT_s64*//*Label 2053*/ GIMT_Encode4(110045),
     /* 108586 */ // Label 2052: @108586
     /* 108586 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(108642), // Rule ID 229 //
     /* 108591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108594 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108616 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108640 */   GIR_RootConstrainSelectedInstOperands,
     /* 108641 */   // GIR_Coverage, 229,
     /* 108641 */   GIR_EraseRootFromParent_Done,
     /* 108642 */ // Label 2055: @108642
     /* 108642 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108698), // Rule ID 230 //
     /* 108647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108650 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108672 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108696 */   GIR_RootConstrainSelectedInstOperands,
     /* 108697 */   // GIR_Coverage, 230,
     /* 108697 */   GIR_EraseRootFromParent_Done,
     /* 108698 */ // Label 2056: @108698
     /* 108698 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(108754), // Rule ID 231 //
     /* 108703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108706 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108728 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 108731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108748 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108752 */   GIR_RootConstrainSelectedInstOperands,
     /* 108753 */   // GIR_Coverage, 231,
     /* 108753 */   GIR_EraseRootFromParent_Done,
     /* 108754 */ // Label 2057: @108754
     /* 108754 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(108810), // Rule ID 232 //
     /* 108759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108784 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 108787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108808 */   GIR_RootConstrainSelectedInstOperands,
     /* 108809 */   // GIR_Coverage, 232,
     /* 108809 */   GIR_EraseRootFromParent_Done,
     /* 108810 */ // Label 2058: @108810
     /* 108810 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(108866), // Rule ID 4118 //
     /* 108815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108840 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108864 */   GIR_RootConstrainSelectedInstOperands,
     /* 108865 */   // GIR_Coverage, 4118,
     /* 108865 */   GIR_EraseRootFromParent_Done,
     /* 108866 */ // Label 2059: @108866
     /* 108866 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(108922), // Rule ID 4119 //
     /* 108871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108874 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108896 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108920 */   GIR_RootConstrainSelectedInstOperands,
     /* 108921 */   // GIR_Coverage, 4119,
     /* 108921 */   GIR_EraseRootFromParent_Done,
     /* 108922 */ // Label 2060: @108922
     /* 108922 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(108973), // Rule ID 266 //
     /* 108927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108952 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 108955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108971 */   GIR_RootConstrainSelectedInstOperands,
     /* 108972 */   // GIR_Coverage, 266,
     /* 108972 */   GIR_EraseRootFromParent_Done,
     /* 108973 */ // Label 2061: @108973
     /* 108973 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109024), // Rule ID 267 //
     /* 108978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109003 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109022 */   GIR_RootConstrainSelectedInstOperands,
     /* 109023 */   // GIR_Coverage, 267,
     /* 109023 */   GIR_EraseRootFromParent_Done,
     /* 109024 */ // Label 2062: @109024
     /* 109024 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109083), // Rule ID 6996 //
     /* 109029 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109039 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109057 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109081 */   GIR_RootConstrainSelectedInstOperands,
     /* 109082 */   // GIR_Coverage, 6996,
     /* 109082 */   GIR_EraseRootFromParent_Done,
     /* 109083 */ // Label 2063: @109083
     /* 109083 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109142), // Rule ID 6998 //
     /* 109088 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109091 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109098 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109105 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109109 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109116 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109140 */   GIR_RootConstrainSelectedInstOperands,
     /* 109141 */   // GIR_Coverage, 6998,
     /* 109141 */   GIR_EraseRootFromParent_Done,
     /* 109142 */ // Label 2064: @109142
     /* 109142 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109201), // Rule ID 7008 //
     /* 109147 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109150 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109157 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109164 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109168 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109175 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109199 */   GIR_RootConstrainSelectedInstOperands,
     /* 109200 */   // GIR_Coverage, 7008,
     /* 109200 */   GIR_EraseRootFromParent_Done,
     /* 109201 */ // Label 2065: @109201
     /* 109201 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109260), // Rule ID 7010 //
     /* 109206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109216 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109234 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109258 */   GIR_RootConstrainSelectedInstOperands,
     /* 109259 */   // GIR_Coverage, 7010,
     /* 109259 */   GIR_EraseRootFromParent_Done,
     /* 109260 */ // Label 2066: @109260
     /* 109260 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109311), // Rule ID 287 //
     /* 109265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109290 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109309 */   GIR_RootConstrainSelectedInstOperands,
     /* 109310 */   // GIR_Coverage, 287,
     /* 109310 */   GIR_EraseRootFromParent_Done,
     /* 109311 */ // Label 2067: @109311
     /* 109311 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109362), // Rule ID 288 //
     /* 109316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109319 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109341 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109360 */   GIR_RootConstrainSelectedInstOperands,
     /* 109361 */   // GIR_Coverage, 288,
     /* 109361 */   GIR_EraseRootFromParent_Done,
     /* 109362 */ // Label 2068: @109362
     /* 109362 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(109413), // Rule ID 4137 //
     /* 109367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109370 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109392 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109411 */   GIR_RootConstrainSelectedInstOperands,
     /* 109412 */   // GIR_Coverage, 4137,
     /* 109412 */   GIR_EraseRootFromParent_Done,
     /* 109413 */ // Label 2069: @109413
     /* 109413 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(109464), // Rule ID 4169 //
     /* 109418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109443 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109462 */   GIR_RootConstrainSelectedInstOperands,
     /* 109463 */   // GIR_Coverage, 4169,
     /* 109463 */   GIR_EraseRootFromParent_Done,
     /* 109464 */ // Label 2070: @109464
     /* 109464 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(109515), // Rule ID 4170 //
     /* 109469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109483 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109487 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109494 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109513 */   GIR_RootConstrainSelectedInstOperands,
     /* 109514 */   // GIR_Coverage, 4170,
     /* 109514 */   GIR_EraseRootFromParent_Done,
     /* 109515 */ // Label 2071: @109515
     /* 109515 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(109566), // Rule ID 4171 //
     /* 109520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109545 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109564 */   GIR_RootConstrainSelectedInstOperands,
     /* 109565 */   // GIR_Coverage, 4171,
     /* 109565 */   GIR_EraseRootFromParent_Done,
     /* 109566 */ // Label 2072: @109566
     /* 109566 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109620), // Rule ID 7000 //
     /* 109571 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109574 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109581 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109599 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15809>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109618 */   GIR_RootConstrainSelectedInstOperands,
     /* 109619 */   // GIR_Coverage, 7000,
     /* 109619 */   GIR_EraseRootFromParent_Done,
     /* 109620 */ // Label 2073: @109620
     /* 109620 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109674), // Rule ID 7002 //
     /* 109625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109635 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109653 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15809>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109672 */   GIR_RootConstrainSelectedInstOperands,
     /* 109673 */   // GIR_Coverage, 7002,
     /* 109673 */   GIR_EraseRootFromParent_Done,
     /* 109674 */ // Label 2074: @109674
     /* 109674 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109728), // Rule ID 7012 //
     /* 109679 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109682 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109689 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109707 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15818>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109726 */   GIR_RootConstrainSelectedInstOperands,
     /* 109727 */   // GIR_Coverage, 7012,
     /* 109727 */   GIR_EraseRootFromParent_Done,
     /* 109728 */ // Label 2075: @109728
     /* 109728 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(109782), // Rule ID 7014 //
     /* 109733 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109736 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109743 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109750 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109754 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109761 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15818>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109780 */   GIR_RootConstrainSelectedInstOperands,
     /* 109781 */   // GIR_Coverage, 7014,
     /* 109781 */   GIR_EraseRootFromParent_Done,
     /* 109782 */ // Label 2076: @109782
     /* 109782 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109839), // Rule ID 7376 //
     /* 109787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109790 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109818 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15807>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 109821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109837 */   GIR_RootConstrainSelectedInstOperands,
     /* 109838 */   // GIR_Coverage, 7376,
     /* 109838 */   GIR_EraseRootFromParent_Done,
     /* 109839 */ // Label 2077: @109839
     /* 109839 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109896), // Rule ID 7378 //
     /* 109844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109847 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109850 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109864 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109868 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109875 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15816>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 109878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109894 */   GIR_RootConstrainSelectedInstOperands,
     /* 109895 */   // GIR_Coverage, 7378,
     /* 109895 */   GIR_EraseRootFromParent_Done,
     /* 109896 */ // Label 2078: @109896
     /* 109896 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(109933), // Rule ID 6992 //
     /* 109901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109918 */   // MIs[0] ptr
     /* 109918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109926 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15805>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109931 */   GIR_RootConstrainSelectedInstOperands,
     /* 109932 */   // GIR_Coverage, 6992,
     /* 109932 */   GIR_Done,
     /* 109933 */ // Label 2079: @109933
     /* 109933 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(109970), // Rule ID 6994 //
     /* 109938 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109955 */   // MIs[0] ptr
     /* 109955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109963 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15807>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109968 */   GIR_RootConstrainSelectedInstOperands,
     /* 109969 */   // GIR_Coverage, 6994,
     /* 109969 */   GIR_Done,
     /* 109970 */ // Label 2080: @109970
     /* 109970 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110007), // Rule ID 7004 //
     /* 109975 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109992 */   // MIs[0] ptr
     /* 109992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110000 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15814>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110005 */   GIR_RootConstrainSelectedInstOperands,
     /* 110006 */   // GIR_Coverage, 7004,
     /* 110006 */   GIR_Done,
     /* 110007 */ // Label 2081: @110007
     /* 110007 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110044), // Rule ID 7006 //
     /* 110012 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110029 */   // MIs[0] ptr
     /* 110029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110037 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15816>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110042 */   GIR_RootConstrainSelectedInstOperands,
     /* 110043 */   // GIR_Coverage, 7006,
     /* 110043 */   GIR_Done,
     /* 110044 */ // Label 2082: @110044
     /* 110044 */ GIM_Reject,
     /* 110045 */ // Label 2053: @110045
     /* 110045 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(111534),
     /* 110050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110053 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110138), // Rule ID 4096 //
     /* 110058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110080 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110107 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110137 */     // GIR_Coverage, 4096,
     /* 110137 */     GIR_EraseRootFromParent_Done,
     /* 110138 */   // Label 2084: @110138
     /* 110138 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110223), // Rule ID 4097 //
     /* 110143 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110165 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110222 */     // GIR_Coverage, 4097,
     /* 110222 */     GIR_EraseRootFromParent_Done,
     /* 110223 */   // Label 2085: @110223
     /* 110223 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110308), // Rule ID 4098 //
     /* 110228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110250 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110277 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110307 */     // GIR_Coverage, 4098,
     /* 110307 */     GIR_EraseRootFromParent_Done,
     /* 110308 */   // Label 2086: @110308
     /* 110308 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110393), // Rule ID 4099 //
     /* 110313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110335 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110362 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110392 */     // GIR_Coverage, 4099,
     /* 110392 */     GIR_EraseRootFromParent_Done,
     /* 110393 */   // Label 2087: @110393
     /* 110393 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110478), // Rule ID 4100 //
     /* 110398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110420 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 110427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110477 */     // GIR_Coverage, 4100,
     /* 110477 */     GIR_EraseRootFromParent_Done,
     /* 110478 */   // Label 2088: @110478
     /* 110478 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110563), // Rule ID 4101 //
     /* 110483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110505 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 110512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110562 */     // GIR_Coverage, 4101,
     /* 110562 */     GIR_EraseRootFromParent_Done,
     /* 110563 */   // Label 2089: @110563
     /* 110563 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110648), // Rule ID 4102 //
     /* 110568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110590 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110647 */     // GIR_Coverage, 4102,
     /* 110647 */     GIR_EraseRootFromParent_Done,
     /* 110648 */   // Label 2090: @110648
     /* 110648 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110733), // Rule ID 4103 //
     /* 110653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110675 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110732 */     // GIR_Coverage, 4103,
     /* 110732 */     GIR_EraseRootFromParent_Done,
     /* 110733 */   // Label 2091: @110733
     /* 110733 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110813), // Rule ID 4135 //
     /* 110738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110760 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110782 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110812 */     // GIR_Coverage, 4135,
     /* 110812 */     GIR_EraseRootFromParent_Done,
     /* 110813 */   // Label 2092: @110813
     /* 110813 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110893), // Rule ID 4136 //
     /* 110818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110840 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110862 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110892 */     // GIR_Coverage, 4136,
     /* 110892 */     GIR_EraseRootFromParent_Done,
     /* 110893 */   // Label 2093: @110893
     /* 110893 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110973), // Rule ID 4138 //
     /* 110898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110920 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110972 */     // GIR_Coverage, 4138,
     /* 110972 */     GIR_EraseRootFromParent_Done,
     /* 110973 */   // Label 2094: @110973
     /* 110973 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111053), // Rule ID 4146 //
     /* 110978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111000 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111022 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111052 */     // GIR_Coverage, 4146,
     /* 111052 */     GIR_EraseRootFromParent_Done,
     /* 111053 */   // Label 2095: @111053
     /* 111053 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111133), // Rule ID 4172 //
     /* 111058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 111080 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 111087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111102 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111132 */     // GIR_Coverage, 4172,
     /* 111132 */     GIR_EraseRootFromParent_Done,
     /* 111133 */   // Label 2096: @111133
     /* 111133 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111213), // Rule ID 4173 //
     /* 111138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111160 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111182 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111212 */     // GIR_Coverage, 4173,
     /* 111212 */     GIR_EraseRootFromParent_Done,
     /* 111213 */   // Label 2097: @111213
     /* 111213 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111293), // Rule ID 4174 //
     /* 111218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111240 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111292 */     // GIR_Coverage, 4174,
     /* 111292 */     GIR_EraseRootFromParent_Done,
     /* 111293 */   // Label 2098: @111293
     /* 111293 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111373), // Rule ID 4175 //
     /* 111298 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111320 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111342 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111372 */     // GIR_Coverage, 4175,
     /* 111372 */     GIR_EraseRootFromParent_Done,
     /* 111373 */   // Label 2099: @111373
     /* 111373 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111453), // Rule ID 4176 //
     /* 111378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111400 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111422 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111452 */     // GIR_Coverage, 4176,
     /* 111452 */     GIR_EraseRootFromParent_Done,
     /* 111453 */   // Label 2100: @111453
     /* 111453 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111533), // Rule ID 4177 //
     /* 111458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111480 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111532 */     // GIR_Coverage, 4177,
     /* 111532 */     GIR_EraseRootFromParent_Done,
     /* 111533 */   // Label 2101: @111533
     /* 111533 */   GIM_Reject,
     /* 111534 */ // Label 2083: @111534
     /* 111534 */ GIM_Reject,
     /* 111535 */ // Label 2054: @111535
     /* 111535 */ GIM_Reject,
     /* 111536 */ // Label 19: @111536
     /* 111536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2122*/ GIMT_Encode4(125061),
     /* 111547 */ /*GILLT_s8*//*Label 2102*/ GIMT_Encode4(111643),
     /* 111551 */ /*GILLT_s16*//*Label 2103*/ GIMT_Encode4(112010),
     /* 111555 */ /*GILLT_s32*//*Label 2104*/ GIMT_Encode4(113149),
     /* 111559 */ /*GILLT_s64*//*Label 2105*/ GIMT_Encode4(117744),
     /* 111563 */ /*GILLT_s128*//*Label 2106*/ GIMT_Encode4(121513),
     /* 111567 */ /*GILLT_v2s32*//*Label 2107*/ GIMT_Encode4(121719),
     /* 111571 */ /*GILLT_v2s64*//*Label 2108*/ GIMT_Encode4(122125),
     /* 111575 */ /*GILLT_v4s16*//*Label 2109*/ GIMT_Encode4(122575),
     /* 111579 */ /*GILLT_v4s32*//*Label 2110*/ GIMT_Encode4(122981),
     /* 111583 */ /*GILLT_v8s8*//*Label 2111*/ GIMT_Encode4(123387),
     /* 111587 */ /*GILLT_v8s16*//*Label 2112*/ GIMT_Encode4(123607),
     /* 111591 */ /*GILLT_v16s8*//*Label 2113*/ GIMT_Encode4(124013), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111603 */ /*GILLT_nxv2s16*//*Label 2114*/ GIMT_Encode4(124233),
     /* 111607 */ /*GILLT_nxv2s32*//*Label 2115*/ GIMT_Encode4(124293),
     /* 111611 */ /*GILLT_nxv2s64*//*Label 2116*/ GIMT_Encode4(124353), GIMT_Encode4(0),
     /* 111619 */ /*GILLT_nxv4s16*//*Label 2117*/ GIMT_Encode4(124523),
     /* 111623 */ /*GILLT_nxv4s32*//*Label 2118*/ GIMT_Encode4(124583), GIMT_Encode4(0),
     /* 111631 */ /*GILLT_nxv8s16*//*Label 2119*/ GIMT_Encode4(124753),
     /* 111635 */ /*GILLT_nxv16s1*//*Label 2120*/ GIMT_Encode4(124923),
     /* 111639 */ /*GILLT_nxv16s8*//*Label 2121*/ GIMT_Encode4(124967),
     /* 111643 */ // Label 2102: @111643
     /* 111643 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112009),
     /* 111648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111655 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111723), // Rule ID 13117 //
     /* 111660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111693 */     // MIs[2] Operand 1
     /* 111693 */     // No operand predicates
     /* 111693 */     // MIs[0] Rn
     /* 111693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111703 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111721 */     GIR_RootConstrainSelectedInstOperands,
     /* 111722 */     // GIR_Coverage, 13117,
     /* 111722 */     GIR_EraseRootFromParent_Done,
     /* 111723 */   // Label 2124: @111723
     /* 111723 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111822), // Rule ID 13118 //
     /* 111728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111757 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111761 */     // MIs[2] Operand 1
     /* 111761 */     // No operand predicates
     /* 111761 */     // MIs[0] Rn
     /* 111761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111771 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111820 */     GIR_RootConstrainSelectedInstOperands,
     /* 111821 */     // GIR_Coverage, 13118,
     /* 111821 */     GIR_EraseRootFromParent_Done,
     /* 111822 */   // Label 2125: @111822
     /* 111822 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111871), // Rule ID 303 //
     /* 111827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111845 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 111848 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111869 */     GIR_RootConstrainSelectedInstOperands,
     /* 111870 */     // GIR_Coverage, 303,
     /* 111870 */     GIR_EraseRootFromParent_Done,
     /* 111871 */   // Label 2126: @111871
     /* 111871 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111920), // Rule ID 304 //
     /* 111876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111894 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 111897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111918 */     GIR_RootConstrainSelectedInstOperands,
     /* 111919 */     // GIR_Coverage, 304,
     /* 111919 */     GIR_EraseRootFromParent_Done,
     /* 111920 */   // Label 2127: @111920
     /* 111920 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111964), // Rule ID 313 //
     /* 111925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111943 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 111943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 111946 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111962 */     GIR_RootConstrainSelectedInstOperands,
     /* 111963 */     // GIR_Coverage, 313,
     /* 111963 */     GIR_EraseRootFromParent_Done,
     /* 111964 */   // Label 2128: @111964
     /* 111964 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112008), // Rule ID 321 //
     /* 111969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111987 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 111987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 111990 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112006 */     GIR_RootConstrainSelectedInstOperands,
     /* 112007 */     // GIR_Coverage, 321,
     /* 112007 */     GIR_EraseRootFromParent_Done,
     /* 112008 */   // Label 2129: @112008
     /* 112008 */   GIM_Reject,
     /* 112009 */ // Label 2123: @112009
     /* 112009 */ GIM_Reject,
     /* 112010 */ // Label 2103: @112010
     /* 112010 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(113148),
     /* 112015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112022 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112121), // Rule ID 4474 //
     /* 112027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112065 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112119 */     GIR_RootConstrainSelectedInstOperands,
     /* 112120 */     // GIR_Coverage, 4474,
     /* 112120 */     GIR_EraseRootFromParent_Done,
     /* 112121 */   // Label 2131: @112121
     /* 112121 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112220), // Rule ID 4475 //
     /* 112126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112164 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112176 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112218 */     GIR_RootConstrainSelectedInstOperands,
     /* 112219 */     // GIR_Coverage, 4475,
     /* 112219 */     GIR_EraseRootFromParent_Done,
     /* 112220 */   // Label 2132: @112220
     /* 112220 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112319), // Rule ID 13115 //
     /* 112225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112263 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112317 */     GIR_RootConstrainSelectedInstOperands,
     /* 112318 */     // GIR_Coverage, 13115,
     /* 112318 */     GIR_EraseRootFromParent_Done,
     /* 112319 */   // Label 2133: @112319
     /* 112319 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112418), // Rule ID 13116 //
     /* 112324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112345 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112362 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112416 */     GIR_RootConstrainSelectedInstOperands,
     /* 112417 */     // GIR_Coverage, 13116,
     /* 112417 */     GIR_EraseRootFromParent_Done,
     /* 112418 */   // Label 2134: @112418
     /* 112418 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112512), // Rule ID 4503 //
     /* 112423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112444 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112461 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112473 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112510 */     GIR_RootConstrainSelectedInstOperands,
     /* 112511 */     // GIR_Coverage, 4503,
     /* 112511 */     GIR_EraseRootFromParent_Done,
     /* 112512 */   // Label 2135: @112512
     /* 112512 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112606), // Rule ID 4528 //
     /* 112517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 112555 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112567 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112604 */     GIR_RootConstrainSelectedInstOperands,
     /* 112605 */     // GIR_Coverage, 4528,
     /* 112605 */     GIR_EraseRootFromParent_Done,
     /* 112606 */   // Label 2136: @112606
     /* 112606 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112700), // Rule ID 13114 //
     /* 112611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112649 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112698 */     GIR_RootConstrainSelectedInstOperands,
     /* 112699 */     // GIR_Coverage, 13114,
     /* 112699 */     GIR_EraseRootFromParent_Done,
     /* 112700 */   // Label 2137: @112700
     /* 112700 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112794), // Rule ID 13120 //
     /* 112705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112726 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 112743 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112755 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112792 */     GIR_RootConstrainSelectedInstOperands,
     /* 112793 */     // GIR_Coverage, 13120,
     /* 112793 */     GIR_EraseRootFromParent_Done,
     /* 112794 */   // Label 2138: @112794
     /* 112794 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112862), // Rule ID 6430 //
     /* 112799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112832 */     // MIs[2] Operand 1
     /* 112832 */     // No operand predicates
     /* 112832 */     // MIs[0] Rn
     /* 112832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112842 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112860 */     GIR_RootConstrainSelectedInstOperands,
     /* 112861 */     // GIR_Coverage, 6430,
     /* 112861 */     GIR_EraseRootFromParent_Done,
     /* 112862 */   // Label 2139: @112862
     /* 112862 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112961), // Rule ID 6435 //
     /* 112867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112900 */     // MIs[2] Operand 1
     /* 112900 */     // No operand predicates
     /* 112900 */     // MIs[0] Rn
     /* 112900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112910 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112922 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112929 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112959 */     GIR_RootConstrainSelectedInstOperands,
     /* 112960 */     // GIR_Coverage, 6435,
     /* 112960 */     GIR_EraseRootFromParent_Done,
     /* 112961 */   // Label 2140: @112961
     /* 112961 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113010), // Rule ID 305 //
     /* 112966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112984 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112987 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113008 */     GIR_RootConstrainSelectedInstOperands,
     /* 113009 */     // GIR_Coverage, 305,
     /* 113009 */     GIR_EraseRootFromParent_Done,
     /* 113010 */   // Label 2141: @113010
     /* 113010 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113059), // Rule ID 306 //
     /* 113015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113033 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113036 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113057 */     GIR_RootConstrainSelectedInstOperands,
     /* 113058 */     // GIR_Coverage, 306,
     /* 113058 */     GIR_EraseRootFromParent_Done,
     /* 113059 */   // Label 2142: @113059
     /* 113059 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113103), // Rule ID 314 //
     /* 113064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113082 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113085 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113101 */     GIR_RootConstrainSelectedInstOperands,
     /* 113102 */     // GIR_Coverage, 314,
     /* 113102 */     GIR_EraseRootFromParent_Done,
     /* 113103 */   // Label 2143: @113103
     /* 113103 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113147), // Rule ID 322 //
     /* 113108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113126 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113129 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113145 */     GIR_RootConstrainSelectedInstOperands,
     /* 113146 */     // GIR_Coverage, 322,
     /* 113146 */     GIR_EraseRootFromParent_Done,
     /* 113147 */   // Label 2144: @113147
     /* 113147 */   GIM_Reject,
     /* 113148 */ // Label 2130: @113148
     /* 113148 */ GIM_Reject,
     /* 113149 */ // Label 2104: @113149
     /* 113149 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113262), // Rule ID 4472 //
     /* 113154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113180 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113184 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113189 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113199 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113206 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113218 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113224 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113229 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113260 */   GIR_RootConstrainSelectedInstOperands,
     /* 113261 */   // GIR_Coverage, 4472,
     /* 113261 */   GIR_EraseRootFromParent_Done,
     /* 113262 */ // Label 2145: @113262
     /* 113262 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113375), // Rule ID 4473 //
     /* 113267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113270 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113289 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113293 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113302 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113319 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113331 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113373 */   GIR_RootConstrainSelectedInstOperands,
     /* 113374 */   // GIR_Coverage, 4473,
     /* 113374 */   GIR_EraseRootFromParent_Done,
     /* 113375 */ // Label 2146: @113375
     /* 113375 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113481), // Rule ID 4476 //
     /* 113380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113395 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113399 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113408 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113412 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113425 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113437 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113448 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113479 */   GIR_RootConstrainSelectedInstOperands,
     /* 113480 */   // GIR_Coverage, 4476,
     /* 113480 */   GIR_EraseRootFromParent_Done,
     /* 113481 */ // Label 2147: @113481
     /* 113481 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113587), // Rule ID 4477 //
     /* 113486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113489 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113501 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113505 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113514 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113524 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113531 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113543 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113585 */   GIR_RootConstrainSelectedInstOperands,
     /* 113586 */   // GIR_Coverage, 4477,
     /* 113586 */   GIR_EraseRootFromParent_Done,
     /* 113587 */ // Label 2148: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113693), // Rule ID 4478 //
     /* 113592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113595 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113607 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113611 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113615 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113620 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113637 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113649 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113691 */   GIR_RootConstrainSelectedInstOperands,
     /* 113692 */   // GIR_Coverage, 4478,
     /* 113692 */   GIR_EraseRootFromParent_Done,
     /* 113693 */ // Label 2149: @113693
     /* 113693 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113799), // Rule ID 4479 //
     /* 113698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113701 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113705 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113709 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113713 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113717 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113721 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113726 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113734 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113743 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113755 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113797 */   GIR_RootConstrainSelectedInstOperands,
     /* 113798 */   // GIR_Coverage, 4479,
     /* 113798 */   GIR_EraseRootFromParent_Done,
     /* 113799 */ // Label 2150: @113799
     /* 113799 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113905), // Rule ID 13122 //
     /* 113804 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113811 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113819 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113823 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113832 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113849 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113861 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113903 */   GIR_RootConstrainSelectedInstOperands,
     /* 113904 */   // GIR_Coverage, 13122,
     /* 113904 */   GIR_EraseRootFromParent_Done,
     /* 113905 */ // Label 2151: @113905
     /* 113905 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114011), // Rule ID 13123 //
     /* 113910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113938 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113948 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113955 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113967 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114009 */   GIR_RootConstrainSelectedInstOperands,
     /* 114010 */   // GIR_Coverage, 13123,
     /* 114010 */   GIR_EraseRootFromParent_Done,
     /* 114011 */ // Label 2152: @114011
     /* 114011 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114119), // Rule ID 4502 //
     /* 114016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114051 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114068 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114080 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114091 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114117 */   GIR_RootConstrainSelectedInstOperands,
     /* 114118 */   // GIR_Coverage, 4502,
     /* 114118 */   GIR_EraseRootFromParent_Done,
     /* 114119 */ // Label 2153: @114119
     /* 114119 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114220), // Rule ID 4504 //
     /* 114124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114139 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114147 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114152 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114169 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114181 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114218 */   GIR_RootConstrainSelectedInstOperands,
     /* 114219 */   // GIR_Coverage, 4504,
     /* 114219 */   GIR_EraseRootFromParent_Done,
     /* 114220 */ // Label 2154: @114220
     /* 114220 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114321), // Rule ID 4505 //
     /* 114225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114248 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114253 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114270 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114282 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114314 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114319 */   GIR_RootConstrainSelectedInstOperands,
     /* 114320 */   // GIR_Coverage, 4505,
     /* 114320 */   GIR_EraseRootFromParent_Done,
     /* 114321 */ // Label 2155: @114321
     /* 114321 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114429), // Rule ID 4527 //
     /* 114326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114329 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114348 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114352 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114361 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114378 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114390 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114427 */   GIR_RootConstrainSelectedInstOperands,
     /* 114428 */   // GIR_Coverage, 4527,
     /* 114428 */   GIR_EraseRootFromParent_Done,
     /* 114429 */ // Label 2156: @114429
     /* 114429 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114530), // Rule ID 4529 //
     /* 114434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114462 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114479 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114491 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114528 */   GIR_RootConstrainSelectedInstOperands,
     /* 114529 */   // GIR_Coverage, 4529,
     /* 114529 */   GIR_EraseRootFromParent_Done,
     /* 114530 */ // Label 2157: @114530
     /* 114530 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114631), // Rule ID 4530 //
     /* 114535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114550 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114563 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114580 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114592 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114629 */   GIR_RootConstrainSelectedInstOperands,
     /* 114630 */   // GIR_Coverage, 4530,
     /* 114630 */   GIR_EraseRootFromParent_Done,
     /* 114631 */ // Label 2158: @114631
     /* 114631 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114732), // Rule ID 13119 //
     /* 114636 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114639 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114651 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114655 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114664 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114681 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114693 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114730 */   GIR_RootConstrainSelectedInstOperands,
     /* 114731 */   // GIR_Coverage, 13119,
     /* 114731 */   GIR_EraseRootFromParent_Done,
     /* 114732 */ // Label 2159: @114732
     /* 114732 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114833), // Rule ID 13121 //
     /* 114737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114760 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114765 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 114782 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114794 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114800 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114805 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114831 */   GIR_RootConstrainSelectedInstOperands,
     /* 114832 */   // GIR_Coverage, 13121,
     /* 114832 */   GIR_EraseRootFromParent_Done,
     /* 114833 */ // Label 2160: @114833
     /* 114833 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114915), // Rule ID 6424 //
     /* 114838 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114841 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114873 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114877 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114881 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 114885 */   // MIs[2] Operand 1
     /* 114885 */   // No operand predicates
     /* 114885 */   // MIs[0] Rn
     /* 114885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114893 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114895 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 114898 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114902 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114905 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114913 */   GIR_RootConstrainSelectedInstOperands,
     /* 114914 */   // GIR_Coverage, 6424,
     /* 114914 */   GIR_EraseRootFromParent_Done,
     /* 114915 */ // Label 2161: @114915
     /* 114915 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114997), // Rule ID 6425 //
     /* 114920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114923 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114927 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114955 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114959 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114963 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 114967 */   // MIs[2] Operand 1
     /* 114967 */   // No operand predicates
     /* 114967 */   // MIs[0] Rn
     /* 114967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114975 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114977 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 114980 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114984 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114995 */   GIR_RootConstrainSelectedInstOperands,
     /* 114996 */   // GIR_Coverage, 6425,
     /* 114996 */   GIR_EraseRootFromParent_Done,
     /* 114997 */ // Label 2162: @114997
     /* 114997 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115072), // Rule ID 6426 //
     /* 115002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115005 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115025 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115030 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115034 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115038 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115042 */   // MIs[2] Operand 1
     /* 115042 */   // No operand predicates
     /* 115042 */   // MIs[0] Rn
     /* 115042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115050 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115052 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115059 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115062 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115070 */   GIR_RootConstrainSelectedInstOperands,
     /* 115071 */   // GIR_Coverage, 6426,
     /* 115071 */   GIR_EraseRootFromParent_Done,
     /* 115072 */ // Label 2163: @115072
     /* 115072 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115147), // Rule ID 6427 //
     /* 115077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115092 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115096 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115100 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115105 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115109 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115113 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115117 */   // MIs[2] Operand 1
     /* 115117 */   // No operand predicates
     /* 115117 */   // MIs[0] Rn
     /* 115117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115125 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115127 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115130 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115134 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115137 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115145 */   GIR_RootConstrainSelectedInstOperands,
     /* 115146 */   // GIR_Coverage, 6427,
     /* 115146 */   GIR_EraseRootFromParent_Done,
     /* 115147 */ // Label 2164: @115147
     /* 115147 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115260), // Rule ID 6431 //
     /* 115152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115174 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 115178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115182 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115187 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115191 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115195 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115199 */   // MIs[2] Operand 1
     /* 115199 */   // No operand predicates
     /* 115199 */   // MIs[0] Rn
     /* 115199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115207 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115209 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115221 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115247 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115258 */   GIR_RootConstrainSelectedInstOperands,
     /* 115259 */   // GIR_Coverage, 6431,
     /* 115259 */   GIR_EraseRootFromParent_Done,
     /* 115260 */ // Label 2165: @115260
     /* 115260 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115373), // Rule ID 6432 //
     /* 115265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115268 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115272 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115287 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115291 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115295 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115300 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115304 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115308 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115312 */   // MIs[2] Operand 1
     /* 115312 */   // No operand predicates
     /* 115312 */   // MIs[0] Rn
     /* 115312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115320 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115322 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115334 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115337 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115341 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115360 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115371 */   GIR_RootConstrainSelectedInstOperands,
     /* 115372 */   // GIR_Coverage, 6432,
     /* 115372 */   GIR_EraseRootFromParent_Done,
     /* 115373 */ // Label 2166: @115373
     /* 115373 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115479), // Rule ID 6433 //
     /* 115378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115393 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115397 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115401 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115406 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115410 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115414 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115418 */   // MIs[2] Operand 1
     /* 115418 */   // No operand predicates
     /* 115418 */   // MIs[0] Rn
     /* 115418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115426 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115428 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115440 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115443 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115447 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115466 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115469 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115477 */   GIR_RootConstrainSelectedInstOperands,
     /* 115478 */   // GIR_Coverage, 6433,
     /* 115478 */   GIR_EraseRootFromParent_Done,
     /* 115479 */ // Label 2167: @115479
     /* 115479 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(115585), // Rule ID 6434 //
     /* 115484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115503 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115507 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115512 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115516 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115520 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115524 */   // MIs[2] Operand 1
     /* 115524 */   // No operand predicates
     /* 115524 */   // MIs[0] Rn
     /* 115524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115532 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115534 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115546 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115553 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115572 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115583 */   GIR_RootConstrainSelectedInstOperands,
     /* 115584 */   // GIR_Coverage, 6434,
     /* 115584 */   GIR_EraseRootFromParent_Done,
     /* 115585 */ // Label 2168: @115585
     /* 115585 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(115645), // Rule ID 295 //
     /* 115590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115593 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115597 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115619 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115622 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115643 */   GIR_RootConstrainSelectedInstOperands,
     /* 115644 */   // GIR_Coverage, 295,
     /* 115644 */   GIR_EraseRootFromParent_Done,
     /* 115645 */ // Label 2169: @115645
     /* 115645 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(115705), // Rule ID 296 //
     /* 115650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115653 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115679 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115682 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115703 */   GIR_RootConstrainSelectedInstOperands,
     /* 115704 */   // GIR_Coverage, 296,
     /* 115704 */   GIR_EraseRootFromParent_Done,
     /* 115705 */ // Label 2170: @115705
     /* 115705 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(115765), // Rule ID 297 //
     /* 115710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115713 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115739 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115742 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115763 */   GIR_RootConstrainSelectedInstOperands,
     /* 115764 */   // GIR_Coverage, 297,
     /* 115764 */   GIR_EraseRootFromParent_Done,
     /* 115765 */ // Label 2171: @115765
     /* 115765 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(115825), // Rule ID 298 //
     /* 115770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115773 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115777 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115792 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115799 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115802 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115823 */   GIR_RootConstrainSelectedInstOperands,
     /* 115824 */   // GIR_Coverage, 298,
     /* 115824 */   GIR_EraseRootFromParent_Done,
     /* 115825 */ // Label 2172: @115825
     /* 115825 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(115878), // Rule ID 299 //
     /* 115830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115852 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115855 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115876 */   GIR_RootConstrainSelectedInstOperands,
     /* 115877 */   // GIR_Coverage, 299,
     /* 115877 */   GIR_EraseRootFromParent_Done,
     /* 115878 */ // Label 2173: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(115931), // Rule ID 300 //
     /* 115883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115905 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115908 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115929 */   GIR_RootConstrainSelectedInstOperands,
     /* 115930 */   // GIR_Coverage, 300,
     /* 115930 */   GIR_EraseRootFromParent_Done,
     /* 115931 */ // Label 2174: @115931
     /* 115931 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(115987), // Rule ID 307 //
     /* 115936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115961 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 115964 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115985 */   GIR_RootConstrainSelectedInstOperands,
     /* 115986 */   // GIR_Coverage, 307,
     /* 115986 */   GIR_EraseRootFromParent_Done,
     /* 115987 */ // Label 2175: @115987
     /* 115987 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116043), // Rule ID 308 //
     /* 115992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116017 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116020 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116041 */   GIR_RootConstrainSelectedInstOperands,
     /* 116042 */   // GIR_Coverage, 308,
     /* 116042 */   GIR_EraseRootFromParent_Done,
     /* 116043 */ // Label 2176: @116043
     /* 116043 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116095), // Rule ID 312 //
     /* 116048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116070 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116073 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116093 */   GIR_RootConstrainSelectedInstOperands,
     /* 116094 */   // GIR_Coverage, 312,
     /* 116094 */   GIR_EraseRootFromParent_Done,
     /* 116095 */ // Label 2177: @116095
     /* 116095 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116146), // Rule ID 315 //
     /* 116100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116118 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116125 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116128 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116144 */   GIR_RootConstrainSelectedInstOperands,
     /* 116145 */   // GIR_Coverage, 315,
     /* 116145 */   GIR_EraseRootFromParent_Done,
     /* 116146 */ // Label 2178: @116146
     /* 116146 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116205), // Rule ID 317 //
     /* 116151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116154 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116180 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116183 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116203 */   GIR_RootConstrainSelectedInstOperands,
     /* 116204 */   // GIR_Coverage, 317,
     /* 116204 */   GIR_EraseRootFromParent_Done,
     /* 116205 */ // Label 2179: @116205
     /* 116205 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116264), // Rule ID 318 //
     /* 116210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116213 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116239 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116242 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116262 */   GIR_RootConstrainSelectedInstOperands,
     /* 116263 */   // GIR_Coverage, 318,
     /* 116263 */   GIR_EraseRootFromParent_Done,
     /* 116264 */ // Label 2180: @116264
     /* 116264 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116341), // Rule ID 7055 //
     /* 116269 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116272 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116279 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116290 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116294 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116312 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116315 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116339 */   GIR_RootConstrainSelectedInstOperands,
     /* 116340 */   // GIR_Coverage, 7055,
     /* 116340 */   GIR_EraseRootFromParent_Done,
     /* 116341 */ // Label 2181: @116341
     /* 116341 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(116418), // Rule ID 7056 //
     /* 116346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116356 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116371 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116389 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116392 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116416 */   GIR_RootConstrainSelectedInstOperands,
     /* 116417 */   // GIR_Coverage, 7056,
     /* 116417 */   GIR_EraseRootFromParent_Done,
     /* 116418 */ // Label 2182: @116418
     /* 116418 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(116477), // Rule ID 7036 //
     /* 116423 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116433 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116451 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15849>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116454 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116475 */   GIR_RootConstrainSelectedInstOperands,
     /* 116476 */   // GIR_Coverage, 7036,
     /* 116476 */   GIR_EraseRootFromParent_Done,
     /* 116477 */ // Label 2183: @116477
     /* 116477 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(116536), // Rule ID 7037 //
     /* 116482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116492 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116510 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15849>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116513 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116534 */   GIR_RootConstrainSelectedInstOperands,
     /* 116535 */   // GIR_Coverage, 7037,
     /* 116535 */   GIR_EraseRootFromParent_Done,
     /* 116536 */ // Label 2184: @116536
     /* 116536 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(116595), // Rule ID 7041 //
     /* 116541 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116551 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116562 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116569 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15856>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116572 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116593 */   GIR_RootConstrainSelectedInstOperands,
     /* 116594 */   // GIR_Coverage, 7041,
     /* 116594 */   GIR_EraseRootFromParent_Done,
     /* 116595 */ // Label 2185: @116595
     /* 116595 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(116654), // Rule ID 7042 //
     /* 116600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116610 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116628 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15856>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116631 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116652 */   GIR_RootConstrainSelectedInstOperands,
     /* 116653 */   // GIR_Coverage, 7042,
     /* 116653 */   GIR_EraseRootFromParent_Done,
     /* 116654 */ // Label 2186: @116654
     /* 116654 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(116713), // Rule ID 7046 //
     /* 116659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116669 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116687 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116690 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116711 */   GIR_RootConstrainSelectedInstOperands,
     /* 116712 */   // GIR_Coverage, 7046,
     /* 116712 */   GIR_EraseRootFromParent_Done,
     /* 116713 */ // Label 2187: @116713
     /* 116713 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(116772), // Rule ID 7047 //
     /* 116718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116728 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116746 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116749 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116770 */   GIR_RootConstrainSelectedInstOperands,
     /* 116771 */   // GIR_Coverage, 7047,
     /* 116771 */   GIR_EraseRootFromParent_Done,
     /* 116772 */ // Label 2188: @116772
     /* 116772 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(116844), // Rule ID 7057 //
     /* 116777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116798 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116820 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116823 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116842 */   GIR_RootConstrainSelectedInstOperands,
     /* 116843 */   // GIR_Coverage, 7057,
     /* 116843 */   GIR_EraseRootFromParent_Done,
     /* 116844 */ // Label 2189: @116844
     /* 116844 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(116916), // Rule ID 7058 //
     /* 116849 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116859 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116892 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116895 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116914 */   GIR_RootConstrainSelectedInstOperands,
     /* 116915 */   // GIR_Coverage, 7058,
     /* 116915 */   GIR_EraseRootFromParent_Done,
     /* 116916 */ // Label 2190: @116916
     /* 116916 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116968), // Rule ID 320 //
     /* 116921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116943 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 116946 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116966 */   GIR_RootConstrainSelectedInstOperands,
     /* 116967 */   // GIR_Coverage, 320,
     /* 116967 */   GIR_EraseRootFromParent_Done,
     /* 116968 */ // Label 2191: @116968
     /* 116968 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117019), // Rule ID 323 //
     /* 116973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116979 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116987 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116998 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117001 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117017 */   GIR_RootConstrainSelectedInstOperands,
     /* 117018 */   // GIR_Coverage, 323,
     /* 117018 */   GIR_EraseRootFromParent_Done,
     /* 117019 */ // Label 2192: @117019
     /* 117019 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117078), // Rule ID 326 //
     /* 117024 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117027 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117053 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117056 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117076 */   GIR_RootConstrainSelectedInstOperands,
     /* 117077 */   // GIR_Coverage, 326,
     /* 117077 */   GIR_EraseRootFromParent_Done,
     /* 117078 */ // Label 2193: @117078
     /* 117078 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117137), // Rule ID 327 //
     /* 117083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117112 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117115 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117135 */   GIR_RootConstrainSelectedInstOperands,
     /* 117136 */   // GIR_Coverage, 327,
     /* 117136 */   GIR_EraseRootFromParent_Done,
     /* 117137 */ // Label 2194: @117137
     /* 117137 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117191), // Rule ID 7038 //
     /* 117142 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117152 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117170 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15849>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117173 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117189 */   GIR_RootConstrainSelectedInstOperands,
     /* 117190 */   // GIR_Coverage, 7038,
     /* 117190 */   GIR_EraseRootFromParent_Done,
     /* 117191 */ // Label 2195: @117191
     /* 117191 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117245), // Rule ID 7039 //
     /* 117196 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117199 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117206 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117217 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117224 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15849>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117227 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117239 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117243 */   GIR_RootConstrainSelectedInstOperands,
     /* 117244 */   // GIR_Coverage, 7039,
     /* 117244 */   GIR_EraseRootFromParent_Done,
     /* 117245 */ // Label 2196: @117245
     /* 117245 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117299), // Rule ID 7043 //
     /* 117250 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117253 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117260 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117278 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15856>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117281 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117297 */   GIR_RootConstrainSelectedInstOperands,
     /* 117298 */   // GIR_Coverage, 7043,
     /* 117298 */   GIR_EraseRootFromParent_Done,
     /* 117299 */ // Label 2197: @117299
     /* 117299 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(117353), // Rule ID 7044 //
     /* 117304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117314 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117332 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15856>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117335 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117351 */   GIR_RootConstrainSelectedInstOperands,
     /* 117352 */   // GIR_Coverage, 7044,
     /* 117352 */   GIR_EraseRootFromParent_Done,
     /* 117353 */ // Label 2198: @117353
     /* 117353 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(117407), // Rule ID 7048 //
     /* 117358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117368 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117375 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117379 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117386 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117389 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117405 */   GIR_RootConstrainSelectedInstOperands,
     /* 117406 */   // GIR_Coverage, 7048,
     /* 117406 */   GIR_EraseRootFromParent_Done,
     /* 117407 */ // Label 2199: @117407
     /* 117407 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(117461), // Rule ID 7049 //
     /* 117412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117415 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117422 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117440 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15863>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117443 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117459 */   GIR_RootConstrainSelectedInstOperands,
     /* 117460 */   // GIR_Coverage, 7049,
     /* 117460 */   GIR_EraseRootFromParent_Done,
     /* 117461 */ // Label 2200: @117461
     /* 117461 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(117518), // Rule ID 7381 //
     /* 117466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117479 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117497 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15847>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 117500 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117516 */   GIR_RootConstrainSelectedInstOperands,
     /* 117517 */   // GIR_Coverage, 7381,
     /* 117517 */   GIR_EraseRootFromParent_Done,
     /* 117518 */ // Label 2201: @117518
     /* 117518 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(117575), // Rule ID 7382 //
     /* 117523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117526 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117554 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15854>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 117557 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117573 */   GIR_RootConstrainSelectedInstOperands,
     /* 117574 */   // GIR_Coverage, 7382,
     /* 117574 */   GIR_EraseRootFromParent_Done,
     /* 117575 */ // Label 2202: @117575
     /* 117575 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(117632), // Rule ID 7383 //
     /* 117580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117593 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117611 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15861>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 117614 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117630 */   GIR_RootConstrainSelectedInstOperands,
     /* 117631 */   // GIR_Coverage, 7383,
     /* 117631 */   GIR_EraseRootFromParent_Done,
     /* 117632 */ // Label 2203: @117632
     /* 117632 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(117669), // Rule ID 7035 //
     /* 117637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117654 */   // MIs[0] ptr
     /* 117654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117662 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15847>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 117667 */   GIR_RootConstrainSelectedInstOperands,
     /* 117668 */   // GIR_Coverage, 7035,
     /* 117668 */   GIR_Done,
     /* 117669 */ // Label 2204: @117669
     /* 117669 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117706), // Rule ID 7040 //
     /* 117674 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117684 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117691 */   // MIs[0] ptr
     /* 117691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117699 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15854>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 117704 */   GIR_RootConstrainSelectedInstOperands,
     /* 117705 */   // GIR_Coverage, 7040,
     /* 117705 */   GIR_Done,
     /* 117706 */ // Label 2205: @117706
     /* 117706 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117743), // Rule ID 7045 //
     /* 117711 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117714 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117728 */   // MIs[0] ptr
     /* 117728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117736 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15861>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 117741 */   GIR_RootConstrainSelectedInstOperands,
     /* 117742 */   // GIR_Coverage, 7045,
     /* 117742 */   GIR_Done,
     /* 117743 */ // Label 2206: @117743
     /* 117743 */ GIM_Reject,
     /* 117744 */ // Label 2105: @117744
     /* 117744 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117850), // Rule ID 4480 //
     /* 117749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117768 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117772 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117777 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117794 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117806 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117848 */   GIR_RootConstrainSelectedInstOperands,
     /* 117849 */   // GIR_Coverage, 4480,
     /* 117849 */   GIR_EraseRootFromParent_Done,
     /* 117850 */ // Label 2207: @117850
     /* 117850 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117956), // Rule ID 4481 //
     /* 117855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117878 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117883 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117900 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117912 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117954 */   GIR_RootConstrainSelectedInstOperands,
     /* 117955 */   // GIR_Coverage, 4481,
     /* 117955 */   GIR_EraseRootFromParent_Done,
     /* 117956 */ // Label 2208: @117956
     /* 117956 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118062), // Rule ID 4482 //
     /* 117961 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117964 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117980 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117989 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118006 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118018 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118060 */   GIR_RootConstrainSelectedInstOperands,
     /* 118061 */   // GIR_Coverage, 4482,
     /* 118061 */   GIR_EraseRootFromParent_Done,
     /* 118062 */ // Label 2209: @118062
     /* 118062 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118168), // Rule ID 4483 //
     /* 118067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118095 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118112 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118124 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118166 */   GIR_RootConstrainSelectedInstOperands,
     /* 118167 */   // GIR_Coverage, 4483,
     /* 118167 */   GIR_EraseRootFromParent_Done,
     /* 118168 */ // Label 2210: @118168
     /* 118168 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118269), // Rule ID 4506 //
     /* 118173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118180 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118188 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118192 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118201 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118218 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118230 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118267 */   GIR_RootConstrainSelectedInstOperands,
     /* 118268 */   // GIR_Coverage, 4506,
     /* 118268 */   GIR_EraseRootFromParent_Done,
     /* 118269 */ // Label 2211: @118269
     /* 118269 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118370), // Rule ID 4507 //
     /* 118274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118289 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118293 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118302 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118319 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118331 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118368 */   GIR_RootConstrainSelectedInstOperands,
     /* 118369 */   // GIR_Coverage, 4507,
     /* 118369 */   GIR_EraseRootFromParent_Done,
     /* 118370 */ // Label 2212: @118370
     /* 118370 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118471), // Rule ID 4531 //
     /* 118375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118403 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118420 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118432 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118469 */   GIR_RootConstrainSelectedInstOperands,
     /* 118470 */   // GIR_Coverage, 4531,
     /* 118470 */   GIR_EraseRootFromParent_Done,
     /* 118471 */ // Label 2213: @118471
     /* 118471 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(118572), // Rule ID 4532 //
     /* 118476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118499 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118504 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118521 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118533 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118570 */   GIR_RootConstrainSelectedInstOperands,
     /* 118571 */   // GIR_Coverage, 4532,
     /* 118571 */   GIR_EraseRootFromParent_Done,
     /* 118572 */ // Label 2214: @118572
     /* 118572 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(118647), // Rule ID 6428 //
     /* 118577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118596 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118605 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118609 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118613 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118617 */   // MIs[2] Operand 1
     /* 118617 */   // No operand predicates
     /* 118617 */   // MIs[0] Rn
     /* 118617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118625 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118627 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118634 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118637 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118645 */   GIR_RootConstrainSelectedInstOperands,
     /* 118646 */   // GIR_Coverage, 6428,
     /* 118646 */   GIR_EraseRootFromParent_Done,
     /* 118647 */ // Label 2215: @118647
     /* 118647 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(118722), // Rule ID 6429 //
     /* 118652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118667 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118671 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118675 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118680 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118684 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118688 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118692 */   // MIs[2] Operand 1
     /* 118692 */   // No operand predicates
     /* 118692 */   // MIs[0] Rn
     /* 118692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118700 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118702 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118705 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118709 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118712 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118720 */   GIR_RootConstrainSelectedInstOperands,
     /* 118721 */   // GIR_Coverage, 6429,
     /* 118721 */   GIR_EraseRootFromParent_Done,
     /* 118722 */ // Label 2216: @118722
     /* 118722 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(118775), // Rule ID 301 //
     /* 118727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118749 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 118752 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118773 */   GIR_RootConstrainSelectedInstOperands,
     /* 118774 */   // GIR_Coverage, 301,
     /* 118774 */   GIR_EraseRootFromParent_Done,
     /* 118775 */ // Label 2217: @118775
     /* 118775 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(118828), // Rule ID 302 //
     /* 118780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118802 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 118805 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118826 */   GIR_RootConstrainSelectedInstOperands,
     /* 118827 */   // GIR_Coverage, 302,
     /* 118827 */   GIR_EraseRootFromParent_Done,
     /* 118828 */ // Label 2218: @118828
     /* 118828 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(118884), // Rule ID 309 //
     /* 118833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118836 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118858 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118861 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118882 */   GIR_RootConstrainSelectedInstOperands,
     /* 118883 */   // GIR_Coverage, 309,
     /* 118883 */   GIR_EraseRootFromParent_Done,
     /* 118884 */ // Label 2219: @118884
     /* 118884 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(118940), // Rule ID 310 //
     /* 118889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118914 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118917 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118938 */   GIR_RootConstrainSelectedInstOperands,
     /* 118939 */   // GIR_Coverage, 310,
     /* 118939 */   GIR_EraseRootFromParent_Done,
     /* 118940 */ // Label 2220: @118940
     /* 118940 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119029), // Rule ID 4438 //
     /* 118945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118948 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118974 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118986 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119027 */   GIR_RootConstrainSelectedInstOperands,
     /* 119028 */   // GIR_Coverage, 4438,
     /* 119028 */   GIR_EraseRootFromParent_Done,
     /* 119029 */ // Label 2221: @119029
     /* 119029 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119118), // Rule ID 4439 //
     /* 119034 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119037 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119041 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119063 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119075 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 119094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119116 */   GIR_RootConstrainSelectedInstOperands,
     /* 119117 */   // GIR_Coverage, 4439,
     /* 119117 */   GIR_EraseRootFromParent_Done,
     /* 119118 */ // Label 2222: @119118
     /* 119118 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119207), // Rule ID 4440 //
     /* 119123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119126 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119152 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119164 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119175 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 119183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119205 */   GIR_RootConstrainSelectedInstOperands,
     /* 119206 */   // GIR_Coverage, 4440,
     /* 119206 */   GIR_EraseRootFromParent_Done,
     /* 119207 */ // Label 2223: @119207
     /* 119207 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119296), // Rule ID 4441 //
     /* 119212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119241 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 119272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119294 */   GIR_RootConstrainSelectedInstOperands,
     /* 119295 */   // GIR_Coverage, 4441,
     /* 119295 */   GIR_EraseRootFromParent_Done,
     /* 119296 */ // Label 2224: @119296
     /* 119296 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119385), // Rule ID 4442 //
     /* 119301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119304 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119330 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119342 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 119361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119383 */   GIR_RootConstrainSelectedInstOperands,
     /* 119384 */   // GIR_Coverage, 4442,
     /* 119384 */   GIR_EraseRootFromParent_Done,
     /* 119385 */ // Label 2225: @119385
     /* 119385 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119474), // Rule ID 4443 //
     /* 119390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119393 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119419 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119431 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 119450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119472 */   GIR_RootConstrainSelectedInstOperands,
     /* 119473 */   // GIR_Coverage, 4443,
     /* 119473 */   GIR_EraseRootFromParent_Done,
     /* 119474 */ // Label 2226: @119474
     /* 119474 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(119527), // Rule ID 4454 //
     /* 119479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119501 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119504 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119525 */   GIR_RootConstrainSelectedInstOperands,
     /* 119526 */   // GIR_Coverage, 4454,
     /* 119526 */   GIR_EraseRootFromParent_Done,
     /* 119527 */ // Label 2227: @119527
     /* 119527 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(119580), // Rule ID 4455 //
     /* 119532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119535 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119554 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119557 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119574 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119578 */   GIR_RootConstrainSelectedInstOperands,
     /* 119579 */   // GIR_Coverage, 4455,
     /* 119579 */   GIR_EraseRootFromParent_Done,
     /* 119580 */ // Label 2228: @119580
     /* 119580 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(119633), // Rule ID 4456 //
     /* 119585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119607 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119610 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119631 */   GIR_RootConstrainSelectedInstOperands,
     /* 119632 */   // GIR_Coverage, 4456,
     /* 119632 */   GIR_EraseRootFromParent_Done,
     /* 119633 */ // Label 2229: @119633
     /* 119633 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(119686), // Rule ID 4457 //
     /* 119638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119660 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119663 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119684 */   GIR_RootConstrainSelectedInstOperands,
     /* 119685 */   // GIR_Coverage, 4457,
     /* 119685 */   GIR_EraseRootFromParent_Done,
     /* 119686 */ // Label 2230: @119686
     /* 119686 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(119738), // Rule ID 311 //
     /* 119691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119713 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 119716 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 119722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119736 */   GIR_RootConstrainSelectedInstOperands,
     /* 119737 */   // GIR_Coverage, 311,
     /* 119737 */   GIR_EraseRootFromParent_Done,
     /* 119738 */ // Label 2231: @119738
     /* 119738 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(119789), // Rule ID 316 //
     /* 119743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119749 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119768 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119771 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119787 */   GIR_RootConstrainSelectedInstOperands,
     /* 119788 */   // GIR_Coverage, 316,
     /* 119788 */   GIR_EraseRootFromParent_Done,
     /* 119789 */ // Label 2232: @119789
     /* 119789 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(119837), // Rule ID 4484 //
     /* 119794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119816 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119819 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119835 */   GIR_RootConstrainSelectedInstOperands,
     /* 119836 */   // GIR_Coverage, 4484,
     /* 119836 */   GIR_EraseRootFromParent_Done,
     /* 119837 */ // Label 2233: @119837
     /* 119837 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(119885), // Rule ID 4485 //
     /* 119842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119864 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119867 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119883 */   GIR_RootConstrainSelectedInstOperands,
     /* 119884 */   // GIR_Coverage, 4485,
     /* 119884 */   GIR_EraseRootFromParent_Done,
     /* 119885 */ // Label 2234: @119885
     /* 119885 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(119969), // Rule ID 4499 //
     /* 119890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119893 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119919 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119931 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 119950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119967 */   GIR_RootConstrainSelectedInstOperands,
     /* 119968 */   // GIR_Coverage, 4499,
     /* 119968 */   GIR_EraseRootFromParent_Done,
     /* 119969 */ // Label 2235: @119969
     /* 119969 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120053), // Rule ID 4500 //
     /* 119974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119977 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120003 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120015 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120051 */   GIR_RootConstrainSelectedInstOperands,
     /* 120052 */   // GIR_Coverage, 4500,
     /* 120052 */   GIR_EraseRootFromParent_Done,
     /* 120053 */ // Label 2236: @120053
     /* 120053 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120137), // Rule ID 4501 //
     /* 120058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120061 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120087 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120099 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120105 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120110 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 120118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120135 */   GIR_RootConstrainSelectedInstOperands,
     /* 120136 */   // GIR_Coverage, 4501,
     /* 120136 */   GIR_EraseRootFromParent_Done,
     /* 120137 */ // Label 2237: @120137
     /* 120137 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120214), // Rule ID 7059 //
     /* 120142 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120152 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120185 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120188 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120212 */   GIR_RootConstrainSelectedInstOperands,
     /* 120213 */   // GIR_Coverage, 7059,
     /* 120213 */   GIR_EraseRootFromParent_Done,
     /* 120214 */ // Label 2238: @120214
     /* 120214 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120291), // Rule ID 7060 //
     /* 120219 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120222 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120229 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120244 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120262 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120289 */   GIR_RootConstrainSelectedInstOperands,
     /* 120290 */   // GIR_Coverage, 7060,
     /* 120290 */   GIR_EraseRootFromParent_Done,
     /* 120291 */ // Label 2239: @120291
     /* 120291 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120350), // Rule ID 7051 //
     /* 120296 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120306 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120324 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 120327 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120348 */   GIR_RootConstrainSelectedInstOperands,
     /* 120349 */   // GIR_Coverage, 7051,
     /* 120349 */   GIR_EraseRootFromParent_Done,
     /* 120350 */ // Label 2240: @120350
     /* 120350 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(120409), // Rule ID 7052 //
     /* 120355 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120365 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120383 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 120386 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120407 */   GIR_RootConstrainSelectedInstOperands,
     /* 120408 */   // GIR_Coverage, 7052,
     /* 120408 */   GIR_EraseRootFromParent_Done,
     /* 120409 */ // Label 2241: @120409
     /* 120409 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(120481), // Rule ID 7061 //
     /* 120414 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120424 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120435 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120457 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120460 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120479 */   GIR_RootConstrainSelectedInstOperands,
     /* 120480 */   // GIR_Coverage, 7061,
     /* 120480 */   GIR_EraseRootFromParent_Done,
     /* 120481 */ // Label 2242: @120481
     /* 120481 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(120553), // Rule ID 7062 //
     /* 120486 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120496 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120529 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120532 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120551 */   GIR_RootConstrainSelectedInstOperands,
     /* 120552 */   // GIR_Coverage, 7062,
     /* 120552 */   GIR_EraseRootFromParent_Done,
     /* 120553 */ // Label 2243: @120553
     /* 120553 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(120650), // Rule ID 7373 //
     /* 120558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 120561 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120564 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120571 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120582 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120586 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 120590 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 120594 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 120598 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 120602 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120607 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 120611 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120615 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 120619 */   // MIs[3] Operand 1
     /* 120619 */   // No operand predicates
     /* 120619 */   // MIs[0] Rn
     /* 120619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120627 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 120629 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15868>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 120629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 120632 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 120636 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 120639 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 120641 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 120648 */   GIR_RootConstrainSelectedInstOperands,
     /* 120649 */   // GIR_Coverage, 7373,
     /* 120649 */   GIR_EraseRootFromParent_Done,
     /* 120650 */ // Label 2244: @120650
     /* 120650 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(120702), // Rule ID 319 //
     /* 120655 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120658 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120670 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120677 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120680 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120700 */   GIR_RootConstrainSelectedInstOperands,
     /* 120701 */   // GIR_Coverage, 319,
     /* 120701 */   GIR_EraseRootFromParent_Done,
     /* 120702 */ // Label 2245: @120702
     /* 120702 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(120753), // Rule ID 324 //
     /* 120707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120732 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120735 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120751 */   GIR_RootConstrainSelectedInstOperands,
     /* 120752 */   // GIR_Coverage, 324,
     /* 120752 */   GIR_EraseRootFromParent_Done,
     /* 120753 */ // Label 2246: @120753
     /* 120753 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(120807), // Rule ID 7053 //
     /* 120758 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120761 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120768 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120786 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120789 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120805 */   GIR_RootConstrainSelectedInstOperands,
     /* 120806 */   // GIR_Coverage, 7053,
     /* 120806 */   GIR_EraseRootFromParent_Done,
     /* 120807 */ // Label 2247: @120807
     /* 120807 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(120861), // Rule ID 7054 //
     /* 120812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120822 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120840 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15870>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120843 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120859 */   GIR_RootConstrainSelectedInstOperands,
     /* 120860 */   // GIR_Coverage, 7054,
     /* 120860 */   GIR_EraseRootFromParent_Done,
     /* 120861 */ // Label 2248: @120861
     /* 120861 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(120918), // Rule ID 7384 //
     /* 120866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 120869 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120879 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120897 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15868>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 120900 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120916 */   GIR_RootConstrainSelectedInstOperands,
     /* 120917 */   // GIR_Coverage, 7384,
     /* 120917 */   GIR_EraseRootFromParent_Done,
     /* 120918 */ // Label 2249: @120918
     /* 120918 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(120966), // Rule ID 4508 //
     /* 120923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120926 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120945 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120948 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120964 */   GIR_RootConstrainSelectedInstOperands,
     /* 120965 */   // GIR_Coverage, 4508,
     /* 120965 */   GIR_EraseRootFromParent_Done,
     /* 120966 */ // Label 2250: @120966
     /* 120966 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121014), // Rule ID 4509 //
     /* 120971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120982 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120986 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120993 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120996 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121012 */   GIR_RootConstrainSelectedInstOperands,
     /* 121013 */   // GIR_Coverage, 4509,
     /* 121013 */   GIR_EraseRootFromParent_Done,
     /* 121014 */ // Label 2251: @121014
     /* 121014 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121098), // Rule ID 4524 //
     /* 121019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121022 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121048 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121060 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 121079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121096 */   GIR_RootConstrainSelectedInstOperands,
     /* 121097 */   // GIR_Coverage, 4524,
     /* 121097 */   GIR_EraseRootFromParent_Done,
     /* 121098 */ // Label 2252: @121098
     /* 121098 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121182), // Rule ID 4525 //
     /* 121103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121106 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121132 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121144 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 121163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121180 */   GIR_RootConstrainSelectedInstOperands,
     /* 121181 */   // GIR_Coverage, 4525,
     /* 121181 */   GIR_EraseRootFromParent_Done,
     /* 121182 */ // Label 2253: @121182
     /* 121182 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121266), // Rule ID 4526 //
     /* 121187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121190 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121216 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121228 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 121247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121264 */   GIR_RootConstrainSelectedInstOperands,
     /* 121265 */   // GIR_Coverage, 4526,
     /* 121265 */   GIR_EraseRootFromParent_Done,
     /* 121266 */ // Label 2254: @121266
     /* 121266 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121350), // Rule ID 7372 //
     /* 121271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121274 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121277 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121284 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121295 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121299 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121303 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121308 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 121312 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121316 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121320 */   // MIs[2] Operand 1
     /* 121320 */   // No operand predicates
     /* 121320 */   // MIs[0] Rn
     /* 121320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121328 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121330 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15868>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121333 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121337 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 121340 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121342 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121348 */   GIR_RootConstrainSelectedInstOperands,
     /* 121349 */   // GIR_Coverage, 7372,
     /* 121349 */   GIR_EraseRootFromParent_Done,
     /* 121350 */ // Label 2255: @121350
     /* 121350 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121448), // Rule ID 7374 //
     /* 121355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121368 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121383 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121388 */   // MIs[0] Rn
     /* 121388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121398 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15868>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 121398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 121401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121410 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 121413 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121417 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 121420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121425 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121446 */   GIR_RootConstrainSelectedInstOperands,
     /* 121447 */   // GIR_Coverage, 7374,
     /* 121447 */   GIR_EraseRootFromParent_Done,
     /* 121448 */ // Label 2256: @121448
     /* 121448 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(121485), // Rule ID 7050 //
     /* 121453 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121456 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121463 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121470 */   // MIs[0] ptr
     /* 121470 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121478 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15868>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 121478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 121483 */   GIR_RootConstrainSelectedInstOperands,
     /* 121484 */   // GIR_Coverage, 7050,
     /* 121484 */   GIR_Done,
     /* 121485 */ // Label 2257: @121485
     /* 121485 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(121512), // Rule ID 6378 //
     /* 121490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121493 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121497 */   // MIs[0] Rn
     /* 121497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121505 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 121505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 121510 */   GIR_RootConstrainSelectedInstOperands,
     /* 121511 */   // GIR_Coverage, 6378,
     /* 121511 */   GIR_Done,
     /* 121512 */ // Label 2258: @121512
     /* 121512 */ GIM_Reject,
     /* 121513 */ // Label 2106: @121513
     /* 121513 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(121718),
     /* 121518 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121521 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121533 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(121574), // Rule ID 4436 //
     /* 121538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 121548 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 121551 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121572 */     GIR_RootConstrainSelectedInstOperands,
     /* 121573 */     // GIR_Coverage, 4436,
     /* 121573 */     GIR_EraseRootFromParent_Done,
     /* 121574 */   // Label 2260: @121574
     /* 121574 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(121615), // Rule ID 4437 //
     /* 121579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 121589 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 121592 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121613 */     GIR_RootConstrainSelectedInstOperands,
     /* 121614 */     // GIR_Coverage, 4437,
     /* 121614 */     GIR_EraseRootFromParent_Done,
     /* 121615 */   // Label 2261: @121615
     /* 121615 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(121648), // Rule ID 4491 //
     /* 121620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 121627 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 121627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 121630 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121646 */     GIR_RootConstrainSelectedInstOperands,
     /* 121647 */     // GIR_Coverage, 4491,
     /* 121647 */     GIR_EraseRootFromParent_Done,
     /* 121648 */   // Label 2262: @121648
     /* 121648 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(121681), // Rule ID 4515 //
     /* 121653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121660 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121663 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121679 */     GIR_RootConstrainSelectedInstOperands,
     /* 121680 */     // GIR_Coverage, 4515,
     /* 121680 */     GIR_EraseRootFromParent_Done,
     /* 121681 */   // Label 2263: @121681
     /* 121681 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(121717), // Rule ID 325 //
     /* 121686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121696 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121699 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121715 */     GIR_RootConstrainSelectedInstOperands,
     /* 121716 */     // GIR_Coverage, 325,
     /* 121716 */     GIR_EraseRootFromParent_Done,
     /* 121717 */   // Label 2264: @121717
     /* 121717 */   GIM_Reject,
     /* 121718 */ // Label 2259: @121718
     /* 121718 */ GIM_Reject,
     /* 121719 */ // Label 2107: @121719
     /* 121719 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(122124),
     /* 121724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121731 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(121780), // Rule ID 4444 //
     /* 121736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121754 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121757 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121778 */     GIR_RootConstrainSelectedInstOperands,
     /* 121779 */     // GIR_Coverage, 4444,
     /* 121779 */     GIR_EraseRootFromParent_Done,
     /* 121780 */   // Label 2266: @121780
     /* 121780 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(121829), // Rule ID 4445 //
     /* 121785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121803 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121806 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121827 */     GIR_RootConstrainSelectedInstOperands,
     /* 121828 */     // GIR_Coverage, 4445,
     /* 121828 */     GIR_EraseRootFromParent_Done,
     /* 121829 */   // Label 2267: @121829
     /* 121829 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(121878), // Rule ID 4446 //
     /* 121834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121852 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121855 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121876 */     GIR_RootConstrainSelectedInstOperands,
     /* 121877 */     // GIR_Coverage, 4446,
     /* 121877 */     GIR_EraseRootFromParent_Done,
     /* 121878 */   // Label 2268: @121878
     /* 121878 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(121927), // Rule ID 4447 //
     /* 121883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121901 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121904 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121925 */     GIR_RootConstrainSelectedInstOperands,
     /* 121926 */     // GIR_Coverage, 4447,
     /* 121926 */     GIR_EraseRootFromParent_Done,
     /* 121927 */   // Label 2269: @121927
     /* 121927 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(121971), // Rule ID 4486 //
     /* 121932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121950 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121953 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121969 */     GIR_RootConstrainSelectedInstOperands,
     /* 121970 */     // GIR_Coverage, 4486,
     /* 121970 */     GIR_EraseRootFromParent_Done,
     /* 121971 */   // Label 2270: @121971
     /* 121971 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122015), // Rule ID 4489 //
     /* 121976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121994 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121997 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122013 */     GIR_RootConstrainSelectedInstOperands,
     /* 122014 */     // GIR_Coverage, 4489,
     /* 122014 */     GIR_EraseRootFromParent_Done,
     /* 122015 */   // Label 2271: @122015
     /* 122015 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122059), // Rule ID 4510 //
     /* 122020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122038 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122041 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122057 */     GIR_RootConstrainSelectedInstOperands,
     /* 122058 */     // GIR_Coverage, 4510,
     /* 122058 */     GIR_EraseRootFromParent_Done,
     /* 122059 */   // Label 2272: @122059
     /* 122059 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122103), // Rule ID 4513 //
     /* 122064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122082 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122085 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122101 */     GIR_RootConstrainSelectedInstOperands,
     /* 122102 */     // GIR_Coverage, 4513,
     /* 122102 */     GIR_EraseRootFromParent_Done,
     /* 122103 */   // Label 2273: @122103
     /* 122103 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122123), // Rule ID 6377 //
     /* 122108 */     // MIs[0] Rn
     /* 122108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122116 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 122121 */     GIR_RootConstrainSelectedInstOperands,
     /* 122122 */     // GIR_Coverage, 6377,
     /* 122122 */     GIR_Done,
     /* 122123 */   // Label 2274: @122123
     /* 122123 */   GIM_Reject,
     /* 122124 */ // Label 2265: @122124
     /* 122124 */ GIM_Reject,
     /* 122125 */ // Label 2108: @122125
     /* 122125 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122574),
     /* 122130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122133 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122137 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122186), // Rule ID 4458 //
     /* 122142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122160 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122163 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122184 */     GIR_RootConstrainSelectedInstOperands,
     /* 122185 */     // GIR_Coverage, 4458,
     /* 122185 */     GIR_EraseRootFromParent_Done,
     /* 122186 */   // Label 2276: @122186
     /* 122186 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(122235), // Rule ID 4459 //
     /* 122191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122209 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122212 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122233 */     GIR_RootConstrainSelectedInstOperands,
     /* 122234 */     // GIR_Coverage, 4459,
     /* 122234 */     GIR_EraseRootFromParent_Done,
     /* 122235 */   // Label 2277: @122235
     /* 122235 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(122284), // Rule ID 4460 //
     /* 122240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122258 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122261 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122282 */     GIR_RootConstrainSelectedInstOperands,
     /* 122283 */     // GIR_Coverage, 4460,
     /* 122283 */     GIR_EraseRootFromParent_Done,
     /* 122284 */   // Label 2278: @122284
     /* 122284 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(122333), // Rule ID 4461 //
     /* 122289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122307 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122310 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122331 */     GIR_RootConstrainSelectedInstOperands,
     /* 122332 */     // GIR_Coverage, 4461,
     /* 122332 */     GIR_EraseRootFromParent_Done,
     /* 122333 */   // Label 2279: @122333
     /* 122333 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(122377), // Rule ID 4493 //
     /* 122338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122356 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122359 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122375 */     GIR_RootConstrainSelectedInstOperands,
     /* 122376 */     // GIR_Coverage, 4493,
     /* 122376 */     GIR_EraseRootFromParent_Done,
     /* 122377 */   // Label 2280: @122377
     /* 122377 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(122421), // Rule ID 4497 //
     /* 122382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122400 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122403 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122419 */     GIR_RootConstrainSelectedInstOperands,
     /* 122420 */     // GIR_Coverage, 4497,
     /* 122420 */     GIR_EraseRootFromParent_Done,
     /* 122421 */   // Label 2281: @122421
     /* 122421 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(122465), // Rule ID 4517 //
     /* 122426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122444 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122447 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122463 */     GIR_RootConstrainSelectedInstOperands,
     /* 122464 */     // GIR_Coverage, 4517,
     /* 122464 */     GIR_EraseRootFromParent_Done,
     /* 122465 */   // Label 2282: @122465
     /* 122465 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(122509), // Rule ID 4521 //
     /* 122470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122488 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122491 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122507 */     GIR_RootConstrainSelectedInstOperands,
     /* 122508 */     // GIR_Coverage, 4521,
     /* 122508 */     GIR_EraseRootFromParent_Done,
     /* 122509 */   // Label 2283: @122509
     /* 122509 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(122553), // Rule ID 4522 //
     /* 122514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122532 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122535 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122551 */     GIR_RootConstrainSelectedInstOperands,
     /* 122552 */     // GIR_Coverage, 4522,
     /* 122552 */     GIR_EraseRootFromParent_Done,
     /* 122553 */   // Label 2284: @122553
     /* 122553 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(122573), // Rule ID 6374 //
     /* 122558 */     // MIs[0] Rn
     /* 122558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122566 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 122571 */     GIR_RootConstrainSelectedInstOperands,
     /* 122572 */     // GIR_Coverage, 6374,
     /* 122572 */     GIR_Done,
     /* 122573 */   // Label 2285: @122573
     /* 122573 */   GIM_Reject,
     /* 122574 */ // Label 2275: @122574
     /* 122574 */ GIM_Reject,
     /* 122575 */ // Label 2109: @122575
     /* 122575 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(122980),
     /* 122580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122587 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(122636), // Rule ID 4448 //
     /* 122592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122610 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122613 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122634 */     GIR_RootConstrainSelectedInstOperands,
     /* 122635 */     // GIR_Coverage, 4448,
     /* 122635 */     GIR_EraseRootFromParent_Done,
     /* 122636 */   // Label 2287: @122636
     /* 122636 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(122685), // Rule ID 4449 //
     /* 122641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122659 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122662 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122683 */     GIR_RootConstrainSelectedInstOperands,
     /* 122684 */     // GIR_Coverage, 4449,
     /* 122684 */     GIR_EraseRootFromParent_Done,
     /* 122685 */   // Label 2288: @122685
     /* 122685 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(122734), // Rule ID 4452 //
     /* 122690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122708 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122711 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122732 */     GIR_RootConstrainSelectedInstOperands,
     /* 122733 */     // GIR_Coverage, 4452,
     /* 122733 */     GIR_EraseRootFromParent_Done,
     /* 122734 */   // Label 2289: @122734
     /* 122734 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(122783), // Rule ID 4453 //
     /* 122739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122757 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122760 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122781 */     GIR_RootConstrainSelectedInstOperands,
     /* 122782 */     // GIR_Coverage, 4453,
     /* 122782 */     GIR_EraseRootFromParent_Done,
     /* 122783 */   // Label 2290: @122783
     /* 122783 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(122827), // Rule ID 4488 //
     /* 122788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122806 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122809 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122825 */     GIR_RootConstrainSelectedInstOperands,
     /* 122826 */     // GIR_Coverage, 4488,
     /* 122826 */     GIR_EraseRootFromParent_Done,
     /* 122827 */   // Label 2291: @122827
     /* 122827 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(122871), // Rule ID 4490 //
     /* 122832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122850 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122853 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122869 */     GIR_RootConstrainSelectedInstOperands,
     /* 122870 */     // GIR_Coverage, 4490,
     /* 122870 */     GIR_EraseRootFromParent_Done,
     /* 122871 */   // Label 2292: @122871
     /* 122871 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(122915), // Rule ID 4512 //
     /* 122876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122894 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122913 */     GIR_RootConstrainSelectedInstOperands,
     /* 122914 */     // GIR_Coverage, 4512,
     /* 122914 */     GIR_EraseRootFromParent_Done,
     /* 122915 */   // Label 2293: @122915
     /* 122915 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(122959), // Rule ID 4514 //
     /* 122920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122938 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122941 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122957 */     GIR_RootConstrainSelectedInstOperands,
     /* 122958 */     // GIR_Coverage, 4514,
     /* 122958 */     GIR_EraseRootFromParent_Done,
     /* 122959 */   // Label 2294: @122959
     /* 122959 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(122979), // Rule ID 6376 //
     /* 122964 */     // MIs[0] Rn
     /* 122964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122972 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 122977 */     GIR_RootConstrainSelectedInstOperands,
     /* 122978 */     // GIR_Coverage, 6376,
     /* 122978 */     GIR_Done,
     /* 122979 */   // Label 2295: @122979
     /* 122979 */   GIM_Reject,
     /* 122980 */ // Label 2286: @122980
     /* 122980 */ GIM_Reject,
     /* 122981 */ // Label 2110: @122981
     /* 122981 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123386),
     /* 122986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122989 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122993 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123042), // Rule ID 4462 //
     /* 122998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123016 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123019 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123040 */     GIR_RootConstrainSelectedInstOperands,
     /* 123041 */     // GIR_Coverage, 4462,
     /* 123041 */     GIR_EraseRootFromParent_Done,
     /* 123042 */   // Label 2297: @123042
     /* 123042 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123091), // Rule ID 4463 //
     /* 123047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123065 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123068 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123089 */     GIR_RootConstrainSelectedInstOperands,
     /* 123090 */     // GIR_Coverage, 4463,
     /* 123090 */     GIR_EraseRootFromParent_Done,
     /* 123091 */   // Label 2298: @123091
     /* 123091 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123140), // Rule ID 4464 //
     /* 123096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123114 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123117 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123138 */     GIR_RootConstrainSelectedInstOperands,
     /* 123139 */     // GIR_Coverage, 4464,
     /* 123139 */     GIR_EraseRootFromParent_Done,
     /* 123140 */   // Label 2299: @123140
     /* 123140 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123189), // Rule ID 4465 //
     /* 123145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123163 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123166 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123187 */     GIR_RootConstrainSelectedInstOperands,
     /* 123188 */     // GIR_Coverage, 4465,
     /* 123188 */     GIR_EraseRootFromParent_Done,
     /* 123189 */   // Label 2300: @123189
     /* 123189 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(123233), // Rule ID 4492 //
     /* 123194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123212 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123215 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123231 */     GIR_RootConstrainSelectedInstOperands,
     /* 123232 */     // GIR_Coverage, 4492,
     /* 123232 */     GIR_EraseRootFromParent_Done,
     /* 123233 */   // Label 2301: @123233
     /* 123233 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123277), // Rule ID 4496 //
     /* 123238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123256 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123259 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123275 */     GIR_RootConstrainSelectedInstOperands,
     /* 123276 */     // GIR_Coverage, 4496,
     /* 123276 */     GIR_EraseRootFromParent_Done,
     /* 123277 */   // Label 2302: @123277
     /* 123277 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(123321), // Rule ID 4516 //
     /* 123282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123300 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123303 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123319 */     GIR_RootConstrainSelectedInstOperands,
     /* 123320 */     // GIR_Coverage, 4516,
     /* 123320 */     GIR_EraseRootFromParent_Done,
     /* 123321 */   // Label 2303: @123321
     /* 123321 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(123365), // Rule ID 4520 //
     /* 123326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123344 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123347 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123363 */     GIR_RootConstrainSelectedInstOperands,
     /* 123364 */     // GIR_Coverage, 4520,
     /* 123364 */     GIR_EraseRootFromParent_Done,
     /* 123365 */   // Label 2304: @123365
     /* 123365 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(123385), // Rule ID 6373 //
     /* 123370 */     // MIs[0] Rn
     /* 123370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123378 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 123383 */     GIR_RootConstrainSelectedInstOperands,
     /* 123384 */     // GIR_Coverage, 6373,
     /* 123384 */     GIR_Done,
     /* 123385 */   // Label 2305: @123385
     /* 123385 */   GIM_Reject,
     /* 123386 */ // Label 2296: @123386
     /* 123386 */ GIM_Reject,
     /* 123387 */ // Label 2111: @123387
     /* 123387 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(123606),
     /* 123392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123399 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(123448), // Rule ID 4450 //
     /* 123404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123422 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123425 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123446 */     GIR_RootConstrainSelectedInstOperands,
     /* 123447 */     // GIR_Coverage, 4450,
     /* 123447 */     GIR_EraseRootFromParent_Done,
     /* 123448 */   // Label 2307: @123448
     /* 123448 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(123497), // Rule ID 4451 //
     /* 123453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123471 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123474 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123495 */     GIR_RootConstrainSelectedInstOperands,
     /* 123496 */     // GIR_Coverage, 4451,
     /* 123496 */     GIR_EraseRootFromParent_Done,
     /* 123497 */   // Label 2308: @123497
     /* 123497 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(123541), // Rule ID 4487 //
     /* 123502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123520 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123523 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123539 */     GIR_RootConstrainSelectedInstOperands,
     /* 123540 */     // GIR_Coverage, 4487,
     /* 123540 */     GIR_EraseRootFromParent_Done,
     /* 123541 */   // Label 2309: @123541
     /* 123541 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(123585), // Rule ID 4511 //
     /* 123546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123564 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123567 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123583 */     GIR_RootConstrainSelectedInstOperands,
     /* 123584 */     // GIR_Coverage, 4511,
     /* 123584 */     GIR_EraseRootFromParent_Done,
     /* 123585 */   // Label 2310: @123585
     /* 123585 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(123605), // Rule ID 6375 //
     /* 123590 */     // MIs[0] Rn
     /* 123590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123598 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 123603 */     GIR_RootConstrainSelectedInstOperands,
     /* 123604 */     // GIR_Coverage, 6375,
     /* 123604 */     GIR_Done,
     /* 123605 */   // Label 2311: @123605
     /* 123605 */   GIM_Reject,
     /* 123606 */ // Label 2306: @123606
     /* 123606 */ GIM_Reject,
     /* 123607 */ // Label 2112: @123607
     /* 123607 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(124012),
     /* 123612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123619 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(123668), // Rule ID 4466 //
     /* 123624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123642 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123645 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123666 */     GIR_RootConstrainSelectedInstOperands,
     /* 123667 */     // GIR_Coverage, 4466,
     /* 123667 */     GIR_EraseRootFromParent_Done,
     /* 123668 */   // Label 2313: @123668
     /* 123668 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(123717), // Rule ID 4467 //
     /* 123673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123691 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123694 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123715 */     GIR_RootConstrainSelectedInstOperands,
     /* 123716 */     // GIR_Coverage, 4467,
     /* 123716 */     GIR_EraseRootFromParent_Done,
     /* 123717 */   // Label 2314: @123717
     /* 123717 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(123766), // Rule ID 4470 //
     /* 123722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123740 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123764 */     GIR_RootConstrainSelectedInstOperands,
     /* 123765 */     // GIR_Coverage, 4470,
     /* 123765 */     GIR_EraseRootFromParent_Done,
     /* 123766 */   // Label 2315: @123766
     /* 123766 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(123815), // Rule ID 4471 //
     /* 123771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123789 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123792 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123813 */     GIR_RootConstrainSelectedInstOperands,
     /* 123814 */     // GIR_Coverage, 4471,
     /* 123814 */     GIR_EraseRootFromParent_Done,
     /* 123815 */   // Label 2316: @123815
     /* 123815 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(123859), // Rule ID 4495 //
     /* 123820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123838 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123841 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123857 */     GIR_RootConstrainSelectedInstOperands,
     /* 123858 */     // GIR_Coverage, 4495,
     /* 123858 */     GIR_EraseRootFromParent_Done,
     /* 123859 */   // Label 2317: @123859
     /* 123859 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(123903), // Rule ID 4498 //
     /* 123864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123882 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123885 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123901 */     GIR_RootConstrainSelectedInstOperands,
     /* 123902 */     // GIR_Coverage, 4498,
     /* 123902 */     GIR_EraseRootFromParent_Done,
     /* 123903 */   // Label 2318: @123903
     /* 123903 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(123947), // Rule ID 4519 //
     /* 123908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123926 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123929 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123945 */     GIR_RootConstrainSelectedInstOperands,
     /* 123946 */     // GIR_Coverage, 4519,
     /* 123946 */     GIR_EraseRootFromParent_Done,
     /* 123947 */   // Label 2319: @123947
     /* 123947 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(123991), // Rule ID 4523 //
     /* 123952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123970 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123973 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123989 */     GIR_RootConstrainSelectedInstOperands,
     /* 123990 */     // GIR_Coverage, 4523,
     /* 123990 */     GIR_EraseRootFromParent_Done,
     /* 123991 */   // Label 2320: @123991
     /* 123991 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124011), // Rule ID 6372 //
     /* 123996 */     // MIs[0] Rn
     /* 123996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124004 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124009 */     GIR_RootConstrainSelectedInstOperands,
     /* 124010 */     // GIR_Coverage, 6372,
     /* 124010 */     GIR_Done,
     /* 124011 */   // Label 2321: @124011
     /* 124011 */   GIM_Reject,
     /* 124012 */ // Label 2312: @124012
     /* 124012 */ GIM_Reject,
     /* 124013 */ // Label 2113: @124013
     /* 124013 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124232),
     /* 124018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124025 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124074), // Rule ID 4468 //
     /* 124030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124048 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124051 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124072 */     GIR_RootConstrainSelectedInstOperands,
     /* 124073 */     // GIR_Coverage, 4468,
     /* 124073 */     GIR_EraseRootFromParent_Done,
     /* 124074 */   // Label 2323: @124074
     /* 124074 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124123), // Rule ID 4469 //
     /* 124079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124097 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124100 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124121 */     GIR_RootConstrainSelectedInstOperands,
     /* 124122 */     // GIR_Coverage, 4469,
     /* 124122 */     GIR_EraseRootFromParent_Done,
     /* 124123 */   // Label 2324: @124123
     /* 124123 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124167), // Rule ID 4494 //
     /* 124128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124146 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124149 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124165 */     GIR_RootConstrainSelectedInstOperands,
     /* 124166 */     // GIR_Coverage, 4494,
     /* 124166 */     GIR_EraseRootFromParent_Done,
     /* 124167 */   // Label 2325: @124167
     /* 124167 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124211), // Rule ID 4518 //
     /* 124172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124190 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124193 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124209 */     GIR_RootConstrainSelectedInstOperands,
     /* 124210 */     // GIR_Coverage, 4518,
     /* 124210 */     GIR_EraseRootFromParent_Done,
     /* 124211 */   // Label 2326: @124211
     /* 124211 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(124231), // Rule ID 6371 //
     /* 124216 */     // MIs[0] Rn
     /* 124216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124224 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 124229 */     GIR_RootConstrainSelectedInstOperands,
     /* 124230 */     // GIR_Coverage, 6371,
     /* 124230 */     GIR_Done,
     /* 124231 */   // Label 2327: @124231
     /* 124231 */   GIM_Reject,
     /* 124232 */ // Label 2322: @124232
     /* 124232 */ GIM_Reject,
     /* 124233 */ // Label 2114: @124233
     /* 124233 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(124292), // Rule ID 10805 //
     /* 124238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124248 */   // MIs[0] base
     /* 124248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124256 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124268 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 124276 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124281 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124290 */   GIR_RootConstrainSelectedInstOperands,
     /* 124291 */   // GIR_Coverage, 10805,
     /* 124291 */   GIR_EraseRootFromParent_Done,
     /* 124292 */ // Label 2328: @124292
     /* 124292 */ GIM_Reject,
     /* 124293 */ // Label 2115: @124293
     /* 124293 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(124352), // Rule ID 10811 //
     /* 124298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124308 */   // MIs[0] base
     /* 124308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124316 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124328 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 124336 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124341 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124350 */   GIR_RootConstrainSelectedInstOperands,
     /* 124351 */   // GIR_Coverage, 10811,
     /* 124351 */   GIR_EraseRootFromParent_Done,
     /* 124352 */ // Label 2329: @124352
     /* 124352 */ GIM_Reject,
     /* 124353 */ // Label 2116: @124353
     /* 124353 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(124522),
     /* 124358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124369 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(124417), // Rule ID 10796 //
     /* 124374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124381 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124401 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124406 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124415 */     GIR_RootConstrainSelectedInstOperands,
     /* 124416 */     // GIR_Coverage, 10796,
     /* 124416 */     GIR_EraseRootFromParent_Done,
     /* 124417 */   // Label 2331: @124417
     /* 124417 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(124465), // Rule ID 10814 //
     /* 124422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124429 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124449 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124454 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124463 */     GIR_RootConstrainSelectedInstOperands,
     /* 124464 */     // GIR_Coverage, 10814,
     /* 124464 */     GIR_EraseRootFromParent_Done,
     /* 124465 */   // Label 2332: @124465
     /* 124465 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124493), // Rule ID 10926 //
     /* 124470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124477 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124480 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124482 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124491 */     GIR_RootConstrainSelectedInstOperands,
     /* 124492 */     // GIR_Coverage, 10926,
     /* 124492 */     GIR_EraseRootFromParent_Done,
     /* 124493 */   // Label 2333: @124493
     /* 124493 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124521), // Rule ID 10938 //
     /* 124498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124505 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124508 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124510 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124519 */     GIR_RootConstrainSelectedInstOperands,
     /* 124520 */     // GIR_Coverage, 10938,
     /* 124520 */     GIR_EraseRootFromParent_Done,
     /* 124521 */   // Label 2334: @124521
     /* 124521 */   GIM_Reject,
     /* 124522 */ // Label 2330: @124522
     /* 124522 */ GIM_Reject,
     /* 124523 */ // Label 2117: @124523
     /* 124523 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124582), // Rule ID 10802 //
     /* 124528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124538 */   // MIs[0] base
     /* 124538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124546 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124558 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 124566 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124571 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124580 */   GIR_RootConstrainSelectedInstOperands,
     /* 124581 */   // GIR_Coverage, 10802,
     /* 124581 */   GIR_EraseRootFromParent_Done,
     /* 124582 */ // Label 2335: @124582
     /* 124582 */ GIM_Reject,
     /* 124583 */ // Label 2118: @124583
     /* 124583 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124752),
     /* 124588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124599 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124647), // Rule ID 10790 //
     /* 124604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124611 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124631 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124636 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124645 */     GIR_RootConstrainSelectedInstOperands,
     /* 124646 */     // GIR_Coverage, 10790,
     /* 124646 */     GIR_EraseRootFromParent_Done,
     /* 124647 */   // Label 2337: @124647
     /* 124647 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(124695), // Rule ID 10808 //
     /* 124652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124659 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124679 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124684 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124693 */     GIR_RootConstrainSelectedInstOperands,
     /* 124694 */     // GIR_Coverage, 10808,
     /* 124694 */     GIR_EraseRootFromParent_Done,
     /* 124695 */   // Label 2338: @124695
     /* 124695 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124723), // Rule ID 10922 //
     /* 124700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124707 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124710 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124712 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124721 */     GIR_RootConstrainSelectedInstOperands,
     /* 124722 */     // GIR_Coverage, 10922,
     /* 124722 */     GIR_EraseRootFromParent_Done,
     /* 124723 */   // Label 2339: @124723
     /* 124723 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124751), // Rule ID 10934 //
     /* 124728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124735 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124738 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124740 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124749 */     GIR_RootConstrainSelectedInstOperands,
     /* 124750 */     // GIR_Coverage, 10934,
     /* 124750 */     GIR_EraseRootFromParent_Done,
     /* 124751 */   // Label 2340: @124751
     /* 124751 */   GIM_Reject,
     /* 124752 */ // Label 2336: @124752
     /* 124752 */ GIM_Reject,
     /* 124753 */ // Label 2119: @124753
     /* 124753 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(124922),
     /* 124758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124769 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(124817), // Rule ID 10781 //
     /* 124774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124781 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124793 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124806 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124815 */     GIR_RootConstrainSelectedInstOperands,
     /* 124816 */     // GIR_Coverage, 10781,
     /* 124816 */     GIR_EraseRootFromParent_Done,
     /* 124817 */   // Label 2342: @124817
     /* 124817 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(124865), // Rule ID 10799 //
     /* 124822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124829 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124849 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124854 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124863 */     GIR_RootConstrainSelectedInstOperands,
     /* 124864 */     // GIR_Coverage, 10799,
     /* 124864 */     GIR_EraseRootFromParent_Done,
     /* 124865 */   // Label 2343: @124865
     /* 124865 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(124893), // Rule ID 10918 //
     /* 124870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124877 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124880 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124882 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124891 */     GIR_RootConstrainSelectedInstOperands,
     /* 124892 */     // GIR_Coverage, 10918,
     /* 124892 */     GIR_EraseRootFromParent_Done,
     /* 124893 */   // Label 2344: @124893
     /* 124893 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(124921), // Rule ID 10930 //
     /* 124898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124905 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124908 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124910 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124919 */     GIR_RootConstrainSelectedInstOperands,
     /* 124920 */     // GIR_Coverage, 10930,
     /* 124920 */     GIR_EraseRootFromParent_Done,
     /* 124921 */   // Label 2345: @124921
     /* 124921 */   GIM_Reject,
     /* 124922 */ // Label 2341: @124922
     /* 124922 */ GIM_Reject,
     /* 124923 */ // Label 2120: @124923
     /* 124923 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(124966), // Rule ID 2430 //
     /* 124928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 124942 */   // MIs[0] base
     /* 124942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124950 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 124953 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 124955 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124964 */   GIR_RootConstrainSelectedInstOperands,
     /* 124965 */   // GIR_Coverage, 2430,
     /* 124965 */   GIR_EraseRootFromParent_Done,
     /* 124966 */ // Label 2346: @124966
     /* 124966 */ GIM_Reject,
     /* 124967 */ // Label 2121: @124967
     /* 124967 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125060),
     /* 124972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124983 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125031), // Rule ID 10767 //
     /* 124988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124995 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125015 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125020 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125029 */     GIR_RootConstrainSelectedInstOperands,
     /* 125030 */     // GIR_Coverage, 10767,
     /* 125030 */     GIR_EraseRootFromParent_Done,
     /* 125031 */   // Label 2348: @125031
     /* 125031 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125059), // Rule ID 10914 //
     /* 125036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125043 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125046 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125048 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125057 */     GIR_RootConstrainSelectedInstOperands,
     /* 125058 */     // GIR_Coverage, 10914,
     /* 125058 */     GIR_EraseRootFromParent_Done,
     /* 125059 */   // Label 2349: @125059
     /* 125059 */   GIM_Reject,
     /* 125060 */ // Label 2347: @125060
     /* 125060 */ GIM_Reject,
     /* 125061 */ // Label 2122: @125061
     /* 125061 */ GIM_Reject,
     /* 125062 */ // Label 20: @125062
     /* 125062 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2352*/ GIMT_Encode4(126412),
     /* 125073 */ /*GILLT_s32*//*Label 2350*/ GIMT_Encode4(125081),
     /* 125077 */ /*GILLT_s64*//*Label 2351*/ GIMT_Encode4(126099),
     /* 125081 */ // Label 2350: @125081
     /* 125081 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(126098),
     /* 125086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125092 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(125147), // Rule ID 7273 //
     /* 125097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125114 */     // MIs[0] Rn
     /* 125114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125130 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 125133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125145 */     GIR_RootConstrainSelectedInstOperands,
     /* 125146 */     // GIR_Coverage, 7273,
     /* 125146 */     GIR_EraseRootFromParent_Done,
     /* 125147 */   // Label 2354: @125147
     /* 125147 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(125202), // Rule ID 7274 //
     /* 125152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125169 */     // MIs[0] Rn
     /* 125169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125185 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 125188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125200 */     GIR_RootConstrainSelectedInstOperands,
     /* 125201 */     // GIR_Coverage, 7274,
     /* 125201 */     GIR_EraseRootFromParent_Done,
     /* 125202 */   // Label 2355: @125202
     /* 125202 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(125257), // Rule ID 7275 //
     /* 125207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125224 */     // MIs[0] Rn
     /* 125224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125240 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 125243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125255 */     GIR_RootConstrainSelectedInstOperands,
     /* 125256 */     // GIR_Coverage, 7275,
     /* 125256 */     GIR_EraseRootFromParent_Done,
     /* 125257 */   // Label 2356: @125257
     /* 125257 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(125312), // Rule ID 7276 //
     /* 125262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125279 */     // MIs[0] Rn
     /* 125279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125295 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125310 */     GIR_RootConstrainSelectedInstOperands,
     /* 125311 */     // GIR_Coverage, 7276,
     /* 125311 */     GIR_EraseRootFromParent_Done,
     /* 125312 */   // Label 2357: @125312
     /* 125312 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(125367), // Rule ID 7277 //
     /* 125317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125334 */     // MIs[0] Rn
     /* 125334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125350 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125365 */     GIR_RootConstrainSelectedInstOperands,
     /* 125366 */     // GIR_Coverage, 7277,
     /* 125366 */     GIR_EraseRootFromParent_Done,
     /* 125367 */   // Label 2358: @125367
     /* 125367 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(125422), // Rule ID 7278 //
     /* 125372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125389 */     // MIs[0] Rn
     /* 125389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125405 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 125408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125420 */     GIR_RootConstrainSelectedInstOperands,
     /* 125421 */     // GIR_Coverage, 7278,
     /* 125421 */     GIR_EraseRootFromParent_Done,
     /* 125422 */   // Label 2359: @125422
     /* 125422 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(125477), // Rule ID 7279 //
     /* 125427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125430 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125444 */     // MIs[0] Rn
     /* 125444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125460 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 125463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125475 */     GIR_RootConstrainSelectedInstOperands,
     /* 125476 */     // GIR_Coverage, 7279,
     /* 125476 */     GIR_EraseRootFromParent_Done,
     /* 125477 */   // Label 2360: @125477
     /* 125477 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(125532), // Rule ID 7280 //
     /* 125482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125499 */     // MIs[0] Rn
     /* 125499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125515 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 125518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125530 */     GIR_RootConstrainSelectedInstOperands,
     /* 125531 */     // GIR_Coverage, 7280,
     /* 125531 */     GIR_EraseRootFromParent_Done,
     /* 125532 */   // Label 2361: @125532
     /* 125532 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125587), // Rule ID 7281 //
     /* 125537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125554 */     // MIs[0] Rn
     /* 125554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125570 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125585 */     GIR_RootConstrainSelectedInstOperands,
     /* 125586 */     // GIR_Coverage, 7281,
     /* 125586 */     GIR_EraseRootFromParent_Done,
     /* 125587 */   // Label 2362: @125587
     /* 125587 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125642), // Rule ID 7282 //
     /* 125592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125609 */     // MIs[0] Rn
     /* 125609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125625 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125640 */     GIR_RootConstrainSelectedInstOperands,
     /* 125641 */     // GIR_Coverage, 7282,
     /* 125641 */     GIR_EraseRootFromParent_Done,
     /* 125642 */   // Label 2363: @125642
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125697), // Rule ID 7283 //
     /* 125647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125664 */     // MIs[0] Rn
     /* 125664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125680 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 125683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125695 */     GIR_RootConstrainSelectedInstOperands,
     /* 125696 */     // GIR_Coverage, 7283,
     /* 125696 */     GIR_EraseRootFromParent_Done,
     /* 125697 */   // Label 2364: @125697
     /* 125697 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(125752), // Rule ID 7284 //
     /* 125702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125719 */     // MIs[0] Rn
     /* 125719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125735 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 125738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125750 */     GIR_RootConstrainSelectedInstOperands,
     /* 125751 */     // GIR_Coverage, 7284,
     /* 125751 */     GIR_EraseRootFromParent_Done,
     /* 125752 */   // Label 2365: @125752
     /* 125752 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(125807), // Rule ID 7285 //
     /* 125757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125774 */     // MIs[0] Rn
     /* 125774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125790 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 125793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125805 */     GIR_RootConstrainSelectedInstOperands,
     /* 125806 */     // GIR_Coverage, 7285,
     /* 125806 */     GIR_EraseRootFromParent_Done,
     /* 125807 */   // Label 2366: @125807
     /* 125807 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(125862), // Rule ID 7286 //
     /* 125812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125829 */     // MIs[0] Rn
     /* 125829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125845 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125860 */     GIR_RootConstrainSelectedInstOperands,
     /* 125861 */     // GIR_Coverage, 7286,
     /* 125861 */     GIR_EraseRootFromParent_Done,
     /* 125862 */   // Label 2367: @125862
     /* 125862 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(125917), // Rule ID 7287 //
     /* 125867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125884 */     // MIs[0] Rn
     /* 125884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125900 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125915 */     GIR_RootConstrainSelectedInstOperands,
     /* 125916 */     // GIR_Coverage, 7287,
     /* 125916 */     GIR_EraseRootFromParent_Done,
     /* 125917 */   // Label 2368: @125917
     /* 125917 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(125977), // Rule ID 13046 //
     /* 125922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125936 */     // MIs[0] addr
     /* 125936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125952 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 125958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125960 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125965 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125967 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125969 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125975 */     GIR_RootConstrainSelectedInstOperands,
     /* 125976 */     // GIR_Coverage, 13046,
     /* 125976 */     GIR_EraseRootFromParent_Done,
     /* 125977 */   // Label 2369: @125977
     /* 125977 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126037), // Rule ID 13047 //
     /* 125982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125996 */     // MIs[0] addr
     /* 125996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126012 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126020 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126025 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126027 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126029 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126035 */     GIR_RootConstrainSelectedInstOperands,
     /* 126036 */     // GIR_Coverage, 13047,
     /* 126036 */     GIR_EraseRootFromParent_Done,
     /* 126037 */   // Label 2370: @126037
     /* 126037 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126097), // Rule ID 13048 //
     /* 126042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126045 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126056 */     // MIs[0] addr
     /* 126056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126072 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 126078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126080 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126085 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126087 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126089 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126095 */     GIR_RootConstrainSelectedInstOperands,
     /* 126096 */     // GIR_Coverage, 13048,
     /* 126096 */     GIR_EraseRootFromParent_Done,
     /* 126097 */   // Label 2371: @126097
     /* 126097 */   GIM_Reject,
     /* 126098 */ // Label 2353: @126098
     /* 126098 */ GIM_Reject,
     /* 126099 */ // Label 2351: @126099
     /* 126099 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126411),
     /* 126104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 126110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126117 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126165), // Rule ID 2589 //
     /* 126122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126132 */     // MIs[0] Rn
     /* 126132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126148 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 126151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126163 */     GIR_RootConstrainSelectedInstOperands,
     /* 126164 */     // GIR_Coverage, 2589,
     /* 126164 */     GIR_EraseRootFromParent_Done,
     /* 126165 */   // Label 2373: @126165
     /* 126165 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126213), // Rule ID 2590 //
     /* 126170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126180 */     // MIs[0] Rn
     /* 126180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126196 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 126199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126211 */     GIR_RootConstrainSelectedInstOperands,
     /* 126212 */     // GIR_Coverage, 2590,
     /* 126212 */     GIR_EraseRootFromParent_Done,
     /* 126213 */   // Label 2374: @126213
     /* 126213 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126261), // Rule ID 2591 //
     /* 126218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126228 */     // MIs[0] Rn
     /* 126228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126244 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 126247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126259 */     GIR_RootConstrainSelectedInstOperands,
     /* 126260 */     // GIR_Coverage, 2591,
     /* 126260 */     GIR_EraseRootFromParent_Done,
     /* 126261 */   // Label 2375: @126261
     /* 126261 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(126309), // Rule ID 2592 //
     /* 126266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126276 */     // MIs[0] Rn
     /* 126276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126292 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126307 */     GIR_RootConstrainSelectedInstOperands,
     /* 126308 */     // GIR_Coverage, 2592,
     /* 126308 */     GIR_EraseRootFromParent_Done,
     /* 126309 */   // Label 2376: @126309
     /* 126309 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(126357), // Rule ID 2593 //
     /* 126314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126324 */     // MIs[0] Rn
     /* 126324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126340 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126355 */     GIR_RootConstrainSelectedInstOperands,
     /* 126356 */     // GIR_Coverage, 2593,
     /* 126356 */     GIR_EraseRootFromParent_Done,
     /* 126357 */   // Label 2377: @126357
     /* 126357 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(126410), // Rule ID 13049 //
     /* 126362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126369 */     // MIs[0] addr
     /* 126369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126385 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 126385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 126391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126393 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126398 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126400 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126402 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126408 */     GIR_RootConstrainSelectedInstOperands,
     /* 126409 */     // GIR_Coverage, 13049,
     /* 126409 */     GIR_EraseRootFromParent_Done,
     /* 126410 */   // Label 2378: @126410
     /* 126410 */   GIM_Reject,
     /* 126411 */ // Label 2372: @126411
     /* 126411 */ GIM_Reject,
     /* 126412 */ // Label 2352: @126412
     /* 126412 */ GIM_Reject,
     /* 126413 */ // Label 21: @126413
     /* 126413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(127404),
     /* 126424 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(126432),
     /* 126428 */ /*GILLT_s64*//*Label 2380*/ GIMT_Encode4(127177),
     /* 126432 */ // Label 2379: @126432
     /* 126432 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(127176),
     /* 126437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126440 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126489), // Rule ID 7258 //
     /* 126445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126462 */     // MIs[0] Rn
     /* 126462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126474 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 126477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126487 */     GIR_RootConstrainSelectedInstOperands,
     /* 126488 */     // GIR_Coverage, 7258,
     /* 126488 */     GIR_EraseRootFromParent_Done,
     /* 126489 */   // Label 2383: @126489
     /* 126489 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126538), // Rule ID 7259 //
     /* 126494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126511 */     // MIs[0] Rn
     /* 126511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126523 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 126526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126536 */     GIR_RootConstrainSelectedInstOperands,
     /* 126537 */     // GIR_Coverage, 7259,
     /* 126537 */     GIR_EraseRootFromParent_Done,
     /* 126538 */   // Label 2384: @126538
     /* 126538 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126587), // Rule ID 7260 //
     /* 126543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126560 */     // MIs[0] Rn
     /* 126560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126572 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 126575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126585 */     GIR_RootConstrainSelectedInstOperands,
     /* 126586 */     // GIR_Coverage, 7260,
     /* 126586 */     GIR_EraseRootFromParent_Done,
     /* 126587 */   // Label 2385: @126587
     /* 126587 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126636), // Rule ID 7261 //
     /* 126592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126609 */     // MIs[0] Rn
     /* 126609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126621 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126634 */     GIR_RootConstrainSelectedInstOperands,
     /* 126635 */     // GIR_Coverage, 7261,
     /* 126635 */     GIR_EraseRootFromParent_Done,
     /* 126636 */   // Label 2386: @126636
     /* 126636 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(126685), // Rule ID 7262 //
     /* 126641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126644 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126658 */     // MIs[0] Rn
     /* 126658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126670 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126683 */     GIR_RootConstrainSelectedInstOperands,
     /* 126684 */     // GIR_Coverage, 7262,
     /* 126684 */     GIR_EraseRootFromParent_Done,
     /* 126685 */   // Label 2387: @126685
     /* 126685 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(126734), // Rule ID 7263 //
     /* 126690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126707 */     // MIs[0] Rn
     /* 126707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126719 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 126722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126732 */     GIR_RootConstrainSelectedInstOperands,
     /* 126733 */     // GIR_Coverage, 7263,
     /* 126733 */     GIR_EraseRootFromParent_Done,
     /* 126734 */   // Label 2388: @126734
     /* 126734 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(126783), // Rule ID 7264 //
     /* 126739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126756 */     // MIs[0] Rn
     /* 126756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126768 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 126771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126781 */     GIR_RootConstrainSelectedInstOperands,
     /* 126782 */     // GIR_Coverage, 7264,
     /* 126782 */     GIR_EraseRootFromParent_Done,
     /* 126783 */   // Label 2389: @126783
     /* 126783 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(126832), // Rule ID 7265 //
     /* 126788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126805 */     // MIs[0] Rn
     /* 126805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126817 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 126820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126830 */     GIR_RootConstrainSelectedInstOperands,
     /* 126831 */     // GIR_Coverage, 7265,
     /* 126831 */     GIR_EraseRootFromParent_Done,
     /* 126832 */   // Label 2390: @126832
     /* 126832 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(126881), // Rule ID 7266 //
     /* 126837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126840 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126847 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126854 */     // MIs[0] Rn
     /* 126854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126866 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126879 */     GIR_RootConstrainSelectedInstOperands,
     /* 126880 */     // GIR_Coverage, 7266,
     /* 126880 */     GIR_EraseRootFromParent_Done,
     /* 126881 */   // Label 2391: @126881
     /* 126881 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(126930), // Rule ID 7267 //
     /* 126886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126889 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126896 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126903 */     // MIs[0] Rn
     /* 126903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126915 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126928 */     GIR_RootConstrainSelectedInstOperands,
     /* 126929 */     // GIR_Coverage, 7267,
     /* 126929 */     GIR_EraseRootFromParent_Done,
     /* 126930 */   // Label 2392: @126930
     /* 126930 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(126979), // Rule ID 7268 //
     /* 126935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126952 */     // MIs[0] Rn
     /* 126952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126964 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 126967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126977 */     GIR_RootConstrainSelectedInstOperands,
     /* 126978 */     // GIR_Coverage, 7268,
     /* 126978 */     GIR_EraseRootFromParent_Done,
     /* 126979 */   // Label 2393: @126979
     /* 126979 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127028), // Rule ID 7269 //
     /* 126984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127001 */     // MIs[0] Rn
     /* 127001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127013 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127026 */     GIR_RootConstrainSelectedInstOperands,
     /* 127027 */     // GIR_Coverage, 7269,
     /* 127027 */     GIR_EraseRootFromParent_Done,
     /* 127028 */   // Label 2394: @127028
     /* 127028 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127077), // Rule ID 7270 //
     /* 127033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127050 */     // MIs[0] Rn
     /* 127050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127062 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 127065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127075 */     GIR_RootConstrainSelectedInstOperands,
     /* 127076 */     // GIR_Coverage, 7270,
     /* 127076 */     GIR_EraseRootFromParent_Done,
     /* 127077 */   // Label 2395: @127077
     /* 127077 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127126), // Rule ID 7271 //
     /* 127082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127099 */     // MIs[0] Rn
     /* 127099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127111 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127124 */     GIR_RootConstrainSelectedInstOperands,
     /* 127125 */     // GIR_Coverage, 7271,
     /* 127125 */     GIR_EraseRootFromParent_Done,
     /* 127126 */   // Label 2396: @127126
     /* 127126 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127175), // Rule ID 7272 //
     /* 127131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127148 */     // MIs[0] Rn
     /* 127148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127160 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127173 */     GIR_RootConstrainSelectedInstOperands,
     /* 127174 */     // GIR_Coverage, 7272,
     /* 127174 */     GIR_EraseRootFromParent_Done,
     /* 127175 */   // Label 2397: @127175
     /* 127175 */   GIM_Reject,
     /* 127176 */ // Label 2382: @127176
     /* 127176 */ GIM_Reject,
     /* 127177 */ // Label 2380: @127177
     /* 127177 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127403),
     /* 127182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127192 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127234), // Rule ID 7253 //
     /* 127197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127207 */     // MIs[0] Rn
     /* 127207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127219 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 127222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127232 */     GIR_RootConstrainSelectedInstOperands,
     /* 127233 */     // GIR_Coverage, 7253,
     /* 127233 */     GIR_EraseRootFromParent_Done,
     /* 127234 */   // Label 2399: @127234
     /* 127234 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(127276), // Rule ID 7254 //
     /* 127239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127249 */     // MIs[0] Rn
     /* 127249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127261 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 127264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127274 */     GIR_RootConstrainSelectedInstOperands,
     /* 127275 */     // GIR_Coverage, 7254,
     /* 127275 */     GIR_EraseRootFromParent_Done,
     /* 127276 */   // Label 2400: @127276
     /* 127276 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(127318), // Rule ID 7255 //
     /* 127281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127291 */     // MIs[0] Rn
     /* 127291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127303 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 127306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127316 */     GIR_RootConstrainSelectedInstOperands,
     /* 127317 */     // GIR_Coverage, 7255,
     /* 127317 */     GIR_EraseRootFromParent_Done,
     /* 127318 */   // Label 2401: @127318
     /* 127318 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(127360), // Rule ID 7256 //
     /* 127323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127333 */     // MIs[0] Rn
     /* 127333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127345 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127358 */     GIR_RootConstrainSelectedInstOperands,
     /* 127359 */     // GIR_Coverage, 7256,
     /* 127359 */     GIR_EraseRootFromParent_Done,
     /* 127360 */   // Label 2402: @127360
     /* 127360 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(127402), // Rule ID 7257 //
     /* 127365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127375 */     // MIs[0] Rn
     /* 127375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127387 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127400 */     GIR_RootConstrainSelectedInstOperands,
     /* 127401 */     // GIR_Coverage, 7257,
     /* 127401 */     GIR_EraseRootFromParent_Done,
     /* 127402 */   // Label 2403: @127402
     /* 127402 */   GIM_Reject,
     /* 127403 */ // Label 2398: @127403
     /* 127403 */ GIM_Reject,
     /* 127404 */ // Label 2381: @127404
     /* 127404 */ GIM_Reject,
     /* 127405 */ // Label 22: @127405
     /* 127405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2406*/ GIMT_Encode4(128396),
     /* 127416 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(127424),
     /* 127420 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(128169),
     /* 127424 */ // Label 2404: @127424
     /* 127424 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(128168),
     /* 127429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127432 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127481), // Rule ID 7098 //
     /* 127437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127454 */     // MIs[0] Rn
     /* 127454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127466 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 127469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127479 */     GIR_RootConstrainSelectedInstOperands,
     /* 127480 */     // GIR_Coverage, 7098,
     /* 127480 */     GIR_EraseRootFromParent_Done,
     /* 127481 */   // Label 2408: @127481
     /* 127481 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127530), // Rule ID 7099 //
     /* 127486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127503 */     // MIs[0] Rn
     /* 127503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127515 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 127518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127528 */     GIR_RootConstrainSelectedInstOperands,
     /* 127529 */     // GIR_Coverage, 7099,
     /* 127529 */     GIR_EraseRootFromParent_Done,
     /* 127530 */   // Label 2409: @127530
     /* 127530 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127579), // Rule ID 7100 //
     /* 127535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127552 */     // MIs[0] Rn
     /* 127552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127564 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 127567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127577 */     GIR_RootConstrainSelectedInstOperands,
     /* 127578 */     // GIR_Coverage, 7100,
     /* 127578 */     GIR_EraseRootFromParent_Done,
     /* 127579 */   // Label 2410: @127579
     /* 127579 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127628), // Rule ID 7101 //
     /* 127584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127587 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127601 */     // MIs[0] Rn
     /* 127601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127613 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127626 */     GIR_RootConstrainSelectedInstOperands,
     /* 127627 */     // GIR_Coverage, 7101,
     /* 127627 */     GIR_EraseRootFromParent_Done,
     /* 127628 */   // Label 2411: @127628
     /* 127628 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(127677), // Rule ID 7102 //
     /* 127633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127650 */     // MIs[0] Rn
     /* 127650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127662 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127675 */     GIR_RootConstrainSelectedInstOperands,
     /* 127676 */     // GIR_Coverage, 7102,
     /* 127676 */     GIR_EraseRootFromParent_Done,
     /* 127677 */   // Label 2412: @127677
     /* 127677 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(127726), // Rule ID 7103 //
     /* 127682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127685 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127699 */     // MIs[0] Rn
     /* 127699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127711 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 127714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127724 */     GIR_RootConstrainSelectedInstOperands,
     /* 127725 */     // GIR_Coverage, 7103,
     /* 127725 */     GIR_EraseRootFromParent_Done,
     /* 127726 */   // Label 2413: @127726
     /* 127726 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(127775), // Rule ID 7104 //
     /* 127731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127748 */     // MIs[0] Rn
     /* 127748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127760 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 127763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127773 */     GIR_RootConstrainSelectedInstOperands,
     /* 127774 */     // GIR_Coverage, 7104,
     /* 127774 */     GIR_EraseRootFromParent_Done,
     /* 127775 */   // Label 2414: @127775
     /* 127775 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(127824), // Rule ID 7105 //
     /* 127780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127783 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127790 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127797 */     // MIs[0] Rn
     /* 127797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127809 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 127812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127822 */     GIR_RootConstrainSelectedInstOperands,
     /* 127823 */     // GIR_Coverage, 7105,
     /* 127823 */     GIR_EraseRootFromParent_Done,
     /* 127824 */   // Label 2415: @127824
     /* 127824 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(127873), // Rule ID 7106 //
     /* 127829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127846 */     // MIs[0] Rn
     /* 127846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127858 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127871 */     GIR_RootConstrainSelectedInstOperands,
     /* 127872 */     // GIR_Coverage, 7106,
     /* 127872 */     GIR_EraseRootFromParent_Done,
     /* 127873 */   // Label 2416: @127873
     /* 127873 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(127922), // Rule ID 7107 //
     /* 127878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127881 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127888 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127895 */     // MIs[0] Rn
     /* 127895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127907 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127920 */     GIR_RootConstrainSelectedInstOperands,
     /* 127921 */     // GIR_Coverage, 7107,
     /* 127921 */     GIR_EraseRootFromParent_Done,
     /* 127922 */   // Label 2417: @127922
     /* 127922 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(127971), // Rule ID 7108 //
     /* 127927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127930 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127937 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127944 */     // MIs[0] Rn
     /* 127944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127956 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 127959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127969 */     GIR_RootConstrainSelectedInstOperands,
     /* 127970 */     // GIR_Coverage, 7108,
     /* 127970 */     GIR_EraseRootFromParent_Done,
     /* 127971 */   // Label 2418: @127971
     /* 127971 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128020), // Rule ID 7109 //
     /* 127976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127979 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127986 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127993 */     // MIs[0] Rn
     /* 127993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128005 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128018 */     GIR_RootConstrainSelectedInstOperands,
     /* 128019 */     // GIR_Coverage, 7109,
     /* 128019 */     GIR_EraseRootFromParent_Done,
     /* 128020 */   // Label 2419: @128020
     /* 128020 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128069), // Rule ID 7110 //
     /* 128025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128042 */     // MIs[0] Rn
     /* 128042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128054 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128067 */     GIR_RootConstrainSelectedInstOperands,
     /* 128068 */     // GIR_Coverage, 7110,
     /* 128068 */     GIR_EraseRootFromParent_Done,
     /* 128069 */   // Label 2420: @128069
     /* 128069 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128118), // Rule ID 7111 //
     /* 128074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128091 */     // MIs[0] Rn
     /* 128091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128103 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128116 */     GIR_RootConstrainSelectedInstOperands,
     /* 128117 */     // GIR_Coverage, 7111,
     /* 128117 */     GIR_EraseRootFromParent_Done,
     /* 128118 */   // Label 2421: @128118
     /* 128118 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128167), // Rule ID 7112 //
     /* 128123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128140 */     // MIs[0] Rn
     /* 128140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128152 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128165 */     GIR_RootConstrainSelectedInstOperands,
     /* 128166 */     // GIR_Coverage, 7112,
     /* 128166 */     GIR_EraseRootFromParent_Done,
     /* 128167 */   // Label 2422: @128167
     /* 128167 */   GIM_Reject,
     /* 128168 */ // Label 2407: @128168
     /* 128168 */ GIM_Reject,
     /* 128169 */ // Label 2405: @128169
     /* 128169 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128395),
     /* 128174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128177 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128184 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128226), // Rule ID 2579 //
     /* 128189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128199 */     // MIs[0] Rn
     /* 128199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128211 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 128214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128224 */     GIR_RootConstrainSelectedInstOperands,
     /* 128225 */     // GIR_Coverage, 2579,
     /* 128225 */     GIR_EraseRootFromParent_Done,
     /* 128226 */   // Label 2424: @128226
     /* 128226 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(128268), // Rule ID 2580 //
     /* 128231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128241 */     // MIs[0] Rn
     /* 128241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128253 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 128256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128266 */     GIR_RootConstrainSelectedInstOperands,
     /* 128267 */     // GIR_Coverage, 2580,
     /* 128267 */     GIR_EraseRootFromParent_Done,
     /* 128268 */   // Label 2425: @128268
     /* 128268 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(128310), // Rule ID 2581 //
     /* 128273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128283 */     // MIs[0] Rn
     /* 128283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128295 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 128298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128308 */     GIR_RootConstrainSelectedInstOperands,
     /* 128309 */     // GIR_Coverage, 2581,
     /* 128309 */     GIR_EraseRootFromParent_Done,
     /* 128310 */   // Label 2426: @128310
     /* 128310 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(128352), // Rule ID 2582 //
     /* 128315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128325 */     // MIs[0] Rn
     /* 128325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128337 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128350 */     GIR_RootConstrainSelectedInstOperands,
     /* 128351 */     // GIR_Coverage, 2582,
     /* 128351 */     GIR_EraseRootFromParent_Done,
     /* 128352 */   // Label 2427: @128352
     /* 128352 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(128394), // Rule ID 2583 //
     /* 128357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128367 */     // MIs[0] Rn
     /* 128367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128379 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128392 */     GIR_RootConstrainSelectedInstOperands,
     /* 128393 */     // GIR_Coverage, 2583,
     /* 128393 */     GIR_EraseRootFromParent_Done,
     /* 128394 */   // Label 2428: @128394
     /* 128394 */   GIM_Reject,
     /* 128395 */ // Label 2423: @128395
     /* 128395 */ GIM_Reject,
     /* 128396 */ // Label 2406: @128396
     /* 128396 */ GIM_Reject,
     /* 128397 */ // Label 23: @128397
     /* 128397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2431*/ GIMT_Encode4(129888),
     /* 128408 */ /*GILLT_s32*//*Label 2429*/ GIMT_Encode4(128416),
     /* 128412 */ /*GILLT_s64*//*Label 2430*/ GIMT_Encode4(129536),
     /* 128416 */ // Label 2429: @128416
     /* 128416 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(129535),
     /* 128421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128424 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(128498), // Rule ID 7293 //
     /* 128429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128446 */     // MIs[0] Rn
     /* 128446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128458 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128470 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128496 */     GIR_RootConstrainSelectedInstOperands,
     /* 128497 */     // GIR_Coverage, 7293,
     /* 128497 */     GIR_EraseRootFromParent_Done,
     /* 128498 */   // Label 2433: @128498
     /* 128498 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128572), // Rule ID 7294 //
     /* 128503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128520 */     // MIs[0] Rn
     /* 128520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128532 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128544 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128570 */     GIR_RootConstrainSelectedInstOperands,
     /* 128571 */     // GIR_Coverage, 7294,
     /* 128571 */     GIR_EraseRootFromParent_Done,
     /* 128572 */   // Label 2434: @128572
     /* 128572 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(128646), // Rule ID 7295 //
     /* 128577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128594 */     // MIs[0] Rn
     /* 128594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128606 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128618 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128644 */     GIR_RootConstrainSelectedInstOperands,
     /* 128645 */     // GIR_Coverage, 7295,
     /* 128645 */     GIR_EraseRootFromParent_Done,
     /* 128646 */   // Label 2435: @128646
     /* 128646 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(128720), // Rule ID 7296 //
     /* 128651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128668 */     // MIs[0] Rn
     /* 128668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128680 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128692 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128718 */     GIR_RootConstrainSelectedInstOperands,
     /* 128719 */     // GIR_Coverage, 7296,
     /* 128719 */     GIR_EraseRootFromParent_Done,
     /* 128720 */   // Label 2436: @128720
     /* 128720 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(128794), // Rule ID 7297 //
     /* 128725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128742 */     // MIs[0] Rn
     /* 128742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128754 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128766 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128792 */     GIR_RootConstrainSelectedInstOperands,
     /* 128793 */     // GIR_Coverage, 7297,
     /* 128793 */     GIR_EraseRootFromParent_Done,
     /* 128794 */   // Label 2437: @128794
     /* 128794 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(128868), // Rule ID 7298 //
     /* 128799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128816 */     // MIs[0] Rn
     /* 128816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128828 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128840 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128866 */     GIR_RootConstrainSelectedInstOperands,
     /* 128867 */     // GIR_Coverage, 7298,
     /* 128867 */     GIR_EraseRootFromParent_Done,
     /* 128868 */   // Label 2438: @128868
     /* 128868 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(128942), // Rule ID 7299 //
     /* 128873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128890 */     // MIs[0] Rn
     /* 128890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128902 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128914 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128940 */     GIR_RootConstrainSelectedInstOperands,
     /* 128941 */     // GIR_Coverage, 7299,
     /* 128941 */     GIR_EraseRootFromParent_Done,
     /* 128942 */   // Label 2439: @128942
     /* 128942 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(129016), // Rule ID 7300 //
     /* 128947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128964 */     // MIs[0] Rn
     /* 128964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128976 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128988 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129014 */     GIR_RootConstrainSelectedInstOperands,
     /* 129015 */     // GIR_Coverage, 7300,
     /* 129015 */     GIR_EraseRootFromParent_Done,
     /* 129016 */   // Label 2440: @129016
     /* 129016 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129090), // Rule ID 7301 //
     /* 129021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129038 */     // MIs[0] Rn
     /* 129038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129050 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129062 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129088 */     GIR_RootConstrainSelectedInstOperands,
     /* 129089 */     // GIR_Coverage, 7301,
     /* 129089 */     GIR_EraseRootFromParent_Done,
     /* 129090 */   // Label 2441: @129090
     /* 129090 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129164), // Rule ID 7302 //
     /* 129095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129112 */     // MIs[0] Rn
     /* 129112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129124 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129136 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129162 */     GIR_RootConstrainSelectedInstOperands,
     /* 129163 */     // GIR_Coverage, 7302,
     /* 129163 */     GIR_EraseRootFromParent_Done,
     /* 129164 */   // Label 2442: @129164
     /* 129164 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129238), // Rule ID 7303 //
     /* 129169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129186 */     // MIs[0] Rn
     /* 129186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129198 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129210 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 129225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129236 */     GIR_RootConstrainSelectedInstOperands,
     /* 129237 */     // GIR_Coverage, 7303,
     /* 129237 */     GIR_EraseRootFromParent_Done,
     /* 129238 */   // Label 2443: @129238
     /* 129238 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129312), // Rule ID 7304 //
     /* 129243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129260 */     // MIs[0] Rn
     /* 129260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129272 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129284 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 129299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129310 */     GIR_RootConstrainSelectedInstOperands,
     /* 129311 */     // GIR_Coverage, 7304,
     /* 129311 */     GIR_EraseRootFromParent_Done,
     /* 129312 */   // Label 2444: @129312
     /* 129312 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129386), // Rule ID 7305 //
     /* 129317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129334 */     // MIs[0] Rn
     /* 129334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129346 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129358 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129384 */     GIR_RootConstrainSelectedInstOperands,
     /* 129385 */     // GIR_Coverage, 7305,
     /* 129385 */     GIR_EraseRootFromParent_Done,
     /* 129386 */   // Label 2445: @129386
     /* 129386 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(129460), // Rule ID 7306 //
     /* 129391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129408 */     // MIs[0] Rn
     /* 129408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129420 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129432 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129458 */     GIR_RootConstrainSelectedInstOperands,
     /* 129459 */     // GIR_Coverage, 7306,
     /* 129459 */     GIR_EraseRootFromParent_Done,
     /* 129460 */   // Label 2446: @129460
     /* 129460 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(129534), // Rule ID 7307 //
     /* 129465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129482 */     // MIs[0] Rn
     /* 129482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129494 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129532 */     GIR_RootConstrainSelectedInstOperands,
     /* 129533 */     // GIR_Coverage, 7307,
     /* 129533 */     GIR_EraseRootFromParent_Done,
     /* 129534 */   // Label 2447: @129534
     /* 129534 */   GIM_Reject,
     /* 129535 */ // Label 2432: @129535
     /* 129535 */ GIM_Reject,
     /* 129536 */ // Label 2430: @129536
     /* 129536 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(129887),
     /* 129541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129551 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(129618), // Rule ID 7288 //
     /* 129556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129566 */     // MIs[0] Rn
     /* 129566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129578 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129590 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129616 */     GIR_RootConstrainSelectedInstOperands,
     /* 129617 */     // GIR_Coverage, 7288,
     /* 129617 */     GIR_EraseRootFromParent_Done,
     /* 129618 */   // Label 2449: @129618
     /* 129618 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(129685), // Rule ID 7289 //
     /* 129623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129633 */     // MIs[0] Rn
     /* 129633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129645 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129657 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129683 */     GIR_RootConstrainSelectedInstOperands,
     /* 129684 */     // GIR_Coverage, 7289,
     /* 129684 */     GIR_EraseRootFromParent_Done,
     /* 129685 */   // Label 2450: @129685
     /* 129685 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(129752), // Rule ID 7290 //
     /* 129690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129700 */     // MIs[0] Rn
     /* 129700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129712 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129724 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129750 */     GIR_RootConstrainSelectedInstOperands,
     /* 129751 */     // GIR_Coverage, 7290,
     /* 129751 */     GIR_EraseRootFromParent_Done,
     /* 129752 */   // Label 2451: @129752
     /* 129752 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(129819), // Rule ID 7291 //
     /* 129757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129767 */     // MIs[0] Rn
     /* 129767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129779 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129791 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129817 */     GIR_RootConstrainSelectedInstOperands,
     /* 129818 */     // GIR_Coverage, 7291,
     /* 129818 */     GIR_EraseRootFromParent_Done,
     /* 129819 */   // Label 2452: @129819
     /* 129819 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(129886), // Rule ID 7292 //
     /* 129824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129834 */     // MIs[0] Rn
     /* 129834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129846 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129884 */     GIR_RootConstrainSelectedInstOperands,
     /* 129885 */     // GIR_Coverage, 7292,
     /* 129885 */     GIR_EraseRootFromParent_Done,
     /* 129886 */   // Label 2453: @129886
     /* 129886 */   GIM_Reject,
     /* 129887 */ // Label 2448: @129887
     /* 129887 */ GIM_Reject,
     /* 129888 */ // Label 2431: @129888
     /* 129888 */ GIM_Reject,
     /* 129889 */ // Label 24: @129889
     /* 129889 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2456*/ GIMT_Encode4(131380),
     /* 129900 */ /*GILLT_s32*//*Label 2454*/ GIMT_Encode4(129908),
     /* 129904 */ /*GILLT_s64*//*Label 2455*/ GIMT_Encode4(131028),
     /* 129908 */ // Label 2454: @129908
     /* 129908 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(131027),
     /* 129913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129916 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(129990), // Rule ID 7313 //
     /* 129921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129938 */     // MIs[0] Rn
     /* 129938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129950 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129962 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 129977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129988 */     GIR_RootConstrainSelectedInstOperands,
     /* 129989 */     // GIR_Coverage, 7313,
     /* 129989 */     GIR_EraseRootFromParent_Done,
     /* 129990 */   // Label 2458: @129990
     /* 129990 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(130064), // Rule ID 7314 //
     /* 129995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130012 */     // MIs[0] Rn
     /* 130012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130024 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 130051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130062 */     GIR_RootConstrainSelectedInstOperands,
     /* 130063 */     // GIR_Coverage, 7314,
     /* 130063 */     GIR_EraseRootFromParent_Done,
     /* 130064 */   // Label 2459: @130064
     /* 130064 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(130138), // Rule ID 7315 //
     /* 130069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130086 */     // MIs[0] Rn
     /* 130086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130098 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130110 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 130125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130136 */     GIR_RootConstrainSelectedInstOperands,
     /* 130137 */     // GIR_Coverage, 7315,
     /* 130137 */     GIR_EraseRootFromParent_Done,
     /* 130138 */   // Label 2460: @130138
     /* 130138 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(130212), // Rule ID 7316 //
     /* 130143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130160 */     // MIs[0] Rn
     /* 130160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130172 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130184 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130210 */     GIR_RootConstrainSelectedInstOperands,
     /* 130211 */     // GIR_Coverage, 7316,
     /* 130211 */     GIR_EraseRootFromParent_Done,
     /* 130212 */   // Label 2461: @130212
     /* 130212 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(130286), // Rule ID 7317 //
     /* 130217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130234 */     // MIs[0] Rn
     /* 130234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130246 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130284 */     GIR_RootConstrainSelectedInstOperands,
     /* 130285 */     // GIR_Coverage, 7317,
     /* 130285 */     GIR_EraseRootFromParent_Done,
     /* 130286 */   // Label 2462: @130286
     /* 130286 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130360), // Rule ID 7318 //
     /* 130291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130308 */     // MIs[0] Rn
     /* 130308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130320 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130332 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 130347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130358 */     GIR_RootConstrainSelectedInstOperands,
     /* 130359 */     // GIR_Coverage, 7318,
     /* 130359 */     GIR_EraseRootFromParent_Done,
     /* 130360 */   // Label 2463: @130360
     /* 130360 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(130434), // Rule ID 7319 //
     /* 130365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130382 */     // MIs[0] Rn
     /* 130382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130394 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130406 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 130421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130432 */     GIR_RootConstrainSelectedInstOperands,
     /* 130433 */     // GIR_Coverage, 7319,
     /* 130433 */     GIR_EraseRootFromParent_Done,
     /* 130434 */   // Label 2464: @130434
     /* 130434 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(130508), // Rule ID 7320 //
     /* 130439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130456 */     // MIs[0] Rn
     /* 130456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130468 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130480 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 130495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130506 */     GIR_RootConstrainSelectedInstOperands,
     /* 130507 */     // GIR_Coverage, 7320,
     /* 130507 */     GIR_EraseRootFromParent_Done,
     /* 130508 */   // Label 2465: @130508
     /* 130508 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(130582), // Rule ID 7321 //
     /* 130513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130530 */     // MIs[0] Rn
     /* 130530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130542 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130554 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130580 */     GIR_RootConstrainSelectedInstOperands,
     /* 130581 */     // GIR_Coverage, 7321,
     /* 130581 */     GIR_EraseRootFromParent_Done,
     /* 130582 */   // Label 2466: @130582
     /* 130582 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(130656), // Rule ID 7322 //
     /* 130587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130604 */     // MIs[0] Rn
     /* 130604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130616 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130628 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130654 */     GIR_RootConstrainSelectedInstOperands,
     /* 130655 */     // GIR_Coverage, 7322,
     /* 130655 */     GIR_EraseRootFromParent_Done,
     /* 130656 */   // Label 2467: @130656
     /* 130656 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(130730), // Rule ID 7323 //
     /* 130661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130678 */     // MIs[0] Rn
     /* 130678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130690 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130702 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 130717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130728 */     GIR_RootConstrainSelectedInstOperands,
     /* 130729 */     // GIR_Coverage, 7323,
     /* 130729 */     GIR_EraseRootFromParent_Done,
     /* 130730 */   // Label 2468: @130730
     /* 130730 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(130804), // Rule ID 7324 //
     /* 130735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130752 */     // MIs[0] Rn
     /* 130752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130764 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130776 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 130791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130802 */     GIR_RootConstrainSelectedInstOperands,
     /* 130803 */     // GIR_Coverage, 7324,
     /* 130803 */     GIR_EraseRootFromParent_Done,
     /* 130804 */   // Label 2469: @130804
     /* 130804 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(130878), // Rule ID 7325 //
     /* 130809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130826 */     // MIs[0] Rn
     /* 130826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130838 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130850 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 130865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130876 */     GIR_RootConstrainSelectedInstOperands,
     /* 130877 */     // GIR_Coverage, 7325,
     /* 130877 */     GIR_EraseRootFromParent_Done,
     /* 130878 */   // Label 2470: @130878
     /* 130878 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(130952), // Rule ID 7326 //
     /* 130883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130900 */     // MIs[0] Rn
     /* 130900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130912 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130924 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130950 */     GIR_RootConstrainSelectedInstOperands,
     /* 130951 */     // GIR_Coverage, 7326,
     /* 130951 */     GIR_EraseRootFromParent_Done,
     /* 130952 */   // Label 2471: @130952
     /* 130952 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(131026), // Rule ID 7327 //
     /* 130957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130974 */     // MIs[0] Rn
     /* 130974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130986 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130998 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131024 */     GIR_RootConstrainSelectedInstOperands,
     /* 131025 */     // GIR_Coverage, 7327,
     /* 131025 */     GIR_EraseRootFromParent_Done,
     /* 131026 */   // Label 2472: @131026
     /* 131026 */   GIM_Reject,
     /* 131027 */ // Label 2457: @131027
     /* 131027 */ GIM_Reject,
     /* 131028 */ // Label 2455: @131028
     /* 131028 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131379),
     /* 131033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131036 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131043 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131110), // Rule ID 7308 //
     /* 131048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131058 */     // MIs[0] Rn
     /* 131058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131070 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131082 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 131097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131108 */     GIR_RootConstrainSelectedInstOperands,
     /* 131109 */     // GIR_Coverage, 7308,
     /* 131109 */     GIR_EraseRootFromParent_Done,
     /* 131110 */   // Label 2474: @131110
     /* 131110 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131177), // Rule ID 7309 //
     /* 131115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131125 */     // MIs[0] Rn
     /* 131125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131137 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131149 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 131164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131175 */     GIR_RootConstrainSelectedInstOperands,
     /* 131176 */     // GIR_Coverage, 7309,
     /* 131176 */     GIR_EraseRootFromParent_Done,
     /* 131177 */   // Label 2475: @131177
     /* 131177 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(131244), // Rule ID 7310 //
     /* 131182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131192 */     // MIs[0] Rn
     /* 131192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131204 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131216 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 131231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131242 */     GIR_RootConstrainSelectedInstOperands,
     /* 131243 */     // GIR_Coverage, 7310,
     /* 131243 */     GIR_EraseRootFromParent_Done,
     /* 131244 */   // Label 2476: @131244
     /* 131244 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131311), // Rule ID 7311 //
     /* 131249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131259 */     // MIs[0] Rn
     /* 131259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131271 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131283 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131309 */     GIR_RootConstrainSelectedInstOperands,
     /* 131310 */     // GIR_Coverage, 7311,
     /* 131310 */     GIR_EraseRootFromParent_Done,
     /* 131311 */   // Label 2477: @131311
     /* 131311 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(131378), // Rule ID 7312 //
     /* 131316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131326 */     // MIs[0] Rn
     /* 131326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131338 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131350 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131376 */     GIR_RootConstrainSelectedInstOperands,
     /* 131377 */     // GIR_Coverage, 7312,
     /* 131377 */     GIR_EraseRootFromParent_Done,
     /* 131378 */   // Label 2478: @131378
     /* 131378 */   GIM_Reject,
     /* 131379 */ // Label 2473: @131379
     /* 131379 */ GIM_Reject,
     /* 131380 */ // Label 2456: @131380
     /* 131380 */ GIM_Reject,
     /* 131381 */ // Label 25: @131381
     /* 131381 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2481*/ GIMT_Encode4(132372),
     /* 131392 */ /*GILLT_s32*//*Label 2479*/ GIMT_Encode4(131400),
     /* 131396 */ /*GILLT_s64*//*Label 2480*/ GIMT_Encode4(132145),
     /* 131400 */ // Label 2479: @131400
     /* 131400 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(132144),
     /* 131405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131408 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(131457), // Rule ID 7118 //
     /* 131413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131430 */     // MIs[0] Rn
     /* 131430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131442 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 131445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131455 */     GIR_RootConstrainSelectedInstOperands,
     /* 131456 */     // GIR_Coverage, 7118,
     /* 131456 */     GIR_EraseRootFromParent_Done,
     /* 131457 */   // Label 2483: @131457
     /* 131457 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(131506), // Rule ID 7119 //
     /* 131462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131479 */     // MIs[0] Rn
     /* 131479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131491 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 131494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131504 */     GIR_RootConstrainSelectedInstOperands,
     /* 131505 */     // GIR_Coverage, 7119,
     /* 131505 */     GIR_EraseRootFromParent_Done,
     /* 131506 */   // Label 2484: @131506
     /* 131506 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(131555), // Rule ID 7120 //
     /* 131511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131528 */     // MIs[0] Rn
     /* 131528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131540 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 131543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131553 */     GIR_RootConstrainSelectedInstOperands,
     /* 131554 */     // GIR_Coverage, 7120,
     /* 131554 */     GIR_EraseRootFromParent_Done,
     /* 131555 */   // Label 2485: @131555
     /* 131555 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(131604), // Rule ID 7121 //
     /* 131560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131577 */     // MIs[0] Rn
     /* 131577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131589 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131602 */     GIR_RootConstrainSelectedInstOperands,
     /* 131603 */     // GIR_Coverage, 7121,
     /* 131603 */     GIR_EraseRootFromParent_Done,
     /* 131604 */   // Label 2486: @131604
     /* 131604 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(131653), // Rule ID 7122 //
     /* 131609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131626 */     // MIs[0] Rn
     /* 131626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131638 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131651 */     GIR_RootConstrainSelectedInstOperands,
     /* 131652 */     // GIR_Coverage, 7122,
     /* 131652 */     GIR_EraseRootFromParent_Done,
     /* 131653 */   // Label 2487: @131653
     /* 131653 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(131702), // Rule ID 7123 //
     /* 131658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131675 */     // MIs[0] Rn
     /* 131675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131687 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 131690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131700 */     GIR_RootConstrainSelectedInstOperands,
     /* 131701 */     // GIR_Coverage, 7123,
     /* 131701 */     GIR_EraseRootFromParent_Done,
     /* 131702 */   // Label 2488: @131702
     /* 131702 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(131751), // Rule ID 7124 //
     /* 131707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131724 */     // MIs[0] Rn
     /* 131724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131736 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 131739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131749 */     GIR_RootConstrainSelectedInstOperands,
     /* 131750 */     // GIR_Coverage, 7124,
     /* 131750 */     GIR_EraseRootFromParent_Done,
     /* 131751 */   // Label 2489: @131751
     /* 131751 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(131800), // Rule ID 7125 //
     /* 131756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131759 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131766 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131773 */     // MIs[0] Rn
     /* 131773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131785 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 131788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131798 */     GIR_RootConstrainSelectedInstOperands,
     /* 131799 */     // GIR_Coverage, 7125,
     /* 131799 */     GIR_EraseRootFromParent_Done,
     /* 131800 */   // Label 2490: @131800
     /* 131800 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(131849), // Rule ID 7126 //
     /* 131805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131822 */     // MIs[0] Rn
     /* 131822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131834 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131847 */     GIR_RootConstrainSelectedInstOperands,
     /* 131848 */     // GIR_Coverage, 7126,
     /* 131848 */     GIR_EraseRootFromParent_Done,
     /* 131849 */   // Label 2491: @131849
     /* 131849 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(131898), // Rule ID 7127 //
     /* 131854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131871 */     // MIs[0] Rn
     /* 131871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131883 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131896 */     GIR_RootConstrainSelectedInstOperands,
     /* 131897 */     // GIR_Coverage, 7127,
     /* 131897 */     GIR_EraseRootFromParent_Done,
     /* 131898 */   // Label 2492: @131898
     /* 131898 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(131947), // Rule ID 7128 //
     /* 131903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131920 */     // MIs[0] Rn
     /* 131920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131932 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 131935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131945 */     GIR_RootConstrainSelectedInstOperands,
     /* 131946 */     // GIR_Coverage, 7128,
     /* 131946 */     GIR_EraseRootFromParent_Done,
     /* 131947 */   // Label 2493: @131947
     /* 131947 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(131996), // Rule ID 7129 //
     /* 131952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131969 */     // MIs[0] Rn
     /* 131969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131981 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 131984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131994 */     GIR_RootConstrainSelectedInstOperands,
     /* 131995 */     // GIR_Coverage, 7129,
     /* 131995 */     GIR_EraseRootFromParent_Done,
     /* 131996 */   // Label 2494: @131996
     /* 131996 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132045), // Rule ID 7130 //
     /* 132001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132004 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132018 */     // MIs[0] Rn
     /* 132018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132030 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132043 */     GIR_RootConstrainSelectedInstOperands,
     /* 132044 */     // GIR_Coverage, 7130,
     /* 132044 */     GIR_EraseRootFromParent_Done,
     /* 132045 */   // Label 2495: @132045
     /* 132045 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132094), // Rule ID 7131 //
     /* 132050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132053 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132060 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132067 */     // MIs[0] Rn
     /* 132067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132079 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132092 */     GIR_RootConstrainSelectedInstOperands,
     /* 132093 */     // GIR_Coverage, 7131,
     /* 132093 */     GIR_EraseRootFromParent_Done,
     /* 132094 */   // Label 2496: @132094
     /* 132094 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132143), // Rule ID 7132 //
     /* 132099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132102 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132109 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132116 */     // MIs[0] Rn
     /* 132116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132128 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132141 */     GIR_RootConstrainSelectedInstOperands,
     /* 132142 */     // GIR_Coverage, 7132,
     /* 132142 */     GIR_EraseRootFromParent_Done,
     /* 132143 */   // Label 2497: @132143
     /* 132143 */   GIM_Reject,
     /* 132144 */ // Label 2482: @132144
     /* 132144 */ GIM_Reject,
     /* 132145 */ // Label 2480: @132145
     /* 132145 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132371),
     /* 132150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132153 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132160 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132202), // Rule ID 7113 //
     /* 132165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132175 */     // MIs[0] Rn
     /* 132175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132187 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 132190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132200 */     GIR_RootConstrainSelectedInstOperands,
     /* 132201 */     // GIR_Coverage, 7113,
     /* 132201 */     GIR_EraseRootFromParent_Done,
     /* 132202 */   // Label 2499: @132202
     /* 132202 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132244), // Rule ID 7114 //
     /* 132207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132217 */     // MIs[0] Rn
     /* 132217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132229 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 132232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132242 */     GIR_RootConstrainSelectedInstOperands,
     /* 132243 */     // GIR_Coverage, 7114,
     /* 132243 */     GIR_EraseRootFromParent_Done,
     /* 132244 */   // Label 2500: @132244
     /* 132244 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(132286), // Rule ID 7115 //
     /* 132249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132259 */     // MIs[0] Rn
     /* 132259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132271 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 132274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132284 */     GIR_RootConstrainSelectedInstOperands,
     /* 132285 */     // GIR_Coverage, 7115,
     /* 132285 */     GIR_EraseRootFromParent_Done,
     /* 132286 */   // Label 2501: @132286
     /* 132286 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(132328), // Rule ID 7116 //
     /* 132291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132301 */     // MIs[0] Rn
     /* 132301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132313 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132326 */     GIR_RootConstrainSelectedInstOperands,
     /* 132327 */     // GIR_Coverage, 7116,
     /* 132327 */     GIR_EraseRootFromParent_Done,
     /* 132328 */   // Label 2502: @132328
     /* 132328 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(132370), // Rule ID 7117 //
     /* 132333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132343 */     // MIs[0] Rn
     /* 132343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132355 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132368 */     GIR_RootConstrainSelectedInstOperands,
     /* 132369 */     // GIR_Coverage, 7117,
     /* 132369 */     GIR_EraseRootFromParent_Done,
     /* 132370 */   // Label 2503: @132370
     /* 132370 */   GIM_Reject,
     /* 132371 */ // Label 2498: @132371
     /* 132371 */ GIM_Reject,
     /* 132372 */ // Label 2481: @132372
     /* 132372 */ GIM_Reject,
     /* 132373 */ // Label 26: @132373
     /* 132373 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2506*/ GIMT_Encode4(133364),
     /* 132384 */ /*GILLT_s32*//*Label 2504*/ GIMT_Encode4(132392),
     /* 132388 */ /*GILLT_s64*//*Label 2505*/ GIMT_Encode4(133137),
     /* 132392 */ // Label 2504: @132392
     /* 132392 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(133136),
     /* 132397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132400 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(132449), // Rule ID 7138 //
     /* 132405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132422 */     // MIs[0] Rn
     /* 132422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132434 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 132437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132447 */     GIR_RootConstrainSelectedInstOperands,
     /* 132448 */     // GIR_Coverage, 7138,
     /* 132448 */     GIR_EraseRootFromParent_Done,
     /* 132449 */   // Label 2508: @132449
     /* 132449 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(132498), // Rule ID 7139 //
     /* 132454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132471 */     // MIs[0] Rn
     /* 132471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132483 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 132486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132496 */     GIR_RootConstrainSelectedInstOperands,
     /* 132497 */     // GIR_Coverage, 7139,
     /* 132497 */     GIR_EraseRootFromParent_Done,
     /* 132498 */   // Label 2509: @132498
     /* 132498 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(132547), // Rule ID 7140 //
     /* 132503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132520 */     // MIs[0] Rn
     /* 132520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132532 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 132535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132545 */     GIR_RootConstrainSelectedInstOperands,
     /* 132546 */     // GIR_Coverage, 7140,
     /* 132546 */     GIR_EraseRootFromParent_Done,
     /* 132547 */   // Label 2510: @132547
     /* 132547 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(132596), // Rule ID 7141 //
     /* 132552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132569 */     // MIs[0] Rn
     /* 132569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132581 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132594 */     GIR_RootConstrainSelectedInstOperands,
     /* 132595 */     // GIR_Coverage, 7141,
     /* 132595 */     GIR_EraseRootFromParent_Done,
     /* 132596 */   // Label 2511: @132596
     /* 132596 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(132645), // Rule ID 7142 //
     /* 132601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132618 */     // MIs[0] Rn
     /* 132618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132630 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132643 */     GIR_RootConstrainSelectedInstOperands,
     /* 132644 */     // GIR_Coverage, 7142,
     /* 132644 */     GIR_EraseRootFromParent_Done,
     /* 132645 */   // Label 2512: @132645
     /* 132645 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(132694), // Rule ID 7143 //
     /* 132650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132667 */     // MIs[0] Rn
     /* 132667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132679 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 132682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132692 */     GIR_RootConstrainSelectedInstOperands,
     /* 132693 */     // GIR_Coverage, 7143,
     /* 132693 */     GIR_EraseRootFromParent_Done,
     /* 132694 */   // Label 2513: @132694
     /* 132694 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(132743), // Rule ID 7144 //
     /* 132699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132716 */     // MIs[0] Rn
     /* 132716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132728 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 132731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132741 */     GIR_RootConstrainSelectedInstOperands,
     /* 132742 */     // GIR_Coverage, 7144,
     /* 132742 */     GIR_EraseRootFromParent_Done,
     /* 132743 */   // Label 2514: @132743
     /* 132743 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(132792), // Rule ID 7145 //
     /* 132748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132765 */     // MIs[0] Rn
     /* 132765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132777 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 132780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132790 */     GIR_RootConstrainSelectedInstOperands,
     /* 132791 */     // GIR_Coverage, 7145,
     /* 132791 */     GIR_EraseRootFromParent_Done,
     /* 132792 */   // Label 2515: @132792
     /* 132792 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(132841), // Rule ID 7146 //
     /* 132797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132814 */     // MIs[0] Rn
     /* 132814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132826 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132839 */     GIR_RootConstrainSelectedInstOperands,
     /* 132840 */     // GIR_Coverage, 7146,
     /* 132840 */     GIR_EraseRootFromParent_Done,
     /* 132841 */   // Label 2516: @132841
     /* 132841 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(132890), // Rule ID 7147 //
     /* 132846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132863 */     // MIs[0] Rn
     /* 132863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132875 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132888 */     GIR_RootConstrainSelectedInstOperands,
     /* 132889 */     // GIR_Coverage, 7147,
     /* 132889 */     GIR_EraseRootFromParent_Done,
     /* 132890 */   // Label 2517: @132890
     /* 132890 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(132939), // Rule ID 7148 //
     /* 132895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132912 */     // MIs[0] Rn
     /* 132912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132924 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 132927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132937 */     GIR_RootConstrainSelectedInstOperands,
     /* 132938 */     // GIR_Coverage, 7148,
     /* 132938 */     GIR_EraseRootFromParent_Done,
     /* 132939 */   // Label 2518: @132939
     /* 132939 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(132988), // Rule ID 7149 //
     /* 132944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132961 */     // MIs[0] Rn
     /* 132961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132973 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 132976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132986 */     GIR_RootConstrainSelectedInstOperands,
     /* 132987 */     // GIR_Coverage, 7149,
     /* 132987 */     GIR_EraseRootFromParent_Done,
     /* 132988 */   // Label 2519: @132988
     /* 132988 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133037), // Rule ID 7150 //
     /* 132993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133010 */     // MIs[0] Rn
     /* 133010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133022 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133035 */     GIR_RootConstrainSelectedInstOperands,
     /* 133036 */     // GIR_Coverage, 7150,
     /* 133036 */     GIR_EraseRootFromParent_Done,
     /* 133037 */   // Label 2520: @133037
     /* 133037 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133086), // Rule ID 7151 //
     /* 133042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133045 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133052 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133059 */     // MIs[0] Rn
     /* 133059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133071 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133084 */     GIR_RootConstrainSelectedInstOperands,
     /* 133085 */     // GIR_Coverage, 7151,
     /* 133085 */     GIR_EraseRootFromParent_Done,
     /* 133086 */   // Label 2521: @133086
     /* 133086 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133135), // Rule ID 7152 //
     /* 133091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133094 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133101 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133108 */     // MIs[0] Rn
     /* 133108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133120 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133133 */     GIR_RootConstrainSelectedInstOperands,
     /* 133134 */     // GIR_Coverage, 7152,
     /* 133134 */     GIR_EraseRootFromParent_Done,
     /* 133135 */   // Label 2522: @133135
     /* 133135 */   GIM_Reject,
     /* 133136 */ // Label 2507: @133136
     /* 133136 */ GIM_Reject,
     /* 133137 */ // Label 2505: @133137
     /* 133137 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133363),
     /* 133142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133152 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133194), // Rule ID 7133 //
     /* 133157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133167 */     // MIs[0] Rn
     /* 133167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133179 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 133182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133192 */     GIR_RootConstrainSelectedInstOperands,
     /* 133193 */     // GIR_Coverage, 7133,
     /* 133193 */     GIR_EraseRootFromParent_Done,
     /* 133194 */   // Label 2524: @133194
     /* 133194 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133236), // Rule ID 7134 //
     /* 133199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133209 */     // MIs[0] Rn
     /* 133209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133221 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 133224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133234 */     GIR_RootConstrainSelectedInstOperands,
     /* 133235 */     // GIR_Coverage, 7134,
     /* 133235 */     GIR_EraseRootFromParent_Done,
     /* 133236 */   // Label 2525: @133236
     /* 133236 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(133278), // Rule ID 7135 //
     /* 133241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133251 */     // MIs[0] Rn
     /* 133251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133263 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 133266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133276 */     GIR_RootConstrainSelectedInstOperands,
     /* 133277 */     // GIR_Coverage, 7135,
     /* 133277 */     GIR_EraseRootFromParent_Done,
     /* 133278 */   // Label 2526: @133278
     /* 133278 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(133320), // Rule ID 7136 //
     /* 133283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133293 */     // MIs[0] Rn
     /* 133293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133305 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133318 */     GIR_RootConstrainSelectedInstOperands,
     /* 133319 */     // GIR_Coverage, 7136,
     /* 133319 */     GIR_EraseRootFromParent_Done,
     /* 133320 */   // Label 2527: @133320
     /* 133320 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(133362), // Rule ID 7137 //
     /* 133325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133335 */     // MIs[0] Rn
     /* 133335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133347 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133360 */     GIR_RootConstrainSelectedInstOperands,
     /* 133361 */     // GIR_Coverage, 7137,
     /* 133361 */     GIR_EraseRootFromParent_Done,
     /* 133362 */   // Label 2528: @133362
     /* 133362 */   GIM_Reject,
     /* 133363 */ // Label 2523: @133363
     /* 133363 */ GIM_Reject,
     /* 133364 */ // Label 2506: @133364
     /* 133364 */ GIM_Reject,
     /* 133365 */ // Label 27: @133365
     /* 133365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(134356),
     /* 133376 */ /*GILLT_s32*//*Label 2529*/ GIMT_Encode4(133384),
     /* 133380 */ /*GILLT_s64*//*Label 2530*/ GIMT_Encode4(134129),
     /* 133384 */ // Label 2529: @133384
     /* 133384 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(134128),
     /* 133389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133392 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(133441), // Rule ID 7178 //
     /* 133397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133414 */     // MIs[0] Rn
     /* 133414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133426 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 133429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133439 */     GIR_RootConstrainSelectedInstOperands,
     /* 133440 */     // GIR_Coverage, 7178,
     /* 133440 */     GIR_EraseRootFromParent_Done,
     /* 133441 */   // Label 2533: @133441
     /* 133441 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(133490), // Rule ID 7179 //
     /* 133446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133463 */     // MIs[0] Rn
     /* 133463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133475 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 133478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133488 */     GIR_RootConstrainSelectedInstOperands,
     /* 133489 */     // GIR_Coverage, 7179,
     /* 133489 */     GIR_EraseRootFromParent_Done,
     /* 133490 */   // Label 2534: @133490
     /* 133490 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(133539), // Rule ID 7180 //
     /* 133495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133512 */     // MIs[0] Rn
     /* 133512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133524 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 133527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133537 */     GIR_RootConstrainSelectedInstOperands,
     /* 133538 */     // GIR_Coverage, 7180,
     /* 133538 */     GIR_EraseRootFromParent_Done,
     /* 133539 */   // Label 2535: @133539
     /* 133539 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(133588), // Rule ID 7181 //
     /* 133544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133561 */     // MIs[0] Rn
     /* 133561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133573 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133586 */     GIR_RootConstrainSelectedInstOperands,
     /* 133587 */     // GIR_Coverage, 7181,
     /* 133587 */     GIR_EraseRootFromParent_Done,
     /* 133588 */   // Label 2536: @133588
     /* 133588 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(133637), // Rule ID 7182 //
     /* 133593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133610 */     // MIs[0] Rn
     /* 133610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133622 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133635 */     GIR_RootConstrainSelectedInstOperands,
     /* 133636 */     // GIR_Coverage, 7182,
     /* 133636 */     GIR_EraseRootFromParent_Done,
     /* 133637 */   // Label 2537: @133637
     /* 133637 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(133686), // Rule ID 7183 //
     /* 133642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133659 */     // MIs[0] Rn
     /* 133659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133671 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 133674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133684 */     GIR_RootConstrainSelectedInstOperands,
     /* 133685 */     // GIR_Coverage, 7183,
     /* 133685 */     GIR_EraseRootFromParent_Done,
     /* 133686 */   // Label 2538: @133686
     /* 133686 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(133735), // Rule ID 7184 //
     /* 133691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133708 */     // MIs[0] Rn
     /* 133708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133720 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 133723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133733 */     GIR_RootConstrainSelectedInstOperands,
     /* 133734 */     // GIR_Coverage, 7184,
     /* 133734 */     GIR_EraseRootFromParent_Done,
     /* 133735 */   // Label 2539: @133735
     /* 133735 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(133784), // Rule ID 7185 //
     /* 133740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133757 */     // MIs[0] Rn
     /* 133757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133769 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 133772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133782 */     GIR_RootConstrainSelectedInstOperands,
     /* 133783 */     // GIR_Coverage, 7185,
     /* 133783 */     GIR_EraseRootFromParent_Done,
     /* 133784 */   // Label 2540: @133784
     /* 133784 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(133833), // Rule ID 7186 //
     /* 133789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133806 */     // MIs[0] Rn
     /* 133806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133818 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133831 */     GIR_RootConstrainSelectedInstOperands,
     /* 133832 */     // GIR_Coverage, 7186,
     /* 133832 */     GIR_EraseRootFromParent_Done,
     /* 133833 */   // Label 2541: @133833
     /* 133833 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(133882), // Rule ID 7187 //
     /* 133838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133855 */     // MIs[0] Rn
     /* 133855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133867 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133880 */     GIR_RootConstrainSelectedInstOperands,
     /* 133881 */     // GIR_Coverage, 7187,
     /* 133881 */     GIR_EraseRootFromParent_Done,
     /* 133882 */   // Label 2542: @133882
     /* 133882 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(133931), // Rule ID 7188 //
     /* 133887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133904 */     // MIs[0] Rn
     /* 133904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133916 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 133919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133929 */     GIR_RootConstrainSelectedInstOperands,
     /* 133930 */     // GIR_Coverage, 7188,
     /* 133930 */     GIR_EraseRootFromParent_Done,
     /* 133931 */   // Label 2543: @133931
     /* 133931 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(133980), // Rule ID 7189 //
     /* 133936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133953 */     // MIs[0] Rn
     /* 133953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133965 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 133968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133978 */     GIR_RootConstrainSelectedInstOperands,
     /* 133979 */     // GIR_Coverage, 7189,
     /* 133979 */     GIR_EraseRootFromParent_Done,
     /* 133980 */   // Label 2544: @133980
     /* 133980 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134029), // Rule ID 7190 //
     /* 133985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134002 */     // MIs[0] Rn
     /* 134002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134014 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134027 */     GIR_RootConstrainSelectedInstOperands,
     /* 134028 */     // GIR_Coverage, 7190,
     /* 134028 */     GIR_EraseRootFromParent_Done,
     /* 134029 */   // Label 2545: @134029
     /* 134029 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134078), // Rule ID 7191 //
     /* 134034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134051 */     // MIs[0] Rn
     /* 134051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134063 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134076 */     GIR_RootConstrainSelectedInstOperands,
     /* 134077 */     // GIR_Coverage, 7191,
     /* 134077 */     GIR_EraseRootFromParent_Done,
     /* 134078 */   // Label 2546: @134078
     /* 134078 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134127), // Rule ID 7192 //
     /* 134083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134086 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134100 */     // MIs[0] Rn
     /* 134100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134112 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134125 */     GIR_RootConstrainSelectedInstOperands,
     /* 134126 */     // GIR_Coverage, 7192,
     /* 134126 */     GIR_EraseRootFromParent_Done,
     /* 134127 */   // Label 2547: @134127
     /* 134127 */   GIM_Reject,
     /* 134128 */ // Label 2532: @134128
     /* 134128 */ GIM_Reject,
     /* 134129 */ // Label 2530: @134129
     /* 134129 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134355),
     /* 134134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134144 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134186), // Rule ID 7173 //
     /* 134149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134159 */     // MIs[0] Rn
     /* 134159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134171 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 134174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134184 */     GIR_RootConstrainSelectedInstOperands,
     /* 134185 */     // GIR_Coverage, 7173,
     /* 134185 */     GIR_EraseRootFromParent_Done,
     /* 134186 */   // Label 2549: @134186
     /* 134186 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134228), // Rule ID 7174 //
     /* 134191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134201 */     // MIs[0] Rn
     /* 134201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134213 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 134216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134226 */     GIR_RootConstrainSelectedInstOperands,
     /* 134227 */     // GIR_Coverage, 7174,
     /* 134227 */     GIR_EraseRootFromParent_Done,
     /* 134228 */   // Label 2550: @134228
     /* 134228 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(134270), // Rule ID 7175 //
     /* 134233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134243 */     // MIs[0] Rn
     /* 134243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134255 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 134258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134268 */     GIR_RootConstrainSelectedInstOperands,
     /* 134269 */     // GIR_Coverage, 7175,
     /* 134269 */     GIR_EraseRootFromParent_Done,
     /* 134270 */   // Label 2551: @134270
     /* 134270 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(134312), // Rule ID 7176 //
     /* 134275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134285 */     // MIs[0] Rn
     /* 134285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134297 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134310 */     GIR_RootConstrainSelectedInstOperands,
     /* 134311 */     // GIR_Coverage, 7176,
     /* 134311 */     GIR_EraseRootFromParent_Done,
     /* 134312 */   // Label 2552: @134312
     /* 134312 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(134354), // Rule ID 7177 //
     /* 134317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134327 */     // MIs[0] Rn
     /* 134327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134339 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134352 */     GIR_RootConstrainSelectedInstOperands,
     /* 134353 */     // GIR_Coverage, 7177,
     /* 134353 */     GIR_EraseRootFromParent_Done,
     /* 134354 */   // Label 2553: @134354
     /* 134354 */   GIM_Reject,
     /* 134355 */ // Label 2548: @134355
     /* 134355 */ GIM_Reject,
     /* 134356 */ // Label 2531: @134356
     /* 134356 */ GIM_Reject,
     /* 134357 */ // Label 28: @134357
     /* 134357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2556*/ GIMT_Encode4(135348),
     /* 134368 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(134376),
     /* 134372 */ /*GILLT_s64*//*Label 2555*/ GIMT_Encode4(135121),
     /* 134376 */ // Label 2554: @134376
     /* 134376 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(135120),
     /* 134381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134384 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134433), // Rule ID 7198 //
     /* 134389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134406 */     // MIs[0] Rn
     /* 134406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134418 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 134421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134431 */     GIR_RootConstrainSelectedInstOperands,
     /* 134432 */     // GIR_Coverage, 7198,
     /* 134432 */     GIR_EraseRootFromParent_Done,
     /* 134433 */   // Label 2558: @134433
     /* 134433 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134482), // Rule ID 7199 //
     /* 134438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134455 */     // MIs[0] Rn
     /* 134455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134467 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 134470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134480 */     GIR_RootConstrainSelectedInstOperands,
     /* 134481 */     // GIR_Coverage, 7199,
     /* 134481 */     GIR_EraseRootFromParent_Done,
     /* 134482 */   // Label 2559: @134482
     /* 134482 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134531), // Rule ID 7200 //
     /* 134487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134504 */     // MIs[0] Rn
     /* 134504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134516 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 134519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134529 */     GIR_RootConstrainSelectedInstOperands,
     /* 134530 */     // GIR_Coverage, 7200,
     /* 134530 */     GIR_EraseRootFromParent_Done,
     /* 134531 */   // Label 2560: @134531
     /* 134531 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134580), // Rule ID 7201 //
     /* 134536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134553 */     // MIs[0] Rn
     /* 134553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134565 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134578 */     GIR_RootConstrainSelectedInstOperands,
     /* 134579 */     // GIR_Coverage, 7201,
     /* 134579 */     GIR_EraseRootFromParent_Done,
     /* 134580 */   // Label 2561: @134580
     /* 134580 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(134629), // Rule ID 7202 //
     /* 134585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134602 */     // MIs[0] Rn
     /* 134602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134614 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134627 */     GIR_RootConstrainSelectedInstOperands,
     /* 134628 */     // GIR_Coverage, 7202,
     /* 134628 */     GIR_EraseRootFromParent_Done,
     /* 134629 */   // Label 2562: @134629
     /* 134629 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(134678), // Rule ID 7203 //
     /* 134634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134651 */     // MIs[0] Rn
     /* 134651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134663 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 134666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134676 */     GIR_RootConstrainSelectedInstOperands,
     /* 134677 */     // GIR_Coverage, 7203,
     /* 134677 */     GIR_EraseRootFromParent_Done,
     /* 134678 */   // Label 2563: @134678
     /* 134678 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(134727), // Rule ID 7204 //
     /* 134683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134700 */     // MIs[0] Rn
     /* 134700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134712 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 134715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134725 */     GIR_RootConstrainSelectedInstOperands,
     /* 134726 */     // GIR_Coverage, 7204,
     /* 134726 */     GIR_EraseRootFromParent_Done,
     /* 134727 */   // Label 2564: @134727
     /* 134727 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(134776), // Rule ID 7205 //
     /* 134732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134749 */     // MIs[0] Rn
     /* 134749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134761 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 134764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134774 */     GIR_RootConstrainSelectedInstOperands,
     /* 134775 */     // GIR_Coverage, 7205,
     /* 134775 */     GIR_EraseRootFromParent_Done,
     /* 134776 */   // Label 2565: @134776
     /* 134776 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(134825), // Rule ID 7206 //
     /* 134781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134798 */     // MIs[0] Rn
     /* 134798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134810 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134823 */     GIR_RootConstrainSelectedInstOperands,
     /* 134824 */     // GIR_Coverage, 7206,
     /* 134824 */     GIR_EraseRootFromParent_Done,
     /* 134825 */   // Label 2566: @134825
     /* 134825 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(134874), // Rule ID 7207 //
     /* 134830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134847 */     // MIs[0] Rn
     /* 134847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134859 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134872 */     GIR_RootConstrainSelectedInstOperands,
     /* 134873 */     // GIR_Coverage, 7207,
     /* 134873 */     GIR_EraseRootFromParent_Done,
     /* 134874 */   // Label 2567: @134874
     /* 134874 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(134923), // Rule ID 7208 //
     /* 134879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134896 */     // MIs[0] Rn
     /* 134896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134908 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 134911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134921 */     GIR_RootConstrainSelectedInstOperands,
     /* 134922 */     // GIR_Coverage, 7208,
     /* 134922 */     GIR_EraseRootFromParent_Done,
     /* 134923 */   // Label 2568: @134923
     /* 134923 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(134972), // Rule ID 7209 //
     /* 134928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134945 */     // MIs[0] Rn
     /* 134945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134957 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 134960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134970 */     GIR_RootConstrainSelectedInstOperands,
     /* 134971 */     // GIR_Coverage, 7209,
     /* 134971 */     GIR_EraseRootFromParent_Done,
     /* 134972 */   // Label 2569: @134972
     /* 134972 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135021), // Rule ID 7210 //
     /* 134977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134994 */     // MIs[0] Rn
     /* 134994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135006 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135019 */     GIR_RootConstrainSelectedInstOperands,
     /* 135020 */     // GIR_Coverage, 7210,
     /* 135020 */     GIR_EraseRootFromParent_Done,
     /* 135021 */   // Label 2570: @135021
     /* 135021 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135070), // Rule ID 7211 //
     /* 135026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135043 */     // MIs[0] Rn
     /* 135043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135055 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135068 */     GIR_RootConstrainSelectedInstOperands,
     /* 135069 */     // GIR_Coverage, 7211,
     /* 135069 */     GIR_EraseRootFromParent_Done,
     /* 135070 */   // Label 2571: @135070
     /* 135070 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135119), // Rule ID 7212 //
     /* 135075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135092 */     // MIs[0] Rn
     /* 135092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135104 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135117 */     GIR_RootConstrainSelectedInstOperands,
     /* 135118 */     // GIR_Coverage, 7212,
     /* 135118 */     GIR_EraseRootFromParent_Done,
     /* 135119 */   // Label 2572: @135119
     /* 135119 */   GIM_Reject,
     /* 135120 */ // Label 2557: @135120
     /* 135120 */ GIM_Reject,
     /* 135121 */ // Label 2555: @135121
     /* 135121 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135347),
     /* 135126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135136 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135178), // Rule ID 7193 //
     /* 135141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135151 */     // MIs[0] Rn
     /* 135151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135163 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 135166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135176 */     GIR_RootConstrainSelectedInstOperands,
     /* 135177 */     // GIR_Coverage, 7193,
     /* 135177 */     GIR_EraseRootFromParent_Done,
     /* 135178 */   // Label 2574: @135178
     /* 135178 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135220), // Rule ID 7194 //
     /* 135183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135193 */     // MIs[0] Rn
     /* 135193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135205 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 135208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135218 */     GIR_RootConstrainSelectedInstOperands,
     /* 135219 */     // GIR_Coverage, 7194,
     /* 135219 */     GIR_EraseRootFromParent_Done,
     /* 135220 */   // Label 2575: @135220
     /* 135220 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(135262), // Rule ID 7195 //
     /* 135225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135235 */     // MIs[0] Rn
     /* 135235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135247 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 135250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135260 */     GIR_RootConstrainSelectedInstOperands,
     /* 135261 */     // GIR_Coverage, 7195,
     /* 135261 */     GIR_EraseRootFromParent_Done,
     /* 135262 */   // Label 2576: @135262
     /* 135262 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(135304), // Rule ID 7196 //
     /* 135267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135277 */     // MIs[0] Rn
     /* 135277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135289 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135302 */     GIR_RootConstrainSelectedInstOperands,
     /* 135303 */     // GIR_Coverage, 7196,
     /* 135303 */     GIR_EraseRootFromParent_Done,
     /* 135304 */   // Label 2577: @135304
     /* 135304 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(135346), // Rule ID 7197 //
     /* 135309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135319 */     // MIs[0] Rn
     /* 135319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135331 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135344 */     GIR_RootConstrainSelectedInstOperands,
     /* 135345 */     // GIR_Coverage, 7197,
     /* 135345 */     GIR_EraseRootFromParent_Done,
     /* 135346 */   // Label 2578: @135346
     /* 135346 */   GIM_Reject,
     /* 135347 */ // Label 2573: @135347
     /* 135347 */ GIM_Reject,
     /* 135348 */ // Label 2556: @135348
     /* 135348 */ GIM_Reject,
     /* 135349 */ // Label 29: @135349
     /* 135349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2581*/ GIMT_Encode4(136340),
     /* 135360 */ /*GILLT_s32*//*Label 2579*/ GIMT_Encode4(135368),
     /* 135364 */ /*GILLT_s64*//*Label 2580*/ GIMT_Encode4(136113),
     /* 135368 */ // Label 2579: @135368
     /* 135368 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(136112),
     /* 135373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135376 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135425), // Rule ID 7218 //
     /* 135381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135398 */     // MIs[0] Rn
     /* 135398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135410 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 135413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135423 */     GIR_RootConstrainSelectedInstOperands,
     /* 135424 */     // GIR_Coverage, 7218,
     /* 135424 */     GIR_EraseRootFromParent_Done,
     /* 135425 */   // Label 2583: @135425
     /* 135425 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135474), // Rule ID 7219 //
     /* 135430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135447 */     // MIs[0] Rn
     /* 135447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135459 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 135462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135472 */     GIR_RootConstrainSelectedInstOperands,
     /* 135473 */     // GIR_Coverage, 7219,
     /* 135473 */     GIR_EraseRootFromParent_Done,
     /* 135474 */   // Label 2584: @135474
     /* 135474 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135523), // Rule ID 7220 //
     /* 135479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135496 */     // MIs[0] Rn
     /* 135496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135508 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 135511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135521 */     GIR_RootConstrainSelectedInstOperands,
     /* 135522 */     // GIR_Coverage, 7220,
     /* 135522 */     GIR_EraseRootFromParent_Done,
     /* 135523 */   // Label 2585: @135523
     /* 135523 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135572), // Rule ID 7221 //
     /* 135528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135545 */     // MIs[0] Rn
     /* 135545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135557 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135570 */     GIR_RootConstrainSelectedInstOperands,
     /* 135571 */     // GIR_Coverage, 7221,
     /* 135571 */     GIR_EraseRootFromParent_Done,
     /* 135572 */   // Label 2586: @135572
     /* 135572 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(135621), // Rule ID 7222 //
     /* 135577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135594 */     // MIs[0] Rn
     /* 135594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135606 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135619 */     GIR_RootConstrainSelectedInstOperands,
     /* 135620 */     // GIR_Coverage, 7222,
     /* 135620 */     GIR_EraseRootFromParent_Done,
     /* 135621 */   // Label 2587: @135621
     /* 135621 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(135670), // Rule ID 7223 //
     /* 135626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135643 */     // MIs[0] Rn
     /* 135643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135655 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 135658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135668 */     GIR_RootConstrainSelectedInstOperands,
     /* 135669 */     // GIR_Coverage, 7223,
     /* 135669 */     GIR_EraseRootFromParent_Done,
     /* 135670 */   // Label 2588: @135670
     /* 135670 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(135719), // Rule ID 7224 //
     /* 135675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135692 */     // MIs[0] Rn
     /* 135692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135704 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 135707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135717 */     GIR_RootConstrainSelectedInstOperands,
     /* 135718 */     // GIR_Coverage, 7224,
     /* 135718 */     GIR_EraseRootFromParent_Done,
     /* 135719 */   // Label 2589: @135719
     /* 135719 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(135768), // Rule ID 7225 //
     /* 135724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135741 */     // MIs[0] Rn
     /* 135741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135753 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 135756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135766 */     GIR_RootConstrainSelectedInstOperands,
     /* 135767 */     // GIR_Coverage, 7225,
     /* 135767 */     GIR_EraseRootFromParent_Done,
     /* 135768 */   // Label 2590: @135768
     /* 135768 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(135817), // Rule ID 7226 //
     /* 135773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135790 */     // MIs[0] Rn
     /* 135790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135802 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135815 */     GIR_RootConstrainSelectedInstOperands,
     /* 135816 */     // GIR_Coverage, 7226,
     /* 135816 */     GIR_EraseRootFromParent_Done,
     /* 135817 */   // Label 2591: @135817
     /* 135817 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(135866), // Rule ID 7227 //
     /* 135822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135839 */     // MIs[0] Rn
     /* 135839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135851 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135864 */     GIR_RootConstrainSelectedInstOperands,
     /* 135865 */     // GIR_Coverage, 7227,
     /* 135865 */     GIR_EraseRootFromParent_Done,
     /* 135866 */   // Label 2592: @135866
     /* 135866 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(135915), // Rule ID 7228 //
     /* 135871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135888 */     // MIs[0] Rn
     /* 135888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135900 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 135903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135913 */     GIR_RootConstrainSelectedInstOperands,
     /* 135914 */     // GIR_Coverage, 7228,
     /* 135914 */     GIR_EraseRootFromParent_Done,
     /* 135915 */   // Label 2593: @135915
     /* 135915 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(135964), // Rule ID 7229 //
     /* 135920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135937 */     // MIs[0] Rn
     /* 135937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135949 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 135952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135962 */     GIR_RootConstrainSelectedInstOperands,
     /* 135963 */     // GIR_Coverage, 7229,
     /* 135963 */     GIR_EraseRootFromParent_Done,
     /* 135964 */   // Label 2594: @135964
     /* 135964 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136013), // Rule ID 7230 //
     /* 135969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135986 */     // MIs[0] Rn
     /* 135986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135998 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136011 */     GIR_RootConstrainSelectedInstOperands,
     /* 136012 */     // GIR_Coverage, 7230,
     /* 136012 */     GIR_EraseRootFromParent_Done,
     /* 136013 */   // Label 2595: @136013
     /* 136013 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136062), // Rule ID 7231 //
     /* 136018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136035 */     // MIs[0] Rn
     /* 136035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136047 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136060 */     GIR_RootConstrainSelectedInstOperands,
     /* 136061 */     // GIR_Coverage, 7231,
     /* 136061 */     GIR_EraseRootFromParent_Done,
     /* 136062 */   // Label 2596: @136062
     /* 136062 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136111), // Rule ID 7232 //
     /* 136067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136084 */     // MIs[0] Rn
     /* 136084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136096 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136109 */     GIR_RootConstrainSelectedInstOperands,
     /* 136110 */     // GIR_Coverage, 7232,
     /* 136110 */     GIR_EraseRootFromParent_Done,
     /* 136111 */   // Label 2597: @136111
     /* 136111 */   GIM_Reject,
     /* 136112 */ // Label 2582: @136112
     /* 136112 */ GIM_Reject,
     /* 136113 */ // Label 2580: @136113
     /* 136113 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136339),
     /* 136118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136128 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136170), // Rule ID 7213 //
     /* 136133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136143 */     // MIs[0] Rn
     /* 136143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136155 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 136158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136168 */     GIR_RootConstrainSelectedInstOperands,
     /* 136169 */     // GIR_Coverage, 7213,
     /* 136169 */     GIR_EraseRootFromParent_Done,
     /* 136170 */   // Label 2599: @136170
     /* 136170 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136212), // Rule ID 7214 //
     /* 136175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136185 */     // MIs[0] Rn
     /* 136185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136197 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 136200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136210 */     GIR_RootConstrainSelectedInstOperands,
     /* 136211 */     // GIR_Coverage, 7214,
     /* 136211 */     GIR_EraseRootFromParent_Done,
     /* 136212 */   // Label 2600: @136212
     /* 136212 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(136254), // Rule ID 7215 //
     /* 136217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136227 */     // MIs[0] Rn
     /* 136227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136239 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 136242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136252 */     GIR_RootConstrainSelectedInstOperands,
     /* 136253 */     // GIR_Coverage, 7215,
     /* 136253 */     GIR_EraseRootFromParent_Done,
     /* 136254 */   // Label 2601: @136254
     /* 136254 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(136296), // Rule ID 7216 //
     /* 136259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136269 */     // MIs[0] Rn
     /* 136269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136281 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136294 */     GIR_RootConstrainSelectedInstOperands,
     /* 136295 */     // GIR_Coverage, 7216,
     /* 136295 */     GIR_EraseRootFromParent_Done,
     /* 136296 */   // Label 2602: @136296
     /* 136296 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(136338), // Rule ID 7217 //
     /* 136301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136311 */     // MIs[0] Rn
     /* 136311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136323 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136336 */     GIR_RootConstrainSelectedInstOperands,
     /* 136337 */     // GIR_Coverage, 7217,
     /* 136337 */     GIR_EraseRootFromParent_Done,
     /* 136338 */   // Label 2603: @136338
     /* 136338 */   GIM_Reject,
     /* 136339 */ // Label 2598: @136339
     /* 136339 */ GIM_Reject,
     /* 136340 */ // Label 2581: @136340
     /* 136340 */ GIM_Reject,
     /* 136341 */ // Label 30: @136341
     /* 136341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2606*/ GIMT_Encode4(137332),
     /* 136352 */ /*GILLT_s32*//*Label 2604*/ GIMT_Encode4(136360),
     /* 136356 */ /*GILLT_s64*//*Label 2605*/ GIMT_Encode4(137105),
     /* 136360 */ // Label 2604: @136360
     /* 136360 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(137104),
     /* 136365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136368 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136417), // Rule ID 7238 //
     /* 136373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136390 */     // MIs[0] Rn
     /* 136390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136402 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 136405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136415 */     GIR_RootConstrainSelectedInstOperands,
     /* 136416 */     // GIR_Coverage, 7238,
     /* 136416 */     GIR_EraseRootFromParent_Done,
     /* 136417 */   // Label 2608: @136417
     /* 136417 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136466), // Rule ID 7239 //
     /* 136422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136439 */     // MIs[0] Rn
     /* 136439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136451 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 136454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136464 */     GIR_RootConstrainSelectedInstOperands,
     /* 136465 */     // GIR_Coverage, 7239,
     /* 136465 */     GIR_EraseRootFromParent_Done,
     /* 136466 */   // Label 2609: @136466
     /* 136466 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136515), // Rule ID 7240 //
     /* 136471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136488 */     // MIs[0] Rn
     /* 136488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136500 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 136503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136513 */     GIR_RootConstrainSelectedInstOperands,
     /* 136514 */     // GIR_Coverage, 7240,
     /* 136514 */     GIR_EraseRootFromParent_Done,
     /* 136515 */   // Label 2610: @136515
     /* 136515 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136564), // Rule ID 7241 //
     /* 136520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136537 */     // MIs[0] Rn
     /* 136537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136549 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136562 */     GIR_RootConstrainSelectedInstOperands,
     /* 136563 */     // GIR_Coverage, 7241,
     /* 136563 */     GIR_EraseRootFromParent_Done,
     /* 136564 */   // Label 2611: @136564
     /* 136564 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(136613), // Rule ID 7242 //
     /* 136569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136586 */     // MIs[0] Rn
     /* 136586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136598 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136611 */     GIR_RootConstrainSelectedInstOperands,
     /* 136612 */     // GIR_Coverage, 7242,
     /* 136612 */     GIR_EraseRootFromParent_Done,
     /* 136613 */   // Label 2612: @136613
     /* 136613 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(136662), // Rule ID 7243 //
     /* 136618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136635 */     // MIs[0] Rn
     /* 136635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136647 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 136650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136660 */     GIR_RootConstrainSelectedInstOperands,
     /* 136661 */     // GIR_Coverage, 7243,
     /* 136661 */     GIR_EraseRootFromParent_Done,
     /* 136662 */   // Label 2613: @136662
     /* 136662 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(136711), // Rule ID 7244 //
     /* 136667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136684 */     // MIs[0] Rn
     /* 136684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136696 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 136699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136709 */     GIR_RootConstrainSelectedInstOperands,
     /* 136710 */     // GIR_Coverage, 7244,
     /* 136710 */     GIR_EraseRootFromParent_Done,
     /* 136711 */   // Label 2614: @136711
     /* 136711 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(136760), // Rule ID 7245 //
     /* 136716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136733 */     // MIs[0] Rn
     /* 136733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136745 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 136748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136758 */     GIR_RootConstrainSelectedInstOperands,
     /* 136759 */     // GIR_Coverage, 7245,
     /* 136759 */     GIR_EraseRootFromParent_Done,
     /* 136760 */   // Label 2615: @136760
     /* 136760 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(136809), // Rule ID 7246 //
     /* 136765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136782 */     // MIs[0] Rn
     /* 136782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136794 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136807 */     GIR_RootConstrainSelectedInstOperands,
     /* 136808 */     // GIR_Coverage, 7246,
     /* 136808 */     GIR_EraseRootFromParent_Done,
     /* 136809 */   // Label 2616: @136809
     /* 136809 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(136858), // Rule ID 7247 //
     /* 136814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136831 */     // MIs[0] Rn
     /* 136831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136843 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136856 */     GIR_RootConstrainSelectedInstOperands,
     /* 136857 */     // GIR_Coverage, 7247,
     /* 136857 */     GIR_EraseRootFromParent_Done,
     /* 136858 */   // Label 2617: @136858
     /* 136858 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(136907), // Rule ID 7248 //
     /* 136863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136880 */     // MIs[0] Rn
     /* 136880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136892 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 136895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136905 */     GIR_RootConstrainSelectedInstOperands,
     /* 136906 */     // GIR_Coverage, 7248,
     /* 136906 */     GIR_EraseRootFromParent_Done,
     /* 136907 */   // Label 2618: @136907
     /* 136907 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(136956), // Rule ID 7249 //
     /* 136912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136929 */     // MIs[0] Rn
     /* 136929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136941 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 136944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136954 */     GIR_RootConstrainSelectedInstOperands,
     /* 136955 */     // GIR_Coverage, 7249,
     /* 136955 */     GIR_EraseRootFromParent_Done,
     /* 136956 */   // Label 2619: @136956
     /* 136956 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137005), // Rule ID 7250 //
     /* 136961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136978 */     // MIs[0] Rn
     /* 136978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136990 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 136993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137003 */     GIR_RootConstrainSelectedInstOperands,
     /* 137004 */     // GIR_Coverage, 7250,
     /* 137004 */     GIR_EraseRootFromParent_Done,
     /* 137005 */   // Label 2620: @137005
     /* 137005 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137054), // Rule ID 7251 //
     /* 137010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137027 */     // MIs[0] Rn
     /* 137027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137039 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137052 */     GIR_RootConstrainSelectedInstOperands,
     /* 137053 */     // GIR_Coverage, 7251,
     /* 137053 */     GIR_EraseRootFromParent_Done,
     /* 137054 */   // Label 2621: @137054
     /* 137054 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137103), // Rule ID 7252 //
     /* 137059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137076 */     // MIs[0] Rn
     /* 137076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137088 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137101 */     GIR_RootConstrainSelectedInstOperands,
     /* 137102 */     // GIR_Coverage, 7252,
     /* 137102 */     GIR_EraseRootFromParent_Done,
     /* 137103 */   // Label 2622: @137103
     /* 137103 */   GIM_Reject,
     /* 137104 */ // Label 2607: @137104
     /* 137104 */ GIM_Reject,
     /* 137105 */ // Label 2605: @137105
     /* 137105 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137331),
     /* 137110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137120 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137162), // Rule ID 7233 //
     /* 137125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137135 */     // MIs[0] Rn
     /* 137135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137147 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 137150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137160 */     GIR_RootConstrainSelectedInstOperands,
     /* 137161 */     // GIR_Coverage, 7233,
     /* 137161 */     GIR_EraseRootFromParent_Done,
     /* 137162 */   // Label 2624: @137162
     /* 137162 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137204), // Rule ID 7234 //
     /* 137167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137177 */     // MIs[0] Rn
     /* 137177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137189 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 137192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137202 */     GIR_RootConstrainSelectedInstOperands,
     /* 137203 */     // GIR_Coverage, 7234,
     /* 137203 */     GIR_EraseRootFromParent_Done,
     /* 137204 */   // Label 2625: @137204
     /* 137204 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(137246), // Rule ID 7235 //
     /* 137209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137219 */     // MIs[0] Rn
     /* 137219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137231 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 137234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137244 */     GIR_RootConstrainSelectedInstOperands,
     /* 137245 */     // GIR_Coverage, 7235,
     /* 137245 */     GIR_EraseRootFromParent_Done,
     /* 137246 */   // Label 2626: @137246
     /* 137246 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(137288), // Rule ID 7236 //
     /* 137251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137261 */     // MIs[0] Rn
     /* 137261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137273 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137286 */     GIR_RootConstrainSelectedInstOperands,
     /* 137287 */     // GIR_Coverage, 7236,
     /* 137287 */     GIR_EraseRootFromParent_Done,
     /* 137288 */   // Label 2627: @137288
     /* 137288 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(137330), // Rule ID 7237 //
     /* 137293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137303 */     // MIs[0] Rn
     /* 137303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137315 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137328 */     GIR_RootConstrainSelectedInstOperands,
     /* 137329 */     // GIR_Coverage, 7237,
     /* 137329 */     GIR_EraseRootFromParent_Done,
     /* 137330 */   // Label 2628: @137330
     /* 137330 */   GIM_Reject,
     /* 137331 */ // Label 2623: @137331
     /* 137331 */ GIM_Reject,
     /* 137332 */ // Label 2606: @137332
     /* 137332 */ GIM_Reject,
     /* 137333 */ // Label 31: @137333
     /* 137333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2632*/ GIMT_Encode4(138037),
     /* 137344 */ /*GILLT_s16*//*Label 2629*/ GIMT_Encode4(137356),
     /* 137348 */ /*GILLT_s32*//*Label 2630*/ GIMT_Encode4(137583),
     /* 137352 */ /*GILLT_s64*//*Label 2631*/ GIMT_Encode4(137810),
     /* 137356 */ // Label 2629: @137356
     /* 137356 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(137582),
     /* 137361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137371 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(137413), // Rule ID 2584 //
     /* 137376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137386 */     // MIs[0] Rn
     /* 137386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137398 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 137401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137411 */     GIR_RootConstrainSelectedInstOperands,
     /* 137412 */     // GIR_Coverage, 2584,
     /* 137412 */     GIR_EraseRootFromParent_Done,
     /* 137413 */   // Label 2634: @137413
     /* 137413 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(137455), // Rule ID 2585 //
     /* 137418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137428 */     // MIs[0] Rn
     /* 137428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137440 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137453 */     GIR_RootConstrainSelectedInstOperands,
     /* 137454 */     // GIR_Coverage, 2585,
     /* 137454 */     GIR_EraseRootFromParent_Done,
     /* 137455 */   // Label 2635: @137455
     /* 137455 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137497), // Rule ID 2586 //
     /* 137460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137470 */     // MIs[0] Rn
     /* 137470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137482 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 137485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137495 */     GIR_RootConstrainSelectedInstOperands,
     /* 137496 */     // GIR_Coverage, 2586,
     /* 137496 */     GIR_EraseRootFromParent_Done,
     /* 137497 */   // Label 2636: @137497
     /* 137497 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(137539), // Rule ID 2587 //
     /* 137502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137512 */     // MIs[0] Rn
     /* 137512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137524 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137537 */     GIR_RootConstrainSelectedInstOperands,
     /* 137538 */     // GIR_Coverage, 2587,
     /* 137538 */     GIR_EraseRootFromParent_Done,
     /* 137539 */   // Label 2637: @137539
     /* 137539 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(137581), // Rule ID 2588 //
     /* 137544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137554 */     // MIs[0] Rn
     /* 137554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137566 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137579 */     GIR_RootConstrainSelectedInstOperands,
     /* 137580 */     // GIR_Coverage, 2588,
     /* 137580 */     GIR_EraseRootFromParent_Done,
     /* 137581 */   // Label 2638: @137581
     /* 137581 */   GIM_Reject,
     /* 137582 */ // Label 2633: @137582
     /* 137582 */ GIM_Reject,
     /* 137583 */ // Label 2630: @137583
     /* 137583 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(137809),
     /* 137588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137598 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(137640), // Rule ID 7328 //
     /* 137603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137613 */     // MIs[0] Rn
     /* 137613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137625 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 137628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137638 */     GIR_RootConstrainSelectedInstOperands,
     /* 137639 */     // GIR_Coverage, 7328,
     /* 137639 */     GIR_EraseRootFromParent_Done,
     /* 137640 */   // Label 2640: @137640
     /* 137640 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(137682), // Rule ID 7329 //
     /* 137645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137655 */     // MIs[0] Rn
     /* 137655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137667 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 137670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137680 */     GIR_RootConstrainSelectedInstOperands,
     /* 137681 */     // GIR_Coverage, 7329,
     /* 137681 */     GIR_EraseRootFromParent_Done,
     /* 137682 */   // Label 2641: @137682
     /* 137682 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137724), // Rule ID 7330 //
     /* 137687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137697 */     // MIs[0] Rn
     /* 137697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137709 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 137712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137722 */     GIR_RootConstrainSelectedInstOperands,
     /* 137723 */     // GIR_Coverage, 7330,
     /* 137723 */     GIR_EraseRootFromParent_Done,
     /* 137724 */   // Label 2642: @137724
     /* 137724 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137766), // Rule ID 7331 //
     /* 137729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137739 */     // MIs[0] Rn
     /* 137739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137751 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137764 */     GIR_RootConstrainSelectedInstOperands,
     /* 137765 */     // GIR_Coverage, 7331,
     /* 137765 */     GIR_EraseRootFromParent_Done,
     /* 137766 */   // Label 2643: @137766
     /* 137766 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(137808), // Rule ID 7332 //
     /* 137771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137781 */     // MIs[0] Rn
     /* 137781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137793 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137806 */     GIR_RootConstrainSelectedInstOperands,
     /* 137807 */     // GIR_Coverage, 7332,
     /* 137807 */     GIR_EraseRootFromParent_Done,
     /* 137808 */   // Label 2644: @137808
     /* 137808 */   GIM_Reject,
     /* 137809 */ // Label 2639: @137809
     /* 137809 */ GIM_Reject,
     /* 137810 */ // Label 2631: @137810
     /* 137810 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138036),
     /* 137815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137825 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(137867), // Rule ID 7333 //
     /* 137830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137840 */     // MIs[0] Rn
     /* 137840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137852 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 137855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137865 */     GIR_RootConstrainSelectedInstOperands,
     /* 137866 */     // GIR_Coverage, 7333,
     /* 137866 */     GIR_EraseRootFromParent_Done,
     /* 137867 */   // Label 2646: @137867
     /* 137867 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(137909), // Rule ID 7334 //
     /* 137872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137882 */     // MIs[0] Rn
     /* 137882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137894 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 137897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137907 */     GIR_RootConstrainSelectedInstOperands,
     /* 137908 */     // GIR_Coverage, 7334,
     /* 137908 */     GIR_EraseRootFromParent_Done,
     /* 137909 */   // Label 2647: @137909
     /* 137909 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(137951), // Rule ID 7335 //
     /* 137914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137924 */     // MIs[0] Rn
     /* 137924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137936 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 137939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137949 */     GIR_RootConstrainSelectedInstOperands,
     /* 137950 */     // GIR_Coverage, 7335,
     /* 137950 */     GIR_EraseRootFromParent_Done,
     /* 137951 */   // Label 2648: @137951
     /* 137951 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(137993), // Rule ID 7336 //
     /* 137956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137966 */     // MIs[0] Rn
     /* 137966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137978 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137991 */     GIR_RootConstrainSelectedInstOperands,
     /* 137992 */     // GIR_Coverage, 7336,
     /* 137992 */     GIR_EraseRootFromParent_Done,
     /* 137993 */   // Label 2649: @137993
     /* 137993 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138035), // Rule ID 7337 //
     /* 137998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138008 */     // MIs[0] Rn
     /* 138008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138020 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138033 */     GIR_RootConstrainSelectedInstOperands,
     /* 138034 */     // GIR_Coverage, 7337,
     /* 138034 */     GIR_EraseRootFromParent_Done,
     /* 138035 */   // Label 2650: @138035
     /* 138035 */   GIM_Reject,
     /* 138036 */ // Label 2645: @138036
     /* 138036 */ GIM_Reject,
     /* 138037 */ // Label 2632: @138037
     /* 138037 */ GIM_Reject,
     /* 138038 */ // Label 32: @138038
     /* 138038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(138742),
     /* 138049 */ /*GILLT_s16*//*Label 2651*/ GIMT_Encode4(138061),
     /* 138053 */ /*GILLT_s32*//*Label 2652*/ GIMT_Encode4(138288),
     /* 138057 */ /*GILLT_s64*//*Label 2653*/ GIMT_Encode4(138515),
     /* 138061 */ // Label 2651: @138061
     /* 138061 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138287),
     /* 138066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138076 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(138118), // Rule ID 7338 //
     /* 138081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138091 */     // MIs[0] Rn
     /* 138091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138103 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 138106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138116 */     GIR_RootConstrainSelectedInstOperands,
     /* 138117 */     // GIR_Coverage, 7338,
     /* 138117 */     GIR_EraseRootFromParent_Done,
     /* 138118 */   // Label 2656: @138118
     /* 138118 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(138160), // Rule ID 7339 //
     /* 138123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138133 */     // MIs[0] Rn
     /* 138133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138145 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 138148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138158 */     GIR_RootConstrainSelectedInstOperands,
     /* 138159 */     // GIR_Coverage, 7339,
     /* 138159 */     GIR_EraseRootFromParent_Done,
     /* 138160 */   // Label 2657: @138160
     /* 138160 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(138202), // Rule ID 7340 //
     /* 138165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138175 */     // MIs[0] Rn
     /* 138175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138187 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 138190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138200 */     GIR_RootConstrainSelectedInstOperands,
     /* 138201 */     // GIR_Coverage, 7340,
     /* 138201 */     GIR_EraseRootFromParent_Done,
     /* 138202 */   // Label 2658: @138202
     /* 138202 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(138244), // Rule ID 7341 //
     /* 138207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138217 */     // MIs[0] Rn
     /* 138217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138229 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138242 */     GIR_RootConstrainSelectedInstOperands,
     /* 138243 */     // GIR_Coverage, 7341,
     /* 138243 */     GIR_EraseRootFromParent_Done,
     /* 138244 */   // Label 2659: @138244
     /* 138244 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(138286), // Rule ID 7342 //
     /* 138249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138259 */     // MIs[0] Rn
     /* 138259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138271 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138284 */     GIR_RootConstrainSelectedInstOperands,
     /* 138285 */     // GIR_Coverage, 7342,
     /* 138285 */     GIR_EraseRootFromParent_Done,
     /* 138286 */   // Label 2660: @138286
     /* 138286 */   GIM_Reject,
     /* 138287 */ // Label 2655: @138287
     /* 138287 */ GIM_Reject,
     /* 138288 */ // Label 2652: @138288
     /* 138288 */ GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(138514),
     /* 138293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138303 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(138345), // Rule ID 7343 //
     /* 138308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138318 */     // MIs[0] Rn
     /* 138318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138330 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 138333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138343 */     GIR_RootConstrainSelectedInstOperands,
     /* 138344 */     // GIR_Coverage, 7343,
     /* 138344 */     GIR_EraseRootFromParent_Done,
     /* 138345 */   // Label 2662: @138345
     /* 138345 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(138387), // Rule ID 7344 //
     /* 138350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138360 */     // MIs[0] Rn
     /* 138360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138372 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 138375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138385 */     GIR_RootConstrainSelectedInstOperands,
     /* 138386 */     // GIR_Coverage, 7344,
     /* 138386 */     GIR_EraseRootFromParent_Done,
     /* 138387 */   // Label 2663: @138387
     /* 138387 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(138429), // Rule ID 7345 //
     /* 138392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138402 */     // MIs[0] Rn
     /* 138402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138414 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 138417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138427 */     GIR_RootConstrainSelectedInstOperands,
     /* 138428 */     // GIR_Coverage, 7345,
     /* 138428 */     GIR_EraseRootFromParent_Done,
     /* 138429 */   // Label 2664: @138429
     /* 138429 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(138471), // Rule ID 7346 //
     /* 138434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138444 */     // MIs[0] Rn
     /* 138444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138456 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138469 */     GIR_RootConstrainSelectedInstOperands,
     /* 138470 */     // GIR_Coverage, 7346,
     /* 138470 */     GIR_EraseRootFromParent_Done,
     /* 138471 */   // Label 2665: @138471
     /* 138471 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(138513), // Rule ID 7347 //
     /* 138476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138486 */     // MIs[0] Rn
     /* 138486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138498 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138511 */     GIR_RootConstrainSelectedInstOperands,
     /* 138512 */     // GIR_Coverage, 7347,
     /* 138512 */     GIR_EraseRootFromParent_Done,
     /* 138513 */   // Label 2666: @138513
     /* 138513 */   GIM_Reject,
     /* 138514 */ // Label 2661: @138514
     /* 138514 */ GIM_Reject,
     /* 138515 */ // Label 2653: @138515
     /* 138515 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(138741),
     /* 138520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138530 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(138572), // Rule ID 7348 //
     /* 138535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138545 */     // MIs[0] Rn
     /* 138545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138557 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 138560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138570 */     GIR_RootConstrainSelectedInstOperands,
     /* 138571 */     // GIR_Coverage, 7348,
     /* 138571 */     GIR_EraseRootFromParent_Done,
     /* 138572 */   // Label 2668: @138572
     /* 138572 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(138614), // Rule ID 7349 //
     /* 138577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138587 */     // MIs[0] Rn
     /* 138587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138599 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 138602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138612 */     GIR_RootConstrainSelectedInstOperands,
     /* 138613 */     // GIR_Coverage, 7349,
     /* 138613 */     GIR_EraseRootFromParent_Done,
     /* 138614 */   // Label 2669: @138614
     /* 138614 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(138656), // Rule ID 7350 //
     /* 138619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138629 */     // MIs[0] Rn
     /* 138629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138641 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 138644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138654 */     GIR_RootConstrainSelectedInstOperands,
     /* 138655 */     // GIR_Coverage, 7350,
     /* 138655 */     GIR_EraseRootFromParent_Done,
     /* 138656 */   // Label 2670: @138656
     /* 138656 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(138698), // Rule ID 7351 //
     /* 138661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138671 */     // MIs[0] Rn
     /* 138671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138683 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138696 */     GIR_RootConstrainSelectedInstOperands,
     /* 138697 */     // GIR_Coverage, 7351,
     /* 138697 */     GIR_EraseRootFromParent_Done,
     /* 138698 */   // Label 2671: @138698
     /* 138698 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(138740), // Rule ID 7352 //
     /* 138703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138713 */     // MIs[0] Rn
     /* 138713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138725 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138738 */     GIR_RootConstrainSelectedInstOperands,
     /* 138739 */     // GIR_Coverage, 7352,
     /* 138739 */     GIR_EraseRootFromParent_Done,
     /* 138740 */   // Label 2672: @138740
     /* 138740 */   GIM_Reject,
     /* 138741 */ // Label 2667: @138741
     /* 138741 */ GIM_Reject,
     /* 138742 */ // Label 2654: @138742
     /* 138742 */ GIM_Reject,
     /* 138743 */ // Label 33: @138743
     /* 138743 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2676*/ GIMT_Encode4(139447),
     /* 138754 */ /*GILLT_s16*//*Label 2673*/ GIMT_Encode4(138766),
     /* 138758 */ /*GILLT_s32*//*Label 2674*/ GIMT_Encode4(138993),
     /* 138762 */ /*GILLT_s64*//*Label 2675*/ GIMT_Encode4(139220),
     /* 138766 */ // Label 2673: @138766
     /* 138766 */ GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(138992),
     /* 138771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138781 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(138823), // Rule ID 7353 //
     /* 138786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138796 */     // MIs[0] Rn
     /* 138796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138808 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 138811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138821 */     GIR_RootConstrainSelectedInstOperands,
     /* 138822 */     // GIR_Coverage, 7353,
     /* 138822 */     GIR_EraseRootFromParent_Done,
     /* 138823 */   // Label 2678: @138823
     /* 138823 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(138865), // Rule ID 7354 //
     /* 138828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138838 */     // MIs[0] Rn
     /* 138838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138850 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 138853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138863 */     GIR_RootConstrainSelectedInstOperands,
     /* 138864 */     // GIR_Coverage, 7354,
     /* 138864 */     GIR_EraseRootFromParent_Done,
     /* 138865 */   // Label 2679: @138865
     /* 138865 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(138907), // Rule ID 7355 //
     /* 138870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138880 */     // MIs[0] Rn
     /* 138880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138892 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 138895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138905 */     GIR_RootConstrainSelectedInstOperands,
     /* 138906 */     // GIR_Coverage, 7355,
     /* 138906 */     GIR_EraseRootFromParent_Done,
     /* 138907 */   // Label 2680: @138907
     /* 138907 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(138949), // Rule ID 7356 //
     /* 138912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138922 */     // MIs[0] Rn
     /* 138922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138934 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138947 */     GIR_RootConstrainSelectedInstOperands,
     /* 138948 */     // GIR_Coverage, 7356,
     /* 138948 */     GIR_EraseRootFromParent_Done,
     /* 138949 */   // Label 2681: @138949
     /* 138949 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(138991), // Rule ID 7357 //
     /* 138954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138964 */     // MIs[0] Rn
     /* 138964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138976 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138989 */     GIR_RootConstrainSelectedInstOperands,
     /* 138990 */     // GIR_Coverage, 7357,
     /* 138990 */     GIR_EraseRootFromParent_Done,
     /* 138991 */   // Label 2682: @138991
     /* 138991 */   GIM_Reject,
     /* 138992 */ // Label 2677: @138992
     /* 138992 */ GIM_Reject,
     /* 138993 */ // Label 2674: @138993
     /* 138993 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139219),
     /* 138998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139001 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139008 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139050), // Rule ID 7358 //
     /* 139013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139023 */     // MIs[0] Rn
     /* 139023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139035 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139048 */     GIR_RootConstrainSelectedInstOperands,
     /* 139049 */     // GIR_Coverage, 7358,
     /* 139049 */     GIR_EraseRootFromParent_Done,
     /* 139050 */   // Label 2684: @139050
     /* 139050 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139092), // Rule ID 7359 //
     /* 139055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139065 */     // MIs[0] Rn
     /* 139065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139077 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 139080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139090 */     GIR_RootConstrainSelectedInstOperands,
     /* 139091 */     // GIR_Coverage, 7359,
     /* 139091 */     GIR_EraseRootFromParent_Done,
     /* 139092 */   // Label 2685: @139092
     /* 139092 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139134), // Rule ID 7360 //
     /* 139097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139107 */     // MIs[0] Rn
     /* 139107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139119 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 139122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139132 */     GIR_RootConstrainSelectedInstOperands,
     /* 139133 */     // GIR_Coverage, 7360,
     /* 139133 */     GIR_EraseRootFromParent_Done,
     /* 139134 */   // Label 2686: @139134
     /* 139134 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139176), // Rule ID 7361 //
     /* 139139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139149 */     // MIs[0] Rn
     /* 139149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139161 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139174 */     GIR_RootConstrainSelectedInstOperands,
     /* 139175 */     // GIR_Coverage, 7361,
     /* 139175 */     GIR_EraseRootFromParent_Done,
     /* 139176 */   // Label 2687: @139176
     /* 139176 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139218), // Rule ID 7362 //
     /* 139181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139191 */     // MIs[0] Rn
     /* 139191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139203 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139216 */     GIR_RootConstrainSelectedInstOperands,
     /* 139217 */     // GIR_Coverage, 7362,
     /* 139217 */     GIR_EraseRootFromParent_Done,
     /* 139218 */   // Label 2688: @139218
     /* 139218 */   GIM_Reject,
     /* 139219 */ // Label 2683: @139219
     /* 139219 */ GIM_Reject,
     /* 139220 */ // Label 2675: @139220
     /* 139220 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139446),
     /* 139225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139235 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(139277), // Rule ID 7363 //
     /* 139240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139250 */     // MIs[0] Rn
     /* 139250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139262 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 139265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139275 */     GIR_RootConstrainSelectedInstOperands,
     /* 139276 */     // GIR_Coverage, 7363,
     /* 139276 */     GIR_EraseRootFromParent_Done,
     /* 139277 */   // Label 2690: @139277
     /* 139277 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(139319), // Rule ID 7364 //
     /* 139282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139292 */     // MIs[0] Rn
     /* 139292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139304 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 139307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139317 */     GIR_RootConstrainSelectedInstOperands,
     /* 139318 */     // GIR_Coverage, 7364,
     /* 139318 */     GIR_EraseRootFromParent_Done,
     /* 139319 */   // Label 2691: @139319
     /* 139319 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(139361), // Rule ID 7365 //
     /* 139324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139334 */     // MIs[0] Rn
     /* 139334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139346 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 139349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139359 */     GIR_RootConstrainSelectedInstOperands,
     /* 139360 */     // GIR_Coverage, 7365,
     /* 139360 */     GIR_EraseRootFromParent_Done,
     /* 139361 */   // Label 2692: @139361
     /* 139361 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139403), // Rule ID 7366 //
     /* 139366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139376 */     // MIs[0] Rn
     /* 139376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139388 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139401 */     GIR_RootConstrainSelectedInstOperands,
     /* 139402 */     // GIR_Coverage, 7366,
     /* 139402 */     GIR_EraseRootFromParent_Done,
     /* 139403 */   // Label 2693: @139403
     /* 139403 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139445), // Rule ID 7367 //
     /* 139408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139418 */     // MIs[0] Rn
     /* 139418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139430 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139443 */     GIR_RootConstrainSelectedInstOperands,
     /* 139444 */     // GIR_Coverage, 7367,
     /* 139444 */     GIR_EraseRootFromParent_Done,
     /* 139445 */   // Label 2694: @139445
     /* 139445 */   GIM_Reject,
     /* 139446 */ // Label 2689: @139446
     /* 139446 */ GIM_Reject,
     /* 139447 */ // Label 2676: @139447
     /* 139447 */ GIM_Reject,
     /* 139448 */ // Label 34: @139448
     /* 139448 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139475), // Rule ID 6985 //
     /* 139453 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139456 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 139460 */   // MIs[0] Operand 1
     /* 139460 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139463 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 139463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 139469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139473 */   GIR_RootConstrainSelectedInstOperands,
     /* 139474 */   // GIR_Coverage, 6985,
     /* 139474 */   GIR_EraseRootFromParent_Done,
     /* 139475 */ // Label 2695: @139475
     /* 139475 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139498), // Rule ID 6986 //
     /* 139480 */   // MIs[0] Operand 0
     /* 139480 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 139483 */   // MIs[0] Operand 1
     /* 139483 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139486 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 139486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 139492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139496 */   GIR_RootConstrainSelectedInstOperands,
     /* 139497 */   // GIR_Coverage, 6986,
     /* 139497 */   GIR_EraseRootFromParent_Done,
     /* 139498 */ // Label 2696: @139498
     /* 139498 */ GIM_Reject,
     /* 139499 */ // Label 35: @139499
     /* 139499 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(152026),
     /* 139504 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 139507 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139598), // Rule ID 6464 //
     /* 139512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 139520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139538 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139541 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 139546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139550 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139566 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 139573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 139591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139596 */     GIR_RootConstrainSelectedInstOperands,
     /* 139597 */     // GIR_Coverage, 6464,
     /* 139597 */     GIR_EraseRootFromParent_Done,
     /* 139598 */   // Label 2698: @139598
     /* 139598 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139689), // Rule ID 6465 //
     /* 139603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 139611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139629 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139632 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 139637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139641 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139657 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 139664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139669 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 139682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139687 */     GIR_RootConstrainSelectedInstOperands,
     /* 139688 */     // GIR_Coverage, 6465,
     /* 139688 */     GIR_EraseRootFromParent_Done,
     /* 139689 */   // Label 2699: @139689
     /* 139689 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139750), // Rule ID 4888 //
     /* 139694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 139699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 139717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 139721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139726 */     // MIs[1] Operand 2
     /* 139726 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 139737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139739 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 139739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 139742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 139748 */     GIR_RootConstrainSelectedInstOperands,
     /* 139749 */     // GIR_Coverage, 4888,
     /* 139749 */     GIR_EraseRootFromParent_Done,
     /* 139750 */   // Label 2700: @139750
     /* 139750 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139790), // Rule ID 2651 //
     /* 139755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 139763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139770 */     // MIs[0] pattern
     /* 139770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139778 */     // (intrinsic_wo_chain:{ *:[i64] } 1324:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 139781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139783 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139788 */     GIR_RootConstrainSelectedInstOperands,
     /* 139789 */     // GIR_Coverage, 2651,
     /* 139789 */     GIR_EraseRootFromParent_Done,
     /* 139790 */   // Label 2701: @139790
     /* 139790 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(139830), // Rule ID 9870 //
     /* 139795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 139803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139810 */     // MIs[0] pattern
     /* 139810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139818 */     // (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 139821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139823 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139828 */     GIR_RootConstrainSelectedInstOperands,
     /* 139829 */     // GIR_Coverage, 9870,
     /* 139829 */     GIR_EraseRootFromParent_Done,
     /* 139830 */   // Label 2702: @139830
     /* 139830 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(139870), // Rule ID 9873 //
     /* 139835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 139843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139850 */     // MIs[0] pattern
     /* 139850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139858 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 139861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139863 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139868 */     GIR_RootConstrainSelectedInstOperands,
     /* 139869 */     // GIR_Coverage, 9873,
     /* 139869 */     GIR_EraseRootFromParent_Done,
     /* 139870 */   // Label 2703: @139870
     /* 139870 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(139910), // Rule ID 9876 //
     /* 139875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 139883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139890 */     // MIs[0] pattern
     /* 139890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139898 */     // (intrinsic_wo_chain:{ *:[i64] } 1325:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 139901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139903 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139908 */     GIR_RootConstrainSelectedInstOperands,
     /* 139909 */     // GIR_Coverage, 9876,
     /* 139909 */     GIR_EraseRootFromParent_Done,
     /* 139910 */   // Label 2704: @139910
     /* 139910 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(139949), // Rule ID 66 //
     /* 139915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 139918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 139923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139937 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 139940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 139947 */     GIR_RootConstrainSelectedInstOperands,
     /* 139948 */     // GIR_Coverage, 66,
     /* 139948 */     GIR_EraseRootFromParent_Done,
     /* 139949 */   // Label 2705: @139949
     /* 139949 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(139985), // Rule ID 346 //
     /* 139954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139976 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 139979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139983 */     GIR_RootConstrainSelectedInstOperands,
     /* 139984 */     // GIR_Coverage, 346,
     /* 139984 */     GIR_EraseRootFromParent_Done,
     /* 139985 */   // Label 2706: @139985
     /* 139985 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140021), // Rule ID 347 //
     /* 139990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140012 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 140015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140019 */     GIR_RootConstrainSelectedInstOperands,
     /* 140020 */     // GIR_Coverage, 347,
     /* 140020 */     GIR_EraseRootFromParent_Done,
     /* 140021 */   // Label 2707: @140021
     /* 140021 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140057), // Rule ID 348 //
     /* 140026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140048 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 140051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140055 */     GIR_RootConstrainSelectedInstOperands,
     /* 140056 */     // GIR_Coverage, 348,
     /* 140056 */     GIR_EraseRootFromParent_Done,
     /* 140057 */   // Label 2708: @140057
     /* 140057 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140093), // Rule ID 349 //
     /* 140062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140084 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 140087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140091 */     GIR_RootConstrainSelectedInstOperands,
     /* 140092 */     // GIR_Coverage, 349,
     /* 140092 */     GIR_EraseRootFromParent_Done,
     /* 140093 */   // Label 2709: @140093
     /* 140093 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140129), // Rule ID 350 //
     /* 140098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140120 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 140123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140127 */     GIR_RootConstrainSelectedInstOperands,
     /* 140128 */     // GIR_Coverage, 350,
     /* 140128 */     GIR_EraseRootFromParent_Done,
     /* 140129 */   // Label 2710: @140129
     /* 140129 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140165), // Rule ID 351 //
     /* 140134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140156 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 140159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140163 */     GIR_RootConstrainSelectedInstOperands,
     /* 140164 */     // GIR_Coverage, 351,
     /* 140164 */     GIR_EraseRootFromParent_Done,
     /* 140165 */   // Label 2711: @140165
     /* 140165 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140201), // Rule ID 352 //
     /* 140170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140192 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 140195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140199 */     GIR_RootConstrainSelectedInstOperands,
     /* 140200 */     // GIR_Coverage, 352,
     /* 140200 */     GIR_EraseRootFromParent_Done,
     /* 140201 */   // Label 2712: @140201
     /* 140201 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140237), // Rule ID 353 //
     /* 140206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140228 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 140231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 353,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2713: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140273), // Rule ID 354 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140264 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 140267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140271 */     GIR_RootConstrainSelectedInstOperands,
     /* 140272 */     // GIR_Coverage, 354,
     /* 140272 */     GIR_EraseRootFromParent_Done,
     /* 140273 */   // Label 2714: @140273
     /* 140273 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140309), // Rule ID 355 //
     /* 140278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140300 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 140303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140307 */     GIR_RootConstrainSelectedInstOperands,
     /* 140308 */     // GIR_Coverage, 355,
     /* 140308 */     GIR_EraseRootFromParent_Done,
     /* 140309 */   // Label 2715: @140309
     /* 140309 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(140345), // Rule ID 356 //
     /* 140314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140336 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 140339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140343 */     GIR_RootConstrainSelectedInstOperands,
     /* 140344 */     // GIR_Coverage, 356,
     /* 140344 */     GIR_EraseRootFromParent_Done,
     /* 140345 */   // Label 2716: @140345
     /* 140345 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140381), // Rule ID 357 //
     /* 140350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140372 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 140375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140379 */     GIR_RootConstrainSelectedInstOperands,
     /* 140380 */     // GIR_Coverage, 357,
     /* 140380 */     GIR_EraseRootFromParent_Done,
     /* 140381 */   // Label 2717: @140381
     /* 140381 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140417), // Rule ID 358 //
     /* 140386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140408 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 140411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140415 */     GIR_RootConstrainSelectedInstOperands,
     /* 140416 */     // GIR_Coverage, 358,
     /* 140416 */     GIR_EraseRootFromParent_Done,
     /* 140417 */   // Label 2718: @140417
     /* 140417 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(140453), // Rule ID 359 //
     /* 140422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140444 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 140447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140451 */     GIR_RootConstrainSelectedInstOperands,
     /* 140452 */     // GIR_Coverage, 359,
     /* 140452 */     GIR_EraseRootFromParent_Done,
     /* 140453 */   // Label 2719: @140453
     /* 140453 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(140489), // Rule ID 360 //
     /* 140458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140480 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 140483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140487 */     GIR_RootConstrainSelectedInstOperands,
     /* 140488 */     // GIR_Coverage, 360,
     /* 140488 */     GIR_EraseRootFromParent_Done,
     /* 140489 */   // Label 2720: @140489
     /* 140489 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140525), // Rule ID 361 //
     /* 140494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140516 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 140519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140523 */     GIR_RootConstrainSelectedInstOperands,
     /* 140524 */     // GIR_Coverage, 361,
     /* 140524 */     GIR_EraseRootFromParent_Done,
     /* 140525 */   // Label 2721: @140525
     /* 140525 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140561), // Rule ID 362 //
     /* 140530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140552 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 140555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140559 */     GIR_RootConstrainSelectedInstOperands,
     /* 140560 */     // GIR_Coverage, 362,
     /* 140560 */     GIR_EraseRootFromParent_Done,
     /* 140561 */   // Label 2722: @140561
     /* 140561 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140597), // Rule ID 363 //
     /* 140566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140588 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 140591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140595 */     GIR_RootConstrainSelectedInstOperands,
     /* 140596 */     // GIR_Coverage, 363,
     /* 140596 */     GIR_EraseRootFromParent_Done,
     /* 140597 */   // Label 2723: @140597
     /* 140597 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140633), // Rule ID 364 //
     /* 140602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140624 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 140627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140631 */     GIR_RootConstrainSelectedInstOperands,
     /* 140632 */     // GIR_Coverage, 364,
     /* 140632 */     GIR_EraseRootFromParent_Done,
     /* 140633 */   // Label 2724: @140633
     /* 140633 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140669), // Rule ID 365 //
     /* 140638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140660 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 140663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140667 */     GIR_RootConstrainSelectedInstOperands,
     /* 140668 */     // GIR_Coverage, 365,
     /* 140668 */     GIR_EraseRootFromParent_Done,
     /* 140669 */   // Label 2725: @140669
     /* 140669 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140705), // Rule ID 366 //
     /* 140674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140696 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 140699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140703 */     GIR_RootConstrainSelectedInstOperands,
     /* 140704 */     // GIR_Coverage, 366,
     /* 140704 */     GIR_EraseRootFromParent_Done,
     /* 140705 */   // Label 2726: @140705
     /* 140705 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140741), // Rule ID 367 //
     /* 140710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140732 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 140735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140739 */     GIR_RootConstrainSelectedInstOperands,
     /* 140740 */     // GIR_Coverage, 367,
     /* 140740 */     GIR_EraseRootFromParent_Done,
     /* 140741 */   // Label 2727: @140741
     /* 140741 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140777), // Rule ID 368 //
     /* 140746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140768 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 140771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140775 */     GIR_RootConstrainSelectedInstOperands,
     /* 140776 */     // GIR_Coverage, 368,
     /* 140776 */     GIR_EraseRootFromParent_Done,
     /* 140777 */   // Label 2728: @140777
     /* 140777 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(140813), // Rule ID 369 //
     /* 140782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140804 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 140807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140811 */     GIR_RootConstrainSelectedInstOperands,
     /* 140812 */     // GIR_Coverage, 369,
     /* 140812 */     GIR_EraseRootFromParent_Done,
     /* 140813 */   // Label 2729: @140813
     /* 140813 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(140849), // Rule ID 370 //
     /* 140818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140840 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 140843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140847 */     GIR_RootConstrainSelectedInstOperands,
     /* 140848 */     // GIR_Coverage, 370,
     /* 140848 */     GIR_EraseRootFromParent_Done,
     /* 140849 */   // Label 2730: @140849
     /* 140849 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(140885), // Rule ID 371 //
     /* 140854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140876 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 140879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140883 */     GIR_RootConstrainSelectedInstOperands,
     /* 140884 */     // GIR_Coverage, 371,
     /* 140884 */     GIR_EraseRootFromParent_Done,
     /* 140885 */   // Label 2731: @140885
     /* 140885 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(140921), // Rule ID 372 //
     /* 140890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140912 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 140915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140919 */     GIR_RootConstrainSelectedInstOperands,
     /* 140920 */     // GIR_Coverage, 372,
     /* 140920 */     GIR_EraseRootFromParent_Done,
     /* 140921 */   // Label 2732: @140921
     /* 140921 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(140957), // Rule ID 373 //
     /* 140926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140948 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 140951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140955 */     GIR_RootConstrainSelectedInstOperands,
     /* 140956 */     // GIR_Coverage, 373,
     /* 140956 */     GIR_EraseRootFromParent_Done,
     /* 140957 */   // Label 2733: @140957
     /* 140957 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(140993), // Rule ID 374 //
     /* 140962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140984 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 140987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140991 */     GIR_RootConstrainSelectedInstOperands,
     /* 140992 */     // GIR_Coverage, 374,
     /* 140992 */     GIR_EraseRootFromParent_Done,
     /* 140993 */   // Label 2734: @140993
     /* 140993 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141029), // Rule ID 375 //
     /* 140998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141020 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 141023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141027 */     GIR_RootConstrainSelectedInstOperands,
     /* 141028 */     // GIR_Coverage, 375,
     /* 141028 */     GIR_EraseRootFromParent_Done,
     /* 141029 */   // Label 2735: @141029
     /* 141029 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141065), // Rule ID 376 //
     /* 141034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141056 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 141059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141063 */     GIR_RootConstrainSelectedInstOperands,
     /* 141064 */     // GIR_Coverage, 376,
     /* 141064 */     GIR_EraseRootFromParent_Done,
     /* 141065 */   // Label 2736: @141065
     /* 141065 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141101), // Rule ID 377 //
     /* 141070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141092 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 141095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141099 */     GIR_RootConstrainSelectedInstOperands,
     /* 141100 */     // GIR_Coverage, 377,
     /* 141100 */     GIR_EraseRootFromParent_Done,
     /* 141101 */   // Label 2737: @141101
     /* 141101 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141137), // Rule ID 378 //
     /* 141106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141128 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 141131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141135 */     GIR_RootConstrainSelectedInstOperands,
     /* 141136 */     // GIR_Coverage, 378,
     /* 141136 */     GIR_EraseRootFromParent_Done,
     /* 141137 */   // Label 2738: @141137
     /* 141137 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141173), // Rule ID 379 //
     /* 141142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141164 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 141167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141171 */     GIR_RootConstrainSelectedInstOperands,
     /* 141172 */     // GIR_Coverage, 379,
     /* 141172 */     GIR_EraseRootFromParent_Done,
     /* 141173 */   // Label 2739: @141173
     /* 141173 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141209), // Rule ID 380 //
     /* 141178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141200 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 141203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141207 */     GIR_RootConstrainSelectedInstOperands,
     /* 141208 */     // GIR_Coverage, 380,
     /* 141208 */     GIR_EraseRootFromParent_Done,
     /* 141209 */   // Label 2740: @141209
     /* 141209 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141245), // Rule ID 381 //
     /* 141214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141236 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 141239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141243 */     GIR_RootConstrainSelectedInstOperands,
     /* 141244 */     // GIR_Coverage, 381,
     /* 141244 */     GIR_EraseRootFromParent_Done,
     /* 141245 */   // Label 2741: @141245
     /* 141245 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141281), // Rule ID 382 //
     /* 141250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141272 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 141275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141279 */     GIR_RootConstrainSelectedInstOperands,
     /* 141280 */     // GIR_Coverage, 382,
     /* 141280 */     GIR_EraseRootFromParent_Done,
     /* 141281 */   // Label 2742: @141281
     /* 141281 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141317), // Rule ID 383 //
     /* 141286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141308 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 141311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141315 */     GIR_RootConstrainSelectedInstOperands,
     /* 141316 */     // GIR_Coverage, 383,
     /* 141316 */     GIR_EraseRootFromParent_Done,
     /* 141317 */   // Label 2743: @141317
     /* 141317 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141353), // Rule ID 384 //
     /* 141322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141344 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 141347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141351 */     GIR_RootConstrainSelectedInstOperands,
     /* 141352 */     // GIR_Coverage, 384,
     /* 141352 */     GIR_EraseRootFromParent_Done,
     /* 141353 */   // Label 2744: @141353
     /* 141353 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141389), // Rule ID 385 //
     /* 141358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141380 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 141383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141387 */     GIR_RootConstrainSelectedInstOperands,
     /* 141388 */     // GIR_Coverage, 385,
     /* 141388 */     GIR_EraseRootFromParent_Done,
     /* 141389 */   // Label 2745: @141389
     /* 141389 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(141425), // Rule ID 386 //
     /* 141394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141416 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 141419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141423 */     GIR_RootConstrainSelectedInstOperands,
     /* 141424 */     // GIR_Coverage, 386,
     /* 141424 */     GIR_EraseRootFromParent_Done,
     /* 141425 */   // Label 2746: @141425
     /* 141425 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141461), // Rule ID 387 //
     /* 141430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141452 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 141455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141459 */     GIR_RootConstrainSelectedInstOperands,
     /* 141460 */     // GIR_Coverage, 387,
     /* 141460 */     GIR_EraseRootFromParent_Done,
     /* 141461 */   // Label 2747: @141461
     /* 141461 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141497), // Rule ID 388 //
     /* 141466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141488 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 141491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141495 */     GIR_RootConstrainSelectedInstOperands,
     /* 141496 */     // GIR_Coverage, 388,
     /* 141496 */     GIR_EraseRootFromParent_Done,
     /* 141497 */   // Label 2748: @141497
     /* 141497 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141533), // Rule ID 389 //
     /* 141502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141524 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 141527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141531 */     GIR_RootConstrainSelectedInstOperands,
     /* 141532 */     // GIR_Coverage, 389,
     /* 141532 */     GIR_EraseRootFromParent_Done,
     /* 141533 */   // Label 2749: @141533
     /* 141533 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141569), // Rule ID 390 //
     /* 141538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141560 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 141563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141567 */     GIR_RootConstrainSelectedInstOperands,
     /* 141568 */     // GIR_Coverage, 390,
     /* 141568 */     GIR_EraseRootFromParent_Done,
     /* 141569 */   // Label 2750: @141569
     /* 141569 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141605), // Rule ID 391 //
     /* 141574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141596 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 141599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141603 */     GIR_RootConstrainSelectedInstOperands,
     /* 141604 */     // GIR_Coverage, 391,
     /* 141604 */     GIR_EraseRootFromParent_Done,
     /* 141605 */   // Label 2751: @141605
     /* 141605 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141641), // Rule ID 392 //
     /* 141610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141632 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 141635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141639 */     GIR_RootConstrainSelectedInstOperands,
     /* 141640 */     // GIR_Coverage, 392,
     /* 141640 */     GIR_EraseRootFromParent_Done,
     /* 141641 */   // Label 2752: @141641
     /* 141641 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141677), // Rule ID 393 //
     /* 141646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141668 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 141671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141675 */     GIR_RootConstrainSelectedInstOperands,
     /* 141676 */     // GIR_Coverage, 393,
     /* 141676 */     GIR_EraseRootFromParent_Done,
     /* 141677 */   // Label 2753: @141677
     /* 141677 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141713), // Rule ID 575 //
     /* 141682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141704 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 141707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141711 */     GIR_RootConstrainSelectedInstOperands,
     /* 141712 */     // GIR_Coverage, 575,
     /* 141712 */     GIR_EraseRootFromParent_Done,
     /* 141713 */   // Label 2754: @141713
     /* 141713 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141749), // Rule ID 576 //
     /* 141718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141740 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 141743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141747 */     GIR_RootConstrainSelectedInstOperands,
     /* 141748 */     // GIR_Coverage, 576,
     /* 141748 */     GIR_EraseRootFromParent_Done,
     /* 141749 */   // Label 2755: @141749
     /* 141749 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(141785), // Rule ID 577 //
     /* 141754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141776 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 141779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141783 */     GIR_RootConstrainSelectedInstOperands,
     /* 141784 */     // GIR_Coverage, 577,
     /* 141784 */     GIR_EraseRootFromParent_Done,
     /* 141785 */   // Label 2756: @141785
     /* 141785 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(141821), // Rule ID 578 //
     /* 141790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141812 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 141815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141819 */     GIR_RootConstrainSelectedInstOperands,
     /* 141820 */     // GIR_Coverage, 578,
     /* 141820 */     GIR_EraseRootFromParent_Done,
     /* 141821 */   // Label 2757: @141821
     /* 141821 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(141857), // Rule ID 579 //
     /* 141826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141848 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 141851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141855 */     GIR_RootConstrainSelectedInstOperands,
     /* 141856 */     // GIR_Coverage, 579,
     /* 141856 */     GIR_EraseRootFromParent_Done,
     /* 141857 */   // Label 2758: @141857
     /* 141857 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(141893), // Rule ID 580 //
     /* 141862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141884 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 141887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141891 */     GIR_RootConstrainSelectedInstOperands,
     /* 141892 */     // GIR_Coverage, 580,
     /* 141892 */     GIR_EraseRootFromParent_Done,
     /* 141893 */   // Label 2759: @141893
     /* 141893 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(141929), // Rule ID 581 //
     /* 141898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141920 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 141923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141927 */     GIR_RootConstrainSelectedInstOperands,
     /* 141928 */     // GIR_Coverage, 581,
     /* 141928 */     GIR_EraseRootFromParent_Done,
     /* 141929 */   // Label 2760: @141929
     /* 141929 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(141965), // Rule ID 582 //
     /* 141934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141956 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 141959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141963 */     GIR_RootConstrainSelectedInstOperands,
     /* 141964 */     // GIR_Coverage, 582,
     /* 141964 */     GIR_EraseRootFromParent_Done,
     /* 141965 */   // Label 2761: @141965
     /* 141965 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142001), // Rule ID 710 //
     /* 141970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141992 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 141992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 141995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141999 */     GIR_RootConstrainSelectedInstOperands,
     /* 142000 */     // GIR_Coverage, 710,
     /* 142000 */     GIR_EraseRootFromParent_Done,
     /* 142001 */   // Label 2762: @142001
     /* 142001 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142037), // Rule ID 711 //
     /* 142006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142028 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 142031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142035 */     GIR_RootConstrainSelectedInstOperands,
     /* 142036 */     // GIR_Coverage, 711,
     /* 142036 */     GIR_EraseRootFromParent_Done,
     /* 142037 */   // Label 2763: @142037
     /* 142037 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142073), // Rule ID 712 //
     /* 142042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142064 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 142067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142071 */     GIR_RootConstrainSelectedInstOperands,
     /* 142072 */     // GIR_Coverage, 712,
     /* 142072 */     GIR_EraseRootFromParent_Done,
     /* 142073 */   // Label 2764: @142073
     /* 142073 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142109), // Rule ID 713 //
     /* 142078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 142103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142107 */     GIR_RootConstrainSelectedInstOperands,
     /* 142108 */     // GIR_Coverage, 713,
     /* 142108 */     GIR_EraseRootFromParent_Done,
     /* 142109 */   // Label 2765: @142109
     /* 142109 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142145), // Rule ID 714 //
     /* 142114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 142136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 142139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142143 */     GIR_RootConstrainSelectedInstOperands,
     /* 142144 */     // GIR_Coverage, 714,
     /* 142144 */     GIR_EraseRootFromParent_Done,
     /* 142145 */   // Label 2766: @142145
     /* 142145 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142181), // Rule ID 715 //
     /* 142150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 142172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 142175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142179 */     GIR_RootConstrainSelectedInstOperands,
     /* 142180 */     // GIR_Coverage, 715,
     /* 142180 */     GIR_EraseRootFromParent_Done,
     /* 142181 */   // Label 2767: @142181
     /* 142181 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142217), // Rule ID 796 //
     /* 142186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142208 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 142211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142215 */     GIR_RootConstrainSelectedInstOperands,
     /* 142216 */     // GIR_Coverage, 796,
     /* 142216 */     GIR_EraseRootFromParent_Done,
     /* 142217 */   // Label 2768: @142217
     /* 142217 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142253), // Rule ID 797 //
     /* 142222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 142247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142251 */     GIR_RootConstrainSelectedInstOperands,
     /* 142252 */     // GIR_Coverage, 797,
     /* 142252 */     GIR_EraseRootFromParent_Done,
     /* 142253 */   // Label 2769: @142253
     /* 142253 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142289), // Rule ID 798 //
     /* 142258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142280 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 142283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142287 */     GIR_RootConstrainSelectedInstOperands,
     /* 142288 */     // GIR_Coverage, 798,
     /* 142288 */     GIR_EraseRootFromParent_Done,
     /* 142289 */   // Label 2770: @142289
     /* 142289 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142325), // Rule ID 799 //
     /* 142294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142316 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 142319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142323 */     GIR_RootConstrainSelectedInstOperands,
     /* 142324 */     // GIR_Coverage, 799,
     /* 142324 */     GIR_EraseRootFromParent_Done,
     /* 142325 */   // Label 2771: @142325
     /* 142325 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142361), // Rule ID 800 //
     /* 142330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 142355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142359 */     GIR_RootConstrainSelectedInstOperands,
     /* 142360 */     // GIR_Coverage, 800,
     /* 142360 */     GIR_EraseRootFromParent_Done,
     /* 142361 */   // Label 2772: @142361
     /* 142361 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142397), // Rule ID 801 //
     /* 142366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142388 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 142391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142395 */     GIR_RootConstrainSelectedInstOperands,
     /* 142396 */     // GIR_Coverage, 801,
     /* 142396 */     GIR_EraseRootFromParent_Done,
     /* 142397 */   // Label 2773: @142397
     /* 142397 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(142433), // Rule ID 802 //
     /* 142402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 142427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142431 */     GIR_RootConstrainSelectedInstOperands,
     /* 142432 */     // GIR_Coverage, 802,
     /* 142432 */     GIR_EraseRootFromParent_Done,
     /* 142433 */   // Label 2774: @142433
     /* 142433 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(142469), // Rule ID 803 //
     /* 142438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142460 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 142463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142467 */     GIR_RootConstrainSelectedInstOperands,
     /* 142468 */     // GIR_Coverage, 803,
     /* 142468 */     GIR_EraseRootFromParent_Done,
     /* 142469 */   // Label 2775: @142469
     /* 142469 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142505), // Rule ID 804 //
     /* 142474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142496 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 142499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142503 */     GIR_RootConstrainSelectedInstOperands,
     /* 142504 */     // GIR_Coverage, 804,
     /* 142504 */     GIR_EraseRootFromParent_Done,
     /* 142505 */   // Label 2776: @142505
     /* 142505 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142541), // Rule ID 805 //
     /* 142510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142532 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 142535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142539 */     GIR_RootConstrainSelectedInstOperands,
     /* 142540 */     // GIR_Coverage, 805,
     /* 142540 */     GIR_EraseRootFromParent_Done,
     /* 142541 */   // Label 2777: @142541
     /* 142541 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142577), // Rule ID 806 //
     /* 142546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142568 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 142571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142575 */     GIR_RootConstrainSelectedInstOperands,
     /* 142576 */     // GIR_Coverage, 806,
     /* 142576 */     GIR_EraseRootFromParent_Done,
     /* 142577 */   // Label 2778: @142577
     /* 142577 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142613), // Rule ID 807 //
     /* 142582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142604 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 142607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142611 */     GIR_RootConstrainSelectedInstOperands,
     /* 142612 */     // GIR_Coverage, 807,
     /* 142612 */     GIR_EraseRootFromParent_Done,
     /* 142613 */   // Label 2779: @142613
     /* 142613 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142649), // Rule ID 808 //
     /* 142618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142640 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 142643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142647 */     GIR_RootConstrainSelectedInstOperands,
     /* 142648 */     // GIR_Coverage, 808,
     /* 142648 */     GIR_EraseRootFromParent_Done,
     /* 142649 */   // Label 2780: @142649
     /* 142649 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142685), // Rule ID 809 //
     /* 142654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 142679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142683 */     GIR_RootConstrainSelectedInstOperands,
     /* 142684 */     // GIR_Coverage, 809,
     /* 142684 */     GIR_EraseRootFromParent_Done,
     /* 142685 */   // Label 2781: @142685
     /* 142685 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142721), // Rule ID 810 //
     /* 142690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142712 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 142715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142719 */     GIR_RootConstrainSelectedInstOperands,
     /* 142720 */     // GIR_Coverage, 810,
     /* 142720 */     GIR_EraseRootFromParent_Done,
     /* 142721 */   // Label 2782: @142721
     /* 142721 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142757), // Rule ID 811 //
     /* 142726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142748 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 142751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142755 */     GIR_RootConstrainSelectedInstOperands,
     /* 142756 */     // GIR_Coverage, 811,
     /* 142756 */     GIR_EraseRootFromParent_Done,
     /* 142757 */   // Label 2783: @142757
     /* 142757 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(142793), // Rule ID 812 //
     /* 142762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 142787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142791 */     GIR_RootConstrainSelectedInstOperands,
     /* 142792 */     // GIR_Coverage, 812,
     /* 142792 */     GIR_EraseRootFromParent_Done,
     /* 142793 */   // Label 2784: @142793
     /* 142793 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(142829), // Rule ID 813 //
     /* 142798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142820 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 142823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142827 */     GIR_RootConstrainSelectedInstOperands,
     /* 142828 */     // GIR_Coverage, 813,
     /* 142828 */     GIR_EraseRootFromParent_Done,
     /* 142829 */   // Label 2785: @142829
     /* 142829 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(142865), // Rule ID 814 //
     /* 142834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 142859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142863 */     GIR_RootConstrainSelectedInstOperands,
     /* 142864 */     // GIR_Coverage, 814,
     /* 142864 */     GIR_EraseRootFromParent_Done,
     /* 142865 */   // Label 2786: @142865
     /* 142865 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(142901), // Rule ID 815 //
     /* 142870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142892 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 142895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142899 */     GIR_RootConstrainSelectedInstOperands,
     /* 142900 */     // GIR_Coverage, 815,
     /* 142900 */     GIR_EraseRootFromParent_Done,
     /* 142901 */   // Label 2787: @142901
     /* 142901 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(142937), // Rule ID 816 //
     /* 142906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142928 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 142931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142935 */     GIR_RootConstrainSelectedInstOperands,
     /* 142936 */     // GIR_Coverage, 816,
     /* 142936 */     GIR_EraseRootFromParent_Done,
     /* 142937 */   // Label 2788: @142937
     /* 142937 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(142973), // Rule ID 817 //
     /* 142942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 142967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142971 */     GIR_RootConstrainSelectedInstOperands,
     /* 142972 */     // GIR_Coverage, 817,
     /* 142972 */     GIR_EraseRootFromParent_Done,
     /* 142973 */   // Label 2789: @142973
     /* 142973 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143009), // Rule ID 818 //
     /* 142978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 143003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143007 */     GIR_RootConstrainSelectedInstOperands,
     /* 143008 */     // GIR_Coverage, 818,
     /* 143008 */     GIR_EraseRootFromParent_Done,
     /* 143009 */   // Label 2790: @143009
     /* 143009 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143045), // Rule ID 819 //
     /* 143014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 143039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143043 */     GIR_RootConstrainSelectedInstOperands,
     /* 143044 */     // GIR_Coverage, 819,
     /* 143044 */     GIR_EraseRootFromParent_Done,
     /* 143045 */   // Label 2791: @143045
     /* 143045 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143081), // Rule ID 820 //
     /* 143050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143072 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 143075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143079 */     GIR_RootConstrainSelectedInstOperands,
     /* 143080 */     // GIR_Coverage, 820,
     /* 143080 */     GIR_EraseRootFromParent_Done,
     /* 143081 */   // Label 2792: @143081
     /* 143081 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143117), // Rule ID 821 //
     /* 143086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143108 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 143111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143115 */     GIR_RootConstrainSelectedInstOperands,
     /* 143116 */     // GIR_Coverage, 821,
     /* 143116 */     GIR_EraseRootFromParent_Done,
     /* 143117 */   // Label 2793: @143117
     /* 143117 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143153), // Rule ID 822 //
     /* 143122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143144 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 143147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143151 */     GIR_RootConstrainSelectedInstOperands,
     /* 143152 */     // GIR_Coverage, 822,
     /* 143152 */     GIR_EraseRootFromParent_Done,
     /* 143153 */   // Label 2794: @143153
     /* 143153 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143189), // Rule ID 823 //
     /* 143158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143180 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 143183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143187 */     GIR_RootConstrainSelectedInstOperands,
     /* 143188 */     // GIR_Coverage, 823,
     /* 143188 */     GIR_EraseRootFromParent_Done,
     /* 143189 */   // Label 2795: @143189
     /* 143189 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143225), // Rule ID 824 //
     /* 143194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143216 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 143219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143223 */     GIR_RootConstrainSelectedInstOperands,
     /* 143224 */     // GIR_Coverage, 824,
     /* 143224 */     GIR_EraseRootFromParent_Done,
     /* 143225 */   // Label 2796: @143225
     /* 143225 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143261), // Rule ID 825 //
     /* 143230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143252 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 143255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143259 */     GIR_RootConstrainSelectedInstOperands,
     /* 143260 */     // GIR_Coverage, 825,
     /* 143260 */     GIR_EraseRootFromParent_Done,
     /* 143261 */   // Label 2797: @143261
     /* 143261 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143297), // Rule ID 826 //
     /* 143266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143288 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 143291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143295 */     GIR_RootConstrainSelectedInstOperands,
     /* 143296 */     // GIR_Coverage, 826,
     /* 143296 */     GIR_EraseRootFromParent_Done,
     /* 143297 */   // Label 2798: @143297
     /* 143297 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143333), // Rule ID 827 //
     /* 143302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143324 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 143327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143331 */     GIR_RootConstrainSelectedInstOperands,
     /* 143332 */     // GIR_Coverage, 827,
     /* 143332 */     GIR_EraseRootFromParent_Done,
     /* 143333 */   // Label 2799: @143333
     /* 143333 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143369), // Rule ID 828 //
     /* 143338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143360 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 143363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143367 */     GIR_RootConstrainSelectedInstOperands,
     /* 143368 */     // GIR_Coverage, 828,
     /* 143368 */     GIR_EraseRootFromParent_Done,
     /* 143369 */   // Label 2800: @143369
     /* 143369 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(143405), // Rule ID 829 //
     /* 143374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 143399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143403 */     GIR_RootConstrainSelectedInstOperands,
     /* 143404 */     // GIR_Coverage, 829,
     /* 143404 */     GIR_EraseRootFromParent_Done,
     /* 143405 */   // Label 2801: @143405
     /* 143405 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(143441), // Rule ID 830 //
     /* 143410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143432 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 143435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143439 */     GIR_RootConstrainSelectedInstOperands,
     /* 143440 */     // GIR_Coverage, 830,
     /* 143440 */     GIR_EraseRootFromParent_Done,
     /* 143441 */   // Label 2802: @143441
     /* 143441 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(143477), // Rule ID 831 //
     /* 143446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143468 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 143471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143475 */     GIR_RootConstrainSelectedInstOperands,
     /* 143476 */     // GIR_Coverage, 831,
     /* 143476 */     GIR_EraseRootFromParent_Done,
     /* 143477 */   // Label 2803: @143477
     /* 143477 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143513), // Rule ID 832 //
     /* 143482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143504 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 143507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143511 */     GIR_RootConstrainSelectedInstOperands,
     /* 143512 */     // GIR_Coverage, 832,
     /* 143512 */     GIR_EraseRootFromParent_Done,
     /* 143513 */   // Label 2804: @143513
     /* 143513 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143549), // Rule ID 833 //
     /* 143518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143540 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143547 */     GIR_RootConstrainSelectedInstOperands,
     /* 143548 */     // GIR_Coverage, 833,
     /* 143548 */     GIR_EraseRootFromParent_Done,
     /* 143549 */   // Label 2805: @143549
     /* 143549 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143585), // Rule ID 834 //
     /* 143554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 143579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143583 */     GIR_RootConstrainSelectedInstOperands,
     /* 143584 */     // GIR_Coverage, 834,
     /* 143584 */     GIR_EraseRootFromParent_Done,
     /* 143585 */   // Label 2806: @143585
     /* 143585 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143621), // Rule ID 835 //
     /* 143590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143612 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 143615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143619 */     GIR_RootConstrainSelectedInstOperands,
     /* 143620 */     // GIR_Coverage, 835,
     /* 143620 */     GIR_EraseRootFromParent_Done,
     /* 143621 */   // Label 2807: @143621
     /* 143621 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143657), // Rule ID 836 //
     /* 143626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 143634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143648 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 143648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 143651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143655 */     GIR_RootConstrainSelectedInstOperands,
     /* 143656 */     // GIR_Coverage, 836,
     /* 143656 */     GIR_EraseRootFromParent_Done,
     /* 143657 */   // Label 2808: @143657
     /* 143657 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143693), // Rule ID 863 //
     /* 143662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143684 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 143684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 143687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143691 */     GIR_RootConstrainSelectedInstOperands,
     /* 143692 */     // GIR_Coverage, 863,
     /* 143692 */     GIR_EraseRootFromParent_Done,
     /* 143693 */   // Label 2809: @143693
     /* 143693 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143729), // Rule ID 864 //
     /* 143698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143720 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 143720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 143723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143727 */     GIR_RootConstrainSelectedInstOperands,
     /* 143728 */     // GIR_Coverage, 864,
     /* 143728 */     GIR_EraseRootFromParent_Done,
     /* 143729 */   // Label 2810: @143729
     /* 143729 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143765), // Rule ID 865 //
     /* 143734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143756 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 143759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143763 */     GIR_RootConstrainSelectedInstOperands,
     /* 143764 */     // GIR_Coverage, 865,
     /* 143764 */     GIR_EraseRootFromParent_Done,
     /* 143765 */   // Label 2811: @143765
     /* 143765 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(143801), // Rule ID 866 //
     /* 143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143792 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 143795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143799 */     GIR_RootConstrainSelectedInstOperands,
     /* 143800 */     // GIR_Coverage, 866,
     /* 143800 */     GIR_EraseRootFromParent_Done,
     /* 143801 */   // Label 2812: @143801
     /* 143801 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(143837), // Rule ID 867 //
     /* 143806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143828 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 143831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143835 */     GIR_RootConstrainSelectedInstOperands,
     /* 143836 */     // GIR_Coverage, 867,
     /* 143836 */     GIR_EraseRootFromParent_Done,
     /* 143837 */   // Label 2813: @143837
     /* 143837 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(143873), // Rule ID 938 //
     /* 143842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143864 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 143867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143871 */     GIR_RootConstrainSelectedInstOperands,
     /* 143872 */     // GIR_Coverage, 938,
     /* 143872 */     GIR_EraseRootFromParent_Done,
     /* 143873 */   // Label 2814: @143873
     /* 143873 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(143909), // Rule ID 939 //
     /* 143878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143900 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 143903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143907 */     GIR_RootConstrainSelectedInstOperands,
     /* 143908 */     // GIR_Coverage, 939,
     /* 143908 */     GIR_EraseRootFromParent_Done,
     /* 143909 */   // Label 2815: @143909
     /* 143909 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(143945), // Rule ID 940 //
     /* 143914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143936 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 143939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143943 */     GIR_RootConstrainSelectedInstOperands,
     /* 143944 */     // GIR_Coverage, 940,
     /* 143944 */     GIR_EraseRootFromParent_Done,
     /* 143945 */   // Label 2816: @143945
     /* 143945 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(143981), // Rule ID 941 //
     /* 143950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143972 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143979 */     GIR_RootConstrainSelectedInstOperands,
     /* 143980 */     // GIR_Coverage, 941,
     /* 143980 */     GIR_EraseRootFromParent_Done,
     /* 143981 */   // Label 2817: @143981
     /* 143981 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144017), // Rule ID 942 //
     /* 143986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144008 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 144011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144015 */     GIR_RootConstrainSelectedInstOperands,
     /* 144016 */     // GIR_Coverage, 942,
     /* 144016 */     GIR_EraseRootFromParent_Done,
     /* 144017 */   // Label 2818: @144017
     /* 144017 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144053), // Rule ID 943 //
     /* 144022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144044 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 144047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144051 */     GIR_RootConstrainSelectedInstOperands,
     /* 144052 */     // GIR_Coverage, 943,
     /* 144052 */     GIR_EraseRootFromParent_Done,
     /* 144053 */   // Label 2819: @144053
     /* 144053 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144089), // Rule ID 944 //
     /* 144058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144080 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 144083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144087 */     GIR_RootConstrainSelectedInstOperands,
     /* 144088 */     // GIR_Coverage, 944,
     /* 144088 */     GIR_EraseRootFromParent_Done,
     /* 144089 */   // Label 2820: @144089
     /* 144089 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144125), // Rule ID 945 //
     /* 144094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144116 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 144119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144123 */     GIR_RootConstrainSelectedInstOperands,
     /* 144124 */     // GIR_Coverage, 945,
     /* 144124 */     GIR_EraseRootFromParent_Done,
     /* 144125 */   // Label 2821: @144125
     /* 144125 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144161), // Rule ID 946 //
     /* 144130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144152 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 144155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144159 */     GIR_RootConstrainSelectedInstOperands,
     /* 144160 */     // GIR_Coverage, 946,
     /* 144160 */     GIR_EraseRootFromParent_Done,
     /* 144161 */   // Label 2822: @144161
     /* 144161 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144197), // Rule ID 947 //
     /* 144166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144188 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 144191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144195 */     GIR_RootConstrainSelectedInstOperands,
     /* 144196 */     // GIR_Coverage, 947,
     /* 144196 */     GIR_EraseRootFromParent_Done,
     /* 144197 */   // Label 2823: @144197
     /* 144197 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144233), // Rule ID 948 //
     /* 144202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144224 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 144227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144231 */     GIR_RootConstrainSelectedInstOperands,
     /* 144232 */     // GIR_Coverage, 948,
     /* 144232 */     GIR_EraseRootFromParent_Done,
     /* 144233 */   // Label 2824: @144233
     /* 144233 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144269), // Rule ID 949 //
     /* 144238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144260 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 144263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144267 */     GIR_RootConstrainSelectedInstOperands,
     /* 144268 */     // GIR_Coverage, 949,
     /* 144268 */     GIR_EraseRootFromParent_Done,
     /* 144269 */   // Label 2825: @144269
     /* 144269 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144305), // Rule ID 950 //
     /* 144274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144296 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 144299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144303 */     GIR_RootConstrainSelectedInstOperands,
     /* 144304 */     // GIR_Coverage, 950,
     /* 144304 */     GIR_EraseRootFromParent_Done,
     /* 144305 */   // Label 2826: @144305
     /* 144305 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144341), // Rule ID 951 //
     /* 144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144332 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 144335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144339 */     GIR_RootConstrainSelectedInstOperands,
     /* 144340 */     // GIR_Coverage, 951,
     /* 144340 */     GIR_EraseRootFromParent_Done,
     /* 144341 */   // Label 2827: @144341
     /* 144341 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144377), // Rule ID 952 //
     /* 144346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144368 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 144371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144375 */     GIR_RootConstrainSelectedInstOperands,
     /* 144376 */     // GIR_Coverage, 952,
     /* 144376 */     GIR_EraseRootFromParent_Done,
     /* 144377 */   // Label 2828: @144377
     /* 144377 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(144413), // Rule ID 953 //
     /* 144382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144404 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 144407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144411 */     GIR_RootConstrainSelectedInstOperands,
     /* 144412 */     // GIR_Coverage, 953,
     /* 144412 */     GIR_EraseRootFromParent_Done,
     /* 144413 */   // Label 2829: @144413
     /* 144413 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(144449), // Rule ID 954 //
     /* 144418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144440 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 144443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144447 */     GIR_RootConstrainSelectedInstOperands,
     /* 144448 */     // GIR_Coverage, 954,
     /* 144448 */     GIR_EraseRootFromParent_Done,
     /* 144449 */   // Label 2830: @144449
     /* 144449 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(144485), // Rule ID 1001 //
     /* 144454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144476 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 144476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 144479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144483 */     GIR_RootConstrainSelectedInstOperands,
     /* 144484 */     // GIR_Coverage, 1001,
     /* 144484 */     GIR_EraseRootFromParent_Done,
     /* 144485 */   // Label 2831: @144485
     /* 144485 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144521), // Rule ID 1003 //
     /* 144490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144512 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 144512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 144515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144519 */     GIR_RootConstrainSelectedInstOperands,
     /* 144520 */     // GIR_Coverage, 1003,
     /* 144520 */     GIR_EraseRootFromParent_Done,
     /* 144521 */   // Label 2832: @144521
     /* 144521 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144557), // Rule ID 1005 //
     /* 144526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144548 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 144548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 144551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144555 */     GIR_RootConstrainSelectedInstOperands,
     /* 144556 */     // GIR_Coverage, 1005,
     /* 144556 */     GIR_EraseRootFromParent_Done,
     /* 144557 */   // Label 2833: @144557
     /* 144557 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144593), // Rule ID 1007 //
     /* 144562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 144584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 144587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144591 */     GIR_RootConstrainSelectedInstOperands,
     /* 144592 */     // GIR_Coverage, 1007,
     /* 144592 */     GIR_EraseRootFromParent_Done,
     /* 144593 */   // Label 2834: @144593
     /* 144593 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144629), // Rule ID 1009 //
     /* 144598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144620 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 144620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 144623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144627 */     GIR_RootConstrainSelectedInstOperands,
     /* 144628 */     // GIR_Coverage, 1009,
     /* 144628 */     GIR_EraseRootFromParent_Done,
     /* 144629 */   // Label 2835: @144629
     /* 144629 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144665), // Rule ID 1011 //
     /* 144634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144656 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 144656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144663 */     GIR_RootConstrainSelectedInstOperands,
     /* 144664 */     // GIR_Coverage, 1011,
     /* 144664 */     GIR_EraseRootFromParent_Done,
     /* 144665 */   // Label 2836: @144665
     /* 144665 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144701), // Rule ID 1022 //
     /* 144670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144692 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 144695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144699 */     GIR_RootConstrainSelectedInstOperands,
     /* 144700 */     // GIR_Coverage, 1022,
     /* 144700 */     GIR_EraseRootFromParent_Done,
     /* 144701 */   // Label 2837: @144701
     /* 144701 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144737), // Rule ID 1023 //
     /* 144706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144728 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 144731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144735 */     GIR_RootConstrainSelectedInstOperands,
     /* 144736 */     // GIR_Coverage, 1023,
     /* 144736 */     GIR_EraseRootFromParent_Done,
     /* 144737 */   // Label 2838: @144737
     /* 144737 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144773), // Rule ID 1024 //
     /* 144742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144764 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 144767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144771 */     GIR_RootConstrainSelectedInstOperands,
     /* 144772 */     // GIR_Coverage, 1024,
     /* 144772 */     GIR_EraseRootFromParent_Done,
     /* 144773 */   // Label 2839: @144773
     /* 144773 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(144809), // Rule ID 1025 //
     /* 144778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144800 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 144803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144807 */     GIR_RootConstrainSelectedInstOperands,
     /* 144808 */     // GIR_Coverage, 1025,
     /* 144808 */     GIR_EraseRootFromParent_Done,
     /* 144809 */   // Label 2840: @144809
     /* 144809 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(144845), // Rule ID 1026 //
     /* 144814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144836 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 144839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144843 */     GIR_RootConstrainSelectedInstOperands,
     /* 144844 */     // GIR_Coverage, 1026,
     /* 144844 */     GIR_EraseRootFromParent_Done,
     /* 144845 */   // Label 2841: @144845
     /* 144845 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(144881), // Rule ID 1027 //
     /* 144850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144872 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 144875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144879 */     GIR_RootConstrainSelectedInstOperands,
     /* 144880 */     // GIR_Coverage, 1027,
     /* 144880 */     GIR_EraseRootFromParent_Done,
     /* 144881 */   // Label 2842: @144881
     /* 144881 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(144917), // Rule ID 1028 //
     /* 144886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144908 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 144908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 144911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144915 */     GIR_RootConstrainSelectedInstOperands,
     /* 144916 */     // GIR_Coverage, 1028,
     /* 144916 */     GIR_EraseRootFromParent_Done,
     /* 144917 */   // Label 2843: @144917
     /* 144917 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(144953), // Rule ID 1029 //
     /* 144922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144944 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 144947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144951 */     GIR_RootConstrainSelectedInstOperands,
     /* 144952 */     // GIR_Coverage, 1029,
     /* 144952 */     GIR_EraseRootFromParent_Done,
     /* 144953 */   // Label 2844: @144953
     /* 144953 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(144989), // Rule ID 1030 //
     /* 144958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144980 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 144983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144987 */     GIR_RootConstrainSelectedInstOperands,
     /* 144988 */     // GIR_Coverage, 1030,
     /* 144988 */     GIR_EraseRootFromParent_Done,
     /* 144989 */   // Label 2845: @144989
     /* 144989 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145025), // Rule ID 1031 //
     /* 144994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145016 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 145019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145023 */     GIR_RootConstrainSelectedInstOperands,
     /* 145024 */     // GIR_Coverage, 1031,
     /* 145024 */     GIR_EraseRootFromParent_Done,
     /* 145025 */   // Label 2846: @145025
     /* 145025 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145061), // Rule ID 1032 //
     /* 145030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145052 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 145055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145059 */     GIR_RootConstrainSelectedInstOperands,
     /* 145060 */     // GIR_Coverage, 1032,
     /* 145060 */     GIR_EraseRootFromParent_Done,
     /* 145061 */   // Label 2847: @145061
     /* 145061 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145097), // Rule ID 1033 //
     /* 145066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145088 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 145091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145095 */     GIR_RootConstrainSelectedInstOperands,
     /* 145096 */     // GIR_Coverage, 1033,
     /* 145096 */     GIR_EraseRootFromParent_Done,
     /* 145097 */   // Label 2848: @145097
     /* 145097 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145133), // Rule ID 1034 //
     /* 145102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145124 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 145127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145131 */     GIR_RootConstrainSelectedInstOperands,
     /* 145132 */     // GIR_Coverage, 1034,
     /* 145132 */     GIR_EraseRootFromParent_Done,
     /* 145133 */   // Label 2849: @145133
     /* 145133 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145169), // Rule ID 1035 //
     /* 145138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145160 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 145163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145167 */     GIR_RootConstrainSelectedInstOperands,
     /* 145168 */     // GIR_Coverage, 1035,
     /* 145168 */     GIR_EraseRootFromParent_Done,
     /* 145169 */   // Label 2850: @145169
     /* 145169 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145205), // Rule ID 1062 //
     /* 145174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145196 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 145196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 145199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145203 */     GIR_RootConstrainSelectedInstOperands,
     /* 145204 */     // GIR_Coverage, 1062,
     /* 145204 */     GIR_EraseRootFromParent_Done,
     /* 145205 */   // Label 2851: @145205
     /* 145205 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145241), // Rule ID 1064 //
     /* 145210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145232 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 145235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145239 */     GIR_RootConstrainSelectedInstOperands,
     /* 145240 */     // GIR_Coverage, 1064,
     /* 145240 */     GIR_EraseRootFromParent_Done,
     /* 145241 */   // Label 2852: @145241
     /* 145241 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145277), // Rule ID 1066 //
     /* 145246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145268 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 145271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145275 */     GIR_RootConstrainSelectedInstOperands,
     /* 145276 */     // GIR_Coverage, 1066,
     /* 145276 */     GIR_EraseRootFromParent_Done,
     /* 145277 */   // Label 2853: @145277
     /* 145277 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145313), // Rule ID 1068 //
     /* 145282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145304 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 145307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145311 */     GIR_RootConstrainSelectedInstOperands,
     /* 145312 */     // GIR_Coverage, 1068,
     /* 145312 */     GIR_EraseRootFromParent_Done,
     /* 145313 */   // Label 2854: @145313
     /* 145313 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145349), // Rule ID 1070 //
     /* 145318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145340 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145347 */     GIR_RootConstrainSelectedInstOperands,
     /* 145348 */     // GIR_Coverage, 1070,
     /* 145348 */     GIR_EraseRootFromParent_Done,
     /* 145349 */   // Label 2855: @145349
     /* 145349 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145385), // Rule ID 1072 //
     /* 145354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145376 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 145379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145383 */     GIR_RootConstrainSelectedInstOperands,
     /* 145384 */     // GIR_Coverage, 1072,
     /* 145384 */     GIR_EraseRootFromParent_Done,
     /* 145385 */   // Label 2856: @145385
     /* 145385 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(145421), // Rule ID 1086 //
     /* 145390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145412 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 145415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145419 */     GIR_RootConstrainSelectedInstOperands,
     /* 145420 */     // GIR_Coverage, 1086,
     /* 145420 */     GIR_EraseRootFromParent_Done,
     /* 145421 */   // Label 2857: @145421
     /* 145421 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(145457), // Rule ID 1087 //
     /* 145426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 145451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145455 */     GIR_RootConstrainSelectedInstOperands,
     /* 145456 */     // GIR_Coverage, 1087,
     /* 145456 */     GIR_EraseRootFromParent_Done,
     /* 145457 */   // Label 2858: @145457
     /* 145457 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145493), // Rule ID 1088 //
     /* 145462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145484 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 145487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145491 */     GIR_RootConstrainSelectedInstOperands,
     /* 145492 */     // GIR_Coverage, 1088,
     /* 145492 */     GIR_EraseRootFromParent_Done,
     /* 145493 */   // Label 2859: @145493
     /* 145493 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145529), // Rule ID 1089 //
     /* 145498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 145523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145527 */     GIR_RootConstrainSelectedInstOperands,
     /* 145528 */     // GIR_Coverage, 1089,
     /* 145528 */     GIR_EraseRootFromParent_Done,
     /* 145529 */   // Label 2860: @145529
     /* 145529 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145565), // Rule ID 1653 //
     /* 145534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 145542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145556 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 145559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145563 */     GIR_RootConstrainSelectedInstOperands,
     /* 145564 */     // GIR_Coverage, 1653,
     /* 145564 */     GIR_EraseRootFromParent_Done,
     /* 145565 */   // Label 2861: @145565
     /* 145565 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145601), // Rule ID 1659 //
     /* 145570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145592 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 145595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145599 */     GIR_RootConstrainSelectedInstOperands,
     /* 145600 */     // GIR_Coverage, 1659,
     /* 145600 */     GIR_EraseRootFromParent_Done,
     /* 145601 */   // Label 2862: @145601
     /* 145601 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145637), // Rule ID 1660 //
     /* 145606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145628 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 145631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145635 */     GIR_RootConstrainSelectedInstOperands,
     /* 145636 */     // GIR_Coverage, 1660,
     /* 145636 */     GIR_EraseRootFromParent_Done,
     /* 145637 */   // Label 2863: @145637
     /* 145637 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145673), // Rule ID 1661 //
     /* 145642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145664 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 145667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145671 */     GIR_RootConstrainSelectedInstOperands,
     /* 145672 */     // GIR_Coverage, 1661,
     /* 145672 */     GIR_EraseRootFromParent_Done,
     /* 145673 */   // Label 2864: @145673
     /* 145673 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145709), // Rule ID 1662 //
     /* 145678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145700 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 145703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145707 */     GIR_RootConstrainSelectedInstOperands,
     /* 145708 */     // GIR_Coverage, 1662,
     /* 145708 */     GIR_EraseRootFromParent_Done,
     /* 145709 */   // Label 2865: @145709
     /* 145709 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145745), // Rule ID 1663 //
     /* 145714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 145722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145736 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 145739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145743 */     GIR_RootConstrainSelectedInstOperands,
     /* 145744 */     // GIR_Coverage, 1663,
     /* 145744 */     GIR_EraseRootFromParent_Done,
     /* 145745 */   // Label 2866: @145745
     /* 145745 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(145781), // Rule ID 1664 //
     /* 145750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 145758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145772 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 145775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145779 */     GIR_RootConstrainSelectedInstOperands,
     /* 145780 */     // GIR_Coverage, 1664,
     /* 145780 */     GIR_EraseRootFromParent_Done,
     /* 145781 */   // Label 2867: @145781
     /* 145781 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(145817), // Rule ID 1670 //
     /* 145786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 145794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145808 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 145811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145815 */     GIR_RootConstrainSelectedInstOperands,
     /* 145816 */     // GIR_Coverage, 1670,
     /* 145816 */     GIR_EraseRootFromParent_Done,
     /* 145817 */   // Label 2868: @145817
     /* 145817 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(145853), // Rule ID 1943 //
     /* 145822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145844 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 145847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145851 */     GIR_RootConstrainSelectedInstOperands,
     /* 145852 */     // GIR_Coverage, 1943,
     /* 145852 */     GIR_EraseRootFromParent_Done,
     /* 145853 */   // Label 2869: @145853
     /* 145853 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(145889), // Rule ID 1945 //
     /* 145858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145880 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 145883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145887 */     GIR_RootConstrainSelectedInstOperands,
     /* 145888 */     // GIR_Coverage, 1945,
     /* 145888 */     GIR_EraseRootFromParent_Done,
     /* 145889 */   // Label 2870: @145889
     /* 145889 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(145925), // Rule ID 1947 //
     /* 145894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145916 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 145919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145923 */     GIR_RootConstrainSelectedInstOperands,
     /* 145924 */     // GIR_Coverage, 1947,
     /* 145924 */     GIR_EraseRootFromParent_Done,
     /* 145925 */   // Label 2871: @145925
     /* 145925 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(145961), // Rule ID 1949 //
     /* 145930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145952 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 145955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145959 */     GIR_RootConstrainSelectedInstOperands,
     /* 145960 */     // GIR_Coverage, 1949,
     /* 145960 */     GIR_EraseRootFromParent_Done,
     /* 145961 */   // Label 2872: @145961
     /* 145961 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145997), // Rule ID 1951 //
     /* 145966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145988 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 145991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145995 */     GIR_RootConstrainSelectedInstOperands,
     /* 145996 */     // GIR_Coverage, 1951,
     /* 145996 */     GIR_EraseRootFromParent_Done,
     /* 145997 */   // Label 2873: @145997
     /* 145997 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146033), // Rule ID 1953 //
     /* 146002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146024 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 146027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146031 */     GIR_RootConstrainSelectedInstOperands,
     /* 146032 */     // GIR_Coverage, 1953,
     /* 146032 */     GIR_EraseRootFromParent_Done,
     /* 146033 */   // Label 2874: @146033
     /* 146033 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146069), // Rule ID 1955 //
     /* 146038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146060 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 146063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146067 */     GIR_RootConstrainSelectedInstOperands,
     /* 146068 */     // GIR_Coverage, 1955,
     /* 146068 */     GIR_EraseRootFromParent_Done,
     /* 146069 */   // Label 2875: @146069
     /* 146069 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146105), // Rule ID 1957 //
     /* 146074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146096 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 146099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146103 */     GIR_RootConstrainSelectedInstOperands,
     /* 146104 */     // GIR_Coverage, 1957,
     /* 146104 */     GIR_EraseRootFromParent_Done,
     /* 146105 */   // Label 2876: @146105
     /* 146105 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146141), // Rule ID 1959 //
     /* 146110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146132 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 146135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146139 */     GIR_RootConstrainSelectedInstOperands,
     /* 146140 */     // GIR_Coverage, 1959,
     /* 146140 */     GIR_EraseRootFromParent_Done,
     /* 146141 */   // Label 2877: @146141
     /* 146141 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146177), // Rule ID 1961 //
     /* 146146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146168 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 146171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146175 */     GIR_RootConstrainSelectedInstOperands,
     /* 146176 */     // GIR_Coverage, 1961,
     /* 146176 */     GIR_EraseRootFromParent_Done,
     /* 146177 */   // Label 2878: @146177
     /* 146177 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146213), // Rule ID 1963 //
     /* 146182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146204 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 146207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146211 */     GIR_RootConstrainSelectedInstOperands,
     /* 146212 */     // GIR_Coverage, 1963,
     /* 146212 */     GIR_EraseRootFromParent_Done,
     /* 146213 */   // Label 2879: @146213
     /* 146213 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146249), // Rule ID 1965 //
     /* 146218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146240 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 146243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146247 */     GIR_RootConstrainSelectedInstOperands,
     /* 146248 */     // GIR_Coverage, 1965,
     /* 146248 */     GIR_EraseRootFromParent_Done,
     /* 146249 */   // Label 2880: @146249
     /* 146249 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146285), // Rule ID 2305 //
     /* 146254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 146262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146276 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 146279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146283 */     GIR_RootConstrainSelectedInstOperands,
     /* 146284 */     // GIR_Coverage, 2305,
     /* 146284 */     GIR_EraseRootFromParent_Done,
     /* 146285 */   // Label 2881: @146285
     /* 146285 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146321), // Rule ID 2306 //
     /* 146290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 146298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146312 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 146315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146319 */     GIR_RootConstrainSelectedInstOperands,
     /* 146320 */     // GIR_Coverage, 2306,
     /* 146320 */     GIR_EraseRootFromParent_Done,
     /* 146321 */   // Label 2882: @146321
     /* 146321 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146357), // Rule ID 2314 //
     /* 146326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 146329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 146334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146348 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 146351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146355 */     GIR_RootConstrainSelectedInstOperands,
     /* 146356 */     // GIR_Coverage, 2314,
     /* 146356 */     GIR_EraseRootFromParent_Done,
     /* 146357 */   // Label 2883: @146357
     /* 146357 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146393), // Rule ID 2515 //
     /* 146362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146384 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 146384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146391 */     GIR_RootConstrainSelectedInstOperands,
     /* 146392 */     // GIR_Coverage, 2515,
     /* 146392 */     GIR_EraseRootFromParent_Done,
     /* 146393 */   // Label 2884: @146393
     /* 146393 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146432), // Rule ID 3548 //
     /* 146398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 146409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 146412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1619:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 146420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 146423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146430 */     GIR_RootConstrainSelectedInstOperands,
     /* 146431 */     // GIR_Coverage, 3548,
     /* 146431 */     GIR_EraseRootFromParent_Done,
     /* 146432 */   // Label 2885: @146432
     /* 146432 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146471), // Rule ID 3549 //
     /* 146437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 146448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1619:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 146459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 146462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146469 */     GIR_RootConstrainSelectedInstOperands,
     /* 146470 */     // GIR_Coverage, 3549,
     /* 146470 */     GIR_EraseRootFromParent_Done,
     /* 146471 */   // Label 2886: @146471
     /* 146471 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146510), // Rule ID 3550 //
     /* 146476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 146487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1619:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 146498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 146501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146508 */     GIR_RootConstrainSelectedInstOperands,
     /* 146509 */     // GIR_Coverage, 3550,
     /* 146509 */     GIR_EraseRootFromParent_Done,
     /* 146510 */   // Label 2887: @146510
     /* 146510 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146549), // Rule ID 3551 //
     /* 146515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 146526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 146529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146537 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1619:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 146537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 146540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146547 */     GIR_RootConstrainSelectedInstOperands,
     /* 146548 */     // GIR_Coverage, 3551,
     /* 146548 */     GIR_EraseRootFromParent_Done,
     /* 146549 */   // Label 2888: @146549
     /* 146549 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146605), // Rule ID 3555 //
     /* 146554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 146568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1621:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 146576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 146593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146603 */     GIR_RootConstrainSelectedInstOperands,
     /* 146604 */     // GIR_Coverage, 3555,
     /* 146604 */     GIR_EraseRootFromParent_Done,
     /* 146605 */   // Label 2889: @146605
     /* 146605 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146661), // Rule ID 3556 //
     /* 146610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 146621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 146624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1621:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 146632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 146649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146659 */     GIR_RootConstrainSelectedInstOperands,
     /* 146660 */     // GIR_Coverage, 3556,
     /* 146660 */     GIR_EraseRootFromParent_Done,
     /* 146661 */   // Label 2890: @146661
     /* 146661 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146717), // Rule ID 3557 //
     /* 146666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 146677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 146680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1621:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 146688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 146705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146715 */     GIR_RootConstrainSelectedInstOperands,
     /* 146716 */     // GIR_Coverage, 3557,
     /* 146716 */     GIR_EraseRootFromParent_Done,
     /* 146717 */   // Label 2891: @146717
     /* 146717 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146773), // Rule ID 3558 //
     /* 146722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 146733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 146736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1621:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 146744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 146761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146771 */     GIR_RootConstrainSelectedInstOperands,
     /* 146772 */     // GIR_Coverage, 3558,
     /* 146772 */     GIR_EraseRootFromParent_Done,
     /* 146773 */   // Label 2892: @146773
     /* 146773 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(146806), // Rule ID 4001 //
     /* 146778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 146783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146797 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 146797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 146800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146804 */     GIR_RootConstrainSelectedInstOperands,
     /* 146805 */     // GIR_Coverage, 4001,
     /* 146805 */     GIR_EraseRootFromParent_Done,
     /* 146806 */   // Label 2893: @146806
     /* 146806 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(146871), // Rule ID 4002 //
     /* 146811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 146816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146830 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 146830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 146833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 146837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 146860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146870 */     // GIR_Coverage, 4002,
     /* 146870 */     GIR_EraseRootFromParent_Done,
     /* 146871 */   // Label 2894: @146871
     /* 146871 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(146904), // Rule ID 4770 //
     /* 146876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146895 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 146898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146902 */     GIR_RootConstrainSelectedInstOperands,
     /* 146903 */     // GIR_Coverage, 4770,
     /* 146903 */     GIR_EraseRootFromParent_Done,
     /* 146904 */   // Label 2895: @146904
     /* 146904 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(146937), // Rule ID 4771 //
     /* 146909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146928 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 146931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146935 */     GIR_RootConstrainSelectedInstOperands,
     /* 146936 */     // GIR_Coverage, 4771,
     /* 146936 */     GIR_EraseRootFromParent_Done,
     /* 146937 */   // Label 2896: @146937
     /* 146937 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(146970), // Rule ID 4772 //
     /* 146942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146961 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146968 */     GIR_RootConstrainSelectedInstOperands,
     /* 146969 */     // GIR_Coverage, 4772,
     /* 146969 */     GIR_EraseRootFromParent_Done,
     /* 146970 */   // Label 2897: @146970
     /* 146970 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147003), // Rule ID 4773 //
     /* 146975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146994 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 146997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147001 */     GIR_RootConstrainSelectedInstOperands,
     /* 147002 */     // GIR_Coverage, 4773,
     /* 147002 */     GIR_EraseRootFromParent_Done,
     /* 147003 */   // Label 2898: @147003
     /* 147003 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147036), // Rule ID 4887 //
     /* 147008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 147013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147027 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 147027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 147030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147034 */     GIR_RootConstrainSelectedInstOperands,
     /* 147035 */     // GIR_Coverage, 4887,
     /* 147035 */     GIR_EraseRootFromParent_Done,
     /* 147036 */   // Label 2899: @147036
     /* 147036 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147069), // Rule ID 4897 //
     /* 147041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 147046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147060 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 147060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 147063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147067 */     GIR_RootConstrainSelectedInstOperands,
     /* 147068 */     // GIR_Coverage, 4897,
     /* 147068 */     GIR_EraseRootFromParent_Done,
     /* 147069 */   // Label 2900: @147069
     /* 147069 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147105), // Rule ID 5236 //
     /* 147074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147096 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 147099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147103 */     GIR_RootConstrainSelectedInstOperands,
     /* 147104 */     // GIR_Coverage, 5236,
     /* 147104 */     GIR_EraseRootFromParent_Done,
     /* 147105 */   // Label 2901: @147105
     /* 147105 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147138), // Rule ID 5239 //
     /* 147110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 147115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147129 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 147132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147136 */     GIR_RootConstrainSelectedInstOperands,
     /* 147137 */     // GIR_Coverage, 5239,
     /* 147137 */     GIR_EraseRootFromParent_Done,
     /* 147138 */   // Label 2902: @147138
     /* 147138 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147171), // Rule ID 5240 //
     /* 147143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 147148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147162 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 147165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147169 */     GIR_RootConstrainSelectedInstOperands,
     /* 147170 */     // GIR_Coverage, 5240,
     /* 147170 */     GIR_EraseRootFromParent_Done,
     /* 147171 */   // Label 2903: @147171
     /* 147171 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147204), // Rule ID 5241 //
     /* 147176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 147181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147195 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 147198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147202 */     GIR_RootConstrainSelectedInstOperands,
     /* 147203 */     // GIR_Coverage, 5241,
     /* 147203 */     GIR_EraseRootFromParent_Done,
     /* 147204 */   // Label 2904: @147204
     /* 147204 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147237), // Rule ID 5242 //
     /* 147209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 147214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147228 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 147231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 5242,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2905: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147270), // Rule ID 5243 //
     /* 147242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 147247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147261 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 147264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147268 */     GIR_RootConstrainSelectedInstOperands,
     /* 147269 */     // GIR_Coverage, 5243,
     /* 147269 */     GIR_EraseRootFromParent_Done,
     /* 147270 */   // Label 2906: @147270
     /* 147270 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147303), // Rule ID 5244 //
     /* 147275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 147280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147294 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 147297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147301 */     GIR_RootConstrainSelectedInstOperands,
     /* 147302 */     // GIR_Coverage, 5244,
     /* 147302 */     GIR_EraseRootFromParent_Done,
     /* 147303 */   // Label 2907: @147303
     /* 147303 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147336), // Rule ID 5245 //
     /* 147308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 147313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147327 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 147330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147334 */     GIR_RootConstrainSelectedInstOperands,
     /* 147335 */     // GIR_Coverage, 5245,
     /* 147335 */     GIR_EraseRootFromParent_Done,
     /* 147336 */   // Label 2908: @147336
     /* 147336 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147369), // Rule ID 5246 //
     /* 147341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 147346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147360 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 147363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147367 */     GIR_RootConstrainSelectedInstOperands,
     /* 147368 */     // GIR_Coverage, 5246,
     /* 147368 */     GIR_EraseRootFromParent_Done,
     /* 147369 */   // Label 2909: @147369
     /* 147369 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147402), // Rule ID 5247 //
     /* 147374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147393 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 147396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147400 */     GIR_RootConstrainSelectedInstOperands,
     /* 147401 */     // GIR_Coverage, 5247,
     /* 147401 */     GIR_EraseRootFromParent_Done,
     /* 147402 */   // Label 2910: @147402
     /* 147402 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147435), // Rule ID 5248 //
     /* 147407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147426 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 147429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147433 */     GIR_RootConstrainSelectedInstOperands,
     /* 147434 */     // GIR_Coverage, 5248,
     /* 147434 */     GIR_EraseRootFromParent_Done,
     /* 147435 */   // Label 2911: @147435
     /* 147435 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147468), // Rule ID 5249 //
     /* 147440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147459 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 147462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147466 */     GIR_RootConstrainSelectedInstOperands,
     /* 147467 */     // GIR_Coverage, 5249,
     /* 147467 */     GIR_EraseRootFromParent_Done,
     /* 147468 */   // Label 2912: @147468
     /* 147468 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147501), // Rule ID 5250 //
     /* 147473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147492 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 147495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147499 */     GIR_RootConstrainSelectedInstOperands,
     /* 147500 */     // GIR_Coverage, 5250,
     /* 147500 */     GIR_EraseRootFromParent_Done,
     /* 147501 */   // Label 2913: @147501
     /* 147501 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147534), // Rule ID 5251 //
     /* 147506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147525 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147532 */     GIR_RootConstrainSelectedInstOperands,
     /* 147533 */     // GIR_Coverage, 5251,
     /* 147533 */     GIR_EraseRootFromParent_Done,
     /* 147534 */   // Label 2914: @147534
     /* 147534 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147567), // Rule ID 5252 //
     /* 147539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147558 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147565 */     GIR_RootConstrainSelectedInstOperands,
     /* 147566 */     // GIR_Coverage, 5252,
     /* 147566 */     GIR_EraseRootFromParent_Done,
     /* 147567 */   // Label 2915: @147567
     /* 147567 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147600), // Rule ID 5264 //
     /* 147572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147591 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 147594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147598 */     GIR_RootConstrainSelectedInstOperands,
     /* 147599 */     // GIR_Coverage, 5264,
     /* 147599 */     GIR_EraseRootFromParent_Done,
     /* 147600 */   // Label 2916: @147600
     /* 147600 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147633), // Rule ID 5265 //
     /* 147605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147624 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 147627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147631 */     GIR_RootConstrainSelectedInstOperands,
     /* 147632 */     // GIR_Coverage, 5265,
     /* 147632 */     GIR_EraseRootFromParent_Done,
     /* 147633 */   // Label 2917: @147633
     /* 147633 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147666), // Rule ID 5266 //
     /* 147638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147657 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 147660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147664 */     GIR_RootConstrainSelectedInstOperands,
     /* 147665 */     // GIR_Coverage, 5266,
     /* 147665 */     GIR_EraseRootFromParent_Done,
     /* 147666 */   // Label 2918: @147666
     /* 147666 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147699), // Rule ID 5267 //
     /* 147671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147690 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 147693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147697 */     GIR_RootConstrainSelectedInstOperands,
     /* 147698 */     // GIR_Coverage, 5267,
     /* 147698 */     GIR_EraseRootFromParent_Done,
     /* 147699 */   // Label 2919: @147699
     /* 147699 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147732), // Rule ID 5268 //
     /* 147704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147723 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 147726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147730 */     GIR_RootConstrainSelectedInstOperands,
     /* 147731 */     // GIR_Coverage, 5268,
     /* 147731 */     GIR_EraseRootFromParent_Done,
     /* 147732 */   // Label 2920: @147732
     /* 147732 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(147765), // Rule ID 5269 //
     /* 147737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147756 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147763 */     GIR_RootConstrainSelectedInstOperands,
     /* 147764 */     // GIR_Coverage, 5269,
     /* 147764 */     GIR_EraseRootFromParent_Done,
     /* 147765 */   // Label 2921: @147765
     /* 147765 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(147798), // Rule ID 5270 //
     /* 147770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147789 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147796 */     GIR_RootConstrainSelectedInstOperands,
     /* 147797 */     // GIR_Coverage, 5270,
     /* 147797 */     GIR_EraseRootFromParent_Done,
     /* 147798 */   // Label 2922: @147798
     /* 147798 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(147831), // Rule ID 5600 //
     /* 147803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147822 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147829 */     GIR_RootConstrainSelectedInstOperands,
     /* 147830 */     // GIR_Coverage, 5600,
     /* 147830 */     GIR_EraseRootFromParent_Done,
     /* 147831 */   // Label 2923: @147831
     /* 147831 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(147916), // Rule ID 5601 //
     /* 147836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147855 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 147855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 147858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 147862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147889 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 147896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147914 */     GIR_RootConstrainSelectedInstOperands,
     /* 147915 */     // GIR_Coverage, 5601,
     /* 147915 */     GIR_EraseRootFromParent_Done,
     /* 147916 */   // Label 2924: @147916
     /* 147916 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(147949), // Rule ID 5602 //
     /* 147921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147940 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 147943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147947 */     GIR_RootConstrainSelectedInstOperands,
     /* 147948 */     // GIR_Coverage, 5602,
     /* 147948 */     GIR_EraseRootFromParent_Done,
     /* 147949 */   // Label 2925: @147949
     /* 147949 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(147982), // Rule ID 5604 //
     /* 147954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147973 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 147976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147980 */     GIR_RootConstrainSelectedInstOperands,
     /* 147981 */     // GIR_Coverage, 5604,
     /* 147981 */     GIR_EraseRootFromParent_Done,
     /* 147982 */   // Label 2926: @147982
     /* 147982 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148015), // Rule ID 5606 //
     /* 147987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148006 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 148009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148013 */     GIR_RootConstrainSelectedInstOperands,
     /* 148014 */     // GIR_Coverage, 5606,
     /* 148014 */     GIR_EraseRootFromParent_Done,
     /* 148015 */   // Label 2927: @148015
     /* 148015 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148048), // Rule ID 5608 //
     /* 148020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148039 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 148042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148046 */     GIR_RootConstrainSelectedInstOperands,
     /* 148047 */     // GIR_Coverage, 5608,
     /* 148047 */     GIR_EraseRootFromParent_Done,
     /* 148048 */   // Label 2928: @148048
     /* 148048 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148081), // Rule ID 5610 //
     /* 148053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148072 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 148075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148079 */     GIR_RootConstrainSelectedInstOperands,
     /* 148080 */     // GIR_Coverage, 5610,
     /* 148080 */     GIR_EraseRootFromParent_Done,
     /* 148081 */   // Label 2929: @148081
     /* 148081 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148114), // Rule ID 5612 //
     /* 148086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148105 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 148108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148112 */     GIR_RootConstrainSelectedInstOperands,
     /* 148113 */     // GIR_Coverage, 5612,
     /* 148113 */     GIR_EraseRootFromParent_Done,
     /* 148114 */   // Label 2930: @148114
     /* 148114 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148147), // Rule ID 5614 //
     /* 148119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148138 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 148141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148145 */     GIR_RootConstrainSelectedInstOperands,
     /* 148146 */     // GIR_Coverage, 5614,
     /* 148146 */     GIR_EraseRootFromParent_Done,
     /* 148147 */   // Label 2931: @148147
     /* 148147 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148180), // Rule ID 5616 //
     /* 148152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148171 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 148174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148178 */     GIR_RootConstrainSelectedInstOperands,
     /* 148179 */     // GIR_Coverage, 5616,
     /* 148179 */     GIR_EraseRootFromParent_Done,
     /* 148180 */   // Label 2932: @148180
     /* 148180 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148213), // Rule ID 5618 //
     /* 148185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148204 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 148207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148211 */     GIR_RootConstrainSelectedInstOperands,
     /* 148212 */     // GIR_Coverage, 5618,
     /* 148212 */     GIR_EraseRootFromParent_Done,
     /* 148213 */   // Label 2933: @148213
     /* 148213 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148246), // Rule ID 13053 //
     /* 148218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148237 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148244 */     GIR_RootConstrainSelectedInstOperands,
     /* 148245 */     // GIR_Coverage, 13053,
     /* 148245 */     GIR_EraseRootFromParent_Done,
     /* 148246 */   // Label 2934: @148246
     /* 148246 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148279), // Rule ID 13055 //
     /* 148251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148270 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148277 */     GIR_RootConstrainSelectedInstOperands,
     /* 148278 */     // GIR_Coverage, 13055,
     /* 148278 */     GIR_EraseRootFromParent_Done,
     /* 148279 */   // Label 2935: @148279
     /* 148279 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148312), // Rule ID 13057 //
     /* 148284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148303 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148310 */     GIR_RootConstrainSelectedInstOperands,
     /* 148311 */     // GIR_Coverage, 13057,
     /* 148311 */     GIR_EraseRootFromParent_Done,
     /* 148312 */   // Label 2936: @148312
     /* 148312 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148345), // Rule ID 13059 //
     /* 148317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148336 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148343 */     GIR_RootConstrainSelectedInstOperands,
     /* 148344 */     // GIR_Coverage, 13059,
     /* 148344 */     GIR_EraseRootFromParent_Done,
     /* 148345 */   // Label 2937: @148345
     /* 148345 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148460), // Rule ID 13060 //
     /* 148350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148369 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148381 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148442 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148459 */     // GIR_Coverage, 13060,
     /* 148459 */     GIR_EraseRootFromParent_Done,
     /* 148460 */   // Label 2938: @148460
     /* 148460 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148493), // Rule ID 13062 //
     /* 148465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148484 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148491 */     GIR_RootConstrainSelectedInstOperands,
     /* 148492 */     // GIR_Coverage, 13062,
     /* 148492 */     GIR_EraseRootFromParent_Done,
     /* 148493 */   // Label 2939: @148493
     /* 148493 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148526), // Rule ID 13064 //
     /* 148498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148517 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148524 */     GIR_RootConstrainSelectedInstOperands,
     /* 148525 */     // GIR_Coverage, 13064,
     /* 148525 */     GIR_EraseRootFromParent_Done,
     /* 148526 */   // Label 2940: @148526
     /* 148526 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(148559), // Rule ID 13066 //
     /* 148531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148550 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148557 */     GIR_RootConstrainSelectedInstOperands,
     /* 148558 */     // GIR_Coverage, 13066,
     /* 148558 */     GIR_EraseRootFromParent_Done,
     /* 148559 */   // Label 2941: @148559
     /* 148559 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(148592), // Rule ID 13068 //
     /* 148564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148583 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148590 */     GIR_RootConstrainSelectedInstOperands,
     /* 148591 */     // GIR_Coverage, 13068,
     /* 148591 */     GIR_EraseRootFromParent_Done,
     /* 148592 */   // Label 2942: @148592
     /* 148592 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(148707), // Rule ID 13069 //
     /* 148597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148616 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148706 */     // GIR_Coverage, 13069,
     /* 148706 */     GIR_EraseRootFromParent_Done,
     /* 148707 */   // Label 2943: @148707
     /* 148707 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(148826), // Rule ID 13070 //
     /* 148712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148731 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148743 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148747 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148785 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148808 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148825 */     // GIR_Coverage, 13070,
     /* 148825 */     GIR_EraseRootFromParent_Done,
     /* 148826 */   // Label 2944: @148826
     /* 148826 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(148941), // Rule ID 13071 //
     /* 148831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148850 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 148850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 148857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148862 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 148871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 148885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148923 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148940 */     // GIR_Coverage, 13071,
     /* 148940 */     GIR_EraseRootFromParent_Done,
     /* 148941 */   // Label 2945: @148941
     /* 148941 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149060), // Rule ID 13072 //
     /* 148946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148965 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148977 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148981 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149042 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149059 */     // GIR_Coverage, 13072,
     /* 149059 */     GIR_EraseRootFromParent_Done,
     /* 149060 */   // Label 2946: @149060
     /* 149060 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149175), // Rule ID 13073 //
     /* 149065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149084 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149096 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149128 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149134 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149174 */     // GIR_Coverage, 13073,
     /* 149174 */     GIR_EraseRootFromParent_Done,
     /* 149175 */   // Label 2947: @149175
     /* 149175 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149208), // Rule ID 13075 //
     /* 149180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149199 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 149202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149206 */     GIR_RootConstrainSelectedInstOperands,
     /* 149207 */     // GIR_Coverage, 13075,
     /* 149207 */     GIR_EraseRootFromParent_Done,
     /* 149208 */   // Label 2948: @149208
     /* 149208 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149241), // Rule ID 13077 //
     /* 149213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149232 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 149235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149239 */     GIR_RootConstrainSelectedInstOperands,
     /* 149240 */     // GIR_Coverage, 13077,
     /* 149240 */     GIR_EraseRootFromParent_Done,
     /* 149241 */   // Label 2949: @149241
     /* 149241 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149274), // Rule ID 13079 //
     /* 149246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149265 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 149268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149272 */     GIR_RootConstrainSelectedInstOperands,
     /* 149273 */     // GIR_Coverage, 13079,
     /* 149273 */     GIR_EraseRootFromParent_Done,
     /* 149274 */   // Label 2950: @149274
     /* 149274 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149307), // Rule ID 13081 //
     /* 149279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149298 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 149301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149305 */     GIR_RootConstrainSelectedInstOperands,
     /* 149306 */     // GIR_Coverage, 13081,
     /* 149306 */     GIR_EraseRootFromParent_Done,
     /* 149307 */   // Label 2951: @149307
     /* 149307 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149422), // Rule ID 13082 //
     /* 149312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149331 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149331 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149334 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 149338 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149343 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149404 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149421 */     // GIR_Coverage, 13082,
     /* 149421 */     GIR_EraseRootFromParent_Done,
     /* 149422 */   // Label 2952: @149422
     /* 149422 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149541), // Rule ID 13083 //
     /* 149427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149446 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 149453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149458 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149462 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149471 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149475 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149540 */     // GIR_Coverage, 13083,
     /* 149540 */     GIR_EraseRootFromParent_Done,
     /* 149541 */   // Label 2953: @149541
     /* 149541 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149574), // Rule ID 13085 //
     /* 149546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149565 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 149568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149572 */     GIR_RootConstrainSelectedInstOperands,
     /* 149573 */     // GIR_Coverage, 13085,
     /* 149573 */     GIR_EraseRootFromParent_Done,
     /* 149574 */   // Label 2954: @149574
     /* 149574 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149607), // Rule ID 13087 //
     /* 149579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149598 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 149601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149605 */     GIR_RootConstrainSelectedInstOperands,
     /* 149606 */     // GIR_Coverage, 13087,
     /* 149606 */     GIR_EraseRootFromParent_Done,
     /* 149607 */   // Label 2955: @149607
     /* 149607 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149640), // Rule ID 13089 //
     /* 149612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149631 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 149634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149638 */     GIR_RootConstrainSelectedInstOperands,
     /* 149639 */     // GIR_Coverage, 13089,
     /* 149639 */     GIR_EraseRootFromParent_Done,
     /* 149640 */   // Label 2956: @149640
     /* 149640 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149673), // Rule ID 13091 //
     /* 149645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149664 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 149667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149671 */     GIR_RootConstrainSelectedInstOperands,
     /* 149672 */     // GIR_Coverage, 13091,
     /* 149672 */     GIR_EraseRootFromParent_Done,
     /* 149673 */   // Label 2957: @149673
     /* 149673 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149788), // Rule ID 13092 //
     /* 149678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149697 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149697 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149700 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 149704 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149709 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149741 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149744 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149770 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149787 */     // GIR_Coverage, 13092,
     /* 149787 */     GIR_EraseRootFromParent_Done,
     /* 149788 */   // Label 2958: @149788
     /* 149788 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149907), // Rule ID 13093 //
     /* 149793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149812 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149812 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149815 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 149819 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149824 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149828 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149889 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149906 */     // GIR_Coverage, 13093,
     /* 149906 */     GIR_EraseRootFromParent_Done,
     /* 149907 */   // Label 2959: @149907
     /* 149907 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149940), // Rule ID 13095 //
     /* 149912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149931 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 149934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149938 */     GIR_RootConstrainSelectedInstOperands,
     /* 149939 */     // GIR_Coverage, 13095,
     /* 149939 */     GIR_EraseRootFromParent_Done,
     /* 149940 */   // Label 2960: @149940
     /* 149940 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149973), // Rule ID 13097 //
     /* 149945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149964 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 149967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149971 */     GIR_RootConstrainSelectedInstOperands,
     /* 149972 */     // GIR_Coverage, 13097,
     /* 149972 */     GIR_EraseRootFromParent_Done,
     /* 149973 */   // Label 2961: @149973
     /* 149973 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(150006), // Rule ID 13099 //
     /* 149978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149997 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 150000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150004 */     GIR_RootConstrainSelectedInstOperands,
     /* 150005 */     // GIR_Coverage, 13099,
     /* 150005 */     GIR_EraseRootFromParent_Done,
     /* 150006 */   // Label 2962: @150006
     /* 150006 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150039), // Rule ID 13101 //
     /* 150011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150030 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 150033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150037 */     GIR_RootConstrainSelectedInstOperands,
     /* 150038 */     // GIR_Coverage, 13101,
     /* 150038 */     GIR_EraseRootFromParent_Done,
     /* 150039 */   // Label 2963: @150039
     /* 150039 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150154), // Rule ID 13102 //
     /* 150044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150063 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 150070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150075 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150153 */     // GIR_Coverage, 13102,
     /* 150153 */     GIR_EraseRootFromParent_Done,
     /* 150154 */   // Label 2964: @150154
     /* 150154 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150273), // Rule ID 13103 //
     /* 150159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150178 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 150185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150190 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150194 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150272 */     // GIR_Coverage, 13103,
     /* 150272 */     GIR_EraseRootFromParent_Done,
     /* 150273 */   // Label 2965: @150273
     /* 150273 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150306), // Rule ID 13105 //
     /* 150278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150297 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 150300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150304 */     GIR_RootConstrainSelectedInstOperands,
     /* 150305 */     // GIR_Coverage, 13105,
     /* 150305 */     GIR_EraseRootFromParent_Done,
     /* 150306 */   // Label 2966: @150306
     /* 150306 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150339), // Rule ID 13107 //
     /* 150311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150330 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 150333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150337 */     GIR_RootConstrainSelectedInstOperands,
     /* 150338 */     // GIR_Coverage, 13107,
     /* 150338 */     GIR_EraseRootFromParent_Done,
     /* 150339 */   // Label 2967: @150339
     /* 150339 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150372), // Rule ID 13109 //
     /* 150344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150363 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 150366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150370 */     GIR_RootConstrainSelectedInstOperands,
     /* 150371 */     // GIR_Coverage, 13109,
     /* 150371 */     GIR_EraseRootFromParent_Done,
     /* 150372 */   // Label 2968: @150372
     /* 150372 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150405), // Rule ID 13111 //
     /* 150377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150396 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 150399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150403 */     GIR_RootConstrainSelectedInstOperands,
     /* 150404 */     // GIR_Coverage, 13111,
     /* 150404 */     GIR_EraseRootFromParent_Done,
     /* 150405 */   // Label 2969: @150405
     /* 150405 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150520), // Rule ID 13112 //
     /* 150410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150429 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150429 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150432 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 150436 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150441 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150502 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150519 */     // GIR_Coverage, 13112,
     /* 150519 */     GIR_EraseRootFromParent_Done,
     /* 150520 */   // Label 2970: @150520
     /* 150520 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150639), // Rule ID 13113 //
     /* 150525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150544 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150544 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150547 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 150551 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150556 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150560 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150598 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150621 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150638 */     // GIR_Coverage, 13113,
     /* 150638 */     GIR_EraseRootFromParent_Done,
     /* 150639 */   // Label 2971: @150639
     /* 150639 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150671), // Rule ID 2393 //
     /* 150644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 150652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150662 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 150665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150669 */     GIR_RootConstrainSelectedInstOperands,
     /* 150670 */     // GIR_Coverage, 2393,
     /* 150670 */     GIR_EraseRootFromParent_Done,
     /* 150671 */   // Label 2972: @150671
     /* 150671 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150703), // Rule ID 2394 //
     /* 150676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 150684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150694 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1662:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 150697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150701 */     GIR_RootConstrainSelectedInstOperands,
     /* 150702 */     // GIR_Coverage, 2394,
     /* 150702 */     GIR_EraseRootFromParent_Done,
     /* 150703 */   // Label 2973: @150703
     /* 150703 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150735), // Rule ID 2395 //
     /* 150708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 150716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1663:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 150729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150733 */     GIR_RootConstrainSelectedInstOperands,
     /* 150734 */     // GIR_Coverage, 2395,
     /* 150734 */     GIR_EraseRootFromParent_Done,
     /* 150735 */   // Label 2974: @150735
     /* 150735 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150767), // Rule ID 3093 //
     /* 150740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 150751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 150761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150765 */     GIR_RootConstrainSelectedInstOperands,
     /* 150766 */     // GIR_Coverage, 3093,
     /* 150766 */     GIR_EraseRootFromParent_Done,
     /* 150767 */   // Label 2975: @150767
     /* 150767 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150799), // Rule ID 3094 //
     /* 150772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 150793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150797 */     GIR_RootConstrainSelectedInstOperands,
     /* 150798 */     // GIR_Coverage, 3094,
     /* 150798 */     GIR_EraseRootFromParent_Done,
     /* 150799 */   // Label 2976: @150799
     /* 150799 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150831), // Rule ID 3095 //
     /* 150804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 150825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150829 */     GIR_RootConstrainSelectedInstOperands,
     /* 150830 */     // GIR_Coverage, 3095,
     /* 150830 */     GIR_EraseRootFromParent_Done,
     /* 150831 */   // Label 2977: @150831
     /* 150831 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150863), // Rule ID 3349 //
     /* 150836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 150847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1653:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 150854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150861 */     GIR_RootConstrainSelectedInstOperands,
     /* 150862 */     // GIR_Coverage, 3349,
     /* 150862 */     GIR_EraseRootFromParent_Done,
     /* 150863 */   // Label 2978: @150863
     /* 150863 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150895), // Rule ID 3350 //
     /* 150868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 150879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 150882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1653:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 150886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150893 */     GIR_RootConstrainSelectedInstOperands,
     /* 150894 */     // GIR_Coverage, 3350,
     /* 150894 */     GIR_EraseRootFromParent_Done,
     /* 150895 */   // Label 2979: @150895
     /* 150895 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(150927), // Rule ID 3351 //
     /* 150900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 150911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 150914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1653:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 150918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150925 */     GIR_RootConstrainSelectedInstOperands,
     /* 150926 */     // GIR_Coverage, 3351,
     /* 150926 */     GIR_EraseRootFromParent_Done,
     /* 150927 */   // Label 2980: @150927
     /* 150927 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(150959), // Rule ID 3430 //
     /* 150932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 150935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1414:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 150953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150957 */     GIR_RootConstrainSelectedInstOperands,
     /* 150958 */     // GIR_Coverage, 3430,
     /* 150958 */     GIR_EraseRootFromParent_Done,
     /* 150959 */   // Label 2981: @150959
     /* 150959 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(150991), // Rule ID 3431 //
     /* 150964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 150967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1414:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 150985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150989 */     GIR_RootConstrainSelectedInstOperands,
     /* 150990 */     // GIR_Coverage, 3431,
     /* 150990 */     GIR_EraseRootFromParent_Done,
     /* 150991 */   // Label 2982: @150991
     /* 150991 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(151023), // Rule ID 3432 //
     /* 150996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 150999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 151007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 151017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151021 */     GIR_RootConstrainSelectedInstOperands,
     /* 151022 */     // GIR_Coverage, 3432,
     /* 151022 */     GIR_EraseRootFromParent_Done,
     /* 151023 */   // Label 2983: @151023
     /* 151023 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151055), // Rule ID 3458 //
     /* 151028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 151036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1253:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 151049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151053 */     GIR_RootConstrainSelectedInstOperands,
     /* 151054 */     // GIR_Coverage, 3458,
     /* 151054 */     GIR_EraseRootFromParent_Done,
     /* 151055 */   // Label 2984: @151055
     /* 151055 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151087), // Rule ID 4615 //
     /* 151060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151078 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 151081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151085 */     GIR_RootConstrainSelectedInstOperands,
     /* 151086 */     // GIR_Coverage, 4615,
     /* 151086 */     GIR_EraseRootFromParent_Done,
     /* 151087 */   // Label 2985: @151087
     /* 151087 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151119), // Rule ID 4616 //
     /* 151092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151110 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 151113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151117 */     GIR_RootConstrainSelectedInstOperands,
     /* 151118 */     // GIR_Coverage, 4616,
     /* 151118 */     GIR_EraseRootFromParent_Done,
     /* 151119 */   // Label 2986: @151119
     /* 151119 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151148), // Rule ID 4617 //
     /* 151124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151139 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 151142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151146 */     GIR_RootConstrainSelectedInstOperands,
     /* 151147 */     // GIR_Coverage, 4617,
     /* 151147 */     GIR_EraseRootFromParent_Done,
     /* 151148 */   // Label 2987: @151148
     /* 151148 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151177), // Rule ID 4618 //
     /* 151153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151168 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 151171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151175 */     GIR_RootConstrainSelectedInstOperands,
     /* 151176 */     // GIR_Coverage, 4618,
     /* 151176 */     GIR_EraseRootFromParent_Done,
     /* 151177 */   // Label 2988: @151177
     /* 151177 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151206), // Rule ID 4619 //
     /* 151182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151197 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 151200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151204 */     GIR_RootConstrainSelectedInstOperands,
     /* 151205 */     // GIR_Coverage, 4619,
     /* 151205 */     GIR_EraseRootFromParent_Done,
     /* 151206 */   // Label 2989: @151206
     /* 151206 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151235), // Rule ID 4620 //
     /* 151211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151226 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 151229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151233 */     GIR_RootConstrainSelectedInstOperands,
     /* 151234 */     // GIR_Coverage, 4620,
     /* 151234 */     GIR_EraseRootFromParent_Done,
     /* 151235 */   // Label 2990: @151235
     /* 151235 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(151267), // Rule ID 4627 //
     /* 151240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151258 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 151261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151265 */     GIR_RootConstrainSelectedInstOperands,
     /* 151266 */     // GIR_Coverage, 4627,
     /* 151266 */     GIR_EraseRootFromParent_Done,
     /* 151267 */   // Label 2991: @151267
     /* 151267 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151299), // Rule ID 4628 //
     /* 151272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151290 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 151293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151297 */     GIR_RootConstrainSelectedInstOperands,
     /* 151298 */     // GIR_Coverage, 4628,
     /* 151298 */     GIR_EraseRootFromParent_Done,
     /* 151299 */   // Label 2992: @151299
     /* 151299 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151328), // Rule ID 4629 //
     /* 151304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151319 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 151322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151326 */     GIR_RootConstrainSelectedInstOperands,
     /* 151327 */     // GIR_Coverage, 4629,
     /* 151327 */     GIR_EraseRootFromParent_Done,
     /* 151328 */   // Label 2993: @151328
     /* 151328 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151357), // Rule ID 4630 //
     /* 151333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151348 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 151351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151355 */     GIR_RootConstrainSelectedInstOperands,
     /* 151356 */     // GIR_Coverage, 4630,
     /* 151356 */     GIR_EraseRootFromParent_Done,
     /* 151357 */   // Label 2994: @151357
     /* 151357 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151386), // Rule ID 4631 //
     /* 151362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151377 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 151380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151384 */     GIR_RootConstrainSelectedInstOperands,
     /* 151385 */     // GIR_Coverage, 4631,
     /* 151385 */     GIR_EraseRootFromParent_Done,
     /* 151386 */   // Label 2995: @151386
     /* 151386 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151415), // Rule ID 4632 //
     /* 151391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151406 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 151409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151413 */     GIR_RootConstrainSelectedInstOperands,
     /* 151414 */     // GIR_Coverage, 4632,
     /* 151414 */     GIR_EraseRootFromParent_Done,
     /* 151415 */   // Label 2996: @151415
     /* 151415 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151444), // Rule ID 4927 //
     /* 151420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151435 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 151438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151442 */     GIR_RootConstrainSelectedInstOperands,
     /* 151443 */     // GIR_Coverage, 4927,
     /* 151443 */     GIR_EraseRootFromParent_Done,
     /* 151444 */   // Label 2997: @151444
     /* 151444 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151473), // Rule ID 4928 //
     /* 151449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 151467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151471 */     GIR_RootConstrainSelectedInstOperands,
     /* 151472 */     // GIR_Coverage, 4928,
     /* 151472 */     GIR_EraseRootFromParent_Done,
     /* 151473 */   // Label 2998: @151473
     /* 151473 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151502), // Rule ID 4929 //
     /* 151478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151493 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 151496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151500 */     GIR_RootConstrainSelectedInstOperands,
     /* 151501 */     // GIR_Coverage, 4929,
     /* 151501 */     GIR_EraseRootFromParent_Done,
     /* 151502 */   // Label 2999: @151502
     /* 151502 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151531), // Rule ID 4930 //
     /* 151507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 151525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151529 */     GIR_RootConstrainSelectedInstOperands,
     /* 151530 */     // GIR_Coverage, 4930,
     /* 151530 */     GIR_EraseRootFromParent_Done,
     /* 151531 */   // Label 3000: @151531
     /* 151531 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151560), // Rule ID 4931 //
     /* 151536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151551 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 151554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151558 */     GIR_RootConstrainSelectedInstOperands,
     /* 151559 */     // GIR_Coverage, 4931,
     /* 151559 */     GIR_EraseRootFromParent_Done,
     /* 151560 */   // Label 3001: @151560
     /* 151560 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151589), // Rule ID 4932 //
     /* 151565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151580 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 151583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151587 */     GIR_RootConstrainSelectedInstOperands,
     /* 151588 */     // GIR_Coverage, 4932,
     /* 151588 */     GIR_EraseRootFromParent_Done,
     /* 151589 */   // Label 3002: @151589
     /* 151589 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151618), // Rule ID 4933 //
     /* 151594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151609 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 151612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151616 */     GIR_RootConstrainSelectedInstOperands,
     /* 151617 */     // GIR_Coverage, 4933,
     /* 151617 */     GIR_EraseRootFromParent_Done,
     /* 151618 */   // Label 3003: @151618
     /* 151618 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151647), // Rule ID 4934 //
     /* 151623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151638 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 151641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151645 */     GIR_RootConstrainSelectedInstOperands,
     /* 151646 */     // GIR_Coverage, 4934,
     /* 151646 */     GIR_EraseRootFromParent_Done,
     /* 151647 */   // Label 3004: @151647
     /* 151647 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151676), // Rule ID 4935 //
     /* 151652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 151670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151674 */     GIR_RootConstrainSelectedInstOperands,
     /* 151675 */     // GIR_Coverage, 4935,
     /* 151675 */     GIR_EraseRootFromParent_Done,
     /* 151676 */   // Label 3005: @151676
     /* 151676 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151705), // Rule ID 4936 //
     /* 151681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151696 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 151699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151703 */     GIR_RootConstrainSelectedInstOperands,
     /* 151704 */     // GIR_Coverage, 4936,
     /* 151704 */     GIR_EraseRootFromParent_Done,
     /* 151705 */   // Label 3006: @151705
     /* 151705 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151737), // Rule ID 8348 //
     /* 151710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 151721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1652:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 151728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151735 */     GIR_RootConstrainSelectedInstOperands,
     /* 151736 */     // GIR_Coverage, 8348,
     /* 151736 */     GIR_EraseRootFromParent_Done,
     /* 151737 */   // Label 3007: @151737
     /* 151737 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151769), // Rule ID 8349 //
     /* 151742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1652:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151767 */     GIR_RootConstrainSelectedInstOperands,
     /* 151768 */     // GIR_Coverage, 8349,
     /* 151768 */     GIR_EraseRootFromParent_Done,
     /* 151769 */   // Label 3008: @151769
     /* 151769 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(151801), // Rule ID 8350 //
     /* 151774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1652:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151799 */     GIR_RootConstrainSelectedInstOperands,
     /* 151800 */     // GIR_Coverage, 8350,
     /* 151800 */     GIR_EraseRootFromParent_Done,
     /* 151801 */   // Label 3009: @151801
     /* 151801 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(151833), // Rule ID 11739 //
     /* 151806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151824 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 151827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151831 */     GIR_RootConstrainSelectedInstOperands,
     /* 151832 */     // GIR_Coverage, 11739,
     /* 151832 */     GIR_EraseRootFromParent_Done,
     /* 151833 */   // Label 3010: @151833
     /* 151833 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(151865), // Rule ID 11740 //
     /* 151838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 151859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151863 */     GIR_RootConstrainSelectedInstOperands,
     /* 151864 */     // GIR_Coverage, 11740,
     /* 151864 */     GIR_EraseRootFromParent_Done,
     /* 151865 */   // Label 3011: @151865
     /* 151865 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(151897), // Rule ID 11741 //
     /* 151870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 151891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151895 */     GIR_RootConstrainSelectedInstOperands,
     /* 151896 */     // GIR_Coverage, 11741,
     /* 151896 */     GIR_EraseRootFromParent_Done,
     /* 151897 */   // Label 3012: @151897
     /* 151897 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(151929), // Rule ID 11742 //
     /* 151902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 151923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151927 */     GIR_RootConstrainSelectedInstOperands,
     /* 151928 */     // GIR_Coverage, 11742,
     /* 151928 */     GIR_EraseRootFromParent_Done,
     /* 151929 */   // Label 3013: @151929
     /* 151929 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(151961), // Rule ID 11743 //
     /* 151934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 151955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151959 */     GIR_RootConstrainSelectedInstOperands,
     /* 151960 */     // GIR_Coverage, 11743,
     /* 151960 */     GIR_EraseRootFromParent_Done,
     /* 151961 */   // Label 3014: @151961
     /* 151961 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(151993), // Rule ID 11744 //
     /* 151966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 151987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151991 */     GIR_RootConstrainSelectedInstOperands,
     /* 151992 */     // GIR_Coverage, 11744,
     /* 151992 */     GIR_EraseRootFromParent_Done,
     /* 151993 */   // Label 3015: @151993
     /* 151993 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152025), // Rule ID 11899 //
     /* 151998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 152001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 152006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 152012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 152016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 152019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 152021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152023 */     GIR_RootConstrainSelectedInstOperands,
     /* 152024 */     // GIR_Coverage, 11899,
     /* 152024 */     GIR_EraseRootFromParent_Done,
     /* 152025 */   // Label 3016: @152025
     /* 152025 */   GIM_Reject,
     /* 152026 */ // Label 2697: @152026
     /* 152026 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(198340),
     /* 152031 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 152034 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152218), // Rule ID 2568 //
     /* 152039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152133 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152137 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152150 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152154 */     // MIs[5] Operand 1
     /* 152154 */     // No operand predicates
     /* 152154 */     // MIs[3] Operand 2
     /* 152154 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152169 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152171 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152183 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 152202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152216 */     GIR_RootConstrainSelectedInstOperands,
     /* 152217 */     // GIR_Coverage, 2568,
     /* 152217 */     GIR_EraseRootFromParent_Done,
     /* 152218 */   // Label 3018: @152218
     /* 152218 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152402), // Rule ID 6234 //
     /* 152223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152272 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152275 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152284 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152313 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152317 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152321 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152326 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152330 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152334 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152338 */     // MIs[5] Operand 1
     /* 152338 */     // No operand predicates
     /* 152338 */     // MIs[3] Operand 2
     /* 152338 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152349 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152353 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152355 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152367 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 152386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152400 */     GIR_RootConstrainSelectedInstOperands,
     /* 152401 */     // GIR_Coverage, 6234,
     /* 152401 */     GIR_EraseRootFromParent_Done,
     /* 152402 */   // Label 3019: @152402
     /* 152402 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152542), // Rule ID 2057 //
     /* 152407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152440 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152443 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152452 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152480 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152484 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152489 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152493 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152497 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152501 */     // MIs[4] Operand 1
     /* 152501 */     // No operand predicates
     /* 152501 */     // MIs[2] Operand 2
     /* 152501 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152512 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 152524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152540 */     GIR_RootConstrainSelectedInstOperands,
     /* 152541 */     // GIR_Coverage, 2057,
     /* 152541 */     GIR_EraseRootFromParent_Done,
     /* 152542 */   // Label 3020: @152542
     /* 152542 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(152682), // Rule ID 2064 //
     /* 152547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152580 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152583 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152592 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152620 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152629 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152633 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152637 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152641 */     // MIs[4] Operand 1
     /* 152641 */     // No operand predicates
     /* 152641 */     // MIs[2] Operand 2
     /* 152641 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152661 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 152664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152680 */     GIR_RootConstrainSelectedInstOperands,
     /* 152681 */     // GIR_Coverage, 2064,
     /* 152681 */     GIR_EraseRootFromParent_Done,
     /* 152682 */   // Label 3021: @152682
     /* 152682 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(152822), // Rule ID 2060 //
     /* 152687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152720 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152723 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152777 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152781 */     // MIs[4] Operand 1
     /* 152781 */     // No operand predicates
     /* 152781 */     // MIs[2] Operand 2
     /* 152781 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152792 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152801 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 152804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152820 */     GIR_RootConstrainSelectedInstOperands,
     /* 152821 */     // GIR_Coverage, 2060,
     /* 152821 */     GIR_EraseRootFromParent_Done,
     /* 152822 */   // Label 3022: @152822
     /* 152822 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(152962), // Rule ID 2067 //
     /* 152827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152860 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152863 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152909 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152913 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152917 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152921 */     // MIs[4] Operand 1
     /* 152921 */     // No operand predicates
     /* 152921 */     // MIs[2] Operand 2
     /* 152921 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152941 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 152944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152960 */     GIR_RootConstrainSelectedInstOperands,
     /* 152961 */     // GIR_Coverage, 2067,
     /* 152961 */     GIR_EraseRootFromParent_Done,
     /* 152962 */   // Label 3023: @152962
     /* 152962 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153099), // Rule ID 2055 //
     /* 152967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153000 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153003 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153012 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153041 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153045 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153054 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153058 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153062 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153066 */     // MIs[4] Operand 1
     /* 153066 */     // No operand predicates
     /* 153066 */     // MIs[2] Operand 2
     /* 153066 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153079 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 153082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153097 */     GIR_RootConstrainSelectedInstOperands,
     /* 153098 */     // GIR_Coverage, 2055,
     /* 153098 */     GIR_EraseRootFromParent_Done,
     /* 153099 */   // Label 3024: @153099
     /* 153099 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153236), // Rule ID 2062 //
     /* 153104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153137 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153140 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153149 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153199 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153203 */     // MIs[4] Operand 1
     /* 153203 */     // No operand predicates
     /* 153203 */     // MIs[2] Operand 2
     /* 153203 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153214 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153216 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 153219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153234 */     GIR_RootConstrainSelectedInstOperands,
     /* 153235 */     // GIR_Coverage, 2062,
     /* 153235 */     GIR_EraseRootFromParent_Done,
     /* 153236 */   // Label 3025: @153236
     /* 153236 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153373), // Rule ID 2058 //
     /* 153241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153315 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153319 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153323 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153328 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153332 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153336 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153340 */     // MIs[4] Operand 1
     /* 153340 */     // No operand predicates
     /* 153340 */     // MIs[2] Operand 2
     /* 153340 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153353 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 153356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153371 */     GIR_RootConstrainSelectedInstOperands,
     /* 153372 */     // GIR_Coverage, 2058,
     /* 153372 */     GIR_EraseRootFromParent_Done,
     /* 153373 */   // Label 3026: @153373
     /* 153373 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153510), // Rule ID 2065 //
     /* 153378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153423 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153465 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153469 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153473 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153477 */     // MIs[4] Operand 1
     /* 153477 */     // No operand predicates
     /* 153477 */     // MIs[2] Operand 2
     /* 153477 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153490 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 153493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153508 */     GIR_RootConstrainSelectedInstOperands,
     /* 153509 */     // GIR_Coverage, 2065,
     /* 153509 */     GIR_EraseRootFromParent_Done,
     /* 153510 */   // Label 3027: @153510
     /* 153510 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153671), // Rule ID 2569 //
     /* 153515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153564 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153567 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153576 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153597 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153601 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153614 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153618 */     // MIs[4] Operand 1
     /* 153618 */     // No operand predicates
     /* 153618 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153624 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153636 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 153655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153669 */     GIR_RootConstrainSelectedInstOperands,
     /* 153670 */     // GIR_Coverage, 2569,
     /* 153670 */     GIR_EraseRootFromParent_Done,
     /* 153671 */   // Label 3028: @153671
     /* 153671 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153832), // Rule ID 6235 //
     /* 153676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153725 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153728 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153737 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153762 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153775 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153779 */     // MIs[4] Operand 1
     /* 153779 */     // No operand predicates
     /* 153779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153783 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153785 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 153816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153830 */     GIR_RootConstrainSelectedInstOperands,
     /* 153831 */     // GIR_Coverage, 6235,
     /* 153831 */     GIR_EraseRootFromParent_Done,
     /* 153832 */   // Label 3029: @153832
     /* 153832 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153942), // Rule ID 2085 //
     /* 153837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153903 */     // MIs[3] Operand 1
     /* 153903 */     // No operand predicates
     /* 153903 */     // MIs[1] Operand 2
     /* 153903 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 153914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153923 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 153926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153940 */     GIR_RootConstrainSelectedInstOperands,
     /* 153941 */     // GIR_Coverage, 2085,
     /* 153941 */     GIR_EraseRootFromParent_Done,
     /* 153942 */   // Label 3030: @153942
     /* 153942 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154052), // Rule ID 2088 //
     /* 153947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154013 */     // MIs[3] Operand 1
     /* 154013 */     // No operand predicates
     /* 154013 */     // MIs[1] Operand 2
     /* 154013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 154024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154033 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 154036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154050 */     GIR_RootConstrainSelectedInstOperands,
     /* 154051 */     // GIR_Coverage, 2088,
     /* 154051 */     GIR_EraseRootFromParent_Done,
     /* 154052 */   // Label 3031: @154052
     /* 154052 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154141), // Rule ID 1743 //
     /* 154057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154090 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154093 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154102 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154122 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 154125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154139 */     GIR_RootConstrainSelectedInstOperands,
     /* 154140 */     // GIR_Coverage, 1743,
     /* 154140 */     GIR_EraseRootFromParent_Done,
     /* 154141 */   // Label 3032: @154141
     /* 154141 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154230), // Rule ID 1745 //
     /* 154146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154179 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154182 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154211 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 154214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154228 */     GIR_RootConstrainSelectedInstOperands,
     /* 154229 */     // GIR_Coverage, 1745,
     /* 154229 */     GIR_EraseRootFromParent_Done,
     /* 154230 */   // Label 3033: @154230
     /* 154230 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154319), // Rule ID 1747 //
     /* 154235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154271 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154280 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154300 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 154303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154317 */     GIR_RootConstrainSelectedInstOperands,
     /* 154318 */     // GIR_Coverage, 1747,
     /* 154318 */     GIR_EraseRootFromParent_Done,
     /* 154319 */   // Label 3034: @154319
     /* 154319 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154408), // Rule ID 1749 //
     /* 154324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154357 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154360 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154389 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 154392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154406 */     GIR_RootConstrainSelectedInstOperands,
     /* 154407 */     // GIR_Coverage, 1749,
     /* 154407 */     GIR_EraseRootFromParent_Done,
     /* 154408 */   // Label 3035: @154408
     /* 154408 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(154530), // Rule ID 6886 //
     /* 154413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154448 */     // MIs[1] Operand 2
     /* 154448 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154467 */     // MIs[2] Rn
     /* 154467 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154472 */     // MIs[2] Operand 2
     /* 154472 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154485 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 154485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 154492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154512 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154529 */     // GIR_Coverage, 6886,
     /* 154529 */     GIR_EraseRootFromParent_Done,
     /* 154530 */   // Label 3036: @154530
     /* 154530 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154652), // Rule ID 6888 //
     /* 154535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154570 */     // MIs[1] Operand 2
     /* 154570 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154589 */     // MIs[2] Rn
     /* 154589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154594 */     // MIs[2] Operand 2
     /* 154594 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154607 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 154607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 154614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154634 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154651 */     // GIR_Coverage, 6888,
     /* 154651 */     GIR_EraseRootFromParent_Done,
     /* 154652 */   // Label 3037: @154652
     /* 154652 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154774), // Rule ID 6890 //
     /* 154657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 154665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 154668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 154671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 154687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154692 */     // MIs[1] Operand 2
     /* 154692 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154711 */     // MIs[2] Rn
     /* 154711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154716 */     // MIs[2] Operand 2
     /* 154716 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 154727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154729 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 154729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 154736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154773 */     // GIR_Coverage, 6890,
     /* 154773 */     GIR_EraseRootFromParent_Done,
     /* 154774 */   // Label 3038: @154774
     /* 154774 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(154896), // Rule ID 6892 //
     /* 154779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154814 */     // MIs[1] Operand 2
     /* 154814 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154833 */     // MIs[2] Rn
     /* 154833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154838 */     // MIs[2] Operand 2
     /* 154838 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154851 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 154851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 154858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154878 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154895 */     // GIR_Coverage, 6892,
     /* 154895 */     GIR_EraseRootFromParent_Done,
     /* 154896 */   // Label 3039: @154896
     /* 154896 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(155018), // Rule ID 6894 //
     /* 154901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154936 */     // MIs[1] Operand 2
     /* 154936 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154955 */     // MIs[2] Rn
     /* 154955 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154960 */     // MIs[2] Operand 2
     /* 154960 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154973 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 154973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 154980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155000 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155017 */     // GIR_Coverage, 6894,
     /* 155017 */     GIR_EraseRootFromParent_Done,
     /* 155018 */   // Label 3040: @155018
     /* 155018 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(155201), // Rule ID 2567 //
     /* 155023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155072 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155075 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155084 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155098 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155104 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155104 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155107 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155111 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155118 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155121 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155125 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155130 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155133 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155137 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155145 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155150 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155167 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 155186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155199 */     GIR_RootConstrainSelectedInstOperands,
     /* 155200 */     // GIR_Coverage, 2567,
     /* 155200 */     GIR_EraseRootFromParent_Done,
     /* 155201 */   // Label 3041: @155201
     /* 155201 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155384), // Rule ID 6233 //
     /* 155206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155255 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155258 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155267 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155281 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155287 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155287 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155290 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155294 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155313 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155320 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155350 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 155369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155382 */     GIR_RootConstrainSelectedInstOperands,
     /* 155383 */     // GIR_Coverage, 6233,
     /* 155383 */     GIR_EraseRootFromParent_Done,
     /* 155384 */   // Label 3042: @155384
     /* 155384 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(155488), // Rule ID 13364 //
     /* 155389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155455 */     // MIs[3] Operand 1
     /* 155455 */     // No operand predicates
     /* 155455 */     // MIs[1] Operand 2
     /* 155455 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155472 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 155475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155486 */     GIR_RootConstrainSelectedInstOperands,
     /* 155487 */     // GIR_Coverage, 13364,
     /* 155487 */     GIR_EraseRootFromParent_Done,
     /* 155488 */   // Label 3043: @155488
     /* 155488 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(155592), // Rule ID 13367 //
     /* 155493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155555 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155559 */     // MIs[3] Operand 1
     /* 155559 */     // No operand predicates
     /* 155559 */     // MIs[1] Operand 2
     /* 155559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155576 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 155579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155590 */     GIR_RootConstrainSelectedInstOperands,
     /* 155591 */     // GIR_Coverage, 13367,
     /* 155591 */     GIR_EraseRootFromParent_Done,
     /* 155592 */   // Label 3044: @155592
     /* 155592 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155723), // Rule ID 2524 //
     /* 155597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155672 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155676 */     // MIs[3] Operand 1
     /* 155676 */     // No operand predicates
     /* 155676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155678 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155690 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155721 */     GIR_RootConstrainSelectedInstOperands,
     /* 155722 */     // GIR_Coverage, 2524,
     /* 155722 */     GIR_EraseRootFromParent_Done,
     /* 155723 */   // Label 3045: @155723
     /* 155723 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155854), // Rule ID 2525 //
     /* 155728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155770 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155803 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155807 */     // MIs[3] Operand 1
     /* 155807 */     // No operand predicates
     /* 155807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155809 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 155827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155852 */     GIR_RootConstrainSelectedInstOperands,
     /* 155853 */     // GIR_Coverage, 2525,
     /* 155853 */     GIR_EraseRootFromParent_Done,
     /* 155854 */   // Label 3046: @155854
     /* 155854 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(155985), // Rule ID 2526 //
     /* 155859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155938 */     // MIs[3] Operand 1
     /* 155938 */     // No operand predicates
     /* 155938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155940 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 155940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 155958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155983 */     GIR_RootConstrainSelectedInstOperands,
     /* 155984 */     // GIR_Coverage, 2526,
     /* 155984 */     GIR_EraseRootFromParent_Done,
     /* 155985 */   // Label 3047: @155985
     /* 155985 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(156116), // Rule ID 13550 //
     /* 155990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156044 */     // MIs[2] Operand 1
     /* 156044 */     // No operand predicates
     /* 156044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156056 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156060 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156065 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156071 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156114 */     GIR_RootConstrainSelectedInstOperands,
     /* 156115 */     // GIR_Coverage, 13550,
     /* 156115 */     GIR_EraseRootFromParent_Done,
     /* 156116 */   // Label 3048: @156116
     /* 156116 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(156247), // Rule ID 13551 //
     /* 156121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156175 */     // MIs[2] Operand 1
     /* 156175 */     // No operand predicates
     /* 156175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156183 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156191 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156196 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156202 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156214 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156245 */     GIR_RootConstrainSelectedInstOperands,
     /* 156246 */     // GIR_Coverage, 13551,
     /* 156246 */     GIR_EraseRootFromParent_Done,
     /* 156247 */   // Label 3049: @156247
     /* 156247 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(156378), // Rule ID 13552 //
     /* 156252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156302 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156306 */     // MIs[2] Operand 1
     /* 156306 */     // No operand predicates
     /* 156306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156318 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156322 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156327 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156333 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156345 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156376 */     GIR_RootConstrainSelectedInstOperands,
     /* 156377 */     // GIR_Coverage, 13552,
     /* 156377 */     GIR_EraseRootFromParent_Done,
     /* 156378 */   // Label 3050: @156378
     /* 156378 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(156492), // Rule ID 2056 //
     /* 156383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156416 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156419 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156470 */     // MIs[3] Operand 1
     /* 156470 */     // No operand predicates
     /* 156470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 156475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156490 */     GIR_RootConstrainSelectedInstOperands,
     /* 156491 */     // GIR_Coverage, 2056,
     /* 156491 */     GIR_EraseRootFromParent_Done,
     /* 156492 */   // Label 3051: @156492
     /* 156492 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(156606), // Rule ID 2063 //
     /* 156497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156530 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156533 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156542 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156584 */     // MIs[3] Operand 1
     /* 156584 */     // No operand predicates
     /* 156584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 156589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156604 */     GIR_RootConstrainSelectedInstOperands,
     /* 156605 */     // GIR_Coverage, 2063,
     /* 156605 */     GIR_EraseRootFromParent_Done,
     /* 156606 */   // Label 3052: @156606
     /* 156606 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156720), // Rule ID 2059 //
     /* 156611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156644 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156647 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156698 */     // MIs[3] Operand 1
     /* 156698 */     // No operand predicates
     /* 156698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156700 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 156703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156718 */     GIR_RootConstrainSelectedInstOperands,
     /* 156719 */     // GIR_Coverage, 2059,
     /* 156719 */     GIR_EraseRootFromParent_Done,
     /* 156720 */   // Label 3053: @156720
     /* 156720 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156834), // Rule ID 2066 //
     /* 156725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156758 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156761 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156770 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156808 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156812 */     // MIs[3] Operand 1
     /* 156812 */     // No operand predicates
     /* 156812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 156817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156832 */     GIR_RootConstrainSelectedInstOperands,
     /* 156833 */     // GIR_Coverage, 2066,
     /* 156833 */     GIR_EraseRootFromParent_Done,
     /* 156834 */   // Label 3054: @156834
     /* 156834 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156948), // Rule ID 2061 //
     /* 156839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156872 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156875 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156926 */     // MIs[3] Operand 1
     /* 156926 */     // No operand predicates
     /* 156926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156928 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 156931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156946 */     GIR_RootConstrainSelectedInstOperands,
     /* 156947 */     // GIR_Coverage, 2061,
     /* 156947 */     GIR_EraseRootFromParent_Done,
     /* 156948 */   // Label 3055: @156948
     /* 156948 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157062), // Rule ID 2068 //
     /* 156953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156986 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156989 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156998 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157040 */     // MIs[3] Operand 1
     /* 157040 */     // No operand predicates
     /* 157040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157042 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 157045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157060 */     GIR_RootConstrainSelectedInstOperands,
     /* 157061 */     // GIR_Coverage, 2068,
     /* 157061 */     GIR_EraseRootFromParent_Done,
     /* 157062 */   // Label 3056: @157062
     /* 157062 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157166), // Rule ID 1987 //
     /* 157067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157137 */     // MIs[3] Operand 1
     /* 157137 */     // No operand predicates
     /* 157137 */     // MIs[1] Operand 2
     /* 157137 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157150 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157164 */     GIR_RootConstrainSelectedInstOperands,
     /* 157165 */     // GIR_Coverage, 1987,
     /* 157165 */     GIR_EraseRootFromParent_Done,
     /* 157166 */   // Label 3057: @157166
     /* 157166 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157270), // Rule ID 2017 //
     /* 157171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157241 */     // MIs[3] Operand 1
     /* 157241 */     // No operand predicates
     /* 157241 */     // MIs[1] Operand 2
     /* 157241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157254 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 157257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157268 */     GIR_RootConstrainSelectedInstOperands,
     /* 157269 */     // GIR_Coverage, 2017,
     /* 157269 */     GIR_EraseRootFromParent_Done,
     /* 157270 */   // Label 3058: @157270
     /* 157270 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157374), // Rule ID 2024 //
     /* 157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157341 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157345 */     // MIs[3] Operand 1
     /* 157345 */     // No operand predicates
     /* 157345 */     // MIs[1] Operand 2
     /* 157345 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157358 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 157361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157372 */     GIR_RootConstrainSelectedInstOperands,
     /* 157373 */     // GIR_Coverage, 2024,
     /* 157373 */     GIR_EraseRootFromParent_Done,
     /* 157374 */   // Label 3059: @157374
     /* 157374 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157478), // Rule ID 2083 //
     /* 157379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157445 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157449 */     // MIs[3] Operand 1
     /* 157449 */     // No operand predicates
     /* 157449 */     // MIs[1] Operand 2
     /* 157449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157462 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 157465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157476 */     GIR_RootConstrainSelectedInstOperands,
     /* 157477 */     // GIR_Coverage, 2083,
     /* 157477 */     GIR_EraseRootFromParent_Done,
     /* 157478 */   // Label 3060: @157478
     /* 157478 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157582), // Rule ID 1990 //
     /* 157483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157549 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157553 */     // MIs[3] Operand 1
     /* 157553 */     // No operand predicates
     /* 157553 */     // MIs[1] Operand 2
     /* 157553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157566 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157580 */     GIR_RootConstrainSelectedInstOperands,
     /* 157581 */     // GIR_Coverage, 1990,
     /* 157581 */     GIR_EraseRootFromParent_Done,
     /* 157582 */   // Label 3061: @157582
     /* 157582 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157686), // Rule ID 2020 //
     /* 157587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157657 */     // MIs[3] Operand 1
     /* 157657 */     // No operand predicates
     /* 157657 */     // MIs[1] Operand 2
     /* 157657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157670 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 157673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157684 */     GIR_RootConstrainSelectedInstOperands,
     /* 157685 */     // GIR_Coverage, 2020,
     /* 157685 */     GIR_EraseRootFromParent_Done,
     /* 157686 */   // Label 3062: @157686
     /* 157686 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157790), // Rule ID 2027 //
     /* 157691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157757 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157761 */     // MIs[3] Operand 1
     /* 157761 */     // No operand predicates
     /* 157761 */     // MIs[1] Operand 2
     /* 157761 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 157777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157788 */     GIR_RootConstrainSelectedInstOperands,
     /* 157789 */     // GIR_Coverage, 2027,
     /* 157789 */     GIR_EraseRootFromParent_Done,
     /* 157790 */   // Label 3063: @157790
     /* 157790 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(157894), // Rule ID 2086 //
     /* 157795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157861 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157865 */     // MIs[3] Operand 1
     /* 157865 */     // No operand predicates
     /* 157865 */     // MIs[1] Operand 2
     /* 157865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157878 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 157881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157892 */     GIR_RootConstrainSelectedInstOperands,
     /* 157893 */     // GIR_Coverage, 2086,
     /* 157893 */     GIR_EraseRootFromParent_Done,
     /* 157894 */   // Label 3064: @157894
     /* 157894 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157951), // Rule ID 1751 //
     /* 157899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157934 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 157934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 157937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157949 */     GIR_RootConstrainSelectedInstOperands,
     /* 157950 */     // GIR_Coverage, 1751,
     /* 157950 */     GIR_EraseRootFromParent_Done,
     /* 157951 */   // Label 3065: @157951
     /* 157951 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(158008), // Rule ID 1753 //
     /* 157956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157991 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 157991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 157994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158006 */     GIR_RootConstrainSelectedInstOperands,
     /* 158007 */     // GIR_Coverage, 1753,
     /* 158007 */     GIR_EraseRootFromParent_Done,
     /* 158008 */   // Label 3066: @158008
     /* 158008 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(158118), // Rule ID 6252 //
     /* 158013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 158018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 158039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158052 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 158063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 158075 */     // MIs[2] Operand 1
     /* 158075 */     // No operand predicates
     /* 158075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158077 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 158077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 158108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 158116 */     GIR_RootConstrainSelectedInstOperands,
     /* 158117 */     // GIR_Coverage, 6252,
     /* 158117 */     GIR_EraseRootFromParent_Done,
     /* 158118 */   // Label 3067: @158118
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158215), // Rule ID 13818 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158175 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158187 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158213 */     GIR_RootConstrainSelectedInstOperands,
     /* 158214 */     // GIR_Coverage, 13818,
     /* 158214 */     GIR_EraseRootFromParent_Done,
     /* 158215 */   // Label 3068: @158215
     /* 158215 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158312), // Rule ID 13819 //
     /* 158220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158262 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158272 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 158272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158284 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 158290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 158303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158310 */     GIR_RootConstrainSelectedInstOperands,
     /* 158311 */     // GIR_Coverage, 13819,
     /* 158311 */     GIR_EraseRootFromParent_Done,
     /* 158312 */   // Label 3069: @158312
     /* 158312 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158409), // Rule ID 13820 //
     /* 158317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158359 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158369 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 158369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158381 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 158387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 158400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158407 */     GIR_RootConstrainSelectedInstOperands,
     /* 158408 */     // GIR_Coverage, 13820,
     /* 158408 */     GIR_EraseRootFromParent_Done,
     /* 158409 */   // Label 3070: @158409
     /* 158409 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158492), // Rule ID 1742 //
     /* 158414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158447 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158450 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158475 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 158478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158490 */     GIR_RootConstrainSelectedInstOperands,
     /* 158491 */     // GIR_Coverage, 1742,
     /* 158491 */     GIR_EraseRootFromParent_Done,
     /* 158492 */   // Label 3071: @158492
     /* 158492 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158575), // Rule ID 1744 //
     /* 158497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158530 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158533 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158542 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158558 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 158561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158573 */     GIR_RootConstrainSelectedInstOperands,
     /* 158574 */     // GIR_Coverage, 1744,
     /* 158574 */     GIR_EraseRootFromParent_Done,
     /* 158575 */   // Label 3072: @158575
     /* 158575 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158658), // Rule ID 1746 //
     /* 158580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158613 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158616 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158625 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 158644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158656 */     GIR_RootConstrainSelectedInstOperands,
     /* 158657 */     // GIR_Coverage, 1746,
     /* 158657 */     GIR_EraseRootFromParent_Done,
     /* 158658 */   // Label 3073: @158658
     /* 158658 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158741), // Rule ID 1748 //
     /* 158663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 158727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158739 */     GIR_RootConstrainSelectedInstOperands,
     /* 158740 */     // GIR_Coverage, 1748,
     /* 158740 */     GIR_EraseRootFromParent_Done,
     /* 158741 */   // Label 3074: @158741
     /* 158741 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158821), // Rule ID 5224 //
     /* 158746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158776 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158779 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158788 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158804 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 158807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158819 */     GIR_RootConstrainSelectedInstOperands,
     /* 158820 */     // GIR_Coverage, 5224,
     /* 158820 */     GIR_EraseRootFromParent_Done,
     /* 158821 */   // Label 3075: @158821
     /* 158821 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158901), // Rule ID 5225 //
     /* 158826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158884 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 158887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158899 */     GIR_RootConstrainSelectedInstOperands,
     /* 158900 */     // GIR_Coverage, 5225,
     /* 158900 */     GIR_EraseRootFromParent_Done,
     /* 158901 */   // Label 3076: @158901
     /* 158901 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158998), // Rule ID 5221 //
     /* 158906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158958 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158970 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158996 */     GIR_RootConstrainSelectedInstOperands,
     /* 158997 */     // GIR_Coverage, 5221,
     /* 158997 */     GIR_EraseRootFromParent_Done,
     /* 158998 */   // Label 3077: @158998
     /* 158998 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159095), // Rule ID 5222 //
     /* 159003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159049 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159055 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159093 */     GIR_RootConstrainSelectedInstOperands,
     /* 159094 */     // GIR_Coverage, 5222,
     /* 159094 */     GIR_EraseRootFromParent_Done,
     /* 159095 */   // Label 3078: @159095
     /* 159095 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159192), // Rule ID 5223 //
     /* 159100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159152 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 159152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 159155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 159170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 159183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159190 */     GIR_RootConstrainSelectedInstOperands,
     /* 159191 */     // GIR_Coverage, 5223,
     /* 159191 */     GIR_EraseRootFromParent_Done,
     /* 159192 */   // Label 3079: @159192
     /* 159192 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159273), // Rule ID 13365 //
     /* 159197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159247 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159251 */     // MIs[2] Operand 1
     /* 159251 */     // No operand predicates
     /* 159251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159257 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159271 */     GIR_RootConstrainSelectedInstOperands,
     /* 159272 */     // GIR_Coverage, 13365,
     /* 159272 */     GIR_EraseRootFromParent_Done,
     /* 159273 */   // Label 3080: @159273
     /* 159273 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159354), // Rule ID 13366 //
     /* 159278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159332 */     // MIs[2] Operand 1
     /* 159332 */     // No operand predicates
     /* 159332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159338 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 159341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159352 */     GIR_RootConstrainSelectedInstOperands,
     /* 159353 */     // GIR_Coverage, 13366,
     /* 159353 */     GIR_EraseRootFromParent_Done,
     /* 159354 */   // Label 3081: @159354
     /* 159354 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159435), // Rule ID 13368 //
     /* 159359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159413 */     // MIs[2] Operand 1
     /* 159413 */     // No operand predicates
     /* 159413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159419 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159433 */     GIR_RootConstrainSelectedInstOperands,
     /* 159434 */     // GIR_Coverage, 13368,
     /* 159434 */     GIR_EraseRootFromParent_Done,
     /* 159435 */   // Label 3082: @159435
     /* 159435 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159516), // Rule ID 13369 //
     /* 159440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159494 */     // MIs[2] Operand 1
     /* 159494 */     // No operand predicates
     /* 159494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159500 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 159503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159514 */     GIR_RootConstrainSelectedInstOperands,
     /* 159515 */     // GIR_Coverage, 13369,
     /* 159515 */     GIR_EraseRootFromParent_Done,
     /* 159516 */   // Label 3083: @159516
     /* 159516 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159597), // Rule ID 13370 //
     /* 159521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 159550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159571 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159575 */     // MIs[2] Operand 1
     /* 159575 */     // No operand predicates
     /* 159575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159581 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 159584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159595 */     GIR_RootConstrainSelectedInstOperands,
     /* 159596 */     // GIR_Coverage, 13370,
     /* 159596 */     GIR_EraseRootFromParent_Done,
     /* 159597 */   // Label 3084: @159597
     /* 159597 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159678), // Rule ID 13371 //
     /* 159602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 159619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159656 */     // MIs[2] Operand 1
     /* 159656 */     // No operand predicates
     /* 159656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159662 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 159665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159676 */     GIR_RootConstrainSelectedInstOperands,
     /* 159677 */     // GIR_Coverage, 13371,
     /* 159677 */     GIR_EraseRootFromParent_Done,
     /* 159678 */   // Label 3085: @159678
     /* 159678 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159759), // Rule ID 13372 //
     /* 159683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159733 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159737 */     // MIs[2] Operand 1
     /* 159737 */     // No operand predicates
     /* 159737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159743 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 159746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159757 */     GIR_RootConstrainSelectedInstOperands,
     /* 159758 */     // GIR_Coverage, 13372,
     /* 159758 */     GIR_EraseRootFromParent_Done,
     /* 159759 */   // Label 3086: @159759
     /* 159759 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159840), // Rule ID 13373 //
     /* 159764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159818 */     // MIs[2] Operand 1
     /* 159818 */     // No operand predicates
     /* 159818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159824 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 159827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159838 */     GIR_RootConstrainSelectedInstOperands,
     /* 159839 */     // GIR_Coverage, 13373,
     /* 159839 */     GIR_EraseRootFromParent_Done,
     /* 159840 */   // Label 3087: @159840
     /* 159840 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159946), // Rule ID 6249 //
     /* 159845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 159871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 159875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159880 */     // MIs[1] Operand 2
     /* 159880 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 159891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 159895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159903 */     // MIs[2] Operand 1
     /* 159903 */     // No operand predicates
     /* 159903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159905 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159917 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 159944 */     GIR_RootConstrainSelectedInstOperands,
     /* 159945 */     // GIR_Coverage, 6249,
     /* 159945 */     GIR_EraseRootFromParent_Done,
     /* 159946 */   // Label 3088: @159946
     /* 159946 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160027), // Rule ID 1988 //
     /* 159951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160009 */     // MIs[2] Operand 1
     /* 160009 */     // No operand predicates
     /* 160009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160011 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 160014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160025 */     GIR_RootConstrainSelectedInstOperands,
     /* 160026 */     // GIR_Coverage, 1988,
     /* 160026 */     GIR_EraseRootFromParent_Done,
     /* 160027 */   // Label 3089: @160027
     /* 160027 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160108), // Rule ID 1989 //
     /* 160032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160086 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160090 */     // MIs[2] Operand 1
     /* 160090 */     // No operand predicates
     /* 160090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160092 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160106 */     GIR_RootConstrainSelectedInstOperands,
     /* 160107 */     // GIR_Coverage, 1989,
     /* 160107 */     GIR_EraseRootFromParent_Done,
     /* 160108 */   // Label 3090: @160108
     /* 160108 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160189), // Rule ID 2018 //
     /* 160113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160171 */     // MIs[2] Operand 1
     /* 160171 */     // No operand predicates
     /* 160171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160173 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 160176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160187 */     GIR_RootConstrainSelectedInstOperands,
     /* 160188 */     // GIR_Coverage, 2018,
     /* 160188 */     GIR_EraseRootFromParent_Done,
     /* 160189 */   // Label 3091: @160189
     /* 160189 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160270), // Rule ID 2019 //
     /* 160194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160252 */     // MIs[2] Operand 1
     /* 160252 */     // No operand predicates
     /* 160252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160254 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 160257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160268 */     GIR_RootConstrainSelectedInstOperands,
     /* 160269 */     // GIR_Coverage, 2019,
     /* 160269 */     GIR_EraseRootFromParent_Done,
     /* 160270 */   // Label 3092: @160270
     /* 160270 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160351), // Rule ID 2025 //
     /* 160275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160333 */     // MIs[2] Operand 1
     /* 160333 */     // No operand predicates
     /* 160333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160335 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 160338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160349 */     GIR_RootConstrainSelectedInstOperands,
     /* 160350 */     // GIR_Coverage, 2025,
     /* 160350 */     GIR_EraseRootFromParent_Done,
     /* 160351 */   // Label 3093: @160351
     /* 160351 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160432), // Rule ID 2026 //
     /* 160356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160414 */     // MIs[2] Operand 1
     /* 160414 */     // No operand predicates
     /* 160414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 160419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160430 */     GIR_RootConstrainSelectedInstOperands,
     /* 160431 */     // GIR_Coverage, 2026,
     /* 160431 */     GIR_EraseRootFromParent_Done,
     /* 160432 */   // Label 3094: @160432
     /* 160432 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160513), // Rule ID 2084 //
     /* 160437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160495 */     // MIs[2] Operand 1
     /* 160495 */     // No operand predicates
     /* 160495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160497 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 160500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160511 */     GIR_RootConstrainSelectedInstOperands,
     /* 160512 */     // GIR_Coverage, 2084,
     /* 160512 */     GIR_EraseRootFromParent_Done,
     /* 160513 */   // Label 3095: @160513
     /* 160513 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160594), // Rule ID 1991 //
     /* 160518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160576 */     // MIs[2] Operand 1
     /* 160576 */     // No operand predicates
     /* 160576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160578 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 160581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160592 */     GIR_RootConstrainSelectedInstOperands,
     /* 160593 */     // GIR_Coverage, 1991,
     /* 160593 */     GIR_EraseRootFromParent_Done,
     /* 160594 */   // Label 3096: @160594
     /* 160594 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160675), // Rule ID 1992 //
     /* 160599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160657 */     // MIs[2] Operand 1
     /* 160657 */     // No operand predicates
     /* 160657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160659 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 160662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160673 */     GIR_RootConstrainSelectedInstOperands,
     /* 160674 */     // GIR_Coverage, 1992,
     /* 160674 */     GIR_EraseRootFromParent_Done,
     /* 160675 */   // Label 3097: @160675
     /* 160675 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160756), // Rule ID 2021 //
     /* 160680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160738 */     // MIs[2] Operand 1
     /* 160738 */     // No operand predicates
     /* 160738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160740 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 160743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160754 */     GIR_RootConstrainSelectedInstOperands,
     /* 160755 */     // GIR_Coverage, 2021,
     /* 160755 */     GIR_EraseRootFromParent_Done,
     /* 160756 */   // Label 3098: @160756
     /* 160756 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160837), // Rule ID 2022 //
     /* 160761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160819 */     // MIs[2] Operand 1
     /* 160819 */     // No operand predicates
     /* 160819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160821 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 160824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160835 */     GIR_RootConstrainSelectedInstOperands,
     /* 160836 */     // GIR_Coverage, 2022,
     /* 160836 */     GIR_EraseRootFromParent_Done,
     /* 160837 */   // Label 3099: @160837
     /* 160837 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160918), // Rule ID 2028 //
     /* 160842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160900 */     // MIs[2] Operand 1
     /* 160900 */     // No operand predicates
     /* 160900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160902 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160916 */     GIR_RootConstrainSelectedInstOperands,
     /* 160917 */     // GIR_Coverage, 2028,
     /* 160917 */     GIR_EraseRootFromParent_Done,
     /* 160918 */   // Label 3100: @160918
     /* 160918 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160999), // Rule ID 2029 //
     /* 160923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160981 */     // MIs[2] Operand 1
     /* 160981 */     // No operand predicates
     /* 160981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160983 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 160986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160997 */     GIR_RootConstrainSelectedInstOperands,
     /* 160998 */     // GIR_Coverage, 2029,
     /* 160998 */     GIR_EraseRootFromParent_Done,
     /* 160999 */   // Label 3101: @160999
     /* 160999 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161080), // Rule ID 2087 //
     /* 161004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161062 */     // MIs[2] Operand 1
     /* 161062 */     // No operand predicates
     /* 161062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161064 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 161067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161078 */     GIR_RootConstrainSelectedInstOperands,
     /* 161079 */     // GIR_Coverage, 2087,
     /* 161079 */     GIR_EraseRootFromParent_Done,
     /* 161080 */   // Label 3102: @161080
     /* 161080 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161161), // Rule ID 1993 //
     /* 161085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161143 */     // MIs[2] Operand 1
     /* 161143 */     // No operand predicates
     /* 161143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161145 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161159 */     GIR_RootConstrainSelectedInstOperands,
     /* 161160 */     // GIR_Coverage, 1993,
     /* 161160 */     GIR_EraseRootFromParent_Done,
     /* 161161 */   // Label 3103: @161161
     /* 161161 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161242), // Rule ID 1994 //
     /* 161166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161224 */     // MIs[2] Operand 1
     /* 161224 */     // No operand predicates
     /* 161224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161226 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 161229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161240 */     GIR_RootConstrainSelectedInstOperands,
     /* 161241 */     // GIR_Coverage, 1994,
     /* 161241 */     GIR_EraseRootFromParent_Done,
     /* 161242 */   // Label 3104: @161242
     /* 161242 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161323), // Rule ID 1995 //
     /* 161247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161305 */     // MIs[2] Operand 1
     /* 161305 */     // No operand predicates
     /* 161305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161307 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 161310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161321 */     GIR_RootConstrainSelectedInstOperands,
     /* 161322 */     // GIR_Coverage, 1995,
     /* 161322 */     GIR_EraseRootFromParent_Done,
     /* 161323 */   // Label 3105: @161323
     /* 161323 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161404), // Rule ID 1996 //
     /* 161328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161386 */     // MIs[2] Operand 1
     /* 161386 */     // No operand predicates
     /* 161386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161388 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 161391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161402 */     GIR_RootConstrainSelectedInstOperands,
     /* 161403 */     // GIR_Coverage, 1996,
     /* 161403 */     GIR_EraseRootFromParent_Done,
     /* 161404 */   // Label 3106: @161404
     /* 161404 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161485), // Rule ID 2023 //
     /* 161409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161467 */     // MIs[2] Operand 1
     /* 161467 */     // No operand predicates
     /* 161467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161469 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 161472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161483 */     GIR_RootConstrainSelectedInstOperands,
     /* 161484 */     // GIR_Coverage, 2023,
     /* 161484 */     GIR_EraseRootFromParent_Done,
     /* 161485 */   // Label 3107: @161485
     /* 161485 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161566), // Rule ID 2030 //
     /* 161490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161548 */     // MIs[2] Operand 1
     /* 161548 */     // No operand predicates
     /* 161548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161550 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 161553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161564 */     GIR_RootConstrainSelectedInstOperands,
     /* 161565 */     // GIR_Coverage, 2030,
     /* 161565 */     GIR_EraseRootFromParent_Done,
     /* 161566 */   // Label 3108: @161566
     /* 161566 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161644), // Rule ID 6236 //
     /* 161571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161626 */     // MIs[2] Operand 1
     /* 161626 */     // No operand predicates
     /* 161626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161628 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 161628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 161631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 161639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161642 */     GIR_RootConstrainSelectedInstOperands,
     /* 161643 */     // GIR_Coverage, 6236,
     /* 161643 */     GIR_EraseRootFromParent_Done,
     /* 161644 */   // Label 3109: @161644
     /* 161644 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161704), // Rule ID 6302 //
     /* 161649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 161675 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 161675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 161678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 161695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161702 */     GIR_RootConstrainSelectedInstOperands,
     /* 161703 */     // GIR_Coverage, 6302,
     /* 161703 */     GIR_EraseRootFromParent_Done,
     /* 161704 */   // Label 3110: @161704
     /* 161704 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161764), // Rule ID 6303 //
     /* 161709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 161735 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 161735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 161755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161762 */     GIR_RootConstrainSelectedInstOperands,
     /* 161763 */     // GIR_Coverage, 6303,
     /* 161763 */     GIR_EraseRootFromParent_Done,
     /* 161764 */   // Label 3111: @161764
     /* 161764 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161824), // Rule ID 6304 //
     /* 161769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 161795 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 161795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 161798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 161815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161822 */     GIR_RootConstrainSelectedInstOperands,
     /* 161823 */     // GIR_Coverage, 6304,
     /* 161823 */     GIR_EraseRootFromParent_Done,
     /* 161824 */   // Label 3112: @161824
     /* 161824 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161871), // Rule ID 3889 //
     /* 161829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161851 */     // MIs[0] Operand 3
     /* 161851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 161862 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161869 */     GIR_RootConstrainSelectedInstOperands,
     /* 161870 */     // GIR_Coverage, 3889,
     /* 161870 */     GIR_EraseRootFromParent_Done,
     /* 161871 */   // Label 3113: @161871
     /* 161871 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161918), // Rule ID 3890 //
     /* 161876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161898 */     // MIs[0] Operand 3
     /* 161898 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 161909 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161916 */     GIR_RootConstrainSelectedInstOperands,
     /* 161917 */     // GIR_Coverage, 3890,
     /* 161917 */     GIR_EraseRootFromParent_Done,
     /* 161918 */   // Label 3114: @161918
     /* 161918 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161965), // Rule ID 3891 //
     /* 161923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161945 */     // MIs[0] Operand 3
     /* 161945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 161956 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161963 */     GIR_RootConstrainSelectedInstOperands,
     /* 161964 */     // GIR_Coverage, 3891,
     /* 161964 */     GIR_EraseRootFromParent_Done,
     /* 161965 */   // Label 3115: @161965
     /* 161965 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(162012), // Rule ID 3892 //
     /* 161970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161992 */     // MIs[0] Operand 3
     /* 161992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 162003 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162010 */     GIR_RootConstrainSelectedInstOperands,
     /* 162011 */     // GIR_Coverage, 3892,
     /* 162011 */     GIR_EraseRootFromParent_Done,
     /* 162012 */   // Label 3116: @162012
     /* 162012 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162058), // Rule ID 3544 //
     /* 162017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 162028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162039 */     // MIs[0] Idx
     /* 162039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 162047 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1618:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 162047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 162050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162056 */     GIR_RootConstrainSelectedInstOperands,
     /* 162057 */     // GIR_Coverage, 3544,
     /* 162057 */     GIR_EraseRootFromParent_Done,
     /* 162058 */   // Label 3117: @162058
     /* 162058 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162104), // Rule ID 3545 //
     /* 162063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 162074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162085 */     // MIs[0] Idx
     /* 162085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 162093 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1618:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 162093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 162096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162102 */     GIR_RootConstrainSelectedInstOperands,
     /* 162103 */     // GIR_Coverage, 3545,
     /* 162103 */     GIR_EraseRootFromParent_Done,
     /* 162104 */   // Label 3118: @162104
     /* 162104 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162150), // Rule ID 3546 //
     /* 162109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 162120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162131 */     // MIs[0] Idx
     /* 162131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 162139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1618:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 162139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 162142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162148 */     GIR_RootConstrainSelectedInstOperands,
     /* 162149 */     // GIR_Coverage, 3546,
     /* 162149 */     GIR_EraseRootFromParent_Done,
     /* 162150 */   // Label 3119: @162150
     /* 162150 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162196), // Rule ID 3547 //
     /* 162155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 162166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 162169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162177 */     // MIs[0] Idx
     /* 162177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 162185 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1618:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 162185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 162188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162194 */     GIR_RootConstrainSelectedInstOperands,
     /* 162195 */     // GIR_Coverage, 3547,
     /* 162195 */     GIR_EraseRootFromParent_Done,
     /* 162196 */   // Label 3120: @162196
     /* 162196 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162252), // Rule ID 2109 //
     /* 162201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 162209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162238 */     // MIs[1] Operand 1
     /* 162238 */     // No operand predicates
     /* 162238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162240 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 162243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162250 */     GIR_RootConstrainSelectedInstOperands,
     /* 162251 */     // GIR_Coverage, 2109,
     /* 162251 */     GIR_EraseRootFromParent_Done,
     /* 162252 */   // Label 3121: @162252
     /* 162252 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162308), // Rule ID 2110 //
     /* 162257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 162265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162294 */     // MIs[1] Operand 1
     /* 162294 */     // No operand predicates
     /* 162294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162296 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 162299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162306 */     GIR_RootConstrainSelectedInstOperands,
     /* 162307 */     // GIR_Coverage, 2110,
     /* 162307 */     GIR_EraseRootFromParent_Done,
     /* 162308 */   // Label 3122: @162308
     /* 162308 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162364), // Rule ID 2115 //
     /* 162313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 162321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162350 */     // MIs[1] Operand 1
     /* 162350 */     // No operand predicates
     /* 162350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162352 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 162355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162362 */     GIR_RootConstrainSelectedInstOperands,
     /* 162363 */     // GIR_Coverage, 2115,
     /* 162363 */     GIR_EraseRootFromParent_Done,
     /* 162364 */   // Label 3123: @162364
     /* 162364 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162420), // Rule ID 2116 //
     /* 162369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 162377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162406 */     // MIs[1] Operand 1
     /* 162406 */     // No operand predicates
     /* 162406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162408 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 162411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162418 */     GIR_RootConstrainSelectedInstOperands,
     /* 162419 */     // GIR_Coverage, 2116,
     /* 162419 */     GIR_EraseRootFromParent_Done,
     /* 162420 */   // Label 3124: @162420
     /* 162420 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162476), // Rule ID 2123 //
     /* 162425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 162433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162462 */     // MIs[1] Operand 1
     /* 162462 */     // No operand predicates
     /* 162462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162464 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 162467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162474 */     GIR_RootConstrainSelectedInstOperands,
     /* 162475 */     // GIR_Coverage, 2123,
     /* 162475 */     GIR_EraseRootFromParent_Done,
     /* 162476 */   // Label 3125: @162476
     /* 162476 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162532), // Rule ID 2126 //
     /* 162481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 162489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162518 */     // MIs[1] Operand 1
     /* 162518 */     // No operand predicates
     /* 162518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162520 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 162523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162530 */     GIR_RootConstrainSelectedInstOperands,
     /* 162531 */     // GIR_Coverage, 2126,
     /* 162531 */     GIR_EraseRootFromParent_Done,
     /* 162532 */   // Label 3126: @162532
     /* 162532 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162588), // Rule ID 2148 //
     /* 162537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 162574 */     // MIs[1] Operand 1
     /* 162574 */     // No operand predicates
     /* 162574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162576 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 162579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162586 */     GIR_RootConstrainSelectedInstOperands,
     /* 162587 */     // GIR_Coverage, 2148,
     /* 162587 */     GIR_EraseRootFromParent_Done,
     /* 162588 */   // Label 3127: @162588
     /* 162588 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162644), // Rule ID 2150 //
     /* 162593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 162630 */     // MIs[1] Operand 1
     /* 162630 */     // No operand predicates
     /* 162630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162632 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 162635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162642 */     GIR_RootConstrainSelectedInstOperands,
     /* 162643 */     // GIR_Coverage, 2150,
     /* 162643 */     GIR_EraseRootFromParent_Done,
     /* 162644 */   // Label 3128: @162644
     /* 162644 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162700), // Rule ID 2152 //
     /* 162649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 162686 */     // MIs[1] Operand 1
     /* 162686 */     // No operand predicates
     /* 162686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162688 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 162691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162698 */     GIR_RootConstrainSelectedInstOperands,
     /* 162699 */     // GIR_Coverage, 2152,
     /* 162699 */     GIR_EraseRootFromParent_Done,
     /* 162700 */   // Label 3129: @162700
     /* 162700 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162753), // Rule ID 6237 //
     /* 162705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162739 */     // MIs[1] Operand 1
     /* 162739 */     // No operand predicates
     /* 162739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162741 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 162744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162751 */     GIR_RootConstrainSelectedInstOperands,
     /* 162752 */     // GIR_Coverage, 6237,
     /* 162752 */     GIR_EraseRootFromParent_Done,
     /* 162753 */   // Label 3130: @162753
     /* 162753 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162806), // Rule ID 6238 //
     /* 162758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162792 */     // MIs[1] Operand 1
     /* 162792 */     // No operand predicates
     /* 162792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162794 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 162797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162804 */     GIR_RootConstrainSelectedInstOperands,
     /* 162805 */     // GIR_Coverage, 6238,
     /* 162805 */     GIR_EraseRootFromParent_Done,
     /* 162806 */   // Label 3131: @162806
     /* 162806 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162859), // Rule ID 6239 //
     /* 162811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162845 */     // MIs[1] Operand 1
     /* 162845 */     // No operand predicates
     /* 162845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162847 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162857 */     GIR_RootConstrainSelectedInstOperands,
     /* 162858 */     // GIR_Coverage, 6239,
     /* 162858 */     GIR_EraseRootFromParent_Done,
     /* 162859 */   // Label 3132: @162859
     /* 162859 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162912), // Rule ID 6240 //
     /* 162864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162898 */     // MIs[1] Operand 1
     /* 162898 */     // No operand predicates
     /* 162898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162900 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162910 */     GIR_RootConstrainSelectedInstOperands,
     /* 162911 */     // GIR_Coverage, 6240,
     /* 162911 */     GIR_EraseRootFromParent_Done,
     /* 162912 */   // Label 3133: @162912
     /* 162912 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162965), // Rule ID 6241 //
     /* 162917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162951 */     // MIs[1] Operand 1
     /* 162951 */     // No operand predicates
     /* 162951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162953 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162963 */     GIR_RootConstrainSelectedInstOperands,
     /* 162964 */     // GIR_Coverage, 6241,
     /* 162964 */     GIR_EraseRootFromParent_Done,
     /* 162965 */   // Label 3134: @162965
     /* 162965 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(163018), // Rule ID 6242 //
     /* 162970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163004 */     // MIs[1] Operand 1
     /* 163004 */     // No operand predicates
     /* 163004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163006 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163016 */     GIR_RootConstrainSelectedInstOperands,
     /* 163017 */     // GIR_Coverage, 6242,
     /* 163017 */     GIR_EraseRootFromParent_Done,
     /* 163018 */   // Label 3135: @163018
     /* 163018 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163071), // Rule ID 6243 //
     /* 163023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163057 */     // MIs[1] Operand 1
     /* 163057 */     // No operand predicates
     /* 163057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163059 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 163062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163069 */     GIR_RootConstrainSelectedInstOperands,
     /* 163070 */     // GIR_Coverage, 6243,
     /* 163070 */     GIR_EraseRootFromParent_Done,
     /* 163071 */   // Label 3136: @163071
     /* 163071 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163124), // Rule ID 6244 //
     /* 163076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163110 */     // MIs[1] Operand 1
     /* 163110 */     // No operand predicates
     /* 163110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163112 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163122 */     GIR_RootConstrainSelectedInstOperands,
     /* 163123 */     // GIR_Coverage, 6244,
     /* 163123 */     GIR_EraseRootFromParent_Done,
     /* 163124 */   // Label 3137: @163124
     /* 163124 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163177), // Rule ID 6245 //
     /* 163129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163163 */     // MIs[1] Operand 1
     /* 163163 */     // No operand predicates
     /* 163163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163165 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163175 */     GIR_RootConstrainSelectedInstOperands,
     /* 163176 */     // GIR_Coverage, 6245,
     /* 163176 */     GIR_EraseRootFromParent_Done,
     /* 163177 */   // Label 3138: @163177
     /* 163177 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163230), // Rule ID 6246 //
     /* 163182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163216 */     // MIs[1] Operand 1
     /* 163216 */     // No operand predicates
     /* 163216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163218 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163228 */     GIR_RootConstrainSelectedInstOperands,
     /* 163229 */     // GIR_Coverage, 6246,
     /* 163229 */     GIR_EraseRootFromParent_Done,
     /* 163230 */   // Label 3139: @163230
     /* 163230 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163283), // Rule ID 6247 //
     /* 163235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163269 */     // MIs[1] Operand 1
     /* 163269 */     // No operand predicates
     /* 163269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163271 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163281 */     GIR_RootConstrainSelectedInstOperands,
     /* 163282 */     // GIR_Coverage, 6247,
     /* 163282 */     GIR_EraseRootFromParent_Done,
     /* 163283 */   // Label 3140: @163283
     /* 163283 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163336), // Rule ID 6248 //
     /* 163288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163322 */     // MIs[1] Operand 1
     /* 163322 */     // No operand predicates
     /* 163322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163324 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 163327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163334 */     GIR_RootConstrainSelectedInstOperands,
     /* 163335 */     // GIR_Coverage, 6248,
     /* 163335 */     GIR_EraseRootFromParent_Done,
     /* 163336 */   // Label 3141: @163336
     /* 163336 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163418), // Rule ID 6250 //
     /* 163341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163375 */     // MIs[1] Operand 1
     /* 163375 */     // No operand predicates
     /* 163375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163377 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163389 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163416 */     GIR_RootConstrainSelectedInstOperands,
     /* 163417 */     // GIR_Coverage, 6250,
     /* 163417 */     GIR_EraseRootFromParent_Done,
     /* 163418 */   // Label 3142: @163418
     /* 163418 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163500), // Rule ID 6251 //
     /* 163423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163457 */     // MIs[1] Operand 1
     /* 163457 */     // No operand predicates
     /* 163457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163459 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163471 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163498 */     GIR_RootConstrainSelectedInstOperands,
     /* 163499 */     // GIR_Coverage, 6251,
     /* 163499 */     GIR_EraseRootFromParent_Done,
     /* 163500 */   // Label 3143: @163500
     /* 163500 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(163582), // Rule ID 6253 //
     /* 163505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163539 */     // MIs[1] Operand 1
     /* 163539 */     // No operand predicates
     /* 163539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163541 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163553 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163580 */     GIR_RootConstrainSelectedInstOperands,
     /* 163581 */     // GIR_Coverage, 6253,
     /* 163581 */     GIR_EraseRootFromParent_Done,
     /* 163582 */   // Label 3144: @163582
     /* 163582 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163664), // Rule ID 6254 //
     /* 163587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163621 */     // MIs[1] Operand 1
     /* 163621 */     // No operand predicates
     /* 163621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163623 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163662 */     GIR_RootConstrainSelectedInstOperands,
     /* 163663 */     // GIR_Coverage, 6254,
     /* 163663 */     GIR_EraseRootFromParent_Done,
     /* 163664 */   // Label 3145: @163664
     /* 163664 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163770), // Rule ID 6255 //
     /* 163669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163703 */     // MIs[1] Operand 1
     /* 163703 */     // No operand predicates
     /* 163703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163705 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163769 */     // GIR_Coverage, 6255,
     /* 163769 */     GIR_EraseRootFromParent_Done,
     /* 163770 */   // Label 3146: @163770
     /* 163770 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163876), // Rule ID 6256 //
     /* 163775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163809 */     // MIs[1] Operand 1
     /* 163809 */     // No operand predicates
     /* 163809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163811 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 163835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163875 */     // GIR_Coverage, 6256,
     /* 163875 */     GIR_EraseRootFromParent_Done,
     /* 163876 */   // Label 3147: @163876
     /* 163876 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163982), // Rule ID 6257 //
     /* 163881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163915 */     // MIs[1] Operand 1
     /* 163915 */     // No operand predicates
     /* 163915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163917 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 163924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163929 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163981 */     // GIR_Coverage, 6257,
     /* 163981 */     GIR_EraseRootFromParent_Done,
     /* 163982 */   // Label 3148: @163982
     /* 163982 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(164088), // Rule ID 6258 //
     /* 163987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164021 */     // MIs[1] Operand 1
     /* 164021 */     // No operand predicates
     /* 164021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164023 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164087 */     // GIR_Coverage, 6258,
     /* 164087 */     GIR_EraseRootFromParent_Done,
     /* 164088 */   // Label 3149: @164088
     /* 164088 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(164146), // Rule ID 6947 //
     /* 164093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 164098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 164127 */     // MIs[1] Operand 1
     /* 164127 */     // No operand predicates
     /* 164127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164129 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 164129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 164132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164136 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 164141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 164144 */     GIR_RootConstrainSelectedInstOperands,
     /* 164145 */     // GIR_Coverage, 6947,
     /* 164145 */     GIR_EraseRootFromParent_Done,
     /* 164146 */   // Label 3150: @164146
     /* 164146 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(164188), // Rule ID 3045 //
     /* 164151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164169 */     // MIs[0] Op2
     /* 164169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 164180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164186 */     GIR_RootConstrainSelectedInstOperands,
     /* 164187 */     // GIR_Coverage, 3045,
     /* 164187 */     GIR_EraseRootFromParent_Done,
     /* 164188 */   // Label 3151: @164188
     /* 164188 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(164230), // Rule ID 3046 //
     /* 164193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164211 */     // MIs[0] Op2
     /* 164211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 164219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 164219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 164222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164228 */     GIR_RootConstrainSelectedInstOperands,
     /* 164229 */     // GIR_Coverage, 3046,
     /* 164229 */     GIR_EraseRootFromParent_Done,
     /* 164230 */   // Label 3152: @164230
     /* 164230 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164272), // Rule ID 3047 //
     /* 164235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164253 */     // MIs[0] Op2
     /* 164253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 164261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 164261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 164264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164270 */     GIR_RootConstrainSelectedInstOperands,
     /* 164271 */     // GIR_Coverage, 3047,
     /* 164271 */     GIR_EraseRootFromParent_Done,
     /* 164272 */   // Label 3153: @164272
     /* 164272 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(164314), // Rule ID 3081 //
     /* 164277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164295 */     // MIs[0] Op2
     /* 164295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164303 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 164306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164312 */     GIR_RootConstrainSelectedInstOperands,
     /* 164313 */     // GIR_Coverage, 3081,
     /* 164313 */     GIR_EraseRootFromParent_Done,
     /* 164314 */   // Label 3154: @164314
     /* 164314 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(164356), // Rule ID 3082 //
     /* 164319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164337 */     // MIs[0] Op2
     /* 164337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 164348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164354 */     GIR_RootConstrainSelectedInstOperands,
     /* 164355 */     // GIR_Coverage, 3082,
     /* 164355 */     GIR_EraseRootFromParent_Done,
     /* 164356 */   // Label 3155: @164356
     /* 164356 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(164398), // Rule ID 3083 //
     /* 164361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164379 */     // MIs[0] Op2
     /* 164379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 164390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164396 */     GIR_RootConstrainSelectedInstOperands,
     /* 164397 */     // GIR_Coverage, 3083,
     /* 164397 */     GIR_EraseRootFromParent_Done,
     /* 164398 */   // Label 3156: @164398
     /* 164398 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(164440), // Rule ID 3530 //
     /* 164403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164421 */     // MIs[0] Op2
     /* 164421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 164429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 164429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 164432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164438 */     GIR_RootConstrainSelectedInstOperands,
     /* 164439 */     // GIR_Coverage, 3530,
     /* 164439 */     GIR_EraseRootFromParent_Done,
     /* 164440 */   // Label 3157: @164440
     /* 164440 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164482), // Rule ID 3531 //
     /* 164445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164463 */     // MIs[0] Op2
     /* 164463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164480 */     GIR_RootConstrainSelectedInstOperands,
     /* 164481 */     // GIR_Coverage, 3531,
     /* 164481 */     GIR_EraseRootFromParent_Done,
     /* 164482 */   // Label 3158: @164482
     /* 164482 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164524), // Rule ID 3532 //
     /* 164487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164505 */     // MIs[0] Op2
     /* 164505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164522 */     GIR_RootConstrainSelectedInstOperands,
     /* 164523 */     // GIR_Coverage, 3532,
     /* 164523 */     GIR_EraseRootFromParent_Done,
     /* 164524 */   // Label 3159: @164524
     /* 164524 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164566), // Rule ID 3533 //
     /* 164529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164547 */     // MIs[0] Op2
     /* 164547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164564 */     GIR_RootConstrainSelectedInstOperands,
     /* 164565 */     // GIR_Coverage, 3533,
     /* 164565 */     GIR_EraseRootFromParent_Done,
     /* 164566 */   // Label 3160: @164566
     /* 164566 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164608), // Rule ID 3534 //
     /* 164571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164589 */     // MIs[0] Op2
     /* 164589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164606 */     GIR_RootConstrainSelectedInstOperands,
     /* 164607 */     // GIR_Coverage, 3534,
     /* 164607 */     GIR_EraseRootFromParent_Done,
     /* 164608 */   // Label 3161: @164608
     /* 164608 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164650), // Rule ID 3535 //
     /* 164613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164631 */     // MIs[0] Op2
     /* 164631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164648 */     GIR_RootConstrainSelectedInstOperands,
     /* 164649 */     // GIR_Coverage, 3535,
     /* 164649 */     GIR_EraseRootFromParent_Done,
     /* 164650 */   // Label 3162: @164650
     /* 164650 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164692), // Rule ID 3536 //
     /* 164655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164673 */     // MIs[0] Op2
     /* 164673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164690 */     GIR_RootConstrainSelectedInstOperands,
     /* 164691 */     // GIR_Coverage, 3536,
     /* 164691 */     GIR_EraseRootFromParent_Done,
     /* 164692 */   // Label 3163: @164692
     /* 164692 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164734), // Rule ID 11676 //
     /* 164697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164715 */     // MIs[0] Op2
     /* 164715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 164726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164732 */     GIR_RootConstrainSelectedInstOperands,
     /* 164733 */     // GIR_Coverage, 11676,
     /* 164733 */     GIR_EraseRootFromParent_Done,
     /* 164734 */   // Label 3164: @164734
     /* 164734 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164776), // Rule ID 11677 //
     /* 164739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164757 */     // MIs[0] Op2
     /* 164757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 164768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164774 */     GIR_RootConstrainSelectedInstOperands,
     /* 164775 */     // GIR_Coverage, 11677,
     /* 164775 */     GIR_EraseRootFromParent_Done,
     /* 164776 */   // Label 3165: @164776
     /* 164776 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164818), // Rule ID 11678 //
     /* 164781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164799 */     // MIs[0] Op2
     /* 164799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 164810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164816 */     GIR_RootConstrainSelectedInstOperands,
     /* 164817 */     // GIR_Coverage, 11678,
     /* 164817 */     GIR_EraseRootFromParent_Done,
     /* 164818 */   // Label 3166: @164818
     /* 164818 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164860), // Rule ID 11679 //
     /* 164823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164841 */     // MIs[0] Op2
     /* 164841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1710:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 164852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164858 */     GIR_RootConstrainSelectedInstOperands,
     /* 164859 */     // GIR_Coverage, 11679,
     /* 164859 */     GIR_EraseRootFromParent_Done,
     /* 164860 */   // Label 3167: @164860
     /* 164860 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164902), // Rule ID 11680 //
     /* 164865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164883 */     // MIs[0] Op2
     /* 164883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 164894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164900 */     GIR_RootConstrainSelectedInstOperands,
     /* 164901 */     // GIR_Coverage, 11680,
     /* 164901 */     GIR_EraseRootFromParent_Done,
     /* 164902 */   // Label 3168: @164902
     /* 164902 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164944), // Rule ID 11681 //
     /* 164907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164925 */     // MIs[0] Op2
     /* 164925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 164936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164942 */     GIR_RootConstrainSelectedInstOperands,
     /* 164943 */     // GIR_Coverage, 11681,
     /* 164943 */     GIR_EraseRootFromParent_Done,
     /* 164944 */   // Label 3169: @164944
     /* 164944 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164986), // Rule ID 11683 //
     /* 164949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164967 */     // MIs[0] Op2
     /* 164967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1668:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 164978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164984 */     GIR_RootConstrainSelectedInstOperands,
     /* 164985 */     // GIR_Coverage, 11683,
     /* 164985 */     GIR_EraseRootFromParent_Done,
     /* 164986 */   // Label 3170: @164986
     /* 164986 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(165028), // Rule ID 11685 //
     /* 164991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165009 */     // MIs[0] Op2
     /* 165009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 165020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165026 */     GIR_RootConstrainSelectedInstOperands,
     /* 165027 */     // GIR_Coverage, 11685,
     /* 165027 */     GIR_EraseRootFromParent_Done,
     /* 165028 */   // Label 3171: @165028
     /* 165028 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165070), // Rule ID 11687 //
     /* 165033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165051 */     // MIs[0] Op2
     /* 165051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 165062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165068 */     GIR_RootConstrainSelectedInstOperands,
     /* 165069 */     // GIR_Coverage, 11687,
     /* 165069 */     GIR_EraseRootFromParent_Done,
     /* 165070 */   // Label 3172: @165070
     /* 165070 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165112), // Rule ID 11688 //
     /* 165075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165093 */     // MIs[0] Op2
     /* 165093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 165104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165110 */     GIR_RootConstrainSelectedInstOperands,
     /* 165111 */     // GIR_Coverage, 11688,
     /* 165111 */     GIR_EraseRootFromParent_Done,
     /* 165112 */   // Label 3173: @165112
     /* 165112 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165154), // Rule ID 11689 //
     /* 165117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165135 */     // MIs[0] Op2
     /* 165135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 165146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165152 */     GIR_RootConstrainSelectedInstOperands,
     /* 165153 */     // GIR_Coverage, 11689,
     /* 165153 */     GIR_EraseRootFromParent_Done,
     /* 165154 */   // Label 3174: @165154
     /* 165154 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165196), // Rule ID 11690 //
     /* 165159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165177 */     // MIs[0] Op2
     /* 165177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 165188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165194 */     GIR_RootConstrainSelectedInstOperands,
     /* 165195 */     // GIR_Coverage, 11690,
     /* 165195 */     GIR_EraseRootFromParent_Done,
     /* 165196 */   // Label 3175: @165196
     /* 165196 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165238), // Rule ID 11691 //
     /* 165201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165219 */     // MIs[0] Op2
     /* 165219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 165230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165236 */     GIR_RootConstrainSelectedInstOperands,
     /* 165237 */     // GIR_Coverage, 11691,
     /* 165237 */     GIR_EraseRootFromParent_Done,
     /* 165238 */   // Label 3176: @165238
     /* 165238 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165280), // Rule ID 11692 //
     /* 165243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165261 */     // MIs[0] Op2
     /* 165261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 165272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165278 */     GIR_RootConstrainSelectedInstOperands,
     /* 165279 */     // GIR_Coverage, 11692,
     /* 165279 */     GIR_EraseRootFromParent_Done,
     /* 165280 */   // Label 3177: @165280
     /* 165280 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165322), // Rule ID 11693 //
     /* 165285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165303 */     // MIs[0] Op2
     /* 165303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 165314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165320 */     GIR_RootConstrainSelectedInstOperands,
     /* 165321 */     // GIR_Coverage, 11693,
     /* 165321 */     GIR_EraseRootFromParent_Done,
     /* 165322 */   // Label 3178: @165322
     /* 165322 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165364), // Rule ID 11694 //
     /* 165327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165345 */     // MIs[0] Op2
     /* 165345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 165356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165362 */     GIR_RootConstrainSelectedInstOperands,
     /* 165363 */     // GIR_Coverage, 11694,
     /* 165363 */     GIR_EraseRootFromParent_Done,
     /* 165364 */   // Label 3179: @165364
     /* 165364 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165406), // Rule ID 11695 //
     /* 165369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165387 */     // MIs[0] Op2
     /* 165387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 165398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165404 */     GIR_RootConstrainSelectedInstOperands,
     /* 165405 */     // GIR_Coverage, 11695,
     /* 165405 */     GIR_EraseRootFromParent_Done,
     /* 165406 */   // Label 3180: @165406
     /* 165406 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165448), // Rule ID 11696 //
     /* 165411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165429 */     // MIs[0] Op2
     /* 165429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 165440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165446 */     GIR_RootConstrainSelectedInstOperands,
     /* 165447 */     // GIR_Coverage, 11696,
     /* 165447 */     GIR_EraseRootFromParent_Done,
     /* 165448 */   // Label 3181: @165448
     /* 165448 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165490), // Rule ID 11697 //
     /* 165453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165471 */     // MIs[0] Op2
     /* 165471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2027:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 165482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165488 */     GIR_RootConstrainSelectedInstOperands,
     /* 165489 */     // GIR_Coverage, 11697,
     /* 165489 */     GIR_EraseRootFromParent_Done,
     /* 165490 */   // Label 3182: @165490
     /* 165490 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165532), // Rule ID 11698 //
     /* 165495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165513 */     // MIs[0] Op2
     /* 165513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2027:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 165524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165530 */     GIR_RootConstrainSelectedInstOperands,
     /* 165531 */     // GIR_Coverage, 11698,
     /* 165531 */     GIR_EraseRootFromParent_Done,
     /* 165532 */   // Label 3183: @165532
     /* 165532 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165574), // Rule ID 11699 //
     /* 165537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165555 */     // MIs[0] Op2
     /* 165555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 165566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165572 */     GIR_RootConstrainSelectedInstOperands,
     /* 165573 */     // GIR_Coverage, 11699,
     /* 165573 */     GIR_EraseRootFromParent_Done,
     /* 165574 */   // Label 3184: @165574
     /* 165574 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165616), // Rule ID 11757 //
     /* 165579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165597 */     // MIs[0] Op2
     /* 165597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 165608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165614 */     GIR_RootConstrainSelectedInstOperands,
     /* 165615 */     // GIR_Coverage, 11757,
     /* 165615 */     GIR_EraseRootFromParent_Done,
     /* 165616 */   // Label 3185: @165616
     /* 165616 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165658), // Rule ID 11758 //
     /* 165621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165639 */     // MIs[0] Op2
     /* 165639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 165650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165656 */     GIR_RootConstrainSelectedInstOperands,
     /* 165657 */     // GIR_Coverage, 11758,
     /* 165657 */     GIR_EraseRootFromParent_Done,
     /* 165658 */   // Label 3186: @165658
     /* 165658 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165700), // Rule ID 11759 //
     /* 165663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165681 */     // MIs[0] Op2
     /* 165681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 165692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165698 */     GIR_RootConstrainSelectedInstOperands,
     /* 165699 */     // GIR_Coverage, 11759,
     /* 165699 */     GIR_EraseRootFromParent_Done,
     /* 165700 */   // Label 3187: @165700
     /* 165700 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165742), // Rule ID 11760 //
     /* 165705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165723 */     // MIs[0] Op2
     /* 165723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 165734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165740 */     GIR_RootConstrainSelectedInstOperands,
     /* 165741 */     // GIR_Coverage, 11760,
     /* 165741 */     GIR_EraseRootFromParent_Done,
     /* 165742 */   // Label 3188: @165742
     /* 165742 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165784), // Rule ID 11761 //
     /* 165747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165765 */     // MIs[0] Op2
     /* 165765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 165776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165782 */     GIR_RootConstrainSelectedInstOperands,
     /* 165783 */     // GIR_Coverage, 11761,
     /* 165783 */     GIR_EraseRootFromParent_Done,
     /* 165784 */   // Label 3189: @165784
     /* 165784 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165826), // Rule ID 11762 //
     /* 165789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165807 */     // MIs[0] Op2
     /* 165807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 165818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165824 */     GIR_RootConstrainSelectedInstOperands,
     /* 165825 */     // GIR_Coverage, 11762,
     /* 165825 */     GIR_EraseRootFromParent_Done,
     /* 165826 */   // Label 3190: @165826
     /* 165826 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165868), // Rule ID 11763 //
     /* 165831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165849 */     // MIs[0] Op2
     /* 165849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 165860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165866 */     GIR_RootConstrainSelectedInstOperands,
     /* 165867 */     // GIR_Coverage, 11763,
     /* 165867 */     GIR_EraseRootFromParent_Done,
     /* 165868 */   // Label 3191: @165868
     /* 165868 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165910), // Rule ID 11764 //
     /* 165873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165891 */     // MIs[0] Op2
     /* 165891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 165902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165908 */     GIR_RootConstrainSelectedInstOperands,
     /* 165909 */     // GIR_Coverage, 11764,
     /* 165909 */     GIR_EraseRootFromParent_Done,
     /* 165910 */   // Label 3192: @165910
     /* 165910 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165952), // Rule ID 11765 //
     /* 165915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165933 */     // MIs[0] Op2
     /* 165933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 165944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165950 */     GIR_RootConstrainSelectedInstOperands,
     /* 165951 */     // GIR_Coverage, 11765,
     /* 165951 */     GIR_EraseRootFromParent_Done,
     /* 165952 */   // Label 3193: @165952
     /* 165952 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166004), // Rule ID 2132 //
     /* 165957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165990 */     // MIs[1] Operand 1
     /* 165990 */     // No operand predicates
     /* 165990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165992 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 165995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166002 */     GIR_RootConstrainSelectedInstOperands,
     /* 166003 */     // GIR_Coverage, 2132,
     /* 166003 */     GIR_EraseRootFromParent_Done,
     /* 166004 */   // Label 3194: @166004
     /* 166004 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166056), // Rule ID 2133 //
     /* 166009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166042 */     // MIs[1] Operand 1
     /* 166042 */     // No operand predicates
     /* 166042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 166047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166054 */     GIR_RootConstrainSelectedInstOperands,
     /* 166055 */     // GIR_Coverage, 2133,
     /* 166055 */     GIR_EraseRootFromParent_Done,
     /* 166056 */   // Label 3195: @166056
     /* 166056 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166108), // Rule ID 2134 //
     /* 166061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166094 */     // MIs[1] Operand 1
     /* 166094 */     // No operand predicates
     /* 166094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166096 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 166099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166106 */     GIR_RootConstrainSelectedInstOperands,
     /* 166107 */     // GIR_Coverage, 2134,
     /* 166107 */     GIR_EraseRootFromParent_Done,
     /* 166108 */   // Label 3196: @166108
     /* 166108 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166160), // Rule ID 2135 //
     /* 166113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166146 */     // MIs[1] Operand 1
     /* 166146 */     // No operand predicates
     /* 166146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166148 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 166151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166158 */     GIR_RootConstrainSelectedInstOperands,
     /* 166159 */     // GIR_Coverage, 2135,
     /* 166159 */     GIR_EraseRootFromParent_Done,
     /* 166160 */   // Label 3197: @166160
     /* 166160 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166212), // Rule ID 2136 //
     /* 166165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166198 */     // MIs[1] Operand 1
     /* 166198 */     // No operand predicates
     /* 166198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 166203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166210 */     GIR_RootConstrainSelectedInstOperands,
     /* 166211 */     // GIR_Coverage, 2136,
     /* 166211 */     GIR_EraseRootFromParent_Done,
     /* 166212 */   // Label 3198: @166212
     /* 166212 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166264), // Rule ID 2137 //
     /* 166217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166250 */     // MIs[1] Operand 1
     /* 166250 */     // No operand predicates
     /* 166250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166252 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 166255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166262 */     GIR_RootConstrainSelectedInstOperands,
     /* 166263 */     // GIR_Coverage, 2137,
     /* 166263 */     GIR_EraseRootFromParent_Done,
     /* 166264 */   // Label 3199: @166264
     /* 166264 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166316), // Rule ID 2138 //
     /* 166269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166302 */     // MIs[1] Operand 1
     /* 166302 */     // No operand predicates
     /* 166302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166304 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 166307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166314 */     GIR_RootConstrainSelectedInstOperands,
     /* 166315 */     // GIR_Coverage, 2138,
     /* 166315 */     GIR_EraseRootFromParent_Done,
     /* 166316 */   // Label 3200: @166316
     /* 166316 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166368), // Rule ID 2139 //
     /* 166321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166354 */     // MIs[1] Operand 1
     /* 166354 */     // No operand predicates
     /* 166354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166356 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 166359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166366 */     GIR_RootConstrainSelectedInstOperands,
     /* 166367 */     // GIR_Coverage, 2139,
     /* 166367 */     GIR_EraseRootFromParent_Done,
     /* 166368 */   // Label 3201: @166368
     /* 166368 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166420), // Rule ID 2140 //
     /* 166373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166406 */     // MIs[1] Operand 1
     /* 166406 */     // No operand predicates
     /* 166406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 166411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166418 */     GIR_RootConstrainSelectedInstOperands,
     /* 166419 */     // GIR_Coverage, 2140,
     /* 166419 */     GIR_EraseRootFromParent_Done,
     /* 166420 */   // Label 3202: @166420
     /* 166420 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166472), // Rule ID 2141 //
     /* 166425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166458 */     // MIs[1] Operand 1
     /* 166458 */     // No operand predicates
     /* 166458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166460 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 166463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166470 */     GIR_RootConstrainSelectedInstOperands,
     /* 166471 */     // GIR_Coverage, 2141,
     /* 166471 */     GIR_EraseRootFromParent_Done,
     /* 166472 */   // Label 3203: @166472
     /* 166472 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166524), // Rule ID 2142 //
     /* 166477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166510 */     // MIs[1] Operand 1
     /* 166510 */     // No operand predicates
     /* 166510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166512 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 166515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166522 */     GIR_RootConstrainSelectedInstOperands,
     /* 166523 */     // GIR_Coverage, 2142,
     /* 166523 */     GIR_EraseRootFromParent_Done,
     /* 166524 */   // Label 3204: @166524
     /* 166524 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166576), // Rule ID 2143 //
     /* 166529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166562 */     // MIs[1] Operand 1
     /* 166562 */     // No operand predicates
     /* 166562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166564 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 166567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166574 */     GIR_RootConstrainSelectedInstOperands,
     /* 166575 */     // GIR_Coverage, 2143,
     /* 166575 */     GIR_EraseRootFromParent_Done,
     /* 166576 */   // Label 3205: @166576
     /* 166576 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166628), // Rule ID 2144 //
     /* 166581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166614 */     // MIs[1] Operand 1
     /* 166614 */     // No operand predicates
     /* 166614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166616 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 166619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166626 */     GIR_RootConstrainSelectedInstOperands,
     /* 166627 */     // GIR_Coverage, 2144,
     /* 166627 */     GIR_EraseRootFromParent_Done,
     /* 166628 */   // Label 3206: @166628
     /* 166628 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166680), // Rule ID 2145 //
     /* 166633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166666 */     // MIs[1] Operand 1
     /* 166666 */     // No operand predicates
     /* 166666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166668 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 166671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166678 */     GIR_RootConstrainSelectedInstOperands,
     /* 166679 */     // GIR_Coverage, 2145,
     /* 166679 */     GIR_EraseRootFromParent_Done,
     /* 166680 */   // Label 3207: @166680
     /* 166680 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166732), // Rule ID 2146 //
     /* 166685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166718 */     // MIs[1] Operand 1
     /* 166718 */     // No operand predicates
     /* 166718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166720 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 166723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166730 */     GIR_RootConstrainSelectedInstOperands,
     /* 166731 */     // GIR_Coverage, 2146,
     /* 166731 */     GIR_EraseRootFromParent_Done,
     /* 166732 */   // Label 3208: @166732
     /* 166732 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166784), // Rule ID 2244 //
     /* 166737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166770 */     // MIs[1] Operand 1
     /* 166770 */     // No operand predicates
     /* 166770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166772 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 166775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166782 */     GIR_RootConstrainSelectedInstOperands,
     /* 166783 */     // GIR_Coverage, 2244,
     /* 166783 */     GIR_EraseRootFromParent_Done,
     /* 166784 */   // Label 3209: @166784
     /* 166784 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166836), // Rule ID 2245 //
     /* 166789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166822 */     // MIs[1] Operand 1
     /* 166822 */     // No operand predicates
     /* 166822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166824 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 166827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166834 */     GIR_RootConstrainSelectedInstOperands,
     /* 166835 */     // GIR_Coverage, 2245,
     /* 166835 */     GIR_EraseRootFromParent_Done,
     /* 166836 */   // Label 3210: @166836
     /* 166836 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(166888), // Rule ID 2246 //
     /* 166841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166874 */     // MIs[1] Operand 1
     /* 166874 */     // No operand predicates
     /* 166874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166876 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 166879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166886 */     GIR_RootConstrainSelectedInstOperands,
     /* 166887 */     // GIR_Coverage, 2246,
     /* 166887 */     GIR_EraseRootFromParent_Done,
     /* 166888 */   // Label 3211: @166888
     /* 166888 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166940), // Rule ID 2247 //
     /* 166893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166926 */     // MIs[1] Operand 1
     /* 166926 */     // No operand predicates
     /* 166926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166928 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 166931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166938 */     GIR_RootConstrainSelectedInstOperands,
     /* 166939 */     // GIR_Coverage, 2247,
     /* 166939 */     GIR_EraseRootFromParent_Done,
     /* 166940 */   // Label 3212: @166940
     /* 166940 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166992), // Rule ID 2248 //
     /* 166945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166978 */     // MIs[1] Operand 1
     /* 166978 */     // No operand predicates
     /* 166978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166980 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 166983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166990 */     GIR_RootConstrainSelectedInstOperands,
     /* 166991 */     // GIR_Coverage, 2248,
     /* 166991 */     GIR_EraseRootFromParent_Done,
     /* 166992 */   // Label 3213: @166992
     /* 166992 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167037), // Rule ID 63 //
     /* 166997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 167000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 167005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 167026 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 167026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 167029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167035 */     GIR_RootConstrainSelectedInstOperands,
     /* 167036 */     // GIR_Coverage, 63,
     /* 167036 */     GIR_EraseRootFromParent_Done,
     /* 167037 */   // Label 3214: @167037
     /* 167037 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167082), // Rule ID 129 //
     /* 167042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 167050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167071 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 167074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167080 */     GIR_RootConstrainSelectedInstOperands,
     /* 167081 */     // GIR_Coverage, 129,
     /* 167081 */     GIR_EraseRootFromParent_Done,
     /* 167082 */   // Label 3215: @167082
     /* 167082 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167127), // Rule ID 130 //
     /* 167087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 167095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167116 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 167119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167125 */     GIR_RootConstrainSelectedInstOperands,
     /* 167126 */     // GIR_Coverage, 130,
     /* 167126 */     GIR_EraseRootFromParent_Done,
     /* 167127 */   // Label 3216: @167127
     /* 167127 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167172), // Rule ID 131 //
     /* 167132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 167140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167161 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 167164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167170 */     GIR_RootConstrainSelectedInstOperands,
     /* 167171 */     // GIR_Coverage, 131,
     /* 167171 */     GIR_EraseRootFromParent_Done,
     /* 167172 */   // Label 3217: @167172
     /* 167172 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167217), // Rule ID 132 //
     /* 167177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 167185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167206 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 167209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167215 */     GIR_RootConstrainSelectedInstOperands,
     /* 167216 */     // GIR_Coverage, 132,
     /* 167216 */     GIR_EraseRootFromParent_Done,
     /* 167217 */   // Label 3218: @167217
     /* 167217 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167262), // Rule ID 133 //
     /* 167222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 167230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167251 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 167254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167260 */     GIR_RootConstrainSelectedInstOperands,
     /* 167261 */     // GIR_Coverage, 133,
     /* 167261 */     GIR_EraseRootFromParent_Done,
     /* 167262 */   // Label 3219: @167262
     /* 167262 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167307), // Rule ID 134 //
     /* 167267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 167275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167296 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 167299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167305 */     GIR_RootConstrainSelectedInstOperands,
     /* 167306 */     // GIR_Coverage, 134,
     /* 167306 */     GIR_EraseRootFromParent_Done,
     /* 167307 */   // Label 3220: @167307
     /* 167307 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167352), // Rule ID 135 //
     /* 167312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 167320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167341 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 167344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167350 */     GIR_RootConstrainSelectedInstOperands,
     /* 167351 */     // GIR_Coverage, 135,
     /* 167351 */     GIR_EraseRootFromParent_Done,
     /* 167352 */   // Label 3221: @167352
     /* 167352 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167397), // Rule ID 136 //
     /* 167357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 167365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167386 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 167389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167395 */     GIR_RootConstrainSelectedInstOperands,
     /* 167396 */     // GIR_Coverage, 136,
     /* 167396 */     GIR_EraseRootFromParent_Done,
     /* 167397 */   // Label 3222: @167397
     /* 167397 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167442), // Rule ID 1042 //
     /* 167402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167431 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 167434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167440 */     GIR_RootConstrainSelectedInstOperands,
     /* 167441 */     // GIR_Coverage, 1042,
     /* 167441 */     GIR_EraseRootFromParent_Done,
     /* 167442 */   // Label 3223: @167442
     /* 167442 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167487), // Rule ID 1043 //
     /* 167447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 167479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167485 */     GIR_RootConstrainSelectedInstOperands,
     /* 167486 */     // GIR_Coverage, 1043,
     /* 167486 */     GIR_EraseRootFromParent_Done,
     /* 167487 */   // Label 3224: @167487
     /* 167487 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167532), // Rule ID 1044 //
     /* 167492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167521 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 167524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167530 */     GIR_RootConstrainSelectedInstOperands,
     /* 167531 */     // GIR_Coverage, 1044,
     /* 167531 */     GIR_EraseRootFromParent_Done,
     /* 167532 */   // Label 3225: @167532
     /* 167532 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167577), // Rule ID 1045 //
     /* 167537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 167569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167575 */     GIR_RootConstrainSelectedInstOperands,
     /* 167576 */     // GIR_Coverage, 1045,
     /* 167576 */     GIR_EraseRootFromParent_Done,
     /* 167577 */   // Label 3226: @167577
     /* 167577 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167622), // Rule ID 1046 //
     /* 167582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 167614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167620 */     GIR_RootConstrainSelectedInstOperands,
     /* 167621 */     // GIR_Coverage, 1046,
     /* 167621 */     GIR_EraseRootFromParent_Done,
     /* 167622 */   // Label 3227: @167622
     /* 167622 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167667), // Rule ID 1047 //
     /* 167627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 167659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167665 */     GIR_RootConstrainSelectedInstOperands,
     /* 167666 */     // GIR_Coverage, 1047,
     /* 167666 */     GIR_EraseRootFromParent_Done,
     /* 167667 */   // Label 3228: @167667
     /* 167667 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167712), // Rule ID 1048 //
     /* 167672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 167701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 167704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167710 */     GIR_RootConstrainSelectedInstOperands,
     /* 167711 */     // GIR_Coverage, 1048,
     /* 167711 */     GIR_EraseRootFromParent_Done,
     /* 167712 */   // Label 3229: @167712
     /* 167712 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167757), // Rule ID 1090 //
     /* 167717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167746 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 167749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167755 */     GIR_RootConstrainSelectedInstOperands,
     /* 167756 */     // GIR_Coverage, 1090,
     /* 167756 */     GIR_EraseRootFromParent_Done,
     /* 167757 */   // Label 3230: @167757
     /* 167757 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167802), // Rule ID 1091 //
     /* 167762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167791 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 167794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167800 */     GIR_RootConstrainSelectedInstOperands,
     /* 167801 */     // GIR_Coverage, 1091,
     /* 167801 */     GIR_EraseRootFromParent_Done,
     /* 167802 */   // Label 3231: @167802
     /* 167802 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167847), // Rule ID 1092 //
     /* 167807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167836 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 167839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167845 */     GIR_RootConstrainSelectedInstOperands,
     /* 167846 */     // GIR_Coverage, 1092,
     /* 167846 */     GIR_EraseRootFromParent_Done,
     /* 167847 */   // Label 3232: @167847
     /* 167847 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167892), // Rule ID 1093 //
     /* 167852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167881 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 167884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167890 */     GIR_RootConstrainSelectedInstOperands,
     /* 167891 */     // GIR_Coverage, 1093,
     /* 167891 */     GIR_EraseRootFromParent_Done,
     /* 167892 */   // Label 3233: @167892
     /* 167892 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167937), // Rule ID 1094 //
     /* 167897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167926 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 167929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167935 */     GIR_RootConstrainSelectedInstOperands,
     /* 167936 */     // GIR_Coverage, 1094,
     /* 167936 */     GIR_EraseRootFromParent_Done,
     /* 167937 */   // Label 3234: @167937
     /* 167937 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(167982), // Rule ID 1095 //
     /* 167942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167971 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 167974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167980 */     GIR_RootConstrainSelectedInstOperands,
     /* 167981 */     // GIR_Coverage, 1095,
     /* 167981 */     GIR_EraseRootFromParent_Done,
     /* 167982 */   // Label 3235: @167982
     /* 167982 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168027), // Rule ID 1096 //
     /* 167987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 168019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168025 */     GIR_RootConstrainSelectedInstOperands,
     /* 168026 */     // GIR_Coverage, 1096,
     /* 168026 */     GIR_EraseRootFromParent_Done,
     /* 168027 */   // Label 3236: @168027
     /* 168027 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168072), // Rule ID 1108 //
     /* 168032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168061 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 168064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168070 */     GIR_RootConstrainSelectedInstOperands,
     /* 168071 */     // GIR_Coverage, 1108,
     /* 168071 */     GIR_EraseRootFromParent_Done,
     /* 168072 */   // Label 3237: @168072
     /* 168072 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168117), // Rule ID 1110 //
     /* 168077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168106 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 168109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168115 */     GIR_RootConstrainSelectedInstOperands,
     /* 168116 */     // GIR_Coverage, 1110,
     /* 168116 */     GIR_EraseRootFromParent_Done,
     /* 168117 */   // Label 3238: @168117
     /* 168117 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168162), // Rule ID 1112 //
     /* 168122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168151 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 168154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168160 */     GIR_RootConstrainSelectedInstOperands,
     /* 168161 */     // GIR_Coverage, 1112,
     /* 168161 */     GIR_EraseRootFromParent_Done,
     /* 168162 */   // Label 3239: @168162
     /* 168162 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168207), // Rule ID 1114 //
     /* 168167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168196 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 168199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168205 */     GIR_RootConstrainSelectedInstOperands,
     /* 168206 */     // GIR_Coverage, 1114,
     /* 168206 */     GIR_EraseRootFromParent_Done,
     /* 168207 */   // Label 3240: @168207
     /* 168207 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168252), // Rule ID 1116 //
     /* 168212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168241 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168250 */     GIR_RootConstrainSelectedInstOperands,
     /* 168251 */     // GIR_Coverage, 1116,
     /* 168251 */     GIR_EraseRootFromParent_Done,
     /* 168252 */   // Label 3241: @168252
     /* 168252 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168297), // Rule ID 1118 //
     /* 168257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168286 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 168289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168295 */     GIR_RootConstrainSelectedInstOperands,
     /* 168296 */     // GIR_Coverage, 1118,
     /* 168296 */     GIR_EraseRootFromParent_Done,
     /* 168297 */   // Label 3242: @168297
     /* 168297 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168342), // Rule ID 1120 //
     /* 168302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168331 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 168334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168340 */     GIR_RootConstrainSelectedInstOperands,
     /* 168341 */     // GIR_Coverage, 1120,
     /* 168341 */     GIR_EraseRootFromParent_Done,
     /* 168342 */   // Label 3243: @168342
     /* 168342 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168387), // Rule ID 1163 //
     /* 168347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168376 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 168379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168385 */     GIR_RootConstrainSelectedInstOperands,
     /* 168386 */     // GIR_Coverage, 1163,
     /* 168386 */     GIR_EraseRootFromParent_Done,
     /* 168387 */   // Label 3244: @168387
     /* 168387 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168432), // Rule ID 1164 //
     /* 168392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168421 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 168424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168430 */     GIR_RootConstrainSelectedInstOperands,
     /* 168431 */     // GIR_Coverage, 1164,
     /* 168431 */     GIR_EraseRootFromParent_Done,
     /* 168432 */   // Label 3245: @168432
     /* 168432 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168477), // Rule ID 1165 //
     /* 168437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168466 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 168469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168475 */     GIR_RootConstrainSelectedInstOperands,
     /* 168476 */     // GIR_Coverage, 1165,
     /* 168476 */     GIR_EraseRootFromParent_Done,
     /* 168477 */   // Label 3246: @168477
     /* 168477 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168522), // Rule ID 1166 //
     /* 168482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168511 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 168514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168520 */     GIR_RootConstrainSelectedInstOperands,
     /* 168521 */     // GIR_Coverage, 1166,
     /* 168521 */     GIR_EraseRootFromParent_Done,
     /* 168522 */   // Label 3247: @168522
     /* 168522 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168567), // Rule ID 1167 //
     /* 168527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168556 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 168559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168565 */     GIR_RootConstrainSelectedInstOperands,
     /* 168566 */     // GIR_Coverage, 1167,
     /* 168566 */     GIR_EraseRootFromParent_Done,
     /* 168567 */   // Label 3248: @168567
     /* 168567 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168612), // Rule ID 1169 //
     /* 168572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168601 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 168604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168610 */     GIR_RootConstrainSelectedInstOperands,
     /* 168611 */     // GIR_Coverage, 1169,
     /* 168611 */     GIR_EraseRootFromParent_Done,
     /* 168612 */   // Label 3249: @168612
     /* 168612 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168657), // Rule ID 1171 //
     /* 168617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168646 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 168649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168655 */     GIR_RootConstrainSelectedInstOperands,
     /* 168656 */     // GIR_Coverage, 1171,
     /* 168656 */     GIR_EraseRootFromParent_Done,
     /* 168657 */   // Label 3250: @168657
     /* 168657 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168702), // Rule ID 1173 //
     /* 168662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168691 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 168694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168700 */     GIR_RootConstrainSelectedInstOperands,
     /* 168701 */     // GIR_Coverage, 1173,
     /* 168701 */     GIR_EraseRootFromParent_Done,
     /* 168702 */   // Label 3251: @168702
     /* 168702 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168747), // Rule ID 1175 //
     /* 168707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 168739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168745 */     GIR_RootConstrainSelectedInstOperands,
     /* 168746 */     // GIR_Coverage, 1175,
     /* 168746 */     GIR_EraseRootFromParent_Done,
     /* 168747 */   // Label 3252: @168747
     /* 168747 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168792), // Rule ID 1177 //
     /* 168752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168781 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 168784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168790 */     GIR_RootConstrainSelectedInstOperands,
     /* 168791 */     // GIR_Coverage, 1177,
     /* 168791 */     GIR_EraseRootFromParent_Done,
     /* 168792 */   // Label 3253: @168792
     /* 168792 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168837), // Rule ID 1179 //
     /* 168797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168826 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 168829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168835 */     GIR_RootConstrainSelectedInstOperands,
     /* 168836 */     // GIR_Coverage, 1179,
     /* 168836 */     GIR_EraseRootFromParent_Done,
     /* 168837 */   // Label 3254: @168837
     /* 168837 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168882), // Rule ID 1181 //
     /* 168842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168871 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 168874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168880 */     GIR_RootConstrainSelectedInstOperands,
     /* 168881 */     // GIR_Coverage, 1181,
     /* 168881 */     GIR_EraseRootFromParent_Done,
     /* 168882 */   // Label 3255: @168882
     /* 168882 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168927), // Rule ID 1183 //
     /* 168887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168916 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 168919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168925 */     GIR_RootConstrainSelectedInstOperands,
     /* 168926 */     // GIR_Coverage, 1183,
     /* 168926 */     GIR_EraseRootFromParent_Done,
     /* 168927 */   // Label 3256: @168927
     /* 168927 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(168972), // Rule ID 1185 //
     /* 168932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 168964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168970 */     GIR_RootConstrainSelectedInstOperands,
     /* 168971 */     // GIR_Coverage, 1185,
     /* 168971 */     GIR_EraseRootFromParent_Done,
     /* 168972 */   // Label 3257: @168972
     /* 168972 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169017), // Rule ID 1187 //
     /* 168977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169006 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 169009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169015 */     GIR_RootConstrainSelectedInstOperands,
     /* 169016 */     // GIR_Coverage, 1187,
     /* 169016 */     GIR_EraseRootFromParent_Done,
     /* 169017 */   // Label 3258: @169017
     /* 169017 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169062), // Rule ID 1189 //
     /* 169022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169051 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 169054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169060 */     GIR_RootConstrainSelectedInstOperands,
     /* 169061 */     // GIR_Coverage, 1189,
     /* 169061 */     GIR_EraseRootFromParent_Done,
     /* 169062 */   // Label 3259: @169062
     /* 169062 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169107), // Rule ID 1191 //
     /* 169067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169096 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 169099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169105 */     GIR_RootConstrainSelectedInstOperands,
     /* 169106 */     // GIR_Coverage, 1191,
     /* 169106 */     GIR_EraseRootFromParent_Done,
     /* 169107 */   // Label 3260: @169107
     /* 169107 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169152), // Rule ID 1193 //
     /* 169112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169141 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 169144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169150 */     GIR_RootConstrainSelectedInstOperands,
     /* 169151 */     // GIR_Coverage, 1193,
     /* 169151 */     GIR_EraseRootFromParent_Done,
     /* 169152 */   // Label 3261: @169152
     /* 169152 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169197), // Rule ID 1195 //
     /* 169157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169186 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169195 */     GIR_RootConstrainSelectedInstOperands,
     /* 169196 */     // GIR_Coverage, 1195,
     /* 169196 */     GIR_EraseRootFromParent_Done,
     /* 169197 */   // Label 3262: @169197
     /* 169197 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169242), // Rule ID 1197 //
     /* 169202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169231 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 169234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169240 */     GIR_RootConstrainSelectedInstOperands,
     /* 169241 */     // GIR_Coverage, 1197,
     /* 169241 */     GIR_EraseRootFromParent_Done,
     /* 169242 */   // Label 3263: @169242
     /* 169242 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169287), // Rule ID 1233 //
     /* 169247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169276 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 169279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169285 */     GIR_RootConstrainSelectedInstOperands,
     /* 169286 */     // GIR_Coverage, 1233,
     /* 169286 */     GIR_EraseRootFromParent_Done,
     /* 169287 */   // Label 3264: @169287
     /* 169287 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169332), // Rule ID 1234 //
     /* 169292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169321 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 169324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169330 */     GIR_RootConstrainSelectedInstOperands,
     /* 169331 */     // GIR_Coverage, 1234,
     /* 169331 */     GIR_EraseRootFromParent_Done,
     /* 169332 */   // Label 3265: @169332
     /* 169332 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169377), // Rule ID 1235 //
     /* 169337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169366 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 169369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169375 */     GIR_RootConstrainSelectedInstOperands,
     /* 169376 */     // GIR_Coverage, 1235,
     /* 169376 */     GIR_EraseRootFromParent_Done,
     /* 169377 */   // Label 3266: @169377
     /* 169377 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169422), // Rule ID 1236 //
     /* 169382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169411 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 169414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169420 */     GIR_RootConstrainSelectedInstOperands,
     /* 169421 */     // GIR_Coverage, 1236,
     /* 169421 */     GIR_EraseRootFromParent_Done,
     /* 169422 */   // Label 3267: @169422
     /* 169422 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169467), // Rule ID 1237 //
     /* 169427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169456 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 169459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169465 */     GIR_RootConstrainSelectedInstOperands,
     /* 169466 */     // GIR_Coverage, 1237,
     /* 169466 */     GIR_EraseRootFromParent_Done,
     /* 169467 */   // Label 3268: @169467
     /* 169467 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169512), // Rule ID 1248 //
     /* 169472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169501 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 169504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169510 */     GIR_RootConstrainSelectedInstOperands,
     /* 169511 */     // GIR_Coverage, 1248,
     /* 169511 */     GIR_EraseRootFromParent_Done,
     /* 169512 */   // Label 3269: @169512
     /* 169512 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169557), // Rule ID 1249 //
     /* 169517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169546 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 169549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169555 */     GIR_RootConstrainSelectedInstOperands,
     /* 169556 */     // GIR_Coverage, 1249,
     /* 169556 */     GIR_EraseRootFromParent_Done,
     /* 169557 */   // Label 3270: @169557
     /* 169557 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169602), // Rule ID 1250 //
     /* 169562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169591 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 169594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169600 */     GIR_RootConstrainSelectedInstOperands,
     /* 169601 */     // GIR_Coverage, 1250,
     /* 169601 */     GIR_EraseRootFromParent_Done,
     /* 169602 */   // Label 3271: @169602
     /* 169602 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169647), // Rule ID 1251 //
     /* 169607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169636 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 169639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169645 */     GIR_RootConstrainSelectedInstOperands,
     /* 169646 */     // GIR_Coverage, 1251,
     /* 169646 */     GIR_EraseRootFromParent_Done,
     /* 169647 */   // Label 3272: @169647
     /* 169647 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169692), // Rule ID 1252 //
     /* 169652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169681 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 169684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169690 */     GIR_RootConstrainSelectedInstOperands,
     /* 169691 */     // GIR_Coverage, 1252,
     /* 169691 */     GIR_EraseRootFromParent_Done,
     /* 169692 */   // Label 3273: @169692
     /* 169692 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169737), // Rule ID 1263 //
     /* 169697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169726 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 169729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169735 */     GIR_RootConstrainSelectedInstOperands,
     /* 169736 */     // GIR_Coverage, 1263,
     /* 169736 */     GIR_EraseRootFromParent_Done,
     /* 169737 */   // Label 3274: @169737
     /* 169737 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169782), // Rule ID 1264 //
     /* 169742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169771 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 169774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169780 */     GIR_RootConstrainSelectedInstOperands,
     /* 169781 */     // GIR_Coverage, 1264,
     /* 169781 */     GIR_EraseRootFromParent_Done,
     /* 169782 */   // Label 3275: @169782
     /* 169782 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169827), // Rule ID 1265 //
     /* 169787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169816 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 169819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169825 */     GIR_RootConstrainSelectedInstOperands,
     /* 169826 */     // GIR_Coverage, 1265,
     /* 169826 */     GIR_EraseRootFromParent_Done,
     /* 169827 */   // Label 3276: @169827
     /* 169827 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(169872), // Rule ID 1266 //
     /* 169832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169861 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 169864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169870 */     GIR_RootConstrainSelectedInstOperands,
     /* 169871 */     // GIR_Coverage, 1266,
     /* 169871 */     GIR_EraseRootFromParent_Done,
     /* 169872 */   // Label 3277: @169872
     /* 169872 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(169917), // Rule ID 1267 //
     /* 169877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169906 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 169909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169915 */     GIR_RootConstrainSelectedInstOperands,
     /* 169916 */     // GIR_Coverage, 1267,
     /* 169916 */     GIR_EraseRootFromParent_Done,
     /* 169917 */   // Label 3278: @169917
     /* 169917 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(169962), // Rule ID 1278 //
     /* 169922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169951 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 169954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169960 */     GIR_RootConstrainSelectedInstOperands,
     /* 169961 */     // GIR_Coverage, 1278,
     /* 169961 */     GIR_EraseRootFromParent_Done,
     /* 169962 */   // Label 3279: @169962
     /* 169962 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170007), // Rule ID 1279 //
     /* 169967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169996 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 169999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170005 */     GIR_RootConstrainSelectedInstOperands,
     /* 170006 */     // GIR_Coverage, 1279,
     /* 170006 */     GIR_EraseRootFromParent_Done,
     /* 170007 */   // Label 3280: @170007
     /* 170007 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170052), // Rule ID 1280 //
     /* 170012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170041 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 170044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170050 */     GIR_RootConstrainSelectedInstOperands,
     /* 170051 */     // GIR_Coverage, 1280,
     /* 170051 */     GIR_EraseRootFromParent_Done,
     /* 170052 */   // Label 3281: @170052
     /* 170052 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170097), // Rule ID 1281 //
     /* 170057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170086 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 170089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170095 */     GIR_RootConstrainSelectedInstOperands,
     /* 170096 */     // GIR_Coverage, 1281,
     /* 170096 */     GIR_EraseRootFromParent_Done,
     /* 170097 */   // Label 3282: @170097
     /* 170097 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170142), // Rule ID 1282 //
     /* 170102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170131 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 170134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170140 */     GIR_RootConstrainSelectedInstOperands,
     /* 170141 */     // GIR_Coverage, 1282,
     /* 170141 */     GIR_EraseRootFromParent_Done,
     /* 170142 */   // Label 3283: @170142
     /* 170142 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170187), // Rule ID 1313 //
     /* 170147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170176 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 170179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170185 */     GIR_RootConstrainSelectedInstOperands,
     /* 170186 */     // GIR_Coverage, 1313,
     /* 170186 */     GIR_EraseRootFromParent_Done,
     /* 170187 */   // Label 3284: @170187
     /* 170187 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170232), // Rule ID 1314 //
     /* 170192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170221 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 170224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170230 */     GIR_RootConstrainSelectedInstOperands,
     /* 170231 */     // GIR_Coverage, 1314,
     /* 170231 */     GIR_EraseRootFromParent_Done,
     /* 170232 */   // Label 3285: @170232
     /* 170232 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170277), // Rule ID 1315 //
     /* 170237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170266 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 170269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170275 */     GIR_RootConstrainSelectedInstOperands,
     /* 170276 */     // GIR_Coverage, 1315,
     /* 170276 */     GIR_EraseRootFromParent_Done,
     /* 170277 */   // Label 3286: @170277
     /* 170277 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170322), // Rule ID 1316 //
     /* 170282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170311 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 170314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170320 */     GIR_RootConstrainSelectedInstOperands,
     /* 170321 */     // GIR_Coverage, 1316,
     /* 170321 */     GIR_EraseRootFromParent_Done,
     /* 170322 */   // Label 3287: @170322
     /* 170322 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170367), // Rule ID 1317 //
     /* 170327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170356 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 170359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170365 */     GIR_RootConstrainSelectedInstOperands,
     /* 170366 */     // GIR_Coverage, 1317,
     /* 170366 */     GIR_EraseRootFromParent_Done,
     /* 170367 */   // Label 3288: @170367
     /* 170367 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170412), // Rule ID 1328 //
     /* 170372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170401 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 170404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170410 */     GIR_RootConstrainSelectedInstOperands,
     /* 170411 */     // GIR_Coverage, 1328,
     /* 170411 */     GIR_EraseRootFromParent_Done,
     /* 170412 */   // Label 3289: @170412
     /* 170412 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170457), // Rule ID 1329 //
     /* 170417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170446 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 170449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170455 */     GIR_RootConstrainSelectedInstOperands,
     /* 170456 */     // GIR_Coverage, 1329,
     /* 170456 */     GIR_EraseRootFromParent_Done,
     /* 170457 */   // Label 3290: @170457
     /* 170457 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170502), // Rule ID 1330 //
     /* 170462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170491 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 170494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170500 */     GIR_RootConstrainSelectedInstOperands,
     /* 170501 */     // GIR_Coverage, 1330,
     /* 170501 */     GIR_EraseRootFromParent_Done,
     /* 170502 */   // Label 3291: @170502
     /* 170502 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170547), // Rule ID 1331 //
     /* 170507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170536 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 170539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170545 */     GIR_RootConstrainSelectedInstOperands,
     /* 170546 */     // GIR_Coverage, 1331,
     /* 170546 */     GIR_EraseRootFromParent_Done,
     /* 170547 */   // Label 3292: @170547
     /* 170547 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170592), // Rule ID 1332 //
     /* 170552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170581 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 170584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170590 */     GIR_RootConstrainSelectedInstOperands,
     /* 170591 */     // GIR_Coverage, 1332,
     /* 170591 */     GIR_EraseRootFromParent_Done,
     /* 170592 */   // Label 3293: @170592
     /* 170592 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170637), // Rule ID 1333 //
     /* 170597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170626 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 170629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170635 */     GIR_RootConstrainSelectedInstOperands,
     /* 170636 */     // GIR_Coverage, 1333,
     /* 170636 */     GIR_EraseRootFromParent_Done,
     /* 170637 */   // Label 3294: @170637
     /* 170637 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170682), // Rule ID 1334 //
     /* 170642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170671 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 170674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170680 */     GIR_RootConstrainSelectedInstOperands,
     /* 170681 */     // GIR_Coverage, 1334,
     /* 170681 */     GIR_EraseRootFromParent_Done,
     /* 170682 */   // Label 3295: @170682
     /* 170682 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170727), // Rule ID 1335 //
     /* 170687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 170719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170725 */     GIR_RootConstrainSelectedInstOperands,
     /* 170726 */     // GIR_Coverage, 1335,
     /* 170726 */     GIR_EraseRootFromParent_Done,
     /* 170727 */   // Label 3296: @170727
     /* 170727 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170772), // Rule ID 1336 //
     /* 170732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170761 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 170764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170770 */     GIR_RootConstrainSelectedInstOperands,
     /* 170771 */     // GIR_Coverage, 1336,
     /* 170771 */     GIR_EraseRootFromParent_Done,
     /* 170772 */   // Label 3297: @170772
     /* 170772 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170817), // Rule ID 1337 //
     /* 170777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170806 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 170809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170815 */     GIR_RootConstrainSelectedInstOperands,
     /* 170816 */     // GIR_Coverage, 1337,
     /* 170816 */     GIR_EraseRootFromParent_Done,
     /* 170817 */   // Label 3298: @170817
     /* 170817 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(170862), // Rule ID 1354 //
     /* 170822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170851 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 170854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170860 */     GIR_RootConstrainSelectedInstOperands,
     /* 170861 */     // GIR_Coverage, 1354,
     /* 170861 */     GIR_EraseRootFromParent_Done,
     /* 170862 */   // Label 3299: @170862
     /* 170862 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(170907), // Rule ID 1355 //
     /* 170867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170896 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 170899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170905 */     GIR_RootConstrainSelectedInstOperands,
     /* 170906 */     // GIR_Coverage, 1355,
     /* 170906 */     GIR_EraseRootFromParent_Done,
     /* 170907 */   // Label 3300: @170907
     /* 170907 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(170952), // Rule ID 1369 //
     /* 170912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170941 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 170944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170950 */     GIR_RootConstrainSelectedInstOperands,
     /* 170951 */     // GIR_Coverage, 1369,
     /* 170951 */     GIR_EraseRootFromParent_Done,
     /* 170952 */   // Label 3301: @170952
     /* 170952 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(170997), // Rule ID 1371 //
     /* 170957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170986 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 170989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170995 */     GIR_RootConstrainSelectedInstOperands,
     /* 170996 */     // GIR_Coverage, 1371,
     /* 170996 */     GIR_EraseRootFromParent_Done,
     /* 170997 */   // Label 3302: @170997
     /* 170997 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171042), // Rule ID 1373 //
     /* 171002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171031 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 171034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171040 */     GIR_RootConstrainSelectedInstOperands,
     /* 171041 */     // GIR_Coverage, 1373,
     /* 171041 */     GIR_EraseRootFromParent_Done,
     /* 171042 */   // Label 3303: @171042
     /* 171042 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171087), // Rule ID 1375 //
     /* 171047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 171079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171085 */     GIR_RootConstrainSelectedInstOperands,
     /* 171086 */     // GIR_Coverage, 1375,
     /* 171086 */     GIR_EraseRootFromParent_Done,
     /* 171087 */   // Label 3304: @171087
     /* 171087 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171132), // Rule ID 1377 //
     /* 171092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171121 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 171124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171130 */     GIR_RootConstrainSelectedInstOperands,
     /* 171131 */     // GIR_Coverage, 1377,
     /* 171131 */     GIR_EraseRootFromParent_Done,
     /* 171132 */   // Label 3305: @171132
     /* 171132 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171177), // Rule ID 1379 //
     /* 171137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171166 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 171169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171175 */     GIR_RootConstrainSelectedInstOperands,
     /* 171176 */     // GIR_Coverage, 1379,
     /* 171176 */     GIR_EraseRootFromParent_Done,
     /* 171177 */   // Label 3306: @171177
     /* 171177 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171222), // Rule ID 1386 //
     /* 171182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171211 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 171214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171220 */     GIR_RootConstrainSelectedInstOperands,
     /* 171221 */     // GIR_Coverage, 1386,
     /* 171221 */     GIR_EraseRootFromParent_Done,
     /* 171222 */   // Label 3307: @171222
     /* 171222 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171267), // Rule ID 1387 //
     /* 171227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 171259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171265 */     GIR_RootConstrainSelectedInstOperands,
     /* 171266 */     // GIR_Coverage, 1387,
     /* 171266 */     GIR_EraseRootFromParent_Done,
     /* 171267 */   // Label 3308: @171267
     /* 171267 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171312), // Rule ID 1388 //
     /* 171272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171301 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 171304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171310 */     GIR_RootConstrainSelectedInstOperands,
     /* 171311 */     // GIR_Coverage, 1388,
     /* 171311 */     GIR_EraseRootFromParent_Done,
     /* 171312 */   // Label 3309: @171312
     /* 171312 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171357), // Rule ID 1389 //
     /* 171317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171346 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 171349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171355 */     GIR_RootConstrainSelectedInstOperands,
     /* 171356 */     // GIR_Coverage, 1389,
     /* 171356 */     GIR_EraseRootFromParent_Done,
     /* 171357 */   // Label 3310: @171357
     /* 171357 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171402), // Rule ID 1390 //
     /* 171362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171391 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 171394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171400 */     GIR_RootConstrainSelectedInstOperands,
     /* 171401 */     // GIR_Coverage, 1390,
     /* 171401 */     GIR_EraseRootFromParent_Done,
     /* 171402 */   // Label 3311: @171402
     /* 171402 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171447), // Rule ID 1391 //
     /* 171407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171436 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 171439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171445 */     GIR_RootConstrainSelectedInstOperands,
     /* 171446 */     // GIR_Coverage, 1391,
     /* 171446 */     GIR_EraseRootFromParent_Done,
     /* 171447 */   // Label 3312: @171447
     /* 171447 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171492), // Rule ID 1392 //
     /* 171452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171481 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 171484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171490 */     GIR_RootConstrainSelectedInstOperands,
     /* 171491 */     // GIR_Coverage, 1392,
     /* 171491 */     GIR_EraseRootFromParent_Done,
     /* 171492 */   // Label 3313: @171492
     /* 171492 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171537), // Rule ID 1393 //
     /* 171497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171526 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 171529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171535 */     GIR_RootConstrainSelectedInstOperands,
     /* 171536 */     // GIR_Coverage, 1393,
     /* 171536 */     GIR_EraseRootFromParent_Done,
     /* 171537 */   // Label 3314: @171537
     /* 171537 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171582), // Rule ID 1394 //
     /* 171542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171571 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 171574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171580 */     GIR_RootConstrainSelectedInstOperands,
     /* 171581 */     // GIR_Coverage, 1394,
     /* 171581 */     GIR_EraseRootFromParent_Done,
     /* 171582 */   // Label 3315: @171582
     /* 171582 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171627), // Rule ID 1395 //
     /* 171587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 171619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171625 */     GIR_RootConstrainSelectedInstOperands,
     /* 171626 */     // GIR_Coverage, 1395,
     /* 171626 */     GIR_EraseRootFromParent_Done,
     /* 171627 */   // Label 3316: @171627
     /* 171627 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171672), // Rule ID 1396 //
     /* 171632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171661 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 171664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171670 */     GIR_RootConstrainSelectedInstOperands,
     /* 171671 */     // GIR_Coverage, 1396,
     /* 171671 */     GIR_EraseRootFromParent_Done,
     /* 171672 */   // Label 3317: @171672
     /* 171672 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171717), // Rule ID 1397 //
     /* 171677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 171709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171715 */     GIR_RootConstrainSelectedInstOperands,
     /* 171716 */     // GIR_Coverage, 1397,
     /* 171716 */     GIR_EraseRootFromParent_Done,
     /* 171717 */   // Label 3318: @171717
     /* 171717 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171762), // Rule ID 1404 //
     /* 171722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171751 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 171754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171760 */     GIR_RootConstrainSelectedInstOperands,
     /* 171761 */     // GIR_Coverage, 1404,
     /* 171761 */     GIR_EraseRootFromParent_Done,
     /* 171762 */   // Label 3319: @171762
     /* 171762 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171807), // Rule ID 1405 //
     /* 171767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 171799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171805 */     GIR_RootConstrainSelectedInstOperands,
     /* 171806 */     // GIR_Coverage, 1405,
     /* 171806 */     GIR_EraseRootFromParent_Done,
     /* 171807 */   // Label 3320: @171807
     /* 171807 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(171852), // Rule ID 1406 //
     /* 171812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171841 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 171844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171850 */     GIR_RootConstrainSelectedInstOperands,
     /* 171851 */     // GIR_Coverage, 1406,
     /* 171851 */     GIR_EraseRootFromParent_Done,
     /* 171852 */   // Label 3321: @171852
     /* 171852 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(171897), // Rule ID 1407 //
     /* 171857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171886 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 171889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171895 */     GIR_RootConstrainSelectedInstOperands,
     /* 171896 */     // GIR_Coverage, 1407,
     /* 171896 */     GIR_EraseRootFromParent_Done,
     /* 171897 */   // Label 3322: @171897
     /* 171897 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(171942), // Rule ID 1408 //
     /* 171902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171931 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 171934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171940 */     GIR_RootConstrainSelectedInstOperands,
     /* 171941 */     // GIR_Coverage, 1408,
     /* 171941 */     GIR_EraseRootFromParent_Done,
     /* 171942 */   // Label 3323: @171942
     /* 171942 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(171987), // Rule ID 1409 //
     /* 171947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171976 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 171979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171985 */     GIR_RootConstrainSelectedInstOperands,
     /* 171986 */     // GIR_Coverage, 1409,
     /* 171986 */     GIR_EraseRootFromParent_Done,
     /* 171987 */   // Label 3324: @171987
     /* 171987 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172032), // Rule ID 1416 //
     /* 171992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172021 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 172024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172030 */     GIR_RootConstrainSelectedInstOperands,
     /* 172031 */     // GIR_Coverage, 1416,
     /* 172031 */     GIR_EraseRootFromParent_Done,
     /* 172032 */   // Label 3325: @172032
     /* 172032 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172077), // Rule ID 1417 //
     /* 172037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172066 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 172069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172075 */     GIR_RootConstrainSelectedInstOperands,
     /* 172076 */     // GIR_Coverage, 1417,
     /* 172076 */     GIR_EraseRootFromParent_Done,
     /* 172077 */   // Label 3326: @172077
     /* 172077 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172122), // Rule ID 1418 //
     /* 172082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172111 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 172114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172120 */     GIR_RootConstrainSelectedInstOperands,
     /* 172121 */     // GIR_Coverage, 1418,
     /* 172121 */     GIR_EraseRootFromParent_Done,
     /* 172122 */   // Label 3327: @172122
     /* 172122 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172167), // Rule ID 1419 //
     /* 172127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 172159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172165 */     GIR_RootConstrainSelectedInstOperands,
     /* 172166 */     // GIR_Coverage, 1419,
     /* 172166 */     GIR_EraseRootFromParent_Done,
     /* 172167 */   // Label 3328: @172167
     /* 172167 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172212), // Rule ID 1420 //
     /* 172172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172201 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 172204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172210 */     GIR_RootConstrainSelectedInstOperands,
     /* 172211 */     // GIR_Coverage, 1420,
     /* 172211 */     GIR_EraseRootFromParent_Done,
     /* 172212 */   // Label 3329: @172212
     /* 172212 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172257), // Rule ID 1421 //
     /* 172217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 172249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172255 */     GIR_RootConstrainSelectedInstOperands,
     /* 172256 */     // GIR_Coverage, 1421,
     /* 172256 */     GIR_EraseRootFromParent_Done,
     /* 172257 */   // Label 3330: @172257
     /* 172257 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172302), // Rule ID 1422 //
     /* 172262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172291 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 172294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172300 */     GIR_RootConstrainSelectedInstOperands,
     /* 172301 */     // GIR_Coverage, 1422,
     /* 172301 */     GIR_EraseRootFromParent_Done,
     /* 172302 */   // Label 3331: @172302
     /* 172302 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172347), // Rule ID 1423 //
     /* 172307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 172339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172345 */     GIR_RootConstrainSelectedInstOperands,
     /* 172346 */     // GIR_Coverage, 1423,
     /* 172346 */     GIR_EraseRootFromParent_Done,
     /* 172347 */   // Label 3332: @172347
     /* 172347 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172392), // Rule ID 1424 //
     /* 172352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172381 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 172384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172390 */     GIR_RootConstrainSelectedInstOperands,
     /* 172391 */     // GIR_Coverage, 1424,
     /* 172391 */     GIR_EraseRootFromParent_Done,
     /* 172392 */   // Label 3333: @172392
     /* 172392 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172437), // Rule ID 1425 //
     /* 172397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172426 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 172429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172435 */     GIR_RootConstrainSelectedInstOperands,
     /* 172436 */     // GIR_Coverage, 1425,
     /* 172436 */     GIR_EraseRootFromParent_Done,
     /* 172437 */   // Label 3334: @172437
     /* 172437 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172482), // Rule ID 1426 //
     /* 172442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 172474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172480 */     GIR_RootConstrainSelectedInstOperands,
     /* 172481 */     // GIR_Coverage, 1426,
     /* 172481 */     GIR_EraseRootFromParent_Done,
     /* 172482 */   // Label 3335: @172482
     /* 172482 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172527), // Rule ID 1427 //
     /* 172487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 172519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172525 */     GIR_RootConstrainSelectedInstOperands,
     /* 172526 */     // GIR_Coverage, 1427,
     /* 172526 */     GIR_EraseRootFromParent_Done,
     /* 172527 */   // Label 3336: @172527
     /* 172527 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172572), // Rule ID 1428 //
     /* 172532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172561 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 172564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172570 */     GIR_RootConstrainSelectedInstOperands,
     /* 172571 */     // GIR_Coverage, 1428,
     /* 172571 */     GIR_EraseRootFromParent_Done,
     /* 172572 */   // Label 3337: @172572
     /* 172572 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172617), // Rule ID 1429 //
     /* 172577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172606 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 172609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172615 */     GIR_RootConstrainSelectedInstOperands,
     /* 172616 */     // GIR_Coverage, 1429,
     /* 172616 */     GIR_EraseRootFromParent_Done,
     /* 172617 */   // Label 3338: @172617
     /* 172617 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172662), // Rule ID 1430 //
     /* 172622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172651 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 172654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172660 */     GIR_RootConstrainSelectedInstOperands,
     /* 172661 */     // GIR_Coverage, 1430,
     /* 172661 */     GIR_EraseRootFromParent_Done,
     /* 172662 */   // Label 3339: @172662
     /* 172662 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172707), // Rule ID 1431 //
     /* 172667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172696 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 172699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172705 */     GIR_RootConstrainSelectedInstOperands,
     /* 172706 */     // GIR_Coverage, 1431,
     /* 172706 */     GIR_EraseRootFromParent_Done,
     /* 172707 */   // Label 3340: @172707
     /* 172707 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172752), // Rule ID 1432 //
     /* 172712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172741 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 172744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172750 */     GIR_RootConstrainSelectedInstOperands,
     /* 172751 */     // GIR_Coverage, 1432,
     /* 172751 */     GIR_EraseRootFromParent_Done,
     /* 172752 */   // Label 3341: @172752
     /* 172752 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172797), // Rule ID 1433 //
     /* 172757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172786 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 172789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172795 */     GIR_RootConstrainSelectedInstOperands,
     /* 172796 */     // GIR_Coverage, 1433,
     /* 172796 */     GIR_EraseRootFromParent_Done,
     /* 172797 */   // Label 3342: @172797
     /* 172797 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172842), // Rule ID 1434 //
     /* 172802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172831 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 172834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172840 */     GIR_RootConstrainSelectedInstOperands,
     /* 172841 */     // GIR_Coverage, 1434,
     /* 172841 */     GIR_EraseRootFromParent_Done,
     /* 172842 */   // Label 3343: @172842
     /* 172842 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(172887), // Rule ID 1435 //
     /* 172847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172876 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 172879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172885 */     GIR_RootConstrainSelectedInstOperands,
     /* 172886 */     // GIR_Coverage, 1435,
     /* 172886 */     GIR_EraseRootFromParent_Done,
     /* 172887 */   // Label 3344: @172887
     /* 172887 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(172932), // Rule ID 1436 //
     /* 172892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172921 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 172924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172930 */     GIR_RootConstrainSelectedInstOperands,
     /* 172931 */     // GIR_Coverage, 1436,
     /* 172931 */     GIR_EraseRootFromParent_Done,
     /* 172932 */   // Label 3345: @172932
     /* 172932 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(172977), // Rule ID 1437 //
     /* 172937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172966 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 172969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172975 */     GIR_RootConstrainSelectedInstOperands,
     /* 172976 */     // GIR_Coverage, 1437,
     /* 172976 */     GIR_EraseRootFromParent_Done,
     /* 172977 */   // Label 3346: @172977
     /* 172977 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173022), // Rule ID 1438 //
     /* 172982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173011 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 173014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173020 */     GIR_RootConstrainSelectedInstOperands,
     /* 173021 */     // GIR_Coverage, 1438,
     /* 173021 */     GIR_EraseRootFromParent_Done,
     /* 173022 */   // Label 3347: @173022
     /* 173022 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173067), // Rule ID 1439 //
     /* 173027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173056 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 173059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173065 */     GIR_RootConstrainSelectedInstOperands,
     /* 173066 */     // GIR_Coverage, 1439,
     /* 173066 */     GIR_EraseRootFromParent_Done,
     /* 173067 */   // Label 3348: @173067
     /* 173067 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173112), // Rule ID 1440 //
     /* 173072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173101 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 173104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173110 */     GIR_RootConstrainSelectedInstOperands,
     /* 173111 */     // GIR_Coverage, 1440,
     /* 173111 */     GIR_EraseRootFromParent_Done,
     /* 173112 */   // Label 3349: @173112
     /* 173112 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173157), // Rule ID 1441 //
     /* 173117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173146 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 173149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173155 */     GIR_RootConstrainSelectedInstOperands,
     /* 173156 */     // GIR_Coverage, 1441,
     /* 173156 */     GIR_EraseRootFromParent_Done,
     /* 173157 */   // Label 3350: @173157
     /* 173157 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173202), // Rule ID 1442 //
     /* 173162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173191 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 173194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173200 */     GIR_RootConstrainSelectedInstOperands,
     /* 173201 */     // GIR_Coverage, 1442,
     /* 173201 */     GIR_EraseRootFromParent_Done,
     /* 173202 */   // Label 3351: @173202
     /* 173202 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173247), // Rule ID 1443 //
     /* 173207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173236 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 173239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173245 */     GIR_RootConstrainSelectedInstOperands,
     /* 173246 */     // GIR_Coverage, 1443,
     /* 173246 */     GIR_EraseRootFromParent_Done,
     /* 173247 */   // Label 3352: @173247
     /* 173247 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173292), // Rule ID 1444 //
     /* 173252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173281 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 173284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173290 */     GIR_RootConstrainSelectedInstOperands,
     /* 173291 */     // GIR_Coverage, 1444,
     /* 173291 */     GIR_EraseRootFromParent_Done,
     /* 173292 */   // Label 3353: @173292
     /* 173292 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173337), // Rule ID 1445 //
     /* 173297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173326 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 173329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173335 */     GIR_RootConstrainSelectedInstOperands,
     /* 173336 */     // GIR_Coverage, 1445,
     /* 173336 */     GIR_EraseRootFromParent_Done,
     /* 173337 */   // Label 3354: @173337
     /* 173337 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173382), // Rule ID 1446 //
     /* 173342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173371 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 173374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173380 */     GIR_RootConstrainSelectedInstOperands,
     /* 173381 */     // GIR_Coverage, 1446,
     /* 173381 */     GIR_EraseRootFromParent_Done,
     /* 173382 */   // Label 3355: @173382
     /* 173382 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173427), // Rule ID 1447 //
     /* 173387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 173419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173425 */     GIR_RootConstrainSelectedInstOperands,
     /* 173426 */     // GIR_Coverage, 1447,
     /* 173426 */     GIR_EraseRootFromParent_Done,
     /* 173427 */   // Label 3356: @173427
     /* 173427 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173472), // Rule ID 1448 //
     /* 173432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 173464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173470 */     GIR_RootConstrainSelectedInstOperands,
     /* 173471 */     // GIR_Coverage, 1448,
     /* 173471 */     GIR_EraseRootFromParent_Done,
     /* 173472 */   // Label 3357: @173472
     /* 173472 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173517), // Rule ID 1449 //
     /* 173477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173506 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 173509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173515 */     GIR_RootConstrainSelectedInstOperands,
     /* 173516 */     // GIR_Coverage, 1449,
     /* 173516 */     GIR_EraseRootFromParent_Done,
     /* 173517 */   // Label 3358: @173517
     /* 173517 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173562), // Rule ID 1450 //
     /* 173522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173551 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 173554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173560 */     GIR_RootConstrainSelectedInstOperands,
     /* 173561 */     // GIR_Coverage, 1450,
     /* 173561 */     GIR_EraseRootFromParent_Done,
     /* 173562 */   // Label 3359: @173562
     /* 173562 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173607), // Rule ID 1451 //
     /* 173567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 173599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173605 */     GIR_RootConstrainSelectedInstOperands,
     /* 173606 */     // GIR_Coverage, 1451,
     /* 173606 */     GIR_EraseRootFromParent_Done,
     /* 173607 */   // Label 3360: @173607
     /* 173607 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173652), // Rule ID 1458 //
     /* 173612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173641 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 173644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173650 */     GIR_RootConstrainSelectedInstOperands,
     /* 173651 */     // GIR_Coverage, 1458,
     /* 173651 */     GIR_EraseRootFromParent_Done,
     /* 173652 */   // Label 3361: @173652
     /* 173652 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173697), // Rule ID 1459 //
     /* 173657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173686 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 173689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173695 */     GIR_RootConstrainSelectedInstOperands,
     /* 173696 */     // GIR_Coverage, 1459,
     /* 173696 */     GIR_EraseRootFromParent_Done,
     /* 173697 */   // Label 3362: @173697
     /* 173697 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173742), // Rule ID 1460 //
     /* 173702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173731 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 173734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173740 */     GIR_RootConstrainSelectedInstOperands,
     /* 173741 */     // GIR_Coverage, 1460,
     /* 173741 */     GIR_EraseRootFromParent_Done,
     /* 173742 */   // Label 3363: @173742
     /* 173742 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173787), // Rule ID 1461 //
     /* 173747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 173779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173785 */     GIR_RootConstrainSelectedInstOperands,
     /* 173786 */     // GIR_Coverage, 1461,
     /* 173786 */     GIR_EraseRootFromParent_Done,
     /* 173787 */   // Label 3364: @173787
     /* 173787 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173832), // Rule ID 1462 //
     /* 173792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173821 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 173824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173830 */     GIR_RootConstrainSelectedInstOperands,
     /* 173831 */     // GIR_Coverage, 1462,
     /* 173831 */     GIR_EraseRootFromParent_Done,
     /* 173832 */   // Label 3365: @173832
     /* 173832 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(173877), // Rule ID 1463 //
     /* 173837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 173869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173875 */     GIR_RootConstrainSelectedInstOperands,
     /* 173876 */     // GIR_Coverage, 1463,
     /* 173876 */     GIR_EraseRootFromParent_Done,
     /* 173877 */   // Label 3366: @173877
     /* 173877 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173922), // Rule ID 1464 //
     /* 173882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173911 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 173914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173920 */     GIR_RootConstrainSelectedInstOperands,
     /* 173921 */     // GIR_Coverage, 1464,
     /* 173921 */     GIR_EraseRootFromParent_Done,
     /* 173922 */   // Label 3367: @173922
     /* 173922 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(173967), // Rule ID 1465 //
     /* 173927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173956 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 173959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173965 */     GIR_RootConstrainSelectedInstOperands,
     /* 173966 */     // GIR_Coverage, 1465,
     /* 173966 */     GIR_EraseRootFromParent_Done,
     /* 173967 */   // Label 3368: @173967
     /* 173967 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174012), // Rule ID 1466 //
     /* 173972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174001 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 174004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174010 */     GIR_RootConstrainSelectedInstOperands,
     /* 174011 */     // GIR_Coverage, 1466,
     /* 174011 */     GIR_EraseRootFromParent_Done,
     /* 174012 */   // Label 3369: @174012
     /* 174012 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174057), // Rule ID 1467 //
     /* 174017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174046 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 174049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174055 */     GIR_RootConstrainSelectedInstOperands,
     /* 174056 */     // GIR_Coverage, 1467,
     /* 174056 */     GIR_EraseRootFromParent_Done,
     /* 174057 */   // Label 3370: @174057
     /* 174057 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174102), // Rule ID 1468 //
     /* 174062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174091 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 174094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174100 */     GIR_RootConstrainSelectedInstOperands,
     /* 174101 */     // GIR_Coverage, 1468,
     /* 174101 */     GIR_EraseRootFromParent_Done,
     /* 174102 */   // Label 3371: @174102
     /* 174102 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174147), // Rule ID 1469 //
     /* 174107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 174139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174145 */     GIR_RootConstrainSelectedInstOperands,
     /* 174146 */     // GIR_Coverage, 1469,
     /* 174146 */     GIR_EraseRootFromParent_Done,
     /* 174147 */   // Label 3372: @174147
     /* 174147 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174192), // Rule ID 1470 //
     /* 174152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 174184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174190 */     GIR_RootConstrainSelectedInstOperands,
     /* 174191 */     // GIR_Coverage, 1470,
     /* 174191 */     GIR_EraseRootFromParent_Done,
     /* 174192 */   // Label 3373: @174192
     /* 174192 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174237), // Rule ID 1471 //
     /* 174197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174226 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 174229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174235 */     GIR_RootConstrainSelectedInstOperands,
     /* 174236 */     // GIR_Coverage, 1471,
     /* 174236 */     GIR_EraseRootFromParent_Done,
     /* 174237 */   // Label 3374: @174237
     /* 174237 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174282), // Rule ID 1492 //
     /* 174242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174271 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 174274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174280 */     GIR_RootConstrainSelectedInstOperands,
     /* 174281 */     // GIR_Coverage, 1492,
     /* 174281 */     GIR_EraseRootFromParent_Done,
     /* 174282 */   // Label 3375: @174282
     /* 174282 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174327), // Rule ID 1494 //
     /* 174287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 174319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174325 */     GIR_RootConstrainSelectedInstOperands,
     /* 174326 */     // GIR_Coverage, 1494,
     /* 174326 */     GIR_EraseRootFromParent_Done,
     /* 174327 */   // Label 3376: @174327
     /* 174327 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174372), // Rule ID 1496 //
     /* 174332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174361 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 174364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174370 */     GIR_RootConstrainSelectedInstOperands,
     /* 174371 */     // GIR_Coverage, 1496,
     /* 174371 */     GIR_EraseRootFromParent_Done,
     /* 174372 */   // Label 3377: @174372
     /* 174372 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174417), // Rule ID 1498 //
     /* 174377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 174409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174415 */     GIR_RootConstrainSelectedInstOperands,
     /* 174416 */     // GIR_Coverage, 1498,
     /* 174416 */     GIR_EraseRootFromParent_Done,
     /* 174417 */   // Label 3378: @174417
     /* 174417 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174462), // Rule ID 1500 //
     /* 174422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174451 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 174454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174460 */     GIR_RootConstrainSelectedInstOperands,
     /* 174461 */     // GIR_Coverage, 1500,
     /* 174461 */     GIR_EraseRootFromParent_Done,
     /* 174462 */   // Label 3379: @174462
     /* 174462 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174507), // Rule ID 1502 //
     /* 174467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174496 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 174499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174505 */     GIR_RootConstrainSelectedInstOperands,
     /* 174506 */     // GIR_Coverage, 1502,
     /* 174506 */     GIR_EraseRootFromParent_Done,
     /* 174507 */   // Label 3380: @174507
     /* 174507 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174552), // Rule ID 1509 //
     /* 174512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174541 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 174544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174550 */     GIR_RootConstrainSelectedInstOperands,
     /* 174551 */     // GIR_Coverage, 1509,
     /* 174551 */     GIR_EraseRootFromParent_Done,
     /* 174552 */   // Label 3381: @174552
     /* 174552 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174597), // Rule ID 1510 //
     /* 174557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174586 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 174589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174595 */     GIR_RootConstrainSelectedInstOperands,
     /* 174596 */     // GIR_Coverage, 1510,
     /* 174596 */     GIR_EraseRootFromParent_Done,
     /* 174597 */   // Label 3382: @174597
     /* 174597 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174642), // Rule ID 1511 //
     /* 174602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174631 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 174634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174640 */     GIR_RootConstrainSelectedInstOperands,
     /* 174641 */     // GIR_Coverage, 1511,
     /* 174641 */     GIR_EraseRootFromParent_Done,
     /* 174642 */   // Label 3383: @174642
     /* 174642 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174687), // Rule ID 1512 //
     /* 174647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174676 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 174679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174685 */     GIR_RootConstrainSelectedInstOperands,
     /* 174686 */     // GIR_Coverage, 1512,
     /* 174686 */     GIR_EraseRootFromParent_Done,
     /* 174687 */   // Label 3384: @174687
     /* 174687 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174732), // Rule ID 1513 //
     /* 174692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174721 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 174724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174730 */     GIR_RootConstrainSelectedInstOperands,
     /* 174731 */     // GIR_Coverage, 1513,
     /* 174731 */     GIR_EraseRootFromParent_Done,
     /* 174732 */   // Label 3385: @174732
     /* 174732 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174777), // Rule ID 1514 //
     /* 174737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174766 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 174769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174775 */     GIR_RootConstrainSelectedInstOperands,
     /* 174776 */     // GIR_Coverage, 1514,
     /* 174776 */     GIR_EraseRootFromParent_Done,
     /* 174777 */   // Label 3386: @174777
     /* 174777 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174822), // Rule ID 1515 //
     /* 174782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174811 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 174814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174820 */     GIR_RootConstrainSelectedInstOperands,
     /* 174821 */     // GIR_Coverage, 1515,
     /* 174821 */     GIR_EraseRootFromParent_Done,
     /* 174822 */   // Label 3387: @174822
     /* 174822 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(174867), // Rule ID 1516 //
     /* 174827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174856 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 174859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174865 */     GIR_RootConstrainSelectedInstOperands,
     /* 174866 */     // GIR_Coverage, 1516,
     /* 174866 */     GIR_EraseRootFromParent_Done,
     /* 174867 */   // Label 3388: @174867
     /* 174867 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(174912), // Rule ID 1517 //
     /* 174872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174901 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 174904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174910 */     GIR_RootConstrainSelectedInstOperands,
     /* 174911 */     // GIR_Coverage, 1517,
     /* 174911 */     GIR_EraseRootFromParent_Done,
     /* 174912 */   // Label 3389: @174912
     /* 174912 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(174957), // Rule ID 1518 //
     /* 174917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174946 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 174949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174955 */     GIR_RootConstrainSelectedInstOperands,
     /* 174956 */     // GIR_Coverage, 1518,
     /* 174956 */     GIR_EraseRootFromParent_Done,
     /* 174957 */   // Label 3390: @174957
     /* 174957 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175002), // Rule ID 1519 //
     /* 174962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174991 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 174994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175000 */     GIR_RootConstrainSelectedInstOperands,
     /* 175001 */     // GIR_Coverage, 1519,
     /* 175001 */     GIR_EraseRootFromParent_Done,
     /* 175002 */   // Label 3391: @175002
     /* 175002 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175047), // Rule ID 1520 //
     /* 175007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 175039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175045 */     GIR_RootConstrainSelectedInstOperands,
     /* 175046 */     // GIR_Coverage, 1520,
     /* 175046 */     GIR_EraseRootFromParent_Done,
     /* 175047 */   // Label 3392: @175047
     /* 175047 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175092), // Rule ID 1527 //
     /* 175052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175081 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 175084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175090 */     GIR_RootConstrainSelectedInstOperands,
     /* 175091 */     // GIR_Coverage, 1527,
     /* 175091 */     GIR_EraseRootFromParent_Done,
     /* 175092 */   // Label 3393: @175092
     /* 175092 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175137), // Rule ID 1528 //
     /* 175097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175126 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 175129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175135 */     GIR_RootConstrainSelectedInstOperands,
     /* 175136 */     // GIR_Coverage, 1528,
     /* 175136 */     GIR_EraseRootFromParent_Done,
     /* 175137 */   // Label 3394: @175137
     /* 175137 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175182), // Rule ID 1529 //
     /* 175142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175171 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 175174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175180 */     GIR_RootConstrainSelectedInstOperands,
     /* 175181 */     // GIR_Coverage, 1529,
     /* 175181 */     GIR_EraseRootFromParent_Done,
     /* 175182 */   // Label 3395: @175182
     /* 175182 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175227), // Rule ID 1530 //
     /* 175187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175216 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 175219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175225 */     GIR_RootConstrainSelectedInstOperands,
     /* 175226 */     // GIR_Coverage, 1530,
     /* 175226 */     GIR_EraseRootFromParent_Done,
     /* 175227 */   // Label 3396: @175227
     /* 175227 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175272), // Rule ID 1531 //
     /* 175232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175261 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 175264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175270 */     GIR_RootConstrainSelectedInstOperands,
     /* 175271 */     // GIR_Coverage, 1531,
     /* 175271 */     GIR_EraseRootFromParent_Done,
     /* 175272 */   // Label 3397: @175272
     /* 175272 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175317), // Rule ID 1532 //
     /* 175277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175306 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 175309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175315 */     GIR_RootConstrainSelectedInstOperands,
     /* 175316 */     // GIR_Coverage, 1532,
     /* 175316 */     GIR_EraseRootFromParent_Done,
     /* 175317 */   // Label 3398: @175317
     /* 175317 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175362), // Rule ID 1539 //
     /* 175322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175351 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 175354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175360 */     GIR_RootConstrainSelectedInstOperands,
     /* 175361 */     // GIR_Coverage, 1539,
     /* 175361 */     GIR_EraseRootFromParent_Done,
     /* 175362 */   // Label 3399: @175362
     /* 175362 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175407), // Rule ID 1540 //
     /* 175367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175396 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 175399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175405 */     GIR_RootConstrainSelectedInstOperands,
     /* 175406 */     // GIR_Coverage, 1540,
     /* 175406 */     GIR_EraseRootFromParent_Done,
     /* 175407 */   // Label 3400: @175407
     /* 175407 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175452), // Rule ID 1541 //
     /* 175412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175441 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 175444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175450 */     GIR_RootConstrainSelectedInstOperands,
     /* 175451 */     // GIR_Coverage, 1541,
     /* 175451 */     GIR_EraseRootFromParent_Done,
     /* 175452 */   // Label 3401: @175452
     /* 175452 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175497), // Rule ID 1542 //
     /* 175457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175486 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 175489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175495 */     GIR_RootConstrainSelectedInstOperands,
     /* 175496 */     // GIR_Coverage, 1542,
     /* 175496 */     GIR_EraseRootFromParent_Done,
     /* 175497 */   // Label 3402: @175497
     /* 175497 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175542), // Rule ID 1543 //
     /* 175502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175531 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 175534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175540 */     GIR_RootConstrainSelectedInstOperands,
     /* 175541 */     // GIR_Coverage, 1543,
     /* 175541 */     GIR_EraseRootFromParent_Done,
     /* 175542 */   // Label 3403: @175542
     /* 175542 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175587), // Rule ID 1544 //
     /* 175547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 175579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175585 */     GIR_RootConstrainSelectedInstOperands,
     /* 175586 */     // GIR_Coverage, 1544,
     /* 175586 */     GIR_EraseRootFromParent_Done,
     /* 175587 */   // Label 3404: @175587
     /* 175587 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175632), // Rule ID 1545 //
     /* 175592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175621 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 175624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175630 */     GIR_RootConstrainSelectedInstOperands,
     /* 175631 */     // GIR_Coverage, 1545,
     /* 175631 */     GIR_EraseRootFromParent_Done,
     /* 175632 */   // Label 3405: @175632
     /* 175632 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175677), // Rule ID 1546 //
     /* 175637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175666 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 175669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175675 */     GIR_RootConstrainSelectedInstOperands,
     /* 175676 */     // GIR_Coverage, 1546,
     /* 175676 */     GIR_EraseRootFromParent_Done,
     /* 175677 */   // Label 3406: @175677
     /* 175677 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175722), // Rule ID 1547 //
     /* 175682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175711 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 175714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175720 */     GIR_RootConstrainSelectedInstOperands,
     /* 175721 */     // GIR_Coverage, 1547,
     /* 175721 */     GIR_EraseRootFromParent_Done,
     /* 175722 */   // Label 3407: @175722
     /* 175722 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175767), // Rule ID 1548 //
     /* 175727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175756 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 175759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175765 */     GIR_RootConstrainSelectedInstOperands,
     /* 175766 */     // GIR_Coverage, 1548,
     /* 175766 */     GIR_EraseRootFromParent_Done,
     /* 175767 */   // Label 3408: @175767
     /* 175767 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175812), // Rule ID 1549 //
     /* 175772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175801 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 175804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175810 */     GIR_RootConstrainSelectedInstOperands,
     /* 175811 */     // GIR_Coverage, 1549,
     /* 175811 */     GIR_EraseRootFromParent_Done,
     /* 175812 */   // Label 3409: @175812
     /* 175812 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(175857), // Rule ID 1550 //
     /* 175817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175846 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 175849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175855 */     GIR_RootConstrainSelectedInstOperands,
     /* 175856 */     // GIR_Coverage, 1550,
     /* 175856 */     GIR_EraseRootFromParent_Done,
     /* 175857 */   // Label 3410: @175857
     /* 175857 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(175902), // Rule ID 1551 //
     /* 175862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 175894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175900 */     GIR_RootConstrainSelectedInstOperands,
     /* 175901 */     // GIR_Coverage, 1551,
     /* 175901 */     GIR_EraseRootFromParent_Done,
     /* 175902 */   // Label 3411: @175902
     /* 175902 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(175947), // Rule ID 1552 //
     /* 175907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 175939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175945 */     GIR_RootConstrainSelectedInstOperands,
     /* 175946 */     // GIR_Coverage, 1552,
     /* 175946 */     GIR_EraseRootFromParent_Done,
     /* 175947 */   // Label 3412: @175947
     /* 175947 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(175992), // Rule ID 1553 //
     /* 175952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175981 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 175984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175990 */     GIR_RootConstrainSelectedInstOperands,
     /* 175991 */     // GIR_Coverage, 1553,
     /* 175991 */     GIR_EraseRootFromParent_Done,
     /* 175992 */   // Label 3413: @175992
     /* 175992 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176037), // Rule ID 1554 //
     /* 175997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176026 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 176029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176035 */     GIR_RootConstrainSelectedInstOperands,
     /* 176036 */     // GIR_Coverage, 1554,
     /* 176036 */     GIR_EraseRootFromParent_Done,
     /* 176037 */   // Label 3414: @176037
     /* 176037 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176082), // Rule ID 1555 //
     /* 176042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176071 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 176074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176080 */     GIR_RootConstrainSelectedInstOperands,
     /* 176081 */     // GIR_Coverage, 1555,
     /* 176081 */     GIR_EraseRootFromParent_Done,
     /* 176082 */   // Label 3415: @176082
     /* 176082 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176127), // Rule ID 1556 //
     /* 176087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176116 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 176119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176125 */     GIR_RootConstrainSelectedInstOperands,
     /* 176126 */     // GIR_Coverage, 1556,
     /* 176126 */     GIR_EraseRootFromParent_Done,
     /* 176127 */   // Label 3416: @176127
     /* 176127 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176172), // Rule ID 1557 //
     /* 176132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176161 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 176164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176170 */     GIR_RootConstrainSelectedInstOperands,
     /* 176171 */     // GIR_Coverage, 1557,
     /* 176171 */     GIR_EraseRootFromParent_Done,
     /* 176172 */   // Label 3417: @176172
     /* 176172 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176217), // Rule ID 1558 //
     /* 176177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 176209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176215 */     GIR_RootConstrainSelectedInstOperands,
     /* 176216 */     // GIR_Coverage, 1558,
     /* 176216 */     GIR_EraseRootFromParent_Done,
     /* 176217 */   // Label 3418: @176217
     /* 176217 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176262), // Rule ID 1559 //
     /* 176222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176251 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 176254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176260 */     GIR_RootConstrainSelectedInstOperands,
     /* 176261 */     // GIR_Coverage, 1559,
     /* 176261 */     GIR_EraseRootFromParent_Done,
     /* 176262 */   // Label 3419: @176262
     /* 176262 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176307), // Rule ID 1560 //
     /* 176267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176296 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 176299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176305 */     GIR_RootConstrainSelectedInstOperands,
     /* 176306 */     // GIR_Coverage, 1560,
     /* 176306 */     GIR_EraseRootFromParent_Done,
     /* 176307 */   // Label 3420: @176307
     /* 176307 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176352), // Rule ID 1561 //
     /* 176312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176341 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 176344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176350 */     GIR_RootConstrainSelectedInstOperands,
     /* 176351 */     // GIR_Coverage, 1561,
     /* 176351 */     GIR_EraseRootFromParent_Done,
     /* 176352 */   // Label 3421: @176352
     /* 176352 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176397), // Rule ID 1562 //
     /* 176357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176386 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 176389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176395 */     GIR_RootConstrainSelectedInstOperands,
     /* 176396 */     // GIR_Coverage, 1562,
     /* 176396 */     GIR_EraseRootFromParent_Done,
     /* 176397 */   // Label 3422: @176397
     /* 176397 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176442), // Rule ID 1563 //
     /* 176402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176431 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 176434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176440 */     GIR_RootConstrainSelectedInstOperands,
     /* 176441 */     // GIR_Coverage, 1563,
     /* 176441 */     GIR_EraseRootFromParent_Done,
     /* 176442 */   // Label 3423: @176442
     /* 176442 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176487), // Rule ID 1564 //
     /* 176447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176476 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 176479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176485 */     GIR_RootConstrainSelectedInstOperands,
     /* 176486 */     // GIR_Coverage, 1564,
     /* 176486 */     GIR_EraseRootFromParent_Done,
     /* 176487 */   // Label 3424: @176487
     /* 176487 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176532), // Rule ID 1565 //
     /* 176492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 176524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176530 */     GIR_RootConstrainSelectedInstOperands,
     /* 176531 */     // GIR_Coverage, 1565,
     /* 176531 */     GIR_EraseRootFromParent_Done,
     /* 176532 */   // Label 3425: @176532
     /* 176532 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176577), // Rule ID 1566 //
     /* 176537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176566 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 176569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176575 */     GIR_RootConstrainSelectedInstOperands,
     /* 176576 */     // GIR_Coverage, 1566,
     /* 176576 */     GIR_EraseRootFromParent_Done,
     /* 176577 */   // Label 3426: @176577
     /* 176577 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176622), // Rule ID 1573 //
     /* 176582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176611 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 176614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176620 */     GIR_RootConstrainSelectedInstOperands,
     /* 176621 */     // GIR_Coverage, 1573,
     /* 176621 */     GIR_EraseRootFromParent_Done,
     /* 176622 */   // Label 3427: @176622
     /* 176622 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176667), // Rule ID 1574 //
     /* 176627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176656 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 176659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176665 */     GIR_RootConstrainSelectedInstOperands,
     /* 176666 */     // GIR_Coverage, 1574,
     /* 176666 */     GIR_EraseRootFromParent_Done,
     /* 176667 */   // Label 3428: @176667
     /* 176667 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176712), // Rule ID 1575 //
     /* 176672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176701 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 176704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176710 */     GIR_RootConstrainSelectedInstOperands,
     /* 176711 */     // GIR_Coverage, 1575,
     /* 176711 */     GIR_EraseRootFromParent_Done,
     /* 176712 */   // Label 3429: @176712
     /* 176712 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176757), // Rule ID 1576 //
     /* 176717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176746 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 176749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176755 */     GIR_RootConstrainSelectedInstOperands,
     /* 176756 */     // GIR_Coverage, 1576,
     /* 176756 */     GIR_EraseRootFromParent_Done,
     /* 176757 */   // Label 3430: @176757
     /* 176757 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176802), // Rule ID 1577 //
     /* 176762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176791 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 176794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176800 */     GIR_RootConstrainSelectedInstOperands,
     /* 176801 */     // GIR_Coverage, 1577,
     /* 176801 */     GIR_EraseRootFromParent_Done,
     /* 176802 */   // Label 3431: @176802
     /* 176802 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(176847), // Rule ID 1578 //
     /* 176807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176836 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 176839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176845 */     GIR_RootConstrainSelectedInstOperands,
     /* 176846 */     // GIR_Coverage, 1578,
     /* 176846 */     GIR_EraseRootFromParent_Done,
     /* 176847 */   // Label 3432: @176847
     /* 176847 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(176892), // Rule ID 1579 //
     /* 176852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176881 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 176884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176890 */     GIR_RootConstrainSelectedInstOperands,
     /* 176891 */     // GIR_Coverage, 1579,
     /* 176891 */     GIR_EraseRootFromParent_Done,
     /* 176892 */   // Label 3433: @176892
     /* 176892 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(176937), // Rule ID 1580 //
     /* 176897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176926 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 176929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176935 */     GIR_RootConstrainSelectedInstOperands,
     /* 176936 */     // GIR_Coverage, 1580,
     /* 176936 */     GIR_EraseRootFromParent_Done,
     /* 176937 */   // Label 3434: @176937
     /* 176937 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(176982), // Rule ID 1581 //
     /* 176942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176971 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 176974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176980 */     GIR_RootConstrainSelectedInstOperands,
     /* 176981 */     // GIR_Coverage, 1581,
     /* 176981 */     GIR_EraseRootFromParent_Done,
     /* 176982 */   // Label 3435: @176982
     /* 176982 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177027), // Rule ID 1582 //
     /* 176987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177016 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 177019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177025 */     GIR_RootConstrainSelectedInstOperands,
     /* 177026 */     // GIR_Coverage, 1582,
     /* 177026 */     GIR_EraseRootFromParent_Done,
     /* 177027 */   // Label 3436: @177027
     /* 177027 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177072), // Rule ID 1583 //
     /* 177032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177061 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 177064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177070 */     GIR_RootConstrainSelectedInstOperands,
     /* 177071 */     // GIR_Coverage, 1583,
     /* 177071 */     GIR_EraseRootFromParent_Done,
     /* 177072 */   // Label 3437: @177072
     /* 177072 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177117), // Rule ID 1584 //
     /* 177077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177106 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 177109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177115 */     GIR_RootConstrainSelectedInstOperands,
     /* 177116 */     // GIR_Coverage, 1584,
     /* 177116 */     GIR_EraseRootFromParent_Done,
     /* 177117 */   // Label 3438: @177117
     /* 177117 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177162), // Rule ID 1585 //
     /* 177122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177151 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 177154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177160 */     GIR_RootConstrainSelectedInstOperands,
     /* 177161 */     // GIR_Coverage, 1585,
     /* 177161 */     GIR_EraseRootFromParent_Done,
     /* 177162 */   // Label 3439: @177162
     /* 177162 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177207), // Rule ID 1586 //
     /* 177167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177196 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 177199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177205 */     GIR_RootConstrainSelectedInstOperands,
     /* 177206 */     // GIR_Coverage, 1586,
     /* 177206 */     GIR_EraseRootFromParent_Done,
     /* 177207 */   // Label 3440: @177207
     /* 177207 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177252), // Rule ID 1614 //
     /* 177212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177241 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 177244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177250 */     GIR_RootConstrainSelectedInstOperands,
     /* 177251 */     // GIR_Coverage, 1614,
     /* 177251 */     GIR_EraseRootFromParent_Done,
     /* 177252 */   // Label 3441: @177252
     /* 177252 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177297), // Rule ID 1615 //
     /* 177257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177286 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 177289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177295 */     GIR_RootConstrainSelectedInstOperands,
     /* 177296 */     // GIR_Coverage, 1615,
     /* 177296 */     GIR_EraseRootFromParent_Done,
     /* 177297 */   // Label 3442: @177297
     /* 177297 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177342), // Rule ID 1616 //
     /* 177302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177331 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 177334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177340 */     GIR_RootConstrainSelectedInstOperands,
     /* 177341 */     // GIR_Coverage, 1616,
     /* 177341 */     GIR_EraseRootFromParent_Done,
     /* 177342 */   // Label 3443: @177342
     /* 177342 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177387), // Rule ID 1617 //
     /* 177347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177376 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 177379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177385 */     GIR_RootConstrainSelectedInstOperands,
     /* 177386 */     // GIR_Coverage, 1617,
     /* 177386 */     GIR_EraseRootFromParent_Done,
     /* 177387 */   // Label 3444: @177387
     /* 177387 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177432), // Rule ID 1618 //
     /* 177392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177421 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 177424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177430 */     GIR_RootConstrainSelectedInstOperands,
     /* 177431 */     // GIR_Coverage, 1618,
     /* 177431 */     GIR_EraseRootFromParent_Done,
     /* 177432 */   // Label 3445: @177432
     /* 177432 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177477), // Rule ID 1619 //
     /* 177437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177466 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 177469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177475 */     GIR_RootConstrainSelectedInstOperands,
     /* 177476 */     // GIR_Coverage, 1619,
     /* 177476 */     GIR_EraseRootFromParent_Done,
     /* 177477 */   // Label 3446: @177477
     /* 177477 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177522), // Rule ID 1620 //
     /* 177482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177511 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 177514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177520 */     GIR_RootConstrainSelectedInstOperands,
     /* 177521 */     // GIR_Coverage, 1620,
     /* 177521 */     GIR_EraseRootFromParent_Done,
     /* 177522 */   // Label 3447: @177522
     /* 177522 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177567), // Rule ID 1627 //
     /* 177527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177556 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177565 */     GIR_RootConstrainSelectedInstOperands,
     /* 177566 */     // GIR_Coverage, 1627,
     /* 177566 */     GIR_EraseRootFromParent_Done,
     /* 177567 */   // Label 3448: @177567
     /* 177567 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177612), // Rule ID 1628 //
     /* 177572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177601 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177610 */     GIR_RootConstrainSelectedInstOperands,
     /* 177611 */     // GIR_Coverage, 1628,
     /* 177611 */     GIR_EraseRootFromParent_Done,
     /* 177612 */   // Label 3449: @177612
     /* 177612 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177657), // Rule ID 1629 //
     /* 177617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177646 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177655 */     GIR_RootConstrainSelectedInstOperands,
     /* 177656 */     // GIR_Coverage, 1629,
     /* 177656 */     GIR_EraseRootFromParent_Done,
     /* 177657 */   // Label 3450: @177657
     /* 177657 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177702), // Rule ID 1630 //
     /* 177662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177691 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 177694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177700 */     GIR_RootConstrainSelectedInstOperands,
     /* 177701 */     // GIR_Coverage, 1630,
     /* 177701 */     GIR_EraseRootFromParent_Done,
     /* 177702 */   // Label 3451: @177702
     /* 177702 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177747), // Rule ID 1631 //
     /* 177707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177736 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 177739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177745 */     GIR_RootConstrainSelectedInstOperands,
     /* 177746 */     // GIR_Coverage, 1631,
     /* 177746 */     GIR_EraseRootFromParent_Done,
     /* 177747 */   // Label 3452: @177747
     /* 177747 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177792), // Rule ID 1632 //
     /* 177752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177781 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 177784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177790 */     GIR_RootConstrainSelectedInstOperands,
     /* 177791 */     // GIR_Coverage, 1632,
     /* 177791 */     GIR_EraseRootFromParent_Done,
     /* 177792 */   // Label 3453: @177792
     /* 177792 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177837), // Rule ID 1633 //
     /* 177797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177826 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 177829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177835 */     GIR_RootConstrainSelectedInstOperands,
     /* 177836 */     // GIR_Coverage, 1633,
     /* 177836 */     GIR_EraseRootFromParent_Done,
     /* 177837 */   // Label 3454: @177837
     /* 177837 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177882), // Rule ID 1634 //
     /* 177842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177871 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 177874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177880 */     GIR_RootConstrainSelectedInstOperands,
     /* 177881 */     // GIR_Coverage, 1634,
     /* 177881 */     GIR_EraseRootFromParent_Done,
     /* 177882 */   // Label 3455: @177882
     /* 177882 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177927), // Rule ID 1635 //
     /* 177887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177916 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 177919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177925 */     GIR_RootConstrainSelectedInstOperands,
     /* 177926 */     // GIR_Coverage, 1635,
     /* 177926 */     GIR_EraseRootFromParent_Done,
     /* 177927 */   // Label 3456: @177927
     /* 177927 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(177972), // Rule ID 1636 //
     /* 177932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177961 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 177964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177970 */     GIR_RootConstrainSelectedInstOperands,
     /* 177971 */     // GIR_Coverage, 1636,
     /* 177971 */     GIR_EraseRootFromParent_Done,
     /* 177972 */   // Label 3457: @177972
     /* 177972 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178017), // Rule ID 1637 //
     /* 177977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178006 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 178009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178015 */     GIR_RootConstrainSelectedInstOperands,
     /* 178016 */     // GIR_Coverage, 1637,
     /* 178016 */     GIR_EraseRootFromParent_Done,
     /* 178017 */   // Label 3458: @178017
     /* 178017 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178062), // Rule ID 1638 //
     /* 178022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178051 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 178054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178060 */     GIR_RootConstrainSelectedInstOperands,
     /* 178061 */     // GIR_Coverage, 1638,
     /* 178061 */     GIR_EraseRootFromParent_Done,
     /* 178062 */   // Label 3459: @178062
     /* 178062 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178107), // Rule ID 1639 //
     /* 178067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178096 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178105 */     GIR_RootConstrainSelectedInstOperands,
     /* 178106 */     // GIR_Coverage, 1639,
     /* 178106 */     GIR_EraseRootFromParent_Done,
     /* 178107 */   // Label 3460: @178107
     /* 178107 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178152), // Rule ID 1640 //
     /* 178112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178141 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178150 */     GIR_RootConstrainSelectedInstOperands,
     /* 178151 */     // GIR_Coverage, 1640,
     /* 178151 */     GIR_EraseRootFromParent_Done,
     /* 178152 */   // Label 3461: @178152
     /* 178152 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178197), // Rule ID 1641 //
     /* 178157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178186 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 178189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178195 */     GIR_RootConstrainSelectedInstOperands,
     /* 178196 */     // GIR_Coverage, 1641,
     /* 178196 */     GIR_EraseRootFromParent_Done,
     /* 178197 */   // Label 3462: @178197
     /* 178197 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178242), // Rule ID 1642 //
     /* 178202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 178210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178231 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 178234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178240 */     GIR_RootConstrainSelectedInstOperands,
     /* 178241 */     // GIR_Coverage, 1642,
     /* 178241 */     GIR_EraseRootFromParent_Done,
     /* 178242 */   // Label 3463: @178242
     /* 178242 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178287), // Rule ID 1643 //
     /* 178247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 178255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178276 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 178279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178285 */     GIR_RootConstrainSelectedInstOperands,
     /* 178286 */     // GIR_Coverage, 1643,
     /* 178286 */     GIR_EraseRootFromParent_Done,
     /* 178287 */   // Label 3464: @178287
     /* 178287 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178332), // Rule ID 1645 //
     /* 178292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178321 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 178324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178330 */     GIR_RootConstrainSelectedInstOperands,
     /* 178331 */     // GIR_Coverage, 1645,
     /* 178331 */     GIR_EraseRootFromParent_Done,
     /* 178332 */   // Label 3465: @178332
     /* 178332 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178377), // Rule ID 1646 //
     /* 178337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178366 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 178369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178375 */     GIR_RootConstrainSelectedInstOperands,
     /* 178376 */     // GIR_Coverage, 1646,
     /* 178376 */     GIR_EraseRootFromParent_Done,
     /* 178377 */   // Label 3466: @178377
     /* 178377 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178422), // Rule ID 1647 //
     /* 178382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178411 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 178414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178420 */     GIR_RootConstrainSelectedInstOperands,
     /* 178421 */     // GIR_Coverage, 1647,
     /* 178421 */     GIR_EraseRootFromParent_Done,
     /* 178422 */   // Label 3467: @178422
     /* 178422 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178467), // Rule ID 1648 //
     /* 178427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178456 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 178459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178465 */     GIR_RootConstrainSelectedInstOperands,
     /* 178466 */     // GIR_Coverage, 1648,
     /* 178466 */     GIR_EraseRootFromParent_Done,
     /* 178467 */   // Label 3468: @178467
     /* 178467 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178512), // Rule ID 1649 //
     /* 178472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178501 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 178504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178510 */     GIR_RootConstrainSelectedInstOperands,
     /* 178511 */     // GIR_Coverage, 1649,
     /* 178511 */     GIR_EraseRootFromParent_Done,
     /* 178512 */   // Label 3469: @178512
     /* 178512 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178557), // Rule ID 1650 //
     /* 178517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 178525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178546 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 178549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178555 */     GIR_RootConstrainSelectedInstOperands,
     /* 178556 */     // GIR_Coverage, 1650,
     /* 178556 */     GIR_EraseRootFromParent_Done,
     /* 178557 */   // Label 3470: @178557
     /* 178557 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178602), // Rule ID 1651 //
     /* 178562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178591 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 178594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178600 */     GIR_RootConstrainSelectedInstOperands,
     /* 178601 */     // GIR_Coverage, 1651,
     /* 178601 */     GIR_EraseRootFromParent_Done,
     /* 178602 */   // Label 3471: @178602
     /* 178602 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178647), // Rule ID 1665 //
     /* 178607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178636 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 178639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178645 */     GIR_RootConstrainSelectedInstOperands,
     /* 178646 */     // GIR_Coverage, 1665,
     /* 178646 */     GIR_EraseRootFromParent_Done,
     /* 178647 */   // Label 3472: @178647
     /* 178647 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178692), // Rule ID 1666 //
     /* 178652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178681 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 178684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178690 */     GIR_RootConstrainSelectedInstOperands,
     /* 178691 */     // GIR_Coverage, 1666,
     /* 178691 */     GIR_EraseRootFromParent_Done,
     /* 178692 */   // Label 3473: @178692
     /* 178692 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178737), // Rule ID 1671 //
     /* 178697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178726 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 178729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178735 */     GIR_RootConstrainSelectedInstOperands,
     /* 178736 */     // GIR_Coverage, 1671,
     /* 178736 */     GIR_EraseRootFromParent_Done,
     /* 178737 */   // Label 3474: @178737
     /* 178737 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178782), // Rule ID 1672 //
     /* 178742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178771 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 178774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178780 */     GIR_RootConstrainSelectedInstOperands,
     /* 178781 */     // GIR_Coverage, 1672,
     /* 178781 */     GIR_EraseRootFromParent_Done,
     /* 178782 */   // Label 3475: @178782
     /* 178782 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178827), // Rule ID 1673 //
     /* 178787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178816 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 178819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178825 */     GIR_RootConstrainSelectedInstOperands,
     /* 178826 */     // GIR_Coverage, 1673,
     /* 178826 */     GIR_EraseRootFromParent_Done,
     /* 178827 */   // Label 3476: @178827
     /* 178827 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178872), // Rule ID 1674 //
     /* 178832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178861 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 178864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178870 */     GIR_RootConstrainSelectedInstOperands,
     /* 178871 */     // GIR_Coverage, 1674,
     /* 178871 */     GIR_EraseRootFromParent_Done,
     /* 178872 */   // Label 3477: @178872
     /* 178872 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178917), // Rule ID 1675 //
     /* 178877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178906 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 178909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178915 */     GIR_RootConstrainSelectedInstOperands,
     /* 178916 */     // GIR_Coverage, 1675,
     /* 178916 */     GIR_EraseRootFromParent_Done,
     /* 178917 */   // Label 3478: @178917
     /* 178917 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(178962), // Rule ID 1676 //
     /* 178922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178951 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 178954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178960 */     GIR_RootConstrainSelectedInstOperands,
     /* 178961 */     // GIR_Coverage, 1676,
     /* 178961 */     GIR_EraseRootFromParent_Done,
     /* 178962 */   // Label 3479: @178962
     /* 178962 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179007), // Rule ID 1677 //
     /* 178967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 178999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179005 */     GIR_RootConstrainSelectedInstOperands,
     /* 179006 */     // GIR_Coverage, 1677,
     /* 179006 */     GIR_EraseRootFromParent_Done,
     /* 179007 */   // Label 3480: @179007
     /* 179007 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179052), // Rule ID 1678 //
     /* 179012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179041 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 179044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179050 */     GIR_RootConstrainSelectedInstOperands,
     /* 179051 */     // GIR_Coverage, 1678,
     /* 179051 */     GIR_EraseRootFromParent_Done,
     /* 179052 */   // Label 3481: @179052
     /* 179052 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179097), // Rule ID 1679 //
     /* 179057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179086 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179095 */     GIR_RootConstrainSelectedInstOperands,
     /* 179096 */     // GIR_Coverage, 1679,
     /* 179096 */     GIR_EraseRootFromParent_Done,
     /* 179097 */   // Label 3482: @179097
     /* 179097 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179142), // Rule ID 1680 //
     /* 179102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179131 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179140 */     GIR_RootConstrainSelectedInstOperands,
     /* 179141 */     // GIR_Coverage, 1680,
     /* 179141 */     GIR_EraseRootFromParent_Done,
     /* 179142 */   // Label 3483: @179142
     /* 179142 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179187), // Rule ID 1681 //
     /* 179147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179176 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179185 */     GIR_RootConstrainSelectedInstOperands,
     /* 179186 */     // GIR_Coverage, 1681,
     /* 179186 */     GIR_EraseRootFromParent_Done,
     /* 179187 */   // Label 3484: @179187
     /* 179187 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179232), // Rule ID 1682 //
     /* 179192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179221 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 179224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179230 */     GIR_RootConstrainSelectedInstOperands,
     /* 179231 */     // GIR_Coverage, 1682,
     /* 179231 */     GIR_EraseRootFromParent_Done,
     /* 179232 */   // Label 3485: @179232
     /* 179232 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179277), // Rule ID 1683 //
     /* 179237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179266 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 179269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179275 */     GIR_RootConstrainSelectedInstOperands,
     /* 179276 */     // GIR_Coverage, 1683,
     /* 179276 */     GIR_EraseRootFromParent_Done,
     /* 179277 */   // Label 3486: @179277
     /* 179277 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179322), // Rule ID 1684 //
     /* 179282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179311 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 179314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179320 */     GIR_RootConstrainSelectedInstOperands,
     /* 179321 */     // GIR_Coverage, 1684,
     /* 179321 */     GIR_EraseRootFromParent_Done,
     /* 179322 */   // Label 3487: @179322
     /* 179322 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179367), // Rule ID 1750 //
     /* 179327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179356 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 179359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179365 */     GIR_RootConstrainSelectedInstOperands,
     /* 179366 */     // GIR_Coverage, 1750,
     /* 179366 */     GIR_EraseRootFromParent_Done,
     /* 179367 */   // Label 3488: @179367
     /* 179367 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179412), // Rule ID 1752 //
     /* 179372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179401 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 179404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179410 */     GIR_RootConstrainSelectedInstOperands,
     /* 179411 */     // GIR_Coverage, 1752,
     /* 179411 */     GIR_EraseRootFromParent_Done,
     /* 179412 */   // Label 3489: @179412
     /* 179412 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179457), // Rule ID 2303 //
     /* 179417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 179425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179446 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 179449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179455 */     GIR_RootConstrainSelectedInstOperands,
     /* 179456 */     // GIR_Coverage, 2303,
     /* 179456 */     GIR_EraseRootFromParent_Done,
     /* 179457 */   // Label 3490: @179457
     /* 179457 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179502), // Rule ID 2304 //
     /* 179462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 179470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179491 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 179494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179500 */     GIR_RootConstrainSelectedInstOperands,
     /* 179501 */     // GIR_Coverage, 2304,
     /* 179501 */     GIR_EraseRootFromParent_Done,
     /* 179502 */   // Label 3491: @179502
     /* 179502 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179547), // Rule ID 2315 //
     /* 179507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 179515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 179539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179545 */     GIR_RootConstrainSelectedInstOperands,
     /* 179546 */     // GIR_Coverage, 2315,
     /* 179546 */     GIR_EraseRootFromParent_Done,
     /* 179547 */   // Label 3492: @179547
     /* 179547 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179592), // Rule ID 2316 //
     /* 179552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 179560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 179584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179590 */     GIR_RootConstrainSelectedInstOperands,
     /* 179591 */     // GIR_Coverage, 2316,
     /* 179591 */     GIR_EraseRootFromParent_Done,
     /* 179592 */   // Label 3493: @179592
     /* 179592 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179637), // Rule ID 2339 //
     /* 179597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179626 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 179629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179635 */     GIR_RootConstrainSelectedInstOperands,
     /* 179636 */     // GIR_Coverage, 2339,
     /* 179636 */     GIR_EraseRootFromParent_Done,
     /* 179637 */   // Label 3494: @179637
     /* 179637 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179682), // Rule ID 2340 //
     /* 179642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179671 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 179674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179680 */     GIR_RootConstrainSelectedInstOperands,
     /* 179681 */     // GIR_Coverage, 2340,
     /* 179681 */     GIR_EraseRootFromParent_Done,
     /* 179682 */   // Label 3495: @179682
     /* 179682 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179727), // Rule ID 2341 //
     /* 179687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 179719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179725 */     GIR_RootConstrainSelectedInstOperands,
     /* 179726 */     // GIR_Coverage, 2341,
     /* 179726 */     GIR_EraseRootFromParent_Done,
     /* 179727 */   // Label 3496: @179727
     /* 179727 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179772), // Rule ID 2342 //
     /* 179732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179761 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 179764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179770 */     GIR_RootConstrainSelectedInstOperands,
     /* 179771 */     // GIR_Coverage, 2342,
     /* 179771 */     GIR_EraseRootFromParent_Done,
     /* 179772 */   // Label 3497: @179772
     /* 179772 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179817), // Rule ID 2343 //
     /* 179777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179806 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 179809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179815 */     GIR_RootConstrainSelectedInstOperands,
     /* 179816 */     // GIR_Coverage, 2343,
     /* 179816 */     GIR_EraseRootFromParent_Done,
     /* 179817 */   // Label 3498: @179817
     /* 179817 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(179862), // Rule ID 2344 //
     /* 179822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179851 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 179851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 179854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179860 */     GIR_RootConstrainSelectedInstOperands,
     /* 179861 */     // GIR_Coverage, 2344,
     /* 179861 */     GIR_EraseRootFromParent_Done,
     /* 179862 */   // Label 3499: @179862
     /* 179862 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(179907), // Rule ID 2347 //
     /* 179867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179896 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 179896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 179899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179905 */     GIR_RootConstrainSelectedInstOperands,
     /* 179906 */     // GIR_Coverage, 2347,
     /* 179906 */     GIR_EraseRootFromParent_Done,
     /* 179907 */   // Label 3500: @179907
     /* 179907 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(179952), // Rule ID 2350 //
     /* 179912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179941 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 179941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 179944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179950 */     GIR_RootConstrainSelectedInstOperands,
     /* 179951 */     // GIR_Coverage, 2350,
     /* 179951 */     GIR_EraseRootFromParent_Done,
     /* 179952 */   // Label 3501: @179952
     /* 179952 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(179997), // Rule ID 2353 //
     /* 179957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179986 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 179986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 179989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179995 */     GIR_RootConstrainSelectedInstOperands,
     /* 179996 */     // GIR_Coverage, 2353,
     /* 179996 */     GIR_EraseRootFromParent_Done,
     /* 179997 */   // Label 3502: @179997
     /* 179997 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180042), // Rule ID 2356 //
     /* 180002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180031 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 180034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180040 */     GIR_RootConstrainSelectedInstOperands,
     /* 180041 */     // GIR_Coverage, 2356,
     /* 180041 */     GIR_EraseRootFromParent_Done,
     /* 180042 */   // Label 3503: @180042
     /* 180042 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180087), // Rule ID 2359 //
     /* 180047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180076 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 180079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180085 */     GIR_RootConstrainSelectedInstOperands,
     /* 180086 */     // GIR_Coverage, 2359,
     /* 180086 */     GIR_EraseRootFromParent_Done,
     /* 180087 */   // Label 3504: @180087
     /* 180087 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180132), // Rule ID 2362 //
     /* 180092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180121 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 180124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180130 */     GIR_RootConstrainSelectedInstOperands,
     /* 180131 */     // GIR_Coverage, 2362,
     /* 180131 */     GIR_EraseRootFromParent_Done,
     /* 180132 */   // Label 3505: @180132
     /* 180132 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180177), // Rule ID 2365 //
     /* 180137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180166 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 180169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180175 */     GIR_RootConstrainSelectedInstOperands,
     /* 180176 */     // GIR_Coverage, 2365,
     /* 180176 */     GIR_EraseRootFromParent_Done,
     /* 180177 */   // Label 3506: @180177
     /* 180177 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180222), // Rule ID 2368 //
     /* 180182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180211 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 180214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180220 */     GIR_RootConstrainSelectedInstOperands,
     /* 180221 */     // GIR_Coverage, 2368,
     /* 180221 */     GIR_EraseRootFromParent_Done,
     /* 180222 */   // Label 3507: @180222
     /* 180222 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180267), // Rule ID 2371 //
     /* 180227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180256 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 180259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180265 */     GIR_RootConstrainSelectedInstOperands,
     /* 180266 */     // GIR_Coverage, 2371,
     /* 180266 */     GIR_EraseRootFromParent_Done,
     /* 180267 */   // Label 3508: @180267
     /* 180267 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180312), // Rule ID 2508 //
     /* 180272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180301 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 180301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180310 */     GIR_RootConstrainSelectedInstOperands,
     /* 180311 */     // GIR_Coverage, 2508,
     /* 180311 */     GIR_EraseRootFromParent_Done,
     /* 180312 */   // Label 3509: @180312
     /* 180312 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180357), // Rule ID 2509 //
     /* 180317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180346 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 180349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180355 */     GIR_RootConstrainSelectedInstOperands,
     /* 180356 */     // GIR_Coverage, 2509,
     /* 180356 */     GIR_EraseRootFromParent_Done,
     /* 180357 */   // Label 3510: @180357
     /* 180357 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180402), // Rule ID 2510 //
     /* 180362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 180370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180391 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 180394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180400 */     GIR_RootConstrainSelectedInstOperands,
     /* 180401 */     // GIR_Coverage, 2510,
     /* 180401 */     GIR_EraseRootFromParent_Done,
     /* 180402 */   // Label 3511: @180402
     /* 180402 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180447), // Rule ID 2511 //
     /* 180407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 180415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180436 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 180439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180445 */     GIR_RootConstrainSelectedInstOperands,
     /* 180446 */     // GIR_Coverage, 2511,
     /* 180446 */     GIR_EraseRootFromParent_Done,
     /* 180447 */   // Label 3512: @180447
     /* 180447 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180492), // Rule ID 2516 //
     /* 180452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180481 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 180481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 180484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180490 */     GIR_RootConstrainSelectedInstOperands,
     /* 180491 */     // GIR_Coverage, 2516,
     /* 180491 */     GIR_EraseRootFromParent_Done,
     /* 180492 */   // Label 3513: @180492
     /* 180492 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180537), // Rule ID 2634 //
     /* 180497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180526 */     // (intrinsic_wo_chain:{ *:[i32] } 2017:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 180529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180535 */     GIR_RootConstrainSelectedInstOperands,
     /* 180536 */     // GIR_Coverage, 2634,
     /* 180536 */     GIR_EraseRootFromParent_Done,
     /* 180537 */   // Label 3514: @180537
     /* 180537 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180582), // Rule ID 2635 //
     /* 180542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180571 */     // (intrinsic_wo_chain:{ *:[i32] } 2017:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 180574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180580 */     GIR_RootConstrainSelectedInstOperands,
     /* 180581 */     // GIR_Coverage, 2635,
     /* 180581 */     GIR_EraseRootFromParent_Done,
     /* 180582 */   // Label 3515: @180582
     /* 180582 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180627), // Rule ID 2636 //
     /* 180587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180616 */     // (intrinsic_wo_chain:{ *:[i32] } 2017:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 180619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180625 */     GIR_RootConstrainSelectedInstOperands,
     /* 180626 */     // GIR_Coverage, 2636,
     /* 180626 */     GIR_EraseRootFromParent_Done,
     /* 180627 */   // Label 3516: @180627
     /* 180627 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180672), // Rule ID 2637 //
     /* 180632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180661 */     // (intrinsic_wo_chain:{ *:[i32] } 2017:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 180664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180670 */     GIR_RootConstrainSelectedInstOperands,
     /* 180671 */     // GIR_Coverage, 2637,
     /* 180671 */     GIR_EraseRootFromParent_Done,
     /* 180672 */   // Label 3517: @180672
     /* 180672 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180717), // Rule ID 2638 //
     /* 180677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180706 */     // (intrinsic_wo_chain:{ *:[i64] } 1807:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 180709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180715 */     GIR_RootConstrainSelectedInstOperands,
     /* 180716 */     // GIR_Coverage, 2638,
     /* 180716 */     GIR_EraseRootFromParent_Done,
     /* 180717 */   // Label 3518: @180717
     /* 180717 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180762), // Rule ID 2639 //
     /* 180722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180751 */     // (intrinsic_wo_chain:{ *:[i64] } 1807:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 180754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180760 */     GIR_RootConstrainSelectedInstOperands,
     /* 180761 */     // GIR_Coverage, 2639,
     /* 180761 */     GIR_EraseRootFromParent_Done,
     /* 180762 */   // Label 3519: @180762
     /* 180762 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180807), // Rule ID 2640 //
     /* 180767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180796 */     // (intrinsic_wo_chain:{ *:[i64] } 1807:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 180799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180805 */     GIR_RootConstrainSelectedInstOperands,
     /* 180806 */     // GIR_Coverage, 2640,
     /* 180806 */     GIR_EraseRootFromParent_Done,
     /* 180807 */   // Label 3520: @180807
     /* 180807 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(180852), // Rule ID 2641 //
     /* 180812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180841 */     // (intrinsic_wo_chain:{ *:[i64] } 1807:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 180844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180850 */     GIR_RootConstrainSelectedInstOperands,
     /* 180851 */     // GIR_Coverage, 2641,
     /* 180851 */     GIR_EraseRootFromParent_Done,
     /* 180852 */   // Label 3521: @180852
     /* 180852 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(180897), // Rule ID 3807 //
     /* 180857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 180865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180886 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 180889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180895 */     GIR_RootConstrainSelectedInstOperands,
     /* 180896 */     // GIR_Coverage, 3807,
     /* 180896 */     GIR_EraseRootFromParent_Done,
     /* 180897 */   // Label 3522: @180897
     /* 180897 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(180942), // Rule ID 3835 //
     /* 180902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 180910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180931 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 180934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180940 */     GIR_RootConstrainSelectedInstOperands,
     /* 180941 */     // GIR_Coverage, 3835,
     /* 180941 */     GIR_EraseRootFromParent_Done,
     /* 180942 */   // Label 3523: @180942
     /* 180942 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(180987), // Rule ID 3845 //
     /* 180947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 180955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180976 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 180979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180985 */     GIR_RootConstrainSelectedInstOperands,
     /* 180986 */     // GIR_Coverage, 3845,
     /* 180986 */     GIR_EraseRootFromParent_Done,
     /* 180987 */   // Label 3524: @180987
     /* 180987 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181032), // Rule ID 3846 //
     /* 180992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 181000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 181024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181030 */     GIR_RootConstrainSelectedInstOperands,
     /* 181031 */     // GIR_Coverage, 3846,
     /* 181031 */     GIR_EraseRootFromParent_Done,
     /* 181032 */   // Label 3525: @181032
     /* 181032 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181080), // Rule ID 3847 //
     /* 181037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181066 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 181066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181078 */     GIR_RootConstrainSelectedInstOperands,
     /* 181079 */     // GIR_Coverage, 3847,
     /* 181079 */     GIR_EraseRootFromParent_Done,
     /* 181080 */   // Label 3526: @181080
     /* 181080 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181128), // Rule ID 3848 //
     /* 181085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181114 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 181114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181126 */     GIR_RootConstrainSelectedInstOperands,
     /* 181127 */     // GIR_Coverage, 3848,
     /* 181127 */     GIR_EraseRootFromParent_Done,
     /* 181128 */   // Label 3527: @181128
     /* 181128 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181176), // Rule ID 3849 //
     /* 181133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181162 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 181162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181174 */     GIR_RootConstrainSelectedInstOperands,
     /* 181175 */     // GIR_Coverage, 3849,
     /* 181175 */     GIR_EraseRootFromParent_Done,
     /* 181176 */   // Label 3528: @181176
     /* 181176 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181224), // Rule ID 3850 //
     /* 181181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181210 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 181210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181222 */     GIR_RootConstrainSelectedInstOperands,
     /* 181223 */     // GIR_Coverage, 3850,
     /* 181223 */     GIR_EraseRootFromParent_Done,
     /* 181224 */   // Label 3529: @181224
     /* 181224 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181272), // Rule ID 3851 //
     /* 181229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181258 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 181258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181270 */     GIR_RootConstrainSelectedInstOperands,
     /* 181271 */     // GIR_Coverage, 3851,
     /* 181271 */     GIR_EraseRootFromParent_Done,
     /* 181272 */   // Label 3530: @181272
     /* 181272 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181320), // Rule ID 3852 //
     /* 181277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181306 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 181306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181318 */     GIR_RootConstrainSelectedInstOperands,
     /* 181319 */     // GIR_Coverage, 3852,
     /* 181319 */     GIR_EraseRootFromParent_Done,
     /* 181320 */   // Label 3531: @181320
     /* 181320 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181368), // Rule ID 3853 //
     /* 181325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181354 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 181354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181366 */     GIR_RootConstrainSelectedInstOperands,
     /* 181367 */     // GIR_Coverage, 3853,
     /* 181367 */     GIR_EraseRootFromParent_Done,
     /* 181368 */   // Label 3532: @181368
     /* 181368 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181416), // Rule ID 3854 //
     /* 181373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181402 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 181402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181414 */     GIR_RootConstrainSelectedInstOperands,
     /* 181415 */     // GIR_Coverage, 3854,
     /* 181415 */     GIR_EraseRootFromParent_Done,
     /* 181416 */   // Label 3533: @181416
     /* 181416 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181464), // Rule ID 3855 //
     /* 181421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181450 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 181450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181462 */     GIR_RootConstrainSelectedInstOperands,
     /* 181463 */     // GIR_Coverage, 3855,
     /* 181463 */     GIR_EraseRootFromParent_Done,
     /* 181464 */   // Label 3534: @181464
     /* 181464 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181512), // Rule ID 3856 //
     /* 181469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181498 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 181498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181510 */     GIR_RootConstrainSelectedInstOperands,
     /* 181511 */     // GIR_Coverage, 3856,
     /* 181511 */     GIR_EraseRootFromParent_Done,
     /* 181512 */   // Label 3535: @181512
     /* 181512 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181554), // Rule ID 3921 //
     /* 181517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181543 */     // (intrinsic_wo_chain:{ *:[i32] } 2161:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 181546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181552 */     GIR_RootConstrainSelectedInstOperands,
     /* 181553 */     // GIR_Coverage, 3921,
     /* 181553 */     GIR_EraseRootFromParent_Done,
     /* 181554 */   // Label 3536: @181554
     /* 181554 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181596), // Rule ID 3922 //
     /* 181559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181585 */     // (intrinsic_wo_chain:{ *:[i64] } 2161:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 181588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181594 */     GIR_RootConstrainSelectedInstOperands,
     /* 181595 */     // GIR_Coverage, 3922,
     /* 181595 */     GIR_EraseRootFromParent_Done,
     /* 181596 */   // Label 3537: @181596
     /* 181596 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181638), // Rule ID 3923 //
     /* 181601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181627 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 181630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181636 */     GIR_RootConstrainSelectedInstOperands,
     /* 181637 */     // GIR_Coverage, 3923,
     /* 181637 */     GIR_EraseRootFromParent_Done,
     /* 181638 */   // Label 3538: @181638
     /* 181638 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181680), // Rule ID 3924 //
     /* 181643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181669 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 181672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181678 */     GIR_RootConstrainSelectedInstOperands,
     /* 181679 */     // GIR_Coverage, 3924,
     /* 181679 */     GIR_EraseRootFromParent_Done,
     /* 181680 */   // Label 3539: @181680
     /* 181680 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181722), // Rule ID 5194 //
     /* 181685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 181690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181711 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 181714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181720 */     GIR_RootConstrainSelectedInstOperands,
     /* 181721 */     // GIR_Coverage, 5194,
     /* 181721 */     GIR_EraseRootFromParent_Done,
     /* 181722 */   // Label 3540: @181722
     /* 181722 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181767), // Rule ID 5198 //
     /* 181727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 181735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181756 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 181759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181765 */     GIR_RootConstrainSelectedInstOperands,
     /* 181766 */     // GIR_Coverage, 5198,
     /* 181766 */     GIR_EraseRootFromParent_Done,
     /* 181767 */   // Label 3541: @181767
     /* 181767 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181812), // Rule ID 5202 //
     /* 181772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 181780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181801 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 181804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181810 */     GIR_RootConstrainSelectedInstOperands,
     /* 181811 */     // GIR_Coverage, 5202,
     /* 181811 */     GIR_EraseRootFromParent_Done,
     /* 181812 */   // Label 3542: @181812
     /* 181812 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(181857), // Rule ID 5203 //
     /* 181817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 181825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181846 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 181849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181855 */     GIR_RootConstrainSelectedInstOperands,
     /* 181856 */     // GIR_Coverage, 5203,
     /* 181856 */     GIR_EraseRootFromParent_Done,
     /* 181857 */   // Label 3543: @181857
     /* 181857 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(181902), // Rule ID 5204 //
     /* 181862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 181870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181891 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 181894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181900 */     GIR_RootConstrainSelectedInstOperands,
     /* 181901 */     // GIR_Coverage, 5204,
     /* 181901 */     GIR_EraseRootFromParent_Done,
     /* 181902 */   // Label 3544: @181902
     /* 181902 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(181947), // Rule ID 5205 //
     /* 181907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181936 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 181939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181945 */     GIR_RootConstrainSelectedInstOperands,
     /* 181946 */     // GIR_Coverage, 5205,
     /* 181946 */     GIR_EraseRootFromParent_Done,
     /* 181947 */   // Label 3545: @181947
     /* 181947 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(181992), // Rule ID 5206 //
     /* 181952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181981 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 181984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181990 */     GIR_RootConstrainSelectedInstOperands,
     /* 181991 */     // GIR_Coverage, 5206,
     /* 181991 */     GIR_EraseRootFromParent_Done,
     /* 181992 */   // Label 3546: @181992
     /* 181992 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182037), // Rule ID 5207 //
     /* 181997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182026 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 182029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182035 */     GIR_RootConstrainSelectedInstOperands,
     /* 182036 */     // GIR_Coverage, 5207,
     /* 182036 */     GIR_EraseRootFromParent_Done,
     /* 182037 */   // Label 3547: @182037
     /* 182037 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182082), // Rule ID 5208 //
     /* 182042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182071 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 182074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182080 */     GIR_RootConstrainSelectedInstOperands,
     /* 182081 */     // GIR_Coverage, 5208,
     /* 182081 */     GIR_EraseRootFromParent_Done,
     /* 182082 */   // Label 3548: @182082
     /* 182082 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182127), // Rule ID 5209 //
     /* 182087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182116 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 182119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182125 */     GIR_RootConstrainSelectedInstOperands,
     /* 182126 */     // GIR_Coverage, 5209,
     /* 182126 */     GIR_EraseRootFromParent_Done,
     /* 182127 */   // Label 3549: @182127
     /* 182127 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182172), // Rule ID 5210 //
     /* 182132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182161 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 182164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182170 */     GIR_RootConstrainSelectedInstOperands,
     /* 182171 */     // GIR_Coverage, 5210,
     /* 182171 */     GIR_EraseRootFromParent_Done,
     /* 182172 */   // Label 3550: @182172
     /* 182172 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182217), // Rule ID 5211 //
     /* 182177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182206 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 182209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182215 */     GIR_RootConstrainSelectedInstOperands,
     /* 182216 */     // GIR_Coverage, 5211,
     /* 182216 */     GIR_EraseRootFromParent_Done,
     /* 182217 */   // Label 3551: @182217
     /* 182217 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182262), // Rule ID 5212 //
     /* 182222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182251 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 182254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182260 */     GIR_RootConstrainSelectedInstOperands,
     /* 182261 */     // GIR_Coverage, 5212,
     /* 182261 */     GIR_EraseRootFromParent_Done,
     /* 182262 */   // Label 3552: @182262
     /* 182262 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182307), // Rule ID 5213 //
     /* 182267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182296 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 182299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182305 */     GIR_RootConstrainSelectedInstOperands,
     /* 182306 */     // GIR_Coverage, 5213,
     /* 182306 */     GIR_EraseRootFromParent_Done,
     /* 182307 */   // Label 3553: @182307
     /* 182307 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182352), // Rule ID 5214 //
     /* 182312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182341 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 182344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182350 */     GIR_RootConstrainSelectedInstOperands,
     /* 182351 */     // GIR_Coverage, 5214,
     /* 182351 */     GIR_EraseRootFromParent_Done,
     /* 182352 */   // Label 3554: @182352
     /* 182352 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182397), // Rule ID 5215 //
     /* 182357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182386 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 182389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182395 */     GIR_RootConstrainSelectedInstOperands,
     /* 182396 */     // GIR_Coverage, 5215,
     /* 182396 */     GIR_EraseRootFromParent_Done,
     /* 182397 */   // Label 3555: @182397
     /* 182397 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182442), // Rule ID 5216 //
     /* 182402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182431 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 182434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182440 */     GIR_RootConstrainSelectedInstOperands,
     /* 182441 */     // GIR_Coverage, 5216,
     /* 182441 */     GIR_EraseRootFromParent_Done,
     /* 182442 */   // Label 3556: @182442
     /* 182442 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182487), // Rule ID 5217 //
     /* 182447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182476 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 182479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182485 */     GIR_RootConstrainSelectedInstOperands,
     /* 182486 */     // GIR_Coverage, 5217,
     /* 182486 */     GIR_EraseRootFromParent_Done,
     /* 182487 */   // Label 3557: @182487
     /* 182487 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182532), // Rule ID 5218 //
     /* 182492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182521 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 182524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182530 */     GIR_RootConstrainSelectedInstOperands,
     /* 182531 */     // GIR_Coverage, 5218,
     /* 182531 */     GIR_EraseRootFromParent_Done,
     /* 182532 */   // Label 3558: @182532
     /* 182532 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182577), // Rule ID 5237 //
     /* 182537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 182545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182566 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 182566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 182569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182575 */     GIR_RootConstrainSelectedInstOperands,
     /* 182576 */     // GIR_Coverage, 5237,
     /* 182576 */     GIR_EraseRootFromParent_Done,
     /* 182577 */   // Label 3559: @182577
     /* 182577 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182619), // Rule ID 5571 //
     /* 182582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 182590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 182596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182608 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 182608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 182611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 182617 */     GIR_RootConstrainSelectedInstOperands,
     /* 182618 */     // GIR_Coverage, 5571,
     /* 182618 */     GIR_EraseRootFromParent_Done,
     /* 182619 */   // Label 3560: @182619
     /* 182619 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182661), // Rule ID 5572 //
     /* 182624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 182632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 182638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182650 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 182650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 182653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 182657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182659 */     GIR_RootConstrainSelectedInstOperands,
     /* 182660 */     // GIR_Coverage, 5572,
     /* 182660 */     GIR_EraseRootFromParent_Done,
     /* 182661 */   // Label 3561: @182661
     /* 182661 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182758), // Rule ID 6259 //
     /* 182666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 182671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182692 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 182699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182708 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182757 */     // GIR_Coverage, 6259,
     /* 182757 */     GIR_EraseRootFromParent_Done,
     /* 182758 */   // Label 3562: @182758
     /* 182758 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182855), // Rule ID 6260 //
     /* 182763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182789 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 182796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182854 */     // GIR_Coverage, 6260,
     /* 182854 */     GIR_EraseRootFromParent_Done,
     /* 182855 */   // Label 3563: @182855
     /* 182855 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182897), // Rule ID 6905 //
     /* 182860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 182865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182886 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 182889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182895 */     GIR_RootConstrainSelectedInstOperands,
     /* 182896 */     // GIR_Coverage, 6905,
     /* 182896 */     GIR_EraseRootFromParent_Done,
     /* 182897 */   // Label 3564: @182897
     /* 182897 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182939), // Rule ID 6906 //
     /* 182902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 182907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182928 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 182931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182937 */     GIR_RootConstrainSelectedInstOperands,
     /* 182938 */     // GIR_Coverage, 6906,
     /* 182938 */     GIR_EraseRootFromParent_Done,
     /* 182939 */   // Label 3565: @182939
     /* 182939 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(182981), // Rule ID 6907 //
     /* 182944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 182949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182970 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 182973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182979 */     GIR_RootConstrainSelectedInstOperands,
     /* 182980 */     // GIR_Coverage, 6907,
     /* 182980 */     GIR_EraseRootFromParent_Done,
     /* 182981 */   // Label 3566: @182981
     /* 182981 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183023), // Rule ID 6908 //
     /* 182986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 182991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183012 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 183015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183021 */     GIR_RootConstrainSelectedInstOperands,
     /* 183022 */     // GIR_Coverage, 6908,
     /* 183022 */     GIR_EraseRootFromParent_Done,
     /* 183023 */   // Label 3567: @183023
     /* 183023 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183071), // Rule ID 6948 //
     /* 183028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183054 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 183054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 183057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 183066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 183069 */     GIR_RootConstrainSelectedInstOperands,
     /* 183070 */     // GIR_Coverage, 6948,
     /* 183070 */     GIR_EraseRootFromParent_Done,
     /* 183071 */   // Label 3568: @183071
     /* 183071 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183116), // Rule ID 9970 //
     /* 183076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183105 */     // (intrinsic_wo_chain:{ *:[i64] } 2018:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 183108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183114 */     GIR_RootConstrainSelectedInstOperands,
     /* 183115 */     // GIR_Coverage, 9970,
     /* 183115 */     GIR_EraseRootFromParent_Done,
     /* 183116 */   // Label 3569: @183116
     /* 183116 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183161), // Rule ID 9971 //
     /* 183121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183150 */     // (intrinsic_wo_chain:{ *:[i64] } 2018:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 183153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183159 */     GIR_RootConstrainSelectedInstOperands,
     /* 183160 */     // GIR_Coverage, 9971,
     /* 183160 */     GIR_EraseRootFromParent_Done,
     /* 183161 */   // Label 3570: @183161
     /* 183161 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183206), // Rule ID 9972 //
     /* 183166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183195 */     // (intrinsic_wo_chain:{ *:[i64] } 2018:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 183198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183204 */     GIR_RootConstrainSelectedInstOperands,
     /* 183205 */     // GIR_Coverage, 9972,
     /* 183205 */     GIR_EraseRootFromParent_Done,
     /* 183206 */   // Label 3571: @183206
     /* 183206 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183251), // Rule ID 9973 //
     /* 183211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183240 */     // (intrinsic_wo_chain:{ *:[i64] } 2018:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 183243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183249 */     GIR_RootConstrainSelectedInstOperands,
     /* 183250 */     // GIR_Coverage, 9973,
     /* 183250 */     GIR_EraseRootFromParent_Done,
     /* 183251 */   // Label 3572: @183251
     /* 183251 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183296), // Rule ID 9982 //
     /* 183256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183285 */     // (intrinsic_wo_chain:{ *:[i64] } 1773:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 183288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183294 */     GIR_RootConstrainSelectedInstOperands,
     /* 183295 */     // GIR_Coverage, 9982,
     /* 183295 */     GIR_EraseRootFromParent_Done,
     /* 183296 */   // Label 3573: @183296
     /* 183296 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183341), // Rule ID 9983 //
     /* 183301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183330 */     // (intrinsic_wo_chain:{ *:[i64] } 1773:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 183333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183339 */     GIR_RootConstrainSelectedInstOperands,
     /* 183340 */     // GIR_Coverage, 9983,
     /* 183340 */     GIR_EraseRootFromParent_Done,
     /* 183341 */   // Label 3574: @183341
     /* 183341 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183386), // Rule ID 9984 //
     /* 183346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183375 */     // (intrinsic_wo_chain:{ *:[i64] } 1773:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 183378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183384 */     GIR_RootConstrainSelectedInstOperands,
     /* 183385 */     // GIR_Coverage, 9984,
     /* 183385 */     GIR_EraseRootFromParent_Done,
     /* 183386 */   // Label 3575: @183386
     /* 183386 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183431), // Rule ID 9985 //
     /* 183391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183420 */     // (intrinsic_wo_chain:{ *:[i64] } 1773:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 183423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183429 */     GIR_RootConstrainSelectedInstOperands,
     /* 183430 */     // GIR_Coverage, 9985,
     /* 183430 */     GIR_EraseRootFromParent_Done,
     /* 183431 */   // Label 3576: @183431
     /* 183431 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183476), // Rule ID 9986 //
     /* 183436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183465 */     // (intrinsic_wo_chain:{ *:[i32] } 2003:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 183468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183474 */     GIR_RootConstrainSelectedInstOperands,
     /* 183475 */     // GIR_Coverage, 9986,
     /* 183475 */     GIR_EraseRootFromParent_Done,
     /* 183476 */   // Label 3577: @183476
     /* 183476 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183521), // Rule ID 9987 //
     /* 183481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183510 */     // (intrinsic_wo_chain:{ *:[i32] } 2003:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 183513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183519 */     GIR_RootConstrainSelectedInstOperands,
     /* 183520 */     // GIR_Coverage, 9987,
     /* 183520 */     GIR_EraseRootFromParent_Done,
     /* 183521 */   // Label 3578: @183521
     /* 183521 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183566), // Rule ID 9988 //
     /* 183526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183555 */     // (intrinsic_wo_chain:{ *:[i32] } 2003:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 183558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183564 */     GIR_RootConstrainSelectedInstOperands,
     /* 183565 */     // GIR_Coverage, 9988,
     /* 183565 */     GIR_EraseRootFromParent_Done,
     /* 183566 */   // Label 3579: @183566
     /* 183566 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183611), // Rule ID 9989 //
     /* 183571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183600 */     // (intrinsic_wo_chain:{ *:[i32] } 2003:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 183603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183609 */     GIR_RootConstrainSelectedInstOperands,
     /* 183610 */     // GIR_Coverage, 9989,
     /* 183610 */     GIR_EraseRootFromParent_Done,
     /* 183611 */   // Label 3580: @183611
     /* 183611 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183656), // Rule ID 9990 //
     /* 183616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183645 */     // (intrinsic_wo_chain:{ *:[i64] } 2004:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 183648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183654 */     GIR_RootConstrainSelectedInstOperands,
     /* 183655 */     // GIR_Coverage, 9990,
     /* 183655 */     GIR_EraseRootFromParent_Done,
     /* 183656 */   // Label 3581: @183656
     /* 183656 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183701), // Rule ID 9991 //
     /* 183661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183690 */     // (intrinsic_wo_chain:{ *:[i64] } 2004:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 183693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183699 */     GIR_RootConstrainSelectedInstOperands,
     /* 183700 */     // GIR_Coverage, 9991,
     /* 183700 */     GIR_EraseRootFromParent_Done,
     /* 183701 */   // Label 3582: @183701
     /* 183701 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183746), // Rule ID 9992 //
     /* 183706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183735 */     // (intrinsic_wo_chain:{ *:[i64] } 2004:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 183738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183744 */     GIR_RootConstrainSelectedInstOperands,
     /* 183745 */     // GIR_Coverage, 9992,
     /* 183745 */     GIR_EraseRootFromParent_Done,
     /* 183746 */   // Label 3583: @183746
     /* 183746 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183791), // Rule ID 9993 //
     /* 183751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183780 */     // (intrinsic_wo_chain:{ *:[i64] } 2004:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 183783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183789 */     GIR_RootConstrainSelectedInstOperands,
     /* 183790 */     // GIR_Coverage, 9993,
     /* 183790 */     GIR_EraseRootFromParent_Done,
     /* 183791 */   // Label 3584: @183791
     /* 183791 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183837), // Rule ID 138 //
     /* 183796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 183804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183814 */     // MIs[0] Rn
     /* 183814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183826 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 183829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183835 */     GIR_RootConstrainSelectedInstOperands,
     /* 183836 */     // GIR_Coverage, 138,
     /* 183836 */     GIR_EraseRootFromParent_Done,
     /* 183837 */   // Label 3585: @183837
     /* 183837 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183884), // Rule ID 139 //
     /* 183842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 183850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183857 */     // MIs[0] Rn
     /* 183857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183865 */     // MIs[0] Rm
     /* 183865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 183869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183873 */     // (intrinsic_wo_chain:{ *:[i64] } 1234:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 183873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 183876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183882 */     GIR_RootConstrainSelectedInstOperands,
     /* 183883 */     // GIR_Coverage, 139,
     /* 183883 */     GIR_EraseRootFromParent_Done,
     /* 183884 */   // Label 3586: @183884
     /* 183884 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(183921), // Rule ID 2399 //
     /* 183889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 183897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2143:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 183913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183919 */     GIR_RootConstrainSelectedInstOperands,
     /* 183920 */     // GIR_Coverage, 2399,
     /* 183920 */     GIR_EraseRootFromParent_Done,
     /* 183921 */   // Label 3587: @183921
     /* 183921 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(183958), // Rule ID 2400 //
     /* 183926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 183934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 183950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183956 */     GIR_RootConstrainSelectedInstOperands,
     /* 183957 */     // GIR_Coverage, 2400,
     /* 183957 */     GIR_EraseRootFromParent_Done,
     /* 183958 */   // Label 3588: @183958
     /* 183958 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(183995), // Rule ID 2401 //
     /* 183963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 183971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2145:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 183987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183993 */     GIR_RootConstrainSelectedInstOperands,
     /* 183994 */     // GIR_Coverage, 2401,
     /* 183994 */     GIR_EraseRootFromParent_Done,
     /* 183995 */   // Label 3589: @183995
     /* 183995 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184032), // Rule ID 2403 //
     /* 184000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 184008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184021 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2148:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 184024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184030 */     GIR_RootConstrainSelectedInstOperands,
     /* 184031 */     // GIR_Coverage, 2403,
     /* 184031 */     GIR_EraseRootFromParent_Done,
     /* 184032 */   // Label 3590: @184032
     /* 184032 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184069), // Rule ID 2404 //
     /* 184037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 184045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2149:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 184061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184067 */     GIR_RootConstrainSelectedInstOperands,
     /* 184068 */     // GIR_Coverage, 2404,
     /* 184068 */     GIR_EraseRootFromParent_Done,
     /* 184069 */   // Label 3591: @184069
     /* 184069 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184106), // Rule ID 2405 //
     /* 184074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 184082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2150:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 184098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184104 */     GIR_RootConstrainSelectedInstOperands,
     /* 184105 */     // GIR_Coverage, 2405,
     /* 184105 */     GIR_EraseRootFromParent_Done,
     /* 184106 */   // Label 3592: @184106
     /* 184106 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184143), // Rule ID 2407 //
     /* 184111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 184119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2069:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 184135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184141 */     GIR_RootConstrainSelectedInstOperands,
     /* 184142 */     // GIR_Coverage, 2407,
     /* 184142 */     GIR_EraseRootFromParent_Done,
     /* 184143 */   // Label 3593: @184143
     /* 184143 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184180), // Rule ID 2408 //
     /* 184148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 184156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184169 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2070:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 184172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184178 */     GIR_RootConstrainSelectedInstOperands,
     /* 184179 */     // GIR_Coverage, 2408,
     /* 184179 */     GIR_EraseRootFromParent_Done,
     /* 184180 */   // Label 3594: @184180
     /* 184180 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184217), // Rule ID 2409 //
     /* 184185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 184193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184206 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2071:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 184209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184215 */     GIR_RootConstrainSelectedInstOperands,
     /* 184216 */     // GIR_Coverage, 2409,
     /* 184216 */     GIR_EraseRootFromParent_Done,
     /* 184217 */   // Label 3595: @184217
     /* 184217 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184254), // Rule ID 2411 //
     /* 184222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 184230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184243 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2074:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 184246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184252 */     GIR_RootConstrainSelectedInstOperands,
     /* 184253 */     // GIR_Coverage, 2411,
     /* 184253 */     GIR_EraseRootFromParent_Done,
     /* 184254 */   // Label 3596: @184254
     /* 184254 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184291), // Rule ID 2412 //
     /* 184259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 184267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184280 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2075:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 184283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184289 */     GIR_RootConstrainSelectedInstOperands,
     /* 184290 */     // GIR_Coverage, 2412,
     /* 184290 */     GIR_EraseRootFromParent_Done,
     /* 184291 */   // Label 3597: @184291
     /* 184291 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184328), // Rule ID 2413 //
     /* 184296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 184304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184317 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 184320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184326 */     GIR_RootConstrainSelectedInstOperands,
     /* 184327 */     // GIR_Coverage, 2413,
     /* 184327 */     GIR_EraseRootFromParent_Done,
     /* 184328 */   // Label 3598: @184328
     /* 184328 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184365), // Rule ID 2415 //
     /* 184333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 184341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184354 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1913:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 184357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184363 */     GIR_RootConstrainSelectedInstOperands,
     /* 184364 */     // GIR_Coverage, 2415,
     /* 184364 */     GIR_EraseRootFromParent_Done,
     /* 184365 */   // Label 3599: @184365
     /* 184365 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184402), // Rule ID 2416 //
     /* 184370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 184378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1914:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 184394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184400 */     GIR_RootConstrainSelectedInstOperands,
     /* 184401 */     // GIR_Coverage, 2416,
     /* 184401 */     GIR_EraseRootFromParent_Done,
     /* 184402 */   // Label 3600: @184402
     /* 184402 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184439), // Rule ID 2417 //
     /* 184407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 184415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1915:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 184431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184437 */     GIR_RootConstrainSelectedInstOperands,
     /* 184438 */     // GIR_Coverage, 2417,
     /* 184438 */     GIR_EraseRootFromParent_Done,
     /* 184439 */   // Label 3601: @184439
     /* 184439 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184476), // Rule ID 2419 //
     /* 184444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 184452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1918:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 184468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184474 */     GIR_RootConstrainSelectedInstOperands,
     /* 184475 */     // GIR_Coverage, 2419,
     /* 184475 */     GIR_EraseRootFromParent_Done,
     /* 184476 */   // Label 3602: @184476
     /* 184476 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184513), // Rule ID 2420 //
     /* 184481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 184489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1919:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 184505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184511 */     GIR_RootConstrainSelectedInstOperands,
     /* 184512 */     // GIR_Coverage, 2420,
     /* 184512 */     GIR_EraseRootFromParent_Done,
     /* 184513 */   // Label 3603: @184513
     /* 184513 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184550), // Rule ID 2421 //
     /* 184518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 184526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1920:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 184542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184548 */     GIR_RootConstrainSelectedInstOperands,
     /* 184549 */     // GIR_Coverage, 2421,
     /* 184549 */     GIR_EraseRootFromParent_Done,
     /* 184550 */   // Label 3604: @184550
     /* 184550 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184587), // Rule ID 2422 //
     /* 184555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 184558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 184563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 184576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 184579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 184583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 184585 */     GIR_RootConstrainSelectedInstOperands,
     /* 184586 */     // GIR_Coverage, 2422,
     /* 184586 */     GIR_EraseRootFromParent_Done,
     /* 184587 */   // Label 3605: @184587
     /* 184587 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184627), // Rule ID 2621 //
     /* 184592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 184600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 184616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184625 */     GIR_RootConstrainSelectedInstOperands,
     /* 184626 */     // GIR_Coverage, 2621,
     /* 184626 */     GIR_EraseRootFromParent_Done,
     /* 184627 */   // Label 3606: @184627
     /* 184627 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184667), // Rule ID 2622 //
     /* 184632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184653 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 184656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184665 */     GIR_RootConstrainSelectedInstOperands,
     /* 184666 */     // GIR_Coverage, 2622,
     /* 184666 */     GIR_EraseRootFromParent_Done,
     /* 184667 */   // Label 3607: @184667
     /* 184667 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184707), // Rule ID 2623 //
     /* 184672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184693 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 184696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184705 */     GIR_RootConstrainSelectedInstOperands,
     /* 184706 */     // GIR_Coverage, 2623,
     /* 184706 */     GIR_EraseRootFromParent_Done,
     /* 184707 */   // Label 3608: @184707
     /* 184707 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184747), // Rule ID 2624 //
     /* 184712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184733 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 184736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184745 */     GIR_RootConstrainSelectedInstOperands,
     /* 184746 */     // GIR_Coverage, 2624,
     /* 184746 */     GIR_EraseRootFromParent_Done,
     /* 184747 */   // Label 3609: @184747
     /* 184747 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184787), // Rule ID 2625 //
     /* 184752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 184776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184785 */     GIR_RootConstrainSelectedInstOperands,
     /* 184786 */     // GIR_Coverage, 2625,
     /* 184786 */     GIR_EraseRootFromParent_Done,
     /* 184787 */   // Label 3610: @184787
     /* 184787 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(184824), // Rule ID 2642 //
     /* 184792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184813 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 184816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184822 */     GIR_RootConstrainSelectedInstOperands,
     /* 184823 */     // GIR_Coverage, 2642,
     /* 184823 */     GIR_EraseRootFromParent_Done,
     /* 184824 */   // Label 3611: @184824
     /* 184824 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(184861), // Rule ID 2643 //
     /* 184829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 184853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184859 */     GIR_RootConstrainSelectedInstOperands,
     /* 184860 */     // GIR_Coverage, 2643,
     /* 184860 */     GIR_EraseRootFromParent_Done,
     /* 184861 */   // Label 3612: @184861
     /* 184861 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(184898), // Rule ID 2644 //
     /* 184866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 184890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184896 */     GIR_RootConstrainSelectedInstOperands,
     /* 184897 */     // GIR_Coverage, 2644,
     /* 184897 */     GIR_EraseRootFromParent_Done,
     /* 184898 */   // Label 3613: @184898
     /* 184898 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(184935), // Rule ID 2645 //
     /* 184903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184924 */     // (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 184927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184933 */     GIR_RootConstrainSelectedInstOperands,
     /* 184934 */     // GIR_Coverage, 2645,
     /* 184934 */     GIR_EraseRootFromParent_Done,
     /* 184935 */   // Label 3614: @184935
     /* 184935 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(184972), // Rule ID 2646 //
     /* 184940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184961 */     // (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 184964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184970 */     GIR_RootConstrainSelectedInstOperands,
     /* 184971 */     // GIR_Coverage, 2646,
     /* 184971 */     GIR_EraseRootFromParent_Done,
     /* 184972 */   // Label 3615: @184972
     /* 184972 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185009), // Rule ID 2647 //
     /* 184977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184998 */     // (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 185001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185007 */     GIR_RootConstrainSelectedInstOperands,
     /* 185008 */     // GIR_Coverage, 2647,
     /* 185008 */     GIR_EraseRootFromParent_Done,
     /* 185009 */   // Label 3616: @185009
     /* 185009 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185046), // Rule ID 2648 //
     /* 185014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185035 */     // (intrinsic_wo_chain:{ *:[i64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 185038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185044 */     GIR_RootConstrainSelectedInstOperands,
     /* 185045 */     // GIR_Coverage, 2648,
     /* 185045 */     GIR_EraseRootFromParent_Done,
     /* 185046 */   // Label 3617: @185046
     /* 185046 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185083), // Rule ID 2826 //
     /* 185051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185072 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1535:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 185075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185081 */     GIR_RootConstrainSelectedInstOperands,
     /* 185082 */     // GIR_Coverage, 2826,
     /* 185082 */     GIR_EraseRootFromParent_Done,
     /* 185083 */   // Label 3618: @185083
     /* 185083 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185120), // Rule ID 2827 //
     /* 185088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185109 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1535:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 185112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185118 */     GIR_RootConstrainSelectedInstOperands,
     /* 185119 */     // GIR_Coverage, 2827,
     /* 185119 */     GIR_EraseRootFromParent_Done,
     /* 185120 */   // Label 3619: @185120
     /* 185120 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185157), // Rule ID 2828 //
     /* 185125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185146 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1535:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 185149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185155 */     GIR_RootConstrainSelectedInstOperands,
     /* 185156 */     // GIR_Coverage, 2828,
     /* 185156 */     GIR_EraseRootFromParent_Done,
     /* 185157 */   // Label 3620: @185157
     /* 185157 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185194), // Rule ID 2999 //
     /* 185162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185183 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1787:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 185186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185192 */     GIR_RootConstrainSelectedInstOperands,
     /* 185193 */     // GIR_Coverage, 2999,
     /* 185193 */     GIR_EraseRootFromParent_Done,
     /* 185194 */   // Label 3621: @185194
     /* 185194 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185231), // Rule ID 3000 //
     /* 185199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 185223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185229 */     GIR_RootConstrainSelectedInstOperands,
     /* 185230 */     // GIR_Coverage, 3000,
     /* 185230 */     GIR_EraseRootFromParent_Done,
     /* 185231 */   // Label 3622: @185231
     /* 185231 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185268), // Rule ID 3001 //
     /* 185236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 185260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185266 */     GIR_RootConstrainSelectedInstOperands,
     /* 185267 */     // GIR_Coverage, 3001,
     /* 185267 */     GIR_EraseRootFromParent_Done,
     /* 185268 */   // Label 3623: @185268
     /* 185268 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185305), // Rule ID 3002 //
     /* 185273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 185297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185303 */     GIR_RootConstrainSelectedInstOperands,
     /* 185304 */     // GIR_Coverage, 3002,
     /* 185304 */     GIR_EraseRootFromParent_Done,
     /* 185305 */   // Label 3624: @185305
     /* 185305 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185342), // Rule ID 3003 //
     /* 185310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 185318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1622:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 185334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185340 */     GIR_RootConstrainSelectedInstOperands,
     /* 185341 */     // GIR_Coverage, 3003,
     /* 185341 */     GIR_EraseRootFromParent_Done,
     /* 185342 */   // Label 3625: @185342
     /* 185342 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185379), // Rule ID 3025 //
     /* 185347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 185371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185377 */     GIR_RootConstrainSelectedInstOperands,
     /* 185378 */     // GIR_Coverage, 3025,
     /* 185378 */     GIR_EraseRootFromParent_Done,
     /* 185379 */   // Label 3626: @185379
     /* 185379 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185416), // Rule ID 3026 //
     /* 185384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 185408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185414 */     GIR_RootConstrainSelectedInstOperands,
     /* 185415 */     // GIR_Coverage, 3026,
     /* 185415 */     GIR_EraseRootFromParent_Done,
     /* 185416 */   // Label 3627: @185416
     /* 185416 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185453), // Rule ID 3027 //
     /* 185421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 185445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185451 */     GIR_RootConstrainSelectedInstOperands,
     /* 185452 */     // GIR_Coverage, 3027,
     /* 185452 */     GIR_EraseRootFromParent_Done,
     /* 185453 */   // Label 3628: @185453
     /* 185453 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185490), // Rule ID 3031 //
     /* 185458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 185461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 185482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185488 */     GIR_RootConstrainSelectedInstOperands,
     /* 185489 */     // GIR_Coverage, 3031,
     /* 185489 */     GIR_EraseRootFromParent_Done,
     /* 185490 */   // Label 3629: @185490
     /* 185490 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185527), // Rule ID 3032 //
     /* 185495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 185519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185525 */     GIR_RootConstrainSelectedInstOperands,
     /* 185526 */     // GIR_Coverage, 3032,
     /* 185526 */     GIR_EraseRootFromParent_Done,
     /* 185527 */   // Label 3630: @185527
     /* 185527 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185564), // Rule ID 3033 //
     /* 185532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 185556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185562 */     GIR_RootConstrainSelectedInstOperands,
     /* 185563 */     // GIR_Coverage, 3033,
     /* 185563 */     GIR_EraseRootFromParent_Done,
     /* 185564 */   // Label 3631: @185564
     /* 185564 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185601), // Rule ID 3034 //
     /* 185569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1265:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 185593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185599 */     GIR_RootConstrainSelectedInstOperands,
     /* 185600 */     // GIR_Coverage, 3034,
     /* 185600 */     GIR_EraseRootFromParent_Done,
     /* 185601 */   // Label 3632: @185601
     /* 185601 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185638), // Rule ID 3035 //
     /* 185606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1265:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 185630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185636 */     GIR_RootConstrainSelectedInstOperands,
     /* 185637 */     // GIR_Coverage, 3035,
     /* 185637 */     GIR_EraseRootFromParent_Done,
     /* 185638 */   // Label 3633: @185638
     /* 185638 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185675), // Rule ID 3036 //
     /* 185643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1265:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 185667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185673 */     GIR_RootConstrainSelectedInstOperands,
     /* 185674 */     // GIR_Coverage, 3036,
     /* 185674 */     GIR_EraseRootFromParent_Done,
     /* 185675 */   // Label 3634: @185675
     /* 185675 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185712), // Rule ID 3037 //
     /* 185680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1265:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 185704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185710 */     GIR_RootConstrainSelectedInstOperands,
     /* 185711 */     // GIR_Coverage, 3037,
     /* 185711 */     GIR_EraseRootFromParent_Done,
     /* 185712 */   // Label 3635: @185712
     /* 185712 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185749), // Rule ID 3038 //
     /* 185717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 185741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185747 */     GIR_RootConstrainSelectedInstOperands,
     /* 185748 */     // GIR_Coverage, 3038,
     /* 185748 */     GIR_EraseRootFromParent_Done,
     /* 185749 */   // Label 3636: @185749
     /* 185749 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185786), // Rule ID 3039 //
     /* 185754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 185778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185784 */     GIR_RootConstrainSelectedInstOperands,
     /* 185785 */     // GIR_Coverage, 3039,
     /* 185785 */     GIR_EraseRootFromParent_Done,
     /* 185786 */   // Label 3637: @185786
     /* 185786 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(185823), // Rule ID 3040 //
     /* 185791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 185815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185821 */     GIR_RootConstrainSelectedInstOperands,
     /* 185822 */     // GIR_Coverage, 3040,
     /* 185822 */     GIR_EraseRootFromParent_Done,
     /* 185823 */   // Label 3638: @185823
     /* 185823 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(185860), // Rule ID 3087 //
     /* 185828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1242:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 185852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185858 */     GIR_RootConstrainSelectedInstOperands,
     /* 185859 */     // GIR_Coverage, 3087,
     /* 185859 */     GIR_EraseRootFromParent_Done,
     /* 185860 */   // Label 3639: @185860
     /* 185860 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(185897), // Rule ID 3088 //
     /* 185865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1242:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 185889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185895 */     GIR_RootConstrainSelectedInstOperands,
     /* 185896 */     // GIR_Coverage, 3088,
     /* 185896 */     GIR_EraseRootFromParent_Done,
     /* 185897 */   // Label 3640: @185897
     /* 185897 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(185934), // Rule ID 3089 //
     /* 185902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1242:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 185926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185932 */     GIR_RootConstrainSelectedInstOperands,
     /* 185933 */     // GIR_Coverage, 3089,
     /* 185933 */     GIR_EraseRootFromParent_Done,
     /* 185934 */   // Label 3641: @185934
     /* 185934 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(185971), // Rule ID 3096 //
     /* 185939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 185963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185969 */     GIR_RootConstrainSelectedInstOperands,
     /* 185970 */     // GIR_Coverage, 3096,
     /* 185970 */     GIR_EraseRootFromParent_Done,
     /* 185971 */   // Label 3642: @185971
     /* 185971 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186008), // Rule ID 3097 //
     /* 185976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 186000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186006 */     GIR_RootConstrainSelectedInstOperands,
     /* 186007 */     // GIR_Coverage, 3097,
     /* 186007 */     GIR_EraseRootFromParent_Done,
     /* 186008 */   // Label 3643: @186008
     /* 186008 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186045), // Rule ID 3098 //
     /* 186013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 186037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186043 */     GIR_RootConstrainSelectedInstOperands,
     /* 186044 */     // GIR_Coverage, 3098,
     /* 186044 */     GIR_EraseRootFromParent_Done,
     /* 186045 */   // Label 3644: @186045
     /* 186045 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186085), // Rule ID 3202 //
     /* 186050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186071 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 186074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186083 */     GIR_RootConstrainSelectedInstOperands,
     /* 186084 */     // GIR_Coverage, 3202,
     /* 186084 */     GIR_EraseRootFromParent_Done,
     /* 186085 */   // Label 3645: @186085
     /* 186085 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186125), // Rule ID 3203 //
     /* 186090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186111 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 186114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186123 */     GIR_RootConstrainSelectedInstOperands,
     /* 186124 */     // GIR_Coverage, 3203,
     /* 186124 */     GIR_EraseRootFromParent_Done,
     /* 186125 */   // Label 3646: @186125
     /* 186125 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186165), // Rule ID 3204 //
     /* 186130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 186154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186163 */     GIR_RootConstrainSelectedInstOperands,
     /* 186164 */     // GIR_Coverage, 3204,
     /* 186164 */     GIR_EraseRootFromParent_Done,
     /* 186165 */   // Label 3647: @186165
     /* 186165 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186205), // Rule ID 3205 //
     /* 186170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 186194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186203 */     GIR_RootConstrainSelectedInstOperands,
     /* 186204 */     // GIR_Coverage, 3205,
     /* 186204 */     GIR_EraseRootFromParent_Done,
     /* 186205 */   // Label 3648: @186205
     /* 186205 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186245), // Rule ID 3210 //
     /* 186210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 186234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186243 */     GIR_RootConstrainSelectedInstOperands,
     /* 186244 */     // GIR_Coverage, 3210,
     /* 186244 */     GIR_EraseRootFromParent_Done,
     /* 186245 */   // Label 3649: @186245
     /* 186245 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186285), // Rule ID 3211 //
     /* 186250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 186274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186283 */     GIR_RootConstrainSelectedInstOperands,
     /* 186284 */     // GIR_Coverage, 3211,
     /* 186284 */     GIR_EraseRootFromParent_Done,
     /* 186285 */   // Label 3650: @186285
     /* 186285 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186325), // Rule ID 3212 //
     /* 186290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186311 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 186314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186323 */     GIR_RootConstrainSelectedInstOperands,
     /* 186324 */     // GIR_Coverage, 3212,
     /* 186324 */     GIR_EraseRootFromParent_Done,
     /* 186325 */   // Label 3651: @186325
     /* 186325 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186365), // Rule ID 3213 //
     /* 186330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 186354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186363 */     GIR_RootConstrainSelectedInstOperands,
     /* 186364 */     // GIR_Coverage, 3213,
     /* 186364 */     GIR_EraseRootFromParent_Done,
     /* 186365 */   // Label 3652: @186365
     /* 186365 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186402), // Rule ID 3402 //
     /* 186370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186400 */     GIR_RootConstrainSelectedInstOperands,
     /* 186401 */     // GIR_Coverage, 3402,
     /* 186401 */     GIR_EraseRootFromParent_Done,
     /* 186402 */   // Label 3653: @186402
     /* 186402 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186439), // Rule ID 3403 //
     /* 186407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186428 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186437 */     GIR_RootConstrainSelectedInstOperands,
     /* 186438 */     // GIR_Coverage, 3403,
     /* 186438 */     GIR_EraseRootFromParent_Done,
     /* 186439 */   // Label 3654: @186439
     /* 186439 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186476), // Rule ID 3404 //
     /* 186444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1333:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186474 */     GIR_RootConstrainSelectedInstOperands,
     /* 186475 */     // GIR_Coverage, 3404,
     /* 186475 */     GIR_EraseRootFromParent_Done,
     /* 186476 */   // Label 3655: @186476
     /* 186476 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186513), // Rule ID 3405 //
     /* 186481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1333:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186511 */     GIR_RootConstrainSelectedInstOperands,
     /* 186512 */     // GIR_Coverage, 3405,
     /* 186512 */     GIR_EraseRootFromParent_Done,
     /* 186513 */   // Label 3656: @186513
     /* 186513 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186550), // Rule ID 3427 //
     /* 186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186539 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1536:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 186542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186548 */     GIR_RootConstrainSelectedInstOperands,
     /* 186549 */     // GIR_Coverage, 3427,
     /* 186549 */     GIR_EraseRootFromParent_Done,
     /* 186550 */   // Label 3657: @186550
     /* 186550 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186587), // Rule ID 3428 //
     /* 186555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1536:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 186579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186585 */     GIR_RootConstrainSelectedInstOperands,
     /* 186586 */     // GIR_Coverage, 3428,
     /* 186586 */     GIR_EraseRootFromParent_Done,
     /* 186587 */   // Label 3658: @186587
     /* 186587 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186624), // Rule ID 3429 //
     /* 186592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186613 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1536:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 186616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186622 */     GIR_RootConstrainSelectedInstOperands,
     /* 186623 */     // GIR_Coverage, 3429,
     /* 186623 */     GIR_EraseRootFromParent_Done,
     /* 186624 */   // Label 3659: @186624
     /* 186624 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186661), // Rule ID 3451 //
     /* 186629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 186637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1286:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 186650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 186653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186659 */     GIR_RootConstrainSelectedInstOperands,
     /* 186660 */     // GIR_Coverage, 3451,
     /* 186660 */     GIR_EraseRootFromParent_Done,
     /* 186661 */   // Label 3660: @186661
     /* 186661 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186698), // Rule ID 3456 //
     /* 186666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 186669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 186674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186687 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1716:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 186690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186696 */     GIR_RootConstrainSelectedInstOperands,
     /* 186697 */     // GIR_Coverage, 3456,
     /* 186697 */     GIR_EraseRootFromParent_Done,
     /* 186698 */   // Label 3661: @186698
     /* 186698 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186735), // Rule ID 3457 //
     /* 186703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 186706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 186711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 186727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 186729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186733 */     GIR_RootConstrainSelectedInstOperands,
     /* 186734 */     // GIR_Coverage, 3457,
     /* 186734 */     GIR_EraseRootFromParent_Done,
     /* 186735 */   // Label 3662: @186735
     /* 186735 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186772), // Rule ID 3466 //
     /* 186740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2146:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186770 */     GIR_RootConstrainSelectedInstOperands,
     /* 186771 */     // GIR_Coverage, 3466,
     /* 186771 */     GIR_EraseRootFromParent_Done,
     /* 186772 */   // Label 3663: @186772
     /* 186772 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(186809), // Rule ID 3467 //
     /* 186777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2146:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186807 */     GIR_RootConstrainSelectedInstOperands,
     /* 186808 */     // GIR_Coverage, 3467,
     /* 186808 */     GIR_EraseRootFromParent_Done,
     /* 186809 */   // Label 3664: @186809
     /* 186809 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(186846), // Rule ID 3468 //
     /* 186814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186835 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2146:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186844 */     GIR_RootConstrainSelectedInstOperands,
     /* 186845 */     // GIR_Coverage, 3468,
     /* 186845 */     GIR_EraseRootFromParent_Done,
     /* 186846 */   // Label 3665: @186846
     /* 186846 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(186883), // Rule ID 3469 //
     /* 186851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2146:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186881 */     GIR_RootConstrainSelectedInstOperands,
     /* 186882 */     // GIR_Coverage, 3469,
     /* 186882 */     GIR_EraseRootFromParent_Done,
     /* 186883 */   // Label 3666: @186883
     /* 186883 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(186920), // Rule ID 3470 //
     /* 186888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186909 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2146:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186918 */     GIR_RootConstrainSelectedInstOperands,
     /* 186919 */     // GIR_Coverage, 3470,
     /* 186919 */     GIR_EraseRootFromParent_Done,
     /* 186920 */   // Label 3667: @186920
     /* 186920 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(186957), // Rule ID 3471 //
     /* 186925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2146:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186955 */     GIR_RootConstrainSelectedInstOperands,
     /* 186956 */     // GIR_Coverage, 3471,
     /* 186956 */     GIR_EraseRootFromParent_Done,
     /* 186957 */   // Label 3668: @186957
     /* 186957 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(186994), // Rule ID 3472 //
     /* 186962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186983 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2146:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186992 */     GIR_RootConstrainSelectedInstOperands,
     /* 186993 */     // GIR_Coverage, 3472,
     /* 186993 */     GIR_EraseRootFromParent_Done,
     /* 186994 */   // Label 3669: @186994
     /* 186994 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187031), // Rule ID 3527 //
     /* 186999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187020 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 187023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187029 */     GIR_RootConstrainSelectedInstOperands,
     /* 187030 */     // GIR_Coverage, 3527,
     /* 187030 */     GIR_EraseRootFromParent_Done,
     /* 187031 */   // Label 3670: @187031
     /* 187031 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187068), // Rule ID 3528 //
     /* 187036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187057 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 187060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187066 */     GIR_RootConstrainSelectedInstOperands,
     /* 187067 */     // GIR_Coverage, 3528,
     /* 187067 */     GIR_EraseRootFromParent_Done,
     /* 187068 */   // Label 3671: @187068
     /* 187068 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187105), // Rule ID 3529 //
     /* 187073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187094 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 187097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187103 */     GIR_RootConstrainSelectedInstOperands,
     /* 187104 */     // GIR_Coverage, 3529,
     /* 187104 */     GIR_EraseRootFromParent_Done,
     /* 187105 */   // Label 3672: @187105
     /* 187105 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187142), // Rule ID 3559 //
     /* 187110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187131 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 187134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187140 */     GIR_RootConstrainSelectedInstOperands,
     /* 187141 */     // GIR_Coverage, 3559,
     /* 187141 */     GIR_EraseRootFromParent_Done,
     /* 187142 */   // Label 3673: @187142
     /* 187142 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187179), // Rule ID 3560 //
     /* 187147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 187171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187177 */     GIR_RootConstrainSelectedInstOperands,
     /* 187178 */     // GIR_Coverage, 3560,
     /* 187178 */     GIR_EraseRootFromParent_Done,
     /* 187179 */   // Label 3674: @187179
     /* 187179 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187216), // Rule ID 3561 //
     /* 187184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187205 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1610:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 187208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187214 */     GIR_RootConstrainSelectedInstOperands,
     /* 187215 */     // GIR_Coverage, 3561,
     /* 187215 */     GIR_EraseRootFromParent_Done,
     /* 187216 */   // Label 3675: @187216
     /* 187216 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187253), // Rule ID 3562 //
     /* 187221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187242 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1610:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 187245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187251 */     GIR_RootConstrainSelectedInstOperands,
     /* 187252 */     // GIR_Coverage, 3562,
     /* 187252 */     GIR_EraseRootFromParent_Done,
     /* 187253 */   // Label 3676: @187253
     /* 187253 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187290), // Rule ID 3563 //
     /* 187258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 187282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187288 */     GIR_RootConstrainSelectedInstOperands,
     /* 187289 */     // GIR_Coverage, 3563,
     /* 187289 */     GIR_EraseRootFromParent_Done,
     /* 187290 */   // Label 3677: @187290
     /* 187290 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187327), // Rule ID 3564 //
     /* 187295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187325 */     GIR_RootConstrainSelectedInstOperands,
     /* 187326 */     // GIR_Coverage, 3564,
     /* 187326 */     GIR_EraseRootFromParent_Done,
     /* 187327 */   // Label 3678: @187327
     /* 187327 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187364), // Rule ID 3565 //
     /* 187332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187362 */     GIR_RootConstrainSelectedInstOperands,
     /* 187363 */     // GIR_Coverage, 3565,
     /* 187363 */     GIR_EraseRootFromParent_Done,
     /* 187364 */   // Label 3679: @187364
     /* 187364 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187401), // Rule ID 3566 //
     /* 187369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187399 */     GIR_RootConstrainSelectedInstOperands,
     /* 187400 */     // GIR_Coverage, 3566,
     /* 187400 */     GIR_EraseRootFromParent_Done,
     /* 187401 */   // Label 3680: @187401
     /* 187401 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187438), // Rule ID 3567 //
     /* 187406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187427 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187436 */     GIR_RootConstrainSelectedInstOperands,
     /* 187437 */     // GIR_Coverage, 3567,
     /* 187437 */     GIR_EraseRootFromParent_Done,
     /* 187438 */   // Label 3681: @187438
     /* 187438 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(187475), // Rule ID 3568 //
     /* 187443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187473 */     GIR_RootConstrainSelectedInstOperands,
     /* 187474 */     // GIR_Coverage, 3568,
     /* 187474 */     GIR_EraseRootFromParent_Done,
     /* 187475 */   // Label 3682: @187475
     /* 187475 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187512), // Rule ID 3569 //
     /* 187480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187501 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187510 */     GIR_RootConstrainSelectedInstOperands,
     /* 187511 */     // GIR_Coverage, 3569,
     /* 187511 */     GIR_EraseRootFromParent_Done,
     /* 187512 */   // Label 3683: @187512
     /* 187512 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187549), // Rule ID 3570 //
     /* 187517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1909:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 187541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187547 */     GIR_RootConstrainSelectedInstOperands,
     /* 187548 */     // GIR_Coverage, 3570,
     /* 187548 */     GIR_EraseRootFromParent_Done,
     /* 187549 */   // Label 3684: @187549
     /* 187549 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187586), // Rule ID 3571 //
     /* 187554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1909:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187584 */     GIR_RootConstrainSelectedInstOperands,
     /* 187585 */     // GIR_Coverage, 3571,
     /* 187585 */     GIR_EraseRootFromParent_Done,
     /* 187586 */   // Label 3685: @187586
     /* 187586 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187623), // Rule ID 3572 //
     /* 187591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1909:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187621 */     GIR_RootConstrainSelectedInstOperands,
     /* 187622 */     // GIR_Coverage, 3572,
     /* 187622 */     GIR_EraseRootFromParent_Done,
     /* 187623 */   // Label 3686: @187623
     /* 187623 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187660), // Rule ID 3573 //
     /* 187628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1909:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187658 */     GIR_RootConstrainSelectedInstOperands,
     /* 187659 */     // GIR_Coverage, 3573,
     /* 187659 */     GIR_EraseRootFromParent_Done,
     /* 187660 */   // Label 3687: @187660
     /* 187660 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187697), // Rule ID 3574 //
     /* 187665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187686 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1909:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187695 */     GIR_RootConstrainSelectedInstOperands,
     /* 187696 */     // GIR_Coverage, 3574,
     /* 187696 */     GIR_EraseRootFromParent_Done,
     /* 187697 */   // Label 3688: @187697
     /* 187697 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187734), // Rule ID 3575 //
     /* 187702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187723 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1909:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187732 */     GIR_RootConstrainSelectedInstOperands,
     /* 187733 */     // GIR_Coverage, 3575,
     /* 187733 */     GIR_EraseRootFromParent_Done,
     /* 187734 */   // Label 3689: @187734
     /* 187734 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187771), // Rule ID 3576 //
     /* 187739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187760 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1909:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187769 */     GIR_RootConstrainSelectedInstOperands,
     /* 187770 */     // GIR_Coverage, 3576,
     /* 187770 */     GIR_EraseRootFromParent_Done,
     /* 187771 */   // Label 3690: @187771
     /* 187771 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(187808), // Rule ID 8353 //
     /* 187776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 187784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187797 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1288:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 187800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187806 */     GIR_RootConstrainSelectedInstOperands,
     /* 187807 */     // GIR_Coverage, 8353,
     /* 187807 */     GIR_EraseRootFromParent_Done,
     /* 187808 */   // Label 3691: @187808
     /* 187808 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(187845), // Rule ID 8829 //
     /* 187813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1246:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 187837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187843 */     GIR_RootConstrainSelectedInstOperands,
     /* 187844 */     // GIR_Coverage, 8829,
     /* 187844 */     GIR_EraseRootFromParent_Done,
     /* 187845 */   // Label 3692: @187845
     /* 187845 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(187882), // Rule ID 8830 //
     /* 187850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1248:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 187874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187880 */     GIR_RootConstrainSelectedInstOperands,
     /* 187881 */     // GIR_Coverage, 8830,
     /* 187881 */     GIR_EraseRootFromParent_Done,
     /* 187882 */   // Label 3693: @187882
     /* 187882 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(187919), // Rule ID 8831 //
     /* 187887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 187895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1249:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 187911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187917 */     GIR_RootConstrainSelectedInstOperands,
     /* 187918 */     // GIR_Coverage, 8831,
     /* 187918 */     GIR_EraseRootFromParent_Done,
     /* 187919 */   // Label 3694: @187919
     /* 187919 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(187956), // Rule ID 8832 //
     /* 187924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 187932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1247:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 187948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187954 */     GIR_RootConstrainSelectedInstOperands,
     /* 187955 */     // GIR_Coverage, 8832,
     /* 187955 */     GIR_EraseRootFromParent_Done,
     /* 187956 */   // Label 3695: @187956
     /* 187956 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(187993), // Rule ID 8833 //
     /* 187961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1246:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 187985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187991 */     GIR_RootConstrainSelectedInstOperands,
     /* 187992 */     // GIR_Coverage, 8833,
     /* 187992 */     GIR_EraseRootFromParent_Done,
     /* 187993 */   // Label 3696: @187993
     /* 187993 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188030), // Rule ID 8834 //
     /* 187998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1248:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 188022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188028 */     GIR_RootConstrainSelectedInstOperands,
     /* 188029 */     // GIR_Coverage, 8834,
     /* 188029 */     GIR_EraseRootFromParent_Done,
     /* 188030 */   // Label 3697: @188030
     /* 188030 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188067), // Rule ID 8835 //
     /* 188035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1249:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 188059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188065 */     GIR_RootConstrainSelectedInstOperands,
     /* 188066 */     // GIR_Coverage, 8835,
     /* 188066 */     GIR_EraseRootFromParent_Done,
     /* 188067 */   // Label 3698: @188067
     /* 188067 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188104), // Rule ID 8836 //
     /* 188072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1247:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 188096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188102 */     GIR_RootConstrainSelectedInstOperands,
     /* 188103 */     // GIR_Coverage, 8836,
     /* 188103 */     GIR_EraseRootFromParent_Done,
     /* 188104 */   // Label 3699: @188104
     /* 188104 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188144), // Rule ID 9836 //
     /* 188109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 188133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188142 */     GIR_RootConstrainSelectedInstOperands,
     /* 188143 */     // GIR_Coverage, 9836,
     /* 188143 */     GIR_EraseRootFromParent_Done,
     /* 188144 */   // Label 3700: @188144
     /* 188144 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188184), // Rule ID 9837 //
     /* 188149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 188173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188182 */     GIR_RootConstrainSelectedInstOperands,
     /* 188183 */     // GIR_Coverage, 9837,
     /* 188183 */     GIR_EraseRootFromParent_Done,
     /* 188184 */   // Label 3701: @188184
     /* 188184 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188224), // Rule ID 9838 //
     /* 188189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 188213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188222 */     GIR_RootConstrainSelectedInstOperands,
     /* 188223 */     // GIR_Coverage, 9838,
     /* 188223 */     GIR_EraseRootFromParent_Done,
     /* 188224 */   // Label 3702: @188224
     /* 188224 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188264), // Rule ID 9839 //
     /* 188229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 188253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188262 */     GIR_RootConstrainSelectedInstOperands,
     /* 188263 */     // GIR_Coverage, 9839,
     /* 188263 */     GIR_EraseRootFromParent_Done,
     /* 188264 */   // Label 3703: @188264
     /* 188264 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188304), // Rule ID 9840 //
     /* 188269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188290 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 188293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188302 */     GIR_RootConstrainSelectedInstOperands,
     /* 188303 */     // GIR_Coverage, 9840,
     /* 188303 */     GIR_EraseRootFromParent_Done,
     /* 188304 */   // Label 3704: @188304
     /* 188304 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188344), // Rule ID 9841 //
     /* 188309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 188333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188342 */     GIR_RootConstrainSelectedInstOperands,
     /* 188343 */     // GIR_Coverage, 9841,
     /* 188343 */     GIR_EraseRootFromParent_Done,
     /* 188344 */   // Label 3705: @188344
     /* 188344 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188384), // Rule ID 9842 //
     /* 188349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 188373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188382 */     GIR_RootConstrainSelectedInstOperands,
     /* 188383 */     // GIR_Coverage, 9842,
     /* 188383 */     GIR_EraseRootFromParent_Done,
     /* 188384 */   // Label 3706: @188384
     /* 188384 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188424), // Rule ID 9843 //
     /* 188389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188410 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 188413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188422 */     GIR_RootConstrainSelectedInstOperands,
     /* 188423 */     // GIR_Coverage, 9843,
     /* 188423 */     GIR_EraseRootFromParent_Done,
     /* 188424 */   // Label 3707: @188424
     /* 188424 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188464), // Rule ID 9848 //
     /* 188429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 188453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188462 */     GIR_RootConstrainSelectedInstOperands,
     /* 188463 */     // GIR_Coverage, 9848,
     /* 188463 */     GIR_EraseRootFromParent_Done,
     /* 188464 */   // Label 3708: @188464
     /* 188464 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188504), // Rule ID 9849 //
     /* 188469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 188493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188502 */     GIR_RootConstrainSelectedInstOperands,
     /* 188503 */     // GIR_Coverage, 9849,
     /* 188503 */     GIR_EraseRootFromParent_Done,
     /* 188504 */   // Label 3709: @188504
     /* 188504 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188544), // Rule ID 9850 //
     /* 188509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 188533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188542 */     GIR_RootConstrainSelectedInstOperands,
     /* 188543 */     // GIR_Coverage, 9850,
     /* 188543 */     GIR_EraseRootFromParent_Done,
     /* 188544 */   // Label 3710: @188544
     /* 188544 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188584), // Rule ID 9851 //
     /* 188549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 188573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188582 */     GIR_RootConstrainSelectedInstOperands,
     /* 188583 */     // GIR_Coverage, 9851,
     /* 188583 */     GIR_EraseRootFromParent_Done,
     /* 188584 */   // Label 3711: @188584
     /* 188584 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188624), // Rule ID 9852 //
     /* 188589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188610 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 188613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188622 */     GIR_RootConstrainSelectedInstOperands,
     /* 188623 */     // GIR_Coverage, 9852,
     /* 188623 */     GIR_EraseRootFromParent_Done,
     /* 188624 */   // Label 3712: @188624
     /* 188624 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188664), // Rule ID 9853 //
     /* 188629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 188653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188662 */     GIR_RootConstrainSelectedInstOperands,
     /* 188663 */     // GIR_Coverage, 9853,
     /* 188663 */     GIR_EraseRootFromParent_Done,
     /* 188664 */   // Label 3713: @188664
     /* 188664 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188704), // Rule ID 9854 //
     /* 188669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 188693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188702 */     GIR_RootConstrainSelectedInstOperands,
     /* 188703 */     // GIR_Coverage, 9854,
     /* 188703 */     GIR_EraseRootFromParent_Done,
     /* 188704 */   // Label 3714: @188704
     /* 188704 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188744), // Rule ID 9855 //
     /* 188709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188730 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 188733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188742 */     GIR_RootConstrainSelectedInstOperands,
     /* 188743 */     // GIR_Coverage, 9855,
     /* 188743 */     GIR_EraseRootFromParent_Done,
     /* 188744 */   // Label 3715: @188744
     /* 188744 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188784), // Rule ID 9856 //
     /* 188749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 188773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188782 */     GIR_RootConstrainSelectedInstOperands,
     /* 188783 */     // GIR_Coverage, 9856,
     /* 188783 */     GIR_EraseRootFromParent_Done,
     /* 188784 */   // Label 3716: @188784
     /* 188784 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(188824), // Rule ID 9857 //
     /* 188789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188810 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 188813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188822 */     GIR_RootConstrainSelectedInstOperands,
     /* 188823 */     // GIR_Coverage, 9857,
     /* 188823 */     GIR_EraseRootFromParent_Done,
     /* 188824 */   // Label 3717: @188824
     /* 188824 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(188864), // Rule ID 9858 //
     /* 188829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 188853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188862 */     GIR_RootConstrainSelectedInstOperands,
     /* 188863 */     // GIR_Coverage, 9858,
     /* 188863 */     GIR_EraseRootFromParent_Done,
     /* 188864 */   // Label 3718: @188864
     /* 188864 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(188904), // Rule ID 9859 //
     /* 188869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188890 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 188893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188902 */     GIR_RootConstrainSelectedInstOperands,
     /* 188903 */     // GIR_Coverage, 9859,
     /* 188903 */     GIR_EraseRootFromParent_Done,
     /* 188904 */   // Label 3719: @188904
     /* 188904 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(188944), // Rule ID 9864 //
     /* 188909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188930 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 188933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188942 */     GIR_RootConstrainSelectedInstOperands,
     /* 188943 */     // GIR_Coverage, 9864,
     /* 188943 */     GIR_EraseRootFromParent_Done,
     /* 188944 */   // Label 3720: @188944
     /* 188944 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(188984), // Rule ID 9865 //
     /* 188949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 188973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188982 */     GIR_RootConstrainSelectedInstOperands,
     /* 188983 */     // GIR_Coverage, 9865,
     /* 188983 */     GIR_EraseRootFromParent_Done,
     /* 188984 */   // Label 3721: @188984
     /* 188984 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189024), // Rule ID 9866 //
     /* 188989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189010 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 189013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189022 */     GIR_RootConstrainSelectedInstOperands,
     /* 189023 */     // GIR_Coverage, 9866,
     /* 189023 */     GIR_EraseRootFromParent_Done,
     /* 189024 */   // Label 3722: @189024
     /* 189024 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189064), // Rule ID 9867 //
     /* 189029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 189053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189062 */     GIR_RootConstrainSelectedInstOperands,
     /* 189063 */     // GIR_Coverage, 9867,
     /* 189063 */     GIR_EraseRootFromParent_Done,
     /* 189064 */   // Label 3723: @189064
     /* 189064 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189101), // Rule ID 10026 //
     /* 189069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2016:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 189093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189099 */     GIR_RootConstrainSelectedInstOperands,
     /* 189100 */     // GIR_Coverage, 10026,
     /* 189100 */     GIR_EraseRootFromParent_Done,
     /* 189101 */   // Label 3724: @189101
     /* 189101 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189138), // Rule ID 10027 //
     /* 189106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2016:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 189137 */     // GIR_Coverage, 10027,
     /* 189137 */     GIR_EraseRootFromParent_Done,
     /* 189138 */   // Label 3725: @189138
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189175), // Rule ID 10028 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2016:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 189167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189173 */     GIR_RootConstrainSelectedInstOperands,
     /* 189174 */     // GIR_Coverage, 10028,
     /* 189174 */     GIR_EraseRootFromParent_Done,
     /* 189175 */   // Label 3726: @189175
     /* 189175 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189212), // Rule ID 10029 //
     /* 189180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189201 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 189204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189210 */     GIR_RootConstrainSelectedInstOperands,
     /* 189211 */     // GIR_Coverage, 10029,
     /* 189211 */     GIR_EraseRootFromParent_Done,
     /* 189212 */   // Label 3727: @189212
     /* 189212 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189249), // Rule ID 10030 //
     /* 189217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 189241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189247 */     GIR_RootConstrainSelectedInstOperands,
     /* 189248 */     // GIR_Coverage, 10030,
     /* 189248 */     GIR_EraseRootFromParent_Done,
     /* 189249 */   // Label 3728: @189249
     /* 189249 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189286), // Rule ID 10031 //
     /* 189254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 189278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189284 */     GIR_RootConstrainSelectedInstOperands,
     /* 189285 */     // GIR_Coverage, 10031,
     /* 189285 */     GIR_EraseRootFromParent_Done,
     /* 189286 */   // Label 3729: @189286
     /* 189286 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189323), // Rule ID 10032 //
     /* 189291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 189315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189321 */     GIR_RootConstrainSelectedInstOperands,
     /* 189322 */     // GIR_Coverage, 10032,
     /* 189322 */     GIR_EraseRootFromParent_Done,
     /* 189323 */   // Label 3730: @189323
     /* 189323 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189360), // Rule ID 10033 //
     /* 189328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 189352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189358 */     GIR_RootConstrainSelectedInstOperands,
     /* 189359 */     // GIR_Coverage, 10033,
     /* 189359 */     GIR_EraseRootFromParent_Done,
     /* 189360 */   // Label 3731: @189360
     /* 189360 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189397), // Rule ID 10034 //
     /* 189365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 189389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189395 */     GIR_RootConstrainSelectedInstOperands,
     /* 189396 */     // GIR_Coverage, 10034,
     /* 189396 */     GIR_EraseRootFromParent_Done,
     /* 189397 */   // Label 3732: @189397
     /* 189397 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189434), // Rule ID 11202 //
     /* 189402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2151:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189432 */     GIR_RootConstrainSelectedInstOperands,
     /* 189433 */     // GIR_Coverage, 11202,
     /* 189433 */     GIR_EraseRootFromParent_Done,
     /* 189434 */   // Label 3733: @189434
     /* 189434 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189471), // Rule ID 11203 //
     /* 189439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2151:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189469 */     GIR_RootConstrainSelectedInstOperands,
     /* 189470 */     // GIR_Coverage, 11203,
     /* 189470 */     GIR_EraseRootFromParent_Done,
     /* 189471 */   // Label 3734: @189471
     /* 189471 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189508), // Rule ID 11204 //
     /* 189476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189497 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2151:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189506 */     GIR_RootConstrainSelectedInstOperands,
     /* 189507 */     // GIR_Coverage, 11204,
     /* 189507 */     GIR_EraseRootFromParent_Done,
     /* 189508 */   // Label 3735: @189508
     /* 189508 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189545), // Rule ID 11205 //
     /* 189513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189543 */     GIR_RootConstrainSelectedInstOperands,
     /* 189544 */     // GIR_Coverage, 11205,
     /* 189544 */     GIR_EraseRootFromParent_Done,
     /* 189545 */   // Label 3736: @189545
     /* 189545 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189582), // Rule ID 11206 //
     /* 189550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2151:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189580 */     GIR_RootConstrainSelectedInstOperands,
     /* 189581 */     // GIR_Coverage, 11206,
     /* 189581 */     GIR_EraseRootFromParent_Done,
     /* 189582 */   // Label 3737: @189582
     /* 189582 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189619), // Rule ID 11207 //
     /* 189587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189617 */     GIR_RootConstrainSelectedInstOperands,
     /* 189618 */     // GIR_Coverage, 11207,
     /* 189618 */     GIR_EraseRootFromParent_Done,
     /* 189619 */   // Label 3738: @189619
     /* 189619 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189656), // Rule ID 11208 //
     /* 189624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189645 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2151:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189654 */     GIR_RootConstrainSelectedInstOperands,
     /* 189655 */     // GIR_Coverage, 11208,
     /* 189655 */     GIR_EraseRootFromParent_Done,
     /* 189656 */   // Label 3739: @189656
     /* 189656 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189693), // Rule ID 11209 //
     /* 189661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2072:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189691 */     GIR_RootConstrainSelectedInstOperands,
     /* 189692 */     // GIR_Coverage, 11209,
     /* 189692 */     GIR_EraseRootFromParent_Done,
     /* 189693 */   // Label 3740: @189693
     /* 189693 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189730), // Rule ID 11210 //
     /* 189698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189728 */     GIR_RootConstrainSelectedInstOperands,
     /* 189729 */     // GIR_Coverage, 11210,
     /* 189729 */     GIR_EraseRootFromParent_Done,
     /* 189730 */   // Label 3741: @189730
     /* 189730 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189767), // Rule ID 11211 //
     /* 189735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189756 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2072:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189765 */     GIR_RootConstrainSelectedInstOperands,
     /* 189766 */     // GIR_Coverage, 11211,
     /* 189766 */     GIR_EraseRootFromParent_Done,
     /* 189767 */   // Label 3742: @189767
     /* 189767 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(189804), // Rule ID 11212 //
     /* 189772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189802 */     GIR_RootConstrainSelectedInstOperands,
     /* 189803 */     // GIR_Coverage, 11212,
     /* 189803 */     GIR_EraseRootFromParent_Done,
     /* 189804 */   // Label 3743: @189804
     /* 189804 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(189841), // Rule ID 11213 //
     /* 189809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2072:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189839 */     GIR_RootConstrainSelectedInstOperands,
     /* 189840 */     // GIR_Coverage, 11213,
     /* 189840 */     GIR_EraseRootFromParent_Done,
     /* 189841 */   // Label 3744: @189841
     /* 189841 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(189878), // Rule ID 11214 //
     /* 189846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189876 */     GIR_RootConstrainSelectedInstOperands,
     /* 189877 */     // GIR_Coverage, 11214,
     /* 189877 */     GIR_EraseRootFromParent_Done,
     /* 189878 */   // Label 3745: @189878
     /* 189878 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(189915), // Rule ID 11215 //
     /* 189883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2072:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189913 */     GIR_RootConstrainSelectedInstOperands,
     /* 189914 */     // GIR_Coverage, 11215,
     /* 189914 */     GIR_EraseRootFromParent_Done,
     /* 189915 */   // Label 3746: @189915
     /* 189915 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(189952), // Rule ID 11216 //
     /* 189920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189941 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2077:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189950 */     GIR_RootConstrainSelectedInstOperands,
     /* 189951 */     // GIR_Coverage, 11216,
     /* 189951 */     GIR_EraseRootFromParent_Done,
     /* 189952 */   // Label 3747: @189952
     /* 189952 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(189989), // Rule ID 11217 //
     /* 189957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2077:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189987 */     GIR_RootConstrainSelectedInstOperands,
     /* 189988 */     // GIR_Coverage, 11217,
     /* 189988 */     GIR_EraseRootFromParent_Done,
     /* 189989 */   // Label 3748: @189989
     /* 189989 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190026), // Rule ID 11218 //
     /* 189994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2077:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190024 */     GIR_RootConstrainSelectedInstOperands,
     /* 190025 */     // GIR_Coverage, 11218,
     /* 190025 */     GIR_EraseRootFromParent_Done,
     /* 190026 */   // Label 3749: @190026
     /* 190026 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190063), // Rule ID 11219 //
     /* 190031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2077:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190061 */     GIR_RootConstrainSelectedInstOperands,
     /* 190062 */     // GIR_Coverage, 11219,
     /* 190062 */     GIR_EraseRootFromParent_Done,
     /* 190063 */   // Label 3750: @190063
     /* 190063 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190100), // Rule ID 11220 //
     /* 190068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190089 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2077:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190098 */     GIR_RootConstrainSelectedInstOperands,
     /* 190099 */     // GIR_Coverage, 11220,
     /* 190099 */     GIR_EraseRootFromParent_Done,
     /* 190100 */   // Label 3751: @190100
     /* 190100 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190137), // Rule ID 11221 //
     /* 190105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2077:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190135 */     GIR_RootConstrainSelectedInstOperands,
     /* 190136 */     // GIR_Coverage, 11221,
     /* 190136 */     GIR_EraseRootFromParent_Done,
     /* 190137 */   // Label 3752: @190137
     /* 190137 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190174), // Rule ID 11222 //
     /* 190142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2077:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190172 */     GIR_RootConstrainSelectedInstOperands,
     /* 190173 */     // GIR_Coverage, 11222,
     /* 190173 */     GIR_EraseRootFromParent_Done,
     /* 190174 */   // Label 3753: @190174
     /* 190174 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190211), // Rule ID 11223 //
     /* 190179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1916:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190209 */     GIR_RootConstrainSelectedInstOperands,
     /* 190210 */     // GIR_Coverage, 11223,
     /* 190210 */     GIR_EraseRootFromParent_Done,
     /* 190211 */   // Label 3754: @190211
     /* 190211 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190248), // Rule ID 11224 //
     /* 190216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190246 */     GIR_RootConstrainSelectedInstOperands,
     /* 190247 */     // GIR_Coverage, 11224,
     /* 190247 */     GIR_EraseRootFromParent_Done,
     /* 190248 */   // Label 3755: @190248
     /* 190248 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190285), // Rule ID 11225 //
     /* 190253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1916:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190283 */     GIR_RootConstrainSelectedInstOperands,
     /* 190284 */     // GIR_Coverage, 11225,
     /* 190284 */     GIR_EraseRootFromParent_Done,
     /* 190285 */   // Label 3756: @190285
     /* 190285 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190322), // Rule ID 11226 //
     /* 190290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190320 */     GIR_RootConstrainSelectedInstOperands,
     /* 190321 */     // GIR_Coverage, 11226,
     /* 190321 */     GIR_EraseRootFromParent_Done,
     /* 190322 */   // Label 3757: @190322
     /* 190322 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190359), // Rule ID 11227 //
     /* 190327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1916:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190357 */     GIR_RootConstrainSelectedInstOperands,
     /* 190358 */     // GIR_Coverage, 11227,
     /* 190358 */     GIR_EraseRootFromParent_Done,
     /* 190359 */   // Label 3758: @190359
     /* 190359 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190396), // Rule ID 11228 //
     /* 190364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190394 */     GIR_RootConstrainSelectedInstOperands,
     /* 190395 */     // GIR_Coverage, 11228,
     /* 190395 */     GIR_EraseRootFromParent_Done,
     /* 190396 */   // Label 3759: @190396
     /* 190396 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190433), // Rule ID 11229 //
     /* 190401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190422 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1916:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190431 */     GIR_RootConstrainSelectedInstOperands,
     /* 190432 */     // GIR_Coverage, 11229,
     /* 190432 */     GIR_EraseRootFromParent_Done,
     /* 190433 */   // Label 3760: @190433
     /* 190433 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190470), // Rule ID 11230 //
     /* 190438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1921:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190468 */     GIR_RootConstrainSelectedInstOperands,
     /* 190469 */     // GIR_Coverage, 11230,
     /* 190469 */     GIR_EraseRootFromParent_Done,
     /* 190470 */   // Label 3761: @190470
     /* 190470 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190507), // Rule ID 11231 //
     /* 190475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190505 */     GIR_RootConstrainSelectedInstOperands,
     /* 190506 */     // GIR_Coverage, 11231,
     /* 190506 */     GIR_EraseRootFromParent_Done,
     /* 190507 */   // Label 3762: @190507
     /* 190507 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190544), // Rule ID 11232 //
     /* 190512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1921:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190542 */     GIR_RootConstrainSelectedInstOperands,
     /* 190543 */     // GIR_Coverage, 11232,
     /* 190543 */     GIR_EraseRootFromParent_Done,
     /* 190544 */   // Label 3763: @190544
     /* 190544 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190581), // Rule ID 11233 //
     /* 190549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190579 */     GIR_RootConstrainSelectedInstOperands,
     /* 190580 */     // GIR_Coverage, 11233,
     /* 190580 */     GIR_EraseRootFromParent_Done,
     /* 190581 */   // Label 3764: @190581
     /* 190581 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190618), // Rule ID 11234 //
     /* 190586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190607 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1921:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190616 */     GIR_RootConstrainSelectedInstOperands,
     /* 190617 */     // GIR_Coverage, 11234,
     /* 190617 */     GIR_EraseRootFromParent_Done,
     /* 190618 */   // Label 3765: @190618
     /* 190618 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190655), // Rule ID 11235 //
     /* 190623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190653 */     GIR_RootConstrainSelectedInstOperands,
     /* 190654 */     // GIR_Coverage, 11235,
     /* 190654 */     GIR_EraseRootFromParent_Done,
     /* 190655 */   // Label 3766: @190655
     /* 190655 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190692), // Rule ID 11236 //
     /* 190660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1921:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190690 */     GIR_RootConstrainSelectedInstOperands,
     /* 190691 */     // GIR_Coverage, 11236,
     /* 190691 */     GIR_EraseRootFromParent_Done,
     /* 190692 */   // Label 3767: @190692
     /* 190692 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190729), // Rule ID 11256 //
     /* 190697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1818:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 190721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190727 */     GIR_RootConstrainSelectedInstOperands,
     /* 190728 */     // GIR_Coverage, 11256,
     /* 190728 */     GIR_EraseRootFromParent_Done,
     /* 190729 */   // Label 3768: @190729
     /* 190729 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190766), // Rule ID 11257 //
     /* 190734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190755 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1818:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 190758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190764 */     GIR_RootConstrainSelectedInstOperands,
     /* 190765 */     // GIR_Coverage, 11257,
     /* 190765 */     GIR_EraseRootFromParent_Done,
     /* 190766 */   // Label 3769: @190766
     /* 190766 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(190803), // Rule ID 11258 //
     /* 190771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1818:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 190795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190801 */     GIR_RootConstrainSelectedInstOperands,
     /* 190802 */     // GIR_Coverage, 11258,
     /* 190802 */     GIR_EraseRootFromParent_Done,
     /* 190803 */   // Label 3770: @190803
     /* 190803 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(190840), // Rule ID 11259 //
     /* 190808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1818:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 190832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190838 */     GIR_RootConstrainSelectedInstOperands,
     /* 190839 */     // GIR_Coverage, 11259,
     /* 190839 */     GIR_EraseRootFromParent_Done,
     /* 190840 */   // Label 3771: @190840
     /* 190840 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(190877), // Rule ID 11547 //
     /* 190845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 190869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190875 */     GIR_RootConstrainSelectedInstOperands,
     /* 190876 */     // GIR_Coverage, 11547,
     /* 190876 */     GIR_EraseRootFromParent_Done,
     /* 190877 */   // Label 3772: @190877
     /* 190877 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(190914), // Rule ID 11548 //
     /* 190882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 190906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190912 */     GIR_RootConstrainSelectedInstOperands,
     /* 190913 */     // GIR_Coverage, 11548,
     /* 190913 */     GIR_EraseRootFromParent_Done,
     /* 190914 */   // Label 3773: @190914
     /* 190914 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(190951), // Rule ID 11549 //
     /* 190919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 190943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190949 */     GIR_RootConstrainSelectedInstOperands,
     /* 190950 */     // GIR_Coverage, 11549,
     /* 190950 */     GIR_EraseRootFromParent_Done,
     /* 190951 */   // Label 3774: @190951
     /* 190951 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(190988), // Rule ID 11550 //
     /* 190956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 190980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190986 */     GIR_RootConstrainSelectedInstOperands,
     /* 190987 */     // GIR_Coverage, 11550,
     /* 190987 */     GIR_EraseRootFromParent_Done,
     /* 190988 */   // Label 3775: @190988
     /* 190988 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191025), // Rule ID 11551 //
     /* 190993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 191017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191023 */     GIR_RootConstrainSelectedInstOperands,
     /* 191024 */     // GIR_Coverage, 11551,
     /* 191024 */     GIR_EraseRootFromParent_Done,
     /* 191025 */   // Label 3776: @191025
     /* 191025 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191062), // Rule ID 11552 //
     /* 191030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 191054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191060 */     GIR_RootConstrainSelectedInstOperands,
     /* 191061 */     // GIR_Coverage, 11552,
     /* 191061 */     GIR_EraseRootFromParent_Done,
     /* 191062 */   // Label 3777: @191062
     /* 191062 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191099), // Rule ID 11553 //
     /* 191067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 191091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191097 */     GIR_RootConstrainSelectedInstOperands,
     /* 191098 */     // GIR_Coverage, 11553,
     /* 191098 */     GIR_EraseRootFromParent_Done,
     /* 191099 */   // Label 3778: @191099
     /* 191099 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191136), // Rule ID 11554 //
     /* 191104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 191128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191134 */     GIR_RootConstrainSelectedInstOperands,
     /* 191135 */     // GIR_Coverage, 11554,
     /* 191135 */     GIR_EraseRootFromParent_Done,
     /* 191136 */   // Label 3779: @191136
     /* 191136 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191173), // Rule ID 11555 //
     /* 191141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 191165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191171 */     GIR_RootConstrainSelectedInstOperands,
     /* 191172 */     // GIR_Coverage, 11555,
     /* 191172 */     GIR_EraseRootFromParent_Done,
     /* 191173 */   // Label 3780: @191173
     /* 191173 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191210), // Rule ID 11556 //
     /* 191178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1859:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 191202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191208 */     GIR_RootConstrainSelectedInstOperands,
     /* 191209 */     // GIR_Coverage, 11556,
     /* 191209 */     GIR_EraseRootFromParent_Done,
     /* 191210 */   // Label 3781: @191210
     /* 191210 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191247), // Rule ID 11557 //
     /* 191215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 191239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191245 */     GIR_RootConstrainSelectedInstOperands,
     /* 191246 */     // GIR_Coverage, 11557,
     /* 191246 */     GIR_EraseRootFromParent_Done,
     /* 191247 */   // Label 3782: @191247
     /* 191247 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191284), // Rule ID 11558 //
     /* 191252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1859:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 191276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191282 */     GIR_RootConstrainSelectedInstOperands,
     /* 191283 */     // GIR_Coverage, 11558,
     /* 191283 */     GIR_EraseRootFromParent_Done,
     /* 191284 */   // Label 3783: @191284
     /* 191284 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191321), // Rule ID 11559 //
     /* 191289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 191313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191319 */     GIR_RootConstrainSelectedInstOperands,
     /* 191320 */     // GIR_Coverage, 11559,
     /* 191320 */     GIR_EraseRootFromParent_Done,
     /* 191321 */   // Label 3784: @191321
     /* 191321 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191358), // Rule ID 11560 //
     /* 191326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191347 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 191350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191356 */     GIR_RootConstrainSelectedInstOperands,
     /* 191357 */     // GIR_Coverage, 11560,
     /* 191357 */     GIR_EraseRootFromParent_Done,
     /* 191358 */   // Label 3785: @191358
     /* 191358 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191395), // Rule ID 11561 //
     /* 191363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 191387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191393 */     GIR_RootConstrainSelectedInstOperands,
     /* 191394 */     // GIR_Coverage, 11561,
     /* 191394 */     GIR_EraseRootFromParent_Done,
     /* 191395 */   // Label 3786: @191395
     /* 191395 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191432), // Rule ID 11562 //
     /* 191400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 191424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191430 */     GIR_RootConstrainSelectedInstOperands,
     /* 191431 */     // GIR_Coverage, 11562,
     /* 191431 */     GIR_EraseRootFromParent_Done,
     /* 191432 */   // Label 3787: @191432
     /* 191432 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(191469), // Rule ID 11563 //
     /* 191437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 191461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191467 */     GIR_RootConstrainSelectedInstOperands,
     /* 191468 */     // GIR_Coverage, 11563,
     /* 191468 */     GIR_EraseRootFromParent_Done,
     /* 191469 */   // Label 3788: @191469
     /* 191469 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191506), // Rule ID 11564 //
     /* 191474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191495 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 191498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191504 */     GIR_RootConstrainSelectedInstOperands,
     /* 191505 */     // GIR_Coverage, 11564,
     /* 191505 */     GIR_EraseRootFromParent_Done,
     /* 191506 */   // Label 3789: @191506
     /* 191506 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191543), // Rule ID 11565 //
     /* 191511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2056:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 191535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191541 */     GIR_RootConstrainSelectedInstOperands,
     /* 191542 */     // GIR_Coverage, 11565,
     /* 191542 */     GIR_EraseRootFromParent_Done,
     /* 191543 */   // Label 3790: @191543
     /* 191543 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191580), // Rule ID 11566 //
     /* 191548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 191572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191578 */     GIR_RootConstrainSelectedInstOperands,
     /* 191579 */     // GIR_Coverage, 11566,
     /* 191579 */     GIR_EraseRootFromParent_Done,
     /* 191580 */   // Label 3791: @191580
     /* 191580 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191617), // Rule ID 11567 //
     /* 191585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2056:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 191609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191615 */     GIR_RootConstrainSelectedInstOperands,
     /* 191616 */     // GIR_Coverage, 11567,
     /* 191616 */     GIR_EraseRootFromParent_Done,
     /* 191617 */   // Label 3792: @191617
     /* 191617 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191654), // Rule ID 11568 //
     /* 191622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 191646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191652 */     GIR_RootConstrainSelectedInstOperands,
     /* 191653 */     // GIR_Coverage, 11568,
     /* 191653 */     GIR_EraseRootFromParent_Done,
     /* 191654 */   // Label 3793: @191654
     /* 191654 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191691), // Rule ID 11569 //
     /* 191659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 191683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191689 */     GIR_RootConstrainSelectedInstOperands,
     /* 191690 */     // GIR_Coverage, 11569,
     /* 191690 */     GIR_EraseRootFromParent_Done,
     /* 191691 */   // Label 3794: @191691
     /* 191691 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191728), // Rule ID 11570 //
     /* 191696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 191720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191726 */     GIR_RootConstrainSelectedInstOperands,
     /* 191727 */     // GIR_Coverage, 11570,
     /* 191727 */     GIR_EraseRootFromParent_Done,
     /* 191728 */   // Label 3795: @191728
     /* 191728 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191765), // Rule ID 11571 //
     /* 191733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 191757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191763 */     GIR_RootConstrainSelectedInstOperands,
     /* 191764 */     // GIR_Coverage, 11571,
     /* 191764 */     GIR_EraseRootFromParent_Done,
     /* 191765 */   // Label 3796: @191765
     /* 191765 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(191802), // Rule ID 11572 //
     /* 191770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 191794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191800 */     GIR_RootConstrainSelectedInstOperands,
     /* 191801 */     // GIR_Coverage, 11572,
     /* 191801 */     GIR_EraseRootFromParent_Done,
     /* 191802 */   // Label 3797: @191802
     /* 191802 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(191839), // Rule ID 11573 //
     /* 191807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 191831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191837 */     GIR_RootConstrainSelectedInstOperands,
     /* 191838 */     // GIR_Coverage, 11573,
     /* 191838 */     GIR_EraseRootFromParent_Done,
     /* 191839 */   // Label 3798: @191839
     /* 191839 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(191876), // Rule ID 11574 //
     /* 191844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 191868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191874 */     GIR_RootConstrainSelectedInstOperands,
     /* 191875 */     // GIR_Coverage, 11574,
     /* 191875 */     GIR_EraseRootFromParent_Done,
     /* 191876 */   // Label 3799: @191876
     /* 191876 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(191913), // Rule ID 11575 //
     /* 191881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1927:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 191905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191911 */     GIR_RootConstrainSelectedInstOperands,
     /* 191912 */     // GIR_Coverage, 11575,
     /* 191912 */     GIR_EraseRootFromParent_Done,
     /* 191913 */   // Label 3800: @191913
     /* 191913 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(191950), // Rule ID 11576 //
     /* 191918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1927:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 191942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191948 */     GIR_RootConstrainSelectedInstOperands,
     /* 191949 */     // GIR_Coverage, 11576,
     /* 191949 */     GIR_EraseRootFromParent_Done,
     /* 191950 */   // Label 3801: @191950
     /* 191950 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(191987), // Rule ID 11577 //
     /* 191955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1928:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 191979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191985 */     GIR_RootConstrainSelectedInstOperands,
     /* 191986 */     // GIR_Coverage, 11577,
     /* 191986 */     GIR_EraseRootFromParent_Done,
     /* 191987 */   // Label 3802: @191987
     /* 191987 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192024), // Rule ID 11578 //
     /* 191992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1928:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 192016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192022 */     GIR_RootConstrainSelectedInstOperands,
     /* 192023 */     // GIR_Coverage, 11578,
     /* 192023 */     GIR_EraseRootFromParent_Done,
     /* 192024 */   // Label 3803: @192024
     /* 192024 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192061), // Rule ID 11579 //
     /* 192029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1928:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 192053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192059 */     GIR_RootConstrainSelectedInstOperands,
     /* 192060 */     // GIR_Coverage, 11579,
     /* 192060 */     GIR_EraseRootFromParent_Done,
     /* 192061 */   // Label 3804: @192061
     /* 192061 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192098), // Rule ID 11589 //
     /* 192066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 192090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192096 */     GIR_RootConstrainSelectedInstOperands,
     /* 192097 */     // GIR_Coverage, 11589,
     /* 192097 */     GIR_EraseRootFromParent_Done,
     /* 192098 */   // Label 3805: @192098
     /* 192098 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192135), // Rule ID 11590 //
     /* 192103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 192127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192133 */     GIR_RootConstrainSelectedInstOperands,
     /* 192134 */     // GIR_Coverage, 11590,
     /* 192134 */     GIR_EraseRootFromParent_Done,
     /* 192135 */   // Label 3806: @192135
     /* 192135 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192172), // Rule ID 11591 //
     /* 192140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 192164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192170 */     GIR_RootConstrainSelectedInstOperands,
     /* 192171 */     // GIR_Coverage, 11591,
     /* 192171 */     GIR_EraseRootFromParent_Done,
     /* 192172 */   // Label 3807: @192172
     /* 192172 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192209), // Rule ID 11592 //
     /* 192177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 192201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192207 */     GIR_RootConstrainSelectedInstOperands,
     /* 192208 */     // GIR_Coverage, 11592,
     /* 192208 */     GIR_EraseRootFromParent_Done,
     /* 192209 */   // Label 3808: @192209
     /* 192209 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192246), // Rule ID 11593 //
     /* 192214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 192238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192244 */     GIR_RootConstrainSelectedInstOperands,
     /* 192245 */     // GIR_Coverage, 11593,
     /* 192245 */     GIR_EraseRootFromParent_Done,
     /* 192246 */   // Label 3809: @192246
     /* 192246 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192283), // Rule ID 11594 //
     /* 192251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 192275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192281 */     GIR_RootConstrainSelectedInstOperands,
     /* 192282 */     // GIR_Coverage, 11594,
     /* 192282 */     GIR_EraseRootFromParent_Done,
     /* 192283 */   // Label 3810: @192283
     /* 192283 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192320), // Rule ID 11595 //
     /* 192288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2057:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 192312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192318 */     GIR_RootConstrainSelectedInstOperands,
     /* 192319 */     // GIR_Coverage, 11595,
     /* 192319 */     GIR_EraseRootFromParent_Done,
     /* 192320 */   // Label 3811: @192320
     /* 192320 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192357), // Rule ID 11596 //
     /* 192325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 192349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192355 */     GIR_RootConstrainSelectedInstOperands,
     /* 192356 */     // GIR_Coverage, 11596,
     /* 192356 */     GIR_EraseRootFromParent_Done,
     /* 192357 */   // Label 3812: @192357
     /* 192357 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192394), // Rule ID 11597 //
     /* 192362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2057:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 192386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192392 */     GIR_RootConstrainSelectedInstOperands,
     /* 192393 */     // GIR_Coverage, 11597,
     /* 192393 */     GIR_EraseRootFromParent_Done,
     /* 192394 */   // Label 3813: @192394
     /* 192394 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192431), // Rule ID 11598 //
     /* 192399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 192423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192429 */     GIR_RootConstrainSelectedInstOperands,
     /* 192430 */     // GIR_Coverage, 11598,
     /* 192430 */     GIR_EraseRootFromParent_Done,
     /* 192431 */   // Label 3814: @192431
     /* 192431 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(192468), // Rule ID 11599 //
     /* 192436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 192460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192466 */     GIR_RootConstrainSelectedInstOperands,
     /* 192467 */     // GIR_Coverage, 11599,
     /* 192467 */     GIR_EraseRootFromParent_Done,
     /* 192468 */   // Label 3815: @192468
     /* 192468 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192505), // Rule ID 11600 //
     /* 192473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 192497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192503 */     GIR_RootConstrainSelectedInstOperands,
     /* 192504 */     // GIR_Coverage, 11600,
     /* 192504 */     GIR_EraseRootFromParent_Done,
     /* 192505 */   // Label 3816: @192505
     /* 192505 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192542), // Rule ID 11601 //
     /* 192510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192531 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 192534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192540 */     GIR_RootConstrainSelectedInstOperands,
     /* 192541 */     // GIR_Coverage, 11601,
     /* 192541 */     GIR_EraseRootFromParent_Done,
     /* 192542 */   // Label 3817: @192542
     /* 192542 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192579), // Rule ID 11602 //
     /* 192547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 192571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192577 */     GIR_RootConstrainSelectedInstOperands,
     /* 192578 */     // GIR_Coverage, 11602,
     /* 192578 */     GIR_EraseRootFromParent_Done,
     /* 192579 */   // Label 3818: @192579
     /* 192579 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192616), // Rule ID 11603 //
     /* 192584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 192608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192614 */     GIR_RootConstrainSelectedInstOperands,
     /* 192615 */     // GIR_Coverage, 11603,
     /* 192615 */     GIR_EraseRootFromParent_Done,
     /* 192616 */   // Label 3819: @192616
     /* 192616 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192653), // Rule ID 11604 //
     /* 192621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 192645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192651 */     GIR_RootConstrainSelectedInstOperands,
     /* 192652 */     // GIR_Coverage, 11604,
     /* 192652 */     GIR_EraseRootFromParent_Done,
     /* 192653 */   // Label 3820: @192653
     /* 192653 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192690), // Rule ID 11605 //
     /* 192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 192682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192688 */     GIR_RootConstrainSelectedInstOperands,
     /* 192689 */     // GIR_Coverage, 11605,
     /* 192689 */     GIR_EraseRootFromParent_Done,
     /* 192690 */   // Label 3821: @192690
     /* 192690 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192727), // Rule ID 11606 //
     /* 192695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 192719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192725 */     GIR_RootConstrainSelectedInstOperands,
     /* 192726 */     // GIR_Coverage, 11606,
     /* 192726 */     GIR_EraseRootFromParent_Done,
     /* 192727 */   // Label 3822: @192727
     /* 192727 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192764), // Rule ID 11607 //
     /* 192732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 192756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192762 */     GIR_RootConstrainSelectedInstOperands,
     /* 192763 */     // GIR_Coverage, 11607,
     /* 192763 */     GIR_EraseRootFromParent_Done,
     /* 192764 */   // Label 3823: @192764
     /* 192764 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(192801), // Rule ID 11608 //
     /* 192769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 192793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192799 */     GIR_RootConstrainSelectedInstOperands,
     /* 192800 */     // GIR_Coverage, 11608,
     /* 192800 */     GIR_EraseRootFromParent_Done,
     /* 192801 */   // Label 3824: @192801
     /* 192801 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(192838), // Rule ID 11609 //
     /* 192806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 192830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192836 */     GIR_RootConstrainSelectedInstOperands,
     /* 192837 */     // GIR_Coverage, 11609,
     /* 192837 */     GIR_EraseRootFromParent_Done,
     /* 192838 */   // Label 3825: @192838
     /* 192838 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(192875), // Rule ID 11610 //
     /* 192843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 192867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192873 */     GIR_RootConstrainSelectedInstOperands,
     /* 192874 */     // GIR_Coverage, 11610,
     /* 192874 */     GIR_EraseRootFromParent_Done,
     /* 192875 */   // Label 3826: @192875
     /* 192875 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(192912), // Rule ID 11611 //
     /* 192880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 192904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192910 */     GIR_RootConstrainSelectedInstOperands,
     /* 192911 */     // GIR_Coverage, 11611,
     /* 192911 */     GIR_EraseRootFromParent_Done,
     /* 192912 */   // Label 3827: @192912
     /* 192912 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(192949), // Rule ID 11612 //
     /* 192917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 192941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192947 */     GIR_RootConstrainSelectedInstOperands,
     /* 192948 */     // GIR_Coverage, 11612,
     /* 192948 */     GIR_EraseRootFromParent_Done,
     /* 192949 */   // Label 3828: @192949
     /* 192949 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(192986), // Rule ID 11613 //
     /* 192954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1984:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 192978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192984 */     GIR_RootConstrainSelectedInstOperands,
     /* 192985 */     // GIR_Coverage, 11613,
     /* 192985 */     GIR_EraseRootFromParent_Done,
     /* 192986 */   // Label 3829: @192986
     /* 192986 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193023), // Rule ID 11614 //
     /* 192991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 193015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193021 */     GIR_RootConstrainSelectedInstOperands,
     /* 193022 */     // GIR_Coverage, 11614,
     /* 193022 */     GIR_EraseRootFromParent_Done,
     /* 193023 */   // Label 3830: @193023
     /* 193023 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193060), // Rule ID 11615 //
     /* 193028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 193052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193058 */     GIR_RootConstrainSelectedInstOperands,
     /* 193059 */     // GIR_Coverage, 11615,
     /* 193059 */     GIR_EraseRootFromParent_Done,
     /* 193060 */   // Label 3831: @193060
     /* 193060 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193097), // Rule ID 11616 //
     /* 193065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 193089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193095 */     GIR_RootConstrainSelectedInstOperands,
     /* 193096 */     // GIR_Coverage, 11616,
     /* 193096 */     GIR_EraseRootFromParent_Done,
     /* 193097 */   // Label 3832: @193097
     /* 193097 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193134), // Rule ID 11617 //
     /* 193102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 193126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193132 */     GIR_RootConstrainSelectedInstOperands,
     /* 193133 */     // GIR_Coverage, 11617,
     /* 193133 */     GIR_EraseRootFromParent_Done,
     /* 193134 */   // Label 3833: @193134
     /* 193134 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193171), // Rule ID 11618 //
     /* 193139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 193163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193169 */     GIR_RootConstrainSelectedInstOperands,
     /* 193170 */     // GIR_Coverage, 11618,
     /* 193170 */     GIR_EraseRootFromParent_Done,
     /* 193171 */   // Label 3834: @193171
     /* 193171 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193208), // Rule ID 11619 //
     /* 193176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193197 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1624:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 193200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193206 */     GIR_RootConstrainSelectedInstOperands,
     /* 193207 */     // GIR_Coverage, 11619,
     /* 193207 */     GIR_EraseRootFromParent_Done,
     /* 193208 */   // Label 3835: @193208
     /* 193208 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193245), // Rule ID 11620 //
     /* 193213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 193237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193243 */     GIR_RootConstrainSelectedInstOperands,
     /* 193244 */     // GIR_Coverage, 11620,
     /* 193244 */     GIR_EraseRootFromParent_Done,
     /* 193245 */   // Label 3836: @193245
     /* 193245 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193282), // Rule ID 11721 //
     /* 193250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1654:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 193274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193280 */     GIR_RootConstrainSelectedInstOperands,
     /* 193281 */     // GIR_Coverage, 11721,
     /* 193281 */     GIR_EraseRootFromParent_Done,
     /* 193282 */   // Label 3837: @193282
     /* 193282 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193319), // Rule ID 11722 //
     /* 193287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 193311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193317 */     GIR_RootConstrainSelectedInstOperands,
     /* 193318 */     // GIR_Coverage, 11722,
     /* 193318 */     GIR_EraseRootFromParent_Done,
     /* 193319 */   // Label 3838: @193319
     /* 193319 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193356), // Rule ID 11723 //
     /* 193324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 193348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193354 */     GIR_RootConstrainSelectedInstOperands,
     /* 193355 */     // GIR_Coverage, 11723,
     /* 193355 */     GIR_EraseRootFromParent_Done,
     /* 193356 */   // Label 3839: @193356
     /* 193356 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193393), // Rule ID 11724 //
     /* 193361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1895:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 193385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193391 */     GIR_RootConstrainSelectedInstOperands,
     /* 193392 */     // GIR_Coverage, 11724,
     /* 193392 */     GIR_EraseRootFromParent_Done,
     /* 193393 */   // Label 3840: @193393
     /* 193393 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193430), // Rule ID 11725 //
     /* 193398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1895:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 193422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193428 */     GIR_RootConstrainSelectedInstOperands,
     /* 193429 */     // GIR_Coverage, 11725,
     /* 193429 */     GIR_EraseRootFromParent_Done,
     /* 193430 */   // Label 3841: @193430
     /* 193430 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(193467), // Rule ID 11726 //
     /* 193435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1895:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 193459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193465 */     GIR_RootConstrainSelectedInstOperands,
     /* 193466 */     // GIR_Coverage, 11726,
     /* 193466 */     GIR_EraseRootFromParent_Done,
     /* 193467 */   // Label 3842: @193467
     /* 193467 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193504), // Rule ID 11727 //
     /* 193472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1670:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 193496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193502 */     GIR_RootConstrainSelectedInstOperands,
     /* 193503 */     // GIR_Coverage, 11727,
     /* 193503 */     GIR_EraseRootFromParent_Done,
     /* 193504 */   // Label 3843: @193504
     /* 193504 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193541), // Rule ID 11728 //
     /* 193509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1670:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 193533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193539 */     GIR_RootConstrainSelectedInstOperands,
     /* 193540 */     // GIR_Coverage, 11728,
     /* 193540 */     GIR_EraseRootFromParent_Done,
     /* 193541 */   // Label 3844: @193541
     /* 193541 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193578), // Rule ID 11729 //
     /* 193546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1670:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 193570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193576 */     GIR_RootConstrainSelectedInstOperands,
     /* 193577 */     // GIR_Coverage, 11729,
     /* 193577 */     GIR_EraseRootFromParent_Done,
     /* 193578 */   // Label 3845: @193578
     /* 193578 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193615), // Rule ID 11745 //
     /* 193583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 193607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193613 */     GIR_RootConstrainSelectedInstOperands,
     /* 193614 */     // GIR_Coverage, 11745,
     /* 193614 */     GIR_EraseRootFromParent_Done,
     /* 193615 */   // Label 3846: @193615
     /* 193615 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193652), // Rule ID 11746 //
     /* 193620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 193644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193650 */     GIR_RootConstrainSelectedInstOperands,
     /* 193651 */     // GIR_Coverage, 11746,
     /* 193651 */     GIR_EraseRootFromParent_Done,
     /* 193652 */   // Label 3847: @193652
     /* 193652 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193689), // Rule ID 11747 //
     /* 193657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 193681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193687 */     GIR_RootConstrainSelectedInstOperands,
     /* 193688 */     // GIR_Coverage, 11747,
     /* 193688 */     GIR_EraseRootFromParent_Done,
     /* 193689 */   // Label 3848: @193689
     /* 193689 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193726), // Rule ID 11748 //
     /* 193694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 193718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193724 */     GIR_RootConstrainSelectedInstOperands,
     /* 193725 */     // GIR_Coverage, 11748,
     /* 193725 */     GIR_EraseRootFromParent_Done,
     /* 193726 */   // Label 3849: @193726
     /* 193726 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193763), // Rule ID 11749 //
     /* 193731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 193755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193761 */     GIR_RootConstrainSelectedInstOperands,
     /* 193762 */     // GIR_Coverage, 11749,
     /* 193762 */     GIR_EraseRootFromParent_Done,
     /* 193763 */   // Label 3850: @193763
     /* 193763 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(193800), // Rule ID 11750 //
     /* 193768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 193792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193798 */     GIR_RootConstrainSelectedInstOperands,
     /* 193799 */     // GIR_Coverage, 11750,
     /* 193799 */     GIR_EraseRootFromParent_Done,
     /* 193800 */   // Label 3851: @193800
     /* 193800 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(193837), // Rule ID 11766 //
     /* 193805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 193829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193835 */     GIR_RootConstrainSelectedInstOperands,
     /* 193836 */     // GIR_Coverage, 11766,
     /* 193836 */     GIR_EraseRootFromParent_Done,
     /* 193837 */   // Label 3852: @193837
     /* 193837 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(193874), // Rule ID 11767 //
     /* 193842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193863 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 193866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193872 */     GIR_RootConstrainSelectedInstOperands,
     /* 193873 */     // GIR_Coverage, 11767,
     /* 193873 */     GIR_EraseRootFromParent_Done,
     /* 193874 */   // Label 3853: @193874
     /* 193874 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(193911), // Rule ID 11768 //
     /* 193879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1860:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 193903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193909 */     GIR_RootConstrainSelectedInstOperands,
     /* 193910 */     // GIR_Coverage, 11768,
     /* 193910 */     GIR_EraseRootFromParent_Done,
     /* 193911 */   // Label 3854: @193911
     /* 193911 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(193948), // Rule ID 11769 //
     /* 193916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 193940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193946 */     GIR_RootConstrainSelectedInstOperands,
     /* 193947 */     // GIR_Coverage, 11769,
     /* 193947 */     GIR_EraseRootFromParent_Done,
     /* 193948 */   // Label 3855: @193948
     /* 193948 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(193985), // Rule ID 11770 //
     /* 193953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 193977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193983 */     GIR_RootConstrainSelectedInstOperands,
     /* 193984 */     // GIR_Coverage, 11770,
     /* 193984 */     GIR_EraseRootFromParent_Done,
     /* 193985 */   // Label 3856: @193985
     /* 193985 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194022), // Rule ID 11771 //
     /* 193990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 194014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194020 */     GIR_RootConstrainSelectedInstOperands,
     /* 194021 */     // GIR_Coverage, 11771,
     /* 194021 */     GIR_EraseRootFromParent_Done,
     /* 194022 */   // Label 3857: @194022
     /* 194022 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194062), // Rule ID 11846 //
     /* 194027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 194051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194060 */     GIR_RootConstrainSelectedInstOperands,
     /* 194061 */     // GIR_Coverage, 11846,
     /* 194061 */     GIR_EraseRootFromParent_Done,
     /* 194062 */   // Label 3858: @194062
     /* 194062 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194102), // Rule ID 11847 //
     /* 194067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 194091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194100 */     GIR_RootConstrainSelectedInstOperands,
     /* 194101 */     // GIR_Coverage, 11847,
     /* 194101 */     GIR_EraseRootFromParent_Done,
     /* 194102 */   // Label 3859: @194102
     /* 194102 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194142), // Rule ID 11848 //
     /* 194107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194128 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 194131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194140 */     GIR_RootConstrainSelectedInstOperands,
     /* 194141 */     // GIR_Coverage, 11848,
     /* 194141 */     GIR_EraseRootFromParent_Done,
     /* 194142 */   // Label 3860: @194142
     /* 194142 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194182), // Rule ID 11849 //
     /* 194147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 194171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194180 */     GIR_RootConstrainSelectedInstOperands,
     /* 194181 */     // GIR_Coverage, 11849,
     /* 194181 */     GIR_EraseRootFromParent_Done,
     /* 194182 */   // Label 3861: @194182
     /* 194182 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194222), // Rule ID 11850 //
     /* 194187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 194211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194220 */     GIR_RootConstrainSelectedInstOperands,
     /* 194221 */     // GIR_Coverage, 11850,
     /* 194221 */     GIR_EraseRootFromParent_Done,
     /* 194222 */   // Label 3862: @194222
     /* 194222 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194262), // Rule ID 11851 //
     /* 194227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 194251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194260 */     GIR_RootConstrainSelectedInstOperands,
     /* 194261 */     // GIR_Coverage, 11851,
     /* 194261 */     GIR_EraseRootFromParent_Done,
     /* 194262 */   // Label 3863: @194262
     /* 194262 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194302), // Rule ID 11852 //
     /* 194267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 194291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194300 */     GIR_RootConstrainSelectedInstOperands,
     /* 194301 */     // GIR_Coverage, 11852,
     /* 194301 */     GIR_EraseRootFromParent_Done,
     /* 194302 */   // Label 3864: @194302
     /* 194302 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194342), // Rule ID 11853 //
     /* 194307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 194331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194340 */     GIR_RootConstrainSelectedInstOperands,
     /* 194341 */     // GIR_Coverage, 11853,
     /* 194341 */     GIR_EraseRootFromParent_Done,
     /* 194342 */   // Label 3865: @194342
     /* 194342 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194382), // Rule ID 11858 //
     /* 194347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 194371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194380 */     GIR_RootConstrainSelectedInstOperands,
     /* 194381 */     // GIR_Coverage, 11858,
     /* 194381 */     GIR_EraseRootFromParent_Done,
     /* 194382 */   // Label 3866: @194382
     /* 194382 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194422), // Rule ID 11859 //
     /* 194387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194408 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 194411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194420 */     GIR_RootConstrainSelectedInstOperands,
     /* 194421 */     // GIR_Coverage, 11859,
     /* 194421 */     GIR_EraseRootFromParent_Done,
     /* 194422 */   // Label 3867: @194422
     /* 194422 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194462), // Rule ID 11860 //
     /* 194427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 194451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194460 */     GIR_RootConstrainSelectedInstOperands,
     /* 194461 */     // GIR_Coverage, 11860,
     /* 194461 */     GIR_EraseRootFromParent_Done,
     /* 194462 */   // Label 3868: @194462
     /* 194462 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194502), // Rule ID 11861 //
     /* 194467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 194491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194500 */     GIR_RootConstrainSelectedInstOperands,
     /* 194501 */     // GIR_Coverage, 11861,
     /* 194501 */     GIR_EraseRootFromParent_Done,
     /* 194502 */   // Label 3869: @194502
     /* 194502 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194542), // Rule ID 11862 //
     /* 194507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 194531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194540 */     GIR_RootConstrainSelectedInstOperands,
     /* 194541 */     // GIR_Coverage, 11862,
     /* 194541 */     GIR_EraseRootFromParent_Done,
     /* 194542 */   // Label 3870: @194542
     /* 194542 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194582), // Rule ID 11863 //
     /* 194547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194568 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 194571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194580 */     GIR_RootConstrainSelectedInstOperands,
     /* 194581 */     // GIR_Coverage, 11863,
     /* 194581 */     GIR_EraseRootFromParent_Done,
     /* 194582 */   // Label 3871: @194582
     /* 194582 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194622), // Rule ID 11864 //
     /* 194587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 194611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194620 */     GIR_RootConstrainSelectedInstOperands,
     /* 194621 */     // GIR_Coverage, 11864,
     /* 194621 */     GIR_EraseRootFromParent_Done,
     /* 194622 */   // Label 3872: @194622
     /* 194622 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194662), // Rule ID 11865 //
     /* 194627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194648 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 194651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194660 */     GIR_RootConstrainSelectedInstOperands,
     /* 194661 */     // GIR_Coverage, 11865,
     /* 194661 */     GIR_EraseRootFromParent_Done,
     /* 194662 */   // Label 3873: @194662
     /* 194662 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194702), // Rule ID 11870 //
     /* 194667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 194691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194700 */     GIR_RootConstrainSelectedInstOperands,
     /* 194701 */     // GIR_Coverage, 11870,
     /* 194701 */     GIR_EraseRootFromParent_Done,
     /* 194702 */   // Label 3874: @194702
     /* 194702 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194742), // Rule ID 11871 //
     /* 194707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 194731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194740 */     GIR_RootConstrainSelectedInstOperands,
     /* 194741 */     // GIR_Coverage, 11871,
     /* 194741 */     GIR_EraseRootFromParent_Done,
     /* 194742 */   // Label 3875: @194742
     /* 194742 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194782), // Rule ID 11872 //
     /* 194747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 194771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194780 */     GIR_RootConstrainSelectedInstOperands,
     /* 194781 */     // GIR_Coverage, 11872,
     /* 194781 */     GIR_EraseRootFromParent_Done,
     /* 194782 */   // Label 3876: @194782
     /* 194782 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194822), // Rule ID 11873 //
     /* 194787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 194811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194820 */     GIR_RootConstrainSelectedInstOperands,
     /* 194821 */     // GIR_Coverage, 11873,
     /* 194821 */     GIR_EraseRootFromParent_Done,
     /* 194822 */   // Label 3877: @194822
     /* 194822 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194862), // Rule ID 11874 //
     /* 194827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 194851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194860 */     GIR_RootConstrainSelectedInstOperands,
     /* 194861 */     // GIR_Coverage, 11874,
     /* 194861 */     GIR_EraseRootFromParent_Done,
     /* 194862 */   // Label 3878: @194862
     /* 194862 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(194902), // Rule ID 11875 //
     /* 194867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 194891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194900 */     GIR_RootConstrainSelectedInstOperands,
     /* 194901 */     // GIR_Coverage, 11875,
     /* 194901 */     GIR_EraseRootFromParent_Done,
     /* 194902 */   // Label 3879: @194902
     /* 194902 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(194942), // Rule ID 11876 //
     /* 194907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 194931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194940 */     GIR_RootConstrainSelectedInstOperands,
     /* 194941 */     // GIR_Coverage, 11876,
     /* 194941 */     GIR_EraseRootFromParent_Done,
     /* 194942 */   // Label 3880: @194942
     /* 194942 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(194982), // Rule ID 11877 //
     /* 194947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 194971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194980 */     GIR_RootConstrainSelectedInstOperands,
     /* 194981 */     // GIR_Coverage, 11877,
     /* 194981 */     GIR_EraseRootFromParent_Done,
     /* 194982 */   // Label 3881: @194982
     /* 194982 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195022), // Rule ID 11882 //
     /* 194987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 195011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195020 */     GIR_RootConstrainSelectedInstOperands,
     /* 195021 */     // GIR_Coverage, 11882,
     /* 195021 */     GIR_EraseRootFromParent_Done,
     /* 195022 */   // Label 3882: @195022
     /* 195022 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195062), // Rule ID 11883 //
     /* 195027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 195051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195060 */     GIR_RootConstrainSelectedInstOperands,
     /* 195061 */     // GIR_Coverage, 11883,
     /* 195061 */     GIR_EraseRootFromParent_Done,
     /* 195062 */   // Label 3883: @195062
     /* 195062 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195102), // Rule ID 11884 //
     /* 195067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 195091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195100 */     GIR_RootConstrainSelectedInstOperands,
     /* 195101 */     // GIR_Coverage, 11884,
     /* 195101 */     GIR_EraseRootFromParent_Done,
     /* 195102 */   // Label 3884: @195102
     /* 195102 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195142), // Rule ID 11885 //
     /* 195107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 195131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195140 */     GIR_RootConstrainSelectedInstOperands,
     /* 195141 */     // GIR_Coverage, 11885,
     /* 195141 */     GIR_EraseRootFromParent_Done,
     /* 195142 */   // Label 3885: @195142
     /* 195142 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195182), // Rule ID 11886 //
     /* 195147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 195171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195180 */     GIR_RootConstrainSelectedInstOperands,
     /* 195181 */     // GIR_Coverage, 11886,
     /* 195181 */     GIR_EraseRootFromParent_Done,
     /* 195182 */   // Label 3886: @195182
     /* 195182 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195222), // Rule ID 11887 //
     /* 195187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 195211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195220 */     GIR_RootConstrainSelectedInstOperands,
     /* 195221 */     // GIR_Coverage, 11887,
     /* 195221 */     GIR_EraseRootFromParent_Done,
     /* 195222 */   // Label 3887: @195222
     /* 195222 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195262), // Rule ID 11888 //
     /* 195227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 195251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195260 */     GIR_RootConstrainSelectedInstOperands,
     /* 195261 */     // GIR_Coverage, 11888,
     /* 195261 */     GIR_EraseRootFromParent_Done,
     /* 195262 */   // Label 3888: @195262
     /* 195262 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195302), // Rule ID 11889 //
     /* 195267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 195291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195300 */     GIR_RootConstrainSelectedInstOperands,
     /* 195301 */     // GIR_Coverage, 11889,
     /* 195301 */     GIR_EraseRootFromParent_Done,
     /* 195302 */   // Label 3889: @195302
     /* 195302 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195339), // Rule ID 11898 //
     /* 195307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 195315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 195331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195337 */     GIR_RootConstrainSelectedInstOperands,
     /* 195338 */     // GIR_Coverage, 11898,
     /* 195338 */     GIR_EraseRootFromParent_Done,
     /* 195339 */   // Label 3890: @195339
     /* 195339 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195376), // Rule ID 11900 //
     /* 195344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 195368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195374 */     GIR_RootConstrainSelectedInstOperands,
     /* 195375 */     // GIR_Coverage, 11900,
     /* 195375 */     GIR_EraseRootFromParent_Done,
     /* 195376 */   // Label 3891: @195376
     /* 195376 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195413), // Rule ID 11901 //
     /* 195381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 195384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 195389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1715:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 195405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195411 */     GIR_RootConstrainSelectedInstOperands,
     /* 195412 */     // GIR_Coverage, 11901,
     /* 195412 */     GIR_EraseRootFromParent_Done,
     /* 195413 */   // Label 3892: @195413
     /* 195413 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195450), // Rule ID 11902 //
     /* 195418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 195421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 195426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1656:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 195442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195448 */     GIR_RootConstrainSelectedInstOperands,
     /* 195449 */     // GIR_Coverage, 11902,
     /* 195449 */     GIR_EraseRootFromParent_Done,
     /* 195450 */   // Label 3893: @195450
     /* 195450 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195487), // Rule ID 11903 //
     /* 195455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1264:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 195479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195485 */     GIR_RootConstrainSelectedInstOperands,
     /* 195486 */     // GIR_Coverage, 11903,
     /* 195486 */     GIR_EraseRootFromParent_Done,
     /* 195487 */   // Label 3894: @195487
     /* 195487 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195524), // Rule ID 11904 //
     /* 195492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1264:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 195516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195522 */     GIR_RootConstrainSelectedInstOperands,
     /* 195523 */     // GIR_Coverage, 11904,
     /* 195523 */     GIR_EraseRootFromParent_Done,
     /* 195524 */   // Label 3895: @195524
     /* 195524 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195561), // Rule ID 11905 //
     /* 195529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 195553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195559 */     GIR_RootConstrainSelectedInstOperands,
     /* 195560 */     // GIR_Coverage, 11905,
     /* 195560 */     GIR_EraseRootFromParent_Done,
     /* 195561 */   // Label 3896: @195561
     /* 195561 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195598), // Rule ID 11906 //
     /* 195566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 195590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195596 */     GIR_RootConstrainSelectedInstOperands,
     /* 195597 */     // GIR_Coverage, 11906,
     /* 195597 */     GIR_EraseRootFromParent_Done,
     /* 195598 */   // Label 3897: @195598
     /* 195598 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195635), // Rule ID 11907 //
     /* 195603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1281:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 195627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195633 */     GIR_RootConstrainSelectedInstOperands,
     /* 195634 */     // GIR_Coverage, 11907,
     /* 195634 */     GIR_EraseRootFromParent_Done,
     /* 195635 */   // Label 3898: @195635
     /* 195635 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195672), // Rule ID 11908 //
     /* 195640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1281:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 195664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195670 */     GIR_RootConstrainSelectedInstOperands,
     /* 195671 */     // GIR_Coverage, 11908,
     /* 195671 */     GIR_EraseRootFromParent_Done,
     /* 195672 */   // Label 3899: @195672
     /* 195672 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195709), // Rule ID 11909 //
     /* 195677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1281:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 195701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195707 */     GIR_RootConstrainSelectedInstOperands,
     /* 195708 */     // GIR_Coverage, 11909,
     /* 195708 */     GIR_EraseRootFromParent_Done,
     /* 195709 */   // Label 3900: @195709
     /* 195709 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195746), // Rule ID 11910 //
     /* 195714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1281:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 195738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195744 */     GIR_RootConstrainSelectedInstOperands,
     /* 195745 */     // GIR_Coverage, 11910,
     /* 195745 */     GIR_EraseRootFromParent_Done,
     /* 195746 */   // Label 3901: @195746
     /* 195746 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195783), // Rule ID 12023 //
     /* 195751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195772 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1430:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 195775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195781 */     GIR_RootConstrainSelectedInstOperands,
     /* 195782 */     // GIR_Coverage, 12023,
     /* 195782 */     GIR_EraseRootFromParent_Done,
     /* 195783 */   // Label 3902: @195783
     /* 195783 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195820), // Rule ID 12024 //
     /* 195788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195809 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1430:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 195812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195818 */     GIR_RootConstrainSelectedInstOperands,
     /* 195819 */     // GIR_Coverage, 12024,
     /* 195819 */     GIR_EraseRootFromParent_Done,
     /* 195820 */   // Label 3903: @195820
     /* 195820 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195857), // Rule ID 12025 //
     /* 195825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195846 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1430:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 195849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195855 */     GIR_RootConstrainSelectedInstOperands,
     /* 195856 */     // GIR_Coverage, 12025,
     /* 195856 */     GIR_EraseRootFromParent_Done,
     /* 195857 */   // Label 3904: @195857
     /* 195857 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195894), // Rule ID 12026 //
     /* 195862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195883 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 195886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195892 */     GIR_RootConstrainSelectedInstOperands,
     /* 195893 */     // GIR_Coverage, 12026,
     /* 195893 */     GIR_EraseRootFromParent_Done,
     /* 195894 */   // Label 3905: @195894
     /* 195894 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195931), // Rule ID 12027 //
     /* 195899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195920 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 195923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195929 */     GIR_RootConstrainSelectedInstOperands,
     /* 195930 */     // GIR_Coverage, 12027,
     /* 195930 */     GIR_EraseRootFromParent_Done,
     /* 195931 */   // Label 3906: @195931
     /* 195931 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195968), // Rule ID 12028 //
     /* 195936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195957 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 195960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195966 */     GIR_RootConstrainSelectedInstOperands,
     /* 195967 */     // GIR_Coverage, 12028,
     /* 195967 */     GIR_EraseRootFromParent_Done,
     /* 195968 */   // Label 3907: @195968
     /* 195968 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196005), // Rule ID 12029 //
     /* 195973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195994 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1433:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 195997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196003 */     GIR_RootConstrainSelectedInstOperands,
     /* 196004 */     // GIR_Coverage, 12029,
     /* 196004 */     GIR_EraseRootFromParent_Done,
     /* 196005 */   // Label 3908: @196005
     /* 196005 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196042), // Rule ID 12030 //
     /* 196010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196031 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1433:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 196034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196040 */     GIR_RootConstrainSelectedInstOperands,
     /* 196041 */     // GIR_Coverage, 12030,
     /* 196041 */     GIR_EraseRootFromParent_Done,
     /* 196042 */   // Label 3909: @196042
     /* 196042 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196079), // Rule ID 12031 //
     /* 196047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196068 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1433:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 196071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196077 */     GIR_RootConstrainSelectedInstOperands,
     /* 196078 */     // GIR_Coverage, 12031,
     /* 196078 */     GIR_EraseRootFromParent_Done,
     /* 196079 */   // Label 3910: @196079
     /* 196079 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196116), // Rule ID 12032 //
     /* 196084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196105 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1451:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 196108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196114 */     GIR_RootConstrainSelectedInstOperands,
     /* 196115 */     // GIR_Coverage, 12032,
     /* 196115 */     GIR_EraseRootFromParent_Done,
     /* 196116 */   // Label 3911: @196116
     /* 196116 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196153), // Rule ID 12033 //
     /* 196121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196142 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 196145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196151 */     GIR_RootConstrainSelectedInstOperands,
     /* 196152 */     // GIR_Coverage, 12033,
     /* 196152 */     GIR_EraseRootFromParent_Done,
     /* 196153 */   // Label 3912: @196153
     /* 196153 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196190), // Rule ID 12034 //
     /* 196158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196179 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 196182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196188 */     GIR_RootConstrainSelectedInstOperands,
     /* 196189 */     // GIR_Coverage, 12034,
     /* 196189 */     GIR_EraseRootFromParent_Done,
     /* 196190 */   // Label 3913: @196190
     /* 196190 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196227), // Rule ID 12035 //
     /* 196195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196216 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1345:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 196219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196225 */     GIR_RootConstrainSelectedInstOperands,
     /* 196226 */     // GIR_Coverage, 12035,
     /* 196226 */     GIR_EraseRootFromParent_Done,
     /* 196227 */   // Label 3914: @196227
     /* 196227 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196264), // Rule ID 12036 //
     /* 196232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196253 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 196256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196262 */     GIR_RootConstrainSelectedInstOperands,
     /* 196263 */     // GIR_Coverage, 12036,
     /* 196263 */     GIR_EraseRootFromParent_Done,
     /* 196264 */   // Label 3915: @196264
     /* 196264 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196301), // Rule ID 12037 //
     /* 196269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196290 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 196293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196299 */     GIR_RootConstrainSelectedInstOperands,
     /* 196300 */     // GIR_Coverage, 12037,
     /* 196300 */     GIR_EraseRootFromParent_Done,
     /* 196301 */   // Label 3916: @196301
     /* 196301 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196338), // Rule ID 12038 //
     /* 196306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196327 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 196330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196336 */     GIR_RootConstrainSelectedInstOperands,
     /* 196337 */     // GIR_Coverage, 12038,
     /* 196337 */     GIR_EraseRootFromParent_Done,
     /* 196338 */   // Label 3917: @196338
     /* 196338 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196375), // Rule ID 12039 //
     /* 196343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196364 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1257:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 196367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196373 */     GIR_RootConstrainSelectedInstOperands,
     /* 196374 */     // GIR_Coverage, 12039,
     /* 196374 */     GIR_EraseRootFromParent_Done,
     /* 196375 */   // Label 3918: @196375
     /* 196375 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196412), // Rule ID 12040 //
     /* 196380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196401 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1257:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 196404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196410 */     GIR_RootConstrainSelectedInstOperands,
     /* 196411 */     // GIR_Coverage, 12040,
     /* 196411 */     GIR_EraseRootFromParent_Done,
     /* 196412 */   // Label 3919: @196412
     /* 196412 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196449), // Rule ID 12041 //
     /* 196417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196438 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1257:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 196441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196447 */     GIR_RootConstrainSelectedInstOperands,
     /* 196448 */     // GIR_Coverage, 12041,
     /* 196448 */     GIR_EraseRootFromParent_Done,
     /* 196449 */   // Label 3920: @196449
     /* 196449 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196486), // Rule ID 12042 //
     /* 196454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196475 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1257:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 196478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196484 */     GIR_RootConstrainSelectedInstOperands,
     /* 196485 */     // GIR_Coverage, 12042,
     /* 196485 */     GIR_EraseRootFromParent_Done,
     /* 196486 */   // Label 3921: @196486
     /* 196486 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196523), // Rule ID 12043 //
     /* 196491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196512 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1245:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 196515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196521 */     GIR_RootConstrainSelectedInstOperands,
     /* 196522 */     // GIR_Coverage, 12043,
     /* 196522 */     GIR_EraseRootFromParent_Done,
     /* 196523 */   // Label 3922: @196523
     /* 196523 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196560), // Rule ID 12044 //
     /* 196528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196549 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1245:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 196552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196558 */     GIR_RootConstrainSelectedInstOperands,
     /* 196559 */     // GIR_Coverage, 12044,
     /* 196559 */     GIR_EraseRootFromParent_Done,
     /* 196560 */   // Label 3923: @196560
     /* 196560 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196597), // Rule ID 12045 //
     /* 196565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1245:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 196589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196595 */     GIR_RootConstrainSelectedInstOperands,
     /* 196596 */     // GIR_Coverage, 12045,
     /* 196596 */     GIR_EraseRootFromParent_Done,
     /* 196597 */   // Label 3924: @196597
     /* 196597 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196634), // Rule ID 12046 //
     /* 196602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196623 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1245:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 196626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196632 */     GIR_RootConstrainSelectedInstOperands,
     /* 196633 */     // GIR_Coverage, 12046,
     /* 196633 */     GIR_EraseRootFromParent_Done,
     /* 196634 */   // Label 3925: @196634
     /* 196634 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196671), // Rule ID 12047 //
     /* 196639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196660 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1724:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 196663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196669 */     GIR_RootConstrainSelectedInstOperands,
     /* 196670 */     // GIR_Coverage, 12047,
     /* 196670 */     GIR_EraseRootFromParent_Done,
     /* 196671 */   // Label 3926: @196671
     /* 196671 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196708), // Rule ID 12048 //
     /* 196676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1724:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 196700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196706 */     GIR_RootConstrainSelectedInstOperands,
     /* 196707 */     // GIR_Coverage, 12048,
     /* 196707 */     GIR_EraseRootFromParent_Done,
     /* 196708 */   // Label 3927: @196708
     /* 196708 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196745), // Rule ID 12049 //
     /* 196713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196734 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1724:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 196737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196743 */     GIR_RootConstrainSelectedInstOperands,
     /* 196744 */     // GIR_Coverage, 12049,
     /* 196744 */     GIR_EraseRootFromParent_Done,
     /* 196745 */   // Label 3928: @196745
     /* 196745 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196782), // Rule ID 12050 //
     /* 196750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196771 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1724:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 196774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196780 */     GIR_RootConstrainSelectedInstOperands,
     /* 196781 */     // GIR_Coverage, 12050,
     /* 196781 */     GIR_EraseRootFromParent_Done,
     /* 196782 */   // Label 3929: @196782
     /* 196782 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196819), // Rule ID 12051 //
     /* 196787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196808 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 196811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196817 */     GIR_RootConstrainSelectedInstOperands,
     /* 196818 */     // GIR_Coverage, 12051,
     /* 196818 */     GIR_EraseRootFromParent_Done,
     /* 196819 */   // Label 3930: @196819
     /* 196819 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(196856), // Rule ID 12052 //
     /* 196824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196845 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 196848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196854 */     GIR_RootConstrainSelectedInstOperands,
     /* 196855 */     // GIR_Coverage, 12052,
     /* 196855 */     GIR_EraseRootFromParent_Done,
     /* 196856 */   // Label 3931: @196856
     /* 196856 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(196893), // Rule ID 12053 //
     /* 196861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 196885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196891 */     GIR_RootConstrainSelectedInstOperands,
     /* 196892 */     // GIR_Coverage, 12053,
     /* 196892 */     GIR_EraseRootFromParent_Done,
     /* 196893 */   // Label 3932: @196893
     /* 196893 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(196930), // Rule ID 12054 //
     /* 196898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196919 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 196922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196928 */     GIR_RootConstrainSelectedInstOperands,
     /* 196929 */     // GIR_Coverage, 12054,
     /* 196929 */     GIR_EraseRootFromParent_Done,
     /* 196930 */   // Label 3933: @196930
     /* 196930 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(196967), // Rule ID 12055 //
     /* 196935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196956 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1733:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 196959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196965 */     GIR_RootConstrainSelectedInstOperands,
     /* 196966 */     // GIR_Coverage, 12055,
     /* 196966 */     GIR_EraseRootFromParent_Done,
     /* 196967 */   // Label 3934: @196967
     /* 196967 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197004), // Rule ID 12056 //
     /* 196972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196993 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1733:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 196996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197002 */     GIR_RootConstrainSelectedInstOperands,
     /* 197003 */     // GIR_Coverage, 12056,
     /* 197003 */     GIR_EraseRootFromParent_Done,
     /* 197004 */   // Label 3935: @197004
     /* 197004 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197041), // Rule ID 12057 //
     /* 197009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1733:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 197033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197039 */     GIR_RootConstrainSelectedInstOperands,
     /* 197040 */     // GIR_Coverage, 12057,
     /* 197040 */     GIR_EraseRootFromParent_Done,
     /* 197041 */   // Label 3936: @197041
     /* 197041 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197078), // Rule ID 12058 //
     /* 197046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197067 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1733:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 197070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197076 */     GIR_RootConstrainSelectedInstOperands,
     /* 197077 */     // GIR_Coverage, 12058,
     /* 197077 */     GIR_EraseRootFromParent_Done,
     /* 197078 */   // Label 3937: @197078
     /* 197078 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197115), // Rule ID 12059 //
     /* 197083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197104 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1971:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 197107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197113 */     GIR_RootConstrainSelectedInstOperands,
     /* 197114 */     // GIR_Coverage, 12059,
     /* 197114 */     GIR_EraseRootFromParent_Done,
     /* 197115 */   // Label 3938: @197115
     /* 197115 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197152), // Rule ID 12060 //
     /* 197120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197141 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1971:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 197144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197150 */     GIR_RootConstrainSelectedInstOperands,
     /* 197151 */     // GIR_Coverage, 12060,
     /* 197151 */     GIR_EraseRootFromParent_Done,
     /* 197152 */   // Label 3939: @197152
     /* 197152 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197189), // Rule ID 12061 //
     /* 197157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1971:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 197181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197187 */     GIR_RootConstrainSelectedInstOperands,
     /* 197188 */     // GIR_Coverage, 12061,
     /* 197188 */     GIR_EraseRootFromParent_Done,
     /* 197189 */   // Label 3940: @197189
     /* 197189 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197226), // Rule ID 12062 //
     /* 197194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197215 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1971:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 197218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197224 */     GIR_RootConstrainSelectedInstOperands,
     /* 197225 */     // GIR_Coverage, 12062,
     /* 197225 */     GIR_EraseRootFromParent_Done,
     /* 197226 */   // Label 3941: @197226
     /* 197226 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197263), // Rule ID 12063 //
     /* 197231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2155:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 197255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197261 */     GIR_RootConstrainSelectedInstOperands,
     /* 197262 */     // GIR_Coverage, 12063,
     /* 197262 */     GIR_EraseRootFromParent_Done,
     /* 197263 */   // Label 3942: @197263
     /* 197263 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197300), // Rule ID 12064 //
     /* 197268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2155:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197298 */     GIR_RootConstrainSelectedInstOperands,
     /* 197299 */     // GIR_Coverage, 12064,
     /* 197299 */     GIR_EraseRootFromParent_Done,
     /* 197300 */   // Label 3943: @197300
     /* 197300 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197337), // Rule ID 12065 //
     /* 197305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2155:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197335 */     GIR_RootConstrainSelectedInstOperands,
     /* 197336 */     // GIR_Coverage, 12065,
     /* 197336 */     GIR_EraseRootFromParent_Done,
     /* 197337 */   // Label 3944: @197337
     /* 197337 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197374), // Rule ID 12066 //
     /* 197342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2155:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197372 */     GIR_RootConstrainSelectedInstOperands,
     /* 197373 */     // GIR_Coverage, 12066,
     /* 197373 */     GIR_EraseRootFromParent_Done,
     /* 197374 */   // Label 3945: @197374
     /* 197374 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197411), // Rule ID 12067 //
     /* 197379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2155:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197409 */     GIR_RootConstrainSelectedInstOperands,
     /* 197410 */     // GIR_Coverage, 12067,
     /* 197410 */     GIR_EraseRootFromParent_Done,
     /* 197411 */   // Label 3946: @197411
     /* 197411 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197448), // Rule ID 12068 //
     /* 197416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2155:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197446 */     GIR_RootConstrainSelectedInstOperands,
     /* 197447 */     // GIR_Coverage, 12068,
     /* 197447 */     GIR_EraseRootFromParent_Done,
     /* 197448 */   // Label 3947: @197448
     /* 197448 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197485), // Rule ID 12069 //
     /* 197453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2155:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197483 */     GIR_RootConstrainSelectedInstOperands,
     /* 197484 */     // GIR_Coverage, 12069,
     /* 197484 */     GIR_EraseRootFromParent_Done,
     /* 197485 */   // Label 3948: @197485
     /* 197485 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197522), // Rule ID 12070 //
     /* 197490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197511 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 197514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197520 */     GIR_RootConstrainSelectedInstOperands,
     /* 197521 */     // GIR_Coverage, 12070,
     /* 197521 */     GIR_EraseRootFromParent_Done,
     /* 197522 */   // Label 3949: @197522
     /* 197522 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197559), // Rule ID 12071 //
     /* 197527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197557 */     GIR_RootConstrainSelectedInstOperands,
     /* 197558 */     // GIR_Coverage, 12071,
     /* 197558 */     GIR_EraseRootFromParent_Done,
     /* 197559 */   // Label 3950: @197559
     /* 197559 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197596), // Rule ID 12072 //
     /* 197564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197585 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197594 */     GIR_RootConstrainSelectedInstOperands,
     /* 197595 */     // GIR_Coverage, 12072,
     /* 197595 */     GIR_EraseRootFromParent_Done,
     /* 197596 */   // Label 3951: @197596
     /* 197596 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197633), // Rule ID 12073 //
     /* 197601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197631 */     GIR_RootConstrainSelectedInstOperands,
     /* 197632 */     // GIR_Coverage, 12073,
     /* 197632 */     GIR_EraseRootFromParent_Done,
     /* 197633 */   // Label 3952: @197633
     /* 197633 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197670), // Rule ID 12074 //
     /* 197638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197659 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197668 */     GIR_RootConstrainSelectedInstOperands,
     /* 197669 */     // GIR_Coverage, 12074,
     /* 197669 */     GIR_EraseRootFromParent_Done,
     /* 197670 */   // Label 3953: @197670
     /* 197670 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197707), // Rule ID 12075 //
     /* 197675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197696 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197705 */     GIR_RootConstrainSelectedInstOperands,
     /* 197706 */     // GIR_Coverage, 12075,
     /* 197706 */     GIR_EraseRootFromParent_Done,
     /* 197707 */   // Label 3954: @197707
     /* 197707 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197744), // Rule ID 12076 //
     /* 197712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197733 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197742 */     GIR_RootConstrainSelectedInstOperands,
     /* 197743 */     // GIR_Coverage, 12076,
     /* 197743 */     GIR_EraseRootFromParent_Done,
     /* 197744 */   // Label 3955: @197744
     /* 197744 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197781), // Rule ID 12077 //
     /* 197749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197770 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2081:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 197773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197779 */     GIR_RootConstrainSelectedInstOperands,
     /* 197780 */     // GIR_Coverage, 12077,
     /* 197780 */     GIR_EraseRootFromParent_Done,
     /* 197781 */   // Label 3956: @197781
     /* 197781 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(197818), // Rule ID 12078 //
     /* 197786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2081:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197816 */     GIR_RootConstrainSelectedInstOperands,
     /* 197817 */     // GIR_Coverage, 12078,
     /* 197817 */     GIR_EraseRootFromParent_Done,
     /* 197818 */   // Label 3957: @197818
     /* 197818 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(197855), // Rule ID 12079 //
     /* 197823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2081:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197853 */     GIR_RootConstrainSelectedInstOperands,
     /* 197854 */     // GIR_Coverage, 12079,
     /* 197854 */     GIR_EraseRootFromParent_Done,
     /* 197855 */   // Label 3958: @197855
     /* 197855 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(197892), // Rule ID 12080 //
     /* 197860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2081:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197890 */     GIR_RootConstrainSelectedInstOperands,
     /* 197891 */     // GIR_Coverage, 12080,
     /* 197891 */     GIR_EraseRootFromParent_Done,
     /* 197892 */   // Label 3959: @197892
     /* 197892 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(197929), // Rule ID 12081 //
     /* 197897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197918 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2081:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197927 */     GIR_RootConstrainSelectedInstOperands,
     /* 197928 */     // GIR_Coverage, 12081,
     /* 197928 */     GIR_EraseRootFromParent_Done,
     /* 197929 */   // Label 3960: @197929
     /* 197929 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(197966), // Rule ID 12082 //
     /* 197934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197955 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2081:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197964 */     GIR_RootConstrainSelectedInstOperands,
     /* 197965 */     // GIR_Coverage, 12082,
     /* 197965 */     GIR_EraseRootFromParent_Done,
     /* 197966 */   // Label 3961: @197966
     /* 197966 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198003), // Rule ID 12083 //
     /* 197971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197992 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2081:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198001 */     GIR_RootConstrainSelectedInstOperands,
     /* 198002 */     // GIR_Coverage, 12083,
     /* 198002 */     GIR_EraseRootFromParent_Done,
     /* 198003 */   // Label 3962: @198003
     /* 198003 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198045), // Rule ID 3218 //
     /* 198008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 198016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198023 */     // MIs[0] Op1
     /* 198023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198027 */     // MIs[0] Op2
     /* 198027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198031 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2134:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 198034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198043 */     GIR_RootConstrainSelectedInstOperands,
     /* 198044 */     // GIR_Coverage, 3218,
     /* 198044 */     GIR_EraseRootFromParent_Done,
     /* 198045 */   // Label 3963: @198045
     /* 198045 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198087), // Rule ID 3219 //
     /* 198050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 198058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198065 */     // MIs[0] Op1
     /* 198065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198069 */     // MIs[0] Op2
     /* 198069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198073 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 198076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198085 */     GIR_RootConstrainSelectedInstOperands,
     /* 198086 */     // GIR_Coverage, 3219,
     /* 198086 */     GIR_EraseRootFromParent_Done,
     /* 198087 */   // Label 3964: @198087
     /* 198087 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198129), // Rule ID 3220 //
     /* 198092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 198100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198107 */     // MIs[0] Op1
     /* 198107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198111 */     // MIs[0] Op2
     /* 198111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2137:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 198118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198127 */     GIR_RootConstrainSelectedInstOperands,
     /* 198128 */     // GIR_Coverage, 3220,
     /* 198128 */     GIR_EraseRootFromParent_Done,
     /* 198129 */   // Label 3965: @198129
     /* 198129 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198171), // Rule ID 3221 //
     /* 198134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 198142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198149 */     // MIs[0] Op1
     /* 198149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198153 */     // MIs[0] Op2
     /* 198153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198157 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2135:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 198160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198169 */     GIR_RootConstrainSelectedInstOperands,
     /* 198170 */     // GIR_Coverage, 3221,
     /* 198170 */     GIR_EraseRootFromParent_Done,
     /* 198171 */   // Label 3966: @198171
     /* 198171 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198213), // Rule ID 11894 //
     /* 198176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 198184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198191 */     // MIs[0] Op1
     /* 198191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198195 */     // MIs[0] Op2
     /* 198195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198199 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2130:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 198202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198211 */     GIR_RootConstrainSelectedInstOperands,
     /* 198212 */     // GIR_Coverage, 11894,
     /* 198212 */     GIR_EraseRootFromParent_Done,
     /* 198213 */   // Label 3967: @198213
     /* 198213 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198255), // Rule ID 11895 //
     /* 198218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 198226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198233 */     // MIs[0] Op1
     /* 198233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198237 */     // MIs[0] Op2
     /* 198237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198241 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198253 */     GIR_RootConstrainSelectedInstOperands,
     /* 198254 */     // GIR_Coverage, 11895,
     /* 198254 */     GIR_EraseRootFromParent_Done,
     /* 198255 */   // Label 3968: @198255
     /* 198255 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198297), // Rule ID 11896 //
     /* 198260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 198268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198275 */     // MIs[0] Op1
     /* 198275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198279 */     // MIs[0] Op2
     /* 198279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198283 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 198286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198295 */     GIR_RootConstrainSelectedInstOperands,
     /* 198296 */     // GIR_Coverage, 11896,
     /* 198296 */     GIR_EraseRootFromParent_Done,
     /* 198297 */   // Label 3969: @198297
     /* 198297 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198339), // Rule ID 11897 //
     /* 198302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 198310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198317 */     // MIs[0] Op1
     /* 198317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198321 */     // MIs[0] Op2
     /* 198321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198325 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2131:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 198328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198337 */     GIR_RootConstrainSelectedInstOperands,
     /* 198338 */     // GIR_Coverage, 11897,
     /* 198338 */     GIR_EraseRootFromParent_Done,
     /* 198339 */   // Label 3970: @198339
     /* 198339 */   GIM_Reject,
     /* 198340 */ // Label 3017: @198340
     /* 198340 */ GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(242123),
     /* 198345 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 198348 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198461), // Rule ID 2069 //
     /* 198353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198430 */     // MIs[3] Operand 1
     /* 198430 */     // No operand predicates
     /* 198430 */     // MIs[1] Operand 2
     /* 198430 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198443 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 198446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198459 */     GIR_RootConstrainSelectedInstOperands,
     /* 198460 */     // GIR_Coverage, 2069,
     /* 198460 */     GIR_EraseRootFromParent_Done,
     /* 198461 */   // Label 3972: @198461
     /* 198461 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198574), // Rule ID 2076 //
     /* 198466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198543 */     // MIs[3] Operand 1
     /* 198543 */     // No operand predicates
     /* 198543 */     // MIs[1] Operand 2
     /* 198543 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198556 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 198559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198572 */     GIR_RootConstrainSelectedInstOperands,
     /* 198573 */     // GIR_Coverage, 2076,
     /* 198573 */     GIR_EraseRootFromParent_Done,
     /* 198574 */   // Label 3973: @198574
     /* 198574 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198687), // Rule ID 2072 //
     /* 198579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198656 */     // MIs[3] Operand 1
     /* 198656 */     // No operand predicates
     /* 198656 */     // MIs[1] Operand 2
     /* 198656 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198669 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 198672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198685 */     GIR_RootConstrainSelectedInstOperands,
     /* 198686 */     // GIR_Coverage, 2072,
     /* 198686 */     GIR_EraseRootFromParent_Done,
     /* 198687 */   // Label 3974: @198687
     /* 198687 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(198800), // Rule ID 2079 //
     /* 198692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198769 */     // MIs[3] Operand 1
     /* 198769 */     // No operand predicates
     /* 198769 */     // MIs[1] Operand 2
     /* 198769 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198782 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 198785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198798 */     GIR_RootConstrainSelectedInstOperands,
     /* 198799 */     // GIR_Coverage, 2079,
     /* 198799 */     GIR_EraseRootFromParent_Done,
     /* 198800 */   // Label 3975: @198800
     /* 198800 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(198905), // Rule ID 3861 //
     /* 198805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198878 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198882 */     // MIs[3] Operand 1
     /* 198882 */     // No operand predicates
     /* 198882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198884 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198903 */     GIR_RootConstrainSelectedInstOperands,
     /* 198904 */     // GIR_Coverage, 3861,
     /* 198904 */     GIR_EraseRootFromParent_Done,
     /* 198905 */   // Label 3976: @198905
     /* 198905 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199010), // Rule ID 3862 //
     /* 198910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 198918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198987 */     // MIs[3] Operand 1
     /* 198987 */     // No operand predicates
     /* 198987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198989 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 198989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199008 */     GIR_RootConstrainSelectedInstOperands,
     /* 199009 */     // GIR_Coverage, 3862,
     /* 199009 */     GIR_EraseRootFromParent_Done,
     /* 199010 */   // Label 3977: @199010
     /* 199010 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199115), // Rule ID 3863 //
     /* 199015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199088 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199092 */     // MIs[3] Operand 1
     /* 199092 */     // No operand predicates
     /* 199092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199094 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199113 */     GIR_RootConstrainSelectedInstOperands,
     /* 199114 */     // GIR_Coverage, 3863,
     /* 199114 */     GIR_EraseRootFromParent_Done,
     /* 199115 */   // Label 3978: @199115
     /* 199115 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199220), // Rule ID 3864 //
     /* 199120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199197 */     // MIs[3] Operand 1
     /* 199197 */     // No operand predicates
     /* 199197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199199 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199218 */     GIR_RootConstrainSelectedInstOperands,
     /* 199219 */     // GIR_Coverage, 3864,
     /* 199219 */     GIR_EraseRootFromParent_Done,
     /* 199220 */   // Label 3979: @199220
     /* 199220 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199325), // Rule ID 3869 //
     /* 199225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199298 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199302 */     // MIs[3] Operand 1
     /* 199302 */     // No operand predicates
     /* 199302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199304 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199323 */     GIR_RootConstrainSelectedInstOperands,
     /* 199324 */     // GIR_Coverage, 3869,
     /* 199324 */     GIR_EraseRootFromParent_Done,
     /* 199325 */   // Label 3980: @199325
     /* 199325 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199430), // Rule ID 3870 //
     /* 199330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199407 */     // MIs[3] Operand 1
     /* 199407 */     // No operand predicates
     /* 199407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199409 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199428 */     GIR_RootConstrainSelectedInstOperands,
     /* 199429 */     // GIR_Coverage, 3870,
     /* 199429 */     GIR_EraseRootFromParent_Done,
     /* 199430 */   // Label 3981: @199430
     /* 199430 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199535), // Rule ID 3871 //
     /* 199435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199508 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199512 */     // MIs[3] Operand 1
     /* 199512 */     // No operand predicates
     /* 199512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199514 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199533 */     GIR_RootConstrainSelectedInstOperands,
     /* 199534 */     // GIR_Coverage, 3871,
     /* 199534 */     GIR_EraseRootFromParent_Done,
     /* 199535 */   // Label 3982: @199535
     /* 199535 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199640), // Rule ID 3872 //
     /* 199540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199613 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199617 */     // MIs[3] Operand 1
     /* 199617 */     // No operand predicates
     /* 199617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199619 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199638 */     GIR_RootConstrainSelectedInstOperands,
     /* 199639 */     // GIR_Coverage, 3872,
     /* 199639 */     GIR_EraseRootFromParent_Done,
     /* 199640 */   // Label 3983: @199640
     /* 199640 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199745), // Rule ID 3885 //
     /* 199645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199718 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199722 */     // MIs[3] Operand 1
     /* 199722 */     // No operand predicates
     /* 199722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199724 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199743 */     GIR_RootConstrainSelectedInstOperands,
     /* 199744 */     // GIR_Coverage, 3885,
     /* 199744 */     GIR_EraseRootFromParent_Done,
     /* 199745 */   // Label 3984: @199745
     /* 199745 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199850), // Rule ID 3886 //
     /* 199750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199827 */     // MIs[3] Operand 1
     /* 199827 */     // No operand predicates
     /* 199827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199829 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199848 */     GIR_RootConstrainSelectedInstOperands,
     /* 199849 */     // GIR_Coverage, 3886,
     /* 199849 */     GIR_EraseRootFromParent_Done,
     /* 199850 */   // Label 3985: @199850
     /* 199850 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199955), // Rule ID 3887 //
     /* 199855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199928 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199932 */     // MIs[3] Operand 1
     /* 199932 */     // No operand predicates
     /* 199932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199934 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199953 */     GIR_RootConstrainSelectedInstOperands,
     /* 199954 */     // GIR_Coverage, 3887,
     /* 199954 */     GIR_EraseRootFromParent_Done,
     /* 199955 */   // Label 3986: @199955
     /* 199955 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200060), // Rule ID 3888 //
     /* 199960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200037 */     // MIs[3] Operand 1
     /* 200037 */     // No operand predicates
     /* 200037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200039 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200058 */     GIR_RootConstrainSelectedInstOperands,
     /* 200059 */     // GIR_Coverage, 3888,
     /* 200059 */     GIR_EraseRootFromParent_Done,
     /* 200060 */   // Label 3987: @200060
     /* 200060 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200114), // Rule ID 59 //
     /* 200065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200090 */     // MIs[0] Operand 3
     /* 200090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 200101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200105 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 200108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200112 */     GIR_RootConstrainSelectedInstOperands,
     /* 200113 */     // GIR_Coverage, 59,
     /* 200113 */     GIR_EraseRootFromParent_Done,
     /* 200114 */   // Label 3988: @200114
     /* 200114 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200168), // Rule ID 60 //
     /* 200119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200144 */     // MIs[0] Operand 3
     /* 200144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 200155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200159 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 200162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200166 */     GIR_RootConstrainSelectedInstOperands,
     /* 200167 */     // GIR_Coverage, 60,
     /* 200167 */     GIR_EraseRootFromParent_Done,
     /* 200168 */   // Label 3989: @200168
     /* 200168 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200222), // Rule ID 61 //
     /* 200173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200198 */     // MIs[0] Operand 3
     /* 200198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 200209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200213 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 200216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200220 */     GIR_RootConstrainSelectedInstOperands,
     /* 200221 */     // GIR_Coverage, 61,
     /* 200221 */     GIR_EraseRootFromParent_Done,
     /* 200222 */   // Label 3990: @200222
     /* 200222 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200276), // Rule ID 62 //
     /* 200227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200252 */     // MIs[0] Operand 3
     /* 200252 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 200263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200267 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 200270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200274 */     GIR_RootConstrainSelectedInstOperands,
     /* 200275 */     // GIR_Coverage, 62,
     /* 200275 */     GIR_EraseRootFromParent_Done,
     /* 200276 */   // Label 3991: @200276
     /* 200276 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200332), // Rule ID 2652 //
     /* 200281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 200289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200303 */     // MIs[0] pattern
     /* 200303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200311 */     // MIs[0] imm4
     /* 200311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 200322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200326 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200328 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200330 */     GIR_RootConstrainSelectedInstOperands,
     /* 200331 */     // GIR_Coverage, 2652,
     /* 200331 */     GIR_EraseRootFromParent_Done,
     /* 200332 */   // Label 3992: @200332
     /* 200332 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200388), // Rule ID 2661 //
     /* 200337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 200345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200359 */     // MIs[0] pattern
     /* 200359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200367 */     // MIs[0] imm4
     /* 200367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200375 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 200378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200382 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200384 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200386 */     GIR_RootConstrainSelectedInstOperands,
     /* 200387 */     // GIR_Coverage, 2661,
     /* 200387 */     GIR_EraseRootFromParent_Done,
     /* 200388 */   // Label 3993: @200388
     /* 200388 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200444), // Rule ID 2662 //
     /* 200393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 200401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200415 */     // MIs[0] pattern
     /* 200415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200423 */     // MIs[0] imm4
     /* 200423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200431 */     // (intrinsic_wo_chain:{ *:[i64] } 1798:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 200434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200438 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200440 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200442 */     GIR_RootConstrainSelectedInstOperands,
     /* 200443 */     // GIR_Coverage, 2662,
     /* 200443 */     GIR_EraseRootFromParent_Done,
     /* 200444 */   // Label 3994: @200444
     /* 200444 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200500), // Rule ID 9925 //
     /* 200449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 200457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200471 */     // MIs[0] pattern
     /* 200471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200479 */     // MIs[0] imm4
     /* 200479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200487 */     // (intrinsic_wo_chain:{ *:[i32] } 1994:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 200490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200494 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200496 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200498 */     GIR_RootConstrainSelectedInstOperands,
     /* 200499 */     // GIR_Coverage, 9925,
     /* 200499 */     GIR_EraseRootFromParent_Done,
     /* 200500 */   // Label 3995: @200500
     /* 200500 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200556), // Rule ID 9926 //
     /* 200505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 200513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200527 */     // MIs[0] pattern
     /* 200527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200535 */     // MIs[0] imm4
     /* 200535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200543 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 200546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200550 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200552 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200554 */     GIR_RootConstrainSelectedInstOperands,
     /* 200555 */     // GIR_Coverage, 9926,
     /* 200555 */     GIR_EraseRootFromParent_Done,
     /* 200556 */   // Label 3996: @200556
     /* 200556 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200612), // Rule ID 9927 //
     /* 200561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 200569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200583 */     // MIs[0] pattern
     /* 200583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200591 */     // MIs[0] imm4
     /* 200591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200599 */     // (intrinsic_wo_chain:{ *:[i64] } 1764:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 200602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200606 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200608 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200610 */     GIR_RootConstrainSelectedInstOperands,
     /* 200611 */     // GIR_Coverage, 9927,
     /* 200611 */     GIR_EraseRootFromParent_Done,
     /* 200612 */   // Label 3997: @200612
     /* 200612 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200668), // Rule ID 9928 //
     /* 200617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 200625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200639 */     // MIs[0] pattern
     /* 200639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200647 */     // MIs[0] imm4
     /* 200647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200655 */     // (intrinsic_wo_chain:{ *:[i64] } 1995:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 200658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200662 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200664 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200666 */     GIR_RootConstrainSelectedInstOperands,
     /* 200667 */     // GIR_Coverage, 9928,
     /* 200667 */     GIR_EraseRootFromParent_Done,
     /* 200668 */   // Label 3998: @200668
     /* 200668 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200724), // Rule ID 9931 //
     /* 200673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 200681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200695 */     // MIs[0] pattern
     /* 200695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200703 */     // MIs[0] imm4
     /* 200703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200711 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 200714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200718 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200720 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200722 */     GIR_RootConstrainSelectedInstOperands,
     /* 200723 */     // GIR_Coverage, 9931,
     /* 200723 */     GIR_EraseRootFromParent_Done,
     /* 200724 */   // Label 3999: @200724
     /* 200724 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200780), // Rule ID 9934 //
     /* 200729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 200737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200751 */     // MIs[0] pattern
     /* 200751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200759 */     // MIs[0] imm4
     /* 200759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200767 */     // (intrinsic_wo_chain:{ *:[i32] } 2000:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 200770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200774 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200776 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200778 */     GIR_RootConstrainSelectedInstOperands,
     /* 200779 */     // GIR_Coverage, 9934,
     /* 200779 */     GIR_EraseRootFromParent_Done,
     /* 200780 */   // Label 4000: @200780
     /* 200780 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200836), // Rule ID 9935 //
     /* 200785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 200793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200807 */     // MIs[0] pattern
     /* 200807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200815 */     // MIs[0] imm4
     /* 200815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200823 */     // (intrinsic_wo_chain:{ *:[i64] } 1804:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 200826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200830 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200832 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200834 */     GIR_RootConstrainSelectedInstOperands,
     /* 200835 */     // GIR_Coverage, 9935,
     /* 200835 */     GIR_EraseRootFromParent_Done,
     /* 200836 */   // Label 4001: @200836
     /* 200836 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200892), // Rule ID 9936 //
     /* 200841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 200849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200863 */     // MIs[0] pattern
     /* 200863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200871 */     // MIs[0] imm4
     /* 200871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200879 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 200882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200886 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200888 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200890 */     GIR_RootConstrainSelectedInstOperands,
     /* 200891 */     // GIR_Coverage, 9936,
     /* 200891 */     GIR_EraseRootFromParent_Done,
     /* 200892 */   // Label 4002: @200892
     /* 200892 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200948), // Rule ID 9937 //
     /* 200897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 200905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200919 */     // MIs[0] pattern
     /* 200919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200927 */     // MIs[0] imm4
     /* 200927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200935 */     // (intrinsic_wo_chain:{ *:[i64] } 1770:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 200938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200942 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200944 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200946 */     GIR_RootConstrainSelectedInstOperands,
     /* 200947 */     // GIR_Coverage, 9937,
     /* 200947 */     GIR_EraseRootFromParent_Done,
     /* 200948 */   // Label 4003: @200948
     /* 200948 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201004), // Rule ID 9938 //
     /* 200953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 200961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200975 */     // MIs[0] pattern
     /* 200975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200983 */     // MIs[0] imm4
     /* 200983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200991 */     // (intrinsic_wo_chain:{ *:[i64] } 2001:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 200994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200998 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201000 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201002 */     GIR_RootConstrainSelectedInstOperands,
     /* 201003 */     // GIR_Coverage, 9938,
     /* 201003 */     GIR_EraseRootFromParent_Done,
     /* 201004 */   // Label 4004: @201004
     /* 201004 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201060), // Rule ID 9941 //
     /* 201009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 201017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201031 */     // MIs[0] pattern
     /* 201031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201039 */     // MIs[0] imm4
     /* 201039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201047 */     // (intrinsic_wo_chain:{ *:[i32] } 2020:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 201050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201054 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201056 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201058 */     GIR_RootConstrainSelectedInstOperands,
     /* 201059 */     // GIR_Coverage, 9941,
     /* 201059 */     GIR_EraseRootFromParent_Done,
     /* 201060 */   // Label 4005: @201060
     /* 201060 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201116), // Rule ID 9944 //
     /* 201065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 201073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201087 */     // MIs[0] pattern
     /* 201087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201095 */     // MIs[0] imm4
     /* 201095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201103 */     // (intrinsic_wo_chain:{ *:[i32] } 2006:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 201106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201110 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201112 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201114 */     GIR_RootConstrainSelectedInstOperands,
     /* 201115 */     // GIR_Coverage, 9944,
     /* 201115 */     GIR_EraseRootFromParent_Done,
     /* 201116 */   // Label 4006: @201116
     /* 201116 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201172), // Rule ID 9945 //
     /* 201121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 201129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201143 */     // MIs[0] pattern
     /* 201143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201151 */     // MIs[0] imm4
     /* 201151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201159 */     // (intrinsic_wo_chain:{ *:[i64] } 1810:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 201162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201166 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201168 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201170 */     GIR_RootConstrainSelectedInstOperands,
     /* 201171 */     // GIR_Coverage, 9945,
     /* 201171 */     GIR_EraseRootFromParent_Done,
     /* 201172 */   // Label 4007: @201172
     /* 201172 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201228), // Rule ID 9946 //
     /* 201177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 201185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201199 */     // MIs[0] pattern
     /* 201199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201207 */     // MIs[0] imm4
     /* 201207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201215 */     // (intrinsic_wo_chain:{ *:[i64] } 2021:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 201218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201222 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201224 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201226 */     GIR_RootConstrainSelectedInstOperands,
     /* 201227 */     // GIR_Coverage, 9946,
     /* 201227 */     GIR_EraseRootFromParent_Done,
     /* 201228 */   // Label 4008: @201228
     /* 201228 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201284), // Rule ID 9947 //
     /* 201233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 201241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201255 */     // MIs[0] pattern
     /* 201255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201263 */     // MIs[0] imm4
     /* 201263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201271 */     // (intrinsic_wo_chain:{ *:[i64] } 1776:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 201274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201278 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201280 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201282 */     GIR_RootConstrainSelectedInstOperands,
     /* 201283 */     // GIR_Coverage, 9947,
     /* 201283 */     GIR_EraseRootFromParent_Done,
     /* 201284 */   // Label 4009: @201284
     /* 201284 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201340), // Rule ID 9948 //
     /* 201289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 201297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201311 */     // MIs[0] pattern
     /* 201311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201319 */     // MIs[0] imm4
     /* 201319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201327 */     // (intrinsic_wo_chain:{ *:[i64] } 2007:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 201330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201334 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201336 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201338 */     GIR_RootConstrainSelectedInstOperands,
     /* 201339 */     // GIR_Coverage, 9948,
     /* 201339 */     GIR_EraseRootFromParent_Done,
     /* 201340 */   // Label 4010: @201340
     /* 201340 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201396), // Rule ID 9951 //
     /* 201345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 201353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201367 */     // MIs[0] pattern
     /* 201367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201375 */     // MIs[0] imm4
     /* 201375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201383 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 201386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201390 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201392 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201394 */     GIR_RootConstrainSelectedInstOperands,
     /* 201395 */     // GIR_Coverage, 9951,
     /* 201395 */     GIR_EraseRootFromParent_Done,
     /* 201396 */   // Label 4011: @201396
     /* 201396 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201452), // Rule ID 9954 //
     /* 201401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 201409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201423 */     // MIs[0] pattern
     /* 201423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201431 */     // MIs[0] imm4
     /* 201431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201439 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 201442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201446 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201448 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201450 */     GIR_RootConstrainSelectedInstOperands,
     /* 201451 */     // GIR_Coverage, 9954,
     /* 201451 */     GIR_EraseRootFromParent_Done,
     /* 201452 */   // Label 4012: @201452
     /* 201452 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201508), // Rule ID 9955 //
     /* 201457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 201465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201479 */     // MIs[0] pattern
     /* 201479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201487 */     // MIs[0] imm4
     /* 201487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201495 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201504 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201506 */     GIR_RootConstrainSelectedInstOperands,
     /* 201507 */     // GIR_Coverage, 9955,
     /* 201507 */     GIR_EraseRootFromParent_Done,
     /* 201508 */   // Label 4013: @201508
     /* 201508 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201564), // Rule ID 9956 //
     /* 201513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 201521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201535 */     // MIs[0] pattern
     /* 201535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201543 */     // MIs[0] imm4
     /* 201543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201551 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 201554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201558 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201560 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201562 */     GIR_RootConstrainSelectedInstOperands,
     /* 201563 */     // GIR_Coverage, 9956,
     /* 201563 */     GIR_EraseRootFromParent_Done,
     /* 201564 */   // Label 4014: @201564
     /* 201564 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201620), // Rule ID 9957 //
     /* 201569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 201577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201591 */     // MIs[0] pattern
     /* 201591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201599 */     // MIs[0] imm4
     /* 201599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201607 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 201610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201614 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201616 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201618 */     GIR_RootConstrainSelectedInstOperands,
     /* 201619 */     // GIR_Coverage, 9957,
     /* 201619 */     GIR_EraseRootFromParent_Done,
     /* 201620 */   // Label 4015: @201620
     /* 201620 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201676), // Rule ID 9958 //
     /* 201625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 201633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201647 */     // MIs[0] pattern
     /* 201647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201655 */     // MIs[0] imm4
     /* 201655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201663 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 201666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201670 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201672 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201674 */     GIR_RootConstrainSelectedInstOperands,
     /* 201675 */     // GIR_Coverage, 9958,
     /* 201675 */     GIR_EraseRootFromParent_Done,
     /* 201676 */   // Label 4016: @201676
     /* 201676 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201732), // Rule ID 9959 //
     /* 201681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 201689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201703 */     // MIs[0] pattern
     /* 201703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201711 */     // MIs[0] imm4
     /* 201711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2013:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201726 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201728 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201730 */     GIR_RootConstrainSelectedInstOperands,
     /* 201731 */     // GIR_Coverage, 9959,
     /* 201731 */     GIR_EraseRootFromParent_Done,
     /* 201732 */   // Label 4017: @201732
     /* 201732 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201788), // Rule ID 9960 //
     /* 201737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 201745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201759 */     // MIs[0] pattern
     /* 201759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201767 */     // MIs[0] imm4
     /* 201767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1768:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 201778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201782 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201786 */     GIR_RootConstrainSelectedInstOperands,
     /* 201787 */     // GIR_Coverage, 9960,
     /* 201787 */     GIR_EraseRootFromParent_Done,
     /* 201788 */   // Label 4018: @201788
     /* 201788 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201844), // Rule ID 9961 //
     /* 201793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 201801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201815 */     // MIs[0] pattern
     /* 201815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201823 */     // MIs[0] imm4
     /* 201823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1999:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 201834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201838 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201840 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201842 */     GIR_RootConstrainSelectedInstOperands,
     /* 201843 */     // GIR_Coverage, 9961,
     /* 201843 */     GIR_EraseRootFromParent_Done,
     /* 201844 */   // Label 4019: @201844
     /* 201844 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201900), // Rule ID 9962 //
     /* 201849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 201857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201871 */     // MIs[0] pattern
     /* 201871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201879 */     // MIs[0] imm4
     /* 201879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 201890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201894 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201896 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201898 */     GIR_RootConstrainSelectedInstOperands,
     /* 201899 */     // GIR_Coverage, 9962,
     /* 201899 */     GIR_EraseRootFromParent_Done,
     /* 201900 */   // Label 4020: @201900
     /* 201900 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(201956), // Rule ID 9963 //
     /* 201905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 201913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201927 */     // MIs[0] pattern
     /* 201927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201935 */     // MIs[0] imm4
     /* 201935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2019:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 201946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201950 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201952 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201954 */     GIR_RootConstrainSelectedInstOperands,
     /* 201955 */     // GIR_Coverage, 9963,
     /* 201955 */     GIR_EraseRootFromParent_Done,
     /* 201956 */   // Label 4021: @201956
     /* 201956 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202012), // Rule ID 9964 //
     /* 201961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 201969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201983 */     // MIs[0] pattern
     /* 201983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201991 */     // MIs[0] imm4
     /* 201991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 202002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202006 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202008 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202010 */     GIR_RootConstrainSelectedInstOperands,
     /* 202011 */     // GIR_Coverage, 9964,
     /* 202011 */     GIR_EraseRootFromParent_Done,
     /* 202012 */   // Label 4022: @202012
     /* 202012 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202068), // Rule ID 9965 //
     /* 202017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 202025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202039 */     // MIs[0] pattern
     /* 202039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202047 */     // MIs[0] imm4
     /* 202047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2005:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 202058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202062 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202064 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202066 */     GIR_RootConstrainSelectedInstOperands,
     /* 202067 */     // GIR_Coverage, 9965,
     /* 202067 */     GIR_EraseRootFromParent_Done,
     /* 202068 */   // Label 4023: @202068
     /* 202068 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202124), // Rule ID 9966 //
     /* 202073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 202081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202095 */     // MIs[0] pattern
     /* 202095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202103 */     // MIs[0] imm4
     /* 202103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 202114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202118 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202120 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202122 */     GIR_RootConstrainSelectedInstOperands,
     /* 202123 */     // GIR_Coverage, 9966,
     /* 202123 */     GIR_EraseRootFromParent_Done,
     /* 202124 */   // Label 4024: @202124
     /* 202124 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202180), // Rule ID 9967 //
     /* 202129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 202137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202151 */     // MIs[0] pattern
     /* 202151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202159 */     // MIs[0] imm4
     /* 202159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202167 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 202170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202174 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202176 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202178 */     GIR_RootConstrainSelectedInstOperands,
     /* 202179 */     // GIR_Coverage, 9967,
     /* 202179 */     GIR_EraseRootFromParent_Done,
     /* 202180 */   // Label 4025: @202180
     /* 202180 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202236), // Rule ID 9968 //
     /* 202185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 202193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202207 */     // MIs[0] pattern
     /* 202207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202215 */     // MIs[0] imm4
     /* 202215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 202226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202230 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202232 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202234 */     GIR_RootConstrainSelectedInstOperands,
     /* 202235 */     // GIR_Coverage, 9968,
     /* 202235 */     GIR_EraseRootFromParent_Done,
     /* 202236 */   // Label 4026: @202236
     /* 202236 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202292), // Rule ID 9969 //
     /* 202241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 202249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202263 */     // MIs[0] pattern
     /* 202263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202271 */     // MIs[0] imm4
     /* 202271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 202282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202286 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202288 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202290 */     GIR_RootConstrainSelectedInstOperands,
     /* 202291 */     // GIR_Coverage, 9969,
     /* 202291 */     GIR_EraseRootFromParent_Done,
     /* 202292 */   // Label 4027: @202292
     /* 202292 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202382), // Rule ID 47 //
     /* 202297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202362 */     // MIs[2] Operand 1
     /* 202362 */     // No operand predicates
     /* 202362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202364 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 202367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202380 */     GIR_RootConstrainSelectedInstOperands,
     /* 202381 */     // GIR_Coverage, 47,
     /* 202381 */     GIR_EraseRootFromParent_Done,
     /* 202382 */   // Label 4028: @202382
     /* 202382 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202472), // Rule ID 48 //
     /* 202387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202452 */     // MIs[2] Operand 1
     /* 202452 */     // No operand predicates
     /* 202452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202454 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 202457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202470 */     GIR_RootConstrainSelectedInstOperands,
     /* 202471 */     // GIR_Coverage, 48,
     /* 202471 */     GIR_EraseRootFromParent_Done,
     /* 202472 */   // Label 4029: @202472
     /* 202472 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202562), // Rule ID 49 //
     /* 202477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202542 */     // MIs[2] Operand 1
     /* 202542 */     // No operand predicates
     /* 202542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202544 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 202547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202560 */     GIR_RootConstrainSelectedInstOperands,
     /* 202561 */     // GIR_Coverage, 49,
     /* 202561 */     GIR_EraseRootFromParent_Done,
     /* 202562 */   // Label 4030: @202562
     /* 202562 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202652), // Rule ID 50 //
     /* 202567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202632 */     // MIs[2] Operand 1
     /* 202632 */     // No operand predicates
     /* 202632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202634 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 202637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202650 */     GIR_RootConstrainSelectedInstOperands,
     /* 202651 */     // GIR_Coverage, 50,
     /* 202651 */     GIR_EraseRootFromParent_Done,
     /* 202652 */   // Label 4031: @202652
     /* 202652 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202742), // Rule ID 51 //
     /* 202657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202722 */     // MIs[2] Operand 1
     /* 202722 */     // No operand predicates
     /* 202722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202724 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 202727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 202741 */     // GIR_Coverage, 51,
     /* 202741 */     GIR_EraseRootFromParent_Done,
     /* 202742 */   // Label 4032: @202742
     /* 202742 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202832), // Rule ID 52 //
     /* 202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202812 */     // MIs[2] Operand 1
     /* 202812 */     // No operand predicates
     /* 202812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202814 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 202817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202830 */     GIR_RootConstrainSelectedInstOperands,
     /* 202831 */     // GIR_Coverage, 52,
     /* 202831 */     GIR_EraseRootFromParent_Done,
     /* 202832 */   // Label 4033: @202832
     /* 202832 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202922), // Rule ID 53 //
     /* 202837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202902 */     // MIs[2] Operand 1
     /* 202902 */     // No operand predicates
     /* 202902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202904 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 202907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202920 */     GIR_RootConstrainSelectedInstOperands,
     /* 202921 */     // GIR_Coverage, 53,
     /* 202921 */     GIR_EraseRootFromParent_Done,
     /* 202922 */   // Label 4034: @202922
     /* 202922 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(203012), // Rule ID 54 //
     /* 202927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202992 */     // MIs[2] Operand 1
     /* 202992 */     // No operand predicates
     /* 202992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202994 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203010 */     GIR_RootConstrainSelectedInstOperands,
     /* 203011 */     // GIR_Coverage, 54,
     /* 203011 */     GIR_EraseRootFromParent_Done,
     /* 203012 */   // Label 4035: @203012
     /* 203012 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(203102), // Rule ID 2070 //
     /* 203017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203078 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203082 */     // MIs[2] Operand 1
     /* 203082 */     // No operand predicates
     /* 203082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203084 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 203087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203100 */     GIR_RootConstrainSelectedInstOperands,
     /* 203101 */     // GIR_Coverage, 2070,
     /* 203101 */     GIR_EraseRootFromParent_Done,
     /* 203102 */   // Label 4036: @203102
     /* 203102 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203192), // Rule ID 2071 //
     /* 203107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203172 */     // MIs[2] Operand 1
     /* 203172 */     // No operand predicates
     /* 203172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203174 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 203177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203190 */     GIR_RootConstrainSelectedInstOperands,
     /* 203191 */     // GIR_Coverage, 2071,
     /* 203191 */     GIR_EraseRootFromParent_Done,
     /* 203192 */   // Label 4037: @203192
     /* 203192 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203282), // Rule ID 2077 //
     /* 203197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203262 */     // MIs[2] Operand 1
     /* 203262 */     // No operand predicates
     /* 203262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 203267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203280 */     GIR_RootConstrainSelectedInstOperands,
     /* 203281 */     // GIR_Coverage, 2077,
     /* 203281 */     GIR_EraseRootFromParent_Done,
     /* 203282 */   // Label 4038: @203282
     /* 203282 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203372), // Rule ID 2078 //
     /* 203287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203348 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203352 */     // MIs[2] Operand 1
     /* 203352 */     // No operand predicates
     /* 203352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203354 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 203357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203370 */     GIR_RootConstrainSelectedInstOperands,
     /* 203371 */     // GIR_Coverage, 2078,
     /* 203371 */     GIR_EraseRootFromParent_Done,
     /* 203372 */   // Label 4039: @203372
     /* 203372 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203462), // Rule ID 2073 //
     /* 203377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203442 */     // MIs[2] Operand 1
     /* 203442 */     // No operand predicates
     /* 203442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203444 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 203447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203460 */     GIR_RootConstrainSelectedInstOperands,
     /* 203461 */     // GIR_Coverage, 2073,
     /* 203461 */     GIR_EraseRootFromParent_Done,
     /* 203462 */   // Label 4040: @203462
     /* 203462 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(203552), // Rule ID 2074 //
     /* 203467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203532 */     // MIs[2] Operand 1
     /* 203532 */     // No operand predicates
     /* 203532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 203537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203550 */     GIR_RootConstrainSelectedInstOperands,
     /* 203551 */     // GIR_Coverage, 2074,
     /* 203551 */     GIR_EraseRootFromParent_Done,
     /* 203552 */   // Label 4041: @203552
     /* 203552 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(203642), // Rule ID 2080 //
     /* 203557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203618 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203622 */     // MIs[2] Operand 1
     /* 203622 */     // No operand predicates
     /* 203622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203624 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 203627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203640 */     GIR_RootConstrainSelectedInstOperands,
     /* 203641 */     // GIR_Coverage, 2080,
     /* 203641 */     GIR_EraseRootFromParent_Done,
     /* 203642 */   // Label 4042: @203642
     /* 203642 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203732), // Rule ID 2081 //
     /* 203647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203708 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203712 */     // MIs[2] Operand 1
     /* 203712 */     // No operand predicates
     /* 203712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203714 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 203717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203730 */     GIR_RootConstrainSelectedInstOperands,
     /* 203731 */     // GIR_Coverage, 2081,
     /* 203731 */     GIR_EraseRootFromParent_Done,
     /* 203732 */   // Label 4043: @203732
     /* 203732 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203822), // Rule ID 2075 //
     /* 203737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203802 */     // MIs[2] Operand 1
     /* 203802 */     // No operand predicates
     /* 203802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203804 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 203807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203820 */     GIR_RootConstrainSelectedInstOperands,
     /* 203821 */     // GIR_Coverage, 2075,
     /* 203821 */     GIR_EraseRootFromParent_Done,
     /* 203822 */   // Label 4044: @203822
     /* 203822 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203912), // Rule ID 2082 //
     /* 203827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203892 */     // MIs[2] Operand 1
     /* 203892 */     // No operand predicates
     /* 203892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203894 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 203897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203910 */     GIR_RootConstrainSelectedInstOperands,
     /* 203911 */     // GIR_Coverage, 2082,
     /* 203911 */     GIR_EraseRootFromParent_Done,
     /* 203912 */   // Label 4045: @203912
     /* 203912 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203989), // Rule ID 2781 //
     /* 203917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203969 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203973 */     // MIs[2] Operand 1
     /* 203973 */     // No operand predicates
     /* 203973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 203978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203987 */     GIR_RootConstrainSelectedInstOperands,
     /* 203988 */     // GIR_Coverage, 2781,
     /* 203988 */     GIR_EraseRootFromParent_Done,
     /* 203989 */   // Label 4046: @203989
     /* 203989 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204066), // Rule ID 2782 //
     /* 203994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204046 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204050 */     // MIs[2] Operand 1
     /* 204050 */     // No operand predicates
     /* 204050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204064 */     GIR_RootConstrainSelectedInstOperands,
     /* 204065 */     // GIR_Coverage, 2782,
     /* 204065 */     GIR_EraseRootFromParent_Done,
     /* 204066 */   // Label 4047: @204066
     /* 204066 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204143), // Rule ID 2783 //
     /* 204071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204123 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204127 */     // MIs[2] Operand 1
     /* 204127 */     // No operand predicates
     /* 204127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204129 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204141 */     GIR_RootConstrainSelectedInstOperands,
     /* 204142 */     // GIR_Coverage, 2783,
     /* 204142 */     GIR_EraseRootFromParent_Done,
     /* 204143 */   // Label 4048: @204143
     /* 204143 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204220), // Rule ID 2784 //
     /* 204148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204200 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204204 */     // MIs[2] Operand 1
     /* 204204 */     // No operand predicates
     /* 204204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204206 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 2784,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 4049: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204297), // Rule ID 2785 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204277 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204281 */     // MIs[2] Operand 1
     /* 204281 */     // No operand predicates
     /* 204281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204283 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204295 */     GIR_RootConstrainSelectedInstOperands,
     /* 204296 */     // GIR_Coverage, 2785,
     /* 204296 */     GIR_EraseRootFromParent_Done,
     /* 204297 */   // Label 4050: @204297
     /* 204297 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204374), // Rule ID 2786 //
     /* 204302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204354 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204358 */     // MIs[2] Operand 1
     /* 204358 */     // No operand predicates
     /* 204358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204360 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204372 */     GIR_RootConstrainSelectedInstOperands,
     /* 204373 */     // GIR_Coverage, 2786,
     /* 204373 */     GIR_EraseRootFromParent_Done,
     /* 204374 */   // Label 4051: @204374
     /* 204374 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204451), // Rule ID 7812 //
     /* 204379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204431 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204435 */     // MIs[2] Operand 1
     /* 204435 */     // No operand predicates
     /* 204435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204437 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204449 */     GIR_RootConstrainSelectedInstOperands,
     /* 204450 */     // GIR_Coverage, 7812,
     /* 204450 */     GIR_EraseRootFromParent_Done,
     /* 204451 */   // Label 4052: @204451
     /* 204451 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204528), // Rule ID 7813 //
     /* 204456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204508 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204512 */     // MIs[2] Operand 1
     /* 204512 */     // No operand predicates
     /* 204512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204514 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204526 */     GIR_RootConstrainSelectedInstOperands,
     /* 204527 */     // GIR_Coverage, 7813,
     /* 204527 */     GIR_EraseRootFromParent_Done,
     /* 204528 */   // Label 4053: @204528
     /* 204528 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(204605), // Rule ID 7814 //
     /* 204533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204585 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204589 */     // MIs[2] Operand 1
     /* 204589 */     // No operand predicates
     /* 204589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204591 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204603 */     GIR_RootConstrainSelectedInstOperands,
     /* 204604 */     // GIR_Coverage, 7814,
     /* 204604 */     GIR_EraseRootFromParent_Done,
     /* 204605 */   // Label 4054: @204605
     /* 204605 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(204682), // Rule ID 7815 //
     /* 204610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204662 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204666 */     // MIs[2] Operand 1
     /* 204666 */     // No operand predicates
     /* 204666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204668 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204680 */     GIR_RootConstrainSelectedInstOperands,
     /* 204681 */     // GIR_Coverage, 7815,
     /* 204681 */     GIR_EraseRootFromParent_Done,
     /* 204682 */   // Label 4055: @204682
     /* 204682 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(204759), // Rule ID 7816 //
     /* 204687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204739 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204743 */     // MIs[2] Operand 1
     /* 204743 */     // No operand predicates
     /* 204743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204745 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204757 */     GIR_RootConstrainSelectedInstOperands,
     /* 204758 */     // GIR_Coverage, 7816,
     /* 204758 */     GIR_EraseRootFromParent_Done,
     /* 204759 */   // Label 4056: @204759
     /* 204759 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(204836), // Rule ID 7817 //
     /* 204764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204816 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204820 */     // MIs[2] Operand 1
     /* 204820 */     // No operand predicates
     /* 204820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1531:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204834 */     GIR_RootConstrainSelectedInstOperands,
     /* 204835 */     // GIR_Coverage, 7817,
     /* 204835 */     GIR_EraseRootFromParent_Done,
     /* 204836 */   // Label 4057: @204836
     /* 204836 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(204913), // Rule ID 7818 //
     /* 204841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204893 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204897 */     // MIs[2] Operand 1
     /* 204897 */     // No operand predicates
     /* 204897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204899 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204911 */     GIR_RootConstrainSelectedInstOperands,
     /* 204912 */     // GIR_Coverage, 7818,
     /* 204912 */     GIR_EraseRootFromParent_Done,
     /* 204913 */   // Label 4058: @204913
     /* 204913 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204990), // Rule ID 7819 //
     /* 204918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204970 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204974 */     // MIs[2] Operand 1
     /* 204974 */     // No operand predicates
     /* 204974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204988 */     GIR_RootConstrainSelectedInstOperands,
     /* 204989 */     // GIR_Coverage, 7819,
     /* 204989 */     GIR_EraseRootFromParent_Done,
     /* 204990 */   // Label 4059: @204990
     /* 204990 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205067), // Rule ID 7820 //
     /* 204995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205047 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205051 */     // MIs[2] Operand 1
     /* 205051 */     // No operand predicates
     /* 205051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205053 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205065 */     GIR_RootConstrainSelectedInstOperands,
     /* 205066 */     // GIR_Coverage, 7820,
     /* 205066 */     GIR_EraseRootFromParent_Done,
     /* 205067 */   // Label 4060: @205067
     /* 205067 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205144), // Rule ID 7821 //
     /* 205072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205124 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205128 */     // MIs[2] Operand 1
     /* 205128 */     // No operand predicates
     /* 205128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205130 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205142 */     GIR_RootConstrainSelectedInstOperands,
     /* 205143 */     // GIR_Coverage, 7821,
     /* 205143 */     GIR_EraseRootFromParent_Done,
     /* 205144 */   // Label 4061: @205144
     /* 205144 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205221), // Rule ID 7822 //
     /* 205149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205201 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205205 */     // MIs[2] Operand 1
     /* 205205 */     // No operand predicates
     /* 205205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205207 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205219 */     GIR_RootConstrainSelectedInstOperands,
     /* 205220 */     // GIR_Coverage, 7822,
     /* 205220 */     GIR_EraseRootFromParent_Done,
     /* 205221 */   // Label 4062: @205221
     /* 205221 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205298), // Rule ID 7823 //
     /* 205226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205278 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205282 */     // MIs[2] Operand 1
     /* 205282 */     // No operand predicates
     /* 205282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205296 */     GIR_RootConstrainSelectedInstOperands,
     /* 205297 */     // GIR_Coverage, 7823,
     /* 205297 */     GIR_EraseRootFromParent_Done,
     /* 205298 */   // Label 4063: @205298
     /* 205298 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205375), // Rule ID 7824 //
     /* 205303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205355 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205359 */     // MIs[2] Operand 1
     /* 205359 */     // No operand predicates
     /* 205359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205361 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205373 */     GIR_RootConstrainSelectedInstOperands,
     /* 205374 */     // GIR_Coverage, 7824,
     /* 205374 */     GIR_EraseRootFromParent_Done,
     /* 205375 */   // Label 4064: @205375
     /* 205375 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205452), // Rule ID 7825 //
     /* 205380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205432 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205436 */     // MIs[2] Operand 1
     /* 205436 */     // No operand predicates
     /* 205436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205450 */     GIR_RootConstrainSelectedInstOperands,
     /* 205451 */     // GIR_Coverage, 7825,
     /* 205451 */     GIR_EraseRootFromParent_Done,
     /* 205452 */   // Label 4065: @205452
     /* 205452 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205529), // Rule ID 7826 //
     /* 205457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205509 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205513 */     // MIs[2] Operand 1
     /* 205513 */     // No operand predicates
     /* 205513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205515 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205527 */     GIR_RootConstrainSelectedInstOperands,
     /* 205528 */     // GIR_Coverage, 7826,
     /* 205528 */     GIR_EraseRootFromParent_Done,
     /* 205529 */   // Label 4066: @205529
     /* 205529 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205606), // Rule ID 7827 //
     /* 205534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205586 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205590 */     // MIs[2] Operand 1
     /* 205590 */     // No operand predicates
     /* 205590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205604 */     GIR_RootConstrainSelectedInstOperands,
     /* 205605 */     // GIR_Coverage, 7827,
     /* 205605 */     GIR_EraseRootFromParent_Done,
     /* 205606 */   // Label 4067: @205606
     /* 205606 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205683), // Rule ID 7828 //
     /* 205611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205663 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205667 */     // MIs[2] Operand 1
     /* 205667 */     // No operand predicates
     /* 205667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205669 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205681 */     GIR_RootConstrainSelectedInstOperands,
     /* 205682 */     // GIR_Coverage, 7828,
     /* 205682 */     GIR_EraseRootFromParent_Done,
     /* 205683 */   // Label 4068: @205683
     /* 205683 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205760), // Rule ID 7829 //
     /* 205688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205740 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205744 */     // MIs[2] Operand 1
     /* 205744 */     // No operand predicates
     /* 205744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1533:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205758 */     GIR_RootConstrainSelectedInstOperands,
     /* 205759 */     // GIR_Coverage, 7829,
     /* 205759 */     GIR_EraseRootFromParent_Done,
     /* 205760 */   // Label 4069: @205760
     /* 205760 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205837), // Rule ID 7830 //
     /* 205765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205817 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205821 */     // MIs[2] Operand 1
     /* 205821 */     // No operand predicates
     /* 205821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205823 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205835 */     GIR_RootConstrainSelectedInstOperands,
     /* 205836 */     // GIR_Coverage, 7830,
     /* 205836 */     GIR_EraseRootFromParent_Done,
     /* 205837 */   // Label 4070: @205837
     /* 205837 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205914), // Rule ID 7831 //
     /* 205842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205894 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205898 */     // MIs[2] Operand 1
     /* 205898 */     // No operand predicates
     /* 205898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205912 */     GIR_RootConstrainSelectedInstOperands,
     /* 205913 */     // GIR_Coverage, 7831,
     /* 205913 */     GIR_EraseRootFromParent_Done,
     /* 205914 */   // Label 4071: @205914
     /* 205914 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205991), // Rule ID 7832 //
     /* 205919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205971 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205975 */     // MIs[2] Operand 1
     /* 205975 */     // No operand predicates
     /* 205975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205977 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 205980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205989 */     GIR_RootConstrainSelectedInstOperands,
     /* 205990 */     // GIR_Coverage, 7832,
     /* 205990 */     GIR_EraseRootFromParent_Done,
     /* 205991 */   // Label 4072: @205991
     /* 205991 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206068), // Rule ID 7833 //
     /* 205996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206048 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206052 */     // MIs[2] Operand 1
     /* 206052 */     // No operand predicates
     /* 206052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206066 */     GIR_RootConstrainSelectedInstOperands,
     /* 206067 */     // GIR_Coverage, 7833,
     /* 206067 */     GIR_EraseRootFromParent_Done,
     /* 206068 */   // Label 4073: @206068
     /* 206068 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206145), // Rule ID 7834 //
     /* 206073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206125 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206129 */     // MIs[2] Operand 1
     /* 206129 */     // No operand predicates
     /* 206129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206131 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206143 */     GIR_RootConstrainSelectedInstOperands,
     /* 206144 */     // GIR_Coverage, 7834,
     /* 206144 */     GIR_EraseRootFromParent_Done,
     /* 206145 */   // Label 4074: @206145
     /* 206145 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206222), // Rule ID 7835 //
     /* 206150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206202 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206206 */     // MIs[2] Operand 1
     /* 206206 */     // No operand predicates
     /* 206206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206208 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206220 */     GIR_RootConstrainSelectedInstOperands,
     /* 206221 */     // GIR_Coverage, 7835,
     /* 206221 */     GIR_EraseRootFromParent_Done,
     /* 206222 */   // Label 4075: @206222
     /* 206222 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206299), // Rule ID 7836 //
     /* 206227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206279 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206283 */     // MIs[2] Operand 1
     /* 206283 */     // No operand predicates
     /* 206283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206285 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206297 */     GIR_RootConstrainSelectedInstOperands,
     /* 206298 */     // GIR_Coverage, 7836,
     /* 206298 */     GIR_EraseRootFromParent_Done,
     /* 206299 */   // Label 4076: @206299
     /* 206299 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206376), // Rule ID 7837 //
     /* 206304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206356 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206360 */     // MIs[2] Operand 1
     /* 206360 */     // No operand predicates
     /* 206360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206374 */     GIR_RootConstrainSelectedInstOperands,
     /* 206375 */     // GIR_Coverage, 7837,
     /* 206375 */     GIR_EraseRootFromParent_Done,
     /* 206376 */   // Label 4077: @206376
     /* 206376 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206453), // Rule ID 7838 //
     /* 206381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206433 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206437 */     // MIs[2] Operand 1
     /* 206437 */     // No operand predicates
     /* 206437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206439 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206451 */     GIR_RootConstrainSelectedInstOperands,
     /* 206452 */     // GIR_Coverage, 7838,
     /* 206452 */     GIR_EraseRootFromParent_Done,
     /* 206453 */   // Label 4078: @206453
     /* 206453 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206530), // Rule ID 7839 //
     /* 206458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206510 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206514 */     // MIs[2] Operand 1
     /* 206514 */     // No operand predicates
     /* 206514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206528 */     GIR_RootConstrainSelectedInstOperands,
     /* 206529 */     // GIR_Coverage, 7839,
     /* 206529 */     GIR_EraseRootFromParent_Done,
     /* 206530 */   // Label 4079: @206530
     /* 206530 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206607), // Rule ID 7840 //
     /* 206535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206587 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206591 */     // MIs[2] Operand 1
     /* 206591 */     // No operand predicates
     /* 206591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206605 */     GIR_RootConstrainSelectedInstOperands,
     /* 206606 */     // GIR_Coverage, 7840,
     /* 206606 */     GIR_EraseRootFromParent_Done,
     /* 206607 */   // Label 4080: @206607
     /* 206607 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206684), // Rule ID 7841 //
     /* 206612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206664 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206668 */     // MIs[2] Operand 1
     /* 206668 */     // No operand predicates
     /* 206668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206670 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206682 */     GIR_RootConstrainSelectedInstOperands,
     /* 206683 */     // GIR_Coverage, 7841,
     /* 206683 */     GIR_EraseRootFromParent_Done,
     /* 206684 */   // Label 4081: @206684
     /* 206684 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206761), // Rule ID 7842 //
     /* 206689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206741 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206745 */     // MIs[2] Operand 1
     /* 206745 */     // No operand predicates
     /* 206745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206747 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206759 */     GIR_RootConstrainSelectedInstOperands,
     /* 206760 */     // GIR_Coverage, 7842,
     /* 206760 */     GIR_EraseRootFromParent_Done,
     /* 206761 */   // Label 4082: @206761
     /* 206761 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206838), // Rule ID 7843 //
     /* 206766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206818 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206822 */     // MIs[2] Operand 1
     /* 206822 */     // No operand predicates
     /* 206822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206836 */     GIR_RootConstrainSelectedInstOperands,
     /* 206837 */     // GIR_Coverage, 7843,
     /* 206837 */     GIR_EraseRootFromParent_Done,
     /* 206838 */   // Label 4083: @206838
     /* 206838 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206915), // Rule ID 7844 //
     /* 206843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206895 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206899 */     // MIs[2] Operand 1
     /* 206899 */     // No operand predicates
     /* 206899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206901 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206913 */     GIR_RootConstrainSelectedInstOperands,
     /* 206914 */     // GIR_Coverage, 7844,
     /* 206914 */     GIR_EraseRootFromParent_Done,
     /* 206915 */   // Label 4084: @206915
     /* 206915 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206992), // Rule ID 7845 //
     /* 206920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206972 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206976 */     // MIs[2] Operand 1
     /* 206976 */     // No operand predicates
     /* 206976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206978 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206990 */     GIR_RootConstrainSelectedInstOperands,
     /* 206991 */     // GIR_Coverage, 7845,
     /* 206991 */     GIR_EraseRootFromParent_Done,
     /* 206992 */   // Label 4085: @206992
     /* 206992 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(207069), // Rule ID 7846 //
     /* 206997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207049 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207053 */     // MIs[2] Operand 1
     /* 207053 */     // No operand predicates
     /* 207053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207055 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 207068 */     // GIR_Coverage, 7846,
     /* 207068 */     GIR_EraseRootFromParent_Done,
     /* 207069 */   // Label 4086: @207069
     /* 207069 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207146), // Rule ID 7847 //
     /* 207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207126 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207130 */     // MIs[2] Operand 1
     /* 207130 */     // No operand predicates
     /* 207130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207132 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207144 */     GIR_RootConstrainSelectedInstOperands,
     /* 207145 */     // GIR_Coverage, 7847,
     /* 207145 */     GIR_EraseRootFromParent_Done,
     /* 207146 */   // Label 4087: @207146
     /* 207146 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207223), // Rule ID 7848 //
     /* 207151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207203 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207207 */     // MIs[2] Operand 1
     /* 207207 */     // No operand predicates
     /* 207207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207209 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207221 */     GIR_RootConstrainSelectedInstOperands,
     /* 207222 */     // GIR_Coverage, 7848,
     /* 207222 */     GIR_EraseRootFromParent_Done,
     /* 207223 */   // Label 4088: @207223
     /* 207223 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207300), // Rule ID 7849 //
     /* 207228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207280 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207284 */     // MIs[2] Operand 1
     /* 207284 */     // No operand predicates
     /* 207284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207298 */     GIR_RootConstrainSelectedInstOperands,
     /* 207299 */     // GIR_Coverage, 7849,
     /* 207299 */     GIR_EraseRootFromParent_Done,
     /* 207300 */   // Label 4089: @207300
     /* 207300 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207377), // Rule ID 7850 //
     /* 207305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207357 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207361 */     // MIs[2] Operand 1
     /* 207361 */     // No operand predicates
     /* 207361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207363 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207375 */     GIR_RootConstrainSelectedInstOperands,
     /* 207376 */     // GIR_Coverage, 7850,
     /* 207376 */     GIR_EraseRootFromParent_Done,
     /* 207377 */   // Label 4090: @207377
     /* 207377 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207454), // Rule ID 7851 //
     /* 207382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207434 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207438 */     // MIs[2] Operand 1
     /* 207438 */     // No operand predicates
     /* 207438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207452 */     GIR_RootConstrainSelectedInstOperands,
     /* 207453 */     // GIR_Coverage, 7851,
     /* 207453 */     GIR_EraseRootFromParent_Done,
     /* 207454 */   // Label 4091: @207454
     /* 207454 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207531), // Rule ID 7852 //
     /* 207459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207511 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207515 */     // MIs[2] Operand 1
     /* 207515 */     // No operand predicates
     /* 207515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207517 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207529 */     GIR_RootConstrainSelectedInstOperands,
     /* 207530 */     // GIR_Coverage, 7852,
     /* 207530 */     GIR_EraseRootFromParent_Done,
     /* 207531 */   // Label 4092: @207531
     /* 207531 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207608), // Rule ID 7853 //
     /* 207536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207588 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207592 */     // MIs[2] Operand 1
     /* 207592 */     // No operand predicates
     /* 207592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207606 */     GIR_RootConstrainSelectedInstOperands,
     /* 207607 */     // GIR_Coverage, 7853,
     /* 207607 */     GIR_EraseRootFromParent_Done,
     /* 207608 */   // Label 4093: @207608
     /* 207608 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207664), // Rule ID 55 //
     /* 207613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207638 */     // MIs[0] Operand 3
     /* 207638 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 207649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207653 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 207656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207662 */     GIR_RootConstrainSelectedInstOperands,
     /* 207663 */     // GIR_Coverage, 55,
     /* 207663 */     GIR_EraseRootFromParent_Done,
     /* 207664 */   // Label 4094: @207664
     /* 207664 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207720), // Rule ID 56 //
     /* 207669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207694 */     // MIs[0] Operand 3
     /* 207694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 207705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207709 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 207712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207718 */     GIR_RootConstrainSelectedInstOperands,
     /* 207719 */     // GIR_Coverage, 56,
     /* 207719 */     GIR_EraseRootFromParent_Done,
     /* 207720 */   // Label 4095: @207720
     /* 207720 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207776), // Rule ID 57 //
     /* 207725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207750 */     // MIs[0] Operand 3
     /* 207750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 207761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207765 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 207768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207774 */     GIR_RootConstrainSelectedInstOperands,
     /* 207775 */     // GIR_Coverage, 57,
     /* 207775 */     GIR_EraseRootFromParent_Done,
     /* 207776 */   // Label 4096: @207776
     /* 207776 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207832), // Rule ID 58 //
     /* 207781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207806 */     // MIs[0] Operand 3
     /* 207806 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 207817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207821 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 207824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207830 */     GIR_RootConstrainSelectedInstOperands,
     /* 207831 */     // GIR_Coverage, 58,
     /* 207831 */     GIR_EraseRootFromParent_Done,
     /* 207832 */   // Label 4097: @207832
     /* 207832 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207887), // Rule ID 2799 //
     /* 207837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207866 */     // MIs[0] imm
     /* 207866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207874 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1534:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 207877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207883 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207885 */     GIR_RootConstrainSelectedInstOperands,
     /* 207886 */     // GIR_Coverage, 2799,
     /* 207886 */     GIR_EraseRootFromParent_Done,
     /* 207887 */   // Label 4098: @207887
     /* 207887 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207942), // Rule ID 2800 //
     /* 207892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207921 */     // MIs[0] imm
     /* 207921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207929 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1534:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 207932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207938 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207940 */     GIR_RootConstrainSelectedInstOperands,
     /* 207941 */     // GIR_Coverage, 2800,
     /* 207941 */     GIR_EraseRootFromParent_Done,
     /* 207942 */   // Label 4099: @207942
     /* 207942 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207997), // Rule ID 2801 //
     /* 207947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207976 */     // MIs[0] imm
     /* 207976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1534:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 207987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207993 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207995 */     GIR_RootConstrainSelectedInstOperands,
     /* 207996 */     // GIR_Coverage, 2801,
     /* 207996 */     GIR_EraseRootFromParent_Done,
     /* 207997 */   // Label 4100: @207997
     /* 207997 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(208052), // Rule ID 3552 //
     /* 208002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208031 */     // MIs[0] Idx
     /* 208031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 208039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1620:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 208039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 208042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208050 */     GIR_RootConstrainSelectedInstOperands,
     /* 208051 */     // GIR_Coverage, 3552,
     /* 208051 */     GIR_EraseRootFromParent_Done,
     /* 208052 */   // Label 4101: @208052
     /* 208052 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(208107), // Rule ID 3553 //
     /* 208057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208086 */     // MIs[0] Idx
     /* 208086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 208094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1620:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 208094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 208097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208105 */     GIR_RootConstrainSelectedInstOperands,
     /* 208106 */     // GIR_Coverage, 3553,
     /* 208106 */     GIR_EraseRootFromParent_Done,
     /* 208107 */   // Label 4102: @208107
     /* 208107 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(208162), // Rule ID 3554 //
     /* 208112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208141 */     // MIs[0] Idx
     /* 208141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 208149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1620:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 208149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 208152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208160 */     GIR_RootConstrainSelectedInstOperands,
     /* 208161 */     // GIR_Coverage, 3554,
     /* 208161 */     GIR_EraseRootFromParent_Done,
     /* 208162 */   // Label 4103: @208162
     /* 208162 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208217), // Rule ID 3836 //
     /* 208167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 208170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 208175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 208178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 208184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208196 */     // MIs[0] imm
     /* 208196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 208204 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 208204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 208207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 208209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 208211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 208213 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208215 */     GIR_RootConstrainSelectedInstOperands,
     /* 208216 */     // GIR_Coverage, 3836,
     /* 208216 */     GIR_EraseRootFromParent_Done,
     /* 208217 */   // Label 4104: @208217
     /* 208217 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208264), // Rule ID 2853 //
     /* 208222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208243 */     // MIs[0] idx
     /* 208243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208251 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 208251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 208254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208260 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208262 */     GIR_RootConstrainSelectedInstOperands,
     /* 208263 */     // GIR_Coverage, 2853,
     /* 208263 */     GIR_EraseRootFromParent_Done,
     /* 208264 */   // Label 4105: @208264
     /* 208264 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208311), // Rule ID 2854 //
     /* 208269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208290 */     // MIs[0] idx
     /* 208290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208298 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 208298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 208301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208307 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208309 */     GIR_RootConstrainSelectedInstOperands,
     /* 208310 */     // GIR_Coverage, 2854,
     /* 208310 */     GIR_EraseRootFromParent_Done,
     /* 208311 */   // Label 4106: @208311
     /* 208311 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208358), // Rule ID 2855 //
     /* 208316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208337 */     // MIs[0] idx
     /* 208337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208345 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 208345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 208348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208354 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208356 */     GIR_RootConstrainSelectedInstOperands,
     /* 208357 */     // GIR_Coverage, 2855,
     /* 208357 */     GIR_EraseRootFromParent_Done,
     /* 208358 */   // Label 4107: @208358
     /* 208358 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208405), // Rule ID 3004 //
     /* 208363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208384 */     // MIs[0] Op3
     /* 208384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 208395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208403 */     GIR_RootConstrainSelectedInstOperands,
     /* 208404 */     // GIR_Coverage, 3004,
     /* 208404 */     GIR_EraseRootFromParent_Done,
     /* 208405 */   // Label 4108: @208405
     /* 208405 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208452), // Rule ID 3005 //
     /* 208410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208431 */     // MIs[0] Op3
     /* 208431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 208442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208450 */     GIR_RootConstrainSelectedInstOperands,
     /* 208451 */     // GIR_Coverage, 3005,
     /* 208451 */     GIR_EraseRootFromParent_Done,
     /* 208452 */   // Label 4109: @208452
     /* 208452 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208499), // Rule ID 3006 //
     /* 208457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208478 */     // MIs[0] Op3
     /* 208478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 208489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208497 */     GIR_RootConstrainSelectedInstOperands,
     /* 208498 */     // GIR_Coverage, 3006,
     /* 208498 */     GIR_EraseRootFromParent_Done,
     /* 208499 */   // Label 4110: @208499
     /* 208499 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208546), // Rule ID 3007 //
     /* 208504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208525 */     // MIs[0] Op3
     /* 208525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 208536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208544 */     GIR_RootConstrainSelectedInstOperands,
     /* 208545 */     // GIR_Coverage, 3007,
     /* 208545 */     GIR_EraseRootFromParent_Done,
     /* 208546 */   // Label 4111: @208546
     /* 208546 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208593), // Rule ID 3008 //
     /* 208551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208572 */     // MIs[0] Op3
     /* 208572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 208583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208591 */     GIR_RootConstrainSelectedInstOperands,
     /* 208592 */     // GIR_Coverage, 3008,
     /* 208592 */     GIR_EraseRootFromParent_Done,
     /* 208593 */   // Label 4112: @208593
     /* 208593 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208640), // Rule ID 3056 //
     /* 208598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208619 */     // MIs[0] Op3
     /* 208619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 208630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208638 */     GIR_RootConstrainSelectedInstOperands,
     /* 208639 */     // GIR_Coverage, 3056,
     /* 208639 */     GIR_EraseRootFromParent_Done,
     /* 208640 */   // Label 4113: @208640
     /* 208640 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208687), // Rule ID 3058 //
     /* 208645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208666 */     // MIs[0] Op3
     /* 208666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 208677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208685 */     GIR_RootConstrainSelectedInstOperands,
     /* 208686 */     // GIR_Coverage, 3058,
     /* 208686 */     GIR_EraseRootFromParent_Done,
     /* 208687 */   // Label 4114: @208687
     /* 208687 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208734), // Rule ID 3060 //
     /* 208692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208713 */     // MIs[0] Op3
     /* 208713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 208724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 3060,
     /* 208733 */     GIR_EraseRootFromParent_Done,
     /* 208734 */   // Label 4115: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208781), // Rule ID 3062 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208760 */     // MIs[0] Op3
     /* 208760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 208768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 208768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 208771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208779 */     GIR_RootConstrainSelectedInstOperands,
     /* 208780 */     // GIR_Coverage, 3062,
     /* 208780 */     GIR_EraseRootFromParent_Done,
     /* 208781 */   // Label 4116: @208781
     /* 208781 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208828), // Rule ID 3084 //
     /* 208786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208807 */     // MIs[0] Op3
     /* 208807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 208818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208826 */     GIR_RootConstrainSelectedInstOperands,
     /* 208827 */     // GIR_Coverage, 3084,
     /* 208827 */     GIR_EraseRootFromParent_Done,
     /* 208828 */   // Label 4117: @208828
     /* 208828 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208875), // Rule ID 3085 //
     /* 208833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208854 */     // MIs[0] Op3
     /* 208854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 208865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208873 */     GIR_RootConstrainSelectedInstOperands,
     /* 208874 */     // GIR_Coverage, 3085,
     /* 208874 */     GIR_EraseRootFromParent_Done,
     /* 208875 */   // Label 4118: @208875
     /* 208875 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208922), // Rule ID 3086 //
     /* 208880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208901 */     // MIs[0] Op3
     /* 208901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 208912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208920 */     GIR_RootConstrainSelectedInstOperands,
     /* 208921 */     // GIR_Coverage, 3086,
     /* 208921 */     GIR_EraseRootFromParent_Done,
     /* 208922 */   // Label 4119: @208922
     /* 208922 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208969), // Rule ID 3155 //
     /* 208927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208948 */     // MIs[0] Op3
     /* 208948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2139:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 208959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208967 */     GIR_RootConstrainSelectedInstOperands,
     /* 208968 */     // GIR_Coverage, 3155,
     /* 208968 */     GIR_EraseRootFromParent_Done,
     /* 208969 */   // Label 4120: @208969
     /* 208969 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(209016), // Rule ID 3156 //
     /* 208974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208995 */     // MIs[0] Op3
     /* 208995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2139:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 209006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209014 */     GIR_RootConstrainSelectedInstOperands,
     /* 209015 */     // GIR_Coverage, 3156,
     /* 209015 */     GIR_EraseRootFromParent_Done,
     /* 209016 */   // Label 4121: @209016
     /* 209016 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209063), // Rule ID 3157 //
     /* 209021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209042 */     // MIs[0] Op3
     /* 209042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2139:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 209053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209061 */     GIR_RootConstrainSelectedInstOperands,
     /* 209062 */     // GIR_Coverage, 3157,
     /* 209062 */     GIR_EraseRootFromParent_Done,
     /* 209063 */   // Label 4122: @209063
     /* 209063 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209110), // Rule ID 3158 //
     /* 209068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209089 */     // MIs[0] Op3
     /* 209089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2139:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 209100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209108 */     GIR_RootConstrainSelectedInstOperands,
     /* 209109 */     // GIR_Coverage, 3158,
     /* 209109 */     GIR_EraseRootFromParent_Done,
     /* 209110 */   // Label 4123: @209110
     /* 209110 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209157), // Rule ID 3537 //
     /* 209115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 209118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 209123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209136 */     // MIs[0] Op3
     /* 209136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 209144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1349:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 209144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 209147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209155 */     GIR_RootConstrainSelectedInstOperands,
     /* 209156 */     // GIR_Coverage, 3537,
     /* 209156 */     GIR_EraseRootFromParent_Done,
     /* 209157 */   // Label 4124: @209157
     /* 209157 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209204), // Rule ID 3585 //
     /* 209162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209183 */     // MIs[0] Op3
     /* 209183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209191 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1588:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 209194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209202 */     GIR_RootConstrainSelectedInstOperands,
     /* 209203 */     // GIR_Coverage, 3585,
     /* 209203 */     GIR_EraseRootFromParent_Done,
     /* 209204 */   // Label 4125: @209204
     /* 209204 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209251), // Rule ID 3586 //
     /* 209209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209230 */     // MIs[0] Op3
     /* 209230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209249 */     GIR_RootConstrainSelectedInstOperands,
     /* 209250 */     // GIR_Coverage, 3586,
     /* 209250 */     GIR_EraseRootFromParent_Done,
     /* 209251 */   // Label 4126: @209251
     /* 209251 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209298), // Rule ID 3587 //
     /* 209256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209277 */     // MIs[0] Op3
     /* 209277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209285 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1588:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209296 */     GIR_RootConstrainSelectedInstOperands,
     /* 209297 */     // GIR_Coverage, 3587,
     /* 209297 */     GIR_EraseRootFromParent_Done,
     /* 209298 */   // Label 4127: @209298
     /* 209298 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209345), // Rule ID 3588 //
     /* 209303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209324 */     // MIs[0] Op3
     /* 209324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 209332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 209332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 209335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209343 */     GIR_RootConstrainSelectedInstOperands,
     /* 209344 */     // GIR_Coverage, 3588,
     /* 209344 */     GIR_EraseRootFromParent_Done,
     /* 209345 */   // Label 4128: @209345
     /* 209345 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209392), // Rule ID 3589 //
     /* 209350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209371 */     // MIs[0] Op3
     /* 209371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209390 */     GIR_RootConstrainSelectedInstOperands,
     /* 209391 */     // GIR_Coverage, 3589,
     /* 209391 */     GIR_EraseRootFromParent_Done,
     /* 209392 */   // Label 4129: @209392
     /* 209392 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209439), // Rule ID 3590 //
     /* 209397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209418 */     // MIs[0] Op3
     /* 209418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209426 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1589:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209437 */     GIR_RootConstrainSelectedInstOperands,
     /* 209438 */     // GIR_Coverage, 3590,
     /* 209438 */     GIR_EraseRootFromParent_Done,
     /* 209439 */   // Label 4130: @209439
     /* 209439 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209486), // Rule ID 11250 //
     /* 209444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209465 */     // MIs[0] Op3
     /* 209465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 209476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209484 */     GIR_RootConstrainSelectedInstOperands,
     /* 209485 */     // GIR_Coverage, 11250,
     /* 209485 */     GIR_EraseRootFromParent_Done,
     /* 209486 */   // Label 4131: @209486
     /* 209486 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209533), // Rule ID 11251 //
     /* 209491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209512 */     // MIs[0] Op3
     /* 209512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 209523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209531 */     GIR_RootConstrainSelectedInstOperands,
     /* 209532 */     // GIR_Coverage, 11251,
     /* 209532 */     GIR_EraseRootFromParent_Done,
     /* 209533 */   // Label 4132: @209533
     /* 209533 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209580), // Rule ID 11252 //
     /* 209538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209559 */     // MIs[0] Op3
     /* 209559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 209570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209578 */     GIR_RootConstrainSelectedInstOperands,
     /* 209579 */     // GIR_Coverage, 11252,
     /* 209579 */     GIR_EraseRootFromParent_Done,
     /* 209580 */   // Label 4133: @209580
     /* 209580 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209627), // Rule ID 11253 //
     /* 209585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209606 */     // MIs[0] Op3
     /* 209606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 209617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209625 */     GIR_RootConstrainSelectedInstOperands,
     /* 209626 */     // GIR_Coverage, 11253,
     /* 209626 */     GIR_EraseRootFromParent_Done,
     /* 209627 */   // Label 4134: @209627
     /* 209627 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209674), // Rule ID 11254 //
     /* 209632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209653 */     // MIs[0] Op3
     /* 209653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 209664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209672 */     GIR_RootConstrainSelectedInstOperands,
     /* 209673 */     // GIR_Coverage, 11254,
     /* 209673 */     GIR_EraseRootFromParent_Done,
     /* 209674 */   // Label 4135: @209674
     /* 209674 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209721), // Rule ID 11255 //
     /* 209679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209700 */     // MIs[0] Op3
     /* 209700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 209711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209719 */     GIR_RootConstrainSelectedInstOperands,
     /* 209720 */     // GIR_Coverage, 11255,
     /* 209720 */     GIR_EraseRootFromParent_Done,
     /* 209721 */   // Label 4136: @209721
     /* 209721 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209768), // Rule ID 11278 //
     /* 209726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209747 */     // MIs[0] Op3
     /* 209747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209755 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 209758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209766 */     GIR_RootConstrainSelectedInstOperands,
     /* 209767 */     // GIR_Coverage, 11278,
     /* 209767 */     GIR_EraseRootFromParent_Done,
     /* 209768 */   // Label 4137: @209768
     /* 209768 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209815), // Rule ID 11279 //
     /* 209773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209794 */     // MIs[0] Op3
     /* 209794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 209805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209813 */     GIR_RootConstrainSelectedInstOperands,
     /* 209814 */     // GIR_Coverage, 11279,
     /* 209814 */     GIR_EraseRootFromParent_Done,
     /* 209815 */   // Label 4138: @209815
     /* 209815 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209862), // Rule ID 11280 //
     /* 209820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209841 */     // MIs[0] Op3
     /* 209841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 209852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209860 */     GIR_RootConstrainSelectedInstOperands,
     /* 209861 */     // GIR_Coverage, 11280,
     /* 209861 */     GIR_EraseRootFromParent_Done,
     /* 209862 */   // Label 4139: @209862
     /* 209862 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209909), // Rule ID 11281 //
     /* 209867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209888 */     // MIs[0] Op3
     /* 209888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 209899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209907 */     GIR_RootConstrainSelectedInstOperands,
     /* 209908 */     // GIR_Coverage, 11281,
     /* 209908 */     GIR_EraseRootFromParent_Done,
     /* 209909 */   // Label 4140: @209909
     /* 209909 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209956), // Rule ID 11282 //
     /* 209914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209935 */     // MIs[0] Op3
     /* 209935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 209946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209954 */     GIR_RootConstrainSelectedInstOperands,
     /* 209955 */     // GIR_Coverage, 11282,
     /* 209955 */     GIR_EraseRootFromParent_Done,
     /* 209956 */   // Label 4141: @209956
     /* 209956 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210003), // Rule ID 11283 //
     /* 209961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209982 */     // MIs[0] Op3
     /* 209982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 209993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210001 */     GIR_RootConstrainSelectedInstOperands,
     /* 210002 */     // GIR_Coverage, 11283,
     /* 210002 */     GIR_EraseRootFromParent_Done,
     /* 210003 */   // Label 4142: @210003
     /* 210003 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210050), // Rule ID 11284 //
     /* 210008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210029 */     // MIs[0] Op3
     /* 210029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 210040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210048 */     GIR_RootConstrainSelectedInstOperands,
     /* 210049 */     // GIR_Coverage, 11284,
     /* 210049 */     GIR_EraseRootFromParent_Done,
     /* 210050 */   // Label 4143: @210050
     /* 210050 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210097), // Rule ID 11285 //
     /* 210055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210076 */     // MIs[0] Op3
     /* 210076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 210087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210095 */     GIR_RootConstrainSelectedInstOperands,
     /* 210096 */     // GIR_Coverage, 11285,
     /* 210096 */     GIR_EraseRootFromParent_Done,
     /* 210097 */   // Label 4144: @210097
     /* 210097 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210144), // Rule ID 11286 //
     /* 210102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210123 */     // MIs[0] Op3
     /* 210123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210142 */     GIR_RootConstrainSelectedInstOperands,
     /* 210143 */     // GIR_Coverage, 11286,
     /* 210143 */     GIR_EraseRootFromParent_Done,
     /* 210144 */   // Label 4145: @210144
     /* 210144 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210191), // Rule ID 11287 //
     /* 210149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210170 */     // MIs[0] Op3
     /* 210170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 210181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210189 */     GIR_RootConstrainSelectedInstOperands,
     /* 210190 */     // GIR_Coverage, 11287,
     /* 210190 */     GIR_EraseRootFromParent_Done,
     /* 210191 */   // Label 4146: @210191
     /* 210191 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210238), // Rule ID 11531 //
     /* 210196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210217 */     // MIs[0] Op3
     /* 210217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 210228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210236 */     GIR_RootConstrainSelectedInstOperands,
     /* 210237 */     // GIR_Coverage, 11531,
     /* 210237 */     GIR_EraseRootFromParent_Done,
     /* 210238 */   // Label 4147: @210238
     /* 210238 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210285), // Rule ID 11532 //
     /* 210243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210264 */     // MIs[0] Op3
     /* 210264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 210275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210283 */     GIR_RootConstrainSelectedInstOperands,
     /* 210284 */     // GIR_Coverage, 11532,
     /* 210284 */     GIR_EraseRootFromParent_Done,
     /* 210285 */   // Label 4148: @210285
     /* 210285 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210332), // Rule ID 11533 //
     /* 210290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210311 */     // MIs[0] Op3
     /* 210311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 210322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210330 */     GIR_RootConstrainSelectedInstOperands,
     /* 210331 */     // GIR_Coverage, 11533,
     /* 210331 */     GIR_EraseRootFromParent_Done,
     /* 210332 */   // Label 4149: @210332
     /* 210332 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210379), // Rule ID 11534 //
     /* 210337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210358 */     // MIs[0] Op3
     /* 210358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 210369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210377 */     GIR_RootConstrainSelectedInstOperands,
     /* 210378 */     // GIR_Coverage, 11534,
     /* 210378 */     GIR_EraseRootFromParent_Done,
     /* 210379 */   // Label 4150: @210379
     /* 210379 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210426), // Rule ID 11535 //
     /* 210384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210405 */     // MIs[0] Op3
     /* 210405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 210416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210424 */     GIR_RootConstrainSelectedInstOperands,
     /* 210425 */     // GIR_Coverage, 11535,
     /* 210425 */     GIR_EraseRootFromParent_Done,
     /* 210426 */   // Label 4151: @210426
     /* 210426 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210473), // Rule ID 11537 //
     /* 210431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210452 */     // MIs[0] Op3
     /* 210452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 210463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210471 */     GIR_RootConstrainSelectedInstOperands,
     /* 210472 */     // GIR_Coverage, 11537,
     /* 210472 */     GIR_EraseRootFromParent_Done,
     /* 210473 */   // Label 4152: @210473
     /* 210473 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210520), // Rule ID 11539 //
     /* 210478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210499 */     // MIs[0] Op3
     /* 210499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 210510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210518 */     GIR_RootConstrainSelectedInstOperands,
     /* 210519 */     // GIR_Coverage, 11539,
     /* 210519 */     GIR_EraseRootFromParent_Done,
     /* 210520 */   // Label 4153: @210520
     /* 210520 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210567), // Rule ID 11541 //
     /* 210525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210546 */     // MIs[0] Op3
     /* 210546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2045:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 210557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210565 */     GIR_RootConstrainSelectedInstOperands,
     /* 210566 */     // GIR_Coverage, 11541,
     /* 210566 */     GIR_EraseRootFromParent_Done,
     /* 210567 */   // Label 4154: @210567
     /* 210567 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210614), // Rule ID 11543 //
     /* 210572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210593 */     // MIs[0] Op3
     /* 210593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 210601 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 210601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 210604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210612 */     GIR_RootConstrainSelectedInstOperands,
     /* 210613 */     // GIR_Coverage, 11543,
     /* 210613 */     GIR_EraseRootFromParent_Done,
     /* 210614 */   // Label 4155: @210614
     /* 210614 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210661), // Rule ID 11544 //
     /* 210619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210640 */     // MIs[0] Op3
     /* 210640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 210648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 210648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 210651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210659 */     GIR_RootConstrainSelectedInstOperands,
     /* 210660 */     // GIR_Coverage, 11544,
     /* 210660 */     GIR_EraseRootFromParent_Done,
     /* 210661 */   // Label 4156: @210661
     /* 210661 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210708), // Rule ID 11545 //
     /* 210666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210687 */     // MIs[0] Op3
     /* 210687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 210695 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 210695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 210698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210706 */     GIR_RootConstrainSelectedInstOperands,
     /* 210707 */     // GIR_Coverage, 11545,
     /* 210707 */     GIR_EraseRootFromParent_Done,
     /* 210708 */   // Label 4157: @210708
     /* 210708 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210755), // Rule ID 11546 //
     /* 210713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210734 */     // MIs[0] Op3
     /* 210734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 210742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 210742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 210745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210753 */     GIR_RootConstrainSelectedInstOperands,
     /* 210754 */     // GIR_Coverage, 11546,
     /* 210754 */     GIR_EraseRootFromParent_Done,
     /* 210755 */   // Label 4158: @210755
     /* 210755 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210802), // Rule ID 11621 //
     /* 210760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210781 */     // MIs[0] Op3
     /* 210781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210789 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 210792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210800 */     GIR_RootConstrainSelectedInstOperands,
     /* 210801 */     // GIR_Coverage, 11621,
     /* 210801 */     GIR_EraseRootFromParent_Done,
     /* 210802 */   // Label 4159: @210802
     /* 210802 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210849), // Rule ID 11623 //
     /* 210807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210828 */     // MIs[0] Op3
     /* 210828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 210839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210847 */     GIR_RootConstrainSelectedInstOperands,
     /* 210848 */     // GIR_Coverage, 11623,
     /* 210848 */     GIR_EraseRootFromParent_Done,
     /* 210849 */   // Label 4160: @210849
     /* 210849 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210896), // Rule ID 11625 //
     /* 210854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210875 */     // MIs[0] Op3
     /* 210875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 210886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210894 */     GIR_RootConstrainSelectedInstOperands,
     /* 210895 */     // GIR_Coverage, 11625,
     /* 210895 */     GIR_EraseRootFromParent_Done,
     /* 210896 */   // Label 4161: @210896
     /* 210896 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(210943), // Rule ID 11627 //
     /* 210901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210922 */     // MIs[0] Op3
     /* 210922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2054:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 210933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210941 */     GIR_RootConstrainSelectedInstOperands,
     /* 210942 */     // GIR_Coverage, 11627,
     /* 210942 */     GIR_EraseRootFromParent_Done,
     /* 210943 */   // Label 4162: @210943
     /* 210943 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(210990), // Rule ID 11629 //
     /* 210948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210969 */     // MIs[0] Op3
     /* 210969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 210980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210988 */     GIR_RootConstrainSelectedInstOperands,
     /* 210989 */     // GIR_Coverage, 11629,
     /* 210989 */     GIR_EraseRootFromParent_Done,
     /* 210990 */   // Label 4163: @210990
     /* 210990 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211037), // Rule ID 11630 //
     /* 210995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211016 */     // MIs[0] Op3
     /* 211016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 211027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211035 */     GIR_RootConstrainSelectedInstOperands,
     /* 211036 */     // GIR_Coverage, 11630,
     /* 211036 */     GIR_EraseRootFromParent_Done,
     /* 211037 */   // Label 4164: @211037
     /* 211037 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211084), // Rule ID 11631 //
     /* 211042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211063 */     // MIs[0] Op3
     /* 211063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 211074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211082 */     GIR_RootConstrainSelectedInstOperands,
     /* 211083 */     // GIR_Coverage, 11631,
     /* 211083 */     GIR_EraseRootFromParent_Done,
     /* 211084 */   // Label 4165: @211084
     /* 211084 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211131), // Rule ID 11632 //
     /* 211089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211110 */     // MIs[0] Op3
     /* 211110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 211121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211129 */     GIR_RootConstrainSelectedInstOperands,
     /* 211130 */     // GIR_Coverage, 11632,
     /* 211130 */     GIR_EraseRootFromParent_Done,
     /* 211131 */   // Label 4166: @211131
     /* 211131 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211178), // Rule ID 11637 //
     /* 211136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211157 */     // MIs[0] Op3
     /* 211157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211165 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211176 */     GIR_RootConstrainSelectedInstOperands,
     /* 211177 */     // GIR_Coverage, 11637,
     /* 211177 */     GIR_EraseRootFromParent_Done,
     /* 211178 */   // Label 4167: @211178
     /* 211178 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211225), // Rule ID 11638 //
     /* 211183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211204 */     // MIs[0] Op3
     /* 211204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 211215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211223 */     GIR_RootConstrainSelectedInstOperands,
     /* 211224 */     // GIR_Coverage, 11638,
     /* 211224 */     GIR_EraseRootFromParent_Done,
     /* 211225 */   // Label 4168: @211225
     /* 211225 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211272), // Rule ID 11639 //
     /* 211230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211251 */     // MIs[0] Op3
     /* 211251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 211262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211270 */     GIR_RootConstrainSelectedInstOperands,
     /* 211271 */     // GIR_Coverage, 11639,
     /* 211271 */     GIR_EraseRootFromParent_Done,
     /* 211272 */   // Label 4169: @211272
     /* 211272 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211319), // Rule ID 11640 //
     /* 211277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211298 */     // MIs[0] Op3
     /* 211298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 211309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211317 */     GIR_RootConstrainSelectedInstOperands,
     /* 211318 */     // GIR_Coverage, 11640,
     /* 211318 */     GIR_EraseRootFromParent_Done,
     /* 211319 */   // Label 4170: @211319
     /* 211319 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211366), // Rule ID 11700 //
     /* 211324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211345 */     // MIs[0] Op3
     /* 211345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 211356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211364 */     GIR_RootConstrainSelectedInstOperands,
     /* 211365 */     // GIR_Coverage, 11700,
     /* 211365 */     GIR_EraseRootFromParent_Done,
     /* 211366 */   // Label 4171: @211366
     /* 211366 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211413), // Rule ID 11701 //
     /* 211371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211392 */     // MIs[0] Op3
     /* 211392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 211403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211411 */     GIR_RootConstrainSelectedInstOperands,
     /* 211412 */     // GIR_Coverage, 11701,
     /* 211412 */     GIR_EraseRootFromParent_Done,
     /* 211413 */   // Label 4172: @211413
     /* 211413 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211460), // Rule ID 11702 //
     /* 211418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211439 */     // MIs[0] Op3
     /* 211439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 211450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211458 */     GIR_RootConstrainSelectedInstOperands,
     /* 211459 */     // GIR_Coverage, 11702,
     /* 211459 */     GIR_EraseRootFromParent_Done,
     /* 211460 */   // Label 4173: @211460
     /* 211460 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211507), // Rule ID 11703 //
     /* 211465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211486 */     // MIs[0] Op3
     /* 211486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1711:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 211497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211505 */     GIR_RootConstrainSelectedInstOperands,
     /* 211506 */     // GIR_Coverage, 11703,
     /* 211506 */     GIR_EraseRootFromParent_Done,
     /* 211507 */   // Label 4174: @211507
     /* 211507 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211554), // Rule ID 11704 //
     /* 211512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211533 */     // MIs[0] Op3
     /* 211533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1711:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 211544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211552 */     GIR_RootConstrainSelectedInstOperands,
     /* 211553 */     // GIR_Coverage, 11704,
     /* 211553 */     GIR_EraseRootFromParent_Done,
     /* 211554 */   // Label 4175: @211554
     /* 211554 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211601), // Rule ID 11705 //
     /* 211559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211580 */     // MIs[0] Op3
     /* 211580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 211591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211599 */     GIR_RootConstrainSelectedInstOperands,
     /* 211600 */     // GIR_Coverage, 11705,
     /* 211600 */     GIR_EraseRootFromParent_Done,
     /* 211601 */   // Label 4176: @211601
     /* 211601 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211648), // Rule ID 11706 //
     /* 211606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211627 */     // MIs[0] Op3
     /* 211627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211635 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 211638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211646 */     GIR_RootConstrainSelectedInstOperands,
     /* 211647 */     // GIR_Coverage, 11706,
     /* 211647 */     GIR_EraseRootFromParent_Done,
     /* 211648 */   // Label 4177: @211648
     /* 211648 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211695), // Rule ID 11707 //
     /* 211653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211674 */     // MIs[0] Op3
     /* 211674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 211685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211693 */     GIR_RootConstrainSelectedInstOperands,
     /* 211694 */     // GIR_Coverage, 11707,
     /* 211694 */     GIR_EraseRootFromParent_Done,
     /* 211695 */   // Label 4178: @211695
     /* 211695 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211742), // Rule ID 11708 //
     /* 211700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211721 */     // MIs[0] Op3
     /* 211721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 211732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211740 */     GIR_RootConstrainSelectedInstOperands,
     /* 211741 */     // GIR_Coverage, 11708,
     /* 211741 */     GIR_EraseRootFromParent_Done,
     /* 211742 */   // Label 4179: @211742
     /* 211742 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211789), // Rule ID 11709 //
     /* 211747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211768 */     // MIs[0] Op3
     /* 211768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 211779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211787 */     GIR_RootConstrainSelectedInstOperands,
     /* 211788 */     // GIR_Coverage, 11709,
     /* 211788 */     GIR_EraseRootFromParent_Done,
     /* 211789 */   // Label 4180: @211789
     /* 211789 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211836), // Rule ID 11710 //
     /* 211794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211815 */     // MIs[0] Op3
     /* 211815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 211826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211834 */     GIR_RootConstrainSelectedInstOperands,
     /* 211835 */     // GIR_Coverage, 11710,
     /* 211835 */     GIR_EraseRootFromParent_Done,
     /* 211836 */   // Label 4181: @211836
     /* 211836 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211883), // Rule ID 11711 //
     /* 211841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211862 */     // MIs[0] Op3
     /* 211862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 211873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211881 */     GIR_RootConstrainSelectedInstOperands,
     /* 211882 */     // GIR_Coverage, 11711,
     /* 211882 */     GIR_EraseRootFromParent_Done,
     /* 211883 */   // Label 4182: @211883
     /* 211883 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211930), // Rule ID 11712 //
     /* 211888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211909 */     // MIs[0] Op3
     /* 211909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 211920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211928 */     GIR_RootConstrainSelectedInstOperands,
     /* 211929 */     // GIR_Coverage, 11712,
     /* 211929 */     GIR_EraseRootFromParent_Done,
     /* 211930 */   // Label 4183: @211930
     /* 211930 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(211977), // Rule ID 11713 //
     /* 211935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211956 */     // MIs[0] Op3
     /* 211956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 211967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211975 */     GIR_RootConstrainSelectedInstOperands,
     /* 211976 */     // GIR_Coverage, 11713,
     /* 211976 */     GIR_EraseRootFromParent_Done,
     /* 211977 */   // Label 4184: @211977
     /* 211977 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212024), // Rule ID 11714 //
     /* 211982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212003 */     // MIs[0] Op3
     /* 212003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 212014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212022 */     GIR_RootConstrainSelectedInstOperands,
     /* 212023 */     // GIR_Coverage, 11714,
     /* 212023 */     GIR_EraseRootFromParent_Done,
     /* 212024 */   // Label 4185: @212024
     /* 212024 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212071), // Rule ID 11715 //
     /* 212029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212050 */     // MIs[0] Op3
     /* 212050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2031:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 212061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212069 */     GIR_RootConstrainSelectedInstOperands,
     /* 212070 */     // GIR_Coverage, 11715,
     /* 212070 */     GIR_EraseRootFromParent_Done,
     /* 212071 */   // Label 4186: @212071
     /* 212071 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212118), // Rule ID 11716 //
     /* 212076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212097 */     // MIs[0] Op3
     /* 212097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212105 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 212108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212116 */     GIR_RootConstrainSelectedInstOperands,
     /* 212117 */     // GIR_Coverage, 11716,
     /* 212117 */     GIR_EraseRootFromParent_Done,
     /* 212118 */   // Label 4187: @212118
     /* 212118 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212165), // Rule ID 11717 //
     /* 212123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212144 */     // MIs[0] Op3
     /* 212144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 212155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212163 */     GIR_RootConstrainSelectedInstOperands,
     /* 212164 */     // GIR_Coverage, 11717,
     /* 212164 */     GIR_EraseRootFromParent_Done,
     /* 212165 */   // Label 4188: @212165
     /* 212165 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212212), // Rule ID 11718 //
     /* 212170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212191 */     // MIs[0] Op3
     /* 212191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212199 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2028:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 212202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212210 */     GIR_RootConstrainSelectedInstOperands,
     /* 212211 */     // GIR_Coverage, 11718,
     /* 212211 */     GIR_EraseRootFromParent_Done,
     /* 212212 */   // Label 4189: @212212
     /* 212212 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212259), // Rule ID 11719 //
     /* 212217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212238 */     // MIs[0] Op3
     /* 212238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2028:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 212249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212257 */     GIR_RootConstrainSelectedInstOperands,
     /* 212258 */     // GIR_Coverage, 11719,
     /* 212258 */     GIR_EraseRootFromParent_Done,
     /* 212259 */   // Label 4190: @212259
     /* 212259 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212306), // Rule ID 11720 //
     /* 212264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212285 */     // MIs[0] Op3
     /* 212285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2028:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 212296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212304 */     GIR_RootConstrainSelectedInstOperands,
     /* 212305 */     // GIR_Coverage, 11720,
     /* 212305 */     GIR_EraseRootFromParent_Done,
     /* 212306 */   // Label 4191: @212306
     /* 212306 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212373), // Rule ID 2604 //
     /* 212311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 212319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 212362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212371 */     GIR_RootConstrainSelectedInstOperands,
     /* 212372 */     // GIR_Coverage, 2604,
     /* 212372 */     GIR_EraseRootFromParent_Done,
     /* 212373 */   // Label 4192: @212373
     /* 212373 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212440), // Rule ID 7651 //
     /* 212378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 212429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212438 */     GIR_RootConstrainSelectedInstOperands,
     /* 212439 */     // GIR_Coverage, 7651,
     /* 212439 */     GIR_EraseRootFromParent_Done,
     /* 212440 */   // Label 4193: @212440
     /* 212440 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212507), // Rule ID 7653 //
     /* 212445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 212496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212505 */     GIR_RootConstrainSelectedInstOperands,
     /* 212506 */     // GIR_Coverage, 7653,
     /* 212506 */     GIR_EraseRootFromParent_Done,
     /* 212507 */   // Label 4194: @212507
     /* 212507 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212574), // Rule ID 7655 //
     /* 212512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 212563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212572 */     GIR_RootConstrainSelectedInstOperands,
     /* 212573 */     // GIR_Coverage, 7655,
     /* 212573 */     GIR_EraseRootFromParent_Done,
     /* 212574 */   // Label 4195: @212574
     /* 212574 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212641), // Rule ID 7657 //
     /* 212579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 212630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212639 */     GIR_RootConstrainSelectedInstOperands,
     /* 212640 */     // GIR_Coverage, 7657,
     /* 212640 */     GIR_EraseRootFromParent_Done,
     /* 212641 */   // Label 4196: @212641
     /* 212641 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212708), // Rule ID 7687 //
     /* 212646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1322:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 212697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212706 */     GIR_RootConstrainSelectedInstOperands,
     /* 212707 */     // GIR_Coverage, 7687,
     /* 212707 */     GIR_EraseRootFromParent_Done,
     /* 212708 */   // Label 4197: @212708
     /* 212708 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212775), // Rule ID 7689 //
     /* 212713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212747 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1322:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 212764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212773 */     GIR_RootConstrainSelectedInstOperands,
     /* 212774 */     // GIR_Coverage, 7689,
     /* 212774 */     GIR_EraseRootFromParent_Done,
     /* 212775 */   // Label 4198: @212775
     /* 212775 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212842), // Rule ID 7691 //
     /* 212780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1322:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 212831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212840 */     GIR_RootConstrainSelectedInstOperands,
     /* 212841 */     // GIR_Coverage, 7691,
     /* 212841 */     GIR_EraseRootFromParent_Done,
     /* 212842 */   // Label 4199: @212842
     /* 212842 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212909), // Rule ID 7693 //
     /* 212847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1322:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 212898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212907 */     GIR_RootConstrainSelectedInstOperands,
     /* 212908 */     // GIR_Coverage, 7693,
     /* 212908 */     GIR_EraseRootFromParent_Done,
     /* 212909 */   // Label 4200: @212909
     /* 212909 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212976), // Rule ID 7699 //
     /* 212914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 212965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212974 */     GIR_RootConstrainSelectedInstOperands,
     /* 212975 */     // GIR_Coverage, 7699,
     /* 212975 */     GIR_EraseRootFromParent_Done,
     /* 212976 */   // Label 4201: @212976
     /* 212976 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213043), // Rule ID 7701 //
     /* 212981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 213032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213041 */     GIR_RootConstrainSelectedInstOperands,
     /* 213042 */     // GIR_Coverage, 7701,
     /* 213042 */     GIR_EraseRootFromParent_Done,
     /* 213043 */   // Label 4202: @213043
     /* 213043 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213110), // Rule ID 7703 //
     /* 213048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 213099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213108 */     GIR_RootConstrainSelectedInstOperands,
     /* 213109 */     // GIR_Coverage, 7703,
     /* 213109 */     GIR_EraseRootFromParent_Done,
     /* 213110 */   // Label 4203: @213110
     /* 213110 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213177), // Rule ID 7705 //
     /* 213115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 213166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213175 */     GIR_RootConstrainSelectedInstOperands,
     /* 213176 */     // GIR_Coverage, 7705,
     /* 213176 */     GIR_EraseRootFromParent_Done,
     /* 213177 */   // Label 4204: @213177
     /* 213177 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213244), // Rule ID 11413 //
     /* 213182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 213190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 213233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213242 */     GIR_RootConstrainSelectedInstOperands,
     /* 213243 */     // GIR_Coverage, 11413,
     /* 213243 */     GIR_EraseRootFromParent_Done,
     /* 213244 */   // Label 4205: @213244
     /* 213244 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213311), // Rule ID 11415 //
     /* 213249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213283 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 213300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213309 */     GIR_RootConstrainSelectedInstOperands,
     /* 213310 */     // GIR_Coverage, 11415,
     /* 213310 */     GIR_EraseRootFromParent_Done,
     /* 213311 */   // Label 4206: @213311
     /* 213311 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213378), // Rule ID 11417 //
     /* 213316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 213367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213376 */     GIR_RootConstrainSelectedInstOperands,
     /* 213377 */     // GIR_Coverage, 11417,
     /* 213377 */     GIR_EraseRootFromParent_Done,
     /* 213378 */   // Label 4207: @213378
     /* 213378 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213445), // Rule ID 11419 //
     /* 213383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 213434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213443 */     GIR_RootConstrainSelectedInstOperands,
     /* 213444 */     // GIR_Coverage, 11419,
     /* 213444 */     GIR_EraseRootFromParent_Done,
     /* 213445 */   // Label 4208: @213445
     /* 213445 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213512), // Rule ID 11421 //
     /* 213450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 213501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213510 */     GIR_RootConstrainSelectedInstOperands,
     /* 213511 */     // GIR_Coverage, 11421,
     /* 213511 */     GIR_EraseRootFromParent_Done,
     /* 213512 */   // Label 4209: @213512
     /* 213512 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213579), // Rule ID 11427 //
     /* 213517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213551 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 213568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213577 */     GIR_RootConstrainSelectedInstOperands,
     /* 213578 */     // GIR_Coverage, 11427,
     /* 213578 */     GIR_EraseRootFromParent_Done,
     /* 213579 */   // Label 4210: @213579
     /* 213579 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213646), // Rule ID 11429 //
     /* 213584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 213635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213644 */     GIR_RootConstrainSelectedInstOperands,
     /* 213645 */     // GIR_Coverage, 11429,
     /* 213645 */     GIR_EraseRootFromParent_Done,
     /* 213646 */   // Label 4211: @213646
     /* 213646 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213713), // Rule ID 11431 //
     /* 213651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 213702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213711 */     GIR_RootConstrainSelectedInstOperands,
     /* 213712 */     // GIR_Coverage, 11431,
     /* 213712 */     GIR_EraseRootFromParent_Done,
     /* 213713 */   // Label 4212: @213713
     /* 213713 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213780), // Rule ID 11433 //
     /* 213718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 213769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213778 */     GIR_RootConstrainSelectedInstOperands,
     /* 213779 */     // GIR_Coverage, 11433,
     /* 213779 */     GIR_EraseRootFromParent_Done,
     /* 213780 */   // Label 4213: @213780
     /* 213780 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213834), // Rule ID 30 //
     /* 213785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 213793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213821 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 213824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213832 */     GIR_RootConstrainSelectedInstOperands,
     /* 213833 */     // GIR_Coverage, 30,
     /* 213833 */     GIR_EraseRootFromParent_Done,
     /* 213834 */   // Label 4214: @213834
     /* 213834 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213888), // Rule ID 31 //
     /* 213839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 213847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213875 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 213878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213886 */     GIR_RootConstrainSelectedInstOperands,
     /* 213887 */     // GIR_Coverage, 31,
     /* 213887 */     GIR_EraseRootFromParent_Done,
     /* 213888 */   // Label 4215: @213888
     /* 213888 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213942), // Rule ID 32 //
     /* 213893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 213901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213929 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 213932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213940 */     GIR_RootConstrainSelectedInstOperands,
     /* 213941 */     // GIR_Coverage, 32,
     /* 213941 */     GIR_EraseRootFromParent_Done,
     /* 213942 */   // Label 4216: @213942
     /* 213942 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213996), // Rule ID 39 //
     /* 213947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213983 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 213986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213994 */     GIR_RootConstrainSelectedInstOperands,
     /* 213995 */     // GIR_Coverage, 39,
     /* 213995 */     GIR_EraseRootFromParent_Done,
     /* 213996 */   // Label 4217: @213996
     /* 213996 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(214050), // Rule ID 40 //
     /* 214001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214037 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 214040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214048 */     GIR_RootConstrainSelectedInstOperands,
     /* 214049 */     // GIR_Coverage, 40,
     /* 214049 */     GIR_EraseRootFromParent_Done,
     /* 214050 */   // Label 4218: @214050
     /* 214050 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(214104), // Rule ID 41 //
     /* 214055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214091 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 214094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214102 */     GIR_RootConstrainSelectedInstOperands,
     /* 214103 */     // GIR_Coverage, 41,
     /* 214103 */     GIR_EraseRootFromParent_Done,
     /* 214104 */   // Label 4219: @214104
     /* 214104 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(214158), // Rule ID 42 //
     /* 214109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214145 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 214148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 214157 */     // GIR_Coverage, 42,
     /* 214157 */     GIR_EraseRootFromParent_Done,
     /* 214158 */   // Label 4220: @214158
     /* 214158 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(214212), // Rule ID 43 //
     /* 214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214199 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 214202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214210 */     GIR_RootConstrainSelectedInstOperands,
     /* 214211 */     // GIR_Coverage, 43,
     /* 214211 */     GIR_EraseRootFromParent_Done,
     /* 214212 */   // Label 4221: @214212
     /* 214212 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(214266), // Rule ID 44 //
     /* 214217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214253 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 214256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214264 */     GIR_RootConstrainSelectedInstOperands,
     /* 214265 */     // GIR_Coverage, 44,
     /* 214265 */     GIR_EraseRootFromParent_Done,
     /* 214266 */   // Label 4222: @214266
     /* 214266 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(214320), // Rule ID 45 //
     /* 214271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214307 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 214310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214318 */     GIR_RootConstrainSelectedInstOperands,
     /* 214319 */     // GIR_Coverage, 45,
     /* 214319 */     GIR_EraseRootFromParent_Done,
     /* 214320 */   // Label 4223: @214320
     /* 214320 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214374), // Rule ID 46 //
     /* 214325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214361 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 214364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214372 */     GIR_RootConstrainSelectedInstOperands,
     /* 214373 */     // GIR_Coverage, 46,
     /* 214373 */     GIR_EraseRootFromParent_Done,
     /* 214374 */   // Label 4224: @214374
     /* 214374 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214428), // Rule ID 1587 //
     /* 214379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214415 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 214418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214426 */     GIR_RootConstrainSelectedInstOperands,
     /* 214427 */     // GIR_Coverage, 1587,
     /* 214427 */     GIR_EraseRootFromParent_Done,
     /* 214428 */   // Label 4225: @214428
     /* 214428 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214482), // Rule ID 1588 //
     /* 214433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214469 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 214472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214480 */     GIR_RootConstrainSelectedInstOperands,
     /* 214481 */     // GIR_Coverage, 1588,
     /* 214481 */     GIR_EraseRootFromParent_Done,
     /* 214482 */   // Label 4226: @214482
     /* 214482 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214536), // Rule ID 1589 //
     /* 214487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214523 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 214526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214534 */     GIR_RootConstrainSelectedInstOperands,
     /* 214535 */     // GIR_Coverage, 1589,
     /* 214535 */     GIR_EraseRootFromParent_Done,
     /* 214536 */   // Label 4227: @214536
     /* 214536 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214590), // Rule ID 1590 //
     /* 214541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214577 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 214580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214588 */     GIR_RootConstrainSelectedInstOperands,
     /* 214589 */     // GIR_Coverage, 1590,
     /* 214589 */     GIR_EraseRootFromParent_Done,
     /* 214590 */   // Label 4228: @214590
     /* 214590 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214644), // Rule ID 1591 //
     /* 214595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214631 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 214634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214642 */     GIR_RootConstrainSelectedInstOperands,
     /* 214643 */     // GIR_Coverage, 1591,
     /* 214643 */     GIR_EraseRootFromParent_Done,
     /* 214644 */   // Label 4229: @214644
     /* 214644 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214698), // Rule ID 1592 //
     /* 214649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214685 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 214688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214696 */     GIR_RootConstrainSelectedInstOperands,
     /* 214697 */     // GIR_Coverage, 1592,
     /* 214697 */     GIR_EraseRootFromParent_Done,
     /* 214698 */   // Label 4230: @214698
     /* 214698 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214752), // Rule ID 1593 //
     /* 214703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214739 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 214742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214750 */     GIR_RootConstrainSelectedInstOperands,
     /* 214751 */     // GIR_Coverage, 1593,
     /* 214751 */     GIR_EraseRootFromParent_Done,
     /* 214752 */   // Label 4231: @214752
     /* 214752 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214806), // Rule ID 1594 //
     /* 214757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214793 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 214796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214804 */     GIR_RootConstrainSelectedInstOperands,
     /* 214805 */     // GIR_Coverage, 1594,
     /* 214805 */     GIR_EraseRootFromParent_Done,
     /* 214806 */   // Label 4232: @214806
     /* 214806 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214860), // Rule ID 2307 //
     /* 214811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 214819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214847 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 214850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214858 */     GIR_RootConstrainSelectedInstOperands,
     /* 214859 */     // GIR_Coverage, 2307,
     /* 214859 */     GIR_EraseRootFromParent_Done,
     /* 214860 */   // Label 4233: @214860
     /* 214860 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214914), // Rule ID 2308 //
     /* 214865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 214873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214901 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 214904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214912 */     GIR_RootConstrainSelectedInstOperands,
     /* 214913 */     // GIR_Coverage, 2308,
     /* 214913 */     GIR_EraseRootFromParent_Done,
     /* 214914 */   // Label 4234: @214914
     /* 214914 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214968), // Rule ID 2309 //
     /* 214919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 214927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214955 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 214958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214966 */     GIR_RootConstrainSelectedInstOperands,
     /* 214967 */     // GIR_Coverage, 2309,
     /* 214967 */     GIR_EraseRootFromParent_Done,
     /* 214968 */   // Label 4235: @214968
     /* 214968 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(215022), // Rule ID 2310 //
     /* 214973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 214981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 215012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215020 */     GIR_RootConstrainSelectedInstOperands,
     /* 215021 */     // GIR_Coverage, 2310,
     /* 215021 */     GIR_EraseRootFromParent_Done,
     /* 215022 */   // Label 4236: @215022
     /* 215022 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(215076), // Rule ID 2311 //
     /* 215027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 215035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215063 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 215066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215074 */     GIR_RootConstrainSelectedInstOperands,
     /* 215075 */     // GIR_Coverage, 2311,
     /* 215075 */     GIR_EraseRootFromParent_Done,
     /* 215076 */   // Label 4237: @215076
     /* 215076 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215130), // Rule ID 2312 //
     /* 215081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 215089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215117 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 215120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215128 */     GIR_RootConstrainSelectedInstOperands,
     /* 215129 */     // GIR_Coverage, 2312,
     /* 215129 */     GIR_EraseRootFromParent_Done,
     /* 215130 */   // Label 4238: @215130
     /* 215130 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215184), // Rule ID 2313 //
     /* 215135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 215143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215171 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 215174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215182 */     GIR_RootConstrainSelectedInstOperands,
     /* 215183 */     // GIR_Coverage, 2313,
     /* 215183 */     GIR_EraseRootFromParent_Done,
     /* 215184 */   // Label 4239: @215184
     /* 215184 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215241), // Rule ID 3640 //
     /* 215189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 215228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215234 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215239 */     GIR_RootConstrainSelectedInstOperands,
     /* 215240 */     // GIR_Coverage, 3640,
     /* 215240 */     GIR_EraseRootFromParent_Done,
     /* 215241 */   // Label 4240: @215241
     /* 215241 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215298), // Rule ID 3641 //
     /* 215246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 215285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215291 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215296 */     GIR_RootConstrainSelectedInstOperands,
     /* 215297 */     // GIR_Coverage, 3641,
     /* 215297 */     GIR_EraseRootFromParent_Done,
     /* 215298 */   // Label 4241: @215298
     /* 215298 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(215355), // Rule ID 3642 //
     /* 215303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215339 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 215342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215348 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215353 */     GIR_RootConstrainSelectedInstOperands,
     /* 215354 */     // GIR_Coverage, 3642,
     /* 215354 */     GIR_EraseRootFromParent_Done,
     /* 215355 */   // Label 4242: @215355
     /* 215355 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215412), // Rule ID 3643 //
     /* 215360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 215399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215405 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215410 */     GIR_RootConstrainSelectedInstOperands,
     /* 215411 */     // GIR_Coverage, 3643,
     /* 215411 */     GIR_EraseRootFromParent_Done,
     /* 215412 */   // Label 4243: @215412
     /* 215412 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215466), // Rule ID 3808 //
     /* 215417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 215425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215453 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 215456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215464 */     GIR_RootConstrainSelectedInstOperands,
     /* 215465 */     // GIR_Coverage, 3808,
     /* 215465 */     GIR_EraseRootFromParent_Done,
     /* 215466 */   // Label 4244: @215466
     /* 215466 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215520), // Rule ID 3809 //
     /* 215471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 215479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215507 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 215510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215518 */     GIR_RootConstrainSelectedInstOperands,
     /* 215519 */     // GIR_Coverage, 3809,
     /* 215519 */     GIR_EraseRootFromParent_Done,
     /* 215520 */   // Label 4245: @215520
     /* 215520 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215574), // Rule ID 3810 //
     /* 215525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 215533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215561 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 215564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215572 */     GIR_RootConstrainSelectedInstOperands,
     /* 215573 */     // GIR_Coverage, 3810,
     /* 215573 */     GIR_EraseRootFromParent_Done,
     /* 215574 */   // Label 4246: @215574
     /* 215574 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215628), // Rule ID 3811 //
     /* 215579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215615 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215626 */     GIR_RootConstrainSelectedInstOperands,
     /* 215627 */     // GIR_Coverage, 3811,
     /* 215627 */     GIR_EraseRootFromParent_Done,
     /* 215628 */   // Label 4247: @215628
     /* 215628 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215682), // Rule ID 3812 //
     /* 215633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215669 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215680 */     GIR_RootConstrainSelectedInstOperands,
     /* 215681 */     // GIR_Coverage, 3812,
     /* 215681 */     GIR_EraseRootFromParent_Done,
     /* 215682 */   // Label 4248: @215682
     /* 215682 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215736), // Rule ID 3813 //
     /* 215687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215734 */     GIR_RootConstrainSelectedInstOperands,
     /* 215735 */     // GIR_Coverage, 3813,
     /* 215735 */     GIR_EraseRootFromParent_Done,
     /* 215736 */   // Label 4249: @215736
     /* 215736 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215790), // Rule ID 3814 //
     /* 215741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215777 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215788 */     GIR_RootConstrainSelectedInstOperands,
     /* 215789 */     // GIR_Coverage, 3814,
     /* 215789 */     GIR_EraseRootFromParent_Done,
     /* 215790 */   // Label 4250: @215790
     /* 215790 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215844), // Rule ID 3823 //
     /* 215795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215831 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215842 */     GIR_RootConstrainSelectedInstOperands,
     /* 215843 */     // GIR_Coverage, 3823,
     /* 215843 */     GIR_EraseRootFromParent_Done,
     /* 215844 */   // Label 4251: @215844
     /* 215844 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215898), // Rule ID 3824 //
     /* 215849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215885 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215896 */     GIR_RootConstrainSelectedInstOperands,
     /* 215897 */     // GIR_Coverage, 3824,
     /* 215897 */     GIR_EraseRootFromParent_Done,
     /* 215898 */   // Label 4252: @215898
     /* 215898 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215952), // Rule ID 3825 //
     /* 215903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215939 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215950 */     GIR_RootConstrainSelectedInstOperands,
     /* 215951 */     // GIR_Coverage, 3825,
     /* 215951 */     GIR_EraseRootFromParent_Done,
     /* 215952 */   // Label 4253: @215952
     /* 215952 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(216006), // Rule ID 3826 //
     /* 215957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216004 */     GIR_RootConstrainSelectedInstOperands,
     /* 216005 */     // GIR_Coverage, 3826,
     /* 216005 */     GIR_EraseRootFromParent_Done,
     /* 216006 */   // Label 4254: @216006
     /* 216006 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(216060), // Rule ID 3827 //
     /* 216011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216047 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216058 */     GIR_RootConstrainSelectedInstOperands,
     /* 216059 */     // GIR_Coverage, 3827,
     /* 216059 */     GIR_EraseRootFromParent_Done,
     /* 216060 */   // Label 4255: @216060
     /* 216060 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216114), // Rule ID 3828 //
     /* 216065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216101 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216112 */     GIR_RootConstrainSelectedInstOperands,
     /* 216113 */     // GIR_Coverage, 3828,
     /* 216113 */     GIR_EraseRootFromParent_Done,
     /* 216114 */   // Label 4256: @216114
     /* 216114 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216168), // Rule ID 3829 //
     /* 216119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216166 */     GIR_RootConstrainSelectedInstOperands,
     /* 216167 */     // GIR_Coverage, 3829,
     /* 216167 */     GIR_EraseRootFromParent_Done,
     /* 216168 */   // Label 4257: @216168
     /* 216168 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216222), // Rule ID 3830 //
     /* 216173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216209 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216220 */     GIR_RootConstrainSelectedInstOperands,
     /* 216221 */     // GIR_Coverage, 3830,
     /* 216221 */     GIR_EraseRootFromParent_Done,
     /* 216222 */   // Label 4258: @216222
     /* 216222 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216276), // Rule ID 3831 //
     /* 216227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216263 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216274 */     GIR_RootConstrainSelectedInstOperands,
     /* 216275 */     // GIR_Coverage, 3831,
     /* 216275 */     GIR_EraseRootFromParent_Done,
     /* 216276 */   // Label 4259: @216276
     /* 216276 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216330), // Rule ID 3832 //
     /* 216281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216317 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216328 */     GIR_RootConstrainSelectedInstOperands,
     /* 216329 */     // GIR_Coverage, 3832,
     /* 216329 */     GIR_EraseRootFromParent_Done,
     /* 216330 */   // Label 4260: @216330
     /* 216330 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216384), // Rule ID 3833 //
     /* 216335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216371 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216382 */     GIR_RootConstrainSelectedInstOperands,
     /* 216383 */     // GIR_Coverage, 3833,
     /* 216383 */     GIR_EraseRootFromParent_Done,
     /* 216384 */   // Label 4261: @216384
     /* 216384 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216438), // Rule ID 3834 //
     /* 216389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216425 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216436 */     GIR_RootConstrainSelectedInstOperands,
     /* 216437 */     // GIR_Coverage, 3834,
     /* 216437 */     GIR_EraseRootFromParent_Done,
     /* 216438 */   // Label 4262: @216438
     /* 216438 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216492), // Rule ID 3838 //
     /* 216443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 216451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 216479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 216482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 216486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 216488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 216490 */     GIR_RootConstrainSelectedInstOperands,
     /* 216491 */     // GIR_Coverage, 3838,
     /* 216491 */     GIR_EraseRootFromParent_Done,
     /* 216492 */   // Label 4263: @216492
     /* 216492 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216546), // Rule ID 3839 //
     /* 216497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 216505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 216536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216544 */     GIR_RootConstrainSelectedInstOperands,
     /* 216545 */     // GIR_Coverage, 3839,
     /* 216545 */     GIR_EraseRootFromParent_Done,
     /* 216546 */   // Label 4264: @216546
     /* 216546 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216600), // Rule ID 3840 //
     /* 216551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 216559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 216590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216598 */     GIR_RootConstrainSelectedInstOperands,
     /* 216599 */     // GIR_Coverage, 3840,
     /* 216599 */     GIR_EraseRootFromParent_Done,
     /* 216600 */   // Label 4265: @216600
     /* 216600 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216657), // Rule ID 3857 //
     /* 216605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216641 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 216641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216655 */     GIR_RootConstrainSelectedInstOperands,
     /* 216656 */     // GIR_Coverage, 3857,
     /* 216656 */     GIR_EraseRootFromParent_Done,
     /* 216657 */   // Label 4266: @216657
     /* 216657 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216714), // Rule ID 3858 //
     /* 216662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216698 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 216698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216712 */     GIR_RootConstrainSelectedInstOperands,
     /* 216713 */     // GIR_Coverage, 3858,
     /* 216713 */     GIR_EraseRootFromParent_Done,
     /* 216714 */   // Label 4267: @216714
     /* 216714 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216771), // Rule ID 3859 //
     /* 216719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216755 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 216755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216769 */     GIR_RootConstrainSelectedInstOperands,
     /* 216770 */     // GIR_Coverage, 3859,
     /* 216770 */     GIR_EraseRootFromParent_Done,
     /* 216771 */   // Label 4268: @216771
     /* 216771 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216828), // Rule ID 3860 //
     /* 216776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216812 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 216812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216826 */     GIR_RootConstrainSelectedInstOperands,
     /* 216827 */     // GIR_Coverage, 3860,
     /* 216827 */     GIR_EraseRootFromParent_Done,
     /* 216828 */   // Label 4269: @216828
     /* 216828 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216885), // Rule ID 3865 //
     /* 216833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216869 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 216869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216883 */     GIR_RootConstrainSelectedInstOperands,
     /* 216884 */     // GIR_Coverage, 3865,
     /* 216884 */     GIR_EraseRootFromParent_Done,
     /* 216885 */   // Label 4270: @216885
     /* 216885 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216942), // Rule ID 3866 //
     /* 216890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216926 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 216926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216940 */     GIR_RootConstrainSelectedInstOperands,
     /* 216941 */     // GIR_Coverage, 3866,
     /* 216941 */     GIR_EraseRootFromParent_Done,
     /* 216942 */   // Label 4271: @216942
     /* 216942 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216999), // Rule ID 3867 //
     /* 216947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216983 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 216983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216997 */     GIR_RootConstrainSelectedInstOperands,
     /* 216998 */     // GIR_Coverage, 3867,
     /* 216998 */     GIR_EraseRootFromParent_Done,
     /* 216999 */   // Label 4272: @216999
     /* 216999 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(217056), // Rule ID 3868 //
     /* 217004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217040 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 217040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217054 */     GIR_RootConstrainSelectedInstOperands,
     /* 217055 */     // GIR_Coverage, 3868,
     /* 217055 */     GIR_EraseRootFromParent_Done,
     /* 217056 */   // Label 4273: @217056
     /* 217056 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217113), // Rule ID 3873 //
     /* 217061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217097 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 217097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217111 */     GIR_RootConstrainSelectedInstOperands,
     /* 217112 */     // GIR_Coverage, 3873,
     /* 217112 */     GIR_EraseRootFromParent_Done,
     /* 217113 */   // Label 4274: @217113
     /* 217113 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217170), // Rule ID 3874 //
     /* 217118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217154 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 217154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217168 */     GIR_RootConstrainSelectedInstOperands,
     /* 217169 */     // GIR_Coverage, 3874,
     /* 217169 */     GIR_EraseRootFromParent_Done,
     /* 217170 */   // Label 4275: @217170
     /* 217170 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217227), // Rule ID 3875 //
     /* 217175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217211 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 217211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217225 */     GIR_RootConstrainSelectedInstOperands,
     /* 217226 */     // GIR_Coverage, 3875,
     /* 217226 */     GIR_EraseRootFromParent_Done,
     /* 217227 */   // Label 4276: @217227
     /* 217227 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217284), // Rule ID 3876 //
     /* 217232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217268 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 217268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217282 */     GIR_RootConstrainSelectedInstOperands,
     /* 217283 */     // GIR_Coverage, 3876,
     /* 217283 */     GIR_EraseRootFromParent_Done,
     /* 217284 */   // Label 4277: @217284
     /* 217284 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217341), // Rule ID 3877 //
     /* 217289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217325 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 217325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217339 */     GIR_RootConstrainSelectedInstOperands,
     /* 217340 */     // GIR_Coverage, 3877,
     /* 217340 */     GIR_EraseRootFromParent_Done,
     /* 217341 */   // Label 4278: @217341
     /* 217341 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217398), // Rule ID 3878 //
     /* 217346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217382 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 217382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217396 */     GIR_RootConstrainSelectedInstOperands,
     /* 217397 */     // GIR_Coverage, 3878,
     /* 217397 */     GIR_EraseRootFromParent_Done,
     /* 217398 */   // Label 4279: @217398
     /* 217398 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217455), // Rule ID 3879 //
     /* 217403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217439 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 217439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217453 */     GIR_RootConstrainSelectedInstOperands,
     /* 217454 */     // GIR_Coverage, 3879,
     /* 217454 */     GIR_EraseRootFromParent_Done,
     /* 217455 */   // Label 4280: @217455
     /* 217455 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217512), // Rule ID 3880 //
     /* 217460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217496 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 217496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217510 */     GIR_RootConstrainSelectedInstOperands,
     /* 217511 */     // GIR_Coverage, 3880,
     /* 217511 */     GIR_EraseRootFromParent_Done,
     /* 217512 */   // Label 4281: @217512
     /* 217512 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217569), // Rule ID 3881 //
     /* 217517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217553 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 217553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217567 */     GIR_RootConstrainSelectedInstOperands,
     /* 217568 */     // GIR_Coverage, 3881,
     /* 217568 */     GIR_EraseRootFromParent_Done,
     /* 217569 */   // Label 4282: @217569
     /* 217569 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217626), // Rule ID 3882 //
     /* 217574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217610 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 217610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217624 */     GIR_RootConstrainSelectedInstOperands,
     /* 217625 */     // GIR_Coverage, 3882,
     /* 217625 */     GIR_EraseRootFromParent_Done,
     /* 217626 */   // Label 4283: @217626
     /* 217626 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217683), // Rule ID 3883 //
     /* 217631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217667 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 217667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217681 */     GIR_RootConstrainSelectedInstOperands,
     /* 217682 */     // GIR_Coverage, 3883,
     /* 217682 */     GIR_EraseRootFromParent_Done,
     /* 217683 */   // Label 4284: @217683
     /* 217683 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217740), // Rule ID 3884 //
     /* 217688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217724 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 217724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217738 */     GIR_RootConstrainSelectedInstOperands,
     /* 217739 */     // GIR_Coverage, 3884,
     /* 217739 */     GIR_EraseRootFromParent_Done,
     /* 217740 */   // Label 4285: @217740
     /* 217740 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217794), // Rule ID 5219 //
     /* 217745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217781 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 217784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217792 */     GIR_RootConstrainSelectedInstOperands,
     /* 217793 */     // GIR_Coverage, 5219,
     /* 217793 */     GIR_EraseRootFromParent_Done,
     /* 217794 */   // Label 4286: @217794
     /* 217794 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217848), // Rule ID 5220 //
     /* 217799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217835 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 217838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217846 */     GIR_RootConstrainSelectedInstOperands,
     /* 217847 */     // GIR_Coverage, 5220,
     /* 217847 */     GIR_EraseRootFromParent_Done,
     /* 217848 */   // Label 4287: @217848
     /* 217848 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217899), // Rule ID 5573 //
     /* 217853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 217861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 217864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 217870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217886 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 217886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 217889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 217897 */     GIR_RootConstrainSelectedInstOperands,
     /* 217898 */     // GIR_Coverage, 5573,
     /* 217898 */     GIR_EraseRootFromParent_Done,
     /* 217899 */   // Label 4288: @217899
     /* 217899 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217950), // Rule ID 5574 //
     /* 217904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217937 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 217937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 217940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 217946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 217948 */     GIR_RootConstrainSelectedInstOperands,
     /* 217949 */     // GIR_Coverage, 5574,
     /* 217949 */     GIR_EraseRootFromParent_Done,
     /* 217950 */   // Label 4289: @217950
     /* 217950 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217992), // Rule ID 2699 //
     /* 217955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217979 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 217982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217990 */     GIR_RootConstrainSelectedInstOperands,
     /* 217991 */     // GIR_Coverage, 2699,
     /* 217991 */     GIR_EraseRootFromParent_Done,
     /* 217992 */   // Label 4290: @217992
     /* 217992 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(218034), // Rule ID 2700 //
     /* 217997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218032 */     GIR_RootConstrainSelectedInstOperands,
     /* 218033 */     // GIR_Coverage, 2700,
     /* 218033 */     GIR_EraseRootFromParent_Done,
     /* 218034 */   // Label 4291: @218034
     /* 218034 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(218076), // Rule ID 2701 //
     /* 218039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218074 */     GIR_RootConstrainSelectedInstOperands,
     /* 218075 */     // GIR_Coverage, 2701,
     /* 218075 */     GIR_EraseRootFromParent_Done,
     /* 218076 */   // Label 4292: @218076
     /* 218076 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218118), // Rule ID 2702 //
     /* 218081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218116 */     GIR_RootConstrainSelectedInstOperands,
     /* 218117 */     // GIR_Coverage, 2702,
     /* 218117 */     GIR_EraseRootFromParent_Done,
     /* 218118 */   // Label 4293: @218118
     /* 218118 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218160), // Rule ID 2703 //
     /* 218123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218147 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1910:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218158 */     GIR_RootConstrainSelectedInstOperands,
     /* 218159 */     // GIR_Coverage, 2703,
     /* 218159 */     GIR_EraseRootFromParent_Done,
     /* 218160 */   // Label 4294: @218160
     /* 218160 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218202), // Rule ID 2704 //
     /* 218165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218189 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1910:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218200 */     GIR_RootConstrainSelectedInstOperands,
     /* 218201 */     // GIR_Coverage, 2704,
     /* 218201 */     GIR_EraseRootFromParent_Done,
     /* 218202 */   // Label 4295: @218202
     /* 218202 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218244), // Rule ID 2705 //
     /* 218207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1910:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218242 */     GIR_RootConstrainSelectedInstOperands,
     /* 218243 */     // GIR_Coverage, 2705,
     /* 218243 */     GIR_EraseRootFromParent_Done,
     /* 218244 */   // Label 4296: @218244
     /* 218244 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218286), // Rule ID 2744 //
     /* 218249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1256:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218284 */     GIR_RootConstrainSelectedInstOperands,
     /* 218285 */     // GIR_Coverage, 2744,
     /* 218285 */     GIR_EraseRootFromParent_Done,
     /* 218286 */   // Label 4297: @218286
     /* 218286 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218328), // Rule ID 2745 //
     /* 218291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 218302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 218311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218315 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1256:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 218315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218326 */     GIR_RootConstrainSelectedInstOperands,
     /* 218327 */     // GIR_Coverage, 2745,
     /* 218327 */     GIR_EraseRootFromParent_Done,
     /* 218328 */   // Label 4298: @218328
     /* 218328 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218370), // Rule ID 2746 //
     /* 218333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 218344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 218353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218357 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1256:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 218357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218368 */     GIR_RootConstrainSelectedInstOperands,
     /* 218369 */     // GIR_Coverage, 2746,
     /* 218369 */     GIR_EraseRootFromParent_Done,
     /* 218370 */   // Label 4299: @218370
     /* 218370 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218412), // Rule ID 2747 //
     /* 218375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 218386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 218395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1256:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 218399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218410 */     GIR_RootConstrainSelectedInstOperands,
     /* 218411 */     // GIR_Coverage, 2747,
     /* 218411 */     GIR_EraseRootFromParent_Done,
     /* 218412 */   // Label 4300: @218412
     /* 218412 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218454), // Rule ID 2748 //
     /* 218417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 218428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 218431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 218434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 218437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218441 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1256:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 218441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218452 */     GIR_RootConstrainSelectedInstOperands,
     /* 218453 */     // GIR_Coverage, 2748,
     /* 218453 */     GIR_EraseRootFromParent_Done,
     /* 218454 */   // Label 4301: @218454
     /* 218454 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218496), // Rule ID 2787 //
     /* 218459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218483 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 218486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218494 */     GIR_RootConstrainSelectedInstOperands,
     /* 218495 */     // GIR_Coverage, 2787,
     /* 218495 */     GIR_EraseRootFromParent_Done,
     /* 218496 */   // Label 4302: @218496
     /* 218496 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218538), // Rule ID 2789 //
     /* 218501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218525 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 218528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218536 */     GIR_RootConstrainSelectedInstOperands,
     /* 218537 */     // GIR_Coverage, 2789,
     /* 218537 */     GIR_EraseRootFromParent_Done,
     /* 218538 */   // Label 4303: @218538
     /* 218538 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218580), // Rule ID 2791 //
     /* 218543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218567 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 218570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218578 */     GIR_RootConstrainSelectedInstOperands,
     /* 218579 */     // GIR_Coverage, 2791,
     /* 218579 */     GIR_EraseRootFromParent_Done,
     /* 218580 */   // Label 4304: @218580
     /* 218580 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218622), // Rule ID 2793 //
     /* 218585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218609 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1529:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 218612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218620 */     GIR_RootConstrainSelectedInstOperands,
     /* 218621 */     // GIR_Coverage, 2793,
     /* 218621 */     GIR_EraseRootFromParent_Done,
     /* 218622 */   // Label 4305: @218622
     /* 218622 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218664), // Rule ID 2794 //
     /* 218627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1529:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 218654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218662 */     GIR_RootConstrainSelectedInstOperands,
     /* 218663 */     // GIR_Coverage, 2794,
     /* 218663 */     GIR_EraseRootFromParent_Done,
     /* 218664 */   // Label 4306: @218664
     /* 218664 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218706), // Rule ID 2795 //
     /* 218669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1529:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 218696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218704 */     GIR_RootConstrainSelectedInstOperands,
     /* 218705 */     // GIR_Coverage, 2795,
     /* 218705 */     GIR_EraseRootFromParent_Done,
     /* 218706 */   // Label 4307: @218706
     /* 218706 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218748), // Rule ID 2864 //
     /* 218711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 218719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218735 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1391:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 218738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218746 */     GIR_RootConstrainSelectedInstOperands,
     /* 218747 */     // GIR_Coverage, 2864,
     /* 218747 */     GIR_EraseRootFromParent_Done,
     /* 218748 */   // Label 4308: @218748
     /* 218748 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218790), // Rule ID 2865 //
     /* 218753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 218761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218777 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 218780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218788 */     GIR_RootConstrainSelectedInstOperands,
     /* 218789 */     // GIR_Coverage, 2865,
     /* 218789 */     GIR_EraseRootFromParent_Done,
     /* 218790 */   // Label 4309: @218790
     /* 218790 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218832), // Rule ID 2866 //
     /* 218795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 218803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 218822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218830 */     GIR_RootConstrainSelectedInstOperands,
     /* 218831 */     // GIR_Coverage, 2866,
     /* 218831 */     GIR_EraseRootFromParent_Done,
     /* 218832 */   // Label 4310: @218832
     /* 218832 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(218874), // Rule ID 2867 //
     /* 218837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 218845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1388:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 218864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218872 */     GIR_RootConstrainSelectedInstOperands,
     /* 218873 */     // GIR_Coverage, 2867,
     /* 218873 */     GIR_EraseRootFromParent_Done,
     /* 218874 */   // Label 4311: @218874
     /* 218874 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(218916), // Rule ID 2868 //
     /* 218879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 218887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218903 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 218906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218914 */     GIR_RootConstrainSelectedInstOperands,
     /* 218915 */     // GIR_Coverage, 2868,
     /* 218915 */     GIR_EraseRootFromParent_Done,
     /* 218916 */   // Label 4312: @218916
     /* 218916 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(218958), // Rule ID 2869 //
     /* 218921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218945 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 218948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218956 */     GIR_RootConstrainSelectedInstOperands,
     /* 218957 */     // GIR_Coverage, 2869,
     /* 218957 */     GIR_EraseRootFromParent_Done,
     /* 218958 */   // Label 4313: @218958
     /* 218958 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(219000), // Rule ID 2870 //
     /* 218963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218987 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 218990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218998 */     GIR_RootConstrainSelectedInstOperands,
     /* 218999 */     // GIR_Coverage, 2870,
     /* 218999 */     GIR_EraseRootFromParent_Done,
     /* 219000 */   // Label 4314: @219000
     /* 219000 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219042), // Rule ID 2871 //
     /* 219005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219029 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 219032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219040 */     GIR_RootConstrainSelectedInstOperands,
     /* 219041 */     // GIR_Coverage, 2871,
     /* 219041 */     GIR_EraseRootFromParent_Done,
     /* 219042 */   // Label 4315: @219042
     /* 219042 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219084), // Rule ID 2882 //
     /* 219047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 219055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219071 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 219074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219082 */     GIR_RootConstrainSelectedInstOperands,
     /* 219083 */     // GIR_Coverage, 2882,
     /* 219083 */     GIR_EraseRootFromParent_Done,
     /* 219084 */   // Label 4316: @219084
     /* 219084 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219126), // Rule ID 2884 //
     /* 219089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 219097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219113 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1378:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 219116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219124 */     GIR_RootConstrainSelectedInstOperands,
     /* 219125 */     // GIR_Coverage, 2884,
     /* 219125 */     GIR_EraseRootFromParent_Done,
     /* 219126 */   // Label 4317: @219126
     /* 219126 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219168), // Rule ID 2892 //
     /* 219131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1415:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 219158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219166 */     GIR_RootConstrainSelectedInstOperands,
     /* 219167 */     // GIR_Coverage, 2892,
     /* 219167 */     GIR_EraseRootFromParent_Done,
     /* 219168 */   // Label 4318: @219168
     /* 219168 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219210), // Rule ID 2893 //
     /* 219173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1415:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 219200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219208 */     GIR_RootConstrainSelectedInstOperands,
     /* 219209 */     // GIR_Coverage, 2893,
     /* 219209 */     GIR_EraseRootFromParent_Done,
     /* 219210 */   // Label 4319: @219210
     /* 219210 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219252), // Rule ID 2894 //
     /* 219215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1415:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 219242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219250 */     GIR_RootConstrainSelectedInstOperands,
     /* 219251 */     // GIR_Coverage, 2894,
     /* 219251 */     GIR_EraseRootFromParent_Done,
     /* 219252 */   // Label 4320: @219252
     /* 219252 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219294), // Rule ID 2898 //
     /* 219257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 219265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219281 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 219284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219292 */     GIR_RootConstrainSelectedInstOperands,
     /* 219293 */     // GIR_Coverage, 2898,
     /* 219293 */     GIR_EraseRootFromParent_Done,
     /* 219294 */   // Label 4321: @219294
     /* 219294 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219336), // Rule ID 2943 //
     /* 219299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 219326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219334 */     GIR_RootConstrainSelectedInstOperands,
     /* 219335 */     // GIR_Coverage, 2943,
     /* 219335 */     GIR_EraseRootFromParent_Done,
     /* 219336 */   // Label 4322: @219336
     /* 219336 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219378), // Rule ID 2944 //
     /* 219341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 219368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219376 */     GIR_RootConstrainSelectedInstOperands,
     /* 219377 */     // GIR_Coverage, 2944,
     /* 219377 */     GIR_EraseRootFromParent_Done,
     /* 219378 */   // Label 4323: @219378
     /* 219378 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219420), // Rule ID 2973 //
     /* 219383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1814:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 219410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219418 */     GIR_RootConstrainSelectedInstOperands,
     /* 219419 */     // GIR_Coverage, 2973,
     /* 219419 */     GIR_EraseRootFromParent_Done,
     /* 219420 */   // Label 4324: @219420
     /* 219420 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219462), // Rule ID 2974 //
     /* 219425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 219452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219460 */     GIR_RootConstrainSelectedInstOperands,
     /* 219461 */     // GIR_Coverage, 2974,
     /* 219461 */     GIR_EraseRootFromParent_Done,
     /* 219462 */   // Label 4325: @219462
     /* 219462 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219504), // Rule ID 2975 //
     /* 219467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 219494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219502 */     GIR_RootConstrainSelectedInstOperands,
     /* 219503 */     // GIR_Coverage, 2975,
     /* 219503 */     GIR_EraseRootFromParent_Done,
     /* 219504 */   // Label 4326: @219504
     /* 219504 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219546), // Rule ID 2976 //
     /* 219509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219533 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 219536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219544 */     GIR_RootConstrainSelectedInstOperands,
     /* 219545 */     // GIR_Coverage, 2976,
     /* 219545 */     GIR_EraseRootFromParent_Done,
     /* 219546 */   // Label 4327: @219546
     /* 219546 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219588), // Rule ID 2977 //
     /* 219551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1735:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 219578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219586 */     GIR_RootConstrainSelectedInstOperands,
     /* 219587 */     // GIR_Coverage, 2977,
     /* 219587 */     GIR_EraseRootFromParent_Done,
     /* 219588 */   // Label 4328: @219588
     /* 219588 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219630), // Rule ID 2978 //
     /* 219593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1735:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 219620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219628 */     GIR_RootConstrainSelectedInstOperands,
     /* 219629 */     // GIR_Coverage, 2978,
     /* 219629 */     GIR_EraseRootFromParent_Done,
     /* 219630 */   // Label 4329: @219630
     /* 219630 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219672), // Rule ID 2979 //
     /* 219635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1735:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 219662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219670 */     GIR_RootConstrainSelectedInstOperands,
     /* 219671 */     // GIR_Coverage, 2979,
     /* 219671 */     GIR_EraseRootFromParent_Done,
     /* 219672 */   // Label 4330: @219672
     /* 219672 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219714), // Rule ID 3009 //
     /* 219677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1709:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 219704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219712 */     GIR_RootConstrainSelectedInstOperands,
     /* 219713 */     // GIR_Coverage, 3009,
     /* 219713 */     GIR_EraseRootFromParent_Done,
     /* 219714 */   // Label 4331: @219714
     /* 219714 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219756), // Rule ID 3011 //
     /* 219719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1709:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 219746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219754 */     GIR_RootConstrainSelectedInstOperands,
     /* 219755 */     // GIR_Coverage, 3011,
     /* 219755 */     GIR_EraseRootFromParent_Done,
     /* 219756 */   // Label 4332: @219756
     /* 219756 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(219798), // Rule ID 3013 //
     /* 219761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 219788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219796 */     GIR_RootConstrainSelectedInstOperands,
     /* 219797 */     // GIR_Coverage, 3013,
     /* 219797 */     GIR_EraseRootFromParent_Done,
     /* 219798 */   // Label 4333: @219798
     /* 219798 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(219840), // Rule ID 3015 //
     /* 219803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 219830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219838 */     GIR_RootConstrainSelectedInstOperands,
     /* 219839 */     // GIR_Coverage, 3015,
     /* 219839 */     GIR_EraseRootFromParent_Done,
     /* 219840 */   // Label 4334: @219840
     /* 219840 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(219882), // Rule ID 3017 //
     /* 219845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 219872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219880 */     GIR_RootConstrainSelectedInstOperands,
     /* 219881 */     // GIR_Coverage, 3017,
     /* 219881 */     GIR_EraseRootFromParent_Done,
     /* 219882 */   // Label 4335: @219882
     /* 219882 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(219924), // Rule ID 3018 //
     /* 219887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 219914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219922 */     GIR_RootConstrainSelectedInstOperands,
     /* 219923 */     // GIR_Coverage, 3018,
     /* 219923 */     GIR_EraseRootFromParent_Done,
     /* 219924 */   // Label 4336: @219924
     /* 219924 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(219966), // Rule ID 3019 //
     /* 219929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1679:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 219956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219964 */     GIR_RootConstrainSelectedInstOperands,
     /* 219965 */     // GIR_Coverage, 3019,
     /* 219965 */     GIR_EraseRootFromParent_Done,
     /* 219966 */   // Label 4337: @219966
     /* 219966 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220008), // Rule ID 3020 //
     /* 219971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 219979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 219998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220006 */     GIR_RootConstrainSelectedInstOperands,
     /* 220007 */     // GIR_Coverage, 3020,
     /* 220007 */     GIR_EraseRootFromParent_Done,
     /* 220008 */   // Label 4338: @220008
     /* 220008 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220050), // Rule ID 3021 //
     /* 220013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220037 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 220040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220048 */     GIR_RootConstrainSelectedInstOperands,
     /* 220049 */     // GIR_Coverage, 3021,
     /* 220049 */     GIR_EraseRootFromParent_Done,
     /* 220050 */   // Label 4339: @220050
     /* 220050 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220092), // Rule ID 3022 //
     /* 220055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220079 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 220082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220090 */     GIR_RootConstrainSelectedInstOperands,
     /* 220091 */     // GIR_Coverage, 3022,
     /* 220091 */     GIR_EraseRootFromParent_Done,
     /* 220092 */   // Label 4340: @220092
     /* 220092 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220134), // Rule ID 3023 //
     /* 220097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 220124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220132 */     GIR_RootConstrainSelectedInstOperands,
     /* 220133 */     // GIR_Coverage, 3023,
     /* 220133 */     GIR_EraseRootFromParent_Done,
     /* 220134 */   // Label 4341: @220134
     /* 220134 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220176), // Rule ID 3024 //
     /* 220139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220163 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 220166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220174 */     GIR_RootConstrainSelectedInstOperands,
     /* 220175 */     // GIR_Coverage, 3024,
     /* 220175 */     GIR_EraseRootFromParent_Done,
     /* 220176 */   // Label 4342: @220176
     /* 220176 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220218), // Rule ID 3041 //
     /* 220181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220205 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1344:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 220208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220216 */     GIR_RootConstrainSelectedInstOperands,
     /* 220217 */     // GIR_Coverage, 3041,
     /* 220217 */     GIR_EraseRootFromParent_Done,
     /* 220218 */   // Label 4343: @220218
     /* 220218 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220260), // Rule ID 3042 //
     /* 220223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220247 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1344:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 220250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220258 */     GIR_RootConstrainSelectedInstOperands,
     /* 220259 */     // GIR_Coverage, 3042,
     /* 220259 */     GIR_EraseRootFromParent_Done,
     /* 220260 */   // Label 4344: @220260
     /* 220260 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220302), // Rule ID 3043 //
     /* 220265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1344:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 220292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220300 */     GIR_RootConstrainSelectedInstOperands,
     /* 220301 */     // GIR_Coverage, 3043,
     /* 220301 */     GIR_EraseRootFromParent_Done,
     /* 220302 */   // Label 4345: @220302
     /* 220302 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220344), // Rule ID 3044 //
     /* 220307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220331 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1344:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 220334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220342 */     GIR_RootConstrainSelectedInstOperands,
     /* 220343 */     // GIR_Coverage, 3044,
     /* 220343 */     GIR_EraseRootFromParent_Done,
     /* 220344 */   // Label 4346: @220344
     /* 220344 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220386), // Rule ID 3068 //
     /* 220349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220373 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1672:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 220376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220384 */     GIR_RootConstrainSelectedInstOperands,
     /* 220385 */     // GIR_Coverage, 3068,
     /* 220385 */     GIR_EraseRootFromParent_Done,
     /* 220386 */   // Label 4347: @220386
     /* 220386 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220428), // Rule ID 3070 //
     /* 220391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220415 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 220418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220426 */     GIR_RootConstrainSelectedInstOperands,
     /* 220427 */     // GIR_Coverage, 3070,
     /* 220427 */     GIR_EraseRootFromParent_Done,
     /* 220428 */   // Label 4348: @220428
     /* 220428 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220470), // Rule ID 3072 //
     /* 220433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 220460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220468 */     GIR_RootConstrainSelectedInstOperands,
     /* 220469 */     // GIR_Coverage, 3072,
     /* 220469 */     GIR_EraseRootFromParent_Done,
     /* 220470 */   // Label 4349: @220470
     /* 220470 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220512), // Rule ID 3074 //
     /* 220475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220499 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 220502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220510 */     GIR_RootConstrainSelectedInstOperands,
     /* 220511 */     // GIR_Coverage, 3074,
     /* 220511 */     GIR_EraseRootFromParent_Done,
     /* 220512 */   // Label 4350: @220512
     /* 220512 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220554), // Rule ID 3076 //
     /* 220517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 220544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220552 */     GIR_RootConstrainSelectedInstOperands,
     /* 220553 */     // GIR_Coverage, 3076,
     /* 220553 */     GIR_EraseRootFromParent_Done,
     /* 220554 */   // Label 4351: @220554
     /* 220554 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220596), // Rule ID 3077 //
     /* 220559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220583 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 220586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220594 */     GIR_RootConstrainSelectedInstOperands,
     /* 220595 */     // GIR_Coverage, 3077,
     /* 220595 */     GIR_EraseRootFromParent_Done,
     /* 220596 */   // Label 4352: @220596
     /* 220596 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220638), // Rule ID 3078 //
     /* 220601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1673:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 220628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220636 */     GIR_RootConstrainSelectedInstOperands,
     /* 220637 */     // GIR_Coverage, 3078,
     /* 220637 */     GIR_EraseRootFromParent_Done,
     /* 220638 */   // Label 4353: @220638
     /* 220638 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220680), // Rule ID 3079 //
     /* 220643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 220670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220678 */     GIR_RootConstrainSelectedInstOperands,
     /* 220679 */     // GIR_Coverage, 3079,
     /* 220679 */     GIR_EraseRootFromParent_Done,
     /* 220680 */   // Label 4354: @220680
     /* 220680 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(220722), // Rule ID 3080 //
     /* 220685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 220712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220720 */     GIR_RootConstrainSelectedInstOperands,
     /* 220721 */     // GIR_Coverage, 3080,
     /* 220721 */     GIR_EraseRootFromParent_Done,
     /* 220722 */   // Label 4355: @220722
     /* 220722 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(220764), // Rule ID 3090 //
     /* 220727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1243:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 220754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220762 */     GIR_RootConstrainSelectedInstOperands,
     /* 220763 */     // GIR_Coverage, 3090,
     /* 220763 */     GIR_EraseRootFromParent_Done,
     /* 220764 */   // Label 4356: @220764
     /* 220764 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(220806), // Rule ID 3091 //
     /* 220769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1243:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 220796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220804 */     GIR_RootConstrainSelectedInstOperands,
     /* 220805 */     // GIR_Coverage, 3091,
     /* 220805 */     GIR_EraseRootFromParent_Done,
     /* 220806 */   // Label 4357: @220806
     /* 220806 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(220848), // Rule ID 3092 //
     /* 220811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1243:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 220838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220846 */     GIR_RootConstrainSelectedInstOperands,
     /* 220847 */     // GIR_Coverage, 3092,
     /* 220847 */     GIR_EraseRootFromParent_Done,
     /* 220848 */   // Label 4358: @220848
     /* 220848 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(220890), // Rule ID 3109 //
     /* 220853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 220880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220888 */     GIR_RootConstrainSelectedInstOperands,
     /* 220889 */     // GIR_Coverage, 3109,
     /* 220889 */     GIR_EraseRootFromParent_Done,
     /* 220890 */   // Label 4359: @220890
     /* 220890 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(220932), // Rule ID 3110 //
     /* 220895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220919 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 220922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220930 */     GIR_RootConstrainSelectedInstOperands,
     /* 220931 */     // GIR_Coverage, 3110,
     /* 220931 */     GIR_EraseRootFromParent_Done,
     /* 220932 */   // Label 4360: @220932
     /* 220932 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(220974), // Rule ID 3111 //
     /* 220937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 220964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220972 */     GIR_RootConstrainSelectedInstOperands,
     /* 220973 */     // GIR_Coverage, 3111,
     /* 220973 */     GIR_EraseRootFromParent_Done,
     /* 220974 */   // Label 4361: @220974
     /* 220974 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221016), // Rule ID 3112 //
     /* 220979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 221003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 221006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221014 */     GIR_RootConstrainSelectedInstOperands,
     /* 221015 */     // GIR_Coverage, 3112,
     /* 221015 */     GIR_EraseRootFromParent_Done,
     /* 221016 */   // Label 4362: @221016
     /* 221016 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221058), // Rule ID 3147 //
     /* 221021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221045 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1343:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221056 */     GIR_RootConstrainSelectedInstOperands,
     /* 221057 */     // GIR_Coverage, 3147,
     /* 221057 */     GIR_EraseRootFromParent_Done,
     /* 221058 */   // Label 4363: @221058
     /* 221058 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221100), // Rule ID 3149 //
     /* 221063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1343:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221098 */     GIR_RootConstrainSelectedInstOperands,
     /* 221099 */     // GIR_Coverage, 3149,
     /* 221099 */     GIR_EraseRootFromParent_Done,
     /* 221100 */   // Label 4364: @221100
     /* 221100 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221142), // Rule ID 3151 //
     /* 221105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1343:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221140 */     GIR_RootConstrainSelectedInstOperands,
     /* 221141 */     // GIR_Coverage, 3151,
     /* 221141 */     GIR_EraseRootFromParent_Done,
     /* 221142 */   // Label 4365: @221142
     /* 221142 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221184), // Rule ID 3153 //
     /* 221147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1343:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221182 */     GIR_RootConstrainSelectedInstOperands,
     /* 221183 */     // GIR_Coverage, 3153,
     /* 221183 */     GIR_EraseRootFromParent_Done,
     /* 221184 */   // Label 4366: @221184
     /* 221184 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221229), // Rule ID 3192 //
     /* 221189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 221216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221227 */     GIR_RootConstrainSelectedInstOperands,
     /* 221228 */     // GIR_Coverage, 3192,
     /* 221228 */     GIR_EraseRootFromParent_Done,
     /* 221229 */   // Label 4367: @221229
     /* 221229 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221274), // Rule ID 3193 //
     /* 221234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 221261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221272 */     GIR_RootConstrainSelectedInstOperands,
     /* 221273 */     // GIR_Coverage, 3193,
     /* 221273 */     GIR_EraseRootFromParent_Done,
     /* 221274 */   // Label 4368: @221274
     /* 221274 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221319), // Rule ID 3194 //
     /* 221279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221303 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 221306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221317 */     GIR_RootConstrainSelectedInstOperands,
     /* 221318 */     // GIR_Coverage, 3194,
     /* 221318 */     GIR_EraseRootFromParent_Done,
     /* 221319 */   // Label 4369: @221319
     /* 221319 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221364), // Rule ID 3195 //
     /* 221324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 221351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221362 */     GIR_RootConstrainSelectedInstOperands,
     /* 221363 */     // GIR_Coverage, 3195,
     /* 221363 */     GIR_EraseRootFromParent_Done,
     /* 221364 */   // Label 4370: @221364
     /* 221364 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221409), // Rule ID 3196 //
     /* 221369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 221396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221407 */     GIR_RootConstrainSelectedInstOperands,
     /* 221408 */     // GIR_Coverage, 3196,
     /* 221408 */     GIR_EraseRootFromParent_Done,
     /* 221409 */   // Label 4371: @221409
     /* 221409 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221454), // Rule ID 3197 //
     /* 221414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 221441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221452 */     GIR_RootConstrainSelectedInstOperands,
     /* 221453 */     // GIR_Coverage, 3197,
     /* 221453 */     GIR_EraseRootFromParent_Done,
     /* 221454 */   // Label 4372: @221454
     /* 221454 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221496), // Rule ID 3252 //
     /* 221459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 221486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221494 */     GIR_RootConstrainSelectedInstOperands,
     /* 221495 */     // GIR_Coverage, 3252,
     /* 221495 */     GIR_EraseRootFromParent_Done,
     /* 221496 */   // Label 4373: @221496
     /* 221496 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221538), // Rule ID 3253 //
     /* 221501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 221528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221536 */     GIR_RootConstrainSelectedInstOperands,
     /* 221537 */     // GIR_Coverage, 3253,
     /* 221537 */     GIR_EraseRootFromParent_Done,
     /* 221538 */   // Label 4374: @221538
     /* 221538 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221580), // Rule ID 3254 //
     /* 221543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 221554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221567 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 221570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221578 */     GIR_RootConstrainSelectedInstOperands,
     /* 221579 */     // GIR_Coverage, 3254,
     /* 221579 */     GIR_EraseRootFromParent_Done,
     /* 221580 */   // Label 4375: @221580
     /* 221580 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221622), // Rule ID 3306 //
     /* 221585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221609 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 221612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 221621 */     // GIR_Coverage, 3306,
     /* 221621 */     GIR_EraseRootFromParent_Done,
     /* 221622 */   // Label 4376: @221622
     /* 221622 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221664), // Rule ID 3307 //
     /* 221627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 221654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221662 */     GIR_RootConstrainSelectedInstOperands,
     /* 221663 */     // GIR_Coverage, 3307,
     /* 221663 */     GIR_EraseRootFromParent_Done,
     /* 221664 */   // Label 4377: @221664
     /* 221664 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221706), // Rule ID 3308 //
     /* 221669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 221696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221704 */     GIR_RootConstrainSelectedInstOperands,
     /* 221705 */     // GIR_Coverage, 3308,
     /* 221705 */     GIR_EraseRootFromParent_Done,
     /* 221706 */   // Label 4378: @221706
     /* 221706 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(221748), // Rule ID 3309 //
     /* 221711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 221738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221746 */     GIR_RootConstrainSelectedInstOperands,
     /* 221747 */     // GIR_Coverage, 3309,
     /* 221747 */     GIR_EraseRootFromParent_Done,
     /* 221748 */   // Label 4379: @221748
     /* 221748 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(221790), // Rule ID 3318 //
     /* 221753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 221780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221788 */     GIR_RootConstrainSelectedInstOperands,
     /* 221789 */     // GIR_Coverage, 3318,
     /* 221789 */     GIR_EraseRootFromParent_Done,
     /* 221790 */   // Label 4380: @221790
     /* 221790 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(221832), // Rule ID 3319 //
     /* 221795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1261:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 221822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221830 */     GIR_RootConstrainSelectedInstOperands,
     /* 221831 */     // GIR_Coverage, 3319,
     /* 221831 */     GIR_EraseRootFromParent_Done,
     /* 221832 */   // Label 4381: @221832
     /* 221832 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(221874), // Rule ID 3320 //
     /* 221837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221872 */     GIR_RootConstrainSelectedInstOperands,
     /* 221873 */     // GIR_Coverage, 3320,
     /* 221873 */     GIR_EraseRootFromParent_Done,
     /* 221874 */   // Label 4382: @221874
     /* 221874 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(221916), // Rule ID 3359 //
     /* 221879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 221906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221914 */     GIR_RootConstrainSelectedInstOperands,
     /* 221915 */     // GIR_Coverage, 3359,
     /* 221915 */     GIR_EraseRootFromParent_Done,
     /* 221916 */   // Label 4383: @221916
     /* 221916 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(221958), // Rule ID 3360 //
     /* 221921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1298:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 221948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221956 */     GIR_RootConstrainSelectedInstOperands,
     /* 221957 */     // GIR_Coverage, 3360,
     /* 221957 */     GIR_EraseRootFromParent_Done,
     /* 221958 */   // Label 4384: @221958
     /* 221958 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222000), // Rule ID 3361 //
     /* 221963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221987 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1298:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 221990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221998 */     GIR_RootConstrainSelectedInstOperands,
     /* 221999 */     // GIR_Coverage, 3361,
     /* 221999 */     GIR_EraseRootFromParent_Done,
     /* 222000 */   // Label 4385: @222000
     /* 222000 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222042), // Rule ID 3362 //
     /* 222005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222029 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1298:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222040 */     GIR_RootConstrainSelectedInstOperands,
     /* 222041 */     // GIR_Coverage, 3362,
     /* 222041 */     GIR_EraseRootFromParent_Done,
     /* 222042 */   // Label 4386: @222042
     /* 222042 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222084), // Rule ID 3363 //
     /* 222047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222071 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1298:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222082 */     GIR_RootConstrainSelectedInstOperands,
     /* 222083 */     // GIR_Coverage, 3363,
     /* 222083 */     GIR_EraseRootFromParent_Done,
     /* 222084 */   // Label 4387: @222084
     /* 222084 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222126), // Rule ID 3364 //
     /* 222089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222113 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1298:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222124 */     GIR_RootConstrainSelectedInstOperands,
     /* 222125 */     // GIR_Coverage, 3364,
     /* 222125 */     GIR_EraseRootFromParent_Done,
     /* 222126 */   // Label 4388: @222126
     /* 222126 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222168), // Rule ID 3365 //
     /* 222131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222155 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1298:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222166 */     GIR_RootConstrainSelectedInstOperands,
     /* 222167 */     // GIR_Coverage, 3365,
     /* 222167 */     GIR_EraseRootFromParent_Done,
     /* 222168 */   // Label 4389: @222168
     /* 222168 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222210), // Rule ID 3448 //
     /* 222173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 222181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222197 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 222200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222208 */     GIR_RootConstrainSelectedInstOperands,
     /* 222209 */     // GIR_Coverage, 3448,
     /* 222209 */     GIR_EraseRootFromParent_Done,
     /* 222210 */   // Label 4390: @222210
     /* 222210 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222252), // Rule ID 3449 //
     /* 222215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 222223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222239 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1289:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 222242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 222244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222250 */     GIR_RootConstrainSelectedInstOperands,
     /* 222251 */     // GIR_Coverage, 3449,
     /* 222251 */     GIR_EraseRootFromParent_Done,
     /* 222252 */   // Label 4391: @222252
     /* 222252 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222294), // Rule ID 3450 //
     /* 222257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 222265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222281 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1285:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 222284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222292 */     GIR_RootConstrainSelectedInstOperands,
     /* 222293 */     // GIR_Coverage, 3450,
     /* 222293 */     GIR_EraseRootFromParent_Done,
     /* 222294 */   // Label 4392: @222294
     /* 222294 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222339), // Rule ID 3452 //
     /* 222299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222337 */     GIR_RootConstrainSelectedInstOperands,
     /* 222338 */     // GIR_Coverage, 3452,
     /* 222338 */     GIR_EraseRootFromParent_Done,
     /* 222339 */   // Label 4393: @222339
     /* 222339 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222384), // Rule ID 3453 //
     /* 222344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 222371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222382 */     GIR_RootConstrainSelectedInstOperands,
     /* 222383 */     // GIR_Coverage, 3453,
     /* 222383 */     GIR_EraseRootFromParent_Done,
     /* 222384 */   // Label 4394: @222384
     /* 222384 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222426), // Rule ID 3454 //
     /* 222389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 222416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222424 */     GIR_RootConstrainSelectedInstOperands,
     /* 222425 */     // GIR_Coverage, 3454,
     /* 222425 */     GIR_EraseRootFromParent_Done,
     /* 222426 */   // Label 4395: @222426
     /* 222426 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222468), // Rule ID 3455 //
     /* 222431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 222458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222466 */     GIR_RootConstrainSelectedInstOperands,
     /* 222467 */     // GIR_Coverage, 3455,
     /* 222467 */     GIR_EraseRootFromParent_Done,
     /* 222468 */   // Label 4396: @222468
     /* 222468 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222510), // Rule ID 3460 //
     /* 222473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 222476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 222481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 222500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222508 */     GIR_RootConstrainSelectedInstOperands,
     /* 222509 */     // GIR_Coverage, 3460,
     /* 222509 */     GIR_EraseRootFromParent_Done,
     /* 222510 */   // Label 4397: @222510
     /* 222510 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222552), // Rule ID 3499 //
     /* 222515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222539 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 222542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222550 */     GIR_RootConstrainSelectedInstOperands,
     /* 222551 */     // GIR_Coverage, 3499,
     /* 222551 */     GIR_EraseRootFromParent_Done,
     /* 222552 */   // Label 4398: @222552
     /* 222552 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222594), // Rule ID 3501 //
     /* 222557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222581 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 222584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222592 */     GIR_RootConstrainSelectedInstOperands,
     /* 222593 */     // GIR_Coverage, 3501,
     /* 222593 */     GIR_EraseRootFromParent_Done,
     /* 222594 */   // Label 4399: @222594
     /* 222594 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222636), // Rule ID 3503 //
     /* 222599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222623 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 222626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222634 */     GIR_RootConstrainSelectedInstOperands,
     /* 222635 */     // GIR_Coverage, 3503,
     /* 222635 */     GIR_EraseRootFromParent_Done,
     /* 222636 */   // Label 4400: @222636
     /* 222636 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222678), // Rule ID 3505 //
     /* 222641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 222649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 222668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222676 */     GIR_RootConstrainSelectedInstOperands,
     /* 222677 */     // GIR_Coverage, 3505,
     /* 222677 */     GIR_EraseRootFromParent_Done,
     /* 222678 */   // Label 4401: @222678
     /* 222678 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222720), // Rule ID 3632 //
     /* 222683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 222710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222718 */     GIR_RootConstrainSelectedInstOperands,
     /* 222719 */     // GIR_Coverage, 3632,
     /* 222719 */     GIR_EraseRootFromParent_Done,
     /* 222720 */   // Label 4402: @222720
     /* 222720 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222762), // Rule ID 3634 //
     /* 222725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 222752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222760 */     GIR_RootConstrainSelectedInstOperands,
     /* 222761 */     // GIR_Coverage, 3634,
     /* 222761 */     GIR_EraseRootFromParent_Done,
     /* 222762 */   // Label 4403: @222762
     /* 222762 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222804), // Rule ID 3636 //
     /* 222767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 222794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222802 */     GIR_RootConstrainSelectedInstOperands,
     /* 222803 */     // GIR_Coverage, 3636,
     /* 222803 */     GIR_EraseRootFromParent_Done,
     /* 222804 */   // Label 4404: @222804
     /* 222804 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222846), // Rule ID 3638 //
     /* 222809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222833 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 222836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222844 */     GIR_RootConstrainSelectedInstOperands,
     /* 222845 */     // GIR_Coverage, 3638,
     /* 222845 */     GIR_EraseRootFromParent_Done,
     /* 222846 */   // Label 4405: @222846
     /* 222846 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222888), // Rule ID 7437 //
     /* 222851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1897:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 222878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222886 */     GIR_RootConstrainSelectedInstOperands,
     /* 222887 */     // GIR_Coverage, 7437,
     /* 222887 */     GIR_EraseRootFromParent_Done,
     /* 222888 */   // Label 4406: @222888
     /* 222888 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222930), // Rule ID 7439 //
     /* 222893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1897:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 222920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222928 */     GIR_RootConstrainSelectedInstOperands,
     /* 222929 */     // GIR_Coverage, 7439,
     /* 222929 */     GIR_EraseRootFromParent_Done,
     /* 222930 */   // Label 4407: @222930
     /* 222930 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222972), // Rule ID 7441 //
     /* 222935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1897:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 222962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222970 */     GIR_RootConstrainSelectedInstOperands,
     /* 222971 */     // GIR_Coverage, 7441,
     /* 222971 */     GIR_EraseRootFromParent_Done,
     /* 222972 */   // Label 4408: @222972
     /* 222972 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223014), // Rule ID 7443 //
     /* 222977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1897:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 223004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223012 */     GIR_RootConstrainSelectedInstOperands,
     /* 223013 */     // GIR_Coverage, 7443,
     /* 223013 */     GIR_EraseRootFromParent_Done,
     /* 223014 */   // Label 4409: @223014
     /* 223014 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223056), // Rule ID 7461 //
     /* 223019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1282:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 223046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223054 */     GIR_RootConstrainSelectedInstOperands,
     /* 223055 */     // GIR_Coverage, 7461,
     /* 223055 */     GIR_EraseRootFromParent_Done,
     /* 223056 */   // Label 4410: @223056
     /* 223056 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223098), // Rule ID 7462 //
     /* 223061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1282:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 223088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223096 */     GIR_RootConstrainSelectedInstOperands,
     /* 223097 */     // GIR_Coverage, 7462,
     /* 223097 */     GIR_EraseRootFromParent_Done,
     /* 223098 */   // Label 4411: @223098
     /* 223098 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223140), // Rule ID 7463 //
     /* 223103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1282:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 223130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223138 */     GIR_RootConstrainSelectedInstOperands,
     /* 223139 */     // GIR_Coverage, 7463,
     /* 223139 */     GIR_EraseRootFromParent_Done,
     /* 223140 */   // Label 4412: @223140
     /* 223140 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223182), // Rule ID 7464 //
     /* 223145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1282:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 223172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223180 */     GIR_RootConstrainSelectedInstOperands,
     /* 223181 */     // GIR_Coverage, 7464,
     /* 223181 */     GIR_EraseRootFromParent_Done,
     /* 223182 */   // Label 4413: @223182
     /* 223182 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223224), // Rule ID 7577 //
     /* 223187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1744:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 223214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223222 */     GIR_RootConstrainSelectedInstOperands,
     /* 223223 */     // GIR_Coverage, 7577,
     /* 223223 */     GIR_EraseRootFromParent_Done,
     /* 223224 */   // Label 4414: @223224
     /* 223224 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223266), // Rule ID 7578 //
     /* 223229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1744:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 223256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223264 */     GIR_RootConstrainSelectedInstOperands,
     /* 223265 */     // GIR_Coverage, 7578,
     /* 223265 */     GIR_EraseRootFromParent_Done,
     /* 223266 */   // Label 4415: @223266
     /* 223266 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223308), // Rule ID 7579 //
     /* 223271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 223298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223306 */     GIR_RootConstrainSelectedInstOperands,
     /* 223307 */     // GIR_Coverage, 7579,
     /* 223307 */     GIR_EraseRootFromParent_Done,
     /* 223308 */   // Label 4416: @223308
     /* 223308 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223350), // Rule ID 7580 //
     /* 223313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 223340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223348 */     GIR_RootConstrainSelectedInstOperands,
     /* 223349 */     // GIR_Coverage, 7580,
     /* 223349 */     GIR_EraseRootFromParent_Done,
     /* 223350 */   // Label 4417: @223350
     /* 223350 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223392), // Rule ID 7581 //
     /* 223355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223379 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1982:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 223382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223390 */     GIR_RootConstrainSelectedInstOperands,
     /* 223391 */     // GIR_Coverage, 7581,
     /* 223391 */     GIR_EraseRootFromParent_Done,
     /* 223392 */   // Label 4418: @223392
     /* 223392 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223434), // Rule ID 7582 //
     /* 223397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1982:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 223424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223432 */     GIR_RootConstrainSelectedInstOperands,
     /* 223433 */     // GIR_Coverage, 7582,
     /* 223433 */     GIR_EraseRootFromParent_Done,
     /* 223434 */   // Label 4419: @223434
     /* 223434 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223476), // Rule ID 7583 //
     /* 223439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 223466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223474 */     GIR_RootConstrainSelectedInstOperands,
     /* 223475 */     // GIR_Coverage, 7583,
     /* 223475 */     GIR_EraseRootFromParent_Done,
     /* 223476 */   // Label 4420: @223476
     /* 223476 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223518), // Rule ID 7584 //
     /* 223481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 223508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223516 */     GIR_RootConstrainSelectedInstOperands,
     /* 223517 */     // GIR_Coverage, 7584,
     /* 223517 */     GIR_EraseRootFromParent_Done,
     /* 223518 */   // Label 4421: @223518
     /* 223518 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223560), // Rule ID 7593 //
     /* 223523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 223550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223558 */     GIR_RootConstrainSelectedInstOperands,
     /* 223559 */     // GIR_Coverage, 7593,
     /* 223559 */     GIR_EraseRootFromParent_Done,
     /* 223560 */   // Label 4422: @223560
     /* 223560 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223602), // Rule ID 7594 //
     /* 223565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 223592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223600 */     GIR_RootConstrainSelectedInstOperands,
     /* 223601 */     // GIR_Coverage, 7594,
     /* 223601 */     GIR_EraseRootFromParent_Done,
     /* 223602 */   // Label 4423: @223602
     /* 223602 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223644), // Rule ID 7595 //
     /* 223607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 223634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223642 */     GIR_RootConstrainSelectedInstOperands,
     /* 223643 */     // GIR_Coverage, 7595,
     /* 223643 */     GIR_EraseRootFromParent_Done,
     /* 223644 */   // Label 4424: @223644
     /* 223644 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223686), // Rule ID 7596 //
     /* 223649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 223676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223684 */     GIR_RootConstrainSelectedInstOperands,
     /* 223685 */     // GIR_Coverage, 7596,
     /* 223685 */     GIR_EraseRootFromParent_Done,
     /* 223686 */   // Label 4425: @223686
     /* 223686 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223728), // Rule ID 7597 //
     /* 223691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 223718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223726 */     GIR_RootConstrainSelectedInstOperands,
     /* 223727 */     // GIR_Coverage, 7597,
     /* 223727 */     GIR_EraseRootFromParent_Done,
     /* 223728 */   // Label 4426: @223728
     /* 223728 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223770), // Rule ID 7598 //
     /* 223733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 223760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223768 */     GIR_RootConstrainSelectedInstOperands,
     /* 223769 */     // GIR_Coverage, 7598,
     /* 223769 */     GIR_EraseRootFromParent_Done,
     /* 223770 */   // Label 4427: @223770
     /* 223770 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223812), // Rule ID 7683 //
     /* 223775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1322:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 223802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223810 */     GIR_RootConstrainSelectedInstOperands,
     /* 223811 */     // GIR_Coverage, 7683,
     /* 223811 */     GIR_EraseRootFromParent_Done,
     /* 223812 */   // Label 4428: @223812
     /* 223812 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(223854), // Rule ID 7684 //
     /* 223817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1322:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 223844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223852 */     GIR_RootConstrainSelectedInstOperands,
     /* 223853 */     // GIR_Coverage, 7684,
     /* 223853 */     GIR_EraseRootFromParent_Done,
     /* 223854 */   // Label 4429: @223854
     /* 223854 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(223896), // Rule ID 7685 //
     /* 223859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1322:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 223886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223894 */     GIR_RootConstrainSelectedInstOperands,
     /* 223895 */     // GIR_Coverage, 7685,
     /* 223895 */     GIR_EraseRootFromParent_Done,
     /* 223896 */   // Label 4430: @223896
     /* 223896 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(223938), // Rule ID 7686 //
     /* 223901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1322:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 223928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223936 */     GIR_RootConstrainSelectedInstOperands,
     /* 223937 */     // GIR_Coverage, 7686,
     /* 223937 */     GIR_EraseRootFromParent_Done,
     /* 223938 */   // Label 4431: @223938
     /* 223938 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(223980), // Rule ID 7695 //
     /* 223943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 223970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223978 */     GIR_RootConstrainSelectedInstOperands,
     /* 223979 */     // GIR_Coverage, 7695,
     /* 223979 */     GIR_EraseRootFromParent_Done,
     /* 223980 */   // Label 4432: @223980
     /* 223980 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224022), // Rule ID 7696 //
     /* 223985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 224012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224020 */     GIR_RootConstrainSelectedInstOperands,
     /* 224021 */     // GIR_Coverage, 7696,
     /* 224021 */     GIR_EraseRootFromParent_Done,
     /* 224022 */   // Label 4433: @224022
     /* 224022 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224064), // Rule ID 7697 //
     /* 224027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 224054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224062 */     GIR_RootConstrainSelectedInstOperands,
     /* 224063 */     // GIR_Coverage, 7697,
     /* 224063 */     GIR_EraseRootFromParent_Done,
     /* 224064 */   // Label 4434: @224064
     /* 224064 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224106), // Rule ID 7698 //
     /* 224069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 224096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224104 */     GIR_RootConstrainSelectedInstOperands,
     /* 224105 */     // GIR_Coverage, 7698,
     /* 224105 */     GIR_EraseRootFromParent_Done,
     /* 224106 */   // Label 4435: @224106
     /* 224106 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224148), // Rule ID 7777 //
     /* 224111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1675:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 224138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224146 */     GIR_RootConstrainSelectedInstOperands,
     /* 224147 */     // GIR_Coverage, 7777,
     /* 224147 */     GIR_EraseRootFromParent_Done,
     /* 224148 */   // Label 4436: @224148
     /* 224148 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224190), // Rule ID 7778 //
     /* 224153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 224180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224188 */     GIR_RootConstrainSelectedInstOperands,
     /* 224189 */     // GIR_Coverage, 7778,
     /* 224189 */     GIR_EraseRootFromParent_Done,
     /* 224190 */   // Label 4437: @224190
     /* 224190 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224232), // Rule ID 7779 //
     /* 224195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 224222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224230 */     GIR_RootConstrainSelectedInstOperands,
     /* 224231 */     // GIR_Coverage, 7779,
     /* 224231 */     GIR_EraseRootFromParent_Done,
     /* 224232 */   // Label 4438: @224232
     /* 224232 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224274), // Rule ID 7780 //
     /* 224237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1675:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 224264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224272 */     GIR_RootConstrainSelectedInstOperands,
     /* 224273 */     // GIR_Coverage, 7780,
     /* 224273 */     GIR_EraseRootFromParent_Done,
     /* 224274 */   // Label 4439: @224274
     /* 224274 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224316), // Rule ID 7781 //
     /* 224279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224303 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 224306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224314 */     GIR_RootConstrainSelectedInstOperands,
     /* 224315 */     // GIR_Coverage, 7781,
     /* 224315 */     GIR_EraseRootFromParent_Done,
     /* 224316 */   // Label 4440: @224316
     /* 224316 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224358), // Rule ID 7782 //
     /* 224321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 224348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224356 */     GIR_RootConstrainSelectedInstOperands,
     /* 224357 */     // GIR_Coverage, 7782,
     /* 224357 */     GIR_EraseRootFromParent_Done,
     /* 224358 */   // Label 4441: @224358
     /* 224358 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224400), // Rule ID 7783 //
     /* 224363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 224390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224398 */     GIR_RootConstrainSelectedInstOperands,
     /* 224399 */     // GIR_Coverage, 7783,
     /* 224399 */     GIR_EraseRootFromParent_Done,
     /* 224400 */   // Label 4442: @224400
     /* 224400 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224442), // Rule ID 7784 //
     /* 224405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 224432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224440 */     GIR_RootConstrainSelectedInstOperands,
     /* 224441 */     // GIR_Coverage, 7784,
     /* 224441 */     GIR_EraseRootFromParent_Done,
     /* 224442 */   // Label 4443: @224442
     /* 224442 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224484), // Rule ID 7980 //
     /* 224447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224471 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1531:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 224474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224482 */     GIR_RootConstrainSelectedInstOperands,
     /* 224483 */     // GIR_Coverage, 7980,
     /* 224483 */     GIR_EraseRootFromParent_Done,
     /* 224484 */   // Label 4444: @224484
     /* 224484 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224526), // Rule ID 7982 //
     /* 224489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224513 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1531:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 224516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224524 */     GIR_RootConstrainSelectedInstOperands,
     /* 224525 */     // GIR_Coverage, 7982,
     /* 224525 */     GIR_EraseRootFromParent_Done,
     /* 224526 */   // Label 4445: @224526
     /* 224526 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224568), // Rule ID 7984 //
     /* 224531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224555 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1531:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 224558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224566 */     GIR_RootConstrainSelectedInstOperands,
     /* 224567 */     // GIR_Coverage, 7984,
     /* 224567 */     GIR_EraseRootFromParent_Done,
     /* 224568 */   // Label 4446: @224568
     /* 224568 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224610), // Rule ID 7992 //
     /* 224573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1533:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 224600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224608 */     GIR_RootConstrainSelectedInstOperands,
     /* 224609 */     // GIR_Coverage, 7992,
     /* 224609 */     GIR_EraseRootFromParent_Done,
     /* 224610 */   // Label 4447: @224610
     /* 224610 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224652), // Rule ID 7994 //
     /* 224615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1533:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 224642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224650 */     GIR_RootConstrainSelectedInstOperands,
     /* 224651 */     // GIR_Coverage, 7994,
     /* 224651 */     GIR_EraseRootFromParent_Done,
     /* 224652 */   // Label 4448: @224652
     /* 224652 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224694), // Rule ID 7996 //
     /* 224657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1533:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 224684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224692 */     GIR_RootConstrainSelectedInstOperands,
     /* 224693 */     // GIR_Coverage, 7996,
     /* 224693 */     GIR_EraseRootFromParent_Done,
     /* 224694 */   // Label 4449: @224694
     /* 224694 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(224736), // Rule ID 8034 //
     /* 224699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224723 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 224726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224734 */     GIR_RootConstrainSelectedInstOperands,
     /* 224735 */     // GIR_Coverage, 8034,
     /* 224735 */     GIR_EraseRootFromParent_Done,
     /* 224736 */   // Label 4450: @224736
     /* 224736 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(224778), // Rule ID 8035 //
     /* 224741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 224768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224776 */     GIR_RootConstrainSelectedInstOperands,
     /* 224777 */     // GIR_Coverage, 8035,
     /* 224777 */     GIR_EraseRootFromParent_Done,
     /* 224778 */   // Label 4451: @224778
     /* 224778 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(224820), // Rule ID 8036 //
     /* 224783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 224810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224818 */     GIR_RootConstrainSelectedInstOperands,
     /* 224819 */     // GIR_Coverage, 8036,
     /* 224819 */     GIR_EraseRootFromParent_Done,
     /* 224820 */   // Label 4452: @224820
     /* 224820 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(224862), // Rule ID 8037 //
     /* 224825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224849 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 224852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224860 */     GIR_RootConstrainSelectedInstOperands,
     /* 224861 */     // GIR_Coverage, 8037,
     /* 224861 */     GIR_EraseRootFromParent_Done,
     /* 224862 */   // Label 4453: @224862
     /* 224862 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224904), // Rule ID 8038 //
     /* 224867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 224894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224902 */     GIR_RootConstrainSelectedInstOperands,
     /* 224903 */     // GIR_Coverage, 8038,
     /* 224903 */     GIR_EraseRootFromParent_Done,
     /* 224904 */   // Label 4454: @224904
     /* 224904 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224946), // Rule ID 8039 //
     /* 224909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 224936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224944 */     GIR_RootConstrainSelectedInstOperands,
     /* 224945 */     // GIR_Coverage, 8039,
     /* 224945 */     GIR_EraseRootFromParent_Done,
     /* 224946 */   // Label 4455: @224946
     /* 224946 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224988), // Rule ID 8040 //
     /* 224951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 224978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224986 */     GIR_RootConstrainSelectedInstOperands,
     /* 224987 */     // GIR_Coverage, 8040,
     /* 224987 */     GIR_EraseRootFromParent_Done,
     /* 224988 */   // Label 4456: @224988
     /* 224988 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225030), // Rule ID 8041 //
     /* 224993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225017 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 225020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225028 */     GIR_RootConstrainSelectedInstOperands,
     /* 225029 */     // GIR_Coverage, 8041,
     /* 225029 */     GIR_EraseRootFromParent_Done,
     /* 225030 */   // Label 4457: @225030
     /* 225030 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225072), // Rule ID 8042 //
     /* 225035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 225062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225070 */     GIR_RootConstrainSelectedInstOperands,
     /* 225071 */     // GIR_Coverage, 8042,
     /* 225071 */     GIR_EraseRootFromParent_Done,
     /* 225072 */   // Label 4458: @225072
     /* 225072 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225114), // Rule ID 8043 //
     /* 225077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225101 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 225104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225112 */     GIR_RootConstrainSelectedInstOperands,
     /* 225113 */     // GIR_Coverage, 8043,
     /* 225113 */     GIR_EraseRootFromParent_Done,
     /* 225114 */   // Label 4459: @225114
     /* 225114 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225156), // Rule ID 8044 //
     /* 225119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225143 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 225146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225154 */     GIR_RootConstrainSelectedInstOperands,
     /* 225155 */     // GIR_Coverage, 8044,
     /* 225155 */     GIR_EraseRootFromParent_Done,
     /* 225156 */   // Label 4460: @225156
     /* 225156 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225198), // Rule ID 8045 //
     /* 225161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225185 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1409:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 225188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225196 */     GIR_RootConstrainSelectedInstOperands,
     /* 225197 */     // GIR_Coverage, 8045,
     /* 225197 */     GIR_EraseRootFromParent_Done,
     /* 225198 */   // Label 4461: @225198
     /* 225198 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225240), // Rule ID 8082 //
     /* 225203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225238 */     GIR_RootConstrainSelectedInstOperands,
     /* 225239 */     // GIR_Coverage, 8082,
     /* 225239 */     GIR_EraseRootFromParent_Done,
     /* 225240 */   // Label 4462: @225240
     /* 225240 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225282), // Rule ID 8084 //
     /* 225245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225269 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225280 */     GIR_RootConstrainSelectedInstOperands,
     /* 225281 */     // GIR_Coverage, 8084,
     /* 225281 */     GIR_EraseRootFromParent_Done,
     /* 225282 */   // Label 4463: @225282
     /* 225282 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225324), // Rule ID 8086 //
     /* 225287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225311 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225322 */     GIR_RootConstrainSelectedInstOperands,
     /* 225323 */     // GIR_Coverage, 8086,
     /* 225323 */     GIR_EraseRootFromParent_Done,
     /* 225324 */   // Label 4464: @225324
     /* 225324 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225366), // Rule ID 8088 //
     /* 225329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225353 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225364 */     GIR_RootConstrainSelectedInstOperands,
     /* 225365 */     // GIR_Coverage, 8088,
     /* 225365 */     GIR_EraseRootFromParent_Done,
     /* 225366 */   // Label 4465: @225366
     /* 225366 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225408), // Rule ID 8090 //
     /* 225371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225395 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225406 */     GIR_RootConstrainSelectedInstOperands,
     /* 225407 */     // GIR_Coverage, 8090,
     /* 225407 */     GIR_EraseRootFromParent_Done,
     /* 225408 */   // Label 4466: @225408
     /* 225408 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225450), // Rule ID 8092 //
     /* 225413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 225440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225448 */     GIR_RootConstrainSelectedInstOperands,
     /* 225449 */     // GIR_Coverage, 8092,
     /* 225449 */     GIR_EraseRootFromParent_Done,
     /* 225450 */   // Label 4467: @225450
     /* 225450 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225492), // Rule ID 8094 //
     /* 225455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225479 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1473:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225490 */     GIR_RootConstrainSelectedInstOperands,
     /* 225491 */     // GIR_Coverage, 8094,
     /* 225491 */     GIR_EraseRootFromParent_Done,
     /* 225492 */   // Label 4468: @225492
     /* 225492 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225534), // Rule ID 8095 //
     /* 225497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225521 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225532 */     GIR_RootConstrainSelectedInstOperands,
     /* 225533 */     // GIR_Coverage, 8095,
     /* 225533 */     GIR_EraseRootFromParent_Done,
     /* 225534 */   // Label 4469: @225534
     /* 225534 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225576), // Rule ID 8096 //
     /* 225539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225563 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225574 */     GIR_RootConstrainSelectedInstOperands,
     /* 225575 */     // GIR_Coverage, 8096,
     /* 225575 */     GIR_EraseRootFromParent_Done,
     /* 225576 */   // Label 4470: @225576
     /* 225576 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225618), // Rule ID 8097 //
     /* 225581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225616 */     GIR_RootConstrainSelectedInstOperands,
     /* 225617 */     // GIR_Coverage, 8097,
     /* 225617 */     GIR_EraseRootFromParent_Done,
     /* 225618 */   // Label 4471: @225618
     /* 225618 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225660), // Rule ID 8098 //
     /* 225623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225647 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225658 */     GIR_RootConstrainSelectedInstOperands,
     /* 225659 */     // GIR_Coverage, 8098,
     /* 225659 */     GIR_EraseRootFromParent_Done,
     /* 225660 */   // Label 4472: @225660
     /* 225660 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225702), // Rule ID 8099 //
     /* 225665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 225692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225700 */     GIR_RootConstrainSelectedInstOperands,
     /* 225701 */     // GIR_Coverage, 8099,
     /* 225701 */     GIR_EraseRootFromParent_Done,
     /* 225702 */   // Label 4473: @225702
     /* 225702 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225744), // Rule ID 8352 //
     /* 225707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 225715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225731 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1291:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 225734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225742 */     GIR_RootConstrainSelectedInstOperands,
     /* 225743 */     // GIR_Coverage, 8352,
     /* 225743 */     GIR_EraseRootFromParent_Done,
     /* 225744 */   // Label 4474: @225744
     /* 225744 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225786), // Rule ID 8354 //
     /* 225749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 225757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225773 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1287:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 225776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225784 */     GIR_RootConstrainSelectedInstOperands,
     /* 225785 */     // GIR_Coverage, 8354,
     /* 225785 */     GIR_EraseRootFromParent_Done,
     /* 225786 */   // Label 4475: @225786
     /* 225786 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225828), // Rule ID 8355 //
     /* 225791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1284:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225826 */     GIR_RootConstrainSelectedInstOperands,
     /* 225827 */     // GIR_Coverage, 8355,
     /* 225827 */     GIR_EraseRootFromParent_Done,
     /* 225828 */   // Label 4476: @225828
     /* 225828 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225870), // Rule ID 8356 //
     /* 225833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1284:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225868 */     GIR_RootConstrainSelectedInstOperands,
     /* 225869 */     // GIR_Coverage, 8356,
     /* 225869 */     GIR_EraseRootFromParent_Done,
     /* 225870 */   // Label 4477: @225870
     /* 225870 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225912), // Rule ID 8357 //
     /* 225875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1284:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225910 */     GIR_RootConstrainSelectedInstOperands,
     /* 225911 */     // GIR_Coverage, 8357,
     /* 225911 */     GIR_EraseRootFromParent_Done,
     /* 225912 */   // Label 4478: @225912
     /* 225912 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225954), // Rule ID 8358 //
     /* 225917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1284:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225952 */     GIR_RootConstrainSelectedInstOperands,
     /* 225953 */     // GIR_Coverage, 8358,
     /* 225953 */     GIR_EraseRootFromParent_Done,
     /* 225954 */   // Label 4479: @225954
     /* 225954 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225996), // Rule ID 8359 //
     /* 225959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1284:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225994 */     GIR_RootConstrainSelectedInstOperands,
     /* 225995 */     // GIR_Coverage, 8359,
     /* 225995 */     GIR_EraseRootFromParent_Done,
     /* 225996 */   // Label 4480: @225996
     /* 225996 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226038), // Rule ID 8380 //
     /* 226001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226025 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1342:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226036 */     GIR_RootConstrainSelectedInstOperands,
     /* 226037 */     // GIR_Coverage, 8380,
     /* 226037 */     GIR_EraseRootFromParent_Done,
     /* 226038 */   // Label 4481: @226038
     /* 226038 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226080), // Rule ID 8381 //
     /* 226043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226067 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1342:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226078 */     GIR_RootConstrainSelectedInstOperands,
     /* 226079 */     // GIR_Coverage, 8381,
     /* 226079 */     GIR_EraseRootFromParent_Done,
     /* 226080 */   // Label 4482: @226080
     /* 226080 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226122), // Rule ID 8382 //
     /* 226085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226120 */     GIR_RootConstrainSelectedInstOperands,
     /* 226121 */     // GIR_Coverage, 8382,
     /* 226121 */     GIR_EraseRootFromParent_Done,
     /* 226122 */   // Label 4483: @226122
     /* 226122 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226164), // Rule ID 8383 //
     /* 226127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226162 */     GIR_RootConstrainSelectedInstOperands,
     /* 226163 */     // GIR_Coverage, 8383,
     /* 226163 */     GIR_EraseRootFromParent_Done,
     /* 226164 */   // Label 4484: @226164
     /* 226164 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226206), // Rule ID 8384 //
     /* 226169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226193 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1342:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226204 */     GIR_RootConstrainSelectedInstOperands,
     /* 226205 */     // GIR_Coverage, 8384,
     /* 226205 */     GIR_EraseRootFromParent_Done,
     /* 226206 */   // Label 4485: @226206
     /* 226206 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226248), // Rule ID 8400 //
     /* 226211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226246 */     GIR_RootConstrainSelectedInstOperands,
     /* 226247 */     // GIR_Coverage, 8400,
     /* 226247 */     GIR_EraseRootFromParent_Done,
     /* 226248 */   // Label 4486: @226248
     /* 226248 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226290), // Rule ID 8401 //
     /* 226253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226288 */     GIR_RootConstrainSelectedInstOperands,
     /* 226289 */     // GIR_Coverage, 8401,
     /* 226289 */     GIR_EraseRootFromParent_Done,
     /* 226290 */   // Label 4487: @226290
     /* 226290 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226332), // Rule ID 8402 //
     /* 226295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226319 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226330 */     GIR_RootConstrainSelectedInstOperands,
     /* 226331 */     // GIR_Coverage, 8402,
     /* 226331 */     GIR_EraseRootFromParent_Done,
     /* 226332 */   // Label 4488: @226332
     /* 226332 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226374), // Rule ID 8403 //
     /* 226337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226361 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226372 */     GIR_RootConstrainSelectedInstOperands,
     /* 226373 */     // GIR_Coverage, 8403,
     /* 226373 */     GIR_EraseRootFromParent_Done,
     /* 226374 */   // Label 4489: @226374
     /* 226374 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226416), // Rule ID 8404 //
     /* 226379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1613:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226414 */     GIR_RootConstrainSelectedInstOperands,
     /* 226415 */     // GIR_Coverage, 8404,
     /* 226415 */     GIR_EraseRootFromParent_Done,
     /* 226416 */   // Label 4490: @226416
     /* 226416 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226458), // Rule ID 8405 //
     /* 226421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226445 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1609:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226456 */     GIR_RootConstrainSelectedInstOperands,
     /* 226457 */     // GIR_Coverage, 8405,
     /* 226457 */     GIR_EraseRootFromParent_Done,
     /* 226458 */   // Label 4491: @226458
     /* 226458 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226500), // Rule ID 8406 //
     /* 226463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1609:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226498 */     GIR_RootConstrainSelectedInstOperands,
     /* 226499 */     // GIR_Coverage, 8406,
     /* 226499 */     GIR_EraseRootFromParent_Done,
     /* 226500 */   // Label 4492: @226500
     /* 226500 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226542), // Rule ID 8407 //
     /* 226505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226529 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1609:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226540 */     GIR_RootConstrainSelectedInstOperands,
     /* 226541 */     // GIR_Coverage, 8407,
     /* 226541 */     GIR_EraseRootFromParent_Done,
     /* 226542 */   // Label 4493: @226542
     /* 226542 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226584), // Rule ID 8408 //
     /* 226547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226571 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1609:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226582 */     GIR_RootConstrainSelectedInstOperands,
     /* 226583 */     // GIR_Coverage, 8408,
     /* 226583 */     GIR_EraseRootFromParent_Done,
     /* 226584 */   // Label 4494: @226584
     /* 226584 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226626), // Rule ID 8409 //
     /* 226589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226613 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1609:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226624 */     GIR_RootConstrainSelectedInstOperands,
     /* 226625 */     // GIR_Coverage, 8409,
     /* 226625 */     GIR_EraseRootFromParent_Done,
     /* 226626 */   // Label 4495: @226626
     /* 226626 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226668), // Rule ID 8410 //
     /* 226631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226655 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226666 */     GIR_RootConstrainSelectedInstOperands,
     /* 226667 */     // GIR_Coverage, 8410,
     /* 226667 */     GIR_EraseRootFromParent_Done,
     /* 226668 */   // Label 4496: @226668
     /* 226668 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(226710), // Rule ID 8411 //
     /* 226673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226708 */     GIR_RootConstrainSelectedInstOperands,
     /* 226709 */     // GIR_Coverage, 8411,
     /* 226709 */     GIR_EraseRootFromParent_Done,
     /* 226710 */   // Label 4497: @226710
     /* 226710 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(226752), // Rule ID 8412 //
     /* 226715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226739 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226750 */     GIR_RootConstrainSelectedInstOperands,
     /* 226751 */     // GIR_Coverage, 8412,
     /* 226751 */     GIR_EraseRootFromParent_Done,
     /* 226752 */   // Label 4498: @226752
     /* 226752 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(226794), // Rule ID 8413 //
     /* 226757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226781 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226792 */     GIR_RootConstrainSelectedInstOperands,
     /* 226793 */     // GIR_Coverage, 8413,
     /* 226793 */     GIR_EraseRootFromParent_Done,
     /* 226794 */   // Label 4499: @226794
     /* 226794 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(226836), // Rule ID 8414 //
     /* 226799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1607:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226834 */     GIR_RootConstrainSelectedInstOperands,
     /* 226835 */     // GIR_Coverage, 8414,
     /* 226835 */     GIR_EraseRootFromParent_Done,
     /* 226836 */   // Label 4500: @226836
     /* 226836 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(226878), // Rule ID 8415 //
     /* 226841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226876 */     GIR_RootConstrainSelectedInstOperands,
     /* 226877 */     // GIR_Coverage, 8415,
     /* 226877 */     GIR_EraseRootFromParent_Done,
     /* 226878 */   // Label 4501: @226878
     /* 226878 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(226920), // Rule ID 8416 //
     /* 226883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226918 */     GIR_RootConstrainSelectedInstOperands,
     /* 226919 */     // GIR_Coverage, 8416,
     /* 226919 */     GIR_EraseRootFromParent_Done,
     /* 226920 */   // Label 4502: @226920
     /* 226920 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(226962), // Rule ID 8417 //
     /* 226925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226960 */     GIR_RootConstrainSelectedInstOperands,
     /* 226961 */     // GIR_Coverage, 8417,
     /* 226961 */     GIR_EraseRootFromParent_Done,
     /* 226962 */   // Label 4503: @226962
     /* 226962 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227004), // Rule ID 8418 //
     /* 226967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227002 */     GIR_RootConstrainSelectedInstOperands,
     /* 227003 */     // GIR_Coverage, 8418,
     /* 227003 */     GIR_EraseRootFromParent_Done,
     /* 227004 */   // Label 4504: @227004
     /* 227004 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227046), // Rule ID 8419 //
     /* 227009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227033 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1603:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227044 */     GIR_RootConstrainSelectedInstOperands,
     /* 227045 */     // GIR_Coverage, 8419,
     /* 227045 */     GIR_EraseRootFromParent_Done,
     /* 227046 */   // Label 4505: @227046
     /* 227046 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227088), // Rule ID 8427 //
     /* 227051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 227078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227086 */     GIR_RootConstrainSelectedInstOperands,
     /* 227087 */     // GIR_Coverage, 8427,
     /* 227087 */     GIR_EraseRootFromParent_Done,
     /* 227088 */   // Label 4506: @227088
     /* 227088 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227130), // Rule ID 8428 //
     /* 227093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 227129 */     // GIR_Coverage, 8428,
     /* 227129 */     GIR_EraseRootFromParent_Done,
     /* 227130 */   // Label 4507: @227130
     /* 227130 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227172), // Rule ID 8429 //
     /* 227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227170 */     GIR_RootConstrainSelectedInstOperands,
     /* 227171 */     // GIR_Coverage, 8429,
     /* 227171 */     GIR_EraseRootFromParent_Done,
     /* 227172 */   // Label 4508: @227172
     /* 227172 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227214), // Rule ID 8430 //
     /* 227177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227212 */     GIR_RootConstrainSelectedInstOperands,
     /* 227213 */     // GIR_Coverage, 8430,
     /* 227213 */     GIR_EraseRootFromParent_Done,
     /* 227214 */   // Label 4509: @227214
     /* 227214 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227256), // Rule ID 8431 //
     /* 227219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1300:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227254 */     GIR_RootConstrainSelectedInstOperands,
     /* 227255 */     // GIR_Coverage, 8431,
     /* 227255 */     GIR_EraseRootFromParent_Done,
     /* 227256 */   // Label 4510: @227256
     /* 227256 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227298), // Rule ID 8432 //
     /* 227261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227285 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1300:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227296 */     GIR_RootConstrainSelectedInstOperands,
     /* 227297 */     // GIR_Coverage, 8432,
     /* 227297 */     GIR_EraseRootFromParent_Done,
     /* 227298 */   // Label 4511: @227298
     /* 227298 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227340), // Rule ID 8433 //
     /* 227303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227327 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1300:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227338 */     GIR_RootConstrainSelectedInstOperands,
     /* 227339 */     // GIR_Coverage, 8433,
     /* 227339 */     GIR_EraseRootFromParent_Done,
     /* 227340 */   // Label 4512: @227340
     /* 227340 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227385), // Rule ID 9129 //
     /* 227345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227369 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 227372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227383 */     GIR_RootConstrainSelectedInstOperands,
     /* 227384 */     // GIR_Coverage, 9129,
     /* 227384 */     GIR_EraseRootFromParent_Done,
     /* 227385 */   // Label 4513: @227385
     /* 227385 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227430), // Rule ID 9130 //
     /* 227390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 227417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227428 */     GIR_RootConstrainSelectedInstOperands,
     /* 227429 */     // GIR_Coverage, 9130,
     /* 227429 */     GIR_EraseRootFromParent_Done,
     /* 227430 */   // Label 4514: @227430
     /* 227430 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227475), // Rule ID 9131 //
     /* 227435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227459 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 227462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227473 */     GIR_RootConstrainSelectedInstOperands,
     /* 227474 */     // GIR_Coverage, 9131,
     /* 227474 */     GIR_EraseRootFromParent_Done,
     /* 227475 */   // Label 4515: @227475
     /* 227475 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227520), // Rule ID 9132 //
     /* 227480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1311:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 227507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227518 */     GIR_RootConstrainSelectedInstOperands,
     /* 227519 */     // GIR_Coverage, 9132,
     /* 227519 */     GIR_EraseRootFromParent_Done,
     /* 227520 */   // Label 4516: @227520
     /* 227520 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227565), // Rule ID 9133 //
     /* 227525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227549 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1311:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 227552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227563 */     GIR_RootConstrainSelectedInstOperands,
     /* 227564 */     // GIR_Coverage, 9133,
     /* 227564 */     GIR_EraseRootFromParent_Done,
     /* 227565 */   // Label 4517: @227565
     /* 227565 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227610), // Rule ID 9134 //
     /* 227570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1311:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 227597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227608 */     GIR_RootConstrainSelectedInstOperands,
     /* 227609 */     // GIR_Coverage, 9134,
     /* 227609 */     GIR_EraseRootFromParent_Done,
     /* 227610 */   // Label 4518: @227610
     /* 227610 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227655), // Rule ID 9135 //
     /* 227615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227639 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 227642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227653 */     GIR_RootConstrainSelectedInstOperands,
     /* 227654 */     // GIR_Coverage, 9135,
     /* 227654 */     GIR_EraseRootFromParent_Done,
     /* 227655 */   // Label 4519: @227655
     /* 227655 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227700), // Rule ID 9136 //
     /* 227660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 227687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227698 */     GIR_RootConstrainSelectedInstOperands,
     /* 227699 */     // GIR_Coverage, 9136,
     /* 227699 */     GIR_EraseRootFromParent_Done,
     /* 227700 */   // Label 4520: @227700
     /* 227700 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(227745), // Rule ID 9137 //
     /* 227705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227729 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 227732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227743 */     GIR_RootConstrainSelectedInstOperands,
     /* 227744 */     // GIR_Coverage, 9137,
     /* 227744 */     GIR_EraseRootFromParent_Done,
     /* 227745 */   // Label 4521: @227745
     /* 227745 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(227790), // Rule ID 9138 //
     /* 227750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1316:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 227777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227788 */     GIR_RootConstrainSelectedInstOperands,
     /* 227789 */     // GIR_Coverage, 9138,
     /* 227789 */     GIR_EraseRootFromParent_Done,
     /* 227790 */   // Label 4522: @227790
     /* 227790 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(227835), // Rule ID 9139 //
     /* 227795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 227822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227833 */     GIR_RootConstrainSelectedInstOperands,
     /* 227834 */     // GIR_Coverage, 9139,
     /* 227834 */     GIR_EraseRootFromParent_Done,
     /* 227835 */   // Label 4523: @227835
     /* 227835 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(227880), // Rule ID 9140 //
     /* 227840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 227867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227878 */     GIR_RootConstrainSelectedInstOperands,
     /* 227879 */     // GIR_Coverage, 9140,
     /* 227879 */     GIR_EraseRootFromParent_Done,
     /* 227880 */   // Label 4524: @227880
     /* 227880 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(227925), // Rule ID 9141 //
     /* 227885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227909 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 227912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227923 */     GIR_RootConstrainSelectedInstOperands,
     /* 227924 */     // GIR_Coverage, 9141,
     /* 227924 */     GIR_EraseRootFromParent_Done,
     /* 227925 */   // Label 4525: @227925
     /* 227925 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(227970), // Rule ID 9142 //
     /* 227930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 227957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227968 */     GIR_RootConstrainSelectedInstOperands,
     /* 227969 */     // GIR_Coverage, 9142,
     /* 227969 */     GIR_EraseRootFromParent_Done,
     /* 227970 */   // Label 4526: @227970
     /* 227970 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228015), // Rule ID 9143 //
     /* 227975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227999 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 228002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228013 */     GIR_RootConstrainSelectedInstOperands,
     /* 228014 */     // GIR_Coverage, 9143,
     /* 228014 */     GIR_EraseRootFromParent_Done,
     /* 228015 */   // Label 4527: @228015
     /* 228015 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228060), // Rule ID 9144 //
     /* 228020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 228047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228058 */     GIR_RootConstrainSelectedInstOperands,
     /* 228059 */     // GIR_Coverage, 9144,
     /* 228059 */     GIR_EraseRootFromParent_Done,
     /* 228060 */   // Label 4528: @228060
     /* 228060 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228105), // Rule ID 9145 //
     /* 228065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228089 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 228092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228103 */     GIR_RootConstrainSelectedInstOperands,
     /* 228104 */     // GIR_Coverage, 9145,
     /* 228104 */     GIR_EraseRootFromParent_Done,
     /* 228105 */   // Label 4529: @228105
     /* 228105 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228150), // Rule ID 9146 //
     /* 228110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 228137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228148 */     GIR_RootConstrainSelectedInstOperands,
     /* 228149 */     // GIR_Coverage, 9146,
     /* 228149 */     GIR_EraseRootFromParent_Done,
     /* 228150 */   // Label 4530: @228150
     /* 228150 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228195), // Rule ID 9147 //
     /* 228155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228179 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 228182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228193 */     GIR_RootConstrainSelectedInstOperands,
     /* 228194 */     // GIR_Coverage, 9147,
     /* 228194 */     GIR_EraseRootFromParent_Done,
     /* 228195 */   // Label 4531: @228195
     /* 228195 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228240), // Rule ID 9148 //
     /* 228200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 228227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228238 */     GIR_RootConstrainSelectedInstOperands,
     /* 228239 */     // GIR_Coverage, 9148,
     /* 228239 */     GIR_EraseRootFromParent_Done,
     /* 228240 */   // Label 4532: @228240
     /* 228240 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228285), // Rule ID 9149 //
     /* 228245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228269 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 228272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228283 */     GIR_RootConstrainSelectedInstOperands,
     /* 228284 */     // GIR_Coverage, 9149,
     /* 228284 */     GIR_EraseRootFromParent_Done,
     /* 228285 */   // Label 4533: @228285
     /* 228285 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228330), // Rule ID 9150 //
     /* 228290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1318:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 228317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228328 */     GIR_RootConstrainSelectedInstOperands,
     /* 228329 */     // GIR_Coverage, 9150,
     /* 228329 */     GIR_EraseRootFromParent_Done,
     /* 228330 */   // Label 4534: @228330
     /* 228330 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228375), // Rule ID 9151 //
     /* 228335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 228362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228373 */     GIR_RootConstrainSelectedInstOperands,
     /* 228374 */     // GIR_Coverage, 9151,
     /* 228374 */     GIR_EraseRootFromParent_Done,
     /* 228375 */   // Label 4535: @228375
     /* 228375 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228420), // Rule ID 9152 //
     /* 228380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 228407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228418 */     GIR_RootConstrainSelectedInstOperands,
     /* 228419 */     // GIR_Coverage, 9152,
     /* 228419 */     GIR_EraseRootFromParent_Done,
     /* 228420 */   // Label 4536: @228420
     /* 228420 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228462), // Rule ID 9549 //
     /* 228425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228449 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1354:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 228452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228460 */     GIR_RootConstrainSelectedInstOperands,
     /* 228461 */     // GIR_Coverage, 9549,
     /* 228461 */     GIR_EraseRootFromParent_Done,
     /* 228462 */   // Label 4537: @228462
     /* 228462 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228504), // Rule ID 9550 //
     /* 228467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228491 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1354:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 228494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228502 */     GIR_RootConstrainSelectedInstOperands,
     /* 228503 */     // GIR_Coverage, 9550,
     /* 228503 */     GIR_EraseRootFromParent_Done,
     /* 228504 */   // Label 4538: @228504
     /* 228504 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228546), // Rule ID 9551 //
     /* 228509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228533 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1354:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 228536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228544 */     GIR_RootConstrainSelectedInstOperands,
     /* 228545 */     // GIR_Coverage, 9551,
     /* 228545 */     GIR_EraseRootFromParent_Done,
     /* 228546 */   // Label 4539: @228546
     /* 228546 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228588), // Rule ID 10089 //
     /* 228551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228575 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 228578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228586 */     GIR_RootConstrainSelectedInstOperands,
     /* 228587 */     // GIR_Coverage, 10089,
     /* 228587 */     GIR_EraseRootFromParent_Done,
     /* 228588 */   // Label 4540: @228588
     /* 228588 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228630), // Rule ID 10090 //
     /* 228593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 228620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228628 */     GIR_RootConstrainSelectedInstOperands,
     /* 228629 */     // GIR_Coverage, 10090,
     /* 228629 */     GIR_EraseRootFromParent_Done,
     /* 228630 */   // Label 4541: @228630
     /* 228630 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228672), // Rule ID 10091 //
     /* 228635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 228662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228670 */     GIR_RootConstrainSelectedInstOperands,
     /* 228671 */     // GIR_Coverage, 10091,
     /* 228671 */     GIR_EraseRootFromParent_Done,
     /* 228672 */   // Label 4542: @228672
     /* 228672 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228714), // Rule ID 10092 //
     /* 228677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1585:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 228704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228712 */     GIR_RootConstrainSelectedInstOperands,
     /* 228713 */     // GIR_Coverage, 10092,
     /* 228713 */     GIR_EraseRootFromParent_Done,
     /* 228714 */   // Label 4543: @228714
     /* 228714 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228756), // Rule ID 10093 //
     /* 228719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 228746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228754 */     GIR_RootConstrainSelectedInstOperands,
     /* 228755 */     // GIR_Coverage, 10093,
     /* 228755 */     GIR_EraseRootFromParent_Done,
     /* 228756 */   // Label 4544: @228756
     /* 228756 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(228798), // Rule ID 10094 //
     /* 228761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 228788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228796 */     GIR_RootConstrainSelectedInstOperands,
     /* 228797 */     // GIR_Coverage, 10094,
     /* 228797 */     GIR_EraseRootFromParent_Done,
     /* 228798 */   // Label 4545: @228798
     /* 228798 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(228840), // Rule ID 10095 //
     /* 228803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1582:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 228830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228838 */     GIR_RootConstrainSelectedInstOperands,
     /* 228839 */     // GIR_Coverage, 10095,
     /* 228839 */     GIR_EraseRootFromParent_Done,
     /* 228840 */   // Label 4546: @228840
     /* 228840 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(228882), // Rule ID 10096 //
     /* 228845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1582:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 228872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228880 */     GIR_RootConstrainSelectedInstOperands,
     /* 228881 */     // GIR_Coverage, 10096,
     /* 228881 */     GIR_EraseRootFromParent_Done,
     /* 228882 */   // Label 4547: @228882
     /* 228882 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(228924), // Rule ID 10109 //
     /* 228887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228911 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1587:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 228914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228922 */     GIR_RootConstrainSelectedInstOperands,
     /* 228923 */     // GIR_Coverage, 10109,
     /* 228923 */     GIR_EraseRootFromParent_Done,
     /* 228924 */   // Label 4548: @228924
     /* 228924 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(228966), // Rule ID 10110 //
     /* 228929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 228956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228964 */     GIR_RootConstrainSelectedInstOperands,
     /* 228965 */     // GIR_Coverage, 10110,
     /* 228965 */     GIR_EraseRootFromParent_Done,
     /* 228966 */   // Label 4549: @228966
     /* 228966 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229008), // Rule ID 10111 //
     /* 228971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 228998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229006 */     GIR_RootConstrainSelectedInstOperands,
     /* 229007 */     // GIR_Coverage, 10111,
     /* 229007 */     GIR_EraseRootFromParent_Done,
     /* 229008 */   // Label 4550: @229008
     /* 229008 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229050), // Rule ID 10112 //
     /* 229013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229037 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1584:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 229040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229048 */     GIR_RootConstrainSelectedInstOperands,
     /* 229049 */     // GIR_Coverage, 10112,
     /* 229049 */     GIR_EraseRootFromParent_Done,
     /* 229050 */   // Label 4551: @229050
     /* 229050 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229092), // Rule ID 10113 //
     /* 229055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229079 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1584:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 229082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229090 */     GIR_RootConstrainSelectedInstOperands,
     /* 229091 */     // GIR_Coverage, 10113,
     /* 229091 */     GIR_EraseRootFromParent_Done,
     /* 229092 */   // Label 4552: @229092
     /* 229092 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229134), // Rule ID 10114 //
     /* 229097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1584:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 229124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229132 */     GIR_RootConstrainSelectedInstOperands,
     /* 229133 */     // GIR_Coverage, 10114,
     /* 229133 */     GIR_EraseRootFromParent_Done,
     /* 229134 */   // Label 4553: @229134
     /* 229134 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229176), // Rule ID 10141 //
     /* 229139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 229147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229163 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 229166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229174 */     GIR_RootConstrainSelectedInstOperands,
     /* 229175 */     // GIR_Coverage, 10141,
     /* 229175 */     GIR_EraseRootFromParent_Done,
     /* 229176 */   // Label 4554: @229176
     /* 229176 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229218), // Rule ID 10145 //
     /* 229181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 229189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229205 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 229208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229216 */     GIR_RootConstrainSelectedInstOperands,
     /* 229217 */     // GIR_Coverage, 10145,
     /* 229217 */     GIR_EraseRootFromParent_Done,
     /* 229218 */   // Label 4555: @229218
     /* 229218 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229260), // Rule ID 10149 //
     /* 229223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 229231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229247 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 229250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229258 */     GIR_RootConstrainSelectedInstOperands,
     /* 229259 */     // GIR_Coverage, 10149,
     /* 229259 */     GIR_EraseRootFromParent_Done,
     /* 229260 */   // Label 4556: @229260
     /* 229260 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229302), // Rule ID 10153 //
     /* 229265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 229273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229289 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 229292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229300 */     GIR_RootConstrainSelectedInstOperands,
     /* 229301 */     // GIR_Coverage, 10153,
     /* 229301 */     GIR_EraseRootFromParent_Done,
     /* 229302 */   // Label 4557: @229302
     /* 229302 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229344), // Rule ID 10157 //
     /* 229307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 229315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229331 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1695:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 229334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229342 */     GIR_RootConstrainSelectedInstOperands,
     /* 229343 */     // GIR_Coverage, 10157,
     /* 229343 */     GIR_EraseRootFromParent_Done,
     /* 229344 */   // Label 4558: @229344
     /* 229344 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229386), // Rule ID 10158 //
     /* 229349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 229357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229373 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1942:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 229376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229384 */     GIR_RootConstrainSelectedInstOperands,
     /* 229385 */     // GIR_Coverage, 10158,
     /* 229385 */     GIR_EraseRootFromParent_Done,
     /* 229386 */   // Label 4559: @229386
     /* 229386 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229428), // Rule ID 10159 //
     /* 229391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 229399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1939:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 229418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229426 */     GIR_RootConstrainSelectedInstOperands,
     /* 229427 */     // GIR_Coverage, 10159,
     /* 229427 */     GIR_EraseRootFromParent_Done,
     /* 229428 */   // Label 4560: @229428
     /* 229428 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229470), // Rule ID 10163 //
     /* 229433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 229441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1694:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 229460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229468 */     GIR_RootConstrainSelectedInstOperands,
     /* 229469 */     // GIR_Coverage, 10163,
     /* 229469 */     GIR_EraseRootFromParent_Done,
     /* 229470 */   // Label 4561: @229470
     /* 229470 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229512), // Rule ID 10167 //
     /* 229475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 229483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1692:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 229502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229510 */     GIR_RootConstrainSelectedInstOperands,
     /* 229511 */     // GIR_Coverage, 10167,
     /* 229511 */     GIR_EraseRootFromParent_Done,
     /* 229512 */   // Label 4562: @229512
     /* 229512 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229554), // Rule ID 10171 //
     /* 229517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 229525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229541 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1693:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 229544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229552 */     GIR_RootConstrainSelectedInstOperands,
     /* 229553 */     // GIR_Coverage, 10171,
     /* 229553 */     GIR_EraseRootFromParent_Done,
     /* 229554 */   // Label 4563: @229554
     /* 229554 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229596), // Rule ID 10175 //
     /* 229559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 229567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229583 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1941:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 229586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229594 */     GIR_RootConstrainSelectedInstOperands,
     /* 229595 */     // GIR_Coverage, 10175,
     /* 229595 */     GIR_EraseRootFromParent_Done,
     /* 229596 */   // Label 4564: @229596
     /* 229596 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229638), // Rule ID 10179 //
     /* 229601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 229609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229625 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1940:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 229628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229636 */     GIR_RootConstrainSelectedInstOperands,
     /* 229637 */     // GIR_Coverage, 10179,
     /* 229637 */     GIR_EraseRootFromParent_Done,
     /* 229638 */   // Label 4565: @229638
     /* 229638 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229680), // Rule ID 10189 //
     /* 229643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 229651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1397:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 229670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229678 */     GIR_RootConstrainSelectedInstOperands,
     /* 229679 */     // GIR_Coverage, 10189,
     /* 229679 */     GIR_EraseRootFromParent_Done,
     /* 229680 */   // Label 4566: @229680
     /* 229680 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229722), // Rule ID 10190 //
     /* 229685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 229693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 229712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229720 */     GIR_RootConstrainSelectedInstOperands,
     /* 229721 */     // GIR_Coverage, 10190,
     /* 229721 */     GIR_EraseRootFromParent_Done,
     /* 229722 */   // Label 4567: @229722
     /* 229722 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(229764), // Rule ID 10191 //
     /* 229727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 229735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1399:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 229754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229762 */     GIR_RootConstrainSelectedInstOperands,
     /* 229763 */     // GIR_Coverage, 10191,
     /* 229763 */     GIR_EraseRootFromParent_Done,
     /* 229764 */   // Label 4568: @229764
     /* 229764 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(229806), // Rule ID 10195 //
     /* 229769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 229777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1396:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 229796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229804 */     GIR_RootConstrainSelectedInstOperands,
     /* 229805 */     // GIR_Coverage, 10195,
     /* 229805 */     GIR_EraseRootFromParent_Done,
     /* 229806 */   // Label 4569: @229806
     /* 229806 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(229848), // Rule ID 10199 //
     /* 229811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 229819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1398:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 229838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229846 */     GIR_RootConstrainSelectedInstOperands,
     /* 229847 */     // GIR_Coverage, 10199,
     /* 229847 */     GIR_EraseRootFromParent_Done,
     /* 229848 */   // Label 4570: @229848
     /* 229848 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(229890), // Rule ID 10203 //
     /* 229853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 229861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1403:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 229880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229888 */     GIR_RootConstrainSelectedInstOperands,
     /* 229889 */     // GIR_Coverage, 10203,
     /* 229889 */     GIR_EraseRootFromParent_Done,
     /* 229890 */   // Label 4571: @229890
     /* 229890 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(229932), // Rule ID 10207 //
     /* 229895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 229903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1405:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 229922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229930 */     GIR_RootConstrainSelectedInstOperands,
     /* 229931 */     // GIR_Coverage, 10207,
     /* 229931 */     GIR_EraseRootFromParent_Done,
     /* 229932 */   // Label 4572: @229932
     /* 229932 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(229974), // Rule ID 10211 //
     /* 229937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 229945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 229964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229972 */     GIR_RootConstrainSelectedInstOperands,
     /* 229973 */     // GIR_Coverage, 10211,
     /* 229973 */     GIR_EraseRootFromParent_Done,
     /* 229974 */   // Label 4573: @229974
     /* 229974 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230016), // Rule ID 11188 //
     /* 229979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 229987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 230006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230014 */     GIR_RootConstrainSelectedInstOperands,
     /* 230015 */     // GIR_Coverage, 11188,
     /* 230015 */     GIR_EraseRootFromParent_Done,
     /* 230016 */   // Label 4574: @230016
     /* 230016 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230058), // Rule ID 11189 //
     /* 230021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 230029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 230048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230056 */     GIR_RootConstrainSelectedInstOperands,
     /* 230057 */     // GIR_Coverage, 11189,
     /* 230057 */     GIR_EraseRootFromParent_Done,
     /* 230058 */   // Label 4575: @230058
     /* 230058 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230100), // Rule ID 11191 //
     /* 230063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 230066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 230090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230098 */     GIR_RootConstrainSelectedInstOperands,
     /* 230099 */     // GIR_Coverage, 11191,
     /* 230099 */     GIR_EraseRootFromParent_Done,
     /* 230100 */   // Label 4576: @230100
     /* 230100 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230142), // Rule ID 11192 //
     /* 230105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 230108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230129 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1467:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 230132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230140 */     GIR_RootConstrainSelectedInstOperands,
     /* 230141 */     // GIR_Coverage, 11192,
     /* 230141 */     GIR_EraseRootFromParent_Done,
     /* 230142 */   // Label 4577: @230142
     /* 230142 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230184), // Rule ID 11246 //
     /* 230147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1816:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 230174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230182 */     GIR_RootConstrainSelectedInstOperands,
     /* 230183 */     // GIR_Coverage, 11246,
     /* 230183 */     GIR_EraseRootFromParent_Done,
     /* 230184 */   // Label 4578: @230184
     /* 230184 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230226), // Rule ID 11247 //
     /* 230189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1816:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 230216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230224 */     GIR_RootConstrainSelectedInstOperands,
     /* 230225 */     // GIR_Coverage, 11247,
     /* 230225 */     GIR_EraseRootFromParent_Done,
     /* 230226 */   // Label 4579: @230226
     /* 230226 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230268), // Rule ID 11248 //
     /* 230231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 230258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230266 */     GIR_RootConstrainSelectedInstOperands,
     /* 230267 */     // GIR_Coverage, 11248,
     /* 230267 */     GIR_EraseRootFromParent_Done,
     /* 230268 */   // Label 4580: @230268
     /* 230268 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230310), // Rule ID 11249 //
     /* 230273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1816:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 230300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230308 */     GIR_RootConstrainSelectedInstOperands,
     /* 230309 */     // GIR_Coverage, 11249,
     /* 230309 */     GIR_EraseRootFromParent_Done,
     /* 230310 */   // Label 4581: @230310
     /* 230310 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230352), // Rule ID 11302 //
     /* 230315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1737:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 230342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230350 */     GIR_RootConstrainSelectedInstOperands,
     /* 230351 */     // GIR_Coverage, 11302,
     /* 230351 */     GIR_EraseRootFromParent_Done,
     /* 230352 */   // Label 4582: @230352
     /* 230352 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230394), // Rule ID 11303 //
     /* 230357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1737:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 230384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230392 */     GIR_RootConstrainSelectedInstOperands,
     /* 230393 */     // GIR_Coverage, 11303,
     /* 230393 */     GIR_EraseRootFromParent_Done,
     /* 230394 */   // Label 4583: @230394
     /* 230394 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230436), // Rule ID 11304 //
     /* 230399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1737:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 230426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230434 */     GIR_RootConstrainSelectedInstOperands,
     /* 230435 */     // GIR_Coverage, 11304,
     /* 230435 */     GIR_EraseRootFromParent_Done,
     /* 230436 */   // Label 4584: @230436
     /* 230436 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230478), // Rule ID 11305 //
     /* 230441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1973:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 230468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230476 */     GIR_RootConstrainSelectedInstOperands,
     /* 230477 */     // GIR_Coverage, 11305,
     /* 230477 */     GIR_EraseRootFromParent_Done,
     /* 230478 */   // Label 4585: @230478
     /* 230478 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230520), // Rule ID 11306 //
     /* 230483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1973:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 230510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230518 */     GIR_RootConstrainSelectedInstOperands,
     /* 230519 */     // GIR_Coverage, 11306,
     /* 230519 */     GIR_EraseRootFromParent_Done,
     /* 230520 */   // Label 4586: @230520
     /* 230520 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230562), // Rule ID 11307 //
     /* 230525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1973:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 230552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230560 */     GIR_RootConstrainSelectedInstOperands,
     /* 230561 */     // GIR_Coverage, 11307,
     /* 230561 */     GIR_EraseRootFromParent_Done,
     /* 230562 */   // Label 4587: @230562
     /* 230562 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230604), // Rule ID 11308 //
     /* 230567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1975:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 230594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230602 */     GIR_RootConstrainSelectedInstOperands,
     /* 230603 */     // GIR_Coverage, 11308,
     /* 230603 */     GIR_EraseRootFromParent_Done,
     /* 230604 */   // Label 4588: @230604
     /* 230604 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230646), // Rule ID 11309 //
     /* 230609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1975:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 230636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230644 */     GIR_RootConstrainSelectedInstOperands,
     /* 230645 */     // GIR_Coverage, 11309,
     /* 230645 */     GIR_EraseRootFromParent_Done,
     /* 230646 */   // Label 4589: @230646
     /* 230646 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230688), // Rule ID 11310 //
     /* 230651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1975:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 230678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230686 */     GIR_RootConstrainSelectedInstOperands,
     /* 230687 */     // GIR_Coverage, 11310,
     /* 230687 */     GIR_EraseRootFromParent_Done,
     /* 230688 */   // Label 4590: @230688
     /* 230688 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(230730), // Rule ID 11311 //
     /* 230693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 230720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230728 */     GIR_RootConstrainSelectedInstOperands,
     /* 230729 */     // GIR_Coverage, 11311,
     /* 230729 */     GIR_EraseRootFromParent_Done,
     /* 230730 */   // Label 4591: @230730
     /* 230730 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(230772), // Rule ID 11312 //
     /* 230735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 230762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230770 */     GIR_RootConstrainSelectedInstOperands,
     /* 230771 */     // GIR_Coverage, 11312,
     /* 230771 */     GIR_EraseRootFromParent_Done,
     /* 230772 */   // Label 4592: @230772
     /* 230772 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(230814), // Rule ID 11313 //
     /* 230777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 230804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230812 */     GIR_RootConstrainSelectedInstOperands,
     /* 230813 */     // GIR_Coverage, 11313,
     /* 230813 */     GIR_EraseRootFromParent_Done,
     /* 230814 */   // Label 4593: @230814
     /* 230814 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(230856), // Rule ID 11314 //
     /* 230819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1741:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 230846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230854 */     GIR_RootConstrainSelectedInstOperands,
     /* 230855 */     // GIR_Coverage, 11314,
     /* 230855 */     GIR_EraseRootFromParent_Done,
     /* 230856 */   // Label 4594: @230856
     /* 230856 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(230898), // Rule ID 11315 //
     /* 230861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 230888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230896 */     GIR_RootConstrainSelectedInstOperands,
     /* 230897 */     // GIR_Coverage, 11315,
     /* 230897 */     GIR_EraseRootFromParent_Done,
     /* 230898 */   // Label 4595: @230898
     /* 230898 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(230940), // Rule ID 11316 //
     /* 230903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 230930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230938 */     GIR_RootConstrainSelectedInstOperands,
     /* 230939 */     // GIR_Coverage, 11316,
     /* 230939 */     GIR_EraseRootFromParent_Done,
     /* 230940 */   // Label 4596: @230940
     /* 230940 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(230982), // Rule ID 11317 //
     /* 230945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1977:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 230972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230980 */     GIR_RootConstrainSelectedInstOperands,
     /* 230981 */     // GIR_Coverage, 11317,
     /* 230981 */     GIR_EraseRootFromParent_Done,
     /* 230982 */   // Label 4597: @230982
     /* 230982 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231024), // Rule ID 11318 //
     /* 230987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1977:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 231014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231022 */     GIR_RootConstrainSelectedInstOperands,
     /* 231023 */     // GIR_Coverage, 11318,
     /* 231023 */     GIR_EraseRootFromParent_Done,
     /* 231024 */   // Label 4598: @231024
     /* 231024 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231066), // Rule ID 11319 //
     /* 231029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1977:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 231056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231064 */     GIR_RootConstrainSelectedInstOperands,
     /* 231065 */     // GIR_Coverage, 11319,
     /* 231065 */     GIR_EraseRootFromParent_Done,
     /* 231066 */   // Label 4599: @231066
     /* 231066 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231108), // Rule ID 11320 //
     /* 231071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1979:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 231098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231106 */     GIR_RootConstrainSelectedInstOperands,
     /* 231107 */     // GIR_Coverage, 11320,
     /* 231107 */     GIR_EraseRootFromParent_Done,
     /* 231108 */   // Label 4600: @231108
     /* 231108 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231150), // Rule ID 11321 //
     /* 231113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 231140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231148 */     GIR_RootConstrainSelectedInstOperands,
     /* 231149 */     // GIR_Coverage, 11321,
     /* 231149 */     GIR_EraseRootFromParent_Done,
     /* 231150 */   // Label 4601: @231150
     /* 231150 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231192), // Rule ID 11322 //
     /* 231155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 231182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231190 */     GIR_RootConstrainSelectedInstOperands,
     /* 231191 */     // GIR_Coverage, 11322,
     /* 231191 */     GIR_EraseRootFromParent_Done,
     /* 231192 */   // Label 4602: @231192
     /* 231192 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231234), // Rule ID 11331 //
     /* 231197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 231224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231232 */     GIR_RootConstrainSelectedInstOperands,
     /* 231233 */     // GIR_Coverage, 11331,
     /* 231233 */     GIR_EraseRootFromParent_Done,
     /* 231234 */   // Label 4603: @231234
     /* 231234 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231276), // Rule ID 11332 //
     /* 231239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 231266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231274 */     GIR_RootConstrainSelectedInstOperands,
     /* 231275 */     // GIR_Coverage, 11332,
     /* 231275 */     GIR_EraseRootFromParent_Done,
     /* 231276 */   // Label 4604: @231276
     /* 231276 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231318), // Rule ID 11333 //
     /* 231281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 231308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231316 */     GIR_RootConstrainSelectedInstOperands,
     /* 231317 */     // GIR_Coverage, 11333,
     /* 231317 */     GIR_EraseRootFromParent_Done,
     /* 231318 */   // Label 4605: @231318
     /* 231318 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231360), // Rule ID 11334 //
     /* 231323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1780:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 231350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231358 */     GIR_RootConstrainSelectedInstOperands,
     /* 231359 */     // GIR_Coverage, 11334,
     /* 231359 */     GIR_EraseRootFromParent_Done,
     /* 231360 */   // Label 4606: @231360
     /* 231360 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231402), // Rule ID 11335 //
     /* 231365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 231392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231400 */     GIR_RootConstrainSelectedInstOperands,
     /* 231401 */     // GIR_Coverage, 11335,
     /* 231401 */     GIR_EraseRootFromParent_Done,
     /* 231402 */   // Label 4607: @231402
     /* 231402 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231444), // Rule ID 11336 //
     /* 231407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 231434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231442 */     GIR_RootConstrainSelectedInstOperands,
     /* 231443 */     // GIR_Coverage, 11336,
     /* 231443 */     GIR_EraseRootFromParent_Done,
     /* 231444 */   // Label 4608: @231444
     /* 231444 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231486), // Rule ID 11337 //
     /* 231449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1782:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 231476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231484 */     GIR_RootConstrainSelectedInstOperands,
     /* 231485 */     // GIR_Coverage, 11337,
     /* 231485 */     GIR_EraseRootFromParent_Done,
     /* 231486 */   // Label 4609: @231486
     /* 231486 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231528), // Rule ID 11338 //
     /* 231491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 231518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231526 */     GIR_RootConstrainSelectedInstOperands,
     /* 231527 */     // GIR_Coverage, 11338,
     /* 231527 */     GIR_EraseRootFromParent_Done,
     /* 231528 */   // Label 4610: @231528
     /* 231528 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231570), // Rule ID 11339 //
     /* 231533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1782:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 231560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231568 */     GIR_RootConstrainSelectedInstOperands,
     /* 231569 */     // GIR_Coverage, 11339,
     /* 231569 */     GIR_EraseRootFromParent_Done,
     /* 231570 */   // Label 4611: @231570
     /* 231570 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231612), // Rule ID 11340 //
     /* 231575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 231602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231610 */     GIR_RootConstrainSelectedInstOperands,
     /* 231611 */     // GIR_Coverage, 11340,
     /* 231611 */     GIR_EraseRootFromParent_Done,
     /* 231612 */   // Label 4612: @231612
     /* 231612 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231654), // Rule ID 11341 //
     /* 231617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 231644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231652 */     GIR_RootConstrainSelectedInstOperands,
     /* 231653 */     // GIR_Coverage, 11341,
     /* 231653 */     GIR_EraseRootFromParent_Done,
     /* 231654 */   // Label 4613: @231654
     /* 231654 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(231696), // Rule ID 11342 //
     /* 231659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 231686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231694 */     GIR_RootConstrainSelectedInstOperands,
     /* 231695 */     // GIR_Coverage, 11342,
     /* 231695 */     GIR_EraseRootFromParent_Done,
     /* 231696 */   // Label 4614: @231696
     /* 231696 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(231738), // Rule ID 11343 //
     /* 231701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 231728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231736 */     GIR_RootConstrainSelectedInstOperands,
     /* 231737 */     // GIR_Coverage, 11343,
     /* 231737 */     GIR_EraseRootFromParent_Done,
     /* 231738 */   // Label 4615: @231738
     /* 231738 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(231780), // Rule ID 11344 //
     /* 231743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 231770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231778 */     GIR_RootConstrainSelectedInstOperands,
     /* 231779 */     // GIR_Coverage, 11344,
     /* 231779 */     GIR_EraseRootFromParent_Done,
     /* 231780 */   // Label 4616: @231780
     /* 231780 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(231822), // Rule ID 11345 //
     /* 231785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 231812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231820 */     GIR_RootConstrainSelectedInstOperands,
     /* 231821 */     // GIR_Coverage, 11345,
     /* 231821 */     GIR_EraseRootFromParent_Done,
     /* 231822 */   // Label 4617: @231822
     /* 231822 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(231864), // Rule ID 11346 //
     /* 231827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1784:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 231854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231862 */     GIR_RootConstrainSelectedInstOperands,
     /* 231863 */     // GIR_Coverage, 11346,
     /* 231863 */     GIR_EraseRootFromParent_Done,
     /* 231864 */   // Label 4618: @231864
     /* 231864 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(231906), // Rule ID 11347 //
     /* 231869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1784:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 231896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231904 */     GIR_RootConstrainSelectedInstOperands,
     /* 231905 */     // GIR_Coverage, 11347,
     /* 231905 */     GIR_EraseRootFromParent_Done,
     /* 231906 */   // Label 4619: @231906
     /* 231906 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(231948), // Rule ID 11348 //
     /* 231911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1784:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 231938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231946 */     GIR_RootConstrainSelectedInstOperands,
     /* 231947 */     // GIR_Coverage, 11348,
     /* 231947 */     GIR_EraseRootFromParent_Done,
     /* 231948 */   // Label 4620: @231948
     /* 231948 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(231990), // Rule ID 11349 //
     /* 231953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1952:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 231980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231988 */     GIR_RootConstrainSelectedInstOperands,
     /* 231989 */     // GIR_Coverage, 11349,
     /* 231989 */     GIR_EraseRootFromParent_Done,
     /* 231990 */   // Label 4621: @231990
     /* 231990 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232032), // Rule ID 11351 //
     /* 231995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1952:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 232022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232030 */     GIR_RootConstrainSelectedInstOperands,
     /* 232031 */     // GIR_Coverage, 11351,
     /* 232031 */     GIR_EraseRootFromParent_Done,
     /* 232032 */   // Label 4622: @232032
     /* 232032 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232074), // Rule ID 11353 //
     /* 232037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 232064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232072 */     GIR_RootConstrainSelectedInstOperands,
     /* 232073 */     // GIR_Coverage, 11353,
     /* 232073 */     GIR_EraseRootFromParent_Done,
     /* 232074 */   // Label 4623: @232074
     /* 232074 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232116), // Rule ID 11355 //
     /* 232079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1952:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 232106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232114 */     GIR_RootConstrainSelectedInstOperands,
     /* 232115 */     // GIR_Coverage, 11355,
     /* 232115 */     GIR_EraseRootFromParent_Done,
     /* 232116 */   // Label 4624: @232116
     /* 232116 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232158), // Rule ID 11357 //
     /* 232121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1712:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 232148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232156 */     GIR_RootConstrainSelectedInstOperands,
     /* 232157 */     // GIR_Coverage, 11357,
     /* 232157 */     GIR_EraseRootFromParent_Done,
     /* 232158 */   // Label 4625: @232158
     /* 232158 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232200), // Rule ID 11358 //
     /* 232163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1712:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 232190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232198 */     GIR_RootConstrainSelectedInstOperands,
     /* 232199 */     // GIR_Coverage, 11358,
     /* 232199 */     GIR_EraseRootFromParent_Done,
     /* 232200 */   // Label 4626: @232200
     /* 232200 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232242), // Rule ID 11359 //
     /* 232205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 232232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232240 */     GIR_RootConstrainSelectedInstOperands,
     /* 232241 */     // GIR_Coverage, 11359,
     /* 232241 */     GIR_EraseRootFromParent_Done,
     /* 232242 */   // Label 4627: @232242
     /* 232242 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232284), // Rule ID 11360 //
     /* 232247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1712:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 232274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232282 */     GIR_RootConstrainSelectedInstOperands,
     /* 232283 */     // GIR_Coverage, 11360,
     /* 232283 */     GIR_EraseRootFromParent_Done,
     /* 232284 */   // Label 4628: @232284
     /* 232284 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232326), // Rule ID 11361 //
     /* 232289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232313 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 232316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232324 */     GIR_RootConstrainSelectedInstOperands,
     /* 232325 */     // GIR_Coverage, 11361,
     /* 232325 */     GIR_EraseRootFromParent_Done,
     /* 232326 */   // Label 4629: @232326
     /* 232326 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232368), // Rule ID 11362 //
     /* 232331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 232358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232366 */     GIR_RootConstrainSelectedInstOperands,
     /* 232367 */     // GIR_Coverage, 11362,
     /* 232367 */     GIR_EraseRootFromParent_Done,
     /* 232368 */   // Label 4630: @232368
     /* 232368 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232410), // Rule ID 11363 //
     /* 232373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 232400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232408 */     GIR_RootConstrainSelectedInstOperands,
     /* 232409 */     // GIR_Coverage, 11363,
     /* 232409 */     GIR_EraseRootFromParent_Done,
     /* 232410 */   // Label 4631: @232410
     /* 232410 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232452), // Rule ID 11364 //
     /* 232415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 232442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232450 */     GIR_RootConstrainSelectedInstOperands,
     /* 232451 */     // GIR_Coverage, 11364,
     /* 232451 */     GIR_EraseRootFromParent_Done,
     /* 232452 */   // Label 4632: @232452
     /* 232452 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232494), // Rule ID 11365 //
     /* 232457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 232484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232492 */     GIR_RootConstrainSelectedInstOperands,
     /* 232493 */     // GIR_Coverage, 11365,
     /* 232493 */     GIR_EraseRootFromParent_Done,
     /* 232494 */   // Label 4633: @232494
     /* 232494 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232536), // Rule ID 11367 //
     /* 232499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 232526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232534 */     GIR_RootConstrainSelectedInstOperands,
     /* 232535 */     // GIR_Coverage, 11367,
     /* 232535 */     GIR_EraseRootFromParent_Done,
     /* 232536 */   // Label 4634: @232536
     /* 232536 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232578), // Rule ID 11369 //
     /* 232541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 232568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232576 */     GIR_RootConstrainSelectedInstOperands,
     /* 232577 */     // GIR_Coverage, 11369,
     /* 232577 */     GIR_EraseRootFromParent_Done,
     /* 232578 */   // Label 4635: @232578
     /* 232578 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232620), // Rule ID 11371 //
     /* 232583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232607 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 232610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232618 */     GIR_RootConstrainSelectedInstOperands,
     /* 232619 */     // GIR_Coverage, 11371,
     /* 232619 */     GIR_EraseRootFromParent_Done,
     /* 232620 */   // Label 4636: @232620
     /* 232620 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232662), // Rule ID 11373 //
     /* 232625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 232652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232660 */     GIR_RootConstrainSelectedInstOperands,
     /* 232661 */     // GIR_Coverage, 11373,
     /* 232661 */     GIR_EraseRootFromParent_Done,
     /* 232662 */   // Label 4637: @232662
     /* 232662 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(232704), // Rule ID 11375 //
     /* 232667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 232694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232702 */     GIR_RootConstrainSelectedInstOperands,
     /* 232703 */     // GIR_Coverage, 11375,
     /* 232703 */     GIR_EraseRootFromParent_Done,
     /* 232704 */   // Label 4638: @232704
     /* 232704 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(232746), // Rule ID 11377 //
     /* 232709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 232736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232744 */     GIR_RootConstrainSelectedInstOperands,
     /* 232745 */     // GIR_Coverage, 11377,
     /* 232745 */     GIR_EraseRootFromParent_Done,
     /* 232746 */   // Label 4639: @232746
     /* 232746 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(232788), // Rule ID 11379 //
     /* 232751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2039:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 232778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232786 */     GIR_RootConstrainSelectedInstOperands,
     /* 232787 */     // GIR_Coverage, 11379,
     /* 232787 */     GIR_EraseRootFromParent_Done,
     /* 232788 */   // Label 4640: @232788
     /* 232788 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(232830), // Rule ID 11381 //
     /* 232793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232817 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1713:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 232820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232828 */     GIR_RootConstrainSelectedInstOperands,
     /* 232829 */     // GIR_Coverage, 11381,
     /* 232829 */     GIR_EraseRootFromParent_Done,
     /* 232830 */   // Label 4641: @232830
     /* 232830 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(232872), // Rule ID 11382 //
     /* 232835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1713:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 232862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232870 */     GIR_RootConstrainSelectedInstOperands,
     /* 232871 */     // GIR_Coverage, 11382,
     /* 232871 */     GIR_EraseRootFromParent_Done,
     /* 232872 */   // Label 4642: @232872
     /* 232872 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(232914), // Rule ID 11383 //
     /* 232877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 232904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232912 */     GIR_RootConstrainSelectedInstOperands,
     /* 232913 */     // GIR_Coverage, 11383,
     /* 232913 */     GIR_EraseRootFromParent_Done,
     /* 232914 */   // Label 4643: @232914
     /* 232914 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(232956), // Rule ID 11384 //
     /* 232919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 232946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232954 */     GIR_RootConstrainSelectedInstOperands,
     /* 232955 */     // GIR_Coverage, 11384,
     /* 232955 */     GIR_EraseRootFromParent_Done,
     /* 232956 */   // Label 4644: @232956
     /* 232956 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(232998), // Rule ID 11385 //
     /* 232961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232985 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1954:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 232988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232996 */     GIR_RootConstrainSelectedInstOperands,
     /* 232997 */     // GIR_Coverage, 11385,
     /* 232997 */     GIR_EraseRootFromParent_Done,
     /* 232998 */   // Label 4645: @232998
     /* 232998 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233040), // Rule ID 11386 //
     /* 233003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1954:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 233030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233038 */     GIR_RootConstrainSelectedInstOperands,
     /* 233039 */     // GIR_Coverage, 11386,
     /* 233039 */     GIR_EraseRootFromParent_Done,
     /* 233040 */   // Label 4646: @233040
     /* 233040 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233082), // Rule ID 11387 //
     /* 233045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 233072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233080 */     GIR_RootConstrainSelectedInstOperands,
     /* 233081 */     // GIR_Coverage, 11387,
     /* 233081 */     GIR_EraseRootFromParent_Done,
     /* 233082 */   // Label 4647: @233082
     /* 233082 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233124), // Rule ID 11388 //
     /* 233087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 233114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233122 */     GIR_RootConstrainSelectedInstOperands,
     /* 233123 */     // GIR_Coverage, 11388,
     /* 233123 */     GIR_EraseRootFromParent_Done,
     /* 233124 */   // Label 4648: @233124
     /* 233124 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233166), // Rule ID 11389 //
     /* 233129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233153 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 233156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233164 */     GIR_RootConstrainSelectedInstOperands,
     /* 233165 */     // GIR_Coverage, 11389,
     /* 233165 */     GIR_EraseRootFromParent_Done,
     /* 233166 */   // Label 4649: @233166
     /* 233166 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233208), // Rule ID 11390 //
     /* 233171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 233198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233206 */     GIR_RootConstrainSelectedInstOperands,
     /* 233207 */     // GIR_Coverage, 11390,
     /* 233207 */     GIR_EraseRootFromParent_Done,
     /* 233208 */   // Label 4650: @233208
     /* 233208 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233250), // Rule ID 11391 //
     /* 233213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233237 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 233240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233248 */     GIR_RootConstrainSelectedInstOperands,
     /* 233249 */     // GIR_Coverage, 11391,
     /* 233249 */     GIR_EraseRootFromParent_Done,
     /* 233250 */   // Label 4651: @233250
     /* 233250 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233292), // Rule ID 11392 //
     /* 233255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1244:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 233282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233290 */     GIR_RootConstrainSelectedInstOperands,
     /* 233291 */     // GIR_Coverage, 11392,
     /* 233291 */     GIR_EraseRootFromParent_Done,
     /* 233292 */   // Label 4652: @233292
     /* 233292 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233334), // Rule ID 11393 //
     /* 233297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1244:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 233324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233332 */     GIR_RootConstrainSelectedInstOperands,
     /* 233333 */     // GIR_Coverage, 11393,
     /* 233333 */     GIR_EraseRootFromParent_Done,
     /* 233334 */   // Label 4653: @233334
     /* 233334 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233376), // Rule ID 11394 //
     /* 233339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 233366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233374 */     GIR_RootConstrainSelectedInstOperands,
     /* 233375 */     // GIR_Coverage, 11394,
     /* 233375 */     GIR_EraseRootFromParent_Done,
     /* 233376 */   // Label 4654: @233376
     /* 233376 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233418), // Rule ID 11395 //
     /* 233381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 233408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233416 */     GIR_RootConstrainSelectedInstOperands,
     /* 233417 */     // GIR_Coverage, 11395,
     /* 233417 */     GIR_EraseRootFromParent_Done,
     /* 233418 */   // Label 4655: @233418
     /* 233418 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233460), // Rule ID 11396 //
     /* 233423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233447 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1723:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 233450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233458 */     GIR_RootConstrainSelectedInstOperands,
     /* 233459 */     // GIR_Coverage, 11396,
     /* 233459 */     GIR_EraseRootFromParent_Done,
     /* 233460 */   // Label 4656: @233460
     /* 233460 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233502), // Rule ID 11397 //
     /* 233465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1723:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 233492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233500 */     GIR_RootConstrainSelectedInstOperands,
     /* 233501 */     // GIR_Coverage, 11397,
     /* 233501 */     GIR_EraseRootFromParent_Done,
     /* 233502 */   // Label 4657: @233502
     /* 233502 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233544), // Rule ID 11398 //
     /* 233507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 233534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233542 */     GIR_RootConstrainSelectedInstOperands,
     /* 233543 */     // GIR_Coverage, 11398,
     /* 233543 */     GIR_EraseRootFromParent_Done,
     /* 233544 */   // Label 4658: @233544
     /* 233544 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233586), // Rule ID 11399 //
     /* 233549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1723:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 233576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233584 */     GIR_RootConstrainSelectedInstOperands,
     /* 233585 */     // GIR_Coverage, 11399,
     /* 233585 */     GIR_EraseRootFromParent_Done,
     /* 233586 */   // Label 4659: @233586
     /* 233586 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233628), // Rule ID 11400 //
     /* 233591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233615 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 233618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233626 */     GIR_RootConstrainSelectedInstOperands,
     /* 233627 */     // GIR_Coverage, 11400,
     /* 233627 */     GIR_EraseRootFromParent_Done,
     /* 233628 */   // Label 4660: @233628
     /* 233628 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233670), // Rule ID 11401 //
     /* 233633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233657 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 233660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233668 */     GIR_RootConstrainSelectedInstOperands,
     /* 233669 */     // GIR_Coverage, 11401,
     /* 233669 */     GIR_EraseRootFromParent_Done,
     /* 233670 */   // Label 4661: @233670
     /* 233670 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(233712), // Rule ID 11402 //
     /* 233675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 233702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233710 */     GIR_RootConstrainSelectedInstOperands,
     /* 233711 */     // GIR_Coverage, 11402,
     /* 233711 */     GIR_EraseRootFromParent_Done,
     /* 233712 */   // Label 4662: @233712
     /* 233712 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(233754), // Rule ID 11403 //
     /* 233717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233741 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 233744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233752 */     GIR_RootConstrainSelectedInstOperands,
     /* 233753 */     // GIR_Coverage, 11403,
     /* 233753 */     GIR_EraseRootFromParent_Done,
     /* 233754 */   // Label 4663: @233754
     /* 233754 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(233796), // Rule ID 11404 //
     /* 233759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 233786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233794 */     GIR_RootConstrainSelectedInstOperands,
     /* 233795 */     // GIR_Coverage, 11404,
     /* 233795 */     GIR_EraseRootFromParent_Done,
     /* 233796 */   // Label 4664: @233796
     /* 233796 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(233838), // Rule ID 11405 //
     /* 233801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 233828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233836 */     GIR_RootConstrainSelectedInstOperands,
     /* 233837 */     // GIR_Coverage, 11405,
     /* 233837 */     GIR_EraseRootFromParent_Done,
     /* 233838 */   // Label 4665: @233838
     /* 233838 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(233880), // Rule ID 11406 //
     /* 233843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 233870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233878 */     GIR_RootConstrainSelectedInstOperands,
     /* 233879 */     // GIR_Coverage, 11406,
     /* 233879 */     GIR_EraseRootFromParent_Done,
     /* 233880 */   // Label 4666: @233880
     /* 233880 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(233922), // Rule ID 11407 //
     /* 233885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 233912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233920 */     GIR_RootConstrainSelectedInstOperands,
     /* 233921 */     // GIR_Coverage, 11407,
     /* 233921 */     GIR_EraseRootFromParent_Done,
     /* 233922 */   // Label 4667: @233922
     /* 233922 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(233964), // Rule ID 11408 //
     /* 233927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233951 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 233954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233962 */     GIR_RootConstrainSelectedInstOperands,
     /* 233963 */     // GIR_Coverage, 11408,
     /* 233963 */     GIR_EraseRootFromParent_Done,
     /* 233964 */   // Label 4668: @233964
     /* 233964 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234006), // Rule ID 11409 //
     /* 233969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 233996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234004 */     GIR_RootConstrainSelectedInstOperands,
     /* 234005 */     // GIR_Coverage, 11409,
     /* 234005 */     GIR_EraseRootFromParent_Done,
     /* 234006 */   // Label 4669: @234006
     /* 234006 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234048), // Rule ID 11410 //
     /* 234011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 234038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234046 */     GIR_RootConstrainSelectedInstOperands,
     /* 234047 */     // GIR_Coverage, 11410,
     /* 234047 */     GIR_EraseRootFromParent_Done,
     /* 234048 */   // Label 4670: @234048
     /* 234048 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234090), // Rule ID 11411 //
     /* 234053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 234080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234088 */     GIR_RootConstrainSelectedInstOperands,
     /* 234089 */     // GIR_Coverage, 11411,
     /* 234089 */     GIR_EraseRootFromParent_Done,
     /* 234090 */   // Label 4671: @234090
     /* 234090 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234132), // Rule ID 11412 //
     /* 234095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 234103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234130 */     GIR_RootConstrainSelectedInstOperands,
     /* 234131 */     // GIR_Coverage, 11412,
     /* 234131 */     GIR_EraseRootFromParent_Done,
     /* 234132 */   // Label 4672: @234132
     /* 234132 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234174), // Rule ID 11423 //
     /* 234137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 234164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234172 */     GIR_RootConstrainSelectedInstOperands,
     /* 234173 */     // GIR_Coverage, 11423,
     /* 234173 */     GIR_EraseRootFromParent_Done,
     /* 234174 */   // Label 4673: @234174
     /* 234174 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234216), // Rule ID 11424 //
     /* 234179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234203 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 234206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234214 */     GIR_RootConstrainSelectedInstOperands,
     /* 234215 */     // GIR_Coverage, 11424,
     /* 234215 */     GIR_EraseRootFromParent_Done,
     /* 234216 */   // Label 4674: @234216
     /* 234216 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234258), // Rule ID 11425 //
     /* 234221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 234248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234256 */     GIR_RootConstrainSelectedInstOperands,
     /* 234257 */     // GIR_Coverage, 11425,
     /* 234257 */     GIR_EraseRootFromParent_Done,
     /* 234258 */   // Label 4675: @234258
     /* 234258 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234300), // Rule ID 11426 //
     /* 234263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 234290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234298 */     GIR_RootConstrainSelectedInstOperands,
     /* 234299 */     // GIR_Coverage, 11426,
     /* 234299 */     GIR_EraseRootFromParent_Done,
     /* 234300 */   // Label 4676: @234300
     /* 234300 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234342), // Rule ID 11435 //
     /* 234305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 234332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234340 */     GIR_RootConstrainSelectedInstOperands,
     /* 234341 */     // GIR_Coverage, 11435,
     /* 234341 */     GIR_EraseRootFromParent_Done,
     /* 234342 */   // Label 4677: @234342
     /* 234342 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234384), // Rule ID 11436 //
     /* 234347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 234374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234382 */     GIR_RootConstrainSelectedInstOperands,
     /* 234383 */     // GIR_Coverage, 11436,
     /* 234383 */     GIR_EraseRootFromParent_Done,
     /* 234384 */   // Label 4678: @234384
     /* 234384 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234426), // Rule ID 11437 //
     /* 234389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 234416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234424 */     GIR_RootConstrainSelectedInstOperands,
     /* 234425 */     // GIR_Coverage, 11437,
     /* 234425 */     GIR_EraseRootFromParent_Done,
     /* 234426 */   // Label 4679: @234426
     /* 234426 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234468), // Rule ID 11438 //
     /* 234431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 234458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234466 */     GIR_RootConstrainSelectedInstOperands,
     /* 234467 */     // GIR_Coverage, 11438,
     /* 234467 */     GIR_EraseRootFromParent_Done,
     /* 234468 */   // Label 4680: @234468
     /* 234468 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234510), // Rule ID 11439 //
     /* 234473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234497 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 234500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234508 */     GIR_RootConstrainSelectedInstOperands,
     /* 234509 */     // GIR_Coverage, 11439,
     /* 234509 */     GIR_EraseRootFromParent_Done,
     /* 234510 */   // Label 4681: @234510
     /* 234510 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234552), // Rule ID 11440 //
     /* 234515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 234542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234550 */     GIR_RootConstrainSelectedInstOperands,
     /* 234551 */     // GIR_Coverage, 11440,
     /* 234551 */     GIR_EraseRootFromParent_Done,
     /* 234552 */   // Label 4682: @234552
     /* 234552 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234594), // Rule ID 11441 //
     /* 234557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 234584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234592 */     GIR_RootConstrainSelectedInstOperands,
     /* 234593 */     // GIR_Coverage, 11441,
     /* 234593 */     GIR_EraseRootFromParent_Done,
     /* 234594 */   // Label 4683: @234594
     /* 234594 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234636), // Rule ID 11442 //
     /* 234599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 234626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234634 */     GIR_RootConstrainSelectedInstOperands,
     /* 234635 */     // GIR_Coverage, 11442,
     /* 234635 */     GIR_EraseRootFromParent_Done,
     /* 234636 */   // Label 4684: @234636
     /* 234636 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234678), // Rule ID 11443 //
     /* 234641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 234668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234676 */     GIR_RootConstrainSelectedInstOperands,
     /* 234677 */     // GIR_Coverage, 11443,
     /* 234677 */     GIR_EraseRootFromParent_Done,
     /* 234678 */   // Label 4685: @234678
     /* 234678 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(234720), // Rule ID 11444 //
     /* 234683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 234710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234718 */     GIR_RootConstrainSelectedInstOperands,
     /* 234719 */     // GIR_Coverage, 11444,
     /* 234719 */     GIR_EraseRootFromParent_Done,
     /* 234720 */   // Label 4686: @234720
     /* 234720 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(234762), // Rule ID 11445 //
     /* 234725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 234752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234760 */     GIR_RootConstrainSelectedInstOperands,
     /* 234761 */     // GIR_Coverage, 11445,
     /* 234761 */     GIR_EraseRootFromParent_Done,
     /* 234762 */   // Label 4687: @234762
     /* 234762 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(234804), // Rule ID 11446 //
     /* 234767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 234794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234802 */     GIR_RootConstrainSelectedInstOperands,
     /* 234803 */     // GIR_Coverage, 11446,
     /* 234803 */     GIR_EraseRootFromParent_Done,
     /* 234804 */   // Label 4688: @234804
     /* 234804 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(234846), // Rule ID 11447 //
     /* 234809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2032:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 234836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234844 */     GIR_RootConstrainSelectedInstOperands,
     /* 234845 */     // GIR_Coverage, 11447,
     /* 234845 */     GIR_EraseRootFromParent_Done,
     /* 234846 */   // Label 4689: @234846
     /* 234846 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(234888), // Rule ID 11448 //
     /* 234851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2032:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 234878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234886 */     GIR_RootConstrainSelectedInstOperands,
     /* 234887 */     // GIR_Coverage, 11448,
     /* 234887 */     GIR_EraseRootFromParent_Done,
     /* 234888 */   // Label 4690: @234888
     /* 234888 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(234930), // Rule ID 11449 //
     /* 234893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234928 */     GIR_RootConstrainSelectedInstOperands,
     /* 234929 */     // GIR_Coverage, 11449,
     /* 234929 */     GIR_EraseRootFromParent_Done,
     /* 234930 */   // Label 4691: @234930
     /* 234930 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(234972), // Rule ID 11450 //
     /* 234935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2032:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 234962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234970 */     GIR_RootConstrainSelectedInstOperands,
     /* 234971 */     // GIR_Coverage, 11450,
     /* 234971 */     GIR_EraseRootFromParent_Done,
     /* 234972 */   // Label 4692: @234972
     /* 234972 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235014), // Rule ID 11451 //
     /* 234977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 235004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235012 */     GIR_RootConstrainSelectedInstOperands,
     /* 235013 */     // GIR_Coverage, 11451,
     /* 235013 */     GIR_EraseRootFromParent_Done,
     /* 235014 */   // Label 4693: @235014
     /* 235014 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235056), // Rule ID 11452 //
     /* 235019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 235046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235054 */     GIR_RootConstrainSelectedInstOperands,
     /* 235055 */     // GIR_Coverage, 11452,
     /* 235055 */     GIR_EraseRootFromParent_Done,
     /* 235056 */   // Label 4694: @235056
     /* 235056 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235098), // Rule ID 11453 //
     /* 235061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235085 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 235088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235096 */     GIR_RootConstrainSelectedInstOperands,
     /* 235097 */     // GIR_Coverage, 11453,
     /* 235097 */     GIR_EraseRootFromParent_Done,
     /* 235098 */   // Label 4695: @235098
     /* 235098 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235140), // Rule ID 11454 //
     /* 235103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1903:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 235130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235138 */     GIR_RootConstrainSelectedInstOperands,
     /* 235139 */     // GIR_Coverage, 11454,
     /* 235139 */     GIR_EraseRootFromParent_Done,
     /* 235140 */   // Label 4696: @235140
     /* 235140 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235182), // Rule ID 11455 //
     /* 235145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 235172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235180 */     GIR_RootConstrainSelectedInstOperands,
     /* 235181 */     // GIR_Coverage, 11455,
     /* 235181 */     GIR_EraseRootFromParent_Done,
     /* 235182 */   // Label 4697: @235182
     /* 235182 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235224), // Rule ID 11456 //
     /* 235187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235222 */     GIR_RootConstrainSelectedInstOperands,
     /* 235223 */     // GIR_Coverage, 11456,
     /* 235223 */     GIR_EraseRootFromParent_Done,
     /* 235224 */   // Label 4698: @235224
     /* 235224 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235266), // Rule ID 11457 //
     /* 235229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 235256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235264 */     GIR_RootConstrainSelectedInstOperands,
     /* 235265 */     // GIR_Coverage, 11457,
     /* 235265 */     GIR_EraseRootFromParent_Done,
     /* 235266 */   // Label 4699: @235266
     /* 235266 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235308), // Rule ID 11458 //
     /* 235271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 235298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235306 */     GIR_RootConstrainSelectedInstOperands,
     /* 235307 */     // GIR_Coverage, 11458,
     /* 235307 */     GIR_EraseRootFromParent_Done,
     /* 235308 */   // Label 4700: @235308
     /* 235308 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235350), // Rule ID 11459 //
     /* 235313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 235340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235348 */     GIR_RootConstrainSelectedInstOperands,
     /* 235349 */     // GIR_Coverage, 11459,
     /* 235349 */     GIR_EraseRootFromParent_Done,
     /* 235350 */   // Label 4701: @235350
     /* 235350 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235392), // Rule ID 11460 //
     /* 235355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 235382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235390 */     GIR_RootConstrainSelectedInstOperands,
     /* 235391 */     // GIR_Coverage, 11460,
     /* 235391 */     GIR_EraseRootFromParent_Done,
     /* 235392 */   // Label 4702: @235392
     /* 235392 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235434), // Rule ID 11461 //
     /* 235397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 235424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235432 */     GIR_RootConstrainSelectedInstOperands,
     /* 235433 */     // GIR_Coverage, 11461,
     /* 235433 */     GIR_EraseRootFromParent_Done,
     /* 235434 */   // Label 4703: @235434
     /* 235434 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235476), // Rule ID 11462 //
     /* 235439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 235466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235474 */     GIR_RootConstrainSelectedInstOperands,
     /* 235475 */     // GIR_Coverage, 11462,
     /* 235475 */     GIR_EraseRootFromParent_Done,
     /* 235476 */   // Label 4704: @235476
     /* 235476 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235518), // Rule ID 11463 //
     /* 235481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235505 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 235508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235516 */     GIR_RootConstrainSelectedInstOperands,
     /* 235517 */     // GIR_Coverage, 11463,
     /* 235517 */     GIR_EraseRootFromParent_Done,
     /* 235518 */   // Label 4705: @235518
     /* 235518 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235560), // Rule ID 11464 //
     /* 235523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 235550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235558 */     GIR_RootConstrainSelectedInstOperands,
     /* 235559 */     // GIR_Coverage, 11464,
     /* 235559 */     GIR_EraseRootFromParent_Done,
     /* 235560 */   // Label 4706: @235560
     /* 235560 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235602), // Rule ID 11465 //
     /* 235565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 235592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235600 */     GIR_RootConstrainSelectedInstOperands,
     /* 235601 */     // GIR_Coverage, 11465,
     /* 235601 */     GIR_EraseRootFromParent_Done,
     /* 235602 */   // Label 4707: @235602
     /* 235602 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235644), // Rule ID 11466 //
     /* 235607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2035:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 235634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235642 */     GIR_RootConstrainSelectedInstOperands,
     /* 235643 */     // GIR_Coverage, 11466,
     /* 235643 */     GIR_EraseRootFromParent_Done,
     /* 235644 */   // Label 4708: @235644
     /* 235644 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235686), // Rule ID 11467 //
     /* 235649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235673 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 235676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235684 */     GIR_RootConstrainSelectedInstOperands,
     /* 235685 */     // GIR_Coverage, 11467,
     /* 235685 */     GIR_EraseRootFromParent_Done,
     /* 235686 */   // Label 4709: @235686
     /* 235686 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(235728), // Rule ID 11468 //
     /* 235691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 235718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235726 */     GIR_RootConstrainSelectedInstOperands,
     /* 235727 */     // GIR_Coverage, 11468,
     /* 235727 */     GIR_EraseRootFromParent_Done,
     /* 235728 */   // Label 4710: @235728
     /* 235728 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(235770), // Rule ID 11469 //
     /* 235733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 235760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235768 */     GIR_RootConstrainSelectedInstOperands,
     /* 235769 */     // GIR_Coverage, 11469,
     /* 235769 */     GIR_EraseRootFromParent_Done,
     /* 235770 */   // Label 4711: @235770
     /* 235770 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(235812), // Rule ID 11470 //
     /* 235775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 235802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235810 */     GIR_RootConstrainSelectedInstOperands,
     /* 235811 */     // GIR_Coverage, 11470,
     /* 235811 */     GIR_EraseRootFromParent_Done,
     /* 235812 */   // Label 4712: @235812
     /* 235812 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(235854), // Rule ID 11471 //
     /* 235817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 235844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235852 */     GIR_RootConstrainSelectedInstOperands,
     /* 235853 */     // GIR_Coverage, 11471,
     /* 235853 */     GIR_EraseRootFromParent_Done,
     /* 235854 */   // Label 4713: @235854
     /* 235854 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(235896), // Rule ID 11472 //
     /* 235859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 235886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235894 */     GIR_RootConstrainSelectedInstOperands,
     /* 235895 */     // GIR_Coverage, 11472,
     /* 235895 */     GIR_EraseRootFromParent_Done,
     /* 235896 */   // Label 4714: @235896
     /* 235896 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(235938), // Rule ID 11473 //
     /* 235901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 235928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235936 */     GIR_RootConstrainSelectedInstOperands,
     /* 235937 */     // GIR_Coverage, 11473,
     /* 235937 */     GIR_EraseRootFromParent_Done,
     /* 235938 */   // Label 4715: @235938
     /* 235938 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(235980), // Rule ID 11474 //
     /* 235943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235967 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 235970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235978 */     GIR_RootConstrainSelectedInstOperands,
     /* 235979 */     // GIR_Coverage, 11474,
     /* 235979 */     GIR_EraseRootFromParent_Done,
     /* 235980 */   // Label 4716: @235980
     /* 235980 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236022), // Rule ID 11475 //
     /* 235985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236009 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 236012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236020 */     GIR_RootConstrainSelectedInstOperands,
     /* 236021 */     // GIR_Coverage, 11475,
     /* 236021 */     GIR_EraseRootFromParent_Done,
     /* 236022 */   // Label 4717: @236022
     /* 236022 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236064), // Rule ID 11476 //
     /* 236027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 236054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236062 */     GIR_RootConstrainSelectedInstOperands,
     /* 236063 */     // GIR_Coverage, 11476,
     /* 236063 */     GIR_EraseRootFromParent_Done,
     /* 236064 */   // Label 4718: @236064
     /* 236064 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236106), // Rule ID 11477 //
     /* 236069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 236096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236104 */     GIR_RootConstrainSelectedInstOperands,
     /* 236105 */     // GIR_Coverage, 11477,
     /* 236105 */     GIR_EraseRootFromParent_Done,
     /* 236106 */   // Label 4719: @236106
     /* 236106 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236148), // Rule ID 11478 //
     /* 236111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 236138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236146 */     GIR_RootConstrainSelectedInstOperands,
     /* 236147 */     // GIR_Coverage, 11478,
     /* 236147 */     GIR_EraseRootFromParent_Done,
     /* 236148 */   // Label 4720: @236148
     /* 236148 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236190), // Rule ID 11479 //
     /* 236153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2029:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 236180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236188 */     GIR_RootConstrainSelectedInstOperands,
     /* 236189 */     // GIR_Coverage, 11479,
     /* 236189 */     GIR_EraseRootFromParent_Done,
     /* 236190 */   // Label 4721: @236190
     /* 236190 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236232), // Rule ID 11480 //
     /* 236195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2029:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 236222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236230 */     GIR_RootConstrainSelectedInstOperands,
     /* 236231 */     // GIR_Coverage, 11480,
     /* 236231 */     GIR_EraseRootFromParent_Done,
     /* 236232 */   // Label 4722: @236232
     /* 236232 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236274), // Rule ID 11481 //
     /* 236237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2029:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 236264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236272 */     GIR_RootConstrainSelectedInstOperands,
     /* 236273 */     // GIR_Coverage, 11481,
     /* 236273 */     GIR_EraseRootFromParent_Done,
     /* 236274 */   // Label 4723: @236274
     /* 236274 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236316), // Rule ID 11482 //
     /* 236279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2029:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 236306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236314 */     GIR_RootConstrainSelectedInstOperands,
     /* 236315 */     // GIR_Coverage, 11482,
     /* 236315 */     GIR_EraseRootFromParent_Done,
     /* 236316 */   // Label 4724: @236316
     /* 236316 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236358), // Rule ID 11483 //
     /* 236321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 236348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236356 */     GIR_RootConstrainSelectedInstOperands,
     /* 236357 */     // GIR_Coverage, 11483,
     /* 236357 */     GIR_EraseRootFromParent_Done,
     /* 236358 */   // Label 4725: @236358
     /* 236358 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236400), // Rule ID 11484 //
     /* 236363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236387 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 236390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236398 */     GIR_RootConstrainSelectedInstOperands,
     /* 236399 */     // GIR_Coverage, 11484,
     /* 236399 */     GIR_EraseRootFromParent_Done,
     /* 236400 */   // Label 4726: @236400
     /* 236400 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236442), // Rule ID 11485 //
     /* 236405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 236432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236440 */     GIR_RootConstrainSelectedInstOperands,
     /* 236441 */     // GIR_Coverage, 11485,
     /* 236441 */     GIR_EraseRootFromParent_Done,
     /* 236442 */   // Label 4727: @236442
     /* 236442 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236484), // Rule ID 11486 //
     /* 236447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 236474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236482 */     GIR_RootConstrainSelectedInstOperands,
     /* 236483 */     // GIR_Coverage, 11486,
     /* 236483 */     GIR_EraseRootFromParent_Done,
     /* 236484 */   // Label 4728: @236484
     /* 236484 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236526), // Rule ID 11487 //
     /* 236489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2022:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 236516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236524 */     GIR_RootConstrainSelectedInstOperands,
     /* 236525 */     // GIR_Coverage, 11487,
     /* 236525 */     GIR_EraseRootFromParent_Done,
     /* 236526 */   // Label 4729: @236526
     /* 236526 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236568), // Rule ID 11488 //
     /* 236531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236555 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2022:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 236558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236566 */     GIR_RootConstrainSelectedInstOperands,
     /* 236567 */     // GIR_Coverage, 11488,
     /* 236567 */     GIR_EraseRootFromParent_Done,
     /* 236568 */   // Label 4730: @236568
     /* 236568 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236610), // Rule ID 11489 //
     /* 236573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2022:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 236600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236608 */     GIR_RootConstrainSelectedInstOperands,
     /* 236609 */     // GIR_Coverage, 11489,
     /* 236609 */     GIR_EraseRootFromParent_Done,
     /* 236610 */   // Label 4731: @236610
     /* 236610 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236652), // Rule ID 11490 //
     /* 236615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2022:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 236642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236650 */     GIR_RootConstrainSelectedInstOperands,
     /* 236651 */     // GIR_Coverage, 11490,
     /* 236651 */     GIR_EraseRootFromParent_Done,
     /* 236652 */   // Label 4732: @236652
     /* 236652 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236694), // Rule ID 11653 //
     /* 236657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1922:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 236684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236692 */     GIR_RootConstrainSelectedInstOperands,
     /* 236693 */     // GIR_Coverage, 11653,
     /* 236693 */     GIR_EraseRootFromParent_Done,
     /* 236694 */   // Label 4733: @236694
     /* 236694 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236736), // Rule ID 11655 //
     /* 236699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1922:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 236726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236734 */     GIR_RootConstrainSelectedInstOperands,
     /* 236735 */     // GIR_Coverage, 11655,
     /* 236735 */     GIR_EraseRootFromParent_Done,
     /* 236736 */   // Label 4734: @236736
     /* 236736 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236778), // Rule ID 11657 //
     /* 236741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1922:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 236768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236776 */     GIR_RootConstrainSelectedInstOperands,
     /* 236777 */     // GIR_Coverage, 11657,
     /* 236777 */     GIR_EraseRootFromParent_Done,
     /* 236778 */   // Label 4735: @236778
     /* 236778 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236820), // Rule ID 11659 //
     /* 236783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1922:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 236810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236818 */     GIR_RootConstrainSelectedInstOperands,
     /* 236819 */     // GIR_Coverage, 11659,
     /* 236819 */     GIR_EraseRootFromParent_Done,
     /* 236820 */   // Label 4736: @236820
     /* 236820 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(236862), // Rule ID 11661 //
     /* 236825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236849 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1674:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 236852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236860 */     GIR_RootConstrainSelectedInstOperands,
     /* 236861 */     // GIR_Coverage, 11661,
     /* 236861 */     GIR_EraseRootFromParent_Done,
     /* 236862 */   // Label 4737: @236862
     /* 236862 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(236904), // Rule ID 11662 //
     /* 236867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236891 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 236894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236902 */     GIR_RootConstrainSelectedInstOperands,
     /* 236903 */     // GIR_Coverage, 11662,
     /* 236903 */     GIR_EraseRootFromParent_Done,
     /* 236904 */   // Label 4738: @236904
     /* 236904 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(236946), // Rule ID 11663 //
     /* 236909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 236936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236944 */     GIR_RootConstrainSelectedInstOperands,
     /* 236945 */     // GIR_Coverage, 11663,
     /* 236945 */     GIR_EraseRootFromParent_Done,
     /* 236946 */   // Label 4739: @236946
     /* 236946 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(236988), // Rule ID 11664 //
     /* 236951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1923:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 236978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236986 */     GIR_RootConstrainSelectedInstOperands,
     /* 236987 */     // GIR_Coverage, 11664,
     /* 236987 */     GIR_EraseRootFromParent_Done,
     /* 236988 */   // Label 4740: @236988
     /* 236988 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237030), // Rule ID 11665 //
     /* 236993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1923:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 237020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237028 */     GIR_RootConstrainSelectedInstOperands,
     /* 237029 */     // GIR_Coverage, 11665,
     /* 237029 */     GIR_EraseRootFromParent_Done,
     /* 237030 */   // Label 4741: @237030
     /* 237030 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237072), // Rule ID 11666 //
     /* 237035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1923:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 237062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237070 */     GIR_RootConstrainSelectedInstOperands,
     /* 237071 */     // GIR_Coverage, 11666,
     /* 237071 */     GIR_EraseRootFromParent_Done,
     /* 237072 */   // Label 4742: @237072
     /* 237072 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237114), // Rule ID 11667 //
     /* 237077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 237104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237112 */     GIR_RootConstrainSelectedInstOperands,
     /* 237113 */     // GIR_Coverage, 11667,
     /* 237113 */     GIR_EraseRootFromParent_Done,
     /* 237114 */   // Label 4743: @237114
     /* 237114 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237156), // Rule ID 11668 //
     /* 237119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 237146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237154 */     GIR_RootConstrainSelectedInstOperands,
     /* 237155 */     // GIR_Coverage, 11668,
     /* 237155 */     GIR_EraseRootFromParent_Done,
     /* 237156 */   // Label 4744: @237156
     /* 237156 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237198), // Rule ID 11669 //
     /* 237161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 237188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237196 */     GIR_RootConstrainSelectedInstOperands,
     /* 237197 */     // GIR_Coverage, 11669,
     /* 237197 */     GIR_EraseRootFromParent_Done,
     /* 237198 */   // Label 4745: @237198
     /* 237198 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237240), // Rule ID 11670 //
     /* 237203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1237:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 237230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237238 */     GIR_RootConstrainSelectedInstOperands,
     /* 237239 */     // GIR_Coverage, 11670,
     /* 237239 */     GIR_EraseRootFromParent_Done,
     /* 237240 */   // Label 4746: @237240
     /* 237240 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237282), // Rule ID 11671 //
     /* 237245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1237:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 237272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237280 */     GIR_RootConstrainSelectedInstOperands,
     /* 237281 */     // GIR_Coverage, 11671,
     /* 237281 */     GIR_EraseRootFromParent_Done,
     /* 237282 */   // Label 4747: @237282
     /* 237282 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237324), // Rule ID 11672 //
     /* 237287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 237314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237322 */     GIR_RootConstrainSelectedInstOperands,
     /* 237323 */     // GIR_Coverage, 11672,
     /* 237323 */     GIR_EraseRootFromParent_Done,
     /* 237324 */   // Label 4748: @237324
     /* 237324 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237366), // Rule ID 11673 //
     /* 237329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 237356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237364 */     GIR_RootConstrainSelectedInstOperands,
     /* 237365 */     // GIR_Coverage, 11673,
     /* 237365 */     GIR_EraseRootFromParent_Done,
     /* 237366 */   // Label 4749: @237366
     /* 237366 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237408), // Rule ID 11674 //
     /* 237371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 237398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237406 */     GIR_RootConstrainSelectedInstOperands,
     /* 237407 */     // GIR_Coverage, 11674,
     /* 237407 */     GIR_EraseRootFromParent_Done,
     /* 237408 */   // Label 4750: @237408
     /* 237408 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237450), // Rule ID 11675 //
     /* 237413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 237440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237448 */     GIR_RootConstrainSelectedInstOperands,
     /* 237449 */     // GIR_Coverage, 11675,
     /* 237449 */     GIR_EraseRootFromParent_Done,
     /* 237450 */   // Label 4751: @237450
     /* 237450 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237492), // Rule ID 11730 //
     /* 237455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1655:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 237482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237490 */     GIR_RootConstrainSelectedInstOperands,
     /* 237491 */     // GIR_Coverage, 11730,
     /* 237491 */     GIR_EraseRootFromParent_Done,
     /* 237492 */   // Label 4752: @237492
     /* 237492 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237534), // Rule ID 11731 //
     /* 237497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 237524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237532 */     GIR_RootConstrainSelectedInstOperands,
     /* 237533 */     // GIR_Coverage, 11731,
     /* 237533 */     GIR_EraseRootFromParent_Done,
     /* 237534 */   // Label 4753: @237534
     /* 237534 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237576), // Rule ID 11732 //
     /* 237539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 237566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237574 */     GIR_RootConstrainSelectedInstOperands,
     /* 237575 */     // GIR_Coverage, 11732,
     /* 237575 */     GIR_EraseRootFromParent_Done,
     /* 237576 */   // Label 4754: @237576
     /* 237576 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237618), // Rule ID 11733 //
     /* 237581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1896:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 237608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237616 */     GIR_RootConstrainSelectedInstOperands,
     /* 237617 */     // GIR_Coverage, 11733,
     /* 237617 */     GIR_EraseRootFromParent_Done,
     /* 237618 */   // Label 4755: @237618
     /* 237618 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237660), // Rule ID 11734 //
     /* 237623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1896:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 237650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237658 */     GIR_RootConstrainSelectedInstOperands,
     /* 237659 */     // GIR_Coverage, 11734,
     /* 237659 */     GIR_EraseRootFromParent_Done,
     /* 237660 */   // Label 4756: @237660
     /* 237660 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237702), // Rule ID 11735 //
     /* 237665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1896:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 237692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237700 */     GIR_RootConstrainSelectedInstOperands,
     /* 237701 */     // GIR_Coverage, 11735,
     /* 237701 */     GIR_EraseRootFromParent_Done,
     /* 237702 */   // Label 4757: @237702
     /* 237702 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237744), // Rule ID 11736 //
     /* 237707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237731 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1671:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 237734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237742 */     GIR_RootConstrainSelectedInstOperands,
     /* 237743 */     // GIR_Coverage, 11736,
     /* 237743 */     GIR_EraseRootFromParent_Done,
     /* 237744 */   // Label 4758: @237744
     /* 237744 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237786), // Rule ID 11737 //
     /* 237749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1671:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 237776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237784 */     GIR_RootConstrainSelectedInstOperands,
     /* 237785 */     // GIR_Coverage, 11737,
     /* 237785 */     GIR_EraseRootFromParent_Done,
     /* 237786 */   // Label 4759: @237786
     /* 237786 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237828), // Rule ID 11738 //
     /* 237791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 237818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237826 */     GIR_RootConstrainSelectedInstOperands,
     /* 237827 */     // GIR_Coverage, 11738,
     /* 237827 */     GIR_EraseRootFromParent_Done,
     /* 237828 */   // Label 4760: @237828
     /* 237828 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237873), // Rule ID 11751 //
     /* 237833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 237860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237871 */     GIR_RootConstrainSelectedInstOperands,
     /* 237872 */     // GIR_Coverage, 11751,
     /* 237872 */     GIR_EraseRootFromParent_Done,
     /* 237873 */   // Label 4761: @237873
     /* 237873 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237918), // Rule ID 11752 //
     /* 237878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 237905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237916 */     GIR_RootConstrainSelectedInstOperands,
     /* 237917 */     // GIR_Coverage, 11752,
     /* 237917 */     GIR_EraseRootFromParent_Done,
     /* 237918 */   // Label 4762: @237918
     /* 237918 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237960), // Rule ID 11753 //
     /* 237923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1346:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 237950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237958 */     GIR_RootConstrainSelectedInstOperands,
     /* 237959 */     // GIR_Coverage, 11753,
     /* 237959 */     GIR_EraseRootFromParent_Done,
     /* 237960 */   // Label 4763: @237960
     /* 237960 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238002), // Rule ID 11754 //
     /* 237965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1346:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 237992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238000 */     GIR_RootConstrainSelectedInstOperands,
     /* 238001 */     // GIR_Coverage, 11754,
     /* 238001 */     GIR_EraseRootFromParent_Done,
     /* 238002 */   // Label 4764: @238002
     /* 238002 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238044), // Rule ID 11755 //
     /* 238007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1346:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 238034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238042 */     GIR_RootConstrainSelectedInstOperands,
     /* 238043 */     // GIR_Coverage, 11755,
     /* 238043 */     GIR_EraseRootFromParent_Done,
     /* 238044 */   // Label 4765: @238044
     /* 238044 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238086), // Rule ID 11756 //
     /* 238049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238073 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1346:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 238076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238084 */     GIR_RootConstrainSelectedInstOperands,
     /* 238085 */     // GIR_Coverage, 11756,
     /* 238085 */     GIR_EraseRootFromParent_Done,
     /* 238086 */   // Label 4766: @238086
     /* 238086 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238128), // Rule ID 11772 //
     /* 238091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238115 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 238118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238126 */     GIR_RootConstrainSelectedInstOperands,
     /* 238127 */     // GIR_Coverage, 11772,
     /* 238127 */     GIR_EraseRootFromParent_Done,
     /* 238128 */   // Label 4767: @238128
     /* 238128 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238170), // Rule ID 11773 //
     /* 238133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238157 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 238160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238168 */     GIR_RootConstrainSelectedInstOperands,
     /* 238169 */     // GIR_Coverage, 11773,
     /* 238169 */     GIR_EraseRootFromParent_Done,
     /* 238170 */   // Label 4768: @238170
     /* 238170 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238212), // Rule ID 11774 //
     /* 238175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 238202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238210 */     GIR_RootConstrainSelectedInstOperands,
     /* 238211 */     // GIR_Coverage, 11774,
     /* 238211 */     GIR_EraseRootFromParent_Done,
     /* 238212 */   // Label 4769: @238212
     /* 238212 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238254), // Rule ID 11775 //
     /* 238217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238241 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 238244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238252 */     GIR_RootConstrainSelectedInstOperands,
     /* 238253 */     // GIR_Coverage, 11775,
     /* 238253 */     GIR_EraseRootFromParent_Done,
     /* 238254 */   // Label 4770: @238254
     /* 238254 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238296), // Rule ID 11776 //
     /* 238259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238283 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 238286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238294 */     GIR_RootConstrainSelectedInstOperands,
     /* 238295 */     // GIR_Coverage, 11776,
     /* 238295 */     GIR_EraseRootFromParent_Done,
     /* 238296 */   // Label 4771: @238296
     /* 238296 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238338), // Rule ID 11777 //
     /* 238301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238325 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 238328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238336 */     GIR_RootConstrainSelectedInstOperands,
     /* 238337 */     // GIR_Coverage, 11777,
     /* 238337 */     GIR_EraseRootFromParent_Done,
     /* 238338 */   // Label 4772: @238338
     /* 238338 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238380), // Rule ID 11778 //
     /* 238343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238367 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 238370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238378 */     GIR_RootConstrainSelectedInstOperands,
     /* 238379 */     // GIR_Coverage, 11778,
     /* 238379 */     GIR_EraseRootFromParent_Done,
     /* 238380 */   // Label 4773: @238380
     /* 238380 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238422), // Rule ID 11779 //
     /* 238385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 238412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238420 */     GIR_RootConstrainSelectedInstOperands,
     /* 238421 */     // GIR_Coverage, 11779,
     /* 238421 */     GIR_EraseRootFromParent_Done,
     /* 238422 */   // Label 4774: @238422
     /* 238422 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238464), // Rule ID 11780 //
     /* 238427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 238454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238462 */     GIR_RootConstrainSelectedInstOperands,
     /* 238463 */     // GIR_Coverage, 11780,
     /* 238463 */     GIR_EraseRootFromParent_Done,
     /* 238464 */   // Label 4775: @238464
     /* 238464 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238506), // Rule ID 11781 //
     /* 238469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238493 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 238496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238504 */     GIR_RootConstrainSelectedInstOperands,
     /* 238505 */     // GIR_Coverage, 11781,
     /* 238505 */     GIR_EraseRootFromParent_Done,
     /* 238506 */   // Label 4776: @238506
     /* 238506 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238548), // Rule ID 11782 //
     /* 238511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238535 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 238538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238546 */     GIR_RootConstrainSelectedInstOperands,
     /* 238547 */     // GIR_Coverage, 11782,
     /* 238547 */     GIR_EraseRootFromParent_Done,
     /* 238548 */   // Label 4777: @238548
     /* 238548 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238590), // Rule ID 11783 //
     /* 238553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 238580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238588 */     GIR_RootConstrainSelectedInstOperands,
     /* 238589 */     // GIR_Coverage, 11783,
     /* 238589 */     GIR_EraseRootFromParent_Done,
     /* 238590 */   // Label 4778: @238590
     /* 238590 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238632), // Rule ID 11788 //
     /* 238595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 238603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238619 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 238622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238630 */     GIR_RootConstrainSelectedInstOperands,
     /* 238631 */     // GIR_Coverage, 11788,
     /* 238631 */     GIR_EraseRootFromParent_Done,
     /* 238632 */   // Label 4779: @238632
     /* 238632 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238674), // Rule ID 11789 //
     /* 238637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 238645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238661 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 238664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238672 */     GIR_RootConstrainSelectedInstOperands,
     /* 238673 */     // GIR_Coverage, 11789,
     /* 238673 */     GIR_EraseRootFromParent_Done,
     /* 238674 */   // Label 4780: @238674
     /* 238674 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238716), // Rule ID 11790 //
     /* 238679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 238687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 238706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238714 */     GIR_RootConstrainSelectedInstOperands,
     /* 238715 */     // GIR_Coverage, 11790,
     /* 238715 */     GIR_EraseRootFromParent_Done,
     /* 238716 */   // Label 4781: @238716
     /* 238716 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238758), // Rule ID 11791 //
     /* 238721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 238729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 238748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238756 */     GIR_RootConstrainSelectedInstOperands,
     /* 238757 */     // GIR_Coverage, 11791,
     /* 238757 */     GIR_EraseRootFromParent_Done,
     /* 238758 */   // Label 4782: @238758
     /* 238758 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238800), // Rule ID 11792 //
     /* 238763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238787 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1263:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238798 */     GIR_RootConstrainSelectedInstOperands,
     /* 238799 */     // GIR_Coverage, 11792,
     /* 238799 */     GIR_EraseRootFromParent_Done,
     /* 238800 */   // Label 4783: @238800
     /* 238800 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238842), // Rule ID 11794 //
     /* 238805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1263:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238840 */     GIR_RootConstrainSelectedInstOperands,
     /* 238841 */     // GIR_Coverage, 11794,
     /* 238841 */     GIR_EraseRootFromParent_Done,
     /* 238842 */   // Label 4784: @238842
     /* 238842 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238884), // Rule ID 11796 //
     /* 238847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1263:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238882 */     GIR_RootConstrainSelectedInstOperands,
     /* 238883 */     // GIR_Coverage, 11796,
     /* 238883 */     GIR_EraseRootFromParent_Done,
     /* 238884 */   // Label 4785: @238884
     /* 238884 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238926), // Rule ID 11798 //
     /* 238889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1263:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238924 */     GIR_RootConstrainSelectedInstOperands,
     /* 238925 */     // GIR_Coverage, 11798,
     /* 238925 */     GIR_EraseRootFromParent_Done,
     /* 238926 */   // Label 4786: @238926
     /* 238926 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238968), // Rule ID 11800 //
     /* 238931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238955 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1292:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238966 */     GIR_RootConstrainSelectedInstOperands,
     /* 238967 */     // GIR_Coverage, 11800,
     /* 238967 */     GIR_EraseRootFromParent_Done,
     /* 238968 */   // Label 4787: @238968
     /* 238968 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239010), // Rule ID 11802 //
     /* 238973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1292:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239008 */     GIR_RootConstrainSelectedInstOperands,
     /* 239009 */     // GIR_Coverage, 11802,
     /* 239009 */     GIR_EraseRootFromParent_Done,
     /* 239010 */   // Label 4788: @239010
     /* 239010 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239052), // Rule ID 11804 //
     /* 239015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1292:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239050 */     GIR_RootConstrainSelectedInstOperands,
     /* 239051 */     // GIR_Coverage, 11804,
     /* 239051 */     GIR_EraseRootFromParent_Done,
     /* 239052 */   // Label 4789: @239052
     /* 239052 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239094), // Rule ID 11806 //
     /* 239057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1292:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239092 */     GIR_RootConstrainSelectedInstOperands,
     /* 239093 */     // GIR_Coverage, 11806,
     /* 239093 */     GIR_EraseRootFromParent_Done,
     /* 239094 */   // Label 4790: @239094
     /* 239094 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239136), // Rule ID 11808 //
     /* 239099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1293:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239134 */     GIR_RootConstrainSelectedInstOperands,
     /* 239135 */     // GIR_Coverage, 11808,
     /* 239135 */     GIR_EraseRootFromParent_Done,
     /* 239136 */   // Label 4791: @239136
     /* 239136 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239178), // Rule ID 11809 //
     /* 239141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1293:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239176 */     GIR_RootConstrainSelectedInstOperands,
     /* 239177 */     // GIR_Coverage, 11809,
     /* 239177 */     GIR_EraseRootFromParent_Done,
     /* 239178 */   // Label 4792: @239178
     /* 239178 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239220), // Rule ID 11810 //
     /* 239183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1293:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239218 */     GIR_RootConstrainSelectedInstOperands,
     /* 239219 */     // GIR_Coverage, 11810,
     /* 239219 */     GIR_EraseRootFromParent_Done,
     /* 239220 */   // Label 4793: @239220
     /* 239220 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239262), // Rule ID 11811 //
     /* 239225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1293:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239260 */     GIR_RootConstrainSelectedInstOperands,
     /* 239261 */     // GIR_Coverage, 11811,
     /* 239261 */     GIR_EraseRootFromParent_Done,
     /* 239262 */   // Label 4794: @239262
     /* 239262 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239304), // Rule ID 11812 //
     /* 239267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1294:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239302 */     GIR_RootConstrainSelectedInstOperands,
     /* 239303 */     // GIR_Coverage, 11812,
     /* 239303 */     GIR_EraseRootFromParent_Done,
     /* 239304 */   // Label 4795: @239304
     /* 239304 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239346), // Rule ID 11813 //
     /* 239309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1294:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239344 */     GIR_RootConstrainSelectedInstOperands,
     /* 239345 */     // GIR_Coverage, 11813,
     /* 239345 */     GIR_EraseRootFromParent_Done,
     /* 239346 */   // Label 4796: @239346
     /* 239346 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239388), // Rule ID 11814 //
     /* 239351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1294:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239386 */     GIR_RootConstrainSelectedInstOperands,
     /* 239387 */     // GIR_Coverage, 11814,
     /* 239387 */     GIR_EraseRootFromParent_Done,
     /* 239388 */   // Label 4797: @239388
     /* 239388 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239430), // Rule ID 11815 //
     /* 239393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1294:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239428 */     GIR_RootConstrainSelectedInstOperands,
     /* 239429 */     // GIR_Coverage, 11815,
     /* 239429 */     GIR_EraseRootFromParent_Done,
     /* 239430 */   // Label 4798: @239430
     /* 239430 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239472), // Rule ID 11816 //
     /* 239435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239470 */     GIR_RootConstrainSelectedInstOperands,
     /* 239471 */     // GIR_Coverage, 11816,
     /* 239471 */     GIR_EraseRootFromParent_Done,
     /* 239472 */   // Label 4799: @239472
     /* 239472 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239514), // Rule ID 11818 //
     /* 239477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239512 */     GIR_RootConstrainSelectedInstOperands,
     /* 239513 */     // GIR_Coverage, 11818,
     /* 239513 */     GIR_EraseRootFromParent_Done,
     /* 239514 */   // Label 4800: @239514
     /* 239514 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239556), // Rule ID 11820 //
     /* 239519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239554 */     GIR_RootConstrainSelectedInstOperands,
     /* 239555 */     // GIR_Coverage, 11820,
     /* 239555 */     GIR_EraseRootFromParent_Done,
     /* 239556 */   // Label 4801: @239556
     /* 239556 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239598), // Rule ID 11822 //
     /* 239561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239596 */     GIR_RootConstrainSelectedInstOperands,
     /* 239597 */     // GIR_Coverage, 11822,
     /* 239597 */     GIR_EraseRootFromParent_Done,
     /* 239598 */   // Label 4802: @239598
     /* 239598 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239640), // Rule ID 11911 //
     /* 239603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 239630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239638 */     GIR_RootConstrainSelectedInstOperands,
     /* 239639 */     // GIR_Coverage, 11911,
     /* 239639 */     GIR_EraseRootFromParent_Done,
     /* 239640 */   // Label 4803: @239640
     /* 239640 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239682), // Rule ID 11913 //
     /* 239645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 239672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239680 */     GIR_RootConstrainSelectedInstOperands,
     /* 239681 */     // GIR_Coverage, 11913,
     /* 239681 */     GIR_EraseRootFromParent_Done,
     /* 239682 */   // Label 4804: @239682
     /* 239682 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239724), // Rule ID 11915 //
     /* 239687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 239714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239722 */     GIR_RootConstrainSelectedInstOperands,
     /* 239723 */     // GIR_Coverage, 11915,
     /* 239723 */     GIR_EraseRootFromParent_Done,
     /* 239724 */   // Label 4805: @239724
     /* 239724 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239766), // Rule ID 11917 //
     /* 239729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 239756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239764 */     GIR_RootConstrainSelectedInstOperands,
     /* 239765 */     // GIR_Coverage, 11917,
     /* 239765 */     GIR_EraseRootFromParent_Done,
     /* 239766 */   // Label 4806: @239766
     /* 239766 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239808), // Rule ID 11919 //
     /* 239771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 239779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239795 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1413:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 239798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239806 */     GIR_RootConstrainSelectedInstOperands,
     /* 239807 */     // GIR_Coverage, 11919,
     /* 239807 */     GIR_EraseRootFromParent_Done,
     /* 239808 */   // Label 4807: @239808
     /* 239808 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(239850), // Rule ID 11921 //
     /* 239813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 239821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1951:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 239840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239848 */     GIR_RootConstrainSelectedInstOperands,
     /* 239849 */     // GIR_Coverage, 11921,
     /* 239849 */     GIR_EraseRootFromParent_Done,
     /* 239850 */   // Label 4808: @239850
     /* 239850 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(239892), // Rule ID 12084 //
     /* 239855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 239882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239890 */     GIR_RootConstrainSelectedInstOperands,
     /* 239891 */     // GIR_Coverage, 12084,
     /* 239891 */     GIR_EraseRootFromParent_Done,
     /* 239892 */   // Label 4809: @239892
     /* 239892 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(239934), // Rule ID 12085 //
     /* 239897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 239924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239932 */     GIR_RootConstrainSelectedInstOperands,
     /* 239933 */     // GIR_Coverage, 12085,
     /* 239933 */     GIR_EraseRootFromParent_Done,
     /* 239934 */   // Label 4810: @239934
     /* 239934 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(239976), // Rule ID 12086 //
     /* 239939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 239966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239974 */     GIR_RootConstrainSelectedInstOperands,
     /* 239975 */     // GIR_Coverage, 12086,
     /* 239975 */     GIR_EraseRootFromParent_Done,
     /* 239976 */   // Label 4811: @239976
     /* 239976 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240018), // Rule ID 12087 //
     /* 239981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240016 */     GIR_RootConstrainSelectedInstOperands,
     /* 240017 */     // GIR_Coverage, 12087,
     /* 240017 */     GIR_EraseRootFromParent_Done,
     /* 240018 */   // Label 4812: @240018
     /* 240018 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240060), // Rule ID 12088 //
     /* 240023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240047 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1911:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240058 */     GIR_RootConstrainSelectedInstOperands,
     /* 240059 */     // GIR_Coverage, 12088,
     /* 240059 */     GIR_EraseRootFromParent_Done,
     /* 240060 */   // Label 4813: @240060
     /* 240060 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240102), // Rule ID 12089 //
     /* 240065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240089 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1911:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240100 */     GIR_RootConstrainSelectedInstOperands,
     /* 240101 */     // GIR_Coverage, 12089,
     /* 240101 */     GIR_EraseRootFromParent_Done,
     /* 240102 */   // Label 4814: @240102
     /* 240102 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240144), // Rule ID 12090 //
     /* 240107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240131 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1911:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240142 */     GIR_RootConstrainSelectedInstOperands,
     /* 240143 */     // GIR_Coverage, 12090,
     /* 240143 */     GIR_EraseRootFromParent_Done,
     /* 240144 */   // Label 4815: @240144
     /* 240144 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240186), // Rule ID 12435 //
     /* 240149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240173 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 240176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240184 */     GIR_RootConstrainSelectedInstOperands,
     /* 240185 */     // GIR_Coverage, 12435,
     /* 240185 */     GIR_EraseRootFromParent_Done,
     /* 240186 */   // Label 4816: @240186
     /* 240186 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240228), // Rule ID 12436 //
     /* 240191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240215 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 240218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240226 */     GIR_RootConstrainSelectedInstOperands,
     /* 240227 */     // GIR_Coverage, 12436,
     /* 240227 */     GIR_EraseRootFromParent_Done,
     /* 240228 */   // Label 4817: @240228
     /* 240228 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240270), // Rule ID 12437 //
     /* 240233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 240260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240268 */     GIR_RootConstrainSelectedInstOperands,
     /* 240269 */     // GIR_Coverage, 12437,
     /* 240269 */     GIR_EraseRootFromParent_Done,
     /* 240270 */   // Label 4818: @240270
     /* 240270 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240312), // Rule ID 12438 //
     /* 240275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240299 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 240302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240310 */     GIR_RootConstrainSelectedInstOperands,
     /* 240311 */     // GIR_Coverage, 12438,
     /* 240311 */     GIR_EraseRootFromParent_Done,
     /* 240312 */   // Label 4819: @240312
     /* 240312 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240354), // Rule ID 12439 //
     /* 240317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 240344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240352 */     GIR_RootConstrainSelectedInstOperands,
     /* 240353 */     // GIR_Coverage, 12439,
     /* 240353 */     GIR_EraseRootFromParent_Done,
     /* 240354 */   // Label 4820: @240354
     /* 240354 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240396), // Rule ID 12440 //
     /* 240359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 240386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240394 */     GIR_RootConstrainSelectedInstOperands,
     /* 240395 */     // GIR_Coverage, 12440,
     /* 240395 */     GIR_EraseRootFromParent_Done,
     /* 240396 */   // Label 4821: @240396
     /* 240396 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240438), // Rule ID 12441 //
     /* 240401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240425 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240436 */     GIR_RootConstrainSelectedInstOperands,
     /* 240437 */     // GIR_Coverage, 12441,
     /* 240437 */     GIR_EraseRootFromParent_Done,
     /* 240438 */   // Label 4822: @240438
     /* 240438 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240480), // Rule ID 12444 //
     /* 240443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240467 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240478 */     GIR_RootConstrainSelectedInstOperands,
     /* 240479 */     // GIR_Coverage, 12444,
     /* 240479 */     GIR_EraseRootFromParent_Done,
     /* 240480 */   // Label 4823: @240480
     /* 240480 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240522), // Rule ID 12447 //
     /* 240485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240509 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240520 */     GIR_RootConstrainSelectedInstOperands,
     /* 240521 */     // GIR_Coverage, 12447,
     /* 240521 */     GIR_EraseRootFromParent_Done,
     /* 240522 */   // Label 4824: @240522
     /* 240522 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240564), // Rule ID 12450 //
     /* 240527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240551 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240562 */     GIR_RootConstrainSelectedInstOperands,
     /* 240563 */     // GIR_Coverage, 12450,
     /* 240563 */     GIR_EraseRootFromParent_Done,
     /* 240564 */   // Label 4825: @240564
     /* 240564 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240606), // Rule ID 12453 //
     /* 240569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240593 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240604 */     GIR_RootConstrainSelectedInstOperands,
     /* 240605 */     // GIR_Coverage, 12453,
     /* 240605 */     GIR_EraseRootFromParent_Done,
     /* 240606 */   // Label 4826: @240606
     /* 240606 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240648), // Rule ID 12456 //
     /* 240611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 240638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240646 */     GIR_RootConstrainSelectedInstOperands,
     /* 240647 */     // GIR_Coverage, 12456,
     /* 240647 */     GIR_EraseRootFromParent_Done,
     /* 240648 */   // Label 4827: @240648
     /* 240648 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240690), // Rule ID 12459 //
     /* 240653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240677 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240688 */     GIR_RootConstrainSelectedInstOperands,
     /* 240689 */     // GIR_Coverage, 12459,
     /* 240689 */     GIR_EraseRootFromParent_Done,
     /* 240690 */   // Label 4828: @240690
     /* 240690 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(240732), // Rule ID 12462 //
     /* 240695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240719 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240730 */     GIR_RootConstrainSelectedInstOperands,
     /* 240731 */     // GIR_Coverage, 12462,
     /* 240731 */     GIR_EraseRootFromParent_Done,
     /* 240732 */   // Label 4829: @240732
     /* 240732 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(240774), // Rule ID 12465 //
     /* 240737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240761 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240772 */     GIR_RootConstrainSelectedInstOperands,
     /* 240773 */     // GIR_Coverage, 12465,
     /* 240773 */     GIR_EraseRootFromParent_Done,
     /* 240774 */   // Label 4830: @240774
     /* 240774 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(240816), // Rule ID 12468 //
     /* 240779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240814 */     GIR_RootConstrainSelectedInstOperands,
     /* 240815 */     // GIR_Coverage, 12468,
     /* 240815 */     GIR_EraseRootFromParent_Done,
     /* 240816 */   // Label 4831: @240816
     /* 240816 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(240858), // Rule ID 12471 //
     /* 240821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240845 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240856 */     GIR_RootConstrainSelectedInstOperands,
     /* 240857 */     // GIR_Coverage, 12471,
     /* 240857 */     GIR_EraseRootFromParent_Done,
     /* 240858 */   // Label 4832: @240858
     /* 240858 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(240900), // Rule ID 12474 //
     /* 240863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 240890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240898 */     GIR_RootConstrainSelectedInstOperands,
     /* 240899 */     // GIR_Coverage, 12474,
     /* 240899 */     GIR_EraseRootFromParent_Done,
     /* 240900 */   // Label 4833: @240900
     /* 240900 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241043), // Rule ID 5575 //
     /* 240905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 240919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240926 */     // MIs[0] idx
     /* 240926 */     // No operand predicates
     /* 240926 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240926 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240929 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240933 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240952 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240955 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240959 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240962 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240967 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240972 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241039 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241041 */     GIR_RootConstrainSelectedInstOperands,
     /* 241042 */     // GIR_Coverage, 5575,
     /* 241042 */     GIR_EraseRootFromParent_Done,
     /* 241043 */   // Label 4834: @241043
     /* 241043 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241134), // Rule ID 5576 //
     /* 241048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241069 */     // MIs[0] idx
     /* 241069 */     // No operand predicates
     /* 241069 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241130 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241132 */     GIR_RootConstrainSelectedInstOperands,
     /* 241133 */     // GIR_Coverage, 5576,
     /* 241133 */     GIR_EraseRootFromParent_Done,
     /* 241134 */   // Label 4835: @241134
     /* 241134 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241225), // Rule ID 5577 //
     /* 241139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241160 */     // MIs[0] idx
     /* 241160 */     // No operand predicates
     /* 241160 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241160 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241163 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241167 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241193 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241221 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241223 */     GIR_RootConstrainSelectedInstOperands,
     /* 241224 */     // GIR_Coverage, 5577,
     /* 241224 */     GIR_EraseRootFromParent_Done,
     /* 241225 */   // Label 4836: @241225
     /* 241225 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241264), // Rule ID 5578 //
     /* 241230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241251 */     // MIs[0] idx
     /* 241251 */     // No operand predicates
     /* 241251 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241260 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241262 */     GIR_RootConstrainSelectedInstOperands,
     /* 241263 */     // GIR_Coverage, 5578,
     /* 241263 */     GIR_EraseRootFromParent_Done,
     /* 241264 */   // Label 4837: @241264
     /* 241264 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241407), // Rule ID 5579 //
     /* 241269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241290 */     // MIs[0] idx
     /* 241290 */     // No operand predicates
     /* 241290 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241290 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241293 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241297 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241316 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241319 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241323 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241326 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241331 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241336 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241403 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241405 */     GIR_RootConstrainSelectedInstOperands,
     /* 241406 */     // GIR_Coverage, 5579,
     /* 241406 */     GIR_EraseRootFromParent_Done,
     /* 241407 */   // Label 4838: @241407
     /* 241407 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241498), // Rule ID 5580 //
     /* 241412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241433 */     // MIs[0] idx
     /* 241433 */     // No operand predicates
     /* 241433 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241494 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241496 */     GIR_RootConstrainSelectedInstOperands,
     /* 241497 */     // GIR_Coverage, 5580,
     /* 241497 */     GIR_EraseRootFromParent_Done,
     /* 241498 */   // Label 4839: @241498
     /* 241498 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241589), // Rule ID 5581 //
     /* 241503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241524 */     // MIs[0] idx
     /* 241524 */     // No operand predicates
     /* 241524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241557 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241585 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241587 */     GIR_RootConstrainSelectedInstOperands,
     /* 241588 */     // GIR_Coverage, 5581,
     /* 241588 */     GIR_EraseRootFromParent_Done,
     /* 241589 */   // Label 4840: @241589
     /* 241589 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241628), // Rule ID 5582 //
     /* 241594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241615 */     // MIs[0] idx
     /* 241615 */     // No operand predicates
     /* 241615 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241624 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241626 */     GIR_RootConstrainSelectedInstOperands,
     /* 241627 */     // GIR_Coverage, 5582,
     /* 241627 */     GIR_EraseRootFromParent_Done,
     /* 241628 */   // Label 4841: @241628
     /* 241628 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241771), // Rule ID 5583 //
     /* 241633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241654 */     // MIs[0] idx
     /* 241654 */     // No operand predicates
     /* 241654 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241654 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241657 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241661 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241668 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241671 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241675 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241680 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241683 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241687 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241690 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241695 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241700 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241767 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241769 */     GIR_RootConstrainSelectedInstOperands,
     /* 241770 */     // GIR_Coverage, 5583,
     /* 241770 */     GIR_EraseRootFromParent_Done,
     /* 241771 */   // Label 4842: @241771
     /* 241771 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241862), // Rule ID 5584 //
     /* 241776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241797 */     // MIs[0] idx
     /* 241797 */     // No operand predicates
     /* 241797 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241858 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241860 */     GIR_RootConstrainSelectedInstOperands,
     /* 241861 */     // GIR_Coverage, 5584,
     /* 241861 */     GIR_EraseRootFromParent_Done,
     /* 241862 */   // Label 4843: @241862
     /* 241862 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241953), // Rule ID 5585 //
     /* 241867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241888 */     // MIs[0] idx
     /* 241888 */     // No operand predicates
     /* 241888 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241949 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241951 */     GIR_RootConstrainSelectedInstOperands,
     /* 241952 */     // GIR_Coverage, 5585,
     /* 241952 */     GIR_EraseRootFromParent_Done,
     /* 241953 */   // Label 4844: @241953
     /* 241953 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241992), // Rule ID 5586 //
     /* 241958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241979 */     // MIs[0] idx
     /* 241979 */     // No operand predicates
     /* 241979 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241988 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241990 */     GIR_RootConstrainSelectedInstOperands,
     /* 241991 */     // GIR_Coverage, 5586,
     /* 241991 */     GIR_EraseRootFromParent_Done,
     /* 241992 */   // Label 4845: @241992
     /* 241992 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(242031), // Rule ID 5587 //
     /* 241997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 242005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242018 */     // MIs[0] idx
     /* 242018 */     // No operand predicates
     /* 242018 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242027 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242029 */     GIR_RootConstrainSelectedInstOperands,
     /* 242030 */     // GIR_Coverage, 5587,
     /* 242030 */     GIR_EraseRootFromParent_Done,
     /* 242031 */   // Label 4846: @242031
     /* 242031 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(242122), // Rule ID 5588 //
     /* 242036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 242044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242057 */     // MIs[0] idx
     /* 242057 */     // No operand predicates
     /* 242057 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242118 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242120 */     GIR_RootConstrainSelectedInstOperands,
     /* 242121 */     // GIR_Coverage, 5588,
     /* 242121 */     GIR_EraseRootFromParent_Done,
     /* 242122 */   // Label 4847: @242122
     /* 242122 */   GIM_Reject,
     /* 242123 */ // Label 3971: @242123
     /* 242123 */ GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(249234),
     /* 242128 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 242131 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(242178), // Rule ID 2965 //
     /* 242136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 242166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242174 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242176 */     GIR_RootConstrainSelectedInstOperands,
     /* 242177 */     // GIR_Coverage, 2965,
     /* 242177 */     GIR_EraseRootFromParent_Done,
     /* 242178 */   // Label 4849: @242178
     /* 242178 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242225), // Rule ID 2967 //
     /* 242183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 242213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242221 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242223 */     GIR_RootConstrainSelectedInstOperands,
     /* 242224 */     // GIR_Coverage, 2967,
     /* 242224 */     GIR_EraseRootFromParent_Done,
     /* 242225 */   // Label 4850: @242225
     /* 242225 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242272), // Rule ID 2969 //
     /* 242230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 242260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242268 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242270 */     GIR_RootConstrainSelectedInstOperands,
     /* 242271 */     // GIR_Coverage, 2969,
     /* 242271 */     GIR_EraseRootFromParent_Done,
     /* 242272 */   // Label 4851: @242272
     /* 242272 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242319), // Rule ID 2971 //
     /* 242277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 242307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242315 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242317 */     GIR_RootConstrainSelectedInstOperands,
     /* 242318 */     // GIR_Coverage, 2971,
     /* 242318 */     GIR_EraseRootFromParent_Done,
     /* 242319 */   // Label 4852: @242319
     /* 242319 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242366), // Rule ID 7533 //
     /* 242324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 242354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242362 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242364 */     GIR_RootConstrainSelectedInstOperands,
     /* 242365 */     // GIR_Coverage, 7533,
     /* 242365 */     GIR_EraseRootFromParent_Done,
     /* 242366 */   // Label 4853: @242366
     /* 242366 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242413), // Rule ID 7535 //
     /* 242371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 242401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242409 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242411 */     GIR_RootConstrainSelectedInstOperands,
     /* 242412 */     // GIR_Coverage, 7535,
     /* 242412 */     GIR_EraseRootFromParent_Done,
     /* 242413 */   // Label 4854: @242413
     /* 242413 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242460), // Rule ID 7537 //
     /* 242418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1598:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 242448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242456 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242458 */     GIR_RootConstrainSelectedInstOperands,
     /* 242459 */     // GIR_Coverage, 7537,
     /* 242459 */     GIR_EraseRootFromParent_Done,
     /* 242460 */   // Label 4855: @242460
     /* 242460 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242507), // Rule ID 7539 //
     /* 242465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1598:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 242495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242503 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242505 */     GIR_RootConstrainSelectedInstOperands,
     /* 242506 */     // GIR_Coverage, 7539,
     /* 242506 */     GIR_EraseRootFromParent_Done,
     /* 242507 */   // Label 4856: @242507
     /* 242507 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242587), // Rule ID 5695 //
     /* 242512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 242529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242552 */     // MIs[1] Operand 1
     /* 242552 */     // No operand predicates
     /* 242552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242568 */     // MIs[2] Operand 1
     /* 242568 */     // No operand predicates
     /* 242568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242570 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 242570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 242573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242585 */     GIR_RootConstrainSelectedInstOperands,
     /* 242586 */     // GIR_Coverage, 5695,
     /* 242586 */     GIR_EraseRootFromParent_Done,
     /* 242587 */   // Label 4857: @242587
     /* 242587 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242667), // Rule ID 5696 //
     /* 242592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 242609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242632 */     // MIs[1] Operand 1
     /* 242632 */     // No operand predicates
     /* 242632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242648 */     // MIs[2] Operand 1
     /* 242648 */     // No operand predicates
     /* 242648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242650 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 242650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 242653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242665 */     GIR_RootConstrainSelectedInstOperands,
     /* 242666 */     // GIR_Coverage, 5696,
     /* 242666 */     GIR_EraseRootFromParent_Done,
     /* 242667 */   // Label 4858: @242667
     /* 242667 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242747), // Rule ID 5697 //
     /* 242672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242712 */     // MIs[1] Operand 1
     /* 242712 */     // No operand predicates
     /* 242712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242724 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242728 */     // MIs[2] Operand 1
     /* 242728 */     // No operand predicates
     /* 242728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 242730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 242733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242745 */     GIR_RootConstrainSelectedInstOperands,
     /* 242746 */     // GIR_Coverage, 5697,
     /* 242746 */     GIR_EraseRootFromParent_Done,
     /* 242747 */   // Label 4859: @242747
     /* 242747 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242827), // Rule ID 5698 //
     /* 242752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 242760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 242763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 242769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242792 */     // MIs[1] Operand 1
     /* 242792 */     // No operand predicates
     /* 242792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242804 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242808 */     // MIs[2] Operand 1
     /* 242808 */     // No operand predicates
     /* 242808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242810 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 242810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 242813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242825 */     GIR_RootConstrainSelectedInstOperands,
     /* 242826 */     // GIR_Coverage, 5698,
     /* 242826 */     GIR_EraseRootFromParent_Done,
     /* 242827 */   // Label 4860: @242827
     /* 242827 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242891), // Rule ID 3841 //
     /* 242832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 242840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242868 */     // MIs[0] imm
     /* 242868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242876 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 242879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242887 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242889 */     GIR_RootConstrainSelectedInstOperands,
     /* 242890 */     // GIR_Coverage, 3841,
     /* 242890 */     GIR_EraseRootFromParent_Done,
     /* 242891 */   // Label 4861: @242891
     /* 242891 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242955), // Rule ID 3842 //
     /* 242896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 242904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242932 */     // MIs[0] imm
     /* 242932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 242943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242951 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242953 */     GIR_RootConstrainSelectedInstOperands,
     /* 242954 */     // GIR_Coverage, 3842,
     /* 242954 */     GIR_EraseRootFromParent_Done,
     /* 242955 */   // Label 4862: @242955
     /* 242955 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(243019), // Rule ID 3843 //
     /* 242960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 242968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242996 */     // MIs[0] imm
     /* 242996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 243007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243017 */     GIR_RootConstrainSelectedInstOperands,
     /* 243018 */     // GIR_Coverage, 3843,
     /* 243018 */     GIR_EraseRootFromParent_Done,
     /* 243019 */   // Label 4863: @243019
     /* 243019 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(243083), // Rule ID 3844 //
     /* 243024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 243032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243060 */     // MIs[0] imm
     /* 243060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 243071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243079 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243081 */     GIR_RootConstrainSelectedInstOperands,
     /* 243082 */     // GIR_Coverage, 3844,
     /* 243082 */     GIR_EraseRootFromParent_Done,
     /* 243083 */   // Label 4864: @243083
     /* 243083 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(243135), // Rule ID 2850 //
     /* 243088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243112 */     // MIs[0] idx
     /* 243112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243120 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1454:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 243123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243131 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243133 */     GIR_RootConstrainSelectedInstOperands,
     /* 243134 */     // GIR_Coverage, 2850,
     /* 243134 */     GIR_EraseRootFromParent_Done,
     /* 243135 */   // Label 4865: @243135
     /* 243135 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(243187), // Rule ID 2851 //
     /* 243140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243164 */     // MIs[0] idx
     /* 243164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243172 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1454:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 243175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243183 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243185 */     GIR_RootConstrainSelectedInstOperands,
     /* 243186 */     // GIR_Coverage, 2851,
     /* 243186 */     GIR_EraseRootFromParent_Done,
     /* 243187 */   // Label 4866: @243187
     /* 243187 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(243239), // Rule ID 2852 //
     /* 243192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243216 */     // MIs[0] idx
     /* 243216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243224 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1454:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 243227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243235 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243237 */     GIR_RootConstrainSelectedInstOperands,
     /* 243238 */     // GIR_Coverage, 2852,
     /* 243238 */     GIR_EraseRootFromParent_Done,
     /* 243239 */   // Label 4867: @243239
     /* 243239 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(243291), // Rule ID 2980 //
     /* 243244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243268 */     // MIs[0] Op4
     /* 243268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 243279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243289 */     GIR_RootConstrainSelectedInstOperands,
     /* 243290 */     // GIR_Coverage, 2980,
     /* 243290 */     GIR_EraseRootFromParent_Done,
     /* 243291 */   // Label 4868: @243291
     /* 243291 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(243343), // Rule ID 2981 //
     /* 243296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243320 */     // MIs[0] Op4
     /* 243320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 243331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243339 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243341 */     GIR_RootConstrainSelectedInstOperands,
     /* 243342 */     // GIR_Coverage, 2981,
     /* 243342 */     GIR_EraseRootFromParent_Done,
     /* 243343 */   // Label 4869: @243343
     /* 243343 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(243395), // Rule ID 2982 //
     /* 243348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243372 */     // MIs[0] Op4
     /* 243372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 243383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243393 */     GIR_RootConstrainSelectedInstOperands,
     /* 243394 */     // GIR_Coverage, 2982,
     /* 243394 */     GIR_EraseRootFromParent_Done,
     /* 243395 */   // Label 4870: @243395
     /* 243395 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243447), // Rule ID 2983 //
     /* 243400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243424 */     // MIs[0] Op4
     /* 243424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1736:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 243435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243443 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243445 */     GIR_RootConstrainSelectedInstOperands,
     /* 243446 */     // GIR_Coverage, 2983,
     /* 243446 */     GIR_EraseRootFromParent_Done,
     /* 243447 */   // Label 4871: @243447
     /* 243447 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243499), // Rule ID 2984 //
     /* 243452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243476 */     // MIs[0] Op4
     /* 243476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1736:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 243487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243495 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243497 */     GIR_RootConstrainSelectedInstOperands,
     /* 243498 */     // GIR_Coverage, 2984,
     /* 243498 */     GIR_EraseRootFromParent_Done,
     /* 243499 */   // Label 4872: @243499
     /* 243499 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243551), // Rule ID 2987 //
     /* 243504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243528 */     // MIs[0] Op4
     /* 243528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 243539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243549 */     GIR_RootConstrainSelectedInstOperands,
     /* 243550 */     // GIR_Coverage, 2987,
     /* 243550 */     GIR_EraseRootFromParent_Done,
     /* 243551 */   // Label 4873: @243551
     /* 243551 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243603), // Rule ID 2988 //
     /* 243556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243580 */     // MIs[0] Op4
     /* 243580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 243591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243601 */     GIR_RootConstrainSelectedInstOperands,
     /* 243602 */     // GIR_Coverage, 2988,
     /* 243602 */     GIR_EraseRootFromParent_Done,
     /* 243603 */   // Label 4874: @243603
     /* 243603 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243655), // Rule ID 3462 //
     /* 243608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 243616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243632 */     // MIs[0] Op4
     /* 243632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 243643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243651 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243653 */     GIR_RootConstrainSelectedInstOperands,
     /* 243654 */     // GIR_Coverage, 3462,
     /* 243654 */     GIR_EraseRootFromParent_Done,
     /* 243655 */   // Label 4875: @243655
     /* 243655 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243707), // Rule ID 3506 //
     /* 243660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 243663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 243668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243684 */     // MIs[0] Op4
     /* 243684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 243695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243703 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243705 */     GIR_RootConstrainSelectedInstOperands,
     /* 243706 */     // GIR_Coverage, 3506,
     /* 243706 */     GIR_EraseRootFromParent_Done,
     /* 243707 */   // Label 4876: @243707
     /* 243707 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243759), // Rule ID 7603 //
     /* 243712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243736 */     // MIs[0] Op4
     /* 243736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 243747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243755 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243757 */     GIR_RootConstrainSelectedInstOperands,
     /* 243758 */     // GIR_Coverage, 7603,
     /* 243758 */     GIR_EraseRootFromParent_Done,
     /* 243759 */   // Label 4877: @243759
     /* 243759 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243811), // Rule ID 7604 //
     /* 243764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243788 */     // MIs[0] Op4
     /* 243788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 243799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243809 */     GIR_RootConstrainSelectedInstOperands,
     /* 243810 */     // GIR_Coverage, 7604,
     /* 243810 */     GIR_EraseRootFromParent_Done,
     /* 243811 */   // Label 4878: @243811
     /* 243811 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243863), // Rule ID 8244 //
     /* 243816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243840 */     // MIs[0] idx
     /* 243840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243848 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 243851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243859 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243861 */     GIR_RootConstrainSelectedInstOperands,
     /* 243862 */     // GIR_Coverage, 8244,
     /* 243862 */     GIR_EraseRootFromParent_Done,
     /* 243863 */   // Label 4879: @243863
     /* 243863 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243915), // Rule ID 8245 //
     /* 243868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243892 */     // MIs[0] idx
     /* 243892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 243903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243911 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243913 */     GIR_RootConstrainSelectedInstOperands,
     /* 243914 */     // GIR_Coverage, 8245,
     /* 243914 */     GIR_EraseRootFromParent_Done,
     /* 243915 */   // Label 4880: @243915
     /* 243915 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243967), // Rule ID 8246 //
     /* 243920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243944 */     // MIs[0] idx
     /* 243944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 243955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243963 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243965 */     GIR_RootConstrainSelectedInstOperands,
     /* 243966 */     // GIR_Coverage, 8246,
     /* 243966 */     GIR_EraseRootFromParent_Done,
     /* 243967 */   // Label 4881: @243967
     /* 243967 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(244019), // Rule ID 11190 //
     /* 243972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 243980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243996 */     // MIs[0] Op4
     /* 243996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1898:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 244007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244017 */     GIR_RootConstrainSelectedInstOperands,
     /* 244018 */     // GIR_Coverage, 11190,
     /* 244018 */     GIR_EraseRootFromParent_Done,
     /* 244019 */   // Label 4882: @244019
     /* 244019 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(244071), // Rule ID 11237 //
     /* 244024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244048 */     // MIs[0] Op4
     /* 244048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 244059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244067 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244069 */     GIR_RootConstrainSelectedInstOperands,
     /* 244070 */     // GIR_Coverage, 11237,
     /* 244070 */     GIR_EraseRootFromParent_Done,
     /* 244071 */   // Label 4883: @244071
     /* 244071 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(244123), // Rule ID 11238 //
     /* 244076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244100 */     // MIs[0] Op4
     /* 244100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1597:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 244111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244119 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244121 */     GIR_RootConstrainSelectedInstOperands,
     /* 244122 */     // GIR_Coverage, 11238,
     /* 244122 */     GIR_EraseRootFromParent_Done,
     /* 244123 */   // Label 4884: @244123
     /* 244123 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(244175), // Rule ID 11239 //
     /* 244128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244152 */     // MIs[0] Op4
     /* 244152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1597:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 244163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244173 */     GIR_RootConstrainSelectedInstOperands,
     /* 244174 */     // GIR_Coverage, 11239,
     /* 244174 */     GIR_EraseRootFromParent_Done,
     /* 244175 */   // Label 4885: @244175
     /* 244175 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(244227), // Rule ID 11240 //
     /* 244180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244204 */     // MIs[0] Op4
     /* 244204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1815:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 244215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244225 */     GIR_RootConstrainSelectedInstOperands,
     /* 244226 */     // GIR_Coverage, 11240,
     /* 244226 */     GIR_EraseRootFromParent_Done,
     /* 244227 */   // Label 4886: @244227
     /* 244227 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(244279), // Rule ID 11241 //
     /* 244232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244256 */     // MIs[0] Op4
     /* 244256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1815:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 244267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244275 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244277 */     GIR_RootConstrainSelectedInstOperands,
     /* 244278 */     // GIR_Coverage, 11241,
     /* 244278 */     GIR_EraseRootFromParent_Done,
     /* 244279 */   // Label 4887: @244279
     /* 244279 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(244331), // Rule ID 11242 //
     /* 244284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244308 */     // MIs[0] Op4
     /* 244308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1815:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 244319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244329 */     GIR_RootConstrainSelectedInstOperands,
     /* 244330 */     // GIR_Coverage, 11242,
     /* 244330 */     GIR_EraseRootFromParent_Done,
     /* 244331 */   // Label 4888: @244331
     /* 244331 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(244383), // Rule ID 11243 //
     /* 244336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244360 */     // MIs[0] Op4
     /* 244360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 244371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244379 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244381 */     GIR_RootConstrainSelectedInstOperands,
     /* 244382 */     // GIR_Coverage, 11243,
     /* 244382 */     GIR_EraseRootFromParent_Done,
     /* 244383 */   // Label 4889: @244383
     /* 244383 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(244435), // Rule ID 11244 //
     /* 244388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244412 */     // MIs[0] Op4
     /* 244412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 244423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244431 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244433 */     GIR_RootConstrainSelectedInstOperands,
     /* 244434 */     // GIR_Coverage, 11244,
     /* 244434 */     GIR_EraseRootFromParent_Done,
     /* 244435 */   // Label 4890: @244435
     /* 244435 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244487), // Rule ID 11245 //
     /* 244440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244464 */     // MIs[0] Op4
     /* 244464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 244475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244483 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244485 */     GIR_RootConstrainSelectedInstOperands,
     /* 244486 */     // GIR_Coverage, 11245,
     /* 244486 */     GIR_EraseRootFromParent_Done,
     /* 244487 */   // Label 4891: @244487
     /* 244487 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244539), // Rule ID 11288 //
     /* 244492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244516 */     // MIs[0] Op4
     /* 244516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 244527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244537 */     GIR_RootConstrainSelectedInstOperands,
     /* 244538 */     // GIR_Coverage, 11288,
     /* 244538 */     GIR_EraseRootFromParent_Done,
     /* 244539 */   // Label 4892: @244539
     /* 244539 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244591), // Rule ID 11289 //
     /* 244544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244568 */     // MIs[0] Op4
     /* 244568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 244579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244589 */     GIR_RootConstrainSelectedInstOperands,
     /* 244590 */     // GIR_Coverage, 11289,
     /* 244590 */     GIR_EraseRootFromParent_Done,
     /* 244591 */   // Label 4893: @244591
     /* 244591 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244643), // Rule ID 11290 //
     /* 244596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244620 */     // MIs[0] Op4
     /* 244620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1974:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 244631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244641 */     GIR_RootConstrainSelectedInstOperands,
     /* 244642 */     // GIR_Coverage, 11290,
     /* 244642 */     GIR_EraseRootFromParent_Done,
     /* 244643 */   // Label 4894: @244643
     /* 244643 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244695), // Rule ID 11291 //
     /* 244648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244672 */     // MIs[0] Op4
     /* 244672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1974:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 244683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244691 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244693 */     GIR_RootConstrainSelectedInstOperands,
     /* 244694 */     // GIR_Coverage, 11291,
     /* 244694 */     GIR_EraseRootFromParent_Done,
     /* 244695 */   // Label 4895: @244695
     /* 244695 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244747), // Rule ID 11292 //
     /* 244700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244724 */     // MIs[0] Op4
     /* 244724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 244735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244743 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244745 */     GIR_RootConstrainSelectedInstOperands,
     /* 244746 */     // GIR_Coverage, 11292,
     /* 244746 */     GIR_EraseRootFromParent_Done,
     /* 244747 */   // Label 4896: @244747
     /* 244747 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(244799), // Rule ID 11293 //
     /* 244752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244776 */     // MIs[0] Op4
     /* 244776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 244787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244795 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244797 */     GIR_RootConstrainSelectedInstOperands,
     /* 244798 */     // GIR_Coverage, 11293,
     /* 244798 */     GIR_EraseRootFromParent_Done,
     /* 244799 */   // Label 4897: @244799
     /* 244799 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244851), // Rule ID 11294 //
     /* 244804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244828 */     // MIs[0] Op4
     /* 244828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 244839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244847 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244849 */     GIR_RootConstrainSelectedInstOperands,
     /* 244850 */     // GIR_Coverage, 11294,
     /* 244850 */     GIR_EraseRootFromParent_Done,
     /* 244851 */   // Label 4898: @244851
     /* 244851 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244903), // Rule ID 11295 //
     /* 244856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244880 */     // MIs[0] Op4
     /* 244880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 244891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244899 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244901 */     GIR_RootConstrainSelectedInstOperands,
     /* 244902 */     // GIR_Coverage, 11295,
     /* 244902 */     GIR_EraseRootFromParent_Done,
     /* 244903 */   // Label 4899: @244903
     /* 244903 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244955), // Rule ID 11296 //
     /* 244908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244932 */     // MIs[0] Op4
     /* 244932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1742:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 244943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244951 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244953 */     GIR_RootConstrainSelectedInstOperands,
     /* 244954 */     // GIR_Coverage, 11296,
     /* 244954 */     GIR_EraseRootFromParent_Done,
     /* 244955 */   // Label 4900: @244955
     /* 244955 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(245007), // Rule ID 11297 //
     /* 244960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244984 */     // MIs[0] Op4
     /* 244984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1742:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 244995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245003 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245005 */     GIR_RootConstrainSelectedInstOperands,
     /* 245006 */     // GIR_Coverage, 11297,
     /* 245006 */     GIR_EraseRootFromParent_Done,
     /* 245007 */   // Label 4901: @245007
     /* 245007 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(245059), // Rule ID 11298 //
     /* 245012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245036 */     // MIs[0] Op4
     /* 245036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 245047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245055 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245057 */     GIR_RootConstrainSelectedInstOperands,
     /* 245058 */     // GIR_Coverage, 11298,
     /* 245058 */     GIR_EraseRootFromParent_Done,
     /* 245059 */   // Label 4902: @245059
     /* 245059 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(245111), // Rule ID 11299 //
     /* 245064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245088 */     // MIs[0] Op4
     /* 245088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 245099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245107 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245109 */     GIR_RootConstrainSelectedInstOperands,
     /* 245110 */     // GIR_Coverage, 11299,
     /* 245110 */     GIR_EraseRootFromParent_Done,
     /* 245111 */   // Label 4903: @245111
     /* 245111 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245163), // Rule ID 11300 //
     /* 245116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245140 */     // MIs[0] Op4
     /* 245140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1980:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 245151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245159 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245161 */     GIR_RootConstrainSelectedInstOperands,
     /* 245162 */     // GIR_Coverage, 11300,
     /* 245162 */     GIR_EraseRootFromParent_Done,
     /* 245163 */   // Label 4904: @245163
     /* 245163 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(245215), // Rule ID 11301 //
     /* 245168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245192 */     // MIs[0] Op4
     /* 245192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1980:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 245203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245211 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245213 */     GIR_RootConstrainSelectedInstOperands,
     /* 245214 */     // GIR_Coverage, 11301,
     /* 245214 */     GIR_EraseRootFromParent_Done,
     /* 245215 */   // Label 4905: @245215
     /* 245215 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245267), // Rule ID 11323 //
     /* 245220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245244 */     // MIs[0] Op4
     /* 245244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 245255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245263 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245265 */     GIR_RootConstrainSelectedInstOperands,
     /* 245266 */     // GIR_Coverage, 11323,
     /* 245266 */     GIR_EraseRootFromParent_Done,
     /* 245267 */   // Label 4906: @245267
     /* 245267 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245319), // Rule ID 11324 //
     /* 245272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245296 */     // MIs[0] Op4
     /* 245296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 245307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245315 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245317 */     GIR_RootConstrainSelectedInstOperands,
     /* 245318 */     // GIR_Coverage, 11324,
     /* 245318 */     GIR_EraseRootFromParent_Done,
     /* 245319 */   // Label 4907: @245319
     /* 245319 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245371), // Rule ID 11325 //
     /* 245324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245348 */     // MIs[0] Op4
     /* 245348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1781:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 245359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245367 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245369 */     GIR_RootConstrainSelectedInstOperands,
     /* 245370 */     // GIR_Coverage, 11325,
     /* 245370 */     GIR_EraseRootFromParent_Done,
     /* 245371 */   // Label 4908: @245371
     /* 245371 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245423), // Rule ID 11326 //
     /* 245376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245400 */     // MIs[0] Op4
     /* 245400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1781:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 245411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245421 */     GIR_RootConstrainSelectedInstOperands,
     /* 245422 */     // GIR_Coverage, 11326,
     /* 245422 */     GIR_EraseRootFromParent_Done,
     /* 245423 */   // Label 4909: @245423
     /* 245423 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245475), // Rule ID 11327 //
     /* 245428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245452 */     // MIs[0] Op4
     /* 245452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1783:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 245463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245471 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245473 */     GIR_RootConstrainSelectedInstOperands,
     /* 245474 */     // GIR_Coverage, 11327,
     /* 245474 */     GIR_EraseRootFromParent_Done,
     /* 245475 */   // Label 4910: @245475
     /* 245475 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245527), // Rule ID 11328 //
     /* 245480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245504 */     // MIs[0] Op4
     /* 245504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1783:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 245515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245523 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245525 */     GIR_RootConstrainSelectedInstOperands,
     /* 245526 */     // GIR_Coverage, 11328,
     /* 245526 */     GIR_EraseRootFromParent_Done,
     /* 245527 */   // Label 4911: @245527
     /* 245527 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245579), // Rule ID 11329 //
     /* 245532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245556 */     // MIs[0] Op4
     /* 245556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 245567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245575 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245577 */     GIR_RootConstrainSelectedInstOperands,
     /* 245578 */     // GIR_Coverage, 11329,
     /* 245578 */     GIR_EraseRootFromParent_Done,
     /* 245579 */   // Label 4912: @245579
     /* 245579 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245631), // Rule ID 11330 //
     /* 245584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245608 */     // MIs[0] Op4
     /* 245608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 245619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245627 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245629 */     GIR_RootConstrainSelectedInstOperands,
     /* 245630 */     // GIR_Coverage, 11330,
     /* 245630 */     GIR_EraseRootFromParent_Done,
     /* 245631 */   // Label 4913: @245631
     /* 245631 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245683), // Rule ID 11784 //
     /* 245636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 245644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245660 */     // MIs[0] Op4
     /* 245660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245668 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1457:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 245671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245679 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245681 */     GIR_RootConstrainSelectedInstOperands,
     /* 245682 */     // GIR_Coverage, 11784,
     /* 245682 */     GIR_EraseRootFromParent_Done,
     /* 245683 */   // Label 4914: @245683
     /* 245683 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245735), // Rule ID 11785 //
     /* 245688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 245696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245712 */     // MIs[0] Op4
     /* 245712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245720 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 245723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245731 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245733 */     GIR_RootConstrainSelectedInstOperands,
     /* 245734 */     // GIR_Coverage, 11785,
     /* 245734 */     GIR_EraseRootFromParent_Done,
     /* 245735 */   // Label 4915: @245735
     /* 245735 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245787), // Rule ID 11786 //
     /* 245740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 245748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245764 */     // MIs[0] Op4
     /* 245764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 245775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245783 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245785 */     GIR_RootConstrainSelectedInstOperands,
     /* 245786 */     // GIR_Coverage, 11786,
     /* 245786 */     GIR_EraseRootFromParent_Done,
     /* 245787 */   // Label 4916: @245787
     /* 245787 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245839), // Rule ID 11787 //
     /* 245792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 245800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245816 */     // MIs[0] Op4
     /* 245816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 245827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245835 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245837 */     GIR_RootConstrainSelectedInstOperands,
     /* 245838 */     // GIR_Coverage, 11787,
     /* 245838 */     GIR_EraseRootFromParent_Done,
     /* 245839 */   // Label 4917: @245839
     /* 245839 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245891), // Rule ID 11920 //
     /* 245844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 245852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245868 */     // MIs[0] Op4
     /* 245868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1412:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 245879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245887 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245889 */     GIR_RootConstrainSelectedInstOperands,
     /* 245890 */     // GIR_Coverage, 11920,
     /* 245890 */     GIR_EraseRootFromParent_Done,
     /* 245891 */   // Label 4918: @245891
     /* 245891 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245943), // Rule ID 11922 //
     /* 245896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 245904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245920 */     // MIs[0] Op4
     /* 245920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 245931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245939 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245941 */     GIR_RootConstrainSelectedInstOperands,
     /* 245942 */     // GIR_Coverage, 11922,
     /* 245942 */     GIR_EraseRootFromParent_Done,
     /* 245943 */   // Label 4919: @245943
     /* 245943 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245990), // Rule ID 2829 //
     /* 245948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245986 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245988 */     GIR_RootConstrainSelectedInstOperands,
     /* 245989 */     // GIR_Coverage, 2829,
     /* 245989 */     GIR_EraseRootFromParent_Done,
     /* 245990 */   // Label 4920: @245990
     /* 245990 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246037), // Rule ID 2832 //
     /* 245995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1453:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246033 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246035 */     GIR_RootConstrainSelectedInstOperands,
     /* 246036 */     // GIR_Coverage, 2832,
     /* 246036 */     GIR_EraseRootFromParent_Done,
     /* 246037 */   // Label 4921: @246037
     /* 246037 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246084), // Rule ID 2835 //
     /* 246042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246069 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1453:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246080 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246082 */     GIR_RootConstrainSelectedInstOperands,
     /* 246083 */     // GIR_Coverage, 2835,
     /* 246083 */     GIR_EraseRootFromParent_Done,
     /* 246084 */   // Label 4922: @246084
     /* 246084 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246131), // Rule ID 2838 //
     /* 246089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246116 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246127 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246129 */     GIR_RootConstrainSelectedInstOperands,
     /* 246130 */     // GIR_Coverage, 2838,
     /* 246130 */     GIR_EraseRootFromParent_Done,
     /* 246131 */   // Label 4923: @246131
     /* 246131 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246178), // Rule ID 2841 //
     /* 246136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246163 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1453:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246174 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246176 */     GIR_RootConstrainSelectedInstOperands,
     /* 246177 */     // GIR_Coverage, 2841,
     /* 246177 */     GIR_EraseRootFromParent_Done,
     /* 246178 */   // Label 4924: @246178
     /* 246178 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246225), // Rule ID 2844 //
     /* 246183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246210 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 246213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246221 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246223 */     GIR_RootConstrainSelectedInstOperands,
     /* 246224 */     // GIR_Coverage, 2844,
     /* 246224 */     GIR_EraseRootFromParent_Done,
     /* 246225 */   // Label 4925: @246225
     /* 246225 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246272), // Rule ID 2847 //
     /* 246230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1416:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 246260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246270 */     GIR_RootConstrainSelectedInstOperands,
     /* 246271 */     // GIR_Coverage, 2847,
     /* 246271 */     GIR_EraseRootFromParent_Done,
     /* 246272 */   // Label 4926: @246272
     /* 246272 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246319), // Rule ID 2848 //
     /* 246277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1416:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 246307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246315 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246317 */     GIR_RootConstrainSelectedInstOperands,
     /* 246318 */     // GIR_Coverage, 2848,
     /* 246318 */     GIR_EraseRootFromParent_Done,
     /* 246319 */   // Label 4927: @246319
     /* 246319 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246366), // Rule ID 2849 //
     /* 246324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246351 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1416:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 246354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246362 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246364 */     GIR_RootConstrainSelectedInstOperands,
     /* 246365 */     // GIR_Coverage, 2849,
     /* 246365 */     GIR_EraseRootFromParent_Done,
     /* 246366 */   // Label 4928: @246366
     /* 246366 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246413), // Rule ID 2945 //
     /* 246371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1591:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 246401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246409 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246411 */     GIR_RootConstrainSelectedInstOperands,
     /* 246412 */     // GIR_Coverage, 2945,
     /* 246412 */     GIR_EraseRootFromParent_Done,
     /* 246413 */   // Label 4929: @246413
     /* 246413 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246460), // Rule ID 2948 //
     /* 246418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246445 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 246448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246456 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246458 */     GIR_RootConstrainSelectedInstOperands,
     /* 246459 */     // GIR_Coverage, 2948,
     /* 246459 */     GIR_EraseRootFromParent_Done,
     /* 246460 */   // Label 4930: @246460
     /* 246460 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246507), // Rule ID 2951 //
     /* 246465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 246495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246503 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246505 */     GIR_RootConstrainSelectedInstOperands,
     /* 246506 */     // GIR_Coverage, 2951,
     /* 246506 */     GIR_EraseRootFromParent_Done,
     /* 246507 */   // Label 4931: @246507
     /* 246507 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246554), // Rule ID 2954 //
     /* 246512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 246542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246550 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246552 */     GIR_RootConstrainSelectedInstOperands,
     /* 246553 */     // GIR_Coverage, 2954,
     /* 246553 */     GIR_EraseRootFromParent_Done,
     /* 246554 */   // Label 4932: @246554
     /* 246554 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246601), // Rule ID 2957 //
     /* 246559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246586 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 246589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246597 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246599 */     GIR_RootConstrainSelectedInstOperands,
     /* 246600 */     // GIR_Coverage, 2957,
     /* 246600 */     GIR_EraseRootFromParent_Done,
     /* 246601 */   // Label 4933: @246601
     /* 246601 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246648), // Rule ID 2959 //
     /* 246606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 246636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246644 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246646 */     GIR_RootConstrainSelectedInstOperands,
     /* 246647 */     // GIR_Coverage, 2959,
     /* 246647 */     GIR_EraseRootFromParent_Done,
     /* 246648 */   // Label 4934: @246648
     /* 246648 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246695), // Rule ID 2961 //
     /* 246653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 246683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246691 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246693 */     GIR_RootConstrainSelectedInstOperands,
     /* 246694 */     // GIR_Coverage, 2961,
     /* 246694 */     GIR_EraseRootFromParent_Done,
     /* 246695 */   // Label 4935: @246695
     /* 246695 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246742), // Rule ID 2963 //
     /* 246700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 246730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246738 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246740 */     GIR_RootConstrainSelectedInstOperands,
     /* 246741 */     // GIR_Coverage, 2963,
     /* 246741 */     GIR_EraseRootFromParent_Done,
     /* 246742 */   // Label 4936: @246742
     /* 246742 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246789), // Rule ID 7513 //
     /* 246747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 246777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246785 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246787 */     GIR_RootConstrainSelectedInstOperands,
     /* 246788 */     // GIR_Coverage, 7513,
     /* 246788 */     GIR_EraseRootFromParent_Done,
     /* 246789 */   // Label 4937: @246789
     /* 246789 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246836), // Rule ID 7516 //
     /* 246794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 246824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246832 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246834 */     GIR_RootConstrainSelectedInstOperands,
     /* 246835 */     // GIR_Coverage, 7516,
     /* 246835 */     GIR_EraseRootFromParent_Done,
     /* 246836 */   // Label 4938: @246836
     /* 246836 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246883), // Rule ID 7519 //
     /* 246841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 246871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246879 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246881 */     GIR_RootConstrainSelectedInstOperands,
     /* 246882 */     // GIR_Coverage, 7519,
     /* 246882 */     GIR_EraseRootFromParent_Done,
     /* 246883 */   // Label 4939: @246883
     /* 246883 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246930), // Rule ID 7522 //
     /* 246888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 246918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246926 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246928 */     GIR_RootConstrainSelectedInstOperands,
     /* 246929 */     // GIR_Coverage, 7522,
     /* 246929 */     GIR_EraseRootFromParent_Done,
     /* 246930 */   // Label 4940: @246930
     /* 246930 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246977), // Rule ID 7525 //
     /* 246935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246962 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 246965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246973 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246975 */     GIR_RootConstrainSelectedInstOperands,
     /* 246976 */     // GIR_Coverage, 7525,
     /* 246976 */     GIR_EraseRootFromParent_Done,
     /* 246977 */   // Label 4941: @246977
     /* 246977 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(247024), // Rule ID 7527 //
     /* 246982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 247012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247020 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247022 */     GIR_RootConstrainSelectedInstOperands,
     /* 247023 */     // GIR_Coverage, 7527,
     /* 247023 */     GIR_EraseRootFromParent_Done,
     /* 247024 */   // Label 4942: @247024
     /* 247024 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247071), // Rule ID 7529 //
     /* 247029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 247059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247067 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247069 */     GIR_RootConstrainSelectedInstOperands,
     /* 247070 */     // GIR_Coverage, 7529,
     /* 247070 */     GIR_EraseRootFromParent_Done,
     /* 247071 */   // Label 4943: @247071
     /* 247071 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247118), // Rule ID 7531 //
     /* 247076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1596:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 247106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247114 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247116 */     GIR_RootConstrainSelectedInstOperands,
     /* 247117 */     // GIR_Coverage, 7531,
     /* 247117 */     GIR_EraseRootFromParent_Done,
     /* 247118 */   // Label 4944: @247118
     /* 247118 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247165), // Rule ID 8157 //
     /* 247123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247150 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1460:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247163 */     GIR_RootConstrainSelectedInstOperands,
     /* 247164 */     // GIR_Coverage, 8157,
     /* 247164 */     GIR_EraseRootFromParent_Done,
     /* 247165 */   // Label 4945: @247165
     /* 247165 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247212), // Rule ID 8160 //
     /* 247170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247197 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1460:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247208 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247210 */     GIR_RootConstrainSelectedInstOperands,
     /* 247211 */     // GIR_Coverage, 8160,
     /* 247211 */     GIR_EraseRootFromParent_Done,
     /* 247212 */   // Label 4946: @247212
     /* 247212 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247259), // Rule ID 8163 //
     /* 247217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247244 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1460:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247257 */     GIR_RootConstrainSelectedInstOperands,
     /* 247258 */     // GIR_Coverage, 8163,
     /* 247258 */     GIR_EraseRootFromParent_Done,
     /* 247259 */   // Label 4947: @247259
     /* 247259 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247306), // Rule ID 8166 //
     /* 247264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247291 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1460:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247302 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247304 */     GIR_RootConstrainSelectedInstOperands,
     /* 247305 */     // GIR_Coverage, 8166,
     /* 247305 */     GIR_EraseRootFromParent_Done,
     /* 247306 */   // Label 4948: @247306
     /* 247306 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247353), // Rule ID 8169 //
     /* 247311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247338 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1460:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247349 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247351 */     GIR_RootConstrainSelectedInstOperands,
     /* 247352 */     // GIR_Coverage, 8169,
     /* 247352 */     GIR_EraseRootFromParent_Done,
     /* 247353 */   // Label 4949: @247353
     /* 247353 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247400), // Rule ID 8172 //
     /* 247358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247385 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1460:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 247388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247396 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247398 */     GIR_RootConstrainSelectedInstOperands,
     /* 247399 */     // GIR_Coverage, 8172,
     /* 247399 */     GIR_EraseRootFromParent_Done,
     /* 247400 */   // Label 4950: @247400
     /* 247400 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247447), // Rule ID 8175 //
     /* 247405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247443 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247445 */     GIR_RootConstrainSelectedInstOperands,
     /* 247446 */     // GIR_Coverage, 8175,
     /* 247446 */     GIR_EraseRootFromParent_Done,
     /* 247447 */   // Label 4951: @247447
     /* 247447 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247494), // Rule ID 8176 //
     /* 247452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247492 */     GIR_RootConstrainSelectedInstOperands,
     /* 247493 */     // GIR_Coverage, 8176,
     /* 247493 */     GIR_EraseRootFromParent_Done,
     /* 247494 */   // Label 4952: @247494
     /* 247494 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247541), // Rule ID 8177 //
     /* 247499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247526 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247537 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247539 */     GIR_RootConstrainSelectedInstOperands,
     /* 247540 */     // GIR_Coverage, 8177,
     /* 247540 */     GIR_EraseRootFromParent_Done,
     /* 247541 */   // Label 4953: @247541
     /* 247541 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247588), // Rule ID 8178 //
     /* 247546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247573 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247584 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247586 */     GIR_RootConstrainSelectedInstOperands,
     /* 247587 */     // GIR_Coverage, 8178,
     /* 247587 */     GIR_EraseRootFromParent_Done,
     /* 247588 */   // Label 4954: @247588
     /* 247588 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247635), // Rule ID 8179 //
     /* 247593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247633 */     GIR_RootConstrainSelectedInstOperands,
     /* 247634 */     // GIR_Coverage, 8179,
     /* 247634 */     GIR_EraseRootFromParent_Done,
     /* 247635 */   // Label 4955: @247635
     /* 247635 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247682), // Rule ID 8180 //
     /* 247640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247667 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 247670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247678 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247680 */     GIR_RootConstrainSelectedInstOperands,
     /* 247681 */     // GIR_Coverage, 8180,
     /* 247681 */     GIR_EraseRootFromParent_Done,
     /* 247682 */   // Label 4956: @247682
     /* 247682 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247729), // Rule ID 8181 //
     /* 247687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247714 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247725 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247727 */     GIR_RootConstrainSelectedInstOperands,
     /* 247728 */     // GIR_Coverage, 8181,
     /* 247728 */     GIR_EraseRootFromParent_Done,
     /* 247729 */   // Label 4957: @247729
     /* 247729 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247776), // Rule ID 8182 //
     /* 247734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247761 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247772 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247774 */     GIR_RootConstrainSelectedInstOperands,
     /* 247775 */     // GIR_Coverage, 8182,
     /* 247775 */     GIR_EraseRootFromParent_Done,
     /* 247776 */   // Label 4958: @247776
     /* 247776 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247823), // Rule ID 8183 //
     /* 247781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247808 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247819 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247821 */     GIR_RootConstrainSelectedInstOperands,
     /* 247822 */     // GIR_Coverage, 8183,
     /* 247822 */     GIR_EraseRootFromParent_Done,
     /* 247823 */   // Label 4959: @247823
     /* 247823 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247870), // Rule ID 8184 //
     /* 247828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247855 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247868 */     GIR_RootConstrainSelectedInstOperands,
     /* 247869 */     // GIR_Coverage, 8184,
     /* 247869 */     GIR_EraseRootFromParent_Done,
     /* 247870 */   // Label 4960: @247870
     /* 247870 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247917), // Rule ID 8185 //
     /* 247875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247915 */     GIR_RootConstrainSelectedInstOperands,
     /* 247916 */     // GIR_Coverage, 8185,
     /* 247916 */     GIR_EraseRootFromParent_Done,
     /* 247917 */   // Label 4961: @247917
     /* 247917 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247964), // Rule ID 8186 //
     /* 247922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247949 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 247952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247960 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247962 */     GIR_RootConstrainSelectedInstOperands,
     /* 247963 */     // GIR_Coverage, 8186,
     /* 247963 */     GIR_EraseRootFromParent_Done,
     /* 247964 */   // Label 4962: @247964
     /* 247964 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248011), // Rule ID 8187 //
     /* 247969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247996 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 247999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248009 */     GIR_RootConstrainSelectedInstOperands,
     /* 248010 */     // GIR_Coverage, 8187,
     /* 248010 */     GIR_EraseRootFromParent_Done,
     /* 248011 */   // Label 4963: @248011
     /* 248011 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248058), // Rule ID 8188 //
     /* 248016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248043 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 248046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248054 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248056 */     GIR_RootConstrainSelectedInstOperands,
     /* 248057 */     // GIR_Coverage, 8188,
     /* 248057 */     GIR_EraseRootFromParent_Done,
     /* 248058 */   // Label 4964: @248058
     /* 248058 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248105), // Rule ID 8189 //
     /* 248063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 248093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248101 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248103 */     GIR_RootConstrainSelectedInstOperands,
     /* 248104 */     // GIR_Coverage, 8189,
     /* 248104 */     GIR_EraseRootFromParent_Done,
     /* 248105 */   // Label 4965: @248105
     /* 248105 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248152), // Rule ID 8190 //
     /* 248110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248137 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1475:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 248140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248148 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248150 */     GIR_RootConstrainSelectedInstOperands,
     /* 248151 */     // GIR_Coverage, 8190,
     /* 248151 */     GIR_EraseRootFromParent_Done,
     /* 248152 */   // Label 4966: @248152
     /* 248152 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248199), // Rule ID 8191 //
     /* 248157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248184 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 248187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248195 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248197 */     GIR_RootConstrainSelectedInstOperands,
     /* 248198 */     // GIR_Coverage, 8191,
     /* 248198 */     GIR_EraseRootFromParent_Done,
     /* 248199 */   // Label 4967: @248199
     /* 248199 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248246), // Rule ID 8192 //
     /* 248204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 248234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248242 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248244 */     GIR_RootConstrainSelectedInstOperands,
     /* 248245 */     // GIR_Coverage, 8192,
     /* 248245 */     GIR_EraseRootFromParent_Done,
     /* 248246 */   // Label 4968: @248246
     /* 248246 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248293), // Rule ID 8193 //
     /* 248251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 248281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248291 */     GIR_RootConstrainSelectedInstOperands,
     /* 248292 */     // GIR_Coverage, 8193,
     /* 248292 */     GIR_EraseRootFromParent_Done,
     /* 248293 */   // Label 4969: @248293
     /* 248293 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248340), // Rule ID 8194 //
     /* 248298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248325 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 248328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248336 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248338 */     GIR_RootConstrainSelectedInstOperands,
     /* 248339 */     // GIR_Coverage, 8194,
     /* 248339 */     GIR_EraseRootFromParent_Done,
     /* 248340 */   // Label 4970: @248340
     /* 248340 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248387), // Rule ID 8195 //
     /* 248345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248372 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 248375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248383 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248385 */     GIR_RootConstrainSelectedInstOperands,
     /* 248386 */     // GIR_Coverage, 8195,
     /* 248386 */     GIR_EraseRootFromParent_Done,
     /* 248387 */   // Label 4971: @248387
     /* 248387 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248434), // Rule ID 8196 //
     /* 248392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248419 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248430 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248432 */     GIR_RootConstrainSelectedInstOperands,
     /* 248433 */     // GIR_Coverage, 8196,
     /* 248433 */     GIR_EraseRootFromParent_Done,
     /* 248434 */   // Label 4972: @248434
     /* 248434 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248481), // Rule ID 8199 //
     /* 248439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248466 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248477 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248479 */     GIR_RootConstrainSelectedInstOperands,
     /* 248480 */     // GIR_Coverage, 8199,
     /* 248480 */     GIR_EraseRootFromParent_Done,
     /* 248481 */   // Label 4973: @248481
     /* 248481 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248528), // Rule ID 8202 //
     /* 248486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248513 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248524 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248526 */     GIR_RootConstrainSelectedInstOperands,
     /* 248527 */     // GIR_Coverage, 8202,
     /* 248527 */     GIR_EraseRootFromParent_Done,
     /* 248528 */   // Label 4974: @248528
     /* 248528 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248575), // Rule ID 8205 //
     /* 248533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248560 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248571 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248573 */     GIR_RootConstrainSelectedInstOperands,
     /* 248574 */     // GIR_Coverage, 8205,
     /* 248574 */     GIR_EraseRootFromParent_Done,
     /* 248575 */   // Label 4975: @248575
     /* 248575 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248622), // Rule ID 8208 //
     /* 248580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248607 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248618 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248620 */     GIR_RootConstrainSelectedInstOperands,
     /* 248621 */     // GIR_Coverage, 8208,
     /* 248621 */     GIR_EraseRootFromParent_Done,
     /* 248622 */   // Label 4976: @248622
     /* 248622 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248669), // Rule ID 8211 //
     /* 248627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 248657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248665 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248667 */     GIR_RootConstrainSelectedInstOperands,
     /* 248668 */     // GIR_Coverage, 8211,
     /* 248668 */     GIR_EraseRootFromParent_Done,
     /* 248669 */   // Label 4977: @248669
     /* 248669 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248716), // Rule ID 8214 //
     /* 248674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248701 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248712 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248714 */     GIR_RootConstrainSelectedInstOperands,
     /* 248715 */     // GIR_Coverage, 8214,
     /* 248715 */     GIR_EraseRootFromParent_Done,
     /* 248716 */   // Label 4978: @248716
     /* 248716 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248763), // Rule ID 8217 //
     /* 248721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248748 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248759 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248761 */     GIR_RootConstrainSelectedInstOperands,
     /* 248762 */     // GIR_Coverage, 8217,
     /* 248762 */     GIR_EraseRootFromParent_Done,
     /* 248763 */   // Label 4979: @248763
     /* 248763 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248810), // Rule ID 8220 //
     /* 248768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248795 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248806 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248808 */     GIR_RootConstrainSelectedInstOperands,
     /* 248809 */     // GIR_Coverage, 8220,
     /* 248809 */     GIR_EraseRootFromParent_Done,
     /* 248810 */   // Label 4980: @248810
     /* 248810 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248857), // Rule ID 8223 //
     /* 248815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248842 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248853 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248855 */     GIR_RootConstrainSelectedInstOperands,
     /* 248856 */     // GIR_Coverage, 8223,
     /* 248856 */     GIR_EraseRootFromParent_Done,
     /* 248857 */   // Label 4981: @248857
     /* 248857 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248904), // Rule ID 8226 //
     /* 248862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248889 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248900 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248902 */     GIR_RootConstrainSelectedInstOperands,
     /* 248903 */     // GIR_Coverage, 8226,
     /* 248903 */     GIR_EraseRootFromParent_Done,
     /* 248904 */   // Label 4982: @248904
     /* 248904 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(248951), // Rule ID 8229 //
     /* 248909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 248939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248947 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248949 */     GIR_RootConstrainSelectedInstOperands,
     /* 248950 */     // GIR_Coverage, 8229,
     /* 248950 */     GIR_EraseRootFromParent_Done,
     /* 248951 */   // Label 4983: @248951
     /* 248951 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(248998), // Rule ID 8232 //
     /* 248956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248983 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248994 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248996 */     GIR_RootConstrainSelectedInstOperands,
     /* 248997 */     // GIR_Coverage, 8232,
     /* 248997 */     GIR_EraseRootFromParent_Done,
     /* 248998 */   // Label 4984: @248998
     /* 248998 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249045), // Rule ID 8234 //
     /* 249003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1479:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249041 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249043 */     GIR_RootConstrainSelectedInstOperands,
     /* 249044 */     // GIR_Coverage, 8234,
     /* 249044 */     GIR_EraseRootFromParent_Done,
     /* 249045 */   // Label 4985: @249045
     /* 249045 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249092), // Rule ID 8236 //
     /* 249050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249077 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1479:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249088 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249090 */     GIR_RootConstrainSelectedInstOperands,
     /* 249091 */     // GIR_Coverage, 8236,
     /* 249091 */     GIR_EraseRootFromParent_Done,
     /* 249092 */   // Label 4986: @249092
     /* 249092 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249139), // Rule ID 8238 //
     /* 249097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249137 */     GIR_RootConstrainSelectedInstOperands,
     /* 249138 */     // GIR_Coverage, 8238,
     /* 249138 */     GIR_EraseRootFromParent_Done,
     /* 249139 */   // Label 4987: @249139
     /* 249139 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249186), // Rule ID 8240 //
     /* 249144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249171 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1479:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249182 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249184 */     GIR_RootConstrainSelectedInstOperands,
     /* 249185 */     // GIR_Coverage, 8240,
     /* 249185 */     GIR_EraseRootFromParent_Done,
     /* 249186 */   // Label 4988: @249186
     /* 249186 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249233), // Rule ID 8242 //
     /* 249191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249218 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1479:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 249221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249229 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249231 */     GIR_RootConstrainSelectedInstOperands,
     /* 249232 */     // GIR_Coverage, 8242,
     /* 249232 */     GIR_EraseRootFromParent_Done,
     /* 249233 */   // Label 4989: @249233
     /* 249233 */   GIM_Reject,
     /* 249234 */ // Label 4848: @249234
     /* 249234 */ GIM_Reject,
     /* 249235 */ // Label 36: @249235
     /* 249235 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249313),
     /* 249240 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 249243 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249265), // Rule ID 78 //
     /* 249248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 249256 */     // (intrinsic_void 2158:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 249256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 249259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249263 */     GIR_RootConstrainSelectedInstOperands,
     /* 249264 */     // GIR_Coverage, 78,
     /* 249264 */     GIR_EraseRootFromParent_Done,
     /* 249265 */   // Label 4991: @249265
     /* 249265 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249290), // Rule ID 2386 //
     /* 249270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 249278 */     // (intrinsic_void 1708:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 249278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 249281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249288 */     GIR_RootConstrainSelectedInstOperands,
     /* 249289 */     // GIR_Coverage, 2386,
     /* 249289 */     GIR_EraseRootFromParent_Done,
     /* 249290 */   // Label 4992: @249290
     /* 249290 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249312), // Rule ID 7097 //
     /* 249295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 249300 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 249300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 249303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 249306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249310 */     GIR_RootConstrainSelectedInstOperands,
     /* 249311 */     // GIR_Coverage, 7097,
     /* 249311 */     GIR_EraseRootFromParent_Done,
     /* 249312 */   // Label 4993: @249312
     /* 249312 */   GIM_Reject,
     /* 249313 */ // Label 4990: @249313
     /* 249313 */ GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249913),
     /* 249318 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 249321 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249353), // Rule ID 79 //
     /* 249326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 249334 */     // MIs[0] imm
     /* 249334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 249342 */     // (intrinsic_void 2157:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 249342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 249345 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249351 */     GIR_RootConstrainSelectedInstOperands,
     /* 249352 */     // GIR_Coverage, 79,
     /* 249352 */     GIR_EraseRootFromParent_Done,
     /* 249353 */   // Label 4995: @249353
     /* 249353 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249378), // Rule ID 227 //
     /* 249358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 249363 */     // MIs[0] imm
     /* 249363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249371 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 249371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 249374 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249376 */     GIR_RootConstrainSelectedInstOperands,
     /* 249377 */     // GIR_Coverage, 227,
     /* 249377 */     GIR_EraseRootFromParent_Done,
     /* 249378 */   // Label 4996: @249378
     /* 249378 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249403), // Rule ID 228 //
     /* 249383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 249388 */     // MIs[0] imm
     /* 249388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249396 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 249396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 249399 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249401 */     GIR_RootConstrainSelectedInstOperands,
     /* 249402 */     // GIR_Coverage, 228,
     /* 249402 */     GIR_EraseRootFromParent_Done,
     /* 249403 */   // Label 4997: @249403
     /* 249403 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249435), // Rule ID 3624 //
     /* 249408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 249416 */     // MIs[0] imm
     /* 249416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 249424 */     // (intrinsic_void 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 249424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 249427 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249433 */     GIR_RootConstrainSelectedInstOperands,
     /* 249434 */     // GIR_Coverage, 3624,
     /* 249434 */     GIR_EraseRootFromParent_Done,
     /* 249435 */   // Label 4998: @249435
     /* 249435 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249475), // Rule ID 16 //
     /* 249440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 249445 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 249460 */     // MIs[1] Operand 1
     /* 249460 */     // No operand predicates
     /* 249460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249462 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 249462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 249465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 249468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249473 */     GIR_RootConstrainSelectedInstOperands,
     /* 249474 */     // GIR_Coverage, 16,
     /* 249474 */     GIR_EraseRootFromParent_Done,
     /* 249475 */   // Label 4999: @249475
     /* 249475 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249515), // Rule ID 17 //
     /* 249480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 249485 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249500 */     // MIs[1] Operand 1
     /* 249500 */     // No operand predicates
     /* 249500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249502 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 249502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 249505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249513 */     GIR_RootConstrainSelectedInstOperands,
     /* 249514 */     // GIR_Coverage, 17,
     /* 249514 */     GIR_EraseRootFromParent_Done,
     /* 249515 */   // Label 5000: @249515
     /* 249515 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249555), // Rule ID 18 //
     /* 249520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 249525 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249540 */     // MIs[1] Operand 1
     /* 249540 */     // No operand predicates
     /* 249540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249542 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 249542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 249545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249553 */     GIR_RootConstrainSelectedInstOperands,
     /* 249554 */     // GIR_Coverage, 18,
     /* 249554 */     GIR_EraseRootFromParent_Done,
     /* 249555 */   // Label 5001: @249555
     /* 249555 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249595), // Rule ID 19 //
     /* 249560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 249565 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249580 */     // MIs[1] Operand 1
     /* 249580 */     // No operand predicates
     /* 249580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249582 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 249582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 249585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249593 */     GIR_RootConstrainSelectedInstOperands,
     /* 249594 */     // GIR_Coverage, 19,
     /* 249594 */     GIR_EraseRootFromParent_Done,
     /* 249595 */   // Label 5002: @249595
     /* 249595 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249619), // Rule ID 72 //
     /* 249600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 249605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249612 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 249612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 249615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249617 */     GIR_RootConstrainSelectedInstOperands,
     /* 249618 */     // GIR_Coverage, 72,
     /* 249618 */     GIR_EraseRootFromParent_Done,
     /* 249619 */   // Label 5003: @249619
     /* 249619 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249643), // Rule ID 74 //
     /* 249624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 249629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249636 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 249636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249641 */     GIR_RootConstrainSelectedInstOperands,
     /* 249642 */     // GIR_Coverage, 74,
     /* 249642 */     GIR_EraseRootFromParent_Done,
     /* 249643 */   // Label 5004: @249643
     /* 249643 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249674), // Rule ID 77 //
     /* 249648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 249656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249663 */     // (intrinsic_w_chain:{ *:[i64] } 2159:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 249663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 249666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249672 */     GIR_RootConstrainSelectedInstOperands,
     /* 249673 */     // GIR_Coverage, 77,
     /* 249673 */     GIR_EraseRootFromParent_Done,
     /* 249674 */   // Label 5005: @249674
     /* 249674 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249701), // Rule ID 80 //
     /* 249679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 249687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249694 */     // (intrinsic_w_chain:{ *:[i64] } 2160:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 249694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 249697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249699 */     GIR_RootConstrainSelectedInstOperands,
     /* 249700 */     // GIR_Coverage, 80,
     /* 249700 */     GIR_EraseRootFromParent_Done,
     /* 249701 */   // Label 5006: @249701
     /* 249701 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(249732), // Rule ID 2385 //
     /* 249706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 249714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 249717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249721 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 249721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 249724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 249726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249730 */     GIR_RootConstrainSelectedInstOperands,
     /* 249731 */     // GIR_Coverage, 2385,
     /* 249731 */     GIR_EraseRootFromParent_Done,
     /* 249732 */   // Label 5007: @249732
     /* 249732 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(249772), // Rule ID 12706 //
     /* 249737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 249745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249752 */     // (intrinsic_w_chain:{ *:[i64] } 883:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 249752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 249755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249757 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 249770 */     GIR_RootConstrainSelectedInstOperands,
     /* 249771 */     // GIR_Coverage, 12706,
     /* 249771 */     GIR_EraseRootFromParent_Done,
     /* 249772 */   // Label 5008: @249772
     /* 249772 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(249806), // Rule ID 2387 //
     /* 249777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 249785 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 249788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249792 */     // (intrinsic_void 2138:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 249792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 249795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 249797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249804 */     GIR_RootConstrainSelectedInstOperands,
     /* 249805 */     // GIR_Coverage, 2387,
     /* 249805 */     GIR_EraseRootFromParent_Done,
     /* 249806 */   // Label 5009: @249806
     /* 249806 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(249829), // Rule ID 73 //
     /* 249811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 249816 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249819 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 249819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 249822 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 249827 */     GIR_RootConstrainSelectedInstOperands,
     /* 249828 */     // GIR_Coverage, 73,
     /* 249828 */     GIR_EraseRootFromParent_Done,
     /* 249829 */   // Label 5010: @249829
     /* 249829 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(249852), // Rule ID 75 //
     /* 249834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 249839 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249842 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 249842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 249845 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 249850 */     GIR_RootConstrainSelectedInstOperands,
     /* 249851 */     // GIR_Coverage, 75,
     /* 249851 */     GIR_EraseRootFromParent_Done,
     /* 249852 */   // Label 5011: @249852
     /* 249852 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(249879), // Rule ID 76 //
     /* 249857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 249862 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249865 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 249865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 249868 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 249873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249877 */     GIR_RootConstrainSelectedInstOperands,
     /* 249878 */     // GIR_Coverage, 76,
     /* 249878 */     GIR_EraseRootFromParent_Done,
     /* 249879 */   // Label 5012: @249879
     /* 249879 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(249912), // Rule ID 12705 //
     /* 249884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 249892 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249895 */     // (intrinsic_void 958:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 249895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 249898 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249908 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249910 */     GIR_RootConstrainSelectedInstOperands,
     /* 249911 */     // GIR_Coverage, 12705,
     /* 249911 */     GIR_EraseRootFromParent_Done,
     /* 249912 */   // Label 5013: @249912
     /* 249912 */   GIM_Reject,
     /* 249913 */ // Label 4994: @249913
     /* 249913 */ GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250884),
     /* 249918 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 249921 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(249997), // Rule ID 7063 //
     /* 249926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249938 */     // MIs[0] addr
     /* 249938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 249950 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 249957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249966 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249996 */     // GIR_Coverage, 7063,
     /* 249996 */     GIR_EraseRootFromParent_Done,
     /* 249997 */   // Label 5015: @249997
     /* 249997 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250073), // Rule ID 7064 //
     /* 250002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250014 */     // MIs[0] addr
     /* 250014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 250026 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 250033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250042 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250072 */     // GIR_Coverage, 7064,
     /* 250072 */     GIR_EraseRootFromParent_Done,
     /* 250073 */   // Label 5016: @250073
     /* 250073 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250149), // Rule ID 7065 //
     /* 250078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250090 */     // MIs[0] addr
     /* 250090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 250102 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 250109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250148 */     // GIR_Coverage, 7065,
     /* 250148 */     GIR_EraseRootFromParent_Done,
     /* 250149 */   // Label 5017: @250149
     /* 250149 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250191), // Rule ID 7066 //
     /* 250154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250166 */     // MIs[0] addr
     /* 250166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 250178 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250183 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250189 */     GIR_RootConstrainSelectedInstOperands,
     /* 250190 */     // GIR_Coverage, 7066,
     /* 250190 */     GIR_EraseRootFromParent_Done,
     /* 250191 */   // Label 5018: @250191
     /* 250191 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250267), // Rule ID 7070 //
     /* 250196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250208 */     // MIs[0] addr
     /* 250208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 250220 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 250227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250236 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250266 */     // GIR_Coverage, 7070,
     /* 250266 */     GIR_EraseRootFromParent_Done,
     /* 250267 */   // Label 5019: @250267
     /* 250267 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250343), // Rule ID 7071 //
     /* 250272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250284 */     // MIs[0] addr
     /* 250284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 250296 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 250303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250312 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250342 */     // GIR_Coverage, 7071,
     /* 250342 */     GIR_EraseRootFromParent_Done,
     /* 250343 */   // Label 5020: @250343
     /* 250343 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250419), // Rule ID 7072 //
     /* 250348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250360 */     // MIs[0] addr
     /* 250360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 250372 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 250379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250388 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250418 */     // GIR_Coverage, 7072,
     /* 250418 */     GIR_EraseRootFromParent_Done,
     /* 250419 */   // Label 5021: @250419
     /* 250419 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250461), // Rule ID 7073 //
     /* 250424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250436 */     // MIs[0] addr
     /* 250436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 250448 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 250451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250453 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250459 */     GIR_RootConstrainSelectedInstOperands,
     /* 250460 */     // GIR_Coverage, 7073,
     /* 250460 */     GIR_EraseRootFromParent_Done,
     /* 250461 */   // Label 5022: @250461
     /* 250461 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250501), // Rule ID 20 //
     /* 250466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 250469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 250474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250488 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 250488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 250491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250499 */     GIR_RootConstrainSelectedInstOperands,
     /* 250500 */     // GIR_Coverage, 20,
     /* 250500 */     GIR_EraseRootFromParent_Done,
     /* 250501 */   // Label 5023: @250501
     /* 250501 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250541), // Rule ID 2384 //
     /* 250506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 250514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 250517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250528 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1659:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 250528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 250531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 250533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250539 */     GIR_RootConstrainSelectedInstOperands,
     /* 250540 */     // GIR_Coverage, 2384,
     /* 250540 */     GIR_EraseRootFromParent_Done,
     /* 250541 */   // Label 5024: @250541
     /* 250541 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250581), // Rule ID 2495 //
     /* 250546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250568 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 250571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250579 */     GIR_RootConstrainSelectedInstOperands,
     /* 250580 */     // GIR_Coverage, 2495,
     /* 250580 */     GIR_EraseRootFromParent_Done,
     /* 250581 */   // Label 5025: @250581
     /* 250581 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250621), // Rule ID 2496 //
     /* 250586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250608 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 250611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250619 */     GIR_RootConstrainSelectedInstOperands,
     /* 250620 */     // GIR_Coverage, 2496,
     /* 250620 */     GIR_EraseRootFromParent_Done,
     /* 250621 */   // Label 5026: @250621
     /* 250621 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(250661), // Rule ID 6952 //
     /* 250626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250648 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 250651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250659 */     GIR_RootConstrainSelectedInstOperands,
     /* 250660 */     // GIR_Coverage, 6952,
     /* 250660 */     GIR_EraseRootFromParent_Done,
     /* 250661 */   // Label 5027: @250661
     /* 250661 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(250701), // Rule ID 6953 //
     /* 250666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250688 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 250691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250699 */     GIR_RootConstrainSelectedInstOperands,
     /* 250700 */     // GIR_Coverage, 6953,
     /* 250700 */     GIR_EraseRootFromParent_Done,
     /* 250701 */   // Label 5028: @250701
     /* 250701 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(250737), // Rule ID 3577 //
     /* 250706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 250714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250724 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 250727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250735 */     GIR_RootConstrainSelectedInstOperands,
     /* 250736 */     // GIR_Coverage, 3577,
     /* 250736 */     GIR_EraseRootFromParent_Done,
     /* 250737 */   // Label 5029: @250737
     /* 250737 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(250775), // Rule ID 3993 //
     /* 250742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 250745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 250750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250760 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 250760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 250763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 250771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 250773 */     GIR_RootConstrainSelectedInstOperands,
     /* 250774 */     // GIR_Coverage, 3993,
     /* 250774 */     GIR_EraseRootFromParent_Done,
     /* 250775 */   // Label 5030: @250775
     /* 250775 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(250811), // Rule ID 12431 //
     /* 250780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 250788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250798 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 250801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250809 */     GIR_RootConstrainSelectedInstOperands,
     /* 250810 */     // GIR_Coverage, 12431,
     /* 250810 */     GIR_EraseRootFromParent_Done,
     /* 250811 */   // Label 5031: @250811
     /* 250811 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(250847), // Rule ID 12432 //
     /* 250816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 250824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250834 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1489:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 250837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250845 */     GIR_RootConstrainSelectedInstOperands,
     /* 250846 */     // GIR_Coverage, 12432,
     /* 250846 */     GIR_EraseRootFromParent_Done,
     /* 250847 */   // Label 5032: @250847
     /* 250847 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(250883), // Rule ID 12433 //
     /* 250852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 250860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250870 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 250873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250881 */     GIR_RootConstrainSelectedInstOperands,
     /* 250882 */     // GIR_Coverage, 12433,
     /* 250882 */     GIR_EraseRootFromParent_Done,
     /* 250883 */   // Label 5033: @250883
     /* 250883 */   GIM_Reject,
     /* 250884 */ // Label 5014: @250884
     /* 250884 */ GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(254856),
     /* 250889 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 250892 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(250989), // Rule ID 7081 //
     /* 250897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250945 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 250956 */     // MIs[0] addr
     /* 250956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 250968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250970 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 250973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250979 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250987 */     GIR_RootConstrainSelectedInstOperands,
     /* 250988 */     // GIR_Coverage, 7081,
     /* 250988 */     GIR_EraseRootFromParent_Done,
     /* 250989 */   // Label 5035: @250989
     /* 250989 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251086), // Rule ID 7082 //
     /* 250994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251042 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251053 */     // MIs[0] addr
     /* 251053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251067 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251076 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251084 */     GIR_RootConstrainSelectedInstOperands,
     /* 251085 */     // GIR_Coverage, 7082,
     /* 251085 */     GIR_EraseRootFromParent_Done,
     /* 251086 */   // Label 5036: @251086
     /* 251086 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251183), // Rule ID 7091 //
     /* 251091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251139 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251150 */     // MIs[0] addr
     /* 251150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251164 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251173 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251181 */     GIR_RootConstrainSelectedInstOperands,
     /* 251182 */     // GIR_Coverage, 7091,
     /* 251182 */     GIR_EraseRootFromParent_Done,
     /* 251183 */   // Label 5037: @251183
     /* 251183 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251280), // Rule ID 7092 //
     /* 251188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251236 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251247 */     // MIs[0] addr
     /* 251247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251261 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251270 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251278 */     GIR_RootConstrainSelectedInstOperands,
     /* 251279 */     // GIR_Coverage, 7092,
     /* 251279 */     GIR_EraseRootFromParent_Done,
     /* 251280 */   // Label 5038: @251280
     /* 251280 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251391), // Rule ID 7084 //
     /* 251285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251321 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251332 */     // MIs[0] addr
     /* 251332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251346 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251358 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251382 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251389 */     GIR_RootConstrainSelectedInstOperands,
     /* 251390 */     // GIR_Coverage, 7084,
     /* 251390 */     GIR_EraseRootFromParent_Done,
     /* 251391 */   // Label 5039: @251391
     /* 251391 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251502), // Rule ID 7085 //
     /* 251396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251432 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251443 */     // MIs[0] addr
     /* 251443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251457 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251493 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251500 */     GIR_RootConstrainSelectedInstOperands,
     /* 251501 */     // GIR_Coverage, 7085,
     /* 251501 */     GIR_EraseRootFromParent_Done,
     /* 251502 */   // Label 5040: @251502
     /* 251502 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251613), // Rule ID 7086 //
     /* 251507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251543 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251554 */     // MIs[0] addr
     /* 251554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 251566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251568 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251580 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 251599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251604 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251611 */     GIR_RootConstrainSelectedInstOperands,
     /* 251612 */     // GIR_Coverage, 7086,
     /* 251612 */     GIR_EraseRootFromParent_Done,
     /* 251613 */   // Label 5041: @251613
     /* 251613 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251724), // Rule ID 7094 //
     /* 251618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251654 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251665 */     // MIs[0] addr
     /* 251665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251679 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251691 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251715 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251722 */     GIR_RootConstrainSelectedInstOperands,
     /* 251723 */     // GIR_Coverage, 7094,
     /* 251723 */     GIR_EraseRootFromParent_Done,
     /* 251724 */   // Label 5042: @251724
     /* 251724 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(251835), // Rule ID 7095 //
     /* 251729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251765 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251776 */     // MIs[0] addr
     /* 251776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251790 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251826 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251833 */     GIR_RootConstrainSelectedInstOperands,
     /* 251834 */     // GIR_Coverage, 7095,
     /* 251834 */     GIR_EraseRootFromParent_Done,
     /* 251835 */   // Label 5043: @251835
     /* 251835 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251946), // Rule ID 7096 //
     /* 251840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251876 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251887 */     // MIs[0] addr
     /* 251887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 251899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251901 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 251932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251937 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251944 */     GIR_RootConstrainSelectedInstOperands,
     /* 251945 */     // GIR_Coverage, 7096,
     /* 251945 */     GIR_EraseRootFromParent_Done,
     /* 251946 */   // Label 5044: @251946
     /* 251946 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251997), // Rule ID 70 //
     /* 251951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 251956 */     // MIs[0] ptr
     /* 251956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251964 */     // MIs[0] accessinfo
     /* 251964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251967 */     // MIs[0] fixed_shadow
     /* 251967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251970 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 251973 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251975 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251977 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 251982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 251985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 251988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 251991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251995 */     GIR_RootConstrainSelectedInstOperands,
     /* 251996 */     // GIR_Coverage, 70,
     /* 251996 */     GIR_EraseRootFromParent_Done,
     /* 251997 */   // Label 5045: @251997
     /* 251997 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252048), // Rule ID 71 //
     /* 252002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 252007 */     // MIs[0] ptr
     /* 252007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252015 */     // MIs[0] accessinfo
     /* 252015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252018 */     // MIs[0] fixed_shadow
     /* 252018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252021 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 252024 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252026 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252028 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252046 */     GIR_RootConstrainSelectedInstOperands,
     /* 252047 */     // GIR_Coverage, 71,
     /* 252047 */     GIR_EraseRootFromParent_Done,
     /* 252048 */   // Label 5046: @252048
     /* 252048 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252117), // Rule ID 7083 //
     /* 252053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252085 */     // MIs[0] addr
     /* 252085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252099 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252108 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252115 */     GIR_RootConstrainSelectedInstOperands,
     /* 252116 */     // GIR_Coverage, 7083,
     /* 252116 */     GIR_EraseRootFromParent_Done,
     /* 252117 */   // Label 5047: @252117
     /* 252117 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252186), // Rule ID 7093 //
     /* 252122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252154 */     // MIs[0] addr
     /* 252154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252168 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252177 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252184 */     GIR_RootConstrainSelectedInstOperands,
     /* 252185 */     // GIR_Coverage, 7093,
     /* 252185 */     GIR_EraseRootFromParent_Done,
     /* 252186 */   // Label 5048: @252186
     /* 252186 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252224), // Rule ID 3601 //
     /* 252191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252205 */     // MIs[0] tile
     /* 252205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252213 */     // (intrinsic_void 1007:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 252216 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252222 */     GIR_RootConstrainSelectedInstOperands,
     /* 252223 */     // GIR_Coverage, 3601,
     /* 252223 */     GIR_EraseRootFromParent_Done,
     /* 252224 */   // Label 5049: @252224
     /* 252224 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252262), // Rule ID 3605 //
     /* 252229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252243 */     // MIs[0] tile
     /* 252243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252251 */     // (intrinsic_void 1007:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 252254 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252260 */     GIR_RootConstrainSelectedInstOperands,
     /* 252261 */     // GIR_Coverage, 3605,
     /* 252261 */     GIR_EraseRootFromParent_Done,
     /* 252262 */   // Label 5050: @252262
     /* 252262 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252300), // Rule ID 3609 //
     /* 252267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 252275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252281 */     // MIs[0] tile
     /* 252281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252289 */     // (intrinsic_void 1011:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 252292 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252298 */     GIR_RootConstrainSelectedInstOperands,
     /* 252299 */     // GIR_Coverage, 3609,
     /* 252299 */     GIR_EraseRootFromParent_Done,
     /* 252300 */   // Label 5051: @252300
     /* 252300 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252338), // Rule ID 3779 //
     /* 252305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 252308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252319 */     // MIs[0] tile
     /* 252319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252327 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 252330 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252336 */     GIR_RootConstrainSelectedInstOperands,
     /* 252337 */     // GIR_Coverage, 3779,
     /* 252337 */     GIR_EraseRootFromParent_Done,
     /* 252338 */   // Label 5052: @252338
     /* 252338 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252376), // Rule ID 3783 //
     /* 252343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252357 */     // MIs[0] tile
     /* 252357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252365 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 252368 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252374 */     GIR_RootConstrainSelectedInstOperands,
     /* 252375 */     // GIR_Coverage, 3783,
     /* 252375 */     GIR_EraseRootFromParent_Done,
     /* 252376 */   // Label 5053: @252376
     /* 252376 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252414), // Rule ID 3787 //
     /* 252381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 252384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252395 */     // MIs[0] tile
     /* 252395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252403 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 252406 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252412 */     GIR_RootConstrainSelectedInstOperands,
     /* 252413 */     // GIR_Coverage, 3787,
     /* 252413 */     GIR_EraseRootFromParent_Done,
     /* 252414 */   // Label 5054: @252414
     /* 252414 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252452), // Rule ID 3791 //
     /* 252419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 252427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252433 */     // MIs[0] tile
     /* 252433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252441 */     // (intrinsic_void 908:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 252444 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252450 */     GIR_RootConstrainSelectedInstOperands,
     /* 252451 */     // GIR_Coverage, 3791,
     /* 252451 */     GIR_EraseRootFromParent_Done,
     /* 252452 */   // Label 5055: @252452
     /* 252452 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252490), // Rule ID 12510 //
     /* 252457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252471 */     // MIs[0] tile
     /* 252471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252479 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 252482 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252488 */     GIR_RootConstrainSelectedInstOperands,
     /* 252489 */     // GIR_Coverage, 12510,
     /* 252489 */     GIR_EraseRootFromParent_Done,
     /* 252490 */   // Label 5056: @252490
     /* 252490 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252528), // Rule ID 12514 //
     /* 252495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 252503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252509 */     // MIs[0] tile
     /* 252509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252517 */     // (intrinsic_void 1059:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 252520 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252526 */     GIR_RootConstrainSelectedInstOperands,
     /* 252527 */     // GIR_Coverage, 12514,
     /* 252527 */     GIR_EraseRootFromParent_Done,
     /* 252528 */   // Label 5057: @252528
     /* 252528 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252566), // Rule ID 12518 //
     /* 252533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 252541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252547 */     // MIs[0] tile
     /* 252547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252555 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 252558 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252564 */     GIR_RootConstrainSelectedInstOperands,
     /* 252565 */     // GIR_Coverage, 12518,
     /* 252565 */     GIR_EraseRootFromParent_Done,
     /* 252566 */   // Label 5058: @252566
     /* 252566 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252604), // Rule ID 12522 //
     /* 252571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 252579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252585 */     // MIs[0] tile
     /* 252585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252593 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 252596 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252602 */     GIR_RootConstrainSelectedInstOperands,
     /* 252603 */     // GIR_Coverage, 12522,
     /* 252603 */     GIR_EraseRootFromParent_Done,
     /* 252604 */   // Label 5059: @252604
     /* 252604 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252642), // Rule ID 12526 //
     /* 252609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 252617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252623 */     // MIs[0] tile
     /* 252623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252631 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 252634 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252640 */     GIR_RootConstrainSelectedInstOperands,
     /* 252641 */     // GIR_Coverage, 12526,
     /* 252641 */     GIR_EraseRootFromParent_Done,
     /* 252642 */   // Label 5060: @252642
     /* 252642 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252680), // Rule ID 12530 //
     /* 252647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252661 */     // MIs[0] tile
     /* 252661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252669 */     // (intrinsic_void 1142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 252672 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252678 */     GIR_RootConstrainSelectedInstOperands,
     /* 252679 */     // GIR_Coverage, 12530,
     /* 252679 */     GIR_EraseRootFromParent_Done,
     /* 252680 */   // Label 5061: @252680
     /* 252680 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252718), // Rule ID 12534 //
     /* 252685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252699 */     // MIs[0] tile
     /* 252699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252707 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 252710 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252716 */     GIR_RootConstrainSelectedInstOperands,
     /* 252717 */     // GIR_Coverage, 12534,
     /* 252717 */     GIR_EraseRootFromParent_Done,
     /* 252718 */   // Label 5062: @252718
     /* 252718 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(252756), // Rule ID 12538 //
     /* 252723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252737 */     // MIs[0] tile
     /* 252737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252745 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 252748 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252754 */     GIR_RootConstrainSelectedInstOperands,
     /* 252755 */     // GIR_Coverage, 12538,
     /* 252755 */     GIR_EraseRootFromParent_Done,
     /* 252756 */   // Label 5063: @252756
     /* 252756 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252794), // Rule ID 12542 //
     /* 252761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252775 */     // MIs[0] tile
     /* 252775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252783 */     // (intrinsic_void 1142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 252786 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252792 */     GIR_RootConstrainSelectedInstOperands,
     /* 252793 */     // GIR_Coverage, 12542,
     /* 252793 */     GIR_EraseRootFromParent_Done,
     /* 252794 */   // Label 5064: @252794
     /* 252794 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252832), // Rule ID 12546 //
     /* 252799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252813 */     // MIs[0] tile
     /* 252813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252821 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 252824 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252830 */     GIR_RootConstrainSelectedInstOperands,
     /* 252831 */     // GIR_Coverage, 12546,
     /* 252831 */     GIR_EraseRootFromParent_Done,
     /* 252832 */   // Label 5065: @252832
     /* 252832 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252870), // Rule ID 12550 //
     /* 252837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 252845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252851 */     // MIs[0] tile
     /* 252851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252859 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 252862 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252868 */     GIR_RootConstrainSelectedInstOperands,
     /* 252869 */     // GIR_Coverage, 12550,
     /* 252869 */     GIR_EraseRootFromParent_Done,
     /* 252870 */   // Label 5066: @252870
     /* 252870 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252908), // Rule ID 12554 //
     /* 252875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 252883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252889 */     // MIs[0] tile
     /* 252889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252897 */     // (intrinsic_void 1063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 252900 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252906 */     GIR_RootConstrainSelectedInstOperands,
     /* 252907 */     // GIR_Coverage, 12554,
     /* 252907 */     GIR_EraseRootFromParent_Done,
     /* 252908 */   // Label 5067: @252908
     /* 252908 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(252946), // Rule ID 12558 //
     /* 252913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 252921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252927 */     // MIs[0] tile
     /* 252927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252935 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 252938 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252944 */     GIR_RootConstrainSelectedInstOperands,
     /* 252945 */     // GIR_Coverage, 12558,
     /* 252945 */     GIR_EraseRootFromParent_Done,
     /* 252946 */   // Label 5068: @252946
     /* 252946 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(252984), // Rule ID 12562 //
     /* 252951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 252959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252965 */     // MIs[0] tile
     /* 252965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252973 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 252976 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252982 */     GIR_RootConstrainSelectedInstOperands,
     /* 252983 */     // GIR_Coverage, 12562,
     /* 252983 */     GIR_EraseRootFromParent_Done,
     /* 252984 */   // Label 5069: @252984
     /* 252984 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253022), // Rule ID 12566 //
     /* 252989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 252997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253003 */     // MIs[0] tile
     /* 253003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253011 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 253014 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253020 */     GIR_RootConstrainSelectedInstOperands,
     /* 253021 */     // GIR_Coverage, 12566,
     /* 253021 */     GIR_EraseRootFromParent_Done,
     /* 253022 */   // Label 5070: @253022
     /* 253022 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253060), // Rule ID 12570 //
     /* 253027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 253035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253041 */     // MIs[0] tile
     /* 253041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253049 */     // (intrinsic_void 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 253052 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253058 */     GIR_RootConstrainSelectedInstOperands,
     /* 253059 */     // GIR_Coverage, 12570,
     /* 253059 */     GIR_EraseRootFromParent_Done,
     /* 253060 */   // Label 5071: @253060
     /* 253060 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253098), // Rule ID 12574 //
     /* 253065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 253073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253079 */     // MIs[0] tile
     /* 253079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253087 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 253090 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253096 */     GIR_RootConstrainSelectedInstOperands,
     /* 253097 */     // GIR_Coverage, 12574,
     /* 253097 */     GIR_EraseRootFromParent_Done,
     /* 253098 */   // Label 5072: @253098
     /* 253098 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253136), // Rule ID 13029 //
     /* 253103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 253111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253117 */     // MIs[0] tile
     /* 253117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253125 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 253128 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253134 */     GIR_RootConstrainSelectedInstOperands,
     /* 253135 */     // GIR_Coverage, 13029,
     /* 253135 */     GIR_EraseRootFromParent_Done,
     /* 253136 */   // Label 5073: @253136
     /* 253136 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253174), // Rule ID 13033 //
     /* 253141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253155 */     // MIs[0] tile
     /* 253155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253163 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 253166 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253172 */     GIR_RootConstrainSelectedInstOperands,
     /* 253173 */     // GIR_Coverage, 13033,
     /* 253173 */     GIR_EraseRootFromParent_Done,
     /* 253174 */   // Label 5074: @253174
     /* 253174 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(253212), // Rule ID 13037 //
     /* 253179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 253182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253193 */     // MIs[0] tile
     /* 253193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253201 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 253204 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253210 */     GIR_RootConstrainSelectedInstOperands,
     /* 253211 */     // GIR_Coverage, 13037,
     /* 253211 */     GIR_EraseRootFromParent_Done,
     /* 253212 */   // Label 5075: @253212
     /* 253212 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253250), // Rule ID 13041 //
     /* 253217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 253220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253231 */     // MIs[0] tile
     /* 253231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253239 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 253242 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253248 */     GIR_RootConstrainSelectedInstOperands,
     /* 253249 */     // GIR_Coverage, 13041,
     /* 253249 */     GIR_EraseRootFromParent_Done,
     /* 253250 */   // Label 5076: @253250
     /* 253250 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253304), // Rule ID 8796 //
     /* 253255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253263 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 253266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253270 */     // MIs[0] base
     /* 253270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253278 */     // MIs[0] prfop
     /* 253278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253286 */     // (intrinsic_void 1626:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 253289 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253291 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253293 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253302 */     GIR_RootConstrainSelectedInstOperands,
     /* 253303 */     // GIR_Coverage, 8796,
     /* 253303 */     GIR_EraseRootFromParent_Done,
     /* 253304 */   // Label 5077: @253304
     /* 253304 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253358), // Rule ID 8799 //
     /* 253309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253317 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 253320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253324 */     // MIs[0] base
     /* 253324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253332 */     // MIs[0] prfop
     /* 253332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253340 */     // (intrinsic_void 1626:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 253343 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253345 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253347 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253356 */     GIR_RootConstrainSelectedInstOperands,
     /* 253357 */     // GIR_Coverage, 8799,
     /* 253357 */     GIR_EraseRootFromParent_Done,
     /* 253358 */   // Label 5078: @253358
     /* 253358 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253412), // Rule ID 8802 //
     /* 253363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253371 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 253374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253378 */     // MIs[0] base
     /* 253378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253386 */     // MIs[0] prfop
     /* 253386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253394 */     // (intrinsic_void 1626:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 253397 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253399 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253401 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253410 */     GIR_RootConstrainSelectedInstOperands,
     /* 253411 */     // GIR_Coverage, 8802,
     /* 253411 */     GIR_EraseRootFromParent_Done,
     /* 253412 */   // Label 5079: @253412
     /* 253412 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253466), // Rule ID 8805 //
     /* 253417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253425 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 253428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253432 */     // MIs[0] base
     /* 253432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253440 */     // MIs[0] prfop
     /* 253440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253448 */     // (intrinsic_void 1626:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 253451 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253453 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253455 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253464 */     GIR_RootConstrainSelectedInstOperands,
     /* 253465 */     // GIR_Coverage, 8805,
     /* 253465 */     GIR_EraseRootFromParent_Done,
     /* 253466 */   // Label 5080: @253466
     /* 253466 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253520), // Rule ID 15 //
     /* 253471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 253476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 253485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 253497 */     // MIs[1] Operand 1
     /* 253497 */     // No operand predicates
     /* 253497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253503 */     // (intrinsic_w_chain:{ *:[i64] } 1224:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 253503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 253506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 253511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253518 */     GIR_RootConstrainSelectedInstOperands,
     /* 253519 */     // GIR_Coverage, 15,
     /* 253519 */     GIR_EraseRootFromParent_Done,
     /* 253520 */   // Label 5081: @253520
     /* 253520 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253588), // Rule ID 68 //
     /* 253525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 253530 */     // MIs[0] Operand 1
     /* 253530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 253538 */     // MIs[0] ptr
     /* 253538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253546 */     // MIs[0] accessinfo
     /* 253546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253549 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253553 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 253563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 253566 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253568 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253586 */     GIR_RootConstrainSelectedInstOperands,
     /* 253587 */     // GIR_Coverage, 68,
     /* 253587 */     GIR_EraseRootFromParent_Done,
     /* 253588 */   // Label 5082: @253588
     /* 253588 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253656), // Rule ID 69 //
     /* 253593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 253598 */     // MIs[0] Operand 1
     /* 253598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 253606 */     // MIs[0] ptr
     /* 253606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253614 */     // MIs[0] accessinfo
     /* 253614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253617 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253621 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 253631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 253634 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253636 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253654 */     GIR_RootConstrainSelectedInstOperands,
     /* 253655 */     // GIR_Coverage, 69,
     /* 253655 */     GIR_EraseRootFromParent_Done,
     /* 253656 */   // Label 5083: @253656
     /* 253656 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253736), // Rule ID 7077 //
     /* 253661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253680 */     // MIs[0] addr
     /* 253680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253692 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253704 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253728 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253734 */     GIR_RootConstrainSelectedInstOperands,
     /* 253735 */     // GIR_Coverage, 7077,
     /* 253735 */     GIR_EraseRootFromParent_Done,
     /* 253736 */   // Label 5084: @253736
     /* 253736 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253816), // Rule ID 7078 //
     /* 253741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253760 */     // MIs[0] addr
     /* 253760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253772 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253784 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253808 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253814 */     GIR_RootConstrainSelectedInstOperands,
     /* 253815 */     // GIR_Coverage, 7078,
     /* 253815 */     GIR_EraseRootFromParent_Done,
     /* 253816 */   // Label 5085: @253816
     /* 253816 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253896), // Rule ID 7079 //
     /* 253821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253840 */     // MIs[0] addr
     /* 253840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 253852 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253864 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 253883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253888 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253894 */     GIR_RootConstrainSelectedInstOperands,
     /* 253895 */     // GIR_Coverage, 7079,
     /* 253895 */     GIR_EraseRootFromParent_Done,
     /* 253896 */   // Label 5086: @253896
     /* 253896 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253947), // Rule ID 7080 //
     /* 253901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253920 */     // MIs[0] addr
     /* 253920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 253932 */     // (intrinsic_w_chain:{ *:[i32] } 1233:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 253935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253937 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 253939 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253945 */     GIR_RootConstrainSelectedInstOperands,
     /* 253946 */     // GIR_Coverage, 7080,
     /* 253946 */     GIR_EraseRootFromParent_Done,
     /* 253947 */   // Label 5087: @253947
     /* 253947 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254027), // Rule ID 7087 //
     /* 253952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253971 */     // MIs[0] addr
     /* 253971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 253983 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 254014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254019 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254025 */     GIR_RootConstrainSelectedInstOperands,
     /* 254026 */     // GIR_Coverage, 7087,
     /* 254026 */     GIR_EraseRootFromParent_Done,
     /* 254027 */   // Label 5088: @254027
     /* 254027 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254107), // Rule ID 7088 //
     /* 254032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254051 */     // MIs[0] addr
     /* 254051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254063 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254075 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254099 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254105 */     GIR_RootConstrainSelectedInstOperands,
     /* 254106 */     // GIR_Coverage, 7088,
     /* 254106 */     GIR_EraseRootFromParent_Done,
     /* 254107 */   // Label 5089: @254107
     /* 254107 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254187), // Rule ID 7089 //
     /* 254112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254131 */     // MIs[0] addr
     /* 254131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254143 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254155 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254179 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254185 */     GIR_RootConstrainSelectedInstOperands,
     /* 254186 */     // GIR_Coverage, 7089,
     /* 254186 */     GIR_EraseRootFromParent_Done,
     /* 254187 */   // Label 5090: @254187
     /* 254187 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254238), // Rule ID 7090 //
     /* 254192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254211 */     // MIs[0] addr
     /* 254211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 254223 */     // (intrinsic_w_chain:{ *:[i32] } 1231:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 254226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254228 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254230 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254236 */     GIR_RootConstrainSelectedInstOperands,
     /* 254237 */     // GIR_Coverage, 7090,
     /* 254237 */     GIR_EraseRootFromParent_Done,
     /* 254238 */   // Label 5091: @254238
     /* 254238 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254287), // Rule ID 2488 //
     /* 254243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254272 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 254272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 254275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254285 */     GIR_RootConstrainSelectedInstOperands,
     /* 254286 */     // GIR_Coverage, 2488,
     /* 254286 */     GIR_EraseRootFromParent_Done,
     /* 254287 */   // Label 5092: @254287
     /* 254287 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254336), // Rule ID 2489 //
     /* 254292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 254303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254321 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 254321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 254324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254334 */     GIR_RootConstrainSelectedInstOperands,
     /* 254335 */     // GIR_Coverage, 2489,
     /* 254335 */     GIR_EraseRootFromParent_Done,
     /* 254336 */   // Label 5093: @254336
     /* 254336 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254385), // Rule ID 2490 //
     /* 254341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 254358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254370 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 254370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 254373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254383 */     GIR_RootConstrainSelectedInstOperands,
     /* 254384 */     // GIR_Coverage, 2490,
     /* 254384 */     GIR_EraseRootFromParent_Done,
     /* 254385 */   // Label 5094: @254385
     /* 254385 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254438), // Rule ID 8682 //
     /* 254390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254412 */     // MIs[0] base
     /* 254412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254420 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1559:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254427 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254436 */     GIR_RootConstrainSelectedInstOperands,
     /* 254437 */     // GIR_Coverage, 8682,
     /* 254437 */     GIR_EraseRootFromParent_Done,
     /* 254438 */   // Label 5095: @254438
     /* 254438 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254491), // Rule ID 8685 //
     /* 254443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254465 */     // MIs[0] base
     /* 254465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254473 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1559:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254480 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254489 */     GIR_RootConstrainSelectedInstOperands,
     /* 254490 */     // GIR_Coverage, 8685,
     /* 254490 */     GIR_EraseRootFromParent_Done,
     /* 254491 */   // Label 5096: @254491
     /* 254491 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254544), // Rule ID 8694 //
     /* 254496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254518 */     // MIs[0] base
     /* 254518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254526 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1558:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254533 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254542 */     GIR_RootConstrainSelectedInstOperands,
     /* 254543 */     // GIR_Coverage, 8694,
     /* 254543 */     GIR_EraseRootFromParent_Done,
     /* 254544 */   // Label 5097: @254544
     /* 254544 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254597), // Rule ID 8697 //
     /* 254549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254571 */     // MIs[0] base
     /* 254571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254579 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1558:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254586 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254595 */     GIR_RootConstrainSelectedInstOperands,
     /* 254596 */     // GIR_Coverage, 8697,
     /* 254596 */     GIR_EraseRootFromParent_Done,
     /* 254597 */   // Label 5098: @254597
     /* 254597 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254643), // Rule ID 137 //
     /* 254602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 254605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 254610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 254613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254620 */     // MIs[0] Rn
     /* 254620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254632 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 254632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 254635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254641 */     GIR_RootConstrainSelectedInstOperands,
     /* 254642 */     // GIR_Coverage, 137,
     /* 254642 */     GIR_EraseRootFromParent_Done,
     /* 254643 */   // Label 5099: @254643
     /* 254643 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254696), // Rule ID 8688 //
     /* 254648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254656 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254670 */     // MIs[0] base
     /* 254670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254678 */     // (intrinsic_void 1879:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254685 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254694 */     GIR_RootConstrainSelectedInstOperands,
     /* 254695 */     // GIR_Coverage, 8688,
     /* 254695 */     GIR_EraseRootFromParent_Done,
     /* 254696 */   // Label 5100: @254696
     /* 254696 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254749), // Rule ID 8691 //
     /* 254701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254709 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254723 */     // MIs[0] base
     /* 254723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254731 */     // (intrinsic_void 1879:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254738 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254747 */     GIR_RootConstrainSelectedInstOperands,
     /* 254748 */     // GIR_Coverage, 8691,
     /* 254748 */     GIR_EraseRootFromParent_Done,
     /* 254749 */   // Label 5101: @254749
     /* 254749 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254802), // Rule ID 8700 //
     /* 254754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254762 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254776 */     // MIs[0] base
     /* 254776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254784 */     // (intrinsic_void 1875:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254791 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254800 */     GIR_RootConstrainSelectedInstOperands,
     /* 254801 */     // GIR_Coverage, 8700,
     /* 254801 */     GIR_EraseRootFromParent_Done,
     /* 254802 */   // Label 5102: @254802
     /* 254802 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254855), // Rule ID 8703 //
     /* 254807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254815 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254829 */     // MIs[0] base
     /* 254829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254837 */     // (intrinsic_void 1875:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254844 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254853 */     GIR_RootConstrainSelectedInstOperands,
     /* 254854 */     // GIR_Coverage, 8703,
     /* 254854 */     GIR_EraseRootFromParent_Done,
     /* 254855 */   // Label 5103: @254855
     /* 254855 */   GIM_Reject,
     /* 254856 */ // Label 5034: @254856
     /* 254856 */ GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(257561),
     /* 254861 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 254864 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254935), // Rule ID 3413 //
     /* 254869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254877 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254906 */     // MIs[1] Operand 1
     /* 254906 */     // No operand predicates
     /* 254906 */     // MIs[0] prfop
     /* 254906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254916 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 254919 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254933 */     GIR_RootConstrainSelectedInstOperands,
     /* 254934 */     // GIR_Coverage, 3413,
     /* 254934 */     GIR_EraseRootFromParent_Done,
     /* 254935 */   // Label 5105: @254935
     /* 254935 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(255006), // Rule ID 3426 //
     /* 254940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254948 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254977 */     // MIs[1] Operand 1
     /* 254977 */     // No operand predicates
     /* 254977 */     // MIs[0] prfop
     /* 254977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254987 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 254990 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255004 */     GIR_RootConstrainSelectedInstOperands,
     /* 255005 */     // GIR_Coverage, 3426,
     /* 255005 */     GIR_EraseRootFromParent_Done,
     /* 255006 */   // Label 5106: @255006
     /* 255006 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(255065), // Rule ID 3613 //
     /* 255011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255028 */     // MIs[0] tile
     /* 255028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255048 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 255051 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255053 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255055 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255057 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255063 */     GIR_RootConstrainSelectedInstOperands,
     /* 255064 */     // GIR_Coverage, 3613,
     /* 255064 */     GIR_EraseRootFromParent_Done,
     /* 255065 */   // Label 5107: @255065
     /* 255065 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255124), // Rule ID 3614 //
     /* 255070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255087 */     // MIs[0] tile
     /* 255087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255107 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 255110 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255112 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255114 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255116 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255122 */     GIR_RootConstrainSelectedInstOperands,
     /* 255123 */     // GIR_Coverage, 3614,
     /* 255123 */     GIR_EraseRootFromParent_Done,
     /* 255124 */   // Label 5108: @255124
     /* 255124 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255183), // Rule ID 12491 //
     /* 255129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255146 */     // MIs[0] tile
     /* 255146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255166 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 255169 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255171 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255173 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255175 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255181 */     GIR_RootConstrainSelectedInstOperands,
     /* 255182 */     // GIR_Coverage, 12491,
     /* 255182 */     GIR_EraseRootFromParent_Done,
     /* 255183 */   // Label 5109: @255183
     /* 255183 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255242), // Rule ID 12492 //
     /* 255188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255205 */     // MIs[0] tile
     /* 255205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255225 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 255228 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255230 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255232 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255234 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255240 */     GIR_RootConstrainSelectedInstOperands,
     /* 255241 */     // GIR_Coverage, 12492,
     /* 255241 */     GIR_EraseRootFromParent_Done,
     /* 255242 */   // Label 5110: @255242
     /* 255242 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255302), // Rule ID 3411 //
     /* 255247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255255 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255265 */     // MIs[0] Rn
     /* 255265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255277 */     // MIs[0] prfop
     /* 255277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255285 */     // (intrinsic_void 1630:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 255288 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255300 */     GIR_RootConstrainSelectedInstOperands,
     /* 255301 */     // GIR_Coverage, 3411,
     /* 255301 */     GIR_EraseRootFromParent_Done,
     /* 255302 */   // Label 5111: @255302
     /* 255302 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255362), // Rule ID 3412 //
     /* 255307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255315 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255325 */     // MIs[0] Rn
     /* 255325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255337 */     // MIs[0] prfop
     /* 255337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255345 */     // (intrinsic_void 1629:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 255348 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255360 */     GIR_RootConstrainSelectedInstOperands,
     /* 255361 */     // GIR_Coverage, 3412,
     /* 255361 */     GIR_EraseRootFromParent_Done,
     /* 255362 */   // Label 5112: @255362
     /* 255362 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255422), // Rule ID 3423 //
     /* 255367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255375 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255385 */     // MIs[0] Rn
     /* 255385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255397 */     // MIs[0] prfop
     /* 255397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255405 */     // (intrinsic_void 1630:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 255408 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255420 */     GIR_RootConstrainSelectedInstOperands,
     /* 255421 */     // GIR_Coverage, 3423,
     /* 255421 */     GIR_EraseRootFromParent_Done,
     /* 255422 */   // Label 5113: @255422
     /* 255422 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255482), // Rule ID 3424 //
     /* 255427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255445 */     // MIs[0] Rn
     /* 255445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255457 */     // MIs[0] prfop
     /* 255457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255465 */     // (intrinsic_void 1629:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 255468 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255480 */     GIR_RootConstrainSelectedInstOperands,
     /* 255481 */     // GIR_Coverage, 3424,
     /* 255481 */     GIR_EraseRootFromParent_Done,
     /* 255482 */   // Label 5114: @255482
     /* 255482 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255542), // Rule ID 3425 //
     /* 255487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 255495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255505 */     // MIs[0] Rn
     /* 255505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255517 */     // MIs[0] prfop
     /* 255517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255525 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 255525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 255528 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255540 */     GIR_RootConstrainSelectedInstOperands,
     /* 255541 */     // GIR_Coverage, 3425,
     /* 255541 */     GIR_EraseRootFromParent_Done,
     /* 255542 */   // Label 5115: @255542
     /* 255542 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255602), // Rule ID 8808 //
     /* 255547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255555 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255565 */     // MIs[0] Rn
     /* 255565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255577 */     // MIs[0] prfop
     /* 255577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255585 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 255588 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255600 */     GIR_RootConstrainSelectedInstOperands,
     /* 255601 */     // GIR_Coverage, 8808,
     /* 255601 */     GIR_EraseRootFromParent_Done,
     /* 255602 */   // Label 5116: @255602
     /* 255602 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255662), // Rule ID 8809 //
     /* 255607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255615 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255625 */     // MIs[0] Rn
     /* 255625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255637 */     // MIs[0] prfop
     /* 255637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255645 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 255648 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255660 */     GIR_RootConstrainSelectedInstOperands,
     /* 255661 */     // GIR_Coverage, 8809,
     /* 255661 */     GIR_EraseRootFromParent_Done,
     /* 255662 */   // Label 5117: @255662
     /* 255662 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255722), // Rule ID 8810 //
     /* 255667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 255675 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255685 */     // MIs[0] Rn
     /* 255685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255697 */     // MIs[0] prfop
     /* 255697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255705 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 255708 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255720 */     GIR_RootConstrainSelectedInstOperands,
     /* 255721 */     // GIR_Coverage, 8810,
     /* 255721 */     GIR_EraseRootFromParent_Done,
     /* 255722 */   // Label 5118: @255722
     /* 255722 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255782), // Rule ID 8811 //
     /* 255727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 255735 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255745 */     // MIs[0] Rn
     /* 255745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255757 */     // MIs[0] prfop
     /* 255757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255765 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 255768 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255780 */     GIR_RootConstrainSelectedInstOperands,
     /* 255781 */     // GIR_Coverage, 8811,
     /* 255781 */     GIR_EraseRootFromParent_Done,
     /* 255782 */   // Label 5119: @255782
     /* 255782 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255842), // Rule ID 8812 //
     /* 255787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 255795 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255805 */     // MIs[0] Rn
     /* 255805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255817 */     // MIs[0] prfop
     /* 255817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255825 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 255828 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255840 */     GIR_RootConstrainSelectedInstOperands,
     /* 255841 */     // GIR_Coverage, 8812,
     /* 255841 */     GIR_EraseRootFromParent_Done,
     /* 255842 */   // Label 5120: @255842
     /* 255842 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255902), // Rule ID 8813 //
     /* 255847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 255855 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255865 */     // MIs[0] Rn
     /* 255865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255877 */     // MIs[0] prfop
     /* 255877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255885 */     // (intrinsic_void 1633:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 255888 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255900 */     GIR_RootConstrainSelectedInstOperands,
     /* 255901 */     // GIR_Coverage, 8813,
     /* 255901 */     GIR_EraseRootFromParent_Done,
     /* 255902 */   // Label 5121: @255902
     /* 255902 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255962), // Rule ID 8814 //
     /* 255907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255915 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255925 */     // MIs[0] Rn
     /* 255925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255937 */     // MIs[0] prfop
     /* 255937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255945 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 255945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 255948 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255960 */     GIR_RootConstrainSelectedInstOperands,
     /* 255961 */     // GIR_Coverage, 8814,
     /* 255961 */     GIR_EraseRootFromParent_Done,
     /* 255962 */   // Label 5122: @255962
     /* 255962 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(256022), // Rule ID 8815 //
     /* 255967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255985 */     // MIs[0] Rn
     /* 255985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255997 */     // MIs[0] prfop
     /* 255997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256005 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 256008 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256020 */     GIR_RootConstrainSelectedInstOperands,
     /* 256021 */     // GIR_Coverage, 8815,
     /* 256021 */     GIR_EraseRootFromParent_Done,
     /* 256022 */   // Label 5123: @256022
     /* 256022 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256082), // Rule ID 8816 //
     /* 256027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256035 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256045 */     // MIs[0] Rn
     /* 256045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256057 */     // MIs[0] prfop
     /* 256057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256065 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 256068 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256080 */     GIR_RootConstrainSelectedInstOperands,
     /* 256081 */     // GIR_Coverage, 8816,
     /* 256081 */     GIR_EraseRootFromParent_Done,
     /* 256082 */   // Label 5124: @256082
     /* 256082 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256142), // Rule ID 8817 //
     /* 256087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256095 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256105 */     // MIs[0] Rn
     /* 256105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256117 */     // MIs[0] prfop
     /* 256117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256125 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 256128 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256140 */     GIR_RootConstrainSelectedInstOperands,
     /* 256141 */     // GIR_Coverage, 8817,
     /* 256141 */     GIR_EraseRootFromParent_Done,
     /* 256142 */   // Label 5125: @256142
     /* 256142 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256202), // Rule ID 8818 //
     /* 256147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256155 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256165 */     // MIs[0] Rn
     /* 256165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256177 */     // MIs[0] prfop
     /* 256177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256185 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 256188 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256200 */     GIR_RootConstrainSelectedInstOperands,
     /* 256201 */     // GIR_Coverage, 8818,
     /* 256201 */     GIR_EraseRootFromParent_Done,
     /* 256202 */   // Label 5126: @256202
     /* 256202 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(256262), // Rule ID 8819 //
     /* 256207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256215 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256225 */     // MIs[0] Rn
     /* 256225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256237 */     // MIs[0] prfop
     /* 256237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256245 */     // (intrinsic_void 1633:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 256248 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256260 */     GIR_RootConstrainSelectedInstOperands,
     /* 256261 */     // GIR_Coverage, 8819,
     /* 256261 */     GIR_EraseRootFromParent_Done,
     /* 256262 */   // Label 5127: @256262
     /* 256262 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(256322), // Rule ID 8820 //
     /* 256267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 256275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256285 */     // MIs[0] Rn
     /* 256285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256297 */     // MIs[0] prfop
     /* 256297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256305 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 256305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 256308 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256320 */     GIR_RootConstrainSelectedInstOperands,
     /* 256321 */     // GIR_Coverage, 8820,
     /* 256321 */     GIR_EraseRootFromParent_Done,
     /* 256322 */   // Label 5128: @256322
     /* 256322 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256382), // Rule ID 8821 //
     /* 256327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 256335 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256345 */     // MIs[0] Rn
     /* 256345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256357 */     // MIs[0] prfop
     /* 256357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256365 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 256365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 256368 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256380 */     GIR_RootConstrainSelectedInstOperands,
     /* 256381 */     // GIR_Coverage, 8821,
     /* 256381 */     GIR_EraseRootFromParent_Done,
     /* 256382 */   // Label 5129: @256382
     /* 256382 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256442), // Rule ID 8822 //
     /* 256387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 256395 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256405 */     // MIs[0] Rn
     /* 256405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256417 */     // MIs[0] prfop
     /* 256417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256425 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 256425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 256428 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256440 */     GIR_RootConstrainSelectedInstOperands,
     /* 256441 */     // GIR_Coverage, 8822,
     /* 256441 */     GIR_EraseRootFromParent_Done,
     /* 256442 */   // Label 5130: @256442
     /* 256442 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256500), // Rule ID 2374 //
     /* 256447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 256455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256483 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 256486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256498 */     GIR_RootConstrainSelectedInstOperands,
     /* 256499 */     // GIR_Coverage, 2374,
     /* 256499 */     GIR_EraseRootFromParent_Done,
     /* 256500 */   // Label 5131: @256500
     /* 256500 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256558), // Rule ID 2375 //
     /* 256505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 256513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256541 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 256544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256556 */     GIR_RootConstrainSelectedInstOperands,
     /* 256557 */     // GIR_Coverage, 2375,
     /* 256557 */     GIR_EraseRootFromParent_Done,
     /* 256558 */   // Label 5132: @256558
     /* 256558 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256616), // Rule ID 2376 //
     /* 256563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 256571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256599 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 256602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256614 */     GIR_RootConstrainSelectedInstOperands,
     /* 256615 */     // GIR_Coverage, 2376,
     /* 256615 */     GIR_EraseRootFromParent_Done,
     /* 256616 */   // Label 5133: @256616
     /* 256616 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256674), // Rule ID 2377 //
     /* 256621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 256629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256657 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 256660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256672 */     GIR_RootConstrainSelectedInstOperands,
     /* 256673 */     // GIR_Coverage, 2377,
     /* 256673 */     GIR_EraseRootFromParent_Done,
     /* 256674 */   // Label 5134: @256674
     /* 256674 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256732), // Rule ID 2378 //
     /* 256679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 256687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256715 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 256718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256730 */     GIR_RootConstrainSelectedInstOperands,
     /* 256731 */     // GIR_Coverage, 2378,
     /* 256731 */     GIR_EraseRootFromParent_Done,
     /* 256732 */   // Label 5135: @256732
     /* 256732 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256790), // Rule ID 2379 //
     /* 256737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 256745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256773 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 256776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256788 */     GIR_RootConstrainSelectedInstOperands,
     /* 256789 */     // GIR_Coverage, 2379,
     /* 256789 */     GIR_EraseRootFromParent_Done,
     /* 256790 */   // Label 5136: @256790
     /* 256790 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256848), // Rule ID 2380 //
     /* 256795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 256806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256831 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 256834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256846 */     GIR_RootConstrainSelectedInstOperands,
     /* 256847 */     // GIR_Coverage, 2380,
     /* 256847 */     GIR_EraseRootFromParent_Done,
     /* 256848 */   // Label 5137: @256848
     /* 256848 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256906), // Rule ID 2381 //
     /* 256853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256889 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 256892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256904 */     GIR_RootConstrainSelectedInstOperands,
     /* 256905 */     // GIR_Coverage, 2381,
     /* 256905 */     GIR_EraseRootFromParent_Done,
     /* 256906 */   // Label 5138: @256906
     /* 256906 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256964), // Rule ID 2382 //
     /* 256911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 256922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256947 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 256950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256962 */     GIR_RootConstrainSelectedInstOperands,
     /* 256963 */     // GIR_Coverage, 2382,
     /* 256963 */     GIR_EraseRootFromParent_Done,
     /* 256964 */   // Label 5139: @256964
     /* 256964 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257022), // Rule ID 2383 //
     /* 256969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257005 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 257008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257020 */     GIR_RootConstrainSelectedInstOperands,
     /* 257021 */     // GIR_Coverage, 2383,
     /* 257021 */     GIR_EraseRootFromParent_Done,
     /* 257022 */   // Label 5140: @257022
     /* 257022 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257080), // Rule ID 2491 //
     /* 257027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 257030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 257035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257063 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 257063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 257066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257068 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 257070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257078 */     GIR_RootConstrainSelectedInstOperands,
     /* 257079 */     // GIR_Coverage, 2491,
     /* 257079 */     GIR_EraseRootFromParent_Done,
     /* 257080 */   // Label 5141: @257080
     /* 257080 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257136), // Rule ID 13050 //
     /* 257085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 257090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257111 */     // MIs[0] addr
     /* 257111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257119 */     // (intrinsic_w_chain:{ *:[i32] } 1230:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 257122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257124 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257126 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257128 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257134 */     GIR_RootConstrainSelectedInstOperands,
     /* 257135 */     // GIR_Coverage, 13050,
     /* 257135 */     GIR_EraseRootFromParent_Done,
     /* 257136 */   // Label 5142: @257136
     /* 257136 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257192), // Rule ID 13051 //
     /* 257141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 257146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257167 */     // MIs[0] addr
     /* 257167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257175 */     // (intrinsic_w_chain:{ *:[i32] } 1232:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257180 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257182 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257184 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257190 */     GIR_RootConstrainSelectedInstOperands,
     /* 257191 */     // GIR_Coverage, 13051,
     /* 257191 */     GIR_EraseRootFromParent_Done,
     /* 257192 */   // Label 5143: @257192
     /* 257192 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257238), // Rule ID 3459 //
     /* 257197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 257200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257221 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 257224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257236 */     GIR_RootConstrainSelectedInstOperands,
     /* 257237 */     // GIR_Coverage, 3459,
     /* 257237 */     GIR_EraseRootFromParent_Done,
     /* 257238 */   // Label 5144: @257238
     /* 257238 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257284), // Rule ID 3581 //
     /* 257243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 257251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257267 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 257270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257282 */     GIR_RootConstrainSelectedInstOperands,
     /* 257283 */     // GIR_Coverage, 3581,
     /* 257283 */     GIR_EraseRootFromParent_Done,
     /* 257284 */   // Label 5145: @257284
     /* 257284 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257330), // Rule ID 12478 //
     /* 257289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 257297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257313 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1507:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 257316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257328 */     GIR_RootConstrainSelectedInstOperands,
     /* 257329 */     // GIR_Coverage, 12478,
     /* 257329 */     GIR_EraseRootFromParent_Done,
     /* 257330 */   // Label 5146: @257330
     /* 257330 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257376), // Rule ID 12482 //
     /* 257335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 257343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257359 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1499:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 257362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257374 */     GIR_RootConstrainSelectedInstOperands,
     /* 257375 */     // GIR_Coverage, 12482,
     /* 257375 */     GIR_EraseRootFromParent_Done,
     /* 257376 */   // Label 5147: @257376
     /* 257376 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257422), // Rule ID 12483 //
     /* 257381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 257389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257405 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1501:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 257408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257420 */     GIR_RootConstrainSelectedInstOperands,
     /* 257421 */     // GIR_Coverage, 12483,
     /* 257421 */     GIR_EraseRootFromParent_Done,
     /* 257422 */   // Label 5148: @257422
     /* 257422 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257468), // Rule ID 12484 //
     /* 257427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 257435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257451 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 257454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257466 */     GIR_RootConstrainSelectedInstOperands,
     /* 257467 */     // GIR_Coverage, 12484,
     /* 257467 */     GIR_EraseRootFromParent_Done,
     /* 257468 */   // Label 5149: @257468
     /* 257468 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257514), // Rule ID 12485 //
     /* 257473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 257481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257497 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1505:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 257500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257512 */     GIR_RootConstrainSelectedInstOperands,
     /* 257513 */     // GIR_Coverage, 12485,
     /* 257513 */     GIR_EraseRootFromParent_Done,
     /* 257514 */   // Label 5150: @257514
     /* 257514 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257560), // Rule ID 12486 //
     /* 257519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 257522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257543 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 257546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257558 */     GIR_RootConstrainSelectedInstOperands,
     /* 257559 */     // GIR_Coverage, 12486,
     /* 257559 */     GIR_EraseRootFromParent_Done,
     /* 257560 */   // Label 5151: @257560
     /* 257560 */   GIM_Reject,
     /* 257561 */ // Label 5104: @257561
     /* 257561 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(260554),
     /* 257566 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 257569 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257637), // Rule ID 2518 //
     /* 257574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 257582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257610 */     // MIs[0] Idx
     /* 257610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257618 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 257621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257635 */     GIR_RootConstrainSelectedInstOperands,
     /* 257636 */     // GIR_Coverage, 2518,
     /* 257636 */     GIR_EraseRootFromParent_Done,
     /* 257637 */   // Label 5153: @257637
     /* 257637 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257705), // Rule ID 2519 //
     /* 257642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 257650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257678 */     // MIs[0] Idx
     /* 257678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257686 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 257689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257697 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257703 */     GIR_RootConstrainSelectedInstOperands,
     /* 257704 */     // GIR_Coverage, 2519,
     /* 257704 */     GIR_EraseRootFromParent_Done,
     /* 257705 */   // Label 5154: @257705
     /* 257705 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257773), // Rule ID 2520 //
     /* 257710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257746 */     // MIs[0] Idx
     /* 257746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257754 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 257757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257765 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257771 */     GIR_RootConstrainSelectedInstOperands,
     /* 257772 */     // GIR_Coverage, 2520,
     /* 257772 */     GIR_EraseRootFromParent_Done,
     /* 257773 */   // Label 5155: @257773
     /* 257773 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257841), // Rule ID 2521 //
     /* 257778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257814 */     // MIs[0] Idx
     /* 257814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257822 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 257825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257833 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257839 */     GIR_RootConstrainSelectedInstOperands,
     /* 257840 */     // GIR_Coverage, 2521,
     /* 257840 */     GIR_EraseRootFromParent_Done,
     /* 257841 */   // Label 5156: @257841
     /* 257841 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257909), // Rule ID 2522 //
     /* 257846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257882 */     // MIs[0] Idx
     /* 257882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257890 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 257893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257907 */     GIR_RootConstrainSelectedInstOperands,
     /* 257908 */     // GIR_Coverage, 2522,
     /* 257908 */     GIR_EraseRootFromParent_Done,
     /* 257909 */   // Label 5157: @257909
     /* 257909 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257977), // Rule ID 2523 //
     /* 257914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257950 */     // MIs[0] Idx
     /* 257950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257958 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 257961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257969 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257975 */     GIR_RootConstrainSelectedInstOperands,
     /* 257976 */     // GIR_Coverage, 2523,
     /* 257976 */     GIR_EraseRootFromParent_Done,
     /* 257977 */   // Label 5158: @257977
     /* 257977 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258045), // Rule ID 6954 //
     /* 257982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 257990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258018 */     // MIs[0] Idx
     /* 258018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258026 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 258029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258037 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258043 */     GIR_RootConstrainSelectedInstOperands,
     /* 258044 */     // GIR_Coverage, 6954,
     /* 258044 */     GIR_EraseRootFromParent_Done,
     /* 258045 */   // Label 5159: @258045
     /* 258045 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(258113), // Rule ID 6955 //
     /* 258050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 258058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258086 */     // MIs[0] Idx
     /* 258086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258094 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 258097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258105 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258111 */     GIR_RootConstrainSelectedInstOperands,
     /* 258112 */     // GIR_Coverage, 6955,
     /* 258112 */     GIR_EraseRootFromParent_Done,
     /* 258113 */   // Label 5160: @258113
     /* 258113 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258181), // Rule ID 6956 //
     /* 258118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 258126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258154 */     // MIs[0] Idx
     /* 258154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258162 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 258165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258173 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258179 */     GIR_RootConstrainSelectedInstOperands,
     /* 258180 */     // GIR_Coverage, 6956,
     /* 258180 */     GIR_EraseRootFromParent_Done,
     /* 258181 */   // Label 5161: @258181
     /* 258181 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258249), // Rule ID 6957 //
     /* 258186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 258194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258222 */     // MIs[0] Idx
     /* 258222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258230 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 258233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258247 */     GIR_RootConstrainSelectedInstOperands,
     /* 258248 */     // GIR_Coverage, 6957,
     /* 258248 */     GIR_EraseRootFromParent_Done,
     /* 258249 */   // Label 5162: @258249
     /* 258249 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(258309), // Rule ID 3593 //
     /* 258254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258274 */     // MIs[0] tile
     /* 258274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258290 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 258293 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258307 */     GIR_RootConstrainSelectedInstOperands,
     /* 258308 */     // GIR_Coverage, 3593,
     /* 258308 */     GIR_EraseRootFromParent_Done,
     /* 258309 */   // Label 5163: @258309
     /* 258309 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258369), // Rule ID 3594 //
     /* 258314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 258317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 258322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258334 */     // MIs[0] tile
     /* 258334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258350 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 258353 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258361 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258367 */     GIR_RootConstrainSelectedInstOperands,
     /* 258368 */     // GIR_Coverage, 3594,
     /* 258368 */     GIR_EraseRootFromParent_Done,
     /* 258369 */   // Label 5164: @258369
     /* 258369 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258429), // Rule ID 3595 //
     /* 258374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258394 */     // MIs[0] tile
     /* 258394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258410 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 258413 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258427 */     GIR_RootConstrainSelectedInstOperands,
     /* 258428 */     // GIR_Coverage, 3595,
     /* 258428 */     GIR_EraseRootFromParent_Done,
     /* 258429 */   // Label 5165: @258429
     /* 258429 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258489), // Rule ID 3596 //
     /* 258434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 258437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 258442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258454 */     // MIs[0] tile
     /* 258454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258470 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 258473 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258481 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258487 */     GIR_RootConstrainSelectedInstOperands,
     /* 258488 */     // GIR_Coverage, 3596,
     /* 258488 */     GIR_EraseRootFromParent_Done,
     /* 258489 */   // Label 5166: @258489
     /* 258489 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258549), // Rule ID 3597 //
     /* 258494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 258497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258514 */     // MIs[0] tile
     /* 258514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258530 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 258533 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258547 */     GIR_RootConstrainSelectedInstOperands,
     /* 258548 */     // GIR_Coverage, 3597,
     /* 258548 */     GIR_EraseRootFromParent_Done,
     /* 258549 */   // Label 5167: @258549
     /* 258549 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258609), // Rule ID 3598 //
     /* 258554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258574 */     // MIs[0] tile
     /* 258574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258590 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 258593 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258601 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258607 */     GIR_RootConstrainSelectedInstOperands,
     /* 258608 */     // GIR_Coverage, 3598,
     /* 258608 */     GIR_EraseRootFromParent_Done,
     /* 258609 */   // Label 5168: @258609
     /* 258609 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258669), // Rule ID 3599 //
     /* 258614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258634 */     // MIs[0] tile
     /* 258634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258650 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 258653 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258667 */     GIR_RootConstrainSelectedInstOperands,
     /* 258668 */     // GIR_Coverage, 3599,
     /* 258668 */     GIR_EraseRootFromParent_Done,
     /* 258669 */   // Label 5169: @258669
     /* 258669 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258729), // Rule ID 3600 //
     /* 258674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 258682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258694 */     // MIs[0] tile
     /* 258694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258710 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 258713 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258721 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258727 */     GIR_RootConstrainSelectedInstOperands,
     /* 258728 */     // GIR_Coverage, 3600,
     /* 258728 */     GIR_EraseRootFromParent_Done,
     /* 258729 */   // Label 5170: @258729
     /* 258729 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258789), // Rule ID 3694 //
     /* 258734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 258742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258754 */     // MIs[0] tile
     /* 258754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258770 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 258773 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258781 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258787 */     GIR_RootConstrainSelectedInstOperands,
     /* 258788 */     // GIR_Coverage, 3694,
     /* 258788 */     GIR_EraseRootFromParent_Done,
     /* 258789 */   // Label 5171: @258789
     /* 258789 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258849), // Rule ID 3695 //
     /* 258794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 258802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258814 */     // MIs[0] tile
     /* 258814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258830 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 258830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 258833 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258841 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258847 */     GIR_RootConstrainSelectedInstOperands,
     /* 258848 */     // GIR_Coverage, 3695,
     /* 258848 */     GIR_EraseRootFromParent_Done,
     /* 258849 */   // Label 5172: @258849
     /* 258849 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258909), // Rule ID 12493 //
     /* 258854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258874 */     // MIs[0] tile
     /* 258874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258890 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 258893 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258907 */     GIR_RootConstrainSelectedInstOperands,
     /* 258908 */     // GIR_Coverage, 12493,
     /* 258908 */     GIR_EraseRootFromParent_Done,
     /* 258909 */   // Label 5173: @258909
     /* 258909 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258969), // Rule ID 12494 //
     /* 258914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258934 */     // MIs[0] tile
     /* 258934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258950 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 258953 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258967 */     GIR_RootConstrainSelectedInstOperands,
     /* 258968 */     // GIR_Coverage, 12494,
     /* 258968 */     GIR_EraseRootFromParent_Done,
     /* 258969 */   // Label 5174: @258969
     /* 258969 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(259029), // Rule ID 12495 //
     /* 258974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 258982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258994 */     // MIs[0] tile
     /* 258994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259010 */     // (intrinsic_void 925:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 259013 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259021 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259027 */     GIR_RootConstrainSelectedInstOperands,
     /* 259028 */     // GIR_Coverage, 12495,
     /* 259028 */     GIR_EraseRootFromParent_Done,
     /* 259029 */   // Label 5175: @259029
     /* 259029 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259089), // Rule ID 12496 //
     /* 259034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259054 */     // MIs[0] tile
     /* 259054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259070 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 259073 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259081 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259087 */     GIR_RootConstrainSelectedInstOperands,
     /* 259088 */     // GIR_Coverage, 12496,
     /* 259088 */     GIR_EraseRootFromParent_Done,
     /* 259089 */   // Label 5176: @259089
     /* 259089 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259149), // Rule ID 12497 //
     /* 259094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259114 */     // MIs[0] tile
     /* 259114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259130 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 259133 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259141 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259147 */     GIR_RootConstrainSelectedInstOperands,
     /* 259148 */     // GIR_Coverage, 12497,
     /* 259148 */     GIR_EraseRootFromParent_Done,
     /* 259149 */   // Label 5177: @259149
     /* 259149 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259209), // Rule ID 12498 //
     /* 259154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259174 */     // MIs[0] tile
     /* 259174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259190 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 259193 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259201 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259207 */     GIR_RootConstrainSelectedInstOperands,
     /* 259208 */     // GIR_Coverage, 12498,
     /* 259208 */     GIR_EraseRootFromParent_Done,
     /* 259209 */   // Label 5178: @259209
     /* 259209 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(259269), // Rule ID 12499 //
     /* 259214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259234 */     // MIs[0] tile
     /* 259234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259250 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 259253 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259267 */     GIR_RootConstrainSelectedInstOperands,
     /* 259268 */     // GIR_Coverage, 12499,
     /* 259268 */     GIR_EraseRootFromParent_Done,
     /* 259269 */   // Label 5179: @259269
     /* 259269 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259329), // Rule ID 12500 //
     /* 259274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259294 */     // MIs[0] tile
     /* 259294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259310 */     // (intrinsic_void 1076:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 259313 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259321 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259327 */     GIR_RootConstrainSelectedInstOperands,
     /* 259328 */     // GIR_Coverage, 12500,
     /* 259328 */     GIR_EraseRootFromParent_Done,
     /* 259329 */   // Label 5180: @259329
     /* 259329 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259389), // Rule ID 12501 //
     /* 259334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259354 */     // MIs[0] tile
     /* 259354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259370 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 259373 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259387 */     GIR_RootConstrainSelectedInstOperands,
     /* 259388 */     // GIR_Coverage, 12501,
     /* 259388 */     GIR_EraseRootFromParent_Done,
     /* 259389 */   // Label 5181: @259389
     /* 259389 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259449), // Rule ID 12502 //
     /* 259394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259414 */     // MIs[0] tile
     /* 259414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259430 */     // (intrinsic_void 1193:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 259433 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259441 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259447 */     GIR_RootConstrainSelectedInstOperands,
     /* 259448 */     // GIR_Coverage, 12502,
     /* 259448 */     GIR_EraseRootFromParent_Done,
     /* 259449 */   // Label 5182: @259449
     /* 259449 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259509), // Rule ID 12503 //
     /* 259454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259474 */     // MIs[0] tile
     /* 259474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259490 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 259493 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259501 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259507 */     GIR_RootConstrainSelectedInstOperands,
     /* 259508 */     // GIR_Coverage, 12503,
     /* 259508 */     GIR_EraseRootFromParent_Done,
     /* 259509 */   // Label 5183: @259509
     /* 259509 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259569), // Rule ID 12504 //
     /* 259514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259534 */     // MIs[0] tile
     /* 259534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259550 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 259553 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259561 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259567 */     GIR_RootConstrainSelectedInstOperands,
     /* 259568 */     // GIR_Coverage, 12504,
     /* 259568 */     GIR_EraseRootFromParent_Done,
     /* 259569 */   // Label 5184: @259569
     /* 259569 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259629), // Rule ID 12505 //
     /* 259574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259594 */     // MIs[0] tile
     /* 259594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259610 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 259613 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259621 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259627 */     GIR_RootConstrainSelectedInstOperands,
     /* 259628 */     // GIR_Coverage, 12505,
     /* 259628 */     GIR_EraseRootFromParent_Done,
     /* 259629 */   // Label 5185: @259629
     /* 259629 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259689), // Rule ID 12506 //
     /* 259634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259654 */     // MIs[0] tile
     /* 259654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259670 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 259673 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259681 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259687 */     GIR_RootConstrainSelectedInstOperands,
     /* 259688 */     // GIR_Coverage, 12506,
     /* 259688 */     GIR_EraseRootFromParent_Done,
     /* 259689 */   // Label 5186: @259689
     /* 259689 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259749), // Rule ID 12507 //
     /* 259694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259714 */     // MIs[0] tile
     /* 259714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259717 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259730 */     // (intrinsic_void 1076:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 259733 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259741 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259747 */     GIR_RootConstrainSelectedInstOperands,
     /* 259748 */     // GIR_Coverage, 12507,
     /* 259748 */     GIR_EraseRootFromParent_Done,
     /* 259749 */   // Label 5187: @259749
     /* 259749 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259809), // Rule ID 12508 //
     /* 259754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259774 */     // MIs[0] tile
     /* 259774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259790 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 259793 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259801 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259807 */     GIR_RootConstrainSelectedInstOperands,
     /* 259808 */     // GIR_Coverage, 12508,
     /* 259808 */     GIR_EraseRootFromParent_Done,
     /* 259809 */   // Label 5188: @259809
     /* 259809 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259869), // Rule ID 12509 //
     /* 259814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259834 */     // MIs[0] tile
     /* 259834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259850 */     // (intrinsic_void 1193:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 259853 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259861 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259867 */     GIR_RootConstrainSelectedInstOperands,
     /* 259868 */     // GIR_Coverage, 12509,
     /* 259868 */     GIR_EraseRootFromParent_Done,
     /* 259869 */   // Label 5189: @259869
     /* 259869 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259929), // Rule ID 12883 //
     /* 259874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 259882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259894 */     // MIs[0] tile
     /* 259894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259910 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 259913 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259921 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259927 */     GIR_RootConstrainSelectedInstOperands,
     /* 259928 */     // GIR_Coverage, 12883,
     /* 259928 */     GIR_EraseRootFromParent_Done,
     /* 259929 */   // Label 5190: @259929
     /* 259929 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259989), // Rule ID 12884 //
     /* 259934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 259942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259954 */     // MIs[0] tile
     /* 259954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259970 */     // (intrinsic_void 1026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 259973 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259981 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259987 */     GIR_RootConstrainSelectedInstOperands,
     /* 259988 */     // GIR_Coverage, 12884,
     /* 259988 */     GIR_EraseRootFromParent_Done,
     /* 259989 */   // Label 5191: @259989
     /* 259989 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260049), // Rule ID 12885 //
     /* 259994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 260002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260014 */     // MIs[0] tile
     /* 260014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260030 */     // (intrinsic_void 1159:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 260033 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260041 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260047 */     GIR_RootConstrainSelectedInstOperands,
     /* 260048 */     // GIR_Coverage, 12885,
     /* 260048 */     GIR_EraseRootFromParent_Done,
     /* 260049 */   // Label 5192: @260049
     /* 260049 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260109), // Rule ID 12886 //
     /* 260054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 260062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260074 */     // MIs[0] tile
     /* 260074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260090 */     // (intrinsic_void 1161:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260093 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260101 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260107 */     GIR_RootConstrainSelectedInstOperands,
     /* 260108 */     // GIR_Coverage, 12886,
     /* 260108 */     GIR_EraseRootFromParent_Done,
     /* 260109 */   // Label 5193: @260109
     /* 260109 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260169), // Rule ID 12997 //
     /* 260114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 260117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 260122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260134 */     // MIs[0] tile
     /* 260134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 260142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260150 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 260150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 260153 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260161 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260167 */     GIR_RootConstrainSelectedInstOperands,
     /* 260168 */     // GIR_Coverage, 12997,
     /* 260168 */     GIR_EraseRootFromParent_Done,
     /* 260169 */   // Label 5194: @260169
     /* 260169 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260217), // Rule ID 3580 //
     /* 260174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 260182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260198 */     // MIs[0] Op4
     /* 260198 */     // No operand predicates
     /* 260198 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 260201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260209 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260215 */     GIR_RootConstrainSelectedInstOperands,
     /* 260216 */     // GIR_Coverage, 3580,
     /* 260216 */     GIR_EraseRootFromParent_Done,
     /* 260217 */   // Label 5195: @260217
     /* 260217 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(260265), // Rule ID 3582 //
     /* 260222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 260230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260246 */     // MIs[0] Op4
     /* 260246 */     // No operand predicates
     /* 260246 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1500:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 260249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260263 */     GIR_RootConstrainSelectedInstOperands,
     /* 260264 */     // GIR_Coverage, 3582,
     /* 260264 */     GIR_EraseRootFromParent_Done,
     /* 260265 */   // Label 5196: @260265
     /* 260265 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(260313), // Rule ID 3583 //
     /* 260270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 260273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260294 */     // MIs[0] Op4
     /* 260294 */     // No operand predicates
     /* 260294 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1496:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 260297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260311 */     GIR_RootConstrainSelectedInstOperands,
     /* 260312 */     // GIR_Coverage, 3583,
     /* 260312 */     GIR_EraseRootFromParent_Done,
     /* 260313 */   // Label 5197: @260313
     /* 260313 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260361), // Rule ID 3584 //
     /* 260318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260342 */     // MIs[0] Op4
     /* 260342 */     // No operand predicates
     /* 260342 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 260345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260353 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260359 */     GIR_RootConstrainSelectedInstOperands,
     /* 260360 */     // GIR_Coverage, 3584,
     /* 260360 */     GIR_EraseRootFromParent_Done,
     /* 260361 */   // Label 5198: @260361
     /* 260361 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260409), // Rule ID 12477 //
     /* 260366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 260374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260390 */     // MIs[0] Op4
     /* 260390 */     // No operand predicates
     /* 260390 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1508:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 260393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260401 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260407 */     GIR_RootConstrainSelectedInstOperands,
     /* 260408 */     // GIR_Coverage, 12477,
     /* 260408 */     GIR_EraseRootFromParent_Done,
     /* 260409 */   // Label 5199: @260409
     /* 260409 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260457), // Rule ID 12479 //
     /* 260414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 260422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260438 */     // MIs[0] Op4
     /* 260438 */     // No operand predicates
     /* 260438 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1502:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 260441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260449 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260455 */     GIR_RootConstrainSelectedInstOperands,
     /* 260456 */     // GIR_Coverage, 12479,
     /* 260456 */     GIR_EraseRootFromParent_Done,
     /* 260457 */   // Label 5200: @260457
     /* 260457 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260505), // Rule ID 12480 //
     /* 260462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 260470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260486 */     // MIs[0] Op4
     /* 260486 */     // No operand predicates
     /* 260486 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 260489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260497 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260503 */     GIR_RootConstrainSelectedInstOperands,
     /* 260504 */     // GIR_Coverage, 12480,
     /* 260504 */     GIR_EraseRootFromParent_Done,
     /* 260505 */   // Label 5201: @260505
     /* 260505 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260553), // Rule ID 12481 //
     /* 260510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 260518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260534 */     // MIs[0] Op4
     /* 260534 */     // No operand predicates
     /* 260534 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1506:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 260537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260545 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260551 */     GIR_RootConstrainSelectedInstOperands,
     /* 260552 */     // GIR_Coverage, 12481,
     /* 260552 */     GIR_EraseRootFromParent_Done,
     /* 260553 */   // Label 5202: @260553
     /* 260553 */   GIM_Reject,
     /* 260554 */ // Label 5152: @260554
     /* 260554 */ GIM_Reject,
     /* 260555 */ // Label 37: @260555
     /* 260555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5207*/ GIMT_Encode4(260844),
     /* 260566 */ /*GILLT_s64*//*Label 5203*/ GIMT_Encode4(260598), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260578 */ /*GILLT_v2s64*//*Label 5204*/ GIMT_Encode4(260658), GIMT_Encode4(0),
     /* 260586 */ /*GILLT_v4s32*//*Label 5205*/ GIMT_Encode4(260720), GIMT_Encode4(0),
     /* 260594 */ /*GILLT_v8s16*//*Label 5206*/ GIMT_Encode4(260782),
     /* 260598 */ // Label 5203: @260598
     /* 260598 */ GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260657), // Rule ID 6466 //
     /* 260603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 260606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260614 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 260614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 260617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 260628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260636 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 260641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260656 */   // GIR_Coverage, 6466,
     /* 260656 */   GIR_EraseRootFromParent_Done,
     /* 260657 */ // Label 5208: @260657
     /* 260657 */ GIM_Reject,
     /* 260658 */ // Label 5204: @260658
     /* 260658 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260719),
     /* 260663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260670 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260697), // Rule ID 6338 //
     /* 260675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260682 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 260682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 260685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260695 */     GIR_RootConstrainSelectedInstOperands,
     /* 260696 */     // GIR_Coverage, 6338,
     /* 260696 */     GIR_EraseRootFromParent_Done,
     /* 260697 */   // Label 5210: @260697
     /* 260697 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260718), // Rule ID 6331 //
     /* 260702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260706 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 260706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 260709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260716 */     GIR_RootConstrainSelectedInstOperands,
     /* 260717 */     // GIR_Coverage, 6331,
     /* 260717 */     GIR_EraseRootFromParent_Done,
     /* 260718 */   // Label 5211: @260718
     /* 260718 */   GIM_Reject,
     /* 260719 */ // Label 5209: @260719
     /* 260719 */ GIM_Reject,
     /* 260720 */ // Label 5205: @260720
     /* 260720 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(260781),
     /* 260725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 260728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260732 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(260759), // Rule ID 6335 //
     /* 260737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 260744 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 260744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 260747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260757 */     GIR_RootConstrainSelectedInstOperands,
     /* 260758 */     // GIR_Coverage, 6335,
     /* 260758 */     GIR_EraseRootFromParent_Done,
     /* 260759 */   // Label 5213: @260759
     /* 260759 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(260780), // Rule ID 6328 //
     /* 260764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260768 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 260768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 260771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260778 */     GIR_RootConstrainSelectedInstOperands,
     /* 260779 */     // GIR_Coverage, 6328,
     /* 260779 */     GIR_EraseRootFromParent_Done,
     /* 260780 */   // Label 5214: @260780
     /* 260780 */   GIM_Reject,
     /* 260781 */ // Label 5212: @260781
     /* 260781 */ GIM_Reject,
     /* 260782 */ // Label 5206: @260782
     /* 260782 */ GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(260843),
     /* 260787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 260790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260794 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260821), // Rule ID 6332 //
     /* 260799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 260806 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 260806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 260809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260819 */     GIR_RootConstrainSelectedInstOperands,
     /* 260820 */     // GIR_Coverage, 6332,
     /* 260820 */     GIR_EraseRootFromParent_Done,
     /* 260821 */   // Label 5216: @260821
     /* 260821 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(260842), // Rule ID 6325 //
     /* 260826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260830 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 260830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 260833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260840 */     GIR_RootConstrainSelectedInstOperands,
     /* 260841 */     // GIR_Coverage, 6325,
     /* 260841 */     GIR_EraseRootFromParent_Done,
     /* 260842 */   // Label 5217: @260842
     /* 260842 */   GIM_Reject,
     /* 260843 */ // Label 5215: @260843
     /* 260843 */ GIM_Reject,
     /* 260844 */ // Label 5207: @260844
     /* 260844 */ GIM_Reject,
     /* 260845 */ // Label 38: @260845
     /* 260845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5222*/ GIMT_Encode4(262281),
     /* 260856 */ /*GILLT_s32*//*Label 5218*/ GIMT_Encode4(260888), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260868 */ /*GILLT_v2s32*//*Label 5219*/ GIMT_Encode4(260927), GIMT_Encode4(0),
     /* 260876 */ /*GILLT_v4s16*//*Label 5220*/ GIMT_Encode4(261283), GIMT_Encode4(0),
     /* 260884 */ /*GILLT_v8s8*//*Label 5221*/ GIMT_Encode4(261782),
     /* 260888 */ // Label 5218: @260888
     /* 260888 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(260926), // Rule ID 6487 //
     /* 260893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 260896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260904 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 260904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260909 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 260915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260925 */   // GIR_Coverage, 6487,
     /* 260925 */   GIR_EraseRootFromParent_Done,
     /* 260926 */ // Label 5223: @260926
     /* 260926 */ GIM_Reject,
     /* 260927 */ // Label 5219: @260927
     /* 260927 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261282),
     /* 260932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260939 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261017), // Rule ID 5417 //
     /* 260944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 260964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 260972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 260987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 260989 */     // MIs[1] Operand 2
     /* 260989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261002 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 261002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261015 */     GIR_RootConstrainSelectedInstOperands,
     /* 261016 */     // GIR_Coverage, 5417,
     /* 261016 */     GIR_EraseRootFromParent_Done,
     /* 261017 */   // Label 5225: @261017
     /* 261017 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261088), // Rule ID 5413 //
     /* 261022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261060 */     // MIs[1] Operand 2
     /* 261060 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261073 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 261076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261086 */     GIR_RootConstrainSelectedInstOperands,
     /* 261087 */     // GIR_Coverage, 5413,
     /* 261087 */     GIR_EraseRootFromParent_Done,
     /* 261088 */   // Label 5226: @261088
     /* 261088 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261159), // Rule ID 5415 //
     /* 261093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261131 */     // MIs[1] Operand 2
     /* 261131 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261144 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261157 */     GIR_RootConstrainSelectedInstOperands,
     /* 261158 */     // GIR_Coverage, 5415,
     /* 261158 */     GIR_EraseRootFromParent_Done,
     /* 261159 */   // Label 5227: @261159
     /* 261159 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261212), // Rule ID 2162 //
     /* 261164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261184 */     // MIs[1] imm
     /* 261184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261196 */     // MIs[2] Operand 1
     /* 261196 */     // No operand predicates
     /* 261196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261198 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261210 */     GIR_RootConstrainSelectedInstOperands,
     /* 261211 */     // GIR_Coverage, 2162,
     /* 261211 */     GIR_EraseRootFromParent_Done,
     /* 261212 */   // Label 5228: @261212
     /* 261212 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261262), // Rule ID 6313 //
     /* 261217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261234 */     // MIs[1] imm
     /* 261234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261246 */     // MIs[2] Operand 1
     /* 261246 */     // No operand predicates
     /* 261246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261248 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 261248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261260 */     GIR_RootConstrainSelectedInstOperands,
     /* 261261 */     // GIR_Coverage, 6313,
     /* 261261 */     GIR_EraseRootFromParent_Done,
     /* 261262 */   // Label 5229: @261262
     /* 261262 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261281), // Rule ID 1099 //
     /* 261267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261274 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 261274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 261279 */     GIR_RootConstrainSelectedInstOperands,
     /* 261280 */     // GIR_Coverage, 1099,
     /* 261280 */     GIR_Done,
     /* 261281 */   // Label 5230: @261281
     /* 261281 */   GIM_Reject,
     /* 261282 */ // Label 5224: @261282
     /* 261282 */ GIM_Reject,
     /* 261283 */ // Label 5220: @261283
     /* 261283 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261781),
     /* 261288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261295 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261373), // Rule ID 5411 //
     /* 261300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261337 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261343 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261345 */     // MIs[1] Operand 2
     /* 261345 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261358 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 261358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261371 */     GIR_RootConstrainSelectedInstOperands,
     /* 261372 */     // GIR_Coverage, 5411,
     /* 261372 */     GIR_EraseRootFromParent_Done,
     /* 261373 */   // Label 5232: @261373
     /* 261373 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261444), // Rule ID 5407 //
     /* 261378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261416 */     // MIs[1] Operand 2
     /* 261416 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261429 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 261432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261442 */     GIR_RootConstrainSelectedInstOperands,
     /* 261443 */     // GIR_Coverage, 5407,
     /* 261443 */     GIR_EraseRootFromParent_Done,
     /* 261444 */   // Label 5233: @261444
     /* 261444 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261515), // Rule ID 5409 //
     /* 261449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261487 */     // MIs[1] Operand 2
     /* 261487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261500 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261513 */     GIR_RootConstrainSelectedInstOperands,
     /* 261514 */     // GIR_Coverage, 5409,
     /* 261514 */     GIR_EraseRootFromParent_Done,
     /* 261515 */   // Label 5234: @261515
     /* 261515 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261607), // Rule ID 5533 //
     /* 261520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261528 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 261560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261568 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261575 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 261575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 261578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 261582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 261591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 261595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261605 */     GIR_RootConstrainSelectedInstOperands,
     /* 261606 */     // GIR_Coverage, 5533,
     /* 261606 */     GIR_EraseRootFromParent_Done,
     /* 261607 */   // Label 5235: @261607
     /* 261607 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(261660), // Rule ID 2161 //
     /* 261612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261632 */     // MIs[1] imm
     /* 261632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261640 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261644 */     // MIs[2] Operand 1
     /* 261644 */     // No operand predicates
     /* 261644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261646 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261658 */     GIR_RootConstrainSelectedInstOperands,
     /* 261659 */     // GIR_Coverage, 2161,
     /* 261659 */     GIR_EraseRootFromParent_Done,
     /* 261660 */   // Label 5236: @261660
     /* 261660 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(261710), // Rule ID 6312 //
     /* 261665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261682 */     // MIs[1] imm
     /* 261682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261694 */     // MIs[2] Operand 1
     /* 261694 */     // No operand predicates
     /* 261694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261696 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 261696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261708 */     GIR_RootConstrainSelectedInstOperands,
     /* 261709 */     // GIR_Coverage, 6312,
     /* 261709 */     GIR_EraseRootFromParent_Done,
     /* 261710 */   // Label 5237: @261710
     /* 261710 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(261761), // Rule ID 5561 //
     /* 261715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261723 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261746 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 261746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 261749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 261755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 261759 */     GIR_RootConstrainSelectedInstOperands,
     /* 261760 */     // GIR_Coverage, 5561,
     /* 261760 */     GIR_EraseRootFromParent_Done,
     /* 261761 */   // Label 5238: @261761
     /* 261761 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(261780), // Rule ID 1098 //
     /* 261766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261773 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 261773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261778 */     GIR_RootConstrainSelectedInstOperands,
     /* 261779 */     // GIR_Coverage, 1098,
     /* 261779 */     GIR_Done,
     /* 261780 */   // Label 5239: @261780
     /* 261780 */   GIM_Reject,
     /* 261781 */ // Label 5231: @261781
     /* 261781 */ GIM_Reject,
     /* 261782 */ // Label 5221: @261782
     /* 261782 */ GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262280),
     /* 261787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261794 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(261872), // Rule ID 5405 //
     /* 261799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261836 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261844 */     // MIs[1] Operand 2
     /* 261844 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261857 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 261857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 261860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261870 */     GIR_RootConstrainSelectedInstOperands,
     /* 261871 */     // GIR_Coverage, 5405,
     /* 261871 */     GIR_EraseRootFromParent_Done,
     /* 261872 */   // Label 5241: @261872
     /* 261872 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(261943), // Rule ID 5401 //
     /* 261877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261915 */     // MIs[1] Operand 2
     /* 261915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261928 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 261931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261941 */     GIR_RootConstrainSelectedInstOperands,
     /* 261942 */     // GIR_Coverage, 5401,
     /* 261942 */     GIR_EraseRootFromParent_Done,
     /* 261943 */   // Label 5242: @261943
     /* 261943 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262014), // Rule ID 5403 //
     /* 261948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261986 */     // MIs[1] Operand 2
     /* 261986 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261999 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262012 */     GIR_RootConstrainSelectedInstOperands,
     /* 262013 */     // GIR_Coverage, 5403,
     /* 262013 */     GIR_EraseRootFromParent_Done,
     /* 262014 */   // Label 5243: @262014
     /* 262014 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262106), // Rule ID 5506 //
     /* 262019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262074 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 262074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 262081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262104 */     GIR_RootConstrainSelectedInstOperands,
     /* 262105 */     // GIR_Coverage, 5506,
     /* 262105 */     GIR_EraseRootFromParent_Done,
     /* 262106 */   // Label 5244: @262106
     /* 262106 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262159), // Rule ID 2160 //
     /* 262111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262131 */     // MIs[1] imm
     /* 262131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262143 */     // MIs[2] Operand 1
     /* 262143 */     // No operand predicates
     /* 262143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262145 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262157 */     GIR_RootConstrainSelectedInstOperands,
     /* 262158 */     // GIR_Coverage, 2160,
     /* 262158 */     GIR_EraseRootFromParent_Done,
     /* 262159 */   // Label 5245: @262159
     /* 262159 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262209), // Rule ID 6311 //
     /* 262164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262181 */     // MIs[1] imm
     /* 262181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262193 */     // MIs[2] Operand 1
     /* 262193 */     // No operand predicates
     /* 262193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262195 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 262195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262207 */     GIR_RootConstrainSelectedInstOperands,
     /* 262208 */     // GIR_Coverage, 6311,
     /* 262208 */     GIR_EraseRootFromParent_Done,
     /* 262209 */   // Label 5246: @262209
     /* 262209 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262260), // Rule ID 5560 //
     /* 262214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262222 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262245 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 262245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 262248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262258 */     GIR_RootConstrainSelectedInstOperands,
     /* 262259 */     // GIR_Coverage, 5560,
     /* 262259 */     GIR_EraseRootFromParent_Done,
     /* 262260 */   // Label 5247: @262260
     /* 262260 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262279), // Rule ID 1097 //
     /* 262265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262272 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 262272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262277 */     GIR_RootConstrainSelectedInstOperands,
     /* 262278 */     // GIR_Coverage, 1097,
     /* 262278 */     GIR_Done,
     /* 262279 */   // Label 5248: @262279
     /* 262279 */   GIM_Reject,
     /* 262280 */ // Label 5240: @262280
     /* 262280 */ GIM_Reject,
     /* 262281 */ // Label 5222: @262281
     /* 262281 */ GIM_Reject,
     /* 262282 */ // Label 39: @262282
     /* 262282 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5251*/ GIMT_Encode4(262401),
     /* 262293 */ /*GILLT_s32*//*Label 5249*/ GIMT_Encode4(262301),
     /* 262297 */ /*GILLT_s64*//*Label 5250*/ GIMT_Encode4(262321),
     /* 262301 */ // Label 5249: @262301
     /* 262301 */ GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262320), // Rule ID 81 //
     /* 262306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262310 */   // MIs[0] Operand 1
     /* 262310 */   // No operand predicates
     /* 262310 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 262310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262315 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262318 */   GIR_RootConstrainSelectedInstOperands,
     /* 262319 */   // GIR_Coverage, 81,
     /* 262319 */   GIR_EraseRootFromParent_Done,
     /* 262320 */ // Label 5252: @262320
     /* 262320 */ GIM_Reject,
     /* 262321 */ // Label 5250: @262321
     /* 262321 */ GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262381), // Rule ID 3897 //
     /* 262326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 262329 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 262333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262337 */   // MIs[0] Operand 1
     /* 262337 */   // No operand predicates
     /* 262337 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 262337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262349 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 262354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 262370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262380 */   // GIR_Coverage, 3897,
     /* 262380 */   GIR_EraseRootFromParent_Done,
     /* 262381 */ // Label 5253: @262381
     /* 262381 */ GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262400), // Rule ID 82 //
     /* 262386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262390 */   // MIs[0] Operand 1
     /* 262390 */   // No operand predicates
     /* 262390 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 262390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 262393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262395 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262398 */   GIR_RootConstrainSelectedInstOperands,
     /* 262399 */   // GIR_Coverage, 82,
     /* 262399 */   GIR_EraseRootFromParent_Done,
     /* 262400 */ // Label 5254: @262400
     /* 262400 */ GIM_Reject,
     /* 262401 */ // Label 5251: @262401
     /* 262401 */ GIM_Reject,
     /* 262402 */ // Label 40: @262402
     /* 262402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5258*/ GIMT_Encode4(262642),
     /* 262413 */ /*GILLT_s16*//*Label 5255*/ GIMT_Encode4(262425),
     /* 262417 */ /*GILLT_s32*//*Label 5256*/ GIMT_Encode4(262477),
     /* 262421 */ /*GILLT_s64*//*Label 5257*/ GIMT_Encode4(262590),
     /* 262425 */ // Label 5255: @262425
     /* 262425 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262448), // Rule ID 506 //
     /* 262430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262433 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262441 */   // MIs[0] Operand 1
     /* 262441 */   // No operand predicates
     /* 262441 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 262441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 262444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262446 */   GIR_RootConstrainSelectedInstOperands,
     /* 262447 */   // GIR_Coverage, 506,
     /* 262447 */   GIR_EraseRootFromParent_Done,
     /* 262448 */ // Label 5259: @262448
     /* 262448 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262476), // Rule ID 688 //
     /* 262453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 262456 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 262460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262464 */   // MIs[0] Operand 1
     /* 262464 */   // No operand predicates
     /* 262464 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 262464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 262467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262469 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 262474 */   GIR_RootConstrainSelectedInstOperands,
     /* 262475 */   // GIR_Coverage, 688,
     /* 262475 */   GIR_EraseRootFromParent_Done,
     /* 262476 */ // Label 5260: @262476
     /* 262476 */ GIM_Reject,
     /* 262477 */ // Label 5256: @262477
     /* 262477 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(262500), // Rule ID 507 //
     /* 262482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262485 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262493 */   // MIs[0] Operand 1
     /* 262493 */   // No operand predicates
     /* 262493 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 262493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 262496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262498 */   GIR_RootConstrainSelectedInstOperands,
     /* 262499 */   // GIR_Coverage, 507,
     /* 262499 */   GIR_EraseRootFromParent_Done,
     /* 262500 */ // Label 5261: @262500
     /* 262500 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(262528), // Rule ID 689 //
     /* 262505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262508 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 262512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262516 */   // MIs[0] Operand 1
     /* 262516 */   // No operand predicates
     /* 262516 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 262516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 262519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262521 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 262526 */   GIR_RootConstrainSelectedInstOperands,
     /* 262527 */   // GIR_Coverage, 689,
     /* 262527 */   GIR_EraseRootFromParent_Done,
     /* 262528 */ // Label 5262: @262528
     /* 262528 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(262589), // Rule ID 6000 //
     /* 262533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262536 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 262540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262544 */   // MIs[0] Operand 1
     /* 262544 */   // No operand predicates
     /* 262544 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 262544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 262551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262556 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 262561 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 262564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262571 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262588 */   // GIR_Coverage, 6000,
     /* 262588 */   GIR_EraseRootFromParent_Done,
     /* 262589 */ // Label 5263: @262589
     /* 262589 */ GIM_Reject,
     /* 262590 */ // Label 5257: @262590
     /* 262590 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(262613), // Rule ID 508 //
     /* 262595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262598 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262606 */   // MIs[0] Operand 1
     /* 262606 */   // No operand predicates
     /* 262606 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 262606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 262609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262611 */   GIR_RootConstrainSelectedInstOperands,
     /* 262612 */   // GIR_Coverage, 508,
     /* 262612 */   GIR_EraseRootFromParent_Done,
     /* 262613 */ // Label 5264: @262613
     /* 262613 */ GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(262641), // Rule ID 690 //
     /* 262618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262621 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 262625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262629 */   // MIs[0] Operand 1
     /* 262629 */   // No operand predicates
     /* 262629 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 262629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 262632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262634 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 262639 */   GIR_RootConstrainSelectedInstOperands,
     /* 262640 */   // GIR_Coverage, 690,
     /* 262640 */   GIR_EraseRootFromParent_Done,
     /* 262641 */ // Label 5265: @262641
     /* 262641 */ GIM_Reject,
     /* 262642 */ // Label 5258: @262642
     /* 262642 */ GIM_Reject,
     /* 262643 */ // Label 41: @262643
     /* 262643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5271*/ GIMT_Encode4(264540),
     /* 262654 */ /*GILLT_s32*//*Label 5266*/ GIMT_Encode4(262690),
     /* 262658 */ /*GILLT_s64*//*Label 5267*/ GIMT_Encode4(264131), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 262670 */ /*GILLT_v2s64*//*Label 5268*/ GIMT_Encode4(264354), GIMT_Encode4(0),
     /* 262678 */ /*GILLT_v4s32*//*Label 5269*/ GIMT_Encode4(264416), GIMT_Encode4(0),
     /* 262686 */ /*GILLT_v8s16*//*Label 5270*/ GIMT_Encode4(264478),
     /* 262690 */ // Label 5266: @262690
     /* 262690 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(262810), // Rule ID 13052 //
     /* 262695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262702 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262710 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262713 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262718 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262722 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262729 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262729 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262732 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 262736 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262741 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262776 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262779 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262782 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262808 */   GIR_RootConstrainSelectedInstOperands,
     /* 262809 */   // GIR_Coverage, 13052,
     /* 262809 */   GIR_EraseRootFromParent_Done,
     /* 262810 */ // Label 5272: @262810
     /* 262810 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(262930), // Rule ID 13054 //
     /* 262815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262822 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262830 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262833 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262849 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262849 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262852 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 262856 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262861 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262867 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262870 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262874 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262899 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262902 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262928 */   GIR_RootConstrainSelectedInstOperands,
     /* 262929 */   // GIR_Coverage, 13054,
     /* 262929 */   GIR_EraseRootFromParent_Done,
     /* 262930 */ // Label 5273: @262930
     /* 262930 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263050), // Rule ID 13056 //
     /* 262935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262942 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262950 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262953 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262962 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262969 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262969 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262972 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 262976 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262981 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262990 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262994 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263016 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263019 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263048 */   GIR_RootConstrainSelectedInstOperands,
     /* 263049 */   // GIR_Coverage, 13056,
     /* 263049 */   GIR_EraseRootFromParent_Done,
     /* 263050 */ // Label 5274: @263050
     /* 263050 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263170), // Rule ID 13058 //
     /* 263055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263062 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263070 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263073 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263089 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263089 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263092 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 263096 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263101 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263107 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263110 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263114 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263133 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263136 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263139 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263168 */   GIR_RootConstrainSelectedInstOperands,
     /* 263169 */   // GIR_Coverage, 13058,
     /* 263169 */   GIR_EraseRootFromParent_Done,
     /* 263170 */ // Label 5275: @263170
     /* 263170 */ GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263290), // Rule ID 13074 //
     /* 263175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263182 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263190 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263193 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263209 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263209 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263212 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 263216 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263221 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263227 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263230 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263234 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263253 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263256 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263259 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263262 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263288 */   GIR_RootConstrainSelectedInstOperands,
     /* 263289 */   // GIR_Coverage, 13074,
     /* 263289 */   GIR_EraseRootFromParent_Done,
     /* 263290 */ // Label 5276: @263290
     /* 263290 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263410), // Rule ID 13076 //
     /* 263295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263302 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263310 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263313 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263318 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263322 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263329 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263329 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263332 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 263336 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263341 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263373 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263376 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263379 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263382 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263408 */   GIR_RootConstrainSelectedInstOperands,
     /* 263409 */   // GIR_Coverage, 13076,
     /* 263409 */   GIR_EraseRootFromParent_Done,
     /* 263410 */ // Label 5277: @263410
     /* 263410 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263530), // Rule ID 13078 //
     /* 263415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263422 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263430 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263433 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263449 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263449 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263452 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 263456 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263461 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263467 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263470 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263474 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263493 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263499 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263528 */   GIR_RootConstrainSelectedInstOperands,
     /* 263529 */   // GIR_Coverage, 13078,
     /* 263529 */   GIR_EraseRootFromParent_Done,
     /* 263530 */ // Label 5278: @263530
     /* 263530 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263650), // Rule ID 13080 //
     /* 263535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263542 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263550 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263553 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263558 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263562 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263569 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263569 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263572 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 263576 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263581 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263587 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263590 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263594 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263613 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263616 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263619 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263648 */   GIR_RootConstrainSelectedInstOperands,
     /* 263649 */   // GIR_Coverage, 13080,
     /* 263649 */   GIR_EraseRootFromParent_Done,
     /* 263650 */ // Label 5279: @263650
     /* 263650 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263770), // Rule ID 13084 //
     /* 263655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263662 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263670 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263673 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263682 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263687 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263689 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263689 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263692 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 263696 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263701 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263707 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263710 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263714 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263733 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263736 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263739 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263752 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263768 */   GIR_RootConstrainSelectedInstOperands,
     /* 263769 */   // GIR_Coverage, 13084,
     /* 263769 */   GIR_EraseRootFromParent_Done,
     /* 263770 */ // Label 5280: @263770
     /* 263770 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263890), // Rule ID 13086 //
     /* 263775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263782 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263790 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263793 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263809 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263809 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263812 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 263816 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263821 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263853 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263856 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263859 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263888 */   GIR_RootConstrainSelectedInstOperands,
     /* 263889 */   // GIR_Coverage, 13086,
     /* 263889 */   GIR_EraseRootFromParent_Done,
     /* 263890 */ // Label 5281: @263890
     /* 263890 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(264010), // Rule ID 13088 //
     /* 263895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263902 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263910 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263913 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263922 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263929 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263929 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263932 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 263936 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263941 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263947 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263950 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263954 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263973 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263976 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263979 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264008 */   GIR_RootConstrainSelectedInstOperands,
     /* 264009 */   // GIR_Coverage, 13088,
     /* 264009 */   GIR_EraseRootFromParent_Done,
     /* 264010 */ // Label 5282: @264010
     /* 264010 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(264130), // Rule ID 13090 //
     /* 264015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264022 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264030 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264033 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264038 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264042 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264049 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264049 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264052 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 264056 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264061 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264093 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264096 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264128 */   GIR_RootConstrainSelectedInstOperands,
     /* 264129 */   // GIR_Coverage, 13090,
     /* 264129 */   GIR_EraseRootFromParent_Done,
     /* 264130 */ // Label 5283: @264130
     /* 264130 */ GIM_Reject,
     /* 264131 */ // Label 5267: @264131
     /* 264131 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264353),
     /* 264136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264143 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264197), // Rule ID 5644 //
     /* 264148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264181 */     // MIs[2] Operand 1
     /* 264181 */     // No operand predicates
     /* 264181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264183 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 264183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264195 */     GIR_RootConstrainSelectedInstOperands,
     /* 264196 */     // GIR_Coverage, 5644,
     /* 264196 */     GIR_EraseRootFromParent_Done,
     /* 264197 */   // Label 5285: @264197
     /* 264197 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264276), // Rule ID 11165 //
     /* 264202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 264217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264233 */     // MIs[2] Operand 1
     /* 264233 */     // No operand predicates
     /* 264233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264235 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 264235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 264238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264274 */     GIR_RootConstrainSelectedInstOperands,
     /* 264275 */     // GIR_Coverage, 11165,
     /* 264275 */     GIR_EraseRootFromParent_Done,
     /* 264276 */   // Label 5286: @264276
     /* 264276 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264352), // Rule ID 6468 //
     /* 264281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264285 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 264285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 264288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 264318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 264350 */     GIR_RootConstrainSelectedInstOperands,
     /* 264351 */     // GIR_Coverage, 6468,
     /* 264351 */     GIR_EraseRootFromParent_Done,
     /* 264352 */   // Label 5287: @264352
     /* 264352 */   GIM_Reject,
     /* 264353 */ // Label 5284: @264353
     /* 264353 */ GIM_Reject,
     /* 264354 */ // Label 5268: @264354
     /* 264354 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264415),
     /* 264359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264366 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264393), // Rule ID 6340 //
     /* 264371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 264378 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 264378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 264381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264391 */     GIR_RootConstrainSelectedInstOperands,
     /* 264392 */     // GIR_Coverage, 6340,
     /* 264392 */     GIR_EraseRootFromParent_Done,
     /* 264393 */   // Label 5289: @264393
     /* 264393 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264414), // Rule ID 6329 //
     /* 264398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264402 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 264402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 264405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264412 */     GIR_RootConstrainSelectedInstOperands,
     /* 264413 */     // GIR_Coverage, 6329,
     /* 264413 */     GIR_EraseRootFromParent_Done,
     /* 264414 */   // Label 5290: @264414
     /* 264414 */   GIM_Reject,
     /* 264415 */ // Label 5288: @264415
     /* 264415 */ GIM_Reject,
     /* 264416 */ // Label 5269: @264416
     /* 264416 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264477),
     /* 264421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264428 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264455), // Rule ID 6337 //
     /* 264433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 264440 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 264440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 264443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264453 */     GIR_RootConstrainSelectedInstOperands,
     /* 264454 */     // GIR_Coverage, 6337,
     /* 264454 */     GIR_EraseRootFromParent_Done,
     /* 264455 */   // Label 5292: @264455
     /* 264455 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264476), // Rule ID 6326 //
     /* 264460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264464 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 264464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 264467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264474 */     GIR_RootConstrainSelectedInstOperands,
     /* 264475 */     // GIR_Coverage, 6326,
     /* 264475 */     GIR_EraseRootFromParent_Done,
     /* 264476 */   // Label 5293: @264476
     /* 264476 */   GIM_Reject,
     /* 264477 */ // Label 5291: @264477
     /* 264477 */ GIM_Reject,
     /* 264478 */ // Label 5270: @264478
     /* 264478 */ GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264539),
     /* 264483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 264486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264490 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264517), // Rule ID 6334 //
     /* 264495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264502 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 264502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 264505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264515 */     GIR_RootConstrainSelectedInstOperands,
     /* 264516 */     // GIR_Coverage, 6334,
     /* 264516 */     GIR_EraseRootFromParent_Done,
     /* 264517 */   // Label 5295: @264517
     /* 264517 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264538), // Rule ID 6323 //
     /* 264522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264526 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 264526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 264529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264536 */     GIR_RootConstrainSelectedInstOperands,
     /* 264537 */     // GIR_Coverage, 6323,
     /* 264537 */     GIR_EraseRootFromParent_Done,
     /* 264538 */   // Label 5296: @264538
     /* 264538 */   GIM_Reject,
     /* 264539 */ // Label 5294: @264539
     /* 264539 */ GIM_Reject,
     /* 264540 */ // Label 5271: @264540
     /* 264540 */ GIM_Reject,
     /* 264541 */ // Label 42: @264541
     /* 264541 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5302*/ GIMT_Encode4(266194),
     /* 264552 */ /*GILLT_s32*//*Label 5297*/ GIMT_Encode4(264632),
     /* 264556 */ /*GILLT_s64*//*Label 5298*/ GIMT_Encode4(265126), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264608 */ /*GILLT_nxv2s64*//*Label 5299*/ GIMT_Encode4(265768), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264620 */ /*GILLT_nxv4s32*//*Label 5300*/ GIMT_Encode4(265977), GIMT_Encode4(0),
     /* 264628 */ /*GILLT_nxv8s16*//*Label 5301*/ GIMT_Encode4(266121),
     /* 264632 */ // Label 5297: @264632
     /* 264632 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(265125),
     /* 264637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264644 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264709), // Rule ID 5639 //
     /* 264649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 264661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264678 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264682 */     // MIs[2] Operand 1
     /* 264682 */     // No operand predicates
     /* 264682 */     // MIs[0] Operand 2
     /* 264682 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264695 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 264695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264707 */     GIR_RootConstrainSelectedInstOperands,
     /* 264708 */     // GIR_Coverage, 5639,
     /* 264708 */     GIR_EraseRootFromParent_Done,
     /* 264709 */   // Label 5304: @264709
     /* 264709 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264774), // Rule ID 5641 //
     /* 264714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264747 */     // MIs[2] Operand 1
     /* 264747 */     // No operand predicates
     /* 264747 */     // MIs[0] Operand 2
     /* 264747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264760 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264772 */     GIR_RootConstrainSelectedInstOperands,
     /* 264773 */     // GIR_Coverage, 5641,
     /* 264773 */     GIR_EraseRootFromParent_Done,
     /* 264774 */   // Label 5305: @264774
     /* 264774 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(264839), // Rule ID 5643 //
     /* 264779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264812 */     // MIs[2] Operand 1
     /* 264812 */     // No operand predicates
     /* 264812 */     // MIs[0] Operand 2
     /* 264812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264825 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264837 */     GIR_RootConstrainSelectedInstOperands,
     /* 264838 */     // GIR_Coverage, 5643,
     /* 264838 */     GIR_EraseRootFromParent_Done,
     /* 264839 */   // Label 5306: @264839
     /* 264839 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(264929), // Rule ID 11161 //
     /* 264844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 264859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264875 */     // MIs[2] Operand 1
     /* 264875 */     // No operand predicates
     /* 264875 */     // MIs[0] Operand 2
     /* 264875 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264888 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 264888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264900 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264927 */     GIR_RootConstrainSelectedInstOperands,
     /* 264928 */     // GIR_Coverage, 11161,
     /* 264928 */     GIR_EraseRootFromParent_Done,
     /* 264929 */   // Label 5307: @264929
     /* 264929 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(265019), // Rule ID 11163 //
     /* 264934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 264949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264965 */     // MIs[2] Operand 1
     /* 264965 */     // No operand predicates
     /* 264965 */     // MIs[0] Operand 2
     /* 264965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264978 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 264978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 264981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265017 */     GIR_RootConstrainSelectedInstOperands,
     /* 265018 */     // GIR_Coverage, 11163,
     /* 265018 */     GIR_EraseRootFromParent_Done,
     /* 265019 */   // Label 5308: @265019
     /* 265019 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(265054), // Rule ID 6473 //
     /* 265024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265028 */     // MIs[0] Operand 2
     /* 265028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265039 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265052 */     GIR_RootConstrainSelectedInstOperands,
     /* 265053 */     // GIR_Coverage, 6473,
     /* 265053 */     GIR_EraseRootFromParent_Done,
     /* 265054 */   // Label 5309: @265054
     /* 265054 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265089), // Rule ID 6474 //
     /* 265059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265063 */     // MIs[0] Operand 2
     /* 265063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265074 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265087 */     GIR_RootConstrainSelectedInstOperands,
     /* 265088 */     // GIR_Coverage, 6474,
     /* 265088 */     GIR_EraseRootFromParent_Done,
     /* 265089 */   // Label 5310: @265089
     /* 265089 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265124), // Rule ID 6475 //
     /* 265094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265098 */     // MIs[0] Operand 2
     /* 265098 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265109 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265122 */     GIR_RootConstrainSelectedInstOperands,
     /* 265123 */     // GIR_Coverage, 6475,
     /* 265123 */     GIR_EraseRootFromParent_Done,
     /* 265124 */   // Label 5311: @265124
     /* 265124 */   GIM_Reject,
     /* 265125 */ // Label 5303: @265125
     /* 265125 */ GIM_Reject,
     /* 265126 */ // Label 5298: @265126
     /* 265126 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265767),
     /* 265131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265138 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265215), // Rule ID 5645 //
     /* 265143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265188 */     // MIs[3] Operand 1
     /* 265188 */     // No operand predicates
     /* 265188 */     // MIs[0] Operand 2
     /* 265188 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265201 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265213 */     GIR_RootConstrainSelectedInstOperands,
     /* 265214 */     // GIR_Coverage, 5645,
     /* 265214 */     GIR_EraseRootFromParent_Done,
     /* 265215 */   // Label 5313: @265215
     /* 265215 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265292), // Rule ID 5646 //
     /* 265220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265261 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265265 */     // MIs[3] Operand 1
     /* 265265 */     // No operand predicates
     /* 265265 */     // MIs[0] Operand 2
     /* 265265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265278 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265290 */     GIR_RootConstrainSelectedInstOperands,
     /* 265291 */     // GIR_Coverage, 5646,
     /* 265291 */     GIR_EraseRootFromParent_Done,
     /* 265292 */   // Label 5314: @265292
     /* 265292 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265394), // Rule ID 11162 //
     /* 265297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265336 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265340 */     // MIs[3] Operand 1
     /* 265340 */     // No operand predicates
     /* 265340 */     // MIs[0] Operand 2
     /* 265340 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265353 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265392 */     GIR_RootConstrainSelectedInstOperands,
     /* 265393 */     // GIR_Coverage, 11162,
     /* 265393 */     GIR_EraseRootFromParent_Done,
     /* 265394 */   // Label 5315: @265394
     /* 265394 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265496), // Rule ID 11164 //
     /* 265399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265442 */     // MIs[3] Operand 1
     /* 265442 */     // No operand predicates
     /* 265442 */     // MIs[0] Operand 2
     /* 265442 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265455 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265494 */     GIR_RootConstrainSelectedInstOperands,
     /* 265495 */     // GIR_Coverage, 11164,
     /* 265495 */     GIR_EraseRootFromParent_Done,
     /* 265496 */   // Label 5316: @265496
     /* 265496 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(265561), // Rule ID 5640 //
     /* 265501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265534 */     // MIs[2] Operand 1
     /* 265534 */     // No operand predicates
     /* 265534 */     // MIs[0] Operand 2
     /* 265534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265547 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265559 */     GIR_RootConstrainSelectedInstOperands,
     /* 265560 */     // GIR_Coverage, 5640,
     /* 265560 */     GIR_EraseRootFromParent_Done,
     /* 265561 */   // Label 5317: @265561
     /* 265561 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(265626), // Rule ID 5642 //
     /* 265566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265599 */     // MIs[2] Operand 1
     /* 265599 */     // No operand predicates
     /* 265599 */     // MIs[0] Operand 2
     /* 265599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265612 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265624 */     GIR_RootConstrainSelectedInstOperands,
     /* 265625 */     // GIR_Coverage, 5642,
     /* 265625 */     GIR_EraseRootFromParent_Done,
     /* 265626 */   // Label 5318: @265626
     /* 265626 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(265661), // Rule ID 6469 //
     /* 265631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265635 */     // MIs[0] Operand 2
     /* 265635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265646 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 265646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265659 */     GIR_RootConstrainSelectedInstOperands,
     /* 265660 */     // GIR_Coverage, 6469,
     /* 265660 */     GIR_EraseRootFromParent_Done,
     /* 265661 */   // Label 5319: @265661
     /* 265661 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(265696), // Rule ID 6470 //
     /* 265666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265670 */     // MIs[0] Operand 2
     /* 265670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265681 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265694 */     GIR_RootConstrainSelectedInstOperands,
     /* 265695 */     // GIR_Coverage, 6470,
     /* 265695 */     GIR_EraseRootFromParent_Done,
     /* 265696 */   // Label 5320: @265696
     /* 265696 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(265731), // Rule ID 6471 //
     /* 265701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265705 */     // MIs[0] Operand 2
     /* 265705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265716 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265729 */     GIR_RootConstrainSelectedInstOperands,
     /* 265730 */     // GIR_Coverage, 6471,
     /* 265730 */     GIR_EraseRootFromParent_Done,
     /* 265731 */   // Label 5321: @265731
     /* 265731 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(265766), // Rule ID 6472 //
     /* 265736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265740 */     // MIs[0] Operand 2
     /* 265740 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265751 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265764 */     GIR_RootConstrainSelectedInstOperands,
     /* 265765 */     // GIR_Coverage, 6472,
     /* 265765 */     GIR_EraseRootFromParent_Done,
     /* 265766 */   // Label 5322: @265766
     /* 265766 */   GIM_Reject,
     /* 265767 */ // Label 5312: @265767
     /* 265767 */ GIM_Reject,
     /* 265768 */ // Label 5299: @265768
     /* 265768 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265976),
     /* 265773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 265776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265780 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(265845), // Rule ID 10445 //
     /* 265785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265788 */     // MIs[0] Operand 2
     /* 265788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265799 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265811 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 265833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265843 */     GIR_RootConstrainSelectedInstOperands,
     /* 265844 */     // GIR_Coverage, 10445,
     /* 265844 */     GIR_EraseRootFromParent_Done,
     /* 265845 */   // Label 5324: @265845
     /* 265845 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265910), // Rule ID 10446 //
     /* 265850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265853 */     // MIs[0] Operand 2
     /* 265853 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265864 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265876 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 265898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265908 */     GIR_RootConstrainSelectedInstOperands,
     /* 265909 */     // GIR_Coverage, 10446,
     /* 265909 */     GIR_EraseRootFromParent_Done,
     /* 265910 */   // Label 5325: @265910
     /* 265910 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265975), // Rule ID 10447 //
     /* 265915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265918 */     // MIs[0] Operand 2
     /* 265918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265929 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265941 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 265963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265973 */     GIR_RootConstrainSelectedInstOperands,
     /* 265974 */     // GIR_Coverage, 10447,
     /* 265974 */     GIR_EraseRootFromParent_Done,
     /* 265975 */   // Label 5326: @265975
     /* 265975 */   GIM_Reject,
     /* 265976 */ // Label 5323: @265976
     /* 265976 */ GIM_Reject,
     /* 265977 */ // Label 5300: @265977
     /* 265977 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(266120),
     /* 265982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 265985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265989 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(266054), // Rule ID 10448 //
     /* 265994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265997 */     // MIs[0] Operand 2
     /* 265997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266008 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266020 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 266042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266052 */     GIR_RootConstrainSelectedInstOperands,
     /* 266053 */     // GIR_Coverage, 10448,
     /* 266053 */     GIR_EraseRootFromParent_Done,
     /* 266054 */   // Label 5328: @266054
     /* 266054 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266119), // Rule ID 10449 //
     /* 266059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266062 */     // MIs[0] Operand 2
     /* 266062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266073 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266085 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 266107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266117 */     GIR_RootConstrainSelectedInstOperands,
     /* 266118 */     // GIR_Coverage, 10449,
     /* 266118 */     GIR_EraseRootFromParent_Done,
     /* 266119 */   // Label 5329: @266119
     /* 266119 */   GIM_Reject,
     /* 266120 */ // Label 5327: @266120
     /* 266120 */ GIM_Reject,
     /* 266121 */ // Label 5301: @266121
     /* 266121 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266193), // Rule ID 10450 //
     /* 266126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 266132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266136 */   // MIs[0] Operand 2
     /* 266136 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266147 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 266147 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266150 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 266154 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266159 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 266181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266189 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266191 */   GIR_RootConstrainSelectedInstOperands,
     /* 266192 */   // GIR_Coverage, 10450,
     /* 266192 */   GIR_EraseRootFromParent_Done,
     /* 266193 */ // Label 5330: @266193
     /* 266193 */ GIM_Reject,
     /* 266194 */ // Label 5302: @266194
     /* 266194 */ GIM_Reject,
     /* 266195 */ // Label 43: @266195
     /* 266195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5335*/ GIMT_Encode4(268973),
     /* 266206 */ /*GILLT_s32*//*Label 5331*/ GIMT_Encode4(266242), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 266222 */ /*GILLT_v2s64*//*Label 5332*/ GIMT_Encode4(268043), GIMT_Encode4(0),
     /* 266230 */ /*GILLT_v4s32*//*Label 5333*/ GIMT_Encode4(268353), GIMT_Encode4(0),
     /* 266238 */ /*GILLT_v8s16*//*Label 5334*/ GIMT_Encode4(268663),
     /* 266242 */ // Label 5331: @266242
     /* 266242 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266392), // Rule ID 13061 //
     /* 266247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266254 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266262 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266265 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266281 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266281 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266284 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 266288 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266293 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266313 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266316 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266320 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266325 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266328 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266331 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266334 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266339 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266344 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266361 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266391 */   // GIR_Coverage, 13061,
     /* 266391 */   GIR_EraseRootFromParent_Done,
     /* 266392 */ // Label 5336: @266392
     /* 266392 */ GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266542), // Rule ID 13063 //
     /* 266397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266404 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266412 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266415 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266420 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266424 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266431 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266431 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266434 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 266438 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266443 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266449 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266452 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266456 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266475 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266478 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266481 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266494 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266511 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266541 */   // GIR_Coverage, 13063,
     /* 266541 */   GIR_EraseRootFromParent_Done,
     /* 266542 */ // Label 5337: @266542
     /* 266542 */ GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266692), // Rule ID 13065 //
     /* 266547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266554 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266562 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266565 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266574 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266581 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266581 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266584 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 266588 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266593 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266599 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266602 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266606 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266613 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266616 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266620 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266625 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266628 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266631 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266634 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266639 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266644 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266661 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266673 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266686 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266691 */   // GIR_Coverage, 13065,
     /* 266691 */   GIR_EraseRootFromParent_Done,
     /* 266692 */ // Label 5338: @266692
     /* 266692 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(266842), // Rule ID 13067 //
     /* 266697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266704 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266712 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266715 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266731 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266731 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266734 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 266738 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266743 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266749 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266752 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266756 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266775 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266778 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266781 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266784 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266789 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266794 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266811 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266841 */   // GIR_Coverage, 13067,
     /* 266841 */   GIR_EraseRootFromParent_Done,
     /* 266842 */ // Label 5339: @266842
     /* 266842 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(266992), // Rule ID 13094 //
     /* 266847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266854 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266862 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266865 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266881 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266881 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266884 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 266888 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266893 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266899 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266902 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266906 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266925 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266928 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266931 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266934 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266939 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266944 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266961 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266991 */   // GIR_Coverage, 13094,
     /* 266991 */   GIR_EraseRootFromParent_Done,
     /* 266992 */ // Label 5340: @266992
     /* 266992 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(267142), // Rule ID 13096 //
     /* 266997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267004 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267012 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267015 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267020 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267024 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267031 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267031 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267034 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 267038 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267043 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267049 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267052 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267056 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267075 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267078 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267081 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267084 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267089 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267094 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267111 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267118 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267141 */   // GIR_Coverage, 13096,
     /* 267141 */   GIR_EraseRootFromParent_Done,
     /* 267142 */ // Label 5341: @267142
     /* 267142 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267292), // Rule ID 13098 //
     /* 267147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267154 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267162 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267165 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267174 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267181 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267181 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267184 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 267188 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267193 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267199 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267202 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267206 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267213 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267216 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267220 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267225 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267228 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267231 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267234 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267239 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267244 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267261 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267291 */   // GIR_Coverage, 13098,
     /* 267291 */   GIR_EraseRootFromParent_Done,
     /* 267292 */ // Label 5342: @267292
     /* 267292 */ GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267442), // Rule ID 13100 //
     /* 267297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267304 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267312 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267315 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267324 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267331 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267331 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267334 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 267338 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267343 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267349 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267352 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267356 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267363 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267366 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267370 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267375 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267378 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267381 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267384 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267389 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267394 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267411 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267441 */   // GIR_Coverage, 13100,
     /* 267441 */   GIR_EraseRootFromParent_Done,
     /* 267442 */ // Label 5343: @267442
     /* 267442 */ GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267592), // Rule ID 13104 //
     /* 267447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267454 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267462 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267465 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267470 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267474 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267481 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267481 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267484 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 267488 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267493 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267499 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267502 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267506 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267513 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267516 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267520 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267525 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267528 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267531 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267534 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267539 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267544 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267561 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267591 */   // GIR_Coverage, 13104,
     /* 267591 */   GIR_EraseRootFromParent_Done,
     /* 267592 */ // Label 5344: @267592
     /* 267592 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267742), // Rule ID 13106 //
     /* 267597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267604 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267612 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267615 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267620 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267624 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267629 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267631 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267631 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267634 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 267638 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267643 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267649 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267652 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267656 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267663 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267666 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267670 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267675 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267678 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267681 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267684 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267689 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267694 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267711 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267723 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267741 */   // GIR_Coverage, 13106,
     /* 267741 */   GIR_EraseRootFromParent_Done,
     /* 267742 */ // Label 5345: @267742
     /* 267742 */ GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267892), // Rule ID 13108 //
     /* 267747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267754 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267762 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267765 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267774 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267781 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267781 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267784 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 267788 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267793 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267813 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267816 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267820 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267825 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267828 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267831 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267834 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267839 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267844 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267861 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267891 */   // GIR_Coverage, 13108,
     /* 267891 */   GIR_EraseRootFromParent_Done,
     /* 267892 */ // Label 5346: @267892
     /* 267892 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(268042), // Rule ID 13110 //
     /* 267897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267904 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267912 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267915 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267920 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267924 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267931 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267931 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267934 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 267938 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267943 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267949 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267952 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267956 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267963 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267966 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267970 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267975 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267978 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267981 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267984 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267989 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267994 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268011 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268041 */   // GIR_Coverage, 13110,
     /* 268041 */   GIR_EraseRootFromParent_Done,
     /* 268042 */ // Label 5347: @268042
     /* 268042 */ GIM_Reject,
     /* 268043 */ // Label 5332: @268043
     /* 268043 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(268352),
     /* 268048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268055 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(268120), // Rule ID 702 //
     /* 268060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268071 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268074 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268083 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268103 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 268106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268118 */     GIR_RootConstrainSelectedInstOperands,
     /* 268119 */     // GIR_Coverage, 702,
     /* 268119 */     GIR_EraseRootFromParent_Done,
     /* 268120 */   // Label 5349: @268120
     /* 268120 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(268185), // Rule ID 1711 //
     /* 268125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268136 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268139 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268168 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 268171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268183 */     GIR_RootConstrainSelectedInstOperands,
     /* 268184 */     // GIR_Coverage, 1711,
     /* 268184 */     GIR_EraseRootFromParent_Done,
     /* 268185 */   // Label 5350: @268185
     /* 268185 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(268244), // Rule ID 700 //
     /* 268190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268201 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268204 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268213 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268229 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 268232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268242 */     GIR_RootConstrainSelectedInstOperands,
     /* 268243 */     // GIR_Coverage, 700,
     /* 268243 */     GIR_EraseRootFromParent_Done,
     /* 268244 */   // Label 5351: @268244
     /* 268244 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(268303), // Rule ID 1709 //
     /* 268249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268260 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268263 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268272 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268288 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 268291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268301 */     GIR_RootConstrainSelectedInstOperands,
     /* 268302 */     // GIR_Coverage, 1709,
     /* 268302 */     GIR_EraseRootFromParent_Done,
     /* 268303 */   // Label 5352: @268303
     /* 268303 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(268330), // Rule ID 6339 //
     /* 268308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268315 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 268315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 268318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268328 */     GIR_RootConstrainSelectedInstOperands,
     /* 268329 */     // GIR_Coverage, 6339,
     /* 268329 */     GIR_EraseRootFromParent_Done,
     /* 268330 */   // Label 5353: @268330
     /* 268330 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(268351), // Rule ID 6330 //
     /* 268335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268339 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 268339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 268342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268349 */     GIR_RootConstrainSelectedInstOperands,
     /* 268350 */     // GIR_Coverage, 6330,
     /* 268350 */     GIR_EraseRootFromParent_Done,
     /* 268351 */   // Label 5354: @268351
     /* 268351 */   GIM_Reject,
     /* 268352 */ // Label 5348: @268352
     /* 268352 */ GIM_Reject,
     /* 268353 */ // Label 5333: @268353
     /* 268353 */ GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(268662),
     /* 268358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268365 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(268430), // Rule ID 698 //
     /* 268370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268381 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268384 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268413 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 268416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268428 */     GIR_RootConstrainSelectedInstOperands,
     /* 268429 */     // GIR_Coverage, 698,
     /* 268429 */     GIR_EraseRootFromParent_Done,
     /* 268430 */   // Label 5356: @268430
     /* 268430 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(268495), // Rule ID 1707 //
     /* 268435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268478 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 268481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268493 */     GIR_RootConstrainSelectedInstOperands,
     /* 268494 */     // GIR_Coverage, 1707,
     /* 268494 */     GIR_EraseRootFromParent_Done,
     /* 268495 */   // Label 5357: @268495
     /* 268495 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(268554), // Rule ID 696 //
     /* 268500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268539 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 268542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268552 */     GIR_RootConstrainSelectedInstOperands,
     /* 268553 */     // GIR_Coverage, 696,
     /* 268553 */     GIR_EraseRootFromParent_Done,
     /* 268554 */   // Label 5358: @268554
     /* 268554 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(268613), // Rule ID 1705 //
     /* 268559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268570 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268573 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268582 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268598 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 268601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268611 */     GIR_RootConstrainSelectedInstOperands,
     /* 268612 */     // GIR_Coverage, 1705,
     /* 268612 */     GIR_EraseRootFromParent_Done,
     /* 268613 */   // Label 5359: @268613
     /* 268613 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268640), // Rule ID 6336 //
     /* 268618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268625 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 268625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 268628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268638 */     GIR_RootConstrainSelectedInstOperands,
     /* 268639 */     // GIR_Coverage, 6336,
     /* 268639 */     GIR_EraseRootFromParent_Done,
     /* 268640 */   // Label 5360: @268640
     /* 268640 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(268661), // Rule ID 6327 //
     /* 268645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268649 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 268649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 268652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268659 */     GIR_RootConstrainSelectedInstOperands,
     /* 268660 */     // GIR_Coverage, 6327,
     /* 268660 */     GIR_EraseRootFromParent_Done,
     /* 268661 */   // Label 5361: @268661
     /* 268661 */   GIM_Reject,
     /* 268662 */ // Label 5355: @268662
     /* 268662 */ GIM_Reject,
     /* 268663 */ // Label 5334: @268663
     /* 268663 */ GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(268972),
     /* 268668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 268671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268675 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(268740), // Rule ID 694 //
     /* 268680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268691 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268694 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268703 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268723 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 268726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268738 */     GIR_RootConstrainSelectedInstOperands,
     /* 268739 */     // GIR_Coverage, 694,
     /* 268739 */     GIR_EraseRootFromParent_Done,
     /* 268740 */   // Label 5363: @268740
     /* 268740 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(268805), // Rule ID 1703 //
     /* 268745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268756 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268759 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268788 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 268791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268803 */     GIR_RootConstrainSelectedInstOperands,
     /* 268804 */     // GIR_Coverage, 1703,
     /* 268804 */     GIR_EraseRootFromParent_Done,
     /* 268805 */   // Label 5364: @268805
     /* 268805 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(268864), // Rule ID 692 //
     /* 268810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268821 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268824 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268833 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268849 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 268852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268862 */     GIR_RootConstrainSelectedInstOperands,
     /* 268863 */     // GIR_Coverage, 692,
     /* 268863 */     GIR_EraseRootFromParent_Done,
     /* 268864 */   // Label 5365: @268864
     /* 268864 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(268923), // Rule ID 1701 //
     /* 268869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268880 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268883 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268892 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268908 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 268911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268921 */     GIR_RootConstrainSelectedInstOperands,
     /* 268922 */     // GIR_Coverage, 1701,
     /* 268922 */     GIR_EraseRootFromParent_Done,
     /* 268923 */   // Label 5366: @268923
     /* 268923 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(268950), // Rule ID 6333 //
     /* 268928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268935 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 268935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 268938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268948 */     GIR_RootConstrainSelectedInstOperands,
     /* 268949 */     // GIR_Coverage, 6333,
     /* 268949 */     GIR_EraseRootFromParent_Done,
     /* 268950 */   // Label 5367: @268950
     /* 268950 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(268971), // Rule ID 6324 //
     /* 268955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268959 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 268959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 268962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268969 */     GIR_RootConstrainSelectedInstOperands,
     /* 268970 */     // GIR_Coverage, 6324,
     /* 268970 */     GIR_EraseRootFromParent_Done,
     /* 268971 */   // Label 5368: @268971
     /* 268971 */   GIM_Reject,
     /* 268972 */ // Label 5362: @268972
     /* 268972 */ GIM_Reject,
     /* 268973 */ // Label 5335: @268973
     /* 268973 */ GIM_Reject,
     /* 268974 */ // Label 44: @268974
     /* 268974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5374*/ GIMT_Encode4(269753),
     /* 268985 */ /*GILLT_s32*//*Label 5369*/ GIMT_Encode4(269021),
     /* 268989 */ /*GILLT_s64*//*Label 5370*/ GIMT_Encode4(269153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 269001 */ /*GILLT_v2s64*//*Label 5371*/ GIMT_Encode4(269326), GIMT_Encode4(0),
     /* 269009 */ /*GILLT_v4s32*//*Label 5372*/ GIMT_Encode4(269471), GIMT_Encode4(0),
     /* 269017 */ /*GILLT_v8s16*//*Label 5373*/ GIMT_Encode4(269612),
     /* 269021 */ // Label 5369: @269021
     /* 269021 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(269152),
     /* 269026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269040 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(269077), // Rule ID 3927 //
     /* 269045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269064 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269075 */     GIR_RootConstrainSelectedInstOperands,
     /* 269076 */     // GIR_Coverage, 3927,
     /* 269076 */     GIR_EraseRootFromParent_Done,
     /* 269077 */   // Label 5376: @269077
     /* 269077 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(269114), // Rule ID 3928 //
     /* 269082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269101 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269112 */     GIR_RootConstrainSelectedInstOperands,
     /* 269113 */     // GIR_Coverage, 3928,
     /* 269113 */     GIR_EraseRootFromParent_Done,
     /* 269114 */   // Label 5377: @269114
     /* 269114 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(269151), // Rule ID 3926 //
     /* 269119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269138 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269149 */     GIR_RootConstrainSelectedInstOperands,
     /* 269150 */     // GIR_Coverage, 3926,
     /* 269150 */     GIR_EraseRootFromParent_Done,
     /* 269151 */   // Label 5378: @269151
     /* 269151 */   GIM_Reject,
     /* 269152 */ // Label 5375: @269152
     /* 269152 */ GIM_Reject,
     /* 269153 */ // Label 5370: @269153
     /* 269153 */ GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(269325),
     /* 269158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269172 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(269240), // Rule ID 3929 //
     /* 269177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269196 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269238 */     GIR_RootConstrainSelectedInstOperands,
     /* 269239 */     // GIR_Coverage, 3929,
     /* 269239 */     GIR_EraseRootFromParent_Done,
     /* 269240 */   // Label 5380: @269240
     /* 269240 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(269308), // Rule ID 3930 //
     /* 269245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269264 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269306 */     GIR_RootConstrainSelectedInstOperands,
     /* 269307 */     // GIR_Coverage, 3930,
     /* 269307 */     GIR_EraseRootFromParent_Done,
     /* 269308 */   // Label 5381: @269308
     /* 269308 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(269324), // Rule ID 120 //
     /* 269313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269317 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269322 */     GIR_RootConstrainSelectedInstOperands,
     /* 269323 */     // GIR_Coverage, 120,
     /* 269323 */     GIR_Done,
     /* 269324 */   // Label 5382: @269324
     /* 269324 */   GIM_Reject,
     /* 269325 */ // Label 5379: @269325
     /* 269325 */ GIM_Reject,
     /* 269326 */ // Label 5371: @269326
     /* 269326 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(269470),
     /* 269331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 269334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 269337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269341 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269405), // Rule ID 6322 //
     /* 269346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269383 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269387 */     // MIs[3] Operand 1
     /* 269387 */     // No operand predicates
     /* 269387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269389 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 269392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269398 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269403 */     GIR_RootConstrainSelectedInstOperands,
     /* 269404 */     // GIR_Coverage, 6322,
     /* 269404 */     GIR_EraseRootFromParent_Done,
     /* 269405 */   // Label 5384: @269405
     /* 269405 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(269469), // Rule ID 6319 //
     /* 269410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269447 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269451 */     // MIs[3] Operand 1
     /* 269451 */     // No operand predicates
     /* 269451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269453 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 269456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269462 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269467 */     GIR_RootConstrainSelectedInstOperands,
     /* 269468 */     // GIR_Coverage, 6319,
     /* 269468 */     GIR_EraseRootFromParent_Done,
     /* 269469 */   // Label 5385: @269469
     /* 269469 */   GIM_Reject,
     /* 269470 */ // Label 5383: @269470
     /* 269470 */ GIM_Reject,
     /* 269471 */ // Label 5372: @269471
     /* 269471 */ GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(269611),
     /* 269476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269486 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(269548), // Rule ID 6321 //
     /* 269491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269528 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269532 */     // MIs[3] Operand 1
     /* 269532 */     // No operand predicates
     /* 269532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269534 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 269537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269546 */     GIR_RootConstrainSelectedInstOperands,
     /* 269547 */     // GIR_Coverage, 6321,
     /* 269547 */     GIR_EraseRootFromParent_Done,
     /* 269548 */   // Label 5387: @269548
     /* 269548 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269610), // Rule ID 6318 //
     /* 269553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269594 */     // MIs[3] Operand 1
     /* 269594 */     // No operand predicates
     /* 269594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269596 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 269599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269608 */     GIR_RootConstrainSelectedInstOperands,
     /* 269609 */     // GIR_Coverage, 6318,
     /* 269609 */     GIR_EraseRootFromParent_Done,
     /* 269610 */   // Label 5388: @269610
     /* 269610 */   GIM_Reject,
     /* 269611 */ // Label 5386: @269611
     /* 269611 */ GIM_Reject,
     /* 269612 */ // Label 5373: @269612
     /* 269612 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269752),
     /* 269617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 269620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269627 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269689), // Rule ID 6320 //
     /* 269632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269669 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269673 */     // MIs[3] Operand 1
     /* 269673 */     // No operand predicates
     /* 269673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269675 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 269678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269687 */     GIR_RootConstrainSelectedInstOperands,
     /* 269688 */     // GIR_Coverage, 6320,
     /* 269688 */     GIR_EraseRootFromParent_Done,
     /* 269689 */   // Label 5390: @269689
     /* 269689 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269751), // Rule ID 6317 //
     /* 269694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269731 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269735 */     // MIs[3] Operand 1
     /* 269735 */     // No operand predicates
     /* 269735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269737 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 269740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269749 */     GIR_RootConstrainSelectedInstOperands,
     /* 269750 */     // GIR_Coverage, 6317,
     /* 269750 */     GIR_EraseRootFromParent_Done,
     /* 269751 */   // Label 5391: @269751
     /* 269751 */   GIM_Reject,
     /* 269752 */ // Label 5389: @269752
     /* 269752 */ GIM_Reject,
     /* 269753 */ // Label 5374: @269753
     /* 269753 */ GIM_Reject,
     /* 269754 */ // Label 45: @269754
     /* 269754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5394*/ GIMT_Encode4(270146),
     /* 269765 */ /*GILLT_s32*//*Label 5392*/ GIMT_Encode4(269773),
     /* 269769 */ /*GILLT_s64*//*Label 5393*/ GIMT_Encode4(269939),
     /* 269773 */ // Label 5392: @269773
     /* 269773 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(269938),
     /* 269778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269792 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(269826), // Rule ID 4016 //
     /* 269797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269809 */     // MIs[1] Operand 1
     /* 269809 */     // No operand predicates
     /* 269809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269811 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 269811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 269814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 269824 */     GIR_RootConstrainSelectedInstOperands,
     /* 269825 */     // GIR_Coverage, 4016,
     /* 269825 */     GIR_EraseRootFromParent_Done,
     /* 269826 */   // Label 5396: @269826
     /* 269826 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(269863), // Rule ID 3933 //
     /* 269831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269850 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269861 */     GIR_RootConstrainSelectedInstOperands,
     /* 269862 */     // GIR_Coverage, 3933,
     /* 269862 */     GIR_EraseRootFromParent_Done,
     /* 269863 */   // Label 5397: @269863
     /* 269863 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(269900), // Rule ID 3934 //
     /* 269868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269887 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269898 */     GIR_RootConstrainSelectedInstOperands,
     /* 269899 */     // GIR_Coverage, 3934,
     /* 269899 */     GIR_EraseRootFromParent_Done,
     /* 269900 */   // Label 5398: @269900
     /* 269900 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(269937), // Rule ID 3932 //
     /* 269905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269924 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269935 */     GIR_RootConstrainSelectedInstOperands,
     /* 269936 */     // GIR_Coverage, 3932,
     /* 269936 */     GIR_EraseRootFromParent_Done,
     /* 269937 */   // Label 5399: @269937
     /* 269937 */   GIM_Reject,
     /* 269938 */ // Label 5395: @269938
     /* 269938 */ GIM_Reject,
     /* 269939 */ // Label 5393: @269939
     /* 269939 */ GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270145),
     /* 269944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269958 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(269992), // Rule ID 4017 //
     /* 269963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 269975 */     // MIs[1] Operand 1
     /* 269975 */     // No operand predicates
     /* 269975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269977 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 269977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 269980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 269990 */     GIR_RootConstrainSelectedInstOperands,
     /* 269991 */     // GIR_Coverage, 4017,
     /* 269991 */     GIR_EraseRootFromParent_Done,
     /* 269992 */   // Label 5401: @269992
     /* 269992 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270060), // Rule ID 3935 //
     /* 269997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270016 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270058 */     GIR_RootConstrainSelectedInstOperands,
     /* 270059 */     // GIR_Coverage, 3935,
     /* 270059 */     GIR_EraseRootFromParent_Done,
     /* 270060 */   // Label 5402: @270060
     /* 270060 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270128), // Rule ID 3936 //
     /* 270065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270084 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270126 */     GIR_RootConstrainSelectedInstOperands,
     /* 270127 */     // GIR_Coverage, 3936,
     /* 270127 */     GIR_EraseRootFromParent_Done,
     /* 270128 */   // Label 5403: @270128
     /* 270128 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270144), // Rule ID 121 //
     /* 270133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270137 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270142 */     GIR_RootConstrainSelectedInstOperands,
     /* 270143 */     // GIR_Coverage, 121,
     /* 270143 */     GIR_Done,
     /* 270144 */   // Label 5404: @270144
     /* 270144 */   GIM_Reject,
     /* 270145 */ // Label 5400: @270145
     /* 270145 */ GIM_Reject,
     /* 270146 */ // Label 5394: @270146
     /* 270146 */ GIM_Reject,
     /* 270147 */ // Label 46: @270147
     /* 270147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5407*/ GIMT_Encode4(270922),
     /* 270158 */ /*GILLT_s32*//*Label 5405*/ GIMT_Encode4(270166),
     /* 270162 */ /*GILLT_s64*//*Label 5406*/ GIMT_Encode4(270472),
     /* 270166 */ // Label 5405: @270166
     /* 270166 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270471),
     /* 270171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270181 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(270245), // Rule ID 6482 //
     /* 270186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270203 */     // MIs[1] Operand 2
     /* 270203 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270226 */     // MIs[2] Operand 1
     /* 270226 */     // No operand predicates
     /* 270226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270228 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270243 */     GIR_RootConstrainSelectedInstOperands,
     /* 270244 */     // GIR_Coverage, 6482,
     /* 270244 */     GIR_EraseRootFromParent_Done,
     /* 270245 */   // Label 5409: @270245
     /* 270245 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(270309), // Rule ID 6484 //
     /* 270250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270267 */     // MIs[1] Operand 2
     /* 270267 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270290 */     // MIs[2] Operand 1
     /* 270290 */     // No operand predicates
     /* 270290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270292 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270307 */     GIR_RootConstrainSelectedInstOperands,
     /* 270308 */     // GIR_Coverage, 6484,
     /* 270308 */     GIR_EraseRootFromParent_Done,
     /* 270309 */   // Label 5410: @270309
     /* 270309 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270347), // Rule ID 4014 //
     /* 270314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270330 */     // MIs[1] Operand 1
     /* 270330 */     // No operand predicates
     /* 270330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270332 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270345 */     GIR_RootConstrainSelectedInstOperands,
     /* 270346 */     // GIR_Coverage, 4014,
     /* 270346 */     GIR_EraseRootFromParent_Done,
     /* 270347 */   // Label 5411: @270347
     /* 270347 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(270388), // Rule ID 2435 //
     /* 270352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270375 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270386 */     GIR_RootConstrainSelectedInstOperands,
     /* 270387 */     // GIR_Coverage, 2435,
     /* 270387 */     GIR_EraseRootFromParent_Done,
     /* 270388 */   // Label 5412: @270388
     /* 270388 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(270429), // Rule ID 2436 //
     /* 270393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270416 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270427 */     GIR_RootConstrainSelectedInstOperands,
     /* 270428 */     // GIR_Coverage, 2436,
     /* 270428 */     GIR_EraseRootFromParent_Done,
     /* 270429 */   // Label 5413: @270429
     /* 270429 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(270470), // Rule ID 2434 //
     /* 270434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270457 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270468 */     GIR_RootConstrainSelectedInstOperands,
     /* 270469 */     // GIR_Coverage, 2434,
     /* 270469 */     GIR_EraseRootFromParent_Done,
     /* 270470 */   // Label 5414: @270470
     /* 270470 */   GIM_Reject,
     /* 270471 */ // Label 5408: @270471
     /* 270471 */ GIM_Reject,
     /* 270472 */ // Label 5406: @270472
     /* 270472 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270921),
     /* 270477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270487 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270551), // Rule ID 6483 //
     /* 270492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270509 */     // MIs[1] Operand 2
     /* 270509 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270532 */     // MIs[2] Operand 1
     /* 270532 */     // No operand predicates
     /* 270532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270534 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270549 */     GIR_RootConstrainSelectedInstOperands,
     /* 270550 */     // GIR_Coverage, 6483,
     /* 270550 */     GIR_EraseRootFromParent_Done,
     /* 270551 */   // Label 5416: @270551
     /* 270551 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270615), // Rule ID 6485 //
     /* 270556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270573 */     // MIs[1] Operand 2
     /* 270573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270596 */     // MIs[2] Operand 1
     /* 270596 */     // No operand predicates
     /* 270596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270598 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270613 */     GIR_RootConstrainSelectedInstOperands,
     /* 270614 */     // GIR_Coverage, 6485,
     /* 270614 */     GIR_EraseRootFromParent_Done,
     /* 270615 */   // Label 5417: @270615
     /* 270615 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270718), // Rule ID 6486 //
     /* 270620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270649 */     // MIs[2] Operand 1
     /* 270649 */     // No operand predicates
     /* 270649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270651 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 270665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270716 */     GIR_RootConstrainSelectedInstOperands,
     /* 270717 */     // GIR_Coverage, 6486,
     /* 270717 */     GIR_EraseRootFromParent_Done,
     /* 270718 */   // Label 5418: @270718
     /* 270718 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270756), // Rule ID 4015 //
     /* 270723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270739 */     // MIs[1] Operand 1
     /* 270739 */     // No operand predicates
     /* 270739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270741 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 270741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270754 */     GIR_RootConstrainSelectedInstOperands,
     /* 270755 */     // GIR_Coverage, 4015,
     /* 270755 */     GIR_EraseRootFromParent_Done,
     /* 270756 */   // Label 5419: @270756
     /* 270756 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270828), // Rule ID 2437 //
     /* 270761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270784 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270796 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270826 */     GIR_RootConstrainSelectedInstOperands,
     /* 270827 */     // GIR_Coverage, 2437,
     /* 270827 */     GIR_EraseRootFromParent_Done,
     /* 270828 */   // Label 5420: @270828
     /* 270828 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(270900), // Rule ID 2438 //
     /* 270833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270856 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270875 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270898 */     GIR_RootConstrainSelectedInstOperands,
     /* 270899 */     // GIR_Coverage, 2438,
     /* 270899 */     GIR_EraseRootFromParent_Done,
     /* 270900 */   // Label 5421: @270900
     /* 270900 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(270920), // Rule ID 119 //
     /* 270905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270913 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270918 */     GIR_RootConstrainSelectedInstOperands,
     /* 270919 */     // GIR_Coverage, 119,
     /* 270919 */     GIR_Done,
     /* 270920 */   // Label 5422: @270920
     /* 270920 */   GIM_Reject,
     /* 270921 */ // Label 5415: @270921
     /* 270921 */ GIM_Reject,
     /* 270922 */ // Label 5407: @270922
     /* 270922 */ GIM_Reject,
     /* 270923 */ // Label 47: @270923
     /* 270923 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5425*/ GIMT_Encode4(271052),
     /* 270934 */ /*GILLT_s32*//*Label 5423*/ GIMT_Encode4(270942),
     /* 270938 */ /*GILLT_s64*//*Label 5424*/ GIMT_Encode4(270997),
     /* 270942 */ // Label 5423: @270942
     /* 270942 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(270996), // Rule ID 188 //
     /* 270947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270976 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270980 */   // MIs[1] Operand 1
     /* 270980 */   // No operand predicates
     /* 270980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270982 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 270982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 270985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270989 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 270991 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270994 */   GIR_RootConstrainSelectedInstOperands,
     /* 270995 */   // GIR_Coverage, 188,
     /* 270995 */   GIR_EraseRootFromParent_Done,
     /* 270996 */ // Label 5426: @270996
     /* 270996 */ GIM_Reject,
     /* 270997 */ // Label 5424: @270997
     /* 270997 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271051), // Rule ID 189 //
     /* 271002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271031 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271035 */   // MIs[1] Operand 1
     /* 271035 */   // No operand predicates
     /* 271035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271037 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271042 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271044 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271046 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271049 */   GIR_RootConstrainSelectedInstOperands,
     /* 271050 */   // GIR_Coverage, 189,
     /* 271050 */   GIR_EraseRootFromParent_Done,
     /* 271051 */ // Label 5427: @271051
     /* 271051 */ GIM_Reject,
     /* 271052 */ // Label 5425: @271052
     /* 271052 */ GIM_Reject,
     /* 271053 */ // Label 48: @271053
     /* 271053 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5430*/ GIMT_Encode4(271545),
     /* 271064 */ /*GILLT_s32*//*Label 5428*/ GIMT_Encode4(271072),
     /* 271068 */ /*GILLT_s64*//*Label 5429*/ GIMT_Encode4(271288),
     /* 271072 */ // Label 5428: @271072
     /* 271072 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271287),
     /* 271077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271087 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271126), // Rule ID 184 //
     /* 271092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 271113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271115 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 271115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 271118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271124 */     GIR_RootConstrainSelectedInstOperands,
     /* 271125 */     // GIR_Coverage, 184,
     /* 271125 */     GIR_EraseRootFromParent_Done,
     /* 271126 */   // Label 5432: @271126
     /* 271126 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271163), // Rule ID 4010 //
     /* 271131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271147 */     // MIs[1] Operand 1
     /* 271147 */     // No operand predicates
     /* 271147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271149 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271161 */     GIR_RootConstrainSelectedInstOperands,
     /* 271162 */     // GIR_Coverage, 4010,
     /* 271162 */     GIR_EraseRootFromParent_Done,
     /* 271163 */   // Label 5433: @271163
     /* 271163 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271204), // Rule ID 3939 //
     /* 271168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271191 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271202 */     GIR_RootConstrainSelectedInstOperands,
     /* 271203 */     // GIR_Coverage, 3939,
     /* 271203 */     GIR_EraseRootFromParent_Done,
     /* 271204 */   // Label 5434: @271204
     /* 271204 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271245), // Rule ID 3940 //
     /* 271209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271232 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271243 */     GIR_RootConstrainSelectedInstOperands,
     /* 271244 */     // GIR_Coverage, 3940,
     /* 271244 */     GIR_EraseRootFromParent_Done,
     /* 271245 */   // Label 5435: @271245
     /* 271245 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271286), // Rule ID 3938 //
     /* 271250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271273 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271284 */     GIR_RootConstrainSelectedInstOperands,
     /* 271285 */     // GIR_Coverage, 3938,
     /* 271285 */     GIR_EraseRootFromParent_Done,
     /* 271286 */   // Label 5436: @271286
     /* 271286 */   GIM_Reject,
     /* 271287 */ // Label 5431: @271287
     /* 271287 */ GIM_Reject,
     /* 271288 */ // Label 5429: @271288
     /* 271288 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271544),
     /* 271293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271303 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271342), // Rule ID 187 //
     /* 271308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 271329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271331 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 271331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 271334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271340 */     GIR_RootConstrainSelectedInstOperands,
     /* 271341 */     // GIR_Coverage, 187,
     /* 271341 */     GIR_EraseRootFromParent_Done,
     /* 271342 */   // Label 5438: @271342
     /* 271342 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271379), // Rule ID 4011 //
     /* 271347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271363 */     // MIs[1] Operand 1
     /* 271363 */     // No operand predicates
     /* 271363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271365 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 271365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271377 */     GIR_RootConstrainSelectedInstOperands,
     /* 271378 */     // GIR_Coverage, 4011,
     /* 271378 */     GIR_EraseRootFromParent_Done,
     /* 271379 */   // Label 5439: @271379
     /* 271379 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271451), // Rule ID 3941 //
     /* 271384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271407 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271449 */     GIR_RootConstrainSelectedInstOperands,
     /* 271450 */     // GIR_Coverage, 3941,
     /* 271450 */     GIR_EraseRootFromParent_Done,
     /* 271451 */   // Label 5440: @271451
     /* 271451 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(271523), // Rule ID 3942 //
     /* 271456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271479 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271521 */     GIR_RootConstrainSelectedInstOperands,
     /* 271522 */     // GIR_Coverage, 3942,
     /* 271522 */     GIR_EraseRootFromParent_Done,
     /* 271523 */   // Label 5441: @271523
     /* 271523 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(271543), // Rule ID 122 //
     /* 271528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271536 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271541 */     GIR_RootConstrainSelectedInstOperands,
     /* 271542 */     // GIR_Coverage, 122,
     /* 271542 */     GIR_Done,
     /* 271543 */   // Label 5442: @271543
     /* 271543 */   GIM_Reject,
     /* 271544 */ // Label 5437: @271544
     /* 271544 */ GIM_Reject,
     /* 271545 */ // Label 5430: @271545
     /* 271545 */ GIM_Reject,
     /* 271546 */ // Label 49: @271546
     /* 271546 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5451*/ GIMT_Encode4(279322),
     /* 271557 */ /*GILLT_s64*//*Label 5443*/ GIMT_Encode4(271593), GIMT_Encode4(0),
     /* 271565 */ /*GILLT_v2s32*//*Label 5444*/ GIMT_Encode4(271986),
     /* 271569 */ /*GILLT_v2s64*//*Label 5445*/ GIMT_Encode4(273034),
     /* 271573 */ /*GILLT_v4s16*//*Label 5446*/ GIMT_Encode4(274082),
     /* 271577 */ /*GILLT_v4s32*//*Label 5447*/ GIMT_Encode4(275130),
     /* 271581 */ /*GILLT_v8s8*//*Label 5448*/ GIMT_Encode4(276178),
     /* 271585 */ /*GILLT_v8s16*//*Label 5449*/ GIMT_Encode4(277226),
     /* 271589 */ /*GILLT_v16s8*//*Label 5450*/ GIMT_Encode4(278274),
     /* 271593 */ // Label 5443: @271593
     /* 271593 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(271985),
     /* 271598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271608 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(271644), // Rule ID 5229 //
     /* 271613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271616 */     // MIs[0] Operand 1
     /* 271616 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271635 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 271638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271642 */     GIR_RootConstrainSelectedInstOperands,
     /* 271643 */     // GIR_Coverage, 5229,
     /* 271643 */     GIR_EraseRootFromParent_Done,
     /* 271644 */   // Label 5453: @271644
     /* 271644 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(271680), // Rule ID 5230 //
     /* 271649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271652 */     // MIs[0] Operand 1
     /* 271652 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271671 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 271674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271678 */     GIR_RootConstrainSelectedInstOperands,
     /* 271679 */     // GIR_Coverage, 5230,
     /* 271679 */     GIR_EraseRootFromParent_Done,
     /* 271680 */   // Label 5454: @271680
     /* 271680 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(271716), // Rule ID 2512 //
     /* 271685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271688 */     // MIs[0] Operand 1
     /* 271688 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271707 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 271710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271714 */     GIR_RootConstrainSelectedInstOperands,
     /* 271715 */     // GIR_Coverage, 2512,
     /* 271715 */     GIR_EraseRootFromParent_Done,
     /* 271716 */   // Label 5455: @271716
     /* 271716 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(271752), // Rule ID 5226 //
     /* 271721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271724 */     // MIs[0] Operand 1
     /* 271724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271743 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271750 */     GIR_RootConstrainSelectedInstOperands,
     /* 271751 */     // GIR_Coverage, 5226,
     /* 271751 */     GIR_EraseRootFromParent_Done,
     /* 271752 */   // Label 5456: @271752
     /* 271752 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(271788), // Rule ID 5227 //
     /* 271757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271760 */     // MIs[0] Operand 1
     /* 271760 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 271777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271779 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271786 */     GIR_RootConstrainSelectedInstOperands,
     /* 271787 */     // GIR_Coverage, 5227,
     /* 271787 */     GIR_EraseRootFromParent_Done,
     /* 271788 */   // Label 5457: @271788
     /* 271788 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(271824), // Rule ID 5228 //
     /* 271793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271796 */     // MIs[0] Operand 1
     /* 271796 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271805 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271811 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271815 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 271818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271822 */     GIR_RootConstrainSelectedInstOperands,
     /* 271823 */     // GIR_Coverage, 5228,
     /* 271823 */     GIR_EraseRootFromParent_Done,
     /* 271824 */   // Label 5458: @271824
     /* 271824 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(271856), // Rule ID 1608 //
     /* 271829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271832 */     // MIs[0] Operand 1
     /* 271832 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271845 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 271848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271854 */     GIR_RootConstrainSelectedInstOperands,
     /* 271855 */     // GIR_Coverage, 1608,
     /* 271855 */     GIR_EraseRootFromParent_Done,
     /* 271856 */   // Label 5459: @271856
     /* 271856 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(271888), // Rule ID 1609 //
     /* 271861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271864 */     // MIs[0] Operand 1
     /* 271864 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271877 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 271880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271886 */     GIR_RootConstrainSelectedInstOperands,
     /* 271887 */     // GIR_Coverage, 1609,
     /* 271887 */     GIR_EraseRootFromParent_Done,
     /* 271888 */   // Label 5460: @271888
     /* 271888 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(271920), // Rule ID 1610 //
     /* 271893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271896 */     // MIs[0] Operand 1
     /* 271896 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271909 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 271912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271918 */     GIR_RootConstrainSelectedInstOperands,
     /* 271919 */     // GIR_Coverage, 1610,
     /* 271919 */     GIR_EraseRootFromParent_Done,
     /* 271920 */   // Label 5461: @271920
     /* 271920 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(271952), // Rule ID 1611 //
     /* 271925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271928 */     // MIs[0] Operand 1
     /* 271928 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 271933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271941 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 271944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271950 */     GIR_RootConstrainSelectedInstOperands,
     /* 271951 */     // GIR_Coverage, 1611,
     /* 271951 */     GIR_EraseRootFromParent_Done,
     /* 271952 */   // Label 5462: @271952
     /* 271952 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(271984), // Rule ID 1612 //
     /* 271957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271960 */     // MIs[0] Operand 1
     /* 271960 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 271965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271973 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 271976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271982 */     GIR_RootConstrainSelectedInstOperands,
     /* 271983 */     // GIR_Coverage, 1612,
     /* 271983 */     GIR_EraseRootFromParent_Done,
     /* 271984 */   // Label 5463: @271984
     /* 271984 */   GIM_Reject,
     /* 271985 */ // Label 5452: @271985
     /* 271985 */ GIM_Reject,
     /* 271986 */ // Label 5444: @271986
     /* 271986 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(273033),
     /* 271991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 271997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272001 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(272041), // Rule ID 754 //
     /* 272006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272009 */     // MIs[0] Operand 1
     /* 272009 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272018 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272024 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272032 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272039 */     GIR_RootConstrainSelectedInstOperands,
     /* 272040 */     // GIR_Coverage, 754,
     /* 272040 */     GIR_EraseRootFromParent_Done,
     /* 272041 */   // Label 5465: @272041
     /* 272041 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(272081), // Rule ID 761 //
     /* 272046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272049 */     // MIs[0] Operand 1
     /* 272049 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272058 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272064 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272072 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272079 */     GIR_RootConstrainSelectedInstOperands,
     /* 272080 */     // GIR_Coverage, 761,
     /* 272080 */     GIR_EraseRootFromParent_Done,
     /* 272081 */   // Label 5466: @272081
     /* 272081 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(272118), // Rule ID 5163 //
     /* 272086 */     // MIs[0] Operand 1
     /* 272086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272095 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272101 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272109 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272116 */     GIR_RootConstrainSelectedInstOperands,
     /* 272117 */     // GIR_Coverage, 5163,
     /* 272117 */     GIR_EraseRootFromParent_Done,
     /* 272118 */   // Label 5467: @272118
     /* 272118 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(272155), // Rule ID 5170 //
     /* 272123 */     // MIs[0] Operand 1
     /* 272123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272146 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272153 */     GIR_RootConstrainSelectedInstOperands,
     /* 272154 */     // GIR_Coverage, 5170,
     /* 272154 */     GIR_EraseRootFromParent_Done,
     /* 272155 */   // Label 5468: @272155
     /* 272155 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(272192), // Rule ID 5177 //
     /* 272160 */     // MIs[0] Operand 1
     /* 272160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272183 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272190 */     GIR_RootConstrainSelectedInstOperands,
     /* 272191 */     // GIR_Coverage, 5177,
     /* 272191 */     GIR_EraseRootFromParent_Done,
     /* 272192 */   // Label 5469: @272192
     /* 272192 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(272229), // Rule ID 5184 //
     /* 272197 */     // MIs[0] Operand 1
     /* 272197 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272206 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272212 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272220 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272227 */     GIR_RootConstrainSelectedInstOperands,
     /* 272228 */     // GIR_Coverage, 5184,
     /* 272228 */     GIR_EraseRootFromParent_Done,
     /* 272229 */   // Label 5470: @272229
     /* 272229 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(272266), // Rule ID 5191 //
     /* 272234 */     // MIs[0] Operand 1
     /* 272234 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272243 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272249 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272257 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272264 */     GIR_RootConstrainSelectedInstOperands,
     /* 272265 */     // GIR_Coverage, 5191,
     /* 272265 */     GIR_EraseRootFromParent_Done,
     /* 272266 */   // Label 5471: @272266
     /* 272266 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(272306), // Rule ID 726 //
     /* 272271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272274 */     // MIs[0] Operand 1
     /* 272274 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272287 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272293 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272297 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272304 */     GIR_RootConstrainSelectedInstOperands,
     /* 272305 */     // GIR_Coverage, 726,
     /* 272305 */     GIR_EraseRootFromParent_Done,
     /* 272306 */   // Label 5472: @272306
     /* 272306 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(272346), // Rule ID 737 //
     /* 272311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272314 */     // MIs[0] Operand 1
     /* 272314 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272327 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272333 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272337 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272344 */     GIR_RootConstrainSelectedInstOperands,
     /* 272345 */     // GIR_Coverage, 737,
     /* 272345 */     GIR_EraseRootFromParent_Done,
     /* 272346 */   // Label 5473: @272346
     /* 272346 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(272386), // Rule ID 738 //
     /* 272351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272354 */     // MIs[0] Operand 1
     /* 272354 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 272375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272377 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272384 */     GIR_RootConstrainSelectedInstOperands,
     /* 272385 */     // GIR_Coverage, 738,
     /* 272385 */     GIR_EraseRootFromParent_Done,
     /* 272386 */   // Label 5474: @272386
     /* 272386 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(272426), // Rule ID 747 //
     /* 272391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272394 */     // MIs[0] Operand 1
     /* 272394 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272417 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272424 */     GIR_RootConstrainSelectedInstOperands,
     /* 272425 */     // GIR_Coverage, 747,
     /* 272425 */     GIR_EraseRootFromParent_Done,
     /* 272426 */   // Label 5475: @272426
     /* 272426 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(272463), // Rule ID 5128 //
     /* 272431 */     // MIs[0] Operand 1
     /* 272431 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272454 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272461 */     GIR_RootConstrainSelectedInstOperands,
     /* 272462 */     // GIR_Coverage, 5128,
     /* 272462 */     GIR_EraseRootFromParent_Done,
     /* 272463 */   // Label 5476: @272463
     /* 272463 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(272500), // Rule ID 5135 //
     /* 272468 */     // MIs[0] Operand 1
     /* 272468 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272491 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272498 */     GIR_RootConstrainSelectedInstOperands,
     /* 272499 */     // GIR_Coverage, 5135,
     /* 272499 */     GIR_EraseRootFromParent_Done,
     /* 272500 */   // Label 5477: @272500
     /* 272500 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(272537), // Rule ID 5142 //
     /* 272505 */     // MIs[0] Operand 1
     /* 272505 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272518 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272524 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272528 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272535 */     GIR_RootConstrainSelectedInstOperands,
     /* 272536 */     // GIR_Coverage, 5142,
     /* 272536 */     GIR_EraseRootFromParent_Done,
     /* 272537 */   // Label 5478: @272537
     /* 272537 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272574), // Rule ID 5149 //
     /* 272542 */     // MIs[0] Operand 1
     /* 272542 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272565 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272572 */     GIR_RootConstrainSelectedInstOperands,
     /* 272573 */     // GIR_Coverage, 5149,
     /* 272573 */     GIR_EraseRootFromParent_Done,
     /* 272574 */   // Label 5479: @272574
     /* 272574 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272611), // Rule ID 5156 //
     /* 272579 */     // MIs[0] Operand 1
     /* 272579 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272592 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272598 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272602 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272609 */     GIR_RootConstrainSelectedInstOperands,
     /* 272610 */     // GIR_Coverage, 5156,
     /* 272610 */     GIR_EraseRootFromParent_Done,
     /* 272611 */   // Label 5480: @272611
     /* 272611 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(272643), // Rule ID 1125 //
     /* 272616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272619 */     // MIs[0] Operand 1
     /* 272619 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272632 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 272635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272641 */     GIR_RootConstrainSelectedInstOperands,
     /* 272642 */     // GIR_Coverage, 1125,
     /* 272642 */     GIR_EraseRootFromParent_Done,
     /* 272643 */   // Label 5481: @272643
     /* 272643 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(272675), // Rule ID 1132 //
     /* 272648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272651 */     // MIs[0] Operand 1
     /* 272651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272664 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272673 */     GIR_RootConstrainSelectedInstOperands,
     /* 272674 */     // GIR_Coverage, 1132,
     /* 272674 */     GIR_EraseRootFromParent_Done,
     /* 272675 */   // Label 5482: @272675
     /* 272675 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(272707), // Rule ID 1139 //
     /* 272680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272683 */     // MIs[0] Operand 1
     /* 272683 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272696 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272705 */     GIR_RootConstrainSelectedInstOperands,
     /* 272706 */     // GIR_Coverage, 1139,
     /* 272706 */     GIR_EraseRootFromParent_Done,
     /* 272707 */   // Label 5483: @272707
     /* 272707 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(272739), // Rule ID 1146 //
     /* 272712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272715 */     // MIs[0] Operand 1
     /* 272715 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272728 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272737 */     GIR_RootConstrainSelectedInstOperands,
     /* 272738 */     // GIR_Coverage, 1146,
     /* 272738 */     GIR_EraseRootFromParent_Done,
     /* 272739 */   // Label 5484: @272739
     /* 272739 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(272771), // Rule ID 1153 //
     /* 272744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272747 */     // MIs[0] Operand 1
     /* 272747 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272760 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272769 */     GIR_RootConstrainSelectedInstOperands,
     /* 272770 */     // GIR_Coverage, 1153,
     /* 272770 */     GIR_EraseRootFromParent_Done,
     /* 272771 */   // Label 5485: @272771
     /* 272771 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(272800), // Rule ID 5065 //
     /* 272776 */     // MIs[0] Operand 1
     /* 272776 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272789 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 272792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272798 */     GIR_RootConstrainSelectedInstOperands,
     /* 272799 */     // GIR_Coverage, 5065,
     /* 272799 */     GIR_EraseRootFromParent_Done,
     /* 272800 */   // Label 5486: @272800
     /* 272800 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(272829), // Rule ID 5072 //
     /* 272805 */     // MIs[0] Operand 1
     /* 272805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272818 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272827 */     GIR_RootConstrainSelectedInstOperands,
     /* 272828 */     // GIR_Coverage, 5072,
     /* 272828 */     GIR_EraseRootFromParent_Done,
     /* 272829 */   // Label 5487: @272829
     /* 272829 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(272858), // Rule ID 5079 //
     /* 272834 */     // MIs[0] Operand 1
     /* 272834 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272847 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272856 */     GIR_RootConstrainSelectedInstOperands,
     /* 272857 */     // GIR_Coverage, 5079,
     /* 272857 */     GIR_EraseRootFromParent_Done,
     /* 272858 */   // Label 5488: @272858
     /* 272858 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(272887), // Rule ID 5086 //
     /* 272863 */     // MIs[0] Operand 1
     /* 272863 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272876 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272885 */     GIR_RootConstrainSelectedInstOperands,
     /* 272886 */     // GIR_Coverage, 5086,
     /* 272886 */     GIR_EraseRootFromParent_Done,
     /* 272887 */   // Label 5489: @272887
     /* 272887 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(272916), // Rule ID 5093 //
     /* 272892 */     // MIs[0] Operand 1
     /* 272892 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272905 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272914 */     GIR_RootConstrainSelectedInstOperands,
     /* 272915 */     // GIR_Coverage, 5093,
     /* 272915 */     GIR_EraseRootFromParent_Done,
     /* 272916 */   // Label 5490: @272916
     /* 272916 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(272945), // Rule ID 5100 //
     /* 272921 */     // MIs[0] Operand 1
     /* 272921 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272934 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272943 */     GIR_RootConstrainSelectedInstOperands,
     /* 272944 */     // GIR_Coverage, 5100,
     /* 272944 */     GIR_EraseRootFromParent_Done,
     /* 272945 */   // Label 5491: @272945
     /* 272945 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(272974), // Rule ID 5107 //
     /* 272950 */     // MIs[0] Operand 1
     /* 272950 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272963 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272972 */     GIR_RootConstrainSelectedInstOperands,
     /* 272973 */     // GIR_Coverage, 5107,
     /* 272973 */     GIR_EraseRootFromParent_Done,
     /* 272974 */   // Label 5492: @272974
     /* 272974 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(273003), // Rule ID 5114 //
     /* 272979 */     // MIs[0] Operand 1
     /* 272979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 272984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272992 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273001 */     GIR_RootConstrainSelectedInstOperands,
     /* 273002 */     // GIR_Coverage, 5114,
     /* 273002 */     GIR_EraseRootFromParent_Done,
     /* 273003 */   // Label 5493: @273003
     /* 273003 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(273032), // Rule ID 5121 //
     /* 273008 */     // MIs[0] Operand 1
     /* 273008 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 273013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273021 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273030 */     GIR_RootConstrainSelectedInstOperands,
     /* 273031 */     // GIR_Coverage, 5121,
     /* 273031 */     GIR_EraseRootFromParent_Done,
     /* 273032 */   // Label 5494: @273032
     /* 273032 */   GIM_Reject,
     /* 273033 */ // Label 5464: @273033
     /* 273033 */ GIM_Reject,
     /* 273034 */ // Label 5445: @273034
     /* 273034 */ GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(274081),
     /* 273039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 273045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273049 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(273089), // Rule ID 756 //
     /* 273054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273057 */     // MIs[0] Operand 1
     /* 273057 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273080 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273087 */     GIR_RootConstrainSelectedInstOperands,
     /* 273088 */     // GIR_Coverage, 756,
     /* 273088 */     GIR_EraseRootFromParent_Done,
     /* 273089 */   // Label 5496: @273089
     /* 273089 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(273129), // Rule ID 763 //
     /* 273094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273097 */     // MIs[0] Operand 1
     /* 273097 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273106 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273112 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273120 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273127 */     GIR_RootConstrainSelectedInstOperands,
     /* 273128 */     // GIR_Coverage, 763,
     /* 273128 */     GIR_EraseRootFromParent_Done,
     /* 273129 */   // Label 5497: @273129
     /* 273129 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(273166), // Rule ID 5165 //
     /* 273134 */     // MIs[0] Operand 1
     /* 273134 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273149 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273157 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273164 */     GIR_RootConstrainSelectedInstOperands,
     /* 273165 */     // GIR_Coverage, 5165,
     /* 273165 */     GIR_EraseRootFromParent_Done,
     /* 273166 */   // Label 5498: @273166
     /* 273166 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(273203), // Rule ID 5172 //
     /* 273171 */     // MIs[0] Operand 1
     /* 273171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273180 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273186 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273194 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273201 */     GIR_RootConstrainSelectedInstOperands,
     /* 273202 */     // GIR_Coverage, 5172,
     /* 273202 */     GIR_EraseRootFromParent_Done,
     /* 273203 */   // Label 5499: @273203
     /* 273203 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(273240), // Rule ID 5179 //
     /* 273208 */     // MIs[0] Operand 1
     /* 273208 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273223 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273231 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273238 */     GIR_RootConstrainSelectedInstOperands,
     /* 273239 */     // GIR_Coverage, 5179,
     /* 273239 */     GIR_EraseRootFromParent_Done,
     /* 273240 */   // Label 5500: @273240
     /* 273240 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(273277), // Rule ID 5186 //
     /* 273245 */     // MIs[0] Operand 1
     /* 273245 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273254 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273260 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273268 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273275 */     GIR_RootConstrainSelectedInstOperands,
     /* 273276 */     // GIR_Coverage, 5186,
     /* 273276 */     GIR_EraseRootFromParent_Done,
     /* 273277 */   // Label 5501: @273277
     /* 273277 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(273314), // Rule ID 5193 //
     /* 273282 */     // MIs[0] Operand 1
     /* 273282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273291 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273297 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273305 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273312 */     GIR_RootConstrainSelectedInstOperands,
     /* 273313 */     // GIR_Coverage, 5193,
     /* 273313 */     GIR_EraseRootFromParent_Done,
     /* 273314 */   // Label 5502: @273314
     /* 273314 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(273354), // Rule ID 728 //
     /* 273319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273322 */     // MIs[0] Operand 1
     /* 273322 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273341 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273345 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273352 */     GIR_RootConstrainSelectedInstOperands,
     /* 273353 */     // GIR_Coverage, 728,
     /* 273353 */     GIR_EraseRootFromParent_Done,
     /* 273354 */   // Label 5503: @273354
     /* 273354 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273394), // Rule ID 741 //
     /* 273359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273362 */     // MIs[0] Operand 1
     /* 273362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273375 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273381 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273385 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273392 */     GIR_RootConstrainSelectedInstOperands,
     /* 273393 */     // GIR_Coverage, 741,
     /* 273393 */     GIR_EraseRootFromParent_Done,
     /* 273394 */   // Label 5504: @273394
     /* 273394 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(273434), // Rule ID 742 //
     /* 273399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273402 */     // MIs[0] Operand 1
     /* 273402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273425 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273432 */     GIR_RootConstrainSelectedInstOperands,
     /* 273433 */     // GIR_Coverage, 742,
     /* 273433 */     GIR_EraseRootFromParent_Done,
     /* 273434 */   // Label 5505: @273434
     /* 273434 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(273474), // Rule ID 749 //
     /* 273439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273442 */     // MIs[0] Operand 1
     /* 273442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273465 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273472 */     GIR_RootConstrainSelectedInstOperands,
     /* 273473 */     // GIR_Coverage, 749,
     /* 273473 */     GIR_EraseRootFromParent_Done,
     /* 273474 */   // Label 5506: @273474
     /* 273474 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(273511), // Rule ID 5130 //
     /* 273479 */     // MIs[0] Operand 1
     /* 273479 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273502 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273509 */     GIR_RootConstrainSelectedInstOperands,
     /* 273510 */     // GIR_Coverage, 5130,
     /* 273510 */     GIR_EraseRootFromParent_Done,
     /* 273511 */   // Label 5507: @273511
     /* 273511 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(273548), // Rule ID 5137 //
     /* 273516 */     // MIs[0] Operand 1
     /* 273516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273539 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273546 */     GIR_RootConstrainSelectedInstOperands,
     /* 273547 */     // GIR_Coverage, 5137,
     /* 273547 */     GIR_EraseRootFromParent_Done,
     /* 273548 */   // Label 5508: @273548
     /* 273548 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(273585), // Rule ID 5144 //
     /* 273553 */     // MIs[0] Operand 1
     /* 273553 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273576 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273583 */     GIR_RootConstrainSelectedInstOperands,
     /* 273584 */     // GIR_Coverage, 5144,
     /* 273584 */     GIR_EraseRootFromParent_Done,
     /* 273585 */   // Label 5509: @273585
     /* 273585 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273622), // Rule ID 5151 //
     /* 273590 */     // MIs[0] Operand 1
     /* 273590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273603 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273609 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273613 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273620 */     GIR_RootConstrainSelectedInstOperands,
     /* 273621 */     // GIR_Coverage, 5151,
     /* 273621 */     GIR_EraseRootFromParent_Done,
     /* 273622 */   // Label 5510: @273622
     /* 273622 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(273659), // Rule ID 5158 //
     /* 273627 */     // MIs[0] Operand 1
     /* 273627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273640 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273646 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273650 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273657 */     GIR_RootConstrainSelectedInstOperands,
     /* 273658 */     // GIR_Coverage, 5158,
     /* 273658 */     GIR_EraseRootFromParent_Done,
     /* 273659 */   // Label 5511: @273659
     /* 273659 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273691), // Rule ID 1127 //
     /* 273664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273667 */     // MIs[0] Operand 1
     /* 273667 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273680 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 273683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273689 */     GIR_RootConstrainSelectedInstOperands,
     /* 273690 */     // GIR_Coverage, 1127,
     /* 273690 */     GIR_EraseRootFromParent_Done,
     /* 273691 */   // Label 5512: @273691
     /* 273691 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(273723), // Rule ID 1134 //
     /* 273696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273699 */     // MIs[0] Operand 1
     /* 273699 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273712 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273721 */     GIR_RootConstrainSelectedInstOperands,
     /* 273722 */     // GIR_Coverage, 1134,
     /* 273722 */     GIR_EraseRootFromParent_Done,
     /* 273723 */   // Label 5513: @273723
     /* 273723 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(273755), // Rule ID 1141 //
     /* 273728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273731 */     // MIs[0] Operand 1
     /* 273731 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273744 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273753 */     GIR_RootConstrainSelectedInstOperands,
     /* 273754 */     // GIR_Coverage, 1141,
     /* 273754 */     GIR_EraseRootFromParent_Done,
     /* 273755 */   // Label 5514: @273755
     /* 273755 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(273787), // Rule ID 1148 //
     /* 273760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273763 */     // MIs[0] Operand 1
     /* 273763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273776 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 273779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273785 */     GIR_RootConstrainSelectedInstOperands,
     /* 273786 */     // GIR_Coverage, 1148,
     /* 273786 */     GIR_EraseRootFromParent_Done,
     /* 273787 */   // Label 5515: @273787
     /* 273787 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(273819), // Rule ID 1155 //
     /* 273792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273795 */     // MIs[0] Operand 1
     /* 273795 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273808 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 273811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273817 */     GIR_RootConstrainSelectedInstOperands,
     /* 273818 */     // GIR_Coverage, 1155,
     /* 273818 */     GIR_EraseRootFromParent_Done,
     /* 273819 */   // Label 5516: @273819
     /* 273819 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(273848), // Rule ID 5067 //
     /* 273824 */     // MIs[0] Operand 1
     /* 273824 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273837 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 273840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273846 */     GIR_RootConstrainSelectedInstOperands,
     /* 273847 */     // GIR_Coverage, 5067,
     /* 273847 */     GIR_EraseRootFromParent_Done,
     /* 273848 */   // Label 5517: @273848
     /* 273848 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(273877), // Rule ID 5074 //
     /* 273853 */     // MIs[0] Operand 1
     /* 273853 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273866 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273875 */     GIR_RootConstrainSelectedInstOperands,
     /* 273876 */     // GIR_Coverage, 5074,
     /* 273876 */     GIR_EraseRootFromParent_Done,
     /* 273877 */   // Label 5518: @273877
     /* 273877 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(273906), // Rule ID 5081 //
     /* 273882 */     // MIs[0] Operand 1
     /* 273882 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273895 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273904 */     GIR_RootConstrainSelectedInstOperands,
     /* 273905 */     // GIR_Coverage, 5081,
     /* 273905 */     GIR_EraseRootFromParent_Done,
     /* 273906 */   // Label 5519: @273906
     /* 273906 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(273935), // Rule ID 5088 //
     /* 273911 */     // MIs[0] Operand 1
     /* 273911 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273924 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 273927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273933 */     GIR_RootConstrainSelectedInstOperands,
     /* 273934 */     // GIR_Coverage, 5088,
     /* 273934 */     GIR_EraseRootFromParent_Done,
     /* 273935 */   // Label 5520: @273935
     /* 273935 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(273964), // Rule ID 5095 //
     /* 273940 */     // MIs[0] Operand 1
     /* 273940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273953 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 273956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273962 */     GIR_RootConstrainSelectedInstOperands,
     /* 273963 */     // GIR_Coverage, 5095,
     /* 273963 */     GIR_EraseRootFromParent_Done,
     /* 273964 */   // Label 5521: @273964
     /* 273964 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(273993), // Rule ID 5102 //
     /* 273969 */     // MIs[0] Operand 1
     /* 273969 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273982 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 273982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273991 */     GIR_RootConstrainSelectedInstOperands,
     /* 273992 */     // GIR_Coverage, 5102,
     /* 273992 */     GIR_EraseRootFromParent_Done,
     /* 273993 */   // Label 5522: @273993
     /* 273993 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274022), // Rule ID 5109 //
     /* 273998 */     // MIs[0] Operand 1
     /* 273998 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274011 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274020 */     GIR_RootConstrainSelectedInstOperands,
     /* 274021 */     // GIR_Coverage, 5109,
     /* 274021 */     GIR_EraseRootFromParent_Done,
     /* 274022 */   // Label 5523: @274022
     /* 274022 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274051), // Rule ID 5116 //
     /* 274027 */     // MIs[0] Operand 1
     /* 274027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274040 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274049 */     GIR_RootConstrainSelectedInstOperands,
     /* 274050 */     // GIR_Coverage, 5116,
     /* 274050 */     GIR_EraseRootFromParent_Done,
     /* 274051 */   // Label 5524: @274051
     /* 274051 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274080), // Rule ID 5123 //
     /* 274056 */     // MIs[0] Operand 1
     /* 274056 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274069 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274078 */     GIR_RootConstrainSelectedInstOperands,
     /* 274079 */     // GIR_Coverage, 5123,
     /* 274079 */     GIR_EraseRootFromParent_Done,
     /* 274080 */   // Label 5525: @274080
     /* 274080 */   GIM_Reject,
     /* 274081 */ // Label 5495: @274081
     /* 274081 */ GIM_Reject,
     /* 274082 */ // Label 5446: @274082
     /* 274082 */ GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(275129),
     /* 274087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 274093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274097 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(274137), // Rule ID 752 //
     /* 274102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274105 */     // MIs[0] Operand 1
     /* 274105 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274114 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274120 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274128 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274135 */     GIR_RootConstrainSelectedInstOperands,
     /* 274136 */     // GIR_Coverage, 752,
     /* 274136 */     GIR_EraseRootFromParent_Done,
     /* 274137 */   // Label 5527: @274137
     /* 274137 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(274177), // Rule ID 759 //
     /* 274142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274145 */     // MIs[0] Operand 1
     /* 274145 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274154 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274160 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274168 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274175 */     GIR_RootConstrainSelectedInstOperands,
     /* 274176 */     // GIR_Coverage, 759,
     /* 274176 */     GIR_EraseRootFromParent_Done,
     /* 274177 */   // Label 5528: @274177
     /* 274177 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(274214), // Rule ID 5161 //
     /* 274182 */     // MIs[0] Operand 1
     /* 274182 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274191 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274197 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274205 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274212 */     GIR_RootConstrainSelectedInstOperands,
     /* 274213 */     // GIR_Coverage, 5161,
     /* 274213 */     GIR_EraseRootFromParent_Done,
     /* 274214 */   // Label 5529: @274214
     /* 274214 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(274251), // Rule ID 5168 //
     /* 274219 */     // MIs[0] Operand 1
     /* 274219 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274228 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274234 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274242 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274249 */     GIR_RootConstrainSelectedInstOperands,
     /* 274250 */     // GIR_Coverage, 5168,
     /* 274250 */     GIR_EraseRootFromParent_Done,
     /* 274251 */   // Label 5530: @274251
     /* 274251 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(274288), // Rule ID 5175 //
     /* 274256 */     // MIs[0] Operand 1
     /* 274256 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274271 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274279 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274286 */     GIR_RootConstrainSelectedInstOperands,
     /* 274287 */     // GIR_Coverage, 5175,
     /* 274287 */     GIR_EraseRootFromParent_Done,
     /* 274288 */   // Label 5531: @274288
     /* 274288 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(274325), // Rule ID 5182 //
     /* 274293 */     // MIs[0] Operand 1
     /* 274293 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274302 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274308 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274316 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274323 */     GIR_RootConstrainSelectedInstOperands,
     /* 274324 */     // GIR_Coverage, 5182,
     /* 274324 */     GIR_EraseRootFromParent_Done,
     /* 274325 */   // Label 5532: @274325
     /* 274325 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(274362), // Rule ID 5189 //
     /* 274330 */     // MIs[0] Operand 1
     /* 274330 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274353 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274360 */     GIR_RootConstrainSelectedInstOperands,
     /* 274361 */     // GIR_Coverage, 5189,
     /* 274361 */     GIR_EraseRootFromParent_Done,
     /* 274362 */   // Label 5533: @274362
     /* 274362 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(274402), // Rule ID 724 //
     /* 274367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274370 */     // MIs[0] Operand 1
     /* 274370 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274383 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274389 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274393 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274400 */     GIR_RootConstrainSelectedInstOperands,
     /* 274401 */     // GIR_Coverage, 724,
     /* 274401 */     GIR_EraseRootFromParent_Done,
     /* 274402 */   // Label 5534: @274402
     /* 274402 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(274442), // Rule ID 733 //
     /* 274407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274410 */     // MIs[0] Operand 1
     /* 274410 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274433 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274440 */     GIR_RootConstrainSelectedInstOperands,
     /* 274441 */     // GIR_Coverage, 733,
     /* 274441 */     GIR_EraseRootFromParent_Done,
     /* 274442 */   // Label 5535: @274442
     /* 274442 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(274482), // Rule ID 734 //
     /* 274447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274450 */     // MIs[0] Operand 1
     /* 274450 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274473 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274480 */     GIR_RootConstrainSelectedInstOperands,
     /* 274481 */     // GIR_Coverage, 734,
     /* 274481 */     GIR_EraseRootFromParent_Done,
     /* 274482 */   // Label 5536: @274482
     /* 274482 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(274522), // Rule ID 745 //
     /* 274487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274490 */     // MIs[0] Operand 1
     /* 274490 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274513 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274520 */     GIR_RootConstrainSelectedInstOperands,
     /* 274521 */     // GIR_Coverage, 745,
     /* 274521 */     GIR_EraseRootFromParent_Done,
     /* 274522 */   // Label 5537: @274522
     /* 274522 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(274559), // Rule ID 5126 //
     /* 274527 */     // MIs[0] Operand 1
     /* 274527 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274550 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274557 */     GIR_RootConstrainSelectedInstOperands,
     /* 274558 */     // GIR_Coverage, 5126,
     /* 274558 */     GIR_EraseRootFromParent_Done,
     /* 274559 */   // Label 5538: @274559
     /* 274559 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(274596), // Rule ID 5133 //
     /* 274564 */     // MIs[0] Operand 1
     /* 274564 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274587 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274594 */     GIR_RootConstrainSelectedInstOperands,
     /* 274595 */     // GIR_Coverage, 5133,
     /* 274595 */     GIR_EraseRootFromParent_Done,
     /* 274596 */   // Label 5539: @274596
     /* 274596 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(274633), // Rule ID 5140 //
     /* 274601 */     // MIs[0] Operand 1
     /* 274601 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274614 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274620 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274624 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274631 */     GIR_RootConstrainSelectedInstOperands,
     /* 274632 */     // GIR_Coverage, 5140,
     /* 274632 */     GIR_EraseRootFromParent_Done,
     /* 274633 */   // Label 5540: @274633
     /* 274633 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274670), // Rule ID 5147 //
     /* 274638 */     // MIs[0] Operand 1
     /* 274638 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274661 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274668 */     GIR_RootConstrainSelectedInstOperands,
     /* 274669 */     // GIR_Coverage, 5147,
     /* 274669 */     GIR_EraseRootFromParent_Done,
     /* 274670 */   // Label 5541: @274670
     /* 274670 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(274707), // Rule ID 5154 //
     /* 274675 */     // MIs[0] Operand 1
     /* 274675 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274698 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274705 */     GIR_RootConstrainSelectedInstOperands,
     /* 274706 */     // GIR_Coverage, 5154,
     /* 274706 */     GIR_EraseRootFromParent_Done,
     /* 274707 */   // Label 5542: @274707
     /* 274707 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(274739), // Rule ID 1123 //
     /* 274712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274715 */     // MIs[0] Operand 1
     /* 274715 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274728 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 274731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274737 */     GIR_RootConstrainSelectedInstOperands,
     /* 274738 */     // GIR_Coverage, 1123,
     /* 274738 */     GIR_EraseRootFromParent_Done,
     /* 274739 */   // Label 5543: @274739
     /* 274739 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(274771), // Rule ID 1130 //
     /* 274744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274747 */     // MIs[0] Operand 1
     /* 274747 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274760 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 274763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274769 */     GIR_RootConstrainSelectedInstOperands,
     /* 274770 */     // GIR_Coverage, 1130,
     /* 274770 */     GIR_EraseRootFromParent_Done,
     /* 274771 */   // Label 5544: @274771
     /* 274771 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(274803), // Rule ID 1137 //
     /* 274776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274779 */     // MIs[0] Operand 1
     /* 274779 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274792 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 274795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274801 */     GIR_RootConstrainSelectedInstOperands,
     /* 274802 */     // GIR_Coverage, 1137,
     /* 274802 */     GIR_EraseRootFromParent_Done,
     /* 274803 */   // Label 5545: @274803
     /* 274803 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(274835), // Rule ID 1144 //
     /* 274808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274811 */     // MIs[0] Operand 1
     /* 274811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274824 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 274827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274833 */     GIR_RootConstrainSelectedInstOperands,
     /* 274834 */     // GIR_Coverage, 1144,
     /* 274834 */     GIR_EraseRootFromParent_Done,
     /* 274835 */   // Label 5546: @274835
     /* 274835 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(274867), // Rule ID 1151 //
     /* 274840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274843 */     // MIs[0] Operand 1
     /* 274843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274856 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 274859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274865 */     GIR_RootConstrainSelectedInstOperands,
     /* 274866 */     // GIR_Coverage, 1151,
     /* 274866 */     GIR_EraseRootFromParent_Done,
     /* 274867 */   // Label 5547: @274867
     /* 274867 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(274896), // Rule ID 5063 //
     /* 274872 */     // MIs[0] Operand 1
     /* 274872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274885 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 274888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274894 */     GIR_RootConstrainSelectedInstOperands,
     /* 274895 */     // GIR_Coverage, 5063,
     /* 274895 */     GIR_EraseRootFromParent_Done,
     /* 274896 */   // Label 5548: @274896
     /* 274896 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(274925), // Rule ID 5070 //
     /* 274901 */     // MIs[0] Operand 1
     /* 274901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274914 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 274917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274923 */     GIR_RootConstrainSelectedInstOperands,
     /* 274924 */     // GIR_Coverage, 5070,
     /* 274924 */     GIR_EraseRootFromParent_Done,
     /* 274925 */   // Label 5549: @274925
     /* 274925 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(274954), // Rule ID 5077 //
     /* 274930 */     // MIs[0] Operand 1
     /* 274930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274943 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 274946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274952 */     GIR_RootConstrainSelectedInstOperands,
     /* 274953 */     // GIR_Coverage, 5077,
     /* 274953 */     GIR_EraseRootFromParent_Done,
     /* 274954 */   // Label 5550: @274954
     /* 274954 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(274983), // Rule ID 5084 //
     /* 274959 */     // MIs[0] Operand 1
     /* 274959 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274972 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 274975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274981 */     GIR_RootConstrainSelectedInstOperands,
     /* 274982 */     // GIR_Coverage, 5084,
     /* 274982 */     GIR_EraseRootFromParent_Done,
     /* 274983 */   // Label 5551: @274983
     /* 274983 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275012), // Rule ID 5091 //
     /* 274988 */     // MIs[0] Operand 1
     /* 274988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275001 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275010 */     GIR_RootConstrainSelectedInstOperands,
     /* 275011 */     // GIR_Coverage, 5091,
     /* 275011 */     GIR_EraseRootFromParent_Done,
     /* 275012 */   // Label 5552: @275012
     /* 275012 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275041), // Rule ID 5098 //
     /* 275017 */     // MIs[0] Operand 1
     /* 275017 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275030 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275039 */     GIR_RootConstrainSelectedInstOperands,
     /* 275040 */     // GIR_Coverage, 5098,
     /* 275040 */     GIR_EraseRootFromParent_Done,
     /* 275041 */   // Label 5553: @275041
     /* 275041 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275070), // Rule ID 5105 //
     /* 275046 */     // MIs[0] Operand 1
     /* 275046 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275059 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275068 */     GIR_RootConstrainSelectedInstOperands,
     /* 275069 */     // GIR_Coverage, 5105,
     /* 275069 */     GIR_EraseRootFromParent_Done,
     /* 275070 */   // Label 5554: @275070
     /* 275070 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275099), // Rule ID 5112 //
     /* 275075 */     // MIs[0] Operand 1
     /* 275075 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275088 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275097 */     GIR_RootConstrainSelectedInstOperands,
     /* 275098 */     // GIR_Coverage, 5112,
     /* 275098 */     GIR_EraseRootFromParent_Done,
     /* 275099 */   // Label 5555: @275099
     /* 275099 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(275128), // Rule ID 5119 //
     /* 275104 */     // MIs[0] Operand 1
     /* 275104 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275117 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275126 */     GIR_RootConstrainSelectedInstOperands,
     /* 275127 */     // GIR_Coverage, 5119,
     /* 275127 */     GIR_EraseRootFromParent_Done,
     /* 275128 */   // Label 5556: @275128
     /* 275128 */   GIM_Reject,
     /* 275129 */ // Label 5526: @275129
     /* 275129 */ GIM_Reject,
     /* 275130 */ // Label 5447: @275130
     /* 275130 */ GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(276177),
     /* 275135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275145 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(275185), // Rule ID 755 //
     /* 275150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275153 */     // MIs[0] Operand 1
     /* 275153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275162 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275168 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275176 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275183 */     GIR_RootConstrainSelectedInstOperands,
     /* 275184 */     // GIR_Coverage, 755,
     /* 275184 */     GIR_EraseRootFromParent_Done,
     /* 275185 */   // Label 5558: @275185
     /* 275185 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(275225), // Rule ID 762 //
     /* 275190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275193 */     // MIs[0] Operand 1
     /* 275193 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275202 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275208 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275216 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275223 */     GIR_RootConstrainSelectedInstOperands,
     /* 275224 */     // GIR_Coverage, 762,
     /* 275224 */     GIR_EraseRootFromParent_Done,
     /* 275225 */   // Label 5559: @275225
     /* 275225 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(275262), // Rule ID 5164 //
     /* 275230 */     // MIs[0] Operand 1
     /* 275230 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275239 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275245 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275253 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275260 */     GIR_RootConstrainSelectedInstOperands,
     /* 275261 */     // GIR_Coverage, 5164,
     /* 275261 */     GIR_EraseRootFromParent_Done,
     /* 275262 */   // Label 5560: @275262
     /* 275262 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(275299), // Rule ID 5171 //
     /* 275267 */     // MIs[0] Operand 1
     /* 275267 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275276 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275282 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275290 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275297 */     GIR_RootConstrainSelectedInstOperands,
     /* 275298 */     // GIR_Coverage, 5171,
     /* 275298 */     GIR_EraseRootFromParent_Done,
     /* 275299 */   // Label 5561: @275299
     /* 275299 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(275336), // Rule ID 5178 //
     /* 275304 */     // MIs[0] Operand 1
     /* 275304 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275327 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275334 */     GIR_RootConstrainSelectedInstOperands,
     /* 275335 */     // GIR_Coverage, 5178,
     /* 275335 */     GIR_EraseRootFromParent_Done,
     /* 275336 */   // Label 5562: @275336
     /* 275336 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(275373), // Rule ID 5185 //
     /* 275341 */     // MIs[0] Operand 1
     /* 275341 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275350 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275356 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275364 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275371 */     GIR_RootConstrainSelectedInstOperands,
     /* 275372 */     // GIR_Coverage, 5185,
     /* 275372 */     GIR_EraseRootFromParent_Done,
     /* 275373 */   // Label 5563: @275373
     /* 275373 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275410), // Rule ID 5192 //
     /* 275378 */     // MIs[0] Operand 1
     /* 275378 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275387 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275401 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275408 */     GIR_RootConstrainSelectedInstOperands,
     /* 275409 */     // GIR_Coverage, 5192,
     /* 275409 */     GIR_EraseRootFromParent_Done,
     /* 275410 */   // Label 5564: @275410
     /* 275410 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(275450), // Rule ID 727 //
     /* 275415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275418 */     // MIs[0] Operand 1
     /* 275418 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275441 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275448 */     GIR_RootConstrainSelectedInstOperands,
     /* 275449 */     // GIR_Coverage, 727,
     /* 275449 */     GIR_EraseRootFromParent_Done,
     /* 275450 */   // Label 5565: @275450
     /* 275450 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(275490), // Rule ID 739 //
     /* 275455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275458 */     // MIs[0] Operand 1
     /* 275458 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275471 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275477 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275481 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275488 */     GIR_RootConstrainSelectedInstOperands,
     /* 275489 */     // GIR_Coverage, 739,
     /* 275489 */     GIR_EraseRootFromParent_Done,
     /* 275490 */   // Label 5566: @275490
     /* 275490 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(275530), // Rule ID 740 //
     /* 275495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275498 */     // MIs[0] Operand 1
     /* 275498 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275511 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275521 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275528 */     GIR_RootConstrainSelectedInstOperands,
     /* 275529 */     // GIR_Coverage, 740,
     /* 275529 */     GIR_EraseRootFromParent_Done,
     /* 275530 */   // Label 5567: @275530
     /* 275530 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(275570), // Rule ID 748 //
     /* 275535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275538 */     // MIs[0] Operand 1
     /* 275538 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275551 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275557 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275561 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275568 */     GIR_RootConstrainSelectedInstOperands,
     /* 275569 */     // GIR_Coverage, 748,
     /* 275569 */     GIR_EraseRootFromParent_Done,
     /* 275570 */   // Label 5568: @275570
     /* 275570 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(275607), // Rule ID 5129 //
     /* 275575 */     // MIs[0] Operand 1
     /* 275575 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275588 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275594 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275598 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275605 */     GIR_RootConstrainSelectedInstOperands,
     /* 275606 */     // GIR_Coverage, 5129,
     /* 275606 */     GIR_EraseRootFromParent_Done,
     /* 275607 */   // Label 5569: @275607
     /* 275607 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(275644), // Rule ID 5136 //
     /* 275612 */     // MIs[0] Operand 1
     /* 275612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275635 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275642 */     GIR_RootConstrainSelectedInstOperands,
     /* 275643 */     // GIR_Coverage, 5136,
     /* 275643 */     GIR_EraseRootFromParent_Done,
     /* 275644 */   // Label 5570: @275644
     /* 275644 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(275681), // Rule ID 5143 //
     /* 275649 */     // MIs[0] Operand 1
     /* 275649 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275672 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275679 */     GIR_RootConstrainSelectedInstOperands,
     /* 275680 */     // GIR_Coverage, 5143,
     /* 275680 */     GIR_EraseRootFromParent_Done,
     /* 275681 */   // Label 5571: @275681
     /* 275681 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(275718), // Rule ID 5150 //
     /* 275686 */     // MIs[0] Operand 1
     /* 275686 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275709 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275716 */     GIR_RootConstrainSelectedInstOperands,
     /* 275717 */     // GIR_Coverage, 5150,
     /* 275717 */     GIR_EraseRootFromParent_Done,
     /* 275718 */   // Label 5572: @275718
     /* 275718 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(275755), // Rule ID 5157 //
     /* 275723 */     // MIs[0] Operand 1
     /* 275723 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275746 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275753 */     GIR_RootConstrainSelectedInstOperands,
     /* 275754 */     // GIR_Coverage, 5157,
     /* 275754 */     GIR_EraseRootFromParent_Done,
     /* 275755 */   // Label 5573: @275755
     /* 275755 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(275787), // Rule ID 1126 //
     /* 275760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275763 */     // MIs[0] Operand 1
     /* 275763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275776 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 275779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275785 */     GIR_RootConstrainSelectedInstOperands,
     /* 275786 */     // GIR_Coverage, 1126,
     /* 275786 */     GIR_EraseRootFromParent_Done,
     /* 275787 */   // Label 5574: @275787
     /* 275787 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(275819), // Rule ID 1133 //
     /* 275792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275795 */     // MIs[0] Operand 1
     /* 275795 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275808 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 275811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275817 */     GIR_RootConstrainSelectedInstOperands,
     /* 275818 */     // GIR_Coverage, 1133,
     /* 275818 */     GIR_EraseRootFromParent_Done,
     /* 275819 */   // Label 5575: @275819
     /* 275819 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(275851), // Rule ID 1140 //
     /* 275824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275827 */     // MIs[0] Operand 1
     /* 275827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275840 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 275843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275849 */     GIR_RootConstrainSelectedInstOperands,
     /* 275850 */     // GIR_Coverage, 1140,
     /* 275850 */     GIR_EraseRootFromParent_Done,
     /* 275851 */   // Label 5576: @275851
     /* 275851 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(275883), // Rule ID 1147 //
     /* 275856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275859 */     // MIs[0] Operand 1
     /* 275859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275872 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 275875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275881 */     GIR_RootConstrainSelectedInstOperands,
     /* 275882 */     // GIR_Coverage, 1147,
     /* 275882 */     GIR_EraseRootFromParent_Done,
     /* 275883 */   // Label 5577: @275883
     /* 275883 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(275915), // Rule ID 1154 //
     /* 275888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275891 */     // MIs[0] Operand 1
     /* 275891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275904 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 275907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275913 */     GIR_RootConstrainSelectedInstOperands,
     /* 275914 */     // GIR_Coverage, 1154,
     /* 275914 */     GIR_EraseRootFromParent_Done,
     /* 275915 */   // Label 5578: @275915
     /* 275915 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(275944), // Rule ID 5066 //
     /* 275920 */     // MIs[0] Operand 1
     /* 275920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275933 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 275936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275942 */     GIR_RootConstrainSelectedInstOperands,
     /* 275943 */     // GIR_Coverage, 5066,
     /* 275943 */     GIR_EraseRootFromParent_Done,
     /* 275944 */   // Label 5579: @275944
     /* 275944 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(275973), // Rule ID 5073 //
     /* 275949 */     // MIs[0] Operand 1
     /* 275949 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275962 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 275965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275971 */     GIR_RootConstrainSelectedInstOperands,
     /* 275972 */     // GIR_Coverage, 5073,
     /* 275972 */     GIR_EraseRootFromParent_Done,
     /* 275973 */   // Label 5580: @275973
     /* 275973 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(276002), // Rule ID 5080 //
     /* 275978 */     // MIs[0] Operand 1
     /* 275978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275991 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 275994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276000 */     GIR_RootConstrainSelectedInstOperands,
     /* 276001 */     // GIR_Coverage, 5080,
     /* 276001 */     GIR_EraseRootFromParent_Done,
     /* 276002 */   // Label 5581: @276002
     /* 276002 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276031), // Rule ID 5087 //
     /* 276007 */     // MIs[0] Operand 1
     /* 276007 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276020 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276029 */     GIR_RootConstrainSelectedInstOperands,
     /* 276030 */     // GIR_Coverage, 5087,
     /* 276030 */     GIR_EraseRootFromParent_Done,
     /* 276031 */   // Label 5582: @276031
     /* 276031 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276060), // Rule ID 5094 //
     /* 276036 */     // MIs[0] Operand 1
     /* 276036 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276049 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276058 */     GIR_RootConstrainSelectedInstOperands,
     /* 276059 */     // GIR_Coverage, 5094,
     /* 276059 */     GIR_EraseRootFromParent_Done,
     /* 276060 */   // Label 5583: @276060
     /* 276060 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276089), // Rule ID 5101 //
     /* 276065 */     // MIs[0] Operand 1
     /* 276065 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276078 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276087 */     GIR_RootConstrainSelectedInstOperands,
     /* 276088 */     // GIR_Coverage, 5101,
     /* 276088 */     GIR_EraseRootFromParent_Done,
     /* 276089 */   // Label 5584: @276089
     /* 276089 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(276118), // Rule ID 5108 //
     /* 276094 */     // MIs[0] Operand 1
     /* 276094 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276107 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276116 */     GIR_RootConstrainSelectedInstOperands,
     /* 276117 */     // GIR_Coverage, 5108,
     /* 276117 */     GIR_EraseRootFromParent_Done,
     /* 276118 */   // Label 5585: @276118
     /* 276118 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(276147), // Rule ID 5115 //
     /* 276123 */     // MIs[0] Operand 1
     /* 276123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276136 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276145 */     GIR_RootConstrainSelectedInstOperands,
     /* 276146 */     // GIR_Coverage, 5115,
     /* 276146 */     GIR_EraseRootFromParent_Done,
     /* 276147 */   // Label 5586: @276147
     /* 276147 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(276176), // Rule ID 5122 //
     /* 276152 */     // MIs[0] Operand 1
     /* 276152 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276165 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276174 */     GIR_RootConstrainSelectedInstOperands,
     /* 276175 */     // GIR_Coverage, 5122,
     /* 276175 */     GIR_EraseRootFromParent_Done,
     /* 276176 */   // Label 5587: @276176
     /* 276176 */   GIM_Reject,
     /* 276177 */ // Label 5557: @276177
     /* 276177 */ GIM_Reject,
     /* 276178 */ // Label 5448: @276178
     /* 276178 */ GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(277225),
     /* 276183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 276186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276193 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(276233), // Rule ID 750 //
     /* 276198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276201 */     // MIs[0] Operand 1
     /* 276201 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276210 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276216 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276224 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276231 */     GIR_RootConstrainSelectedInstOperands,
     /* 276232 */     // GIR_Coverage, 750,
     /* 276232 */     GIR_EraseRootFromParent_Done,
     /* 276233 */   // Label 5589: @276233
     /* 276233 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(276273), // Rule ID 757 //
     /* 276238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276241 */     // MIs[0] Operand 1
     /* 276241 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276264 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276271 */     GIR_RootConstrainSelectedInstOperands,
     /* 276272 */     // GIR_Coverage, 757,
     /* 276272 */     GIR_EraseRootFromParent_Done,
     /* 276273 */   // Label 5590: @276273
     /* 276273 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(276310), // Rule ID 5159 //
     /* 276278 */     // MIs[0] Operand 1
     /* 276278 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276287 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276293 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276301 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276308 */     GIR_RootConstrainSelectedInstOperands,
     /* 276309 */     // GIR_Coverage, 5159,
     /* 276309 */     GIR_EraseRootFromParent_Done,
     /* 276310 */   // Label 5591: @276310
     /* 276310 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(276347), // Rule ID 5166 //
     /* 276315 */     // MIs[0] Operand 1
     /* 276315 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276324 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276330 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276338 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276345 */     GIR_RootConstrainSelectedInstOperands,
     /* 276346 */     // GIR_Coverage, 5166,
     /* 276346 */     GIR_EraseRootFromParent_Done,
     /* 276347 */   // Label 5592: @276347
     /* 276347 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(276384), // Rule ID 5173 //
     /* 276352 */     // MIs[0] Operand 1
     /* 276352 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276367 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276375 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276382 */     GIR_RootConstrainSelectedInstOperands,
     /* 276383 */     // GIR_Coverage, 5173,
     /* 276383 */     GIR_EraseRootFromParent_Done,
     /* 276384 */   // Label 5593: @276384
     /* 276384 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(276421), // Rule ID 5180 //
     /* 276389 */     // MIs[0] Operand 1
     /* 276389 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276412 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276419 */     GIR_RootConstrainSelectedInstOperands,
     /* 276420 */     // GIR_Coverage, 5180,
     /* 276420 */     GIR_EraseRootFromParent_Done,
     /* 276421 */   // Label 5594: @276421
     /* 276421 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(276458), // Rule ID 5187 //
     /* 276426 */     // MIs[0] Operand 1
     /* 276426 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276449 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276456 */     GIR_RootConstrainSelectedInstOperands,
     /* 276457 */     // GIR_Coverage, 5187,
     /* 276457 */     GIR_EraseRootFromParent_Done,
     /* 276458 */   // Label 5595: @276458
     /* 276458 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(276498), // Rule ID 722 //
     /* 276463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276466 */     // MIs[0] Operand 1
     /* 276466 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276479 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276485 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276489 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276496 */     GIR_RootConstrainSelectedInstOperands,
     /* 276497 */     // GIR_Coverage, 722,
     /* 276497 */     GIR_EraseRootFromParent_Done,
     /* 276498 */   // Label 5596: @276498
     /* 276498 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(276538), // Rule ID 729 //
     /* 276503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276506 */     // MIs[0] Operand 1
     /* 276506 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276519 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276525 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276529 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276536 */     GIR_RootConstrainSelectedInstOperands,
     /* 276537 */     // GIR_Coverage, 729,
     /* 276537 */     GIR_EraseRootFromParent_Done,
     /* 276538 */   // Label 5597: @276538
     /* 276538 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(276578), // Rule ID 730 //
     /* 276543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276546 */     // MIs[0] Operand 1
     /* 276546 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276569 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276576 */     GIR_RootConstrainSelectedInstOperands,
     /* 276577 */     // GIR_Coverage, 730,
     /* 276577 */     GIR_EraseRootFromParent_Done,
     /* 276578 */   // Label 5598: @276578
     /* 276578 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(276618), // Rule ID 743 //
     /* 276583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276586 */     // MIs[0] Operand 1
     /* 276586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276609 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276616 */     GIR_RootConstrainSelectedInstOperands,
     /* 276617 */     // GIR_Coverage, 743,
     /* 276617 */     GIR_EraseRootFromParent_Done,
     /* 276618 */   // Label 5599: @276618
     /* 276618 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(276655), // Rule ID 5124 //
     /* 276623 */     // MIs[0] Operand 1
     /* 276623 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276646 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276653 */     GIR_RootConstrainSelectedInstOperands,
     /* 276654 */     // GIR_Coverage, 5124,
     /* 276654 */     GIR_EraseRootFromParent_Done,
     /* 276655 */   // Label 5600: @276655
     /* 276655 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(276692), // Rule ID 5131 //
     /* 276660 */     // MIs[0] Operand 1
     /* 276660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276683 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276690 */     GIR_RootConstrainSelectedInstOperands,
     /* 276691 */     // GIR_Coverage, 5131,
     /* 276691 */     GIR_EraseRootFromParent_Done,
     /* 276692 */   // Label 5601: @276692
     /* 276692 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(276729), // Rule ID 5138 //
     /* 276697 */     // MIs[0] Operand 1
     /* 276697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276710 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276716 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276720 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276727 */     GIR_RootConstrainSelectedInstOperands,
     /* 276728 */     // GIR_Coverage, 5138,
     /* 276728 */     GIR_EraseRootFromParent_Done,
     /* 276729 */   // Label 5602: @276729
     /* 276729 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(276766), // Rule ID 5145 //
     /* 276734 */     // MIs[0] Operand 1
     /* 276734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276747 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276753 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276757 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276764 */     GIR_RootConstrainSelectedInstOperands,
     /* 276765 */     // GIR_Coverage, 5145,
     /* 276765 */     GIR_EraseRootFromParent_Done,
     /* 276766 */   // Label 5603: @276766
     /* 276766 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(276803), // Rule ID 5152 //
     /* 276771 */     // MIs[0] Operand 1
     /* 276771 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276784 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276790 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276794 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276801 */     GIR_RootConstrainSelectedInstOperands,
     /* 276802 */     // GIR_Coverage, 5152,
     /* 276802 */     GIR_EraseRootFromParent_Done,
     /* 276803 */   // Label 5604: @276803
     /* 276803 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(276835), // Rule ID 1121 //
     /* 276808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276811 */     // MIs[0] Operand 1
     /* 276811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276824 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 276827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276833 */     GIR_RootConstrainSelectedInstOperands,
     /* 276834 */     // GIR_Coverage, 1121,
     /* 276834 */     GIR_EraseRootFromParent_Done,
     /* 276835 */   // Label 5605: @276835
     /* 276835 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(276867), // Rule ID 1128 //
     /* 276840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276843 */     // MIs[0] Operand 1
     /* 276843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276856 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 276859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276865 */     GIR_RootConstrainSelectedInstOperands,
     /* 276866 */     // GIR_Coverage, 1128,
     /* 276866 */     GIR_EraseRootFromParent_Done,
     /* 276867 */   // Label 5606: @276867
     /* 276867 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(276899), // Rule ID 1135 //
     /* 276872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276875 */     // MIs[0] Operand 1
     /* 276875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276888 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 276891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276897 */     GIR_RootConstrainSelectedInstOperands,
     /* 276898 */     // GIR_Coverage, 1135,
     /* 276898 */     GIR_EraseRootFromParent_Done,
     /* 276899 */   // Label 5607: @276899
     /* 276899 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(276931), // Rule ID 1142 //
     /* 276904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276907 */     // MIs[0] Operand 1
     /* 276907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276920 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 276923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276929 */     GIR_RootConstrainSelectedInstOperands,
     /* 276930 */     // GIR_Coverage, 1142,
     /* 276930 */     GIR_EraseRootFromParent_Done,
     /* 276931 */   // Label 5608: @276931
     /* 276931 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(276963), // Rule ID 1149 //
     /* 276936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276939 */     // MIs[0] Operand 1
     /* 276939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276952 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 276955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276961 */     GIR_RootConstrainSelectedInstOperands,
     /* 276962 */     // GIR_Coverage, 1149,
     /* 276962 */     GIR_EraseRootFromParent_Done,
     /* 276963 */   // Label 5609: @276963
     /* 276963 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(276992), // Rule ID 5061 //
     /* 276968 */     // MIs[0] Operand 1
     /* 276968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276981 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 276984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276990 */     GIR_RootConstrainSelectedInstOperands,
     /* 276991 */     // GIR_Coverage, 5061,
     /* 276991 */     GIR_EraseRootFromParent_Done,
     /* 276992 */   // Label 5610: @276992
     /* 276992 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277021), // Rule ID 5068 //
     /* 276997 */     // MIs[0] Operand 1
     /* 276997 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277010 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277019 */     GIR_RootConstrainSelectedInstOperands,
     /* 277020 */     // GIR_Coverage, 5068,
     /* 277020 */     GIR_EraseRootFromParent_Done,
     /* 277021 */   // Label 5611: @277021
     /* 277021 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(277050), // Rule ID 5075 //
     /* 277026 */     // MIs[0] Operand 1
     /* 277026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277039 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277048 */     GIR_RootConstrainSelectedInstOperands,
     /* 277049 */     // GIR_Coverage, 5075,
     /* 277049 */     GIR_EraseRootFromParent_Done,
     /* 277050 */   // Label 5612: @277050
     /* 277050 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277079), // Rule ID 5082 //
     /* 277055 */     // MIs[0] Operand 1
     /* 277055 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277068 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277077 */     GIR_RootConstrainSelectedInstOperands,
     /* 277078 */     // GIR_Coverage, 5082,
     /* 277078 */     GIR_EraseRootFromParent_Done,
     /* 277079 */   // Label 5613: @277079
     /* 277079 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277108), // Rule ID 5089 //
     /* 277084 */     // MIs[0] Operand 1
     /* 277084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277097 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277106 */     GIR_RootConstrainSelectedInstOperands,
     /* 277107 */     // GIR_Coverage, 5089,
     /* 277107 */     GIR_EraseRootFromParent_Done,
     /* 277108 */   // Label 5614: @277108
     /* 277108 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(277137), // Rule ID 5096 //
     /* 277113 */     // MIs[0] Operand 1
     /* 277113 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277126 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277135 */     GIR_RootConstrainSelectedInstOperands,
     /* 277136 */     // GIR_Coverage, 5096,
     /* 277136 */     GIR_EraseRootFromParent_Done,
     /* 277137 */   // Label 5615: @277137
     /* 277137 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(277166), // Rule ID 5103 //
     /* 277142 */     // MIs[0] Operand 1
     /* 277142 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277155 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277164 */     GIR_RootConstrainSelectedInstOperands,
     /* 277165 */     // GIR_Coverage, 5103,
     /* 277165 */     GIR_EraseRootFromParent_Done,
     /* 277166 */   // Label 5616: @277166
     /* 277166 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(277195), // Rule ID 5110 //
     /* 277171 */     // MIs[0] Operand 1
     /* 277171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277184 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277193 */     GIR_RootConstrainSelectedInstOperands,
     /* 277194 */     // GIR_Coverage, 5110,
     /* 277194 */     GIR_EraseRootFromParent_Done,
     /* 277195 */   // Label 5617: @277195
     /* 277195 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(277224), // Rule ID 5117 //
     /* 277200 */     // MIs[0] Operand 1
     /* 277200 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277213 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277222 */     GIR_RootConstrainSelectedInstOperands,
     /* 277223 */     // GIR_Coverage, 5117,
     /* 277223 */     GIR_EraseRootFromParent_Done,
     /* 277224 */   // Label 5618: @277224
     /* 277224 */   GIM_Reject,
     /* 277225 */ // Label 5588: @277225
     /* 277225 */ GIM_Reject,
     /* 277226 */ // Label 5449: @277226
     /* 277226 */ GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(278273),
     /* 277231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 277237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277241 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(277281), // Rule ID 753 //
     /* 277246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277249 */     // MIs[0] Operand 1
     /* 277249 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277258 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277264 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277272 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277279 */     GIR_RootConstrainSelectedInstOperands,
     /* 277280 */     // GIR_Coverage, 753,
     /* 277280 */     GIR_EraseRootFromParent_Done,
     /* 277281 */   // Label 5620: @277281
     /* 277281 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(277321), // Rule ID 760 //
     /* 277286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277289 */     // MIs[0] Operand 1
     /* 277289 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277298 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277304 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277312 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277319 */     GIR_RootConstrainSelectedInstOperands,
     /* 277320 */     // GIR_Coverage, 760,
     /* 277320 */     GIR_EraseRootFromParent_Done,
     /* 277321 */   // Label 5621: @277321
     /* 277321 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(277358), // Rule ID 5162 //
     /* 277326 */     // MIs[0] Operand 1
     /* 277326 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277341 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277349 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277356 */     GIR_RootConstrainSelectedInstOperands,
     /* 277357 */     // GIR_Coverage, 5162,
     /* 277357 */     GIR_EraseRootFromParent_Done,
     /* 277358 */   // Label 5622: @277358
     /* 277358 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(277395), // Rule ID 5169 //
     /* 277363 */     // MIs[0] Operand 1
     /* 277363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277386 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277393 */     GIR_RootConstrainSelectedInstOperands,
     /* 277394 */     // GIR_Coverage, 5169,
     /* 277394 */     GIR_EraseRootFromParent_Done,
     /* 277395 */   // Label 5623: @277395
     /* 277395 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(277432), // Rule ID 5176 //
     /* 277400 */     // MIs[0] Operand 1
     /* 277400 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277415 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277423 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277430 */     GIR_RootConstrainSelectedInstOperands,
     /* 277431 */     // GIR_Coverage, 5176,
     /* 277431 */     GIR_EraseRootFromParent_Done,
     /* 277432 */   // Label 5624: @277432
     /* 277432 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(277469), // Rule ID 5183 //
     /* 277437 */     // MIs[0] Operand 1
     /* 277437 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277446 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277460 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277467 */     GIR_RootConstrainSelectedInstOperands,
     /* 277468 */     // GIR_Coverage, 5183,
     /* 277468 */     GIR_EraseRootFromParent_Done,
     /* 277469 */   // Label 5625: @277469
     /* 277469 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(277506), // Rule ID 5190 //
     /* 277474 */     // MIs[0] Operand 1
     /* 277474 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277497 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277504 */     GIR_RootConstrainSelectedInstOperands,
     /* 277505 */     // GIR_Coverage, 5190,
     /* 277505 */     GIR_EraseRootFromParent_Done,
     /* 277506 */   // Label 5626: @277506
     /* 277506 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(277546), // Rule ID 725 //
     /* 277511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277514 */     // MIs[0] Operand 1
     /* 277514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277527 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277533 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277537 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277544 */     GIR_RootConstrainSelectedInstOperands,
     /* 277545 */     // GIR_Coverage, 725,
     /* 277545 */     GIR_EraseRootFromParent_Done,
     /* 277546 */   // Label 5627: @277546
     /* 277546 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(277586), // Rule ID 735 //
     /* 277551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277554 */     // MIs[0] Operand 1
     /* 277554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277573 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277577 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277584 */     GIR_RootConstrainSelectedInstOperands,
     /* 277585 */     // GIR_Coverage, 735,
     /* 277585 */     GIR_EraseRootFromParent_Done,
     /* 277586 */   // Label 5628: @277586
     /* 277586 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(277626), // Rule ID 736 //
     /* 277591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277594 */     // MIs[0] Operand 1
     /* 277594 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277607 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277613 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277617 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277624 */     GIR_RootConstrainSelectedInstOperands,
     /* 277625 */     // GIR_Coverage, 736,
     /* 277625 */     GIR_EraseRootFromParent_Done,
     /* 277626 */   // Label 5629: @277626
     /* 277626 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(277666), // Rule ID 746 //
     /* 277631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277634 */     // MIs[0] Operand 1
     /* 277634 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277653 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277657 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277664 */     GIR_RootConstrainSelectedInstOperands,
     /* 277665 */     // GIR_Coverage, 746,
     /* 277665 */     GIR_EraseRootFromParent_Done,
     /* 277666 */   // Label 5630: @277666
     /* 277666 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(277703), // Rule ID 5127 //
     /* 277671 */     // MIs[0] Operand 1
     /* 277671 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277684 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277694 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277701 */     GIR_RootConstrainSelectedInstOperands,
     /* 277702 */     // GIR_Coverage, 5127,
     /* 277702 */     GIR_EraseRootFromParent_Done,
     /* 277703 */   // Label 5631: @277703
     /* 277703 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(277740), // Rule ID 5134 //
     /* 277708 */     // MIs[0] Operand 1
     /* 277708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277731 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277738 */     GIR_RootConstrainSelectedInstOperands,
     /* 277739 */     // GIR_Coverage, 5134,
     /* 277739 */     GIR_EraseRootFromParent_Done,
     /* 277740 */   // Label 5632: @277740
     /* 277740 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(277777), // Rule ID 5141 //
     /* 277745 */     // MIs[0] Operand 1
     /* 277745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277768 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277775 */     GIR_RootConstrainSelectedInstOperands,
     /* 277776 */     // GIR_Coverage, 5141,
     /* 277776 */     GIR_EraseRootFromParent_Done,
     /* 277777 */   // Label 5633: @277777
     /* 277777 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(277814), // Rule ID 5148 //
     /* 277782 */     // MIs[0] Operand 1
     /* 277782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277795 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277801 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277805 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277812 */     GIR_RootConstrainSelectedInstOperands,
     /* 277813 */     // GIR_Coverage, 5148,
     /* 277813 */     GIR_EraseRootFromParent_Done,
     /* 277814 */   // Label 5634: @277814
     /* 277814 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(277851), // Rule ID 5155 //
     /* 277819 */     // MIs[0] Operand 1
     /* 277819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277842 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277849 */     GIR_RootConstrainSelectedInstOperands,
     /* 277850 */     // GIR_Coverage, 5155,
     /* 277850 */     GIR_EraseRootFromParent_Done,
     /* 277851 */   // Label 5635: @277851
     /* 277851 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(277883), // Rule ID 1124 //
     /* 277856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277859 */     // MIs[0] Operand 1
     /* 277859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277872 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 277875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277881 */     GIR_RootConstrainSelectedInstOperands,
     /* 277882 */     // GIR_Coverage, 1124,
     /* 277882 */     GIR_EraseRootFromParent_Done,
     /* 277883 */   // Label 5636: @277883
     /* 277883 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(277915), // Rule ID 1131 //
     /* 277888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277891 */     // MIs[0] Operand 1
     /* 277891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277904 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 277907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277913 */     GIR_RootConstrainSelectedInstOperands,
     /* 277914 */     // GIR_Coverage, 1131,
     /* 277914 */     GIR_EraseRootFromParent_Done,
     /* 277915 */   // Label 5637: @277915
     /* 277915 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(277947), // Rule ID 1138 //
     /* 277920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277923 */     // MIs[0] Operand 1
     /* 277923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277936 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 277939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277945 */     GIR_RootConstrainSelectedInstOperands,
     /* 277946 */     // GIR_Coverage, 1138,
     /* 277946 */     GIR_EraseRootFromParent_Done,
     /* 277947 */   // Label 5638: @277947
     /* 277947 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(277979), // Rule ID 1145 //
     /* 277952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277955 */     // MIs[0] Operand 1
     /* 277955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277968 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 277971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277977 */     GIR_RootConstrainSelectedInstOperands,
     /* 277978 */     // GIR_Coverage, 1145,
     /* 277978 */     GIR_EraseRootFromParent_Done,
     /* 277979 */   // Label 5639: @277979
     /* 277979 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278011), // Rule ID 1152 //
     /* 277984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277987 */     // MIs[0] Operand 1
     /* 277987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278000 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278009 */     GIR_RootConstrainSelectedInstOperands,
     /* 278010 */     // GIR_Coverage, 1152,
     /* 278010 */     GIR_EraseRootFromParent_Done,
     /* 278011 */   // Label 5640: @278011
     /* 278011 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278040), // Rule ID 5064 //
     /* 278016 */     // MIs[0] Operand 1
     /* 278016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278029 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278038 */     GIR_RootConstrainSelectedInstOperands,
     /* 278039 */     // GIR_Coverage, 5064,
     /* 278039 */     GIR_EraseRootFromParent_Done,
     /* 278040 */   // Label 5641: @278040
     /* 278040 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278069), // Rule ID 5071 //
     /* 278045 */     // MIs[0] Operand 1
     /* 278045 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278058 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278067 */     GIR_RootConstrainSelectedInstOperands,
     /* 278068 */     // GIR_Coverage, 5071,
     /* 278068 */     GIR_EraseRootFromParent_Done,
     /* 278069 */   // Label 5642: @278069
     /* 278069 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(278098), // Rule ID 5078 //
     /* 278074 */     // MIs[0] Operand 1
     /* 278074 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278087 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278096 */     GIR_RootConstrainSelectedInstOperands,
     /* 278097 */     // GIR_Coverage, 5078,
     /* 278097 */     GIR_EraseRootFromParent_Done,
     /* 278098 */   // Label 5643: @278098
     /* 278098 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278127), // Rule ID 5085 //
     /* 278103 */     // MIs[0] Operand 1
     /* 278103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278116 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278125 */     GIR_RootConstrainSelectedInstOperands,
     /* 278126 */     // GIR_Coverage, 5085,
     /* 278126 */     GIR_EraseRootFromParent_Done,
     /* 278127 */   // Label 5644: @278127
     /* 278127 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(278156), // Rule ID 5092 //
     /* 278132 */     // MIs[0] Operand 1
     /* 278132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278145 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278154 */     GIR_RootConstrainSelectedInstOperands,
     /* 278155 */     // GIR_Coverage, 5092,
     /* 278155 */     GIR_EraseRootFromParent_Done,
     /* 278156 */   // Label 5645: @278156
     /* 278156 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(278185), // Rule ID 5099 //
     /* 278161 */     // MIs[0] Operand 1
     /* 278161 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278174 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278183 */     GIR_RootConstrainSelectedInstOperands,
     /* 278184 */     // GIR_Coverage, 5099,
     /* 278184 */     GIR_EraseRootFromParent_Done,
     /* 278185 */   // Label 5646: @278185
     /* 278185 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(278214), // Rule ID 5106 //
     /* 278190 */     // MIs[0] Operand 1
     /* 278190 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278203 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278212 */     GIR_RootConstrainSelectedInstOperands,
     /* 278213 */     // GIR_Coverage, 5106,
     /* 278213 */     GIR_EraseRootFromParent_Done,
     /* 278214 */   // Label 5647: @278214
     /* 278214 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(278243), // Rule ID 5113 //
     /* 278219 */     // MIs[0] Operand 1
     /* 278219 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278232 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278241 */     GIR_RootConstrainSelectedInstOperands,
     /* 278242 */     // GIR_Coverage, 5113,
     /* 278242 */     GIR_EraseRootFromParent_Done,
     /* 278243 */   // Label 5648: @278243
     /* 278243 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(278272), // Rule ID 5120 //
     /* 278248 */     // MIs[0] Operand 1
     /* 278248 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278261 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278270 */     GIR_RootConstrainSelectedInstOperands,
     /* 278271 */     // GIR_Coverage, 5120,
     /* 278271 */     GIR_EraseRootFromParent_Done,
     /* 278272 */   // Label 5649: @278272
     /* 278272 */   GIM_Reject,
     /* 278273 */ // Label 5619: @278273
     /* 278273 */ GIM_Reject,
     /* 278274 */ // Label 5450: @278274
     /* 278274 */ GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(279321),
     /* 278279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 278285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278289 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(278329), // Rule ID 751 //
     /* 278294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278297 */     // MIs[0] Operand 1
     /* 278297 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278306 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278312 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278320 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278327 */     GIR_RootConstrainSelectedInstOperands,
     /* 278328 */     // GIR_Coverage, 751,
     /* 278328 */     GIR_EraseRootFromParent_Done,
     /* 278329 */   // Label 5651: @278329
     /* 278329 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(278369), // Rule ID 758 //
     /* 278334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278337 */     // MIs[0] Operand 1
     /* 278337 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278360 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278367 */     GIR_RootConstrainSelectedInstOperands,
     /* 278368 */     // GIR_Coverage, 758,
     /* 278368 */     GIR_EraseRootFromParent_Done,
     /* 278369 */   // Label 5652: @278369
     /* 278369 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(278406), // Rule ID 5160 //
     /* 278374 */     // MIs[0] Operand 1
     /* 278374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278383 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278389 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278397 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278404 */     GIR_RootConstrainSelectedInstOperands,
     /* 278405 */     // GIR_Coverage, 5160,
     /* 278405 */     GIR_EraseRootFromParent_Done,
     /* 278406 */   // Label 5653: @278406
     /* 278406 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(278443), // Rule ID 5167 //
     /* 278411 */     // MIs[0] Operand 1
     /* 278411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278420 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278426 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278434 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278441 */     GIR_RootConstrainSelectedInstOperands,
     /* 278442 */     // GIR_Coverage, 5167,
     /* 278442 */     GIR_EraseRootFromParent_Done,
     /* 278443 */   // Label 5654: @278443
     /* 278443 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(278480), // Rule ID 5174 //
     /* 278448 */     // MIs[0] Operand 1
     /* 278448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278471 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278478 */     GIR_RootConstrainSelectedInstOperands,
     /* 278479 */     // GIR_Coverage, 5174,
     /* 278479 */     GIR_EraseRootFromParent_Done,
     /* 278480 */   // Label 5655: @278480
     /* 278480 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(278517), // Rule ID 5181 //
     /* 278485 */     // MIs[0] Operand 1
     /* 278485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278494 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278500 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278508 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278515 */     GIR_RootConstrainSelectedInstOperands,
     /* 278516 */     // GIR_Coverage, 5181,
     /* 278516 */     GIR_EraseRootFromParent_Done,
     /* 278517 */   // Label 5656: @278517
     /* 278517 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(278554), // Rule ID 5188 //
     /* 278522 */     // MIs[0] Operand 1
     /* 278522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278531 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278545 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278552 */     GIR_RootConstrainSelectedInstOperands,
     /* 278553 */     // GIR_Coverage, 5188,
     /* 278553 */     GIR_EraseRootFromParent_Done,
     /* 278554 */   // Label 5657: @278554
     /* 278554 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(278594), // Rule ID 723 //
     /* 278559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278562 */     // MIs[0] Operand 1
     /* 278562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278585 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278592 */     GIR_RootConstrainSelectedInstOperands,
     /* 278593 */     // GIR_Coverage, 723,
     /* 278593 */     GIR_EraseRootFromParent_Done,
     /* 278594 */   // Label 5658: @278594
     /* 278594 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(278634), // Rule ID 731 //
     /* 278599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278602 */     // MIs[0] Operand 1
     /* 278602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278625 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278632 */     GIR_RootConstrainSelectedInstOperands,
     /* 278633 */     // GIR_Coverage, 731,
     /* 278633 */     GIR_EraseRootFromParent_Done,
     /* 278634 */   // Label 5659: @278634
     /* 278634 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(278674), // Rule ID 732 //
     /* 278639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278642 */     // MIs[0] Operand 1
     /* 278642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278665 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278672 */     GIR_RootConstrainSelectedInstOperands,
     /* 278673 */     // GIR_Coverage, 732,
     /* 278673 */     GIR_EraseRootFromParent_Done,
     /* 278674 */   // Label 5660: @278674
     /* 278674 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(278714), // Rule ID 744 //
     /* 278679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278682 */     // MIs[0] Operand 1
     /* 278682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278705 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278712 */     GIR_RootConstrainSelectedInstOperands,
     /* 278713 */     // GIR_Coverage, 744,
     /* 278713 */     GIR_EraseRootFromParent_Done,
     /* 278714 */   // Label 5661: @278714
     /* 278714 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(278751), // Rule ID 5125 //
     /* 278719 */     // MIs[0] Operand 1
     /* 278719 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278732 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278738 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278742 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278749 */     GIR_RootConstrainSelectedInstOperands,
     /* 278750 */     // GIR_Coverage, 5125,
     /* 278750 */     GIR_EraseRootFromParent_Done,
     /* 278751 */   // Label 5662: @278751
     /* 278751 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(278788), // Rule ID 5132 //
     /* 278756 */     // MIs[0] Operand 1
     /* 278756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278775 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278779 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278786 */     GIR_RootConstrainSelectedInstOperands,
     /* 278787 */     // GIR_Coverage, 5132,
     /* 278787 */     GIR_EraseRootFromParent_Done,
     /* 278788 */   // Label 5663: @278788
     /* 278788 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(278825), // Rule ID 5139 //
     /* 278793 */     // MIs[0] Operand 1
     /* 278793 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278806 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278812 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278816 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278823 */     GIR_RootConstrainSelectedInstOperands,
     /* 278824 */     // GIR_Coverage, 5139,
     /* 278824 */     GIR_EraseRootFromParent_Done,
     /* 278825 */   // Label 5664: @278825
     /* 278825 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(278862), // Rule ID 5146 //
     /* 278830 */     // MIs[0] Operand 1
     /* 278830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278849 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278853 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278860 */     GIR_RootConstrainSelectedInstOperands,
     /* 278861 */     // GIR_Coverage, 5146,
     /* 278861 */     GIR_EraseRootFromParent_Done,
     /* 278862 */   // Label 5665: @278862
     /* 278862 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(278899), // Rule ID 5153 //
     /* 278867 */     // MIs[0] Operand 1
     /* 278867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278890 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278897 */     GIR_RootConstrainSelectedInstOperands,
     /* 278898 */     // GIR_Coverage, 5153,
     /* 278898 */     GIR_EraseRootFromParent_Done,
     /* 278899 */   // Label 5666: @278899
     /* 278899 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(278931), // Rule ID 1122 //
     /* 278904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278907 */     // MIs[0] Operand 1
     /* 278907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278920 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 278923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278929 */     GIR_RootConstrainSelectedInstOperands,
     /* 278930 */     // GIR_Coverage, 1122,
     /* 278930 */     GIR_EraseRootFromParent_Done,
     /* 278931 */   // Label 5667: @278931
     /* 278931 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(278963), // Rule ID 1129 //
     /* 278936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278939 */     // MIs[0] Operand 1
     /* 278939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278952 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 278955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278961 */     GIR_RootConstrainSelectedInstOperands,
     /* 278962 */     // GIR_Coverage, 1129,
     /* 278962 */     GIR_EraseRootFromParent_Done,
     /* 278963 */   // Label 5668: @278963
     /* 278963 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(278995), // Rule ID 1136 //
     /* 278968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278971 */     // MIs[0] Operand 1
     /* 278971 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278984 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 278987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278993 */     GIR_RootConstrainSelectedInstOperands,
     /* 278994 */     // GIR_Coverage, 1136,
     /* 278994 */     GIR_EraseRootFromParent_Done,
     /* 278995 */   // Label 5669: @278995
     /* 278995 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279027), // Rule ID 1143 //
     /* 279000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279003 */     // MIs[0] Operand 1
     /* 279003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279016 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279025 */     GIR_RootConstrainSelectedInstOperands,
     /* 279026 */     // GIR_Coverage, 1143,
     /* 279026 */     GIR_EraseRootFromParent_Done,
     /* 279027 */   // Label 5670: @279027
     /* 279027 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279059), // Rule ID 1150 //
     /* 279032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279035 */     // MIs[0] Operand 1
     /* 279035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279048 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279057 */     GIR_RootConstrainSelectedInstOperands,
     /* 279058 */     // GIR_Coverage, 1150,
     /* 279058 */     GIR_EraseRootFromParent_Done,
     /* 279059 */   // Label 5671: @279059
     /* 279059 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279088), // Rule ID 5062 //
     /* 279064 */     // MIs[0] Operand 1
     /* 279064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279077 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279086 */     GIR_RootConstrainSelectedInstOperands,
     /* 279087 */     // GIR_Coverage, 5062,
     /* 279087 */     GIR_EraseRootFromParent_Done,
     /* 279088 */   // Label 5672: @279088
     /* 279088 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279117), // Rule ID 5069 //
     /* 279093 */     // MIs[0] Operand 1
     /* 279093 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279106 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279115 */     GIR_RootConstrainSelectedInstOperands,
     /* 279116 */     // GIR_Coverage, 5069,
     /* 279116 */     GIR_EraseRootFromParent_Done,
     /* 279117 */   // Label 5673: @279117
     /* 279117 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(279146), // Rule ID 5076 //
     /* 279122 */     // MIs[0] Operand 1
     /* 279122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279135 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279144 */     GIR_RootConstrainSelectedInstOperands,
     /* 279145 */     // GIR_Coverage, 5076,
     /* 279145 */     GIR_EraseRootFromParent_Done,
     /* 279146 */   // Label 5674: @279146
     /* 279146 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(279175), // Rule ID 5083 //
     /* 279151 */     // MIs[0] Operand 1
     /* 279151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279164 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279173 */     GIR_RootConstrainSelectedInstOperands,
     /* 279174 */     // GIR_Coverage, 5083,
     /* 279174 */     GIR_EraseRootFromParent_Done,
     /* 279175 */   // Label 5675: @279175
     /* 279175 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(279204), // Rule ID 5090 //
     /* 279180 */     // MIs[0] Operand 1
     /* 279180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279193 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279202 */     GIR_RootConstrainSelectedInstOperands,
     /* 279203 */     // GIR_Coverage, 5090,
     /* 279203 */     GIR_EraseRootFromParent_Done,
     /* 279204 */   // Label 5676: @279204
     /* 279204 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(279233), // Rule ID 5097 //
     /* 279209 */     // MIs[0] Operand 1
     /* 279209 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279222 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279231 */     GIR_RootConstrainSelectedInstOperands,
     /* 279232 */     // GIR_Coverage, 5097,
     /* 279232 */     GIR_EraseRootFromParent_Done,
     /* 279233 */   // Label 5677: @279233
     /* 279233 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(279262), // Rule ID 5104 //
     /* 279238 */     // MIs[0] Operand 1
     /* 279238 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279251 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279260 */     GIR_RootConstrainSelectedInstOperands,
     /* 279261 */     // GIR_Coverage, 5104,
     /* 279261 */     GIR_EraseRootFromParent_Done,
     /* 279262 */   // Label 5678: @279262
     /* 279262 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(279291), // Rule ID 5111 //
     /* 279267 */     // MIs[0] Operand 1
     /* 279267 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279280 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279289 */     GIR_RootConstrainSelectedInstOperands,
     /* 279290 */     // GIR_Coverage, 5111,
     /* 279290 */     GIR_EraseRootFromParent_Done,
     /* 279291 */   // Label 5679: @279291
     /* 279291 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(279320), // Rule ID 5118 //
     /* 279296 */     // MIs[0] Operand 1
     /* 279296 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279309 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279318 */     GIR_RootConstrainSelectedInstOperands,
     /* 279319 */     // GIR_Coverage, 5118,
     /* 279319 */     GIR_EraseRootFromParent_Done,
     /* 279320 */   // Label 5680: @279320
     /* 279320 */   GIM_Reject,
     /* 279321 */ // Label 5650: @279321
     /* 279321 */ GIM_Reject,
     /* 279322 */ // Label 5451: @279322
     /* 279322 */ GIM_Reject,
     /* 279323 */ // Label 50: @279323
     /* 279323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5693*/ GIMT_Encode4(280367),
     /* 279334 */ /*GILLT_nxv1s1*//*Label 5681*/ GIMT_Encode4(279382),
     /* 279338 */ /*GILLT_nxv2s1*//*Label 5682*/ GIMT_Encode4(279411),
     /* 279342 */ /*GILLT_nxv2s16*//*Label 5683*/ GIMT_Encode4(279440),
     /* 279346 */ /*GILLT_nxv2s32*//*Label 5684*/ GIMT_Encode4(279525),
     /* 279350 */ /*GILLT_nxv2s64*//*Label 5685*/ GIMT_Encode4(279610),
     /* 279354 */ /*GILLT_nxv4s1*//*Label 5686*/ GIMT_Encode4(279776),
     /* 279358 */ /*GILLT_nxv4s16*//*Label 5687*/ GIMT_Encode4(279805),
     /* 279362 */ /*GILLT_nxv4s32*//*Label 5688*/ GIMT_Encode4(279890),
     /* 279366 */ /*GILLT_nxv8s1*//*Label 5689*/ GIMT_Encode4(280056),
     /* 279370 */ /*GILLT_nxv8s16*//*Label 5690*/ GIMT_Encode4(280085),
     /* 279374 */ /*GILLT_nxv16s1*//*Label 5691*/ GIMT_Encode4(280251),
     /* 279378 */ /*GILLT_nxv16s8*//*Label 5692*/ GIMT_Encode4(280280),
     /* 279382 */ // Label 5681: @279382
     /* 279382 */ GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(279410), // Rule ID 8394 //
     /* 279387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 279393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 279396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 279399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279403 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 279403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279408 */   GIR_RootConstrainSelectedInstOperands,
     /* 279409 */   // GIR_Coverage, 8394,
     /* 279409 */   GIR_Done,
     /* 279410 */ // Label 5694: @279410
     /* 279410 */ GIM_Reject,
     /* 279411 */ // Label 5682: @279411
     /* 279411 */ GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(279439), // Rule ID 8393 //
     /* 279416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 279425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 279428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279432 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 279432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279437 */   GIR_RootConstrainSelectedInstOperands,
     /* 279438 */   // GIR_Coverage, 8393,
     /* 279438 */   GIR_Done,
     /* 279439 */ // Label 5695: @279439
     /* 279439 */ GIM_Reject,
     /* 279440 */ // Label 5683: @279440
     /* 279440 */ GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(279524),
     /* 279445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 279451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 279454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279458 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(279508), // Rule ID 3161 //
     /* 279463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279486 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279490 */     // MIs[2] Operand 1
     /* 279490 */     // No operand predicates
     /* 279490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279492 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 279495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279497 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279499 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279501 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 279506 */     GIR_RootConstrainSelectedInstOperands,
     /* 279507 */     // GIR_Coverage, 3161,
     /* 279507 */     GIR_EraseRootFromParent_Done,
     /* 279508 */   // Label 5697: @279508
     /* 279508 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(279523), // Rule ID 2741 //
     /* 279513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279516 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 279516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279521 */     GIR_RootConstrainSelectedInstOperands,
     /* 279522 */     // GIR_Coverage, 2741,
     /* 279522 */     GIR_Done,
     /* 279523 */   // Label 5698: @279523
     /* 279523 */   GIM_Reject,
     /* 279524 */ // Label 5696: @279524
     /* 279524 */ GIM_Reject,
     /* 279525 */ // Label 5684: @279525
     /* 279525 */ GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(279609),
     /* 279530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 279536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 279539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279543 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(279593), // Rule ID 3163 //
     /* 279548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279571 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279575 */     // MIs[2] Operand 1
     /* 279575 */     // No operand predicates
     /* 279575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279577 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 279577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 279580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279582 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279584 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279586 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 279591 */     GIR_RootConstrainSelectedInstOperands,
     /* 279592 */     // GIR_Coverage, 3163,
     /* 279592 */     GIR_EraseRootFromParent_Done,
     /* 279593 */   // Label 5700: @279593
     /* 279593 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(279608), // Rule ID 2742 //
     /* 279598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279601 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 279601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279606 */     GIR_RootConstrainSelectedInstOperands,
     /* 279607 */     // GIR_Coverage, 2742,
     /* 279607 */     GIR_Done,
     /* 279608 */   // Label 5701: @279608
     /* 279608 */   GIM_Reject,
     /* 279609 */ // Label 5699: @279609
     /* 279609 */ GIM_Reject,
     /* 279610 */ // Label 5685: @279610
     /* 279610 */ GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(279775),
     /* 279615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279621 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(279678), // Rule ID 3164 //
     /* 279626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 279648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279656 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279660 */     // MIs[2] Operand 1
     /* 279660 */     // No operand predicates
     /* 279660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279662 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 279662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 279665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279667 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279669 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279671 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 279676 */     GIR_RootConstrainSelectedInstOperands,
     /* 279677 */     // GIR_Coverage, 3164,
     /* 279677 */     GIR_EraseRootFromParent_Done,
     /* 279678 */   // Label 5703: @279678
     /* 279678 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(279730), // Rule ID 7444 //
     /* 279683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 279702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279706 */     // MIs[0] Op2
     /* 279706 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 279711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279713 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 279716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 279718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 279720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 279724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 279728 */     GIR_RootConstrainSelectedInstOperands,
     /* 279729 */     // GIR_Coverage, 7444,
     /* 279729 */     GIR_EraseRootFromParent_Done,
     /* 279730 */   // Label 5704: @279730
     /* 279730 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(279752), // Rule ID 2737 //
     /* 279735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279745 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279750 */     GIR_RootConstrainSelectedInstOperands,
     /* 279751 */     // GIR_Coverage, 2737,
     /* 279751 */     GIR_Done,
     /* 279752 */   // Label 5705: @279752
     /* 279752 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(279774), // Rule ID 2743 //
     /* 279757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279767 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 279767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279772 */     GIR_RootConstrainSelectedInstOperands,
     /* 279773 */     // GIR_Coverage, 2743,
     /* 279773 */     GIR_Done,
     /* 279774 */   // Label 5706: @279774
     /* 279774 */   GIM_Reject,
     /* 279775 */ // Label 5702: @279775
     /* 279775 */ GIM_Reject,
     /* 279776 */ // Label 5686: @279776
     /* 279776 */ GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(279804), // Rule ID 8392 //
     /* 279781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 279790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 279793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279797 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 279797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279802 */   GIR_RootConstrainSelectedInstOperands,
     /* 279803 */   // GIR_Coverage, 8392,
     /* 279803 */   GIR_Done,
     /* 279804 */ // Label 5707: @279804
     /* 279804 */ GIM_Reject,
     /* 279805 */ // Label 5687: @279805
     /* 279805 */ GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(279889),
     /* 279810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 279816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 279819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279823 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(279873), // Rule ID 3160 //
     /* 279828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279851 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279855 */     // MIs[2] Operand 1
     /* 279855 */     // No operand predicates
     /* 279855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279857 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 279860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279862 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279864 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279866 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 279871 */     GIR_RootConstrainSelectedInstOperands,
     /* 279872 */     // GIR_Coverage, 3160,
     /* 279872 */     GIR_EraseRootFromParent_Done,
     /* 279873 */   // Label 5709: @279873
     /* 279873 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(279888), // Rule ID 2739 //
     /* 279878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279881 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 279881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 279886 */     GIR_RootConstrainSelectedInstOperands,
     /* 279887 */     // GIR_Coverage, 2739,
     /* 279887 */     GIR_Done,
     /* 279888 */   // Label 5710: @279888
     /* 279888 */   GIM_Reject,
     /* 279889 */ // Label 5708: @279889
     /* 279889 */ GIM_Reject,
     /* 279890 */ // Label 5688: @279890
     /* 279890 */ GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(280055),
     /* 279895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279901 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(279958), // Rule ID 3162 //
     /* 279906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 279912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279936 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279940 */     // MIs[2] Operand 1
     /* 279940 */     // No operand predicates
     /* 279940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279942 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 279942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 279945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279947 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279949 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279951 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 279956 */     GIR_RootConstrainSelectedInstOperands,
     /* 279957 */     // GIR_Coverage, 3162,
     /* 279957 */     GIR_EraseRootFromParent_Done,
     /* 279958 */   // Label 5712: @279958
     /* 279958 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(280010), // Rule ID 7442 //
     /* 279963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279986 */     // MIs[0] Op2
     /* 279986 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 279991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279993 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 279993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 279996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 279998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280008 */     GIR_RootConstrainSelectedInstOperands,
     /* 280009 */     // GIR_Coverage, 7442,
     /* 280009 */     GIR_EraseRootFromParent_Done,
     /* 280010 */   // Label 5713: @280010
     /* 280010 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(280032), // Rule ID 2736 //
     /* 280015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280025 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 280025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280030 */     GIR_RootConstrainSelectedInstOperands,
     /* 280031 */     // GIR_Coverage, 2736,
     /* 280031 */     GIR_Done,
     /* 280032 */   // Label 5714: @280032
     /* 280032 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(280054), // Rule ID 2740 //
     /* 280037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280047 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 280047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280052 */     GIR_RootConstrainSelectedInstOperands,
     /* 280053 */     // GIR_Coverage, 2740,
     /* 280053 */     GIR_Done,
     /* 280054 */   // Label 5715: @280054
     /* 280054 */   GIM_Reject,
     /* 280055 */ // Label 5711: @280055
     /* 280055 */ GIM_Reject,
     /* 280056 */ // Label 5689: @280056
     /* 280056 */ GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(280084), // Rule ID 8391 //
     /* 280061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 280070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 280073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280077 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 280077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280082 */   GIR_RootConstrainSelectedInstOperands,
     /* 280083 */   // GIR_Coverage, 8391,
     /* 280083 */   GIR_Done,
     /* 280084 */ // Label 5716: @280084
     /* 280084 */ GIM_Reject,
     /* 280085 */ // Label 5690: @280085
     /* 280085 */ GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(280250),
     /* 280090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280096 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(280153), // Rule ID 3159 //
     /* 280101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280131 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280135 */     // MIs[2] Operand 1
     /* 280135 */     // No operand predicates
     /* 280135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280137 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280142 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280144 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280146 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280151 */     GIR_RootConstrainSelectedInstOperands,
     /* 280152 */     // GIR_Coverage, 3159,
     /* 280152 */     GIR_EraseRootFromParent_Done,
     /* 280153 */   // Label 5718: @280153
     /* 280153 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(280205), // Rule ID 7440 //
     /* 280158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280181 */     // MIs[0] Op2
     /* 280181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280188 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 280191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280203 */     GIR_RootConstrainSelectedInstOperands,
     /* 280204 */     // GIR_Coverage, 7440,
     /* 280204 */     GIR_EraseRootFromParent_Done,
     /* 280205 */   // Label 5719: @280205
     /* 280205 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(280227), // Rule ID 2735 //
     /* 280210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280220 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280225 */     GIR_RootConstrainSelectedInstOperands,
     /* 280226 */     // GIR_Coverage, 2735,
     /* 280226 */     GIR_Done,
     /* 280227 */   // Label 5720: @280227
     /* 280227 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(280249), // Rule ID 2738 //
     /* 280232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280242 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 280242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280247 */     GIR_RootConstrainSelectedInstOperands,
     /* 280248 */     // GIR_Coverage, 2738,
     /* 280248 */     GIR_Done,
     /* 280249 */   // Label 5721: @280249
     /* 280249 */   GIM_Reject,
     /* 280250 */ // Label 5717: @280250
     /* 280250 */ GIM_Reject,
     /* 280251 */ // Label 5691: @280251
     /* 280251 */ GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(280279), // Rule ID 8390 //
     /* 280256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 280265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 280268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280272 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 280272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280277 */   GIR_RootConstrainSelectedInstOperands,
     /* 280278 */   // GIR_Coverage, 8390,
     /* 280278 */   GIR_Done,
     /* 280279 */ // Label 5722: @280279
     /* 280279 */ GIM_Reject,
     /* 280280 */ // Label 5692: @280280
     /* 280280 */ GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(280366),
     /* 280285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280291 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(280343), // Rule ID 7438 //
     /* 280296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280319 */     // MIs[0] Op2
     /* 280319 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280326 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 280329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280341 */     GIR_RootConstrainSelectedInstOperands,
     /* 280342 */     // GIR_Coverage, 7438,
     /* 280342 */     GIR_EraseRootFromParent_Done,
     /* 280343 */   // Label 5724: @280343
     /* 280343 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(280365), // Rule ID 2734 //
     /* 280348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 280354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280358 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 280363 */     GIR_RootConstrainSelectedInstOperands,
     /* 280364 */     // GIR_Coverage, 2734,
     /* 280364 */     GIR_Done,
     /* 280365 */   // Label 5725: @280365
     /* 280365 */   GIM_Reject,
     /* 280366 */ // Label 5723: @280366
     /* 280366 */ GIM_Reject,
     /* 280367 */ // Label 5693: @280367
     /* 280367 */ GIM_Reject,
     /* 280368 */ // Label 51: @280368
     /* 280368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5730*/ GIMT_Encode4(280851),
     /* 280379 */ /*GILLT_s64*//*Label 5726*/ GIMT_Encode4(280415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280399 */ /*GILLT_v4s32*//*Label 5727*/ GIMT_Encode4(280446), GIMT_Encode4(0),
     /* 280407 */ /*GILLT_v8s16*//*Label 5728*/ GIMT_Encode4(280581),
     /* 280411 */ /*GILLT_v16s8*//*Label 5729*/ GIMT_Encode4(280716),
     /* 280415 */ // Label 5726: @280415
     /* 280415 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(280445), // Rule ID 128 //
     /* 280420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280438 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 280443 */   GIR_RootConstrainSelectedInstOperands,
     /* 280444 */   // GIR_Coverage, 128,
     /* 280444 */   GIR_Done,
     /* 280445 */ // Label 5731: @280445
     /* 280445 */ GIM_Reject,
     /* 280446 */ // Label 5727: @280446
     /* 280446 */ GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(280580), // Rule ID 6496 //
     /* 280451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280469 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280469 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280472 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 280476 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280481 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280485 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280491 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280494 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280498 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280503 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280509 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280514 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280519 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280522 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280526 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280531 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280537 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280542 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280547 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280550 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 280554 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280559 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280562 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 280570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280578 */   GIR_RootConstrainSelectedInstOperands,
     /* 280579 */   // GIR_Coverage, 6496,
     /* 280579 */   GIR_EraseRootFromParent_Done,
     /* 280580 */ // Label 5732: @280580
     /* 280580 */ GIM_Reject,
     /* 280581 */ // Label 5728: @280581
     /* 280581 */ GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(280715), // Rule ID 6495 //
     /* 280586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280604 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 280604 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280607 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 280611 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280616 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280620 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280626 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280629 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280633 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280638 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280644 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280666 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280672 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280677 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 280689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280694 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280697 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 280705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280713 */   GIR_RootConstrainSelectedInstOperands,
     /* 280714 */   // GIR_Coverage, 6495,
     /* 280714 */   GIR_EraseRootFromParent_Done,
     /* 280715 */ // Label 5733: @280715
     /* 280715 */ GIM_Reject,
     /* 280716 */ // Label 5729: @280716
     /* 280716 */ GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(280850), // Rule ID 6494 //
     /* 280721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280739 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 280739 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280742 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 280746 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280751 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280755 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280761 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280764 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280768 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280773 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280779 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280784 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280789 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280792 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280796 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280801 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280807 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280812 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 280824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280829 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280832 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 280840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280848 */   GIR_RootConstrainSelectedInstOperands,
     /* 280849 */   // GIR_Coverage, 6494,
     /* 280849 */   GIR_EraseRootFromParent_Done,
     /* 280850 */ // Label 5734: @280850
     /* 280850 */ GIM_Reject,
     /* 280851 */ // Label 5730: @280851
     /* 280851 */ GIM_Reject,
     /* 280852 */ // Label 52: @280852
     /* 280852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5739*/ GIMT_Encode4(281335),
     /* 280863 */ /*GILLT_s64*//*Label 5735*/ GIMT_Encode4(280899), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280883 */ /*GILLT_v4s32*//*Label 5736*/ GIMT_Encode4(280930), GIMT_Encode4(0),
     /* 280891 */ /*GILLT_v8s16*//*Label 5737*/ GIMT_Encode4(281065),
     /* 280895 */ /*GILLT_v16s8*//*Label 5738*/ GIMT_Encode4(281200),
     /* 280899 */ // Label 5735: @280899
     /* 280899 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(280929), // Rule ID 127 //
     /* 280904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280922 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 280927 */   GIR_RootConstrainSelectedInstOperands,
     /* 280928 */   // GIR_Coverage, 127,
     /* 280928 */   GIR_Done,
     /* 280929 */ // Label 5740: @280929
     /* 280929 */ GIM_Reject,
     /* 280930 */ // Label 5736: @280930
     /* 280930 */ GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(281064), // Rule ID 6493 //
     /* 280935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280953 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280953 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280956 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 280960 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280965 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280969 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280975 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280978 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280982 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280987 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280993 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280998 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281015 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281021 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281026 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 281038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281062 */   GIR_RootConstrainSelectedInstOperands,
     /* 281063 */   // GIR_Coverage, 6493,
     /* 281063 */   GIR_EraseRootFromParent_Done,
     /* 281064 */ // Label 5741: @281064
     /* 281064 */ GIM_Reject,
     /* 281065 */ // Label 5737: @281065
     /* 281065 */ GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(281199), // Rule ID 6492 //
     /* 281070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281088 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281088 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281091 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 281095 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281100 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281104 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281110 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281113 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281117 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281122 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281128 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281133 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281138 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281141 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281145 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281150 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281156 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281161 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 281173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281178 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281181 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281197 */   GIR_RootConstrainSelectedInstOperands,
     /* 281198 */   // GIR_Coverage, 6492,
     /* 281198 */   GIR_EraseRootFromParent_Done,
     /* 281199 */ // Label 5742: @281199
     /* 281199 */ GIM_Reject,
     /* 281200 */ // Label 5738: @281200
     /* 281200 */ GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(281334), // Rule ID 6491 //
     /* 281205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281223 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281223 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281226 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 281230 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281235 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281239 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281245 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281248 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281252 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281257 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281263 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281273 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281276 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281280 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281285 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281291 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281296 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 281308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281313 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281332 */   GIR_RootConstrainSelectedInstOperands,
     /* 281333 */   // GIR_Coverage, 6491,
     /* 281333 */   GIR_EraseRootFromParent_Done,
     /* 281334 */ // Label 5743: @281334
     /* 281334 */ GIM_Reject,
     /* 281335 */ // Label 5739: @281335
     /* 281335 */ GIM_Reject,
     /* 281336 */ // Label 53: @281336
     /* 281336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5755*/ GIMT_Encode4(281765),
     /* 281347 */ /*GILLT_v2s32*//*Label 5744*/ GIMT_Encode4(281423),
     /* 281351 */ /*GILLT_v2s64*//*Label 5745*/ GIMT_Encode4(281457),
     /* 281355 */ /*GILLT_v4s16*//*Label 5746*/ GIMT_Encode4(281491),
     /* 281359 */ /*GILLT_v4s32*//*Label 5747*/ GIMT_Encode4(281525),
     /* 281363 */ /*GILLT_v8s8*//*Label 5748*/ GIMT_Encode4(281559),
     /* 281367 */ /*GILLT_v8s16*//*Label 5749*/ GIMT_Encode4(281593),
     /* 281371 */ /*GILLT_v16s8*//*Label 5750*/ GIMT_Encode4(281627), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281391 */ /*GILLT_nxv2s64*//*Label 5751*/ GIMT_Encode4(281661), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281403 */ /*GILLT_nxv4s32*//*Label 5752*/ GIMT_Encode4(281687), GIMT_Encode4(0),
     /* 281411 */ /*GILLT_nxv8s16*//*Label 5753*/ GIMT_Encode4(281713), GIMT_Encode4(0),
     /* 281419 */ /*GILLT_nxv16s8*//*Label 5754*/ GIMT_Encode4(281739),
     /* 281423 */ // Label 5744: @281423
     /* 281423 */ GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(281456), // Rule ID 5010 //
     /* 281428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281449 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 281454 */   GIR_RootConstrainSelectedInstOperands,
     /* 281455 */   // GIR_Coverage, 5010,
     /* 281455 */   GIR_Done,
     /* 281456 */ // Label 5756: @281456
     /* 281456 */ GIM_Reject,
     /* 281457 */ // Label 5745: @281457
     /* 281457 */ GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(281490), // Rule ID 5014 //
     /* 281462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281483 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 281488 */   GIR_RootConstrainSelectedInstOperands,
     /* 281489 */   // GIR_Coverage, 5014,
     /* 281489 */   GIR_Done,
     /* 281490 */ // Label 5757: @281490
     /* 281490 */ GIM_Reject,
     /* 281491 */ // Label 5746: @281491
     /* 281491 */ GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(281524), // Rule ID 5009 //
     /* 281496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281517 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 281517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 281522 */   GIR_RootConstrainSelectedInstOperands,
     /* 281523 */   // GIR_Coverage, 5009,
     /* 281523 */   GIR_Done,
     /* 281524 */ // Label 5758: @281524
     /* 281524 */ GIM_Reject,
     /* 281525 */ // Label 5747: @281525
     /* 281525 */ GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(281558), // Rule ID 5013 //
     /* 281530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281551 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 281551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 281556 */   GIR_RootConstrainSelectedInstOperands,
     /* 281557 */   // GIR_Coverage, 5013,
     /* 281557 */   GIR_Done,
     /* 281558 */ // Label 5759: @281558
     /* 281558 */ GIM_Reject,
     /* 281559 */ // Label 5748: @281559
     /* 281559 */ GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(281592), // Rule ID 5008 //
     /* 281564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281585 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 281585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 281590 */   GIR_RootConstrainSelectedInstOperands,
     /* 281591 */   // GIR_Coverage, 5008,
     /* 281591 */   GIR_Done,
     /* 281592 */ // Label 5760: @281592
     /* 281592 */ GIM_Reject,
     /* 281593 */ // Label 5749: @281593
     /* 281593 */ GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(281626), // Rule ID 5012 //
     /* 281598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281619 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 281619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 281624 */   GIR_RootConstrainSelectedInstOperands,
     /* 281625 */   // GIR_Coverage, 5012,
     /* 281625 */   GIR_Done,
     /* 281626 */ // Label 5761: @281626
     /* 281626 */ GIM_Reject,
     /* 281627 */ // Label 5750: @281627
     /* 281627 */ GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(281660), // Rule ID 5011 //
     /* 281632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281653 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 281653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 281658 */   GIR_RootConstrainSelectedInstOperands,
     /* 281659 */   // GIR_Coverage, 5011,
     /* 281659 */   GIR_Done,
     /* 281660 */ // Label 5762: @281660
     /* 281660 */ GIM_Reject,
     /* 281661 */ // Label 5751: @281661
     /* 281661 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(281686), // Rule ID 7396 //
     /* 281666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 281675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281679 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 281679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 281684 */   GIR_RootConstrainSelectedInstOperands,
     /* 281685 */   // GIR_Coverage, 7396,
     /* 281685 */   GIR_Done,
     /* 281686 */ // Label 5763: @281686
     /* 281686 */ GIM_Reject,
     /* 281687 */ // Label 5752: @281687
     /* 281687 */ GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281712), // Rule ID 7395 //
     /* 281692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281705 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 281705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 281710 */   GIR_RootConstrainSelectedInstOperands,
     /* 281711 */   // GIR_Coverage, 7395,
     /* 281711 */   GIR_Done,
     /* 281712 */ // Label 5764: @281712
     /* 281712 */ GIM_Reject,
     /* 281713 */ // Label 5753: @281713
     /* 281713 */ GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281738), // Rule ID 7394 //
     /* 281718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281731 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 281731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 281736 */   GIR_RootConstrainSelectedInstOperands,
     /* 281737 */   // GIR_Coverage, 7394,
     /* 281737 */   GIR_Done,
     /* 281738 */ // Label 5765: @281738
     /* 281738 */ GIM_Reject,
     /* 281739 */ // Label 5754: @281739
     /* 281739 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(281764), // Rule ID 7393 //
     /* 281744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 281753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281757 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 281757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 281762 */   GIR_RootConstrainSelectedInstOperands,
     /* 281763 */   // GIR_Coverage, 7393,
     /* 281763 */   GIR_Done,
     /* 281764 */ // Label 5766: @281764
     /* 281764 */ GIM_Reject,
     /* 281765 */ // Label 5755: @281765
     /* 281765 */ GIM_Reject,
     /* 281766 */ // Label 54: @281766
     /* 281766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5778*/ GIMT_Encode4(282195),
     /* 281777 */ /*GILLT_v2s32*//*Label 5767*/ GIMT_Encode4(281853),
     /* 281781 */ /*GILLT_v2s64*//*Label 5768*/ GIMT_Encode4(281887),
     /* 281785 */ /*GILLT_v4s16*//*Label 5769*/ GIMT_Encode4(281921),
     /* 281789 */ /*GILLT_v4s32*//*Label 5770*/ GIMT_Encode4(281955),
     /* 281793 */ /*GILLT_v8s8*//*Label 5771*/ GIMT_Encode4(281989),
     /* 281797 */ /*GILLT_v8s16*//*Label 5772*/ GIMT_Encode4(282023),
     /* 281801 */ /*GILLT_v16s8*//*Label 5773*/ GIMT_Encode4(282057), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281821 */ /*GILLT_nxv2s64*//*Label 5774*/ GIMT_Encode4(282091), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281833 */ /*GILLT_nxv4s32*//*Label 5775*/ GIMT_Encode4(282117), GIMT_Encode4(0),
     /* 281841 */ /*GILLT_nxv8s16*//*Label 5776*/ GIMT_Encode4(282143), GIMT_Encode4(0),
     /* 281849 */ /*GILLT_nxv16s8*//*Label 5777*/ GIMT_Encode4(282169),
     /* 281853 */ // Label 5767: @281853
     /* 281853 */ GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(281886), // Rule ID 2477 //
     /* 281858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281879 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 281884 */   GIR_RootConstrainSelectedInstOperands,
     /* 281885 */   // GIR_Coverage, 2477,
     /* 281885 */   GIR_Done,
     /* 281886 */ // Label 5779: @281886
     /* 281886 */ GIM_Reject,
     /* 281887 */ // Label 5768: @281887
     /* 281887 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(281920), // Rule ID 2481 //
     /* 281892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281913 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 281918 */   GIR_RootConstrainSelectedInstOperands,
     /* 281919 */   // GIR_Coverage, 2481,
     /* 281919 */   GIR_Done,
     /* 281920 */ // Label 5780: @281920
     /* 281920 */ GIM_Reject,
     /* 281921 */ // Label 5769: @281921
     /* 281921 */ GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(281954), // Rule ID 2476 //
     /* 281926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281947 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 281947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 281952 */   GIR_RootConstrainSelectedInstOperands,
     /* 281953 */   // GIR_Coverage, 2476,
     /* 281953 */   GIR_Done,
     /* 281954 */ // Label 5781: @281954
     /* 281954 */ GIM_Reject,
     /* 281955 */ // Label 5770: @281955
     /* 281955 */ GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(281988), // Rule ID 2480 //
     /* 281960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281981 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 281981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 281986 */   GIR_RootConstrainSelectedInstOperands,
     /* 281987 */   // GIR_Coverage, 2480,
     /* 281987 */   GIR_Done,
     /* 281988 */ // Label 5782: @281988
     /* 281988 */ GIM_Reject,
     /* 281989 */ // Label 5771: @281989
     /* 281989 */ GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(282022), // Rule ID 2475 //
     /* 281994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282015 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 282020 */   GIR_RootConstrainSelectedInstOperands,
     /* 282021 */   // GIR_Coverage, 2475,
     /* 282021 */   GIR_Done,
     /* 282022 */ // Label 5783: @282022
     /* 282022 */ GIM_Reject,
     /* 282023 */ // Label 5772: @282023
     /* 282023 */ GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(282056), // Rule ID 2479 //
     /* 282028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282049 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 282054 */   GIR_RootConstrainSelectedInstOperands,
     /* 282055 */   // GIR_Coverage, 2479,
     /* 282055 */   GIR_Done,
     /* 282056 */ // Label 5784: @282056
     /* 282056 */ GIM_Reject,
     /* 282057 */ // Label 5773: @282057
     /* 282057 */ GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(282090), // Rule ID 2478 //
     /* 282062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282083 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 282088 */   GIR_RootConstrainSelectedInstOperands,
     /* 282089 */   // GIR_Coverage, 2478,
     /* 282089 */   GIR_Done,
     /* 282090 */ // Label 5785: @282090
     /* 282090 */ GIM_Reject,
     /* 282091 */ // Label 5774: @282091
     /* 282091 */ GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(282116), // Rule ID 7392 //
     /* 282096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282109 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 282114 */   GIR_RootConstrainSelectedInstOperands,
     /* 282115 */   // GIR_Coverage, 7392,
     /* 282115 */   GIR_Done,
     /* 282116 */ // Label 5786: @282116
     /* 282116 */ GIM_Reject,
     /* 282117 */ // Label 5775: @282117
     /* 282117 */ GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(282142), // Rule ID 7391 //
     /* 282122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282135 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 282140 */   GIR_RootConstrainSelectedInstOperands,
     /* 282141 */   // GIR_Coverage, 7391,
     /* 282141 */   GIR_Done,
     /* 282142 */ // Label 5787: @282142
     /* 282142 */ GIM_Reject,
     /* 282143 */ // Label 5776: @282143
     /* 282143 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(282168), // Rule ID 7390 //
     /* 282148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282161 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 282166 */   GIR_RootConstrainSelectedInstOperands,
     /* 282167 */   // GIR_Coverage, 7390,
     /* 282167 */   GIR_Done,
     /* 282168 */ // Label 5788: @282168
     /* 282168 */ GIM_Reject,
     /* 282169 */ // Label 5777: @282169
     /* 282169 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(282194), // Rule ID 7389 //
     /* 282174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282187 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 282192 */   GIR_RootConstrainSelectedInstOperands,
     /* 282193 */   // GIR_Coverage, 7389,
     /* 282193 */   GIR_Done,
     /* 282194 */ // Label 5789: @282194
     /* 282194 */ GIM_Reject,
     /* 282195 */ // Label 5778: @282195
     /* 282195 */ GIM_Reject,
     /* 282196 */ // Label 55: @282196
     /* 282196 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5801*/ GIMT_Encode4(282625),
     /* 282207 */ /*GILLT_v2s32*//*Label 5790*/ GIMT_Encode4(282283),
     /* 282211 */ /*GILLT_v2s64*//*Label 5791*/ GIMT_Encode4(282317),
     /* 282215 */ /*GILLT_v4s16*//*Label 5792*/ GIMT_Encode4(282351),
     /* 282219 */ /*GILLT_v4s32*//*Label 5793*/ GIMT_Encode4(282385),
     /* 282223 */ /*GILLT_v8s8*//*Label 5794*/ GIMT_Encode4(282419),
     /* 282227 */ /*GILLT_v8s16*//*Label 5795*/ GIMT_Encode4(282453),
     /* 282231 */ /*GILLT_v16s8*//*Label 5796*/ GIMT_Encode4(282487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282251 */ /*GILLT_nxv2s64*//*Label 5797*/ GIMT_Encode4(282521), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282263 */ /*GILLT_nxv4s32*//*Label 5798*/ GIMT_Encode4(282547), GIMT_Encode4(0),
     /* 282271 */ /*GILLT_nxv8s16*//*Label 5799*/ GIMT_Encode4(282573), GIMT_Encode4(0),
     /* 282279 */ /*GILLT_nxv16s8*//*Label 5800*/ GIMT_Encode4(282599),
     /* 282283 */ // Label 5790: @282283
     /* 282283 */ GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(282316), // Rule ID 5024 //
     /* 282288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282309 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 282314 */   GIR_RootConstrainSelectedInstOperands,
     /* 282315 */   // GIR_Coverage, 5024,
     /* 282315 */   GIR_Done,
     /* 282316 */ // Label 5802: @282316
     /* 282316 */ GIM_Reject,
     /* 282317 */ // Label 5791: @282317
     /* 282317 */ GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(282350), // Rule ID 5028 //
     /* 282322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282343 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 282348 */   GIR_RootConstrainSelectedInstOperands,
     /* 282349 */   // GIR_Coverage, 5028,
     /* 282349 */   GIR_Done,
     /* 282350 */ // Label 5803: @282350
     /* 282350 */ GIM_Reject,
     /* 282351 */ // Label 5792: @282351
     /* 282351 */ GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(282384), // Rule ID 5023 //
     /* 282356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282377 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 282382 */   GIR_RootConstrainSelectedInstOperands,
     /* 282383 */   // GIR_Coverage, 5023,
     /* 282383 */   GIR_Done,
     /* 282384 */ // Label 5804: @282384
     /* 282384 */ GIM_Reject,
     /* 282385 */ // Label 5793: @282385
     /* 282385 */ GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(282418), // Rule ID 5027 //
     /* 282390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282411 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 282416 */   GIR_RootConstrainSelectedInstOperands,
     /* 282417 */   // GIR_Coverage, 5027,
     /* 282417 */   GIR_Done,
     /* 282418 */ // Label 5805: @282418
     /* 282418 */ GIM_Reject,
     /* 282419 */ // Label 5794: @282419
     /* 282419 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(282452), // Rule ID 5022 //
     /* 282424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282445 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 282450 */   GIR_RootConstrainSelectedInstOperands,
     /* 282451 */   // GIR_Coverage, 5022,
     /* 282451 */   GIR_Done,
     /* 282452 */ // Label 5806: @282452
     /* 282452 */ GIM_Reject,
     /* 282453 */ // Label 5795: @282453
     /* 282453 */ GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(282486), // Rule ID 5026 //
     /* 282458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282479 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 282484 */   GIR_RootConstrainSelectedInstOperands,
     /* 282485 */   // GIR_Coverage, 5026,
     /* 282485 */   GIR_Done,
     /* 282486 */ // Label 5807: @282486
     /* 282486 */ GIM_Reject,
     /* 282487 */ // Label 5796: @282487
     /* 282487 */ GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(282520), // Rule ID 5025 //
     /* 282492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282513 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 282518 */   GIR_RootConstrainSelectedInstOperands,
     /* 282519 */   // GIR_Coverage, 5025,
     /* 282519 */   GIR_Done,
     /* 282520 */ // Label 5808: @282520
     /* 282520 */ GIM_Reject,
     /* 282521 */ // Label 5797: @282521
     /* 282521 */ GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(282546), // Rule ID 7404 //
     /* 282526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282539 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 282544 */   GIR_RootConstrainSelectedInstOperands,
     /* 282545 */   // GIR_Coverage, 7404,
     /* 282545 */   GIR_Done,
     /* 282546 */ // Label 5809: @282546
     /* 282546 */ GIM_Reject,
     /* 282547 */ // Label 5798: @282547
     /* 282547 */ GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(282572), // Rule ID 7403 //
     /* 282552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282565 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 282570 */   GIR_RootConstrainSelectedInstOperands,
     /* 282571 */   // GIR_Coverage, 7403,
     /* 282571 */   GIR_Done,
     /* 282572 */ // Label 5810: @282572
     /* 282572 */ GIM_Reject,
     /* 282573 */ // Label 5799: @282573
     /* 282573 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(282598), // Rule ID 7402 //
     /* 282578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282591 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 282596 */   GIR_RootConstrainSelectedInstOperands,
     /* 282597 */   // GIR_Coverage, 7402,
     /* 282597 */   GIR_Done,
     /* 282598 */ // Label 5811: @282598
     /* 282598 */ GIM_Reject,
     /* 282599 */ // Label 5800: @282599
     /* 282599 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(282624), // Rule ID 7401 //
     /* 282604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282617 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 282622 */   GIR_RootConstrainSelectedInstOperands,
     /* 282623 */   // GIR_Coverage, 7401,
     /* 282623 */   GIR_Done,
     /* 282624 */ // Label 5812: @282624
     /* 282624 */ GIM_Reject,
     /* 282625 */ // Label 5801: @282625
     /* 282625 */ GIM_Reject,
     /* 282626 */ // Label 56: @282626
     /* 282626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5824*/ GIMT_Encode4(283055),
     /* 282637 */ /*GILLT_v2s32*//*Label 5813*/ GIMT_Encode4(282713),
     /* 282641 */ /*GILLT_v2s64*//*Label 5814*/ GIMT_Encode4(282747),
     /* 282645 */ /*GILLT_v4s16*//*Label 5815*/ GIMT_Encode4(282781),
     /* 282649 */ /*GILLT_v4s32*//*Label 5816*/ GIMT_Encode4(282815),
     /* 282653 */ /*GILLT_v8s8*//*Label 5817*/ GIMT_Encode4(282849),
     /* 282657 */ /*GILLT_v8s16*//*Label 5818*/ GIMT_Encode4(282883),
     /* 282661 */ /*GILLT_v16s8*//*Label 5819*/ GIMT_Encode4(282917), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282681 */ /*GILLT_nxv2s64*//*Label 5820*/ GIMT_Encode4(282951), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282693 */ /*GILLT_nxv4s32*//*Label 5821*/ GIMT_Encode4(282977), GIMT_Encode4(0),
     /* 282701 */ /*GILLT_nxv8s16*//*Label 5822*/ GIMT_Encode4(283003), GIMT_Encode4(0),
     /* 282709 */ /*GILLT_nxv16s8*//*Label 5823*/ GIMT_Encode4(283029),
     /* 282713 */ // Label 5813: @282713
     /* 282713 */ GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(282746), // Rule ID 5017 //
     /* 282718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282739 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 282744 */   GIR_RootConstrainSelectedInstOperands,
     /* 282745 */   // GIR_Coverage, 5017,
     /* 282745 */   GIR_Done,
     /* 282746 */ // Label 5825: @282746
     /* 282746 */ GIM_Reject,
     /* 282747 */ // Label 5814: @282747
     /* 282747 */ GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(282780), // Rule ID 5021 //
     /* 282752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282773 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 282778 */   GIR_RootConstrainSelectedInstOperands,
     /* 282779 */   // GIR_Coverage, 5021,
     /* 282779 */   GIR_Done,
     /* 282780 */ // Label 5826: @282780
     /* 282780 */ GIM_Reject,
     /* 282781 */ // Label 5815: @282781
     /* 282781 */ GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(282814), // Rule ID 5016 //
     /* 282786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282807 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 282812 */   GIR_RootConstrainSelectedInstOperands,
     /* 282813 */   // GIR_Coverage, 5016,
     /* 282813 */   GIR_Done,
     /* 282814 */ // Label 5827: @282814
     /* 282814 */ GIM_Reject,
     /* 282815 */ // Label 5816: @282815
     /* 282815 */ GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(282848), // Rule ID 5020 //
     /* 282820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282841 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 282846 */   GIR_RootConstrainSelectedInstOperands,
     /* 282847 */   // GIR_Coverage, 5020,
     /* 282847 */   GIR_Done,
     /* 282848 */ // Label 5828: @282848
     /* 282848 */ GIM_Reject,
     /* 282849 */ // Label 5817: @282849
     /* 282849 */ GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(282882), // Rule ID 5015 //
     /* 282854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282875 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 282880 */   GIR_RootConstrainSelectedInstOperands,
     /* 282881 */   // GIR_Coverage, 5015,
     /* 282881 */   GIR_Done,
     /* 282882 */ // Label 5829: @282882
     /* 282882 */ GIM_Reject,
     /* 282883 */ // Label 5818: @282883
     /* 282883 */ GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(282916), // Rule ID 5019 //
     /* 282888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282909 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 282914 */   GIR_RootConstrainSelectedInstOperands,
     /* 282915 */   // GIR_Coverage, 5019,
     /* 282915 */   GIR_Done,
     /* 282916 */ // Label 5830: @282916
     /* 282916 */ GIM_Reject,
     /* 282917 */ // Label 5819: @282917
     /* 282917 */ GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(282950), // Rule ID 5018 //
     /* 282922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282943 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 282948 */   GIR_RootConstrainSelectedInstOperands,
     /* 282949 */   // GIR_Coverage, 5018,
     /* 282949 */   GIR_Done,
     /* 282950 */ // Label 5831: @282950
     /* 282950 */ GIM_Reject,
     /* 282951 */ // Label 5820: @282951
     /* 282951 */ GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(282976), // Rule ID 7400 //
     /* 282956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282969 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 282974 */   GIR_RootConstrainSelectedInstOperands,
     /* 282975 */   // GIR_Coverage, 7400,
     /* 282975 */   GIR_Done,
     /* 282976 */ // Label 5832: @282976
     /* 282976 */ GIM_Reject,
     /* 282977 */ // Label 5821: @282977
     /* 282977 */ GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(283002), // Rule ID 7399 //
     /* 282982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282995 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 283000 */   GIR_RootConstrainSelectedInstOperands,
     /* 283001 */   // GIR_Coverage, 7399,
     /* 283001 */   GIR_Done,
     /* 283002 */ // Label 5833: @283002
     /* 283002 */ GIM_Reject,
     /* 283003 */ // Label 5822: @283003
     /* 283003 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(283028), // Rule ID 7398 //
     /* 283008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283021 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 283026 */   GIR_RootConstrainSelectedInstOperands,
     /* 283027 */   // GIR_Coverage, 7398,
     /* 283027 */   GIR_Done,
     /* 283028 */ // Label 5834: @283028
     /* 283028 */ GIM_Reject,
     /* 283029 */ // Label 5823: @283029
     /* 283029 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(283054), // Rule ID 7397 //
     /* 283034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283047 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 283052 */   GIR_RootConstrainSelectedInstOperands,
     /* 283053 */   // GIR_Coverage, 7397,
     /* 283053 */   GIR_Done,
     /* 283054 */ // Label 5835: @283054
     /* 283054 */ GIM_Reject,
     /* 283055 */ // Label 5824: @283055
     /* 283055 */ GIM_Reject,
     /* 283056 */ // Label 57: @283056
     /* 283056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5847*/ GIMT_Encode4(284853),
     /* 283067 */ /*GILLT_s16*//*Label 5836*/ GIMT_Encode4(283151),
     /* 283071 */ /*GILLT_s32*//*Label 5837*/ GIMT_Encode4(283377),
     /* 283075 */ /*GILLT_s64*//*Label 5838*/ GIMT_Encode4(283731), GIMT_Encode4(0),
     /* 283083 */ /*GILLT_v2s32*//*Label 5839*/ GIMT_Encode4(283903),
     /* 283087 */ /*GILLT_v2s64*//*Label 5840*/ GIMT_Encode4(283941),
     /* 283091 */ /*GILLT_v4s16*//*Label 5841*/ GIMT_Encode4(284117),
     /* 283095 */ /*GILLT_v4s32*//*Label 5842*/ GIMT_Encode4(284155), GIMT_Encode4(0),
     /* 283103 */ /*GILLT_v8s16*//*Label 5843*/ GIMT_Encode4(284331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283127 */ /*GILLT_nxv2s64*//*Label 5844*/ GIMT_Encode4(284775), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283139 */ /*GILLT_nxv4s32*//*Label 5845*/ GIMT_Encode4(284801), GIMT_Encode4(0),
     /* 283147 */ /*GILLT_nxv8s16*//*Label 5846*/ GIMT_Encode4(284827),
     /* 283151 */ // Label 5836: @283151
     /* 283151 */ GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(283376),
     /* 283156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283166 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(283257), // Rule ID 6884 //
     /* 283171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283192 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283208 */     // MIs[2] Rn
     /* 283208 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283213 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283219 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283231 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283255 */     GIR_RootConstrainSelectedInstOperands,
     /* 283256 */     // GIR_Coverage, 6884,
     /* 283256 */     GIR_EraseRootFromParent_Done,
     /* 283257 */   // Label 5849: @283257
     /* 283257 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(283348), // Rule ID 13860 //
     /* 283262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283299 */     // MIs[2] Rn
     /* 283299 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283304 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283310 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283346 */     GIR_RootConstrainSelectedInstOperands,
     /* 283347 */     // GIR_Coverage, 13860,
     /* 283347 */     GIR_EraseRootFromParent_Done,
     /* 283348 */   // Label 5850: @283348
     /* 283348 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(283375), // Rule ID 584 //
     /* 283353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283364 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 283364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 283369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283373 */     GIR_RootConstrainSelectedInstOperands,
     /* 283374 */     // GIR_Coverage, 584,
     /* 283374 */     GIR_Done,
     /* 283375 */   // Label 5851: @283375
     /* 283375 */   GIM_Reject,
     /* 283376 */ // Label 5848: @283376
     /* 283376 */ GIM_Reject,
     /* 283377 */ // Label 5837: @283377
     /* 283377 */ GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(283730),
     /* 283382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283392 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(283483), // Rule ID 6882 //
     /* 283397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283434 */     // MIs[2] Rn
     /* 283434 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283439 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283445 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283457 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283481 */     GIR_RootConstrainSelectedInstOperands,
     /* 283482 */     // GIR_Coverage, 6882,
     /* 283482 */     GIR_EraseRootFromParent_Done,
     /* 283483 */   // Label 5853: @283483
     /* 283483 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(283547), // Rule ID 13045 //
     /* 283488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283509 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283525 */     // MIs[2] Rn
     /* 283525 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283530 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283536 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283545 */     GIR_RootConstrainSelectedInstOperands,
     /* 283546 */     // GIR_Coverage, 13045,
     /* 283546 */     GIR_EraseRootFromParent_Done,
     /* 283547 */   // Label 5854: @283547
     /* 283547 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(283638), // Rule ID 13858 //
     /* 283552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283589 */     // MIs[2] Rn
     /* 283589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283600 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283636 */     GIR_RootConstrainSelectedInstOperands,
     /* 283637 */     // GIR_Coverage, 13858,
     /* 283637 */     GIR_EraseRootFromParent_Done,
     /* 283638 */   // Label 5855: @283638
     /* 283638 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(283702), // Rule ID 15533 //
     /* 283643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283680 */     // MIs[2] Rn
     /* 283680 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283691 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283700 */     GIR_RootConstrainSelectedInstOperands,
     /* 283701 */     // GIR_Coverage, 15533,
     /* 283701 */     GIR_EraseRootFromParent_Done,
     /* 283702 */   // Label 5856: @283702
     /* 283702 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(283729), // Rule ID 586 //
     /* 283707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283718 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 283718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 283723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283727 */     GIR_RootConstrainSelectedInstOperands,
     /* 283728 */     // GIR_Coverage, 586,
     /* 283728 */     GIR_Done,
     /* 283729 */   // Label 5857: @283729
     /* 283729 */   GIM_Reject,
     /* 283730 */ // Label 5852: @283730
     /* 283730 */ GIM_Reject,
     /* 283731 */ // Label 5838: @283731
     /* 283731 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(283902),
     /* 283736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283746 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(283810), // Rule ID 6880 //
     /* 283751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283788 */     // MIs[2] Rn
     /* 283788 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283793 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283799 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 283799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 283802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283808 */     GIR_RootConstrainSelectedInstOperands,
     /* 283809 */     // GIR_Coverage, 6880,
     /* 283809 */     GIR_EraseRootFromParent_Done,
     /* 283810 */   // Label 5859: @283810
     /* 283810 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(283874), // Rule ID 13856 //
     /* 283815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283836 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283852 */     // MIs[2] Rn
     /* 283852 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283857 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283863 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 283863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 283866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283872 */     GIR_RootConstrainSelectedInstOperands,
     /* 283873 */     // GIR_Coverage, 13856,
     /* 283873 */     GIR_EraseRootFromParent_Done,
     /* 283874 */   // Label 5860: @283874
     /* 283874 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(283901), // Rule ID 588 //
     /* 283879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283890 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 283890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 283895 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283899 */     GIR_RootConstrainSelectedInstOperands,
     /* 283900 */     // GIR_Coverage, 588,
     /* 283900 */     GIR_Done,
     /* 283901 */   // Label 5861: @283901
     /* 283901 */   GIM_Reject,
     /* 283902 */ // Label 5858: @283902
     /* 283902 */ GIM_Reject,
     /* 283903 */ // Label 5839: @283903
     /* 283903 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(283940), // Rule ID 1203 //
     /* 283908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283929 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 283929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 283934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283938 */   GIR_RootConstrainSelectedInstOperands,
     /* 283939 */   // GIR_Coverage, 1203,
     /* 283939 */   GIR_Done,
     /* 283940 */ // Label 5862: @283940
     /* 283940 */ GIM_Reject,
     /* 283941 */ // Label 5840: @283941
     /* 283941 */ GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284116),
     /* 283946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283956 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284022), // Rule ID 6902 //
     /* 283961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 283969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 283995 */     // MIs[2] Rn
     /* 283995 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284000 */     // MIs[2] Rm
     /* 284000 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284007 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284020 */     GIR_RootConstrainSelectedInstOperands,
     /* 284021 */     // GIR_Coverage, 6902,
     /* 284021 */     GIR_EraseRootFromParent_Done,
     /* 284022 */   // Label 5864: @284022
     /* 284022 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284088), // Rule ID 13868 //
     /* 284027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284061 */     // MIs[2] Rn
     /* 284061 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284066 */     // MIs[2] Rm
     /* 284066 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284073 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284086 */     GIR_RootConstrainSelectedInstOperands,
     /* 284087 */     // GIR_Coverage, 13868,
     /* 284087 */     GIR_EraseRootFromParent_Done,
     /* 284088 */   // Label 5865: @284088
     /* 284088 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284115), // Rule ID 1207 //
     /* 284093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284104 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 284104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 284109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284113 */     GIR_RootConstrainSelectedInstOperands,
     /* 284114 */     // GIR_Coverage, 1207,
     /* 284114 */     GIR_Done,
     /* 284115 */   // Label 5866: @284115
     /* 284115 */   GIM_Reject,
     /* 284116 */ // Label 5863: @284116
     /* 284116 */ GIM_Reject,
     /* 284117 */ // Label 5841: @284117
     /* 284117 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284154), // Rule ID 1199 //
     /* 284122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284143 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 284143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 284148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284152 */   GIR_RootConstrainSelectedInstOperands,
     /* 284153 */   // GIR_Coverage, 1199,
     /* 284153 */   GIR_Done,
     /* 284154 */ // Label 5867: @284154
     /* 284154 */ GIM_Reject,
     /* 284155 */ // Label 5842: @284155
     /* 284155 */ GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284330),
     /* 284160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284170 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284236), // Rule ID 6903 //
     /* 284175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284209 */     // MIs[2] Rn
     /* 284209 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284214 */     // MIs[2] Rm
     /* 284214 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284221 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284234 */     GIR_RootConstrainSelectedInstOperands,
     /* 284235 */     // GIR_Coverage, 6903,
     /* 284235 */     GIR_EraseRootFromParent_Done,
     /* 284236 */   // Label 5869: @284236
     /* 284236 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(284302), // Rule ID 13869 //
     /* 284241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284275 */     // MIs[2] Rn
     /* 284275 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284280 */     // MIs[2] Rm
     /* 284280 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284287 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284300 */     GIR_RootConstrainSelectedInstOperands,
     /* 284301 */     // GIR_Coverage, 13869,
     /* 284301 */     GIR_EraseRootFromParent_Done,
     /* 284302 */   // Label 5870: @284302
     /* 284302 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284329), // Rule ID 1205 //
     /* 284307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284318 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 284318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284323 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284327 */     GIR_RootConstrainSelectedInstOperands,
     /* 284328 */     // GIR_Coverage, 1205,
     /* 284328 */     GIR_Done,
     /* 284329 */   // Label 5871: @284329
     /* 284329 */   GIM_Reject,
     /* 284330 */ // Label 5868: @284330
     /* 284330 */ GIM_Reject,
     /* 284331 */ // Label 5843: @284331
     /* 284331 */ GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(284774),
     /* 284336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284346 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(284415), // Rule ID 6904 //
     /* 284351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284388 */     // MIs[2] Rn
     /* 284388 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284393 */     // MIs[2] Rm
     /* 284393 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284400 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284413 */     GIR_RootConstrainSelectedInstOperands,
     /* 284414 */     // GIR_Coverage, 6904,
     /* 284414 */     GIR_EraseRootFromParent_Done,
     /* 284415 */   // Label 5873: @284415
     /* 284415 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(284484), // Rule ID 13870 //
     /* 284420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284457 */     // MIs[2] Rn
     /* 284457 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284462 */     // MIs[2] Rm
     /* 284462 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284469 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284482 */     GIR_RootConstrainSelectedInstOperands,
     /* 284483 */     // GIR_Coverage, 13870,
     /* 284483 */     GIR_EraseRootFromParent_Done,
     /* 284484 */   // Label 5874: @284484
     /* 284484 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(284511), // Rule ID 1201 //
     /* 284489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284500 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 284500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 284505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284509 */     GIR_RootConstrainSelectedInstOperands,
     /* 284510 */     // GIR_Coverage, 1201,
     /* 284510 */     GIR_Done,
     /* 284511 */   // Label 5875: @284511
     /* 284511 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(284773), // Rule ID 6973 //
     /* 284516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 284519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284527 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 284527 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 284530 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284534 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284539 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 284543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 284545 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 284548 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284552 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284557 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 284561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 284563 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 284566 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284570 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284575 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 284578 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 284581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 284583 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 284586 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284590 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284595 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 284601 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284606 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284611 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 284614 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284618 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284623 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 284626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 284628 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 284631 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284635 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284640 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284646 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284651 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284656 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 284659 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284663 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284668 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 284671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 284673 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 284676 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284680 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284685 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 284688 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 284691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 284696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 284700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284705 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 284708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 284713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 284727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 284742 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 284745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 284763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 284771 */     GIR_RootConstrainSelectedInstOperands,
     /* 284772 */     // GIR_Coverage, 6973,
     /* 284772 */     GIR_EraseRootFromParent_Done,
     /* 284773 */   // Label 5876: @284773
     /* 284773 */   GIM_Reject,
     /* 284774 */ // Label 5872: @284774
     /* 284774 */ GIM_Reject,
     /* 284775 */ // Label 5844: @284775
     /* 284775 */ GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(284800), // Rule ID 2824 //
     /* 284780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284793 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 284793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 284798 */   GIR_RootConstrainSelectedInstOperands,
     /* 284799 */   // GIR_Coverage, 2824,
     /* 284799 */   GIR_Done,
     /* 284800 */ // Label 5877: @284800
     /* 284800 */ GIM_Reject,
     /* 284801 */ // Label 5845: @284801
     /* 284801 */ GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(284826), // Rule ID 2822 //
     /* 284806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284819 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 284819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 284824 */   GIR_RootConstrainSelectedInstOperands,
     /* 284825 */   // GIR_Coverage, 2822,
     /* 284825 */   GIR_Done,
     /* 284826 */ // Label 5878: @284826
     /* 284826 */ GIM_Reject,
     /* 284827 */ // Label 5846: @284827
     /* 284827 */ GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(284852), // Rule ID 2820 //
     /* 284832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284845 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 284845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 284850 */   GIR_RootConstrainSelectedInstOperands,
     /* 284851 */   // GIR_Coverage, 2820,
     /* 284851 */   GIR_Done,
     /* 284852 */ // Label 5879: @284852
     /* 284852 */ GIM_Reject,
     /* 284853 */ // Label 5847: @284853
     /* 284853 */ GIM_Reject,
     /* 284854 */ // Label 58: @284854
     /* 284854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5891*/ GIMT_Encode4(285591),
     /* 284865 */ /*GILLT_s16*//*Label 5880*/ GIMT_Encode4(284949),
     /* 284869 */ /*GILLT_s32*//*Label 5881*/ GIMT_Encode4(284987),
     /* 284873 */ /*GILLT_s64*//*Label 5882*/ GIMT_Encode4(285025), GIMT_Encode4(0),
     /* 284881 */ /*GILLT_v2s32*//*Label 5883*/ GIMT_Encode4(285063),
     /* 284885 */ /*GILLT_v2s64*//*Label 5884*/ GIMT_Encode4(285101),
     /* 284889 */ /*GILLT_v4s16*//*Label 5885*/ GIMT_Encode4(285139),
     /* 284893 */ /*GILLT_v4s32*//*Label 5886*/ GIMT_Encode4(285177), GIMT_Encode4(0),
     /* 284901 */ /*GILLT_v8s16*//*Label 5887*/ GIMT_Encode4(285215), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284925 */ /*GILLT_nxv2s64*//*Label 5888*/ GIMT_Encode4(285513), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284937 */ /*GILLT_nxv4s32*//*Label 5889*/ GIMT_Encode4(285539), GIMT_Encode4(0),
     /* 284945 */ /*GILLT_nxv8s16*//*Label 5890*/ GIMT_Encode4(285565),
     /* 284949 */ // Label 5880: @284949
     /* 284949 */ GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(284986), // Rule ID 632 //
     /* 284954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 284963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284975 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 284975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 284980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284984 */   GIR_RootConstrainSelectedInstOperands,
     /* 284985 */   // GIR_Coverage, 632,
     /* 284985 */   GIR_Done,
     /* 284986 */ // Label 5892: @284986
     /* 284986 */ GIM_Reject,
     /* 284987 */ // Label 5881: @284987
     /* 284987 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(285024), // Rule ID 634 //
     /* 284992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285013 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 285013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 285018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285022 */   GIR_RootConstrainSelectedInstOperands,
     /* 285023 */   // GIR_Coverage, 634,
     /* 285023 */   GIR_Done,
     /* 285024 */ // Label 5893: @285024
     /* 285024 */ GIM_Reject,
     /* 285025 */ // Label 5882: @285025
     /* 285025 */ GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(285062), // Rule ID 636 //
     /* 285030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285051 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 285051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 285056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285060 */   GIR_RootConstrainSelectedInstOperands,
     /* 285061 */   // GIR_Coverage, 636,
     /* 285061 */   GIR_Done,
     /* 285062 */ // Label 5894: @285062
     /* 285062 */ GIM_Reject,
     /* 285063 */ // Label 5883: @285063
     /* 285063 */ GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(285100), // Rule ID 1343 //
     /* 285068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285089 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 285089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 285094 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285098 */   GIR_RootConstrainSelectedInstOperands,
     /* 285099 */   // GIR_Coverage, 1343,
     /* 285099 */   GIR_Done,
     /* 285100 */ // Label 5895: @285100
     /* 285100 */ GIM_Reject,
     /* 285101 */ // Label 5884: @285101
     /* 285101 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(285138), // Rule ID 1347 //
     /* 285106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285127 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 285127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 285132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285136 */   GIR_RootConstrainSelectedInstOperands,
     /* 285137 */   // GIR_Coverage, 1347,
     /* 285137 */   GIR_Done,
     /* 285138 */ // Label 5896: @285138
     /* 285138 */ GIM_Reject,
     /* 285139 */ // Label 5885: @285139
     /* 285139 */ GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(285176), // Rule ID 1339 //
     /* 285144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285165 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 285165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 285170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285174 */   GIR_RootConstrainSelectedInstOperands,
     /* 285175 */   // GIR_Coverage, 1339,
     /* 285175 */   GIR_Done,
     /* 285176 */ // Label 5897: @285176
     /* 285176 */ GIM_Reject,
     /* 285177 */ // Label 5886: @285177
     /* 285177 */ GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(285214), // Rule ID 1345 //
     /* 285182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285203 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285212 */   GIR_RootConstrainSelectedInstOperands,
     /* 285213 */   // GIR_Coverage, 1345,
     /* 285213 */   GIR_Done,
     /* 285214 */ // Label 5898: @285214
     /* 285214 */ GIM_Reject,
     /* 285215 */ // Label 5887: @285215
     /* 285215 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(285512),
     /* 285220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285238 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(285257), // Rule ID 1341 //
     /* 285243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285246 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 285251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285255 */     GIR_RootConstrainSelectedInstOperands,
     /* 285256 */     // GIR_Coverage, 1341,
     /* 285256 */     GIR_Done,
     /* 285257 */   // Label 5900: @285257
     /* 285257 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(285511), // Rule ID 6979 //
     /* 285262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285265 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285265 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285268 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285272 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285277 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285283 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285286 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285290 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285295 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285301 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285304 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285308 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285313 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285316 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285321 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285324 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285328 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285333 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285339 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285344 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285349 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285352 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285356 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285361 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285366 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285369 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285373 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285378 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285384 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285389 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285394 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285397 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285401 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285406 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285411 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285414 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285418 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285423 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285426 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285431 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285434 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285438 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285443 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285448 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285451 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285455 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285474 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285480 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 285509 */     GIR_RootConstrainSelectedInstOperands,
     /* 285510 */     // GIR_Coverage, 6979,
     /* 285510 */     GIR_EraseRootFromParent_Done,
     /* 285511 */   // Label 5901: @285511
     /* 285511 */   GIM_Reject,
     /* 285512 */ // Label 5899: @285512
     /* 285512 */ GIM_Reject,
     /* 285513 */ // Label 5888: @285513
     /* 285513 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(285538), // Rule ID 8143 //
     /* 285518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285531 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 285536 */   GIR_RootConstrainSelectedInstOperands,
     /* 285537 */   // GIR_Coverage, 8143,
     /* 285537 */   GIR_Done,
     /* 285538 */ // Label 5902: @285538
     /* 285538 */ GIM_Reject,
     /* 285539 */ // Label 5889: @285539
     /* 285539 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(285564), // Rule ID 8141 //
     /* 285544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285557 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 285562 */   GIR_RootConstrainSelectedInstOperands,
     /* 285563 */   // GIR_Coverage, 8141,
     /* 285563 */   GIR_Done,
     /* 285564 */ // Label 5903: @285564
     /* 285564 */ GIM_Reject,
     /* 285565 */ // Label 5890: @285565
     /* 285565 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(285590), // Rule ID 8139 //
     /* 285570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285583 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 285588 */   GIR_RootConstrainSelectedInstOperands,
     /* 285589 */   // GIR_Coverage, 8139,
     /* 285589 */   GIR_Done,
     /* 285590 */ // Label 5904: @285590
     /* 285590 */ GIM_Reject,
     /* 285591 */ // Label 5891: @285591
     /* 285591 */ GIM_Reject,
     /* 285592 */ // Label 59: @285592
     /* 285592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5916*/ GIMT_Encode4(289687),
     /* 285603 */ /*GILLT_s16*//*Label 5905*/ GIMT_Encode4(285687),
     /* 285607 */ /*GILLT_s32*//*Label 5906*/ GIMT_Encode4(286329),
     /* 285611 */ /*GILLT_s64*//*Label 5907*/ GIMT_Encode4(286959), GIMT_Encode4(0),
     /* 285619 */ /*GILLT_v2s32*//*Label 5908*/ GIMT_Encode4(287589),
     /* 285623 */ /*GILLT_v2s64*//*Label 5909*/ GIMT_Encode4(288119),
     /* 285627 */ /*GILLT_v4s16*//*Label 5910*/ GIMT_Encode4(288477),
     /* 285631 */ /*GILLT_v4s32*//*Label 5911*/ GIMT_Encode4(288819), GIMT_Encode4(0),
     /* 285639 */ /*GILLT_v8s16*//*Label 5912*/ GIMT_Encode4(289177), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285663 */ /*GILLT_nxv2s64*//*Label 5913*/ GIMT_Encode4(289609), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285675 */ /*GILLT_nxv4s32*//*Label 5914*/ GIMT_Encode4(289635), GIMT_Encode4(0),
     /* 285683 */ /*GILLT_nxv8s16*//*Label 5915*/ GIMT_Encode4(289661),
     /* 285687 */ // Label 5905: @285687
     /* 285687 */ GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(286328),
     /* 285692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285702 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(285815), // Rule ID 6214 //
     /* 285707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 285760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285768 */     // MIs[3] Operand 1
     /* 285768 */     // No operand predicates
     /* 285768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285770 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 285770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285782 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 285801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 285810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 285813 */     GIR_RootConstrainSelectedInstOperands,
     /* 285814 */     // GIR_Coverage, 6214,
     /* 285814 */     GIR_EraseRootFromParent_Done,
     /* 285815 */   // Label 5918: @285815
     /* 285815 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(285928), // Rule ID 13837 //
     /* 285820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285856 */     // MIs[2] Operand 1
     /* 285856 */     // No operand predicates
     /* 285856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285872 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285877 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285883 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 285883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285895 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 285914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285926 */     GIR_RootConstrainSelectedInstOperands,
     /* 285927 */     // GIR_Coverage, 13837,
     /* 285927 */     GIR_EraseRootFromParent_Done,
     /* 285928 */   // Label 5919: @285928
     /* 285928 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(286007), // Rule ID 13774 //
     /* 285933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285967 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 285967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285979 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 285985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 285998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286005 */     GIR_RootConstrainSelectedInstOperands,
     /* 286006 */     // GIR_Coverage, 13774,
     /* 286006 */     GIR_EraseRootFromParent_Done,
     /* 286007 */   // Label 5920: @286007
     /* 286007 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(286086), // Rule ID 4793 //
     /* 286012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286040 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286046 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286084 */     GIR_RootConstrainSelectedInstOperands,
     /* 286085 */     // GIR_Coverage, 4793,
     /* 286085 */     GIR_EraseRootFromParent_Done,
     /* 286086 */   // Label 5921: @286086
     /* 286086 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(286149), // Rule ID 13389 //
     /* 286091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286127 */     // MIs[2] Operand 1
     /* 286127 */     // No operand predicates
     /* 286127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286133 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286147 */     GIR_RootConstrainSelectedInstOperands,
     /* 286148 */     // GIR_Coverage, 13389,
     /* 286148 */     GIR_EraseRootFromParent_Done,
     /* 286149 */   // Label 5922: @286149
     /* 286149 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(286212), // Rule ID 2012 //
     /* 286154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286194 */     // MIs[2] Operand 1
     /* 286194 */     // No operand predicates
     /* 286194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286196 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286210 */     GIR_RootConstrainSelectedInstOperands,
     /* 286211 */     // GIR_Coverage, 2012,
     /* 286211 */     GIR_EraseRootFromParent_Done,
     /* 286212 */   // Label 5923: @286212
     /* 286212 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(286256), // Rule ID 4798 //
     /* 286217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286243 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286252 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286254 */     GIR_RootConstrainSelectedInstOperands,
     /* 286255 */     // GIR_Coverage, 4798,
     /* 286255 */     GIR_EraseRootFromParent_Done,
     /* 286256 */   // Label 5924: @286256
     /* 286256 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(286300), // Rule ID 13779 //
     /* 286261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286287 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286296 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286298 */     GIR_RootConstrainSelectedInstOperands,
     /* 286299 */     // GIR_Coverage, 13779,
     /* 286299 */     GIR_EraseRootFromParent_Done,
     /* 286300 */   // Label 5925: @286300
     /* 286300 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(286327), // Rule ID 620 //
     /* 286305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286316 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286321 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286325 */     GIR_RootConstrainSelectedInstOperands,
     /* 286326 */     // GIR_Coverage, 620,
     /* 286326 */     GIR_Done,
     /* 286327 */   // Label 5926: @286327
     /* 286327 */   GIM_Reject,
     /* 286328 */ // Label 5917: @286328
     /* 286328 */ GIM_Reject,
     /* 286329 */ // Label 5906: @286329
     /* 286329 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(286958),
     /* 286334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286344 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(286457), // Rule ID 6216 //
     /* 286349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286373 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286406 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286410 */     // MIs[3] Operand 1
     /* 286410 */     // No operand predicates
     /* 286410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286412 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286455 */     GIR_RootConstrainSelectedInstOperands,
     /* 286456 */     // GIR_Coverage, 6216,
     /* 286456 */     GIR_EraseRootFromParent_Done,
     /* 286457 */   // Label 5928: @286457
     /* 286457 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(286570), // Rule ID 13839 //
     /* 286462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286498 */     // MIs[2] Operand 1
     /* 286498 */     // No operand predicates
     /* 286498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286510 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286514 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286519 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286525 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286537 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286568 */     GIR_RootConstrainSelectedInstOperands,
     /* 286569 */     // GIR_Coverage, 13839,
     /* 286569 */     GIR_EraseRootFromParent_Done,
     /* 286570 */   // Label 5929: @286570
     /* 286570 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(286646), // Rule ID 13776 //
     /* 286575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286606 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286644 */     GIR_RootConstrainSelectedInstOperands,
     /* 286645 */     // GIR_Coverage, 13776,
     /* 286645 */     GIR_EraseRootFromParent_Done,
     /* 286646 */   // Label 5930: @286646
     /* 286646 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(286722), // Rule ID 4795 //
     /* 286651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286676 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286682 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286694 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286720 */     GIR_RootConstrainSelectedInstOperands,
     /* 286721 */     // GIR_Coverage, 4795,
     /* 286721 */     GIR_EraseRootFromParent_Done,
     /* 286722 */   // Label 5931: @286722
     /* 286722 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(286785), // Rule ID 13391 //
     /* 286727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286763 */     // MIs[2] Operand 1
     /* 286763 */     // No operand predicates
     /* 286763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286769 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286783 */     GIR_RootConstrainSelectedInstOperands,
     /* 286784 */     // GIR_Coverage, 13391,
     /* 286784 */     GIR_EraseRootFromParent_Done,
     /* 286785 */   // Label 5932: @286785
     /* 286785 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(286848), // Rule ID 2014 //
     /* 286790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286830 */     // MIs[2] Operand 1
     /* 286830 */     // No operand predicates
     /* 286830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286832 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286846 */     GIR_RootConstrainSelectedInstOperands,
     /* 286847 */     // GIR_Coverage, 2014,
     /* 286847 */     GIR_EraseRootFromParent_Done,
     /* 286848 */   // Label 5933: @286848
     /* 286848 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(286889), // Rule ID 4799 //
     /* 286853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286876 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 286876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 286879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286885 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286887 */     GIR_RootConstrainSelectedInstOperands,
     /* 286888 */     // GIR_Coverage, 4799,
     /* 286888 */     GIR_EraseRootFromParent_Done,
     /* 286889 */   // Label 5934: @286889
     /* 286889 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(286930), // Rule ID 13780 //
     /* 286894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286917 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 286917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 286920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286926 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286928 */     GIR_RootConstrainSelectedInstOperands,
     /* 286929 */     // GIR_Coverage, 13780,
     /* 286929 */     GIR_EraseRootFromParent_Done,
     /* 286930 */   // Label 5935: @286930
     /* 286930 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(286957), // Rule ID 622 //
     /* 286935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286946 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 286946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286955 */     GIR_RootConstrainSelectedInstOperands,
     /* 286956 */     // GIR_Coverage, 622,
     /* 286956 */     GIR_Done,
     /* 286957 */   // Label 5936: @286957
     /* 286957 */   GIM_Reject,
     /* 286958 */ // Label 5927: @286958
     /* 286958 */ GIM_Reject,
     /* 286959 */ // Label 5907: @286959
     /* 286959 */ GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(287588),
     /* 286964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286974 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(287087), // Rule ID 6218 //
     /* 286979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287040 */     // MIs[3] Operand 1
     /* 287040 */     // No operand predicates
     /* 287040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287042 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287085 */     GIR_RootConstrainSelectedInstOperands,
     /* 287086 */     // GIR_Coverage, 6218,
     /* 287086 */     GIR_EraseRootFromParent_Done,
     /* 287087 */   // Label 5938: @287087
     /* 287087 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(287200), // Rule ID 13841 //
     /* 287092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287124 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287128 */     // MIs[2] Operand 1
     /* 287128 */     // No operand predicates
     /* 287128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287144 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287149 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287155 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287167 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287198 */     GIR_RootConstrainSelectedInstOperands,
     /* 287199 */     // GIR_Coverage, 13841,
     /* 287199 */     GIR_EraseRootFromParent_Done,
     /* 287200 */   // Label 5939: @287200
     /* 287200 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(287276), // Rule ID 13778 //
     /* 287205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287236 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287248 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287274 */     GIR_RootConstrainSelectedInstOperands,
     /* 287275 */     // GIR_Coverage, 13778,
     /* 287275 */     GIR_EraseRootFromParent_Done,
     /* 287276 */   // Label 5940: @287276
     /* 287276 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(287352), // Rule ID 4797 //
     /* 287281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287306 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287312 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287324 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287350 */     GIR_RootConstrainSelectedInstOperands,
     /* 287351 */     // GIR_Coverage, 4797,
     /* 287351 */     GIR_EraseRootFromParent_Done,
     /* 287352 */   // Label 5941: @287352
     /* 287352 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(287415), // Rule ID 13393 //
     /* 287357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287393 */     // MIs[2] Operand 1
     /* 287393 */     // No operand predicates
     /* 287393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287399 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287413 */     GIR_RootConstrainSelectedInstOperands,
     /* 287414 */     // GIR_Coverage, 13393,
     /* 287414 */     GIR_EraseRootFromParent_Done,
     /* 287415 */   // Label 5942: @287415
     /* 287415 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(287478), // Rule ID 2016 //
     /* 287420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287456 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287460 */     // MIs[2] Operand 1
     /* 287460 */     // No operand predicates
     /* 287460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287462 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287476 */     GIR_RootConstrainSelectedInstOperands,
     /* 287477 */     // GIR_Coverage, 2016,
     /* 287477 */     GIR_EraseRootFromParent_Done,
     /* 287478 */   // Label 5943: @287478
     /* 287478 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(287519), // Rule ID 4800 //
     /* 287483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287506 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287515 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287517 */     GIR_RootConstrainSelectedInstOperands,
     /* 287518 */     // GIR_Coverage, 4800,
     /* 287518 */     GIR_EraseRootFromParent_Done,
     /* 287519 */   // Label 5944: @287519
     /* 287519 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(287560), // Rule ID 13781 //
     /* 287524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287547 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287556 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287558 */     GIR_RootConstrainSelectedInstOperands,
     /* 287559 */     // GIR_Coverage, 13781,
     /* 287559 */     GIR_EraseRootFromParent_Done,
     /* 287560 */   // Label 5945: @287560
     /* 287560 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(287587), // Rule ID 624 //
     /* 287565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287576 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 287576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287581 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287585 */     GIR_RootConstrainSelectedInstOperands,
     /* 287586 */     // GIR_Coverage, 624,
     /* 287586 */     GIR_Done,
     /* 287587 */   // Label 5946: @287587
     /* 287587 */   GIM_Reject,
     /* 287588 */ // Label 5937: @287588
     /* 287588 */ GIM_Reject,
     /* 287589 */ // Label 5908: @287589
     /* 287589 */ GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(288118),
     /* 287594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287604 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(287690), // Rule ID 13382 //
     /* 287609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287657 */     // MIs[3] Operand 1
     /* 287657 */     // No operand predicates
     /* 287657 */     // MIs[1] Operand 2
     /* 287657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287674 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287688 */     GIR_RootConstrainSelectedInstOperands,
     /* 287689 */     // GIR_Coverage, 13382,
     /* 287689 */     GIR_EraseRootFromParent_Done,
     /* 287690 */   // Label 5948: @287690
     /* 287690 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(287776), // Rule ID 2005 //
     /* 287695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287743 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287747 */     // MIs[3] Operand 1
     /* 287747 */     // No operand predicates
     /* 287747 */     // MIs[1] Operand 2
     /* 287747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287760 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287774 */     GIR_RootConstrainSelectedInstOperands,
     /* 287775 */     // GIR_Coverage, 2005,
     /* 287775 */     GIR_EraseRootFromParent_Done,
     /* 287776 */   // Label 5949: @287776
     /* 287776 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(287839), // Rule ID 13383 //
     /* 287781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287817 */     // MIs[2] Operand 1
     /* 287817 */     // No operand predicates
     /* 287817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287823 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287837 */     GIR_RootConstrainSelectedInstOperands,
     /* 287838 */     // GIR_Coverage, 13383,
     /* 287838 */     GIR_EraseRootFromParent_Done,
     /* 287839 */   // Label 5950: @287839
     /* 287839 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(287902), // Rule ID 2006 //
     /* 287844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287884 */     // MIs[2] Operand 1
     /* 287884 */     // No operand predicates
     /* 287884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287886 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287900 */     GIR_RootConstrainSelectedInstOperands,
     /* 287901 */     // GIR_Coverage, 2006,
     /* 287901 */     GIR_EraseRootFromParent_Done,
     /* 287902 */   // Label 5951: @287902
     /* 287902 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(287996), // Rule ID 13843 //
     /* 287907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 287915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287930 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 287930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 287933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 287947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 287966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287994 */     GIR_RootConstrainSelectedInstOperands,
     /* 287995 */     // GIR_Coverage, 13843,
     /* 287995 */     GIR_EraseRootFromParent_Done,
     /* 287996 */   // Label 5952: @287996
     /* 287996 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(288090), // Rule ID 6220 //
     /* 288001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288024 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288057 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288088 */     GIR_RootConstrainSelectedInstOperands,
     /* 288089 */     // GIR_Coverage, 6220,
     /* 288089 */     GIR_EraseRootFromParent_Done,
     /* 288090 */   // Label 5953: @288090
     /* 288090 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288117), // Rule ID 1323 //
     /* 288095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288106 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 288106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 288111 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288115 */     GIR_RootConstrainSelectedInstOperands,
     /* 288116 */     // GIR_Coverage, 1323,
     /* 288116 */     GIR_Done,
     /* 288117 */   // Label 5954: @288117
     /* 288117 */   GIM_Reject,
     /* 288118 */ // Label 5947: @288118
     /* 288118 */ GIM_Reject,
     /* 288119 */ // Label 5909: @288119
     /* 288119 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288476),
     /* 288124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288134 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288197), // Rule ID 13387 //
     /* 288139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288175 */     // MIs[2] Operand 1
     /* 288175 */     // No operand predicates
     /* 288175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288181 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288195 */     GIR_RootConstrainSelectedInstOperands,
     /* 288196 */     // GIR_Coverage, 13387,
     /* 288196 */     GIR_EraseRootFromParent_Done,
     /* 288197 */   // Label 5956: @288197
     /* 288197 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288260), // Rule ID 2010 //
     /* 288202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288242 */     // MIs[2] Operand 1
     /* 288242 */     // No operand predicates
     /* 288242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288244 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288258 */     GIR_RootConstrainSelectedInstOperands,
     /* 288259 */     // GIR_Coverage, 2010,
     /* 288259 */     GIR_EraseRootFromParent_Done,
     /* 288260 */   // Label 5957: @288260
     /* 288260 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(288354), // Rule ID 13847 //
     /* 288265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288288 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288352 */     GIR_RootConstrainSelectedInstOperands,
     /* 288353 */     // GIR_Coverage, 13847,
     /* 288353 */     GIR_EraseRootFromParent_Done,
     /* 288354 */   // Label 5958: @288354
     /* 288354 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288448), // Rule ID 6224 //
     /* 288359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288382 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288408 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288446 */     GIR_RootConstrainSelectedInstOperands,
     /* 288447 */     // GIR_Coverage, 6224,
     /* 288447 */     GIR_EraseRootFromParent_Done,
     /* 288448 */   // Label 5959: @288448
     /* 288448 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(288475), // Rule ID 1327 //
     /* 288453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288464 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 288464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 288469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288473 */     GIR_RootConstrainSelectedInstOperands,
     /* 288474 */     // GIR_Coverage, 1327,
     /* 288474 */     GIR_Done,
     /* 288475 */   // Label 5960: @288475
     /* 288475 */   GIM_Reject,
     /* 288476 */ // Label 5955: @288476
     /* 288476 */ GIM_Reject,
     /* 288477 */ // Label 5910: @288477
     /* 288477 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(288818),
     /* 288482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 288488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288492 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(288578), // Rule ID 13376 //
     /* 288497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288545 */     // MIs[3] Operand 1
     /* 288545 */     // No operand predicates
     /* 288545 */     // MIs[1] Operand 2
     /* 288545 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288562 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288576 */     GIR_RootConstrainSelectedInstOperands,
     /* 288577 */     // GIR_Coverage, 13376,
     /* 288577 */     GIR_EraseRootFromParent_Done,
     /* 288578 */   // Label 5962: @288578
     /* 288578 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(288664), // Rule ID 1999 //
     /* 288583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288631 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288635 */     // MIs[3] Operand 1
     /* 288635 */     // No operand predicates
     /* 288635 */     // MIs[1] Operand 2
     /* 288635 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288648 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288662 */     GIR_RootConstrainSelectedInstOperands,
     /* 288663 */     // GIR_Coverage, 1999,
     /* 288663 */     GIR_EraseRootFromParent_Done,
     /* 288664 */   // Label 5963: @288664
     /* 288664 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(288727), // Rule ID 13377 //
     /* 288669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288705 */     // MIs[2] Operand 1
     /* 288705 */     // No operand predicates
     /* 288705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288711 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288725 */     GIR_RootConstrainSelectedInstOperands,
     /* 288726 */     // GIR_Coverage, 13377,
     /* 288726 */     GIR_EraseRootFromParent_Done,
     /* 288727 */   // Label 5964: @288727
     /* 288727 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(288790), // Rule ID 2000 //
     /* 288732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288772 */     // MIs[2] Operand 1
     /* 288772 */     // No operand predicates
     /* 288772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288774 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288788 */     GIR_RootConstrainSelectedInstOperands,
     /* 288789 */     // GIR_Coverage, 2000,
     /* 288789 */     GIR_EraseRootFromParent_Done,
     /* 288790 */   // Label 5965: @288790
     /* 288790 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(288817), // Rule ID 1319 //
     /* 288795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288806 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 288806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 288811 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288815 */     GIR_RootConstrainSelectedInstOperands,
     /* 288816 */     // GIR_Coverage, 1319,
     /* 288816 */     GIR_Done,
     /* 288817 */   // Label 5966: @288817
     /* 288817 */   GIM_Reject,
     /* 288818 */ // Label 5961: @288818
     /* 288818 */ GIM_Reject,
     /* 288819 */ // Label 5911: @288819
     /* 288819 */ GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(289176),
     /* 288824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 288830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288834 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(288897), // Rule ID 13385 //
     /* 288839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288875 */     // MIs[2] Operand 1
     /* 288875 */     // No operand predicates
     /* 288875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288881 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 288884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288895 */     GIR_RootConstrainSelectedInstOperands,
     /* 288896 */     // GIR_Coverage, 13385,
     /* 288896 */     GIR_EraseRootFromParent_Done,
     /* 288897 */   // Label 5968: @288897
     /* 288897 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(288960), // Rule ID 2008 //
     /* 288902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288942 */     // MIs[2] Operand 1
     /* 288942 */     // No operand predicates
     /* 288942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288944 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 288947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288958 */     GIR_RootConstrainSelectedInstOperands,
     /* 288959 */     // GIR_Coverage, 2008,
     /* 288959 */     GIR_EraseRootFromParent_Done,
     /* 288960 */   // Label 5969: @288960
     /* 288960 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(289054), // Rule ID 13845 //
     /* 288965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288988 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289021 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289052 */     GIR_RootConstrainSelectedInstOperands,
     /* 289053 */     // GIR_Coverage, 13845,
     /* 289053 */     GIR_EraseRootFromParent_Done,
     /* 289054 */   // Label 5970: @289054
     /* 289054 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(289148), // Rule ID 6222 //
     /* 289059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289082 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289146 */     GIR_RootConstrainSelectedInstOperands,
     /* 289147 */     // GIR_Coverage, 6222,
     /* 289147 */     GIR_EraseRootFromParent_Done,
     /* 289148 */   // Label 5971: @289148
     /* 289148 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289175), // Rule ID 1325 //
     /* 289153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289164 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 289164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289169 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289173 */     GIR_RootConstrainSelectedInstOperands,
     /* 289174 */     // GIR_Coverage, 1325,
     /* 289174 */     GIR_Done,
     /* 289175 */   // Label 5972: @289175
     /* 289175 */   GIM_Reject,
     /* 289176 */ // Label 5967: @289176
     /* 289176 */ GIM_Reject,
     /* 289177 */ // Label 5912: @289177
     /* 289177 */ GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(289608),
     /* 289182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 289188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289192 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(289255), // Rule ID 13379 //
     /* 289197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289233 */     // MIs[2] Operand 1
     /* 289233 */     // No operand predicates
     /* 289233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289239 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289253 */     GIR_RootConstrainSelectedInstOperands,
     /* 289254 */     // GIR_Coverage, 13379,
     /* 289254 */     GIR_EraseRootFromParent_Done,
     /* 289255 */   // Label 5974: @289255
     /* 289255 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(289318), // Rule ID 2002 //
     /* 289260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289296 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289300 */     // MIs[2] Operand 1
     /* 289300 */     // No operand predicates
     /* 289300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289302 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289316 */     GIR_RootConstrainSelectedInstOperands,
     /* 289317 */     // GIR_Coverage, 2002,
     /* 289317 */     GIR_EraseRootFromParent_Done,
     /* 289318 */   // Label 5975: @289318
     /* 289318 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(289345), // Rule ID 1321 //
     /* 289323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289334 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 289334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 289339 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289343 */     GIR_RootConstrainSelectedInstOperands,
     /* 289344 */     // GIR_Coverage, 1321,
     /* 289344 */     GIR_Done,
     /* 289345 */   // Label 5976: @289345
     /* 289345 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(289607), // Rule ID 6977 //
     /* 289350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 289353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289361 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 289361 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 289364 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289368 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289373 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 289377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 289379 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 289382 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289386 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289391 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 289395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 289397 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 289400 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289404 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289409 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 289412 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 289415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 289417 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 289420 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289424 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289429 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289435 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289440 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289445 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 289448 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289452 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289457 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 289460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 289462 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 289465 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289469 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289474 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289480 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289485 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289490 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 289493 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289497 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289502 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 289505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 289507 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 289510 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289514 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289519 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 289522 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 289525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 289527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 289530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 289534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289539 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 289542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 289544 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 289547 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289551 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 289576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 289579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 289597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 289605 */     GIR_RootConstrainSelectedInstOperands,
     /* 289606 */     // GIR_Coverage, 6977,
     /* 289606 */     GIR_EraseRootFromParent_Done,
     /* 289607 */   // Label 5977: @289607
     /* 289607 */   GIM_Reject,
     /* 289608 */ // Label 5973: @289608
     /* 289608 */ GIM_Reject,
     /* 289609 */ // Label 5913: @289609
     /* 289609 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(289634), // Rule ID 8149 //
     /* 289614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 289620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 289623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289627 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 289627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 289632 */   GIR_RootConstrainSelectedInstOperands,
     /* 289633 */   // GIR_Coverage, 8149,
     /* 289633 */   GIR_Done,
     /* 289634 */ // Label 5978: @289634
     /* 289634 */ GIM_Reject,
     /* 289635 */ // Label 5914: @289635
     /* 289635 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(289660), // Rule ID 8147 //
     /* 289640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 289646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 289649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289653 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 289653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 289658 */   GIR_RootConstrainSelectedInstOperands,
     /* 289659 */   // GIR_Coverage, 8147,
     /* 289659 */   GIR_Done,
     /* 289660 */ // Label 5979: @289660
     /* 289660 */ GIM_Reject,
     /* 289661 */ // Label 5915: @289661
     /* 289661 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(289686), // Rule ID 8145 //
     /* 289666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 289672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 289675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289679 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 289679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 289684 */   GIR_RootConstrainSelectedInstOperands,
     /* 289685 */   // GIR_Coverage, 8145,
     /* 289685 */   GIR_Done,
     /* 289686 */ // Label 5980: @289686
     /* 289686 */ GIM_Reject,
     /* 289687 */ // Label 5916: @289687
     /* 289687 */ GIM_Reject,
     /* 289688 */ // Label 60: @289688
     /* 289688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5989*/ GIMT_Encode4(305960),
     /* 289699 */ /*GILLT_s16*//*Label 5981*/ GIMT_Encode4(289739),
     /* 289703 */ /*GILLT_s32*//*Label 5982*/ GIMT_Encode4(292743),
     /* 289707 */ /*GILLT_s64*//*Label 5983*/ GIMT_Encode4(295891), GIMT_Encode4(0),
     /* 289715 */ /*GILLT_v2s32*//*Label 5984*/ GIMT_Encode4(299039),
     /* 289719 */ /*GILLT_v2s64*//*Label 5985*/ GIMT_Encode4(300560),
     /* 289723 */ /*GILLT_v4s16*//*Label 5986*/ GIMT_Encode4(302081),
     /* 289727 */ /*GILLT_v4s32*//*Label 5987*/ GIMT_Encode4(303260), GIMT_Encode4(0),
     /* 289735 */ /*GILLT_v8s16*//*Label 5988*/ GIMT_Encode4(304781),
     /* 289739 */ // Label 5981: @289739
     /* 289739 */ GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(292742),
     /* 289744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 289747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 289750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 289753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289757 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(289907), // Rule ID 4855 //
     /* 289762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289786 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289811 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 289819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 289827 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289834 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 289834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 289837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289846 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 289852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 289865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289874 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 289880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 289893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 289905 */     GIR_RootConstrainSelectedInstOperands,
     /* 289906 */     // GIR_Coverage, 4855,
     /* 289906 */     GIR_EraseRootFromParent_Done,
     /* 289907 */   // Label 5991: @289907
     /* 289907 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(290054), // Rule ID 4819 //
     /* 289912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289936 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 289952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 289956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289968 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289973 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289983 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 289983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 289986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289995 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290052 */     GIR_RootConstrainSelectedInstOperands,
     /* 290053 */     // GIR_Coverage, 4819,
     /* 290053 */     GIR_EraseRootFromParent_Done,
     /* 290054 */   // Label 5992: @290054
     /* 290054 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(290201), // Rule ID 13787 //
     /* 290059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290095 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290120 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290130 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290142 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290199 */     GIR_RootConstrainSelectedInstOperands,
     /* 290200 */     // GIR_Coverage, 13787,
     /* 290200 */     GIR_EraseRootFromParent_Done,
     /* 290201 */   // Label 5993: @290201
     /* 290201 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(290332), // Rule ID 6052 //
     /* 290206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290262 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290271 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290275 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290279 */     // MIs[4] Operand 1
     /* 290279 */     // No operand predicates
     /* 290279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290283 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290285 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290297 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290330 */     GIR_RootConstrainSelectedInstOperands,
     /* 290331 */     // GIR_Coverage, 6052,
     /* 290331 */     GIR_EraseRootFromParent_Done,
     /* 290332 */   // Label 5994: @290332
     /* 290332 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(290463), // Rule ID 6084 //
     /* 290337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290373 */     // MIs[2] Operand 1
     /* 290373 */     // No operand predicates
     /* 290373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290385 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 290389 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290393 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290397 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290401 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290406 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290414 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290416 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290428 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290461 */     GIR_RootConstrainSelectedInstOperands,
     /* 290462 */     // GIR_Coverage, 6084,
     /* 290462 */     GIR_EraseRootFromParent_Done,
     /* 290463 */   // Label 5995: @290463
     /* 290463 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(290594), // Rule ID 6148 //
     /* 290468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290504 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290537 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290541 */     // MIs[4] Operand 1
     /* 290541 */     // No operand predicates
     /* 290541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290545 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290547 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290559 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290592 */     GIR_RootConstrainSelectedInstOperands,
     /* 290593 */     // GIR_Coverage, 6148,
     /* 290593 */     GIR_EraseRootFromParent_Done,
     /* 290594 */   // Label 5996: @290594
     /* 290594 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(290725), // Rule ID 6116 //
     /* 290599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290643 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290647 */     // MIs[3] Operand 1
     /* 290647 */     // No operand predicates
     /* 290647 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 290651 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290655 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290659 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290663 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290668 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290676 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290678 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290690 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290723 */     GIR_RootConstrainSelectedInstOperands,
     /* 290724 */     // GIR_Coverage, 6116,
     /* 290724 */     GIR_EraseRootFromParent_Done,
     /* 290725 */   // Label 5997: @290725
     /* 290725 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(290860), // Rule ID 2456 //
     /* 290730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290789 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290801 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290829 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 290848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290858 */     GIR_RootConstrainSelectedInstOperands,
     /* 290859 */     // GIR_Coverage, 2456,
     /* 290859 */     GIR_EraseRootFromParent_Done,
     /* 290860 */   // Label 5998: @290860
     /* 290860 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(290979), // Rule ID 6020 //
     /* 290865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290926 */     // MIs[3] Operand 1
     /* 290926 */     // No operand predicates
     /* 290926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290932 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 290963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290977 */     GIR_RootConstrainSelectedInstOperands,
     /* 290978 */     // GIR_Coverage, 6020,
     /* 290978 */     GIR_EraseRootFromParent_Done,
     /* 290979 */   // Label 5999: @290979
     /* 290979 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(291098), // Rule ID 2538 //
     /* 290984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291020 */     // MIs[2] Operand 1
     /* 291020 */     // No operand predicates
     /* 291020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291041 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291051 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291063 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291096 */     GIR_RootConstrainSelectedInstOperands,
     /* 291097 */     // GIR_Coverage, 2538,
     /* 291097 */     GIR_EraseRootFromParent_Done,
     /* 291098 */   // Label 6000: @291098
     /* 291098 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(291198), // Rule ID 4817 //
     /* 291103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291127 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291154 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291166 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291196 */     GIR_RootConstrainSelectedInstOperands,
     /* 291197 */     // GIR_Coverage, 4817,
     /* 291197 */     GIR_EraseRootFromParent_Done,
     /* 291198 */   // Label 6001: @291198
     /* 291198 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(291298), // Rule ID 4853 //
     /* 291203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291227 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291254 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291296 */     GIR_RootConstrainSelectedInstOperands,
     /* 291297 */     // GIR_Coverage, 4853,
     /* 291297 */     GIR_EraseRootFromParent_Done,
     /* 291298 */   // Label 6002: @291298
     /* 291298 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(291395), // Rule ID 13783 //
     /* 291303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291339 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291353 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291393 */     GIR_RootConstrainSelectedInstOperands,
     /* 291394 */     // GIR_Coverage, 13783,
     /* 291394 */     GIR_EraseRootFromParent_Done,
     /* 291395 */   // Label 6003: @291395
     /* 291395 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(291495), // Rule ID 13785 //
     /* 291400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291451 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291493 */     GIR_RootConstrainSelectedInstOperands,
     /* 291494 */     // GIR_Coverage, 13785,
     /* 291494 */     GIR_EraseRootFromParent_Done,
     /* 291495 */   // Label 6004: @291495
     /* 291495 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(291595), // Rule ID 4851 //
     /* 291500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291528 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291551 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291593 */     GIR_RootConstrainSelectedInstOperands,
     /* 291594 */     // GIR_Coverage, 4851,
     /* 291594 */     GIR_EraseRootFromParent_Done,
     /* 291595 */   // Label 6005: @291595
     /* 291595 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(291692), // Rule ID 4815 //
     /* 291600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291640 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291650 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291662 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291690 */     GIR_RootConstrainSelectedInstOperands,
     /* 291691 */     // GIR_Coverage, 4815,
     /* 291691 */     GIR_EraseRootFromParent_Done,
     /* 291692 */   // Label 6006: @291692
     /* 291692 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(291776), // Rule ID 6082 //
     /* 291697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291733 */     // MIs[2] Operand 1
     /* 291733 */     // No operand predicates
     /* 291733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 291745 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291756 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291774 */     GIR_RootConstrainSelectedInstOperands,
     /* 291775 */     // GIR_Coverage, 6082,
     /* 291775 */     GIR_EraseRootFromParent_Done,
     /* 291776 */   // Label 6007: @291776
     /* 291776 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(291857), // Rule ID 6114 //
     /* 291781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291829 */     // MIs[3] Operand 1
     /* 291829 */     // No operand predicates
     /* 291829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291839 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291855 */     GIR_RootConstrainSelectedInstOperands,
     /* 291856 */     // GIR_Coverage, 6114,
     /* 291856 */     GIR_EraseRootFromParent_Done,
     /* 291857 */   // Label 6008: @291857
     /* 291857 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(291941), // Rule ID 6146 //
     /* 291862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291915 */     // MIs[3] Operand 1
     /* 291915 */     // No operand predicates
     /* 291915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291921 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291939 */     GIR_RootConstrainSelectedInstOperands,
     /* 291940 */     // GIR_Coverage, 6146,
     /* 291940 */     GIR_EraseRootFromParent_Done,
     /* 291941 */   // Label 6009: @291941
     /* 291941 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(292022), // Rule ID 6050 //
     /* 291946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291998 */     // MIs[3] Operand 1
     /* 291998 */     // No operand predicates
     /* 291998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292004 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292020 */     GIR_RootConstrainSelectedInstOperands,
     /* 292021 */     // GIR_Coverage, 6050,
     /* 292021 */     GIR_EraseRootFromParent_Done,
     /* 292022 */   // Label 6010: @292022
     /* 292022 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(292107), // Rule ID 2454 //
     /* 292027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292065 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292105 */     GIR_RootConstrainSelectedInstOperands,
     /* 292106 */     // GIR_Coverage, 2454,
     /* 292106 */     GIR_EraseRootFromParent_Done,
     /* 292107 */   // Label 6011: @292107
     /* 292107 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(292192), // Rule ID 2452 //
     /* 292112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292140 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292150 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292162 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292190 */     GIR_RootConstrainSelectedInstOperands,
     /* 292191 */     // GIR_Coverage, 2452,
     /* 292191 */     GIR_EraseRootFromParent_Done,
     /* 292192 */   // Label 6012: @292192
     /* 292192 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(292261), // Rule ID 2536 //
     /* 292197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292233 */     // MIs[2] Operand 1
     /* 292233 */     // No operand predicates
     /* 292233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292243 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292259 */     GIR_RootConstrainSelectedInstOperands,
     /* 292260 */     // GIR_Coverage, 2536,
     /* 292260 */     GIR_EraseRootFromParent_Done,
     /* 292261 */   // Label 6013: @292261
     /* 292261 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(292330), // Rule ID 6018 //
     /* 292266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292302 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292306 */     // MIs[2] Operand 1
     /* 292306 */     // No operand predicates
     /* 292306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292312 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292328 */     GIR_RootConstrainSelectedInstOperands,
     /* 292329 */     // GIR_Coverage, 6018,
     /* 292329 */     GIR_EraseRootFromParent_Done,
     /* 292330 */   // Label 6014: @292330
     /* 292330 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(292395), // Rule ID 4871 //
     /* 292335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292378 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292393 */     GIR_RootConstrainSelectedInstOperands,
     /* 292394 */     // GIR_Coverage, 4871,
     /* 292394 */     GIR_EraseRootFromParent_Done,
     /* 292395 */   // Label 6015: @292395
     /* 292395 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(292460), // Rule ID 13803 //
     /* 292400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292443 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292458 */     GIR_RootConstrainSelectedInstOperands,
     /* 292459 */     // GIR_Coverage, 13803,
     /* 292459 */     GIR_EraseRootFromParent_Done,
     /* 292460 */   // Label 6016: @292460
     /* 292460 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(292510), // Rule ID 4868 //
     /* 292465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292495 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292508 */     GIR_RootConstrainSelectedInstOperands,
     /* 292509 */     // GIR_Coverage, 4868,
     /* 292509 */     GIR_EraseRootFromParent_Done,
     /* 292510 */   // Label 6017: @292510
     /* 292510 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(292560), // Rule ID 13229 //
     /* 292515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292545 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292558 */     GIR_RootConstrainSelectedInstOperands,
     /* 292559 */     // GIR_Coverage, 13229,
     /* 292559 */     GIR_EraseRootFromParent_Done,
     /* 292560 */   // Label 6018: @292560
     /* 292560 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(292610), // Rule ID 644 //
     /* 292565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292595 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292608 */     GIR_RootConstrainSelectedInstOperands,
     /* 292609 */     // GIR_Coverage, 644,
     /* 292609 */     GIR_EraseRootFromParent_Done,
     /* 292610 */   // Label 6019: @292610
     /* 292610 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(292660), // Rule ID 13800 //
     /* 292615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292645 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292658 */     GIR_RootConstrainSelectedInstOperands,
     /* 292659 */     // GIR_Coverage, 13800,
     /* 292659 */     GIR_EraseRootFromParent_Done,
     /* 292660 */   // Label 6020: @292660
     /* 292660 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(292710), // Rule ID 656 //
     /* 292665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292695 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 292708 */     GIR_RootConstrainSelectedInstOperands,
     /* 292709 */     // GIR_Coverage, 656,
     /* 292709 */     GIR_EraseRootFromParent_Done,
     /* 292710 */   // Label 6021: @292710
     /* 292710 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(292741), // Rule ID 638 //
     /* 292715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292730 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292735 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 292739 */     GIR_RootConstrainSelectedInstOperands,
     /* 292740 */     // GIR_Coverage, 638,
     /* 292740 */     GIR_Done,
     /* 292741 */   // Label 6022: @292741
     /* 292741 */   GIM_Reject,
     /* 292742 */ // Label 5990: @292742
     /* 292742 */ GIM_Reject,
     /* 292743 */ // Label 5982: @292743
     /* 292743 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(295890),
     /* 292748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 292757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292761 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(292911), // Rule ID 4861 //
     /* 292766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292790 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292815 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 292823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292827 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 292831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292838 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 292838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 292841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292850 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 292856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 292869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 292884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 292897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 292909 */     GIR_RootConstrainSelectedInstOperands,
     /* 292910 */     // GIR_Coverage, 4861,
     /* 292910 */     GIR_EraseRootFromParent_Done,
     /* 292911 */   // Label 6024: @292911
     /* 292911 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(293058), // Rule ID 4825 //
     /* 292916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292940 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292977 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292987 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 292987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 292990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292999 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293027 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293056 */     GIR_RootConstrainSelectedInstOperands,
     /* 293057 */     // GIR_Coverage, 4825,
     /* 293057 */     GIR_EraseRootFromParent_Done,
     /* 293058 */   // Label 6025: @293058
     /* 293058 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(293205), // Rule ID 13793 //
     /* 293063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293115 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293124 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293134 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293146 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293203 */     GIR_RootConstrainSelectedInstOperands,
     /* 293204 */     // GIR_Coverage, 13793,
     /* 293204 */     GIR_EraseRootFromParent_Done,
     /* 293205 */   // Label 6026: @293205
     /* 293205 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(293336), // Rule ID 6068 //
     /* 293210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293279 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293283 */     // MIs[4] Operand 1
     /* 293283 */     // No operand predicates
     /* 293283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293287 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293289 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293301 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293334 */     GIR_RootConstrainSelectedInstOperands,
     /* 293335 */     // GIR_Coverage, 6068,
     /* 293335 */     GIR_EraseRootFromParent_Done,
     /* 293336 */   // Label 6027: @293336
     /* 293336 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(293467), // Rule ID 6100 //
     /* 293341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293377 */     // MIs[2] Operand 1
     /* 293377 */     // No operand predicates
     /* 293377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293389 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293393 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293397 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293401 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293405 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293410 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293420 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293465 */     GIR_RootConstrainSelectedInstOperands,
     /* 293466 */     // GIR_Coverage, 6100,
     /* 293466 */     GIR_EraseRootFromParent_Done,
     /* 293467 */   // Label 6028: @293467
     /* 293467 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(293598), // Rule ID 6164 //
     /* 293472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293508 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293533 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293537 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293541 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293545 */     // MIs[4] Operand 1
     /* 293545 */     // No operand predicates
     /* 293545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293551 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293596 */     GIR_RootConstrainSelectedInstOperands,
     /* 293597 */     // GIR_Coverage, 6164,
     /* 293597 */     GIR_EraseRootFromParent_Done,
     /* 293598 */   // Label 6029: @293598
     /* 293598 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(293729), // Rule ID 6132 //
     /* 293603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293647 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293651 */     // MIs[3] Operand 1
     /* 293651 */     // No operand predicates
     /* 293651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 293655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293659 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293663 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293667 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293672 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293680 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293682 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293694 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293727 */     GIR_RootConstrainSelectedInstOperands,
     /* 293728 */     // GIR_Coverage, 6132,
     /* 293728 */     GIR_EraseRootFromParent_Done,
     /* 293729 */   // Label 6030: @293729
     /* 293729 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(293864), // Rule ID 2462 //
     /* 293734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293758 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293783 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293793 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293805 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 293852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293862 */     GIR_RootConstrainSelectedInstOperands,
     /* 293863 */     // GIR_Coverage, 2462,
     /* 293863 */     GIR_EraseRootFromParent_Done,
     /* 293864 */   // Label 6031: @293864
     /* 293864 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(293983), // Rule ID 6036 //
     /* 293869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293893 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293930 */     // MIs[3] Operand 1
     /* 293930 */     // No operand predicates
     /* 293930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293936 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293948 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 293967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293981 */     GIR_RootConstrainSelectedInstOperands,
     /* 293982 */     // GIR_Coverage, 6036,
     /* 293982 */     GIR_EraseRootFromParent_Done,
     /* 293983 */   // Label 6032: @293983
     /* 293983 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(294102), // Rule ID 2554 //
     /* 293988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294024 */     // MIs[2] Operand 1
     /* 294024 */     // No operand predicates
     /* 294024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294045 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294055 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294100 */     GIR_RootConstrainSelectedInstOperands,
     /* 294101 */     // GIR_Coverage, 2554,
     /* 294101 */     GIR_EraseRootFromParent_Done,
     /* 294102 */   // Label 6033: @294102
     /* 294102 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(294202), // Rule ID 4823 //
     /* 294107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294131 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294158 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294200 */     GIR_RootConstrainSelectedInstOperands,
     /* 294201 */     // GIR_Coverage, 4823,
     /* 294201 */     GIR_EraseRootFromParent_Done,
     /* 294202 */   // Label 6034: @294202
     /* 294202 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(294302), // Rule ID 4859 //
     /* 294207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294258 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294300 */     GIR_RootConstrainSelectedInstOperands,
     /* 294301 */     // GIR_Coverage, 4859,
     /* 294301 */     GIR_EraseRootFromParent_Done,
     /* 294302 */   // Label 6035: @294302
     /* 294302 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(294399), // Rule ID 13789 //
     /* 294307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294357 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294397 */     GIR_RootConstrainSelectedInstOperands,
     /* 294398 */     // GIR_Coverage, 13789,
     /* 294398 */     GIR_EraseRootFromParent_Done,
     /* 294399 */   // Label 6036: @294399
     /* 294399 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(294499), // Rule ID 13791 //
     /* 294404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294455 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294497 */     GIR_RootConstrainSelectedInstOperands,
     /* 294498 */     // GIR_Coverage, 13791,
     /* 294498 */     GIR_EraseRootFromParent_Done,
     /* 294499 */   // Label 6037: @294499
     /* 294499 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(294599), // Rule ID 4857 //
     /* 294504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294555 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294567 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294597 */     GIR_RootConstrainSelectedInstOperands,
     /* 294598 */     // GIR_Coverage, 4857,
     /* 294598 */     GIR_EraseRootFromParent_Done,
     /* 294599 */   // Label 6038: @294599
     /* 294599 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(294696), // Rule ID 4821 //
     /* 294604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294644 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294654 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294666 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294694 */     GIR_RootConstrainSelectedInstOperands,
     /* 294695 */     // GIR_Coverage, 4821,
     /* 294695 */     GIR_EraseRootFromParent_Done,
     /* 294696 */   // Label 6039: @294696
     /* 294696 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(294774), // Rule ID 6186 //
     /* 294701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 294738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294746 */     // MIs[3] Operand 1
     /* 294746 */     // No operand predicates
     /* 294746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294756 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294772 */     GIR_RootConstrainSelectedInstOperands,
     /* 294773 */     // GIR_Coverage, 6186,
     /* 294773 */     GIR_EraseRootFromParent_Done,
     /* 294774 */   // Label 6040: @294774
     /* 294774 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(294858), // Rule ID 6098 //
     /* 294779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294815 */     // MIs[2] Operand 1
     /* 294815 */     // No operand predicates
     /* 294815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 294827 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294838 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294856 */     GIR_RootConstrainSelectedInstOperands,
     /* 294857 */     // GIR_Coverage, 6098,
     /* 294857 */     GIR_EraseRootFromParent_Done,
     /* 294858 */   // Label 6041: @294858
     /* 294858 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(294939), // Rule ID 6130 //
     /* 294863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294907 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294911 */     // MIs[3] Operand 1
     /* 294911 */     // No operand predicates
     /* 294911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294921 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294937 */     GIR_RootConstrainSelectedInstOperands,
     /* 294938 */     // GIR_Coverage, 6130,
     /* 294938 */     GIR_EraseRootFromParent_Done,
     /* 294939 */   // Label 6042: @294939
     /* 294939 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(295023), // Rule ID 6162 //
     /* 294944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294993 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294997 */     // MIs[3] Operand 1
     /* 294997 */     // No operand predicates
     /* 294997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295003 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295021 */     GIR_RootConstrainSelectedInstOperands,
     /* 295022 */     // GIR_Coverage, 6162,
     /* 295022 */     GIR_EraseRootFromParent_Done,
     /* 295023 */   // Label 6043: @295023
     /* 295023 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(295101), // Rule ID 6208 //
     /* 295028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295077 */     // MIs[3] Operand 1
     /* 295077 */     // No operand predicates
     /* 295077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295083 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295099 */     GIR_RootConstrainSelectedInstOperands,
     /* 295100 */     // GIR_Coverage, 6208,
     /* 295100 */     GIR_EraseRootFromParent_Done,
     /* 295101 */   // Label 6044: @295101
     /* 295101 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295182), // Rule ID 6066 //
     /* 295106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295158 */     // MIs[3] Operand 1
     /* 295158 */     // No operand predicates
     /* 295158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295164 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295180 */     GIR_RootConstrainSelectedInstOperands,
     /* 295181 */     // GIR_Coverage, 6066,
     /* 295181 */     GIR_EraseRootFromParent_Done,
     /* 295182 */   // Label 6045: @295182
     /* 295182 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(295267), // Rule ID 2460 //
     /* 295187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295225 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295265 */     GIR_RootConstrainSelectedInstOperands,
     /* 295266 */     // GIR_Coverage, 2460,
     /* 295266 */     GIR_EraseRootFromParent_Done,
     /* 295267 */   // Label 6046: @295267
     /* 295267 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(295352), // Rule ID 2458 //
     /* 295272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295300 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295310 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295350 */     GIR_RootConstrainSelectedInstOperands,
     /* 295351 */     // GIR_Coverage, 2458,
     /* 295351 */     GIR_EraseRootFromParent_Done,
     /* 295352 */   // Label 6047: @295352
     /* 295352 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(295421), // Rule ID 2552 //
     /* 295357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295393 */     // MIs[2] Operand 1
     /* 295393 */     // No operand predicates
     /* 295393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295403 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295419 */     GIR_RootConstrainSelectedInstOperands,
     /* 295420 */     // GIR_Coverage, 2552,
     /* 295420 */     GIR_EraseRootFromParent_Done,
     /* 295421 */   // Label 6048: @295421
     /* 295421 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(295490), // Rule ID 6034 //
     /* 295426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295466 */     // MIs[2] Operand 1
     /* 295466 */     // No operand predicates
     /* 295466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295472 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295488 */     GIR_RootConstrainSelectedInstOperands,
     /* 295489 */     // GIR_Coverage, 6034,
     /* 295489 */     GIR_EraseRootFromParent_Done,
     /* 295490 */   // Label 6049: @295490
     /* 295490 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(295552), // Rule ID 4872 //
     /* 295495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295535 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295550 */     GIR_RootConstrainSelectedInstOperands,
     /* 295551 */     // GIR_Coverage, 4872,
     /* 295551 */     GIR_EraseRootFromParent_Done,
     /* 295552 */   // Label 6050: @295552
     /* 295552 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(295614), // Rule ID 13804 //
     /* 295557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295597 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295612 */     GIR_RootConstrainSelectedInstOperands,
     /* 295613 */     // GIR_Coverage, 13804,
     /* 295613 */     GIR_EraseRootFromParent_Done,
     /* 295614 */   // Label 6051: @295614
     /* 295614 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(295661), // Rule ID 4869 //
     /* 295619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295646 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295659 */     GIR_RootConstrainSelectedInstOperands,
     /* 295660 */     // GIR_Coverage, 4869,
     /* 295660 */     GIR_EraseRootFromParent_Done,
     /* 295661 */   // Label 6052: @295661
     /* 295661 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(295711), // Rule ID 13231 //
     /* 295666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295696 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295709 */     GIR_RootConstrainSelectedInstOperands,
     /* 295710 */     // GIR_Coverage, 13231,
     /* 295710 */     GIR_EraseRootFromParent_Done,
     /* 295711 */   // Label 6053: @295711
     /* 295711 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(295761), // Rule ID 646 //
     /* 295716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295746 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295759 */     GIR_RootConstrainSelectedInstOperands,
     /* 295760 */     // GIR_Coverage, 646,
     /* 295760 */     GIR_EraseRootFromParent_Done,
     /* 295761 */   // Label 6054: @295761
     /* 295761 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(295808), // Rule ID 13801 //
     /* 295766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295793 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295806 */     GIR_RootConstrainSelectedInstOperands,
     /* 295807 */     // GIR_Coverage, 13801,
     /* 295807 */     GIR_EraseRootFromParent_Done,
     /* 295808 */   // Label 6055: @295808
     /* 295808 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(295858), // Rule ID 658 //
     /* 295813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295843 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 295856 */     GIR_RootConstrainSelectedInstOperands,
     /* 295857 */     // GIR_Coverage, 658,
     /* 295857 */     GIR_EraseRootFromParent_Done,
     /* 295858 */   // Label 6056: @295858
     /* 295858 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(295889), // Rule ID 640 //
     /* 295863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295878 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295883 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295887 */     GIR_RootConstrainSelectedInstOperands,
     /* 295888 */     // GIR_Coverage, 640,
     /* 295888 */     GIR_Done,
     /* 295889 */   // Label 6057: @295889
     /* 295889 */   GIM_Reject,
     /* 295890 */ // Label 6023: @295890
     /* 295890 */ GIM_Reject,
     /* 295891 */ // Label 5983: @295891
     /* 295891 */ GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(299038),
     /* 295896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 295905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295909 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(296059), // Rule ID 4867 //
     /* 295914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295938 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295963 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 295971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 295979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295986 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 295986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 295989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296026 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 296045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 296057 */     GIR_RootConstrainSelectedInstOperands,
     /* 296058 */     // GIR_Coverage, 4867,
     /* 296058 */     GIR_EraseRootFromParent_Done,
     /* 296059 */   // Label 6059: @296059
     /* 296059 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(296206), // Rule ID 4831 //
     /* 296064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296116 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296120 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296125 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296135 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296147 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296175 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296204 */     GIR_RootConstrainSelectedInstOperands,
     /* 296205 */     // GIR_Coverage, 4831,
     /* 296205 */     GIR_EraseRootFromParent_Done,
     /* 296206 */   // Label 6060: @296206
     /* 296206 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(296353), // Rule ID 13799 //
     /* 296211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296247 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296272 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296282 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296294 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296351 */     GIR_RootConstrainSelectedInstOperands,
     /* 296352 */     // GIR_Coverage, 13799,
     /* 296352 */     GIR_EraseRootFromParent_Done,
     /* 296353 */   // Label 6061: @296353
     /* 296353 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(296484), // Rule ID 6072 //
     /* 296358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296410 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296414 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296419 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296423 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296427 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296431 */     // MIs[4] Operand 1
     /* 296431 */     // No operand predicates
     /* 296431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296437 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296449 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296482 */     GIR_RootConstrainSelectedInstOperands,
     /* 296483 */     // GIR_Coverage, 6072,
     /* 296483 */     GIR_EraseRootFromParent_Done,
     /* 296484 */   // Label 6062: @296484
     /* 296484 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(296615), // Rule ID 6104 //
     /* 296489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296525 */     // MIs[2] Operand 1
     /* 296525 */     // No operand predicates
     /* 296525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 296537 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 296541 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296545 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296549 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296553 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296558 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296566 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296568 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296580 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296613 */     GIR_RootConstrainSelectedInstOperands,
     /* 296614 */     // GIR_Coverage, 6104,
     /* 296614 */     GIR_EraseRootFromParent_Done,
     /* 296615 */   // Label 6063: @296615
     /* 296615 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(296746), // Rule ID 6168 //
     /* 296620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296656 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296672 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296676 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296689 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296693 */     // MIs[4] Operand 1
     /* 296693 */     // No operand predicates
     /* 296693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296697 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296699 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296711 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296744 */     GIR_RootConstrainSelectedInstOperands,
     /* 296745 */     // GIR_Coverage, 6168,
     /* 296745 */     GIR_EraseRootFromParent_Done,
     /* 296746 */   // Label 6064: @296746
     /* 296746 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(296877), // Rule ID 6136 //
     /* 296751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296795 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296799 */     // MIs[3] Operand 1
     /* 296799 */     // No operand predicates
     /* 296799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 296803 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296807 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296811 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296820 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296828 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296830 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296842 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296875 */     GIR_RootConstrainSelectedInstOperands,
     /* 296876 */     // GIR_Coverage, 6136,
     /* 296876 */     GIR_EraseRootFromParent_Done,
     /* 296877 */   // Label 6065: @296877
     /* 296877 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(297012), // Rule ID 2468 //
     /* 296882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296906 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296931 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296941 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296941 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296944 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296948 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296953 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296981 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 297000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297010 */     GIR_RootConstrainSelectedInstOperands,
     /* 297011 */     // GIR_Coverage, 2468,
     /* 297011 */     GIR_EraseRootFromParent_Done,
     /* 297012 */   // Label 6066: @297012
     /* 297012 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(297131), // Rule ID 6040 //
     /* 297017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297074 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297078 */     // MIs[3] Operand 1
     /* 297078 */     // No operand predicates
     /* 297078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297084 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297096 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297129 */     GIR_RootConstrainSelectedInstOperands,
     /* 297130 */     // GIR_Coverage, 6040,
     /* 297130 */     GIR_EraseRootFromParent_Done,
     /* 297131 */   // Label 6067: @297131
     /* 297131 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(297250), // Rule ID 2558 //
     /* 297136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297172 */     // MIs[2] Operand 1
     /* 297172 */     // No operand predicates
     /* 297172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297184 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297188 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297193 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297203 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297215 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297248 */     GIR_RootConstrainSelectedInstOperands,
     /* 297249 */     // GIR_Coverage, 2558,
     /* 297249 */     GIR_EraseRootFromParent_Done,
     /* 297250 */   // Label 6068: @297250
     /* 297250 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(297350), // Rule ID 4829 //
     /* 297255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297279 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297306 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297318 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297348 */     GIR_RootConstrainSelectedInstOperands,
     /* 297349 */     // GIR_Coverage, 4829,
     /* 297349 */     GIR_EraseRootFromParent_Done,
     /* 297350 */   // Label 6069: @297350
     /* 297350 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(297450), // Rule ID 4865 //
     /* 297355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297379 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297406 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297448 */     GIR_RootConstrainSelectedInstOperands,
     /* 297449 */     // GIR_Coverage, 4865,
     /* 297449 */     GIR_EraseRootFromParent_Done,
     /* 297450 */   // Label 6070: @297450
     /* 297450 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(297547), // Rule ID 13795 //
     /* 297455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297491 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297505 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297517 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297545 */     GIR_RootConstrainSelectedInstOperands,
     /* 297546 */     // GIR_Coverage, 13795,
     /* 297546 */     GIR_EraseRootFromParent_Done,
     /* 297547 */   // Label 6071: @297547
     /* 297547 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(297647), // Rule ID 13797 //
     /* 297552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297603 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297615 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297645 */     GIR_RootConstrainSelectedInstOperands,
     /* 297646 */     // GIR_Coverage, 13797,
     /* 297646 */     GIR_EraseRootFromParent_Done,
     /* 297647 */   // Label 6072: @297647
     /* 297647 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(297747), // Rule ID 4863 //
     /* 297652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297703 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297715 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297745 */     GIR_RootConstrainSelectedInstOperands,
     /* 297746 */     // GIR_Coverage, 4863,
     /* 297746 */     GIR_EraseRootFromParent_Done,
     /* 297747 */   // Label 6073: @297747
     /* 297747 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(297844), // Rule ID 4827 //
     /* 297752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297802 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297814 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297842 */     GIR_RootConstrainSelectedInstOperands,
     /* 297843 */     // GIR_Coverage, 4827,
     /* 297843 */     GIR_EraseRootFromParent_Done,
     /* 297844 */   // Label 6074: @297844
     /* 297844 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(297922), // Rule ID 6190 //
     /* 297849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297890 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297894 */     // MIs[3] Operand 1
     /* 297894 */     // No operand predicates
     /* 297894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297904 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297920 */     GIR_RootConstrainSelectedInstOperands,
     /* 297921 */     // GIR_Coverage, 6190,
     /* 297921 */     GIR_EraseRootFromParent_Done,
     /* 297922 */   // Label 6075: @297922
     /* 297922 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(298006), // Rule ID 6102 //
     /* 297927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297963 */     // MIs[2] Operand 1
     /* 297963 */     // No operand predicates
     /* 297963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 297975 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297986 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 297997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298004 */     GIR_RootConstrainSelectedInstOperands,
     /* 298005 */     // GIR_Coverage, 6102,
     /* 298005 */     GIR_EraseRootFromParent_Done,
     /* 298006 */   // Label 6076: @298006
     /* 298006 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(298087), // Rule ID 6134 //
     /* 298011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298055 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298059 */     // MIs[3] Operand 1
     /* 298059 */     // No operand predicates
     /* 298059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298069 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298085 */     GIR_RootConstrainSelectedInstOperands,
     /* 298086 */     // GIR_Coverage, 6134,
     /* 298086 */     GIR_EraseRootFromParent_Done,
     /* 298087 */   // Label 6077: @298087
     /* 298087 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298171), // Rule ID 6166 //
     /* 298092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298145 */     // MIs[3] Operand 1
     /* 298145 */     // No operand predicates
     /* 298145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298151 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298169 */     GIR_RootConstrainSelectedInstOperands,
     /* 298170 */     // GIR_Coverage, 6166,
     /* 298170 */     GIR_EraseRootFromParent_Done,
     /* 298171 */   // Label 6078: @298171
     /* 298171 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(298249), // Rule ID 6212 //
     /* 298176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298225 */     // MIs[3] Operand 1
     /* 298225 */     // No operand predicates
     /* 298225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298231 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298247 */     GIR_RootConstrainSelectedInstOperands,
     /* 298248 */     // GIR_Coverage, 6212,
     /* 298248 */     GIR_EraseRootFromParent_Done,
     /* 298249 */   // Label 6079: @298249
     /* 298249 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(298330), // Rule ID 6070 //
     /* 298254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298302 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298306 */     // MIs[3] Operand 1
     /* 298306 */     // No operand predicates
     /* 298306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298312 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298328 */     GIR_RootConstrainSelectedInstOperands,
     /* 298329 */     // GIR_Coverage, 6070,
     /* 298329 */     GIR_EraseRootFromParent_Done,
     /* 298330 */   // Label 6080: @298330
     /* 298330 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(298415), // Rule ID 2466 //
     /* 298335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298359 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298373 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298413 */     GIR_RootConstrainSelectedInstOperands,
     /* 298414 */     // GIR_Coverage, 2466,
     /* 298414 */     GIR_EraseRootFromParent_Done,
     /* 298415 */   // Label 6081: @298415
     /* 298415 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(298500), // Rule ID 2464 //
     /* 298420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298458 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298470 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298498 */     GIR_RootConstrainSelectedInstOperands,
     /* 298499 */     // GIR_Coverage, 2464,
     /* 298499 */     GIR_EraseRootFromParent_Done,
     /* 298500 */   // Label 6082: @298500
     /* 298500 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(298569), // Rule ID 2556 //
     /* 298505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298541 */     // MIs[2] Operand 1
     /* 298541 */     // No operand predicates
     /* 298541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298551 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298567 */     GIR_RootConstrainSelectedInstOperands,
     /* 298568 */     // GIR_Coverage, 2556,
     /* 298568 */     GIR_EraseRootFromParent_Done,
     /* 298569 */   // Label 6083: @298569
     /* 298569 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(298638), // Rule ID 6038 //
     /* 298574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298614 */     // MIs[2] Operand 1
     /* 298614 */     // No operand predicates
     /* 298614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298620 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298636 */     GIR_RootConstrainSelectedInstOperands,
     /* 298637 */     // GIR_Coverage, 6038,
     /* 298637 */     GIR_EraseRootFromParent_Done,
     /* 298638 */   // Label 6084: @298638
     /* 298638 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(298700), // Rule ID 4873 //
     /* 298643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298683 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298698 */     GIR_RootConstrainSelectedInstOperands,
     /* 298699 */     // GIR_Coverage, 4873,
     /* 298699 */     GIR_EraseRootFromParent_Done,
     /* 298700 */   // Label 6085: @298700
     /* 298700 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(298762), // Rule ID 13805 //
     /* 298705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298745 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298760 */     GIR_RootConstrainSelectedInstOperands,
     /* 298761 */     // GIR_Coverage, 13805,
     /* 298761 */     GIR_EraseRootFromParent_Done,
     /* 298762 */   // Label 6086: @298762
     /* 298762 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(298809), // Rule ID 4870 //
     /* 298767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298794 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298807 */     GIR_RootConstrainSelectedInstOperands,
     /* 298808 */     // GIR_Coverage, 4870,
     /* 298808 */     GIR_EraseRootFromParent_Done,
     /* 298809 */   // Label 6087: @298809
     /* 298809 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(298859), // Rule ID 13233 //
     /* 298814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298844 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298857 */     GIR_RootConstrainSelectedInstOperands,
     /* 298858 */     // GIR_Coverage, 13233,
     /* 298858 */     GIR_EraseRootFromParent_Done,
     /* 298859 */   // Label 6088: @298859
     /* 298859 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(298909), // Rule ID 648 //
     /* 298864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298894 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298907 */     GIR_RootConstrainSelectedInstOperands,
     /* 298908 */     // GIR_Coverage, 648,
     /* 298908 */     GIR_EraseRootFromParent_Done,
     /* 298909 */   // Label 6089: @298909
     /* 298909 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(298956), // Rule ID 13802 //
     /* 298914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298941 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298954 */     GIR_RootConstrainSelectedInstOperands,
     /* 298955 */     // GIR_Coverage, 13802,
     /* 298955 */     GIR_EraseRootFromParent_Done,
     /* 298956 */   // Label 6090: @298956
     /* 298956 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(299006), // Rule ID 660 //
     /* 298961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298991 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 299004 */     GIR_RootConstrainSelectedInstOperands,
     /* 299005 */     // GIR_Coverage, 660,
     /* 299005 */     GIR_EraseRootFromParent_Done,
     /* 299006 */   // Label 6091: @299006
     /* 299006 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(299037), // Rule ID 642 //
     /* 299011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299026 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299031 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299035 */     GIR_RootConstrainSelectedInstOperands,
     /* 299036 */     // GIR_Coverage, 642,
     /* 299036 */     GIR_Done,
     /* 299037 */   // Label 6092: @299037
     /* 299037 */   GIM_Reject,
     /* 299038 */ // Label 6058: @299038
     /* 299038 */ GIM_Reject,
     /* 299039 */ // Label 5984: @299039
     /* 299039 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(300559),
     /* 299044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299057 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(299135), // Rule ID 6170 //
     /* 299062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299103 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299107 */     // MIs[3] Operand 1
     /* 299107 */     // No operand predicates
     /* 299107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299117 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299133 */     GIR_RootConstrainSelectedInstOperands,
     /* 299134 */     // GIR_Coverage, 6170,
     /* 299134 */     GIR_EraseRootFromParent_Done,
     /* 299135 */   // Label 6094: @299135
     /* 299135 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(299219), // Rule ID 6086 //
     /* 299140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299176 */     // MIs[2] Operand 1
     /* 299176 */     // No operand predicates
     /* 299176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299188 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299199 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299217 */     GIR_RootConstrainSelectedInstOperands,
     /* 299218 */     // GIR_Coverage, 6086,
     /* 299218 */     GIR_EraseRootFromParent_Done,
     /* 299219 */   // Label 6095: @299219
     /* 299219 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(299300), // Rule ID 6118 //
     /* 299224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299268 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299272 */     // MIs[3] Operand 1
     /* 299272 */     // No operand predicates
     /* 299272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299282 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299298 */     GIR_RootConstrainSelectedInstOperands,
     /* 299299 */     // GIR_Coverage, 6118,
     /* 299299 */     GIR_EraseRootFromParent_Done,
     /* 299300 */   // Label 6096: @299300
     /* 299300 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(299384), // Rule ID 6150 //
     /* 299305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299358 */     // MIs[3] Operand 1
     /* 299358 */     // No operand predicates
     /* 299358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299364 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299382 */     GIR_RootConstrainSelectedInstOperands,
     /* 299383 */     // GIR_Coverage, 6150,
     /* 299383 */     GIR_EraseRootFromParent_Done,
     /* 299384 */   // Label 6097: @299384
     /* 299384 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(299462), // Rule ID 6192 //
     /* 299389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299434 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299438 */     // MIs[3] Operand 1
     /* 299438 */     // No operand predicates
     /* 299438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299444 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299460 */     GIR_RootConstrainSelectedInstOperands,
     /* 299461 */     // GIR_Coverage, 6192,
     /* 299461 */     GIR_EraseRootFromParent_Done,
     /* 299462 */   // Label 6098: @299462
     /* 299462 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(299543), // Rule ID 6054 //
     /* 299467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299515 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299519 */     // MIs[3] Operand 1
     /* 299519 */     // No operand predicates
     /* 299519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299525 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299541 */     GIR_RootConstrainSelectedInstOperands,
     /* 299542 */     // GIR_Coverage, 6054,
     /* 299542 */     GIR_EraseRootFromParent_Done,
     /* 299543 */   // Label 6099: @299543
     /* 299543 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(299612), // Rule ID 2540 //
     /* 299548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299584 */     // MIs[2] Operand 1
     /* 299584 */     // No operand predicates
     /* 299584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299594 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299610 */     GIR_RootConstrainSelectedInstOperands,
     /* 299611 */     // GIR_Coverage, 2540,
     /* 299611 */     GIR_EraseRootFromParent_Done,
     /* 299612 */   // Label 6100: @299612
     /* 299612 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(299681), // Rule ID 6022 //
     /* 299617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299657 */     // MIs[2] Operand 1
     /* 299657 */     // No operand predicates
     /* 299657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299663 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299679 */     GIR_RootConstrainSelectedInstOperands,
     /* 299680 */     // GIR_Coverage, 6022,
     /* 299680 */     GIR_EraseRootFromParent_Done,
     /* 299681 */   // Label 6101: @299681
     /* 299681 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(299774), // Rule ID 6174 //
     /* 299686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299725 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299772 */     GIR_RootConstrainSelectedInstOperands,
     /* 299773 */     // GIR_Coverage, 6174,
     /* 299773 */     GIR_EraseRootFromParent_Done,
     /* 299774 */   // Label 6102: @299774
     /* 299774 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(299873), // Rule ID 6088 //
     /* 299779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299822 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299834 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 299865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299871 */     GIR_RootConstrainSelectedInstOperands,
     /* 299872 */     // GIR_Coverage, 6088,
     /* 299872 */     GIR_EraseRootFromParent_Done,
     /* 299873 */   // Label 6103: @299873
     /* 299873 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(299969), // Rule ID 6120 //
     /* 299878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 299901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299920 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299967 */     GIR_RootConstrainSelectedInstOperands,
     /* 299968 */     // GIR_Coverage, 6120,
     /* 299968 */     GIR_EraseRootFromParent_Done,
     /* 299969 */   // Label 6104: @299969
     /* 299969 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(300068), // Rule ID 6152 //
     /* 299974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300017 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300066 */     GIR_RootConstrainSelectedInstOperands,
     /* 300067 */     // GIR_Coverage, 6152,
     /* 300067 */     GIR_EraseRootFromParent_Done,
     /* 300068 */   // Label 6105: @300068
     /* 300068 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(300161), // Rule ID 6196 //
     /* 300073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300112 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300159 */     GIR_RootConstrainSelectedInstOperands,
     /* 300160 */     // GIR_Coverage, 6196,
     /* 300160 */     GIR_EraseRootFromParent_Done,
     /* 300161 */   // Label 6106: @300161
     /* 300161 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(300257), // Rule ID 6056 //
     /* 300166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300208 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300227 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300255 */     GIR_RootConstrainSelectedInstOperands,
     /* 300256 */     // GIR_Coverage, 6056,
     /* 300256 */     GIR_EraseRootFromParent_Done,
     /* 300257 */   // Label 6107: @300257
     /* 300257 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(300341), // Rule ID 2542 //
     /* 300262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300292 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300339 */     GIR_RootConstrainSelectedInstOperands,
     /* 300340 */     // GIR_Coverage, 2542,
     /* 300340 */     GIR_EraseRootFromParent_Done,
     /* 300341 */   // Label 6108: @300341
     /* 300341 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(300391), // Rule ID 13263 //
     /* 300346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300376 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300389 */     GIR_RootConstrainSelectedInstOperands,
     /* 300390 */     // GIR_Coverage, 13263,
     /* 300390 */     GIR_EraseRootFromParent_Done,
     /* 300391 */   // Label 6109: @300391
     /* 300391 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(300475), // Rule ID 6024 //
     /* 300396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300426 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300473 */     GIR_RootConstrainSelectedInstOperands,
     /* 300474 */     // GIR_Coverage, 6024,
     /* 300474 */     GIR_EraseRootFromParent_Done,
     /* 300475 */   // Label 6110: @300475
     /* 300475 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(300525), // Rule ID 1308 //
     /* 300480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300510 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300523 */     GIR_RootConstrainSelectedInstOperands,
     /* 300524 */     // GIR_Coverage, 1308,
     /* 300524 */     GIR_EraseRootFromParent_Done,
     /* 300525 */   // Label 6111: @300525
     /* 300525 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(300558), // Rule ID 1298 //
     /* 300530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300545 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 300548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 300556 */     GIR_RootConstrainSelectedInstOperands,
     /* 300557 */     // GIR_Coverage, 1298,
     /* 300557 */     GIR_EraseRootFromParent_Done,
     /* 300558 */   // Label 6112: @300558
     /* 300558 */   GIM_Reject,
     /* 300559 */ // Label 6093: @300559
     /* 300559 */ GIM_Reject,
     /* 300560 */ // Label 5985: @300560
     /* 300560 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(302080),
     /* 300565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 300574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300578 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(300656), // Rule ID 6182 //
     /* 300583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300628 */     // MIs[3] Operand 1
     /* 300628 */     // No operand predicates
     /* 300628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300638 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300654 */     GIR_RootConstrainSelectedInstOperands,
     /* 300655 */     // GIR_Coverage, 6182,
     /* 300655 */     GIR_EraseRootFromParent_Done,
     /* 300656 */   // Label 6114: @300656
     /* 300656 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(300740), // Rule ID 6094 //
     /* 300661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300697 */     // MIs[2] Operand 1
     /* 300697 */     // No operand predicates
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300709 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300720 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300738 */     GIR_RootConstrainSelectedInstOperands,
     /* 300739 */     // GIR_Coverage, 6094,
     /* 300739 */     GIR_EraseRootFromParent_Done,
     /* 300740 */   // Label 6115: @300740
     /* 300740 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(300821), // Rule ID 6126 //
     /* 300745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300789 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300793 */     // MIs[3] Operand 1
     /* 300793 */     // No operand predicates
     /* 300793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300803 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300819 */     GIR_RootConstrainSelectedInstOperands,
     /* 300820 */     // GIR_Coverage, 6126,
     /* 300820 */     GIR_EraseRootFromParent_Done,
     /* 300821 */   // Label 6116: @300821
     /* 300821 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(300905), // Rule ID 6158 //
     /* 300826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300875 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300879 */     // MIs[3] Operand 1
     /* 300879 */     // No operand predicates
     /* 300879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300885 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300903 */     GIR_RootConstrainSelectedInstOperands,
     /* 300904 */     // GIR_Coverage, 6158,
     /* 300904 */     GIR_EraseRootFromParent_Done,
     /* 300905 */   // Label 6117: @300905
     /* 300905 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(300983), // Rule ID 6204 //
     /* 300910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300955 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300959 */     // MIs[3] Operand 1
     /* 300959 */     // No operand predicates
     /* 300959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300965 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300981 */     GIR_RootConstrainSelectedInstOperands,
     /* 300982 */     // GIR_Coverage, 6204,
     /* 300982 */     GIR_EraseRootFromParent_Done,
     /* 300983 */   // Label 6118: @300983
     /* 300983 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(301064), // Rule ID 6062 //
     /* 300988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301040 */     // MIs[3] Operand 1
     /* 301040 */     // No operand predicates
     /* 301040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301046 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301062 */     GIR_RootConstrainSelectedInstOperands,
     /* 301063 */     // GIR_Coverage, 6062,
     /* 301063 */     GIR_EraseRootFromParent_Done,
     /* 301064 */   // Label 6119: @301064
     /* 301064 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(301133), // Rule ID 2548 //
     /* 301069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301105 */     // MIs[2] Operand 1
     /* 301105 */     // No operand predicates
     /* 301105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301115 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301131 */     GIR_RootConstrainSelectedInstOperands,
     /* 301132 */     // GIR_Coverage, 2548,
     /* 301132 */     GIR_EraseRootFromParent_Done,
     /* 301133 */   // Label 6120: @301133
     /* 301133 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(301202), // Rule ID 6030 //
     /* 301138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301178 */     // MIs[2] Operand 1
     /* 301178 */     // No operand predicates
     /* 301178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301184 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301200 */     GIR_RootConstrainSelectedInstOperands,
     /* 301201 */     // GIR_Coverage, 6030,
     /* 301201 */     GIR_EraseRootFromParent_Done,
     /* 301202 */   // Label 6121: @301202
     /* 301202 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(301295), // Rule ID 6184 //
     /* 301207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301246 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301293 */     GIR_RootConstrainSelectedInstOperands,
     /* 301294 */     // GIR_Coverage, 6184,
     /* 301294 */     GIR_EraseRootFromParent_Done,
     /* 301295 */   // Label 6122: @301295
     /* 301295 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(301394), // Rule ID 6096 //
     /* 301300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301343 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301392 */     GIR_RootConstrainSelectedInstOperands,
     /* 301393 */     // GIR_Coverage, 6096,
     /* 301393 */     GIR_EraseRootFromParent_Done,
     /* 301394 */   // Label 6123: @301394
     /* 301394 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(301490), // Rule ID 6128 //
     /* 301399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301441 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301488 */     GIR_RootConstrainSelectedInstOperands,
     /* 301489 */     // GIR_Coverage, 6128,
     /* 301489 */     GIR_EraseRootFromParent_Done,
     /* 301490 */   // Label 6124: @301490
     /* 301490 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(301589), // Rule ID 6160 //
     /* 301495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301538 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301557 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301587 */     GIR_RootConstrainSelectedInstOperands,
     /* 301588 */     // GIR_Coverage, 6160,
     /* 301588 */     GIR_EraseRootFromParent_Done,
     /* 301589 */   // Label 6125: @301589
     /* 301589 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(301682), // Rule ID 6206 //
     /* 301594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301633 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301680 */     GIR_RootConstrainSelectedInstOperands,
     /* 301681 */     // GIR_Coverage, 6206,
     /* 301681 */     GIR_EraseRootFromParent_Done,
     /* 301682 */   // Label 6126: @301682
     /* 301682 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(301778), // Rule ID 6064 //
     /* 301687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301729 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301776 */     GIR_RootConstrainSelectedInstOperands,
     /* 301777 */     // GIR_Coverage, 6064,
     /* 301777 */     GIR_EraseRootFromParent_Done,
     /* 301778 */   // Label 6127: @301778
     /* 301778 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(301862), // Rule ID 2550 //
     /* 301783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301813 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301860 */     GIR_RootConstrainSelectedInstOperands,
     /* 301861 */     // GIR_Coverage, 2550,
     /* 301861 */     GIR_EraseRootFromParent_Done,
     /* 301862 */   // Label 6128: @301862
     /* 301862 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(301912), // Rule ID 13267 //
     /* 301867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301897 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 301897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 301900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301910 */     GIR_RootConstrainSelectedInstOperands,
     /* 301911 */     // GIR_Coverage, 13267,
     /* 301911 */     GIR_EraseRootFromParent_Done,
     /* 301912 */   // Label 6129: @301912
     /* 301912 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(301996), // Rule ID 6032 //
     /* 301917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301947 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301994 */     GIR_RootConstrainSelectedInstOperands,
     /* 301995 */     // GIR_Coverage, 6032,
     /* 301995 */     GIR_EraseRootFromParent_Done,
     /* 301996 */   // Label 6130: @301996
     /* 301996 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302046), // Rule ID 1312 //
     /* 302001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302031 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302044 */     GIR_RootConstrainSelectedInstOperands,
     /* 302045 */     // GIR_Coverage, 1312,
     /* 302045 */     GIR_EraseRootFromParent_Done,
     /* 302046 */   // Label 6131: @302046
     /* 302046 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(302079), // Rule ID 1302 //
     /* 302051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302066 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 302069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 302077 */     GIR_RootConstrainSelectedInstOperands,
     /* 302078 */     // GIR_Coverage, 1302,
     /* 302078 */     GIR_EraseRootFromParent_Done,
     /* 302079 */   // Label 6132: @302079
     /* 302079 */   GIM_Reject,
     /* 302080 */ // Label 6113: @302080
     /* 302080 */ GIM_Reject,
     /* 302081 */ // Label 5986: @302081
     /* 302081 */ GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(303259),
     /* 302086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302092 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302099 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(302183), // Rule ID 6078 //
     /* 302104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302136 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302140 */     // MIs[2] Operand 1
     /* 302140 */     // No operand predicates
     /* 302140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 302144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302152 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302163 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 302174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302181 */     GIR_RootConstrainSelectedInstOperands,
     /* 302182 */     // GIR_Coverage, 6078,
     /* 302182 */     GIR_EraseRootFromParent_Done,
     /* 302183 */   // Label 6134: @302183
     /* 302183 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(302264), // Rule ID 6110 //
     /* 302188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302232 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302236 */     // MIs[3] Operand 1
     /* 302236 */     // No operand predicates
     /* 302236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302246 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302262 */     GIR_RootConstrainSelectedInstOperands,
     /* 302263 */     // GIR_Coverage, 6110,
     /* 302263 */     GIR_EraseRootFromParent_Done,
     /* 302264 */   // Label 6135: @302264
     /* 302264 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(302348), // Rule ID 6142 //
     /* 302269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302322 */     // MIs[3] Operand 1
     /* 302322 */     // No operand predicates
     /* 302322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302328 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302346 */     GIR_RootConstrainSelectedInstOperands,
     /* 302347 */     // GIR_Coverage, 6142,
     /* 302347 */     GIR_EraseRootFromParent_Done,
     /* 302348 */   // Label 6136: @302348
     /* 302348 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(302429), // Rule ID 6046 //
     /* 302353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302405 */     // MIs[3] Operand 1
     /* 302405 */     // No operand predicates
     /* 302405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302411 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302427 */     GIR_RootConstrainSelectedInstOperands,
     /* 302428 */     // GIR_Coverage, 6046,
     /* 302428 */     GIR_EraseRootFromParent_Done,
     /* 302429 */   // Label 6137: @302429
     /* 302429 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(302498), // Rule ID 2532 //
     /* 302434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302470 */     // MIs[2] Operand 1
     /* 302470 */     // No operand predicates
     /* 302470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302480 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302496 */     GIR_RootConstrainSelectedInstOperands,
     /* 302497 */     // GIR_Coverage, 2532,
     /* 302497 */     GIR_EraseRootFromParent_Done,
     /* 302498 */   // Label 6138: @302498
     /* 302498 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(302567), // Rule ID 6014 //
     /* 302503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302543 */     // MIs[2] Operand 1
     /* 302543 */     // No operand predicates
     /* 302543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302549 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302565 */     GIR_RootConstrainSelectedInstOperands,
     /* 302566 */     // GIR_Coverage, 6014,
     /* 302566 */     GIR_EraseRootFromParent_Done,
     /* 302567 */   // Label 6139: @302567
     /* 302567 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(302666), // Rule ID 6080 //
     /* 302572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302615 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302664 */     GIR_RootConstrainSelectedInstOperands,
     /* 302665 */     // GIR_Coverage, 6080,
     /* 302665 */     GIR_EraseRootFromParent_Done,
     /* 302666 */   // Label 6140: @302666
     /* 302666 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(302762), // Rule ID 6112 //
     /* 302671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302713 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302760 */     GIR_RootConstrainSelectedInstOperands,
     /* 302761 */     // GIR_Coverage, 6112,
     /* 302761 */     GIR_EraseRootFromParent_Done,
     /* 302762 */   // Label 6141: @302762
     /* 302762 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(302861), // Rule ID 6144 //
     /* 302767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302810 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302859 */     GIR_RootConstrainSelectedInstOperands,
     /* 302860 */     // GIR_Coverage, 6144,
     /* 302860 */     GIR_EraseRootFromParent_Done,
     /* 302861 */   // Label 6142: @302861
     /* 302861 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(302957), // Rule ID 6048 //
     /* 302866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302908 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302955 */     GIR_RootConstrainSelectedInstOperands,
     /* 302956 */     // GIR_Coverage, 6048,
     /* 302956 */     GIR_EraseRootFromParent_Done,
     /* 302957 */   // Label 6143: @302957
     /* 302957 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(303041), // Rule ID 2534 //
     /* 302962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302992 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303011 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303039 */     GIR_RootConstrainSelectedInstOperands,
     /* 303040 */     // GIR_Coverage, 2534,
     /* 303040 */     GIR_EraseRootFromParent_Done,
     /* 303041 */   // Label 6144: @303041
     /* 303041 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(303091), // Rule ID 13259 //
     /* 303046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303076 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303089 */     GIR_RootConstrainSelectedInstOperands,
     /* 303090 */     // GIR_Coverage, 13259,
     /* 303090 */     GIR_EraseRootFromParent_Done,
     /* 303091 */   // Label 6145: @303091
     /* 303091 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(303175), // Rule ID 6016 //
     /* 303096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303126 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303145 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303173 */     GIR_RootConstrainSelectedInstOperands,
     /* 303174 */     // GIR_Coverage, 6016,
     /* 303174 */     GIR_EraseRootFromParent_Done,
     /* 303175 */   // Label 6146: @303175
     /* 303175 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303225), // Rule ID 1304 //
     /* 303180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303210 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303223 */     GIR_RootConstrainSelectedInstOperands,
     /* 303224 */     // GIR_Coverage, 1304,
     /* 303224 */     GIR_EraseRootFromParent_Done,
     /* 303225 */   // Label 6147: @303225
     /* 303225 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303258), // Rule ID 1294 //
     /* 303230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303245 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 303248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303256 */     GIR_RootConstrainSelectedInstOperands,
     /* 303257 */     // GIR_Coverage, 1294,
     /* 303257 */     GIR_EraseRootFromParent_Done,
     /* 303258 */   // Label 6148: @303258
     /* 303258 */   GIM_Reject,
     /* 303259 */ // Label 6133: @303259
     /* 303259 */ GIM_Reject,
     /* 303260 */ // Label 5987: @303260
     /* 303260 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(304780),
     /* 303265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 303274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303278 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303356), // Rule ID 6176 //
     /* 303283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303328 */     // MIs[3] Operand 1
     /* 303328 */     // No operand predicates
     /* 303328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303338 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303354 */     GIR_RootConstrainSelectedInstOperands,
     /* 303355 */     // GIR_Coverage, 6176,
     /* 303355 */     GIR_EraseRootFromParent_Done,
     /* 303356 */   // Label 6150: @303356
     /* 303356 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(303440), // Rule ID 6090 //
     /* 303361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303397 */     // MIs[2] Operand 1
     /* 303397 */     // No operand predicates
     /* 303397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303420 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303438 */     GIR_RootConstrainSelectedInstOperands,
     /* 303439 */     // GIR_Coverage, 6090,
     /* 303439 */     GIR_EraseRootFromParent_Done,
     /* 303440 */   // Label 6151: @303440
     /* 303440 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(303521), // Rule ID 6122 //
     /* 303445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303493 */     // MIs[3] Operand 1
     /* 303493 */     // No operand predicates
     /* 303493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303503 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303519 */     GIR_RootConstrainSelectedInstOperands,
     /* 303520 */     // GIR_Coverage, 6122,
     /* 303520 */     GIR_EraseRootFromParent_Done,
     /* 303521 */   // Label 6152: @303521
     /* 303521 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(303605), // Rule ID 6154 //
     /* 303526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303579 */     // MIs[3] Operand 1
     /* 303579 */     // No operand predicates
     /* 303579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303585 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303603 */     GIR_RootConstrainSelectedInstOperands,
     /* 303604 */     // GIR_Coverage, 6154,
     /* 303604 */     GIR_EraseRootFromParent_Done,
     /* 303605 */   // Label 6153: @303605
     /* 303605 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(303683), // Rule ID 6198 //
     /* 303610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303659 */     // MIs[3] Operand 1
     /* 303659 */     // No operand predicates
     /* 303659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303665 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303681 */     GIR_RootConstrainSelectedInstOperands,
     /* 303682 */     // GIR_Coverage, 6198,
     /* 303682 */     GIR_EraseRootFromParent_Done,
     /* 303683 */   // Label 6154: @303683
     /* 303683 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(303764), // Rule ID 6058 //
     /* 303688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303736 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303740 */     // MIs[3] Operand 1
     /* 303740 */     // No operand predicates
     /* 303740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303746 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303762 */     GIR_RootConstrainSelectedInstOperands,
     /* 303763 */     // GIR_Coverage, 6058,
     /* 303763 */     GIR_EraseRootFromParent_Done,
     /* 303764 */   // Label 6155: @303764
     /* 303764 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(303833), // Rule ID 2544 //
     /* 303769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303805 */     // MIs[2] Operand 1
     /* 303805 */     // No operand predicates
     /* 303805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303815 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 303818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303831 */     GIR_RootConstrainSelectedInstOperands,
     /* 303832 */     // GIR_Coverage, 2544,
     /* 303832 */     GIR_EraseRootFromParent_Done,
     /* 303833 */   // Label 6156: @303833
     /* 303833 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(303902), // Rule ID 6026 //
     /* 303838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303878 */     // MIs[2] Operand 1
     /* 303878 */     // No operand predicates
     /* 303878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303884 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 303887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303900 */     GIR_RootConstrainSelectedInstOperands,
     /* 303901 */     // GIR_Coverage, 6026,
     /* 303901 */     GIR_EraseRootFromParent_Done,
     /* 303902 */   // Label 6157: @303902
     /* 303902 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(303995), // Rule ID 6180 //
     /* 303907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 303931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303946 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303993 */     GIR_RootConstrainSelectedInstOperands,
     /* 303994 */     // GIR_Coverage, 6180,
     /* 303994 */     GIR_EraseRootFromParent_Done,
     /* 303995 */   // Label 6158: @303995
     /* 303995 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(304094), // Rule ID 6092 //
     /* 304000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304043 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304092 */     GIR_RootConstrainSelectedInstOperands,
     /* 304093 */     // GIR_Coverage, 6092,
     /* 304093 */     GIR_EraseRootFromParent_Done,
     /* 304094 */   // Label 6159: @304094
     /* 304094 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(304190), // Rule ID 6124 //
     /* 304099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304141 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304188 */     GIR_RootConstrainSelectedInstOperands,
     /* 304189 */     // GIR_Coverage, 6124,
     /* 304189 */     GIR_EraseRootFromParent_Done,
     /* 304190 */   // Label 6160: @304190
     /* 304190 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(304289), // Rule ID 6156 //
     /* 304195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304238 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304287 */     GIR_RootConstrainSelectedInstOperands,
     /* 304288 */     // GIR_Coverage, 6156,
     /* 304288 */     GIR_EraseRootFromParent_Done,
     /* 304289 */   // Label 6161: @304289
     /* 304289 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(304382), // Rule ID 6202 //
     /* 304294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304333 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304380 */     GIR_RootConstrainSelectedInstOperands,
     /* 304381 */     // GIR_Coverage, 6202,
     /* 304381 */     GIR_EraseRootFromParent_Done,
     /* 304382 */   // Label 6162: @304382
     /* 304382 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(304478), // Rule ID 6060 //
     /* 304387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304429 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304476 */     GIR_RootConstrainSelectedInstOperands,
     /* 304477 */     // GIR_Coverage, 6060,
     /* 304477 */     GIR_EraseRootFromParent_Done,
     /* 304478 */   // Label 6163: @304478
     /* 304478 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(304562), // Rule ID 2546 //
     /* 304483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304513 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304560 */     GIR_RootConstrainSelectedInstOperands,
     /* 304561 */     // GIR_Coverage, 2546,
     /* 304561 */     GIR_EraseRootFromParent_Done,
     /* 304562 */   // Label 6164: @304562
     /* 304562 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(304612), // Rule ID 13265 //
     /* 304567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304597 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304610 */     GIR_RootConstrainSelectedInstOperands,
     /* 304611 */     // GIR_Coverage, 13265,
     /* 304611 */     GIR_EraseRootFromParent_Done,
     /* 304612 */   // Label 6165: @304612
     /* 304612 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(304696), // Rule ID 6028 //
     /* 304617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304647 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304694 */     GIR_RootConstrainSelectedInstOperands,
     /* 304695 */     // GIR_Coverage, 6028,
     /* 304695 */     GIR_EraseRootFromParent_Done,
     /* 304696 */   // Label 6166: @304696
     /* 304696 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(304746), // Rule ID 1310 //
     /* 304701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304731 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304744 */     GIR_RootConstrainSelectedInstOperands,
     /* 304745 */     // GIR_Coverage, 1310,
     /* 304745 */     GIR_EraseRootFromParent_Done,
     /* 304746 */   // Label 6167: @304746
     /* 304746 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(304779), // Rule ID 1300 //
     /* 304751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304766 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 304769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304777 */     GIR_RootConstrainSelectedInstOperands,
     /* 304778 */     // GIR_Coverage, 1300,
     /* 304778 */     GIR_EraseRootFromParent_Done,
     /* 304779 */   // Label 6168: @304779
     /* 304779 */   GIM_Reject,
     /* 304780 */ // Label 6149: @304780
     /* 304780 */ GIM_Reject,
     /* 304781 */ // Label 5988: @304781
     /* 304781 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(305959),
     /* 304786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 304795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304799 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(304883), // Rule ID 6074 //
     /* 304804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304840 */     // MIs[2] Operand 1
     /* 304840 */     // No operand predicates
     /* 304840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304852 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304863 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 304866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 304874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304881 */     GIR_RootConstrainSelectedInstOperands,
     /* 304882 */     // GIR_Coverage, 6074,
     /* 304882 */     GIR_EraseRootFromParent_Done,
     /* 304883 */   // Label 6170: @304883
     /* 304883 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(304964), // Rule ID 6106 //
     /* 304888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304932 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304936 */     // MIs[3] Operand 1
     /* 304936 */     // No operand predicates
     /* 304936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304946 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 304949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304962 */     GIR_RootConstrainSelectedInstOperands,
     /* 304963 */     // GIR_Coverage, 6106,
     /* 304963 */     GIR_EraseRootFromParent_Done,
     /* 304964 */   // Label 6171: @304964
     /* 304964 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(305048), // Rule ID 6138 //
     /* 304969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305018 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305022 */     // MIs[3] Operand 1
     /* 305022 */     // No operand predicates
     /* 305022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305028 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305046 */     GIR_RootConstrainSelectedInstOperands,
     /* 305047 */     // GIR_Coverage, 6138,
     /* 305047 */     GIR_EraseRootFromParent_Done,
     /* 305048 */   // Label 6172: @305048
     /* 305048 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(305129), // Rule ID 6042 //
     /* 305053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305105 */     // MIs[3] Operand 1
     /* 305105 */     // No operand predicates
     /* 305105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305111 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305127 */     GIR_RootConstrainSelectedInstOperands,
     /* 305128 */     // GIR_Coverage, 6042,
     /* 305128 */     GIR_EraseRootFromParent_Done,
     /* 305129 */   // Label 6173: @305129
     /* 305129 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(305198), // Rule ID 2528 //
     /* 305134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305170 */     // MIs[2] Operand 1
     /* 305170 */     // No operand predicates
     /* 305170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305180 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305196 */     GIR_RootConstrainSelectedInstOperands,
     /* 305197 */     // GIR_Coverage, 2528,
     /* 305197 */     GIR_EraseRootFromParent_Done,
     /* 305198 */   // Label 6174: @305198
     /* 305198 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(305267), // Rule ID 6010 //
     /* 305203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305239 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305243 */     // MIs[2] Operand 1
     /* 305243 */     // No operand predicates
     /* 305243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305249 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305265 */     GIR_RootConstrainSelectedInstOperands,
     /* 305266 */     // GIR_Coverage, 6010,
     /* 305266 */     GIR_EraseRootFromParent_Done,
     /* 305267 */   // Label 6175: @305267
     /* 305267 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(305366), // Rule ID 6076 //
     /* 305272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305315 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305364 */     GIR_RootConstrainSelectedInstOperands,
     /* 305365 */     // GIR_Coverage, 6076,
     /* 305365 */     GIR_EraseRootFromParent_Done,
     /* 305366 */   // Label 6176: @305366
     /* 305366 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(305462), // Rule ID 6108 //
     /* 305371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305413 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305460 */     GIR_RootConstrainSelectedInstOperands,
     /* 305461 */     // GIR_Coverage, 6108,
     /* 305461 */     GIR_EraseRootFromParent_Done,
     /* 305462 */   // Label 6177: @305462
     /* 305462 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(305561), // Rule ID 6140 //
     /* 305467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305510 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305559 */     GIR_RootConstrainSelectedInstOperands,
     /* 305560 */     // GIR_Coverage, 6140,
     /* 305560 */     GIR_EraseRootFromParent_Done,
     /* 305561 */   // Label 6178: @305561
     /* 305561 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(305657), // Rule ID 6044 //
     /* 305566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305608 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305620 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305655 */     GIR_RootConstrainSelectedInstOperands,
     /* 305656 */     // GIR_Coverage, 6044,
     /* 305656 */     GIR_EraseRootFromParent_Done,
     /* 305657 */   // Label 6179: @305657
     /* 305657 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(305741), // Rule ID 2530 //
     /* 305662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305692 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305739 */     GIR_RootConstrainSelectedInstOperands,
     /* 305740 */     // GIR_Coverage, 2530,
     /* 305740 */     GIR_EraseRootFromParent_Done,
     /* 305741 */   // Label 6180: @305741
     /* 305741 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(305791), // Rule ID 13261 //
     /* 305746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305776 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 305779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305789 */     GIR_RootConstrainSelectedInstOperands,
     /* 305790 */     // GIR_Coverage, 13261,
     /* 305790 */     GIR_EraseRootFromParent_Done,
     /* 305791 */   // Label 6181: @305791
     /* 305791 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(305875), // Rule ID 6012 //
     /* 305796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305826 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305873 */     GIR_RootConstrainSelectedInstOperands,
     /* 305874 */     // GIR_Coverage, 6012,
     /* 305874 */     GIR_EraseRootFromParent_Done,
     /* 305875 */   // Label 6182: @305875
     /* 305875 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(305925), // Rule ID 1306 //
     /* 305880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305910 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 305913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305923 */     GIR_RootConstrainSelectedInstOperands,
     /* 305924 */     // GIR_Coverage, 1306,
     /* 305924 */     GIR_EraseRootFromParent_Done,
     /* 305925 */   // Label 6183: @305925
     /* 305925 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(305958), // Rule ID 1296 //
     /* 305930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305945 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 305948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 305956 */     GIR_RootConstrainSelectedInstOperands,
     /* 305957 */     // GIR_Coverage, 1296,
     /* 305957 */     GIR_EraseRootFromParent_Done,
     /* 305958 */   // Label 6184: @305958
     /* 305958 */   GIM_Reject,
     /* 305959 */ // Label 6169: @305959
     /* 305959 */ GIM_Reject,
     /* 305960 */ // Label 5989: @305960
     /* 305960 */ GIM_Reject,
     /* 305961 */ // Label 61: @305961
     /* 305961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6193*/ GIMT_Encode4(306576),
     /* 305972 */ /*GILLT_s16*//*Label 6185*/ GIMT_Encode4(306012),
     /* 305976 */ /*GILLT_s32*//*Label 6186*/ GIMT_Encode4(306050),
     /* 305980 */ /*GILLT_s64*//*Label 6187*/ GIMT_Encode4(306088), GIMT_Encode4(0),
     /* 305988 */ /*GILLT_v2s32*//*Label 6188*/ GIMT_Encode4(306126),
     /* 305992 */ /*GILLT_v2s64*//*Label 6189*/ GIMT_Encode4(306164),
     /* 305996 */ /*GILLT_v4s16*//*Label 6190*/ GIMT_Encode4(306202),
     /* 306000 */ /*GILLT_v4s32*//*Label 6191*/ GIMT_Encode4(306240), GIMT_Encode4(0),
     /* 306008 */ /*GILLT_v8s16*//*Label 6192*/ GIMT_Encode4(306278),
     /* 306012 */ // Label 6185: @306012
     /* 306012 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(306049), // Rule ID 590 //
     /* 306017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306038 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 306043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306047 */   GIR_RootConstrainSelectedInstOperands,
     /* 306048 */   // GIR_Coverage, 590,
     /* 306048 */   GIR_Done,
     /* 306049 */ // Label 6194: @306049
     /* 306049 */ GIM_Reject,
     /* 306050 */ // Label 6186: @306050
     /* 306050 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(306087), // Rule ID 592 //
     /* 306055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306076 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 306081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306085 */   GIR_RootConstrainSelectedInstOperands,
     /* 306086 */   // GIR_Coverage, 592,
     /* 306086 */   GIR_Done,
     /* 306087 */ // Label 6195: @306087
     /* 306087 */ GIM_Reject,
     /* 306088 */ // Label 6187: @306088
     /* 306088 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(306125), // Rule ID 594 //
     /* 306093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306114 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 306119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306123 */   GIR_RootConstrainSelectedInstOperands,
     /* 306124 */   // GIR_Coverage, 594,
     /* 306124 */   GIR_Done,
     /* 306125 */ // Label 6196: @306125
     /* 306125 */ GIM_Reject,
     /* 306126 */ // Label 6188: @306126
     /* 306126 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(306163), // Rule ID 1228 //
     /* 306131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306152 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 306157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306161 */   GIR_RootConstrainSelectedInstOperands,
     /* 306162 */   // GIR_Coverage, 1228,
     /* 306162 */   GIR_Done,
     /* 306163 */ // Label 6197: @306163
     /* 306163 */ GIM_Reject,
     /* 306164 */ // Label 6189: @306164
     /* 306164 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(306201), // Rule ID 1232 //
     /* 306169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306190 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 306195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306199 */   GIR_RootConstrainSelectedInstOperands,
     /* 306200 */   // GIR_Coverage, 1232,
     /* 306200 */   GIR_Done,
     /* 306201 */ // Label 6198: @306201
     /* 306201 */ GIM_Reject,
     /* 306202 */ // Label 6190: @306202
     /* 306202 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(306239), // Rule ID 1224 //
     /* 306207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306228 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 306228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 306233 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306237 */   GIR_RootConstrainSelectedInstOperands,
     /* 306238 */   // GIR_Coverage, 1224,
     /* 306238 */   GIR_Done,
     /* 306239 */ // Label 6199: @306239
     /* 306239 */ GIM_Reject,
     /* 306240 */ // Label 6191: @306240
     /* 306240 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(306277), // Rule ID 1230 //
     /* 306245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306266 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 306266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306271 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306275 */   GIR_RootConstrainSelectedInstOperands,
     /* 306276 */   // GIR_Coverage, 1230,
     /* 306276 */   GIR_Done,
     /* 306277 */ // Label 6200: @306277
     /* 306277 */ GIM_Reject,
     /* 306278 */ // Label 6192: @306278
     /* 306278 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(306575),
     /* 306283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 306289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306301 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(306320), // Rule ID 1226 //
     /* 306306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306309 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 306314 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306318 */     GIR_RootConstrainSelectedInstOperands,
     /* 306319 */     // GIR_Coverage, 1226,
     /* 306319 */     GIR_Done,
     /* 306320 */   // Label 6202: @306320
     /* 306320 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306574), // Rule ID 6975 //
     /* 306325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 306328 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 306328 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 306331 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306335 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306340 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 306344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 306346 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 306349 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306353 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306358 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 306362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 306364 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 306367 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306371 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306376 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 306379 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 306382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 306384 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 306387 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306391 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306396 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306402 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306407 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306412 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 306415 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306419 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306424 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 306427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306429 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 306432 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306436 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306441 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306447 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306452 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306457 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 306460 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306464 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306469 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306474 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 306477 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306481 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306486 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306489 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 306492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306494 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 306497 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 306501 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306506 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 306564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 306572 */     GIR_RootConstrainSelectedInstOperands,
     /* 306573 */     // GIR_Coverage, 6975,
     /* 306573 */     GIR_EraseRootFromParent_Done,
     /* 306574 */   // Label 6203: @306574
     /* 306574 */   GIM_Reject,
     /* 306575 */ // Label 6201: @306575
     /* 306575 */ GIM_Reject,
     /* 306576 */ // Label 6193: @306576
     /* 306576 */ GIM_Reject,
     /* 306577 */ // Label 62: @306577
     /* 306577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6212*/ GIMT_Encode4(310083),
     /* 306588 */ /*GILLT_s16*//*Label 6204*/ GIMT_Encode4(306628),
     /* 306592 */ /*GILLT_s32*//*Label 6205*/ GIMT_Encode4(307796),
     /* 306596 */ /*GILLT_s64*//*Label 6206*/ GIMT_Encode4(308819), GIMT_Encode4(0),
     /* 306604 */ /*GILLT_v2s32*//*Label 6207*/ GIMT_Encode4(309842),
     /* 306608 */ /*GILLT_v2s64*//*Label 6208*/ GIMT_Encode4(309869),
     /* 306612 */ /*GILLT_v4s16*//*Label 6209*/ GIMT_Encode4(309896),
     /* 306616 */ /*GILLT_v4s32*//*Label 6210*/ GIMT_Encode4(309976), GIMT_Encode4(0),
     /* 306624 */ /*GILLT_v8s16*//*Label 6211*/ GIMT_Encode4(310003),
     /* 306628 */ // Label 6204: @306628
     /* 306628 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(307795),
     /* 306633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306640 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(306798), // Rule ID 4837 //
     /* 306645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306701 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306705 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306709 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306714 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306725 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 306725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306737 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306743 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306765 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 306784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 306796 */     GIR_RootConstrainSelectedInstOperands,
     /* 306797 */     // GIR_Coverage, 4837,
     /* 306797 */     GIR_EraseRootFromParent_Done,
     /* 306798 */   // Label 6214: @306798
     /* 306798 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(306956), // Rule ID 4836 //
     /* 306803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 306814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306822 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306847 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306859 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306863 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306872 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306883 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 306883 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306886 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306890 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306895 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 306942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 306954 */     GIR_RootConstrainSelectedInstOperands,
     /* 306955 */     // GIR_Coverage, 4836,
     /* 306955 */     GIR_EraseRootFromParent_Done,
     /* 306956 */   // Label 6215: @306956
     /* 306956 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307067), // Rule ID 4835 //
     /* 306961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306980 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307005 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307021 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307033 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307065 */     GIR_RootConstrainSelectedInstOperands,
     /* 307066 */     // GIR_Coverage, 4835,
     /* 307066 */     GIR_EraseRootFromParent_Done,
     /* 307067 */   // Label 6216: @307067
     /* 307067 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307178), // Rule ID 4833 //
     /* 307072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307121 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307132 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307144 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307176 */     GIR_RootConstrainSelectedInstOperands,
     /* 307177 */     // GIR_Coverage, 4833,
     /* 307177 */     GIR_EraseRootFromParent_Done,
     /* 307178 */   // Label 6217: @307178
     /* 307178 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307289), // Rule ID 4834 //
     /* 307183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307202 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307227 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307243 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307287 */     GIR_RootConstrainSelectedInstOperands,
     /* 307288 */     // GIR_Coverage, 4834,
     /* 307288 */     GIR_EraseRootFromParent_Done,
     /* 307289 */   // Label 6218: @307289
     /* 307289 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307400), // Rule ID 4832 //
     /* 307294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307313 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307354 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307398 */     GIR_RootConstrainSelectedInstOperands,
     /* 307399 */     // GIR_Coverage, 4832,
     /* 307399 */     GIR_EraseRootFromParent_Done,
     /* 307400 */   // Label 6219: @307400
     /* 307400 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307464), // Rule ID 650 //
     /* 307405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307445 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307462 */     GIR_RootConstrainSelectedInstOperands,
     /* 307463 */     // GIR_Coverage, 650,
     /* 307463 */     GIR_EraseRootFromParent_Done,
     /* 307464 */   // Label 6220: @307464
     /* 307464 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307528), // Rule ID 649 //
     /* 307469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307509 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307526 */     GIR_RootConstrainSelectedInstOperands,
     /* 307527 */     // GIR_Coverage, 649,
     /* 307527 */     GIR_EraseRootFromParent_Done,
     /* 307528 */   // Label 6221: @307528
     /* 307528 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307579), // Rule ID 626 //
     /* 307533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 307544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307564 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307577 */     GIR_RootConstrainSelectedInstOperands,
     /* 307578 */     // GIR_Coverage, 626,
     /* 307578 */     GIR_EraseRootFromParent_Done,
     /* 307579 */   // Label 6222: @307579
     /* 307579 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(307630), // Rule ID 625 //
     /* 307584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 307595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307615 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307628 */     GIR_RootConstrainSelectedInstOperands,
     /* 307629 */     // GIR_Coverage, 625,
     /* 307629 */     GIR_EraseRootFromParent_Done,
     /* 307630 */   // Label 6223: @307630
     /* 307630 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(307649), // Rule ID 524 //
     /* 307635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307642 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 307642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 307647 */     GIR_RootConstrainSelectedInstOperands,
     /* 307648 */     // GIR_Coverage, 524,
     /* 307648 */     GIR_Done,
     /* 307649 */   // Label 6224: @307649
     /* 307649 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(307794), // Rule ID 6342 //
     /* 307654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307658 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 307658 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307661 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307665 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 307675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307684 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307687 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307691 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 307694 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307699 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307704 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307709 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 307712 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307716 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307721 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307724 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 307736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307741 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307744 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 307749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307763 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 307783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307793 */     // GIR_Coverage, 6342,
     /* 307793 */     GIR_EraseRootFromParent_Done,
     /* 307794 */   // Label 6225: @307794
     /* 307794 */   GIM_Reject,
     /* 307795 */ // Label 6213: @307795
     /* 307795 */ GIM_Reject,
     /* 307796 */ // Label 6205: @307796
     /* 307796 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(308818),
     /* 307801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307808 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(307966), // Rule ID 4843 //
     /* 307813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 307832 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 307836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307857 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307873 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307877 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307882 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307893 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 307893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307896 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307900 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307905 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 307911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 307939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 307952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307964 */     GIR_RootConstrainSelectedInstOperands,
     /* 307965 */     // GIR_Coverage, 4843,
     /* 307965 */     GIR_EraseRootFromParent_Done,
     /* 307966 */   // Label 6227: @307966
     /* 307966 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(308124), // Rule ID 4842 //
     /* 307971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 307990 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 307994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308015 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308027 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308031 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308040 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308051 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308063 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308074 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308091 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308122 */     GIR_RootConstrainSelectedInstOperands,
     /* 308123 */     // GIR_Coverage, 4842,
     /* 308123 */     GIR_EraseRootFromParent_Done,
     /* 308124 */   // Label 6228: @308124
     /* 308124 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(308235), // Rule ID 4841 //
     /* 308129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308173 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308189 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308233 */     GIR_RootConstrainSelectedInstOperands,
     /* 308234 */     // GIR_Coverage, 4841,
     /* 308234 */     GIR_EraseRootFromParent_Done,
     /* 308235 */   // Label 6229: @308235
     /* 308235 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308346), // Rule ID 4839 //
     /* 308240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308289 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308300 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308312 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308344 */     GIR_RootConstrainSelectedInstOperands,
     /* 308345 */     // GIR_Coverage, 4839,
     /* 308345 */     GIR_EraseRootFromParent_Done,
     /* 308346 */   // Label 6230: @308346
     /* 308346 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308457), // Rule ID 4840 //
     /* 308351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308370 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308395 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308411 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308455 */     GIR_RootConstrainSelectedInstOperands,
     /* 308456 */     // GIR_Coverage, 4840,
     /* 308456 */     GIR_EraseRootFromParent_Done,
     /* 308457 */   // Label 6231: @308457
     /* 308457 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308568), // Rule ID 4838 //
     /* 308462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308522 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308534 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308566 */     GIR_RootConstrainSelectedInstOperands,
     /* 308567 */     // GIR_Coverage, 4838,
     /* 308567 */     GIR_EraseRootFromParent_Done,
     /* 308568 */   // Label 6232: @308568
     /* 308568 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308632), // Rule ID 652 //
     /* 308573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308592 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308613 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308630 */     GIR_RootConstrainSelectedInstOperands,
     /* 308631 */     // GIR_Coverage, 652,
     /* 308631 */     GIR_EraseRootFromParent_Done,
     /* 308632 */   // Label 6233: @308632
     /* 308632 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(308696), // Rule ID 651 //
     /* 308637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308677 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308694 */     GIR_RootConstrainSelectedInstOperands,
     /* 308695 */     // GIR_Coverage, 651,
     /* 308695 */     GIR_EraseRootFromParent_Done,
     /* 308696 */   // Label 6234: @308696
     /* 308696 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(308747), // Rule ID 628 //
     /* 308701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 308712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308732 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308745 */     GIR_RootConstrainSelectedInstOperands,
     /* 308746 */     // GIR_Coverage, 628,
     /* 308746 */     GIR_EraseRootFromParent_Done,
     /* 308747 */   // Label 6235: @308747
     /* 308747 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(308798), // Rule ID 627 //
     /* 308752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 308763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308783 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308796 */     GIR_RootConstrainSelectedInstOperands,
     /* 308797 */     // GIR_Coverage, 627,
     /* 308797 */     GIR_EraseRootFromParent_Done,
     /* 308798 */   // Label 6236: @308798
     /* 308798 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(308817), // Rule ID 525 //
     /* 308803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308810 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 308810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 308815 */     GIR_RootConstrainSelectedInstOperands,
     /* 308816 */     // GIR_Coverage, 525,
     /* 308816 */     GIR_Done,
     /* 308817 */   // Label 6237: @308817
     /* 308817 */   GIM_Reject,
     /* 308818 */ // Label 6226: @308818
     /* 308818 */ GIM_Reject,
     /* 308819 */ // Label 6206: @308819
     /* 308819 */ GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(309841),
     /* 308824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308831 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308989), // Rule ID 4849 //
     /* 308836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308855 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 308859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308880 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308905 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308916 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 308916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308928 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 308934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 308962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 308975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308987 */     GIR_RootConstrainSelectedInstOperands,
     /* 308988 */     // GIR_Coverage, 4849,
     /* 308988 */     GIR_EraseRootFromParent_Done,
     /* 308989 */   // Label 6239: @308989
     /* 308989 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(309147), // Rule ID 4848 //
     /* 308994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309013 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309038 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309063 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309074 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309086 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309114 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309145 */     GIR_RootConstrainSelectedInstOperands,
     /* 309146 */     // GIR_Coverage, 4848,
     /* 309146 */     GIR_EraseRootFromParent_Done,
     /* 309147 */   // Label 6240: @309147
     /* 309147 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(309258), // Rule ID 4847 //
     /* 309152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309196 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309212 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309224 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309256 */     GIR_RootConstrainSelectedInstOperands,
     /* 309257 */     // GIR_Coverage, 4847,
     /* 309257 */     GIR_EraseRootFromParent_Done,
     /* 309258 */   // Label 6241: @309258
     /* 309258 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(309369), // Rule ID 4845 //
     /* 309263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309282 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309312 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309323 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309367 */     GIR_RootConstrainSelectedInstOperands,
     /* 309368 */     // GIR_Coverage, 4845,
     /* 309368 */     GIR_EraseRootFromParent_Done,
     /* 309369 */   // Label 6242: @309369
     /* 309369 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(309480), // Rule ID 4846 //
     /* 309374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309418 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309434 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309446 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309478 */     GIR_RootConstrainSelectedInstOperands,
     /* 309479 */     // GIR_Coverage, 4846,
     /* 309479 */     GIR_EraseRootFromParent_Done,
     /* 309480 */   // Label 6243: @309480
     /* 309480 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(309591), // Rule ID 4844 //
     /* 309485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309504 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309545 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309589 */     GIR_RootConstrainSelectedInstOperands,
     /* 309590 */     // GIR_Coverage, 4844,
     /* 309590 */     GIR_EraseRootFromParent_Done,
     /* 309591 */   // Label 6244: @309591
     /* 309591 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(309655), // Rule ID 654 //
     /* 309596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309636 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309653 */     GIR_RootConstrainSelectedInstOperands,
     /* 309654 */     // GIR_Coverage, 654,
     /* 309654 */     GIR_EraseRootFromParent_Done,
     /* 309655 */   // Label 6245: @309655
     /* 309655 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(309719), // Rule ID 653 //
     /* 309660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309679 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309700 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309717 */     GIR_RootConstrainSelectedInstOperands,
     /* 309718 */     // GIR_Coverage, 653,
     /* 309718 */     GIR_EraseRootFromParent_Done,
     /* 309719 */   // Label 6246: @309719
     /* 309719 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(309770), // Rule ID 630 //
     /* 309724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 309735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309755 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 309755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 309758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309768 */     GIR_RootConstrainSelectedInstOperands,
     /* 309769 */     // GIR_Coverage, 630,
     /* 309769 */     GIR_EraseRootFromParent_Done,
     /* 309770 */   // Label 6247: @309770
     /* 309770 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(309821), // Rule ID 629 //
     /* 309775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 309786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309806 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 309806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 309809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309819 */     GIR_RootConstrainSelectedInstOperands,
     /* 309820 */     // GIR_Coverage, 629,
     /* 309820 */     GIR_EraseRootFromParent_Done,
     /* 309821 */   // Label 6248: @309821
     /* 309821 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(309840), // Rule ID 526 //
     /* 309826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309833 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 309833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 309838 */     GIR_RootConstrainSelectedInstOperands,
     /* 309839 */     // GIR_Coverage, 526,
     /* 309839 */     GIR_Done,
     /* 309840 */   // Label 6249: @309840
     /* 309840 */   GIM_Reject,
     /* 309841 */ // Label 6238: @309841
     /* 309841 */ GIM_Reject,
     /* 309842 */ // Label 6207: @309842
     /* 309842 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(309868), // Rule ID 860 //
     /* 309847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309861 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 309861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 309866 */   GIR_RootConstrainSelectedInstOperands,
     /* 309867 */   // GIR_Coverage, 860,
     /* 309867 */   GIR_Done,
     /* 309868 */ // Label 6250: @309868
     /* 309868 */ GIM_Reject,
     /* 309869 */ // Label 6208: @309869
     /* 309869 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(309895), // Rule ID 862 //
     /* 309874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309888 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 309888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 309893 */   GIR_RootConstrainSelectedInstOperands,
     /* 309894 */   // GIR_Coverage, 862,
     /* 309894 */   GIR_Done,
     /* 309895 */ // Label 6251: @309895
     /* 309895 */ GIM_Reject,
     /* 309896 */ // Label 6209: @309896
     /* 309896 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(309975),
     /* 309901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 309904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309912 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(309927), // Rule ID 858 //
     /* 309917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309920 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 309920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 309925 */     GIR_RootConstrainSelectedInstOperands,
     /* 309926 */     // GIR_Coverage, 858,
     /* 309926 */     GIR_Done,
     /* 309927 */   // Label 6253: @309927
     /* 309927 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(309974), // Rule ID 6345 //
     /* 309932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309935 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 309935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 309942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309947 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 309957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 309960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 309965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309972 */     GIR_RootConstrainSelectedInstOperands,
     /* 309973 */     // GIR_Coverage, 6345,
     /* 309973 */     GIR_EraseRootFromParent_Done,
     /* 309974 */   // Label 6254: @309974
     /* 309974 */   GIM_Reject,
     /* 309975 */ // Label 6252: @309975
     /* 309975 */ GIM_Reject,
     /* 309976 */ // Label 6210: @309976
     /* 309976 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(310002), // Rule ID 861 //
     /* 309981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309995 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 309995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 310000 */   GIR_RootConstrainSelectedInstOperands,
     /* 310001 */   // GIR_Coverage, 861,
     /* 310001 */   GIR_Done,
     /* 310002 */ // Label 6255: @310002
     /* 310002 */ GIM_Reject,
     /* 310003 */ // Label 6211: @310003
     /* 310003 */ GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(310082),
     /* 310008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310019 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(310034), // Rule ID 859 //
     /* 310024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310027 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 310027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 310032 */     GIR_RootConstrainSelectedInstOperands,
     /* 310033 */     // GIR_Coverage, 859,
     /* 310033 */     GIR_Done,
     /* 310034 */   // Label 6257: @310034
     /* 310034 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(310081), // Rule ID 6346 //
     /* 310039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310042 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 310049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310054 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 310072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310079 */     GIR_RootConstrainSelectedInstOperands,
     /* 310080 */     // GIR_Coverage, 6346,
     /* 310080 */     GIR_EraseRootFromParent_Done,
     /* 310081 */   // Label 6258: @310081
     /* 310081 */   GIM_Reject,
     /* 310082 */ // Label 6256: @310082
     /* 310082 */ GIM_Reject,
     /* 310083 */ // Label 6212: @310083
     /* 310083 */ GIM_Reject,
     /* 310084 */ // Label 63: @310084
     /* 310084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6263*/ GIMT_Encode4(310331),
     /* 310095 */ /*GILLT_s32*//*Label 6259*/ GIMT_Encode4(310123),
     /* 310099 */ /*GILLT_s64*//*Label 6260*/ GIMT_Encode4(310154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310111 */ /*GILLT_v2s64*//*Label 6261*/ GIMT_Encode4(310215), GIMT_Encode4(0),
     /* 310119 */ /*GILLT_v4s32*//*Label 6262*/ GIMT_Encode4(310273),
     /* 310123 */ // Label 6259: @310123
     /* 310123 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310153), // Rule ID 516 //
     /* 310128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310142 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 310142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 310147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310151 */   GIR_RootConstrainSelectedInstOperands,
     /* 310152 */   // GIR_Coverage, 516,
     /* 310152 */   GIR_Done,
     /* 310153 */ // Label 6264: @310153
     /* 310153 */ GIM_Reject,
     /* 310154 */ // Label 6260: @310154
     /* 310154 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(310184), // Rule ID 514 //
     /* 310159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310173 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 310173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 310178 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310182 */   GIR_RootConstrainSelectedInstOperands,
     /* 310183 */   // GIR_Coverage, 514,
     /* 310183 */   GIR_Done,
     /* 310184 */ // Label 6265: @310184
     /* 310184 */ GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(310214), // Rule ID 518 //
     /* 310189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310203 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 310203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 310208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310212 */   GIR_RootConstrainSelectedInstOperands,
     /* 310213 */   // GIR_Coverage, 518,
     /* 310213 */   GIR_Done,
     /* 310214 */ // Label 6266: @310214
     /* 310214 */ GIM_Reject,
     /* 310215 */ // Label 6261: @310215
     /* 310215 */ GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(310272),
     /* 310220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310227 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(310251), // Rule ID 4892 //
     /* 310232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 310239 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 310239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 310242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310249 */     GIR_RootConstrainSelectedInstOperands,
     /* 310250 */     // GIR_Coverage, 4892,
     /* 310250 */     GIR_EraseRootFromParent_Done,
     /* 310251 */   // Label 6268: @310251
     /* 310251 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(310271), // Rule ID 4890 //
     /* 310256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310260 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 310260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 310265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310269 */     GIR_RootConstrainSelectedInstOperands,
     /* 310270 */     // GIR_Coverage, 4890,
     /* 310270 */     GIR_Done,
     /* 310271 */   // Label 6269: @310271
     /* 310271 */   GIM_Reject,
     /* 310272 */ // Label 6267: @310272
     /* 310272 */ GIM_Reject,
     /* 310273 */ // Label 6262: @310273
     /* 310273 */ GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(310330),
     /* 310278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310285 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(310309), // Rule ID 4896 //
     /* 310290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 310297 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 310297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 310300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310307 */     GIR_RootConstrainSelectedInstOperands,
     /* 310308 */     // GIR_Coverage, 4896,
     /* 310308 */     GIR_EraseRootFromParent_Done,
     /* 310309 */   // Label 6271: @310309
     /* 310309 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(310329), // Rule ID 4894 //
     /* 310314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310318 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 310318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 310323 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310327 */     GIR_RootConstrainSelectedInstOperands,
     /* 310328 */     // GIR_Coverage, 4894,
     /* 310328 */     GIR_Done,
     /* 310329 */   // Label 6272: @310329
     /* 310329 */   GIM_Reject,
     /* 310330 */ // Label 6270: @310330
     /* 310330 */ GIM_Reject,
     /* 310331 */ // Label 6263: @310331
     /* 310331 */ GIM_Reject,
     /* 310332 */ // Label 64: @310332
     /* 310332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6277*/ GIMT_Encode4(310519),
     /* 310343 */ /*GILLT_s16*//*Label 6273*/ GIMT_Encode4(310371),
     /* 310347 */ /*GILLT_s32*//*Label 6274*/ GIMT_Encode4(310432), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310359 */ /*GILLT_v2s32*//*Label 6275*/ GIMT_Encode4(310463), GIMT_Encode4(0),
     /* 310367 */ /*GILLT_v4s16*//*Label 6276*/ GIMT_Encode4(310491),
     /* 310371 */ // Label 6273: @310371
     /* 310371 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310401), // Rule ID 510 //
     /* 310376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310390 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 310390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 310395 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310399 */   GIR_RootConstrainSelectedInstOperands,
     /* 310400 */   // GIR_Coverage, 510,
     /* 310400 */   GIR_Done,
     /* 310401 */ // Label 6278: @310401
     /* 310401 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310431), // Rule ID 520 //
     /* 310406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310420 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 310420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 310425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310429 */   GIR_RootConstrainSelectedInstOperands,
     /* 310430 */   // GIR_Coverage, 520,
     /* 310430 */   GIR_Done,
     /* 310431 */ // Label 6279: @310431
     /* 310431 */ GIM_Reject,
     /* 310432 */ // Label 6274: @310432
     /* 310432 */ GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310462), // Rule ID 512 //
     /* 310437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310451 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 310451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 310456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310460 */   GIR_RootConstrainSelectedInstOperands,
     /* 310461 */   // GIR_Coverage, 512,
     /* 310461 */   GIR_Done,
     /* 310462 */ // Label 6280: @310462
     /* 310462 */ GIM_Reject,
     /* 310463 */ // Label 6275: @310463
     /* 310463 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(310490), // Rule ID 4900 //
     /* 310468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310479 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 310479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 310484 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310488 */   GIR_RootConstrainSelectedInstOperands,
     /* 310489 */   // GIR_Coverage, 4900,
     /* 310489 */   GIR_Done,
     /* 310490 */ // Label 6281: @310490
     /* 310490 */ GIM_Reject,
     /* 310491 */ // Label 6276: @310491
     /* 310491 */ GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310518), // Rule ID 4902 //
     /* 310496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310507 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 310507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 310512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310516 */   GIR_RootConstrainSelectedInstOperands,
     /* 310517 */   // GIR_Coverage, 4902,
     /* 310517 */   GIR_Done,
     /* 310518 */ // Label 6282: @310518
     /* 310518 */ GIM_Reject,
     /* 310519 */ // Label 6277: @310519
     /* 310519 */ GIM_Reject,
     /* 310520 */ // Label 65: @310520
     /* 310520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6290*/ GIMT_Encode4(311496),
     /* 310531 */ /*GILLT_s32*//*Label 6283*/ GIMT_Encode4(310567),
     /* 310535 */ /*GILLT_s64*//*Label 6284*/ GIMT_Encode4(310954), GIMT_Encode4(0),
     /* 310543 */ /*GILLT_v2s32*//*Label 6285*/ GIMT_Encode4(311341),
     /* 310547 */ /*GILLT_v2s64*//*Label 6286*/ GIMT_Encode4(311372),
     /* 310551 */ /*GILLT_v4s16*//*Label 6287*/ GIMT_Encode4(311403),
     /* 310555 */ /*GILLT_v4s32*//*Label 6288*/ GIMT_Encode4(311434), GIMT_Encode4(0),
     /* 310563 */ /*GILLT_v8s16*//*Label 6289*/ GIMT_Encode4(311465),
     /* 310567 */ // Label 6283: @310567
     /* 310567 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(310604), // Rule ID 4639 //
     /* 310572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310587 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310593 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 310596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310598 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310602 */   GIR_RootConstrainSelectedInstOperands,
     /* 310603 */   // GIR_Coverage, 4639,
     /* 310603 */   GIR_EraseRootFromParent_Done,
     /* 310604 */ // Label 6291: @310604
     /* 310604 */ GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(310641), // Rule ID 4641 //
     /* 310609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310624 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310630 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 310633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310635 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310639 */   GIR_RootConstrainSelectedInstOperands,
     /* 310640 */   // GIR_Coverage, 4641,
     /* 310640 */   GIR_EraseRootFromParent_Done,
     /* 310641 */ // Label 6292: @310641
     /* 310641 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(310678), // Rule ID 4659 //
     /* 310646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310661 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310667 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 310670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310672 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310676 */   GIR_RootConstrainSelectedInstOperands,
     /* 310677 */   // GIR_Coverage, 4659,
     /* 310677 */   GIR_EraseRootFromParent_Done,
     /* 310678 */ // Label 6293: @310678
     /* 310678 */ GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(310715), // Rule ID 4661 //
     /* 310683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310698 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310704 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 310707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310709 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310713 */   GIR_RootConstrainSelectedInstOperands,
     /* 310714 */   // GIR_Coverage, 4661,
     /* 310714 */   GIR_EraseRootFromParent_Done,
     /* 310715 */ // Label 6294: @310715
     /* 310715 */ GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(310752), // Rule ID 4699 //
     /* 310720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310741 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 310744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310746 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310750 */   GIR_RootConstrainSelectedInstOperands,
     /* 310751 */   // GIR_Coverage, 4699,
     /* 310751 */   GIR_EraseRootFromParent_Done,
     /* 310752 */ // Label 6295: @310752
     /* 310752 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(310789), // Rule ID 4701 //
     /* 310757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310772 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310778 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 310781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310787 */   GIR_RootConstrainSelectedInstOperands,
     /* 310788 */   // GIR_Coverage, 4701,
     /* 310788 */   GIR_EraseRootFromParent_Done,
     /* 310789 */ // Label 6296: @310789
     /* 310789 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(310826), // Rule ID 4679 //
     /* 310794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 310809 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310815 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310820 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310824 */   GIR_RootConstrainSelectedInstOperands,
     /* 310825 */   // GIR_Coverage, 4679,
     /* 310825 */   GIR_EraseRootFromParent_Done,
     /* 310826 */ // Label 6297: @310826
     /* 310826 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(310863), // Rule ID 4681 //
     /* 310831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 310846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310852 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310857 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310861 */   GIR_RootConstrainSelectedInstOperands,
     /* 310862 */   // GIR_Coverage, 4681,
     /* 310862 */   GIR_EraseRootFromParent_Done,
     /* 310863 */ // Label 6298: @310863
     /* 310863 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(310893), // Rule ID 395 //
     /* 310868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310882 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 310882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 310887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310891 */   GIR_RootConstrainSelectedInstOperands,
     /* 310892 */   // GIR_Coverage, 395,
     /* 310892 */   GIR_Done,
     /* 310893 */ // Label 6299: @310893
     /* 310893 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(310923), // Rule ID 399 //
     /* 310898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310912 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 310912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310921 */   GIR_RootConstrainSelectedInstOperands,
     /* 310922 */   // GIR_Coverage, 399,
     /* 310922 */   GIR_Done,
     /* 310923 */ // Label 6300: @310923
     /* 310923 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(310953), // Rule ID 403 //
     /* 310928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310942 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 310942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310951 */   GIR_RootConstrainSelectedInstOperands,
     /* 310952 */   // GIR_Coverage, 403,
     /* 310952 */   GIR_Done,
     /* 310953 */ // Label 6301: @310953
     /* 310953 */ GIM_Reject,
     /* 310954 */ // Label 6284: @310954
     /* 310954 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(310991), // Rule ID 4640 //
     /* 310959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310974 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310980 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 310983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310985 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310989 */   GIR_RootConstrainSelectedInstOperands,
     /* 310990 */   // GIR_Coverage, 4640,
     /* 310990 */   GIR_EraseRootFromParent_Done,
     /* 310991 */ // Label 6302: @310991
     /* 310991 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311028), // Rule ID 4642 //
     /* 310996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311017 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 311020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311022 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311026 */   GIR_RootConstrainSelectedInstOperands,
     /* 311027 */   // GIR_Coverage, 4642,
     /* 311027 */   GIR_EraseRootFromParent_Done,
     /* 311028 */ // Label 6303: @311028
     /* 311028 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311065), // Rule ID 4660 //
     /* 311033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311054 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 311057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311059 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311063 */   GIR_RootConstrainSelectedInstOperands,
     /* 311064 */   // GIR_Coverage, 4660,
     /* 311064 */   GIR_EraseRootFromParent_Done,
     /* 311065 */ // Label 6304: @311065
     /* 311065 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(311102), // Rule ID 4662 //
     /* 311070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311085 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311091 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 311094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311096 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311100 */   GIR_RootConstrainSelectedInstOperands,
     /* 311101 */   // GIR_Coverage, 4662,
     /* 311101 */   GIR_EraseRootFromParent_Done,
     /* 311102 */ // Label 6305: @311102
     /* 311102 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(311139), // Rule ID 4700 //
     /* 311107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311114 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311122 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311126 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311128 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 311131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311133 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311137 */   GIR_RootConstrainSelectedInstOperands,
     /* 311138 */   // GIR_Coverage, 4700,
     /* 311138 */   GIR_EraseRootFromParent_Done,
     /* 311139 */ // Label 6306: @311139
     /* 311139 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(311176), // Rule ID 4702 //
     /* 311144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311165 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 311168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311174 */   GIR_RootConstrainSelectedInstOperands,
     /* 311175 */   // GIR_Coverage, 4702,
     /* 311175 */   GIR_EraseRootFromParent_Done,
     /* 311176 */ // Label 6307: @311176
     /* 311176 */ GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(311213), // Rule ID 4680 //
     /* 311181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311202 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311211 */   GIR_RootConstrainSelectedInstOperands,
     /* 311212 */   // GIR_Coverage, 4680,
     /* 311212 */   GIR_EraseRootFromParent_Done,
     /* 311213 */ // Label 6308: @311213
     /* 311213 */ GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(311250), // Rule ID 4682 //
     /* 311218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311233 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311239 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311244 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311248 */   GIR_RootConstrainSelectedInstOperands,
     /* 311249 */   // GIR_Coverage, 4682,
     /* 311249 */   GIR_EraseRootFromParent_Done,
     /* 311250 */ // Label 6309: @311250
     /* 311250 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(311280), // Rule ID 397 //
     /* 311255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311269 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 311269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 311274 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311278 */   GIR_RootConstrainSelectedInstOperands,
     /* 311279 */   // GIR_Coverage, 397,
     /* 311279 */   GIR_Done,
     /* 311280 */ // Label 6310: @311280
     /* 311280 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(311310), // Rule ID 401 //
     /* 311285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311299 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 311299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311304 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311308 */   GIR_RootConstrainSelectedInstOperands,
     /* 311309 */   // GIR_Coverage, 401,
     /* 311309 */   GIR_Done,
     /* 311310 */ // Label 6311: @311310
     /* 311310 */ GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(311340), // Rule ID 405 //
     /* 311315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311329 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 311329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311338 */   GIR_RootConstrainSelectedInstOperands,
     /* 311339 */   // GIR_Coverage, 405,
     /* 311339 */   GIR_Done,
     /* 311340 */ // Label 6312: @311340
     /* 311340 */ GIM_Reject,
     /* 311341 */ // Label 6285: @311341
     /* 311341 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(311371), // Rule ID 843 //
     /* 311346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311360 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 311360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 311365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311369 */   GIR_RootConstrainSelectedInstOperands,
     /* 311370 */   // GIR_Coverage, 843,
     /* 311370 */   GIR_Done,
     /* 311371 */ // Label 6313: @311371
     /* 311371 */ GIM_Reject,
     /* 311372 */ // Label 6286: @311372
     /* 311372 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311402), // Rule ID 847 //
     /* 311377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311391 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 311391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311400 */   GIR_RootConstrainSelectedInstOperands,
     /* 311401 */   // GIR_Coverage, 847,
     /* 311401 */   GIR_Done,
     /* 311402 */ // Label 6314: @311402
     /* 311402 */ GIM_Reject,
     /* 311403 */ // Label 6287: @311403
     /* 311403 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(311433), // Rule ID 839 //
     /* 311408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311422 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 311422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 311427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311431 */   GIR_RootConstrainSelectedInstOperands,
     /* 311432 */   // GIR_Coverage, 839,
     /* 311432 */   GIR_Done,
     /* 311433 */ // Label 6315: @311433
     /* 311433 */ GIM_Reject,
     /* 311434 */ // Label 6288: @311434
     /* 311434 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(311464), // Rule ID 845 //
     /* 311439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311453 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 311453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 311458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311462 */   GIR_RootConstrainSelectedInstOperands,
     /* 311463 */   // GIR_Coverage, 845,
     /* 311463 */   GIR_Done,
     /* 311464 */ // Label 6316: @311464
     /* 311464 */ GIM_Reject,
     /* 311465 */ // Label 6289: @311465
     /* 311465 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(311495), // Rule ID 841 //
     /* 311470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311484 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 311484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 311489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311493 */   GIR_RootConstrainSelectedInstOperands,
     /* 311494 */   // GIR_Coverage, 841,
     /* 311494 */   GIR_Done,
     /* 311495 */ // Label 6317: @311495
     /* 311495 */ GIM_Reject,
     /* 311496 */ // Label 6290: @311496
     /* 311496 */ GIM_Reject,
     /* 311497 */ // Label 66: @311497
     /* 311497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6325*/ GIMT_Encode4(312473),
     /* 311508 */ /*GILLT_s32*//*Label 6318*/ GIMT_Encode4(311544),
     /* 311512 */ /*GILLT_s64*//*Label 6319*/ GIMT_Encode4(311931), GIMT_Encode4(0),
     /* 311520 */ /*GILLT_v2s32*//*Label 6320*/ GIMT_Encode4(312318),
     /* 311524 */ /*GILLT_v2s64*//*Label 6321*/ GIMT_Encode4(312349),
     /* 311528 */ /*GILLT_v4s16*//*Label 6322*/ GIMT_Encode4(312380),
     /* 311532 */ /*GILLT_v4s32*//*Label 6323*/ GIMT_Encode4(312411), GIMT_Encode4(0),
     /* 311540 */ /*GILLT_v8s16*//*Label 6324*/ GIMT_Encode4(312442),
     /* 311544 */ // Label 6318: @311544
     /* 311544 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(311581), // Rule ID 4649 //
     /* 311549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311570 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 311573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311579 */   GIR_RootConstrainSelectedInstOperands,
     /* 311580 */   // GIR_Coverage, 4649,
     /* 311580 */   GIR_EraseRootFromParent_Done,
     /* 311581 */ // Label 6326: @311581
     /* 311581 */ GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(311618), // Rule ID 4651 //
     /* 311586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311607 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 311610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311612 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311616 */   GIR_RootConstrainSelectedInstOperands,
     /* 311617 */   // GIR_Coverage, 4651,
     /* 311617 */   GIR_EraseRootFromParent_Done,
     /* 311618 */ // Label 6327: @311618
     /* 311618 */ GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(311655), // Rule ID 4669 //
     /* 311623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311638 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311644 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 311647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311649 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311653 */   GIR_RootConstrainSelectedInstOperands,
     /* 311654 */   // GIR_Coverage, 4669,
     /* 311654 */   GIR_EraseRootFromParent_Done,
     /* 311655 */ // Label 6328: @311655
     /* 311655 */ GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(311692), // Rule ID 4671 //
     /* 311660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311681 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 311684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311686 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311690 */   GIR_RootConstrainSelectedInstOperands,
     /* 311691 */   // GIR_Coverage, 4671,
     /* 311691 */   GIR_EraseRootFromParent_Done,
     /* 311692 */ // Label 6329: @311692
     /* 311692 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(311729), // Rule ID 4709 //
     /* 311697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311718 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 311721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311727 */   GIR_RootConstrainSelectedInstOperands,
     /* 311728 */   // GIR_Coverage, 4709,
     /* 311728 */   GIR_EraseRootFromParent_Done,
     /* 311729 */ // Label 6330: @311729
     /* 311729 */ GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(311766), // Rule ID 4711 //
     /* 311734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311749 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311755 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 311758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311764 */   GIR_RootConstrainSelectedInstOperands,
     /* 311765 */   // GIR_Coverage, 4711,
     /* 311765 */   GIR_EraseRootFromParent_Done,
     /* 311766 */ // Label 6331: @311766
     /* 311766 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(311803), // Rule ID 4689 //
     /* 311771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311792 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 311795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311801 */   GIR_RootConstrainSelectedInstOperands,
     /* 311802 */   // GIR_Coverage, 4689,
     /* 311802 */   GIR_EraseRootFromParent_Done,
     /* 311803 */ // Label 6332: @311803
     /* 311803 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(311840), // Rule ID 4691 //
     /* 311808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311829 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 311832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311834 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311838 */   GIR_RootConstrainSelectedInstOperands,
     /* 311839 */   // GIR_Coverage, 4691,
     /* 311839 */   GIR_EraseRootFromParent_Done,
     /* 311840 */ // Label 6333: @311840
     /* 311840 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(311870), // Rule ID 407 //
     /* 311845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311859 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 311859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 311864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311868 */   GIR_RootConstrainSelectedInstOperands,
     /* 311869 */   // GIR_Coverage, 407,
     /* 311869 */   GIR_Done,
     /* 311870 */ // Label 6334: @311870
     /* 311870 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(311900), // Rule ID 411 //
     /* 311875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311889 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 311889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 311894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311898 */   GIR_RootConstrainSelectedInstOperands,
     /* 311899 */   // GIR_Coverage, 411,
     /* 311899 */   GIR_Done,
     /* 311900 */ // Label 6335: @311900
     /* 311900 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(311930), // Rule ID 415 //
     /* 311905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311919 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 311919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 311924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311928 */   GIR_RootConstrainSelectedInstOperands,
     /* 311929 */   // GIR_Coverage, 415,
     /* 311929 */   GIR_Done,
     /* 311930 */ // Label 6336: @311930
     /* 311930 */ GIM_Reject,
     /* 311931 */ // Label 6319: @311931
     /* 311931 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(311968), // Rule ID 4650 //
     /* 311936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311957 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 311960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311962 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311966 */   GIR_RootConstrainSelectedInstOperands,
     /* 311967 */   // GIR_Coverage, 4650,
     /* 311967 */   GIR_EraseRootFromParent_Done,
     /* 311968 */ // Label 6337: @311968
     /* 311968 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312005), // Rule ID 4652 //
     /* 311973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311994 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 311997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311999 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312003 */   GIR_RootConstrainSelectedInstOperands,
     /* 312004 */   // GIR_Coverage, 4652,
     /* 312004 */   GIR_EraseRootFromParent_Done,
     /* 312005 */ // Label 6338: @312005
     /* 312005 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312042), // Rule ID 4670 //
     /* 312010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312031 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 312034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312040 */   GIR_RootConstrainSelectedInstOperands,
     /* 312041 */   // GIR_Coverage, 4670,
     /* 312041 */   GIR_EraseRootFromParent_Done,
     /* 312042 */ // Label 6339: @312042
     /* 312042 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312079), // Rule ID 4672 //
     /* 312047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312062 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312068 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 312071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312077 */   GIR_RootConstrainSelectedInstOperands,
     /* 312078 */   // GIR_Coverage, 4672,
     /* 312078 */   GIR_EraseRootFromParent_Done,
     /* 312079 */ // Label 6340: @312079
     /* 312079 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312116), // Rule ID 4710 //
     /* 312084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312105 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 312108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312114 */   GIR_RootConstrainSelectedInstOperands,
     /* 312115 */   // GIR_Coverage, 4710,
     /* 312115 */   GIR_EraseRootFromParent_Done,
     /* 312116 */ // Label 6341: @312116
     /* 312116 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312153), // Rule ID 4712 //
     /* 312121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312142 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 312145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312151 */   GIR_RootConstrainSelectedInstOperands,
     /* 312152 */   // GIR_Coverage, 4712,
     /* 312152 */   GIR_EraseRootFromParent_Done,
     /* 312153 */ // Label 6342: @312153
     /* 312153 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(312190), // Rule ID 4690 //
     /* 312158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312173 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312179 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312184 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312188 */   GIR_RootConstrainSelectedInstOperands,
     /* 312189 */   // GIR_Coverage, 4690,
     /* 312189 */   GIR_EraseRootFromParent_Done,
     /* 312190 */ // Label 6343: @312190
     /* 312190 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(312227), // Rule ID 4692 //
     /* 312195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312216 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312225 */   GIR_RootConstrainSelectedInstOperands,
     /* 312226 */   // GIR_Coverage, 4692,
     /* 312226 */   GIR_EraseRootFromParent_Done,
     /* 312227 */ // Label 6344: @312227
     /* 312227 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(312257), // Rule ID 409 //
     /* 312232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312246 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 312246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 312251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312255 */   GIR_RootConstrainSelectedInstOperands,
     /* 312256 */   // GIR_Coverage, 409,
     /* 312256 */   GIR_Done,
     /* 312257 */ // Label 6345: @312257
     /* 312257 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(312287), // Rule ID 413 //
     /* 312262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312276 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 312276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312285 */   GIR_RootConstrainSelectedInstOperands,
     /* 312286 */   // GIR_Coverage, 413,
     /* 312286 */   GIR_Done,
     /* 312287 */ // Label 6346: @312287
     /* 312287 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(312317), // Rule ID 417 //
     /* 312292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312306 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 312306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312315 */   GIR_RootConstrainSelectedInstOperands,
     /* 312316 */   // GIR_Coverage, 417,
     /* 312316 */   GIR_Done,
     /* 312317 */ // Label 6347: @312317
     /* 312317 */ GIM_Reject,
     /* 312318 */ // Label 6320: @312318
     /* 312318 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(312348), // Rule ID 853 //
     /* 312323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312337 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 312337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 312342 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312346 */   GIR_RootConstrainSelectedInstOperands,
     /* 312347 */   // GIR_Coverage, 853,
     /* 312347 */   GIR_Done,
     /* 312348 */ // Label 6348: @312348
     /* 312348 */ GIM_Reject,
     /* 312349 */ // Label 6321: @312349
     /* 312349 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(312379), // Rule ID 857 //
     /* 312354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312368 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 312368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312377 */   GIR_RootConstrainSelectedInstOperands,
     /* 312378 */   // GIR_Coverage, 857,
     /* 312378 */   GIR_Done,
     /* 312379 */ // Label 6349: @312379
     /* 312379 */ GIM_Reject,
     /* 312380 */ // Label 6322: @312380
     /* 312380 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(312410), // Rule ID 849 //
     /* 312385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312399 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 312399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 312404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312408 */   GIR_RootConstrainSelectedInstOperands,
     /* 312409 */   // GIR_Coverage, 849,
     /* 312409 */   GIR_Done,
     /* 312410 */ // Label 6350: @312410
     /* 312410 */ GIM_Reject,
     /* 312411 */ // Label 6323: @312411
     /* 312411 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(312441), // Rule ID 855 //
     /* 312416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312430 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 312430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 312435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312439 */   GIR_RootConstrainSelectedInstOperands,
     /* 312440 */   // GIR_Coverage, 855,
     /* 312440 */   GIR_Done,
     /* 312441 */ // Label 6351: @312441
     /* 312441 */ GIM_Reject,
     /* 312442 */ // Label 6324: @312442
     /* 312442 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312472), // Rule ID 851 //
     /* 312447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312461 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 312461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 312466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312470 */   GIR_RootConstrainSelectedInstOperands,
     /* 312471 */   // GIR_Coverage, 851,
     /* 312471 */   GIR_Done,
     /* 312472 */ // Label 6352: @312472
     /* 312472 */ GIM_Reject,
     /* 312473 */ // Label 6325: @312473
     /* 312473 */ GIM_Reject,
     /* 312474 */ // Label 67: @312474
     /* 312474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6361*/ GIMT_Encode4(316781),
     /* 312485 */ /*GILLT_s16*//*Label 6353*/ GIMT_Encode4(312525),
     /* 312489 */ /*GILLT_s32*//*Label 6354*/ GIMT_Encode4(312806),
     /* 312493 */ /*GILLT_s64*//*Label 6355*/ GIMT_Encode4(314722), GIMT_Encode4(0),
     /* 312501 */ /*GILLT_v2s32*//*Label 6356*/ GIMT_Encode4(316626),
     /* 312505 */ /*GILLT_v2s64*//*Label 6357*/ GIMT_Encode4(316657),
     /* 312509 */ /*GILLT_v4s16*//*Label 6358*/ GIMT_Encode4(316688),
     /* 312513 */ /*GILLT_v4s32*//*Label 6359*/ GIMT_Encode4(316719), GIMT_Encode4(0),
     /* 312521 */ /*GILLT_v8s16*//*Label 6360*/ GIMT_Encode4(316750),
     /* 312525 */ // Label 6353: @312525
     /* 312525 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(312628), // Rule ID 5310 //
     /* 312530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 312548 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312552 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312556 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312560 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312564 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312568 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312573 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312577 */   // MIs[1] Operand 2
     /* 312577 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 312588 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312590 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 312590 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312593 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312597 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312602 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312626 */   GIR_RootConstrainSelectedInstOperands,
     /* 312627 */   // GIR_Coverage, 5310,
     /* 312627 */   GIR_EraseRootFromParent_Done,
     /* 312628 */ // Label 6362: @312628
     /* 312628 */ GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(312685), // Rule ID 5301 //
     /* 312633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 312651 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312657 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 312657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 312664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312683 */   GIR_RootConstrainSelectedInstOperands,
     /* 312684 */   // GIR_Coverage, 5301,
     /* 312684 */   GIR_EraseRootFromParent_Done,
     /* 312685 */ // Label 6363: @312685
     /* 312685 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(312715), // Rule ID 443 //
     /* 312690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312704 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 312704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 312709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312713 */   GIR_RootConstrainSelectedInstOperands,
     /* 312714 */   // GIR_Coverage, 443,
     /* 312714 */   GIR_Done,
     /* 312715 */ // Label 6364: @312715
     /* 312715 */ GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(312745), // Rule ID 449 //
     /* 312720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312734 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 312734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 312739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312743 */   GIR_RootConstrainSelectedInstOperands,
     /* 312744 */   // GIR_Coverage, 449,
     /* 312744 */   GIR_Done,
     /* 312745 */ // Label 6365: @312745
     /* 312745 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(312775), // Rule ID 491 //
     /* 312750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312764 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 312764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 312769 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312773 */   GIR_RootConstrainSelectedInstOperands,
     /* 312774 */   // GIR_Coverage, 491,
     /* 312774 */   GIR_Done,
     /* 312775 */ // Label 6366: @312775
     /* 312775 */ GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(312805), // Rule ID 495 //
     /* 312780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312794 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 312794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 312799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312803 */   GIR_RootConstrainSelectedInstOperands,
     /* 312804 */   // GIR_Coverage, 495,
     /* 312804 */   GIR_Done,
     /* 312805 */ // Label 6367: @312805
     /* 312805 */ GIM_Reject,
     /* 312806 */ // Label 6354: @312806
     /* 312806 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(313044), // Rule ID 6347 //
     /* 312811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 312814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 312829 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312832 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 312839 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312845 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 312852 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 312852 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 312855 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 312859 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 312874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 312879 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 312886 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 312889 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312893 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 312900 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 312903 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312907 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312912 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 312915 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 312918 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 312921 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312926 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312931 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 312936 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 312939 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 312943 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312948 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 312951 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 312954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 312956 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 312959 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312963 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312968 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312975 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312980 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312985 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 312988 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 312992 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312997 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313000 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313017 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313042 */   GIR_RootConstrainSelectedInstOperands,
     /* 313043 */   // GIR_Coverage, 6347,
     /* 313043 */   GIR_EraseRootFromParent_Done,
     /* 313044 */ // Label 6368: @313044
     /* 313044 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(313282), // Rule ID 6348 //
     /* 313049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313067 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313070 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313077 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313083 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 313090 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313090 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313093 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 313097 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313117 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313124 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313127 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313131 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313138 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313141 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313145 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313150 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313153 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313156 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313159 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313164 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313169 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313174 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313177 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313181 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313186 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313189 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313194 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313197 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313201 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313206 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313213 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313218 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313223 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313226 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313230 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313235 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313238 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313255 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313262 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313280 */   GIR_RootConstrainSelectedInstOperands,
     /* 313281 */   // GIR_Coverage, 6348,
     /* 313281 */   GIR_EraseRootFromParent_Done,
     /* 313282 */ // Label 6369: @313282
     /* 313282 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(313471), // Rule ID 6351 //
     /* 313287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313305 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313308 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313315 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313321 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 313328 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313328 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313331 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 313335 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313355 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313362 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313365 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313369 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313376 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313379 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313383 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313388 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313391 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313394 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313397 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313402 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313407 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313424 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313427 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313444 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313456 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313469 */   GIR_RootConstrainSelectedInstOperands,
     /* 313470 */   // GIR_Coverage, 6351,
     /* 313470 */   GIR_EraseRootFromParent_Done,
     /* 313471 */ // Label 6370: @313471
     /* 313471 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(313660), // Rule ID 6352 //
     /* 313476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313494 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313497 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313504 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313510 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 313517 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313517 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313520 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 313524 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313544 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313551 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313554 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313558 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313565 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313568 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313572 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313577 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313580 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313583 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313586 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313591 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313596 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313601 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313604 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313608 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313613 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313616 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313633 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313645 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313658 */   GIR_RootConstrainSelectedInstOperands,
     /* 313659 */   // GIR_Coverage, 6352,
     /* 313659 */   GIR_EraseRootFromParent_Done,
     /* 313660 */ // Label 6371: @313660
     /* 313660 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313893), // Rule ID 6349 //
     /* 313665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313683 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313686 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313693 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313699 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 313706 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313706 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313709 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 313713 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 313728 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313735 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313738 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313742 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313749 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313752 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313756 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313761 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313764 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313767 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313770 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313775 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313780 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313785 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313788 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313792 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313797 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313800 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313817 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313824 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313829 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313834 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313837 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313841 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313846 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313849 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313866 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313891 */   GIR_RootConstrainSelectedInstOperands,
     /* 313892 */   // GIR_Coverage, 6349,
     /* 313892 */   GIR_EraseRootFromParent_Done,
     /* 313893 */ // Label 6372: @313893
     /* 313893 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(314126), // Rule ID 6350 //
     /* 313898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313916 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313919 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313926 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313932 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 313939 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313939 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313942 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 313946 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 313961 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313968 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313971 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313975 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313982 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313985 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313989 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313994 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313997 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314000 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314003 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314008 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314013 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314018 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314021 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314025 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314030 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314033 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314038 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314041 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314045 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314050 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314057 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314062 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314079 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314082 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314099 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314124 */   GIR_RootConstrainSelectedInstOperands,
     /* 314125 */   // GIR_Coverage, 6350,
     /* 314125 */   GIR_EraseRootFromParent_Done,
     /* 314126 */ // Label 6373: @314126
     /* 314126 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(314310), // Rule ID 6353 //
     /* 314131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314149 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314152 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314159 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314165 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 314172 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314172 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314175 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 314179 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314194 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314201 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314204 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314208 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314215 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314218 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314222 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314227 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314230 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314233 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314236 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314241 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314246 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314251 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314254 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314258 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314263 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314266 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314283 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314308 */   GIR_RootConstrainSelectedInstOperands,
     /* 314309 */   // GIR_Coverage, 6353,
     /* 314309 */   GIR_EraseRootFromParent_Done,
     /* 314310 */ // Label 6374: @314310
     /* 314310 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(314494), // Rule ID 6354 //
     /* 314315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314333 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314336 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314343 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314349 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 314356 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314356 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314359 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 314363 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314378 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314385 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314388 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314392 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314399 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314402 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314406 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314411 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314414 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314417 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314420 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314425 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314430 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314447 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314450 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314467 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314492 */   GIR_RootConstrainSelectedInstOperands,
     /* 314493 */   // GIR_Coverage, 6354,
     /* 314493 */   GIR_EraseRootFromParent_Done,
     /* 314494 */ // Label 6375: @314494
     /* 314494 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(314574), // Rule ID 5306 //
     /* 314499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314509 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314517 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314521 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314525 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314530 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314536 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 314536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314548 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314572 */   GIR_RootConstrainSelectedInstOperands,
     /* 314573 */   // GIR_Coverage, 5306,
     /* 314573 */   GIR_EraseRootFromParent_Done,
     /* 314574 */ // Label 6376: @314574
     /* 314574 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(314631), // Rule ID 5289 //
     /* 314579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 314597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314603 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 314603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 314610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 314621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314629 */   GIR_RootConstrainSelectedInstOperands,
     /* 314630 */   // GIR_Coverage, 5289,
     /* 314630 */   GIR_EraseRootFromParent_Done,
     /* 314631 */ // Label 6377: @314631
     /* 314631 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(314661), // Rule ID 445 //
     /* 314636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314650 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 314650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 314655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314659 */   GIR_RootConstrainSelectedInstOperands,
     /* 314660 */   // GIR_Coverage, 445,
     /* 314660 */   GIR_Done,
     /* 314661 */ // Label 6378: @314661
     /* 314661 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(314691), // Rule ID 451 //
     /* 314666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314680 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 314680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 314685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314689 */   GIR_RootConstrainSelectedInstOperands,
     /* 314690 */   // GIR_Coverage, 451,
     /* 314690 */   GIR_Done,
     /* 314691 */ // Label 6379: @314691
     /* 314691 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(314721), // Rule ID 497 //
     /* 314696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314710 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 314710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 314715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314719 */   GIR_RootConstrainSelectedInstOperands,
     /* 314720 */   // GIR_Coverage, 497,
     /* 314720 */   GIR_Done,
     /* 314721 */ // Label 6380: @314721
     /* 314721 */ GIM_Reject,
     /* 314722 */ // Label 6355: @314722
     /* 314722 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314908), // Rule ID 6359 //
     /* 314727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314745 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314752 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314758 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 314765 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 314765 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 314768 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 314772 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314792 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314799 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314802 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314806 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314813 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314816 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314820 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314825 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314828 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314831 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 314834 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314839 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314844 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314849 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314852 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 314856 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314861 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314864 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314881 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314888 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314893 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 314901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314906 */   GIR_RootConstrainSelectedInstOperands,
     /* 314907 */   // GIR_Coverage, 6359,
     /* 314907 */   GIR_EraseRootFromParent_Done,
     /* 314908 */ // Label 6381: @314908
     /* 314908 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(315094), // Rule ID 6360 //
     /* 314913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314931 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314938 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314944 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 314951 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 314951 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 314954 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 314958 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314978 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314985 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314988 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314992 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314999 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315002 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315006 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315011 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315014 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315017 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315020 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315025 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315030 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315047 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315050 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315067 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315092 */   GIR_RootConstrainSelectedInstOperands,
     /* 315093 */   // GIR_Coverage, 6360,
     /* 315093 */   GIR_EraseRootFromParent_Done,
     /* 315094 */ // Label 6382: @315094
     /* 315094 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(315332), // Rule ID 6355 //
     /* 315099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315117 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315120 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315127 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315133 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 315140 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315140 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315143 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 315147 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315167 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315174 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315177 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315181 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315188 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315191 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315195 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315200 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315203 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315206 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315209 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315214 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315219 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315224 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315227 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315231 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315236 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315239 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315244 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315247 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315251 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315256 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315263 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315273 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315276 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315280 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315285 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315288 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315305 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315330 */   GIR_RootConstrainSelectedInstOperands,
     /* 315331 */   // GIR_Coverage, 6355,
     /* 315331 */   GIR_EraseRootFromParent_Done,
     /* 315332 */ // Label 6383: @315332
     /* 315332 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(315570), // Rule ID 6356 //
     /* 315337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315355 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315358 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315365 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315371 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 315378 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315378 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315381 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 315385 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315405 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315412 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315415 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315419 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315426 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315429 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315433 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315438 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315441 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315444 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315447 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315452 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315457 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315462 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315465 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315469 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315474 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315477 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315482 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315485 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315489 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315494 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315501 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315506 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315523 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315526 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315543 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315568 */   GIR_RootConstrainSelectedInstOperands,
     /* 315569 */   // GIR_Coverage, 6356,
     /* 315569 */   GIR_EraseRootFromParent_Done,
     /* 315570 */ // Label 6384: @315570
     /* 315570 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(315751), // Rule ID 6361 //
     /* 315575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315593 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315600 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315606 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 315613 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315613 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315616 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 315620 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315635 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315642 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315645 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315649 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315656 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315659 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315663 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315668 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315671 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315674 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315677 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315682 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315687 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315692 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315695 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315699 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315704 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315707 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315724 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315736 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315749 */   GIR_RootConstrainSelectedInstOperands,
     /* 315750 */   // GIR_Coverage, 6361,
     /* 315750 */   GIR_EraseRootFromParent_Done,
     /* 315751 */ // Label 6385: @315751
     /* 315751 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(315932), // Rule ID 6362 //
     /* 315756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315766 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315774 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315777 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315781 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315787 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 315794 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315794 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315797 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 315801 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315816 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315823 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315826 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315830 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315837 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315840 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315844 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315849 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315852 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315855 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315858 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315863 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315868 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315885 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315888 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315905 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315930 */   GIR_RootConstrainSelectedInstOperands,
     /* 315931 */   // GIR_Coverage, 6362,
     /* 315931 */   GIR_EraseRootFromParent_Done,
     /* 315932 */ // Label 6386: @315932
     /* 315932 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(316165), // Rule ID 6357 //
     /* 315937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315955 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315958 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315965 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315971 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 315978 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315978 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315981 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 315985 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316000 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316007 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316010 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316014 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316021 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316024 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316028 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316033 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316036 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316039 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316042 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316047 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316052 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316057 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316060 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316064 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316069 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316072 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316077 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316080 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316084 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316089 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316096 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316101 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316106 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316109 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316113 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316118 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316121 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316138 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316145 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316163 */   GIR_RootConstrainSelectedInstOperands,
     /* 316164 */   // GIR_Coverage, 6357,
     /* 316164 */   GIR_EraseRootFromParent_Done,
     /* 316165 */ // Label 6387: @316165
     /* 316165 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(316398), // Rule ID 6358 //
     /* 316170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316180 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316188 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316191 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316198 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316204 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 316211 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316211 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316214 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 316218 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316233 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316240 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316243 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316247 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316254 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316257 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316261 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316266 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316269 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316272 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316275 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316280 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316285 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316290 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316293 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316297 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316302 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316305 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316310 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316313 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316317 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316322 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316329 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316334 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316339 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316342 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316346 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316351 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316354 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316371 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316396 */   GIR_RootConstrainSelectedInstOperands,
     /* 316397 */   // GIR_Coverage, 6358,
     /* 316397 */   GIR_EraseRootFromParent_Done,
     /* 316398 */ // Label 6388: @316398
     /* 316398 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(316478), // Rule ID 5308 //
     /* 316403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316429 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316434 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316440 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 316440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316452 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316476 */   GIR_RootConstrainSelectedInstOperands,
     /* 316477 */   // GIR_Coverage, 5308,
     /* 316477 */   GIR_EraseRootFromParent_Done,
     /* 316478 */ // Label 6389: @316478
     /* 316478 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(316535), // Rule ID 5285 //
     /* 316483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 316501 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316507 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 316507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 316514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316519 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316533 */   GIR_RootConstrainSelectedInstOperands,
     /* 316534 */   // GIR_Coverage, 5285,
     /* 316534 */   GIR_EraseRootFromParent_Done,
     /* 316535 */ // Label 6390: @316535
     /* 316535 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(316565), // Rule ID 447 //
     /* 316540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316554 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 316554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 316559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316563 */   GIR_RootConstrainSelectedInstOperands,
     /* 316564 */   // GIR_Coverage, 447,
     /* 316564 */   GIR_Done,
     /* 316565 */ // Label 6391: @316565
     /* 316565 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(316595), // Rule ID 453 //
     /* 316570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316584 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 316584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 316589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316593 */   GIR_RootConstrainSelectedInstOperands,
     /* 316594 */   // GIR_Coverage, 453,
     /* 316594 */   GIR_Done,
     /* 316595 */ // Label 6392: @316595
     /* 316595 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(316625), // Rule ID 493 //
     /* 316600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 316603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316614 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 316614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 316619 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316623 */   GIR_RootConstrainSelectedInstOperands,
     /* 316624 */   // GIR_Coverage, 493,
     /* 316624 */   GIR_Done,
     /* 316625 */ // Label 6393: @316625
     /* 316625 */ GIM_Reject,
     /* 316626 */ // Label 6356: @316626
     /* 316626 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(316656), // Rule ID 1017 //
     /* 316631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316645 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 316645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 316650 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316654 */   GIR_RootConstrainSelectedInstOperands,
     /* 316655 */   // GIR_Coverage, 1017,
     /* 316655 */   GIR_Done,
     /* 316656 */ // Label 6394: @316656
     /* 316656 */ GIM_Reject,
     /* 316657 */ // Label 6357: @316657
     /* 316657 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316687), // Rule ID 1021 //
     /* 316662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316676 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 316676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 316681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316685 */   GIR_RootConstrainSelectedInstOperands,
     /* 316686 */   // GIR_Coverage, 1021,
     /* 316686 */   GIR_Done,
     /* 316687 */ // Label 6395: @316687
     /* 316687 */ GIM_Reject,
     /* 316688 */ // Label 6358: @316688
     /* 316688 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(316718), // Rule ID 1013 //
     /* 316693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316707 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 316707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 316712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316716 */   GIR_RootConstrainSelectedInstOperands,
     /* 316717 */   // GIR_Coverage, 1013,
     /* 316717 */   GIR_Done,
     /* 316718 */ // Label 6396: @316718
     /* 316718 */ GIM_Reject,
     /* 316719 */ // Label 6359: @316719
     /* 316719 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(316749), // Rule ID 1019 //
     /* 316724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316738 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 316738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 316743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316747 */   GIR_RootConstrainSelectedInstOperands,
     /* 316748 */   // GIR_Coverage, 1019,
     /* 316748 */   GIR_Done,
     /* 316749 */ // Label 6397: @316749
     /* 316749 */ GIM_Reject,
     /* 316750 */ // Label 6360: @316750
     /* 316750 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(316780), // Rule ID 1015 //
     /* 316755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316769 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 316769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 316774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316778 */   GIR_RootConstrainSelectedInstOperands,
     /* 316779 */   // GIR_Coverage, 1015,
     /* 316779 */   GIR_Done,
     /* 316780 */ // Label 6398: @316780
     /* 316780 */ GIM_Reject,
     /* 316781 */ // Label 6361: @316781
     /* 316781 */ GIM_Reject,
     /* 316782 */ // Label 68: @316782
     /* 316782 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6407*/ GIMT_Encode4(320467),
     /* 316793 */ /*GILLT_s16*//*Label 6399*/ GIMT_Encode4(316833),
     /* 316797 */ /*GILLT_s32*//*Label 6400*/ GIMT_Encode4(317118),
     /* 316801 */ /*GILLT_s64*//*Label 6401*/ GIMT_Encode4(318446), GIMT_Encode4(0),
     /* 316809 */ /*GILLT_v2s32*//*Label 6402*/ GIMT_Encode4(320312),
     /* 316813 */ /*GILLT_v2s64*//*Label 6403*/ GIMT_Encode4(320343),
     /* 316817 */ /*GILLT_v4s16*//*Label 6404*/ GIMT_Encode4(320374),
     /* 316821 */ /*GILLT_v4s32*//*Label 6405*/ GIMT_Encode4(320405), GIMT_Encode4(0),
     /* 316829 */ /*GILLT_v8s16*//*Label 6406*/ GIMT_Encode4(320436),
     /* 316833 */ // Label 6399: @316833
     /* 316833 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(316940), // Rule ID 5311 //
     /* 316838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 316841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 316856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 316864 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316868 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316872 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316876 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316880 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316885 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316889 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 316900 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316902 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 316902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 316905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316914 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 316920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 316933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316938 */   GIR_RootConstrainSelectedInstOperands,
     /* 316939 */   // GIR_Coverage, 5311,
     /* 316939 */   GIR_EraseRootFromParent_Done,
     /* 316940 */ // Label 6408: @316940
     /* 316940 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(316997), // Rule ID 5305 //
     /* 316945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 316948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 316963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316969 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 316969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 316972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 316976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 316990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316995 */   GIR_RootConstrainSelectedInstOperands,
     /* 316996 */   // GIR_Coverage, 5305,
     /* 316996 */   GIR_EraseRootFromParent_Done,
     /* 316997 */ // Label 6409: @316997
     /* 316997 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(317027), // Rule ID 467 //
     /* 317002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317016 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 317016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 317021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317025 */   GIR_RootConstrainSelectedInstOperands,
     /* 317026 */   // GIR_Coverage, 467,
     /* 317026 */   GIR_Done,
     /* 317027 */ // Label 6410: @317027
     /* 317027 */ GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(317057), // Rule ID 473 //
     /* 317032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317046 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 317046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 317051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317055 */   GIR_RootConstrainSelectedInstOperands,
     /* 317056 */   // GIR_Coverage, 473,
     /* 317056 */   GIR_Done,
     /* 317057 */ // Label 6411: @317057
     /* 317057 */ GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(317087), // Rule ID 499 //
     /* 317062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317076 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 317076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 317081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317085 */   GIR_RootConstrainSelectedInstOperands,
     /* 317086 */   // GIR_Coverage, 499,
     /* 317086 */   GIR_Done,
     /* 317087 */ // Label 6412: @317087
     /* 317087 */ GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(317117), // Rule ID 503 //
     /* 317092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317106 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 317106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 317111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317115 */   GIR_RootConstrainSelectedInstOperands,
     /* 317116 */   // GIR_Coverage, 503,
     /* 317116 */   GIR_Done,
     /* 317117 */ // Label 6413: @317117
     /* 317117 */ GIM_Reject,
     /* 317118 */ // Label 6400: @317118
     /* 317118 */ GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(317258), // Rule ID 5312 //
     /* 317123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317141 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317144 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317151 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317157 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 317164 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 317171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317191 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317198 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317201 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317205 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317224 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317227 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317230 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317256 */   GIR_RootConstrainSelectedInstOperands,
     /* 317257 */   // GIR_Coverage, 5312,
     /* 317257 */   GIR_EraseRootFromParent_Done,
     /* 317258 */ // Label 6414: @317258
     /* 317258 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(317398), // Rule ID 5313 //
     /* 317263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317281 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317284 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317291 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317297 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 317304 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317304 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317307 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 317311 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317331 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317364 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317367 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317370 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317396 */   GIR_RootConstrainSelectedInstOperands,
     /* 317397 */   // GIR_Coverage, 5313,
     /* 317397 */   GIR_EraseRootFromParent_Done,
     /* 317398 */ // Label 6415: @317398
     /* 317398 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(317538), // Rule ID 5316 //
     /* 317403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317421 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317424 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317431 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317437 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 317444 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 317451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317471 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317478 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317481 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317485 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317507 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317510 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317536 */   GIR_RootConstrainSelectedInstOperands,
     /* 317537 */   // GIR_Coverage, 5316,
     /* 317537 */   GIR_EraseRootFromParent_Done,
     /* 317538 */ // Label 6416: @317538
     /* 317538 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(317678), // Rule ID 5317 //
     /* 317543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317561 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317564 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317571 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317577 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 317584 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317584 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317587 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 317591 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317611 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317618 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317621 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317625 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317644 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317647 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317650 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317658 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317676 */   GIR_RootConstrainSelectedInstOperands,
     /* 317677 */   // GIR_Coverage, 5317,
     /* 317677 */   GIR_EraseRootFromParent_Done,
     /* 317678 */ // Label 6417: @317678
     /* 317678 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(317813), // Rule ID 5314 //
     /* 317683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317701 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317704 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317711 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317717 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 317724 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 317724 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317727 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 317731 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317746 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317753 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317756 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317760 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317782 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317785 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317811 */   GIR_RootConstrainSelectedInstOperands,
     /* 317812 */   // GIR_Coverage, 5314,
     /* 317812 */   GIR_EraseRootFromParent_Done,
     /* 317813 */ // Label 6418: @317813
     /* 317813 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(317948), // Rule ID 5315 //
     /* 317818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317836 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317839 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317846 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317852 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 317859 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 317859 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317862 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 317866 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317881 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317888 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317891 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317895 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317914 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317917 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317920 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317928 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317933 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317943 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317946 */   GIR_RootConstrainSelectedInstOperands,
     /* 317947 */   // GIR_Coverage, 5315,
     /* 317947 */   GIR_EraseRootFromParent_Done,
     /* 317948 */ // Label 6419: @317948
     /* 317948 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(318083), // Rule ID 5318 //
     /* 317953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317963 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317971 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317974 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317981 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317987 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 317994 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 317994 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317997 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318001 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318016 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318023 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318026 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318030 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318049 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318055 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318081 */   GIR_RootConstrainSelectedInstOperands,
     /* 318082 */   // GIR_Coverage, 5318,
     /* 318082 */   GIR_EraseRootFromParent_Done,
     /* 318083 */ // Label 6420: @318083
     /* 318083 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(318218), // Rule ID 5319 //
     /* 318088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318106 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318109 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318116 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318122 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 318129 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 318129 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318132 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 318136 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318151 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318184 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318187 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318190 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318193 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318203 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318216 */   GIR_RootConstrainSelectedInstOperands,
     /* 318217 */   // GIR_Coverage, 5319,
     /* 318217 */   GIR_EraseRootFromParent_Done,
     /* 318218 */ // Label 6421: @318218
     /* 318218 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(318298), // Rule ID 5307 //
     /* 318223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318249 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318254 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318260 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 318260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318272 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 318278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318296 */   GIR_RootConstrainSelectedInstOperands,
     /* 318297 */   // GIR_Coverage, 5307,
     /* 318297 */   GIR_EraseRootFromParent_Done,
     /* 318298 */ // Label 6422: @318298
     /* 318298 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(318355), // Rule ID 5297 //
     /* 318303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 318321 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318327 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 318327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 318334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318339 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318353 */   GIR_RootConstrainSelectedInstOperands,
     /* 318354 */   // GIR_Coverage, 5297,
     /* 318354 */   GIR_EraseRootFromParent_Done,
     /* 318355 */ // Label 6423: @318355
     /* 318355 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(318385), // Rule ID 469 //
     /* 318360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318374 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 318374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 318379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318383 */   GIR_RootConstrainSelectedInstOperands,
     /* 318384 */   // GIR_Coverage, 469,
     /* 318384 */   GIR_Done,
     /* 318385 */ // Label 6424: @318385
     /* 318385 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(318415), // Rule ID 475 //
     /* 318390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318404 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 318404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 318409 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318413 */   GIR_RootConstrainSelectedInstOperands,
     /* 318414 */   // GIR_Coverage, 475,
     /* 318414 */   GIR_Done,
     /* 318415 */ // Label 6425: @318415
     /* 318415 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(318445), // Rule ID 505 //
     /* 318420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318434 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 318434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 318439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318443 */   GIR_RootConstrainSelectedInstOperands,
     /* 318444 */   // GIR_Coverage, 505,
     /* 318444 */   GIR_Done,
     /* 318445 */ // Label 6426: @318445
     /* 318445 */ GIM_Reject,
     /* 318446 */ // Label 6401: @318446
     /* 318446 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(318583), // Rule ID 5328 //
     /* 318451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318469 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318476 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318482 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 318489 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318489 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318492 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 318496 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318516 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318523 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318526 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318530 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318549 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318552 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318555 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318563 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318581 */   GIR_RootConstrainSelectedInstOperands,
     /* 318582 */   // GIR_Coverage, 5328,
     /* 318582 */   GIR_EraseRootFromParent_Done,
     /* 318583 */ // Label 6427: @318583
     /* 318583 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(318720), // Rule ID 5329 //
     /* 318588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318606 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318609 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318613 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318617 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318619 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 318626 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318626 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318629 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 318633 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318653 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318660 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318663 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318667 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318686 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318689 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318692 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318718 */   GIR_RootConstrainSelectedInstOperands,
     /* 318719 */   // GIR_Coverage, 5329,
     /* 318719 */   GIR_EraseRootFromParent_Done,
     /* 318720 */ // Label 6428: @318720
     /* 318720 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(318860), // Rule ID 5320 //
     /* 318725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318743 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318746 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 318766 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318766 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318769 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 318773 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318793 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318800 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318803 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318807 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318826 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318829 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318858 */   GIR_RootConstrainSelectedInstOperands,
     /* 318859 */   // GIR_Coverage, 5320,
     /* 318859 */   GIR_EraseRootFromParent_Done,
     /* 318860 */ // Label 6429: @318860
     /* 318860 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(319000), // Rule ID 5321 //
     /* 318865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318883 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318886 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318893 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318899 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 318906 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318906 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318909 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 318913 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318933 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318940 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318943 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318947 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318980 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318985 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318998 */   GIR_RootConstrainSelectedInstOperands,
     /* 318999 */   // GIR_Coverage, 5321,
     /* 318999 */   GIR_EraseRootFromParent_Done,
     /* 319000 */ // Label 6430: @319000
     /* 319000 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(319140), // Rule ID 5324 //
     /* 319005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319015 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319019 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319023 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319026 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319033 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319039 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 319046 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319046 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319049 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 319053 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319073 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319080 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319083 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319087 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319094 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319097 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319101 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319106 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319109 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319112 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319125 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319138 */   GIR_RootConstrainSelectedInstOperands,
     /* 319139 */   // GIR_Coverage, 5324,
     /* 319139 */   GIR_EraseRootFromParent_Done,
     /* 319140 */ // Label 6431: @319140
     /* 319140 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(319280), // Rule ID 5325 //
     /* 319145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319163 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319166 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319173 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319179 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 319186 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319186 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319189 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 319193 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319213 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319246 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319249 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319252 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319255 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319260 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319278 */   GIR_RootConstrainSelectedInstOperands,
     /* 319279 */   // GIR_Coverage, 5325,
     /* 319279 */   GIR_EraseRootFromParent_Done,
     /* 319280 */ // Label 6432: @319280
     /* 319280 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(319412), // Rule ID 5330 //
     /* 319285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319303 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 319323 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 319323 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319326 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 319330 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319345 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319352 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319355 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319359 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319378 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319381 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319384 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319410 */   GIR_RootConstrainSelectedInstOperands,
     /* 319411 */   // GIR_Coverage, 5330,
     /* 319411 */   GIR_EraseRootFromParent_Done,
     /* 319412 */ // Label 6433: @319412
     /* 319412 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(319544), // Rule ID 5331 //
     /* 319417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319435 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319442 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319448 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 319455 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 319455 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319458 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 319462 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319477 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319484 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319487 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319491 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319510 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319513 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319516 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319542 */   GIR_RootConstrainSelectedInstOperands,
     /* 319543 */   // GIR_Coverage, 5331,
     /* 319543 */   GIR_EraseRootFromParent_Done,
     /* 319544 */ // Label 6434: @319544
     /* 319544 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(319679), // Rule ID 5322 //
     /* 319549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319567 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319570 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319577 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319583 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 319590 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 319590 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319593 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 319597 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319612 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319645 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319677 */   GIR_RootConstrainSelectedInstOperands,
     /* 319678 */   // GIR_Coverage, 5322,
     /* 319678 */   GIR_EraseRootFromParent_Done,
     /* 319679 */ // Label 6435: @319679
     /* 319679 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(319814), // Rule ID 5323 //
     /* 319684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319702 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319705 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319712 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319718 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 319725 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 319725 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319728 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 319732 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319747 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319783 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319786 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319812 */   GIR_RootConstrainSelectedInstOperands,
     /* 319813 */   // GIR_Coverage, 5323,
     /* 319813 */   GIR_EraseRootFromParent_Done,
     /* 319814 */ // Label 6436: @319814
     /* 319814 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(319949), // Rule ID 5326 //
     /* 319819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319837 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319840 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319847 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319853 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 319860 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 319860 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319863 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 319867 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319882 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319889 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319892 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319896 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319915 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319918 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319921 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319947 */   GIR_RootConstrainSelectedInstOperands,
     /* 319948 */   // GIR_Coverage, 5326,
     /* 319948 */   GIR_EraseRootFromParent_Done,
     /* 319949 */ // Label 6437: @319949
     /* 319949 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(320084), // Rule ID 5327 //
     /* 319954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319964 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319968 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319972 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319975 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319982 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319988 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 319995 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 319995 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319998 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 320002 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320017 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320050 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320053 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320056 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320082 */   GIR_RootConstrainSelectedInstOperands,
     /* 320083 */   // GIR_Coverage, 5327,
     /* 320083 */   GIR_EraseRootFromParent_Done,
     /* 320084 */ // Label 6438: @320084
     /* 320084 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(320164), // Rule ID 5309 //
     /* 320089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320120 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320126 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320138 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320162 */   GIR_RootConstrainSelectedInstOperands,
     /* 320163 */   // GIR_Coverage, 5309,
     /* 320163 */   GIR_EraseRootFromParent_Done,
     /* 320164 */ // Label 6439: @320164
     /* 320164 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(320221), // Rule ID 5293 //
     /* 320169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320187 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320193 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 320193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 320200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320205 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320219 */   GIR_RootConstrainSelectedInstOperands,
     /* 320220 */   // GIR_Coverage, 5293,
     /* 320220 */   GIR_EraseRootFromParent_Done,
     /* 320221 */ // Label 6440: @320221
     /* 320221 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(320251), // Rule ID 471 //
     /* 320226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320240 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 320240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 320245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320249 */   GIR_RootConstrainSelectedInstOperands,
     /* 320250 */   // GIR_Coverage, 471,
     /* 320250 */   GIR_Done,
     /* 320251 */ // Label 6441: @320251
     /* 320251 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(320281), // Rule ID 477 //
     /* 320256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320270 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 320270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 320275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320279 */   GIR_RootConstrainSelectedInstOperands,
     /* 320280 */   // GIR_Coverage, 477,
     /* 320280 */   GIR_Done,
     /* 320281 */ // Label 6442: @320281
     /* 320281 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(320311), // Rule ID 501 //
     /* 320286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320300 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 320300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 320305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320309 */   GIR_RootConstrainSelectedInstOperands,
     /* 320310 */   // GIR_Coverage, 501,
     /* 320310 */   GIR_Done,
     /* 320311 */ // Label 6443: @320311
     /* 320311 */ GIM_Reject,
     /* 320312 */ // Label 6402: @320312
     /* 320312 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(320342), // Rule ID 1078 //
     /* 320317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320331 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 320331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 320336 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320340 */   GIR_RootConstrainSelectedInstOperands,
     /* 320341 */   // GIR_Coverage, 1078,
     /* 320341 */   GIR_Done,
     /* 320342 */ // Label 6444: @320342
     /* 320342 */ GIM_Reject,
     /* 320343 */ // Label 6403: @320343
     /* 320343 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(320373), // Rule ID 1082 //
     /* 320348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320362 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 320362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 320367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320371 */   GIR_RootConstrainSelectedInstOperands,
     /* 320372 */   // GIR_Coverage, 1082,
     /* 320372 */   GIR_Done,
     /* 320373 */ // Label 6445: @320373
     /* 320373 */ GIM_Reject,
     /* 320374 */ // Label 6404: @320374
     /* 320374 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(320404), // Rule ID 1074 //
     /* 320379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320393 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 320393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 320398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320402 */   GIR_RootConstrainSelectedInstOperands,
     /* 320403 */   // GIR_Coverage, 1074,
     /* 320403 */   GIR_Done,
     /* 320404 */ // Label 6446: @320404
     /* 320404 */ GIM_Reject,
     /* 320405 */ // Label 6405: @320405
     /* 320405 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(320435), // Rule ID 1080 //
     /* 320410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320424 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 320424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 320429 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320433 */   GIR_RootConstrainSelectedInstOperands,
     /* 320434 */   // GIR_Coverage, 1080,
     /* 320434 */   GIR_Done,
     /* 320435 */ // Label 6447: @320435
     /* 320435 */ GIM_Reject,
     /* 320436 */ // Label 6406: @320436
     /* 320436 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(320466), // Rule ID 1076 //
     /* 320441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320455 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 320455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 320460 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320464 */   GIR_RootConstrainSelectedInstOperands,
     /* 320465 */   // GIR_Coverage, 1076,
     /* 320465 */   GIR_Done,
     /* 320466 */ // Label 6448: @320466
     /* 320466 */ GIM_Reject,
     /* 320467 */ // Label 6407: @320467
     /* 320467 */ GIM_Reject,
     /* 320468 */ // Label 69: @320468
     /* 320468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6456*/ GIMT_Encode4(320787),
     /* 320479 */ /*GILLT_s32*//*Label 6449*/ GIMT_Encode4(320515),
     /* 320483 */ /*GILLT_s64*//*Label 6450*/ GIMT_Encode4(320588), GIMT_Encode4(0),
     /* 320491 */ /*GILLT_v2s32*//*Label 6451*/ GIMT_Encode4(320661),
     /* 320495 */ /*GILLT_v2s64*//*Label 6452*/ GIMT_Encode4(320685),
     /* 320499 */ /*GILLT_v4s16*//*Label 6453*/ GIMT_Encode4(320709),
     /* 320503 */ /*GILLT_v4s32*//*Label 6454*/ GIMT_Encode4(320736), GIMT_Encode4(0),
     /* 320511 */ /*GILLT_v8s16*//*Label 6455*/ GIMT_Encode4(320760),
     /* 320515 */ // Label 6449: @320515
     /* 320515 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(320541), // Rule ID 4573 //
     /* 320520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320530 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 320530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 320535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320539 */   GIR_RootConstrainSelectedInstOperands,
     /* 320540 */   // GIR_Coverage, 4573,
     /* 320540 */   GIR_Done,
     /* 320541 */ // Label 6457: @320541
     /* 320541 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(320564), // Rule ID 4575 //
     /* 320546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320553 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 320553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 320558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320562 */   GIR_RootConstrainSelectedInstOperands,
     /* 320563 */   // GIR_Coverage, 4575,
     /* 320563 */   GIR_Done,
     /* 320564 */ // Label 6458: @320564
     /* 320564 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(320587), // Rule ID 4577 //
     /* 320569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320576 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 320576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 320581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320585 */   GIR_RootConstrainSelectedInstOperands,
     /* 320586 */   // GIR_Coverage, 4577,
     /* 320586 */   GIR_Done,
     /* 320587 */ // Label 6459: @320587
     /* 320587 */ GIM_Reject,
     /* 320588 */ // Label 6450: @320588
     /* 320588 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(320614), // Rule ID 4574 //
     /* 320593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320603 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 320608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320612 */   GIR_RootConstrainSelectedInstOperands,
     /* 320613 */   // GIR_Coverage, 4574,
     /* 320613 */   GIR_Done,
     /* 320614 */ // Label 6460: @320614
     /* 320614 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(320637), // Rule ID 4576 //
     /* 320619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320626 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 320631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320635 */   GIR_RootConstrainSelectedInstOperands,
     /* 320636 */   // GIR_Coverage, 4576,
     /* 320636 */   GIR_Done,
     /* 320637 */ // Label 6461: @320637
     /* 320637 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(320660), // Rule ID 4578 //
     /* 320642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320649 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 320654 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320658 */   GIR_RootConstrainSelectedInstOperands,
     /* 320659 */   // GIR_Coverage, 4578,
     /* 320659 */   GIR_Done,
     /* 320660 */ // Label 6462: @320660
     /* 320660 */ GIM_Reject,
     /* 320661 */ // Label 6451: @320661
     /* 320661 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(320684), // Rule ID 4914 //
     /* 320666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320673 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 320673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 320678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320682 */   GIR_RootConstrainSelectedInstOperands,
     /* 320683 */   // GIR_Coverage, 4914,
     /* 320683 */   GIR_Done,
     /* 320684 */ // Label 6463: @320684
     /* 320684 */ GIM_Reject,
     /* 320685 */ // Label 6452: @320685
     /* 320685 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(320708), // Rule ID 4916 //
     /* 320690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320697 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 320697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 320702 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320706 */   GIR_RootConstrainSelectedInstOperands,
     /* 320707 */   // GIR_Coverage, 4916,
     /* 320707 */   GIR_Done,
     /* 320708 */ // Label 6464: @320708
     /* 320708 */ GIM_Reject,
     /* 320709 */ // Label 6453: @320709
     /* 320709 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(320735), // Rule ID 4909 //
     /* 320714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320724 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 320724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 320729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320733 */   GIR_RootConstrainSelectedInstOperands,
     /* 320734 */   // GIR_Coverage, 4909,
     /* 320734 */   GIR_Done,
     /* 320735 */ // Label 6465: @320735
     /* 320735 */ GIM_Reject,
     /* 320736 */ // Label 6454: @320736
     /* 320736 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(320759), // Rule ID 4915 //
     /* 320741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320748 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 320748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 320753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320757 */   GIR_RootConstrainSelectedInstOperands,
     /* 320758 */   // GIR_Coverage, 4915,
     /* 320758 */   GIR_Done,
     /* 320759 */ // Label 6466: @320759
     /* 320759 */ GIM_Reject,
     /* 320760 */ // Label 6455: @320760
     /* 320760 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(320786), // Rule ID 4910 //
     /* 320765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320775 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 320775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 320780 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320784 */   GIR_RootConstrainSelectedInstOperands,
     /* 320785 */   // GIR_Coverage, 4910,
     /* 320785 */   GIR_Done,
     /* 320786 */ // Label 6467: @320786
     /* 320786 */ GIM_Reject,
     /* 320787 */ // Label 6456: @320787
     /* 320787 */ GIM_Reject,
     /* 320788 */ // Label 70: @320788
     /* 320788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6475*/ GIMT_Encode4(321107),
     /* 320799 */ /*GILLT_s32*//*Label 6468*/ GIMT_Encode4(320835),
     /* 320803 */ /*GILLT_s64*//*Label 6469*/ GIMT_Encode4(320908), GIMT_Encode4(0),
     /* 320811 */ /*GILLT_v2s32*//*Label 6470*/ GIMT_Encode4(320981),
     /* 320815 */ /*GILLT_v2s64*//*Label 6471*/ GIMT_Encode4(321005),
     /* 320819 */ /*GILLT_v4s16*//*Label 6472*/ GIMT_Encode4(321029),
     /* 320823 */ /*GILLT_v4s32*//*Label 6473*/ GIMT_Encode4(321056), GIMT_Encode4(0),
     /* 320831 */ /*GILLT_v8s16*//*Label 6474*/ GIMT_Encode4(321080),
     /* 320835 */ // Label 6468: @320835
     /* 320835 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(320861), // Rule ID 4597 //
     /* 320840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320850 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 320850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 320855 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320859 */   GIR_RootConstrainSelectedInstOperands,
     /* 320860 */   // GIR_Coverage, 4597,
     /* 320860 */   GIR_Done,
     /* 320861 */ // Label 6476: @320861
     /* 320861 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(320884), // Rule ID 4599 //
     /* 320866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320873 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 320873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 320878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320882 */   GIR_RootConstrainSelectedInstOperands,
     /* 320883 */   // GIR_Coverage, 4599,
     /* 320883 */   GIR_Done,
     /* 320884 */ // Label 6477: @320884
     /* 320884 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(320907), // Rule ID 4601 //
     /* 320889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320896 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 320896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 320901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320905 */   GIR_RootConstrainSelectedInstOperands,
     /* 320906 */   // GIR_Coverage, 4601,
     /* 320906 */   GIR_Done,
     /* 320907 */ // Label 6478: @320907
     /* 320907 */ GIM_Reject,
     /* 320908 */ // Label 6469: @320908
     /* 320908 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(320934), // Rule ID 4598 //
     /* 320913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320923 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 320928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320932 */   GIR_RootConstrainSelectedInstOperands,
     /* 320933 */   // GIR_Coverage, 4598,
     /* 320933 */   GIR_Done,
     /* 320934 */ // Label 6479: @320934
     /* 320934 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(320957), // Rule ID 4600 //
     /* 320939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320946 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 320951 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320955 */   GIR_RootConstrainSelectedInstOperands,
     /* 320956 */   // GIR_Coverage, 4600,
     /* 320956 */   GIR_Done,
     /* 320957 */ // Label 6480: @320957
     /* 320957 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(320980), // Rule ID 4602 //
     /* 320962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320969 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 320974 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320978 */   GIR_RootConstrainSelectedInstOperands,
     /* 320979 */   // GIR_Coverage, 4602,
     /* 320979 */   GIR_Done,
     /* 320980 */ // Label 6481: @320980
     /* 320980 */ GIM_Reject,
     /* 320981 */ // Label 6470: @320981
     /* 320981 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(321004), // Rule ID 4924 //
     /* 320986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320993 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 320993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 320998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321002 */   GIR_RootConstrainSelectedInstOperands,
     /* 321003 */   // GIR_Coverage, 4924,
     /* 321003 */   GIR_Done,
     /* 321004 */ // Label 6482: @321004
     /* 321004 */ GIM_Reject,
     /* 321005 */ // Label 6471: @321005
     /* 321005 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(321028), // Rule ID 4926 //
     /* 321010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321017 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 321022 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321026 */   GIR_RootConstrainSelectedInstOperands,
     /* 321027 */   // GIR_Coverage, 4926,
     /* 321027 */   GIR_Done,
     /* 321028 */ // Label 6483: @321028
     /* 321028 */ GIM_Reject,
     /* 321029 */ // Label 6472: @321029
     /* 321029 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(321055), // Rule ID 4919 //
     /* 321034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321044 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 321049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321053 */   GIR_RootConstrainSelectedInstOperands,
     /* 321054 */   // GIR_Coverage, 4919,
     /* 321054 */   GIR_Done,
     /* 321055 */ // Label 6484: @321055
     /* 321055 */ GIM_Reject,
     /* 321056 */ // Label 6473: @321056
     /* 321056 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(321079), // Rule ID 4925 //
     /* 321061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321068 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 321073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321077 */   GIR_RootConstrainSelectedInstOperands,
     /* 321078 */   // GIR_Coverage, 4925,
     /* 321078 */   GIR_Done,
     /* 321079 */ // Label 6485: @321079
     /* 321079 */ GIM_Reject,
     /* 321080 */ // Label 6474: @321080
     /* 321080 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(321106), // Rule ID 4920 //
     /* 321085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321095 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 321100 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321104 */   GIR_RootConstrainSelectedInstOperands,
     /* 321105 */   // GIR_Coverage, 4920,
     /* 321105 */   GIR_Done,
     /* 321106 */ // Label 6486: @321106
     /* 321106 */ GIM_Reject,
     /* 321107 */ // Label 6475: @321107
     /* 321107 */ GIM_Reject,
     /* 321108 */ // Label 71: @321108
     /* 321108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6495*/ GIMT_Encode4(321964),
     /* 321119 */ /*GILLT_s16*//*Label 6487*/ GIMT_Encode4(321159),
     /* 321123 */ /*GILLT_s32*//*Label 6488*/ GIMT_Encode4(321378),
     /* 321127 */ /*GILLT_s64*//*Label 6489*/ GIMT_Encode4(321452), GIMT_Encode4(0),
     /* 321135 */ /*GILLT_v2s32*//*Label 6490*/ GIMT_Encode4(321526),
     /* 321139 */ /*GILLT_v2s64*//*Label 6491*/ GIMT_Encode4(321600),
     /* 321143 */ /*GILLT_v4s16*//*Label 6492*/ GIMT_Encode4(321674),
     /* 321147 */ /*GILLT_v4s32*//*Label 6493*/ GIMT_Encode4(321782), GIMT_Encode4(0),
     /* 321155 */ /*GILLT_v8s16*//*Label 6494*/ GIMT_Encode4(321856),
     /* 321159 */ // Label 6487: @321159
     /* 321159 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(321377),
     /* 321164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321171 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(321212), // Rule ID 5195 //
     /* 321176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321197 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 321197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 321200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321210 */     GIR_RootConstrainSelectedInstOperands,
     /* 321211 */     // GIR_Coverage, 5195,
     /* 321211 */     GIR_EraseRootFromParent_Done,
     /* 321212 */   // Label 6497: @321212
     /* 321212 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(321231), // Rule ID 521 //
     /* 321217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321224 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 321224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 321229 */     GIR_RootConstrainSelectedInstOperands,
     /* 321230 */     // GIR_Coverage, 521,
     /* 321230 */     GIR_Done,
     /* 321231 */   // Label 6498: @321231
     /* 321231 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(321376), // Rule ID 6341 //
     /* 321236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321240 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 321240 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 321243 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321247 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 321254 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 321257 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321261 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321266 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 321269 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321273 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 321276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321281 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321286 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321291 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321294 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321298 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321303 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 321306 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 321318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321323 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321326 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 321331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321358 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 321365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321375 */     // GIR_Coverage, 6341,
     /* 321375 */     GIR_EraseRootFromParent_Done,
     /* 321376 */   // Label 6499: @321376
     /* 321376 */   GIM_Reject,
     /* 321377 */ // Label 6496: @321377
     /* 321377 */ GIM_Reject,
     /* 321378 */ // Label 6488: @321378
     /* 321378 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(321451),
     /* 321383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321390 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(321431), // Rule ID 5196 //
     /* 321395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 321414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321416 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 321416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 321419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321429 */     GIR_RootConstrainSelectedInstOperands,
     /* 321430 */     // GIR_Coverage, 5196,
     /* 321430 */     GIR_EraseRootFromParent_Done,
     /* 321431 */   // Label 6501: @321431
     /* 321431 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(321450), // Rule ID 522 //
     /* 321436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321443 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 321443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 321448 */     GIR_RootConstrainSelectedInstOperands,
     /* 321449 */     // GIR_Coverage, 522,
     /* 321449 */     GIR_Done,
     /* 321450 */   // Label 6502: @321450
     /* 321450 */   GIM_Reject,
     /* 321451 */ // Label 6500: @321451
     /* 321451 */ GIM_Reject,
     /* 321452 */ // Label 6489: @321452
     /* 321452 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(321525),
     /* 321457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321464 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(321505), // Rule ID 5197 //
     /* 321469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321490 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 321490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 321493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321503 */     GIR_RootConstrainSelectedInstOperands,
     /* 321504 */     // GIR_Coverage, 5197,
     /* 321504 */     GIR_EraseRootFromParent_Done,
     /* 321505 */   // Label 6504: @321505
     /* 321505 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(321524), // Rule ID 523 //
     /* 321510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321517 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 321517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 321522 */     GIR_RootConstrainSelectedInstOperands,
     /* 321523 */     // GIR_Coverage, 523,
     /* 321523 */     GIR_Done,
     /* 321524 */   // Label 6505: @321524
     /* 321524 */   GIM_Reject,
     /* 321525 */ // Label 6503: @321525
     /* 321525 */ GIM_Reject,
     /* 321526 */ // Label 6490: @321526
     /* 321526 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(321599),
     /* 321531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321538 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(321579), // Rule ID 4988 //
     /* 321543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 321562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321564 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 321564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 321567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321577 */     GIR_RootConstrainSelectedInstOperands,
     /* 321578 */     // GIR_Coverage, 4988,
     /* 321578 */     GIR_EraseRootFromParent_Done,
     /* 321579 */   // Label 6507: @321579
     /* 321579 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(321598), // Rule ID 768 //
     /* 321584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321591 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 321591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 321596 */     GIR_RootConstrainSelectedInstOperands,
     /* 321597 */     // GIR_Coverage, 768,
     /* 321597 */     GIR_Done,
     /* 321598 */   // Label 6508: @321598
     /* 321598 */   GIM_Reject,
     /* 321599 */ // Label 6506: @321599
     /* 321599 */ GIM_Reject,
     /* 321600 */ // Label 6491: @321600
     /* 321600 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(321673),
     /* 321605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321612 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(321653), // Rule ID 4990 //
     /* 321617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321638 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 321638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 321641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321651 */     GIR_RootConstrainSelectedInstOperands,
     /* 321652 */     // GIR_Coverage, 4990,
     /* 321652 */     GIR_EraseRootFromParent_Done,
     /* 321653 */   // Label 6510: @321653
     /* 321653 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(321672), // Rule ID 770 //
     /* 321658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321665 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 321665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 321670 */     GIR_RootConstrainSelectedInstOperands,
     /* 321671 */     // GIR_Coverage, 770,
     /* 321671 */     GIR_Done,
     /* 321672 */   // Label 6511: @321672
     /* 321672 */   GIM_Reject,
     /* 321673 */ // Label 6509: @321673
     /* 321673 */ GIM_Reject,
     /* 321674 */ // Label 6492: @321674
     /* 321674 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(321781),
     /* 321679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321686 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(321727), // Rule ID 4991 //
     /* 321691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321712 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 321712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 321715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321725 */     GIR_RootConstrainSelectedInstOperands,
     /* 321726 */     // GIR_Coverage, 4991,
     /* 321726 */     GIR_EraseRootFromParent_Done,
     /* 321727 */   // Label 6513: @321727
     /* 321727 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(321746), // Rule ID 766 //
     /* 321732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321739 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 321739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 321744 */     GIR_RootConstrainSelectedInstOperands,
     /* 321745 */     // GIR_Coverage, 766,
     /* 321745 */     GIR_Done,
     /* 321746 */   // Label 6514: @321746
     /* 321746 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(321780), // Rule ID 6343 //
     /* 321751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321758 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 321758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 321761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321765 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 321775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 321778 */     GIR_RootConstrainSelectedInstOperands,
     /* 321779 */     // GIR_Coverage, 6343,
     /* 321779 */     GIR_EraseRootFromParent_Done,
     /* 321780 */   // Label 6515: @321780
     /* 321780 */   GIM_Reject,
     /* 321781 */ // Label 6512: @321781
     /* 321781 */ GIM_Reject,
     /* 321782 */ // Label 6493: @321782
     /* 321782 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(321855),
     /* 321787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321794 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(321835), // Rule ID 4989 //
     /* 321799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 321818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321820 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 321820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 321823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321833 */     GIR_RootConstrainSelectedInstOperands,
     /* 321834 */     // GIR_Coverage, 4989,
     /* 321834 */     GIR_EraseRootFromParent_Done,
     /* 321835 */   // Label 6517: @321835
     /* 321835 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(321854), // Rule ID 769 //
     /* 321840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321847 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 321847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 321852 */     GIR_RootConstrainSelectedInstOperands,
     /* 321853 */     // GIR_Coverage, 769,
     /* 321853 */     GIR_Done,
     /* 321854 */   // Label 6518: @321854
     /* 321854 */   GIM_Reject,
     /* 321855 */ // Label 6516: @321855
     /* 321855 */ GIM_Reject,
     /* 321856 */ // Label 6494: @321856
     /* 321856 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(321963),
     /* 321861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321868 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(321909), // Rule ID 4992 //
     /* 321873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 321892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321894 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 321894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 321897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321907 */     GIR_RootConstrainSelectedInstOperands,
     /* 321908 */     // GIR_Coverage, 4992,
     /* 321908 */     GIR_EraseRootFromParent_Done,
     /* 321909 */   // Label 6520: @321909
     /* 321909 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(321928), // Rule ID 767 //
     /* 321914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321921 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 321921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 321926 */     GIR_RootConstrainSelectedInstOperands,
     /* 321927 */     // GIR_Coverage, 767,
     /* 321927 */     GIR_Done,
     /* 321928 */   // Label 6521: @321928
     /* 321928 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(321962), // Rule ID 6344 //
     /* 321933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321940 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 321940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 321943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321947 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 321957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 321960 */     GIR_RootConstrainSelectedInstOperands,
     /* 321961 */     // GIR_Coverage, 6344,
     /* 321961 */     GIR_EraseRootFromParent_Done,
     /* 321962 */   // Label 6522: @321962
     /* 321962 */   GIM_Reject,
     /* 321963 */ // Label 6519: @321963
     /* 321963 */ GIM_Reject,
     /* 321964 */ // Label 6495: @321964
     /* 321964 */ GIM_Reject,
     /* 321965 */ // Label 72: @321965
     /* 321965 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6531*/ GIMT_Encode4(322246),
     /* 321976 */ /*GILLT_s16*//*Label 6523*/ GIMT_Encode4(322016),
     /* 321980 */ /*GILLT_s32*//*Label 6524*/ GIMT_Encode4(322043),
     /* 321984 */ /*GILLT_s64*//*Label 6525*/ GIMT_Encode4(322067), GIMT_Encode4(0),
     /* 321992 */ /*GILLT_v2s32*//*Label 6526*/ GIMT_Encode4(322091),
     /* 321996 */ /*GILLT_v2s64*//*Label 6527*/ GIMT_Encode4(322122),
     /* 322000 */ /*GILLT_v4s16*//*Label 6528*/ GIMT_Encode4(322153),
     /* 322004 */ /*GILLT_v4s32*//*Label 6529*/ GIMT_Encode4(322184), GIMT_Encode4(0),
     /* 322012 */ /*GILLT_v8s16*//*Label 6530*/ GIMT_Encode4(322215),
     /* 322016 */ // Label 6523: @322016
     /* 322016 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(322042), // Rule ID 4813 //
     /* 322021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322031 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 322031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322036 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322038 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322040 */   GIR_RootConstrainSelectedInstOperands,
     /* 322041 */   // GIR_Coverage, 4813,
     /* 322041 */   GIR_EraseRootFromParent_Done,
     /* 322042 */ // Label 6532: @322042
     /* 322042 */ GIM_Reject,
     /* 322043 */ // Label 6524: @322043
     /* 322043 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(322066), // Rule ID 4810 //
     /* 322048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322055 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 322055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322060 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322062 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322064 */   GIR_RootConstrainSelectedInstOperands,
     /* 322065 */   // GIR_Coverage, 4810,
     /* 322065 */   GIR_EraseRootFromParent_Done,
     /* 322066 */ // Label 6533: @322066
     /* 322066 */ GIM_Reject,
     /* 322067 */ // Label 6525: @322067
     /* 322067 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(322090), // Rule ID 4807 //
     /* 322072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322079 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 322079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322084 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322086 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322088 */   GIR_RootConstrainSelectedInstOperands,
     /* 322089 */   // GIR_Coverage, 4807,
     /* 322089 */   GIR_EraseRootFromParent_Done,
     /* 322090 */ // Label 6534: @322090
     /* 322090 */ GIM_Reject,
     /* 322091 */ // Label 6526: @322091
     /* 322091 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(322121), // Rule ID 5001 //
     /* 322096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322110 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 322110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322117 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322119 */   GIR_RootConstrainSelectedInstOperands,
     /* 322120 */   // GIR_Coverage, 5001,
     /* 322120 */   GIR_EraseRootFromParent_Done,
     /* 322121 */ // Label 6535: @322121
     /* 322121 */ GIM_Reject,
     /* 322122 */ // Label 6527: @322122
     /* 322122 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(322152), // Rule ID 4995 //
     /* 322127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322141 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 322141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322146 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322148 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322150 */   GIR_RootConstrainSelectedInstOperands,
     /* 322151 */   // GIR_Coverage, 4995,
     /* 322151 */   GIR_EraseRootFromParent_Done,
     /* 322152 */ // Label 6536: @322152
     /* 322152 */ GIM_Reject,
     /* 322153 */ // Label 6528: @322153
     /* 322153 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(322183), // Rule ID 5007 //
     /* 322158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322172 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 322172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322177 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322181 */   GIR_RootConstrainSelectedInstOperands,
     /* 322182 */   // GIR_Coverage, 5007,
     /* 322182 */   GIR_EraseRootFromParent_Done,
     /* 322183 */ // Label 6537: @322183
     /* 322183 */ GIM_Reject,
     /* 322184 */ // Label 6529: @322184
     /* 322184 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(322214), // Rule ID 4998 //
     /* 322189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322203 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 322203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322208 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322210 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322212 */   GIR_RootConstrainSelectedInstOperands,
     /* 322213 */   // GIR_Coverage, 4998,
     /* 322213 */   GIR_EraseRootFromParent_Done,
     /* 322214 */ // Label 6538: @322214
     /* 322214 */ GIM_Reject,
     /* 322215 */ // Label 6530: @322215
     /* 322215 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(322245), // Rule ID 5004 //
     /* 322220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322234 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 322234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322239 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322241 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322243 */   GIR_RootConstrainSelectedInstOperands,
     /* 322244 */   // GIR_Coverage, 5004,
     /* 322244 */   GIR_EraseRootFromParent_Done,
     /* 322245 */ // Label 6539: @322245
     /* 322245 */ GIM_Reject,
     /* 322246 */ // Label 6531: @322246
     /* 322246 */ GIM_Reject,
     /* 322247 */ // Label 73: @322247
     /* 322247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6548*/ GIMT_Encode4(322624),
     /* 322258 */ /*GILLT_s16*//*Label 6540*/ GIMT_Encode4(322298),
     /* 322262 */ /*GILLT_s32*//*Label 6541*/ GIMT_Encode4(322336),
     /* 322266 */ /*GILLT_s64*//*Label 6542*/ GIMT_Encode4(322374), GIMT_Encode4(0),
     /* 322274 */ /*GILLT_v2s32*//*Label 6543*/ GIMT_Encode4(322434),
     /* 322278 */ /*GILLT_v2s64*//*Label 6544*/ GIMT_Encode4(322472),
     /* 322282 */ /*GILLT_v4s16*//*Label 6545*/ GIMT_Encode4(322510),
     /* 322286 */ /*GILLT_v4s32*//*Label 6546*/ GIMT_Encode4(322548), GIMT_Encode4(0),
     /* 322294 */ /*GILLT_v8s16*//*Label 6547*/ GIMT_Encode4(322586),
     /* 322298 */ // Label 6540: @322298
     /* 322298 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(322335), // Rule ID 608 //
     /* 322303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 322312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322324 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 322324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322333 */   GIR_RootConstrainSelectedInstOperands,
     /* 322334 */   // GIR_Coverage, 608,
     /* 322334 */   GIR_Done,
     /* 322335 */ // Label 6549: @322335
     /* 322335 */ GIM_Reject,
     /* 322336 */ // Label 6541: @322336
     /* 322336 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(322373), // Rule ID 610 //
     /* 322341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322362 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 322362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322371 */   GIR_RootConstrainSelectedInstOperands,
     /* 322372 */   // GIR_Coverage, 610,
     /* 322372 */   GIR_Done,
     /* 322373 */ // Label 6550: @322373
     /* 322373 */ GIM_Reject,
     /* 322374 */ // Label 6542: @322374
     /* 322374 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(322433),
     /* 322379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322397 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(322416), // Rule ID 612 //
     /* 322402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322405 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 322405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322414 */     GIR_RootConstrainSelectedInstOperands,
     /* 322415 */     // GIR_Coverage, 612,
     /* 322415 */     GIR_Done,
     /* 322416 */   // Label 6552: @322416
     /* 322416 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(322432), // Rule ID 4804 //
     /* 322421 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 322421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322430 */     GIR_RootConstrainSelectedInstOperands,
     /* 322431 */     // GIR_Coverage, 4804,
     /* 322431 */     GIR_Done,
     /* 322432 */   // Label 6553: @322432
     /* 322432 */   GIM_Reject,
     /* 322433 */ // Label 6551: @322433
     /* 322433 */ GIM_Reject,
     /* 322434 */ // Label 6543: @322434
     /* 322434 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(322471), // Rule ID 1273 //
     /* 322439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322460 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 322460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322469 */   GIR_RootConstrainSelectedInstOperands,
     /* 322470 */   // GIR_Coverage, 1273,
     /* 322470 */   GIR_Done,
     /* 322471 */ // Label 6554: @322471
     /* 322471 */ GIM_Reject,
     /* 322472 */ // Label 6544: @322472
     /* 322472 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(322509), // Rule ID 1277 //
     /* 322477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 322486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322498 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322507 */   GIR_RootConstrainSelectedInstOperands,
     /* 322508 */   // GIR_Coverage, 1277,
     /* 322508 */   GIR_Done,
     /* 322509 */ // Label 6555: @322509
     /* 322509 */ GIM_Reject,
     /* 322510 */ // Label 6545: @322510
     /* 322510 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(322547), // Rule ID 1269 //
     /* 322515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322536 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322545 */   GIR_RootConstrainSelectedInstOperands,
     /* 322546 */   // GIR_Coverage, 1269,
     /* 322546 */   GIR_Done,
     /* 322547 */ // Label 6556: @322547
     /* 322547 */ GIM_Reject,
     /* 322548 */ // Label 6546: @322548
     /* 322548 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(322585), // Rule ID 1275 //
     /* 322553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322574 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322583 */   GIR_RootConstrainSelectedInstOperands,
     /* 322584 */   // GIR_Coverage, 1275,
     /* 322584 */   GIR_Done,
     /* 322585 */ // Label 6557: @322585
     /* 322585 */ GIM_Reject,
     /* 322586 */ // Label 6547: @322586
     /* 322586 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(322623), // Rule ID 1271 //
     /* 322591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322612 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 322612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322621 */   GIR_RootConstrainSelectedInstOperands,
     /* 322622 */   // GIR_Coverage, 1271,
     /* 322622 */   GIR_Done,
     /* 322623 */ // Label 6558: @322623
     /* 322623 */ GIM_Reject,
     /* 322624 */ // Label 6548: @322624
     /* 322624 */ GIM_Reject,
     /* 322625 */ // Label 74: @322625
     /* 322625 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6567*/ GIMT_Encode4(323002),
     /* 322636 */ /*GILLT_s16*//*Label 6559*/ GIMT_Encode4(322676),
     /* 322640 */ /*GILLT_s32*//*Label 6560*/ GIMT_Encode4(322714),
     /* 322644 */ /*GILLT_s64*//*Label 6561*/ GIMT_Encode4(322752), GIMT_Encode4(0),
     /* 322652 */ /*GILLT_v2s32*//*Label 6562*/ GIMT_Encode4(322812),
     /* 322656 */ /*GILLT_v2s64*//*Label 6563*/ GIMT_Encode4(322850),
     /* 322660 */ /*GILLT_v4s16*//*Label 6564*/ GIMT_Encode4(322888),
     /* 322664 */ /*GILLT_v4s32*//*Label 6565*/ GIMT_Encode4(322926), GIMT_Encode4(0),
     /* 322672 */ /*GILLT_v8s16*//*Label 6566*/ GIMT_Encode4(322964),
     /* 322676 */ // Label 6559: @322676
     /* 322676 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(322713), // Rule ID 596 //
     /* 322681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 322690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322702 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 322702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 322707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322711 */   GIR_RootConstrainSelectedInstOperands,
     /* 322712 */   // GIR_Coverage, 596,
     /* 322712 */   GIR_Done,
     /* 322713 */ // Label 6568: @322713
     /* 322713 */ GIM_Reject,
     /* 322714 */ // Label 6560: @322714
     /* 322714 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(322751), // Rule ID 598 //
     /* 322719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322740 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 322740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 322745 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322749 */   GIR_RootConstrainSelectedInstOperands,
     /* 322750 */   // GIR_Coverage, 598,
     /* 322750 */   GIR_Done,
     /* 322751 */ // Label 6569: @322751
     /* 322751 */ GIM_Reject,
     /* 322752 */ // Label 6561: @322752
     /* 322752 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(322811),
     /* 322757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322775 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(322794), // Rule ID 600 //
     /* 322780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322783 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 322783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 322788 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322792 */     GIR_RootConstrainSelectedInstOperands,
     /* 322793 */     // GIR_Coverage, 600,
     /* 322793 */     GIR_Done,
     /* 322794 */   // Label 6571: @322794
     /* 322794 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(322810), // Rule ID 4803 //
     /* 322799 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 322799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 322804 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322808 */     GIR_RootConstrainSelectedInstOperands,
     /* 322809 */     // GIR_Coverage, 4803,
     /* 322809 */     GIR_Done,
     /* 322810 */   // Label 6572: @322810
     /* 322810 */   GIM_Reject,
     /* 322811 */ // Label 6570: @322811
     /* 322811 */ GIM_Reject,
     /* 322812 */ // Label 6562: @322812
     /* 322812 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(322849), // Rule ID 1243 //
     /* 322817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322838 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 322838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 322843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322847 */   GIR_RootConstrainSelectedInstOperands,
     /* 322848 */   // GIR_Coverage, 1243,
     /* 322848 */   GIR_Done,
     /* 322849 */ // Label 6573: @322849
     /* 322849 */ GIM_Reject,
     /* 322850 */ // Label 6563: @322850
     /* 322850 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(322887), // Rule ID 1247 //
     /* 322855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 322864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322876 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 322881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322885 */   GIR_RootConstrainSelectedInstOperands,
     /* 322886 */   // GIR_Coverage, 1247,
     /* 322886 */   GIR_Done,
     /* 322887 */ // Label 6574: @322887
     /* 322887 */ GIM_Reject,
     /* 322888 */ // Label 6564: @322888
     /* 322888 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(322925), // Rule ID 1239 //
     /* 322893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322914 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 322919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322923 */   GIR_RootConstrainSelectedInstOperands,
     /* 322924 */   // GIR_Coverage, 1239,
     /* 322924 */   GIR_Done,
     /* 322925 */ // Label 6575: @322925
     /* 322925 */ GIM_Reject,
     /* 322926 */ // Label 6565: @322926
     /* 322926 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(322963), // Rule ID 1245 //
     /* 322931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322952 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 322957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322961 */   GIR_RootConstrainSelectedInstOperands,
     /* 322962 */   // GIR_Coverage, 1245,
     /* 322962 */   GIR_Done,
     /* 322963 */ // Label 6576: @322963
     /* 322963 */ GIM_Reject,
     /* 322964 */ // Label 6566: @322964
     /* 322964 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(323001), // Rule ID 1241 //
     /* 322969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322990 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 322990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 322995 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322999 */   GIR_RootConstrainSelectedInstOperands,
     /* 323000 */   // GIR_Coverage, 1241,
     /* 323000 */   GIR_Done,
     /* 323001 */ // Label 6577: @323001
     /* 323001 */ GIM_Reject,
     /* 323002 */ // Label 6567: @323002
     /* 323002 */ GIM_Reject,
     /* 323003 */ // Label 75: @323003
     /* 323003 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6586*/ GIMT_Encode4(323352),
     /* 323014 */ /*GILLT_s16*//*Label 6578*/ GIMT_Encode4(323054),
     /* 323018 */ /*GILLT_s32*//*Label 6579*/ GIMT_Encode4(323092),
     /* 323022 */ /*GILLT_s64*//*Label 6580*/ GIMT_Encode4(323127), GIMT_Encode4(0),
     /* 323030 */ /*GILLT_v2s32*//*Label 6581*/ GIMT_Encode4(323162),
     /* 323034 */ /*GILLT_v2s64*//*Label 6582*/ GIMT_Encode4(323200),
     /* 323038 */ /*GILLT_v4s16*//*Label 6583*/ GIMT_Encode4(323238),
     /* 323042 */ /*GILLT_v4s32*//*Label 6584*/ GIMT_Encode4(323276), GIMT_Encode4(0),
     /* 323050 */ /*GILLT_v8s16*//*Label 6585*/ GIMT_Encode4(323314),
     /* 323054 */ // Label 6578: @323054
     /* 323054 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(323091), // Rule ID 4811 //
     /* 323059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323080 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323085 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323089 */   GIR_RootConstrainSelectedInstOperands,
     /* 323090 */   // GIR_Coverage, 4811,
     /* 323090 */   GIR_Done,
     /* 323091 */ // Label 6587: @323091
     /* 323091 */ GIM_Reject,
     /* 323092 */ // Label 6579: @323092
     /* 323092 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(323126), // Rule ID 4808 //
     /* 323097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323115 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323120 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323124 */   GIR_RootConstrainSelectedInstOperands,
     /* 323125 */   // GIR_Coverage, 4808,
     /* 323125 */   GIR_Done,
     /* 323126 */ // Label 6588: @323126
     /* 323126 */ GIM_Reject,
     /* 323127 */ // Label 6580: @323127
     /* 323127 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(323161), // Rule ID 4805 //
     /* 323132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323150 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323155 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323159 */   GIR_RootConstrainSelectedInstOperands,
     /* 323160 */   // GIR_Coverage, 4805,
     /* 323160 */   GIR_Done,
     /* 323161 */ // Label 6589: @323161
     /* 323161 */ GIM_Reject,
     /* 323162 */ // Label 6581: @323162
     /* 323162 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(323199), // Rule ID 4999 //
     /* 323167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323188 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 323193 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323197 */   GIR_RootConstrainSelectedInstOperands,
     /* 323198 */   // GIR_Coverage, 4999,
     /* 323198 */   GIR_Done,
     /* 323199 */ // Label 6590: @323199
     /* 323199 */ GIM_Reject,
     /* 323200 */ // Label 6582: @323200
     /* 323200 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(323237), // Rule ID 4993 //
     /* 323205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323226 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 323231 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323235 */   GIR_RootConstrainSelectedInstOperands,
     /* 323236 */   // GIR_Coverage, 4993,
     /* 323236 */   GIR_Done,
     /* 323237 */ // Label 6591: @323237
     /* 323237 */ GIM_Reject,
     /* 323238 */ // Label 6583: @323238
     /* 323238 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(323275), // Rule ID 5005 //
     /* 323243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323264 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 323269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323273 */   GIR_RootConstrainSelectedInstOperands,
     /* 323274 */   // GIR_Coverage, 5005,
     /* 323274 */   GIR_Done,
     /* 323275 */ // Label 6592: @323275
     /* 323275 */ GIM_Reject,
     /* 323276 */ // Label 6584: @323276
     /* 323276 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(323313), // Rule ID 4996 //
     /* 323281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323302 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 323307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323311 */   GIR_RootConstrainSelectedInstOperands,
     /* 323312 */   // GIR_Coverage, 4996,
     /* 323312 */   GIR_Done,
     /* 323313 */ // Label 6593: @323313
     /* 323313 */ GIM_Reject,
     /* 323314 */ // Label 6585: @323314
     /* 323314 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(323351), // Rule ID 5002 //
     /* 323319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323340 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 323345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323349 */   GIR_RootConstrainSelectedInstOperands,
     /* 323350 */   // GIR_Coverage, 5002,
     /* 323350 */   GIR_Done,
     /* 323351 */ // Label 6594: @323351
     /* 323351 */ GIM_Reject,
     /* 323352 */ // Label 6586: @323352
     /* 323352 */ GIM_Reject,
     /* 323353 */ // Label 76: @323353
     /* 323353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6603*/ GIMT_Encode4(323702),
     /* 323364 */ /*GILLT_s16*//*Label 6595*/ GIMT_Encode4(323404),
     /* 323368 */ /*GILLT_s32*//*Label 6596*/ GIMT_Encode4(323442),
     /* 323372 */ /*GILLT_s64*//*Label 6597*/ GIMT_Encode4(323477), GIMT_Encode4(0),
     /* 323380 */ /*GILLT_v2s32*//*Label 6598*/ GIMT_Encode4(323512),
     /* 323384 */ /*GILLT_v2s64*//*Label 6599*/ GIMT_Encode4(323550),
     /* 323388 */ /*GILLT_v4s16*//*Label 6600*/ GIMT_Encode4(323588),
     /* 323392 */ /*GILLT_v4s32*//*Label 6601*/ GIMT_Encode4(323626), GIMT_Encode4(0),
     /* 323400 */ /*GILLT_v8s16*//*Label 6602*/ GIMT_Encode4(323664),
     /* 323404 */ // Label 6595: @323404
     /* 323404 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(323441), // Rule ID 4812 //
     /* 323409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323430 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 323435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323439 */   GIR_RootConstrainSelectedInstOperands,
     /* 323440 */   // GIR_Coverage, 4812,
     /* 323440 */   GIR_Done,
     /* 323441 */ // Label 6604: @323441
     /* 323441 */ GIM_Reject,
     /* 323442 */ // Label 6596: @323442
     /* 323442 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(323476), // Rule ID 4809 //
     /* 323447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323465 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 323470 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323474 */   GIR_RootConstrainSelectedInstOperands,
     /* 323475 */   // GIR_Coverage, 4809,
     /* 323475 */   GIR_Done,
     /* 323476 */ // Label 6605: @323476
     /* 323476 */ GIM_Reject,
     /* 323477 */ // Label 6597: @323477
     /* 323477 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(323511), // Rule ID 4806 //
     /* 323482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323500 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323509 */   GIR_RootConstrainSelectedInstOperands,
     /* 323510 */   // GIR_Coverage, 4806,
     /* 323510 */   GIR_Done,
     /* 323511 */ // Label 6606: @323511
     /* 323511 */ GIM_Reject,
     /* 323512 */ // Label 6598: @323512
     /* 323512 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(323549), // Rule ID 5000 //
     /* 323517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323538 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323547 */   GIR_RootConstrainSelectedInstOperands,
     /* 323548 */   // GIR_Coverage, 5000,
     /* 323548 */   GIR_Done,
     /* 323549 */ // Label 6607: @323549
     /* 323549 */ GIM_Reject,
     /* 323550 */ // Label 6599: @323550
     /* 323550 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(323587), // Rule ID 4994 //
     /* 323555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323576 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323585 */   GIR_RootConstrainSelectedInstOperands,
     /* 323586 */   // GIR_Coverage, 4994,
     /* 323586 */   GIR_Done,
     /* 323587 */ // Label 6608: @323587
     /* 323587 */ GIM_Reject,
     /* 323588 */ // Label 6600: @323588
     /* 323588 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(323625), // Rule ID 5006 //
     /* 323593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323614 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323619 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323623 */   GIR_RootConstrainSelectedInstOperands,
     /* 323624 */   // GIR_Coverage, 5006,
     /* 323624 */   GIR_Done,
     /* 323625 */ // Label 6609: @323625
     /* 323625 */ GIM_Reject,
     /* 323626 */ // Label 6601: @323626
     /* 323626 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(323663), // Rule ID 4997 //
     /* 323631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323652 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323661 */   GIR_RootConstrainSelectedInstOperands,
     /* 323662 */   // GIR_Coverage, 4997,
     /* 323662 */   GIR_Done,
     /* 323663 */ // Label 6610: @323663
     /* 323663 */ GIM_Reject,
     /* 323664 */ // Label 6602: @323664
     /* 323664 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(323701), // Rule ID 5003 //
     /* 323669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323690 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 323695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323699 */   GIR_RootConstrainSelectedInstOperands,
     /* 323700 */   // GIR_Coverage, 5003,
     /* 323700 */   GIR_Done,
     /* 323701 */ // Label 6611: @323701
     /* 323701 */ GIM_Reject,
     /* 323702 */ // Label 6603: @323702
     /* 323702 */ GIM_Reject,
     /* 323703 */ // Label 77: @323703
     /* 323703 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6620*/ GIMT_Encode4(324405),
     /* 323714 */ /*GILLT_s16*//*Label 6612*/ GIMT_Encode4(323754),
     /* 323718 */ /*GILLT_s32*//*Label 6613*/ GIMT_Encode4(323792),
     /* 323722 */ /*GILLT_s64*//*Label 6614*/ GIMT_Encode4(323830), GIMT_Encode4(0),
     /* 323730 */ /*GILLT_v2s32*//*Label 6615*/ GIMT_Encode4(323890),
     /* 323734 */ /*GILLT_v2s64*//*Label 6616*/ GIMT_Encode4(323993),
     /* 323738 */ /*GILLT_v4s16*//*Label 6617*/ GIMT_Encode4(324096),
     /* 323742 */ /*GILLT_v4s32*//*Label 6618*/ GIMT_Encode4(324199), GIMT_Encode4(0),
     /* 323750 */ /*GILLT_v8s16*//*Label 6619*/ GIMT_Encode4(324302),
     /* 323754 */ // Label 6612: @323754
     /* 323754 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(323791), // Rule ID 614 //
     /* 323759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323780 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 323780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 323785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323789 */   GIR_RootConstrainSelectedInstOperands,
     /* 323790 */   // GIR_Coverage, 614,
     /* 323790 */   GIR_Done,
     /* 323791 */ // Label 6621: @323791
     /* 323791 */ GIM_Reject,
     /* 323792 */ // Label 6613: @323792
     /* 323792 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(323829), // Rule ID 616 //
     /* 323797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323818 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 323818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 323823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323827 */   GIR_RootConstrainSelectedInstOperands,
     /* 323828 */   // GIR_Coverage, 616,
     /* 323828 */   GIR_Done,
     /* 323829 */ // Label 6622: @323829
     /* 323829 */ GIM_Reject,
     /* 323830 */ // Label 6614: @323830
     /* 323830 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(323889),
     /* 323835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323853 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(323872), // Rule ID 618 //
     /* 323858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323861 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 323861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 323866 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323870 */     GIR_RootConstrainSelectedInstOperands,
     /* 323871 */     // GIR_Coverage, 618,
     /* 323871 */     GIR_Done,
     /* 323872 */   // Label 6624: @323872
     /* 323872 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(323888), // Rule ID 4802 //
     /* 323877 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 323877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 323882 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323886 */     GIR_RootConstrainSelectedInstOperands,
     /* 323887 */     // GIR_Coverage, 4802,
     /* 323887 */     GIR_Done,
     /* 323888 */   // Label 6625: @323888
     /* 323888 */   GIM_Reject,
     /* 323889 */ // Label 6623: @323889
     /* 323889 */ GIM_Reject,
     /* 323890 */ // Label 6615: @323890
     /* 323890 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(323992),
     /* 323895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323905 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(323964), // Rule ID 2366 //
     /* 323910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 323913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 323921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 323938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323949 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 323952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323962 */     GIR_RootConstrainSelectedInstOperands,
     /* 323963 */     // GIR_Coverage, 2366,
     /* 323963 */     GIR_EraseRootFromParent_Done,
     /* 323964 */   // Label 6627: @323964
     /* 323964 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(323991), // Rule ID 1288 //
     /* 323969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323980 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 323985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323989 */     GIR_RootConstrainSelectedInstOperands,
     /* 323990 */     // GIR_Coverage, 1288,
     /* 323990 */     GIR_Done,
     /* 323991 */   // Label 6628: @323991
     /* 323991 */   GIM_Reject,
     /* 323992 */ // Label 6626: @323992
     /* 323992 */ GIM_Reject,
     /* 323993 */ // Label 6616: @323993
     /* 323993 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(324095),
     /* 323998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324008 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(324067), // Rule ID 2372 //
     /* 324013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324052 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 324055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324065 */     GIR_RootConstrainSelectedInstOperands,
     /* 324066 */     // GIR_Coverage, 2372,
     /* 324066 */     GIR_EraseRootFromParent_Done,
     /* 324067 */   // Label 6630: @324067
     /* 324067 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(324094), // Rule ID 1292 //
     /* 324072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324083 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 324088 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324092 */     GIR_RootConstrainSelectedInstOperands,
     /* 324093 */     // GIR_Coverage, 1292,
     /* 324093 */     GIR_Done,
     /* 324094 */   // Label 6631: @324094
     /* 324094 */   GIM_Reject,
     /* 324095 */ // Label 6629: @324095
     /* 324095 */ GIM_Reject,
     /* 324096 */ // Label 6617: @324096
     /* 324096 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(324198),
     /* 324101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324111 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(324170), // Rule ID 2360 //
     /* 324116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324155 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 324158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324168 */     GIR_RootConstrainSelectedInstOperands,
     /* 324169 */     // GIR_Coverage, 2360,
     /* 324169 */     GIR_EraseRootFromParent_Done,
     /* 324170 */   // Label 6633: @324170
     /* 324170 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(324197), // Rule ID 1284 //
     /* 324175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324186 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 324191 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324195 */     GIR_RootConstrainSelectedInstOperands,
     /* 324196 */     // GIR_Coverage, 1284,
     /* 324196 */     GIR_Done,
     /* 324197 */   // Label 6634: @324197
     /* 324197 */   GIM_Reject,
     /* 324198 */ // Label 6632: @324198
     /* 324198 */ GIM_Reject,
     /* 324199 */ // Label 6618: @324199
     /* 324199 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(324301),
     /* 324204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324214 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(324273), // Rule ID 2369 //
     /* 324219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324258 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 324261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324271 */     GIR_RootConstrainSelectedInstOperands,
     /* 324272 */     // GIR_Coverage, 2369,
     /* 324272 */     GIR_EraseRootFromParent_Done,
     /* 324273 */   // Label 6636: @324273
     /* 324273 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(324300), // Rule ID 1290 //
     /* 324278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324289 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 324294 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324298 */     GIR_RootConstrainSelectedInstOperands,
     /* 324299 */     // GIR_Coverage, 1290,
     /* 324299 */     GIR_Done,
     /* 324300 */   // Label 6637: @324300
     /* 324300 */   GIM_Reject,
     /* 324301 */ // Label 6635: @324301
     /* 324301 */ GIM_Reject,
     /* 324302 */ // Label 6619: @324302
     /* 324302 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(324404),
     /* 324307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324317 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(324376), // Rule ID 2363 //
     /* 324322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324361 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 324364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324374 */     GIR_RootConstrainSelectedInstOperands,
     /* 324375 */     // GIR_Coverage, 2363,
     /* 324375 */     GIR_EraseRootFromParent_Done,
     /* 324376 */   // Label 6639: @324376
     /* 324376 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(324403), // Rule ID 1286 //
     /* 324381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324392 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 324397 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324401 */     GIR_RootConstrainSelectedInstOperands,
     /* 324402 */     // GIR_Coverage, 1286,
     /* 324402 */     GIR_Done,
     /* 324403 */   // Label 6640: @324403
     /* 324403 */   GIM_Reject,
     /* 324404 */ // Label 6638: @324404
     /* 324404 */ GIM_Reject,
     /* 324405 */ // Label 6620: @324405
     /* 324405 */ GIM_Reject,
     /* 324406 */ // Label 78: @324406
     /* 324406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6649*/ GIMT_Encode4(325108),
     /* 324417 */ /*GILLT_s16*//*Label 6641*/ GIMT_Encode4(324457),
     /* 324421 */ /*GILLT_s32*//*Label 6642*/ GIMT_Encode4(324495),
     /* 324425 */ /*GILLT_s64*//*Label 6643*/ GIMT_Encode4(324533), GIMT_Encode4(0),
     /* 324433 */ /*GILLT_v2s32*//*Label 6644*/ GIMT_Encode4(324593),
     /* 324437 */ /*GILLT_v2s64*//*Label 6645*/ GIMT_Encode4(324696),
     /* 324441 */ /*GILLT_v4s16*//*Label 6646*/ GIMT_Encode4(324799),
     /* 324445 */ /*GILLT_v4s32*//*Label 6647*/ GIMT_Encode4(324902), GIMT_Encode4(0),
     /* 324453 */ /*GILLT_v8s16*//*Label 6648*/ GIMT_Encode4(325005),
     /* 324457 */ // Label 6641: @324457
     /* 324457 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(324494), // Rule ID 602 //
     /* 324462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324483 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 324488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324492 */   GIR_RootConstrainSelectedInstOperands,
     /* 324493 */   // GIR_Coverage, 602,
     /* 324493 */   GIR_Done,
     /* 324494 */ // Label 6650: @324494
     /* 324494 */ GIM_Reject,
     /* 324495 */ // Label 6642: @324495
     /* 324495 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(324532), // Rule ID 604 //
     /* 324500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324521 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 324526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324530 */   GIR_RootConstrainSelectedInstOperands,
     /* 324531 */   // GIR_Coverage, 604,
     /* 324531 */   GIR_Done,
     /* 324532 */ // Label 6651: @324532
     /* 324532 */ GIM_Reject,
     /* 324533 */ // Label 6643: @324533
     /* 324533 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(324592),
     /* 324538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324556 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(324575), // Rule ID 606 //
     /* 324561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324564 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324569 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324573 */     GIR_RootConstrainSelectedInstOperands,
     /* 324574 */     // GIR_Coverage, 606,
     /* 324574 */     GIR_Done,
     /* 324575 */   // Label 6653: @324575
     /* 324575 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(324591), // Rule ID 4801 //
     /* 324580 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324589 */     GIR_RootConstrainSelectedInstOperands,
     /* 324590 */     // GIR_Coverage, 4801,
     /* 324590 */     GIR_Done,
     /* 324591 */   // Label 6654: @324591
     /* 324591 */   GIM_Reject,
     /* 324592 */ // Label 6652: @324592
     /* 324592 */ GIM_Reject,
     /* 324593 */ // Label 6644: @324593
     /* 324593 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(324695),
     /* 324598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324608 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(324667), // Rule ID 2351 //
     /* 324613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324652 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 324655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324665 */     GIR_RootConstrainSelectedInstOperands,
     /* 324666 */     // GIR_Coverage, 2351,
     /* 324666 */     GIR_EraseRootFromParent_Done,
     /* 324667 */   // Label 6656: @324667
     /* 324667 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(324694), // Rule ID 1258 //
     /* 324672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324683 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 324688 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324692 */     GIR_RootConstrainSelectedInstOperands,
     /* 324693 */     // GIR_Coverage, 1258,
     /* 324693 */     GIR_Done,
     /* 324694 */   // Label 6657: @324694
     /* 324694 */   GIM_Reject,
     /* 324695 */ // Label 6655: @324695
     /* 324695 */ GIM_Reject,
     /* 324696 */ // Label 6645: @324696
     /* 324696 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(324798),
     /* 324701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324711 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(324770), // Rule ID 2357 //
     /* 324716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324755 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 324758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324768 */     GIR_RootConstrainSelectedInstOperands,
     /* 324769 */     // GIR_Coverage, 2357,
     /* 324769 */     GIR_EraseRootFromParent_Done,
     /* 324770 */   // Label 6659: @324770
     /* 324770 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(324797), // Rule ID 1262 //
     /* 324775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324786 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 324791 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324795 */     GIR_RootConstrainSelectedInstOperands,
     /* 324796 */     // GIR_Coverage, 1262,
     /* 324796 */     GIR_Done,
     /* 324797 */   // Label 6660: @324797
     /* 324797 */   GIM_Reject,
     /* 324798 */ // Label 6658: @324798
     /* 324798 */ GIM_Reject,
     /* 324799 */ // Label 6646: @324799
     /* 324799 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(324901),
     /* 324804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324814 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(324873), // Rule ID 2345 //
     /* 324819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324858 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 324861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324871 */     GIR_RootConstrainSelectedInstOperands,
     /* 324872 */     // GIR_Coverage, 2345,
     /* 324872 */     GIR_EraseRootFromParent_Done,
     /* 324873 */   // Label 6662: @324873
     /* 324873 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(324900), // Rule ID 1254 //
     /* 324878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324889 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 324894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324898 */     GIR_RootConstrainSelectedInstOperands,
     /* 324899 */     // GIR_Coverage, 1254,
     /* 324899 */     GIR_Done,
     /* 324900 */   // Label 6663: @324900
     /* 324900 */   GIM_Reject,
     /* 324901 */ // Label 6661: @324901
     /* 324901 */ GIM_Reject,
     /* 324902 */ // Label 6647: @324902
     /* 324902 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(325004),
     /* 324907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324917 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(324976), // Rule ID 2354 //
     /* 324922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324961 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 324964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324974 */     GIR_RootConstrainSelectedInstOperands,
     /* 324975 */     // GIR_Coverage, 2354,
     /* 324975 */     GIR_EraseRootFromParent_Done,
     /* 324976 */   // Label 6665: @324976
     /* 324976 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(325003), // Rule ID 1260 //
     /* 324981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324992 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 324997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325001 */     GIR_RootConstrainSelectedInstOperands,
     /* 325002 */     // GIR_Coverage, 1260,
     /* 325002 */     GIR_Done,
     /* 325003 */   // Label 6666: @325003
     /* 325003 */   GIM_Reject,
     /* 325004 */ // Label 6664: @325004
     /* 325004 */ GIM_Reject,
     /* 325005 */ // Label 6648: @325005
     /* 325005 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(325107),
     /* 325010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325020 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(325079), // Rule ID 2348 //
     /* 325025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325064 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 325067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325077 */     GIR_RootConstrainSelectedInstOperands,
     /* 325078 */     // GIR_Coverage, 2348,
     /* 325078 */     GIR_EraseRootFromParent_Done,
     /* 325079 */   // Label 6668: @325079
     /* 325079 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(325106), // Rule ID 1256 //
     /* 325084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325095 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 325100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325104 */     GIR_RootConstrainSelectedInstOperands,
     /* 325105 */     // GIR_Coverage, 1256,
     /* 325105 */     GIR_Done,
     /* 325106 */   // Label 6669: @325106
     /* 325106 */   GIM_Reject,
     /* 325107 */ // Label 6667: @325107
     /* 325107 */ GIM_Reject,
     /* 325108 */ // Label 6649: @325108
     /* 325108 */ GIM_Reject,
     /* 325109 */ // Label 79: @325109
     /* 325109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6678*/ GIMT_Encode4(325512),
     /* 325120 */ /*GILLT_s32*//*Label 6670*/ GIMT_Encode4(325160),
     /* 325124 */ /*GILLT_s64*//*Label 6671*/ GIMT_Encode4(325234), GIMT_Encode4(0),
     /* 325132 */ /*GILLT_v2s32*//*Label 6672*/ GIMT_Encode4(325308), GIMT_Encode4(0),
     /* 325140 */ /*GILLT_v4s16*//*Label 6673*/ GIMT_Encode4(325342),
     /* 325144 */ /*GILLT_v4s32*//*Label 6674*/ GIMT_Encode4(325376),
     /* 325148 */ /*GILLT_v8s8*//*Label 6675*/ GIMT_Encode4(325410),
     /* 325152 */ /*GILLT_v8s16*//*Label 6676*/ GIMT_Encode4(325444),
     /* 325156 */ /*GILLT_v16s8*//*Label 6677*/ GIMT_Encode4(325478),
     /* 325160 */ // Label 6670: @325160
     /* 325160 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(325233),
     /* 325165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325179 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(325213), // Rule ID 2328 //
     /* 325184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325199 */     // MIs[1] Operand 1
     /* 325199 */     // No operand predicates
     /* 325199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325201 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 325204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325211 */     GIR_RootConstrainSelectedInstOperands,
     /* 325212 */     // GIR_Coverage, 2328,
     /* 325212 */     GIR_EraseRootFromParent_Done,
     /* 325213 */   // Label 6680: @325213
     /* 325213 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(325232), // Rule ID 2327 //
     /* 325218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325225 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 325230 */     GIR_RootConstrainSelectedInstOperands,
     /* 325231 */     // GIR_Coverage, 2327,
     /* 325231 */     GIR_Done,
     /* 325232 */   // Label 6681: @325232
     /* 325232 */   GIM_Reject,
     /* 325233 */ // Label 6679: @325233
     /* 325233 */ GIM_Reject,
     /* 325234 */ // Label 6671: @325234
     /* 325234 */ GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(325307),
     /* 325239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325253 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(325287), // Rule ID 2330 //
     /* 325258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325273 */     // MIs[1] Operand 1
     /* 325273 */     // No operand predicates
     /* 325273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325275 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 325278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325285 */     GIR_RootConstrainSelectedInstOperands,
     /* 325286 */     // GIR_Coverage, 2330,
     /* 325286 */     GIR_EraseRootFromParent_Done,
     /* 325287 */   // Label 6683: @325287
     /* 325287 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(325306), // Rule ID 2329 //
     /* 325292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325299 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 325299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 325304 */     GIR_RootConstrainSelectedInstOperands,
     /* 325305 */     // GIR_Coverage, 2329,
     /* 325305 */     GIR_Done,
     /* 325306 */   // Label 6684: @325306
     /* 325306 */   GIM_Reject,
     /* 325307 */ // Label 6682: @325307
     /* 325307 */ GIM_Reject,
     /* 325308 */ // Label 6672: @325308
     /* 325308 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(325341), // Rule ID 1414 //
     /* 325313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325334 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 325334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 325339 */   GIR_RootConstrainSelectedInstOperands,
     /* 325340 */   // GIR_Coverage, 1414,
     /* 325340 */   GIR_Done,
     /* 325341 */ // Label 6685: @325341
     /* 325341 */ GIM_Reject,
     /* 325342 */ // Label 6673: @325342
     /* 325342 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(325375), // Rule ID 1412 //
     /* 325347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325368 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 325368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 325373 */   GIR_RootConstrainSelectedInstOperands,
     /* 325374 */   // GIR_Coverage, 1412,
     /* 325374 */   GIR_Done,
     /* 325375 */ // Label 6686: @325375
     /* 325375 */ GIM_Reject,
     /* 325376 */ // Label 6674: @325376
     /* 325376 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(325409), // Rule ID 1415 //
     /* 325381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325402 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 325402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 325407 */   GIR_RootConstrainSelectedInstOperands,
     /* 325408 */   // GIR_Coverage, 1415,
     /* 325408 */   GIR_Done,
     /* 325409 */ // Label 6687: @325409
     /* 325409 */ GIM_Reject,
     /* 325410 */ // Label 6675: @325410
     /* 325410 */ GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(325443), // Rule ID 1410 //
     /* 325415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 325424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325436 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 325436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 325441 */   GIR_RootConstrainSelectedInstOperands,
     /* 325442 */   // GIR_Coverage, 1410,
     /* 325442 */   GIR_Done,
     /* 325443 */ // Label 6688: @325443
     /* 325443 */ GIM_Reject,
     /* 325444 */ // Label 6676: @325444
     /* 325444 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(325477), // Rule ID 1413 //
     /* 325449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325470 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 325470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 325475 */   GIR_RootConstrainSelectedInstOperands,
     /* 325476 */   // GIR_Coverage, 1413,
     /* 325476 */   GIR_Done,
     /* 325477 */ // Label 6689: @325477
     /* 325477 */ GIM_Reject,
     /* 325478 */ // Label 6677: @325478
     /* 325478 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(325511), // Rule ID 1411 //
     /* 325483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 325489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 325492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325504 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 325504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 325509 */   GIR_RootConstrainSelectedInstOperands,
     /* 325510 */   // GIR_Coverage, 1411,
     /* 325510 */   GIR_Done,
     /* 325511 */ // Label 6690: @325511
     /* 325511 */ GIM_Reject,
     /* 325512 */ // Label 6678: @325512
     /* 325512 */ GIM_Reject,
     /* 325513 */ // Label 80: @325513
     /* 325513 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6699*/ GIMT_Encode4(325916),
     /* 325524 */ /*GILLT_s32*//*Label 6691*/ GIMT_Encode4(325564),
     /* 325528 */ /*GILLT_s64*//*Label 6692*/ GIMT_Encode4(325638), GIMT_Encode4(0),
     /* 325536 */ /*GILLT_v2s32*//*Label 6693*/ GIMT_Encode4(325712), GIMT_Encode4(0),
     /* 325544 */ /*GILLT_v4s16*//*Label 6694*/ GIMT_Encode4(325746),
     /* 325548 */ /*GILLT_v4s32*//*Label 6695*/ GIMT_Encode4(325780),
     /* 325552 */ /*GILLT_v8s8*//*Label 6696*/ GIMT_Encode4(325814),
     /* 325556 */ /*GILLT_v8s16*//*Label 6697*/ GIMT_Encode4(325848),
     /* 325560 */ /*GILLT_v16s8*//*Label 6698*/ GIMT_Encode4(325882),
     /* 325564 */ // Label 6691: @325564
     /* 325564 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(325637),
     /* 325569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325583 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(325617), // Rule ID 2324 //
     /* 325588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325603 */     // MIs[1] Operand 1
     /* 325603 */     // No operand predicates
     /* 325603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325605 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 325608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325615 */     GIR_RootConstrainSelectedInstOperands,
     /* 325616 */     // GIR_Coverage, 2324,
     /* 325616 */     GIR_EraseRootFromParent_Done,
     /* 325617 */   // Label 6701: @325617
     /* 325617 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(325636), // Rule ID 2323 //
     /* 325622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325629 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 325634 */     GIR_RootConstrainSelectedInstOperands,
     /* 325635 */     // GIR_Coverage, 2323,
     /* 325635 */     GIR_Done,
     /* 325636 */   // Label 6702: @325636
     /* 325636 */   GIM_Reject,
     /* 325637 */ // Label 6700: @325637
     /* 325637 */ GIM_Reject,
     /* 325638 */ // Label 6692: @325638
     /* 325638 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(325711),
     /* 325643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325657 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(325691), // Rule ID 2326 //
     /* 325662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325677 */     // MIs[1] Operand 1
     /* 325677 */     // No operand predicates
     /* 325677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325679 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 325682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325689 */     GIR_RootConstrainSelectedInstOperands,
     /* 325690 */     // GIR_Coverage, 2326,
     /* 325690 */     GIR_EraseRootFromParent_Done,
     /* 325691 */   // Label 6704: @325691
     /* 325691 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(325710), // Rule ID 2325 //
     /* 325696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325703 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 325703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 325708 */     GIR_RootConstrainSelectedInstOperands,
     /* 325709 */     // GIR_Coverage, 2325,
     /* 325709 */     GIR_Done,
     /* 325710 */   // Label 6705: @325710
     /* 325710 */   GIM_Reject,
     /* 325711 */ // Label 6703: @325711
     /* 325711 */ GIM_Reject,
     /* 325712 */ // Label 6693: @325712
     /* 325712 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(325745), // Rule ID 1402 //
     /* 325717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325738 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 325738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 325743 */   GIR_RootConstrainSelectedInstOperands,
     /* 325744 */   // GIR_Coverage, 1402,
     /* 325744 */   GIR_Done,
     /* 325745 */ // Label 6706: @325745
     /* 325745 */ GIM_Reject,
     /* 325746 */ // Label 6694: @325746
     /* 325746 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(325779), // Rule ID 1400 //
     /* 325751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325772 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 325772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 325777 */   GIR_RootConstrainSelectedInstOperands,
     /* 325778 */   // GIR_Coverage, 1400,
     /* 325778 */   GIR_Done,
     /* 325779 */ // Label 6707: @325779
     /* 325779 */ GIM_Reject,
     /* 325780 */ // Label 6695: @325780
     /* 325780 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(325813), // Rule ID 1403 //
     /* 325785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325806 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 325806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 325811 */   GIR_RootConstrainSelectedInstOperands,
     /* 325812 */   // GIR_Coverage, 1403,
     /* 325812 */   GIR_Done,
     /* 325813 */ // Label 6708: @325813
     /* 325813 */ GIM_Reject,
     /* 325814 */ // Label 6696: @325814
     /* 325814 */ GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(325847), // Rule ID 1398 //
     /* 325819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 325828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325840 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 325840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 325845 */   GIR_RootConstrainSelectedInstOperands,
     /* 325846 */   // GIR_Coverage, 1398,
     /* 325846 */   GIR_Done,
     /* 325847 */ // Label 6709: @325847
     /* 325847 */ GIM_Reject,
     /* 325848 */ // Label 6697: @325848
     /* 325848 */ GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(325881), // Rule ID 1401 //
     /* 325853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325874 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 325874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 325879 */   GIR_RootConstrainSelectedInstOperands,
     /* 325880 */   // GIR_Coverage, 1401,
     /* 325880 */   GIR_Done,
     /* 325881 */ // Label 6710: @325881
     /* 325881 */ GIM_Reject,
     /* 325882 */ // Label 6698: @325882
     /* 325882 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(325915), // Rule ID 1399 //
     /* 325887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 325893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 325896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325908 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 325908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 325913 */   GIR_RootConstrainSelectedInstOperands,
     /* 325914 */   // GIR_Coverage, 1399,
     /* 325914 */   GIR_Done,
     /* 325915 */ // Label 6711: @325915
     /* 325915 */ GIM_Reject,
     /* 325916 */ // Label 6699: @325916
     /* 325916 */ GIM_Reject,
     /* 325917 */ // Label 81: @325917
     /* 325917 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6720*/ GIMT_Encode4(326320),
     /* 325928 */ /*GILLT_s32*//*Label 6712*/ GIMT_Encode4(325968),
     /* 325932 */ /*GILLT_s64*//*Label 6713*/ GIMT_Encode4(326042), GIMT_Encode4(0),
     /* 325940 */ /*GILLT_v2s32*//*Label 6714*/ GIMT_Encode4(326116), GIMT_Encode4(0),
     /* 325948 */ /*GILLT_v4s16*//*Label 6715*/ GIMT_Encode4(326150),
     /* 325952 */ /*GILLT_v4s32*//*Label 6716*/ GIMT_Encode4(326184),
     /* 325956 */ /*GILLT_v8s8*//*Label 6717*/ GIMT_Encode4(326218),
     /* 325960 */ /*GILLT_v8s16*//*Label 6718*/ GIMT_Encode4(326252),
     /* 325964 */ /*GILLT_v16s8*//*Label 6719*/ GIMT_Encode4(326286),
     /* 325968 */ // Label 6712: @325968
     /* 325968 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326041),
     /* 325973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325987 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(326021), // Rule ID 2336 //
     /* 325992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326007 */     // MIs[1] Operand 1
     /* 326007 */     // No operand predicates
     /* 326007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326009 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 326012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326019 */     GIR_RootConstrainSelectedInstOperands,
     /* 326020 */     // GIR_Coverage, 2336,
     /* 326020 */     GIR_EraseRootFromParent_Done,
     /* 326021 */   // Label 6722: @326021
     /* 326021 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326040), // Rule ID 2335 //
     /* 326026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326033 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 326038 */     GIR_RootConstrainSelectedInstOperands,
     /* 326039 */     // GIR_Coverage, 2335,
     /* 326039 */     GIR_Done,
     /* 326040 */   // Label 6723: @326040
     /* 326040 */   GIM_Reject,
     /* 326041 */ // Label 6721: @326041
     /* 326041 */ GIM_Reject,
     /* 326042 */ // Label 6713: @326042
     /* 326042 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(326115),
     /* 326047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326061 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(326095), // Rule ID 2338 //
     /* 326066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326081 */     // MIs[1] Operand 1
     /* 326081 */     // No operand predicates
     /* 326081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326083 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 326086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326093 */     GIR_RootConstrainSelectedInstOperands,
     /* 326094 */     // GIR_Coverage, 2338,
     /* 326094 */     GIR_EraseRootFromParent_Done,
     /* 326095 */   // Label 6725: @326095
     /* 326095 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(326114), // Rule ID 2337 //
     /* 326100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326107 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 326112 */     GIR_RootConstrainSelectedInstOperands,
     /* 326113 */     // GIR_Coverage, 2337,
     /* 326113 */     GIR_Done,
     /* 326114 */   // Label 6726: @326114
     /* 326114 */   GIM_Reject,
     /* 326115 */ // Label 6724: @326115
     /* 326115 */ GIM_Reject,
     /* 326116 */ // Label 6714: @326116
     /* 326116 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(326149), // Rule ID 1537 //
     /* 326121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326142 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 326147 */   GIR_RootConstrainSelectedInstOperands,
     /* 326148 */   // GIR_Coverage, 1537,
     /* 326148 */   GIR_Done,
     /* 326149 */ // Label 6727: @326149
     /* 326149 */ GIM_Reject,
     /* 326150 */ // Label 6715: @326150
     /* 326150 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(326183), // Rule ID 1535 //
     /* 326155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326176 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 326181 */   GIR_RootConstrainSelectedInstOperands,
     /* 326182 */   // GIR_Coverage, 1535,
     /* 326182 */   GIR_Done,
     /* 326183 */ // Label 6728: @326183
     /* 326183 */ GIM_Reject,
     /* 326184 */ // Label 6716: @326184
     /* 326184 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(326217), // Rule ID 1538 //
     /* 326189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326210 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 326215 */   GIR_RootConstrainSelectedInstOperands,
     /* 326216 */   // GIR_Coverage, 1538,
     /* 326216 */   GIR_Done,
     /* 326217 */ // Label 6729: @326217
     /* 326217 */ GIM_Reject,
     /* 326218 */ // Label 6717: @326218
     /* 326218 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(326251), // Rule ID 1533 //
     /* 326223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326244 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 326249 */   GIR_RootConstrainSelectedInstOperands,
     /* 326250 */   // GIR_Coverage, 1533,
     /* 326250 */   GIR_Done,
     /* 326251 */ // Label 6730: @326251
     /* 326251 */ GIM_Reject,
     /* 326252 */ // Label 6718: @326252
     /* 326252 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(326285), // Rule ID 1536 //
     /* 326257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326278 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 326283 */   GIR_RootConstrainSelectedInstOperands,
     /* 326284 */   // GIR_Coverage, 1536,
     /* 326284 */   GIR_Done,
     /* 326285 */ // Label 6731: @326285
     /* 326285 */ GIM_Reject,
     /* 326286 */ // Label 6719: @326286
     /* 326286 */ GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(326319), // Rule ID 1534 //
     /* 326291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326312 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 326317 */   GIR_RootConstrainSelectedInstOperands,
     /* 326318 */   // GIR_Coverage, 1534,
     /* 326318 */   GIR_Done,
     /* 326319 */ // Label 6732: @326319
     /* 326319 */ GIM_Reject,
     /* 326320 */ // Label 6720: @326320
     /* 326320 */ GIM_Reject,
     /* 326321 */ // Label 82: @326321
     /* 326321 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6741*/ GIMT_Encode4(326724),
     /* 326332 */ /*GILLT_s32*//*Label 6733*/ GIMT_Encode4(326372),
     /* 326336 */ /*GILLT_s64*//*Label 6734*/ GIMT_Encode4(326446), GIMT_Encode4(0),
     /* 326344 */ /*GILLT_v2s32*//*Label 6735*/ GIMT_Encode4(326520), GIMT_Encode4(0),
     /* 326352 */ /*GILLT_v4s16*//*Label 6736*/ GIMT_Encode4(326554),
     /* 326356 */ /*GILLT_v4s32*//*Label 6737*/ GIMT_Encode4(326588),
     /* 326360 */ /*GILLT_v8s8*//*Label 6738*/ GIMT_Encode4(326622),
     /* 326364 */ /*GILLT_v8s16*//*Label 6739*/ GIMT_Encode4(326656),
     /* 326368 */ /*GILLT_v16s8*//*Label 6740*/ GIMT_Encode4(326690),
     /* 326372 */ // Label 6733: @326372
     /* 326372 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(326445),
     /* 326377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326391 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(326425), // Rule ID 2332 //
     /* 326396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326411 */     // MIs[1] Operand 1
     /* 326411 */     // No operand predicates
     /* 326411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326413 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 326416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326423 */     GIR_RootConstrainSelectedInstOperands,
     /* 326424 */     // GIR_Coverage, 2332,
     /* 326424 */     GIR_EraseRootFromParent_Done,
     /* 326425 */   // Label 6743: @326425
     /* 326425 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(326444), // Rule ID 2331 //
     /* 326430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326437 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 326442 */     GIR_RootConstrainSelectedInstOperands,
     /* 326443 */     // GIR_Coverage, 2331,
     /* 326443 */     GIR_Done,
     /* 326444 */   // Label 6744: @326444
     /* 326444 */   GIM_Reject,
     /* 326445 */ // Label 6742: @326445
     /* 326445 */ GIM_Reject,
     /* 326446 */ // Label 6734: @326446
     /* 326446 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(326519),
     /* 326451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326465 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(326499), // Rule ID 2334 //
     /* 326470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326485 */     // MIs[1] Operand 1
     /* 326485 */     // No operand predicates
     /* 326485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326487 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 326490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326497 */     GIR_RootConstrainSelectedInstOperands,
     /* 326498 */     // GIR_Coverage, 2334,
     /* 326498 */     GIR_EraseRootFromParent_Done,
     /* 326499 */   // Label 6746: @326499
     /* 326499 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(326518), // Rule ID 2333 //
     /* 326504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326511 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 326516 */     GIR_RootConstrainSelectedInstOperands,
     /* 326517 */     // GIR_Coverage, 2333,
     /* 326517 */     GIR_Done,
     /* 326518 */   // Label 6747: @326518
     /* 326518 */   GIM_Reject,
     /* 326519 */ // Label 6745: @326519
     /* 326519 */ GIM_Reject,
     /* 326520 */ // Label 6735: @326520
     /* 326520 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(326553), // Rule ID 1525 //
     /* 326525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326546 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 326551 */   GIR_RootConstrainSelectedInstOperands,
     /* 326552 */   // GIR_Coverage, 1525,
     /* 326552 */   GIR_Done,
     /* 326553 */ // Label 6748: @326553
     /* 326553 */ GIM_Reject,
     /* 326554 */ // Label 6736: @326554
     /* 326554 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(326587), // Rule ID 1523 //
     /* 326559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326580 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 326585 */   GIR_RootConstrainSelectedInstOperands,
     /* 326586 */   // GIR_Coverage, 1523,
     /* 326586 */   GIR_Done,
     /* 326587 */ // Label 6749: @326587
     /* 326587 */ GIM_Reject,
     /* 326588 */ // Label 6737: @326588
     /* 326588 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(326621), // Rule ID 1526 //
     /* 326593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326614 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 326619 */   GIR_RootConstrainSelectedInstOperands,
     /* 326620 */   // GIR_Coverage, 1526,
     /* 326620 */   GIR_Done,
     /* 326621 */ // Label 6750: @326621
     /* 326621 */ GIM_Reject,
     /* 326622 */ // Label 6738: @326622
     /* 326622 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(326655), // Rule ID 1521 //
     /* 326627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326648 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 326653 */   GIR_RootConstrainSelectedInstOperands,
     /* 326654 */   // GIR_Coverage, 1521,
     /* 326654 */   GIR_Done,
     /* 326655 */ // Label 6751: @326655
     /* 326655 */ GIM_Reject,
     /* 326656 */ // Label 6739: @326656
     /* 326656 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(326689), // Rule ID 1524 //
     /* 326661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326682 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 326687 */   GIR_RootConstrainSelectedInstOperands,
     /* 326688 */   // GIR_Coverage, 1524,
     /* 326688 */   GIR_Done,
     /* 326689 */ // Label 6752: @326689
     /* 326689 */ GIM_Reject,
     /* 326690 */ // Label 6740: @326690
     /* 326690 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(326723), // Rule ID 1522 //
     /* 326695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326716 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 326721 */   GIR_RootConstrainSelectedInstOperands,
     /* 326722 */   // GIR_Coverage, 1522,
     /* 326722 */   GIR_Done,
     /* 326723 */ // Label 6753: @326723
     /* 326723 */ GIM_Reject,
     /* 326724 */ // Label 6741: @326724
     /* 326724 */ GIM_Reject,
     /* 326725 */ // Label 83: @326725
     /* 326725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6763*/ GIMT_Encode4(327539),
     /* 326736 */ /*GILLT_s32*//*Label 6754*/ GIMT_Encode4(326776),
     /* 326740 */ /*GILLT_s64*//*Label 6755*/ GIMT_Encode4(326803), GIMT_Encode4(0),
     /* 326748 */ /*GILLT_v2s32*//*Label 6756*/ GIMT_Encode4(326882),
     /* 326752 */ /*GILLT_v2s64*//*Label 6757*/ GIMT_Encode4(326909),
     /* 326756 */ /*GILLT_v4s16*//*Label 6758*/ GIMT_Encode4(327092),
     /* 326760 */ /*GILLT_v4s32*//*Label 6759*/ GIMT_Encode4(327119),
     /* 326764 */ /*GILLT_v8s8*//*Label 6760*/ GIMT_Encode4(327302),
     /* 326768 */ /*GILLT_v8s16*//*Label 6761*/ GIMT_Encode4(327329),
     /* 326772 */ /*GILLT_v16s8*//*Label 6762*/ GIMT_Encode4(327512),
     /* 326776 */ // Label 6754: @326776
     /* 326776 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(326802), // Rule ID 2317 //
     /* 326781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326795 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 326795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 326800 */   GIR_RootConstrainSelectedInstOperands,
     /* 326801 */   // GIR_Coverage, 2317,
     /* 326801 */   GIR_Done,
     /* 326802 */ // Label 6764: @326802
     /* 326802 */ GIM_Reject,
     /* 326803 */ // Label 6755: @326803
     /* 326803 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(326881),
     /* 326808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326811 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(326834), // Rule ID 1652 //
     /* 326816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326827 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 326827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 326832 */     GIR_RootConstrainSelectedInstOperands,
     /* 326833 */     // GIR_Coverage, 1652,
     /* 326833 */     GIR_Done,
     /* 326834 */   // Label 6766: @326834
     /* 326834 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(326857), // Rule ID 2318 //
     /* 326839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326850 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 326850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 326855 */     GIR_RootConstrainSelectedInstOperands,
     /* 326856 */     // GIR_Coverage, 2318,
     /* 326856 */     GIR_Done,
     /* 326857 */   // Label 6767: @326857
     /* 326857 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(326880), // Rule ID 2514 //
     /* 326862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 326865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326873 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 326873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 326878 */     GIR_RootConstrainSelectedInstOperands,
     /* 326879 */     // GIR_Coverage, 2514,
     /* 326879 */     GIR_Done,
     /* 326880 */   // Label 6768: @326880
     /* 326880 */   GIM_Reject,
     /* 326881 */ // Label 6765: @326881
     /* 326881 */ GIM_Reject,
     /* 326882 */ // Label 6756: @326882
     /* 326882 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(326908), // Rule ID 707 //
     /* 326887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326901 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 326901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 326906 */   GIR_RootConstrainSelectedInstOperands,
     /* 326907 */   // GIR_Coverage, 707,
     /* 326907 */   GIR_Done,
     /* 326908 */ // Label 6769: @326908
     /* 326908 */ GIM_Reject,
     /* 326909 */ // Label 6757: @326909
     /* 326909 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(327091),
     /* 326914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326921 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(326999), // Rule ID 4879 //
     /* 326926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 326934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 326950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 326962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 326975 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 326982 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 326982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 326985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 326992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 326997 */     GIR_RootConstrainSelectedInstOperands,
     /* 326998 */     // GIR_Coverage, 4879,
     /* 326998 */     GIR_EraseRootFromParent_Done,
     /* 326999 */   // Label 6771: @326999
     /* 326999 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(327071), // Rule ID 4878 //
     /* 327004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327056 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 327056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 327059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327069 */     GIR_RootConstrainSelectedInstOperands,
     /* 327070 */     // GIR_Coverage, 4878,
     /* 327070 */     GIR_EraseRootFromParent_Done,
     /* 327071 */   // Label 6772: @327071
     /* 327071 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(327090), // Rule ID 709 //
     /* 327076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327083 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 327083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 327088 */     GIR_RootConstrainSelectedInstOperands,
     /* 327089 */     // GIR_Coverage, 709,
     /* 327089 */     GIR_Done,
     /* 327090 */   // Label 6773: @327090
     /* 327090 */   GIM_Reject,
     /* 327091 */ // Label 6770: @327091
     /* 327091 */ GIM_Reject,
     /* 327092 */ // Label 6758: @327092
     /* 327092 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(327118), // Rule ID 705 //
     /* 327097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327111 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 327111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 327116 */   GIR_RootConstrainSelectedInstOperands,
     /* 327117 */   // GIR_Coverage, 705,
     /* 327117 */   GIR_Done,
     /* 327118 */ // Label 6774: @327118
     /* 327118 */ GIM_Reject,
     /* 327119 */ // Label 6759: @327119
     /* 327119 */ GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(327301),
     /* 327124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327131 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(327209), // Rule ID 4877 //
     /* 327136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327185 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327192 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 327192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 327195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327207 */     GIR_RootConstrainSelectedInstOperands,
     /* 327208 */     // GIR_Coverage, 4877,
     /* 327208 */     GIR_EraseRootFromParent_Done,
     /* 327209 */   // Label 6776: @327209
     /* 327209 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(327281), // Rule ID 4876 //
     /* 327214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327266 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 327266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 327269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327279 */     GIR_RootConstrainSelectedInstOperands,
     /* 327280 */     // GIR_Coverage, 4876,
     /* 327280 */     GIR_EraseRootFromParent_Done,
     /* 327281 */   // Label 6777: @327281
     /* 327281 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(327300), // Rule ID 708 //
     /* 327286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327293 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 327293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 327298 */     GIR_RootConstrainSelectedInstOperands,
     /* 327299 */     // GIR_Coverage, 708,
     /* 327299 */     GIR_Done,
     /* 327300 */   // Label 6778: @327300
     /* 327300 */   GIM_Reject,
     /* 327301 */ // Label 6775: @327301
     /* 327301 */ GIM_Reject,
     /* 327302 */ // Label 6760: @327302
     /* 327302 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(327328), // Rule ID 703 //
     /* 327307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327321 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 327321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 327326 */   GIR_RootConstrainSelectedInstOperands,
     /* 327327 */   // GIR_Coverage, 703,
     /* 327327 */   GIR_Done,
     /* 327328 */ // Label 6779: @327328
     /* 327328 */ GIM_Reject,
     /* 327329 */ // Label 6761: @327329
     /* 327329 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(327511),
     /* 327334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327341 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(327419), // Rule ID 4875 //
     /* 327346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327395 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327402 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 327402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 327405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327417 */     GIR_RootConstrainSelectedInstOperands,
     /* 327418 */     // GIR_Coverage, 4875,
     /* 327418 */     GIR_EraseRootFromParent_Done,
     /* 327419 */   // Label 6781: @327419
     /* 327419 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(327491), // Rule ID 4874 //
     /* 327424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327469 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327476 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 327476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 327479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327489 */     GIR_RootConstrainSelectedInstOperands,
     /* 327490 */     // GIR_Coverage, 4874,
     /* 327490 */     GIR_EraseRootFromParent_Done,
     /* 327491 */   // Label 6782: @327491
     /* 327491 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(327510), // Rule ID 706 //
     /* 327496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327503 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 327503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 327508 */     GIR_RootConstrainSelectedInstOperands,
     /* 327509 */     // GIR_Coverage, 706,
     /* 327509 */     GIR_Done,
     /* 327510 */   // Label 6783: @327510
     /* 327510 */   GIM_Reject,
     /* 327511 */ // Label 6780: @327511
     /* 327511 */ GIM_Reject,
     /* 327512 */ // Label 6762: @327512
     /* 327512 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(327538), // Rule ID 704 //
     /* 327517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327531 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 327531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 327536 */   GIR_RootConstrainSelectedInstOperands,
     /* 327537 */   // GIR_Coverage, 704,
     /* 327537 */   GIR_Done,
     /* 327538 */ // Label 6784: @327538
     /* 327538 */ GIM_Reject,
     /* 327539 */ // Label 6763: @327539
     /* 327539 */ GIM_Reject,
     /* 327540 */ // Label 84: @327540
     /* 327540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6787*/ GIMT_Encode4(327705),
     /* 327551 */ /*GILLT_s32*//*Label 6785*/ GIMT_Encode4(327559),
     /* 327555 */ /*GILLT_s64*//*Label 6786*/ GIMT_Encode4(327632),
     /* 327559 */ // Label 6785: @327559
     /* 327559 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(327585), // Rule ID 4720 //
     /* 327564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327574 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 327574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 327579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327583 */   GIR_RootConstrainSelectedInstOperands,
     /* 327584 */   // GIR_Coverage, 4720,
     /* 327584 */   GIR_Done,
     /* 327585 */ // Label 6788: @327585
     /* 327585 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(327608), // Rule ID 4726 //
     /* 327590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327597 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 327597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 327602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327606 */   GIR_RootConstrainSelectedInstOperands,
     /* 327607 */   // GIR_Coverage, 4726,
     /* 327607 */   GIR_Done,
     /* 327608 */ // Label 6789: @327608
     /* 327608 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(327631), // Rule ID 4728 //
     /* 327613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327620 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 327620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 327625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327629 */   GIR_RootConstrainSelectedInstOperands,
     /* 327630 */   // GIR_Coverage, 4728,
     /* 327630 */   GIR_Done,
     /* 327631 */ // Label 6790: @327631
     /* 327631 */ GIM_Reject,
     /* 327632 */ // Label 6786: @327632
     /* 327632 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(327658), // Rule ID 4722 //
     /* 327637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327647 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 327647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 327652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327656 */   GIR_RootConstrainSelectedInstOperands,
     /* 327657 */   // GIR_Coverage, 4722,
     /* 327657 */   GIR_Done,
     /* 327658 */ // Label 6791: @327658
     /* 327658 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(327681), // Rule ID 4730 //
     /* 327663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327670 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 327670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 327675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327679 */   GIR_RootConstrainSelectedInstOperands,
     /* 327680 */   // GIR_Coverage, 4730,
     /* 327680 */   GIR_Done,
     /* 327681 */ // Label 6792: @327681
     /* 327681 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(327704), // Rule ID 4732 //
     /* 327686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327693 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 327693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 327698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327702 */   GIR_RootConstrainSelectedInstOperands,
     /* 327703 */   // GIR_Coverage, 4732,
     /* 327703 */   GIR_Done,
     /* 327704 */ // Label 6793: @327704
     /* 327704 */ GIM_Reject,
     /* 327705 */ // Label 6787: @327705
     /* 327705 */ GIM_Reject,
     /* 327706 */ // Label 85: @327706
     /* 327706 */ GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(327804),
     /* 327711 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 327714 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6798*/ GIMT_Encode4(327803),
     /* 327725 */   /*GILLT_s16*//*Label 6795*/ GIMT_Encode4(327737),
     /* 327729 */   /*GILLT_s32*//*Label 6796*/ GIMT_Encode4(327761),
     /* 327733 */   /*GILLT_s64*//*Label 6797*/ GIMT_Encode4(327782),
     /* 327737 */   // Label 6795: @327737
     /* 327737 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(327760), // Rule ID 4724 //
     /* 327742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327749 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 327749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 327754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327758 */     GIR_RootConstrainSelectedInstOperands,
     /* 327759 */     // GIR_Coverage, 4724,
     /* 327759 */     GIR_Done,
     /* 327760 */   // Label 6799: @327760
     /* 327760 */   GIM_Reject,
     /* 327761 */   // Label 6796: @327761
     /* 327761 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(327781), // Rule ID 4734 //
     /* 327766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327770 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 327770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 327775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327779 */     GIR_RootConstrainSelectedInstOperands,
     /* 327780 */     // GIR_Coverage, 4734,
     /* 327780 */     GIR_Done,
     /* 327781 */   // Label 6800: @327781
     /* 327781 */   GIM_Reject,
     /* 327782 */   // Label 6797: @327782
     /* 327782 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(327802), // Rule ID 4736 //
     /* 327787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327791 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 327791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 327796 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327800 */     GIR_RootConstrainSelectedInstOperands,
     /* 327801 */     // GIR_Coverage, 4736,
     /* 327801 */     GIR_Done,
     /* 327802 */   // Label 6801: @327802
     /* 327802 */   GIM_Reject,
     /* 327803 */   // Label 6798: @327803
     /* 327803 */   GIM_Reject,
     /* 327804 */ // Label 6794: @327804
     /* 327804 */ GIM_Reject,
     /* 327805 */ // Label 86: @327805
     /* 327805 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(327820), // Rule ID 225 //
     /* 327810 */   // MIs[0] addr
     /* 327810 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 327813 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 327813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 327818 */   GIR_RootConstrainSelectedInstOperands,
     /* 327819 */   // GIR_Coverage, 225,
     /* 327819 */   GIR_Done,
     /* 327820 */ // Label 6802: @327820
     /* 327820 */ GIM_Reject,
     /* 327821 */ // Label 87: @327821
     /* 327821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6814*/ GIMT_Encode4(333192),
     /* 327832 */ /*GILLT_s64*//*Label 6803*/ GIMT_Encode4(327904), GIMT_Encode4(0),
     /* 327840 */ /*GILLT_v2s32*//*Label 6804*/ GIMT_Encode4(328306), GIMT_Encode4(0),
     /* 327848 */ /*GILLT_v4s16*//*Label 6805*/ GIMT_Encode4(328708), GIMT_Encode4(0),
     /* 327856 */ /*GILLT_v8s8*//*Label 6806*/ GIMT_Encode4(329110), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 327868 */ /*GILLT_nxv1s1*//*Label 6807*/ GIMT_Encode4(329290),
     /* 327872 */ /*GILLT_nxv2s1*//*Label 6808*/ GIMT_Encode4(331553),
     /* 327876 */ /*GILLT_nxv2s16*//*Label 6809*/ GIMT_Encode4(332408),
     /* 327880 */ /*GILLT_nxv2s32*//*Label 6810*/ GIMT_Encode4(332695), GIMT_Encode4(0),
     /* 327888 */ /*GILLT_nxv4s1*//*Label 6811*/ GIMT_Encode4(332765),
     /* 327892 */ /*GILLT_nxv4s16*//*Label 6812*/ GIMT_Encode4(333052), GIMT_Encode4(0),
     /* 327900 */ /*GILLT_nxv8s1*//*Label 6813*/ GIMT_Encode4(333122),
     /* 327904 */ // Label 6803: @327904
     /* 327904 */ GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(328305),
     /* 327909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327916 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(327968), // Rule ID 5567 //
     /* 327921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 327929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327933 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 327935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327940 */     // MIs[0] Operand 2
     /* 327940 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 327951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327953 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 327953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 327956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 327962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 327966 */     GIR_RootConstrainSelectedInstOperands,
     /* 327967 */     // GIR_Coverage, 5567,
     /* 327967 */     GIR_EraseRootFromParent_Done,
     /* 327968 */   // Label 6816: @327968
     /* 327968 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(328020), // Rule ID 5570 //
     /* 327973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 327981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327985 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 327987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327992 */     // MIs[0] Operand 2
     /* 327992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328005 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 328008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328018 */     GIR_RootConstrainSelectedInstOperands,
     /* 328019 */     // GIR_Coverage, 5570,
     /* 328019 */     GIR_EraseRootFromParent_Done,
     /* 328020 */   // Label 6817: @328020
     /* 328020 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(328088), // Rule ID 5446 //
     /* 328025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328029 */     // MIs[0] Operand 2
     /* 328029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328040 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328070 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328087 */     // GIR_Coverage, 5446,
     /* 328087 */     GIR_EraseRootFromParent_Done,
     /* 328088 */   // Label 6818: @328088
     /* 328088 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(328156), // Rule ID 5451 //
     /* 328093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328097 */     // MIs[0] Operand 2
     /* 328097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328108 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328138 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328155 */     // GIR_Coverage, 5451,
     /* 328155 */     GIR_EraseRootFromParent_Done,
     /* 328156 */   // Label 6819: @328156
     /* 328156 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(328198), // Rule ID 6858 //
     /* 328161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328165 */     // MIs[0] Operand 2
     /* 328165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328176 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 328176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328181 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328197 */     // GIR_Coverage, 6858,
     /* 328197 */     GIR_EraseRootFromParent_Done,
     /* 328198 */   // Label 6820: @328198
     /* 328198 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(328240), // Rule ID 6859 //
     /* 328203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328207 */     // MIs[0] Operand 2
     /* 328207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328218 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 328218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328223 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328239 */     // GIR_Coverage, 6859,
     /* 328239 */     GIR_EraseRootFromParent_Done,
     /* 328240 */   // Label 6821: @328240
     /* 328240 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(328304), // Rule ID 6863 //
     /* 328245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328249 */     // MIs[0] Operand 2
     /* 328249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328260 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 328279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328286 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328303 */     // GIR_Coverage, 6863,
     /* 328303 */     GIR_EraseRootFromParent_Done,
     /* 328304 */   // Label 6822: @328304
     /* 328304 */   GIM_Reject,
     /* 328305 */ // Label 6815: @328305
     /* 328305 */ GIM_Reject,
     /* 328306 */ // Label 6804: @328306
     /* 328306 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(328707),
     /* 328311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328318 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(328370), // Rule ID 5566 //
     /* 328323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328335 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328342 */     // MIs[0] Operand 2
     /* 328342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328355 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 328358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328368 */     GIR_RootConstrainSelectedInstOperands,
     /* 328369 */     // GIR_Coverage, 5566,
     /* 328369 */     GIR_EraseRootFromParent_Done,
     /* 328370 */   // Label 6824: @328370
     /* 328370 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(328422), // Rule ID 5569 //
     /* 328375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328387 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328394 */     // MIs[0] Operand 2
     /* 328394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328407 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 328410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328420 */     GIR_RootConstrainSelectedInstOperands,
     /* 328421 */     // GIR_Coverage, 5569,
     /* 328421 */     GIR_EraseRootFromParent_Done,
     /* 328422 */   // Label 6825: @328422
     /* 328422 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(328490), // Rule ID 5436 //
     /* 328427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328431 */     // MIs[0] Operand 2
     /* 328431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328442 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328489 */     // GIR_Coverage, 5436,
     /* 328489 */     GIR_EraseRootFromParent_Done,
     /* 328490 */   // Label 6826: @328490
     /* 328490 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(328558), // Rule ID 5441 //
     /* 328495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328499 */     // MIs[0] Operand 2
     /* 328499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328510 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328557 */     // GIR_Coverage, 5441,
     /* 328557 */     GIR_EraseRootFromParent_Done,
     /* 328558 */   // Label 6827: @328558
     /* 328558 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(328600), // Rule ID 6855 //
     /* 328563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328567 */     // MIs[0] Operand 2
     /* 328567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328578 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 328578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328583 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328599 */     // GIR_Coverage, 6855,
     /* 328599 */     GIR_EraseRootFromParent_Done,
     /* 328600 */   // Label 6828: @328600
     /* 328600 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(328642), // Rule ID 6857 //
     /* 328605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328609 */     // MIs[0] Operand 2
     /* 328609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328620 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 328620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328625 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328641 */     // GIR_Coverage, 6857,
     /* 328641 */     GIR_EraseRootFromParent_Done,
     /* 328642 */   // Label 6829: @328642
     /* 328642 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(328706), // Rule ID 6862 //
     /* 328647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328651 */     // MIs[0] Operand 2
     /* 328651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328662 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 328681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328688 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328705 */     // GIR_Coverage, 6862,
     /* 328705 */     GIR_EraseRootFromParent_Done,
     /* 328706 */   // Label 6830: @328706
     /* 328706 */   GIM_Reject,
     /* 328707 */ // Label 6823: @328707
     /* 328707 */ GIM_Reject,
     /* 328708 */ // Label 6805: @328708
     /* 328708 */ GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(329109),
     /* 328713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328720 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(328772), // Rule ID 5565 //
     /* 328725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328737 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328744 */     // MIs[0] Operand 2
     /* 328744 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328757 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 328757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 328760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328770 */     GIR_RootConstrainSelectedInstOperands,
     /* 328771 */     // GIR_Coverage, 5565,
     /* 328771 */     GIR_EraseRootFromParent_Done,
     /* 328772 */   // Label 6832: @328772
     /* 328772 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(328824), // Rule ID 5568 //
     /* 328777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328789 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328796 */     // MIs[0] Operand 2
     /* 328796 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 328807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328809 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 328809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 328812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328822 */     GIR_RootConstrainSelectedInstOperands,
     /* 328823 */     // GIR_Coverage, 5568,
     /* 328823 */     GIR_EraseRootFromParent_Done,
     /* 328824 */   // Label 6833: @328824
     /* 328824 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(328892), // Rule ID 5426 //
     /* 328829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328833 */     // MIs[0] Operand 2
     /* 328833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 328844 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328874 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328891 */     // GIR_Coverage, 5426,
     /* 328891 */     GIR_EraseRootFromParent_Done,
     /* 328892 */   // Label 6834: @328892
     /* 328892 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(328960), // Rule ID 5431 //
     /* 328897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328901 */     // MIs[0] Operand 2
     /* 328901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 328912 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328942 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328959 */     // GIR_Coverage, 5431,
     /* 328959 */     GIR_EraseRootFromParent_Done,
     /* 328960 */   // Label 6835: @328960
     /* 328960 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(329002), // Rule ID 6853 //
     /* 328965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328969 */     // MIs[0] Operand 2
     /* 328969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328980 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 328980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328985 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329001 */     // GIR_Coverage, 6853,
     /* 329001 */     GIR_EraseRootFromParent_Done,
     /* 329002 */   // Label 6836: @329002
     /* 329002 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(329044), // Rule ID 6856 //
     /* 329007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329011 */     // MIs[0] Operand 2
     /* 329011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329022 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 329022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329027 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329043 */     // GIR_Coverage, 6856,
     /* 329043 */     GIR_EraseRootFromParent_Done,
     /* 329044 */   // Label 6837: @329044
     /* 329044 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(329108), // Rule ID 6861 //
     /* 329049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329053 */     // MIs[0] Operand 2
     /* 329053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329064 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329107 */     // GIR_Coverage, 6861,
     /* 329107 */     GIR_EraseRootFromParent_Done,
     /* 329108 */   // Label 6838: @329108
     /* 329108 */   GIM_Reject,
     /* 329109 */ // Label 6831: @329109
     /* 329109 */ GIM_Reject,
     /* 329110 */ // Label 6806: @329110
     /* 329110 */ GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(329289),
     /* 329115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329126 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(329190), // Rule ID 5421 //
     /* 329131 */     // MIs[0] Operand 2
     /* 329131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329142 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329189 */     // GIR_Coverage, 5421,
     /* 329189 */     GIR_EraseRootFromParent_Done,
     /* 329190 */   // Label 6840: @329190
     /* 329190 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(329228), // Rule ID 6854 //
     /* 329195 */     // MIs[0] Operand 2
     /* 329195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329206 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 329206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329211 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329227 */     // GIR_Coverage, 6854,
     /* 329227 */     GIR_EraseRootFromParent_Done,
     /* 329228 */   // Label 6841: @329228
     /* 329228 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(329288), // Rule ID 6860 //
     /* 329233 */     // MIs[0] Operand 2
     /* 329233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329244 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329260 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329270 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329287 */     // GIR_Coverage, 6860,
     /* 329287 */     GIR_EraseRootFromParent_Done,
     /* 329288 */   // Label 6842: @329288
     /* 329288 */   GIM_Reject,
     /* 329289 */ // Label 6839: @329289
     /* 329289 */ GIM_Reject,
     /* 329290 */ // Label 6807: @329290
     /* 329290 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(329325), // Rule ID 8916 //
     /* 329295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329305 */   // MIs[0] Operand 2
     /* 329305 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329316 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329321 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329323 */   GIR_RootConstrainSelectedInstOperands,
     /* 329324 */   // GIR_Coverage, 8916,
     /* 329324 */   GIR_EraseRootFromParent_Done,
     /* 329325 */ // Label 6843: @329325
     /* 329325 */ GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(329360), // Rule ID 8917 //
     /* 329330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329340 */   // MIs[0] Operand 2
     /* 329340 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329351 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329356 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329358 */   GIR_RootConstrainSelectedInstOperands,
     /* 329359 */   // GIR_Coverage, 8917,
     /* 329359 */   GIR_EraseRootFromParent_Done,
     /* 329360 */ // Label 6844: @329360
     /* 329360 */ GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(329414), // Rule ID 8924 //
     /* 329365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329375 */   // MIs[0] Operand 2
     /* 329375 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329386 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329412 */   GIR_RootConstrainSelectedInstOperands,
     /* 329413 */   // GIR_Coverage, 8924,
     /* 329413 */   GIR_EraseRootFromParent_Done,
     /* 329414 */ // Label 6845: @329414
     /* 329414 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(329468), // Rule ID 8925 //
     /* 329419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329429 */   // MIs[0] Operand 2
     /* 329429 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329440 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329466 */   GIR_RootConstrainSelectedInstOperands,
     /* 329467 */   // GIR_Coverage, 8925,
     /* 329467 */   GIR_EraseRootFromParent_Done,
     /* 329468 */ // Label 6846: @329468
     /* 329468 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(329522), // Rule ID 8926 //
     /* 329473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329483 */   // MIs[0] Operand 2
     /* 329483 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329494 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329506 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329520 */   GIR_RootConstrainSelectedInstOperands,
     /* 329521 */   // GIR_Coverage, 8926,
     /* 329521 */   GIR_EraseRootFromParent_Done,
     /* 329522 */ // Label 6847: @329522
     /* 329522 */ GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(329576), // Rule ID 8927 //
     /* 329527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329537 */   // MIs[0] Operand 2
     /* 329537 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 329548 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329574 */   GIR_RootConstrainSelectedInstOperands,
     /* 329575 */   // GIR_Coverage, 8927,
     /* 329575 */   GIR_EraseRootFromParent_Done,
     /* 329576 */ // Label 6848: @329576
     /* 329576 */ GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(329647), // Rule ID 8936 //
     /* 329581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329591 */   // MIs[0] Operand 2
     /* 329591 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329602 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329602 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329605 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329609 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329614 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329632 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329645 */   GIR_RootConstrainSelectedInstOperands,
     /* 329646 */   // GIR_Coverage, 8936,
     /* 329646 */   GIR_EraseRootFromParent_Done,
     /* 329647 */ // Label 6849: @329647
     /* 329647 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(329718), // Rule ID 8937 //
     /* 329652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329662 */   // MIs[0] Operand 2
     /* 329662 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329673 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329673 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329676 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329680 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329685 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329703 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329716 */   GIR_RootConstrainSelectedInstOperands,
     /* 329717 */   // GIR_Coverage, 8937,
     /* 329717 */   GIR_EraseRootFromParent_Done,
     /* 329718 */ // Label 6850: @329718
     /* 329718 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(329789), // Rule ID 8938 //
     /* 329723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329733 */   // MIs[0] Operand 2
     /* 329733 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329744 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329744 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329747 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329751 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329756 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329787 */   GIR_RootConstrainSelectedInstOperands,
     /* 329788 */   // GIR_Coverage, 8938,
     /* 329788 */   GIR_EraseRootFromParent_Done,
     /* 329789 */ // Label 6851: @329789
     /* 329789 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(329860), // Rule ID 8939 //
     /* 329794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329804 */   // MIs[0] Operand 2
     /* 329804 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 329815 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329827 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329845 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329858 */   GIR_RootConstrainSelectedInstOperands,
     /* 329859 */   // GIR_Coverage, 8939,
     /* 329859 */   GIR_EraseRootFromParent_Done,
     /* 329860 */ // Label 6852: @329860
     /* 329860 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(329931), // Rule ID 8940 //
     /* 329865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329875 */   // MIs[0] Operand 2
     /* 329875 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329886 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329886 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329889 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329893 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329898 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329916 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329929 */   GIR_RootConstrainSelectedInstOperands,
     /* 329930 */   // GIR_Coverage, 8940,
     /* 329930 */   GIR_EraseRootFromParent_Done,
     /* 329931 */ // Label 6853: @329931
     /* 329931 */ GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(330002), // Rule ID 8941 //
     /* 329936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329946 */   // MIs[0] Operand 2
     /* 329946 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 329957 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329969 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329987 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330000 */   GIR_RootConstrainSelectedInstOperands,
     /* 330001 */   // GIR_Coverage, 8941,
     /* 330001 */   GIR_EraseRootFromParent_Done,
     /* 330002 */ // Label 6854: @330002
     /* 330002 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(330073), // Rule ID 8942 //
     /* 330007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330017 */   // MIs[0] Operand 2
     /* 330017 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330028 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330058 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330071 */   GIR_RootConstrainSelectedInstOperands,
     /* 330072 */   // GIR_Coverage, 8942,
     /* 330072 */   GIR_EraseRootFromParent_Done,
     /* 330073 */ // Label 6855: @330073
     /* 330073 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(330144), // Rule ID 8943 //
     /* 330078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330088 */   // MIs[0] Operand 2
     /* 330088 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330099 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330099 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330102 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330106 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330111 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330129 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330142 */   GIR_RootConstrainSelectedInstOperands,
     /* 330143 */   // GIR_Coverage, 8943,
     /* 330143 */   GIR_EraseRootFromParent_Done,
     /* 330144 */ // Label 6856: @330144
     /* 330144 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(330232), // Rule ID 8952 //
     /* 330149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330159 */   // MIs[0] Operand 2
     /* 330159 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330170 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330170 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330173 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330177 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330182 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330200 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330217 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330230 */   GIR_RootConstrainSelectedInstOperands,
     /* 330231 */   // GIR_Coverage, 8952,
     /* 330231 */   GIR_EraseRootFromParent_Done,
     /* 330232 */ // Label 6857: @330232
     /* 330232 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(330320), // Rule ID 8953 //
     /* 330237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330247 */   // MIs[0] Operand 2
     /* 330247 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330258 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330270 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330288 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330318 */   GIR_RootConstrainSelectedInstOperands,
     /* 330319 */   // GIR_Coverage, 8953,
     /* 330319 */   GIR_EraseRootFromParent_Done,
     /* 330320 */ // Label 6858: @330320
     /* 330320 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(330408), // Rule ID 8954 //
     /* 330325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330335 */   // MIs[0] Operand 2
     /* 330335 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330346 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330346 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330349 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330353 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330358 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330364 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330367 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330371 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330376 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330393 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330406 */   GIR_RootConstrainSelectedInstOperands,
     /* 330407 */   // GIR_Coverage, 8954,
     /* 330407 */   GIR_EraseRootFromParent_Done,
     /* 330408 */ // Label 6859: @330408
     /* 330408 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(330496), // Rule ID 8955 //
     /* 330413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330423 */   // MIs[0] Operand 2
     /* 330423 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330434 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330434 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330437 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330441 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330446 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330464 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330481 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330494 */   GIR_RootConstrainSelectedInstOperands,
     /* 330495 */   // GIR_Coverage, 8955,
     /* 330495 */   GIR_EraseRootFromParent_Done,
     /* 330496 */ // Label 6860: @330496
     /* 330496 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(330584), // Rule ID 8956 //
     /* 330501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330511 */   // MIs[0] Operand 2
     /* 330511 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330522 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330522 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330525 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330529 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330534 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330552 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330569 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330582 */   GIR_RootConstrainSelectedInstOperands,
     /* 330583 */   // GIR_Coverage, 8956,
     /* 330583 */   GIR_EraseRootFromParent_Done,
     /* 330584 */ // Label 6861: @330584
     /* 330584 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(330672), // Rule ID 8957 //
     /* 330589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330599 */   // MIs[0] Operand 2
     /* 330599 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330610 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330610 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330613 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330617 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330622 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330628 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330631 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330635 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330640 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330670 */   GIR_RootConstrainSelectedInstOperands,
     /* 330671 */   // GIR_Coverage, 8957,
     /* 330671 */   GIR_EraseRootFromParent_Done,
     /* 330672 */ // Label 6862: @330672
     /* 330672 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(330760), // Rule ID 8958 //
     /* 330677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330687 */   // MIs[0] Operand 2
     /* 330687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330698 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330710 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330728 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330758 */   GIR_RootConstrainSelectedInstOperands,
     /* 330759 */   // GIR_Coverage, 8958,
     /* 330759 */   GIR_EraseRootFromParent_Done,
     /* 330760 */ // Label 6863: @330760
     /* 330760 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(330848), // Rule ID 8959 //
     /* 330765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330775 */   // MIs[0] Operand 2
     /* 330775 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330786 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330786 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330789 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330793 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330798 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330816 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330833 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330846 */   GIR_RootConstrainSelectedInstOperands,
     /* 330847 */   // GIR_Coverage, 8959,
     /* 330847 */   GIR_EraseRootFromParent_Done,
     /* 330848 */ // Label 6864: @330848
     /* 330848 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(330936), // Rule ID 8960 //
     /* 330853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330863 */   // MIs[0] Operand 2
     /* 330863 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 330874 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330874 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330877 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330881 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330886 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330892 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330895 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330899 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330904 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330921 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330934 */   GIR_RootConstrainSelectedInstOperands,
     /* 330935 */   // GIR_Coverage, 8960,
     /* 330935 */   GIR_EraseRootFromParent_Done,
     /* 330936 */ // Label 6865: @330936
     /* 330936 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(331024), // Rule ID 8961 //
     /* 330941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330951 */   // MIs[0] Operand 2
     /* 330951 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 330962 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330962 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330965 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330969 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330974 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330980 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330983 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330987 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330992 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331009 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331022 */   GIR_RootConstrainSelectedInstOperands,
     /* 331023 */   // GIR_Coverage, 8961,
     /* 331023 */   GIR_EraseRootFromParent_Done,
     /* 331024 */ // Label 6866: @331024
     /* 331024 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(331112), // Rule ID 8962 //
     /* 331029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331039 */   // MIs[0] Operand 2
     /* 331039 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 331050 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331050 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331053 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331057 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331062 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331080 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331110 */   GIR_RootConstrainSelectedInstOperands,
     /* 331111 */   // GIR_Coverage, 8962,
     /* 331111 */   GIR_EraseRootFromParent_Done,
     /* 331112 */ // Label 6867: @331112
     /* 331112 */ GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(331200), // Rule ID 8963 //
     /* 331117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331127 */   // MIs[0] Operand 2
     /* 331127 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 331138 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331138 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331141 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331145 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331150 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331156 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331159 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331163 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331168 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331185 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331198 */   GIR_RootConstrainSelectedInstOperands,
     /* 331199 */   // GIR_Coverage, 8963,
     /* 331199 */   GIR_EraseRootFromParent_Done,
     /* 331200 */ // Label 6868: @331200
     /* 331200 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(331288), // Rule ID 8964 //
     /* 331205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331215 */   // MIs[0] Operand 2
     /* 331215 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 331226 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331226 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331229 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331233 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331238 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331256 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331273 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331286 */   GIR_RootConstrainSelectedInstOperands,
     /* 331287 */   // GIR_Coverage, 8964,
     /* 331287 */   GIR_EraseRootFromParent_Done,
     /* 331288 */ // Label 6869: @331288
     /* 331288 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(331376), // Rule ID 8965 //
     /* 331293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331303 */   // MIs[0] Operand 2
     /* 331303 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 331314 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331326 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331344 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331361 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331374 */   GIR_RootConstrainSelectedInstOperands,
     /* 331375 */   // GIR_Coverage, 8965,
     /* 331375 */   GIR_EraseRootFromParent_Done,
     /* 331376 */ // Label 6870: @331376
     /* 331376 */ GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(331464), // Rule ID 8966 //
     /* 331381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331391 */   // MIs[0] Operand 2
     /* 331391 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 331402 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331402 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331405 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331409 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331414 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331420 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331423 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331427 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331432 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331449 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331462 */   GIR_RootConstrainSelectedInstOperands,
     /* 331463 */   // GIR_Coverage, 8966,
     /* 331463 */   GIR_EraseRootFromParent_Done,
     /* 331464 */ // Label 6871: @331464
     /* 331464 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(331552), // Rule ID 8967 //
     /* 331469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331479 */   // MIs[0] Operand 2
     /* 331479 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 331490 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331502 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331520 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331550 */   GIR_RootConstrainSelectedInstOperands,
     /* 331551 */   // GIR_Coverage, 8967,
     /* 331551 */   GIR_EraseRootFromParent_Done,
     /* 331552 */ // Label 6872: @331552
     /* 331552 */ GIM_Reject,
     /* 331553 */ // Label 6808: @331553
     /* 331553 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(331588), // Rule ID 8918 //
     /* 331558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331568 */   // MIs[0] Operand 2
     /* 331568 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331579 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331586 */   GIR_RootConstrainSelectedInstOperands,
     /* 331587 */   // GIR_Coverage, 8918,
     /* 331587 */   GIR_EraseRootFromParent_Done,
     /* 331588 */ // Label 6873: @331588
     /* 331588 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(331623), // Rule ID 8919 //
     /* 331593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331603 */   // MIs[0] Operand 2
     /* 331603 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331614 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331619 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331621 */   GIR_RootConstrainSelectedInstOperands,
     /* 331622 */   // GIR_Coverage, 8919,
     /* 331622 */   GIR_EraseRootFromParent_Done,
     /* 331623 */ // Label 6874: @331623
     /* 331623 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(331677), // Rule ID 8928 //
     /* 331628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331638 */   // MIs[0] Operand 2
     /* 331638 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331649 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331675 */   GIR_RootConstrainSelectedInstOperands,
     /* 331676 */   // GIR_Coverage, 8928,
     /* 331676 */   GIR_EraseRootFromParent_Done,
     /* 331677 */ // Label 6875: @331677
     /* 331677 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(331731), // Rule ID 8929 //
     /* 331682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331692 */   // MIs[0] Operand 2
     /* 331692 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331703 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331729 */   GIR_RootConstrainSelectedInstOperands,
     /* 331730 */   // GIR_Coverage, 8929,
     /* 331730 */   GIR_EraseRootFromParent_Done,
     /* 331731 */ // Label 6876: @331731
     /* 331731 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(331785), // Rule ID 8930 //
     /* 331736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331746 */   // MIs[0] Operand 2
     /* 331746 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 331757 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331783 */   GIR_RootConstrainSelectedInstOperands,
     /* 331784 */   // GIR_Coverage, 8930,
     /* 331784 */   GIR_EraseRootFromParent_Done,
     /* 331785 */ // Label 6877: @331785
     /* 331785 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(331839), // Rule ID 8931 //
     /* 331790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331800 */   // MIs[0] Operand 2
     /* 331800 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 331811 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331837 */   GIR_RootConstrainSelectedInstOperands,
     /* 331838 */   // GIR_Coverage, 8931,
     /* 331838 */   GIR_EraseRootFromParent_Done,
     /* 331839 */ // Label 6878: @331839
     /* 331839 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(331910), // Rule ID 8944 //
     /* 331844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331854 */   // MIs[0] Operand 2
     /* 331854 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331865 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 331865 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331868 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331872 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331877 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331895 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331908 */   GIR_RootConstrainSelectedInstOperands,
     /* 331909 */   // GIR_Coverage, 8944,
     /* 331909 */   GIR_EraseRootFromParent_Done,
     /* 331910 */ // Label 6879: @331910
     /* 331910 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(331981), // Rule ID 8945 //
     /* 331915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331925 */   // MIs[0] Operand 2
     /* 331925 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331936 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 331936 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331939 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331943 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331948 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331979 */   GIR_RootConstrainSelectedInstOperands,
     /* 331980 */   // GIR_Coverage, 8945,
     /* 331980 */   GIR_EraseRootFromParent_Done,
     /* 331981 */ // Label 6880: @331981
     /* 331981 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(332052), // Rule ID 8946 //
     /* 331986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331996 */   // MIs[0] Operand 2
     /* 331996 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332007 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332037 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332050 */   GIR_RootConstrainSelectedInstOperands,
     /* 332051 */   // GIR_Coverage, 8946,
     /* 332051 */   GIR_EraseRootFromParent_Done,
     /* 332052 */ // Label 6881: @332052
     /* 332052 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(332123), // Rule ID 8947 //
     /* 332057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332067 */   // MIs[0] Operand 2
     /* 332067 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332078 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332090 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332121 */   GIR_RootConstrainSelectedInstOperands,
     /* 332122 */   // GIR_Coverage, 8947,
     /* 332122 */   GIR_EraseRootFromParent_Done,
     /* 332123 */ // Label 6882: @332123
     /* 332123 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(332194), // Rule ID 8948 //
     /* 332128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332138 */   // MIs[0] Operand 2
     /* 332138 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332149 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332149 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332152 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332156 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332161 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332179 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332192 */   GIR_RootConstrainSelectedInstOperands,
     /* 332193 */   // GIR_Coverage, 8948,
     /* 332193 */   GIR_EraseRootFromParent_Done,
     /* 332194 */ // Label 6883: @332194
     /* 332194 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(332265), // Rule ID 8949 //
     /* 332199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332209 */   // MIs[0] Operand 2
     /* 332209 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 332220 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332232 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332250 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332263 */   GIR_RootConstrainSelectedInstOperands,
     /* 332264 */   // GIR_Coverage, 8949,
     /* 332264 */   GIR_EraseRootFromParent_Done,
     /* 332265 */ // Label 6884: @332265
     /* 332265 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(332336), // Rule ID 8950 //
     /* 332270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332280 */   // MIs[0] Operand 2
     /* 332280 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 332291 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332291 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332294 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332298 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332303 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332321 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332334 */   GIR_RootConstrainSelectedInstOperands,
     /* 332335 */   // GIR_Coverage, 8950,
     /* 332335 */   GIR_EraseRootFromParent_Done,
     /* 332336 */ // Label 6885: @332336
     /* 332336 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332407), // Rule ID 8951 //
     /* 332341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332351 */   // MIs[0] Operand 2
     /* 332351 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 332362 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332362 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332365 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332369 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332374 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332392 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332405 */   GIR_RootConstrainSelectedInstOperands,
     /* 332406 */   // GIR_Coverage, 8951,
     /* 332406 */   GIR_EraseRootFromParent_Done,
     /* 332407 */ // Label 6886: @332407
     /* 332407 */ GIM_Reject,
     /* 332408 */ // Label 6809: @332408
     /* 332408 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(332443), // Rule ID 8968 //
     /* 332413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332423 */   // MIs[0] Operand 2
     /* 332423 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332434 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332441 */   GIR_RootConstrainSelectedInstOperands,
     /* 332442 */   // GIR_Coverage, 8968,
     /* 332442 */   GIR_EraseRootFromParent_Done,
     /* 332443 */ // Label 6887: @332443
     /* 332443 */ GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(332478), // Rule ID 8969 //
     /* 332448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332458 */   // MIs[0] Operand 2
     /* 332458 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332469 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332474 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332476 */   GIR_RootConstrainSelectedInstOperands,
     /* 332477 */   // GIR_Coverage, 8969,
     /* 332477 */   GIR_EraseRootFromParent_Done,
     /* 332478 */ // Label 6888: @332478
     /* 332478 */ GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(332532), // Rule ID 8974 //
     /* 332483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332493 */   // MIs[0] Operand 2
     /* 332493 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332504 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332516 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332530 */   GIR_RootConstrainSelectedInstOperands,
     /* 332531 */   // GIR_Coverage, 8974,
     /* 332531 */   GIR_EraseRootFromParent_Done,
     /* 332532 */ // Label 6889: @332532
     /* 332532 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(332586), // Rule ID 8975 //
     /* 332537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332547 */   // MIs[0] Operand 2
     /* 332547 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332558 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332584 */   GIR_RootConstrainSelectedInstOperands,
     /* 332585 */   // GIR_Coverage, 8975,
     /* 332585 */   GIR_EraseRootFromParent_Done,
     /* 332586 */ // Label 6890: @332586
     /* 332586 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(332640), // Rule ID 8976 //
     /* 332591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332601 */   // MIs[0] Operand 2
     /* 332601 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332612 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332624 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332638 */   GIR_RootConstrainSelectedInstOperands,
     /* 332639 */   // GIR_Coverage, 8976,
     /* 332639 */   GIR_EraseRootFromParent_Done,
     /* 332640 */ // Label 6891: @332640
     /* 332640 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332694), // Rule ID 8977 //
     /* 332645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332655 */   // MIs[0] Operand 2
     /* 332655 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332666 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332692 */   GIR_RootConstrainSelectedInstOperands,
     /* 332693 */   // GIR_Coverage, 8977,
     /* 332693 */   GIR_EraseRootFromParent_Done,
     /* 332694 */ // Label 6892: @332694
     /* 332694 */ GIM_Reject,
     /* 332695 */ // Label 6810: @332695
     /* 332695 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(332764),
     /* 332700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 332703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332707 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(332735), // Rule ID 8972 //
     /* 332712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332715 */     // MIs[0] Operand 2
     /* 332715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332726 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 332726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332733 */     GIR_RootConstrainSelectedInstOperands,
     /* 332734 */     // GIR_Coverage, 8972,
     /* 332734 */     GIR_EraseRootFromParent_Done,
     /* 332735 */   // Label 6894: @332735
     /* 332735 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(332763), // Rule ID 8973 //
     /* 332740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332743 */     // MIs[0] Operand 2
     /* 332743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332754 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 332754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332761 */     GIR_RootConstrainSelectedInstOperands,
     /* 332762 */     // GIR_Coverage, 8973,
     /* 332762 */     GIR_EraseRootFromParent_Done,
     /* 332763 */   // Label 6895: @332763
     /* 332763 */   GIM_Reject,
     /* 332764 */ // Label 6893: @332764
     /* 332764 */ GIM_Reject,
     /* 332765 */ // Label 6811: @332765
     /* 332765 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(332800), // Rule ID 8920 //
     /* 332770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332780 */   // MIs[0] Operand 2
     /* 332780 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332791 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 332791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332796 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332798 */   GIR_RootConstrainSelectedInstOperands,
     /* 332799 */   // GIR_Coverage, 8920,
     /* 332799 */   GIR_EraseRootFromParent_Done,
     /* 332800 */ // Label 6896: @332800
     /* 332800 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(332835), // Rule ID 8921 //
     /* 332805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332815 */   // MIs[0] Operand 2
     /* 332815 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332826 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 332826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332831 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332833 */   GIR_RootConstrainSelectedInstOperands,
     /* 332834 */   // GIR_Coverage, 8921,
     /* 332834 */   GIR_EraseRootFromParent_Done,
     /* 332835 */ // Label 6897: @332835
     /* 332835 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(332889), // Rule ID 8932 //
     /* 332840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332850 */   // MIs[0] Operand 2
     /* 332850 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332861 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 332861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332887 */   GIR_RootConstrainSelectedInstOperands,
     /* 332888 */   // GIR_Coverage, 8932,
     /* 332888 */   GIR_EraseRootFromParent_Done,
     /* 332889 */ // Label 6898: @332889
     /* 332889 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(332943), // Rule ID 8933 //
     /* 332894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332904 */   // MIs[0] Operand 2
     /* 332904 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332915 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 332915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332941 */   GIR_RootConstrainSelectedInstOperands,
     /* 332942 */   // GIR_Coverage, 8933,
     /* 332942 */   GIR_EraseRootFromParent_Done,
     /* 332943 */ // Label 6899: @332943
     /* 332943 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(332997), // Rule ID 8934 //
     /* 332948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332958 */   // MIs[0] Operand 2
     /* 332958 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332969 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 332969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332995 */   GIR_RootConstrainSelectedInstOperands,
     /* 332996 */   // GIR_Coverage, 8934,
     /* 332996 */   GIR_EraseRootFromParent_Done,
     /* 332997 */ // Label 6900: @332997
     /* 332997 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(333051), // Rule ID 8935 //
     /* 333002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333012 */   // MIs[0] Operand 2
     /* 333012 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333023 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333035 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333049 */   GIR_RootConstrainSelectedInstOperands,
     /* 333050 */   // GIR_Coverage, 8935,
     /* 333050 */   GIR_EraseRootFromParent_Done,
     /* 333051 */ // Label 6901: @333051
     /* 333051 */ GIM_Reject,
     /* 333052 */ // Label 6812: @333052
     /* 333052 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(333121),
     /* 333057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333064 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(333092), // Rule ID 8970 //
     /* 333069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333072 */     // MIs[0] Operand 2
     /* 333072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333083 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333090 */     GIR_RootConstrainSelectedInstOperands,
     /* 333091 */     // GIR_Coverage, 8970,
     /* 333091 */     GIR_EraseRootFromParent_Done,
     /* 333092 */   // Label 6903: @333092
     /* 333092 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(333120), // Rule ID 8971 //
     /* 333097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333100 */     // MIs[0] Operand 2
     /* 333100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333111 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333118 */     GIR_RootConstrainSelectedInstOperands,
     /* 333119 */     // GIR_Coverage, 8971,
     /* 333119 */     GIR_EraseRootFromParent_Done,
     /* 333120 */   // Label 6904: @333120
     /* 333120 */   GIM_Reject,
     /* 333121 */ // Label 6902: @333121
     /* 333121 */ GIM_Reject,
     /* 333122 */ // Label 6813: @333122
     /* 333122 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(333191),
     /* 333127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333134 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(333162), // Rule ID 8922 //
     /* 333139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333142 */     // MIs[0] Operand 2
     /* 333142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333153 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333160 */     GIR_RootConstrainSelectedInstOperands,
     /* 333161 */     // GIR_Coverage, 8922,
     /* 333161 */     GIR_EraseRootFromParent_Done,
     /* 333162 */   // Label 6906: @333162
     /* 333162 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(333190), // Rule ID 8923 //
     /* 333167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333170 */     // MIs[0] Operand 2
     /* 333170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333181 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333188 */     GIR_RootConstrainSelectedInstOperands,
     /* 333189 */     // GIR_Coverage, 8923,
     /* 333189 */     GIR_EraseRootFromParent_Done,
     /* 333190 */   // Label 6907: @333190
     /* 333190 */   GIM_Reject,
     /* 333191 */ // Label 6905: @333191
     /* 333191 */ GIM_Reject,
     /* 333192 */ // Label 6814: @333192
     /* 333192 */ GIM_Reject,
     /* 333193 */ // Label 88: @333193
     /* 333193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6923*/ GIMT_Encode4(360589),
     /* 333204 */ /*GILLT_s64*//*Label 6908*/ GIMT_Encode4(333288), GIMT_Encode4(0),
     /* 333212 */ /*GILLT_v2s32*//*Label 6909*/ GIMT_Encode4(333998),
     /* 333216 */ /*GILLT_v2s64*//*Label 6910*/ GIMT_Encode4(337529),
     /* 333220 */ /*GILLT_v4s16*//*Label 6911*/ GIMT_Encode4(340358),
     /* 333224 */ /*GILLT_v4s32*//*Label 6912*/ GIMT_Encode4(343998),
     /* 333228 */ /*GILLT_v8s8*//*Label 6913*/ GIMT_Encode4(346662),
     /* 333232 */ /*GILLT_v8s16*//*Label 6914*/ GIMT_Encode4(348506),
     /* 333236 */ /*GILLT_v16s8*//*Label 6915*/ GIMT_Encode4(351481), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 333248 */ /*GILLT_nxv2s16*//*Label 6916*/ GIMT_Encode4(353061),
     /* 333252 */ /*GILLT_nxv2s32*//*Label 6917*/ GIMT_Encode4(353186),
     /* 333256 */ /*GILLT_nxv2s64*//*Label 6918*/ GIMT_Encode4(353311), GIMT_Encode4(0),
     /* 333264 */ /*GILLT_nxv4s16*//*Label 6919*/ GIMT_Encode4(355225),
     /* 333268 */ /*GILLT_nxv4s32*//*Label 6920*/ GIMT_Encode4(355377), GIMT_Encode4(0),
     /* 333276 */ /*GILLT_nxv8s16*//*Label 6921*/ GIMT_Encode4(357345), GIMT_Encode4(0),
     /* 333284 */ /*GILLT_nxv16s8*//*Label 6922*/ GIMT_Encode4(359539),
     /* 333288 */ // Label 6908: @333288
     /* 333288 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(333997),
     /* 333293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 333299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333306 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(333436), // Rule ID 5715 //
     /* 333311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333344 */     // MIs[2] Operand 1
     /* 333344 */     // No operand predicates
     /* 333344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333352 */     // MIs[3] Operand 1
     /* 333352 */     // No operand predicates
     /* 333352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333354 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333354 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333357 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333361 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333369 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333373 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333418 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333435 */     // GIR_Coverage, 5715,
     /* 333435 */     GIR_EraseRootFromParent_Done,
     /* 333436 */   // Label 6925: @333436
     /* 333436 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(333597), // Rule ID 5716 //
     /* 333441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333474 */     // MIs[2] Operand 1
     /* 333474 */     // No operand predicates
     /* 333474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333482 */     // MIs[3] Operand 1
     /* 333482 */     // No operand predicates
     /* 333482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333484 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333484 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 333487 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333491 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333496 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 333499 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333503 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 333506 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333511 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333516 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333519 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333523 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333528 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333535 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333560 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333566 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 333569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333579 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333596 */     // GIR_Coverage, 5716,
     /* 333596 */     GIR_EraseRootFromParent_Done,
     /* 333597 */   // Label 6926: @333597
     /* 333597 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(333727), // Rule ID 5739 //
     /* 333602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333635 */     // MIs[2] Operand 1
     /* 333635 */     // No operand predicates
     /* 333635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333643 */     // MIs[3] Operand 1
     /* 333643 */     // No operand predicates
     /* 333643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333645 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333657 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333664 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333726 */     // GIR_Coverage, 5739,
     /* 333726 */     GIR_EraseRootFromParent_Done,
     /* 333727 */   // Label 6927: @333727
     /* 333727 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(333888), // Rule ID 5740 //
     /* 333732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333765 */     // MIs[2] Operand 1
     /* 333765 */     // No operand predicates
     /* 333765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333773 */     // MIs[3] Operand 1
     /* 333773 */     // No operand predicates
     /* 333773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333775 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 333778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333787 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 333790 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333794 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 333797 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333802 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333819 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333826 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333834 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 333860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333870 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333887 */     // GIR_Coverage, 5740,
     /* 333887 */     GIR_EraseRootFromParent_Done,
     /* 333888 */   // Label 6928: @333888
     /* 333888 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(333924), // Rule ID 6634 //
     /* 333893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333911 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 333911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 333918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333923 */     // GIR_Coverage, 6634,
     /* 333923 */     GIR_EraseRootFromParent_Done,
     /* 333924 */   // Label 6929: @333924
     /* 333924 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(333960), // Rule ID 6636 //
     /* 333929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333947 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 333947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 333954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333959 */     // GIR_Coverage, 6636,
     /* 333959 */     GIR_EraseRootFromParent_Done,
     /* 333960 */   // Label 6930: @333960
     /* 333960 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(333996), // Rule ID 6638 //
     /* 333965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333983 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 333983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333986 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 333988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 333990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333995 */     // GIR_Coverage, 6638,
     /* 333995 */     GIR_EraseRootFromParent_Done,
     /* 333996 */   // Label 6931: @333996
     /* 333996 */   GIM_Reject,
     /* 333997 */ // Label 6924: @333997
     /* 333997 */ GIM_Reject,
     /* 333998 */ // Label 6909: @333998
     /* 333998 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(337528),
     /* 334003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 334006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334016 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(334125), // Rule ID 4264 //
     /* 334021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334065 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334092 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334124 */     // GIR_Coverage, 4264,
     /* 334124 */     GIR_EraseRootFromParent_Done,
     /* 334125 */   // Label 6933: @334125
     /* 334125 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(334234), // Rule ID 4265 //
     /* 334130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334157 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334174 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334201 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334233 */     // GIR_Coverage, 4265,
     /* 334233 */     GIR_EraseRootFromParent_Done,
     /* 334234 */   // Label 6934: @334234
     /* 334234 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(334343), // Rule ID 4372 //
     /* 334239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334243 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334249 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334266 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334283 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334342 */     // GIR_Coverage, 4372,
     /* 334342 */     GIR_EraseRootFromParent_Done,
     /* 334343 */   // Label 6935: @334343
     /* 334343 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(334452), // Rule ID 4373 //
     /* 334348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334375 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334392 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334419 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334451 */     // GIR_Coverage, 4373,
     /* 334451 */     GIR_EraseRootFromParent_Done,
     /* 334452 */   // Label 6936: @334452
     /* 334452 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(334557), // Rule ID 4270 //
     /* 334457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334497 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334524 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334556 */     // GIR_Coverage, 4270,
     /* 334556 */     GIR_EraseRootFromParent_Done,
     /* 334557 */   // Label 6937: @334557
     /* 334557 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(334662), // Rule ID 4272 //
     /* 334562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334602 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334661 */     // GIR_Coverage, 4272,
     /* 334661 */     GIR_EraseRootFromParent_Done,
     /* 334662 */   // Label 6938: @334662
     /* 334662 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(334767), // Rule ID 4378 //
     /* 334667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334683 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334690 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334707 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334766 */     // GIR_Coverage, 4378,
     /* 334766 */     GIR_EraseRootFromParent_Done,
     /* 334767 */   // Label 6939: @334767
     /* 334767 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(334872), // Rule ID 4380 //
     /* 334772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334788 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334795 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334812 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334839 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334871 */     // GIR_Coverage, 4380,
     /* 334871 */     GIR_EraseRootFromParent_Done,
     /* 334872 */   // Label 6940: @334872
     /* 334872 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(334976), // Rule ID 4262 //
     /* 334877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334921 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334943 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334975 */     // GIR_Coverage, 4262,
     /* 334975 */     GIR_EraseRootFromParent_Done,
     /* 334976 */   // Label 6941: @334976
     /* 334976 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(335080), // Rule ID 4263 //
     /* 334981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335001 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335008 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335025 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335079 */     // GIR_Coverage, 4263,
     /* 335079 */     GIR_EraseRootFromParent_Done,
     /* 335080 */   // Label 6942: @335080
     /* 335080 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(335184), // Rule ID 4370 //
     /* 335085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335129 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335183 */     // GIR_Coverage, 4370,
     /* 335183 */     GIR_EraseRootFromParent_Done,
     /* 335184 */   // Label 6943: @335184
     /* 335184 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(335288), // Rule ID 4371 //
     /* 335189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335233 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335287 */     // GIR_Coverage, 4371,
     /* 335287 */     GIR_EraseRootFromParent_Done,
     /* 335288 */   // Label 6944: @335288
     /* 335288 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(335388), // Rule ID 4266 //
     /* 335293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335309 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335316 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335333 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335387 */     // GIR_Coverage, 4266,
     /* 335387 */     GIR_EraseRootFromParent_Done,
     /* 335388 */   // Label 6945: @335388
     /* 335388 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(335488), // Rule ID 4268 //
     /* 335393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335409 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335416 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335433 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335487 */     // GIR_Coverage, 4268,
     /* 335487 */     GIR_EraseRootFromParent_Done,
     /* 335488 */   // Label 6946: @335488
     /* 335488 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(335588), // Rule ID 4374 //
     /* 335493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335516 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335533 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335555 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335587 */     // GIR_Coverage, 4374,
     /* 335587 */     GIR_EraseRootFromParent_Done,
     /* 335588 */   // Label 6947: @335588
     /* 335588 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(335688), // Rule ID 4376 //
     /* 335593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335609 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335616 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335633 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335687 */     // GIR_Coverage, 4376,
     /* 335687 */     GIR_EraseRootFromParent_Done,
     /* 335688 */   // Label 6948: @335688
     /* 335688 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(335808), // Rule ID 6413 //
     /* 335693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335712 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335715 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335719 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335726 */     // MIs[2] Rn
     /* 335726 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 335730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335741 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 335741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 335744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 335762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 335777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335790 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335807 */     // GIR_Coverage, 6413,
     /* 335807 */     GIR_EraseRootFromParent_Done,
     /* 335808 */   // Label 6949: @335808
     /* 335808 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335928), // Rule ID 6415 //
     /* 335813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335832 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335835 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335839 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 335846 */     // MIs[2] Rn
     /* 335846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 335850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335861 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 335861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 335864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 335882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335890 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 335897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335910 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335927 */     // GIR_Coverage, 6415,
     /* 335927 */     GIR_EraseRootFromParent_Done,
     /* 335928 */   // Label 6950: @335928
     /* 335928 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(336058), // Rule ID 5709 //
     /* 335933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335966 */     // MIs[2] Operand 1
     /* 335966 */     // No operand predicates
     /* 335966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335974 */     // MIs[3] Operand 1
     /* 335974 */     // No operand predicates
     /* 335974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335976 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335995 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336057 */     // GIR_Coverage, 5709,
     /* 336057 */     GIR_EraseRootFromParent_Done,
     /* 336058 */   // Label 6951: @336058
     /* 336058 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(336219), // Rule ID 5710 //
     /* 336063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336096 */     // MIs[2] Operand 1
     /* 336096 */     // No operand predicates
     /* 336096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336104 */     // MIs[3] Operand 1
     /* 336104 */     // No operand predicates
     /* 336104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336106 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336106 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336109 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336113 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336118 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336121 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336125 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336128 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336133 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336157 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336218 */     // GIR_Coverage, 5710,
     /* 336218 */     GIR_EraseRootFromParent_Done,
     /* 336219 */   // Label 6952: @336219
     /* 336219 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(336349), // Rule ID 5733 //
     /* 336224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336257 */     // MIs[2] Operand 1
     /* 336257 */     // No operand predicates
     /* 336257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336265 */     // MIs[3] Operand 1
     /* 336265 */     // No operand predicates
     /* 336265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336267 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336279 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336286 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336331 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336348 */     // GIR_Coverage, 5733,
     /* 336348 */     GIR_EraseRootFromParent_Done,
     /* 336349 */   // Label 6953: @336349
     /* 336349 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(336510), // Rule ID 5734 //
     /* 336354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336387 */     // MIs[2] Operand 1
     /* 336387 */     // No operand predicates
     /* 336387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336395 */     // MIs[3] Operand 1
     /* 336395 */     // No operand predicates
     /* 336395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336397 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336409 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336412 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336416 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336419 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336424 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336444 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336448 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336451 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336479 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336492 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336509 */     // GIR_Coverage, 5734,
     /* 336509 */     GIR_EraseRootFromParent_Done,
     /* 336510 */   // Label 6954: @336510
     /* 336510 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(336576), // Rule ID 5664 //
     /* 336515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336533 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 336533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336575 */     // GIR_Coverage, 5664,
     /* 336575 */     GIR_EraseRootFromParent_Done,
     /* 336576 */   // Label 6955: @336576
     /* 336576 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(336642), // Rule ID 5676 //
     /* 336581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336599 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 336599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336641 */     // GIR_Coverage, 5676,
     /* 336641 */     GIR_EraseRootFromParent_Done,
     /* 336642 */   // Label 6956: @336642
     /* 336642 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(336777), // Rule ID 5684 //
     /* 336647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 336659 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 336663 */     // MIs[1] Operand 1
     /* 336663 */     // No operand predicates
     /* 336663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336671 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336675 */     // MIs[2] Operand 1
     /* 336675 */     // No operand predicates
     /* 336675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336677 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 336677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 336680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 336694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336703 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 336710 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 336735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 336746 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 336752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336776 */     // GIR_Coverage, 5684,
     /* 336776 */     GIR_EraseRootFromParent_Done,
     /* 336777 */   // Label 6957: @336777
     /* 336777 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(336909), // Rule ID 6421 //
     /* 336782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336801 */     // MIs[1] Rn
     /* 336801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336822 */     // MIs[2] Operand 1
     /* 336822 */     // No operand predicates
     /* 336822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336824 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336836 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 336843 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 336863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 336874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336878 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336891 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336908 */     // GIR_Coverage, 6421,
     /* 336908 */     GIR_EraseRootFromParent_Done,
     /* 336909 */   // Label 6958: @336909
     /* 336909 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(337041), // Rule ID 6422 //
     /* 336914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336933 */     // MIs[1] Rn
     /* 336933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336954 */     // MIs[2] Operand 1
     /* 336954 */     // No operand predicates
     /* 336954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336956 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 336975 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 336995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337023 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337040 */     // GIR_Coverage, 6422,
     /* 337040 */     GIR_EraseRootFromParent_Done,
     /* 337041 */   // Label 6959: @337041
     /* 337041 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(337224), // Rule ID 5742 //
     /* 337046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 337054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337071 */     // MIs[2] Operand 1
     /* 337071 */     // No operand predicates
     /* 337071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337073 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337073 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 337076 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337080 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337087 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337090 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337094 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337099 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337102 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 337106 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337109 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337114 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337119 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337124 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337127 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337131 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337150 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337157 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 337193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337206 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337223 */     // GIR_Coverage, 5742,
     /* 337223 */     GIR_EraseRootFromParent_Done,
     /* 337224 */   // Label 6960: @337224
     /* 337224 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(337402), // Rule ID 5687 //
     /* 337229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337249 */     // MIs[1] Operand 1
     /* 337249 */     // No operand predicates
     /* 337249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337251 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337251 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 337254 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337258 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337265 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 337268 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337272 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337277 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337280 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337284 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337287 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337292 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337297 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337328 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337335 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337401 */     // GIR_Coverage, 5687,
     /* 337401 */     GIR_EraseRootFromParent_Done,
     /* 337402 */   // Label 6961: @337402
     /* 337402 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(337527), // Rule ID 5690 //
     /* 337407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337427 */     // MIs[1] Operand 1
     /* 337427 */     // No operand predicates
     /* 337427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337429 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337429 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337432 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337436 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337455 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337462 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 337487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337526 */     // GIR_Coverage, 5690,
     /* 337526 */     GIR_EraseRootFromParent_Done,
     /* 337527 */   // Label 6962: @337527
     /* 337527 */   GIM_Reject,
     /* 337528 */ // Label 6932: @337528
     /* 337528 */ GIM_Reject,
     /* 337529 */ // Label 6910: @337529
     /* 337529 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(340357),
     /* 337534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 337540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337547 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(337656), // Rule ID 4288 //
     /* 337552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337556 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337562 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337572 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337579 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 337596 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 337603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337655 */     // GIR_Coverage, 4288,
     /* 337655 */     GIR_EraseRootFromParent_Done,
     /* 337656 */   // Label 6964: @337656
     /* 337656 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(337765), // Rule ID 4289 //
     /* 337661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 337705 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 337712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337764 */     // GIR_Coverage, 4289,
     /* 337764 */     GIR_EraseRootFromParent_Done,
     /* 337765 */   // Label 6965: @337765
     /* 337765 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(337874), // Rule ID 4396 //
     /* 337770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337797 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 337814 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 337821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337873 */     // GIR_Coverage, 4396,
     /* 337873 */     GIR_EraseRootFromParent_Done,
     /* 337874 */   // Label 6966: @337874
     /* 337874 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(337983), // Rule ID 4397 //
     /* 337879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337889 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337899 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337906 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 337923 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 337930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337982 */     // GIR_Coverage, 4397,
     /* 337982 */     GIR_EraseRootFromParent_Done,
     /* 337983 */   // Label 6967: @337983
     /* 337983 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(338088), // Rule ID 4294 //
     /* 337988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338004 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338011 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338028 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338055 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338087 */     // GIR_Coverage, 4294,
     /* 338087 */     GIR_EraseRootFromParent_Done,
     /* 338088 */   // Label 6968: @338088
     /* 338088 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(338193), // Rule ID 4296 //
     /* 338093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338109 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338116 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338133 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338192 */     // GIR_Coverage, 4296,
     /* 338192 */     GIR_EraseRootFromParent_Done,
     /* 338193 */   // Label 6969: @338193
     /* 338193 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(338298), // Rule ID 4402 //
     /* 338198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338214 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338221 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338238 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338265 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338297 */     // GIR_Coverage, 4402,
     /* 338297 */     GIR_EraseRootFromParent_Done,
     /* 338298 */   // Label 6970: @338298
     /* 338298 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(338403), // Rule ID 4404 //
     /* 338303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338319 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338326 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338343 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338402 */     // GIR_Coverage, 4404,
     /* 338402 */     GIR_EraseRootFromParent_Done,
     /* 338403 */   // Label 6971: @338403
     /* 338403 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(338507), // Rule ID 4286 //
     /* 338408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338412 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338418 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338428 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338435 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338452 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338474 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338506 */     // GIR_Coverage, 4286,
     /* 338506 */     GIR_EraseRootFromParent_Done,
     /* 338507 */   // Label 6972: @338507
     /* 338507 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(338611), // Rule ID 4287 //
     /* 338512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338516 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338522 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338539 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338556 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338578 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338610 */     // GIR_Coverage, 4287,
     /* 338610 */     GIR_EraseRootFromParent_Done,
     /* 338611 */   // Label 6973: @338611
     /* 338611 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(338715), // Rule ID 4394 //
     /* 338616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338636 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338660 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338714 */     // GIR_Coverage, 4394,
     /* 338714 */     GIR_EraseRootFromParent_Done,
     /* 338715 */   // Label 6974: @338715
     /* 338715 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(338819), // Rule ID 4395 //
     /* 338720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338724 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338730 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338740 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338747 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338764 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338786 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338818 */     // GIR_Coverage, 4395,
     /* 338818 */     GIR_EraseRootFromParent_Done,
     /* 338819 */   // Label 6975: @338819
     /* 338819 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(338919), // Rule ID 4290 //
     /* 338824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338840 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338847 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338864 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338886 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338918 */     // GIR_Coverage, 4290,
     /* 338918 */     GIR_EraseRootFromParent_Done,
     /* 338919 */   // Label 6976: @338919
     /* 338919 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(339019), // Rule ID 4292 //
     /* 338924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338940 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338947 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338964 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339018 */     // GIR_Coverage, 4292,
     /* 339018 */     GIR_EraseRootFromParent_Done,
     /* 339019 */   // Label 6977: @339019
     /* 339019 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(339119), // Rule ID 4398 //
     /* 339024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339040 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339047 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339064 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339118 */     // GIR_Coverage, 4398,
     /* 339118 */     GIR_EraseRootFromParent_Done,
     /* 339119 */   // Label 6978: @339119
     /* 339119 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(339219), // Rule ID 4400 //
     /* 339124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339140 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339147 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339164 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339186 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339218 */     // GIR_Coverage, 4400,
     /* 339218 */     GIR_EraseRootFromParent_Done,
     /* 339219 */   // Label 6979: @339219
     /* 339219 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(339297), // Rule ID 1941 //
     /* 339224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339260 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339264 */     // MIs[2] Operand 1
     /* 339264 */     // No operand predicates
     /* 339264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339272 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339276 */     // MIs[3] Operand 1
     /* 339276 */     // No operand predicates
     /* 339276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339278 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 339278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 339295 */     GIR_RootConstrainSelectedInstOperands,
     /* 339296 */     // GIR_Coverage, 1941,
     /* 339296 */     GIR_EraseRootFromParent_Done,
     /* 339297 */   // Label 6980: @339297
     /* 339297 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(339388), // Rule ID 7369 //
     /* 339302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 339305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 339317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 339325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339329 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 339332 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 339339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 339342 */     // MIs[2] Rn
     /* 339342 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339359 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339363 */     // MIs[3] Operand 1
     /* 339363 */     // No operand predicates
     /* 339363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339365 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15803>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 339365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 339368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 339386 */     GIR_RootConstrainSelectedInstOperands,
     /* 339387 */     // GIR_Coverage, 7369,
     /* 339387 */     GIR_EraseRootFromParent_Done,
     /* 339388 */   // Label 6981: @339388
     /* 339388 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(339455), // Rule ID 5713 //
     /* 339393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339426 */     // MIs[2] Operand 1
     /* 339426 */     // No operand predicates
     /* 339426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339434 */     // MIs[3] Operand 1
     /* 339434 */     // No operand predicates
     /* 339434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339436 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339453 */     GIR_RootConstrainSelectedInstOperands,
     /* 339454 */     // GIR_Coverage, 5713,
     /* 339454 */     GIR_EraseRootFromParent_Done,
     /* 339455 */   // Label 6982: @339455
     /* 339455 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(339553), // Rule ID 5714 //
     /* 339460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339493 */     // MIs[2] Operand 1
     /* 339493 */     // No operand predicates
     /* 339493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339501 */     // MIs[3] Operand 1
     /* 339501 */     // No operand predicates
     /* 339501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339503 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339551 */     GIR_RootConstrainSelectedInstOperands,
     /* 339552 */     // GIR_Coverage, 5714,
     /* 339552 */     GIR_EraseRootFromParent_Done,
     /* 339553 */   // Label 6983: @339553
     /* 339553 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(339620), // Rule ID 5737 //
     /* 339558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339591 */     // MIs[2] Operand 1
     /* 339591 */     // No operand predicates
     /* 339591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339599 */     // MIs[3] Operand 1
     /* 339599 */     // No operand predicates
     /* 339599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339601 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339618 */     GIR_RootConstrainSelectedInstOperands,
     /* 339619 */     // GIR_Coverage, 5737,
     /* 339619 */     GIR_EraseRootFromParent_Done,
     /* 339620 */   // Label 6984: @339620
     /* 339620 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(339718), // Rule ID 5738 //
     /* 339625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339658 */     // MIs[2] Operand 1
     /* 339658 */     // No operand predicates
     /* 339658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339666 */     // MIs[3] Operand 1
     /* 339666 */     // No operand predicates
     /* 339666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339668 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339716 */     GIR_RootConstrainSelectedInstOperands,
     /* 339717 */     // GIR_Coverage, 5738,
     /* 339717 */     GIR_EraseRootFromParent_Done,
     /* 339718 */   // Label 6985: @339718
     /* 339718 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(339784), // Rule ID 5668 //
     /* 339723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339741 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 339741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 339744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339783 */     // GIR_Coverage, 5668,
     /* 339783 */     GIR_EraseRootFromParent_Done,
     /* 339784 */   // Label 6986: @339784
     /* 339784 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(339850), // Rule ID 5678 //
     /* 339789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339807 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 339807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 339810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339849 */     // GIR_Coverage, 5678,
     /* 339849 */     GIR_EraseRootFromParent_Done,
     /* 339850 */   // Label 6987: @339850
     /* 339850 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(339928), // Rule ID 7368 //
     /* 339855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 339858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339870 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 339873 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 339880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 339883 */     // MIs[1] Rn
     /* 339883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 339887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 339896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339904 */     // MIs[2] Operand 1
     /* 339904 */     // No operand predicates
     /* 339904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339906 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15803>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 339906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 339909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 339916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339926 */     GIR_RootConstrainSelectedInstOperands,
     /* 339927 */     // GIR_Coverage, 7368,
     /* 339927 */     GIR_EraseRootFromParent_Done,
     /* 339928 */   // Label 6988: @339928
     /* 339928 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(339997), // Rule ID 6404 //
     /* 339933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339952 */     // MIs[1] Rn
     /* 339952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 339956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 339965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339973 */     // MIs[2] Operand 1
     /* 339973 */     // No operand predicates
     /* 339973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339975 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 339975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 339978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 339985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339995 */     GIR_RootConstrainSelectedInstOperands,
     /* 339996 */     // GIR_Coverage, 6404,
     /* 339996 */     GIR_EraseRootFromParent_Done,
     /* 339997 */   // Label 6989: @339997
     /* 339997 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(340066), // Rule ID 6405 //
     /* 340002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340021 */     // MIs[1] Rn
     /* 340021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340038 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340042 */     // MIs[2] Operand 1
     /* 340042 */     // No operand predicates
     /* 340042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340044 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340064 */     GIR_RootConstrainSelectedInstOperands,
     /* 340065 */     // GIR_Coverage, 6405,
     /* 340065 */     GIR_EraseRootFromParent_Done,
     /* 340066 */   // Label 6990: @340066
     /* 340066 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(340115), // Rule ID 5685 //
     /* 340071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340079 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340083 */     // MIs[1] Operand 1
     /* 340083 */     // No operand predicates
     /* 340083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340091 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340095 */     // MIs[2] Operand 1
     /* 340095 */     // No operand predicates
     /* 340095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340097 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 340097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340113 */     GIR_RootConstrainSelectedInstOperands,
     /* 340114 */     // GIR_Coverage, 5685,
     /* 340114 */     GIR_EraseRootFromParent_Done,
     /* 340115 */   // Label 6991: @340115
     /* 340115 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(340216), // Rule ID 5743 //
     /* 340120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340145 */     // MIs[2] Operand 1
     /* 340145 */     // No operand predicates
     /* 340145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340147 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 340180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 340208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340214 */     GIR_RootConstrainSelectedInstOperands,
     /* 340215 */     // GIR_Coverage, 5743,
     /* 340215 */     GIR_EraseRootFromParent_Done,
     /* 340216 */   // Label 6992: @340216
     /* 340216 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(340260), // Rule ID 1937 //
     /* 340221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340244 */     // MIs[1] Operand 1
     /* 340244 */     // No operand predicates
     /* 340244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340246 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 340246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 340256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340258 */     GIR_RootConstrainSelectedInstOperands,
     /* 340259 */     // GIR_Coverage, 1937,
     /* 340259 */     GIR_EraseRootFromParent_Done,
     /* 340260 */   // Label 6993: @340260
     /* 340260 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(340356), // Rule ID 5689 //
     /* 340265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340285 */     // MIs[1] Operand 1
     /* 340285 */     // No operand predicates
     /* 340285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340287 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 340290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 340348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340354 */     GIR_RootConstrainSelectedInstOperands,
     /* 340355 */     // GIR_Coverage, 5689,
     /* 340355 */     GIR_EraseRootFromParent_Done,
     /* 340356 */   // Label 6994: @340356
     /* 340356 */   GIM_Reject,
     /* 340357 */ // Label 6963: @340357
     /* 340357 */ GIM_Reject,
     /* 340358 */ // Label 6911: @340358
     /* 340358 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(343997),
     /* 340363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340366 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(340492), // Rule ID 4228 //
     /* 340371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340391 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340401 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340404 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340408 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340415 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340432 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340459 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340491 */     // GIR_Coverage, 4228,
     /* 340491 */     GIR_EraseRootFromParent_Done,
     /* 340492 */   // Label 6996: @340492
     /* 340492 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(340618), // Rule ID 4229 //
     /* 340497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340511 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340517 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340530 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340534 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340541 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340558 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340617 */     // GIR_Coverage, 4229,
     /* 340617 */     GIR_EraseRootFromParent_Done,
     /* 340618 */   // Label 6997: @340618
     /* 340618 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(340737), // Rule ID 4336 //
     /* 340623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340653 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340660 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340677 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340704 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340736 */     // GIR_Coverage, 4336,
     /* 340736 */     GIR_EraseRootFromParent_Done,
     /* 340737 */   // Label 6998: @340737
     /* 340737 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(340856), // Rule ID 4337 //
     /* 340742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340779 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340796 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340823 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340855 */     // GIR_Coverage, 4337,
     /* 340855 */     GIR_EraseRootFromParent_Done,
     /* 340856 */   // Label 6999: @340856
     /* 340856 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(340978), // Rule ID 4234 //
     /* 340861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340887 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340890 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340894 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340901 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340918 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340977 */     // GIR_Coverage, 4234,
     /* 340977 */     GIR_EraseRootFromParent_Done,
     /* 340978 */   // Label 7000: @340978
     /* 340978 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(341100), // Rule ID 4236 //
     /* 340983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341009 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341012 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341016 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341023 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341040 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341067 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341099 */     // GIR_Coverage, 4236,
     /* 341099 */     GIR_EraseRootFromParent_Done,
     /* 341100 */   // Label 7001: @341100
     /* 341100 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(341215), // Rule ID 4342 //
     /* 341105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341131 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341138 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341155 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341182 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341214 */     // GIR_Coverage, 4342,
     /* 341214 */     GIR_EraseRootFromParent_Done,
     /* 341215 */   // Label 7002: @341215
     /* 341215 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(341330), // Rule ID 4344 //
     /* 341220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341253 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341270 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341297 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341329 */     // GIR_Coverage, 4344,
     /* 341329 */     GIR_EraseRootFromParent_Done,
     /* 341330 */   // Label 7003: @341330
     /* 341330 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(341451), // Rule ID 4226 //
     /* 341335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341355 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341365 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341368 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341372 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341379 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341396 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341418 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341450 */     // GIR_Coverage, 4226,
     /* 341450 */     GIR_EraseRootFromParent_Done,
     /* 341451 */   // Label 7004: @341451
     /* 341451 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(341572), // Rule ID 4227 //
     /* 341456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341470 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341476 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341486 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341489 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341493 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341500 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341517 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341539 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341571 */     // GIR_Coverage, 4227,
     /* 341571 */     GIR_EraseRootFromParent_Done,
     /* 341572 */   // Label 7005: @341572
     /* 341572 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(341686), // Rule ID 4334 //
     /* 341577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341591 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341597 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341607 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341614 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341631 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341653 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341685 */     // GIR_Coverage, 4334,
     /* 341685 */     GIR_EraseRootFromParent_Done,
     /* 341686 */   // Label 7006: @341686
     /* 341686 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(341800), // Rule ID 4335 //
     /* 341691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341705 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341711 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341721 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341728 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341745 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341767 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341799 */     // GIR_Coverage, 4335,
     /* 341799 */     GIR_EraseRootFromParent_Done,
     /* 341800 */   // Label 7007: @341800
     /* 341800 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(341917), // Rule ID 4230 //
     /* 341805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341831 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341834 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341838 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341845 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341862 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341884 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341916 */     // GIR_Coverage, 4230,
     /* 341916 */     GIR_EraseRootFromParent_Done,
     /* 341917 */   // Label 7008: @341917
     /* 341917 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(342034), // Rule ID 4232 //
     /* 341922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341951 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341955 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341962 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341979 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342033 */     // GIR_Coverage, 4232,
     /* 342033 */     GIR_EraseRootFromParent_Done,
     /* 342034 */   // Label 7009: @342034
     /* 342034 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(342144), // Rule ID 4338 //
     /* 342039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342072 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342089 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342111 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342143 */     // GIR_Coverage, 4338,
     /* 342143 */     GIR_EraseRootFromParent_Done,
     /* 342144 */   // Label 7010: @342144
     /* 342144 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(342254), // Rule ID 4340 //
     /* 342149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342175 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342182 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342199 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342221 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342253 */     // GIR_Coverage, 4340,
     /* 342253 */     GIR_EraseRootFromParent_Done,
     /* 342254 */   // Label 7011: @342254
     /* 342254 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(342384), // Rule ID 6417 //
     /* 342259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342288 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342291 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342295 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342302 */     // MIs[2] Rn
     /* 342302 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 342306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342317 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 342317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342343 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342366 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342383 */     // GIR_Coverage, 6417,
     /* 342383 */     GIR_EraseRootFromParent_Done,
     /* 342384 */   // Label 7012: @342384
     /* 342384 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(342524), // Rule ID 5703 //
     /* 342389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342432 */     // MIs[2] Operand 1
     /* 342432 */     // No operand predicates
     /* 342432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342440 */     // MIs[3] Operand 1
     /* 342440 */     // No operand predicates
     /* 342440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342442 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342442 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342445 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342449 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342454 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342461 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342486 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342506 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342523 */     // GIR_Coverage, 5703,
     /* 342523 */     GIR_EraseRootFromParent_Done,
     /* 342524 */   // Label 7013: @342524
     /* 342524 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(342695), // Rule ID 5704 //
     /* 342529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342572 */     // MIs[2] Operand 1
     /* 342572 */     // No operand predicates
     /* 342572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342580 */     // MIs[3] Operand 1
     /* 342580 */     // No operand predicates
     /* 342580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342582 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342582 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 342585 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342589 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342594 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342597 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342601 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 342604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342609 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342626 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342629 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342633 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342694 */     // GIR_Coverage, 5704,
     /* 342694 */     GIR_EraseRootFromParent_Done,
     /* 342695 */   // Label 7014: @342695
     /* 342695 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(342835), // Rule ID 5727 //
     /* 342700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342743 */     // MIs[2] Operand 1
     /* 342743 */     // No operand predicates
     /* 342743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342751 */     // MIs[3] Operand 1
     /* 342751 */     // No operand predicates
     /* 342751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342753 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342765 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342768 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342772 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342775 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342797 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342817 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342834 */     // GIR_Coverage, 5727,
     /* 342834 */     GIR_EraseRootFromParent_Done,
     /* 342835 */   // Label 7015: @342835
     /* 342835 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(343006), // Rule ID 5728 //
     /* 342840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342883 */     // MIs[2] Operand 1
     /* 342883 */     // No operand predicates
     /* 342883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342891 */     // MIs[3] Operand 1
     /* 342891 */     // No operand predicates
     /* 342891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342893 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342893 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 342896 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342900 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342905 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342908 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342912 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 342915 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342920 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342937 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342969 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343005 */     // GIR_Coverage, 5728,
     /* 343005 */     GIR_EraseRootFromParent_Done,
     /* 343006 */   // Label 7016: @343006
     /* 343006 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(343085), // Rule ID 5658 //
     /* 343011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343039 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 343039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 343042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 343055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 343074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343084 */     // GIR_Coverage, 5658,
     /* 343084 */     GIR_EraseRootFromParent_Done,
     /* 343085 */   // Label 7017: @343085
     /* 343085 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(343161), // Rule ID 5660 //
     /* 343090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343118 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343160 */     // GIR_Coverage, 5660,
     /* 343160 */     GIR_EraseRootFromParent_Done,
     /* 343161 */   // Label 7018: @343161
     /* 343161 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(343237), // Rule ID 5670 //
     /* 343166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343194 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343236 */     // GIR_Coverage, 5670,
     /* 343236 */     GIR_EraseRootFromParent_Done,
     /* 343237 */   // Label 7019: @343237
     /* 343237 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(343382), // Rule ID 5682 //
     /* 343242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343264 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343268 */     // MIs[1] Operand 1
     /* 343268 */     // No operand predicates
     /* 343268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343280 */     // MIs[2] Operand 1
     /* 343280 */     // No operand predicates
     /* 343280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343282 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 343282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 343285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 343296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343308 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 343311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 343315 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 343351 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343364 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343381 */     // GIR_Coverage, 5682,
     /* 343381 */     GIR_EraseRootFromParent_Done,
     /* 343382 */   // Label 7020: @343382
     /* 343382 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(343531), // Rule ID 6420 //
     /* 343387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343412 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343416 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343423 */     // MIs[1] Rn
     /* 343423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343444 */     // MIs[2] Operand 1
     /* 343444 */     // No operand predicates
     /* 343444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343446 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343458 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343461 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 343465 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 343496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343500 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343530 */     // GIR_Coverage, 6420,
     /* 343530 */     GIR_EraseRootFromParent_Done,
     /* 343531 */   // Label 7021: @343531
     /* 343531 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(343673), // Rule ID 6423 //
     /* 343536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343565 */     // MIs[1] Rn
     /* 343565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343582 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343586 */     // MIs[2] Operand 1
     /* 343586 */     // No operand predicates
     /* 343586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343588 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343600 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 343607 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 343638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343642 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343655 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343672 */     // GIR_Coverage, 6423,
     /* 343672 */     GIR_EraseRootFromParent_Done,
     /* 343673 */   // Label 7022: @343673
     /* 343673 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(343861), // Rule ID 5680 //
     /* 343678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 343700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 343708 */     // MIs[1] Operand 1
     /* 343708 */     // No operand predicates
     /* 343708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343710 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 343710 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 343713 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343717 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 343724 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 343727 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343731 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343736 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 343739 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 343743 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 343746 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343751 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343756 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343761 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 343764 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343768 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 343775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343787 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 343790 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 343794 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343797 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343802 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343824 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 343830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 343833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343860 */     // GIR_Coverage, 5680,
     /* 343860 */     GIR_EraseRootFromParent_Done,
     /* 343861 */   // Label 7023: @343861
     /* 343861 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(343996), // Rule ID 5691 //
     /* 343866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 343888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343896 */     // MIs[1] Operand 1
     /* 343896 */     // No operand predicates
     /* 343896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343898 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 343898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 343901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 343912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 343927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 343931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 343967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 343971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343978 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343995 */     // GIR_Coverage, 5691,
     /* 343995 */     GIR_EraseRootFromParent_Done,
     /* 343996 */   // Label 7024: @343996
     /* 343996 */   GIM_Reject,
     /* 343997 */ // Label 6995: @343997
     /* 343997 */ GIM_Reject,
     /* 343998 */ // Label 6912: @343998
     /* 343998 */ GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(346661),
     /* 344003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344016 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(344125), // Rule ID 4252 //
     /* 344021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344065 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344092 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344124 */     // GIR_Coverage, 4252,
     /* 344124 */     GIR_EraseRootFromParent_Done,
     /* 344125 */   // Label 7026: @344125
     /* 344125 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(344234), // Rule ID 4253 //
     /* 344130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344157 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344174 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344201 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344233 */     // GIR_Coverage, 4253,
     /* 344233 */     GIR_EraseRootFromParent_Done,
     /* 344234 */   // Label 7027: @344234
     /* 344234 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(344343), // Rule ID 4360 //
     /* 344239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344243 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344249 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344266 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344283 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344342 */     // GIR_Coverage, 4360,
     /* 344342 */     GIR_EraseRootFromParent_Done,
     /* 344343 */   // Label 7028: @344343
     /* 344343 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(344452), // Rule ID 4361 //
     /* 344348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344375 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344392 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344419 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344451 */     // GIR_Coverage, 4361,
     /* 344451 */     GIR_EraseRootFromParent_Done,
     /* 344452 */   // Label 7029: @344452
     /* 344452 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(344557), // Rule ID 4258 //
     /* 344457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344497 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344524 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344556 */     // GIR_Coverage, 4258,
     /* 344556 */     GIR_EraseRootFromParent_Done,
     /* 344557 */   // Label 7030: @344557
     /* 344557 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(344662), // Rule ID 4260 //
     /* 344562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344602 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344661 */     // GIR_Coverage, 4260,
     /* 344661 */     GIR_EraseRootFromParent_Done,
     /* 344662 */   // Label 7031: @344662
     /* 344662 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(344767), // Rule ID 4366 //
     /* 344667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344683 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344690 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344707 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344766 */     // GIR_Coverage, 4366,
     /* 344766 */     GIR_EraseRootFromParent_Done,
     /* 344767 */   // Label 7032: @344767
     /* 344767 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(344872), // Rule ID 4368 //
     /* 344772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344788 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344795 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344812 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344839 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344871 */     // GIR_Coverage, 4368,
     /* 344871 */     GIR_EraseRootFromParent_Done,
     /* 344872 */   // Label 7033: @344872
     /* 344872 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(344976), // Rule ID 4250 //
     /* 344877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 344921 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 344921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 344928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344943 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344975 */     // GIR_Coverage, 4250,
     /* 344975 */     GIR_EraseRootFromParent_Done,
     /* 344976 */   // Label 7034: @344976
     /* 344976 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(345080), // Rule ID 4251 //
     /* 344981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345001 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345008 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345025 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345079 */     // GIR_Coverage, 4251,
     /* 345079 */     GIR_EraseRootFromParent_Done,
     /* 345080 */   // Label 7035: @345080
     /* 345080 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(345184), // Rule ID 4358 //
     /* 345085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345129 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345183 */     // GIR_Coverage, 4358,
     /* 345183 */     GIR_EraseRootFromParent_Done,
     /* 345184 */   // Label 7036: @345184
     /* 345184 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(345288), // Rule ID 4359 //
     /* 345189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345233 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345287 */     // GIR_Coverage, 4359,
     /* 345287 */     GIR_EraseRootFromParent_Done,
     /* 345288 */   // Label 7037: @345288
     /* 345288 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(345388), // Rule ID 4254 //
     /* 345293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345309 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345316 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345333 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345387 */     // GIR_Coverage, 4254,
     /* 345387 */     GIR_EraseRootFromParent_Done,
     /* 345388 */   // Label 7038: @345388
     /* 345388 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(345488), // Rule ID 4256 //
     /* 345393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345409 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345416 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345433 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345487 */     // GIR_Coverage, 4256,
     /* 345487 */     GIR_EraseRootFromParent_Done,
     /* 345488 */   // Label 7039: @345488
     /* 345488 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(345588), // Rule ID 4362 //
     /* 345493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345516 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345533 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345555 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345587 */     // GIR_Coverage, 4362,
     /* 345587 */     GIR_EraseRootFromParent_Done,
     /* 345588 */   // Label 7040: @345588
     /* 345588 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(345688), // Rule ID 4364 //
     /* 345593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345609 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345616 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345633 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345687 */     // GIR_Coverage, 4364,
     /* 345687 */     GIR_EraseRootFromParent_Done,
     /* 345688 */   // Label 7041: @345688
     /* 345688 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(345766), // Rule ID 1940 //
     /* 345693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 345708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 345733 */     // MIs[2] Operand 1
     /* 345733 */     // No operand predicates
     /* 345733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345741 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 345745 */     // MIs[3] Operand 1
     /* 345745 */     // No operand predicates
     /* 345745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345747 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 345747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 345750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 345754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 345757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 345764 */     GIR_RootConstrainSelectedInstOperands,
     /* 345765 */     // GIR_Coverage, 1940,
     /* 345765 */     GIR_EraseRootFromParent_Done,
     /* 345766 */   // Label 7042: @345766
     /* 345766 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(345833), // Rule ID 5707 //
     /* 345771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 345783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345804 */     // MIs[2] Operand 1
     /* 345804 */     // No operand predicates
     /* 345804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345812 */     // MIs[3] Operand 1
     /* 345812 */     // No operand predicates
     /* 345812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345814 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 345814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 345817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 345821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 345824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 345831 */     GIR_RootConstrainSelectedInstOperands,
     /* 345832 */     // GIR_Coverage, 5707,
     /* 345832 */     GIR_EraseRootFromParent_Done,
     /* 345833 */   // Label 7043: @345833
     /* 345833 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(345931), // Rule ID 5708 //
     /* 345838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 345850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345871 */     // MIs[2] Operand 1
     /* 345871 */     // No operand predicates
     /* 345871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345879 */     // MIs[3] Operand 1
     /* 345879 */     // No operand predicates
     /* 345879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345881 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 345881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 345896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 345903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 345916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 345920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 345923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 345929 */     GIR_RootConstrainSelectedInstOperands,
     /* 345930 */     // GIR_Coverage, 5708,
     /* 345930 */     GIR_EraseRootFromParent_Done,
     /* 345931 */   // Label 7044: @345931
     /* 345931 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(345998), // Rule ID 5731 //
     /* 345936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 345948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345969 */     // MIs[2] Operand 1
     /* 345969 */     // No operand predicates
     /* 345969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345977 */     // MIs[3] Operand 1
     /* 345977 */     // No operand predicates
     /* 345977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345979 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 345979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 345982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 345986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 345989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 345996 */     GIR_RootConstrainSelectedInstOperands,
     /* 345997 */     // GIR_Coverage, 5731,
     /* 345997 */     GIR_EraseRootFromParent_Done,
     /* 345998 */   // Label 7045: @345998
     /* 345998 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(346096), // Rule ID 5732 //
     /* 346003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346036 */     // MIs[2] Operand 1
     /* 346036 */     // No operand predicates
     /* 346036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346044 */     // MIs[3] Operand 1
     /* 346044 */     // No operand predicates
     /* 346044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346046 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346094 */     GIR_RootConstrainSelectedInstOperands,
     /* 346095 */     // GIR_Coverage, 5732,
     /* 346095 */     GIR_EraseRootFromParent_Done,
     /* 346096 */   // Label 7046: @346096
     /* 346096 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(346162), // Rule ID 5666 //
     /* 346101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346119 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 346119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346161 */     // GIR_Coverage, 5666,
     /* 346161 */     GIR_EraseRootFromParent_Done,
     /* 346162 */   // Label 7047: @346162
     /* 346162 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(346228), // Rule ID 5674 //
     /* 346167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346185 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 346185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346227 */     // GIR_Coverage, 5674,
     /* 346227 */     GIR_EraseRootFromParent_Done,
     /* 346228 */   // Label 7048: @346228
     /* 346228 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(346281), // Rule ID 5683 //
     /* 346233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 346245 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 346249 */     // MIs[1] Operand 1
     /* 346249 */     // No operand predicates
     /* 346249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346261 */     // MIs[2] Operand 1
     /* 346261 */     // No operand predicates
     /* 346261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346263 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 346263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 346266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 346273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 346279 */     GIR_RootConstrainSelectedInstOperands,
     /* 346280 */     // GIR_Coverage, 5683,
     /* 346280 */     GIR_EraseRootFromParent_Done,
     /* 346281 */   // Label 7049: @346281
     /* 346281 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(346350), // Rule ID 6402 //
     /* 346286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 346305 */     // MIs[1] Rn
     /* 346305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 346309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346326 */     // MIs[2] Operand 1
     /* 346326 */     // No operand predicates
     /* 346326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346328 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 346328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 346331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 346338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346348 */     GIR_RootConstrainSelectedInstOperands,
     /* 346349 */     // GIR_Coverage, 6402,
     /* 346349 */     GIR_EraseRootFromParent_Done,
     /* 346350 */   // Label 7050: @346350
     /* 346350 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(346419), // Rule ID 6403 //
     /* 346355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346367 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 346374 */     // MIs[1] Rn
     /* 346374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 346378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346395 */     // MIs[2] Operand 1
     /* 346395 */     // No operand predicates
     /* 346395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346397 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 346397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 346400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 346407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346417 */     GIR_RootConstrainSelectedInstOperands,
     /* 346418 */     // GIR_Coverage, 6403,
     /* 346418 */     GIR_EraseRootFromParent_Done,
     /* 346419 */   // Label 7051: @346419
     /* 346419 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(346520), // Rule ID 5741 //
     /* 346424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 346432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 346436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346449 */     // MIs[2] Operand 1
     /* 346449 */     // No operand predicates
     /* 346449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346451 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 346451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 346484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 346487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 346512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346518 */     GIR_RootConstrainSelectedInstOperands,
     /* 346519 */     // GIR_Coverage, 5741,
     /* 346519 */     GIR_EraseRootFromParent_Done,
     /* 346520 */   // Label 7052: @346520
     /* 346520 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(346564), // Rule ID 1936 //
     /* 346525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 346540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346548 */     // MIs[1] Operand 1
     /* 346548 */     // No operand predicates
     /* 346548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346550 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 346550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 346553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 346560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346562 */     GIR_RootConstrainSelectedInstOperands,
     /* 346563 */     // GIR_Coverage, 1936,
     /* 346563 */     GIR_EraseRootFromParent_Done,
     /* 346564 */   // Label 7053: @346564
     /* 346564 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(346660), // Rule ID 5688 //
     /* 346569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 346581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346589 */     // MIs[1] Operand 1
     /* 346589 */     // No operand predicates
     /* 346589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346591 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 346591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 346594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 346624 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 346627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346658 */     GIR_RootConstrainSelectedInstOperands,
     /* 346659 */     // GIR_Coverage, 5688,
     /* 346659 */     GIR_EraseRootFromParent_Done,
     /* 346660 */   // Label 7054: @346660
     /* 346660 */   GIM_Reject,
     /* 346661 */ // Label 7025: @346661
     /* 346661 */ GIM_Reject,
     /* 346662 */ // Label 6913: @346662
     /* 346662 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(348505),
     /* 346667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346670 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(346796), // Rule ID 4192 //
     /* 346675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346689 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346695 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346705 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346708 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346712 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 346719 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 346736 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 346736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 346739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 346743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346763 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 346785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 346795 */     // GIR_Coverage, 4192,
     /* 346795 */     GIR_EraseRootFromParent_Done,
     /* 346796 */   // Label 7056: @346796
     /* 346796 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(346922), // Rule ID 4193 //
     /* 346801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346821 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346831 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346834 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346838 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 346845 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 346862 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 346862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 346865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 346869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 346911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 346921 */     // GIR_Coverage, 4193,
     /* 346921 */     GIR_EraseRootFromParent_Done,
     /* 346922 */   // Label 7057: @346922
     /* 346922 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(347044), // Rule ID 4198 //
     /* 346927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346953 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346956 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346960 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 346967 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 346984 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 346984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 346987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 346991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347011 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347043 */     // GIR_Coverage, 4198,
     /* 347043 */     GIR_EraseRootFromParent_Done,
     /* 347044 */   // Label 7058: @347044
     /* 347044 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(347166), // Rule ID 4200 //
     /* 347049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347075 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347078 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347082 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347089 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347106 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347165 */     // GIR_Coverage, 4200,
     /* 347165 */     GIR_EraseRootFromParent_Done,
     /* 347166 */   // Label 7059: @347166
     /* 347166 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(347287), // Rule ID 4190 //
     /* 347171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347185 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347191 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347201 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347204 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347208 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347215 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 347232 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 347232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 347239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347254 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347286 */     // GIR_Coverage, 4190,
     /* 347286 */     GIR_EraseRootFromParent_Done,
     /* 347287 */   // Label 7060: @347287
     /* 347287 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(347408), // Rule ID 4191 //
     /* 347292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347306 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347312 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347322 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347325 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347329 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347336 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 347353 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 347353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 347360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347375 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347407 */     // GIR_Coverage, 4191,
     /* 347407 */     GIR_EraseRootFromParent_Done,
     /* 347408 */   // Label 7061: @347408
     /* 347408 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(347525), // Rule ID 4194 //
     /* 347413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347442 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347446 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347453 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 347470 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 347470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 347477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347524 */     // GIR_Coverage, 4194,
     /* 347524 */     GIR_EraseRootFromParent_Done,
     /* 347525 */   // Label 7062: @347525
     /* 347525 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(347642), // Rule ID 4196 //
     /* 347530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347559 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347563 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347570 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 347587 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 347587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 347594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347641 */     // GIR_Coverage, 4196,
     /* 347641 */     GIR_EraseRootFromParent_Done,
     /* 347642 */   // Label 7063: @347642
     /* 347642 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(347782), // Rule ID 5721 //
     /* 347647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347690 */     // MIs[2] Operand 1
     /* 347690 */     // No operand predicates
     /* 347690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 347694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347698 */     // MIs[3] Operand 1
     /* 347698 */     // No operand predicates
     /* 347698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347700 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 347700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347712 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 347719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 347739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347744 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 347750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 347757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347781 */     // GIR_Coverage, 5721,
     /* 347781 */     GIR_EraseRootFromParent_Done,
     /* 347782 */   // Label 7064: @347782
     /* 347782 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(347953), // Rule ID 5722 //
     /* 347787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347830 */     // MIs[2] Operand 1
     /* 347830 */     // No operand predicates
     /* 347830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 347834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347838 */     // MIs[3] Operand 1
     /* 347838 */     // No operand predicates
     /* 347838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347840 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 347840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 347843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347852 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 347855 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347859 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 347862 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347867 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347884 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 347891 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 347911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 347922 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 347925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 347928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347952 */     // GIR_Coverage, 5722,
     /* 347952 */     GIR_EraseRootFromParent_Done,
     /* 347953 */   // Label 7065: @347953
     /* 347953 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(348032), // Rule ID 5653 //
     /* 347958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347986 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 347986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 348002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348031 */     // GIR_Coverage, 5653,
     /* 348031 */     GIR_EraseRootFromParent_Done,
     /* 348032 */   // Label 7066: @348032
     /* 348032 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(348181), // Rule ID 6419 //
     /* 348037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348062 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 348066 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348073 */     // MIs[1] Rn
     /* 348073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 348077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 348082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348090 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348094 */     // MIs[2] Operand 1
     /* 348094 */     // No operand predicates
     /* 348094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348096 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 348096 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348099 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348103 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348108 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 348115 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 348135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 348146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348163 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348180 */     // GIR_Coverage, 6419,
     /* 348180 */     GIR_EraseRootFromParent_Done,
     /* 348181 */   // Label 7067: @348181
     /* 348181 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(348316), // Rule ID 5692 //
     /* 348186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 348208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348216 */     // MIs[1] Operand 1
     /* 348216 */     // No operand predicates
     /* 348216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348218 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 348218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 348221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 348235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348244 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 348247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348251 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348254 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348259 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 348276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 348287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 348291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348298 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348315 */     // GIR_Coverage, 5692,
     /* 348315 */     GIR_EraseRootFromParent_Done,
     /* 348316 */   // Label 7068: @348316
     /* 348316 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(348504), // Rule ID 5693 //
     /* 348321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 348324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 348343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348351 */     // MIs[1] Operand 1
     /* 348351 */     // No operand predicates
     /* 348351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348353 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348353 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 348356 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348360 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 348367 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 348370 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348374 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348379 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348382 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 348386 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 348389 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348394 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348399 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 348407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 348421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 348433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 348473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 348479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348503 */     // GIR_Coverage, 5693,
     /* 348503 */     GIR_EraseRootFromParent_Done,
     /* 348504 */   // Label 7069: @348504
     /* 348504 */   GIM_Reject,
     /* 348505 */ // Label 7055: @348505
     /* 348505 */ GIM_Reject,
     /* 348506 */ // Label 6914: @348506
     /* 348506 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(351480),
     /* 348511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348514 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(348640), // Rule ID 4216 //
     /* 348519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348533 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348539 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348549 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348552 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348556 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 348580 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 348580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 348587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348607 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348639 */     // GIR_Coverage, 4216,
     /* 348639 */     GIR_EraseRootFromParent_Done,
     /* 348640 */   // Label 7071: @348640
     /* 348640 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(348766), // Rule ID 4217 //
     /* 348645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348675 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348678 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348682 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348689 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 348706 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 348706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 348713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348733 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348765 */     // GIR_Coverage, 4217,
     /* 348765 */     GIR_EraseRootFromParent_Done,
     /* 348766 */   // Label 7072: @348766
     /* 348766 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(348885), // Rule ID 4324 //
     /* 348771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348785 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348791 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348801 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348804 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348808 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 348825 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 348825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 348832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348852 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348884 */     // GIR_Coverage, 4324,
     /* 348884 */     GIR_EraseRootFromParent_Done,
     /* 348885 */   // Label 7073: @348885
     /* 348885 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(349004), // Rule ID 4325 //
     /* 348890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348904 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348910 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 348944 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 348944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 348951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348971 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349003 */     // GIR_Coverage, 4325,
     /* 349003 */     GIR_EraseRootFromParent_Done,
     /* 349004 */   // Label 7074: @349004
     /* 349004 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(349126), // Rule ID 4222 //
     /* 349009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349038 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349042 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349049 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349066 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349093 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349125 */     // GIR_Coverage, 4222,
     /* 349125 */     GIR_EraseRootFromParent_Done,
     /* 349126 */   // Label 7075: @349126
     /* 349126 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(349248), // Rule ID 4224 //
     /* 349131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349157 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349160 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349164 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349188 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349247 */     // GIR_Coverage, 4224,
     /* 349247 */     GIR_EraseRootFromParent_Done,
     /* 349248 */   // Label 7076: @349248
     /* 349248 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(349363), // Rule ID 4330 //
     /* 349253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349279 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349303 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349362 */     // GIR_Coverage, 4330,
     /* 349362 */     GIR_EraseRootFromParent_Done,
     /* 349363 */   // Label 7077: @349363
     /* 349363 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(349478), // Rule ID 4332 //
     /* 349368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349394 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349401 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349418 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349477 */     // GIR_Coverage, 4332,
     /* 349477 */     GIR_EraseRootFromParent_Done,
     /* 349478 */   // Label 7078: @349478
     /* 349478 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(349599), // Rule ID 4214 //
     /* 349483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349516 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349520 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349527 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 349544 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 349544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 349551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349598 */     // GIR_Coverage, 4214,
     /* 349598 */     GIR_EraseRootFromParent_Done,
     /* 349599 */   // Label 7079: @349599
     /* 349599 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(349720), // Rule ID 4215 //
     /* 349604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349634 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349637 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349641 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349648 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 349665 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 349665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 349672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349687 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349719 */     // GIR_Coverage, 4215,
     /* 349719 */     GIR_EraseRootFromParent_Done,
     /* 349720 */   // Label 7080: @349720
     /* 349720 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(349834), // Rule ID 4322 //
     /* 349725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 349779 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 349779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 349786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349801 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349833 */     // GIR_Coverage, 4322,
     /* 349833 */     GIR_EraseRootFromParent_Done,
     /* 349834 */   // Label 7081: @349834
     /* 349834 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(349948), // Rule ID 4323 //
     /* 349839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349853 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349859 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349869 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 349893 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 349893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 349900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349947 */     // GIR_Coverage, 4323,
     /* 349947 */     GIR_EraseRootFromParent_Done,
     /* 349948 */   // Label 7082: @349948
     /* 349948 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(350065), // Rule ID 4218 //
     /* 349953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349982 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349986 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349993 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350010 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350032 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350064 */     // GIR_Coverage, 4218,
     /* 350064 */     GIR_EraseRootFromParent_Done,
     /* 350065 */   // Label 7083: @350065
     /* 350065 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(350182), // Rule ID 4220 //
     /* 350070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350096 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350099 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350103 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350110 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350127 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350149 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350181 */     // GIR_Coverage, 4220,
     /* 350181 */     GIR_EraseRootFromParent_Done,
     /* 350182 */   // Label 7084: @350182
     /* 350182 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(350292), // Rule ID 4326 //
     /* 350187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350213 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350237 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350259 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350291 */     // GIR_Coverage, 4326,
     /* 350291 */     GIR_EraseRootFromParent_Done,
     /* 350292 */   // Label 7085: @350292
     /* 350292 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(350402), // Rule ID 4328 //
     /* 350297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350323 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350330 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350347 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350369 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350401 */     // GIR_Coverage, 4328,
     /* 350401 */     GIR_EraseRootFromParent_Done,
     /* 350402 */   // Label 7086: @350402
     /* 350402 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(350490), // Rule ID 1939 //
     /* 350407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350453 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350457 */     // MIs[2] Operand 1
     /* 350457 */     // No operand predicates
     /* 350457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350465 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350469 */     // MIs[3] Operand 1
     /* 350469 */     // No operand predicates
     /* 350469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350471 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 350471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 350481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 350488 */     GIR_RootConstrainSelectedInstOperands,
     /* 350489 */     // GIR_Coverage, 1939,
     /* 350489 */     GIR_EraseRootFromParent_Done,
     /* 350490 */   // Label 7087: @350490
     /* 350490 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(350567), // Rule ID 5701 //
     /* 350495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350538 */     // MIs[2] Operand 1
     /* 350538 */     // No operand predicates
     /* 350538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350546 */     // MIs[3] Operand 1
     /* 350546 */     // No operand predicates
     /* 350546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350548 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350565 */     GIR_RootConstrainSelectedInstOperands,
     /* 350566 */     // GIR_Coverage, 5701,
     /* 350566 */     GIR_EraseRootFromParent_Done,
     /* 350567 */   // Label 7088: @350567
     /* 350567 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(350675), // Rule ID 5702 //
     /* 350572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350615 */     // MIs[2] Operand 1
     /* 350615 */     // No operand predicates
     /* 350615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350623 */     // MIs[3] Operand 1
     /* 350623 */     // No operand predicates
     /* 350623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350625 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350662 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350673 */     GIR_RootConstrainSelectedInstOperands,
     /* 350674 */     // GIR_Coverage, 5702,
     /* 350674 */     GIR_EraseRootFromParent_Done,
     /* 350675 */   // Label 7089: @350675
     /* 350675 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(350752), // Rule ID 5725 //
     /* 350680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350723 */     // MIs[2] Operand 1
     /* 350723 */     // No operand predicates
     /* 350723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350731 */     // MIs[3] Operand 1
     /* 350731 */     // No operand predicates
     /* 350731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350733 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350750 */     GIR_RootConstrainSelectedInstOperands,
     /* 350751 */     // GIR_Coverage, 5725,
     /* 350751 */     GIR_EraseRootFromParent_Done,
     /* 350752 */   // Label 7090: @350752
     /* 350752 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(350860), // Rule ID 5726 //
     /* 350757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350800 */     // MIs[2] Operand 1
     /* 350800 */     // No operand predicates
     /* 350800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350808 */     // MIs[3] Operand 1
     /* 350808 */     // No operand predicates
     /* 350808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350810 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350858 */     GIR_RootConstrainSelectedInstOperands,
     /* 350859 */     // GIR_Coverage, 5726,
     /* 350859 */     GIR_EraseRootFromParent_Done,
     /* 350860 */   // Label 7091: @350860
     /* 350860 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350939), // Rule ID 5656 //
     /* 350865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350893 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 350893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 350896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 350909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350938 */     // GIR_Coverage, 5656,
     /* 350938 */     GIR_EraseRootFromParent_Done,
     /* 350939 */   // Label 7092: @350939
     /* 350939 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351015), // Rule ID 5662 //
     /* 350944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350972 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 350972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 350975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351014 */     // GIR_Coverage, 5662,
     /* 351014 */     GIR_EraseRootFromParent_Done,
     /* 351015 */   // Label 7093: @351015
     /* 351015 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351091), // Rule ID 5672 //
     /* 351020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351048 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351090 */     // GIR_Coverage, 5672,
     /* 351090 */     GIR_EraseRootFromParent_Done,
     /* 351091 */   // Label 7094: @351091
     /* 351091 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(351154), // Rule ID 5681 //
     /* 351096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 351118 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 351122 */     // MIs[1] Operand 1
     /* 351122 */     // No operand predicates
     /* 351122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351134 */     // MIs[2] Operand 1
     /* 351134 */     // No operand predicates
     /* 351134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351136 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 351136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 351139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 351146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351152 */     GIR_RootConstrainSelectedInstOperands,
     /* 351153 */     // GIR_Coverage, 5681,
     /* 351153 */     GIR_EraseRootFromParent_Done,
     /* 351154 */   // Label 7095: @351154
     /* 351154 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351240), // Rule ID 6401 //
     /* 351159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351184 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 351188 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351195 */     // MIs[1] Rn
     /* 351195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 351199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 351204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351216 */     // MIs[2] Operand 1
     /* 351216 */     // No operand predicates
     /* 351216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351218 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 351218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 351221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 351228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351238 */     GIR_RootConstrainSelectedInstOperands,
     /* 351239 */     // GIR_Coverage, 6401,
     /* 351239 */     GIR_EraseRootFromParent_Done,
     /* 351240 */   // Label 7096: @351240
     /* 351240 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(351319), // Rule ID 6406 //
     /* 351245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 351274 */     // MIs[1] Rn
     /* 351274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 351278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 351283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351295 */     // MIs[2] Operand 1
     /* 351295 */     // No operand predicates
     /* 351295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351297 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 351297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 351300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 351307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351317 */     GIR_RootConstrainSelectedInstOperands,
     /* 351318 */     // GIR_Coverage, 6406,
     /* 351318 */     GIR_EraseRootFromParent_Done,
     /* 351319 */   // Label 7097: @351319
     /* 351319 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(351373), // Rule ID 1935 //
     /* 351324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 351349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351357 */     // MIs[1] Operand 1
     /* 351357 */     // No operand predicates
     /* 351357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351359 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 351359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 351362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351371 */     GIR_RootConstrainSelectedInstOperands,
     /* 351372 */     // GIR_Coverage, 1935,
     /* 351372 */     GIR_EraseRootFromParent_Done,
     /* 351373 */   // Label 7098: @351373
     /* 351373 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(351479), // Rule ID 5686 //
     /* 351378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 351400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351408 */     // MIs[1] Operand 1
     /* 351408 */     // No operand predicates
     /* 351408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351410 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 351410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 351413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 351443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 351446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 351471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351477 */     GIR_RootConstrainSelectedInstOperands,
     /* 351478 */     // GIR_Coverage, 5686,
     /* 351478 */     GIR_EraseRootFromParent_Done,
     /* 351479 */   // Label 7099: @351479
     /* 351479 */   GIM_Reject,
     /* 351480 */ // Label 7070: @351480
     /* 351480 */ GIM_Reject,
     /* 351481 */ // Label 6915: @351481
     /* 351481 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(353060),
     /* 351486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351489 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(351615), // Rule ID 4180 //
     /* 351494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351508 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351524 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351527 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351531 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351538 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351555 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351582 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351614 */     // GIR_Coverage, 4180,
     /* 351614 */     GIR_EraseRootFromParent_Done,
     /* 351615 */   // Label 7101: @351615
     /* 351615 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(351741), // Rule ID 4181 //
     /* 351620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351650 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351653 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351657 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351664 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351681 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351740 */     // GIR_Coverage, 4181,
     /* 351740 */     GIR_EraseRootFromParent_Done,
     /* 351741 */   // Label 7102: @351741
     /* 351741 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(351863), // Rule ID 4186 //
     /* 351746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351775 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351779 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351786 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351803 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351830 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351862 */     // GIR_Coverage, 4186,
     /* 351862 */     GIR_EraseRootFromParent_Done,
     /* 351863 */   // Label 7103: @351863
     /* 351863 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(351985), // Rule ID 4188 //
     /* 351868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351894 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351897 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351901 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351908 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351925 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351952 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351984 */     // GIR_Coverage, 4188,
     /* 351984 */     GIR_EraseRootFromParent_Done,
     /* 351985 */   // Label 7104: @351985
     /* 351985 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352106), // Rule ID 4178 //
     /* 351990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352004 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352010 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352020 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352023 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352027 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352051 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352073 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352105 */     // GIR_Coverage, 4178,
     /* 352105 */     GIR_EraseRootFromParent_Done,
     /* 352106 */   // Label 7105: @352106
     /* 352106 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352227), // Rule ID 4179 //
     /* 352111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352125 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352144 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352148 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352172 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352226 */     // GIR_Coverage, 4179,
     /* 352226 */     GIR_EraseRootFromParent_Done,
     /* 352227 */   // Label 7106: @352227
     /* 352227 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352344), // Rule ID 4182 //
     /* 352232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352258 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352261 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352265 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352272 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352289 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352311 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352343 */     // GIR_Coverage, 4182,
     /* 352343 */     GIR_EraseRootFromParent_Done,
     /* 352344 */   // Label 7107: @352344
     /* 352344 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352461), // Rule ID 4184 //
     /* 352349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352375 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352378 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352382 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352389 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352406 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352460 */     // GIR_Coverage, 4184,
     /* 352460 */     GIR_EraseRootFromParent_Done,
     /* 352461 */   // Label 7108: @352461
     /* 352461 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(352549), // Rule ID 1938 //
     /* 352466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352516 */     // MIs[2] Operand 1
     /* 352516 */     // No operand predicates
     /* 352516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352524 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352528 */     // MIs[3] Operand 1
     /* 352528 */     // No operand predicates
     /* 352528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352530 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 352530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 352540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 352547 */     GIR_RootConstrainSelectedInstOperands,
     /* 352548 */     // GIR_Coverage, 1938,
     /* 352548 */     GIR_EraseRootFromParent_Done,
     /* 352549 */   // Label 7109: @352549
     /* 352549 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352626), // Rule ID 5719 //
     /* 352554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352597 */     // MIs[2] Operand 1
     /* 352597 */     // No operand predicates
     /* 352597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352605 */     // MIs[3] Operand 1
     /* 352605 */     // No operand predicates
     /* 352605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352607 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 352607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 352614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 352617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 352624 */     GIR_RootConstrainSelectedInstOperands,
     /* 352625 */     // GIR_Coverage, 5719,
     /* 352625 */     GIR_EraseRootFromParent_Done,
     /* 352626 */   // Label 7110: @352626
     /* 352626 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(352734), // Rule ID 5720 //
     /* 352631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 352657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352674 */     // MIs[2] Operand 1
     /* 352674 */     // No operand predicates
     /* 352674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352682 */     // MIs[3] Operand 1
     /* 352682 */     // No operand predicates
     /* 352682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352684 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 352684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 352699 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 352706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 352723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 352726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 352732 */     GIR_RootConstrainSelectedInstOperands,
     /* 352733 */     // GIR_Coverage, 5720,
     /* 352733 */     GIR_EraseRootFromParent_Done,
     /* 352734 */   // Label 7111: @352734
     /* 352734 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(352813), // Rule ID 5651 //
     /* 352739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352767 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 352767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 352783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352812 */     // GIR_Coverage, 5651,
     /* 352812 */     GIR_EraseRootFromParent_Done,
     /* 352813 */   // Label 7112: @352813
     /* 352813 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(352899), // Rule ID 6400 //
     /* 352818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352843 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352847 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352854 */     // MIs[1] Rn
     /* 352854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352875 */     // MIs[2] Operand 1
     /* 352875 */     // No operand predicates
     /* 352875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352877 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 352877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 352880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 352887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352897 */     GIR_RootConstrainSelectedInstOperands,
     /* 352898 */     // GIR_Coverage, 6400,
     /* 352898 */     GIR_EraseRootFromParent_Done,
     /* 352899 */   // Label 7113: @352899
     /* 352899 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(352953), // Rule ID 1934 //
     /* 352904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352937 */     // MIs[1] Operand 1
     /* 352937 */     // No operand predicates
     /* 352937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352939 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 352939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 352942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 352951 */     GIR_RootConstrainSelectedInstOperands,
     /* 352952 */     // GIR_Coverage, 1934,
     /* 352952 */     GIR_EraseRootFromParent_Done,
     /* 352953 */   // Label 7114: @352953
     /* 352953 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353059), // Rule ID 5694 //
     /* 352958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 352961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352988 */     // MIs[1] Operand 1
     /* 352988 */     // No operand predicates
     /* 352988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352990 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 352990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 352993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 353007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 353023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 353026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 353048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 353051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353057 */     GIR_RootConstrainSelectedInstOperands,
     /* 353058 */     // GIR_Coverage, 5694,
     /* 353058 */     GIR_EraseRootFromParent_Done,
     /* 353059 */   // Label 7115: @353059
     /* 353059 */   GIM_Reject,
     /* 353060 */ // Label 7100: @353060
     /* 353060 */ GIM_Reject,
     /* 353061 */ // Label 6916: @353061
     /* 353061 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353185), // Rule ID 11125 //
     /* 353066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353086 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353090 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 353090 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353093 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353097 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353102 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 353106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353108 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353111 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 353115 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353120 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353123 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 353135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353140 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 353152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353157 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353160 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353166 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 353174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353176 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353181 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353183 */   GIR_RootConstrainSelectedInstOperands,
     /* 353184 */   // GIR_Coverage, 11125,
     /* 353184 */   GIR_EraseRootFromParent_Done,
     /* 353185 */ // Label 7116: @353185
     /* 353185 */ GIM_Reject,
     /* 353186 */ // Label 6917: @353186
     /* 353186 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353310), // Rule ID 11128 //
     /* 353191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353211 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353215 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 353215 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353218 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353222 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353227 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 353231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353233 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353236 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 353240 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353245 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353248 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353253 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353256 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 353260 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353265 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 353277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353291 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 353299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353301 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353306 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353308 */   GIR_RootConstrainSelectedInstOperands,
     /* 353309 */   // GIR_Coverage, 11128,
     /* 353309 */   GIR_EraseRootFromParent_Done,
     /* 353310 */ // Label 7117: @353310
     /* 353310 */ GIM_Reject,
     /* 353311 */ // Label 6918: @353311
     /* 353311 */ GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(355224),
     /* 353316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353329 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353438), // Rule ID 4312 //
     /* 353334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353361 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 353378 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 353385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353405 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353437 */     // GIR_Coverage, 4312,
     /* 353437 */     GIR_EraseRootFromParent_Done,
     /* 353438 */   // Label 7119: @353438
     /* 353438 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353547), // Rule ID 4313 //
     /* 353443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353463 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353470 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 353487 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 353494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353546 */     // GIR_Coverage, 4313,
     /* 353546 */     GIR_EraseRootFromParent_Done,
     /* 353547 */   // Label 7120: @353547
     /* 353547 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(353656), // Rule ID 4420 //
     /* 353552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353556 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353562 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353572 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353579 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 353596 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 353603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353655 */     // GIR_Coverage, 4420,
     /* 353655 */     GIR_EraseRootFromParent_Done,
     /* 353656 */   // Label 7121: @353656
     /* 353656 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353765), // Rule ID 4421 //
     /* 353661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 353705 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 353712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353764 */     // GIR_Coverage, 4421,
     /* 353764 */     GIR_EraseRootFromParent_Done,
     /* 353765 */   // Label 7122: @353765
     /* 353765 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(353870), // Rule ID 4318 //
     /* 353770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353786 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353793 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 353810 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 353817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353837 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353869 */     // GIR_Coverage, 4318,
     /* 353869 */     GIR_EraseRootFromParent_Done,
     /* 353870 */   // Label 7123: @353870
     /* 353870 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353975), // Rule ID 4320 //
     /* 353875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353891 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353898 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 353915 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 353922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353974 */     // GIR_Coverage, 4320,
     /* 353974 */     GIR_EraseRootFromParent_Done,
     /* 353975 */   // Label 7124: @353975
     /* 353975 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(354080), // Rule ID 4426 //
     /* 353980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353996 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354003 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354020 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354079 */     // GIR_Coverage, 4426,
     /* 354079 */     GIR_EraseRootFromParent_Done,
     /* 354080 */   // Label 7125: @354080
     /* 354080 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(354185), // Rule ID 4428 //
     /* 354085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354101 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354125 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354184 */     // GIR_Coverage, 4428,
     /* 354184 */     GIR_EraseRootFromParent_Done,
     /* 354185 */   // Label 7126: @354185
     /* 354185 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(354289), // Rule ID 4310 //
     /* 354190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354194 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354200 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354210 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354217 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354234 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354256 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354288 */     // GIR_Coverage, 4310,
     /* 354288 */     GIR_EraseRootFromParent_Done,
     /* 354289 */   // Label 7127: @354289
     /* 354289 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(354393), // Rule ID 4311 //
     /* 354294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354298 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354304 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354314 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354321 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354338 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354392 */     // GIR_Coverage, 4311,
     /* 354392 */     GIR_EraseRootFromParent_Done,
     /* 354393 */   // Label 7128: @354393
     /* 354393 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(354497), // Rule ID 4418 //
     /* 354398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354418 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354425 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354442 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354496 */     // GIR_Coverage, 4418,
     /* 354496 */     GIR_EraseRootFromParent_Done,
     /* 354497 */   // Label 7129: @354497
     /* 354497 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(354601), // Rule ID 4419 //
     /* 354502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354506 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354512 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354529 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354546 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354568 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354600 */     // GIR_Coverage, 4419,
     /* 354600 */     GIR_EraseRootFromParent_Done,
     /* 354601 */   // Label 7130: @354601
     /* 354601 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(354701), // Rule ID 4314 //
     /* 354606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354622 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354629 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354646 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354668 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354700 */     // GIR_Coverage, 4314,
     /* 354700 */     GIR_EraseRootFromParent_Done,
     /* 354701 */   // Label 7131: @354701
     /* 354701 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354801), // Rule ID 4316 //
     /* 354706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354722 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354729 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354746 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354768 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354800 */     // GIR_Coverage, 4316,
     /* 354800 */     GIR_EraseRootFromParent_Done,
     /* 354801 */   // Label 7132: @354801
     /* 354801 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354901), // Rule ID 4422 //
     /* 354806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354822 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354829 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354846 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354868 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354900 */     // GIR_Coverage, 4422,
     /* 354900 */     GIR_EraseRootFromParent_Done,
     /* 354901 */   // Label 7133: @354901
     /* 354901 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(355001), // Rule ID 4424 //
     /* 354906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354922 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354929 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354946 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354968 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355000 */     // GIR_Coverage, 4424,
     /* 355000 */     GIR_EraseRootFromParent_Done,
     /* 355001 */   // Label 7134: @355001
     /* 355001 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(355112), // Rule ID 11124 //
     /* 355006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355017 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 355017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355029 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355035 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355038 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 355042 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355047 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355050 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 355062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355067 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 355079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355093 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 355101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355103 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355110 */     GIR_RootConstrainSelectedInstOperands,
     /* 355111 */     // GIR_Coverage, 11124,
     /* 355111 */     GIR_EraseRootFromParent_Done,
     /* 355112 */   // Label 7135: @355112
     /* 355112 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(355223), // Rule ID 11130 //
     /* 355117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355128 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 355128 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355131 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355135 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355140 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355146 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355149 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 355153 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355158 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355161 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 355173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355178 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 355190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355195 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355204 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 355212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355214 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355219 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355221 */     GIR_RootConstrainSelectedInstOperands,
     /* 355222 */     // GIR_Coverage, 11130,
     /* 355222 */     GIR_EraseRootFromParent_Done,
     /* 355223 */   // Label 7136: @355223
     /* 355223 */   GIM_Reject,
     /* 355224 */ // Label 7118: @355224
     /* 355224 */ GIM_Reject,
     /* 355225 */ // Label 6919: @355225
     /* 355225 */ GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(355376), // Rule ID 11126 //
     /* 355230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 355236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355254 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 355254 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 355257 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355261 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355266 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 355272 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355277 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355282 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355285 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 355289 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355294 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 355297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 355306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355311 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355314 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 355326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355331 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 355343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355351 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355354 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355357 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 355365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355367 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355372 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355374 */   GIR_RootConstrainSelectedInstOperands,
     /* 355375 */   // GIR_Coverage, 11126,
     /* 355375 */   GIR_EraseRootFromParent_Done,
     /* 355376 */ // Label 7137: @355376
     /* 355376 */ GIM_Reject,
     /* 355377 */ // Label 6920: @355377
     /* 355377 */ GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(357344),
     /* 355382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 355385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355395 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(355504), // Rule ID 4276 //
     /* 355400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355404 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355410 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355420 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355427 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355444 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355503 */     // GIR_Coverage, 4276,
     /* 355503 */     GIR_EraseRootFromParent_Done,
     /* 355504 */   // Label 7139: @355504
     /* 355504 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(355613), // Rule ID 4277 //
     /* 355509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355553 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355580 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355612 */     // GIR_Coverage, 4277,
     /* 355612 */     GIR_EraseRootFromParent_Done,
     /* 355613 */   // Label 7140: @355613
     /* 355613 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(355722), // Rule ID 4384 //
     /* 355618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355622 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355628 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355638 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355645 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355662 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355721 */     // GIR_Coverage, 4384,
     /* 355721 */     GIR_EraseRootFromParent_Done,
     /* 355722 */   // Label 7141: @355722
     /* 355722 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(355831), // Rule ID 4385 //
     /* 355727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355731 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355737 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355747 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355754 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355771 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355798 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355830 */     // GIR_Coverage, 4385,
     /* 355830 */     GIR_EraseRootFromParent_Done,
     /* 355831 */   // Label 7142: @355831
     /* 355831 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(355936), // Rule ID 4282 //
     /* 355836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355852 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355859 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355876 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355935 */     // GIR_Coverage, 4282,
     /* 355935 */     GIR_EraseRootFromParent_Done,
     /* 355936 */   // Label 7143: @355936
     /* 355936 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356041), // Rule ID 4284 //
     /* 355941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355957 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355964 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355981 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356040 */     // GIR_Coverage, 4284,
     /* 356040 */     GIR_EraseRootFromParent_Done,
     /* 356041 */   // Label 7144: @356041
     /* 356041 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356146), // Rule ID 4390 //
     /* 356046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356062 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356069 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356086 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356113 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356145 */     // GIR_Coverage, 4390,
     /* 356145 */     GIR_EraseRootFromParent_Done,
     /* 356146 */   // Label 7145: @356146
     /* 356146 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356251), // Rule ID 4392 //
     /* 356151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356174 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356191 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356250 */     // GIR_Coverage, 4392,
     /* 356250 */     GIR_EraseRootFromParent_Done,
     /* 356251 */   // Label 7146: @356251
     /* 356251 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356355), // Rule ID 4274 //
     /* 356256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356276 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356283 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356300 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356322 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356354 */     // GIR_Coverage, 4274,
     /* 356354 */     GIR_EraseRootFromParent_Done,
     /* 356355 */   // Label 7147: @356355
     /* 356355 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(356459), // Rule ID 4275 //
     /* 356360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356364 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356370 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356380 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356387 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356404 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356426 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356458 */     // GIR_Coverage, 4275,
     /* 356458 */     GIR_EraseRootFromParent_Done,
     /* 356459 */   // Label 7148: @356459
     /* 356459 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(356563), // Rule ID 4382 //
     /* 356464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356484 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356491 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356508 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356562 */     // GIR_Coverage, 4382,
     /* 356562 */     GIR_EraseRootFromParent_Done,
     /* 356563 */   // Label 7149: @356563
     /* 356563 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(356667), // Rule ID 4383 //
     /* 356568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356578 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356588 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356595 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356612 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356634 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356666 */     // GIR_Coverage, 4383,
     /* 356666 */     GIR_EraseRootFromParent_Done,
     /* 356667 */   // Label 7150: @356667
     /* 356667 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(356767), // Rule ID 4278 //
     /* 356672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356688 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356695 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356712 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356766 */     // GIR_Coverage, 4278,
     /* 356766 */     GIR_EraseRootFromParent_Done,
     /* 356767 */   // Label 7151: @356767
     /* 356767 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(356867), // Rule ID 4280 //
     /* 356772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356788 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356795 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356812 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356834 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356866 */     // GIR_Coverage, 4280,
     /* 356866 */     GIR_EraseRootFromParent_Done,
     /* 356867 */   // Label 7152: @356867
     /* 356867 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(356967), // Rule ID 4386 //
     /* 356872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356912 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356966 */     // GIR_Coverage, 4386,
     /* 356966 */     GIR_EraseRootFromParent_Done,
     /* 356967 */   // Label 7153: @356967
     /* 356967 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(357067), // Rule ID 4388 //
     /* 356972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356988 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356995 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357012 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357034 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357066 */     // GIR_Coverage, 4388,
     /* 357066 */     GIR_EraseRootFromParent_Done,
     /* 357067 */   // Label 7154: @357067
     /* 357067 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(357205), // Rule ID 11123 //
     /* 357072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357083 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 357083 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 357086 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357090 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357095 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 357101 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357106 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357111 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357114 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 357118 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357123 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 357135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357140 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357143 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 357146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 357151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 357155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357160 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 357163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 357172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357186 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 357194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357196 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 357203 */     GIR_RootConstrainSelectedInstOperands,
     /* 357204 */     // GIR_Coverage, 11123,
     /* 357204 */     GIR_EraseRootFromParent_Done,
     /* 357205 */   // Label 7155: @357205
     /* 357205 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(357343), // Rule ID 11129 //
     /* 357210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357221 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 357221 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 357224 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357228 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357233 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 357239 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357244 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357249 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357252 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 357256 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357261 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357266 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357269 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 357273 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357278 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357281 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 357284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 357289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 357293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357298 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 357301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 357310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357315 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357324 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 357332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357334 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 357341 */     GIR_RootConstrainSelectedInstOperands,
     /* 357342 */     // GIR_Coverage, 11129,
     /* 357342 */     GIR_EraseRootFromParent_Done,
     /* 357343 */   // Label 7156: @357343
     /* 357343 */   GIM_Reject,
     /* 357344 */ // Label 7138: @357344
     /* 357344 */ GIM_Reject,
     /* 357345 */ // Label 6921: @357345
     /* 357345 */ GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(359538),
     /* 357350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357353 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(357479), // Rule ID 4240 //
     /* 357358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357388 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357391 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357395 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 357419 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 357426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357446 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357478 */     // GIR_Coverage, 4240,
     /* 357478 */     GIR_EraseRootFromParent_Done,
     /* 357479 */   // Label 7158: @357479
     /* 357479 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(357605), // Rule ID 4241 //
     /* 357484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357514 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357517 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357521 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357528 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 357545 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 357552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357604 */     // GIR_Coverage, 4241,
     /* 357604 */     GIR_EraseRootFromParent_Done,
     /* 357605 */   // Label 7159: @357605
     /* 357605 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(357724), // Rule ID 4348 //
     /* 357610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 357613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357630 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357640 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357647 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 357664 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 357671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357691 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357723 */     // GIR_Coverage, 4348,
     /* 357723 */     GIR_EraseRootFromParent_Done,
     /* 357724 */   // Label 7160: @357724
     /* 357724 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357843), // Rule ID 4349 //
     /* 357729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 357732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357759 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357766 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 357783 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 357790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357842 */     // GIR_Coverage, 4349,
     /* 357842 */     GIR_EraseRootFromParent_Done,
     /* 357843 */   // Label 7161: @357843
     /* 357843 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(357965), // Rule ID 4246 //
     /* 357848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357874 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357877 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357881 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357888 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 357905 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 357912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357932 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357964 */     // GIR_Coverage, 4246,
     /* 357964 */     GIR_EraseRootFromParent_Done,
     /* 357965 */   // Label 7162: @357965
     /* 357965 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(358087), // Rule ID 4248 //
     /* 357970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357996 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357999 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358003 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358027 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358086 */     // GIR_Coverage, 4248,
     /* 358086 */     GIR_EraseRootFromParent_Done,
     /* 358087 */   // Label 7163: @358087
     /* 358087 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(358202), // Rule ID 4354 //
     /* 358092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358118 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358125 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358142 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358201 */     // GIR_Coverage, 4354,
     /* 358201 */     GIR_EraseRootFromParent_Done,
     /* 358202 */   // Label 7164: @358202
     /* 358202 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(358317), // Rule ID 4356 //
     /* 358207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358233 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358240 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358257 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358284 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358316 */     // GIR_Coverage, 4356,
     /* 358316 */     GIR_EraseRootFromParent_Done,
     /* 358317 */   // Label 7165: @358317
     /* 358317 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(358438), // Rule ID 4238 //
     /* 358322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358355 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358359 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358366 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 358383 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 358383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 358390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358405 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358437 */     // GIR_Coverage, 4238,
     /* 358437 */     GIR_EraseRootFromParent_Done,
     /* 358438 */   // Label 7166: @358438
     /* 358438 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(358559), // Rule ID 4239 //
     /* 358443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358476 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358480 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 358504 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 358504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 358511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358526 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358558 */     // GIR_Coverage, 4239,
     /* 358558 */     GIR_EraseRootFromParent_Done,
     /* 358559 */   // Label 7167: @358559
     /* 358559 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(358673), // Rule ID 4346 //
     /* 358564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358594 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358601 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 358618 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 358618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 358625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358640 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358672 */     // GIR_Coverage, 4346,
     /* 358672 */     GIR_EraseRootFromParent_Done,
     /* 358673 */   // Label 7168: @358673
     /* 358673 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(358787), // Rule ID 4347 //
     /* 358678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358708 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358715 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 358732 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 358732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 358739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358754 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358786 */     // GIR_Coverage, 4347,
     /* 358786 */     GIR_EraseRootFromParent_Done,
     /* 358787 */   // Label 7169: @358787
     /* 358787 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(358904), // Rule ID 4242 //
     /* 358792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358818 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358821 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358825 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358832 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 358849 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 358849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 358856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358903 */     // GIR_Coverage, 4242,
     /* 358903 */     GIR_EraseRootFromParent_Done,
     /* 358904 */   // Label 7170: @358904
     /* 358904 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(359021), // Rule ID 4244 //
     /* 358909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358935 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358938 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358942 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358949 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 358966 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 358966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 358973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358988 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359020 */     // GIR_Coverage, 4244,
     /* 359020 */     GIR_EraseRootFromParent_Done,
     /* 359021 */   // Label 7171: @359021
     /* 359021 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(359131), // Rule ID 4350 //
     /* 359026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359052 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359059 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359076 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359098 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359130 */     // GIR_Coverage, 4350,
     /* 359130 */     GIR_EraseRootFromParent_Done,
     /* 359131 */   // Label 7172: @359131
     /* 359131 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(359241), // Rule ID 4352 //
     /* 359136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359162 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359169 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359186 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359240 */     // GIR_Coverage, 4352,
     /* 359240 */     GIR_EraseRootFromParent_Done,
     /* 359241 */   // Label 7173: @359241
     /* 359241 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(359389), // Rule ID 11122 //
     /* 359246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359267 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 359267 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 359270 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359274 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359279 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 359285 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359290 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359295 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359298 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 359302 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359307 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 359319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359324 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359327 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 359339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359344 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 359347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 359356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359370 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 359378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359380 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 359387 */     GIR_RootConstrainSelectedInstOperands,
     /* 359388 */     // GIR_Coverage, 11122,
     /* 359388 */     GIR_EraseRootFromParent_Done,
     /* 359389 */   // Label 7174: @359389
     /* 359389 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(359537), // Rule ID 11127 //
     /* 359394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359415 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 359415 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 359418 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359422 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359427 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 359433 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359438 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359443 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359446 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 359450 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359455 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359460 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359463 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 359467 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359472 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359475 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 359487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 359495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 359504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359518 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 359526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359528 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 359535 */     GIR_RootConstrainSelectedInstOperands,
     /* 359536 */     // GIR_Coverage, 11127,
     /* 359536 */     GIR_EraseRootFromParent_Done,
     /* 359537 */   // Label 7175: @359537
     /* 359537 */   GIM_Reject,
     /* 359538 */ // Label 7157: @359538
     /* 359538 */ GIM_Reject,
     /* 359539 */ // Label 6922: @359539
     /* 359539 */ GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(360588),
     /* 359544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 359547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359557 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(359673), // Rule ID 4204 //
     /* 359562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359582 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359585 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359589 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 359596 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 359613 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 359613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 359616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 359620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359640 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 359662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 359672 */     // GIR_Coverage, 4204,
     /* 359672 */     GIR_EraseRootFromParent_Done,
     /* 359673 */   // Label 7177: @359673
     /* 359673 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(359789), // Rule ID 4205 //
     /* 359678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359698 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359701 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359705 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 359712 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 359729 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 359729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 359732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 359736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359756 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 359778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 359788 */     // GIR_Coverage, 4205,
     /* 359788 */     GIR_EraseRootFromParent_Done,
     /* 359789 */   // Label 7178: @359789
     /* 359789 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(359901), // Rule ID 4210 //
     /* 359794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359810 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359813 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359817 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 359824 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 359841 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 359841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 359844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 359848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359868 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 359890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 359900 */     // GIR_Coverage, 4210,
     /* 359900 */     GIR_EraseRootFromParent_Done,
     /* 359901 */   // Label 7179: @359901
     /* 359901 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(360013), // Rule ID 4212 //
     /* 359906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359922 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359925 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359929 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 359936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 359953 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 359953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 359956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 359960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360012 */     // GIR_Coverage, 4212,
     /* 360012 */     GIR_EraseRootFromParent_Done,
     /* 360013 */   // Label 7180: @360013
     /* 360013 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(360124), // Rule ID 4202 //
     /* 360018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360038 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360041 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360045 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360052 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 360069 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 360069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 360076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360091 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360123 */     // GIR_Coverage, 4202,
     /* 360123 */     GIR_EraseRootFromParent_Done,
     /* 360124 */   // Label 7181: @360124
     /* 360124 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(360235), // Rule ID 4203 //
     /* 360129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360133 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360149 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360152 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360156 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360163 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 360180 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 360180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 360187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360202 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360234 */     // GIR_Coverage, 4203,
     /* 360234 */     GIR_EraseRootFromParent_Done,
     /* 360235 */   // Label 7182: @360235
     /* 360235 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(360342), // Rule ID 4206 //
     /* 360240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360256 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360259 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360263 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 360287 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 360287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 360294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360309 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360341 */     // GIR_Coverage, 4206,
     /* 360341 */     GIR_EraseRootFromParent_Done,
     /* 360342 */   // Label 7183: @360342
     /* 360342 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(360449), // Rule ID 4208 //
     /* 360347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360363 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360366 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360370 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360377 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 360394 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 360394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 360401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360416 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360448 */     // GIR_Coverage, 4208,
     /* 360448 */     GIR_EraseRootFromParent_Done,
     /* 360449 */   // Label 7184: @360449
     /* 360449 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(360587), // Rule ID 11121 //
     /* 360454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360465 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 360465 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360468 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360472 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360477 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360483 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360488 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360493 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360496 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 360500 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360505 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360510 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360513 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 360517 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360522 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360525 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 360537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360542 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 360554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360568 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 360576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360578 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360585 */     GIR_RootConstrainSelectedInstOperands,
     /* 360586 */     // GIR_Coverage, 11121,
     /* 360586 */     GIR_EraseRootFromParent_Done,
     /* 360587 */   // Label 7185: @360587
     /* 360587 */   GIM_Reject,
     /* 360588 */ // Label 7176: @360588
     /* 360588 */ GIM_Reject,
     /* 360589 */ // Label 6923: @360589
     /* 360589 */ GIM_Reject,
     /* 360590 */ // Label 89: @360590
     /* 360590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7189*/ GIMT_Encode4(363507),
     /* 360601 */ /*GILLT_s16*//*Label 7186*/ GIMT_Encode4(360613),
     /* 360605 */ /*GILLT_s32*//*Label 7187*/ GIMT_Encode4(361247),
     /* 360609 */ /*GILLT_s64*//*Label 7188*/ GIMT_Encode4(362840),
     /* 360613 */ // Label 7186: @360613
     /* 360613 */ GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(360657), // Rule ID 11170 //
     /* 360618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360631 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360635 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 360635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360640 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 360646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360656 */   // GIR_Coverage, 11170,
     /* 360656 */   GIR_EraseRootFromParent_Done,
     /* 360657 */ // Label 7190: @360657
     /* 360657 */ GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(360701), // Rule ID 11171 //
     /* 360662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360675 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360679 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 360679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360684 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 360690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360700 */   // GIR_Coverage, 11171,
     /* 360700 */   GIR_EraseRootFromParent_Done,
     /* 360701 */ // Label 7191: @360701
     /* 360701 */ GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(360745), // Rule ID 11172 //
     /* 360706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 360712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360719 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360723 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 360723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360728 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 360734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360744 */   // GIR_Coverage, 11172,
     /* 360744 */   GIR_EraseRootFromParent_Done,
     /* 360745 */ // Label 7192: @360745
     /* 360745 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(360790), // Rule ID 5750 //
     /* 360750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360764 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360768 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 360768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360773 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360789 */   // GIR_Coverage, 5750,
     /* 360789 */   GIR_EraseRootFromParent_Done,
     /* 360790 */ // Label 7193: @360790
     /* 360790 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(360835), // Rule ID 5753 //
     /* 360795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360817 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360821 */   // MIs[1] Operand 1
     /* 360821 */   // No operand predicates
     /* 360821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360823 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 360826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360828 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360830 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 360833 */   GIR_RootConstrainSelectedInstOperands,
     /* 360834 */   // GIR_Coverage, 5753,
     /* 360834 */   GIR_EraseRootFromParent_Done,
     /* 360835 */ // Label 7194: @360835
     /* 360835 */ GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360911), // Rule ID 11145 //
     /* 360840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360861 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 360865 */   // MIs[1] Operand 1
     /* 360865 */   // No operand predicates
     /* 360865 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360867 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 360867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 360883 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 360886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360893 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 360900 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360910 */   // GIR_Coverage, 11145,
     /* 360910 */   GIR_EraseRootFromParent_Done,
     /* 360911 */ // Label 7195: @360911
     /* 360911 */ GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(360987), // Rule ID 11146 //
     /* 360916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360937 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 360941 */   // MIs[1] Operand 1
     /* 360941 */   // No operand predicates
     /* 360941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360943 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 360943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360955 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 360959 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 360962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360969 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 360976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360986 */   // GIR_Coverage, 11146,
     /* 360986 */   GIR_EraseRootFromParent_Done,
     /* 360987 */ // Label 7196: @360987
     /* 360987 */ GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(361063), // Rule ID 11147 //
     /* 360992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 360998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361013 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 361017 */   // MIs[1] Operand 1
     /* 361017 */   // No operand predicates
     /* 361017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361019 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 361019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 361026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361035 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361045 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361062 */   // GIR_Coverage, 11147,
     /* 361062 */   GIR_EraseRootFromParent_Done,
     /* 361063 */ // Label 7197: @361063
     /* 361063 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(361124), // Rule ID 11135 //
     /* 361068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361085 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 361085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 361092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361097 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361103 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361107 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361120 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361122 */   GIR_RootConstrainSelectedInstOperands,
     /* 361123 */   // GIR_Coverage, 11135,
     /* 361123 */   GIR_EraseRootFromParent_Done,
     /* 361124 */ // Label 7198: @361124
     /* 361124 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361185), // Rule ID 11136 //
     /* 361129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361146 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 361146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 361153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361158 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361168 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361181 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361183 */   GIR_RootConstrainSelectedInstOperands,
     /* 361184 */   // GIR_Coverage, 11136,
     /* 361184 */   GIR_EraseRootFromParent_Done,
     /* 361185 */ // Label 7199: @361185
     /* 361185 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(361246), // Rule ID 11137 //
     /* 361190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361207 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 361207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 361214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361219 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361229 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361242 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361244 */   GIR_RootConstrainSelectedInstOperands,
     /* 361245 */   // GIR_Coverage, 11137,
     /* 361245 */   GIR_EraseRootFromParent_Done,
     /* 361246 */ // Label 7200: @361246
     /* 361246 */ GIM_Reject,
     /* 361247 */ // Label 7187: @361247
     /* 361247 */ GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(361292), // Rule ID 6927 //
     /* 361252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361266 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361270 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 361270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361275 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 361281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361291 */   // GIR_Coverage, 6927,
     /* 361291 */   GIR_EraseRootFromParent_Done,
     /* 361292 */ // Label 7201: @361292
     /* 361292 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(361337), // Rule ID 6928 //
     /* 361297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 361300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361311 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361315 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 361315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361320 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 361326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361336 */   // GIR_Coverage, 6928,
     /* 361336 */   GIR_EraseRootFromParent_Done,
     /* 361337 */ // Label 7202: @361337
     /* 361337 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(361381), // Rule ID 11166 //
     /* 361342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361355 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361359 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 361359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361364 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361380 */   // GIR_Coverage, 11166,
     /* 361380 */   GIR_EraseRootFromParent_Done,
     /* 361381 */ // Label 7203: @361381
     /* 361381 */ GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(361425), // Rule ID 11167 //
     /* 361386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361399 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361403 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 361403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361408 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361424 */   // GIR_Coverage, 11167,
     /* 361424 */   GIR_EraseRootFromParent_Done,
     /* 361425 */ // Label 7204: @361425
     /* 361425 */ GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(361469), // Rule ID 11168 //
     /* 361430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361443 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361447 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 361447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361452 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361468 */   // GIR_Coverage, 11168,
     /* 361468 */   GIR_EraseRootFromParent_Done,
     /* 361469 */ // Label 7205: @361469
     /* 361469 */ GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361513), // Rule ID 11173 //
     /* 361474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361487 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361491 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 361491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361496 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361512 */   // GIR_Coverage, 11173,
     /* 361512 */   GIR_EraseRootFromParent_Done,
     /* 361513 */ // Label 7206: @361513
     /* 361513 */ GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361557), // Rule ID 11174 //
     /* 361518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 361524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361531 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361535 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 361535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361540 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361556 */   // GIR_Coverage, 11174,
     /* 361556 */   GIR_EraseRootFromParent_Done,
     /* 361557 */ // Label 7207: @361557
     /* 361557 */ GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361602), // Rule ID 5749 //
     /* 361562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361576 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361580 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 361580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361585 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 361591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361601 */   // GIR_Coverage, 5749,
     /* 361601 */   GIR_EraseRootFromParent_Done,
     /* 361602 */ // Label 7208: @361602
     /* 361602 */ GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361675), // Rule ID 11151 //
     /* 361607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361628 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 361632 */   // MIs[1] Operand 1
     /* 361632 */   // No operand predicates
     /* 361632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361634 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 361634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 361637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361646 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 361652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 361665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 361673 */   GIR_RootConstrainSelectedInstOperands,
     /* 361674 */   // GIR_Coverage, 11151,
     /* 361674 */   GIR_EraseRootFromParent_Done,
     /* 361675 */ // Label 7209: @361675
     /* 361675 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361748), // Rule ID 11152 //
     /* 361680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361701 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 361705 */   // MIs[1] Operand 1
     /* 361705 */   // No operand predicates
     /* 361705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361707 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 361707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 361710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361719 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 361725 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361730 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 361738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361743 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 361746 */   GIR_RootConstrainSelectedInstOperands,
     /* 361747 */   // GIR_Coverage, 11152,
     /* 361747 */   GIR_EraseRootFromParent_Done,
     /* 361748 */ // Label 7210: @361748
     /* 361748 */ GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361821), // Rule ID 11153 //
     /* 361753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361766 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361774 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361778 */   // MIs[1] Operand 1
     /* 361778 */   // No operand predicates
     /* 361778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361780 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 361780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 361783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361792 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 361798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 361811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361816 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 361819 */   GIR_RootConstrainSelectedInstOperands,
     /* 361820 */   // GIR_Coverage, 11153,
     /* 361820 */   GIR_EraseRootFromParent_Done,
     /* 361821 */ // Label 7211: @361821
     /* 361821 */ GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361869), // Rule ID 1926 //
     /* 361826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 361829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 361832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361851 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 361855 */   // MIs[1] Operand 1
     /* 361855 */   // No operand predicates
     /* 361855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361857 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 361857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 361860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361864 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361867 */   GIR_RootConstrainSelectedInstOperands,
     /* 361868 */   // GIR_Coverage, 1926,
     /* 361868 */   GIR_EraseRootFromParent_Done,
     /* 361869 */ // Label 7212: @361869
     /* 361869 */ GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361917), // Rule ID 1927 //
     /* 361874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 361877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361899 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 361903 */   // MIs[1] Operand 1
     /* 361903 */   // No operand predicates
     /* 361903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361905 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 361905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 361908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361910 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361912 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361915 */   GIR_RootConstrainSelectedInstOperands,
     /* 361916 */   // GIR_Coverage, 1927,
     /* 361916 */   GIR_EraseRootFromParent_Done,
     /* 361917 */ // Label 7213: @361917
     /* 361917 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361965), // Rule ID 1928 //
     /* 361922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 361925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361947 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 361951 */   // MIs[1] Operand 1
     /* 361951 */   // No operand predicates
     /* 361951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361953 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 361953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 361956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361958 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361960 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361963 */   GIR_RootConstrainSelectedInstOperands,
     /* 361964 */   // GIR_Coverage, 1928,
     /* 361964 */   GIR_EraseRootFromParent_Done,
     /* 361965 */ // Label 7214: @361965
     /* 361965 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(362013), // Rule ID 1930 //
     /* 361970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 361976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361995 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 361999 */   // MIs[1] Operand 1
     /* 361999 */   // No operand predicates
     /* 361999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362001 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 362004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362006 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362008 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362011 */   GIR_RootConstrainSelectedInstOperands,
     /* 362012 */   // GIR_Coverage, 1930,
     /* 362012 */   GIR_EraseRootFromParent_Done,
     /* 362013 */ // Label 7215: @362013
     /* 362013 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362061), // Rule ID 1931 //
     /* 362018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362043 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362047 */   // MIs[1] Operand 1
     /* 362047 */   // No operand predicates
     /* 362047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362049 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 362052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362054 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362056 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362059 */   GIR_RootConstrainSelectedInstOperands,
     /* 362060 */   // GIR_Coverage, 1931,
     /* 362060 */   GIR_EraseRootFromParent_Done,
     /* 362061 */ // Label 7216: @362061
     /* 362061 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362109), // Rule ID 1932 //
     /* 362066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362091 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362095 */   // MIs[1] Operand 1
     /* 362095 */   // No operand predicates
     /* 362095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362097 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 362100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362102 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362104 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362107 */   GIR_RootConstrainSelectedInstOperands,
     /* 362108 */   // GIR_Coverage, 1932,
     /* 362108 */   GIR_EraseRootFromParent_Done,
     /* 362109 */ // Label 7217: @362109
     /* 362109 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362154), // Rule ID 5752 //
     /* 362114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362136 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362140 */   // MIs[1] Operand 1
     /* 362140 */   // No operand predicates
     /* 362140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362142 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 362142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 362145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362147 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362149 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362152 */   GIR_RootConstrainSelectedInstOperands,
     /* 362153 */   // GIR_Coverage, 5752,
     /* 362153 */   GIR_EraseRootFromParent_Done,
     /* 362154 */ // Label 7218: @362154
     /* 362154 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362230), // Rule ID 11141 //
     /* 362159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362180 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 362184 */   // MIs[1] Operand 1
     /* 362184 */   // No operand predicates
     /* 362184 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362186 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 362186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 362193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362198 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362202 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362212 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362229 */   // GIR_Coverage, 11141,
     /* 362229 */   GIR_EraseRootFromParent_Done,
     /* 362230 */ // Label 7219: @362230
     /* 362230 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362306), // Rule ID 11142 //
     /* 362235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362256 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 362260 */   // MIs[1] Operand 1
     /* 362260 */   // No operand predicates
     /* 362260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362262 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 362262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 362269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362278 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362288 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362305 */   // GIR_Coverage, 11142,
     /* 362305 */   GIR_EraseRootFromParent_Done,
     /* 362306 */ // Label 7220: @362306
     /* 362306 */ GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362382), // Rule ID 11143 //
     /* 362311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362332 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362336 */   // MIs[1] Operand 1
     /* 362336 */   // No operand predicates
     /* 362336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362338 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 362338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362350 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362364 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362381 */   // GIR_Coverage, 11143,
     /* 362381 */   GIR_EraseRootFromParent_Done,
     /* 362382 */ // Label 7221: @362382
     /* 362382 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362458), // Rule ID 11148 //
     /* 362387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362408 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362412 */   // MIs[1] Operand 1
     /* 362412 */   // No operand predicates
     /* 362412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362414 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 362414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362426 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362430 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362440 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362457 */   // GIR_Coverage, 11148,
     /* 362457 */   GIR_EraseRootFromParent_Done,
     /* 362458 */ // Label 7222: @362458
     /* 362458 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362534), // Rule ID 11149 //
     /* 362463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 362469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362484 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 362488 */   // MIs[1] Operand 1
     /* 362488 */   // No operand predicates
     /* 362488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362490 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 362490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 362497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362506 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362516 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362533 */   // GIR_Coverage, 11149,
     /* 362533 */   GIR_EraseRootFromParent_Done,
     /* 362534 */ // Label 7223: @362534
     /* 362534 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362595), // Rule ID 11131 //
     /* 362539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362556 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 362556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 362563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362568 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362574 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362578 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 362586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362591 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362593 */   GIR_RootConstrainSelectedInstOperands,
     /* 362594 */   // GIR_Coverage, 11131,
     /* 362594 */   GIR_EraseRootFromParent_Done,
     /* 362595 */ // Label 7224: @362595
     /* 362595 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362656), // Rule ID 11132 //
     /* 362600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362617 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 362617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 362624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362629 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362635 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362639 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 362647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362652 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362654 */   GIR_RootConstrainSelectedInstOperands,
     /* 362655 */   // GIR_Coverage, 11132,
     /* 362655 */   GIR_EraseRootFromParent_Done,
     /* 362656 */ // Label 7225: @362656
     /* 362656 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362717), // Rule ID 11133 //
     /* 362661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362678 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 362678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 362685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362690 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362696 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362700 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 362708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362713 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362715 */   GIR_RootConstrainSelectedInstOperands,
     /* 362716 */   // GIR_Coverage, 11133,
     /* 362716 */   GIR_EraseRootFromParent_Done,
     /* 362717 */ // Label 7226: @362717
     /* 362717 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362778), // Rule ID 11138 //
     /* 362722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362739 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 362739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 362746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362751 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362757 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362761 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 362769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362774 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362776 */   GIR_RootConstrainSelectedInstOperands,
     /* 362777 */   // GIR_Coverage, 11138,
     /* 362777 */   GIR_EraseRootFromParent_Done,
     /* 362778 */ // Label 7227: @362778
     /* 362778 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(362839), // Rule ID 11139 //
     /* 362783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 362789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362800 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 362800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 362807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362812 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362818 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362822 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 362830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362835 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362837 */   GIR_RootConstrainSelectedInstOperands,
     /* 362838 */   // GIR_Coverage, 11139,
     /* 362838 */   GIR_EraseRootFromParent_Done,
     /* 362839 */ // Label 7228: @362839
     /* 362839 */ GIM_Reject,
     /* 362840 */ // Label 7188: @362840
     /* 362840 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(362885), // Rule ID 6926 //
     /* 362845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362859 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362863 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 362863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362868 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 362874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362884 */   // GIR_Coverage, 6926,
     /* 362884 */   GIR_EraseRootFromParent_Done,
     /* 362885 */ // Label 7229: @362885
     /* 362885 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(362929), // Rule ID 11169 //
     /* 362890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 362896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362903 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362907 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 362907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362912 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 362918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362928 */   // GIR_Coverage, 11169,
     /* 362928 */   GIR_EraseRootFromParent_Done,
     /* 362929 */ // Label 7230: @362929
     /* 362929 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(362973), // Rule ID 11175 //
     /* 362934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 362940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362947 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362951 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 362951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362956 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 362962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362972 */   // GIR_Coverage, 11175,
     /* 362972 */   GIR_EraseRootFromParent_Done,
     /* 362973 */ // Label 7231: @362973
     /* 362973 */ GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363018), // Rule ID 5748 //
     /* 362978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362992 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362996 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 362996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363001 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363017 */   // GIR_Coverage, 5748,
     /* 363017 */   GIR_EraseRootFromParent_Done,
     /* 363018 */ // Label 7232: @363018
     /* 363018 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(363091), // Rule ID 11154 //
     /* 363023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363044 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363048 */   // MIs[1] Operand 1
     /* 363048 */   // No operand predicates
     /* 363048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363050 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 363050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 363053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363062 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 363068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 363081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363086 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 363089 */   GIR_RootConstrainSelectedInstOperands,
     /* 363090 */   // GIR_Coverage, 11154,
     /* 363090 */   GIR_EraseRootFromParent_Done,
     /* 363091 */ // Label 7233: @363091
     /* 363091 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(363139), // Rule ID 1929 //
     /* 363096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363121 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363125 */   // MIs[1] Operand 1
     /* 363125 */   // No operand predicates
     /* 363125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363127 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 363130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363132 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363134 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363137 */   GIR_RootConstrainSelectedInstOperands,
     /* 363138 */   // GIR_Coverage, 1929,
     /* 363138 */   GIR_EraseRootFromParent_Done,
     /* 363139 */ // Label 7234: @363139
     /* 363139 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(363187), // Rule ID 1933 //
     /* 363144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363169 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363173 */   // MIs[1] Operand 1
     /* 363173 */   // No operand predicates
     /* 363173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363175 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 363178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363180 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363182 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363185 */   GIR_RootConstrainSelectedInstOperands,
     /* 363186 */   // GIR_Coverage, 1933,
     /* 363186 */   GIR_EraseRootFromParent_Done,
     /* 363187 */ // Label 7235: @363187
     /* 363187 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(363232), // Rule ID 5751 //
     /* 363192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363214 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363218 */   // MIs[1] Operand 1
     /* 363218 */   // No operand predicates
     /* 363218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363220 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 363220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 363223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363227 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363230 */   GIR_RootConstrainSelectedInstOperands,
     /* 363231 */   // GIR_Coverage, 5751,
     /* 363231 */   GIR_EraseRootFromParent_Done,
     /* 363232 */ // Label 7236: @363232
     /* 363232 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(363308), // Rule ID 11144 //
     /* 363237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363258 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363262 */   // MIs[1] Operand 1
     /* 363262 */   // No operand predicates
     /* 363262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363264 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 363264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363276 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363280 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363290 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363307 */   // GIR_Coverage, 11144,
     /* 363307 */   GIR_EraseRootFromParent_Done,
     /* 363308 */ // Label 7237: @363308
     /* 363308 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(363384), // Rule ID 11150 //
     /* 363313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363326 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363330 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363334 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363338 */   // MIs[1] Operand 1
     /* 363338 */   // No operand predicates
     /* 363338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363340 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 363340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363356 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363366 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363383 */   // GIR_Coverage, 11150,
     /* 363383 */   GIR_EraseRootFromParent_Done,
     /* 363384 */ // Label 7238: @363384
     /* 363384 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(363445), // Rule ID 11134 //
     /* 363389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363406 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 363406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363418 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363424 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363428 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 363436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363441 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363443 */   GIR_RootConstrainSelectedInstOperands,
     /* 363444 */   // GIR_Coverage, 11134,
     /* 363444 */   GIR_EraseRootFromParent_Done,
     /* 363445 */ // Label 7239: @363445
     /* 363445 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(363506), // Rule ID 11140 //
     /* 363450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363467 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 363467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363489 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 363497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363502 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363504 */   GIR_RootConstrainSelectedInstOperands,
     /* 363505 */   // GIR_Coverage, 11140,
     /* 363505 */   GIR_EraseRootFromParent_Done,
     /* 363506 */ // Label 7240: @363506
     /* 363506 */ GIM_Reject,
     /* 363507 */ // Label 7189: @363507
     /* 363507 */ GIM_Reject,
     /* 363508 */ // Label 90: @363508
     /* 363508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7248*/ GIMT_Encode4(365827),
     /* 363519 */ /*GILLT_nxv2s16*//*Label 7241*/ GIMT_Encode4(363559),
     /* 363523 */ /*GILLT_nxv2s32*//*Label 7242*/ GIMT_Encode4(363918),
     /* 363527 */ /*GILLT_nxv2s64*//*Label 7243*/ GIMT_Encode4(364220), GIMT_Encode4(0),
     /* 363535 */ /*GILLT_nxv4s16*//*Label 7244*/ GIMT_Encode4(364595),
     /* 363539 */ /*GILLT_nxv4s32*//*Label 7245*/ GIMT_Encode4(364897), GIMT_Encode4(0),
     /* 363547 */ /*GILLT_nxv8s16*//*Label 7246*/ GIMT_Encode4(365272), GIMT_Encode4(0),
     /* 363555 */ /*GILLT_nxv16s8*//*Label 7247*/ GIMT_Encode4(365683),
     /* 363559 */ // Label 7241: @363559
     /* 363559 */ GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363917),
     /* 363564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363571 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(363635), // Rule ID 5982 //
     /* 363576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363587 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 363591 */     // MIs[1] Operand 1
     /* 363591 */     // No operand predicates
     /* 363591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363593 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 363593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 363600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363605 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 363624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363634 */     // GIR_Coverage, 5982,
     /* 363634 */     GIR_EraseRootFromParent_Done,
     /* 363635 */   // Label 7250: @363635
     /* 363635 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(363692), // Rule ID 2675 //
     /* 363640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 363655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363672 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363676 */     // MIs[2] Operand 1
     /* 363676 */     // No operand predicates
     /* 363676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363678 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 363678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 363681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 363687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 363690 */     GIR_RootConstrainSelectedInstOperands,
     /* 363691 */     // GIR_Coverage, 2675,
     /* 363691 */     GIR_EraseRootFromParent_Done,
     /* 363692 */   // Label 7251: @363692
     /* 363692 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(363749), // Rule ID 2677 //
     /* 363697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 363712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363733 */     // MIs[2] Operand 1
     /* 363733 */     // No operand predicates
     /* 363733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363735 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 363735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 363744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 363747 */     GIR_RootConstrainSelectedInstOperands,
     /* 363748 */     // GIR_Coverage, 2677,
     /* 363748 */     GIR_EraseRootFromParent_Done,
     /* 363749 */   // Label 7252: @363749
     /* 363749 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(363806), // Rule ID 8286 //
     /* 363754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 363769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363786 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 363790 */     // MIs[2] Operand 1
     /* 363790 */     // No operand predicates
     /* 363790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363792 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 363792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 363795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 363801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 363804 */     GIR_RootConstrainSelectedInstOperands,
     /* 363805 */     // GIR_Coverage, 8286,
     /* 363805 */     GIR_EraseRootFromParent_Done,
     /* 363806 */   // Label 7253: @363806
     /* 363806 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(363840), // Rule ID 8329 //
     /* 363811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363822 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 363826 */     // MIs[1] Operand 1
     /* 363826 */     // No operand predicates
     /* 363826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363828 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 363828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 363831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363833 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 363838 */     GIR_RootConstrainSelectedInstOperands,
     /* 363839 */     // GIR_Coverage, 8329,
     /* 363839 */     GIR_EraseRootFromParent_Done,
     /* 363840 */   // Label 7254: @363840
     /* 363840 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(363916), // Rule ID 8307 //
     /* 363845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363852 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 363855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 363888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 363906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363914 */     GIR_RootConstrainSelectedInstOperands,
     /* 363915 */     // GIR_Coverage, 8307,
     /* 363915 */     GIR_EraseRootFromParent_Done,
     /* 363916 */   // Label 7255: @363916
     /* 363916 */   GIM_Reject,
     /* 363917 */ // Label 7249: @363917
     /* 363917 */ GIM_Reject,
     /* 363918 */ // Label 7242: @363918
     /* 363918 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(364219),
     /* 363923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363930 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(363994), // Rule ID 5980 //
     /* 363935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363946 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 363950 */     // MIs[1] Operand 1
     /* 363950 */     // No operand predicates
     /* 363950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363952 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 363952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 363959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 363983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363993 */     // GIR_Coverage, 5980,
     /* 363993 */     GIR_EraseRootFromParent_Done,
     /* 363994 */   // Label 7257: @363994
     /* 363994 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364051), // Rule ID 8295 //
     /* 363999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 364014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364035 */     // MIs[2] Operand 1
     /* 364035 */     // No operand predicates
     /* 364035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364037 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364049 */     GIR_RootConstrainSelectedInstOperands,
     /* 364050 */     // GIR_Coverage, 8295,
     /* 364050 */     GIR_EraseRootFromParent_Done,
     /* 364051 */   // Label 7258: @364051
     /* 364051 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364108), // Rule ID 8304 //
     /* 364056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 364071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364092 */     // MIs[2] Operand 1
     /* 364092 */     // No operand predicates
     /* 364092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364094 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364106 */     GIR_RootConstrainSelectedInstOperands,
     /* 364107 */     // GIR_Coverage, 8304,
     /* 364107 */     GIR_EraseRootFromParent_Done,
     /* 364108 */   // Label 7259: @364108
     /* 364108 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(364142), // Rule ID 8331 //
     /* 364113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364124 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 364128 */     // MIs[1] Operand 1
     /* 364128 */     // No operand predicates
     /* 364128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364130 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 364130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 364133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364135 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 364140 */     GIR_RootConstrainSelectedInstOperands,
     /* 364141 */     // GIR_Coverage, 8331,
     /* 364141 */     GIR_EraseRootFromParent_Done,
     /* 364142 */   // Label 7260: @364142
     /* 364142 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(364218), // Rule ID 8309 //
     /* 364147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364154 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 364190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364216 */     GIR_RootConstrainSelectedInstOperands,
     /* 364217 */     // GIR_Coverage, 8309,
     /* 364217 */     GIR_EraseRootFromParent_Done,
     /* 364218 */   // Label 7261: @364218
     /* 364218 */   GIM_Reject,
     /* 364219 */ // Label 7256: @364219
     /* 364219 */ GIM_Reject,
     /* 364220 */ // Label 7243: @364220
     /* 364220 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(364594),
     /* 364225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 364228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364232 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(364286), // Rule ID 5975 //
     /* 364237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 364244 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364285 */     // GIR_Coverage, 5975,
     /* 364285 */     GIR_EraseRootFromParent_Done,
     /* 364286 */   // Label 7263: @364286
     /* 364286 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(364350), // Rule ID 5979 //
     /* 364291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364302 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364306 */     // MIs[1] Operand 1
     /* 364306 */     // No operand predicates
     /* 364306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364308 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364349 */     // GIR_Coverage, 5979,
     /* 364349 */     GIR_EraseRootFromParent_Done,
     /* 364350 */   // Label 7264: @364350
     /* 364350 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(364407), // Rule ID 2672 //
     /* 364355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364391 */     // MIs[2] Operand 1
     /* 364391 */     // No operand predicates
     /* 364391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364393 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364405 */     GIR_RootConstrainSelectedInstOperands,
     /* 364406 */     // GIR_Coverage, 2672,
     /* 364406 */     GIR_EraseRootFromParent_Done,
     /* 364407 */   // Label 7265: @364407
     /* 364407 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(364464), // Rule ID 8301 //
     /* 364412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364448 */     // MIs[2] Operand 1
     /* 364448 */     // No operand predicates
     /* 364448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364450 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364462 */     GIR_RootConstrainSelectedInstOperands,
     /* 364463 */     // GIR_Coverage, 8301,
     /* 364463 */     GIR_EraseRootFromParent_Done,
     /* 364464 */   // Label 7266: @364464
     /* 364464 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(364498), // Rule ID 8332 //
     /* 364469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364480 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 364484 */     // MIs[1] Operand 1
     /* 364484 */     // No operand predicates
     /* 364484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364486 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 364486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 364489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364491 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 364496 */     GIR_RootConstrainSelectedInstOperands,
     /* 364497 */     // GIR_Coverage, 8332,
     /* 364497 */     GIR_EraseRootFromParent_Done,
     /* 364498 */   // Label 7267: @364498
     /* 364498 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(364517), // Rule ID 2391 //
     /* 364503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364510 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 364510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 364515 */     GIR_RootConstrainSelectedInstOperands,
     /* 364516 */     // GIR_Coverage, 2391,
     /* 364516 */     GIR_Done,
     /* 364517 */   // Label 7268: @364517
     /* 364517 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(364593), // Rule ID 8310 //
     /* 364522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364529 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364591 */     GIR_RootConstrainSelectedInstOperands,
     /* 364592 */     // GIR_Coverage, 8310,
     /* 364592 */     GIR_EraseRootFromParent_Done,
     /* 364593 */   // Label 7269: @364593
     /* 364593 */   GIM_Reject,
     /* 364594 */ // Label 7262: @364594
     /* 364594 */ GIM_Reject,
     /* 364595 */ // Label 7244: @364595
     /* 364595 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(364896),
     /* 364600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364607 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(364671), // Rule ID 5983 //
     /* 364612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364623 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364627 */     // MIs[1] Operand 1
     /* 364627 */     // No operand predicates
     /* 364627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364629 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364670 */     // GIR_Coverage, 5983,
     /* 364670 */     GIR_EraseRootFromParent_Done,
     /* 364671 */   // Label 7271: @364671
     /* 364671 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(364728), // Rule ID 2676 //
     /* 364676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364708 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364712 */     // MIs[2] Operand 1
     /* 364712 */     // No operand predicates
     /* 364712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364714 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364726 */     GIR_RootConstrainSelectedInstOperands,
     /* 364727 */     // GIR_Coverage, 2676,
     /* 364727 */     GIR_EraseRootFromParent_Done,
     /* 364728 */   // Label 7272: @364728
     /* 364728 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(364785), // Rule ID 8289 //
     /* 364733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364769 */     // MIs[2] Operand 1
     /* 364769 */     // No operand predicates
     /* 364769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364771 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 364771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364783 */     GIR_RootConstrainSelectedInstOperands,
     /* 364784 */     // GIR_Coverage, 8289,
     /* 364784 */     GIR_EraseRootFromParent_Done,
     /* 364785 */   // Label 7273: @364785
     /* 364785 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(364819), // Rule ID 8328 //
     /* 364790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364801 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 364805 */     // MIs[1] Operand 1
     /* 364805 */     // No operand predicates
     /* 364805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364807 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 364807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 364810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364812 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 364817 */     GIR_RootConstrainSelectedInstOperands,
     /* 364818 */     // GIR_Coverage, 8328,
     /* 364818 */     GIR_EraseRootFromParent_Done,
     /* 364819 */   // Label 7274: @364819
     /* 364819 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(364895), // Rule ID 8306 //
     /* 364824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364831 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 364867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364893 */     GIR_RootConstrainSelectedInstOperands,
     /* 364894 */     // GIR_Coverage, 8306,
     /* 364894 */     GIR_EraseRootFromParent_Done,
     /* 364895 */   // Label 7275: @364895
     /* 364895 */   GIM_Reject,
     /* 364896 */ // Label 7270: @364896
     /* 364896 */ GIM_Reject,
     /* 364897 */ // Label 7245: @364897
     /* 364897 */ GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(365271),
     /* 364902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364909 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(364963), // Rule ID 5976 //
     /* 364914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 364921 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364962 */     // GIR_Coverage, 5976,
     /* 364962 */     GIR_EraseRootFromParent_Done,
     /* 364963 */   // Label 7277: @364963
     /* 364963 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(365027), // Rule ID 5981 //
     /* 364968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364979 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364983 */     // MIs[1] Operand 1
     /* 364983 */     // No operand predicates
     /* 364983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364985 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365026 */     // GIR_Coverage, 5981,
     /* 365026 */     GIR_EraseRootFromParent_Done,
     /* 365027 */   // Label 7278: @365027
     /* 365027 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(365084), // Rule ID 2669 //
     /* 365032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365068 */     // MIs[2] Operand 1
     /* 365068 */     // No operand predicates
     /* 365068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365070 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365082 */     GIR_RootConstrainSelectedInstOperands,
     /* 365083 */     // GIR_Coverage, 2669,
     /* 365083 */     GIR_EraseRootFromParent_Done,
     /* 365084 */   // Label 7279: @365084
     /* 365084 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(365141), // Rule ID 8298 //
     /* 365089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365125 */     // MIs[2] Operand 1
     /* 365125 */     // No operand predicates
     /* 365125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365127 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365139 */     GIR_RootConstrainSelectedInstOperands,
     /* 365140 */     // GIR_Coverage, 8298,
     /* 365140 */     GIR_EraseRootFromParent_Done,
     /* 365141 */   // Label 7280: @365141
     /* 365141 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(365175), // Rule ID 8330 //
     /* 365146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365157 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 365161 */     // MIs[1] Operand 1
     /* 365161 */     // No operand predicates
     /* 365161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365163 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 365163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 365166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365168 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 365173 */     GIR_RootConstrainSelectedInstOperands,
     /* 365174 */     // GIR_Coverage, 8330,
     /* 365174 */     GIR_EraseRootFromParent_Done,
     /* 365175 */   // Label 7281: @365175
     /* 365175 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(365194), // Rule ID 2390 //
     /* 365180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 365187 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 365187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 365192 */     GIR_RootConstrainSelectedInstOperands,
     /* 365193 */     // GIR_Coverage, 2390,
     /* 365193 */     GIR_Done,
     /* 365194 */   // Label 7282: @365194
     /* 365194 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(365270), // Rule ID 8308 //
     /* 365199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365206 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 365242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365268 */     GIR_RootConstrainSelectedInstOperands,
     /* 365269 */     // GIR_Coverage, 8308,
     /* 365269 */     GIR_EraseRootFromParent_Done,
     /* 365270 */   // Label 7283: @365270
     /* 365270 */   GIM_Reject,
     /* 365271 */ // Label 7276: @365271
     /* 365271 */ GIM_Reject,
     /* 365272 */ // Label 7246: @365272
     /* 365272 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(365333), // Rule ID 5977 //
     /* 365277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365287 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365291 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365303 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365332 */   // GIR_Coverage, 5977,
     /* 365332 */   GIR_EraseRootFromParent_Done,
     /* 365333 */ // Label 7284: @365333
     /* 365333 */ GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(365404), // Rule ID 5984 //
     /* 365338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365356 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365360 */   // MIs[1] Operand 1
     /* 365360 */   // No operand predicates
     /* 365360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365362 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365374 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365403 */   // GIR_Coverage, 5984,
     /* 365403 */   GIR_EraseRootFromParent_Done,
     /* 365404 */ // Label 7285: @365404
     /* 365404 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(365468), // Rule ID 2666 //
     /* 365409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365427 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365431 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365435 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365440 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365444 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365448 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365452 */   // MIs[2] Operand 1
     /* 365452 */   // No operand predicates
     /* 365452 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365454 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365459 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365466 */   GIR_RootConstrainSelectedInstOperands,
     /* 365467 */   // GIR_Coverage, 2666,
     /* 365467 */   GIR_EraseRootFromParent_Done,
     /* 365468 */ // Label 7286: @365468
     /* 365468 */ GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(365532), // Rule ID 8292 //
     /* 365473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365499 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365504 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365508 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365512 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365516 */   // MIs[2] Operand 1
     /* 365516 */   // No operand predicates
     /* 365516 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365518 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365527 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365530 */   GIR_RootConstrainSelectedInstOperands,
     /* 365531 */   // GIR_Coverage, 8292,
     /* 365531 */   GIR_EraseRootFromParent_Done,
     /* 365532 */ // Label 7287: @365532
     /* 365532 */ GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(365573), // Rule ID 8327 //
     /* 365537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365555 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 365559 */   // MIs[1] Operand 1
     /* 365559 */   // No operand predicates
     /* 365559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365561 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 365561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 365564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365566 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 365571 */   GIR_RootConstrainSelectedInstOperands,
     /* 365572 */   // GIR_Coverage, 8327,
     /* 365572 */   GIR_EraseRootFromParent_Done,
     /* 365573 */ // Label 7288: @365573
     /* 365573 */ GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(365599), // Rule ID 2389 //
     /* 365578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 365592 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 365592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 365597 */   GIR_RootConstrainSelectedInstOperands,
     /* 365598 */   // GIR_Coverage, 2389,
     /* 365598 */   GIR_Done,
     /* 365599 */ // Label 7289: @365599
     /* 365599 */ GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(365682), // Rule ID 8305 //
     /* 365604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365618 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365618 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365621 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365625 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365644 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 365654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365680 */   GIR_RootConstrainSelectedInstOperands,
     /* 365681 */   // GIR_Coverage, 8305,
     /* 365681 */   GIR_EraseRootFromParent_Done,
     /* 365682 */ // Label 7290: @365682
     /* 365682 */ GIM_Reject,
     /* 365683 */ // Label 7247: @365683
     /* 365683 */ GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(365826),
     /* 365688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365695 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(365749), // Rule ID 5978 //
     /* 365700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365707 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365748 */     // GIR_Coverage, 5978,
     /* 365748 */     GIR_EraseRootFromParent_Done,
     /* 365749 */   // Label 7292: @365749
     /* 365749 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(365806), // Rule ID 2663 //
     /* 365754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 365769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365786 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 365790 */     // MIs[2] Operand 1
     /* 365790 */     // No operand predicates
     /* 365790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365792 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 365792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 365795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365804 */     GIR_RootConstrainSelectedInstOperands,
     /* 365805 */     // GIR_Coverage, 2663,
     /* 365805 */     GIR_EraseRootFromParent_Done,
     /* 365806 */   // Label 7293: @365806
     /* 365806 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(365825), // Rule ID 2388 //
     /* 365811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 365818 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 365818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 365823 */     GIR_RootConstrainSelectedInstOperands,
     /* 365824 */     // GIR_Coverage, 2388,
     /* 365824 */     GIR_Done,
     /* 365825 */   // Label 7294: @365825
     /* 365825 */   GIM_Reject,
     /* 365826 */ // Label 7291: @365826
     /* 365826 */ GIM_Reject,
     /* 365827 */ // Label 7248: @365827
     /* 365827 */ GIM_Reject,
     /* 365828 */ // Label 91: @365828
     /* 365828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7297*/ GIMT_Encode4(365979),
     /* 365839 */ /*GILLT_s32*//*Label 7295*/ GIMT_Encode4(365847),
     /* 365843 */ /*GILLT_s64*//*Label 7296*/ GIMT_Encode4(365913),
     /* 365847 */ // Label 7295: @365847
     /* 365847 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(365912),
     /* 365852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365863 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(365878), // Rule ID 2321 //
     /* 365868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 365871 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 365871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 365876 */     GIR_RootConstrainSelectedInstOperands,
     /* 365877 */     // GIR_Coverage, 2321,
     /* 365877 */     GIR_Done,
     /* 365878 */   // Label 7299: @365878
     /* 365878 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(365911), // Rule ID 3997 //
     /* 365883 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 365883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 365890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 365904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365909 */     GIR_RootConstrainSelectedInstOperands,
     /* 365910 */     // GIR_Coverage, 3997,
     /* 365910 */     GIR_EraseRootFromParent_Done,
     /* 365911 */   // Label 7300: @365911
     /* 365911 */   GIM_Reject,
     /* 365912 */ // Label 7298: @365912
     /* 365912 */ GIM_Reject,
     /* 365913 */ // Label 7296: @365913
     /* 365913 */ GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(365978),
     /* 365918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 365921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365929 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(365944), // Rule ID 2322 //
     /* 365934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 365937 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 365937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 365942 */     GIR_RootConstrainSelectedInstOperands,
     /* 365943 */     // GIR_Coverage, 2322,
     /* 365943 */     GIR_Done,
     /* 365944 */   // Label 7302: @365944
     /* 365944 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(365977), // Rule ID 3998 //
     /* 365949 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 365949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 365952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 365956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 365970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365975 */     GIR_RootConstrainSelectedInstOperands,
     /* 365976 */     // GIR_Coverage, 3998,
     /* 365976 */     GIR_EraseRootFromParent_Done,
     /* 365977 */   // Label 7303: @365977
     /* 365977 */   GIM_Reject,
     /* 365978 */ // Label 7301: @365978
     /* 365978 */ GIM_Reject,
     /* 365979 */ // Label 7297: @365979
     /* 365979 */ GIM_Reject,
     /* 365980 */ // Label 92: @365980
     /* 365980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7312*/ GIMT_Encode4(366653),
     /* 365991 */ /*GILLT_s32*//*Label 7304*/ GIMT_Encode4(366031),
     /* 365995 */ /*GILLT_s64*//*Label 7305*/ GIMT_Encode4(366261), GIMT_Encode4(0),
     /* 366003 */ /*GILLT_v2s32*//*Label 7306*/ GIMT_Encode4(366491), GIMT_Encode4(0),
     /* 366011 */ /*GILLT_v4s16*//*Label 7307*/ GIMT_Encode4(366518),
     /* 366015 */ /*GILLT_v4s32*//*Label 7308*/ GIMT_Encode4(366545),
     /* 366019 */ /*GILLT_v8s8*//*Label 7309*/ GIMT_Encode4(366572),
     /* 366023 */ /*GILLT_v8s16*//*Label 7310*/ GIMT_Encode4(366599),
     /* 366027 */ /*GILLT_v16s8*//*Label 7311*/ GIMT_Encode4(366626),
     /* 366031 */ // Label 7304: @366031
     /* 366031 */ GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(366260),
     /* 366036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366043 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(366143), // Rule ID 3999 //
     /* 366048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 366092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 366096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366100 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 366104 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366108 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366113 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 366117 */     // MIs[3] Rn
     /* 366117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 366122 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366132 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 366135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 366141 */     GIR_RootConstrainSelectedInstOperands,
     /* 366142 */     // GIR_Coverage, 3999,
     /* 366142 */     GIR_EraseRootFromParent_Done,
     /* 366143 */   // Label 7314: @366143
     /* 366143 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(366243), // Rule ID 13724 //
     /* 366148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 366192 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 366196 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 366205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366213 */     // MIs[4] Rn
     /* 366213 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 366218 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 366222 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366230 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366232 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 366235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366241 */     GIR_RootConstrainSelectedInstOperands,
     /* 366242 */     // GIR_Coverage, 13724,
     /* 366242 */     GIR_EraseRootFromParent_Done,
     /* 366243 */   // Label 7315: @366243
     /* 366243 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(366259), // Rule ID 180 //
     /* 366248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366252 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 366257 */     GIR_RootConstrainSelectedInstOperands,
     /* 366258 */     // GIR_Coverage, 180,
     /* 366258 */     GIR_Done,
     /* 366259 */   // Label 7316: @366259
     /* 366259 */   GIM_Reject,
     /* 366260 */ // Label 7313: @366260
     /* 366260 */ GIM_Reject,
     /* 366261 */ // Label 7305: @366261
     /* 366261 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(366490),
     /* 366266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366273 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(366373), // Rule ID 4000 //
     /* 366278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 366290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 366306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 366322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 366326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366330 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 366334 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366338 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366343 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 366347 */     // MIs[3] Rn
     /* 366347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 366352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366356 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366362 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 366365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 366371 */     GIR_RootConstrainSelectedInstOperands,
     /* 366372 */     // GIR_Coverage, 4000,
     /* 366372 */     GIR_EraseRootFromParent_Done,
     /* 366373 */   // Label 7318: @366373
     /* 366373 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(366473), // Rule ID 13725 //
     /* 366378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 366390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 366406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366418 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 366422 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 366426 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366431 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 366435 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366439 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366443 */     // MIs[4] Rn
     /* 366443 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 366448 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 366452 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366456 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366460 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366462 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 366465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366471 */     GIR_RootConstrainSelectedInstOperands,
     /* 366472 */     // GIR_Coverage, 13725,
     /* 366472 */     GIR_EraseRootFromParent_Done,
     /* 366473 */   // Label 7319: @366473
     /* 366473 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(366489), // Rule ID 181 //
     /* 366478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366482 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 366487 */     GIR_RootConstrainSelectedInstOperands,
     /* 366488 */     // GIR_Coverage, 181,
     /* 366488 */     GIR_Done,
     /* 366489 */   // Label 7320: @366489
     /* 366489 */   GIM_Reject,
     /* 366490 */ // Label 7317: @366490
     /* 366490 */ GIM_Reject,
     /* 366491 */ // Label 7306: @366491
     /* 366491 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(366517), // Rule ID 720 //
     /* 366496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366510 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 366510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 366515 */   GIR_RootConstrainSelectedInstOperands,
     /* 366516 */   // GIR_Coverage, 720,
     /* 366516 */   GIR_Done,
     /* 366517 */ // Label 7321: @366517
     /* 366517 */ GIM_Reject,
     /* 366518 */ // Label 7307: @366518
     /* 366518 */ GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(366544), // Rule ID 718 //
     /* 366523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 366529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366537 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 366537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 366542 */   GIR_RootConstrainSelectedInstOperands,
     /* 366543 */   // GIR_Coverage, 718,
     /* 366543 */   GIR_Done,
     /* 366544 */ // Label 7322: @366544
     /* 366544 */ GIM_Reject,
     /* 366545 */ // Label 7308: @366545
     /* 366545 */ GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(366571), // Rule ID 721 //
     /* 366550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366564 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 366564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 366569 */   GIR_RootConstrainSelectedInstOperands,
     /* 366570 */   // GIR_Coverage, 721,
     /* 366570 */   GIR_Done,
     /* 366571 */ // Label 7323: @366571
     /* 366571 */ GIM_Reject,
     /* 366572 */ // Label 7309: @366572
     /* 366572 */ GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(366598), // Rule ID 716 //
     /* 366577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 366583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366591 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 366591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 366596 */   GIR_RootConstrainSelectedInstOperands,
     /* 366597 */   // GIR_Coverage, 716,
     /* 366597 */   GIR_Done,
     /* 366598 */ // Label 7324: @366598
     /* 366598 */ GIM_Reject,
     /* 366599 */ // Label 7310: @366599
     /* 366599 */ GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(366625), // Rule ID 719 //
     /* 366604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366618 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 366618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 366623 */   GIR_RootConstrainSelectedInstOperands,
     /* 366624 */   // GIR_Coverage, 719,
     /* 366624 */   GIR_Done,
     /* 366625 */ // Label 7325: @366625
     /* 366625 */ GIM_Reject,
     /* 366626 */ // Label 7311: @366626
     /* 366626 */ GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(366652), // Rule ID 717 //
     /* 366631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 366637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366645 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 366645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 366650 */   GIR_RootConstrainSelectedInstOperands,
     /* 366651 */   // GIR_Coverage, 717,
     /* 366651 */   GIR_Done,
     /* 366652 */ // Label 7326: @366652
     /* 366652 */ GIM_Reject,
     /* 366653 */ // Label 7312: @366653
     /* 366653 */ GIM_Reject,
     /* 366654 */ // Label 93: @366654
     /* 366654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7331*/ GIMT_Encode4(366813),
     /* 366665 */ /*GILLT_s32*//*Label 7327*/ GIMT_Encode4(366705),
     /* 366669 */ /*GILLT_s64*//*Label 7328*/ GIMT_Encode4(366732), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 366693 */ /*GILLT_v8s8*//*Label 7329*/ GIMT_Encode4(366759), GIMT_Encode4(0),
     /* 366701 */ /*GILLT_v16s8*//*Label 7330*/ GIMT_Encode4(366786),
     /* 366705 */ // Label 7327: @366705
     /* 366705 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(366731), // Rule ID 2319 //
     /* 366710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366724 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 366729 */   GIR_RootConstrainSelectedInstOperands,
     /* 366730 */   // GIR_Coverage, 2319,
     /* 366730 */   GIR_Done,
     /* 366731 */ // Label 7332: @366731
     /* 366731 */ GIM_Reject,
     /* 366732 */ // Label 7328: @366732
     /* 366732 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(366758), // Rule ID 2320 //
     /* 366737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366751 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 366756 */   GIR_RootConstrainSelectedInstOperands,
     /* 366757 */   // GIR_Coverage, 2320,
     /* 366757 */   GIR_Done,
     /* 366758 */ // Label 7333: @366758
     /* 366758 */ GIM_Reject,
     /* 366759 */ // Label 7329: @366759
     /* 366759 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(366785), // Rule ID 764 //
     /* 366764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 366770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366778 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 366778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 366783 */   GIR_RootConstrainSelectedInstOperands,
     /* 366784 */   // GIR_Coverage, 764,
     /* 366784 */   GIR_Done,
     /* 366785 */ // Label 7334: @366785
     /* 366785 */ GIM_Reject,
     /* 366786 */ // Label 7330: @366786
     /* 366786 */ GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(366812), // Rule ID 765 //
     /* 366791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 366797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366805 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 366805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 366810 */   GIR_RootConstrainSelectedInstOperands,
     /* 366811 */   // GIR_Coverage, 765,
     /* 366811 */   GIR_Done,
     /* 366812 */ // Label 7335: @366812
     /* 366812 */ GIM_Reject,
     /* 366813 */ // Label 7331: @366813
     /* 366813 */ GIM_Reject,
     /* 366814 */ // Label 94: @366814
     /* 366814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7343*/ GIMT_Encode4(367127),
     /* 366825 */ /*GILLT_s32*//*Label 7336*/ GIMT_Encode4(366861),
     /* 366829 */ /*GILLT_s64*//*Label 7337*/ GIMT_Encode4(366934), GIMT_Encode4(0),
     /* 366837 */ /*GILLT_v2s32*//*Label 7338*/ GIMT_Encode4(367007),
     /* 366841 */ /*GILLT_v2s64*//*Label 7339*/ GIMT_Encode4(367031),
     /* 366845 */ /*GILLT_v4s16*//*Label 7340*/ GIMT_Encode4(367055),
     /* 366849 */ /*GILLT_v4s32*//*Label 7341*/ GIMT_Encode4(367079), GIMT_Encode4(0),
     /* 366857 */ /*GILLT_v8s16*//*Label 7342*/ GIMT_Encode4(367103),
     /* 366861 */ // Label 7336: @366861
     /* 366861 */ GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(366933),
     /* 366866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366873 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(366916), // Rule ID 4003 //
     /* 366878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 366886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 366903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366905 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 366908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366914 */     GIR_RootConstrainSelectedInstOperands,
     /* 366915 */     // GIR_Coverage, 4003,
     /* 366915 */     GIR_EraseRootFromParent_Done,
     /* 366916 */   // Label 7345: @366916
     /* 366916 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(366932), // Rule ID 185 //
     /* 366921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366925 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 366930 */     GIR_RootConstrainSelectedInstOperands,
     /* 366931 */     // GIR_Coverage, 185,
     /* 366931 */     GIR_Done,
     /* 366932 */   // Label 7346: @366932
     /* 366932 */   GIM_Reject,
     /* 366933 */ // Label 7344: @366933
     /* 366933 */ GIM_Reject,
     /* 366934 */ // Label 7337: @366934
     /* 366934 */ GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(367006),
     /* 366939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366946 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(366989), // Rule ID 4004 //
     /* 366951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 366959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 366963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 366976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366978 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 366981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366987 */     GIR_RootConstrainSelectedInstOperands,
     /* 366988 */     // GIR_Coverage, 4004,
     /* 366988 */     GIR_EraseRootFromParent_Done,
     /* 366989 */   // Label 7348: @366989
     /* 366989 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(367005), // Rule ID 186 //
     /* 366994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366998 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 367003 */     GIR_RootConstrainSelectedInstOperands,
     /* 367004 */     // GIR_Coverage, 186,
     /* 367004 */     GIR_Done,
     /* 367005 */   // Label 7349: @367005
     /* 367005 */   GIM_Reject,
     /* 367006 */ // Label 7347: @367006
     /* 367006 */ GIM_Reject,
     /* 367007 */ // Label 7338: @367007
     /* 367007 */ GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(367030), // Rule ID 4978 //
     /* 367012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367023 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 367023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 367028 */   GIR_RootConstrainSelectedInstOperands,
     /* 367029 */   // GIR_Coverage, 4978,
     /* 367029 */   GIR_Done,
     /* 367030 */ // Label 7350: @367030
     /* 367030 */ GIM_Reject,
     /* 367031 */ // Label 7339: @367031
     /* 367031 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(367054), // Rule ID 4980 //
     /* 367036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367047 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 367047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 367052 */   GIR_RootConstrainSelectedInstOperands,
     /* 367053 */   // GIR_Coverage, 4980,
     /* 367053 */   GIR_Done,
     /* 367054 */ // Label 7351: @367054
     /* 367054 */ GIM_Reject,
     /* 367055 */ // Label 7340: @367055
     /* 367055 */ GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(367078), // Rule ID 4976 //
     /* 367060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367071 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 367071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 367076 */   GIR_RootConstrainSelectedInstOperands,
     /* 367077 */   // GIR_Coverage, 4976,
     /* 367077 */   GIR_Done,
     /* 367078 */ // Label 7352: @367078
     /* 367078 */ GIM_Reject,
     /* 367079 */ // Label 7341: @367079
     /* 367079 */ GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(367102), // Rule ID 4979 //
     /* 367084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367095 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 367095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 367100 */   GIR_RootConstrainSelectedInstOperands,
     /* 367101 */   // GIR_Coverage, 4979,
     /* 367101 */   GIR_Done,
     /* 367102 */ // Label 7353: @367102
     /* 367102 */ GIM_Reject,
     /* 367103 */ // Label 7342: @367103
     /* 367103 */ GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(367126), // Rule ID 4977 //
     /* 367108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367119 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 367119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 367124 */   GIR_RootConstrainSelectedInstOperands,
     /* 367125 */   // GIR_Coverage, 4977,
     /* 367125 */   GIR_Done,
     /* 367126 */ // Label 7354: @367126
     /* 367126 */ GIM_Reject,
     /* 367127 */ // Label 7343: @367127
     /* 367127 */ GIM_Reject,
     /* 367128 */ // Label 95: @367128
     /* 367128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7359*/ GIMT_Encode4(367281),
     /* 367139 */ /*GILLT_s32*//*Label 7355*/ GIMT_Encode4(367179),
     /* 367143 */ /*GILLT_s64*//*Label 7356*/ GIMT_Encode4(367203), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 367167 */ /*GILLT_v8s8*//*Label 7357*/ GIMT_Encode4(367227), GIMT_Encode4(0),
     /* 367175 */ /*GILLT_v16s8*//*Label 7358*/ GIMT_Encode4(367254),
     /* 367179 */ // Label 7355: @367179
     /* 367179 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(367202), // Rule ID 182 //
     /* 367184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367195 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 367200 */   GIR_RootConstrainSelectedInstOperands,
     /* 367201 */   // GIR_Coverage, 182,
     /* 367201 */   GIR_Done,
     /* 367202 */ // Label 7360: @367202
     /* 367202 */ GIM_Reject,
     /* 367203 */ // Label 7356: @367203
     /* 367203 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(367226), // Rule ID 183 //
     /* 367208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367219 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 367224 */   GIR_RootConstrainSelectedInstOperands,
     /* 367225 */   // GIR_Coverage, 183,
     /* 367225 */   GIR_Done,
     /* 367226 */ // Label 7361: @367226
     /* 367226 */ GIM_Reject,
     /* 367227 */ // Label 7357: @367227
     /* 367227 */ GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(367253), // Rule ID 974 //
     /* 367232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367246 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 367251 */   GIR_RootConstrainSelectedInstOperands,
     /* 367252 */   // GIR_Coverage, 974,
     /* 367252 */   GIR_Done,
     /* 367253 */ // Label 7362: @367253
     /* 367253 */ GIM_Reject,
     /* 367254 */ // Label 7358: @367254
     /* 367254 */ GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(367280), // Rule ID 975 //
     /* 367259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367273 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 367278 */   GIR_RootConstrainSelectedInstOperands,
     /* 367279 */   // GIR_Coverage, 975,
     /* 367279 */   GIR_Done,
     /* 367280 */ // Label 7363: @367280
     /* 367280 */ GIM_Reject,
     /* 367281 */ // Label 7359: @367281
     /* 367281 */ GIM_Reject,
     /* 367282 */ // Label 96: @367282
     /* 367282 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7372*/ GIMT_Encode4(367772),
     /* 367293 */ /*GILLT_s16*//*Label 7364*/ GIMT_Encode4(367333),
     /* 367297 */ /*GILLT_s32*//*Label 7365*/ GIMT_Encode4(367364),
     /* 367301 */ /*GILLT_s64*//*Label 7366*/ GIMT_Encode4(367395), GIMT_Encode4(0),
     /* 367309 */ /*GILLT_v2s32*//*Label 7367*/ GIMT_Encode4(367426),
     /* 367313 */ /*GILLT_v2s64*//*Label 7368*/ GIMT_Encode4(367457),
     /* 367317 */ /*GILLT_v4s16*//*Label 7369*/ GIMT_Encode4(367488),
     /* 367321 */ /*GILLT_v4s32*//*Label 7370*/ GIMT_Encode4(367519), GIMT_Encode4(0),
     /* 367329 */ /*GILLT_v8s16*//*Label 7371*/ GIMT_Encode4(367550),
     /* 367333 */ // Label 7364: @367333
     /* 367333 */ GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(367363), // Rule ID 552 //
     /* 367338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367352 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 367352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 367357 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367361 */   GIR_RootConstrainSelectedInstOperands,
     /* 367362 */   // GIR_Coverage, 552,
     /* 367362 */   GIR_Done,
     /* 367363 */ // Label 7373: @367363
     /* 367363 */ GIM_Reject,
     /* 367364 */ // Label 7365: @367364
     /* 367364 */ GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(367394), // Rule ID 554 //
     /* 367369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367383 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 367383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 367388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367392 */   GIR_RootConstrainSelectedInstOperands,
     /* 367393 */   // GIR_Coverage, 554,
     /* 367393 */   GIR_Done,
     /* 367394 */ // Label 7374: @367394
     /* 367394 */ GIM_Reject,
     /* 367395 */ // Label 7366: @367395
     /* 367395 */ GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(367425), // Rule ID 556 //
     /* 367400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367414 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 367414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 367419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367423 */   GIR_RootConstrainSelectedInstOperands,
     /* 367424 */   // GIR_Coverage, 556,
     /* 367424 */   GIR_Done,
     /* 367425 */ // Label 7375: @367425
     /* 367425 */ GIM_Reject,
     /* 367426 */ // Label 7367: @367426
     /* 367426 */ GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(367456), // Rule ID 913 //
     /* 367431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367445 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 367445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 367450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367454 */   GIR_RootConstrainSelectedInstOperands,
     /* 367455 */   // GIR_Coverage, 913,
     /* 367455 */   GIR_Done,
     /* 367456 */ // Label 7376: @367456
     /* 367456 */ GIM_Reject,
     /* 367457 */ // Label 7368: @367457
     /* 367457 */ GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(367487), // Rule ID 917 //
     /* 367462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367476 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 367476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 367481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367485 */   GIR_RootConstrainSelectedInstOperands,
     /* 367486 */   // GIR_Coverage, 917,
     /* 367486 */   GIR_Done,
     /* 367487 */ // Label 7377: @367487
     /* 367487 */ GIM_Reject,
     /* 367488 */ // Label 7369: @367488
     /* 367488 */ GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(367518), // Rule ID 909 //
     /* 367493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367507 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 367507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 367512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367516 */   GIR_RootConstrainSelectedInstOperands,
     /* 367517 */   // GIR_Coverage, 909,
     /* 367517 */   GIR_Done,
     /* 367518 */ // Label 7378: @367518
     /* 367518 */ GIM_Reject,
     /* 367519 */ // Label 7370: @367519
     /* 367519 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(367549), // Rule ID 915 //
     /* 367524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367538 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 367538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367547 */   GIR_RootConstrainSelectedInstOperands,
     /* 367548 */   // GIR_Coverage, 915,
     /* 367548 */   GIR_Done,
     /* 367549 */ // Label 7379: @367549
     /* 367549 */ GIM_Reject,
     /* 367550 */ // Label 7371: @367550
     /* 367550 */ GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(367771),
     /* 367555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367566 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(367585), // Rule ID 911 //
     /* 367571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367574 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 367574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 367579 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367583 */     GIR_RootConstrainSelectedInstOperands,
     /* 367584 */     // GIR_Coverage, 911,
     /* 367584 */     GIR_Done,
     /* 367585 */   // Label 7381: @367585
     /* 367585 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(367770), // Rule ID 6959 //
     /* 367590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 367593 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 367593 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 367596 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 367600 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367605 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 367609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 367611 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 367614 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367618 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367623 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 367626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 367628 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 367631 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367635 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367640 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 367646 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367651 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367656 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 367659 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 367663 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367668 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 367671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 367673 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 367676 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367680 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367685 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 367688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 367690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 367693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 367697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367702 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 367705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 367707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 367739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 367760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 367768 */     GIR_RootConstrainSelectedInstOperands,
     /* 367769 */     // GIR_Coverage, 6959,
     /* 367769 */     GIR_EraseRootFromParent_Done,
     /* 367770 */   // Label 7382: @367770
     /* 367770 */   GIM_Reject,
     /* 367771 */ // Label 7380: @367771
     /* 367771 */ GIM_Reject,
     /* 367772 */ // Label 7372: @367772
     /* 367772 */ GIM_Reject,
     /* 367773 */ // Label 97: @367773
     /* 367773 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7391*/ GIMT_Encode4(368072),
     /* 367784 */ /*GILLT_s16*//*Label 7383*/ GIMT_Encode4(367824),
     /* 367788 */ /*GILLT_s32*//*Label 7384*/ GIMT_Encode4(367855),
     /* 367792 */ /*GILLT_s64*//*Label 7385*/ GIMT_Encode4(367886), GIMT_Encode4(0),
     /* 367800 */ /*GILLT_v2s32*//*Label 7386*/ GIMT_Encode4(367917),
     /* 367804 */ /*GILLT_v2s64*//*Label 7387*/ GIMT_Encode4(367948),
     /* 367808 */ /*GILLT_v4s16*//*Label 7388*/ GIMT_Encode4(367979),
     /* 367812 */ /*GILLT_v4s32*//*Label 7389*/ GIMT_Encode4(368010), GIMT_Encode4(0),
     /* 367820 */ /*GILLT_v8s16*//*Label 7390*/ GIMT_Encode4(368041),
     /* 367824 */ // Label 7383: @367824
     /* 367824 */ GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(367854), // Rule ID 570 //
     /* 367829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367843 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 367843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 367848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367852 */   GIR_RootConstrainSelectedInstOperands,
     /* 367853 */   // GIR_Coverage, 570,
     /* 367853 */   GIR_Done,
     /* 367854 */ // Label 7392: @367854
     /* 367854 */ GIM_Reject,
     /* 367855 */ // Label 7384: @367855
     /* 367855 */ GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(367885), // Rule ID 572 //
     /* 367860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367874 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 367874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 367879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367883 */   GIR_RootConstrainSelectedInstOperands,
     /* 367884 */   // GIR_Coverage, 572,
     /* 367884 */   GIR_Done,
     /* 367885 */ // Label 7393: @367885
     /* 367885 */ GIM_Reject,
     /* 367886 */ // Label 7385: @367886
     /* 367886 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(367916), // Rule ID 574 //
     /* 367891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367905 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 367905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 367910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367914 */   GIR_RootConstrainSelectedInstOperands,
     /* 367915 */   // GIR_Coverage, 574,
     /* 367915 */   GIR_Done,
     /* 367916 */ // Label 7394: @367916
     /* 367916 */ GIM_Reject,
     /* 367917 */ // Label 7386: @367917
     /* 367917 */ GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(367947), // Rule ID 960 //
     /* 367922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367936 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 367936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 367941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367945 */   GIR_RootConstrainSelectedInstOperands,
     /* 367946 */   // GIR_Coverage, 960,
     /* 367946 */   GIR_Done,
     /* 367947 */ // Label 7395: @367947
     /* 367947 */ GIM_Reject,
     /* 367948 */ // Label 7387: @367948
     /* 367948 */ GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(367978), // Rule ID 964 //
     /* 367953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367967 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 367967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 367972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367976 */   GIR_RootConstrainSelectedInstOperands,
     /* 367977 */   // GIR_Coverage, 964,
     /* 367977 */   GIR_Done,
     /* 367978 */ // Label 7396: @367978
     /* 367978 */ GIM_Reject,
     /* 367979 */ // Label 7388: @367979
     /* 367979 */ GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(368009), // Rule ID 956 //
     /* 367984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367998 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 367998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 368003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368007 */   GIR_RootConstrainSelectedInstOperands,
     /* 368008 */   // GIR_Coverage, 956,
     /* 368008 */   GIR_Done,
     /* 368009 */ // Label 7397: @368009
     /* 368009 */ GIM_Reject,
     /* 368010 */ // Label 7389: @368010
     /* 368010 */ GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(368040), // Rule ID 962 //
     /* 368015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368029 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 368034 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368038 */   GIR_RootConstrainSelectedInstOperands,
     /* 368039 */   // GIR_Coverage, 962,
     /* 368039 */   GIR_Done,
     /* 368040 */ // Label 7398: @368040
     /* 368040 */ GIM_Reject,
     /* 368041 */ // Label 7390: @368041
     /* 368041 */ GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(368071), // Rule ID 958 //
     /* 368046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368060 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 368065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368069 */   GIR_RootConstrainSelectedInstOperands,
     /* 368070 */   // GIR_Coverage, 958,
     /* 368070 */   GIR_Done,
     /* 368071 */ // Label 7399: @368071
     /* 368071 */ GIM_Reject,
     /* 368072 */ // Label 7391: @368072
     /* 368072 */ GIM_Reject,
     /* 368073 */ // Label 98: @368073
     /* 368073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7408*/ GIMT_Encode4(368563),
     /* 368084 */ /*GILLT_s16*//*Label 7400*/ GIMT_Encode4(368124),
     /* 368088 */ /*GILLT_s32*//*Label 7401*/ GIMT_Encode4(368155),
     /* 368092 */ /*GILLT_s64*//*Label 7402*/ GIMT_Encode4(368186), GIMT_Encode4(0),
     /* 368100 */ /*GILLT_v2s32*//*Label 7403*/ GIMT_Encode4(368217),
     /* 368104 */ /*GILLT_v2s64*//*Label 7404*/ GIMT_Encode4(368248),
     /* 368108 */ /*GILLT_v4s16*//*Label 7405*/ GIMT_Encode4(368279),
     /* 368112 */ /*GILLT_v4s32*//*Label 7406*/ GIMT_Encode4(368310), GIMT_Encode4(0),
     /* 368120 */ /*GILLT_v8s16*//*Label 7407*/ GIMT_Encode4(368341),
     /* 368124 */ // Label 7400: @368124
     /* 368124 */ GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(368154), // Rule ID 540 //
     /* 368129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368143 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 368148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368152 */   GIR_RootConstrainSelectedInstOperands,
     /* 368153 */   // GIR_Coverage, 540,
     /* 368153 */   GIR_Done,
     /* 368154 */ // Label 7409: @368154
     /* 368154 */ GIM_Reject,
     /* 368155 */ // Label 7401: @368155
     /* 368155 */ GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(368185), // Rule ID 542 //
     /* 368160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368174 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 368179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368183 */   GIR_RootConstrainSelectedInstOperands,
     /* 368184 */   // GIR_Coverage, 542,
     /* 368184 */   GIR_Done,
     /* 368185 */ // Label 7410: @368185
     /* 368185 */ GIM_Reject,
     /* 368186 */ // Label 7402: @368186
     /* 368186 */ GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(368216), // Rule ID 544 //
     /* 368191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368205 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 368210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368214 */   GIR_RootConstrainSelectedInstOperands,
     /* 368215 */   // GIR_Coverage, 544,
     /* 368215 */   GIR_Done,
     /* 368216 */ // Label 7411: @368216
     /* 368216 */ GIM_Reject,
     /* 368217 */ // Label 7403: @368217
     /* 368217 */ GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(368247), // Rule ID 893 //
     /* 368222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368236 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 368241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368245 */   GIR_RootConstrainSelectedInstOperands,
     /* 368246 */   // GIR_Coverage, 893,
     /* 368246 */   GIR_Done,
     /* 368247 */ // Label 7412: @368247
     /* 368247 */ GIM_Reject,
     /* 368248 */ // Label 7404: @368248
     /* 368248 */ GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(368278), // Rule ID 897 //
     /* 368253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368267 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 368272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368276 */   GIR_RootConstrainSelectedInstOperands,
     /* 368277 */   // GIR_Coverage, 897,
     /* 368277 */   GIR_Done,
     /* 368278 */ // Label 7413: @368278
     /* 368278 */ GIM_Reject,
     /* 368279 */ // Label 7405: @368279
     /* 368279 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(368309), // Rule ID 889 //
     /* 368284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368298 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 368303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368307 */   GIR_RootConstrainSelectedInstOperands,
     /* 368308 */   // GIR_Coverage, 889,
     /* 368308 */   GIR_Done,
     /* 368309 */ // Label 7414: @368309
     /* 368309 */ GIM_Reject,
     /* 368310 */ // Label 7406: @368310
     /* 368310 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(368340), // Rule ID 895 //
     /* 368315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368329 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368338 */   GIR_RootConstrainSelectedInstOperands,
     /* 368339 */   // GIR_Coverage, 895,
     /* 368339 */   GIR_Done,
     /* 368340 */ // Label 7415: @368340
     /* 368340 */ GIM_Reject,
     /* 368341 */ // Label 7407: @368341
     /* 368341 */ GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(368562),
     /* 368346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368357 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(368376), // Rule ID 891 //
     /* 368362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368365 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 368370 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368374 */     GIR_RootConstrainSelectedInstOperands,
     /* 368375 */     // GIR_Coverage, 891,
     /* 368375 */     GIR_Done,
     /* 368376 */   // Label 7417: @368376
     /* 368376 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(368561), // Rule ID 6961 //
     /* 368381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 368384 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 368384 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 368387 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 368391 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368396 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 368400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 368402 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 368405 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368409 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368414 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 368417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 368419 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 368422 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368426 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368431 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368437 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368442 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368447 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 368450 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 368454 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368459 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 368462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 368464 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 368467 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368471 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368476 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368481 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368484 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368488 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368493 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 368496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 368498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 368551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 368559 */     GIR_RootConstrainSelectedInstOperands,
     /* 368560 */     // GIR_Coverage, 6961,
     /* 368560 */     GIR_EraseRootFromParent_Done,
     /* 368561 */   // Label 7418: @368561
     /* 368561 */   GIM_Reject,
     /* 368562 */ // Label 7416: @368562
     /* 368562 */ GIM_Reject,
     /* 368563 */ // Label 7408: @368563
     /* 368563 */ GIM_Reject,
     /* 368564 */ // Label 99: @368564
     /* 368564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7427*/ GIMT_Encode4(369054),
     /* 368575 */ /*GILLT_s16*//*Label 7419*/ GIMT_Encode4(368615),
     /* 368579 */ /*GILLT_s32*//*Label 7420*/ GIMT_Encode4(368646),
     /* 368583 */ /*GILLT_s64*//*Label 7421*/ GIMT_Encode4(368677), GIMT_Encode4(0),
     /* 368591 */ /*GILLT_v2s32*//*Label 7422*/ GIMT_Encode4(368708),
     /* 368595 */ /*GILLT_v2s64*//*Label 7423*/ GIMT_Encode4(368739),
     /* 368599 */ /*GILLT_v4s16*//*Label 7424*/ GIMT_Encode4(368770),
     /* 368603 */ /*GILLT_v4s32*//*Label 7425*/ GIMT_Encode4(368801), GIMT_Encode4(0),
     /* 368611 */ /*GILLT_v8s16*//*Label 7426*/ GIMT_Encode4(368832),
     /* 368615 */ // Label 7419: @368615
     /* 368615 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(368645), // Rule ID 558 //
     /* 368620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368634 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 368639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368643 */   GIR_RootConstrainSelectedInstOperands,
     /* 368644 */   // GIR_Coverage, 558,
     /* 368644 */   GIR_Done,
     /* 368645 */ // Label 7428: @368645
     /* 368645 */ GIM_Reject,
     /* 368646 */ // Label 7420: @368646
     /* 368646 */ GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(368676), // Rule ID 560 //
     /* 368651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368665 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 368670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368674 */   GIR_RootConstrainSelectedInstOperands,
     /* 368675 */   // GIR_Coverage, 560,
     /* 368675 */   GIR_Done,
     /* 368676 */ // Label 7429: @368676
     /* 368676 */ GIM_Reject,
     /* 368677 */ // Label 7421: @368677
     /* 368677 */ GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(368707), // Rule ID 562 //
     /* 368682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368696 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 368701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368705 */   GIR_RootConstrainSelectedInstOperands,
     /* 368706 */   // GIR_Coverage, 562,
     /* 368706 */   GIR_Done,
     /* 368707 */ // Label 7430: @368707
     /* 368707 */ GIM_Reject,
     /* 368708 */ // Label 7422: @368708
     /* 368708 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(368738), // Rule ID 923 //
     /* 368713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368727 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 368732 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368736 */   GIR_RootConstrainSelectedInstOperands,
     /* 368737 */   // GIR_Coverage, 923,
     /* 368737 */   GIR_Done,
     /* 368738 */ // Label 7431: @368738
     /* 368738 */ GIM_Reject,
     /* 368739 */ // Label 7423: @368739
     /* 368739 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(368769), // Rule ID 927 //
     /* 368744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368758 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 368763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368767 */   GIR_RootConstrainSelectedInstOperands,
     /* 368768 */   // GIR_Coverage, 927,
     /* 368768 */   GIR_Done,
     /* 368769 */ // Label 7432: @368769
     /* 368769 */ GIM_Reject,
     /* 368770 */ // Label 7424: @368770
     /* 368770 */ GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(368800), // Rule ID 919 //
     /* 368775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368789 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 368794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368798 */   GIR_RootConstrainSelectedInstOperands,
     /* 368799 */   // GIR_Coverage, 919,
     /* 368799 */   GIR_Done,
     /* 368800 */ // Label 7433: @368800
     /* 368800 */ GIM_Reject,
     /* 368801 */ // Label 7425: @368801
     /* 368801 */ GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(368831), // Rule ID 925 //
     /* 368806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368820 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 368825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368829 */   GIR_RootConstrainSelectedInstOperands,
     /* 368830 */   // GIR_Coverage, 925,
     /* 368830 */   GIR_Done,
     /* 368831 */ // Label 7434: @368831
     /* 368831 */ GIM_Reject,
     /* 368832 */ // Label 7426: @368832
     /* 368832 */ GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(369053),
     /* 368837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368848 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(368867), // Rule ID 921 //
     /* 368853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368856 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 368861 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368865 */     GIR_RootConstrainSelectedInstOperands,
     /* 368866 */     // GIR_Coverage, 921,
     /* 368866 */     GIR_Done,
     /* 368867 */   // Label 7436: @368867
     /* 368867 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(369052), // Rule ID 6969 //
     /* 368872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 368875 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 368875 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 368878 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 368882 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368887 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 368891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 368893 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 368896 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 368900 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368905 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 368908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 368910 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 368913 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368917 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368922 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368928 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368933 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368938 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 368941 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 368945 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368950 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 368953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 368955 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 368958 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 368962 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368967 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368972 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368975 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368979 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368984 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 368987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 368989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369021 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369050 */     GIR_RootConstrainSelectedInstOperands,
     /* 369051 */     // GIR_Coverage, 6969,
     /* 369051 */     GIR_EraseRootFromParent_Done,
     /* 369052 */   // Label 7437: @369052
     /* 369052 */   GIM_Reject,
     /* 369053 */ // Label 7435: @369053
     /* 369053 */ GIM_Reject,
     /* 369054 */ // Label 7427: @369054
     /* 369054 */ GIM_Reject,
     /* 369055 */ // Label 100: @369055
     /* 369055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7446*/ GIMT_Encode4(369545),
     /* 369066 */ /*GILLT_s16*//*Label 7438*/ GIMT_Encode4(369106),
     /* 369070 */ /*GILLT_s32*//*Label 7439*/ GIMT_Encode4(369137),
     /* 369074 */ /*GILLT_s64*//*Label 7440*/ GIMT_Encode4(369168), GIMT_Encode4(0),
     /* 369082 */ /*GILLT_v2s32*//*Label 7441*/ GIMT_Encode4(369199),
     /* 369086 */ /*GILLT_v2s64*//*Label 7442*/ GIMT_Encode4(369230),
     /* 369090 */ /*GILLT_v4s16*//*Label 7443*/ GIMT_Encode4(369261),
     /* 369094 */ /*GILLT_v4s32*//*Label 7444*/ GIMT_Encode4(369292), GIMT_Encode4(0),
     /* 369102 */ /*GILLT_v8s16*//*Label 7445*/ GIMT_Encode4(369323),
     /* 369106 */ // Label 7438: @369106
     /* 369106 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(369136), // Rule ID 534 //
     /* 369111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369125 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 369130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369134 */   GIR_RootConstrainSelectedInstOperands,
     /* 369135 */   // GIR_Coverage, 534,
     /* 369135 */   GIR_Done,
     /* 369136 */ // Label 7447: @369136
     /* 369136 */ GIM_Reject,
     /* 369137 */ // Label 7439: @369137
     /* 369137 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(369167), // Rule ID 536 //
     /* 369142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369156 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 369161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369165 */   GIR_RootConstrainSelectedInstOperands,
     /* 369166 */   // GIR_Coverage, 536,
     /* 369166 */   GIR_Done,
     /* 369167 */ // Label 7448: @369167
     /* 369167 */ GIM_Reject,
     /* 369168 */ // Label 7440: @369168
     /* 369168 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(369198), // Rule ID 538 //
     /* 369173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369187 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 369192 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369196 */   GIR_RootConstrainSelectedInstOperands,
     /* 369197 */   // GIR_Coverage, 538,
     /* 369197 */   GIR_Done,
     /* 369198 */ // Label 7449: @369198
     /* 369198 */ GIM_Reject,
     /* 369199 */ // Label 7441: @369199
     /* 369199 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(369229), // Rule ID 883 //
     /* 369204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369218 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 369223 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369227 */   GIR_RootConstrainSelectedInstOperands,
     /* 369228 */   // GIR_Coverage, 883,
     /* 369228 */   GIR_Done,
     /* 369229 */ // Label 7450: @369229
     /* 369229 */ GIM_Reject,
     /* 369230 */ // Label 7442: @369230
     /* 369230 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(369260), // Rule ID 887 //
     /* 369235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369249 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 369254 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369258 */   GIR_RootConstrainSelectedInstOperands,
     /* 369259 */   // GIR_Coverage, 887,
     /* 369259 */   GIR_Done,
     /* 369260 */ // Label 7451: @369260
     /* 369260 */ GIM_Reject,
     /* 369261 */ // Label 7443: @369261
     /* 369261 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(369291), // Rule ID 879 //
     /* 369266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369280 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 369285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369289 */   GIR_RootConstrainSelectedInstOperands,
     /* 369290 */   // GIR_Coverage, 879,
     /* 369290 */   GIR_Done,
     /* 369291 */ // Label 7452: @369291
     /* 369291 */ GIM_Reject,
     /* 369292 */ // Label 7444: @369292
     /* 369292 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(369322), // Rule ID 885 //
     /* 369297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369311 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369316 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369320 */   GIR_RootConstrainSelectedInstOperands,
     /* 369321 */   // GIR_Coverage, 885,
     /* 369321 */   GIR_Done,
     /* 369322 */ // Label 7453: @369322
     /* 369322 */ GIM_Reject,
     /* 369323 */ // Label 7445: @369323
     /* 369323 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(369544),
     /* 369328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369339 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(369358), // Rule ID 881 //
     /* 369344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369347 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 369352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369356 */     GIR_RootConstrainSelectedInstOperands,
     /* 369357 */     // GIR_Coverage, 881,
     /* 369357 */     GIR_Done,
     /* 369358 */   // Label 7455: @369358
     /* 369358 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(369543), // Rule ID 6963 //
     /* 369363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369366 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369366 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369369 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369373 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369378 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369384 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369387 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369391 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369396 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369401 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369404 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369408 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369413 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369419 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369424 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369429 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369432 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369436 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369441 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369446 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369449 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369453 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369458 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369463 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369466 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369470 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369475 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369541 */     GIR_RootConstrainSelectedInstOperands,
     /* 369542 */     // GIR_Coverage, 6963,
     /* 369542 */     GIR_EraseRootFromParent_Done,
     /* 369543 */   // Label 7456: @369543
     /* 369543 */   GIM_Reject,
     /* 369544 */ // Label 7454: @369544
     /* 369544 */ GIM_Reject,
     /* 369545 */ // Label 7446: @369545
     /* 369545 */ GIM_Reject,
     /* 369546 */ // Label 101: @369546
     /* 369546 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7465*/ GIMT_Encode4(370671),
     /* 369557 */ /*GILLT_s16*//*Label 7457*/ GIMT_Encode4(369597),
     /* 369561 */ /*GILLT_s32*//*Label 7458*/ GIMT_Encode4(369823),
     /* 369565 */ /*GILLT_s64*//*Label 7459*/ GIMT_Encode4(370049), GIMT_Encode4(0),
     /* 369573 */ /*GILLT_v2s32*//*Label 7460*/ GIMT_Encode4(370221),
     /* 369577 */ /*GILLT_v2s64*//*Label 7461*/ GIMT_Encode4(370259),
     /* 369581 */ /*GILLT_v4s16*//*Label 7462*/ GIMT_Encode4(370297),
     /* 369585 */ /*GILLT_v4s32*//*Label 7463*/ GIMT_Encode4(370335), GIMT_Encode4(0),
     /* 369593 */ /*GILLT_v8s16*//*Label 7464*/ GIMT_Encode4(370373),
     /* 369597 */ // Label 7457: @369597
     /* 369597 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(369822),
     /* 369602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 369608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369612 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(369703), // Rule ID 6883 //
     /* 369617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369638 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369654 */     // MIs[2] Rn
     /* 369654 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369659 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369665 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 369665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 369696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369701 */     GIR_RootConstrainSelectedInstOperands,
     /* 369702 */     // GIR_Coverage, 6883,
     /* 369702 */     GIR_EraseRootFromParent_Done,
     /* 369703 */   // Label 7467: @369703
     /* 369703 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(369794), // Rule ID 13859 //
     /* 369708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 369733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369745 */     // MIs[2] Rn
     /* 369745 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369750 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369756 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 369756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369768 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 369787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369792 */     GIR_RootConstrainSelectedInstOperands,
     /* 369793 */     // GIR_Coverage, 13859,
     /* 369793 */     GIR_EraseRootFromParent_Done,
     /* 369794 */   // Label 7468: @369794
     /* 369794 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(369821), // Rule ID 583 //
     /* 369799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369810 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 369810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 369815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369819 */     GIR_RootConstrainSelectedInstOperands,
     /* 369820 */     // GIR_Coverage, 583,
     /* 369820 */     GIR_Done,
     /* 369821 */   // Label 7469: @369821
     /* 369821 */   GIM_Reject,
     /* 369822 */ // Label 7466: @369822
     /* 369822 */ GIM_Reject,
     /* 369823 */ // Label 7458: @369823
     /* 369823 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(370048),
     /* 369828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369838 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(369929), // Rule ID 6881 //
     /* 369843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369864 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369880 */     // MIs[2] Rn
     /* 369880 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369885 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369891 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 369891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369903 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 369922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369927 */     GIR_RootConstrainSelectedInstOperands,
     /* 369928 */     // GIR_Coverage, 6881,
     /* 369928 */     GIR_EraseRootFromParent_Done,
     /* 369929 */   // Label 7471: @369929
     /* 369929 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(370020), // Rule ID 13857 //
     /* 369934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 369959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369971 */     // MIs[2] Rn
     /* 369971 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369976 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369982 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 369982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369994 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 370013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370018 */     GIR_RootConstrainSelectedInstOperands,
     /* 370019 */     // GIR_Coverage, 13857,
     /* 370019 */     GIR_EraseRootFromParent_Done,
     /* 370020 */   // Label 7472: @370020
     /* 370020 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(370047), // Rule ID 585 //
     /* 370025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370036 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 370036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 370041 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370045 */     GIR_RootConstrainSelectedInstOperands,
     /* 370046 */     // GIR_Coverage, 585,
     /* 370046 */     GIR_Done,
     /* 370047 */   // Label 7473: @370047
     /* 370047 */   GIM_Reject,
     /* 370048 */ // Label 7470: @370048
     /* 370048 */ GIM_Reject,
     /* 370049 */ // Label 7459: @370049
     /* 370049 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(370220),
     /* 370054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370064 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(370128), // Rule ID 6879 //
     /* 370069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370090 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370106 */     // MIs[2] Rn
     /* 370106 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370111 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370117 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 370117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 370120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370126 */     GIR_RootConstrainSelectedInstOperands,
     /* 370127 */     // GIR_Coverage, 6879,
     /* 370127 */     GIR_EraseRootFromParent_Done,
     /* 370128 */   // Label 7475: @370128
     /* 370128 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(370192), // Rule ID 13855 //
     /* 370133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370154 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370170 */     // MIs[2] Rn
     /* 370170 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370181 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 370181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 370184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370190 */     GIR_RootConstrainSelectedInstOperands,
     /* 370191 */     // GIR_Coverage, 13855,
     /* 370191 */     GIR_EraseRootFromParent_Done,
     /* 370192 */   // Label 7476: @370192
     /* 370192 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(370219), // Rule ID 587 //
     /* 370197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370208 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 370208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 370213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370217 */     GIR_RootConstrainSelectedInstOperands,
     /* 370218 */     // GIR_Coverage, 587,
     /* 370218 */     GIR_Done,
     /* 370219 */   // Label 7477: @370219
     /* 370219 */   GIM_Reject,
     /* 370220 */ // Label 7474: @370220
     /* 370220 */ GIM_Reject,
     /* 370221 */ // Label 7460: @370221
     /* 370221 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(370258), // Rule ID 1202 //
     /* 370226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 370235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370247 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 370247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 370252 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370256 */   GIR_RootConstrainSelectedInstOperands,
     /* 370257 */   // GIR_Coverage, 1202,
     /* 370257 */   GIR_Done,
     /* 370258 */ // Label 7478: @370258
     /* 370258 */ GIM_Reject,
     /* 370259 */ // Label 7461: @370259
     /* 370259 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(370296), // Rule ID 1206 //
     /* 370264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 370273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370285 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 370285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 370290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370294 */   GIR_RootConstrainSelectedInstOperands,
     /* 370295 */   // GIR_Coverage, 1206,
     /* 370295 */   GIR_Done,
     /* 370296 */ // Label 7479: @370296
     /* 370296 */ GIM_Reject,
     /* 370297 */ // Label 7462: @370297
     /* 370297 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(370334), // Rule ID 1198 //
     /* 370302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 370311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370323 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 370323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 370328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370332 */   GIR_RootConstrainSelectedInstOperands,
     /* 370333 */   // GIR_Coverage, 1198,
     /* 370333 */   GIR_Done,
     /* 370334 */ // Label 7480: @370334
     /* 370334 */ GIM_Reject,
     /* 370335 */ // Label 7463: @370335
     /* 370335 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(370372), // Rule ID 1204 //
     /* 370340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 370349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370361 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 370361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370370 */   GIR_RootConstrainSelectedInstOperands,
     /* 370371 */   // GIR_Coverage, 1204,
     /* 370371 */   GIR_Done,
     /* 370372 */ // Label 7481: @370372
     /* 370372 */ GIM_Reject,
     /* 370373 */ // Label 7464: @370373
     /* 370373 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(370670),
     /* 370378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 370384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370396 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(370415), // Rule ID 1200 //
     /* 370401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370404 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 370404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 370409 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370413 */     GIR_RootConstrainSelectedInstOperands,
     /* 370414 */     // GIR_Coverage, 1200,
     /* 370414 */     GIR_Done,
     /* 370415 */   // Label 7483: @370415
     /* 370415 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(370669), // Rule ID 6972 //
     /* 370420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370423 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 370423 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 370426 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370430 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370435 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 370441 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 370444 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370448 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370453 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 370459 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 370462 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370466 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370471 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 370474 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 370477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 370479 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 370482 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370486 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370491 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370497 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370502 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370507 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370510 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370514 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370519 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370524 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370527 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370531 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370536 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370542 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370547 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370552 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370555 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370559 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370564 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370569 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370572 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370576 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370581 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370584 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 370587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370589 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370592 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370596 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370601 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 370667 */     GIR_RootConstrainSelectedInstOperands,
     /* 370668 */     // GIR_Coverage, 6972,
     /* 370668 */     GIR_EraseRootFromParent_Done,
     /* 370669 */   // Label 7484: @370669
     /* 370669 */   GIM_Reject,
     /* 370670 */ // Label 7482: @370670
     /* 370670 */ GIM_Reject,
     /* 370671 */ // Label 7465: @370671
     /* 370671 */ GIM_Reject,
     /* 370672 */ // Label 102: @370672
     /* 370672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7493*/ GIMT_Encode4(371287),
     /* 370683 */ /*GILLT_s16*//*Label 7485*/ GIMT_Encode4(370723),
     /* 370687 */ /*GILLT_s32*//*Label 7486*/ GIMT_Encode4(370761),
     /* 370691 */ /*GILLT_s64*//*Label 7487*/ GIMT_Encode4(370799), GIMT_Encode4(0),
     /* 370699 */ /*GILLT_v2s32*//*Label 7488*/ GIMT_Encode4(370837),
     /* 370703 */ /*GILLT_v2s64*//*Label 7489*/ GIMT_Encode4(370875),
     /* 370707 */ /*GILLT_v4s16*//*Label 7490*/ GIMT_Encode4(370913),
     /* 370711 */ /*GILLT_v4s32*//*Label 7491*/ GIMT_Encode4(370951), GIMT_Encode4(0),
     /* 370719 */ /*GILLT_v8s16*//*Label 7492*/ GIMT_Encode4(370989),
     /* 370723 */ // Label 7485: @370723
     /* 370723 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(370760), // Rule ID 631 //
     /* 370728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370749 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 370749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 370754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370758 */   GIR_RootConstrainSelectedInstOperands,
     /* 370759 */   // GIR_Coverage, 631,
     /* 370759 */   GIR_Done,
     /* 370760 */ // Label 7494: @370760
     /* 370760 */ GIM_Reject,
     /* 370761 */ // Label 7486: @370761
     /* 370761 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(370798), // Rule ID 633 //
     /* 370766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370787 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 370787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 370792 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370796 */   GIR_RootConstrainSelectedInstOperands,
     /* 370797 */   // GIR_Coverage, 633,
     /* 370797 */   GIR_Done,
     /* 370798 */ // Label 7495: @370798
     /* 370798 */ GIM_Reject,
     /* 370799 */ // Label 7487: @370799
     /* 370799 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(370836), // Rule ID 635 //
     /* 370804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370825 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 370825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 370830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370834 */   GIR_RootConstrainSelectedInstOperands,
     /* 370835 */   // GIR_Coverage, 635,
     /* 370835 */   GIR_Done,
     /* 370836 */ // Label 7496: @370836
     /* 370836 */ GIM_Reject,
     /* 370837 */ // Label 7488: @370837
     /* 370837 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(370874), // Rule ID 1342 //
     /* 370842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 370851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370863 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 370863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 370868 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370872 */   GIR_RootConstrainSelectedInstOperands,
     /* 370873 */   // GIR_Coverage, 1342,
     /* 370873 */   GIR_Done,
     /* 370874 */ // Label 7497: @370874
     /* 370874 */ GIM_Reject,
     /* 370875 */ // Label 7489: @370875
     /* 370875 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(370912), // Rule ID 1346 //
     /* 370880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 370889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370901 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 370901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 370906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370910 */   GIR_RootConstrainSelectedInstOperands,
     /* 370911 */   // GIR_Coverage, 1346,
     /* 370911 */   GIR_Done,
     /* 370912 */ // Label 7498: @370912
     /* 370912 */ GIM_Reject,
     /* 370913 */ // Label 7490: @370913
     /* 370913 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(370950), // Rule ID 1338 //
     /* 370918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 370927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370939 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 370939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 370944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370948 */   GIR_RootConstrainSelectedInstOperands,
     /* 370949 */   // GIR_Coverage, 1338,
     /* 370949 */   GIR_Done,
     /* 370950 */ // Label 7499: @370950
     /* 370950 */ GIM_Reject,
     /* 370951 */ // Label 7491: @370951
     /* 370951 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(370988), // Rule ID 1344 //
     /* 370956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 370965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370977 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 370977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 370982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370986 */   GIR_RootConstrainSelectedInstOperands,
     /* 370987 */   // GIR_Coverage, 1344,
     /* 370987 */   GIR_Done,
     /* 370988 */ // Label 7500: @370988
     /* 370988 */ GIM_Reject,
     /* 370989 */ // Label 7492: @370989
     /* 370989 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(371286),
     /* 370994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371012 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(371031), // Rule ID 1340 //
     /* 371017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371020 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 371025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371029 */     GIR_RootConstrainSelectedInstOperands,
     /* 371030 */     // GIR_Coverage, 1340,
     /* 371030 */     GIR_Done,
     /* 371031 */   // Label 7502: @371031
     /* 371031 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(371285), // Rule ID 6978 //
     /* 371036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371039 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371039 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371042 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371046 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371051 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371057 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371060 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371064 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371069 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371075 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371078 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371082 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371087 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371090 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371095 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371098 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371102 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371107 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371113 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371118 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371123 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371126 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371130 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371135 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371140 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371143 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371147 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371152 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371158 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371163 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371168 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371171 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371175 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371180 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371185 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371188 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371192 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371197 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371200 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 371203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371217 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371248 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 371283 */     GIR_RootConstrainSelectedInstOperands,
     /* 371284 */     // GIR_Coverage, 6978,
     /* 371284 */     GIR_EraseRootFromParent_Done,
     /* 371285 */   // Label 7503: @371285
     /* 371285 */   GIM_Reject,
     /* 371286 */ // Label 7501: @371286
     /* 371286 */ GIM_Reject,
     /* 371287 */ // Label 7493: @371287
     /* 371287 */ GIM_Reject,
     /* 371288 */ // Label 103: @371288
     /* 371288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7512*/ GIMT_Encode4(375009),
     /* 371299 */ /*GILLT_s16*//*Label 7504*/ GIMT_Encode4(371339),
     /* 371303 */ /*GILLT_s32*//*Label 7505*/ GIMT_Encode4(371893),
     /* 371307 */ /*GILLT_s64*//*Label 7506*/ GIMT_Encode4(372441), GIMT_Encode4(0),
     /* 371315 */ /*GILLT_v2s32*//*Label 7507*/ GIMT_Encode4(372989),
     /* 371319 */ /*GILLT_v2s64*//*Label 7508*/ GIMT_Encode4(373519),
     /* 371323 */ /*GILLT_v4s16*//*Label 7509*/ GIMT_Encode4(373877),
     /* 371327 */ /*GILLT_v4s32*//*Label 7510*/ GIMT_Encode4(374219), GIMT_Encode4(0),
     /* 371335 */ /*GILLT_v8s16*//*Label 7511*/ GIMT_Encode4(374577),
     /* 371339 */ // Label 7504: @371339
     /* 371339 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(371892),
     /* 371344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371354 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(371467), // Rule ID 6213 //
     /* 371359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371383 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371420 */     // MIs[3] Operand 1
     /* 371420 */     // No operand predicates
     /* 371420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371422 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 371422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371434 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371465 */     GIR_RootConstrainSelectedInstOperands,
     /* 371466 */     // GIR_Coverage, 6213,
     /* 371466 */     GIR_EraseRootFromParent_Done,
     /* 371467 */   // Label 7514: @371467
     /* 371467 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(371580), // Rule ID 13836 //
     /* 371472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371508 */     // MIs[2] Operand 1
     /* 371508 */     // No operand predicates
     /* 371508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371529 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371535 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 371535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371547 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371578 */     GIR_RootConstrainSelectedInstOperands,
     /* 371579 */     // GIR_Coverage, 13836,
     /* 371579 */     GIR_EraseRootFromParent_Done,
     /* 371580 */   // Label 7515: @371580
     /* 371580 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(371659), // Rule ID 13773 //
     /* 371585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371609 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371619 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 371619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 371650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371657 */     GIR_RootConstrainSelectedInstOperands,
     /* 371658 */     // GIR_Coverage, 13773,
     /* 371658 */     GIR_EraseRootFromParent_Done,
     /* 371659 */   // Label 7516: @371659
     /* 371659 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(371738), // Rule ID 4792 //
     /* 371664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371698 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 371698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 371729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371736 */     GIR_RootConstrainSelectedInstOperands,
     /* 371737 */     // GIR_Coverage, 4792,
     /* 371737 */     GIR_EraseRootFromParent_Done,
     /* 371738 */   // Label 7517: @371738
     /* 371738 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(371801), // Rule ID 13388 //
     /* 371743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 371767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371779 */     // MIs[2] Operand 1
     /* 371779 */     // No operand predicates
     /* 371779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371785 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 371785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371799 */     GIR_RootConstrainSelectedInstOperands,
     /* 371800 */     // GIR_Coverage, 13388,
     /* 371800 */     GIR_EraseRootFromParent_Done,
     /* 371801 */   // Label 7518: @371801
     /* 371801 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(371864), // Rule ID 2011 //
     /* 371806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 371834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371846 */     // MIs[2] Operand 1
     /* 371846 */     // No operand predicates
     /* 371846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371848 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 371848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371862 */     GIR_RootConstrainSelectedInstOperands,
     /* 371863 */     // GIR_Coverage, 2011,
     /* 371863 */     GIR_EraseRootFromParent_Done,
     /* 371864 */   // Label 7519: @371864
     /* 371864 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(371891), // Rule ID 619 //
     /* 371869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371880 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 371880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 371885 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371889 */     GIR_RootConstrainSelectedInstOperands,
     /* 371890 */     // GIR_Coverage, 619,
     /* 371890 */     GIR_Done,
     /* 371891 */   // Label 7520: @371891
     /* 371891 */   GIM_Reject,
     /* 371892 */ // Label 7513: @371892
     /* 371892 */ GIM_Reject,
     /* 371893 */ // Label 7505: @371893
     /* 371893 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(372440),
     /* 371898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371908 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(372021), // Rule ID 6215 //
     /* 371913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371970 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 371974 */     // MIs[3] Operand 1
     /* 371974 */     // No operand predicates
     /* 371974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371976 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 371976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372019 */     GIR_RootConstrainSelectedInstOperands,
     /* 372020 */     // GIR_Coverage, 6215,
     /* 372020 */     GIR_EraseRootFromParent_Done,
     /* 372021 */   // Label 7522: @372021
     /* 372021 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(372134), // Rule ID 13838 //
     /* 372026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372062 */     // MIs[2] Operand 1
     /* 372062 */     // No operand predicates
     /* 372062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372078 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372083 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372089 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372101 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372132 */     GIR_RootConstrainSelectedInstOperands,
     /* 372133 */     // GIR_Coverage, 13838,
     /* 372133 */     GIR_EraseRootFromParent_Done,
     /* 372134 */   // Label 7523: @372134
     /* 372134 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(372210), // Rule ID 13775 //
     /* 372139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372160 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372170 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 372170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 372188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372208 */     GIR_RootConstrainSelectedInstOperands,
     /* 372209 */     // GIR_Coverage, 13775,
     /* 372209 */     GIR_EraseRootFromParent_Done,
     /* 372210 */   // Label 7524: @372210
     /* 372210 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(372286), // Rule ID 4794 //
     /* 372215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372240 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372246 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 372246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 372264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372284 */     GIR_RootConstrainSelectedInstOperands,
     /* 372285 */     // GIR_Coverage, 4794,
     /* 372285 */     GIR_EraseRootFromParent_Done,
     /* 372286 */   // Label 7525: @372286
     /* 372286 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(372349), // Rule ID 13390 //
     /* 372291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372327 */     // MIs[2] Operand 1
     /* 372327 */     // No operand predicates
     /* 372327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372333 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372347 */     GIR_RootConstrainSelectedInstOperands,
     /* 372348 */     // GIR_Coverage, 13390,
     /* 372348 */     GIR_EraseRootFromParent_Done,
     /* 372349 */   // Label 7526: @372349
     /* 372349 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(372412), // Rule ID 2013 //
     /* 372354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372390 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372394 */     // MIs[2] Operand 1
     /* 372394 */     // No operand predicates
     /* 372394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372396 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372410 */     GIR_RootConstrainSelectedInstOperands,
     /* 372411 */     // GIR_Coverage, 2013,
     /* 372411 */     GIR_EraseRootFromParent_Done,
     /* 372412 */   // Label 7527: @372412
     /* 372412 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(372439), // Rule ID 621 //
     /* 372417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372428 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 372428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372433 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372437 */     GIR_RootConstrainSelectedInstOperands,
     /* 372438 */     // GIR_Coverage, 621,
     /* 372438 */     GIR_Done,
     /* 372439 */   // Label 7528: @372439
     /* 372439 */   GIM_Reject,
     /* 372440 */ // Label 7521: @372440
     /* 372440 */ GIM_Reject,
     /* 372441 */ // Label 7506: @372441
     /* 372441 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(372988),
     /* 372446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 372452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372456 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(372569), // Rule ID 6217 //
     /* 372461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372485 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372522 */     // MIs[3] Operand 1
     /* 372522 */     // No operand predicates
     /* 372522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372524 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372567 */     GIR_RootConstrainSelectedInstOperands,
     /* 372568 */     // GIR_Coverage, 6217,
     /* 372568 */     GIR_EraseRootFromParent_Done,
     /* 372569 */   // Label 7530: @372569
     /* 372569 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(372682), // Rule ID 13840 //
     /* 372574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372610 */     // MIs[2] Operand 1
     /* 372610 */     // No operand predicates
     /* 372610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372626 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372631 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372637 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372680 */     GIR_RootConstrainSelectedInstOperands,
     /* 372681 */     // GIR_Coverage, 13840,
     /* 372681 */     GIR_EraseRootFromParent_Done,
     /* 372682 */   // Label 7531: @372682
     /* 372682 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(372758), // Rule ID 13777 //
     /* 372687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372718 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 372718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 372749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372756 */     GIR_RootConstrainSelectedInstOperands,
     /* 372757 */     // GIR_Coverage, 13777,
     /* 372757 */     GIR_EraseRootFromParent_Done,
     /* 372758 */   // Label 7532: @372758
     /* 372758 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(372834), // Rule ID 4796 //
     /* 372763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372788 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372794 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 372794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372806 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 372825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372832 */     GIR_RootConstrainSelectedInstOperands,
     /* 372833 */     // GIR_Coverage, 4796,
     /* 372833 */     GIR_EraseRootFromParent_Done,
     /* 372834 */   // Label 7533: @372834
     /* 372834 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(372897), // Rule ID 13392 //
     /* 372839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372875 */     // MIs[2] Operand 1
     /* 372875 */     // No operand predicates
     /* 372875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372881 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372895 */     GIR_RootConstrainSelectedInstOperands,
     /* 372896 */     // GIR_Coverage, 13392,
     /* 372896 */     GIR_EraseRootFromParent_Done,
     /* 372897 */   // Label 7534: @372897
     /* 372897 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(372960), // Rule ID 2015 //
     /* 372902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372942 */     // MIs[2] Operand 1
     /* 372942 */     // No operand predicates
     /* 372942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372944 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372958 */     GIR_RootConstrainSelectedInstOperands,
     /* 372959 */     // GIR_Coverage, 2015,
     /* 372959 */     GIR_EraseRootFromParent_Done,
     /* 372960 */   // Label 7535: @372960
     /* 372960 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(372987), // Rule ID 623 //
     /* 372965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372976 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 372976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 372981 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372985 */     GIR_RootConstrainSelectedInstOperands,
     /* 372986 */     // GIR_Coverage, 623,
     /* 372986 */     GIR_Done,
     /* 372987 */   // Label 7536: @372987
     /* 372987 */   GIM_Reject,
     /* 372988 */ // Label 7529: @372988
     /* 372988 */ GIM_Reject,
     /* 372989 */ // Label 7507: @372989
     /* 372989 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(373518),
     /* 372994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 373000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373004 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(373090), // Rule ID 13380 //
     /* 373009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373057 */     // MIs[3] Operand 1
     /* 373057 */     // No operand predicates
     /* 373057 */     // MIs[1] Operand 2
     /* 373057 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373074 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373088 */     GIR_RootConstrainSelectedInstOperands,
     /* 373089 */     // GIR_Coverage, 13380,
     /* 373089 */     GIR_EraseRootFromParent_Done,
     /* 373090 */   // Label 7538: @373090
     /* 373090 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(373176), // Rule ID 2003 //
     /* 373095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373147 */     // MIs[3] Operand 1
     /* 373147 */     // No operand predicates
     /* 373147 */     // MIs[1] Operand 2
     /* 373147 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373160 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373174 */     GIR_RootConstrainSelectedInstOperands,
     /* 373175 */     // GIR_Coverage, 2003,
     /* 373175 */     GIR_EraseRootFromParent_Done,
     /* 373176 */   // Label 7539: @373176
     /* 373176 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(373239), // Rule ID 13381 //
     /* 373181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373217 */     // MIs[2] Operand 1
     /* 373217 */     // No operand predicates
     /* 373217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373223 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373237 */     GIR_RootConstrainSelectedInstOperands,
     /* 373238 */     // GIR_Coverage, 13381,
     /* 373238 */     GIR_EraseRootFromParent_Done,
     /* 373239 */   // Label 7540: @373239
     /* 373239 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(373302), // Rule ID 2004 //
     /* 373244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373284 */     // MIs[2] Operand 1
     /* 373284 */     // No operand predicates
     /* 373284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373286 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373300 */     GIR_RootConstrainSelectedInstOperands,
     /* 373301 */     // GIR_Coverage, 2004,
     /* 373301 */     GIR_EraseRootFromParent_Done,
     /* 373302 */   // Label 7541: @373302
     /* 373302 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(373396), // Rule ID 13842 //
     /* 373307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373330 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373394 */     GIR_RootConstrainSelectedInstOperands,
     /* 373395 */     // GIR_Coverage, 13842,
     /* 373395 */     GIR_EraseRootFromParent_Done,
     /* 373396 */   // Label 7542: @373396
     /* 373396 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(373490), // Rule ID 6219 //
     /* 373401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373424 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373424 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373427 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373431 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373457 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373488 */     GIR_RootConstrainSelectedInstOperands,
     /* 373489 */     // GIR_Coverage, 6219,
     /* 373489 */     GIR_EraseRootFromParent_Done,
     /* 373490 */   // Label 7543: @373490
     /* 373490 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(373517), // Rule ID 1322 //
     /* 373495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373506 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 373506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 373511 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373515 */     GIR_RootConstrainSelectedInstOperands,
     /* 373516 */     // GIR_Coverage, 1322,
     /* 373516 */     GIR_Done,
     /* 373517 */   // Label 7544: @373517
     /* 373517 */   GIM_Reject,
     /* 373518 */ // Label 7537: @373518
     /* 373518 */ GIM_Reject,
     /* 373519 */ // Label 7508: @373519
     /* 373519 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(373876),
     /* 373524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 373530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373534 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(373597), // Rule ID 13386 //
     /* 373539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 373550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373571 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373575 */     // MIs[2] Operand 1
     /* 373575 */     // No operand predicates
     /* 373575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373581 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373595 */     GIR_RootConstrainSelectedInstOperands,
     /* 373596 */     // GIR_Coverage, 13386,
     /* 373596 */     GIR_EraseRootFromParent_Done,
     /* 373597 */   // Label 7546: @373597
     /* 373597 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(373660), // Rule ID 2009 //
     /* 373602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 373617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373638 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373642 */     // MIs[2] Operand 1
     /* 373642 */     // No operand predicates
     /* 373642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373644 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373658 */     GIR_RootConstrainSelectedInstOperands,
     /* 373659 */     // GIR_Coverage, 2009,
     /* 373659 */     GIR_EraseRootFromParent_Done,
     /* 373660 */   // Label 7547: @373660
     /* 373660 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(373754), // Rule ID 13846 //
     /* 373665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373688 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373752 */     GIR_RootConstrainSelectedInstOperands,
     /* 373753 */     // GIR_Coverage, 13846,
     /* 373753 */     GIR_EraseRootFromParent_Done,
     /* 373754 */   // Label 7548: @373754
     /* 373754 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(373848), // Rule ID 6223 //
     /* 373759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373782 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373808 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373846 */     GIR_RootConstrainSelectedInstOperands,
     /* 373847 */     // GIR_Coverage, 6223,
     /* 373847 */     GIR_EraseRootFromParent_Done,
     /* 373848 */   // Label 7549: @373848
     /* 373848 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(373875), // Rule ID 1326 //
     /* 373853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373864 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 373864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 373869 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373873 */     GIR_RootConstrainSelectedInstOperands,
     /* 373874 */     // GIR_Coverage, 1326,
     /* 373874 */     GIR_Done,
     /* 373875 */   // Label 7550: @373875
     /* 373875 */   GIM_Reject,
     /* 373876 */ // Label 7545: @373876
     /* 373876 */ GIM_Reject,
     /* 373877 */ // Label 7509: @373877
     /* 373877 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(374218),
     /* 373882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 373888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373892 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(373978), // Rule ID 13374 //
     /* 373897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 373920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373945 */     // MIs[3] Operand 1
     /* 373945 */     // No operand predicates
     /* 373945 */     // MIs[1] Operand 2
     /* 373945 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373962 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 373965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373976 */     GIR_RootConstrainSelectedInstOperands,
     /* 373977 */     // GIR_Coverage, 13374,
     /* 373977 */     GIR_EraseRootFromParent_Done,
     /* 373978 */   // Label 7552: @373978
     /* 373978 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(374064), // Rule ID 1997 //
     /* 373983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374031 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374035 */     // MIs[3] Operand 1
     /* 374035 */     // No operand predicates
     /* 374035 */     // MIs[1] Operand 2
     /* 374035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374048 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374062 */     GIR_RootConstrainSelectedInstOperands,
     /* 374063 */     // GIR_Coverage, 1997,
     /* 374063 */     GIR_EraseRootFromParent_Done,
     /* 374064 */   // Label 7553: @374064
     /* 374064 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(374127), // Rule ID 13375 //
     /* 374069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374105 */     // MIs[2] Operand 1
     /* 374105 */     // No operand predicates
     /* 374105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374111 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374125 */     GIR_RootConstrainSelectedInstOperands,
     /* 374126 */     // GIR_Coverage, 13375,
     /* 374126 */     GIR_EraseRootFromParent_Done,
     /* 374127 */   // Label 7554: @374127
     /* 374127 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(374190), // Rule ID 1998 //
     /* 374132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374172 */     // MIs[2] Operand 1
     /* 374172 */     // No operand predicates
     /* 374172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374174 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374188 */     GIR_RootConstrainSelectedInstOperands,
     /* 374189 */     // GIR_Coverage, 1998,
     /* 374189 */     GIR_EraseRootFromParent_Done,
     /* 374190 */   // Label 7555: @374190
     /* 374190 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(374217), // Rule ID 1318 //
     /* 374195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374206 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 374206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 374211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374215 */     GIR_RootConstrainSelectedInstOperands,
     /* 374216 */     // GIR_Coverage, 1318,
     /* 374216 */     GIR_Done,
     /* 374217 */   // Label 7556: @374217
     /* 374217 */   GIM_Reject,
     /* 374218 */ // Label 7551: @374218
     /* 374218 */ GIM_Reject,
     /* 374219 */ // Label 7510: @374219
     /* 374219 */ GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(374576),
     /* 374224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 374230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374234 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(374297), // Rule ID 13384 //
     /* 374239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374271 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374275 */     // MIs[2] Operand 1
     /* 374275 */     // No operand predicates
     /* 374275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374281 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374295 */     GIR_RootConstrainSelectedInstOperands,
     /* 374296 */     // GIR_Coverage, 13384,
     /* 374296 */     GIR_EraseRootFromParent_Done,
     /* 374297 */   // Label 7558: @374297
     /* 374297 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(374360), // Rule ID 2007 //
     /* 374302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374338 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374342 */     // MIs[2] Operand 1
     /* 374342 */     // No operand predicates
     /* 374342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374344 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374358 */     GIR_RootConstrainSelectedInstOperands,
     /* 374359 */     // GIR_Coverage, 2007,
     /* 374359 */     GIR_EraseRootFromParent_Done,
     /* 374360 */   // Label 7559: @374360
     /* 374360 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(374454), // Rule ID 13844 //
     /* 374365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374388 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374452 */     GIR_RootConstrainSelectedInstOperands,
     /* 374453 */     // GIR_Coverage, 13844,
     /* 374453 */     GIR_EraseRootFromParent_Done,
     /* 374454 */   // Label 7560: @374454
     /* 374454 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(374548), // Rule ID 6221 //
     /* 374459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374482 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374546 */     GIR_RootConstrainSelectedInstOperands,
     /* 374547 */     // GIR_Coverage, 6221,
     /* 374547 */     GIR_EraseRootFromParent_Done,
     /* 374548 */   // Label 7561: @374548
     /* 374548 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(374575), // Rule ID 1324 //
     /* 374553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374564 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 374564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 374569 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374573 */     GIR_RootConstrainSelectedInstOperands,
     /* 374574 */     // GIR_Coverage, 1324,
     /* 374574 */     GIR_Done,
     /* 374575 */   // Label 7562: @374575
     /* 374575 */   GIM_Reject,
     /* 374576 */ // Label 7557: @374576
     /* 374576 */ GIM_Reject,
     /* 374577 */ // Label 7511: @374577
     /* 374577 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(375008),
     /* 374582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 374588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374592 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(374655), // Rule ID 13378 //
     /* 374597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374633 */     // MIs[2] Operand 1
     /* 374633 */     // No operand predicates
     /* 374633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374639 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 374642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374653 */     GIR_RootConstrainSelectedInstOperands,
     /* 374654 */     // GIR_Coverage, 13378,
     /* 374654 */     GIR_EraseRootFromParent_Done,
     /* 374655 */   // Label 7564: @374655
     /* 374655 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(374718), // Rule ID 2001 //
     /* 374660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374696 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374700 */     // MIs[2] Operand 1
     /* 374700 */     // No operand predicates
     /* 374700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374702 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 374705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374716 */     GIR_RootConstrainSelectedInstOperands,
     /* 374717 */     // GIR_Coverage, 2001,
     /* 374717 */     GIR_EraseRootFromParent_Done,
     /* 374718 */   // Label 7565: @374718
     /* 374718 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(374745), // Rule ID 1320 //
     /* 374723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374734 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 374734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 374739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374743 */     GIR_RootConstrainSelectedInstOperands,
     /* 374744 */     // GIR_Coverage, 1320,
     /* 374744 */     GIR_Done,
     /* 374745 */   // Label 7566: @374745
     /* 374745 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(375007), // Rule ID 6976 //
     /* 374750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374761 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 374761 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 374764 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374768 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374773 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 374777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 374779 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 374782 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374786 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374791 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 374797 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 374800 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 374804 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374809 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 374812 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 374815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 374817 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 374820 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374824 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374829 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374835 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374840 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374845 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374848 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374852 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374857 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374862 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374865 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374869 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374874 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374880 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374885 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374902 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374907 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374910 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 374914 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374919 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374922 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 374925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374939 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375005 */     GIR_RootConstrainSelectedInstOperands,
     /* 375006 */     // GIR_Coverage, 6976,
     /* 375006 */     GIR_EraseRootFromParent_Done,
     /* 375007 */   // Label 7567: @375007
     /* 375007 */   GIM_Reject,
     /* 375008 */ // Label 7563: @375008
     /* 375008 */ GIM_Reject,
     /* 375009 */ // Label 7512: @375009
     /* 375009 */ GIM_Reject,
     /* 375010 */ // Label 104: @375010
     /* 375010 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7576*/ GIMT_Encode4(375625),
     /* 375021 */ /*GILLT_s16*//*Label 7568*/ GIMT_Encode4(375061),
     /* 375025 */ /*GILLT_s32*//*Label 7569*/ GIMT_Encode4(375099),
     /* 375029 */ /*GILLT_s64*//*Label 7570*/ GIMT_Encode4(375137), GIMT_Encode4(0),
     /* 375037 */ /*GILLT_v2s32*//*Label 7571*/ GIMT_Encode4(375175),
     /* 375041 */ /*GILLT_v2s64*//*Label 7572*/ GIMT_Encode4(375213),
     /* 375045 */ /*GILLT_v4s16*//*Label 7573*/ GIMT_Encode4(375251),
     /* 375049 */ /*GILLT_v4s32*//*Label 7574*/ GIMT_Encode4(375289), GIMT_Encode4(0),
     /* 375057 */ /*GILLT_v8s16*//*Label 7575*/ GIMT_Encode4(375327),
     /* 375061 */ // Label 7568: @375061
     /* 375061 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(375098), // Rule ID 589 //
     /* 375066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375087 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 375092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375096 */   GIR_RootConstrainSelectedInstOperands,
     /* 375097 */   // GIR_Coverage, 589,
     /* 375097 */   GIR_Done,
     /* 375098 */ // Label 7577: @375098
     /* 375098 */ GIM_Reject,
     /* 375099 */ // Label 7569: @375099
     /* 375099 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(375136), // Rule ID 591 //
     /* 375104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375125 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 375130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375134 */   GIR_RootConstrainSelectedInstOperands,
     /* 375135 */   // GIR_Coverage, 591,
     /* 375135 */   GIR_Done,
     /* 375136 */ // Label 7578: @375136
     /* 375136 */ GIM_Reject,
     /* 375137 */ // Label 7570: @375137
     /* 375137 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(375174), // Rule ID 593 //
     /* 375142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375163 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 375168 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375172 */   GIR_RootConstrainSelectedInstOperands,
     /* 375173 */   // GIR_Coverage, 593,
     /* 375173 */   GIR_Done,
     /* 375174 */ // Label 7579: @375174
     /* 375174 */ GIM_Reject,
     /* 375175 */ // Label 7571: @375175
     /* 375175 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(375212), // Rule ID 1227 //
     /* 375180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375201 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 375201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 375206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375210 */   GIR_RootConstrainSelectedInstOperands,
     /* 375211 */   // GIR_Coverage, 1227,
     /* 375211 */   GIR_Done,
     /* 375212 */ // Label 7580: @375212
     /* 375212 */ GIM_Reject,
     /* 375213 */ // Label 7572: @375213
     /* 375213 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(375250), // Rule ID 1231 //
     /* 375218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 375227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375239 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 375244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375248 */   GIR_RootConstrainSelectedInstOperands,
     /* 375249 */   // GIR_Coverage, 1231,
     /* 375249 */   GIR_Done,
     /* 375250 */ // Label 7581: @375250
     /* 375250 */ GIM_Reject,
     /* 375251 */ // Label 7573: @375251
     /* 375251 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(375288), // Rule ID 1223 //
     /* 375256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375277 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 375282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375286 */   GIR_RootConstrainSelectedInstOperands,
     /* 375287 */   // GIR_Coverage, 1223,
     /* 375287 */   GIR_Done,
     /* 375288 */ // Label 7582: @375288
     /* 375288 */ GIM_Reject,
     /* 375289 */ // Label 7574: @375289
     /* 375289 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(375326), // Rule ID 1229 //
     /* 375294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375315 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375324 */   GIR_RootConstrainSelectedInstOperands,
     /* 375325 */   // GIR_Coverage, 1229,
     /* 375325 */   GIR_Done,
     /* 375326 */ // Label 7583: @375326
     /* 375326 */ GIM_Reject,
     /* 375327 */ // Label 7575: @375327
     /* 375327 */ GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(375624),
     /* 375332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375350 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(375369), // Rule ID 1225 //
     /* 375355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375358 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 375363 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375367 */     GIR_RootConstrainSelectedInstOperands,
     /* 375368 */     // GIR_Coverage, 1225,
     /* 375368 */     GIR_Done,
     /* 375369 */   // Label 7585: @375369
     /* 375369 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(375623), // Rule ID 6974 //
     /* 375374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375377 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375377 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375380 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375384 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375389 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375395 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375398 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375402 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375407 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375413 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375416 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375420 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375425 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375428 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375433 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375436 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375440 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375445 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375451 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375456 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375461 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375464 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375468 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375473 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375478 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375481 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375485 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375490 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375496 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375501 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375506 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375509 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375513 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375518 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375523 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375526 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375530 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375535 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375538 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375543 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375546 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375550 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375555 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375563 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375567 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375592 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375621 */     GIR_RootConstrainSelectedInstOperands,
     /* 375622 */     // GIR_Coverage, 6974,
     /* 375622 */     GIR_EraseRootFromParent_Done,
     /* 375623 */   // Label 7586: @375623
     /* 375623 */   GIM_Reject,
     /* 375624 */ // Label 7584: @375624
     /* 375624 */ GIM_Reject,
     /* 375625 */ // Label 7576: @375625
     /* 375625 */ GIM_Reject,
     /* 375626 */ // Label 105: @375626
     /* 375626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7595*/ GIMT_Encode4(391232),
     /* 375637 */ /*GILLT_s16*//*Label 7587*/ GIMT_Encode4(375677),
     /* 375641 */ /*GILLT_s32*//*Label 7588*/ GIMT_Encode4(378451),
     /* 375645 */ /*GILLT_s64*//*Label 7589*/ GIMT_Encode4(381381), GIMT_Encode4(0),
     /* 375653 */ /*GILLT_v2s32*//*Label 7590*/ GIMT_Encode4(384311),
     /* 375657 */ /*GILLT_v2s64*//*Label 7591*/ GIMT_Encode4(385832),
     /* 375661 */ /*GILLT_v4s16*//*Label 7592*/ GIMT_Encode4(387353),
     /* 375665 */ /*GILLT_v4s32*//*Label 7593*/ GIMT_Encode4(388532), GIMT_Encode4(0),
     /* 375673 */ /*GILLT_v8s16*//*Label 7594*/ GIMT_Encode4(390053),
     /* 375677 */ // Label 7587: @375677
     /* 375677 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(378450),
     /* 375682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 375691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375695 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(375845), // Rule ID 4854 //
     /* 375700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375761 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 375765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375772 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 375772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 375775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375784 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 375790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 375818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 375831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 375843 */     GIR_RootConstrainSelectedInstOperands,
     /* 375844 */     // GIR_Coverage, 4854,
     /* 375844 */     GIR_EraseRootFromParent_Done,
     /* 375845 */   // Label 7597: @375845
     /* 375845 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(375992), // Rule ID 4818 //
     /* 375850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375874 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 375890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 375894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375902 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 375906 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375911 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 375915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375921 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 375921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 375924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375933 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 375939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375961 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 375967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 375980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375990 */     GIR_RootConstrainSelectedInstOperands,
     /* 375991 */     // GIR_Coverage, 4818,
     /* 375991 */     GIR_EraseRootFromParent_Done,
     /* 375992 */   // Label 7598: @375992
     /* 375992 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(376139), // Rule ID 13786 //
     /* 375997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376033 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376049 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376058 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376068 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376080 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376086 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376108 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 376127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376137 */     GIR_RootConstrainSelectedInstOperands,
     /* 376138 */     // GIR_Coverage, 13786,
     /* 376138 */     GIR_EraseRootFromParent_Done,
     /* 376139 */   // Label 7599: @376139
     /* 376139 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(376270), // Rule ID 6051 //
     /* 376144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376205 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 376209 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376213 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376217 */     // MIs[4] Operand 1
     /* 376217 */     // No operand predicates
     /* 376217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376221 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376223 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 376265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 376268 */     GIR_RootConstrainSelectedInstOperands,
     /* 376269 */     // GIR_Coverage, 6051,
     /* 376269 */     GIR_EraseRootFromParent_Done,
     /* 376270 */   // Label 7600: @376270
     /* 376270 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(376401), // Rule ID 6083 //
     /* 376275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376311 */     // MIs[2] Operand 1
     /* 376311 */     // No operand predicates
     /* 376311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376319 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 376323 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 376327 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376331 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376335 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 376339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376344 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 376348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376354 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376399 */     GIR_RootConstrainSelectedInstOperands,
     /* 376400 */     // GIR_Coverage, 6083,
     /* 376400 */     GIR_EraseRootFromParent_Done,
     /* 376401 */   // Label 7601: @376401
     /* 376401 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(376532), // Rule ID 6147 //
     /* 376406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376442 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376458 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376462 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376467 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 376471 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376475 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376479 */     // MIs[4] Operand 1
     /* 376479 */     // No operand predicates
     /* 376479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376485 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376497 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 376527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 376530 */     GIR_RootConstrainSelectedInstOperands,
     /* 376531 */     // GIR_Coverage, 6147,
     /* 376531 */     GIR_EraseRootFromParent_Done,
     /* 376532 */   // Label 7602: @376532
     /* 376532 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(376663), // Rule ID 6115 //
     /* 376537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376581 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376585 */     // MIs[3] Operand 1
     /* 376585 */     // No operand predicates
     /* 376585 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 376589 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376593 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376597 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 376601 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376606 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 376610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376616 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376628 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376661 */     GIR_RootConstrainSelectedInstOperands,
     /* 376662 */     // GIR_Coverage, 6115,
     /* 376662 */     GIR_EraseRootFromParent_Done,
     /* 376663 */   // Label 7603: @376663
     /* 376663 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(376798), // Rule ID 2455 //
     /* 376668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376717 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376727 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376739 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376767 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 376786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376796 */     GIR_RootConstrainSelectedInstOperands,
     /* 376797 */     // GIR_Coverage, 2455,
     /* 376797 */     GIR_EraseRootFromParent_Done,
     /* 376798 */   // Label 7604: @376798
     /* 376798 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(376917), // Rule ID 6019 //
     /* 376803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376827 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376860 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376864 */     // MIs[3] Operand 1
     /* 376864 */     // No operand predicates
     /* 376864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376870 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376882 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 376901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376915 */     GIR_RootConstrainSelectedInstOperands,
     /* 376916 */     // GIR_Coverage, 6019,
     /* 376916 */     GIR_EraseRootFromParent_Done,
     /* 376917 */   // Label 7605: @376917
     /* 376917 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(377036), // Rule ID 2537 //
     /* 376922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376954 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376958 */     // MIs[2] Operand 1
     /* 376958 */     // No operand predicates
     /* 376958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376979 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376989 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377001 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 377020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377034 */     GIR_RootConstrainSelectedInstOperands,
     /* 377035 */     // GIR_Coverage, 2537,
     /* 377035 */     GIR_EraseRootFromParent_Done,
     /* 377036 */   // Label 7606: @377036
     /* 377036 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(377136), // Rule ID 4816 //
     /* 377041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377065 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377092 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377134 */     GIR_RootConstrainSelectedInstOperands,
     /* 377135 */     // GIR_Coverage, 4816,
     /* 377135 */     GIR_EraseRootFromParent_Done,
     /* 377136 */   // Label 7607: @377136
     /* 377136 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(377236), // Rule ID 4852 //
     /* 377141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377192 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377204 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 377223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 377230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 377234 */     GIR_RootConstrainSelectedInstOperands,
     /* 377235 */     // GIR_Coverage, 4852,
     /* 377235 */     GIR_EraseRootFromParent_Done,
     /* 377236 */   // Label 7608: @377236
     /* 377236 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(377333), // Rule ID 13782 //
     /* 377241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377277 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377291 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377303 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377331 */     GIR_RootConstrainSelectedInstOperands,
     /* 377332 */     // GIR_Coverage, 13782,
     /* 377332 */     GIR_EraseRootFromParent_Done,
     /* 377333 */   // Label 7609: @377333
     /* 377333 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(377433), // Rule ID 13784 //
     /* 377338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377379 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377389 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377431 */     GIR_RootConstrainSelectedInstOperands,
     /* 377432 */     // GIR_Coverage, 13784,
     /* 377432 */     GIR_EraseRootFromParent_Done,
     /* 377433 */   // Label 7610: @377433
     /* 377433 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(377533), // Rule ID 4850 //
     /* 377438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377466 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377489 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377501 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 377520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 377531 */     GIR_RootConstrainSelectedInstOperands,
     /* 377532 */     // GIR_Coverage, 4850,
     /* 377532 */     GIR_EraseRootFromParent_Done,
     /* 377533 */   // Label 7611: @377533
     /* 377533 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(377630), // Rule ID 4814 //
     /* 377538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377588 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377628 */     GIR_RootConstrainSelectedInstOperands,
     /* 377629 */     // GIR_Coverage, 4814,
     /* 377629 */     GIR_EraseRootFromParent_Done,
     /* 377630 */   // Label 7612: @377630
     /* 377630 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(377714), // Rule ID 6081 //
     /* 377635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377671 */     // MIs[2] Operand 1
     /* 377671 */     // No operand predicates
     /* 377671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 377683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377694 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 377705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377712 */     GIR_RootConstrainSelectedInstOperands,
     /* 377713 */     // GIR_Coverage, 6081,
     /* 377713 */     GIR_EraseRootFromParent_Done,
     /* 377714 */   // Label 7613: @377714
     /* 377714 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(377795), // Rule ID 6113 //
     /* 377719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377767 */     // MIs[3] Operand 1
     /* 377767 */     // No operand predicates
     /* 377767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377777 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377793 */     GIR_RootConstrainSelectedInstOperands,
     /* 377794 */     // GIR_Coverage, 6113,
     /* 377794 */     GIR_EraseRootFromParent_Done,
     /* 377795 */   // Label 7614: @377795
     /* 377795 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(377879), // Rule ID 6145 //
     /* 377800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377853 */     // MIs[3] Operand 1
     /* 377853 */     // No operand predicates
     /* 377853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377859 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377877 */     GIR_RootConstrainSelectedInstOperands,
     /* 377878 */     // GIR_Coverage, 6145,
     /* 377878 */     GIR_EraseRootFromParent_Done,
     /* 377879 */   // Label 7615: @377879
     /* 377879 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(377960), // Rule ID 6049 //
     /* 377884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377932 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377936 */     // MIs[3] Operand 1
     /* 377936 */     // No operand predicates
     /* 377936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377942 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377958 */     GIR_RootConstrainSelectedInstOperands,
     /* 377959 */     // GIR_Coverage, 6049,
     /* 377959 */     GIR_EraseRootFromParent_Done,
     /* 377960 */   // Label 7616: @377960
     /* 377960 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(378045), // Rule ID 2453 //
     /* 377965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378003 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378043 */     GIR_RootConstrainSelectedInstOperands,
     /* 378044 */     // GIR_Coverage, 2453,
     /* 378044 */     GIR_EraseRootFromParent_Done,
     /* 378045 */   // Label 7617: @378045
     /* 378045 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(378130), // Rule ID 2451 //
     /* 378050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378088 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378100 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378128 */     GIR_RootConstrainSelectedInstOperands,
     /* 378129 */     // GIR_Coverage, 2451,
     /* 378129 */     GIR_EraseRootFromParent_Done,
     /* 378130 */   // Label 7618: @378130
     /* 378130 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(378199), // Rule ID 2535 //
     /* 378135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378171 */     // MIs[2] Operand 1
     /* 378171 */     // No operand predicates
     /* 378171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378181 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378197 */     GIR_RootConstrainSelectedInstOperands,
     /* 378198 */     // GIR_Coverage, 2535,
     /* 378198 */     GIR_EraseRootFromParent_Done,
     /* 378199 */   // Label 7619: @378199
     /* 378199 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(378268), // Rule ID 6017 //
     /* 378204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378244 */     // MIs[2] Operand 1
     /* 378244 */     // No operand predicates
     /* 378244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378250 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378266 */     GIR_RootConstrainSelectedInstOperands,
     /* 378267 */     // GIR_Coverage, 6017,
     /* 378267 */     GIR_EraseRootFromParent_Done,
     /* 378268 */   // Label 7620: @378268
     /* 378268 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(378318), // Rule ID 13228 //
     /* 378273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378303 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378316 */     GIR_RootConstrainSelectedInstOperands,
     /* 378317 */     // GIR_Coverage, 13228,
     /* 378317 */     GIR_EraseRootFromParent_Done,
     /* 378318 */   // Label 7621: @378318
     /* 378318 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(378368), // Rule ID 643 //
     /* 378323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378353 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378366 */     GIR_RootConstrainSelectedInstOperands,
     /* 378367 */     // GIR_Coverage, 643,
     /* 378367 */     GIR_EraseRootFromParent_Done,
     /* 378368 */   // Label 7622: @378368
     /* 378368 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(378418), // Rule ID 655 //
     /* 378373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 378388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378403 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 378416 */     GIR_RootConstrainSelectedInstOperands,
     /* 378417 */     // GIR_Coverage, 655,
     /* 378417 */     GIR_EraseRootFromParent_Done,
     /* 378418 */   // Label 7623: @378418
     /* 378418 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(378449), // Rule ID 637 //
     /* 378423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378438 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378443 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378447 */     GIR_RootConstrainSelectedInstOperands,
     /* 378448 */     // GIR_Coverage, 637,
     /* 378448 */     GIR_Done,
     /* 378449 */   // Label 7624: @378449
     /* 378449 */   GIM_Reject,
     /* 378450 */ // Label 7596: @378450
     /* 378450 */ GIM_Reject,
     /* 378451 */ // Label 7588: @378451
     /* 378451 */ GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(381380),
     /* 378456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 378459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 378465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378469 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(378619), // Rule ID 4860 //
     /* 378474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378498 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378523 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 378539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378546 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 378546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 378549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378558 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 378564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378586 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 378592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 378605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 378617 */     GIR_RootConstrainSelectedInstOperands,
     /* 378618 */     // GIR_Coverage, 4860,
     /* 378618 */     GIR_EraseRootFromParent_Done,
     /* 378619 */   // Label 7626: @378619
     /* 378619 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(378766), // Rule ID 4824 //
     /* 378624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378648 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378676 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378685 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 378689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378695 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 378695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 378698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378707 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 378713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 378741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 378754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378764 */     GIR_RootConstrainSelectedInstOperands,
     /* 378765 */     // GIR_Coverage, 4824,
     /* 378765 */     GIR_EraseRootFromParent_Done,
     /* 378766 */   // Label 7627: @378766
     /* 378766 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(378913), // Rule ID 13792 //
     /* 378771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378823 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378827 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378832 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 378836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378842 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 378842 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 378845 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378849 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378854 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 378860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378882 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 378888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 378901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378911 */     GIR_RootConstrainSelectedInstOperands,
     /* 378912 */     // GIR_Coverage, 13792,
     /* 378912 */     GIR_EraseRootFromParent_Done,
     /* 378913 */   // Label 7628: @378913
     /* 378913 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(379044), // Rule ID 6067 //
     /* 378918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 378983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378987 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378991 */     // MIs[4] Operand 1
     /* 378991 */     // No operand predicates
     /* 378991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378995 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 378997 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 378997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379009 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379042 */     GIR_RootConstrainSelectedInstOperands,
     /* 379043 */     // GIR_Coverage, 6067,
     /* 379043 */     GIR_EraseRootFromParent_Done,
     /* 379044 */   // Label 7629: @379044
     /* 379044 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(379175), // Rule ID 6099 //
     /* 379049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379085 */     // MIs[2] Operand 1
     /* 379085 */     // No operand predicates
     /* 379085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379093 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 379097 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 379101 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379105 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379109 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379113 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379118 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379128 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379140 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379173 */     GIR_RootConstrainSelectedInstOperands,
     /* 379174 */     // GIR_Coverage, 6099,
     /* 379174 */     GIR_EraseRootFromParent_Done,
     /* 379175 */   // Label 7630: @379175
     /* 379175 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(379306), // Rule ID 6163 //
     /* 379180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379216 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379241 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 379245 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379249 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379253 */     // MIs[4] Operand 1
     /* 379253 */     // No operand predicates
     /* 379253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379257 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379259 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379271 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379304 */     GIR_RootConstrainSelectedInstOperands,
     /* 379305 */     // GIR_Coverage, 6163,
     /* 379305 */     GIR_EraseRootFromParent_Done,
     /* 379306 */   // Label 7631: @379306
     /* 379306 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(379437), // Rule ID 6131 //
     /* 379311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379355 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379359 */     // MIs[3] Operand 1
     /* 379359 */     // No operand predicates
     /* 379359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 379363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379367 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379371 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379375 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379380 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379390 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379435 */     GIR_RootConstrainSelectedInstOperands,
     /* 379436 */     // GIR_Coverage, 6131,
     /* 379436 */     GIR_EraseRootFromParent_Done,
     /* 379437 */   // Label 7632: @379437
     /* 379437 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(379572), // Rule ID 2461 //
     /* 379442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379466 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379491 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379501 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379513 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379541 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 379560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379570 */     GIR_RootConstrainSelectedInstOperands,
     /* 379571 */     // GIR_Coverage, 2461,
     /* 379571 */     GIR_EraseRootFromParent_Done,
     /* 379572 */   // Label 7633: @379572
     /* 379572 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(379691), // Rule ID 6035 //
     /* 379577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379601 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379634 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379638 */     // MIs[3] Operand 1
     /* 379638 */     // No operand predicates
     /* 379638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379644 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 379675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379689 */     GIR_RootConstrainSelectedInstOperands,
     /* 379690 */     // GIR_Coverage, 6035,
     /* 379690 */     GIR_EraseRootFromParent_Done,
     /* 379691 */   // Label 7634: @379691
     /* 379691 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379810), // Rule ID 2553 //
     /* 379696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379732 */     // MIs[2] Operand 1
     /* 379732 */     // No operand predicates
     /* 379732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379740 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379744 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379748 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379753 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379763 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 379794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379808 */     GIR_RootConstrainSelectedInstOperands,
     /* 379809 */     // GIR_Coverage, 2553,
     /* 379809 */     GIR_EraseRootFromParent_Done,
     /* 379810 */   // Label 7635: @379810
     /* 379810 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(379910), // Rule ID 4822 //
     /* 379815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379866 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 379866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 379897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379908 */     GIR_RootConstrainSelectedInstOperands,
     /* 379909 */     // GIR_Coverage, 4822,
     /* 379909 */     GIR_EraseRootFromParent_Done,
     /* 379910 */   // Label 7636: @379910
     /* 379910 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(380010), // Rule ID 4858 //
     /* 379915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 379951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379966 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 379966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 379997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380008 */     GIR_RootConstrainSelectedInstOperands,
     /* 380009 */     // GIR_Coverage, 4858,
     /* 380009 */     GIR_EraseRootFromParent_Done,
     /* 380010 */   // Label 7637: @380010
     /* 380010 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(380107), // Rule ID 13788 //
     /* 380015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380051 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380065 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380105 */     GIR_RootConstrainSelectedInstOperands,
     /* 380106 */     // GIR_Coverage, 13788,
     /* 380106 */     GIR_EraseRootFromParent_Done,
     /* 380107 */   // Label 7638: @380107
     /* 380107 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(380207), // Rule ID 13790 //
     /* 380112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380163 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380175 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380205 */     GIR_RootConstrainSelectedInstOperands,
     /* 380206 */     // GIR_Coverage, 13790,
     /* 380206 */     GIR_EraseRootFromParent_Done,
     /* 380207 */   // Label 7639: @380207
     /* 380207 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(380307), // Rule ID 4856 //
     /* 380212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380240 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 380248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380263 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 380294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380305 */     GIR_RootConstrainSelectedInstOperands,
     /* 380306 */     // GIR_Coverage, 4856,
     /* 380306 */     GIR_EraseRootFromParent_Done,
     /* 380307 */   // Label 7640: @380307
     /* 380307 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(380404), // Rule ID 4820 //
     /* 380312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380362 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380402 */     GIR_RootConstrainSelectedInstOperands,
     /* 380403 */     // GIR_Coverage, 4820,
     /* 380403 */     GIR_EraseRootFromParent_Done,
     /* 380404 */   // Label 7641: @380404
     /* 380404 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(380482), // Rule ID 6185 //
     /* 380409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380454 */     // MIs[3] Operand 1
     /* 380454 */     // No operand predicates
     /* 380454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380464 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380480 */     GIR_RootConstrainSelectedInstOperands,
     /* 380481 */     // GIR_Coverage, 6185,
     /* 380481 */     GIR_EraseRootFromParent_Done,
     /* 380482 */   // Label 7642: @380482
     /* 380482 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(380566), // Rule ID 6097 //
     /* 380487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380523 */     // MIs[2] Operand 1
     /* 380523 */     // No operand predicates
     /* 380523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 380535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380546 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 380557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380564 */     GIR_RootConstrainSelectedInstOperands,
     /* 380565 */     // GIR_Coverage, 6097,
     /* 380565 */     GIR_EraseRootFromParent_Done,
     /* 380566 */   // Label 7643: @380566
     /* 380566 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(380647), // Rule ID 6129 //
     /* 380571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380615 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380619 */     // MIs[3] Operand 1
     /* 380619 */     // No operand predicates
     /* 380619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380629 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380645 */     GIR_RootConstrainSelectedInstOperands,
     /* 380646 */     // GIR_Coverage, 6129,
     /* 380646 */     GIR_EraseRootFromParent_Done,
     /* 380647 */   // Label 7644: @380647
     /* 380647 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(380731), // Rule ID 6161 //
     /* 380652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380701 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380705 */     // MIs[3] Operand 1
     /* 380705 */     // No operand predicates
     /* 380705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380711 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 380722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380729 */     GIR_RootConstrainSelectedInstOperands,
     /* 380730 */     // GIR_Coverage, 6161,
     /* 380730 */     GIR_EraseRootFromParent_Done,
     /* 380731 */   // Label 7645: @380731
     /* 380731 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(380809), // Rule ID 6207 //
     /* 380736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380781 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380785 */     // MIs[3] Operand 1
     /* 380785 */     // No operand predicates
     /* 380785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380791 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380807 */     GIR_RootConstrainSelectedInstOperands,
     /* 380808 */     // GIR_Coverage, 6207,
     /* 380808 */     GIR_EraseRootFromParent_Done,
     /* 380809 */   // Label 7646: @380809
     /* 380809 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(380890), // Rule ID 6065 //
     /* 380814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380862 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380866 */     // MIs[3] Operand 1
     /* 380866 */     // No operand predicates
     /* 380866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380872 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380888 */     GIR_RootConstrainSelectedInstOperands,
     /* 380889 */     // GIR_Coverage, 6065,
     /* 380889 */     GIR_EraseRootFromParent_Done,
     /* 380890 */   // Label 7647: @380890
     /* 380890 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(380975), // Rule ID 2459 //
     /* 380895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380919 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380933 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 380964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380973 */     GIR_RootConstrainSelectedInstOperands,
     /* 380974 */     // GIR_Coverage, 2459,
     /* 380974 */     GIR_EraseRootFromParent_Done,
     /* 380975 */   // Label 7648: @380975
     /* 380975 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(381060), // Rule ID 2457 //
     /* 380980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381018 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381030 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381058 */     GIR_RootConstrainSelectedInstOperands,
     /* 381059 */     // GIR_Coverage, 2457,
     /* 381059 */     GIR_EraseRootFromParent_Done,
     /* 381060 */   // Label 7649: @381060
     /* 381060 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(381129), // Rule ID 2551 //
     /* 381065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381101 */     // MIs[2] Operand 1
     /* 381101 */     // No operand predicates
     /* 381101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381111 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381127 */     GIR_RootConstrainSelectedInstOperands,
     /* 381128 */     // GIR_Coverage, 2551,
     /* 381128 */     GIR_EraseRootFromParent_Done,
     /* 381129 */   // Label 7650: @381129
     /* 381129 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(381198), // Rule ID 6033 //
     /* 381134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381174 */     // MIs[2] Operand 1
     /* 381174 */     // No operand predicates
     /* 381174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381180 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381196 */     GIR_RootConstrainSelectedInstOperands,
     /* 381197 */     // GIR_Coverage, 6033,
     /* 381197 */     GIR_EraseRootFromParent_Done,
     /* 381198 */   // Label 7651: @381198
     /* 381198 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(381248), // Rule ID 13230 //
     /* 381203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381233 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381246 */     GIR_RootConstrainSelectedInstOperands,
     /* 381247 */     // GIR_Coverage, 13230,
     /* 381247 */     GIR_EraseRootFromParent_Done,
     /* 381248 */   // Label 7652: @381248
     /* 381248 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(381298), // Rule ID 645 //
     /* 381253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381283 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381296 */     GIR_RootConstrainSelectedInstOperands,
     /* 381297 */     // GIR_Coverage, 645,
     /* 381297 */     GIR_EraseRootFromParent_Done,
     /* 381298 */   // Label 7653: @381298
     /* 381298 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(381348), // Rule ID 657 //
     /* 381303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 381318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381333 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 381336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 381346 */     GIR_RootConstrainSelectedInstOperands,
     /* 381347 */     // GIR_Coverage, 657,
     /* 381347 */     GIR_EraseRootFromParent_Done,
     /* 381348 */   // Label 7654: @381348
     /* 381348 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(381379), // Rule ID 639 //
     /* 381353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381368 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381377 */     GIR_RootConstrainSelectedInstOperands,
     /* 381378 */     // GIR_Coverage, 639,
     /* 381378 */     GIR_Done,
     /* 381379 */   // Label 7655: @381379
     /* 381379 */   GIM_Reject,
     /* 381380 */ // Label 7625: @381380
     /* 381380 */ GIM_Reject,
     /* 381381 */ // Label 7589: @381381
     /* 381381 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(384310),
     /* 381386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 381389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 381392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381399 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(381549), // Rule ID 4866 //
     /* 381404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381428 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 381461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 381469 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381476 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 381476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 381479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381488 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 381494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 381535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 381547 */     GIR_RootConstrainSelectedInstOperands,
     /* 381548 */     // GIR_Coverage, 4866,
     /* 381548 */     GIR_EraseRootFromParent_Done,
     /* 381549 */   // Label 7657: @381549
     /* 381549 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(381696), // Rule ID 4830 //
     /* 381554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 381594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381615 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381625 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 381625 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 381628 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381632 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381637 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 381643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 381684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381694 */     GIR_RootConstrainSelectedInstOperands,
     /* 381695 */     // GIR_Coverage, 4830,
     /* 381695 */     GIR_EraseRootFromParent_Done,
     /* 381696 */   // Label 7658: @381696
     /* 381696 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(381843), // Rule ID 13798 //
     /* 381701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 381716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381737 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381762 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381772 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 381772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 381775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381784 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 381790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 381831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381841 */     GIR_RootConstrainSelectedInstOperands,
     /* 381842 */     // GIR_Coverage, 13798,
     /* 381842 */     GIR_EraseRootFromParent_Done,
     /* 381843 */   // Label 7659: @381843
     /* 381843 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(381974), // Rule ID 6071 //
     /* 381848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381872 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 381888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381909 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 381913 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381917 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 381921 */     // MIs[4] Operand 1
     /* 381921 */     // No operand predicates
     /* 381921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381927 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 381927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381939 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 381958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 381969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 381972 */     GIR_RootConstrainSelectedInstOperands,
     /* 381973 */     // GIR_Coverage, 6071,
     /* 381973 */     GIR_EraseRootFromParent_Done,
     /* 381974 */   // Label 7660: @381974
     /* 381974 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(382105), // Rule ID 6103 //
     /* 381979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382011 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382015 */     // MIs[2] Operand 1
     /* 382015 */     // No operand predicates
     /* 382015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 382027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 382031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382035 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382039 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382043 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382048 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382056 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382058 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382103 */     GIR_RootConstrainSelectedInstOperands,
     /* 382104 */     // GIR_Coverage, 6103,
     /* 382104 */     GIR_EraseRootFromParent_Done,
     /* 382105 */   // Label 7661: @382105
     /* 382105 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(382236), // Rule ID 6167 //
     /* 382110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382146 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382166 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382171 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382175 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382179 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382183 */     // MIs[4] Operand 1
     /* 382183 */     // No operand predicates
     /* 382183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382187 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382189 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382234 */     GIR_RootConstrainSelectedInstOperands,
     /* 382235 */     // GIR_Coverage, 6167,
     /* 382235 */     GIR_EraseRootFromParent_Done,
     /* 382236 */   // Label 7662: @382236
     /* 382236 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(382367), // Rule ID 6135 //
     /* 382241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382289 */     // MIs[3] Operand 1
     /* 382289 */     // No operand predicates
     /* 382289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 382293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382297 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382301 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382305 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382310 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382320 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382332 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382365 */     GIR_RootConstrainSelectedInstOperands,
     /* 382366 */     // GIR_Coverage, 6135,
     /* 382366 */     GIR_EraseRootFromParent_Done,
     /* 382367 */   // Label 7663: @382367
     /* 382367 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(382502), // Rule ID 2467 //
     /* 382372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382421 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382431 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382443 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382454 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382471 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 382490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382500 */     GIR_RootConstrainSelectedInstOperands,
     /* 382501 */     // GIR_Coverage, 2467,
     /* 382501 */     GIR_EraseRootFromParent_Done,
     /* 382502 */   // Label 7664: @382502
     /* 382502 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(382621), // Rule ID 6039 //
     /* 382507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382564 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382568 */     // MIs[3] Operand 1
     /* 382568 */     // No operand predicates
     /* 382568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382574 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382586 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 382605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382619 */     GIR_RootConstrainSelectedInstOperands,
     /* 382620 */     // GIR_Coverage, 6039,
     /* 382620 */     GIR_EraseRootFromParent_Done,
     /* 382621 */   // Label 7665: @382621
     /* 382621 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(382740), // Rule ID 2557 //
     /* 382626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382658 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382662 */     // MIs[2] Operand 1
     /* 382662 */     // No operand predicates
     /* 382662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382683 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382693 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 382724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382738 */     GIR_RootConstrainSelectedInstOperands,
     /* 382739 */     // GIR_Coverage, 2557,
     /* 382739 */     GIR_EraseRootFromParent_Done,
     /* 382740 */   // Label 7666: @382740
     /* 382740 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(382840), // Rule ID 4828 //
     /* 382745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382769 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382796 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 382796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382808 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382838 */     GIR_RootConstrainSelectedInstOperands,
     /* 382839 */     // GIR_Coverage, 4828,
     /* 382839 */     GIR_EraseRootFromParent_Done,
     /* 382840 */   // Label 7667: @382840
     /* 382840 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(382940), // Rule ID 4864 //
     /* 382845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 382881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382896 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 382896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382908 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 382927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 382938 */     GIR_RootConstrainSelectedInstOperands,
     /* 382939 */     // GIR_Coverage, 4864,
     /* 382939 */     GIR_EraseRootFromParent_Done,
     /* 382940 */   // Label 7668: @382940
     /* 382940 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383037), // Rule ID 13794 //
     /* 382945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382981 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382995 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383007 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383035 */     GIR_RootConstrainSelectedInstOperands,
     /* 383036 */     // GIR_Coverage, 13794,
     /* 383036 */     GIR_EraseRootFromParent_Done,
     /* 383037 */   // Label 7669: @383037
     /* 383037 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383137), // Rule ID 13796 //
     /* 383042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383083 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383093 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383105 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383135 */     GIR_RootConstrainSelectedInstOperands,
     /* 383136 */     // GIR_Coverage, 13796,
     /* 383136 */     GIR_EraseRootFromParent_Done,
     /* 383137 */   // Label 7670: @383137
     /* 383137 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(383237), // Rule ID 4862 //
     /* 383142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383170 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383193 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 383224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383235 */     GIR_RootConstrainSelectedInstOperands,
     /* 383236 */     // GIR_Coverage, 4862,
     /* 383236 */     GIR_EraseRootFromParent_Done,
     /* 383237 */   // Label 7671: @383237
     /* 383237 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(383334), // Rule ID 4826 //
     /* 383242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383292 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383332 */     GIR_RootConstrainSelectedInstOperands,
     /* 383333 */     // GIR_Coverage, 4826,
     /* 383333 */     GIR_EraseRootFromParent_Done,
     /* 383334 */   // Label 7672: @383334
     /* 383334 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(383412), // Rule ID 6189 //
     /* 383339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 383376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 383384 */     // MIs[3] Operand 1
     /* 383384 */     // No operand predicates
     /* 383384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383394 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383410 */     GIR_RootConstrainSelectedInstOperands,
     /* 383411 */     // GIR_Coverage, 6189,
     /* 383411 */     GIR_EraseRootFromParent_Done,
     /* 383412 */   // Label 7673: @383412
     /* 383412 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(383496), // Rule ID 6101 //
     /* 383417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383453 */     // MIs[2] Operand 1
     /* 383453 */     // No operand predicates
     /* 383453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383461 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 383465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383476 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 383487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383494 */     GIR_RootConstrainSelectedInstOperands,
     /* 383495 */     // GIR_Coverage, 6101,
     /* 383495 */     GIR_EraseRootFromParent_Done,
     /* 383496 */   // Label 7674: @383496
     /* 383496 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(383577), // Rule ID 6133 //
     /* 383501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383549 */     // MIs[3] Operand 1
     /* 383549 */     // No operand predicates
     /* 383549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383559 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383575 */     GIR_RootConstrainSelectedInstOperands,
     /* 383576 */     // GIR_Coverage, 6133,
     /* 383576 */     GIR_EraseRootFromParent_Done,
     /* 383577 */   // Label 7675: @383577
     /* 383577 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(383661), // Rule ID 6165 //
     /* 383582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383631 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383635 */     // MIs[3] Operand 1
     /* 383635 */     // No operand predicates
     /* 383635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383641 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383659 */     GIR_RootConstrainSelectedInstOperands,
     /* 383660 */     // GIR_Coverage, 6165,
     /* 383660 */     GIR_EraseRootFromParent_Done,
     /* 383661 */   // Label 7676: @383661
     /* 383661 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383739), // Rule ID 6211 //
     /* 383666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 383707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 383715 */     // MIs[3] Operand 1
     /* 383715 */     // No operand predicates
     /* 383715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383721 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383737 */     GIR_RootConstrainSelectedInstOperands,
     /* 383738 */     // GIR_Coverage, 6211,
     /* 383738 */     GIR_EraseRootFromParent_Done,
     /* 383739 */   // Label 7677: @383739
     /* 383739 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(383820), // Rule ID 6069 //
     /* 383744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383792 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383796 */     // MIs[3] Operand 1
     /* 383796 */     // No operand predicates
     /* 383796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383802 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383818 */     GIR_RootConstrainSelectedInstOperands,
     /* 383819 */     // GIR_Coverage, 6069,
     /* 383819 */     GIR_EraseRootFromParent_Done,
     /* 383820 */   // Label 7678: @383820
     /* 383820 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(383905), // Rule ID 2465 //
     /* 383825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383849 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383863 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 383894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383903 */     GIR_RootConstrainSelectedInstOperands,
     /* 383904 */     // GIR_Coverage, 2465,
     /* 383904 */     GIR_EraseRootFromParent_Done,
     /* 383905 */   // Label 7679: @383905
     /* 383905 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(383990), // Rule ID 2463 //
     /* 383910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383938 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383948 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 383979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383988 */     GIR_RootConstrainSelectedInstOperands,
     /* 383989 */     // GIR_Coverage, 2463,
     /* 383989 */     GIR_EraseRootFromParent_Done,
     /* 383990 */   // Label 7680: @383990
     /* 383990 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(384059), // Rule ID 2555 //
     /* 383995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384031 */     // MIs[2] Operand 1
     /* 384031 */     // No operand predicates
     /* 384031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384041 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384057 */     GIR_RootConstrainSelectedInstOperands,
     /* 384058 */     // GIR_Coverage, 2555,
     /* 384058 */     GIR_EraseRootFromParent_Done,
     /* 384059 */   // Label 7681: @384059
     /* 384059 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(384128), // Rule ID 6037 //
     /* 384064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384100 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384104 */     // MIs[2] Operand 1
     /* 384104 */     // No operand predicates
     /* 384104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384110 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384126 */     GIR_RootConstrainSelectedInstOperands,
     /* 384127 */     // GIR_Coverage, 6037,
     /* 384127 */     GIR_EraseRootFromParent_Done,
     /* 384128 */   // Label 7682: @384128
     /* 384128 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(384178), // Rule ID 13232 //
     /* 384133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384163 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384176 */     GIR_RootConstrainSelectedInstOperands,
     /* 384177 */     // GIR_Coverage, 13232,
     /* 384177 */     GIR_EraseRootFromParent_Done,
     /* 384178 */   // Label 7683: @384178
     /* 384178 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(384228), // Rule ID 647 //
     /* 384183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384213 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384226 */     GIR_RootConstrainSelectedInstOperands,
     /* 384227 */     // GIR_Coverage, 647,
     /* 384227 */     GIR_EraseRootFromParent_Done,
     /* 384228 */   // Label 7684: @384228
     /* 384228 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(384278), // Rule ID 659 //
     /* 384233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 384248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384263 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 384266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 384276 */     GIR_RootConstrainSelectedInstOperands,
     /* 384277 */     // GIR_Coverage, 659,
     /* 384277 */     GIR_EraseRootFromParent_Done,
     /* 384278 */   // Label 7685: @384278
     /* 384278 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(384309), // Rule ID 641 //
     /* 384283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384298 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384307 */     GIR_RootConstrainSelectedInstOperands,
     /* 384308 */     // GIR_Coverage, 641,
     /* 384308 */     GIR_Done,
     /* 384309 */   // Label 7686: @384309
     /* 384309 */   GIM_Reject,
     /* 384310 */ // Label 7656: @384310
     /* 384310 */ GIM_Reject,
     /* 384311 */ // Label 7590: @384311
     /* 384311 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(385831),
     /* 384316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 384322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 384325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384329 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(384407), // Rule ID 6169 //
     /* 384334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384379 */     // MIs[3] Operand 1
     /* 384379 */     // No operand predicates
     /* 384379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384389 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384405 */     GIR_RootConstrainSelectedInstOperands,
     /* 384406 */     // GIR_Coverage, 6169,
     /* 384406 */     GIR_EraseRootFromParent_Done,
     /* 384407 */   // Label 7688: @384407
     /* 384407 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(384491), // Rule ID 6085 //
     /* 384412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384448 */     // MIs[2] Operand 1
     /* 384448 */     // No operand predicates
     /* 384448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384471 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384489 */     GIR_RootConstrainSelectedInstOperands,
     /* 384490 */     // GIR_Coverage, 6085,
     /* 384490 */     GIR_EraseRootFromParent_Done,
     /* 384491 */   // Label 7689: @384491
     /* 384491 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(384572), // Rule ID 6117 //
     /* 384496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384544 */     // MIs[3] Operand 1
     /* 384544 */     // No operand predicates
     /* 384544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384554 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384570 */     GIR_RootConstrainSelectedInstOperands,
     /* 384571 */     // GIR_Coverage, 6117,
     /* 384571 */     GIR_EraseRootFromParent_Done,
     /* 384572 */   // Label 7690: @384572
     /* 384572 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(384656), // Rule ID 6149 //
     /* 384577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384626 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384630 */     // MIs[3] Operand 1
     /* 384630 */     // No operand predicates
     /* 384630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384636 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384654 */     GIR_RootConstrainSelectedInstOperands,
     /* 384655 */     // GIR_Coverage, 6149,
     /* 384655 */     GIR_EraseRootFromParent_Done,
     /* 384656 */   // Label 7691: @384656
     /* 384656 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(384734), // Rule ID 6191 //
     /* 384661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384710 */     // MIs[3] Operand 1
     /* 384710 */     // No operand predicates
     /* 384710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384716 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384732 */     GIR_RootConstrainSelectedInstOperands,
     /* 384733 */     // GIR_Coverage, 6191,
     /* 384733 */     GIR_EraseRootFromParent_Done,
     /* 384734 */   // Label 7692: @384734
     /* 384734 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(384815), // Rule ID 6053 //
     /* 384739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384791 */     // MIs[3] Operand 1
     /* 384791 */     // No operand predicates
     /* 384791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384797 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384813 */     GIR_RootConstrainSelectedInstOperands,
     /* 384814 */     // GIR_Coverage, 6053,
     /* 384814 */     GIR_EraseRootFromParent_Done,
     /* 384815 */   // Label 7693: @384815
     /* 384815 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(384884), // Rule ID 2539 //
     /* 384820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384856 */     // MIs[2] Operand 1
     /* 384856 */     // No operand predicates
     /* 384856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384866 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 384869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384882 */     GIR_RootConstrainSelectedInstOperands,
     /* 384883 */     // GIR_Coverage, 2539,
     /* 384883 */     GIR_EraseRootFromParent_Done,
     /* 384884 */   // Label 7694: @384884
     /* 384884 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(384953), // Rule ID 6021 //
     /* 384889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384929 */     // MIs[2] Operand 1
     /* 384929 */     // No operand predicates
     /* 384929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384935 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 384938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384951 */     GIR_RootConstrainSelectedInstOperands,
     /* 384952 */     // GIR_Coverage, 6021,
     /* 384952 */     GIR_EraseRootFromParent_Done,
     /* 384953 */   // Label 7695: @384953
     /* 384953 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(385046), // Rule ID 6173 //
     /* 384958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 384966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384997 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385044 */     GIR_RootConstrainSelectedInstOperands,
     /* 385045 */     // GIR_Coverage, 6173,
     /* 385045 */     GIR_EraseRootFromParent_Done,
     /* 385046 */   // Label 7696: @385046
     /* 385046 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(385145), // Rule ID 6087 //
     /* 385051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385094 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 385137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385143 */     GIR_RootConstrainSelectedInstOperands,
     /* 385144 */     // GIR_Coverage, 6087,
     /* 385144 */     GIR_EraseRootFromParent_Done,
     /* 385145 */   // Label 7697: @385145
     /* 385145 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(385241), // Rule ID 6119 //
     /* 385150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385192 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385239 */     GIR_RootConstrainSelectedInstOperands,
     /* 385240 */     // GIR_Coverage, 6119,
     /* 385240 */     GIR_EraseRootFromParent_Done,
     /* 385241 */   // Label 7698: @385241
     /* 385241 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(385340), // Rule ID 6151 //
     /* 385246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385289 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385338 */     GIR_RootConstrainSelectedInstOperands,
     /* 385339 */     // GIR_Coverage, 6151,
     /* 385339 */     GIR_EraseRootFromParent_Done,
     /* 385340 */   // Label 7699: @385340
     /* 385340 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(385433), // Rule ID 6195 //
     /* 385345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385384 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385431 */     GIR_RootConstrainSelectedInstOperands,
     /* 385432 */     // GIR_Coverage, 6195,
     /* 385432 */     GIR_EraseRootFromParent_Done,
     /* 385433 */   // Label 7700: @385433
     /* 385433 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(385529), // Rule ID 6055 //
     /* 385438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385480 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385527 */     GIR_RootConstrainSelectedInstOperands,
     /* 385528 */     // GIR_Coverage, 6055,
     /* 385528 */     GIR_EraseRootFromParent_Done,
     /* 385529 */   // Label 7701: @385529
     /* 385529 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(385613), // Rule ID 2541 //
     /* 385534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385564 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385611 */     GIR_RootConstrainSelectedInstOperands,
     /* 385612 */     // GIR_Coverage, 2541,
     /* 385612 */     GIR_EraseRootFromParent_Done,
     /* 385613 */   // Label 7702: @385613
     /* 385613 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(385663), // Rule ID 13262 //
     /* 385618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385648 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 385648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 385651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385661 */     GIR_RootConstrainSelectedInstOperands,
     /* 385662 */     // GIR_Coverage, 13262,
     /* 385662 */     GIR_EraseRootFromParent_Done,
     /* 385663 */   // Label 7703: @385663
     /* 385663 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(385747), // Rule ID 6023 //
     /* 385668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385698 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385745 */     GIR_RootConstrainSelectedInstOperands,
     /* 385746 */     // GIR_Coverage, 6023,
     /* 385746 */     GIR_EraseRootFromParent_Done,
     /* 385747 */   // Label 7704: @385747
     /* 385747 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(385797), // Rule ID 1307 //
     /* 385752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385782 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 385782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 385785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385795 */     GIR_RootConstrainSelectedInstOperands,
     /* 385796 */     // GIR_Coverage, 1307,
     /* 385796 */     GIR_EraseRootFromParent_Done,
     /* 385797 */   // Label 7705: @385797
     /* 385797 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(385830), // Rule ID 1297 //
     /* 385802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385817 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 385817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 385820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 385828 */     GIR_RootConstrainSelectedInstOperands,
     /* 385829 */     // GIR_Coverage, 1297,
     /* 385829 */     GIR_EraseRootFromParent_Done,
     /* 385830 */   // Label 7706: @385830
     /* 385830 */   GIM_Reject,
     /* 385831 */ // Label 7687: @385831
     /* 385831 */ GIM_Reject,
     /* 385832 */ // Label 7591: @385832
     /* 385832 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(387352),
     /* 385837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 385843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 385846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385850 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(385928), // Rule ID 6181 //
     /* 385855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 385863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385896 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385900 */     // MIs[3] Operand 1
     /* 385900 */     // No operand predicates
     /* 385900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385910 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 385913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385926 */     GIR_RootConstrainSelectedInstOperands,
     /* 385927 */     // GIR_Coverage, 6181,
     /* 385927 */     GIR_EraseRootFromParent_Done,
     /* 385928 */   // Label 7708: @385928
     /* 385928 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(386012), // Rule ID 6093 //
     /* 385933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 385944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385965 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385969 */     // MIs[2] Operand 1
     /* 385969 */     // No operand predicates
     /* 385969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385977 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385992 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 385995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 386003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386010 */     GIR_RootConstrainSelectedInstOperands,
     /* 386011 */     // GIR_Coverage, 6093,
     /* 386011 */     GIR_EraseRootFromParent_Done,
     /* 386012 */   // Label 7709: @386012
     /* 386012 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(386093), // Rule ID 6125 //
     /* 386017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386061 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386065 */     // MIs[3] Operand 1
     /* 386065 */     // No operand predicates
     /* 386065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386075 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386091 */     GIR_RootConstrainSelectedInstOperands,
     /* 386092 */     // GIR_Coverage, 6125,
     /* 386092 */     GIR_EraseRootFromParent_Done,
     /* 386093 */   // Label 7710: @386093
     /* 386093 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(386177), // Rule ID 6157 //
     /* 386098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386147 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386151 */     // MIs[3] Operand 1
     /* 386151 */     // No operand predicates
     /* 386151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386157 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386175 */     GIR_RootConstrainSelectedInstOperands,
     /* 386176 */     // GIR_Coverage, 6157,
     /* 386176 */     GIR_EraseRootFromParent_Done,
     /* 386177 */   // Label 7711: @386177
     /* 386177 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(386255), // Rule ID 6203 //
     /* 386182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 386223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386231 */     // MIs[3] Operand 1
     /* 386231 */     // No operand predicates
     /* 386231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386237 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386253 */     GIR_RootConstrainSelectedInstOperands,
     /* 386254 */     // GIR_Coverage, 6203,
     /* 386254 */     GIR_EraseRootFromParent_Done,
     /* 386255 */   // Label 7712: @386255
     /* 386255 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(386336), // Rule ID 6061 //
     /* 386260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386312 */     // MIs[3] Operand 1
     /* 386312 */     // No operand predicates
     /* 386312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386318 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386334 */     GIR_RootConstrainSelectedInstOperands,
     /* 386335 */     // GIR_Coverage, 6061,
     /* 386335 */     GIR_EraseRootFromParent_Done,
     /* 386336 */   // Label 7713: @386336
     /* 386336 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(386405), // Rule ID 2547 //
     /* 386341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386377 */     // MIs[2] Operand 1
     /* 386377 */     // No operand predicates
     /* 386377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386387 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 386390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386403 */     GIR_RootConstrainSelectedInstOperands,
     /* 386404 */     // GIR_Coverage, 2547,
     /* 386404 */     GIR_EraseRootFromParent_Done,
     /* 386405 */   // Label 7714: @386405
     /* 386405 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(386474), // Rule ID 6029 //
     /* 386410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386450 */     // MIs[2] Operand 1
     /* 386450 */     // No operand predicates
     /* 386450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386456 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 386459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386472 */     GIR_RootConstrainSelectedInstOperands,
     /* 386473 */     // GIR_Coverage, 6029,
     /* 386473 */     GIR_EraseRootFromParent_Done,
     /* 386474 */   // Label 7715: @386474
     /* 386474 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(386567), // Rule ID 6183 //
     /* 386479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386518 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386565 */     GIR_RootConstrainSelectedInstOperands,
     /* 386566 */     // GIR_Coverage, 6183,
     /* 386566 */     GIR_EraseRootFromParent_Done,
     /* 386567 */   // Label 7716: @386567
     /* 386567 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(386666), // Rule ID 6095 //
     /* 386572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386615 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 386658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386664 */     GIR_RootConstrainSelectedInstOperands,
     /* 386665 */     // GIR_Coverage, 6095,
     /* 386665 */     GIR_EraseRootFromParent_Done,
     /* 386666 */   // Label 7717: @386666
     /* 386666 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(386762), // Rule ID 6127 //
     /* 386671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386713 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386760 */     GIR_RootConstrainSelectedInstOperands,
     /* 386761 */     // GIR_Coverage, 6127,
     /* 386761 */     GIR_EraseRootFromParent_Done,
     /* 386762 */   // Label 7718: @386762
     /* 386762 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(386861), // Rule ID 6159 //
     /* 386767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386810 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386859 */     GIR_RootConstrainSelectedInstOperands,
     /* 386860 */     // GIR_Coverage, 6159,
     /* 386860 */     GIR_EraseRootFromParent_Done,
     /* 386861 */   // Label 7719: @386861
     /* 386861 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(386954), // Rule ID 6205 //
     /* 386866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386905 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386952 */     GIR_RootConstrainSelectedInstOperands,
     /* 386953 */     // GIR_Coverage, 6205,
     /* 386953 */     GIR_EraseRootFromParent_Done,
     /* 386954 */   // Label 7720: @386954
     /* 386954 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(387050), // Rule ID 6063 //
     /* 386959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387001 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387048 */     GIR_RootConstrainSelectedInstOperands,
     /* 387049 */     // GIR_Coverage, 6063,
     /* 387049 */     GIR_EraseRootFromParent_Done,
     /* 387050 */   // Label 7721: @387050
     /* 387050 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(387134), // Rule ID 2549 //
     /* 387055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387085 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387132 */     GIR_RootConstrainSelectedInstOperands,
     /* 387133 */     // GIR_Coverage, 2549,
     /* 387133 */     GIR_EraseRootFromParent_Done,
     /* 387134 */   // Label 7722: @387134
     /* 387134 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(387184), // Rule ID 13266 //
     /* 387139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387169 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 387172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387182 */     GIR_RootConstrainSelectedInstOperands,
     /* 387183 */     // GIR_Coverage, 13266,
     /* 387183 */     GIR_EraseRootFromParent_Done,
     /* 387184 */   // Label 7723: @387184
     /* 387184 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(387268), // Rule ID 6031 //
     /* 387189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387219 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387266 */     GIR_RootConstrainSelectedInstOperands,
     /* 387267 */     // GIR_Coverage, 6031,
     /* 387267 */     GIR_EraseRootFromParent_Done,
     /* 387268 */   // Label 7724: @387268
     /* 387268 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(387318), // Rule ID 1311 //
     /* 387273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387303 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 387306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387316 */     GIR_RootConstrainSelectedInstOperands,
     /* 387317 */     // GIR_Coverage, 1311,
     /* 387317 */     GIR_EraseRootFromParent_Done,
     /* 387318 */   // Label 7725: @387318
     /* 387318 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(387351), // Rule ID 1301 //
     /* 387323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387338 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 387341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 387349 */     GIR_RootConstrainSelectedInstOperands,
     /* 387350 */     // GIR_Coverage, 1301,
     /* 387350 */     GIR_EraseRootFromParent_Done,
     /* 387351 */   // Label 7726: @387351
     /* 387351 */   GIM_Reject,
     /* 387352 */ // Label 7707: @387352
     /* 387352 */ GIM_Reject,
     /* 387353 */ // Label 7592: @387353
     /* 387353 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(388531),
     /* 387358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 387364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 387367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387371 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(387455), // Rule ID 6077 //
     /* 387376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387412 */     // MIs[2] Operand 1
     /* 387412 */     // No operand predicates
     /* 387412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387420 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387424 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387435 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 387446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387453 */     GIR_RootConstrainSelectedInstOperands,
     /* 387454 */     // GIR_Coverage, 6077,
     /* 387454 */     GIR_EraseRootFromParent_Done,
     /* 387455 */   // Label 7728: @387455
     /* 387455 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(387536), // Rule ID 6109 //
     /* 387460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387508 */     // MIs[3] Operand 1
     /* 387508 */     // No operand predicates
     /* 387508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387518 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387534 */     GIR_RootConstrainSelectedInstOperands,
     /* 387535 */     // GIR_Coverage, 6109,
     /* 387535 */     GIR_EraseRootFromParent_Done,
     /* 387536 */   // Label 7729: @387536
     /* 387536 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(387620), // Rule ID 6141 //
     /* 387541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387594 */     // MIs[3] Operand 1
     /* 387594 */     // No operand predicates
     /* 387594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387600 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387618 */     GIR_RootConstrainSelectedInstOperands,
     /* 387619 */     // GIR_Coverage, 6141,
     /* 387619 */     GIR_EraseRootFromParent_Done,
     /* 387620 */   // Label 7730: @387620
     /* 387620 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(387701), // Rule ID 6045 //
     /* 387625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387677 */     // MIs[3] Operand 1
     /* 387677 */     // No operand predicates
     /* 387677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387683 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387699 */     GIR_RootConstrainSelectedInstOperands,
     /* 387700 */     // GIR_Coverage, 6045,
     /* 387700 */     GIR_EraseRootFromParent_Done,
     /* 387701 */   // Label 7731: @387701
     /* 387701 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(387770), // Rule ID 2531 //
     /* 387706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387738 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387742 */     // MIs[2] Operand 1
     /* 387742 */     // No operand predicates
     /* 387742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387752 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 387755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387768 */     GIR_RootConstrainSelectedInstOperands,
     /* 387769 */     // GIR_Coverage, 2531,
     /* 387769 */     GIR_EraseRootFromParent_Done,
     /* 387770 */   // Label 7732: @387770
     /* 387770 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(387839), // Rule ID 6013 //
     /* 387775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387815 */     // MIs[2] Operand 1
     /* 387815 */     // No operand predicates
     /* 387815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387821 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 387824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387837 */     GIR_RootConstrainSelectedInstOperands,
     /* 387838 */     // GIR_Coverage, 6013,
     /* 387838 */     GIR_EraseRootFromParent_Done,
     /* 387839 */   // Label 7733: @387839
     /* 387839 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(387938), // Rule ID 6079 //
     /* 387844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 387864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387887 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 387890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 387909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 387919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 387930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387936 */     GIR_RootConstrainSelectedInstOperands,
     /* 387937 */     // GIR_Coverage, 6079,
     /* 387937 */     GIR_EraseRootFromParent_Done,
     /* 387938 */   // Label 7734: @387938
     /* 387938 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(388034), // Rule ID 6111 //
     /* 387943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 387975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387985 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 387988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388032 */     GIR_RootConstrainSelectedInstOperands,
     /* 388033 */     // GIR_Coverage, 6111,
     /* 388033 */     GIR_EraseRootFromParent_Done,
     /* 388034 */   // Label 7735: @388034
     /* 388034 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(388133), // Rule ID 6143 //
     /* 388039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388082 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388101 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388131 */     GIR_RootConstrainSelectedInstOperands,
     /* 388132 */     // GIR_Coverage, 6143,
     /* 388132 */     GIR_EraseRootFromParent_Done,
     /* 388133 */   // Label 7736: @388133
     /* 388133 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(388229), // Rule ID 6047 //
     /* 388138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388180 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388227 */     GIR_RootConstrainSelectedInstOperands,
     /* 388228 */     // GIR_Coverage, 6047,
     /* 388228 */     GIR_EraseRootFromParent_Done,
     /* 388229 */   // Label 7737: @388229
     /* 388229 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(388313), // Rule ID 2533 //
     /* 388234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388264 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388311 */     GIR_RootConstrainSelectedInstOperands,
     /* 388312 */     // GIR_Coverage, 2533,
     /* 388312 */     GIR_EraseRootFromParent_Done,
     /* 388313 */   // Label 7738: @388313
     /* 388313 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(388363), // Rule ID 13258 //
     /* 388318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388348 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 388351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388361 */     GIR_RootConstrainSelectedInstOperands,
     /* 388362 */     // GIR_Coverage, 13258,
     /* 388362 */     GIR_EraseRootFromParent_Done,
     /* 388363 */   // Label 7739: @388363
     /* 388363 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(388447), // Rule ID 6015 //
     /* 388368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388398 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388445 */     GIR_RootConstrainSelectedInstOperands,
     /* 388446 */     // GIR_Coverage, 6015,
     /* 388446 */     GIR_EraseRootFromParent_Done,
     /* 388447 */   // Label 7740: @388447
     /* 388447 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(388497), // Rule ID 1303 //
     /* 388452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388482 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 388485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388495 */     GIR_RootConstrainSelectedInstOperands,
     /* 388496 */     // GIR_Coverage, 1303,
     /* 388496 */     GIR_EraseRootFromParent_Done,
     /* 388497 */   // Label 7741: @388497
     /* 388497 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(388530), // Rule ID 1293 //
     /* 388502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388517 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 388520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 388528 */     GIR_RootConstrainSelectedInstOperands,
     /* 388529 */     // GIR_Coverage, 1293,
     /* 388529 */     GIR_EraseRootFromParent_Done,
     /* 388530 */   // Label 7742: @388530
     /* 388530 */   GIM_Reject,
     /* 388531 */ // Label 7727: @388531
     /* 388531 */ GIM_Reject,
     /* 388532 */ // Label 7593: @388532
     /* 388532 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(390052),
     /* 388537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 388546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388550 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(388628), // Rule ID 6175 //
     /* 388555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388596 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388600 */     // MIs[3] Operand 1
     /* 388600 */     // No operand predicates
     /* 388600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388610 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388626 */     GIR_RootConstrainSelectedInstOperands,
     /* 388627 */     // GIR_Coverage, 6175,
     /* 388627 */     GIR_EraseRootFromParent_Done,
     /* 388628 */   // Label 7744: @388628
     /* 388628 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(388712), // Rule ID 6089 //
     /* 388633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388669 */     // MIs[2] Operand 1
     /* 388669 */     // No operand predicates
     /* 388669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388681 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388692 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388710 */     GIR_RootConstrainSelectedInstOperands,
     /* 388711 */     // GIR_Coverage, 6089,
     /* 388711 */     GIR_EraseRootFromParent_Done,
     /* 388712 */   // Label 7745: @388712
     /* 388712 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(388793), // Rule ID 6121 //
     /* 388717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388761 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388765 */     // MIs[3] Operand 1
     /* 388765 */     // No operand predicates
     /* 388765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388775 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388791 */     GIR_RootConstrainSelectedInstOperands,
     /* 388792 */     // GIR_Coverage, 6121,
     /* 388792 */     GIR_EraseRootFromParent_Done,
     /* 388793 */   // Label 7746: @388793
     /* 388793 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(388877), // Rule ID 6153 //
     /* 388798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388847 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388851 */     // MIs[3] Operand 1
     /* 388851 */     // No operand predicates
     /* 388851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388857 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388875 */     GIR_RootConstrainSelectedInstOperands,
     /* 388876 */     // GIR_Coverage, 6153,
     /* 388876 */     GIR_EraseRootFromParent_Done,
     /* 388877 */   // Label 7747: @388877
     /* 388877 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(388955), // Rule ID 6197 //
     /* 388882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388931 */     // MIs[3] Operand 1
     /* 388931 */     // No operand predicates
     /* 388931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388937 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388953 */     GIR_RootConstrainSelectedInstOperands,
     /* 388954 */     // GIR_Coverage, 6197,
     /* 388954 */     GIR_EraseRootFromParent_Done,
     /* 388955 */   // Label 7748: @388955
     /* 388955 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(389036), // Rule ID 6057 //
     /* 388960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389012 */     // MIs[3] Operand 1
     /* 389012 */     // No operand predicates
     /* 389012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389018 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389034 */     GIR_RootConstrainSelectedInstOperands,
     /* 389035 */     // GIR_Coverage, 6057,
     /* 389035 */     GIR_EraseRootFromParent_Done,
     /* 389036 */   // Label 7749: @389036
     /* 389036 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(389105), // Rule ID 2543 //
     /* 389041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389073 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389077 */     // MIs[2] Operand 1
     /* 389077 */     // No operand predicates
     /* 389077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389087 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389103 */     GIR_RootConstrainSelectedInstOperands,
     /* 389104 */     // GIR_Coverage, 2543,
     /* 389104 */     GIR_EraseRootFromParent_Done,
     /* 389105 */   // Label 7750: @389105
     /* 389105 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(389174), // Rule ID 6025 //
     /* 389110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389150 */     // MIs[2] Operand 1
     /* 389150 */     // No operand predicates
     /* 389150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389156 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389172 */     GIR_RootConstrainSelectedInstOperands,
     /* 389173 */     // GIR_Coverage, 6025,
     /* 389173 */     GIR_EraseRootFromParent_Done,
     /* 389174 */   // Label 7751: @389174
     /* 389174 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(389267), // Rule ID 6179 //
     /* 389179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389218 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389265 */     GIR_RootConstrainSelectedInstOperands,
     /* 389266 */     // GIR_Coverage, 6179,
     /* 389266 */     GIR_EraseRootFromParent_Done,
     /* 389267 */   // Label 7752: @389267
     /* 389267 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(389366), // Rule ID 6091 //
     /* 389272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389315 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 389358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389364 */     GIR_RootConstrainSelectedInstOperands,
     /* 389365 */     // GIR_Coverage, 6091,
     /* 389365 */     GIR_EraseRootFromParent_Done,
     /* 389366 */   // Label 7753: @389366
     /* 389366 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(389462), // Rule ID 6123 //
     /* 389371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389413 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389460 */     GIR_RootConstrainSelectedInstOperands,
     /* 389461 */     // GIR_Coverage, 6123,
     /* 389461 */     GIR_EraseRootFromParent_Done,
     /* 389462 */   // Label 7754: @389462
     /* 389462 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(389561), // Rule ID 6155 //
     /* 389467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389510 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389559 */     GIR_RootConstrainSelectedInstOperands,
     /* 389560 */     // GIR_Coverage, 6155,
     /* 389560 */     GIR_EraseRootFromParent_Done,
     /* 389561 */   // Label 7755: @389561
     /* 389561 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(389654), // Rule ID 6201 //
     /* 389566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389605 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389617 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389624 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389652 */     GIR_RootConstrainSelectedInstOperands,
     /* 389653 */     // GIR_Coverage, 6201,
     /* 389653 */     GIR_EraseRootFromParent_Done,
     /* 389654 */   // Label 7756: @389654
     /* 389654 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(389750), // Rule ID 6059 //
     /* 389659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389701 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389748 */     GIR_RootConstrainSelectedInstOperands,
     /* 389749 */     // GIR_Coverage, 6059,
     /* 389749 */     GIR_EraseRootFromParent_Done,
     /* 389750 */   // Label 7757: @389750
     /* 389750 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(389834), // Rule ID 2545 //
     /* 389755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389785 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389832 */     GIR_RootConstrainSelectedInstOperands,
     /* 389833 */     // GIR_Coverage, 2545,
     /* 389833 */     GIR_EraseRootFromParent_Done,
     /* 389834 */   // Label 7758: @389834
     /* 389834 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(389884), // Rule ID 13264 //
     /* 389839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389869 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 389872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389882 */     GIR_RootConstrainSelectedInstOperands,
     /* 389883 */     // GIR_Coverage, 13264,
     /* 389883 */     GIR_EraseRootFromParent_Done,
     /* 389884 */   // Label 7759: @389884
     /* 389884 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(389968), // Rule ID 6027 //
     /* 389889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389919 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389966 */     GIR_RootConstrainSelectedInstOperands,
     /* 389967 */     // GIR_Coverage, 6027,
     /* 389967 */     GIR_EraseRootFromParent_Done,
     /* 389968 */   // Label 7760: @389968
     /* 389968 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(390018), // Rule ID 1309 //
     /* 389973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390003 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 390006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390016 */     GIR_RootConstrainSelectedInstOperands,
     /* 390017 */     // GIR_Coverage, 1309,
     /* 390017 */     GIR_EraseRootFromParent_Done,
     /* 390018 */   // Label 7761: @390018
     /* 390018 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(390051), // Rule ID 1299 //
     /* 390023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390038 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 390041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390049 */     GIR_RootConstrainSelectedInstOperands,
     /* 390050 */     // GIR_Coverage, 1299,
     /* 390050 */     GIR_EraseRootFromParent_Done,
     /* 390051 */   // Label 7762: @390051
     /* 390051 */   GIM_Reject,
     /* 390052 */ // Label 7743: @390052
     /* 390052 */ GIM_Reject,
     /* 390053 */ // Label 7594: @390053
     /* 390053 */ GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(391231),
     /* 390058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 390067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390071 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(390155), // Rule ID 6073 //
     /* 390076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390108 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390112 */     // MIs[2] Operand 1
     /* 390112 */     // No operand predicates
     /* 390112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 390116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390135 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390153 */     GIR_RootConstrainSelectedInstOperands,
     /* 390154 */     // GIR_Coverage, 6073,
     /* 390154 */     GIR_EraseRootFromParent_Done,
     /* 390155 */   // Label 7764: @390155
     /* 390155 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(390236), // Rule ID 6105 //
     /* 390160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390208 */     // MIs[3] Operand 1
     /* 390208 */     // No operand predicates
     /* 390208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390218 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390234 */     GIR_RootConstrainSelectedInstOperands,
     /* 390235 */     // GIR_Coverage, 6105,
     /* 390235 */     GIR_EraseRootFromParent_Done,
     /* 390236 */   // Label 7765: @390236
     /* 390236 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(390320), // Rule ID 6137 //
     /* 390241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390290 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390294 */     // MIs[3] Operand 1
     /* 390294 */     // No operand predicates
     /* 390294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390300 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390318 */     GIR_RootConstrainSelectedInstOperands,
     /* 390319 */     // GIR_Coverage, 6137,
     /* 390319 */     GIR_EraseRootFromParent_Done,
     /* 390320 */   // Label 7766: @390320
     /* 390320 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(390401), // Rule ID 6041 //
     /* 390325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390373 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390377 */     // MIs[3] Operand 1
     /* 390377 */     // No operand predicates
     /* 390377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390383 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390399 */     GIR_RootConstrainSelectedInstOperands,
     /* 390400 */     // GIR_Coverage, 6041,
     /* 390400 */     GIR_EraseRootFromParent_Done,
     /* 390401 */   // Label 7767: @390401
     /* 390401 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(390470), // Rule ID 2527 //
     /* 390406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390442 */     // MIs[2] Operand 1
     /* 390442 */     // No operand predicates
     /* 390442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390452 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 390455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390468 */     GIR_RootConstrainSelectedInstOperands,
     /* 390469 */     // GIR_Coverage, 2527,
     /* 390469 */     GIR_EraseRootFromParent_Done,
     /* 390470 */   // Label 7768: @390470
     /* 390470 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(390539), // Rule ID 6009 //
     /* 390475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390511 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390515 */     // MIs[2] Operand 1
     /* 390515 */     // No operand predicates
     /* 390515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390521 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 390524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390537 */     GIR_RootConstrainSelectedInstOperands,
     /* 390538 */     // GIR_Coverage, 6009,
     /* 390538 */     GIR_EraseRootFromParent_Done,
     /* 390539 */   // Label 7769: @390539
     /* 390539 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(390638), // Rule ID 6075 //
     /* 390544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390587 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390636 */     GIR_RootConstrainSelectedInstOperands,
     /* 390637 */     // GIR_Coverage, 6075,
     /* 390637 */     GIR_EraseRootFromParent_Done,
     /* 390638 */   // Label 7770: @390638
     /* 390638 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(390734), // Rule ID 6107 //
     /* 390643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390685 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390732 */     GIR_RootConstrainSelectedInstOperands,
     /* 390733 */     // GIR_Coverage, 6107,
     /* 390733 */     GIR_EraseRootFromParent_Done,
     /* 390734 */   // Label 7771: @390734
     /* 390734 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(390833), // Rule ID 6139 //
     /* 390739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390782 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390831 */     GIR_RootConstrainSelectedInstOperands,
     /* 390832 */     // GIR_Coverage, 6139,
     /* 390832 */     GIR_EraseRootFromParent_Done,
     /* 390833 */   // Label 7772: @390833
     /* 390833 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(390929), // Rule ID 6043 //
     /* 390838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390880 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390927 */     GIR_RootConstrainSelectedInstOperands,
     /* 390928 */     // GIR_Coverage, 6043,
     /* 390928 */     GIR_EraseRootFromParent_Done,
     /* 390929 */   // Label 7773: @390929
     /* 390929 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(391013), // Rule ID 2529 //
     /* 390934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390964 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 390999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391011 */     GIR_RootConstrainSelectedInstOperands,
     /* 391012 */     // GIR_Coverage, 2529,
     /* 391012 */     GIR_EraseRootFromParent_Done,
     /* 391013 */   // Label 7774: @391013
     /* 391013 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(391063), // Rule ID 13260 //
     /* 391018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391048 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 391051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391061 */     GIR_RootConstrainSelectedInstOperands,
     /* 391062 */     // GIR_Coverage, 13260,
     /* 391062 */     GIR_EraseRootFromParent_Done,
     /* 391063 */   // Label 7775: @391063
     /* 391063 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(391147), // Rule ID 6011 //
     /* 391068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391098 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391145 */     GIR_RootConstrainSelectedInstOperands,
     /* 391146 */     // GIR_Coverage, 6011,
     /* 391146 */     GIR_EraseRootFromParent_Done,
     /* 391147 */   // Label 7776: @391147
     /* 391147 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(391197), // Rule ID 1305 //
     /* 391152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391182 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 391185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391195 */     GIR_RootConstrainSelectedInstOperands,
     /* 391196 */     // GIR_Coverage, 1305,
     /* 391196 */     GIR_EraseRootFromParent_Done,
     /* 391197 */   // Label 7777: @391197
     /* 391197 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(391230), // Rule ID 1295 //
     /* 391202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391217 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 391220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 391228 */     GIR_RootConstrainSelectedInstOperands,
     /* 391229 */     // GIR_Coverage, 1295,
     /* 391229 */     GIR_EraseRootFromParent_Done,
     /* 391230 */   // Label 7778: @391230
     /* 391230 */   GIM_Reject,
     /* 391231 */ // Label 7763: @391231
     /* 391231 */ GIM_Reject,
     /* 391232 */ // Label 7595: @391232
     /* 391232 */ GIM_Reject,
     /* 391233 */ // Label 106: @391233
     /* 391233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7787*/ GIMT_Encode4(391532),
     /* 391244 */ /*GILLT_s16*//*Label 7779*/ GIMT_Encode4(391284),
     /* 391248 */ /*GILLT_s32*//*Label 7780*/ GIMT_Encode4(391315),
     /* 391252 */ /*GILLT_s64*//*Label 7781*/ GIMT_Encode4(391346), GIMT_Encode4(0),
     /* 391260 */ /*GILLT_v2s32*//*Label 7782*/ GIMT_Encode4(391377),
     /* 391264 */ /*GILLT_v2s64*//*Label 7783*/ GIMT_Encode4(391408),
     /* 391268 */ /*GILLT_v4s16*//*Label 7784*/ GIMT_Encode4(391439),
     /* 391272 */ /*GILLT_v4s32*//*Label 7785*/ GIMT_Encode4(391470), GIMT_Encode4(0),
     /* 391280 */ /*GILLT_v8s16*//*Label 7786*/ GIMT_Encode4(391501),
     /* 391284 */ // Label 7779: @391284
     /* 391284 */ GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(391314), // Rule ID 569 //
     /* 391289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391303 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 391303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 391308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391312 */   GIR_RootConstrainSelectedInstOperands,
     /* 391313 */   // GIR_Coverage, 569,
     /* 391313 */   GIR_Done,
     /* 391314 */ // Label 7788: @391314
     /* 391314 */ GIM_Reject,
     /* 391315 */ // Label 7780: @391315
     /* 391315 */ GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(391345), // Rule ID 571 //
     /* 391320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391334 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 391334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 391339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391343 */   GIR_RootConstrainSelectedInstOperands,
     /* 391344 */   // GIR_Coverage, 571,
     /* 391344 */   GIR_Done,
     /* 391345 */ // Label 7789: @391345
     /* 391345 */ GIM_Reject,
     /* 391346 */ // Label 7781: @391346
     /* 391346 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(391376), // Rule ID 573 //
     /* 391351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391365 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 391365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 391370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391374 */   GIR_RootConstrainSelectedInstOperands,
     /* 391375 */   // GIR_Coverage, 573,
     /* 391375 */   GIR_Done,
     /* 391376 */ // Label 7790: @391376
     /* 391376 */ GIM_Reject,
     /* 391377 */ // Label 7782: @391377
     /* 391377 */ GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(391407), // Rule ID 959 //
     /* 391382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391396 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 391401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391405 */   GIR_RootConstrainSelectedInstOperands,
     /* 391406 */   // GIR_Coverage, 959,
     /* 391406 */   GIR_Done,
     /* 391407 */ // Label 7791: @391407
     /* 391407 */ GIM_Reject,
     /* 391408 */ // Label 7783: @391408
     /* 391408 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(391438), // Rule ID 963 //
     /* 391413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391427 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 391427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 391432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391436 */   GIR_RootConstrainSelectedInstOperands,
     /* 391437 */   // GIR_Coverage, 963,
     /* 391437 */   GIR_Done,
     /* 391438 */ // Label 7792: @391438
     /* 391438 */ GIM_Reject,
     /* 391439 */ // Label 7784: @391439
     /* 391439 */ GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(391469), // Rule ID 955 //
     /* 391444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391458 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 391463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391467 */   GIR_RootConstrainSelectedInstOperands,
     /* 391468 */   // GIR_Coverage, 955,
     /* 391468 */   GIR_Done,
     /* 391469 */ // Label 7793: @391469
     /* 391469 */ GIM_Reject,
     /* 391470 */ // Label 7785: @391470
     /* 391470 */ GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(391500), // Rule ID 961 //
     /* 391475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391489 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 391494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391498 */   GIR_RootConstrainSelectedInstOperands,
     /* 391499 */   // GIR_Coverage, 961,
     /* 391499 */   GIR_Done,
     /* 391500 */ // Label 7794: @391500
     /* 391500 */ GIM_Reject,
     /* 391501 */ // Label 7786: @391501
     /* 391501 */ GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(391531), // Rule ID 957 //
     /* 391506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391520 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 391525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391529 */   GIR_RootConstrainSelectedInstOperands,
     /* 391530 */   // GIR_Coverage, 957,
     /* 391530 */   GIR_Done,
     /* 391531 */ // Label 7795: @391531
     /* 391531 */ GIM_Reject,
     /* 391532 */ // Label 7787: @391532
     /* 391532 */ GIM_Reject,
     /* 391533 */ // Label 107: @391533
     /* 391533 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(391546), // Rule ID 6488 //
     /* 391538 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 391538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 391544 */   GIR_RootConstrainSelectedInstOperands,
     /* 391545 */   // GIR_Coverage, 6488,
     /* 391545 */   GIR_EraseRootFromParent_Done,
     /* 391546 */ // Label 7796: @391546
     /* 391546 */ GIM_Reject,
     /* 391547 */ // Label 108: @391547
     /* 391547 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(391567), // Rule ID 6489 //
     /* 391552 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 391552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391555 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 391565 */   GIR_RootConstrainSelectedInstOperands,
     /* 391566 */   // GIR_Coverage, 6489,
     /* 391566 */   GIR_EraseRootFromParent_Done,
     /* 391567 */ // Label 7797: @391567
     /* 391567 */ GIM_Reject,
     /* 391568 */ // Label 109: @391568
     /* 391568 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(391592), // Rule ID 6490 //
     /* 391573 */   // MIs[0] kind
     /* 391573 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 391576 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 391581 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 391581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391584 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 391590 */   GIR_RootConstrainSelectedInstOperands,
     /* 391591 */   // GIR_Coverage, 6490,
     /* 391591 */   GIR_EraseRootFromParent_Done,
     /* 391592 */ // Label 7798: @391592
     /* 391592 */ GIM_Reject,
     /* 391593 */ // Label 110: @391593
     /* 391593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7802*/ GIMT_Encode4(391902),
     /* 391604 */ /*GILLT_s16*//*Label 7799*/ GIMT_Encode4(391616),
     /* 391608 */ /*GILLT_s32*//*Label 7800*/ GIMT_Encode4(391769),
     /* 391612 */ /*GILLT_s64*//*Label 7801*/ GIMT_Encode4(391874),
     /* 391616 */ // Label 7799: @391616
     /* 391616 */ GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(391717), // Rule ID 5593 //
     /* 391621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391635 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 391635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 391638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 391642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391647 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391651 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 391657 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 391660 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 391664 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391669 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 391672 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 391685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391690 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 391697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 391710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391715 */   GIR_RootConstrainSelectedInstOperands,
     /* 391716 */   // GIR_Coverage, 5593,
     /* 391716 */   GIR_EraseRootFromParent_Done,
     /* 391717 */ // Label 7803: @391717
     /* 391717 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(391768), // Rule ID 5594 //
     /* 391722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391736 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 391736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 391743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391748 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 391761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391766 */   GIR_RootConstrainSelectedInstOperands,
     /* 391767 */   // GIR_Coverage, 5594,
     /* 391767 */   GIR_EraseRootFromParent_Done,
     /* 391768 */ // Label 7804: @391768
     /* 391768 */ GIM_Reject,
     /* 391769 */ // Label 7800: @391769
     /* 391769 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(391846), // Rule ID 5595 //
     /* 391774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391785 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 391785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 391788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 391792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391801 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 391814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391819 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 391826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 391839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391844 */   GIR_RootConstrainSelectedInstOperands,
     /* 391845 */   // GIR_Coverage, 5595,
     /* 391845 */   GIR_EraseRootFromParent_Done,
     /* 391846 */ // Label 7805: @391846
     /* 391846 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(391873), // Rule ID 5596 //
     /* 391851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391862 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 391867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391871 */   GIR_RootConstrainSelectedInstOperands,
     /* 391872 */   // GIR_Coverage, 5596,
     /* 391872 */   GIR_Done,
     /* 391873 */ // Label 7806: @391873
     /* 391873 */ GIM_Reject,
     /* 391874 */ // Label 7801: @391874
     /* 391874 */ GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(391901), // Rule ID 5597 //
     /* 391879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391890 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 391890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 391895 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391899 */   GIR_RootConstrainSelectedInstOperands,
     /* 391900 */   // GIR_Coverage, 5597,
     /* 391900 */   GIR_Done,
     /* 391901 */ // Label 7807: @391901
     /* 391901 */ GIM_Reject,
     /* 391902 */ // Label 7802: @391902
     /* 391902 */ GIM_Reject,
     /* 391903 */ // Label 111: @391903
     /* 391903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7811*/ GIMT_Encode4(392073),
     /* 391914 */ /*GILLT_s16*//*Label 7808*/ GIMT_Encode4(391926),
     /* 391918 */ /*GILLT_s32*//*Label 7809*/ GIMT_Encode4(391987),
     /* 391922 */ /*GILLT_s64*//*Label 7810*/ GIMT_Encode4(392045),
     /* 391926 */ // Label 7808: @391926
     /* 391926 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(391956), // Rule ID 1942 //
     /* 391931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391945 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 391950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391954 */   GIR_RootConstrainSelectedInstOperands,
     /* 391955 */   // GIR_Coverage, 1942,
     /* 391955 */   GIR_Done,
     /* 391956 */ // Label 7812: @391956
     /* 391956 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(391986), // Rule ID 1944 //
     /* 391961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391975 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 391980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391984 */   GIR_RootConstrainSelectedInstOperands,
     /* 391985 */   // GIR_Coverage, 1944,
     /* 391985 */   GIR_Done,
     /* 391986 */ // Label 7813: @391986
     /* 391986 */ GIM_Reject,
     /* 391987 */ // Label 7809: @391987
     /* 391987 */ GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(392017), // Rule ID 1946 //
     /* 391992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392006 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 392011 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392015 */   GIR_RootConstrainSelectedInstOperands,
     /* 392016 */   // GIR_Coverage, 1946,
     /* 392016 */   GIR_Done,
     /* 392017 */ // Label 7814: @392017
     /* 392017 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(392044), // Rule ID 5603 //
     /* 392022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392033 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 392038 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392042 */   GIR_RootConstrainSelectedInstOperands,
     /* 392043 */   // GIR_Coverage, 5603,
     /* 392043 */   GIR_Done,
     /* 392044 */ // Label 7815: @392044
     /* 392044 */ GIM_Reject,
     /* 392045 */ // Label 7810: @392045
     /* 392045 */ GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(392072), // Rule ID 5605 //
     /* 392050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392061 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 392066 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392070 */   GIR_RootConstrainSelectedInstOperands,
     /* 392071 */   // GIR_Coverage, 5605,
     /* 392071 */   GIR_Done,
     /* 392072 */ // Label 7816: @392072
     /* 392072 */ GIM_Reject,
     /* 392073 */ // Label 7811: @392073
     /* 392073 */ GIM_Reject,
     /* 392074 */ // Label 112: @392074
     /* 392074 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7820*/ GIMT_Encode4(392244),
     /* 392085 */ /*GILLT_s16*//*Label 7817*/ GIMT_Encode4(392097),
     /* 392089 */ /*GILLT_s32*//*Label 7818*/ GIMT_Encode4(392158),
     /* 392093 */ /*GILLT_s64*//*Label 7819*/ GIMT_Encode4(392216),
     /* 392097 */ // Label 7817: @392097
     /* 392097 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(392127), // Rule ID 1954 //
     /* 392102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392116 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 392121 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392125 */   GIR_RootConstrainSelectedInstOperands,
     /* 392126 */   // GIR_Coverage, 1954,
     /* 392126 */   GIR_Done,
     /* 392127 */ // Label 7821: @392127
     /* 392127 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(392157), // Rule ID 1956 //
     /* 392132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392146 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 392151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392155 */   GIR_RootConstrainSelectedInstOperands,
     /* 392156 */   // GIR_Coverage, 1956,
     /* 392156 */   GIR_Done,
     /* 392157 */ // Label 7822: @392157
     /* 392157 */ GIM_Reject,
     /* 392158 */ // Label 7818: @392158
     /* 392158 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(392188), // Rule ID 1958 //
     /* 392163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392177 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 392182 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392186 */   GIR_RootConstrainSelectedInstOperands,
     /* 392187 */   // GIR_Coverage, 1958,
     /* 392187 */   GIR_Done,
     /* 392188 */ // Label 7823: @392188
     /* 392188 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(392215), // Rule ID 5611 //
     /* 392193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392204 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 392209 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392213 */   GIR_RootConstrainSelectedInstOperands,
     /* 392214 */   // GIR_Coverage, 5611,
     /* 392214 */   GIR_Done,
     /* 392215 */ // Label 7824: @392215
     /* 392215 */ GIM_Reject,
     /* 392216 */ // Label 7819: @392216
     /* 392216 */ GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(392243), // Rule ID 5613 //
     /* 392221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392232 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 392237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392241 */   GIR_RootConstrainSelectedInstOperands,
     /* 392242 */   // GIR_Coverage, 5613,
     /* 392242 */   GIR_Done,
     /* 392243 */ // Label 7825: @392243
     /* 392243 */ GIM_Reject,
     /* 392244 */ // Label 7820: @392244
     /* 392244 */ GIM_Reject,
     /* 392245 */ // Label 113: @392245
     /* 392245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7829*/ GIMT_Encode4(392415),
     /* 392256 */ /*GILLT_s16*//*Label 7826*/ GIMT_Encode4(392268),
     /* 392260 */ /*GILLT_s32*//*Label 7827*/ GIMT_Encode4(392329),
     /* 392264 */ /*GILLT_s64*//*Label 7828*/ GIMT_Encode4(392387),
     /* 392268 */ // Label 7826: @392268
     /* 392268 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(392298), // Rule ID 1948 //
     /* 392273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392287 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 392292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392296 */   GIR_RootConstrainSelectedInstOperands,
     /* 392297 */   // GIR_Coverage, 1948,
     /* 392297 */   GIR_Done,
     /* 392298 */ // Label 7830: @392298
     /* 392298 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(392328), // Rule ID 1950 //
     /* 392303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392317 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 392322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392326 */   GIR_RootConstrainSelectedInstOperands,
     /* 392327 */   // GIR_Coverage, 1950,
     /* 392327 */   GIR_Done,
     /* 392328 */ // Label 7831: @392328
     /* 392328 */ GIM_Reject,
     /* 392329 */ // Label 7827: @392329
     /* 392329 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(392359), // Rule ID 1952 //
     /* 392334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392348 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 392353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392357 */   GIR_RootConstrainSelectedInstOperands,
     /* 392358 */   // GIR_Coverage, 1952,
     /* 392358 */   GIR_Done,
     /* 392359 */ // Label 7832: @392359
     /* 392359 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(392386), // Rule ID 5607 //
     /* 392364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392375 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 392380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392384 */   GIR_RootConstrainSelectedInstOperands,
     /* 392385 */   // GIR_Coverage, 5607,
     /* 392385 */   GIR_Done,
     /* 392386 */ // Label 7833: @392386
     /* 392386 */ GIM_Reject,
     /* 392387 */ // Label 7828: @392387
     /* 392387 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(392414), // Rule ID 5609 //
     /* 392392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392403 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 392408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392412 */   GIR_RootConstrainSelectedInstOperands,
     /* 392413 */   // GIR_Coverage, 5609,
     /* 392413 */   GIR_Done,
     /* 392414 */ // Label 7834: @392414
     /* 392414 */ GIM_Reject,
     /* 392415 */ // Label 7829: @392415
     /* 392415 */ GIM_Reject,
     /* 392416 */ // Label 114: @392416
     /* 392416 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7838*/ GIMT_Encode4(392586),
     /* 392427 */ /*GILLT_s16*//*Label 7835*/ GIMT_Encode4(392439),
     /* 392431 */ /*GILLT_s32*//*Label 7836*/ GIMT_Encode4(392500),
     /* 392435 */ /*GILLT_s64*//*Label 7837*/ GIMT_Encode4(392558),
     /* 392439 */ // Label 7835: @392439
     /* 392439 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(392469), // Rule ID 1960 //
     /* 392444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392458 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 392463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392467 */   GIR_RootConstrainSelectedInstOperands,
     /* 392468 */   // GIR_Coverage, 1960,
     /* 392468 */   GIR_Done,
     /* 392469 */ // Label 7839: @392469
     /* 392469 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(392499), // Rule ID 1962 //
     /* 392474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392488 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 392493 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392497 */   GIR_RootConstrainSelectedInstOperands,
     /* 392498 */   // GIR_Coverage, 1962,
     /* 392498 */   GIR_Done,
     /* 392499 */ // Label 7840: @392499
     /* 392499 */ GIM_Reject,
     /* 392500 */ // Label 7836: @392500
     /* 392500 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(392530), // Rule ID 1964 //
     /* 392505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392519 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 392524 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392528 */   GIR_RootConstrainSelectedInstOperands,
     /* 392529 */   // GIR_Coverage, 1964,
     /* 392529 */   GIR_Done,
     /* 392530 */ // Label 7841: @392530
     /* 392530 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(392557), // Rule ID 5615 //
     /* 392535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392546 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 392551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392555 */   GIR_RootConstrainSelectedInstOperands,
     /* 392556 */   // GIR_Coverage, 5615,
     /* 392556 */   GIR_Done,
     /* 392557 */ // Label 7842: @392557
     /* 392557 */ GIM_Reject,
     /* 392558 */ // Label 7837: @392558
     /* 392558 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(392585), // Rule ID 5617 //
     /* 392563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392574 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 392579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392583 */   GIR_RootConstrainSelectedInstOperands,
     /* 392584 */   // GIR_Coverage, 5617,
     /* 392584 */   GIR_Done,
     /* 392585 */ // Label 7843: @392585
     /* 392585 */ GIM_Reject,
     /* 392586 */ // Label 7838: @392586
     /* 392586 */ GIM_Reject,
     /* 392587 */ // Label 115: @392587
     /* 392587 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7848*/ GIMT_Encode4(393715),
     /* 392598 */ /*GILLT_s8*//*Label 7844*/ GIMT_Encode4(392614),
     /* 392602 */ /*GILLT_s16*//*Label 7845*/ GIMT_Encode4(392661),
     /* 392606 */ /*GILLT_s32*//*Label 7846*/ GIMT_Encode4(393076),
     /* 392610 */ /*GILLT_s64*//*Label 7847*/ GIMT_Encode4(393529),
     /* 392614 */ // Label 7844: @392614
     /* 392614 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(392637), // Rule ID 5862 //
     /* 392619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 392626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392630 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 392635 */   GIR_RootConstrainSelectedInstOperands,
     /* 392636 */   // GIR_Coverage, 5862,
     /* 392636 */   GIR_Done,
     /* 392637 */ // Label 7849: @392637
     /* 392637 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(392660), // Rule ID 5863 //
     /* 392642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 392649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392653 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 392658 */   GIR_RootConstrainSelectedInstOperands,
     /* 392659 */   // GIR_Coverage, 5863,
     /* 392659 */   GIR_Done,
     /* 392660 */ // Label 7850: @392660
     /* 392660 */ GIM_Reject,
     /* 392661 */ // Label 7845: @392661
     /* 392661 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(392711), // Rule ID 5809 //
     /* 392666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 392681 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 392684 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 392689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 392693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392700 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 392700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 392703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392705 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 392709 */   GIR_RootConstrainSelectedInstOperands,
     /* 392710 */   // GIR_Coverage, 5809,
     /* 392710 */   GIR_EraseRootFromParent_Done,
     /* 392711 */ // Label 7851: @392711
     /* 392711 */ GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(392761), // Rule ID 5811 //
     /* 392716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 392731 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 392734 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 392739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 392743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392750 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 392750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 392753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 392759 */   GIR_RootConstrainSelectedInstOperands,
     /* 392760 */   // GIR_Coverage, 5811,
     /* 392760 */   GIR_EraseRootFromParent_Done,
     /* 392761 */ // Label 7852: @392761
     /* 392761 */ GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(392811), // Rule ID 5819 //
     /* 392766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 392781 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 392784 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 392789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 392793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392800 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 392800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 392803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392805 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 392809 */   GIR_RootConstrainSelectedInstOperands,
     /* 392810 */   // GIR_Coverage, 5819,
     /* 392810 */   GIR_EraseRootFromParent_Done,
     /* 392811 */ // Label 7853: @392811
     /* 392811 */ GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(392861), // Rule ID 5821 //
     /* 392816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392823 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 392831 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 392834 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 392839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 392843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392850 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 392850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 392853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 392859 */   GIR_RootConstrainSelectedInstOperands,
     /* 392860 */   // GIR_Coverage, 5821,
     /* 392860 */   GIR_EraseRootFromParent_Done,
     /* 392861 */ // Label 7854: @392861
     /* 392861 */ GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(392903), // Rule ID 5818 //
     /* 392866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 392881 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392885 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392892 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 392892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 392895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392901 */   GIR_RootConstrainSelectedInstOperands,
     /* 392902 */   // GIR_Coverage, 5818,
     /* 392902 */   GIR_EraseRootFromParent_Done,
     /* 392903 */ // Label 7855: @392903
     /* 392903 */ GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(392945), // Rule ID 5820 //
     /* 392908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 392923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392934 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 392934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 392937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392943 */   GIR_RootConstrainSelectedInstOperands,
     /* 392944 */   // GIR_Coverage, 5820,
     /* 392944 */   GIR_EraseRootFromParent_Done,
     /* 392945 */ // Label 7856: @392945
     /* 392945 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(392987), // Rule ID 5808 //
     /* 392950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 392965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392969 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392976 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 392976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 392979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392981 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392985 */   GIR_RootConstrainSelectedInstOperands,
     /* 392986 */   // GIR_Coverage, 5808,
     /* 392986 */   GIR_EraseRootFromParent_Done,
     /* 392987 */ // Label 7857: @392987
     /* 392987 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(393029), // Rule ID 5810 //
     /* 392992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393018 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 393021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393023 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393027 */   GIR_RootConstrainSelectedInstOperands,
     /* 393028 */   // GIR_Coverage, 5810,
     /* 393028 */   GIR_EraseRootFromParent_Done,
     /* 393029 */ // Label 7858: @393029
     /* 393029 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(393052), // Rule ID 5864 //
     /* 393034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393045 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 393050 */   GIR_RootConstrainSelectedInstOperands,
     /* 393051 */   // GIR_Coverage, 5864,
     /* 393051 */   GIR_Done,
     /* 393052 */ // Label 7859: @393052
     /* 393052 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(393075), // Rule ID 5865 //
     /* 393057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393068 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 393073 */   GIR_RootConstrainSelectedInstOperands,
     /* 393074 */   // GIR_Coverage, 5865,
     /* 393074 */   GIR_Done,
     /* 393075 */ // Label 7860: @393075
     /* 393075 */ GIM_Reject,
     /* 393076 */ // Label 7846: @393076
     /* 393076 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(393126), // Rule ID 5813 //
     /* 393081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393096 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393099 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393104 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393115 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 393118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393120 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393124 */   GIR_RootConstrainSelectedInstOperands,
     /* 393125 */   // GIR_Coverage, 5813,
     /* 393125 */   GIR_EraseRootFromParent_Done,
     /* 393126 */ // Label 7861: @393126
     /* 393126 */ GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(393176), // Rule ID 5815 //
     /* 393131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393146 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393149 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393154 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393158 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393165 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 393168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393174 */   GIR_RootConstrainSelectedInstOperands,
     /* 393175 */   // GIR_Coverage, 5815,
     /* 393175 */   GIR_EraseRootFromParent_Done,
     /* 393176 */ // Label 7862: @393176
     /* 393176 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(393226), // Rule ID 5823 //
     /* 393181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393196 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393199 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393204 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393215 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 393218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393220 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393224 */   GIR_RootConstrainSelectedInstOperands,
     /* 393225 */   // GIR_Coverage, 5823,
     /* 393225 */   GIR_EraseRootFromParent_Done,
     /* 393226 */ // Label 7863: @393226
     /* 393226 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(393276), // Rule ID 5825 //
     /* 393231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393246 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393249 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393265 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 393268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393270 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393274 */   GIR_RootConstrainSelectedInstOperands,
     /* 393275 */   // GIR_Coverage, 5825,
     /* 393275 */   GIR_EraseRootFromParent_Done,
     /* 393276 */ // Label 7864: @393276
     /* 393276 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(393318), // Rule ID 5822 //
     /* 393281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393296 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393300 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393307 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 393310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393312 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393316 */   GIR_RootConstrainSelectedInstOperands,
     /* 393317 */   // GIR_Coverage, 5822,
     /* 393317 */   GIR_EraseRootFromParent_Done,
     /* 393318 */ // Label 7865: @393318
     /* 393318 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(393360), // Rule ID 5824 //
     /* 393323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393349 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 393352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393358 */   GIR_RootConstrainSelectedInstOperands,
     /* 393359 */   // GIR_Coverage, 5824,
     /* 393359 */   GIR_EraseRootFromParent_Done,
     /* 393360 */ // Label 7866: @393360
     /* 393360 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(393402), // Rule ID 5812 //
     /* 393365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393380 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393391 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 393394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393396 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393400 */   GIR_RootConstrainSelectedInstOperands,
     /* 393401 */   // GIR_Coverage, 5812,
     /* 393401 */   GIR_EraseRootFromParent_Done,
     /* 393402 */ // Label 7867: @393402
     /* 393402 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(393444), // Rule ID 5814 //
     /* 393407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393433 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 393436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393438 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393442 */   GIR_RootConstrainSelectedInstOperands,
     /* 393443 */   // GIR_Coverage, 5814,
     /* 393443 */   GIR_EraseRootFromParent_Done,
     /* 393444 */ // Label 7868: @393444
     /* 393444 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(393505), // Rule ID 5866 //
     /* 393449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393460 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 393460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 393467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393472 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393476 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393487 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 393494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393504 */   // GIR_Coverage, 5866,
     /* 393504 */   GIR_EraseRootFromParent_Done,
     /* 393505 */ // Label 7869: @393505
     /* 393505 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(393528), // Rule ID 5867 //
     /* 393510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393521 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 393526 */   GIR_RootConstrainSelectedInstOperands,
     /* 393527 */   // GIR_Coverage, 5867,
     /* 393527 */   GIR_Done,
     /* 393528 */ // Label 7870: @393528
     /* 393528 */ GIM_Reject,
     /* 393529 */ // Label 7847: @393529
     /* 393529 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(393714),
     /* 393534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393541 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(393584), // Rule ID 5817 //
     /* 393546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393554 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393557 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393573 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 393576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393582 */     GIR_RootConstrainSelectedInstOperands,
     /* 393583 */     // GIR_Coverage, 5817,
     /* 393583 */     GIR_EraseRootFromParent_Done,
     /* 393584 */   // Label 7872: @393584
     /* 393584 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(393627), // Rule ID 5827 //
     /* 393589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393597 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393600 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393616 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 393619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393625 */     GIR_RootConstrainSelectedInstOperands,
     /* 393626 */     // GIR_Coverage, 5827,
     /* 393626 */     GIR_EraseRootFromParent_Done,
     /* 393627 */   // Label 7873: @393627
     /* 393627 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(393662), // Rule ID 5826 //
     /* 393632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393651 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 393654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393660 */     GIR_RootConstrainSelectedInstOperands,
     /* 393661 */     // GIR_Coverage, 5826,
     /* 393661 */     GIR_EraseRootFromParent_Done,
     /* 393662 */   // Label 7874: @393662
     /* 393662 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(393697), // Rule ID 5816 //
     /* 393667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393686 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 393689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393695 */     GIR_RootConstrainSelectedInstOperands,
     /* 393696 */     // GIR_Coverage, 5816,
     /* 393696 */     GIR_EraseRootFromParent_Done,
     /* 393697 */   // Label 7875: @393697
     /* 393697 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(393713), // Rule ID 5868 //
     /* 393702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393706 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 393706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 393711 */     GIR_RootConstrainSelectedInstOperands,
     /* 393712 */     // GIR_Coverage, 5868,
     /* 393712 */     GIR_Done,
     /* 393713 */   // Label 7876: @393713
     /* 393713 */   GIM_Reject,
     /* 393714 */ // Label 7871: @393714
     /* 393714 */ GIM_Reject,
     /* 393715 */ // Label 7848: @393715
     /* 393715 */ GIM_Reject,
     /* 393716 */ // Label 116: @393716
     /* 393716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7880*/ GIMT_Encode4(393918),
     /* 393727 */ /*GILLT_s8*//*Label 7877*/ GIMT_Encode4(393739),
     /* 393731 */ /*GILLT_s16*//*Label 7878*/ GIMT_Encode4(393786),
     /* 393735 */ /*GILLT_s32*//*Label 7879*/ GIMT_Encode4(393833),
     /* 393739 */ // Label 7877: @393739
     /* 393739 */ GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(393762), // Rule ID 5959 //
     /* 393744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393755 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 393755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 393760 */   GIR_RootConstrainSelectedInstOperands,
     /* 393761 */   // GIR_Coverage, 5959,
     /* 393761 */   GIR_Done,
     /* 393762 */ // Label 7881: @393762
     /* 393762 */ GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(393785), // Rule ID 5960 //
     /* 393767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393778 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 393778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 393783 */   GIR_RootConstrainSelectedInstOperands,
     /* 393784 */   // GIR_Coverage, 5960,
     /* 393784 */   GIR_Done,
     /* 393785 */ // Label 7882: @393785
     /* 393785 */ GIM_Reject,
     /* 393786 */ // Label 7878: @393786
     /* 393786 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(393809), // Rule ID 5961 //
     /* 393791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393802 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 393802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 393807 */   GIR_RootConstrainSelectedInstOperands,
     /* 393808 */   // GIR_Coverage, 5961,
     /* 393808 */   GIR_Done,
     /* 393809 */ // Label 7883: @393809
     /* 393809 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(393832), // Rule ID 5962 //
     /* 393814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393825 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 393825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 393830 */   GIR_RootConstrainSelectedInstOperands,
     /* 393831 */   // GIR_Coverage, 5962,
     /* 393831 */   GIR_Done,
     /* 393832 */ // Label 7884: @393832
     /* 393832 */ GIM_Reject,
     /* 393833 */ // Label 7879: @393833
     /* 393833 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(393856), // Rule ID 5963 //
     /* 393838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393849 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 393854 */   GIR_RootConstrainSelectedInstOperands,
     /* 393855 */   // GIR_Coverage, 5963,
     /* 393855 */   GIR_Done,
     /* 393856 */ // Label 7885: @393856
     /* 393856 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(393917), // Rule ID 5964 //
     /* 393861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393872 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 393872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 393879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393884 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393899 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 393906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393916 */   // GIR_Coverage, 5964,
     /* 393916 */   GIR_EraseRootFromParent_Done,
     /* 393917 */ // Label 7886: @393917
     /* 393917 */ GIM_Reject,
     /* 393918 */ // Label 7880: @393918
     /* 393918 */ GIM_Reject,
     /* 393919 */ // Label 117: @393919
     /* 393919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7890*/ GIMT_Encode4(394121),
     /* 393930 */ /*GILLT_s8*//*Label 7887*/ GIMT_Encode4(393942),
     /* 393934 */ /*GILLT_s16*//*Label 7888*/ GIMT_Encode4(393989),
     /* 393938 */ /*GILLT_s32*//*Label 7889*/ GIMT_Encode4(394036),
     /* 393942 */ // Label 7887: @393942
     /* 393942 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(393965), // Rule ID 5953 //
     /* 393947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393958 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 393958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 393963 */   GIR_RootConstrainSelectedInstOperands,
     /* 393964 */   // GIR_Coverage, 5953,
     /* 393964 */   GIR_Done,
     /* 393965 */ // Label 7891: @393965
     /* 393965 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(393988), // Rule ID 5954 //
     /* 393970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393981 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 393981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 393986 */   GIR_RootConstrainSelectedInstOperands,
     /* 393987 */   // GIR_Coverage, 5954,
     /* 393987 */   GIR_Done,
     /* 393988 */ // Label 7892: @393988
     /* 393988 */ GIM_Reject,
     /* 393989 */ // Label 7888: @393989
     /* 393989 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(394012), // Rule ID 5955 //
     /* 393994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394005 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 394010 */   GIR_RootConstrainSelectedInstOperands,
     /* 394011 */   // GIR_Coverage, 5955,
     /* 394011 */   GIR_Done,
     /* 394012 */ // Label 7893: @394012
     /* 394012 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(394035), // Rule ID 5956 //
     /* 394017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394028 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 394033 */   GIR_RootConstrainSelectedInstOperands,
     /* 394034 */   // GIR_Coverage, 5956,
     /* 394034 */   GIR_Done,
     /* 394035 */ // Label 7894: @394035
     /* 394035 */ GIM_Reject,
     /* 394036 */ // Label 7889: @394036
     /* 394036 */ GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(394059), // Rule ID 5957 //
     /* 394041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394052 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 394057 */   GIR_RootConstrainSelectedInstOperands,
     /* 394058 */   // GIR_Coverage, 5957,
     /* 394058 */   GIR_Done,
     /* 394059 */ // Label 7895: @394059
     /* 394059 */ GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(394120), // Rule ID 5958 //
     /* 394064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394075 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 394082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394087 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394091 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394102 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394119 */   // GIR_Coverage, 5958,
     /* 394119 */   GIR_EraseRootFromParent_Done,
     /* 394120 */ // Label 7896: @394120
     /* 394120 */ GIM_Reject,
     /* 394121 */ // Label 7890: @394121
     /* 394121 */ GIM_Reject,
     /* 394122 */ // Label 118: @394122
     /* 394122 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7900*/ GIMT_Encode4(394324),
     /* 394133 */ /*GILLT_s8*//*Label 7897*/ GIMT_Encode4(394145),
     /* 394137 */ /*GILLT_s16*//*Label 7898*/ GIMT_Encode4(394192),
     /* 394141 */ /*GILLT_s32*//*Label 7899*/ GIMT_Encode4(394239),
     /* 394145 */ // Label 7897: @394145
     /* 394145 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(394168), // Rule ID 5947 //
     /* 394150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394161 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 394166 */   GIR_RootConstrainSelectedInstOperands,
     /* 394167 */   // GIR_Coverage, 5947,
     /* 394167 */   GIR_Done,
     /* 394168 */ // Label 7901: @394168
     /* 394168 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(394191), // Rule ID 5948 //
     /* 394173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394184 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 394189 */   GIR_RootConstrainSelectedInstOperands,
     /* 394190 */   // GIR_Coverage, 5948,
     /* 394190 */   GIR_Done,
     /* 394191 */ // Label 7902: @394191
     /* 394191 */ GIM_Reject,
     /* 394192 */ // Label 7898: @394192
     /* 394192 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(394215), // Rule ID 5949 //
     /* 394197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394208 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 394213 */   GIR_RootConstrainSelectedInstOperands,
     /* 394214 */   // GIR_Coverage, 5949,
     /* 394214 */   GIR_Done,
     /* 394215 */ // Label 7903: @394215
     /* 394215 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(394238), // Rule ID 5950 //
     /* 394220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394231 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 394236 */   GIR_RootConstrainSelectedInstOperands,
     /* 394237 */   // GIR_Coverage, 5950,
     /* 394237 */   GIR_Done,
     /* 394238 */ // Label 7904: @394238
     /* 394238 */ GIM_Reject,
     /* 394239 */ // Label 7899: @394239
     /* 394239 */ GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(394262), // Rule ID 5951 //
     /* 394244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394255 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 394260 */   GIR_RootConstrainSelectedInstOperands,
     /* 394261 */   // GIR_Coverage, 5951,
     /* 394261 */   GIR_Done,
     /* 394262 */ // Label 7905: @394262
     /* 394262 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(394323), // Rule ID 5952 //
     /* 394267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394278 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 394285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394290 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394305 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394322 */   // GIR_Coverage, 5952,
     /* 394322 */   GIR_EraseRootFromParent_Done,
     /* 394323 */ // Label 7906: @394323
     /* 394323 */ GIM_Reject,
     /* 394324 */ // Label 7900: @394324
     /* 394324 */ GIM_Reject,
     /* 394325 */ // Label 119: @394325
     /* 394325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7910*/ GIMT_Encode4(394527),
     /* 394336 */ /*GILLT_s8*//*Label 7907*/ GIMT_Encode4(394348),
     /* 394340 */ /*GILLT_s16*//*Label 7908*/ GIMT_Encode4(394395),
     /* 394344 */ /*GILLT_s32*//*Label 7909*/ GIMT_Encode4(394442),
     /* 394348 */ // Label 7907: @394348
     /* 394348 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(394371), // Rule ID 5941 //
     /* 394353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394364 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 394369 */   GIR_RootConstrainSelectedInstOperands,
     /* 394370 */   // GIR_Coverage, 5941,
     /* 394370 */   GIR_Done,
     /* 394371 */ // Label 7911: @394371
     /* 394371 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(394394), // Rule ID 5942 //
     /* 394376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394387 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 394392 */   GIR_RootConstrainSelectedInstOperands,
     /* 394393 */   // GIR_Coverage, 5942,
     /* 394393 */   GIR_Done,
     /* 394394 */ // Label 7912: @394394
     /* 394394 */ GIM_Reject,
     /* 394395 */ // Label 7908: @394395
     /* 394395 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(394418), // Rule ID 5943 //
     /* 394400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394411 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 394416 */   GIR_RootConstrainSelectedInstOperands,
     /* 394417 */   // GIR_Coverage, 5943,
     /* 394417 */   GIR_Done,
     /* 394418 */ // Label 7913: @394418
     /* 394418 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(394441), // Rule ID 5944 //
     /* 394423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394434 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 394439 */   GIR_RootConstrainSelectedInstOperands,
     /* 394440 */   // GIR_Coverage, 5944,
     /* 394440 */   GIR_Done,
     /* 394441 */ // Label 7914: @394441
     /* 394441 */ GIM_Reject,
     /* 394442 */ // Label 7909: @394442
     /* 394442 */ GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(394465), // Rule ID 5945 //
     /* 394447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394458 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 394463 */   GIR_RootConstrainSelectedInstOperands,
     /* 394464 */   // GIR_Coverage, 5945,
     /* 394464 */   GIR_Done,
     /* 394465 */ // Label 7915: @394465
     /* 394465 */ GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(394526), // Rule ID 5946 //
     /* 394470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394481 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 394488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394508 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394525 */   // GIR_Coverage, 5946,
     /* 394525 */   GIR_EraseRootFromParent_Done,
     /* 394526 */ // Label 7916: @394526
     /* 394526 */ GIM_Reject,
     /* 394527 */ // Label 7910: @394527
     /* 394527 */ GIM_Reject,
     /* 394528 */ // Label 120: @394528
     /* 394528 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(394667),
     /* 394533 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 394536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 394540 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(394574), // Rule ID 257 //
     /* 394545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 394552 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 394552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 394555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 394567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 394572 */     GIR_RootConstrainSelectedInstOperands,
     /* 394573 */     // GIR_Coverage, 257,
     /* 394573 */     GIR_EraseRootFromParent_Done,
     /* 394574 */   // Label 7918: @394574
     /* 394574 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(394608), // Rule ID 258 //
     /* 394579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 394586 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 394586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 394589 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 394601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 394606 */     GIR_RootConstrainSelectedInstOperands,
     /* 394607 */     // GIR_Coverage, 258,
     /* 394607 */     GIR_EraseRootFromParent_Done,
     /* 394608 */   // Label 7919: @394608
     /* 394608 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(394637), // Rule ID 273 //
     /* 394613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 394620 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 394620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 394623 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 394635 */     GIR_RootConstrainSelectedInstOperands,
     /* 394636 */     // GIR_Coverage, 273,
     /* 394636 */     GIR_EraseRootFromParent_Done,
     /* 394637 */   // Label 7920: @394637
     /* 394637 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(394666), // Rule ID 294 //
     /* 394642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 394649 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 394649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 394652 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 394664 */     GIR_RootConstrainSelectedInstOperands,
     /* 394665 */     // GIR_Coverage, 294,
     /* 394665 */     GIR_EraseRootFromParent_Done,
     /* 394666 */   // Label 7921: @394666
     /* 394666 */   GIM_Reject,
     /* 394667 */ // Label 7917: @394667
     /* 394667 */ GIM_Reject,
     /* 394668 */ // Label 121: @394668
     /* 394668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7934*/ GIMT_Encode4(395207),
     /* 394679 */ /*GILLT_s64*//*Label 7922*/ GIMT_Encode4(394763), GIMT_Encode4(0),
     /* 394687 */ /*GILLT_v2s32*//*Label 7923*/ GIMT_Encode4(394801),
     /* 394691 */ /*GILLT_v2s64*//*Label 7924*/ GIMT_Encode4(394839),
     /* 394695 */ /*GILLT_v4s16*//*Label 7925*/ GIMT_Encode4(394877),
     /* 394699 */ /*GILLT_v4s32*//*Label 7926*/ GIMT_Encode4(394915),
     /* 394703 */ /*GILLT_v8s8*//*Label 7927*/ GIMT_Encode4(394953),
     /* 394707 */ /*GILLT_v8s16*//*Label 7928*/ GIMT_Encode4(394991),
     /* 394711 */ /*GILLT_v16s8*//*Label 7929*/ GIMT_Encode4(395029), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 394731 */ /*GILLT_nxv2s64*//*Label 7930*/ GIMT_Encode4(395067), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 394743 */ /*GILLT_nxv4s32*//*Label 7931*/ GIMT_Encode4(395102), GIMT_Encode4(0),
     /* 394751 */ /*GILLT_nxv8s16*//*Label 7932*/ GIMT_Encode4(395137), GIMT_Encode4(0),
     /* 394759 */ /*GILLT_nxv16s8*//*Label 7933*/ GIMT_Encode4(395172),
     /* 394763 */ // Label 7922: @394763
     /* 394763 */ GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(394800), // Rule ID 5056 //
     /* 394768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 394774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 394777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394793 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 394793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 394798 */   GIR_RootConstrainSelectedInstOperands,
     /* 394799 */   // GIR_Coverage, 5056,
     /* 394799 */   GIR_Done,
     /* 394800 */ // Label 7935: @394800
     /* 394800 */ GIM_Reject,
     /* 394801 */ // Label 7923: @394801
     /* 394801 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(394838), // Rule ID 5055 //
     /* 394806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 394815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394827 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394831 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 394836 */   GIR_RootConstrainSelectedInstOperands,
     /* 394837 */   // GIR_Coverage, 5055,
     /* 394837 */   GIR_Done,
     /* 394838 */ // Label 7936: @394838
     /* 394838 */ GIM_Reject,
     /* 394839 */ // Label 7924: @394839
     /* 394839 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(394876), // Rule ID 5060 //
     /* 394844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 394853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394869 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 394874 */   GIR_RootConstrainSelectedInstOperands,
     /* 394875 */   // GIR_Coverage, 5060,
     /* 394875 */   GIR_Done,
     /* 394876 */ // Label 7937: @394876
     /* 394876 */ GIM_Reject,
     /* 394877 */ // Label 7925: @394877
     /* 394877 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(394914), // Rule ID 5054 //
     /* 394882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 394891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394907 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 394912 */   GIR_RootConstrainSelectedInstOperands,
     /* 394913 */   // GIR_Coverage, 5054,
     /* 394913 */   GIR_Done,
     /* 394914 */ // Label 7938: @394914
     /* 394914 */ GIM_Reject,
     /* 394915 */ // Label 7926: @394915
     /* 394915 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(394952), // Rule ID 5059 //
     /* 394920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 394929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394945 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 394950 */   GIR_RootConstrainSelectedInstOperands,
     /* 394951 */   // GIR_Coverage, 5059,
     /* 394951 */   GIR_Done,
     /* 394952 */ // Label 7939: @394952
     /* 394952 */ GIM_Reject,
     /* 394953 */ // Label 7927: @394953
     /* 394953 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(394990), // Rule ID 5053 //
     /* 394958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 394967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394983 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 394983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 394988 */   GIR_RootConstrainSelectedInstOperands,
     /* 394989 */   // GIR_Coverage, 5053,
     /* 394989 */   GIR_Done,
     /* 394990 */ // Label 7940: @394990
     /* 394990 */ GIM_Reject,
     /* 394991 */ // Label 7928: @394991
     /* 394991 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(395028), // Rule ID 5058 //
     /* 394996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 395005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395021 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395026 */   GIR_RootConstrainSelectedInstOperands,
     /* 395027 */   // GIR_Coverage, 5058,
     /* 395027 */   GIR_Done,
     /* 395028 */ // Label 7941: @395028
     /* 395028 */ GIM_Reject,
     /* 395029 */ // Label 7929: @395029
     /* 395029 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(395066), // Rule ID 5057 //
     /* 395034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 395043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395059 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395064 */   GIR_RootConstrainSelectedInstOperands,
     /* 395065 */   // GIR_Coverage, 5057,
     /* 395065 */   GIR_Done,
     /* 395066 */ // Label 7942: @395066
     /* 395066 */ GIM_Reject,
     /* 395067 */ // Label 7930: @395067
     /* 395067 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(395101), // Rule ID 11807 //
     /* 395072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 395084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395088 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 395088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395093 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395095 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395099 */   GIR_RootConstrainSelectedInstOperands,
     /* 395100 */   // GIR_Coverage, 11807,
     /* 395100 */   GIR_EraseRootFromParent_Done,
     /* 395101 */ // Label 7943: @395101
     /* 395101 */ GIM_Reject,
     /* 395102 */ // Label 7931: @395102
     /* 395102 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(395136), // Rule ID 11805 //
     /* 395107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 395119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395123 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 395123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395128 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395130 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395132 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395134 */   GIR_RootConstrainSelectedInstOperands,
     /* 395135 */   // GIR_Coverage, 11805,
     /* 395135 */   GIR_EraseRootFromParent_Done,
     /* 395136 */ // Label 7944: @395136
     /* 395136 */ GIM_Reject,
     /* 395137 */ // Label 7932: @395137
     /* 395137 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(395171), // Rule ID 11803 //
     /* 395142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 395154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395158 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 395158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395163 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395165 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395167 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395169 */   GIR_RootConstrainSelectedInstOperands,
     /* 395170 */   // GIR_Coverage, 11803,
     /* 395170 */   GIR_EraseRootFromParent_Done,
     /* 395171 */ // Label 7945: @395171
     /* 395171 */ GIM_Reject,
     /* 395172 */ // Label 7933: @395172
     /* 395172 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(395206), // Rule ID 11801 //
     /* 395177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 395189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395193 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 395193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395198 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395200 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395202 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395204 */   GIR_RootConstrainSelectedInstOperands,
     /* 395205 */   // GIR_Coverage, 11801,
     /* 395205 */   GIR_EraseRootFromParent_Done,
     /* 395206 */ // Label 7946: @395206
     /* 395206 */ GIM_Reject,
     /* 395207 */ // Label 7934: @395207
     /* 395207 */ GIM_Reject,
     /* 395208 */ // Label 122: @395208
     /* 395208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7955*/ GIMT_Encode4(397030),
     /* 395219 */ /*GILLT_s64*//*Label 7947*/ GIMT_Encode4(395255), GIMT_Encode4(0),
     /* 395227 */ /*GILLT_v2s32*//*Label 7948*/ GIMT_Encode4(395450),
     /* 395231 */ /*GILLT_v2s64*//*Label 7949*/ GIMT_Encode4(395697),
     /* 395235 */ /*GILLT_v4s16*//*Label 7950*/ GIMT_Encode4(395944),
     /* 395239 */ /*GILLT_v4s32*//*Label 7951*/ GIMT_Encode4(396220),
     /* 395243 */ /*GILLT_v8s8*//*Label 7952*/ GIMT_Encode4(396467),
     /* 395247 */ /*GILLT_v8s16*//*Label 7953*/ GIMT_Encode4(396612),
     /* 395251 */ /*GILLT_v16s8*//*Label 7954*/ GIMT_Encode4(396888),
     /* 395255 */ // Label 7947: @395255
     /* 395255 */ GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(395449),
     /* 395260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395267 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(395314), // Rule ID 6386 //
     /* 395272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395287 */     // MIs[1] Rn
     /* 395287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395298 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395312 */     GIR_RootConstrainSelectedInstOperands,
     /* 395313 */     // GIR_Coverage, 6386,
     /* 395313 */     GIR_EraseRootFromParent_Done,
     /* 395314 */   // Label 7957: @395314
     /* 395314 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(395361), // Rule ID 6397 //
     /* 395319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395334 */     // MIs[1] Rn
     /* 395334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395345 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395359 */     GIR_RootConstrainSelectedInstOperands,
     /* 395360 */     // GIR_Coverage, 6397,
     /* 395360 */     GIR_EraseRootFromParent_Done,
     /* 395361 */   // Label 7958: @395361
     /* 395361 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(395408), // Rule ID 13131 //
     /* 395366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395381 */     // MIs[1] Rn
     /* 395381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395392 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395406 */     GIR_RootConstrainSelectedInstOperands,
     /* 395407 */     // GIR_Coverage, 13131,
     /* 395407 */     GIR_EraseRootFromParent_Done,
     /* 395408 */   // Label 7959: @395408
     /* 395408 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(395428), // Rule ID 5619 //
     /* 395413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 395417 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 395417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395427 */     // GIR_Coverage, 5619,
     /* 395427 */     GIR_Done,
     /* 395428 */   // Label 7960: @395428
     /* 395428 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(395448), // Rule ID 5620 //
     /* 395433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395437 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 395437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395447 */     // GIR_Coverage, 5620,
     /* 395447 */     GIR_Done,
     /* 395448 */   // Label 7961: @395448
     /* 395448 */   GIM_Reject,
     /* 395449 */ // Label 7956: @395449
     /* 395449 */ GIM_Reject,
     /* 395450 */ // Label 7948: @395450
     /* 395450 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(395696),
     /* 395455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395462 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(395509), // Rule ID 6383 //
     /* 395467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395482 */     // MIs[1] Rn
     /* 395482 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395493 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395507 */     GIR_RootConstrainSelectedInstOperands,
     /* 395508 */     // GIR_Coverage, 6383,
     /* 395508 */     GIR_EraseRootFromParent_Done,
     /* 395509 */   // Label 7963: @395509
     /* 395509 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(395556), // Rule ID 6394 //
     /* 395514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395529 */     // MIs[1] Rn
     /* 395529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395540 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395554 */     GIR_RootConstrainSelectedInstOperands,
     /* 395555 */     // GIR_Coverage, 6394,
     /* 395555 */     GIR_EraseRootFromParent_Done,
     /* 395556 */   // Label 7964: @395556
     /* 395556 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(395603), // Rule ID 13128 //
     /* 395561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395576 */     // MIs[1] Rn
     /* 395576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395587 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395601 */     GIR_RootConstrainSelectedInstOperands,
     /* 395602 */     // GIR_Coverage, 13128,
     /* 395602 */     GIR_EraseRootFromParent_Done,
     /* 395603 */   // Label 7965: @395603
     /* 395603 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(395622), // Rule ID 1916 //
     /* 395608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 395615 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 395615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 395620 */     GIR_RootConstrainSelectedInstOperands,
     /* 395621 */     // GIR_Coverage, 1916,
     /* 395621 */     GIR_Done,
     /* 395622 */   // Label 7966: @395622
     /* 395622 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(395695), // Rule ID 5621 //
     /* 395627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395631 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 395634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 395648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 395667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 395685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395693 */     GIR_RootConstrainSelectedInstOperands,
     /* 395694 */     // GIR_Coverage, 5621,
     /* 395694 */     GIR_EraseRootFromParent_Done,
     /* 395695 */   // Label 7967: @395695
     /* 395695 */   GIM_Reject,
     /* 395696 */ // Label 7962: @395696
     /* 395696 */ GIM_Reject,
     /* 395697 */ // Label 7949: @395697
     /* 395697 */ GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(395943),
     /* 395702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395709 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(395756), // Rule ID 6385 //
     /* 395714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395729 */     // MIs[1] Rn
     /* 395729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395740 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 395743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395754 */     GIR_RootConstrainSelectedInstOperands,
     /* 395755 */     // GIR_Coverage, 6385,
     /* 395755 */     GIR_EraseRootFromParent_Done,
     /* 395756 */   // Label 7969: @395756
     /* 395756 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(395803), // Rule ID 6396 //
     /* 395761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395776 */     // MIs[1] Rn
     /* 395776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395787 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 395790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395801 */     GIR_RootConstrainSelectedInstOperands,
     /* 395802 */     // GIR_Coverage, 6396,
     /* 395802 */     GIR_EraseRootFromParent_Done,
     /* 395803 */   // Label 7970: @395803
     /* 395803 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(395850), // Rule ID 13130 //
     /* 395808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395823 */     // MIs[1] Rn
     /* 395823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395834 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 395837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395848 */     GIR_RootConstrainSelectedInstOperands,
     /* 395849 */     // GIR_Coverage, 13130,
     /* 395849 */     GIR_EraseRootFromParent_Done,
     /* 395850 */   // Label 7971: @395850
     /* 395850 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(395869), // Rule ID 1918 //
     /* 395855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 395862 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 395862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 395867 */     GIR_RootConstrainSelectedInstOperands,
     /* 395868 */     // GIR_Coverage, 1918,
     /* 395868 */     GIR_Done,
     /* 395869 */   // Label 7972: @395869
     /* 395869 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(395942), // Rule ID 5623 //
     /* 395874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395878 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 395881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 395895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395911 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 395932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395940 */     GIR_RootConstrainSelectedInstOperands,
     /* 395941 */     // GIR_Coverage, 5623,
     /* 395941 */     GIR_EraseRootFromParent_Done,
     /* 395942 */   // Label 7973: @395942
     /* 395942 */   GIM_Reject,
     /* 395943 */ // Label 7968: @395943
     /* 395943 */ GIM_Reject,
     /* 395944 */ // Label 7950: @395944
     /* 395944 */ GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(396005), // Rule ID 6381 //
     /* 395949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395964 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395967 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395971 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 395978 */   // MIs[1] Rn
     /* 395978 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395982 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395989 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 395992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395994 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395998 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396003 */   GIR_RootConstrainSelectedInstOperands,
     /* 396004 */   // GIR_Coverage, 6381,
     /* 396004 */   GIR_EraseRootFromParent_Done,
     /* 396005 */ // Label 7974: @396005
     /* 396005 */ GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(396059), // Rule ID 6398 //
     /* 396010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396025 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396032 */   // MIs[1] Rn
     /* 396032 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396036 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396041 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396043 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396048 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396057 */   GIR_RootConstrainSelectedInstOperands,
     /* 396058 */   // GIR_Coverage, 6398,
     /* 396058 */   GIR_EraseRootFromParent_Done,
     /* 396059 */ // Label 7975: @396059
     /* 396059 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(396113), // Rule ID 13126 //
     /* 396064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396079 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396086 */   // MIs[1] Rn
     /* 396086 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396097 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396102 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396111 */   GIR_RootConstrainSelectedInstOperands,
     /* 396112 */   // GIR_Coverage, 13126,
     /* 396112 */   GIR_EraseRootFromParent_Done,
     /* 396113 */ // Label 7976: @396113
     /* 396113 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(396139), // Rule ID 1914 //
     /* 396118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396132 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 396132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 396137 */   GIR_RootConstrainSelectedInstOperands,
     /* 396138 */   // GIR_Coverage, 1914,
     /* 396138 */   GIR_Done,
     /* 396139 */ // Label 7977: @396139
     /* 396139 */ GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(396219), // Rule ID 5624 //
     /* 396144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396155 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 396158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 396172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396181 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396184 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396188 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 396209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396217 */   GIR_RootConstrainSelectedInstOperands,
     /* 396218 */   // GIR_Coverage, 5624,
     /* 396218 */   GIR_EraseRootFromParent_Done,
     /* 396219 */ // Label 7978: @396219
     /* 396219 */ GIM_Reject,
     /* 396220 */ // Label 7951: @396220
     /* 396220 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(396466),
     /* 396225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396232 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(396279), // Rule ID 6384 //
     /* 396237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396252 */     // MIs[1] Rn
     /* 396252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396263 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396277 */     GIR_RootConstrainSelectedInstOperands,
     /* 396278 */     // GIR_Coverage, 6384,
     /* 396278 */     GIR_EraseRootFromParent_Done,
     /* 396279 */   // Label 7980: @396279
     /* 396279 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(396326), // Rule ID 6395 //
     /* 396284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396299 */     // MIs[1] Rn
     /* 396299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396310 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396324 */     GIR_RootConstrainSelectedInstOperands,
     /* 396325 */     // GIR_Coverage, 6395,
     /* 396325 */     GIR_EraseRootFromParent_Done,
     /* 396326 */   // Label 7981: @396326
     /* 396326 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(396373), // Rule ID 13129 //
     /* 396331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396339 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396346 */     // MIs[1] Rn
     /* 396346 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396357 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396371 */     GIR_RootConstrainSelectedInstOperands,
     /* 396372 */     // GIR_Coverage, 13129,
     /* 396372 */     GIR_EraseRootFromParent_Done,
     /* 396373 */   // Label 7982: @396373
     /* 396373 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(396392), // Rule ID 1917 //
     /* 396378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396385 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 396385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 396390 */     GIR_RootConstrainSelectedInstOperands,
     /* 396391 */     // GIR_Coverage, 1917,
     /* 396391 */     GIR_Done,
     /* 396392 */   // Label 7983: @396392
     /* 396392 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(396465), // Rule ID 5622 //
     /* 396397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396401 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 396437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 396455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396463 */     GIR_RootConstrainSelectedInstOperands,
     /* 396464 */     // GIR_Coverage, 5622,
     /* 396464 */     GIR_EraseRootFromParent_Done,
     /* 396465 */   // Label 7984: @396465
     /* 396465 */   GIM_Reject,
     /* 396466 */ // Label 7979: @396466
     /* 396466 */ GIM_Reject,
     /* 396467 */ // Label 7952: @396467
     /* 396467 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(396524), // Rule ID 13124 //
     /* 396472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 396475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396487 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396494 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 396498 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396500 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 396507 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 396510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396517 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396522 */   GIR_RootConstrainSelectedInstOperands,
     /* 396523 */   // GIR_Coverage, 13124,
     /* 396523 */   GIR_EraseRootFromParent_Done,
     /* 396524 */ // Label 7985: @396524
     /* 396524 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(396585), // Rule ID 6379 //
     /* 396529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396544 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396547 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396551 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 396558 */   // MIs[1] Rn
     /* 396558 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396562 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396569 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 396572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396578 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396583 */   GIR_RootConstrainSelectedInstOperands,
     /* 396584 */   // GIR_Coverage, 6379,
     /* 396584 */   GIR_EraseRootFromParent_Done,
     /* 396585 */ // Label 7986: @396585
     /* 396585 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(396611), // Rule ID 1912 //
     /* 396590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396604 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 396604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 396609 */   GIR_RootConstrainSelectedInstOperands,
     /* 396610 */   // GIR_Coverage, 1912,
     /* 396610 */   GIR_Done,
     /* 396611 */ // Label 7987: @396611
     /* 396611 */ GIM_Reject,
     /* 396612 */ // Label 7953: @396612
     /* 396612 */ GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(396673), // Rule ID 6382 //
     /* 396617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396632 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396639 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 396646 */   // MIs[1] Rn
     /* 396646 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396657 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 396660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396662 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396671 */   GIR_RootConstrainSelectedInstOperands,
     /* 396672 */   // GIR_Coverage, 6382,
     /* 396672 */   GIR_EraseRootFromParent_Done,
     /* 396673 */ // Label 7988: @396673
     /* 396673 */ GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(396727), // Rule ID 6399 //
     /* 396678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396693 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396700 */   // MIs[1] Rn
     /* 396700 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396711 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 396714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396716 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396725 */   GIR_RootConstrainSelectedInstOperands,
     /* 396726 */   // GIR_Coverage, 6399,
     /* 396726 */   GIR_EraseRootFromParent_Done,
     /* 396727 */ // Label 7989: @396727
     /* 396727 */ GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(396781), // Rule ID 13127 //
     /* 396732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396747 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396754 */   // MIs[1] Rn
     /* 396754 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396765 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 396768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396770 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396779 */   GIR_RootConstrainSelectedInstOperands,
     /* 396780 */   // GIR_Coverage, 13127,
     /* 396780 */   GIR_EraseRootFromParent_Done,
     /* 396781 */ // Label 7990: @396781
     /* 396781 */ GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(396807), // Rule ID 1915 //
     /* 396786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396800 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 396800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 396805 */   GIR_RootConstrainSelectedInstOperands,
     /* 396806 */   // GIR_Coverage, 1915,
     /* 396806 */   GIR_Done,
     /* 396807 */ // Label 7991: @396807
     /* 396807 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(396887), // Rule ID 5625 //
     /* 396812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396823 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396823 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 396826 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396830 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 396840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396849 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396852 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396856 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 396877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396885 */   GIR_RootConstrainSelectedInstOperands,
     /* 396886 */   // GIR_Coverage, 5625,
     /* 396886 */   GIR_EraseRootFromParent_Done,
     /* 396887 */ // Label 7992: @396887
     /* 396887 */ GIM_Reject,
     /* 396888 */ // Label 7954: @396888
     /* 396888 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(396949), // Rule ID 6380 //
     /* 396893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396908 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396911 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396915 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 396922 */   // MIs[1] Rn
     /* 396922 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396926 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396933 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 396936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396938 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396947 */   GIR_RootConstrainSelectedInstOperands,
     /* 396948 */   // GIR_Coverage, 6380,
     /* 396948 */   GIR_EraseRootFromParent_Done,
     /* 396949 */ // Label 7993: @396949
     /* 396949 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(397003), // Rule ID 13125 //
     /* 396954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 396957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396969 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396976 */   // MIs[1] Rn
     /* 396976 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396987 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 396990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397001 */   GIR_RootConstrainSelectedInstOperands,
     /* 397002 */   // GIR_Coverage, 13125,
     /* 397002 */   GIR_EraseRootFromParent_Done,
     /* 397003 */ // Label 7994: @397003
     /* 397003 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(397029), // Rule ID 1913 //
     /* 397008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397022 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 397022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 397027 */   GIR_RootConstrainSelectedInstOperands,
     /* 397028 */   // GIR_Coverage, 1913,
     /* 397028 */   GIR_Done,
     /* 397029 */ // Label 7995: @397029
     /* 397029 */ GIM_Reject,
     /* 397030 */ // Label 7955: @397030
     /* 397030 */ GIM_Reject,
     /* 397031 */ // Label 123: @397031
     /* 397031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7998*/ GIMT_Encode4(397285),
     /* 397042 */ /*GILLT_v4s16*//*Label 7996*/ GIMT_Encode4(397058), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397054 */ /*GILLT_v8s16*//*Label 7997*/ GIMT_Encode4(397144),
     /* 397058 */ // Label 7996: @397058
     /* 397058 */ GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(397143),
     /* 397063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397077 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(397111), // Rule ID 1922 //
     /* 397082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397097 */     // MIs[1] Operand 1
     /* 397097 */     // No operand predicates
     /* 397097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397099 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397109 */     GIR_RootConstrainSelectedInstOperands,
     /* 397110 */     // GIR_Coverage, 1922,
     /* 397110 */     GIR_EraseRootFromParent_Done,
     /* 397111 */   // Label 8000: @397111
     /* 397111 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(397142), // Rule ID 5626 //
     /* 397116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397128 */     // MIs[1] Operand 1
     /* 397128 */     // No operand predicates
     /* 397128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397130 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 397130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397140 */     GIR_RootConstrainSelectedInstOperands,
     /* 397141 */     // GIR_Coverage, 5626,
     /* 397141 */     GIR_EraseRootFromParent_Done,
     /* 397142 */   // Label 8001: @397142
     /* 397142 */   GIM_Reject,
     /* 397143 */ // Label 7999: @397143
     /* 397143 */ GIM_Reject,
     /* 397144 */ // Label 7997: @397144
     /* 397144 */ GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(397284),
     /* 397149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397159 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(397210), // Rule ID 6390 //
     /* 397164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397179 */     // MIs[1] Rn
     /* 397179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397194 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397208 */     GIR_RootConstrainSelectedInstOperands,
     /* 397209 */     // GIR_Coverage, 6390,
     /* 397209 */     GIR_EraseRootFromParent_Done,
     /* 397210 */   // Label 8003: @397210
     /* 397210 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(397248), // Rule ID 1923 //
     /* 397215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397234 */     // MIs[1] Operand 1
     /* 397234 */     // No operand predicates
     /* 397234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397236 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397246 */     GIR_RootConstrainSelectedInstOperands,
     /* 397247 */     // GIR_Coverage, 1923,
     /* 397247 */     GIR_EraseRootFromParent_Done,
     /* 397248 */   // Label 8004: @397248
     /* 397248 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(397283), // Rule ID 5627 //
     /* 397253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397269 */     // MIs[1] Operand 1
     /* 397269 */     // No operand predicates
     /* 397269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397271 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 397271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397281 */     GIR_RootConstrainSelectedInstOperands,
     /* 397282 */     // GIR_Coverage, 5627,
     /* 397282 */     GIR_EraseRootFromParent_Done,
     /* 397283 */   // Label 8005: @397283
     /* 397283 */   GIM_Reject,
     /* 397284 */ // Label 8002: @397284
     /* 397284 */ GIM_Reject,
     /* 397285 */ // Label 7998: @397285
     /* 397285 */ GIM_Reject,
     /* 397286 */ // Label 124: @397286
     /* 397286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8008*/ GIMT_Encode4(397540),
     /* 397297 */ /*GILLT_v2s32*//*Label 8006*/ GIMT_Encode4(397313), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397309 */ /*GILLT_v4s32*//*Label 8007*/ GIMT_Encode4(397399),
     /* 397313 */ // Label 8006: @397313
     /* 397313 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(397398),
     /* 397318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397332 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(397366), // Rule ID 1920 //
     /* 397337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397352 */     // MIs[1] Operand 1
     /* 397352 */     // No operand predicates
     /* 397352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397354 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 397357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397364 */     GIR_RootConstrainSelectedInstOperands,
     /* 397365 */     // GIR_Coverage, 1920,
     /* 397365 */     GIR_EraseRootFromParent_Done,
     /* 397366 */   // Label 8010: @397366
     /* 397366 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(397397), // Rule ID 5628 //
     /* 397371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397383 */     // MIs[1] Operand 1
     /* 397383 */     // No operand predicates
     /* 397383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397385 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 397385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 397388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397395 */     GIR_RootConstrainSelectedInstOperands,
     /* 397396 */     // GIR_Coverage, 5628,
     /* 397396 */     GIR_EraseRootFromParent_Done,
     /* 397397 */   // Label 8011: @397397
     /* 397397 */   GIM_Reject,
     /* 397398 */ // Label 8009: @397398
     /* 397398 */ GIM_Reject,
     /* 397399 */ // Label 8007: @397399
     /* 397399 */ GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(397539),
     /* 397404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397414 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(397465), // Rule ID 6392 //
     /* 397419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397434 */     // MIs[1] Rn
     /* 397434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397449 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397463 */     GIR_RootConstrainSelectedInstOperands,
     /* 397464 */     // GIR_Coverage, 6392,
     /* 397464 */     GIR_EraseRootFromParent_Done,
     /* 397465 */   // Label 8013: @397465
     /* 397465 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(397503), // Rule ID 1921 //
     /* 397470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397489 */     // MIs[1] Operand 1
     /* 397489 */     // No operand predicates
     /* 397489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397491 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397501 */     GIR_RootConstrainSelectedInstOperands,
     /* 397502 */     // GIR_Coverage, 1921,
     /* 397502 */     GIR_EraseRootFromParent_Done,
     /* 397503 */   // Label 8014: @397503
     /* 397503 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(397538), // Rule ID 5629 //
     /* 397508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397524 */     // MIs[1] Operand 1
     /* 397524 */     // No operand predicates
     /* 397524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397526 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 397526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397536 */     GIR_RootConstrainSelectedInstOperands,
     /* 397537 */     // GIR_Coverage, 5629,
     /* 397537 */     GIR_EraseRootFromParent_Done,
     /* 397538 */   // Label 8015: @397538
     /* 397538 */   GIM_Reject,
     /* 397539 */ // Label 8012: @397539
     /* 397539 */ GIM_Reject,
     /* 397540 */ // Label 8008: @397540
     /* 397540 */ GIM_Reject,
     /* 397541 */ // Label 125: @397541
     /* 397541 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(397686),
     /* 397546 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 397549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397559 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(397610), // Rule ID 6393 //
     /* 397564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397579 */     // MIs[1] Rn
     /* 397579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397594 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 397597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397608 */     GIR_RootConstrainSelectedInstOperands,
     /* 397609 */     // GIR_Coverage, 6393,
     /* 397609 */     GIR_EraseRootFromParent_Done,
     /* 397610 */   // Label 8017: @397610
     /* 397610 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(397685),
     /* 397615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397619 */     GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(397653), // Rule ID 1919 //
     /* 397624 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397627 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397631 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397635 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397639 */       // MIs[1] Operand 1
     /* 397639 */       // No operand predicates
     /* 397639 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397641 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397641 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 397644 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397646 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397648 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397651 */       GIR_RootConstrainSelectedInstOperands,
     /* 397652 */       // GIR_Coverage, 1919,
     /* 397652 */       GIR_EraseRootFromParent_Done,
     /* 397653 */     // Label 8019: @397653
     /* 397653 */     GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(397684), // Rule ID 5630 //
     /* 397658 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397662 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397666 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397670 */       // MIs[1] Operand 1
     /* 397670 */       // No operand predicates
     /* 397670 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397672 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 397672 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 397675 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397677 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397679 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397682 */       GIR_RootConstrainSelectedInstOperands,
     /* 397683 */       // GIR_Coverage, 5630,
     /* 397683 */       GIR_EraseRootFromParent_Done,
     /* 397684 */     // Label 8020: @397684
     /* 397684 */     GIM_Reject,
     /* 397685 */   // Label 8018: @397685
     /* 397685 */   GIM_Reject,
     /* 397686 */ // Label 8016: @397686
     /* 397686 */ GIM_Reject,
     /* 397687 */ // Label 126: @397687
     /* 397687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8023*/ GIMT_Encode4(397865),
     /* 397698 */ /*GILLT_v8s8*//*Label 8021*/ GIMT_Encode4(397710), GIMT_Encode4(0),
     /* 397706 */ /*GILLT_v16s8*//*Label 8022*/ GIMT_Encode4(397759),
     /* 397710 */ // Label 8021: @397710
     /* 397710 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(397758), // Rule ID 1924 //
     /* 397715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397740 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 397744 */   // MIs[1] Operand 1
     /* 397744 */   // No operand predicates
     /* 397744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397746 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 397749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397751 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397753 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397756 */   GIR_RootConstrainSelectedInstOperands,
     /* 397757 */   // GIR_Coverage, 1924,
     /* 397757 */   GIR_EraseRootFromParent_Done,
     /* 397758 */ // Label 8024: @397758
     /* 397758 */ GIM_Reject,
     /* 397759 */ // Label 8022: @397759
     /* 397759 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(397864),
     /* 397764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397774 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(397825), // Rule ID 6388 //
     /* 397779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397794 */     // MIs[1] Rn
     /* 397794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397809 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 397812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397823 */     GIR_RootConstrainSelectedInstOperands,
     /* 397824 */     // GIR_Coverage, 6388,
     /* 397824 */     GIR_EraseRootFromParent_Done,
     /* 397825 */   // Label 8026: @397825
     /* 397825 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(397863), // Rule ID 1925 //
     /* 397830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 397849 */     // MIs[1] Operand 1
     /* 397849 */     // No operand predicates
     /* 397849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397851 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 397854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397861 */     GIR_RootConstrainSelectedInstOperands,
     /* 397862 */     // GIR_Coverage, 1925,
     /* 397862 */     GIR_EraseRootFromParent_Done,
     /* 397863 */   // Label 8027: @397863
     /* 397863 */   GIM_Reject,
     /* 397864 */ // Label 8025: @397864
     /* 397864 */ GIM_Reject,
     /* 397865 */ // Label 8023: @397865
     /* 397865 */ GIM_Reject,
     /* 397866 */ // Label 127: @397866
     /* 397866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8037*/ GIMT_Encode4(399515),
     /* 397877 */ /*GILLT_s64*//*Label 8028*/ GIMT_Encode4(397961), GIMT_Encode4(0),
     /* 397885 */ /*GILLT_v2s32*//*Label 8029*/ GIMT_Encode4(398282),
     /* 397889 */ /*GILLT_v2s64*//*Label 8030*/ GIMT_Encode4(398603),
     /* 397893 */ /*GILLT_v4s16*//*Label 8031*/ GIMT_Encode4(398686),
     /* 397897 */ /*GILLT_v4s32*//*Label 8032*/ GIMT_Encode4(399007),
     /* 397901 */ /*GILLT_v8s8*//*Label 8033*/ GIMT_Encode4(399090),
     /* 397905 */ /*GILLT_v8s16*//*Label 8034*/ GIMT_Encode4(399299),
     /* 397909 */ /*GILLT_v16s8*//*Label 8035*/ GIMT_Encode4(399382), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397957 */ /*GILLT_nxv16s8*//*Label 8036*/ GIMT_Encode4(399468),
     /* 397961 */ // Label 8028: @397961
     /* 397961 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(398281),
     /* 397966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397976 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(398091), // Rule ID 5447 //
     /* 397981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397998 */     // MIs[1] Operand 2
     /* 397998 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398017 */     // MIs[2] Rn
     /* 398017 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398022 */     // MIs[2] Operand 2
     /* 398022 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 398033 */     // MIs[0] imm
     /* 398033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398041 */     // MIs[3] Operand 1
     /* 398041 */     // No operand predicates
     /* 398041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398043 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398073 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398090 */     // GIR_Coverage, 5447,
     /* 398090 */     GIR_EraseRootFromParent_Done,
     /* 398091 */   // Label 8039: @398091
     /* 398091 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(398206), // Rule ID 5452 //
     /* 398096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398113 */     // MIs[1] Operand 2
     /* 398113 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398132 */     // MIs[2] Rn
     /* 398132 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398137 */     // MIs[2] Operand 2
     /* 398137 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 398148 */     // MIs[0] imm
     /* 398148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398156 */     // MIs[3] Operand 1
     /* 398156 */     // No operand predicates
     /* 398156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398158 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398205 */     // GIR_Coverage, 5452,
     /* 398205 */     GIR_EraseRootFromParent_Done,
     /* 398206 */   // Label 8040: @398206
     /* 398206 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(398243), // Rule ID 5444 //
     /* 398211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398219 */     // MIs[0] imm
     /* 398219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398227 */     // MIs[1] Operand 1
     /* 398227 */     // No operand predicates
     /* 398227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398229 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398241 */     GIR_RootConstrainSelectedInstOperands,
     /* 398242 */     // GIR_Coverage, 5444,
     /* 398242 */     GIR_EraseRootFromParent_Done,
     /* 398243 */   // Label 8041: @398243
     /* 398243 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(398280), // Rule ID 5449 //
     /* 398248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398256 */     // MIs[0] imm
     /* 398256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398264 */     // MIs[1] Operand 1
     /* 398264 */     // No operand predicates
     /* 398264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398266 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398278 */     GIR_RootConstrainSelectedInstOperands,
     /* 398279 */     // GIR_Coverage, 5449,
     /* 398279 */     GIR_EraseRootFromParent_Done,
     /* 398280 */   // Label 8042: @398280
     /* 398280 */   GIM_Reject,
     /* 398281 */ // Label 8038: @398281
     /* 398281 */ GIM_Reject,
     /* 398282 */ // Label 8029: @398282
     /* 398282 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(398602),
     /* 398287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398297 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(398412), // Rule ID 5437 //
     /* 398302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398319 */     // MIs[1] Operand 2
     /* 398319 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398338 */     // MIs[2] Rn
     /* 398338 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398343 */     // MIs[2] Operand 2
     /* 398343 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 398354 */     // MIs[0] imm
     /* 398354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398362 */     // MIs[3] Operand 1
     /* 398362 */     // No operand predicates
     /* 398362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398364 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398411 */     // GIR_Coverage, 5437,
     /* 398411 */     GIR_EraseRootFromParent_Done,
     /* 398412 */   // Label 8044: @398412
     /* 398412 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(398527), // Rule ID 5442 //
     /* 398417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398434 */     // MIs[1] Operand 2
     /* 398434 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398453 */     // MIs[2] Rn
     /* 398453 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398458 */     // MIs[2] Operand 2
     /* 398458 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 398469 */     // MIs[0] imm
     /* 398469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398477 */     // MIs[3] Operand 1
     /* 398477 */     // No operand predicates
     /* 398477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398479 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398526 */     // GIR_Coverage, 5442,
     /* 398526 */     GIR_EraseRootFromParent_Done,
     /* 398527 */   // Label 8045: @398527
     /* 398527 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(398564), // Rule ID 5434 //
     /* 398532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398540 */     // MIs[0] imm
     /* 398540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398548 */     // MIs[1] Operand 1
     /* 398548 */     // No operand predicates
     /* 398548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398550 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398562 */     GIR_RootConstrainSelectedInstOperands,
     /* 398563 */     // GIR_Coverage, 5434,
     /* 398563 */     GIR_EraseRootFromParent_Done,
     /* 398564 */   // Label 8046: @398564
     /* 398564 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(398601), // Rule ID 5439 //
     /* 398569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398577 */     // MIs[0] imm
     /* 398577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398585 */     // MIs[1] Operand 1
     /* 398585 */     // No operand predicates
     /* 398585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398587 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398599 */     GIR_RootConstrainSelectedInstOperands,
     /* 398600 */     // GIR_Coverage, 5439,
     /* 398600 */     GIR_EraseRootFromParent_Done,
     /* 398601 */   // Label 8047: @398601
     /* 398601 */   GIM_Reject,
     /* 398602 */ // Label 8043: @398602
     /* 398602 */ GIM_Reject,
     /* 398603 */ // Label 8030: @398603
     /* 398603 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(398685),
     /* 398608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398626 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(398655), // Rule ID 5445 //
     /* 398631 */     // MIs[0] imm
     /* 398631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398639 */     // MIs[1] Operand 1
     /* 398639 */     // No operand predicates
     /* 398639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398641 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398653 */     GIR_RootConstrainSelectedInstOperands,
     /* 398654 */     // GIR_Coverage, 5445,
     /* 398654 */     GIR_EraseRootFromParent_Done,
     /* 398655 */   // Label 8049: @398655
     /* 398655 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(398684), // Rule ID 5450 //
     /* 398660 */     // MIs[0] imm
     /* 398660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398668 */     // MIs[1] Operand 1
     /* 398668 */     // No operand predicates
     /* 398668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398670 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398682 */     GIR_RootConstrainSelectedInstOperands,
     /* 398683 */     // GIR_Coverage, 5450,
     /* 398683 */     GIR_EraseRootFromParent_Done,
     /* 398684 */   // Label 8050: @398684
     /* 398684 */   GIM_Reject,
     /* 398685 */ // Label 8048: @398685
     /* 398685 */ GIM_Reject,
     /* 398686 */ // Label 8031: @398686
     /* 398686 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(399006),
     /* 398691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398701 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(398816), // Rule ID 5427 //
     /* 398706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398723 */     // MIs[1] Operand 2
     /* 398723 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398742 */     // MIs[2] Rn
     /* 398742 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398747 */     // MIs[2] Operand 2
     /* 398747 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 398758 */     // MIs[0] imm
     /* 398758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398766 */     // MIs[3] Operand 1
     /* 398766 */     // No operand predicates
     /* 398766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398768 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398798 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398815 */     // GIR_Coverage, 5427,
     /* 398815 */     GIR_EraseRootFromParent_Done,
     /* 398816 */   // Label 8052: @398816
     /* 398816 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(398931), // Rule ID 5432 //
     /* 398821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398838 */     // MIs[1] Operand 2
     /* 398838 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398857 */     // MIs[2] Rn
     /* 398857 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398862 */     // MIs[2] Operand 2
     /* 398862 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 398873 */     // MIs[0] imm
     /* 398873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398881 */     // MIs[3] Operand 1
     /* 398881 */     // No operand predicates
     /* 398881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398883 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398930 */     // GIR_Coverage, 5432,
     /* 398930 */     GIR_EraseRootFromParent_Done,
     /* 398931 */   // Label 8053: @398931
     /* 398931 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(398968), // Rule ID 5424 //
     /* 398936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398944 */     // MIs[0] imm
     /* 398944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398952 */     // MIs[1] Operand 1
     /* 398952 */     // No operand predicates
     /* 398952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398954 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398966 */     GIR_RootConstrainSelectedInstOperands,
     /* 398967 */     // GIR_Coverage, 5424,
     /* 398967 */     GIR_EraseRootFromParent_Done,
     /* 398968 */   // Label 8054: @398968
     /* 398968 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(399005), // Rule ID 5429 //
     /* 398973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398981 */     // MIs[0] imm
     /* 398981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398989 */     // MIs[1] Operand 1
     /* 398989 */     // No operand predicates
     /* 398989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398991 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399003 */     GIR_RootConstrainSelectedInstOperands,
     /* 399004 */     // GIR_Coverage, 5429,
     /* 399004 */     GIR_EraseRootFromParent_Done,
     /* 399005 */   // Label 8055: @399005
     /* 399005 */   GIM_Reject,
     /* 399006 */ // Label 8051: @399006
     /* 399006 */ GIM_Reject,
     /* 399007 */ // Label 8032: @399007
     /* 399007 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(399089),
     /* 399012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399030 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(399059), // Rule ID 5435 //
     /* 399035 */     // MIs[0] imm
     /* 399035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399043 */     // MIs[1] Operand 1
     /* 399043 */     // No operand predicates
     /* 399043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399045 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399057 */     GIR_RootConstrainSelectedInstOperands,
     /* 399058 */     // GIR_Coverage, 5435,
     /* 399058 */     GIR_EraseRootFromParent_Done,
     /* 399059 */   // Label 8057: @399059
     /* 399059 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(399088), // Rule ID 5440 //
     /* 399064 */     // MIs[0] imm
     /* 399064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399072 */     // MIs[1] Operand 1
     /* 399072 */     // No operand predicates
     /* 399072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399074 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399086 */     GIR_RootConstrainSelectedInstOperands,
     /* 399087 */     // GIR_Coverage, 5440,
     /* 399087 */     GIR_EraseRootFromParent_Done,
     /* 399088 */   // Label 8058: @399088
     /* 399088 */   GIM_Reject,
     /* 399089 */ // Label 8056: @399089
     /* 399089 */ GIM_Reject,
     /* 399090 */ // Label 8033: @399090
     /* 399090 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(399298),
     /* 399095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399105 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(399220), // Rule ID 5422 //
     /* 399110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399127 */     // MIs[1] Operand 2
     /* 399127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399146 */     // MIs[2] Rn
     /* 399146 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399151 */     // MIs[2] Operand 2
     /* 399151 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 399162 */     // MIs[0] imm
     /* 399162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399170 */     // MIs[3] Operand 1
     /* 399170 */     // No operand predicates
     /* 399170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399172 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399202 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399219 */     // GIR_Coverage, 5422,
     /* 399219 */     GIR_EraseRootFromParent_Done,
     /* 399220 */   // Label 8060: @399220
     /* 399220 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(399260), // Rule ID 1868 //
     /* 399225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399236 */     // MIs[0] imm
     /* 399236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399244 */     // MIs[1] Operand 1
     /* 399244 */     // No operand predicates
     /* 399244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399246 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399258 */     GIR_RootConstrainSelectedInstOperands,
     /* 399259 */     // GIR_Coverage, 1868,
     /* 399259 */     GIR_EraseRootFromParent_Done,
     /* 399260 */   // Label 8061: @399260
     /* 399260 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(399297), // Rule ID 5419 //
     /* 399265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399273 */     // MIs[0] imm
     /* 399273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399281 */     // MIs[1] Operand 1
     /* 399281 */     // No operand predicates
     /* 399281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399283 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399295 */     GIR_RootConstrainSelectedInstOperands,
     /* 399296 */     // GIR_Coverage, 5419,
     /* 399296 */     GIR_EraseRootFromParent_Done,
     /* 399297 */   // Label 8062: @399297
     /* 399297 */   GIM_Reject,
     /* 399298 */ // Label 8059: @399298
     /* 399298 */ GIM_Reject,
     /* 399299 */ // Label 8034: @399299
     /* 399299 */ GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(399381),
     /* 399304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399322 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(399351), // Rule ID 5425 //
     /* 399327 */     // MIs[0] imm
     /* 399327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399335 */     // MIs[1] Operand 1
     /* 399335 */     // No operand predicates
     /* 399335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399337 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399349 */     GIR_RootConstrainSelectedInstOperands,
     /* 399350 */     // GIR_Coverage, 5425,
     /* 399350 */     GIR_EraseRootFromParent_Done,
     /* 399351 */   // Label 8064: @399351
     /* 399351 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(399380), // Rule ID 5430 //
     /* 399356 */     // MIs[0] imm
     /* 399356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399364 */     // MIs[1] Operand 1
     /* 399364 */     // No operand predicates
     /* 399364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399366 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399378 */     GIR_RootConstrainSelectedInstOperands,
     /* 399379 */     // GIR_Coverage, 5430,
     /* 399379 */     GIR_EraseRootFromParent_Done,
     /* 399380 */   // Label 8065: @399380
     /* 399380 */   GIM_Reject,
     /* 399381 */ // Label 8063: @399381
     /* 399381 */ GIM_Reject,
     /* 399382 */ // Label 8035: @399382
     /* 399382 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(399467),
     /* 399387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399405 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(399437), // Rule ID 1869 //
     /* 399410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399413 */     // MIs[0] imm
     /* 399413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399421 */     // MIs[1] Operand 1
     /* 399421 */     // No operand predicates
     /* 399421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399423 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399435 */     GIR_RootConstrainSelectedInstOperands,
     /* 399436 */     // GIR_Coverage, 1869,
     /* 399436 */     GIR_EraseRootFromParent_Done,
     /* 399437 */   // Label 8067: @399437
     /* 399437 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(399466), // Rule ID 5420 //
     /* 399442 */     // MIs[0] imm
     /* 399442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399450 */     // MIs[1] Operand 1
     /* 399450 */     // No operand predicates
     /* 399450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399452 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399464 */     GIR_RootConstrainSelectedInstOperands,
     /* 399465 */     // GIR_Coverage, 5420,
     /* 399465 */     GIR_EraseRootFromParent_Done,
     /* 399466 */   // Label 8068: @399466
     /* 399466 */   GIM_Reject,
     /* 399467 */ // Label 8066: @399467
     /* 399467 */ GIM_Reject,
     /* 399468 */ // Label 8036: @399468
     /* 399468 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(399514), // Rule ID 2733 //
     /* 399473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399486 */   // MIs[0] Op3
     /* 399486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399494 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 399498 */   // MIs[1] Operand 1
     /* 399498 */   // No operand predicates
     /* 399498 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399500 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 399500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 399503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 399505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 399507 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 399509 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 399512 */   GIR_RootConstrainSelectedInstOperands,
     /* 399513 */   // GIR_Coverage, 2733,
     /* 399513 */   GIR_EraseRootFromParent_Done,
     /* 399514 */ // Label 8069: @399514
     /* 399514 */ GIM_Reject,
     /* 399515 */ // Label 8037: @399515
     /* 399515 */ GIM_Reject,
     /* 399516 */ // Label 128: @399516
     /* 399516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8077*/ GIMT_Encode4(399854),
     /* 399527 */ /*GILLT_s32*//*Label 8070*/ GIMT_Encode4(399563),
     /* 399531 */ /*GILLT_s64*//*Label 8071*/ GIMT_Encode4(399601), GIMT_Encode4(0),
     /* 399539 */ /*GILLT_v2s32*//*Label 8072*/ GIMT_Encode4(399664),
     /* 399543 */ /*GILLT_v2s64*//*Label 8073*/ GIMT_Encode4(399702),
     /* 399547 */ /*GILLT_v4s16*//*Label 8074*/ GIMT_Encode4(399740),
     /* 399551 */ /*GILLT_v4s32*//*Label 8075*/ GIMT_Encode4(399778), GIMT_Encode4(0),
     /* 399559 */ /*GILLT_v8s16*//*Label 8076*/ GIMT_Encode4(399816),
     /* 399563 */ // Label 8070: @399563
     /* 399563 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(399600), // Rule ID 1622 //
     /* 399568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399589 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 399594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399598 */   GIR_RootConstrainSelectedInstOperands,
     /* 399599 */   // GIR_Coverage, 1622,
     /* 399599 */   GIR_Done,
     /* 399600 */ // Label 8078: @399600
     /* 399600 */ GIM_Reject,
     /* 399601 */ // Label 8071: @399601
     /* 399601 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(399663),
     /* 399606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399624 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(399643), // Rule ID 1621 //
     /* 399629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399632 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 399637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399641 */     GIR_RootConstrainSelectedInstOperands,
     /* 399642 */     // GIR_Coverage, 1621,
     /* 399642 */     GIR_Done,
     /* 399643 */   // Label 8080: @399643
     /* 399643 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(399662), // Rule ID 5199 //
     /* 399648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399651 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 399651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 399656 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399660 */     GIR_RootConstrainSelectedInstOperands,
     /* 399661 */     // GIR_Coverage, 5199,
     /* 399661 */     GIR_Done,
     /* 399662 */   // Label 8081: @399662
     /* 399662 */   GIM_Reject,
     /* 399663 */ // Label 8079: @399663
     /* 399663 */ GIM_Reject,
     /* 399664 */ // Label 8072: @399664
     /* 399664 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(399701), // Rule ID 1210 //
     /* 399669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399690 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 399695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399699 */   GIR_RootConstrainSelectedInstOperands,
     /* 399700 */   // GIR_Coverage, 1210,
     /* 399700 */   GIR_Done,
     /* 399701 */ // Label 8082: @399701
     /* 399701 */ GIM_Reject,
     /* 399702 */ // Label 8073: @399702
     /* 399702 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(399739), // Rule ID 1212 //
     /* 399707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399728 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 399733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399737 */   GIR_RootConstrainSelectedInstOperands,
     /* 399738 */   // GIR_Coverage, 1212,
     /* 399738 */   GIR_Done,
     /* 399739 */ // Label 8083: @399739
     /* 399739 */ GIM_Reject,
     /* 399740 */ // Label 8074: @399740
     /* 399740 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(399777), // Rule ID 1208 //
     /* 399745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399766 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 399771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399775 */   GIR_RootConstrainSelectedInstOperands,
     /* 399776 */   // GIR_Coverage, 1208,
     /* 399776 */   GIR_Done,
     /* 399777 */ // Label 8084: @399777
     /* 399777 */ GIM_Reject,
     /* 399778 */ // Label 8075: @399778
     /* 399778 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(399815), // Rule ID 1211 //
     /* 399783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399804 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 399809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399813 */   GIR_RootConstrainSelectedInstOperands,
     /* 399814 */   // GIR_Coverage, 1211,
     /* 399814 */   GIR_Done,
     /* 399815 */ // Label 8085: @399815
     /* 399815 */ GIM_Reject,
     /* 399816 */ // Label 8076: @399816
     /* 399816 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(399853), // Rule ID 1209 //
     /* 399821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399842 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 399847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399851 */   GIR_RootConstrainSelectedInstOperands,
     /* 399852 */   // GIR_Coverage, 1209,
     /* 399852 */   GIR_Done,
     /* 399853 */ // Label 8086: @399853
     /* 399853 */ GIM_Reject,
     /* 399854 */ // Label 8077: @399854
     /* 399854 */ GIM_Reject,
     /* 399855 */ // Label 129: @399855
     /* 399855 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8093*/ GIMT_Encode4(400084),
     /* 399866 */ /*GILLT_s64*//*Label 8087*/ GIMT_Encode4(399898), GIMT_Encode4(0),
     /* 399874 */ /*GILLT_v2s32*//*Label 8088*/ GIMT_Encode4(399929),
     /* 399878 */ /*GILLT_v2s64*//*Label 8089*/ GIMT_Encode4(399960),
     /* 399882 */ /*GILLT_v4s16*//*Label 8090*/ GIMT_Encode4(399991),
     /* 399886 */ /*GILLT_v4s32*//*Label 8091*/ GIMT_Encode4(400022), GIMT_Encode4(0),
     /* 399894 */ /*GILLT_v8s16*//*Label 8092*/ GIMT_Encode4(400053),
     /* 399898 */ // Label 8087: @399898
     /* 399898 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(399928), // Rule ID 2513 //
     /* 399903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399917 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 399917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 399922 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399926 */   GIR_RootConstrainSelectedInstOperands,
     /* 399927 */   // GIR_Coverage, 2513,
     /* 399927 */   GIR_Done,
     /* 399928 */ // Label 8094: @399928
     /* 399928 */ GIM_Reject,
     /* 399929 */ // Label 8088: @399929
     /* 399929 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(399959), // Rule ID 773 //
     /* 399934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399948 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 399948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 399953 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399957 */   GIR_RootConstrainSelectedInstOperands,
     /* 399958 */   // GIR_Coverage, 773,
     /* 399958 */   GIR_Done,
     /* 399959 */ // Label 8095: @399959
     /* 399959 */ GIM_Reject,
     /* 399960 */ // Label 8089: @399960
     /* 399960 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(399990), // Rule ID 775 //
     /* 399965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399979 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 399979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 399984 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399988 */   GIR_RootConstrainSelectedInstOperands,
     /* 399989 */   // GIR_Coverage, 775,
     /* 399989 */   GIR_Done,
     /* 399990 */ // Label 8096: @399990
     /* 399990 */ GIM_Reject,
     /* 399991 */ // Label 8090: @399991
     /* 399991 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(400021), // Rule ID 771 //
     /* 399996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400010 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 400010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 400015 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400019 */   GIR_RootConstrainSelectedInstOperands,
     /* 400020 */   // GIR_Coverage, 771,
     /* 400020 */   GIR_Done,
     /* 400021 */ // Label 8097: @400021
     /* 400021 */ GIM_Reject,
     /* 400022 */ // Label 8091: @400022
     /* 400022 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(400052), // Rule ID 774 //
     /* 400027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400041 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 400041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 400046 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400050 */   GIR_RootConstrainSelectedInstOperands,
     /* 400051 */   // GIR_Coverage, 774,
     /* 400051 */   GIR_Done,
     /* 400052 */ // Label 8098: @400052
     /* 400052 */ GIM_Reject,
     /* 400053 */ // Label 8092: @400053
     /* 400053 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(400083), // Rule ID 772 //
     /* 400058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400072 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 400072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 400077 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400081 */   GIR_RootConstrainSelectedInstOperands,
     /* 400082 */   // GIR_Coverage, 772,
     /* 400082 */   GIR_Done,
     /* 400083 */ // Label 8099: @400083
     /* 400083 */ GIM_Reject,
     /* 400084 */ // Label 8093: @400084
     /* 400084 */ GIM_Reject,
     /* 400085 */ // Label 130: @400085
     /* 400085 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8107*/ GIMT_Encode4(400748),
     /* 400096 */ /*GILLT_s32*//*Label 8100*/ GIMT_Encode4(400132),
     /* 400100 */ /*GILLT_s64*//*Label 8101*/ GIMT_Encode4(400170), GIMT_Encode4(0),
     /* 400108 */ /*GILLT_v2s32*//*Label 8102*/ GIMT_Encode4(400233),
     /* 400112 */ /*GILLT_v2s64*//*Label 8103*/ GIMT_Encode4(400336),
     /* 400116 */ /*GILLT_v4s16*//*Label 8104*/ GIMT_Encode4(400439),
     /* 400120 */ /*GILLT_v4s32*//*Label 8105*/ GIMT_Encode4(400542), GIMT_Encode4(0),
     /* 400128 */ /*GILLT_v8s16*//*Label 8106*/ GIMT_Encode4(400645),
     /* 400132 */ // Label 8100: @400132
     /* 400132 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(400169), // Rule ID 1624 //
     /* 400137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400158 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 400163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400167 */   GIR_RootConstrainSelectedInstOperands,
     /* 400168 */   // GIR_Coverage, 1624,
     /* 400168 */   GIR_Done,
     /* 400169 */ // Label 8108: @400169
     /* 400169 */ GIM_Reject,
     /* 400170 */ // Label 8101: @400170
     /* 400170 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(400232),
     /* 400175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400193 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(400212), // Rule ID 1623 //
     /* 400198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400201 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 400206 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400210 */     GIR_RootConstrainSelectedInstOperands,
     /* 400211 */     // GIR_Coverage, 1623,
     /* 400211 */     GIR_Done,
     /* 400212 */   // Label 8110: @400212
     /* 400212 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(400231), // Rule ID 5200 //
     /* 400217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400220 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 400220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 400225 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400229 */     GIR_RootConstrainSelectedInstOperands,
     /* 400230 */     // GIR_Coverage, 5200,
     /* 400230 */     GIR_Done,
     /* 400231 */   // Label 8111: @400231
     /* 400231 */   GIM_Reject,
     /* 400232 */ // Label 8109: @400232
     /* 400232 */ GIM_Reject,
     /* 400233 */ // Label 8102: @400233
     /* 400233 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(400335),
     /* 400238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400248 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(400307), // Rule ID 1172 //
     /* 400253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400292 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 400295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400305 */     GIR_RootConstrainSelectedInstOperands,
     /* 400306 */     // GIR_Coverage, 1172,
     /* 400306 */     GIR_EraseRootFromParent_Done,
     /* 400307 */   // Label 8113: @400307
     /* 400307 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(400334), // Rule ID 1215 //
     /* 400312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400323 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 400328 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400332 */     GIR_RootConstrainSelectedInstOperands,
     /* 400333 */     // GIR_Coverage, 1215,
     /* 400333 */     GIR_Done,
     /* 400334 */   // Label 8114: @400334
     /* 400334 */   GIM_Reject,
     /* 400335 */ // Label 8112: @400335
     /* 400335 */ GIM_Reject,
     /* 400336 */ // Label 8103: @400336
     /* 400336 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(400438),
     /* 400341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400351 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(400410), // Rule ID 1176 //
     /* 400356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400395 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 400398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400408 */     GIR_RootConstrainSelectedInstOperands,
     /* 400409 */     // GIR_Coverage, 1176,
     /* 400409 */     GIR_EraseRootFromParent_Done,
     /* 400410 */   // Label 8116: @400410
     /* 400410 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(400437), // Rule ID 1217 //
     /* 400415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400426 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 400431 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400435 */     GIR_RootConstrainSelectedInstOperands,
     /* 400436 */     // GIR_Coverage, 1217,
     /* 400436 */     GIR_Done,
     /* 400437 */   // Label 8117: @400437
     /* 400437 */   GIM_Reject,
     /* 400438 */ // Label 8115: @400438
     /* 400438 */ GIM_Reject,
     /* 400439 */ // Label 8104: @400439
     /* 400439 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(400541),
     /* 400444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400454 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(400513), // Rule ID 1168 //
     /* 400459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400498 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 400501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400511 */     GIR_RootConstrainSelectedInstOperands,
     /* 400512 */     // GIR_Coverage, 1168,
     /* 400512 */     GIR_EraseRootFromParent_Done,
     /* 400513 */   // Label 8119: @400513
     /* 400513 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(400540), // Rule ID 1213 //
     /* 400518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400529 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 400534 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400538 */     GIR_RootConstrainSelectedInstOperands,
     /* 400539 */     // GIR_Coverage, 1213,
     /* 400539 */     GIR_Done,
     /* 400540 */   // Label 8120: @400540
     /* 400540 */   GIM_Reject,
     /* 400541 */ // Label 8118: @400541
     /* 400541 */ GIM_Reject,
     /* 400542 */ // Label 8105: @400542
     /* 400542 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(400644),
     /* 400547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400557 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(400616), // Rule ID 1174 //
     /* 400562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400601 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 400604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400614 */     GIR_RootConstrainSelectedInstOperands,
     /* 400615 */     // GIR_Coverage, 1174,
     /* 400615 */     GIR_EraseRootFromParent_Done,
     /* 400616 */   // Label 8122: @400616
     /* 400616 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(400643), // Rule ID 1216 //
     /* 400621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400632 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 400637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400641 */     GIR_RootConstrainSelectedInstOperands,
     /* 400642 */     // GIR_Coverage, 1216,
     /* 400642 */     GIR_Done,
     /* 400643 */   // Label 8123: @400643
     /* 400643 */   GIM_Reject,
     /* 400644 */ // Label 8121: @400644
     /* 400644 */ GIM_Reject,
     /* 400645 */ // Label 8106: @400645
     /* 400645 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(400747),
     /* 400650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400660 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(400719), // Rule ID 1170 //
     /* 400665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400704 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 400707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400717 */     GIR_RootConstrainSelectedInstOperands,
     /* 400718 */     // GIR_Coverage, 1170,
     /* 400718 */     GIR_EraseRootFromParent_Done,
     /* 400719 */   // Label 8125: @400719
     /* 400719 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(400746), // Rule ID 1214 //
     /* 400724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400735 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 400740 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400744 */     GIR_RootConstrainSelectedInstOperands,
     /* 400745 */     // GIR_Coverage, 1214,
     /* 400745 */     GIR_Done,
     /* 400746 */   // Label 8126: @400746
     /* 400746 */   GIM_Reject,
     /* 400747 */ // Label 8124: @400747
     /* 400747 */ GIM_Reject,
     /* 400748 */ // Label 8107: @400748
     /* 400748 */ GIM_Reject,
     /* 400749 */ // Label 131: @400749
     /* 400749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8133*/ GIMT_Encode4(400978),
     /* 400760 */ /*GILLT_s64*//*Label 8127*/ GIMT_Encode4(400792), GIMT_Encode4(0),
     /* 400768 */ /*GILLT_v2s32*//*Label 8128*/ GIMT_Encode4(400823),
     /* 400772 */ /*GILLT_v2s64*//*Label 8129*/ GIMT_Encode4(400854),
     /* 400776 */ /*GILLT_v4s16*//*Label 8130*/ GIMT_Encode4(400885),
     /* 400780 */ /*GILLT_v4s32*//*Label 8131*/ GIMT_Encode4(400916), GIMT_Encode4(0),
     /* 400788 */ /*GILLT_v8s16*//*Label 8132*/ GIMT_Encode4(400947),
     /* 400792 */ // Label 8127: @400792
     /* 400792 */ GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(400822), // Rule ID 5231 //
     /* 400797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400811 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 400811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 400816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400820 */   GIR_RootConstrainSelectedInstOperands,
     /* 400821 */   // GIR_Coverage, 5231,
     /* 400821 */   GIR_Done,
     /* 400822 */ // Label 8134: @400822
     /* 400822 */ GIM_Reject,
     /* 400823 */ // Label 8128: @400823
     /* 400823 */ GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(400853), // Rule ID 778 //
     /* 400828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400842 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 400842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 400847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400851 */   GIR_RootConstrainSelectedInstOperands,
     /* 400852 */   // GIR_Coverage, 778,
     /* 400852 */   GIR_Done,
     /* 400853 */ // Label 8135: @400853
     /* 400853 */ GIM_Reject,
     /* 400854 */ // Label 8129: @400854
     /* 400854 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(400884), // Rule ID 780 //
     /* 400859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400873 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 400873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 400878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400882 */   GIR_RootConstrainSelectedInstOperands,
     /* 400883 */   // GIR_Coverage, 780,
     /* 400883 */   GIR_Done,
     /* 400884 */ // Label 8136: @400884
     /* 400884 */ GIM_Reject,
     /* 400885 */ // Label 8130: @400885
     /* 400885 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(400915), // Rule ID 776 //
     /* 400890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400904 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 400904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 400909 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400913 */   GIR_RootConstrainSelectedInstOperands,
     /* 400914 */   // GIR_Coverage, 776,
     /* 400914 */   GIR_Done,
     /* 400915 */ // Label 8137: @400915
     /* 400915 */ GIM_Reject,
     /* 400916 */ // Label 8131: @400916
     /* 400916 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(400946), // Rule ID 779 //
     /* 400921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400935 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 400935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 400940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400944 */   GIR_RootConstrainSelectedInstOperands,
     /* 400945 */   // GIR_Coverage, 779,
     /* 400945 */   GIR_Done,
     /* 400946 */ // Label 8138: @400946
     /* 400946 */ GIM_Reject,
     /* 400947 */ // Label 8132: @400947
     /* 400947 */ GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(400977), // Rule ID 777 //
     /* 400952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400966 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 400966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 400971 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400975 */   GIR_RootConstrainSelectedInstOperands,
     /* 400976 */   // GIR_Coverage, 777,
     /* 400976 */   GIR_Done,
     /* 400977 */ // Label 8139: @400977
     /* 400977 */ GIM_Reject,
     /* 400978 */ // Label 8133: @400978
     /* 400978 */ GIM_Reject,
     /* 400979 */ // Label 132: @400979
     /* 400979 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8147*/ GIMT_Encode4(401642),
     /* 400990 */ /*GILLT_s32*//*Label 8140*/ GIMT_Encode4(401026),
     /* 400994 */ /*GILLT_s64*//*Label 8141*/ GIMT_Encode4(401064), GIMT_Encode4(0),
     /* 401002 */ /*GILLT_v2s32*//*Label 8142*/ GIMT_Encode4(401127),
     /* 401006 */ /*GILLT_v2s64*//*Label 8143*/ GIMT_Encode4(401230),
     /* 401010 */ /*GILLT_v4s16*//*Label 8144*/ GIMT_Encode4(401333),
     /* 401014 */ /*GILLT_v4s32*//*Label 8145*/ GIMT_Encode4(401436), GIMT_Encode4(0),
     /* 401022 */ /*GILLT_v8s16*//*Label 8146*/ GIMT_Encode4(401539),
     /* 401026 */ // Label 8140: @401026
     /* 401026 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(401063), // Rule ID 1626 //
     /* 401031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401052 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 401057 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401061 */   GIR_RootConstrainSelectedInstOperands,
     /* 401062 */   // GIR_Coverage, 1626,
     /* 401062 */   GIR_Done,
     /* 401063 */ // Label 8148: @401063
     /* 401063 */ GIM_Reject,
     /* 401064 */ // Label 8141: @401064
     /* 401064 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(401126),
     /* 401069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401087 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(401106), // Rule ID 1625 //
     /* 401092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401095 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401104 */     GIR_RootConstrainSelectedInstOperands,
     /* 401105 */     // GIR_Coverage, 1625,
     /* 401105 */     GIR_Done,
     /* 401106 */   // Label 8150: @401106
     /* 401106 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(401125), // Rule ID 5201 //
     /* 401111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401114 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 401114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401119 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401123 */     GIR_RootConstrainSelectedInstOperands,
     /* 401124 */     // GIR_Coverage, 5201,
     /* 401124 */     GIR_Done,
     /* 401125 */   // Label 8151: @401125
     /* 401125 */   GIM_Reject,
     /* 401126 */ // Label 8149: @401126
     /* 401126 */ GIM_Reject,
     /* 401127 */ // Label 8142: @401127
     /* 401127 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(401229),
     /* 401132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401142 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(401201), // Rule ID 1182 //
     /* 401147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401186 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 401189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401199 */     GIR_RootConstrainSelectedInstOperands,
     /* 401200 */     // GIR_Coverage, 1182,
     /* 401200 */     GIR_EraseRootFromParent_Done,
     /* 401201 */   // Label 8153: @401201
     /* 401201 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(401228), // Rule ID 1220 //
     /* 401206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401217 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 401222 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401226 */     GIR_RootConstrainSelectedInstOperands,
     /* 401227 */     // GIR_Coverage, 1220,
     /* 401227 */     GIR_Done,
     /* 401228 */   // Label 8154: @401228
     /* 401228 */   GIM_Reject,
     /* 401229 */ // Label 8152: @401229
     /* 401229 */ GIM_Reject,
     /* 401230 */ // Label 8143: @401230
     /* 401230 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(401332),
     /* 401235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401245 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(401304), // Rule ID 1186 //
     /* 401250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401289 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 401292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401302 */     GIR_RootConstrainSelectedInstOperands,
     /* 401303 */     // GIR_Coverage, 1186,
     /* 401303 */     GIR_EraseRootFromParent_Done,
     /* 401304 */   // Label 8156: @401304
     /* 401304 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(401331), // Rule ID 1222 //
     /* 401309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401320 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 401325 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401329 */     GIR_RootConstrainSelectedInstOperands,
     /* 401330 */     // GIR_Coverage, 1222,
     /* 401330 */     GIR_Done,
     /* 401331 */   // Label 8157: @401331
     /* 401331 */   GIM_Reject,
     /* 401332 */ // Label 8155: @401332
     /* 401332 */ GIM_Reject,
     /* 401333 */ // Label 8144: @401333
     /* 401333 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(401435),
     /* 401338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401348 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(401407), // Rule ID 1178 //
     /* 401353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401392 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 401395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401405 */     GIR_RootConstrainSelectedInstOperands,
     /* 401406 */     // GIR_Coverage, 1178,
     /* 401406 */     GIR_EraseRootFromParent_Done,
     /* 401407 */   // Label 8159: @401407
     /* 401407 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(401434), // Rule ID 1218 //
     /* 401412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401423 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 401428 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401432 */     GIR_RootConstrainSelectedInstOperands,
     /* 401433 */     // GIR_Coverage, 1218,
     /* 401433 */     GIR_Done,
     /* 401434 */   // Label 8160: @401434
     /* 401434 */   GIM_Reject,
     /* 401435 */ // Label 8158: @401435
     /* 401435 */ GIM_Reject,
     /* 401436 */ // Label 8145: @401436
     /* 401436 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(401538),
     /* 401441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401451 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(401510), // Rule ID 1184 //
     /* 401456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401495 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 401498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401508 */     GIR_RootConstrainSelectedInstOperands,
     /* 401509 */     // GIR_Coverage, 1184,
     /* 401509 */     GIR_EraseRootFromParent_Done,
     /* 401510 */   // Label 8162: @401510
     /* 401510 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(401537), // Rule ID 1221 //
     /* 401515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401526 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 401531 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401535 */     GIR_RootConstrainSelectedInstOperands,
     /* 401536 */     // GIR_Coverage, 1221,
     /* 401536 */     GIR_Done,
     /* 401537 */   // Label 8163: @401537
     /* 401537 */   GIM_Reject,
     /* 401538 */ // Label 8161: @401538
     /* 401538 */ GIM_Reject,
     /* 401539 */ // Label 8146: @401539
     /* 401539 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(401641),
     /* 401544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401554 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(401613), // Rule ID 1180 //
     /* 401559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401598 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 401601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401611 */     GIR_RootConstrainSelectedInstOperands,
     /* 401612 */     // GIR_Coverage, 1180,
     /* 401612 */     GIR_EraseRootFromParent_Done,
     /* 401613 */   // Label 8165: @401613
     /* 401613 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(401640), // Rule ID 1219 //
     /* 401618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401629 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 401634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401638 */     GIR_RootConstrainSelectedInstOperands,
     /* 401639 */     // GIR_Coverage, 1219,
     /* 401639 */     GIR_Done,
     /* 401640 */   // Label 8166: @401640
     /* 401640 */   GIM_Reject,
     /* 401641 */ // Label 8164: @401641
     /* 401641 */ GIM_Reject,
     /* 401642 */ // Label 8147: @401642
     /* 401642 */ GIM_Reject,
     /* 401643 */ // Label 133: @401643
     /* 401643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8173*/ GIMT_Encode4(401872),
     /* 401654 */ /*GILLT_s64*//*Label 8167*/ GIMT_Encode4(401686), GIMT_Encode4(0),
     /* 401662 */ /*GILLT_v2s32*//*Label 8168*/ GIMT_Encode4(401717),
     /* 401666 */ /*GILLT_v2s64*//*Label 8169*/ GIMT_Encode4(401748),
     /* 401670 */ /*GILLT_v4s16*//*Label 8170*/ GIMT_Encode4(401779),
     /* 401674 */ /*GILLT_v4s32*//*Label 8171*/ GIMT_Encode4(401810), GIMT_Encode4(0),
     /* 401682 */ /*GILLT_v8s16*//*Label 8172*/ GIMT_Encode4(401841),
     /* 401686 */ // Label 8167: @401686
     /* 401686 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(401716), // Rule ID 5232 //
     /* 401691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401705 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 401710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401714 */   GIR_RootConstrainSelectedInstOperands,
     /* 401715 */   // GIR_Coverage, 5232,
     /* 401715 */   GIR_Done,
     /* 401716 */ // Label 8174: @401716
     /* 401716 */ GIM_Reject,
     /* 401717 */ // Label 8168: @401717
     /* 401717 */ GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(401747), // Rule ID 783 //
     /* 401722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401736 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 401741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401745 */   GIR_RootConstrainSelectedInstOperands,
     /* 401746 */   // GIR_Coverage, 783,
     /* 401746 */   GIR_Done,
     /* 401747 */ // Label 8175: @401747
     /* 401747 */ GIM_Reject,
     /* 401748 */ // Label 8169: @401748
     /* 401748 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(401778), // Rule ID 785 //
     /* 401753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401767 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 401772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401776 */   GIR_RootConstrainSelectedInstOperands,
     /* 401777 */   // GIR_Coverage, 785,
     /* 401777 */   GIR_Done,
     /* 401778 */ // Label 8176: @401778
     /* 401778 */ GIM_Reject,
     /* 401779 */ // Label 8170: @401779
     /* 401779 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(401809), // Rule ID 781 //
     /* 401784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401798 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 401798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 401803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401807 */   GIR_RootConstrainSelectedInstOperands,
     /* 401808 */   // GIR_Coverage, 781,
     /* 401808 */   GIR_Done,
     /* 401809 */ // Label 8177: @401809
     /* 401809 */ GIM_Reject,
     /* 401810 */ // Label 8171: @401810
     /* 401810 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(401840), // Rule ID 784 //
     /* 401815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401829 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 401829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 401834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401838 */   GIR_RootConstrainSelectedInstOperands,
     /* 401839 */   // GIR_Coverage, 784,
     /* 401839 */   GIR_Done,
     /* 401840 */ // Label 8178: @401840
     /* 401840 */ GIM_Reject,
     /* 401841 */ // Label 8172: @401841
     /* 401841 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(401871), // Rule ID 782 //
     /* 401846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401860 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 401860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 401865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401869 */   GIR_RootConstrainSelectedInstOperands,
     /* 401870 */   // GIR_Coverage, 782,
     /* 401870 */   GIR_Done,
     /* 401871 */ // Label 8179: @401871
     /* 401871 */ GIM_Reject,
     /* 401872 */ // Label 8173: @401872
     /* 401872 */ GIM_Reject,
     /* 401873 */ // Label 134: @401873
     /* 401873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8186*/ GIMT_Encode4(402102),
     /* 401884 */ /*GILLT_s64*//*Label 8180*/ GIMT_Encode4(401916), GIMT_Encode4(0),
     /* 401892 */ /*GILLT_v2s32*//*Label 8181*/ GIMT_Encode4(401947),
     /* 401896 */ /*GILLT_v2s64*//*Label 8182*/ GIMT_Encode4(401978),
     /* 401900 */ /*GILLT_v4s16*//*Label 8183*/ GIMT_Encode4(402009),
     /* 401904 */ /*GILLT_v4s32*//*Label 8184*/ GIMT_Encode4(402040), GIMT_Encode4(0),
     /* 401912 */ /*GILLT_v8s16*//*Label 8185*/ GIMT_Encode4(402071),
     /* 401916 */ // Label 8180: @401916
     /* 401916 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(401946), // Rule ID 5233 //
     /* 401921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401935 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 401940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401944 */   GIR_RootConstrainSelectedInstOperands,
     /* 401945 */   // GIR_Coverage, 5233,
     /* 401945 */   GIR_Done,
     /* 401946 */ // Label 8187: @401946
     /* 401946 */ GIM_Reject,
     /* 401947 */ // Label 8181: @401947
     /* 401947 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(401977), // Rule ID 788 //
     /* 401952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401966 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 401971 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401975 */   GIR_RootConstrainSelectedInstOperands,
     /* 401976 */   // GIR_Coverage, 788,
     /* 401976 */   GIR_Done,
     /* 401977 */ // Label 8188: @401977
     /* 401977 */ GIM_Reject,
     /* 401978 */ // Label 8182: @401978
     /* 401978 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(402008), // Rule ID 790 //
     /* 401983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401997 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 402002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402006 */   GIR_RootConstrainSelectedInstOperands,
     /* 402007 */   // GIR_Coverage, 790,
     /* 402007 */   GIR_Done,
     /* 402008 */ // Label 8189: @402008
     /* 402008 */ GIM_Reject,
     /* 402009 */ // Label 8183: @402009
     /* 402009 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(402039), // Rule ID 786 //
     /* 402014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402028 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 402033 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402037 */   GIR_RootConstrainSelectedInstOperands,
     /* 402038 */   // GIR_Coverage, 786,
     /* 402038 */   GIR_Done,
     /* 402039 */ // Label 8190: @402039
     /* 402039 */ GIM_Reject,
     /* 402040 */ // Label 8184: @402040
     /* 402040 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(402070), // Rule ID 789 //
     /* 402045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402059 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 402064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402068 */   GIR_RootConstrainSelectedInstOperands,
     /* 402069 */   // GIR_Coverage, 789,
     /* 402069 */   GIR_Done,
     /* 402070 */ // Label 8191: @402070
     /* 402070 */ GIM_Reject,
     /* 402071 */ // Label 8185: @402071
     /* 402071 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(402101), // Rule ID 787 //
     /* 402076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402090 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 402095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402099 */   GIR_RootConstrainSelectedInstOperands,
     /* 402100 */   // GIR_Coverage, 787,
     /* 402100 */   GIR_Done,
     /* 402101 */ // Label 8192: @402101
     /* 402101 */ GIM_Reject,
     /* 402102 */ // Label 8186: @402102
     /* 402102 */ GIM_Reject,
     /* 402103 */ // Label 135: @402103
     /* 402103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8199*/ GIMT_Encode4(402332),
     /* 402114 */ /*GILLT_s64*//*Label 8193*/ GIMT_Encode4(402146), GIMT_Encode4(0),
     /* 402122 */ /*GILLT_v2s32*//*Label 8194*/ GIMT_Encode4(402177),
     /* 402126 */ /*GILLT_v2s64*//*Label 8195*/ GIMT_Encode4(402208),
     /* 402130 */ /*GILLT_v4s16*//*Label 8196*/ GIMT_Encode4(402239),
     /* 402134 */ /*GILLT_v4s32*//*Label 8197*/ GIMT_Encode4(402270), GIMT_Encode4(0),
     /* 402142 */ /*GILLT_v8s16*//*Label 8198*/ GIMT_Encode4(402301),
     /* 402146 */ // Label 8193: @402146
     /* 402146 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(402176), // Rule ID 5234 //
     /* 402151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402165 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 402170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402174 */   GIR_RootConstrainSelectedInstOperands,
     /* 402175 */   // GIR_Coverage, 5234,
     /* 402175 */   GIR_Done,
     /* 402176 */ // Label 8200: @402176
     /* 402176 */ GIM_Reject,
     /* 402177 */ // Label 8194: @402177
     /* 402177 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(402207), // Rule ID 793 //
     /* 402182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402196 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 402201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402205 */   GIR_RootConstrainSelectedInstOperands,
     /* 402206 */   // GIR_Coverage, 793,
     /* 402206 */   GIR_Done,
     /* 402207 */ // Label 8201: @402207
     /* 402207 */ GIM_Reject,
     /* 402208 */ // Label 8195: @402208
     /* 402208 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(402238), // Rule ID 795 //
     /* 402213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402227 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 402232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402236 */   GIR_RootConstrainSelectedInstOperands,
     /* 402237 */   // GIR_Coverage, 795,
     /* 402237 */   GIR_Done,
     /* 402238 */ // Label 8202: @402238
     /* 402238 */ GIM_Reject,
     /* 402239 */ // Label 8196: @402239
     /* 402239 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(402269), // Rule ID 791 //
     /* 402244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402258 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 402263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402267 */   GIR_RootConstrainSelectedInstOperands,
     /* 402268 */   // GIR_Coverage, 791,
     /* 402268 */   GIR_Done,
     /* 402269 */ // Label 8203: @402269
     /* 402269 */ GIM_Reject,
     /* 402270 */ // Label 8197: @402270
     /* 402270 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(402300), // Rule ID 794 //
     /* 402275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402289 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 402294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402298 */   GIR_RootConstrainSelectedInstOperands,
     /* 402299 */   // GIR_Coverage, 794,
     /* 402299 */   GIR_Done,
     /* 402300 */ // Label 8204: @402300
     /* 402300 */ GIM_Reject,
     /* 402301 */ // Label 8198: @402301
     /* 402301 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(402331), // Rule ID 792 //
     /* 402306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402320 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 402325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402329 */   GIR_RootConstrainSelectedInstOperands,
     /* 402330 */   // GIR_Coverage, 792,
     /* 402330 */   GIR_Done,
     /* 402331 */ // Label 8205: @402331
     /* 402331 */ GIM_Reject,
     /* 402332 */ // Label 8199: @402332
     /* 402332 */ GIM_Reject,
     /* 402333 */ // Label 136: @402333
     /* 402333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8210*/ GIMT_Encode4(402486),
     /* 402344 */ /*GILLT_s32*//*Label 8206*/ GIMT_Encode4(402384),
     /* 402348 */ /*GILLT_s64*//*Label 8207*/ GIMT_Encode4(402408), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402372 */ /*GILLT_v8s8*//*Label 8208*/ GIMT_Encode4(402432), GIMT_Encode4(0),
     /* 402380 */ /*GILLT_v16s8*//*Label 8209*/ GIMT_Encode4(402459),
     /* 402384 */ // Label 8206: @402384
     /* 402384 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(402407), // Rule ID 4007 //
     /* 402389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402400 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 402400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 402405 */   GIR_RootConstrainSelectedInstOperands,
     /* 402406 */   // GIR_Coverage, 4007,
     /* 402406 */   GIR_Done,
     /* 402407 */ // Label 8211: @402407
     /* 402407 */ GIM_Reject,
     /* 402408 */ // Label 8207: @402408
     /* 402408 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(402431), // Rule ID 4008 //
     /* 402413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 402420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 402424 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 402424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 402429 */   GIR_RootConstrainSelectedInstOperands,
     /* 402430 */   // GIR_Coverage, 4008,
     /* 402430 */   GIR_Done,
     /* 402431 */ // Label 8212: @402431
     /* 402431 */ GIM_Reject,
     /* 402432 */ // Label 8208: @402432
     /* 402432 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(402458), // Rule ID 976 //
     /* 402437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402451 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 402451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 402456 */   GIR_RootConstrainSelectedInstOperands,
     /* 402457 */   // GIR_Coverage, 976,
     /* 402457 */   GIR_Done,
     /* 402458 */ // Label 8213: @402458
     /* 402458 */ GIM_Reject,
     /* 402459 */ // Label 8209: @402459
     /* 402459 */ GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(402485), // Rule ID 977 //
     /* 402464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402478 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 402478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 402483 */   GIR_RootConstrainSelectedInstOperands,
     /* 402484 */   // GIR_Coverage, 977,
     /* 402484 */   GIR_Done,
     /* 402485 */ // Label 8214: @402485
     /* 402485 */ GIM_Reject,
     /* 402486 */ // Label 8210: @402486
     /* 402486 */ GIM_Reject,
     /* 402487 */ // Label 137: @402487
     /* 402487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8219*/ GIMT_Encode4(402662),
     /* 402498 */ /*GILLT_v4s16*//*Label 8215*/ GIMT_Encode4(402518), GIMT_Encode4(0),
     /* 402506 */ /*GILLT_v8s8*//*Label 8216*/ GIMT_Encode4(402563),
     /* 402510 */ /*GILLT_v8s16*//*Label 8217*/ GIMT_Encode4(402590),
     /* 402514 */ /*GILLT_v16s8*//*Label 8218*/ GIMT_Encode4(402635),
     /* 402518 */ // Label 8215: @402518
     /* 402518 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(402562),
     /* 402523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402534 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(402549), // Rule ID 980 //
     /* 402539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402542 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 402542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 402547 */     GIR_RootConstrainSelectedInstOperands,
     /* 402548 */     // GIR_Coverage, 980,
     /* 402548 */     GIR_Done,
     /* 402549 */   // Label 8221: @402549
     /* 402549 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(402561), // Rule ID 4952 //
     /* 402554 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 402554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 402559 */     GIR_RootConstrainSelectedInstOperands,
     /* 402560 */     // GIR_Coverage, 4952,
     /* 402560 */     GIR_Done,
     /* 402561 */   // Label 8222: @402561
     /* 402561 */   GIM_Reject,
     /* 402562 */ // Label 8220: @402562
     /* 402562 */ GIM_Reject,
     /* 402563 */ // Label 8216: @402563
     /* 402563 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(402589), // Rule ID 978 //
     /* 402568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402582 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 402582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 402587 */   GIR_RootConstrainSelectedInstOperands,
     /* 402588 */   // GIR_Coverage, 978,
     /* 402588 */   GIR_Done,
     /* 402589 */ // Label 8223: @402589
     /* 402589 */ GIM_Reject,
     /* 402590 */ // Label 8217: @402590
     /* 402590 */ GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(402634),
     /* 402595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402606 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(402621), // Rule ID 981 //
     /* 402611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402614 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 402614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 402619 */     GIR_RootConstrainSelectedInstOperands,
     /* 402620 */     // GIR_Coverage, 981,
     /* 402620 */     GIR_Done,
     /* 402621 */   // Label 8225: @402621
     /* 402621 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(402633), // Rule ID 4954 //
     /* 402626 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 402626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 402631 */     GIR_RootConstrainSelectedInstOperands,
     /* 402632 */     // GIR_Coverage, 4954,
     /* 402632 */     GIR_Done,
     /* 402633 */   // Label 8226: @402633
     /* 402633 */   GIM_Reject,
     /* 402634 */ // Label 8224: @402634
     /* 402634 */ GIM_Reject,
     /* 402635 */ // Label 8218: @402635
     /* 402635 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(402661), // Rule ID 979 //
     /* 402640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402654 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 402654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 402659 */   GIR_RootConstrainSelectedInstOperands,
     /* 402660 */   // GIR_Coverage, 979,
     /* 402660 */   GIR_Done,
     /* 402661 */ // Label 8227: @402661
     /* 402661 */ GIM_Reject,
     /* 402662 */ // Label 8219: @402662
     /* 402662 */ GIM_Reject,
     /* 402663 */ // Label 138: @402663
     /* 402663 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8234*/ GIMT_Encode4(402936),
     /* 402674 */ /*GILLT_v2s32*//*Label 8228*/ GIMT_Encode4(402702), GIMT_Encode4(0),
     /* 402682 */ /*GILLT_v4s16*//*Label 8229*/ GIMT_Encode4(402747),
     /* 402686 */ /*GILLT_v4s32*//*Label 8230*/ GIMT_Encode4(402792),
     /* 402690 */ /*GILLT_v8s8*//*Label 8231*/ GIMT_Encode4(402837),
     /* 402694 */ /*GILLT_v8s16*//*Label 8232*/ GIMT_Encode4(402864),
     /* 402698 */ /*GILLT_v16s8*//*Label 8233*/ GIMT_Encode4(402909),
     /* 402702 */ // Label 8228: @402702
     /* 402702 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(402746),
     /* 402707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402718 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(402733), // Rule ID 986 //
     /* 402723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402726 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 402726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 402731 */     GIR_RootConstrainSelectedInstOperands,
     /* 402732 */     // GIR_Coverage, 986,
     /* 402732 */     GIR_Done,
     /* 402733 */   // Label 8236: @402733
     /* 402733 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(402745), // Rule ID 4956 //
     /* 402738 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 402738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 402743 */     GIR_RootConstrainSelectedInstOperands,
     /* 402744 */     // GIR_Coverage, 4956,
     /* 402744 */     GIR_Done,
     /* 402745 */   // Label 8237: @402745
     /* 402745 */   GIM_Reject,
     /* 402746 */ // Label 8235: @402746
     /* 402746 */ GIM_Reject,
     /* 402747 */ // Label 8229: @402747
     /* 402747 */ GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(402791),
     /* 402752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402763 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(402778), // Rule ID 984 //
     /* 402768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402771 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 402771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 402776 */     GIR_RootConstrainSelectedInstOperands,
     /* 402777 */     // GIR_Coverage, 984,
     /* 402777 */     GIR_Done,
     /* 402778 */   // Label 8239: @402778
     /* 402778 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(402790), // Rule ID 4953 //
     /* 402783 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 402783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 402788 */     GIR_RootConstrainSelectedInstOperands,
     /* 402789 */     // GIR_Coverage, 4953,
     /* 402789 */     GIR_Done,
     /* 402790 */   // Label 8240: @402790
     /* 402790 */   GIM_Reject,
     /* 402791 */ // Label 8238: @402791
     /* 402791 */ GIM_Reject,
     /* 402792 */ // Label 8230: @402792
     /* 402792 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(402836),
     /* 402797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402808 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(402823), // Rule ID 987 //
     /* 402813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402816 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 402816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 402821 */     GIR_RootConstrainSelectedInstOperands,
     /* 402822 */     // GIR_Coverage, 987,
     /* 402822 */     GIR_Done,
     /* 402823 */   // Label 8242: @402823
     /* 402823 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(402835), // Rule ID 4957 //
     /* 402828 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 402828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 402833 */     GIR_RootConstrainSelectedInstOperands,
     /* 402834 */     // GIR_Coverage, 4957,
     /* 402834 */     GIR_Done,
     /* 402835 */   // Label 8243: @402835
     /* 402835 */   GIM_Reject,
     /* 402836 */ // Label 8241: @402836
     /* 402836 */ GIM_Reject,
     /* 402837 */ // Label 8231: @402837
     /* 402837 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(402863), // Rule ID 982 //
     /* 402842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402856 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 402856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 402861 */   GIR_RootConstrainSelectedInstOperands,
     /* 402862 */   // GIR_Coverage, 982,
     /* 402862 */   GIR_Done,
     /* 402863 */ // Label 8244: @402863
     /* 402863 */ GIM_Reject,
     /* 402864 */ // Label 8232: @402864
     /* 402864 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(402908),
     /* 402869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402880 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(402895), // Rule ID 985 //
     /* 402885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402888 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 402888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 402893 */     GIR_RootConstrainSelectedInstOperands,
     /* 402894 */     // GIR_Coverage, 985,
     /* 402894 */     GIR_Done,
     /* 402895 */   // Label 8246: @402895
     /* 402895 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(402907), // Rule ID 4955 //
     /* 402900 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 402900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 402905 */     GIR_RootConstrainSelectedInstOperands,
     /* 402906 */     // GIR_Coverage, 4955,
     /* 402906 */     GIR_Done,
     /* 402907 */   // Label 8247: @402907
     /* 402907 */   GIM_Reject,
     /* 402908 */ // Label 8245: @402908
     /* 402908 */ GIM_Reject,
     /* 402909 */ // Label 8233: @402909
     /* 402909 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(402935), // Rule ID 983 //
     /* 402914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402928 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 402928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 402933 */   GIR_RootConstrainSelectedInstOperands,
     /* 402934 */   // GIR_Coverage, 983,
     /* 402934 */   GIR_Done,
     /* 402935 */ // Label 8248: @402935
     /* 402935 */ GIM_Reject,
     /* 402936 */ // Label 8234: @402936
     /* 402936 */ GIM_Reject,
     /* 402937 */ // Label 139: @402937
     /* 402937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8255*/ GIMT_Encode4(403142),
     /* 402948 */ /*GILLT_s64*//*Label 8249*/ GIMT_Encode4(402980), GIMT_Encode4(0),
     /* 402956 */ /*GILLT_v2s32*//*Label 8250*/ GIMT_Encode4(403007),
     /* 402960 */ /*GILLT_v2s64*//*Label 8251*/ GIMT_Encode4(403034),
     /* 402964 */ /*GILLT_v4s16*//*Label 8252*/ GIMT_Encode4(403061),
     /* 402968 */ /*GILLT_v4s32*//*Label 8253*/ GIMT_Encode4(403088), GIMT_Encode4(0),
     /* 402976 */ /*GILLT_v8s16*//*Label 8254*/ GIMT_Encode4(403115),
     /* 402980 */ // Label 8249: @402980
     /* 402980 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(403006), // Rule ID 1008 //
     /* 402985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402999 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 402999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 403004 */   GIR_RootConstrainSelectedInstOperands,
     /* 403005 */   // GIR_Coverage, 1008,
     /* 403005 */   GIR_Done,
     /* 403006 */ // Label 8256: @403006
     /* 403006 */ GIM_Reject,
     /* 403007 */ // Label 8250: @403007
     /* 403007 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(403033), // Rule ID 1004 //
     /* 403012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403026 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 403026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 403031 */   GIR_RootConstrainSelectedInstOperands,
     /* 403032 */   // GIR_Coverage, 1004,
     /* 403032 */   GIR_Done,
     /* 403033 */ // Label 8257: @403033
     /* 403033 */ GIM_Reject,
     /* 403034 */ // Label 8251: @403034
     /* 403034 */ GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(403060), // Rule ID 1010 //
     /* 403039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403053 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 403053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 403058 */   GIR_RootConstrainSelectedInstOperands,
     /* 403059 */   // GIR_Coverage, 1010,
     /* 403059 */   GIR_Done,
     /* 403060 */ // Label 8258: @403060
     /* 403060 */ GIM_Reject,
     /* 403061 */ // Label 8252: @403061
     /* 403061 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(403087), // Rule ID 1000 //
     /* 403066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403080 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 403080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 403085 */   GIR_RootConstrainSelectedInstOperands,
     /* 403086 */   // GIR_Coverage, 1000,
     /* 403086 */   GIR_Done,
     /* 403087 */ // Label 8259: @403087
     /* 403087 */ GIM_Reject,
     /* 403088 */ // Label 8253: @403088
     /* 403088 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(403114), // Rule ID 1006 //
     /* 403093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403107 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 403107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 403112 */   GIR_RootConstrainSelectedInstOperands,
     /* 403113 */   // GIR_Coverage, 1006,
     /* 403113 */   GIR_Done,
     /* 403114 */ // Label 8260: @403114
     /* 403114 */ GIM_Reject,
     /* 403115 */ // Label 8254: @403115
     /* 403115 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(403141), // Rule ID 1002 //
     /* 403120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403134 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 403134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 403139 */   GIR_RootConstrainSelectedInstOperands,
     /* 403140 */   // GIR_Coverage, 1002,
     /* 403140 */   GIR_Done,
     /* 403141 */ // Label 8261: @403141
     /* 403141 */ GIM_Reject,
     /* 403142 */ // Label 8255: @403142
     /* 403142 */ GIM_Reject,
     /* 403143 */ // Label 140: @403143
     /* 403143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8264*/ GIMT_Encode4(403541),
     /* 403154 */ /*GILLT_v2s64*//*Label 8262*/ GIMT_Encode4(403166), GIMT_Encode4(0),
     /* 403162 */ /*GILLT_v4s32*//*Label 8263*/ GIMT_Encode4(403304),
     /* 403166 */ // Label 8262: @403166
     /* 403166 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(403225), // Rule ID 5843 //
     /* 403171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403182 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 403182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 403185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 403189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403194 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403224 */   // GIR_Coverage, 5843,
     /* 403224 */   GIR_EraseRootFromParent_Done,
     /* 403225 */ // Label 8265: @403225
     /* 403225 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(403303), // Rule ID 5965 //
     /* 403230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403241 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 403241 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 403244 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 403248 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403253 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 403259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 403262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 403266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 403276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403302 */   // GIR_Coverage, 5965,
     /* 403302 */   GIR_EraseRootFromParent_Done,
     /* 403303 */ // Label 8266: @403303
     /* 403303 */ GIM_Reject,
     /* 403304 */ // Label 8263: @403304
     /* 403304 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(403363), // Rule ID 5839 //
     /* 403309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403320 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 403320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 403327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403332 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403362 */   // GIR_Coverage, 5839,
     /* 403362 */   GIR_EraseRootFromParent_Done,
     /* 403363 */ // Label 8267: @403363
     /* 403363 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(403422), // Rule ID 5840 //
     /* 403368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403379 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 403379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 403386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403421 */   // GIR_Coverage, 5840,
     /* 403421 */   GIR_EraseRootFromParent_Done,
     /* 403422 */ // Label 8268: @403422
     /* 403422 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(403481), // Rule ID 5841 //
     /* 403427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403438 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 403438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 403445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403480 */   // GIR_Coverage, 5841,
     /* 403480 */   GIR_EraseRootFromParent_Done,
     /* 403481 */ // Label 8269: @403481
     /* 403481 */ GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(403540), // Rule ID 5842 //
     /* 403486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403497 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 403497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 403504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403529 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403539 */   // GIR_Coverage, 5842,
     /* 403539 */   GIR_EraseRootFromParent_Done,
     /* 403540 */ // Label 8270: @403540
     /* 403540 */ GIM_Reject,
     /* 403541 */ // Label 8264: @403541
     /* 403541 */ GIM_Reject,
     /* 403542 */ // Label 141: @403542
     /* 403542 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8275*/ GIMT_Encode4(403911),
     /* 403553 */ /*GILLT_v2s32*//*Label 8271*/ GIMT_Encode4(403613), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403565 */ /*GILLT_v4s32*//*Label 8272*/ GIMT_Encode4(403733), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403597 */ /*GILLT_nxv2s64*//*Label 8273*/ GIMT_Encode4(403853), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403609 */ /*GILLT_nxv4s32*//*Label 8274*/ GIMT_Encode4(403882),
     /* 403613 */ // Label 8271: @403613
     /* 403613 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(403732),
     /* 403618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 403624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 403627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403639 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(403712), // Rule ID 26 //
     /* 403644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 403655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 403667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403688 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403692 */     // MIs[3] Operand 1
     /* 403692 */     // No operand predicates
     /* 403692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403694 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 403694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 403697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 403701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403710 */     GIR_RootConstrainSelectedInstOperands,
     /* 403711 */     // GIR_Coverage, 26,
     /* 403711 */     GIR_EraseRootFromParent_Done,
     /* 403712 */   // Label 8277: @403712
     /* 403712 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(403731), // Rule ID 22 //
     /* 403717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403724 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 403724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 403729 */     GIR_RootConstrainSelectedInstOperands,
     /* 403730 */     // GIR_Coverage, 22,
     /* 403730 */     GIR_Done,
     /* 403731 */   // Label 8278: @403731
     /* 403731 */   GIM_Reject,
     /* 403732 */ // Label 8276: @403732
     /* 403732 */ GIM_Reject,
     /* 403733 */ // Label 8272: @403733
     /* 403733 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(403852),
     /* 403738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 403744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 403747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403759 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(403832), // Rule ID 27 //
     /* 403764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 403775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 403787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403808 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403812 */     // MIs[3] Operand 1
     /* 403812 */     // No operand predicates
     /* 403812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403814 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 403814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 403817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 403821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403830 */     GIR_RootConstrainSelectedInstOperands,
     /* 403831 */     // GIR_Coverage, 27,
     /* 403831 */     GIR_EraseRootFromParent_Done,
     /* 403832 */   // Label 8280: @403832
     /* 403832 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(403851), // Rule ID 23 //
     /* 403837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403844 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 403844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 403849 */     GIR_RootConstrainSelectedInstOperands,
     /* 403850 */     // GIR_Coverage, 23,
     /* 403850 */     GIR_Done,
     /* 403851 */   // Label 8281: @403851
     /* 403851 */   GIM_Reject,
     /* 403852 */ // Label 8279: @403852
     /* 403852 */ GIM_Reject,
     /* 403853 */ // Label 8273: @403853
     /* 403853 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(403881), // Rule ID 2986 //
     /* 403858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 403861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 403864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 403867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 403870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 403874 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 403874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 403879 */   GIR_RootConstrainSelectedInstOperands,
     /* 403880 */   // GIR_Coverage, 2986,
     /* 403880 */   GIR_Done,
     /* 403881 */ // Label 8282: @403881
     /* 403881 */ GIM_Reject,
     /* 403882 */ // Label 8274: @403882
     /* 403882 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(403910), // Rule ID 2985 //
     /* 403887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 403890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 403893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 403896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 403899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 403903 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 403903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 403908 */   GIR_RootConstrainSelectedInstOperands,
     /* 403909 */   // GIR_Coverage, 2985,
     /* 403909 */   GIR_Done,
     /* 403910 */ // Label 8283: @403910
     /* 403910 */ GIM_Reject,
     /* 403911 */ // Label 8275: @403911
     /* 403911 */ GIM_Reject,
     /* 403912 */ // Label 142: @403912
     /* 403912 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8287*/ GIMT_Encode4(404028),
     /* 403923 */ /*GILLT_s16*//*Label 8284*/ GIMT_Encode4(403935),
     /* 403927 */ /*GILLT_s32*//*Label 8285*/ GIMT_Encode4(403966),
     /* 403931 */ /*GILLT_s64*//*Label 8286*/ GIMT_Encode4(403997),
     /* 403935 */ // Label 8284: @403935
     /* 403935 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(403965), // Rule ID 1658 //
     /* 403940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 403943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 403946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403954 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 403954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 403959 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403963 */   GIR_RootConstrainSelectedInstOperands,
     /* 403964 */   // GIR_Coverage, 1658,
     /* 403964 */   GIR_Done,
     /* 403965 */ // Label 8288: @403965
     /* 403965 */ GIM_Reject,
     /* 403966 */ // Label 8285: @403966
     /* 403966 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(403996), // Rule ID 1657 //
     /* 403971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 403974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403985 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 403985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 403990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403994 */   GIR_RootConstrainSelectedInstOperands,
     /* 403995 */   // GIR_Coverage, 1657,
     /* 403995 */   GIR_Done,
     /* 403996 */ // Label 8289: @403996
     /* 403996 */ GIM_Reject,
     /* 403997 */ // Label 8286: @403997
     /* 403997 */ GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(404027), // Rule ID 1656 //
     /* 404002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404016 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 404016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 404021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404025 */   GIR_RootConstrainSelectedInstOperands,
     /* 404026 */   // GIR_Coverage, 1656,
     /* 404026 */   GIR_Done,
     /* 404027 */ // Label 8290: @404027
     /* 404027 */ GIM_Reject,
     /* 404028 */ // Label 8287: @404028
     /* 404028 */ GIM_Reject,
     /* 404029 */ // Label 143: @404029
     /* 404029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8294*/ GIMT_Encode4(405261),
     /* 404040 */ /*GILLT_v2s64*//*Label 8291*/ GIMT_Encode4(404060), GIMT_Encode4(0),
     /* 404048 */ /*GILLT_v4s32*//*Label 8292*/ GIMT_Encode4(404621), GIMT_Encode4(0),
     /* 404056 */ /*GILLT_v8s16*//*Label 8293*/ GIMT_Encode4(405182),
     /* 404060 */ // Label 8291: @404060
     /* 404060 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(404620),
     /* 404065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404075 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(404167), // Rule ID 2054 //
     /* 404080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404124 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404128 */     // MIs[3] Operand 1
     /* 404128 */     // No operand predicates
     /* 404128 */     // MIs[1] Operand 2
     /* 404128 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404148 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 404151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404165 */     GIR_RootConstrainSelectedInstOperands,
     /* 404166 */     // GIR_Coverage, 2054,
     /* 404166 */     GIR_EraseRootFromParent_Done,
     /* 404167 */   // Label 8296: @404167
     /* 404167 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(404259), // Rule ID 13429 //
     /* 404172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404216 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404220 */     // MIs[3] Operand 1
     /* 404220 */     // No operand predicates
     /* 404220 */     // MIs[1] Operand 2
     /* 404220 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404240 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 404243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404257 */     GIR_RootConstrainSelectedInstOperands,
     /* 404258 */     // GIR_Coverage, 13429,
     /* 404258 */     GIR_EraseRootFromParent_Done,
     /* 404259 */   // Label 8297: @404259
     /* 404259 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(404345), // Rule ID 13427 //
     /* 404264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404312 */     // MIs[3] Operand 1
     /* 404312 */     // No operand predicates
     /* 404312 */     // MIs[1] Operand 2
     /* 404312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404329 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404343 */     GIR_RootConstrainSelectedInstOperands,
     /* 404344 */     // GIR_Coverage, 13427,
     /* 404344 */     GIR_EraseRootFromParent_Done,
     /* 404345 */   // Label 8298: @404345
     /* 404345 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(404431), // Rule ID 2052 //
     /* 404350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404402 */     // MIs[3] Operand 1
     /* 404402 */     // No operand predicates
     /* 404402 */     // MIs[1] Operand 2
     /* 404402 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404415 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404429 */     GIR_RootConstrainSelectedInstOperands,
     /* 404430 */     // GIR_Coverage, 2052,
     /* 404430 */     GIR_EraseRootFromParent_Done,
     /* 404431 */   // Label 8299: @404431
     /* 404431 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(404470), // Rule ID 1741 //
     /* 404436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404453 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 404453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 404456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 404468 */     GIR_RootConstrainSelectedInstOperands,
     /* 404469 */     // GIR_Coverage, 1741,
     /* 404469 */     GIR_EraseRootFromParent_Done,
     /* 404470 */   // Label 8300: @404470
     /* 404470 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(404533), // Rule ID 13428 //
     /* 404475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404511 */     // MIs[2] Operand 1
     /* 404511 */     // No operand predicates
     /* 404511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404517 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404531 */     GIR_RootConstrainSelectedInstOperands,
     /* 404532 */     // GIR_Coverage, 13428,
     /* 404532 */     GIR_EraseRootFromParent_Done,
     /* 404533 */   // Label 8301: @404533
     /* 404533 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(404596), // Rule ID 2053 //
     /* 404538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404578 */     // MIs[2] Operand 1
     /* 404578 */     // No operand predicates
     /* 404578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404580 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404594 */     GIR_RootConstrainSelectedInstOperands,
     /* 404595 */     // GIR_Coverage, 2053,
     /* 404595 */     GIR_EraseRootFromParent_Done,
     /* 404596 */   // Label 8302: @404596
     /* 404596 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(404619), // Rule ID 1740 //
     /* 404601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404612 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 404612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 404617 */     GIR_RootConstrainSelectedInstOperands,
     /* 404618 */     // GIR_Coverage, 1740,
     /* 404618 */     GIR_Done,
     /* 404619 */   // Label 8303: @404619
     /* 404619 */   GIM_Reject,
     /* 404620 */ // Label 8295: @404620
     /* 404620 */ GIM_Reject,
     /* 404621 */ // Label 8292: @404621
     /* 404621 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(405181),
     /* 404626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404636 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(404728), // Rule ID 2051 //
     /* 404641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404689 */     // MIs[3] Operand 1
     /* 404689 */     // No operand predicates
     /* 404689 */     // MIs[1] Operand 2
     /* 404689 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 404700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 404709 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 404712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404726 */     GIR_RootConstrainSelectedInstOperands,
     /* 404727 */     // GIR_Coverage, 2051,
     /* 404727 */     GIR_EraseRootFromParent_Done,
     /* 404728 */   // Label 8305: @404728
     /* 404728 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(404820), // Rule ID 13426 //
     /* 404733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404777 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404781 */     // MIs[3] Operand 1
     /* 404781 */     // No operand predicates
     /* 404781 */     // MIs[1] Operand 2
     /* 404781 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 404792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 404801 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 404804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404818 */     GIR_RootConstrainSelectedInstOperands,
     /* 404819 */     // GIR_Coverage, 13426,
     /* 404819 */     GIR_EraseRootFromParent_Done,
     /* 404820 */   // Label 8306: @404820
     /* 404820 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(404906), // Rule ID 13424 //
     /* 404825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404869 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404873 */     // MIs[3] Operand 1
     /* 404873 */     // No operand predicates
     /* 404873 */     // MIs[1] Operand 2
     /* 404873 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404890 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 404893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404904 */     GIR_RootConstrainSelectedInstOperands,
     /* 404905 */     // GIR_Coverage, 13424,
     /* 404905 */     GIR_EraseRootFromParent_Done,
     /* 404906 */   // Label 8307: @404906
     /* 404906 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(404992), // Rule ID 2049 //
     /* 404911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404963 */     // MIs[3] Operand 1
     /* 404963 */     // No operand predicates
     /* 404963 */     // MIs[1] Operand 2
     /* 404963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404976 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 404979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404990 */     GIR_RootConstrainSelectedInstOperands,
     /* 404991 */     // GIR_Coverage, 2049,
     /* 404991 */     GIR_EraseRootFromParent_Done,
     /* 404992 */   // Label 8308: @404992
     /* 404992 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(405031), // Rule ID 1739 //
     /* 404997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405014 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 405017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405029 */     GIR_RootConstrainSelectedInstOperands,
     /* 405030 */     // GIR_Coverage, 1739,
     /* 405030 */     GIR_EraseRootFromParent_Done,
     /* 405031 */   // Label 8309: @405031
     /* 405031 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(405094), // Rule ID 13425 //
     /* 405036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405072 */     // MIs[2] Operand 1
     /* 405072 */     // No operand predicates
     /* 405072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405078 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405092 */     GIR_RootConstrainSelectedInstOperands,
     /* 405093 */     // GIR_Coverage, 13425,
     /* 405093 */     GIR_EraseRootFromParent_Done,
     /* 405094 */   // Label 8310: @405094
     /* 405094 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(405157), // Rule ID 2050 //
     /* 405099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405139 */     // MIs[2] Operand 1
     /* 405139 */     // No operand predicates
     /* 405139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405141 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405155 */     GIR_RootConstrainSelectedInstOperands,
     /* 405156 */     // GIR_Coverage, 2050,
     /* 405156 */     GIR_EraseRootFromParent_Done,
     /* 405157 */   // Label 8311: @405157
     /* 405157 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(405180), // Rule ID 1738 //
     /* 405162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405173 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 405178 */     GIR_RootConstrainSelectedInstOperands,
     /* 405179 */     // GIR_Coverage, 1738,
     /* 405179 */     GIR_Done,
     /* 405180 */   // Label 8312: @405180
     /* 405180 */   GIM_Reject,
     /* 405181 */ // Label 8304: @405181
     /* 405181 */ GIM_Reject,
     /* 405182 */ // Label 8293: @405182
     /* 405182 */ GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(405260),
     /* 405187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405197 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(405236), // Rule ID 1737 //
     /* 405202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405219 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 405222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405234 */     GIR_RootConstrainSelectedInstOperands,
     /* 405235 */     // GIR_Coverage, 1737,
     /* 405235 */     GIR_EraseRootFromParent_Done,
     /* 405236 */   // Label 8314: @405236
     /* 405236 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(405259), // Rule ID 1736 //
     /* 405241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405252 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 405257 */     GIR_RootConstrainSelectedInstOperands,
     /* 405258 */     // GIR_Coverage, 1736,
     /* 405258 */     GIR_Done,
     /* 405259 */   // Label 8315: @405259
     /* 405259 */   GIM_Reject,
     /* 405260 */ // Label 8313: @405260
     /* 405260 */ GIM_Reject,
     /* 405261 */ // Label 8294: @405261
     /* 405261 */ GIM_Reject,
     /* 405262 */ // Label 144: @405262
     /* 405262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8334*/ GIMT_Encode4(406041),
     /* 405273 */ /*GILLT_v2s32*//*Label 8316*/ GIMT_Encode4(405349),
     /* 405277 */ /*GILLT_v2s64*//*Label 8317*/ GIMT_Encode4(405404),
     /* 405281 */ /*GILLT_v4s16*//*Label 8318*/ GIMT_Encode4(405459),
     /* 405285 */ /*GILLT_v4s32*//*Label 8319*/ GIMT_Encode4(405514),
     /* 405289 */ /*GILLT_v8s8*//*Label 8320*/ GIMT_Encode4(405569),
     /* 405293 */ /*GILLT_v8s16*//*Label 8321*/ GIMT_Encode4(405603),
     /* 405297 */ /*GILLT_v16s8*//*Label 8322*/ GIMT_Encode4(405658), GIMT_Encode4(0),
     /* 405305 */ /*GILLT_nxv2s1*//*Label 8323*/ GIMT_Encode4(405692),
     /* 405309 */ /*GILLT_nxv2s16*//*Label 8324*/ GIMT_Encode4(405718),
     /* 405313 */ /*GILLT_nxv2s32*//*Label 8325*/ GIMT_Encode4(405744),
     /* 405317 */ /*GILLT_nxv2s64*//*Label 8326*/ GIMT_Encode4(405770),
     /* 405321 */ /*GILLT_nxv4s1*//*Label 8327*/ GIMT_Encode4(405817),
     /* 405325 */ /*GILLT_nxv4s16*//*Label 8328*/ GIMT_Encode4(405843),
     /* 405329 */ /*GILLT_nxv4s32*//*Label 8329*/ GIMT_Encode4(405869),
     /* 405333 */ /*GILLT_nxv8s1*//*Label 8330*/ GIMT_Encode4(405916),
     /* 405337 */ /*GILLT_nxv8s16*//*Label 8331*/ GIMT_Encode4(405942),
     /* 405341 */ /*GILLT_nxv16s1*//*Label 8332*/ GIMT_Encode4(405989),
     /* 405345 */ /*GILLT_nxv16s8*//*Label 8333*/ GIMT_Encode4(406015),
     /* 405349 */ // Label 8316: @405349
     /* 405349 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(405403),
     /* 405354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405372 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(405387), // Rule ID 1874 //
     /* 405377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405380 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 405380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 405385 */     GIR_RootConstrainSelectedInstOperands,
     /* 405386 */     // GIR_Coverage, 1874,
     /* 405386 */     GIR_Done,
     /* 405387 */   // Label 8336: @405387
     /* 405387 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(405402), // Rule ID 2505 //
     /* 405392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405395 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 405400 */     GIR_RootConstrainSelectedInstOperands,
     /* 405401 */     // GIR_Coverage, 2505,
     /* 405401 */     GIR_Done,
     /* 405402 */   // Label 8337: @405402
     /* 405402 */   GIM_Reject,
     /* 405403 */ // Label 8335: @405403
     /* 405403 */ GIM_Reject,
     /* 405404 */ // Label 8317: @405404
     /* 405404 */ GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(405458),
     /* 405409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405427 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(405442), // Rule ID 1876 //
     /* 405432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405435 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 405435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 405440 */     GIR_RootConstrainSelectedInstOperands,
     /* 405441 */     // GIR_Coverage, 1876,
     /* 405441 */     GIR_Done,
     /* 405442 */   // Label 8339: @405442
     /* 405442 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(405457), // Rule ID 2507 //
     /* 405447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405450 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 405455 */     GIR_RootConstrainSelectedInstOperands,
     /* 405456 */     // GIR_Coverage, 2507,
     /* 405456 */     GIR_Done,
     /* 405457 */   // Label 8340: @405457
     /* 405457 */   GIM_Reject,
     /* 405458 */ // Label 8338: @405458
     /* 405458 */ GIM_Reject,
     /* 405459 */ // Label 8318: @405459
     /* 405459 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(405513),
     /* 405464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405482 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(405497), // Rule ID 1872 //
     /* 405487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405490 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 405495 */     GIR_RootConstrainSelectedInstOperands,
     /* 405496 */     // GIR_Coverage, 1872,
     /* 405496 */     GIR_Done,
     /* 405497 */   // Label 8342: @405497
     /* 405497 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(405512), // Rule ID 2503 //
     /* 405502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405505 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 405510 */     GIR_RootConstrainSelectedInstOperands,
     /* 405511 */     // GIR_Coverage, 2503,
     /* 405511 */     GIR_Done,
     /* 405512 */   // Label 8343: @405512
     /* 405512 */   GIM_Reject,
     /* 405513 */ // Label 8341: @405513
     /* 405513 */ GIM_Reject,
     /* 405514 */ // Label 8319: @405514
     /* 405514 */ GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(405568),
     /* 405519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405537 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(405552), // Rule ID 1875 //
     /* 405542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405545 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 405545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 405550 */     GIR_RootConstrainSelectedInstOperands,
     /* 405551 */     // GIR_Coverage, 1875,
     /* 405551 */     GIR_Done,
     /* 405552 */   // Label 8345: @405552
     /* 405552 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(405567), // Rule ID 2506 //
     /* 405557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405560 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 405565 */     GIR_RootConstrainSelectedInstOperands,
     /* 405566 */     // GIR_Coverage, 2506,
     /* 405566 */     GIR_Done,
     /* 405567 */   // Label 8346: @405567
     /* 405567 */   GIM_Reject,
     /* 405568 */ // Label 8344: @405568
     /* 405568 */ GIM_Reject,
     /* 405569 */ // Label 8320: @405569
     /* 405569 */ GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(405602), // Rule ID 1870 //
     /* 405574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405595 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 405600 */   GIR_RootConstrainSelectedInstOperands,
     /* 405601 */   // GIR_Coverage, 1870,
     /* 405601 */   GIR_Done,
     /* 405602 */ // Label 8347: @405602
     /* 405602 */ GIM_Reject,
     /* 405603 */ // Label 8321: @405603
     /* 405603 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(405657),
     /* 405608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405626 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(405641), // Rule ID 1873 //
     /* 405631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405634 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 405639 */     GIR_RootConstrainSelectedInstOperands,
     /* 405640 */     // GIR_Coverage, 1873,
     /* 405640 */     GIR_Done,
     /* 405641 */   // Label 8349: @405641
     /* 405641 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(405656), // Rule ID 2504 //
     /* 405646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405649 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 405654 */     GIR_RootConstrainSelectedInstOperands,
     /* 405655 */     // GIR_Coverage, 2504,
     /* 405655 */     GIR_Done,
     /* 405656 */   // Label 8350: @405656
     /* 405656 */   GIM_Reject,
     /* 405657 */ // Label 8348: @405657
     /* 405657 */ GIM_Reject,
     /* 405658 */ // Label 8322: @405658
     /* 405658 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(405691), // Rule ID 1871 //
     /* 405663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 405669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 405672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405684 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 405689 */   GIR_RootConstrainSelectedInstOperands,
     /* 405690 */   // GIR_Coverage, 1871,
     /* 405690 */   GIR_Done,
     /* 405691 */ // Label 8351: @405691
     /* 405691 */ GIM_Reject,
     /* 405692 */ // Label 8323: @405692
     /* 405692 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(405717), // Rule ID 8912 //
     /* 405697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 405703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 405706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405710 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 405710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 405715 */   GIR_RootConstrainSelectedInstOperands,
     /* 405716 */   // GIR_Coverage, 8912,
     /* 405716 */   GIR_Done,
     /* 405717 */ // Label 8352: @405717
     /* 405717 */ GIM_Reject,
     /* 405718 */ // Label 8324: @405718
     /* 405718 */ GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(405743), // Rule ID 8888 //
     /* 405723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 405729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 405732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405736 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 405736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 405741 */   GIR_RootConstrainSelectedInstOperands,
     /* 405742 */   // GIR_Coverage, 8888,
     /* 405742 */   GIR_Done,
     /* 405743 */ // Label 8353: @405743
     /* 405743 */ GIM_Reject,
     /* 405744 */ // Label 8325: @405744
     /* 405744 */ GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(405769), // Rule ID 8889 //
     /* 405749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 405755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 405758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405762 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 405762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 405767 */   GIR_RootConstrainSelectedInstOperands,
     /* 405768 */   // GIR_Coverage, 8889,
     /* 405768 */   GIR_Done,
     /* 405769 */ // Label 8354: @405769
     /* 405769 */ GIM_Reject,
     /* 405770 */ // Label 8326: @405770
     /* 405770 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(405816),
     /* 405775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 405778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 405781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405785 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(405800), // Rule ID 8884 //
     /* 405790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405793 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 405793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 405798 */     GIR_RootConstrainSelectedInstOperands,
     /* 405799 */     // GIR_Coverage, 8884,
     /* 405799 */     GIR_Done,
     /* 405800 */   // Label 8356: @405800
     /* 405800 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(405815), // Rule ID 8890 //
     /* 405805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405808 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 405808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 405813 */     GIR_RootConstrainSelectedInstOperands,
     /* 405814 */     // GIR_Coverage, 8890,
     /* 405814 */     GIR_Done,
     /* 405815 */   // Label 8357: @405815
     /* 405815 */   GIM_Reject,
     /* 405816 */ // Label 8355: @405816
     /* 405816 */ GIM_Reject,
     /* 405817 */ // Label 8327: @405817
     /* 405817 */ GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(405842), // Rule ID 8911 //
     /* 405822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 405828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 405831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405835 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 405835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 405840 */   GIR_RootConstrainSelectedInstOperands,
     /* 405841 */   // GIR_Coverage, 8911,
     /* 405841 */   GIR_Done,
     /* 405842 */ // Label 8358: @405842
     /* 405842 */ GIM_Reject,
     /* 405843 */ // Label 8328: @405843
     /* 405843 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(405868), // Rule ID 8886 //
     /* 405848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 405854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 405857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405861 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 405861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 405866 */   GIR_RootConstrainSelectedInstOperands,
     /* 405867 */   // GIR_Coverage, 8886,
     /* 405867 */   GIR_Done,
     /* 405868 */ // Label 8359: @405868
     /* 405868 */ GIM_Reject,
     /* 405869 */ // Label 8329: @405869
     /* 405869 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(405915),
     /* 405874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 405877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 405880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405884 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(405899), // Rule ID 8883 //
     /* 405889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405892 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 405892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 405897 */     GIR_RootConstrainSelectedInstOperands,
     /* 405898 */     // GIR_Coverage, 8883,
     /* 405898 */     GIR_Done,
     /* 405899 */   // Label 8361: @405899
     /* 405899 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(405914), // Rule ID 8887 //
     /* 405904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405907 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 405907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 405912 */     GIR_RootConstrainSelectedInstOperands,
     /* 405913 */     // GIR_Coverage, 8887,
     /* 405913 */     GIR_Done,
     /* 405914 */   // Label 8362: @405914
     /* 405914 */   GIM_Reject,
     /* 405915 */ // Label 8360: @405915
     /* 405915 */ GIM_Reject,
     /* 405916 */ // Label 8330: @405916
     /* 405916 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(405941), // Rule ID 8910 //
     /* 405921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 405927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 405930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405934 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 405934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 405939 */   GIR_RootConstrainSelectedInstOperands,
     /* 405940 */   // GIR_Coverage, 8910,
     /* 405940 */   GIR_Done,
     /* 405941 */ // Label 8363: @405941
     /* 405941 */ GIM_Reject,
     /* 405942 */ // Label 8331: @405942
     /* 405942 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(405988),
     /* 405947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 405950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 405953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405957 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(405972), // Rule ID 8882 //
     /* 405962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405965 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 405965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 405970 */     GIR_RootConstrainSelectedInstOperands,
     /* 405971 */     // GIR_Coverage, 8882,
     /* 405971 */     GIR_Done,
     /* 405972 */   // Label 8365: @405972
     /* 405972 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(405987), // Rule ID 8885 //
     /* 405977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405980 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 405980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 405985 */     GIR_RootConstrainSelectedInstOperands,
     /* 405986 */     // GIR_Coverage, 8885,
     /* 405986 */     GIR_Done,
     /* 405987 */   // Label 8366: @405987
     /* 405987 */   GIM_Reject,
     /* 405988 */ // Label 8364: @405988
     /* 405988 */ GIM_Reject,
     /* 405989 */ // Label 8332: @405989
     /* 405989 */ GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(406014), // Rule ID 2414 //
     /* 405994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406007 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 406012 */   GIR_RootConstrainSelectedInstOperands,
     /* 406013 */   // GIR_Coverage, 2414,
     /* 406013 */   GIR_Done,
     /* 406014 */ // Label 8367: @406014
     /* 406014 */ GIM_Reject,
     /* 406015 */ // Label 8333: @406015
     /* 406015 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(406040), // Rule ID 8881 //
     /* 406020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406033 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 406038 */   GIR_RootConstrainSelectedInstOperands,
     /* 406039 */   // GIR_Coverage, 8881,
     /* 406039 */   GIR_Done,
     /* 406040 */ // Label 8368: @406040
     /* 406040 */ GIM_Reject,
     /* 406041 */ // Label 8334: @406041
     /* 406041 */ GIM_Reject,
     /* 406042 */ // Label 145: @406042
     /* 406042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8387*/ GIMT_Encode4(406821),
     /* 406053 */ /*GILLT_v2s32*//*Label 8369*/ GIMT_Encode4(406129),
     /* 406057 */ /*GILLT_v2s64*//*Label 8370*/ GIMT_Encode4(406184),
     /* 406061 */ /*GILLT_v4s16*//*Label 8371*/ GIMT_Encode4(406239),
     /* 406065 */ /*GILLT_v4s32*//*Label 8372*/ GIMT_Encode4(406294),
     /* 406069 */ /*GILLT_v8s8*//*Label 8373*/ GIMT_Encode4(406349),
     /* 406073 */ /*GILLT_v8s16*//*Label 8374*/ GIMT_Encode4(406383),
     /* 406077 */ /*GILLT_v16s8*//*Label 8375*/ GIMT_Encode4(406438), GIMT_Encode4(0),
     /* 406085 */ /*GILLT_nxv2s1*//*Label 8376*/ GIMT_Encode4(406472),
     /* 406089 */ /*GILLT_nxv2s16*//*Label 8377*/ GIMT_Encode4(406498),
     /* 406093 */ /*GILLT_nxv2s32*//*Label 8378*/ GIMT_Encode4(406524),
     /* 406097 */ /*GILLT_nxv2s64*//*Label 8379*/ GIMT_Encode4(406550),
     /* 406101 */ /*GILLT_nxv4s1*//*Label 8380*/ GIMT_Encode4(406597),
     /* 406105 */ /*GILLT_nxv4s16*//*Label 8381*/ GIMT_Encode4(406623),
     /* 406109 */ /*GILLT_nxv4s32*//*Label 8382*/ GIMT_Encode4(406649),
     /* 406113 */ /*GILLT_nxv8s1*//*Label 8383*/ GIMT_Encode4(406696),
     /* 406117 */ /*GILLT_nxv8s16*//*Label 8384*/ GIMT_Encode4(406722),
     /* 406121 */ /*GILLT_nxv16s1*//*Label 8385*/ GIMT_Encode4(406769),
     /* 406125 */ /*GILLT_nxv16s8*//*Label 8386*/ GIMT_Encode4(406795),
     /* 406129 */ // Label 8369: @406129
     /* 406129 */ GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(406183),
     /* 406134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406152 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(406167), // Rule ID 1881 //
     /* 406157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406160 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 406160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 406165 */     GIR_RootConstrainSelectedInstOperands,
     /* 406166 */     // GIR_Coverage, 1881,
     /* 406166 */     GIR_Done,
     /* 406167 */   // Label 8389: @406167
     /* 406167 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(406182), // Rule ID 5456 //
     /* 406172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406175 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 406180 */     GIR_RootConstrainSelectedInstOperands,
     /* 406181 */     // GIR_Coverage, 5456,
     /* 406181 */     GIR_Done,
     /* 406182 */   // Label 8390: @406182
     /* 406182 */   GIM_Reject,
     /* 406183 */ // Label 8388: @406183
     /* 406183 */ GIM_Reject,
     /* 406184 */ // Label 8370: @406184
     /* 406184 */ GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(406238),
     /* 406189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406207 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(406222), // Rule ID 1883 //
     /* 406212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406215 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 406215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 406220 */     GIR_RootConstrainSelectedInstOperands,
     /* 406221 */     // GIR_Coverage, 1883,
     /* 406221 */     GIR_Done,
     /* 406222 */   // Label 8392: @406222
     /* 406222 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(406237), // Rule ID 5458 //
     /* 406227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406230 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 406235 */     GIR_RootConstrainSelectedInstOperands,
     /* 406236 */     // GIR_Coverage, 5458,
     /* 406236 */     GIR_Done,
     /* 406237 */   // Label 8393: @406237
     /* 406237 */   GIM_Reject,
     /* 406238 */ // Label 8391: @406238
     /* 406238 */ GIM_Reject,
     /* 406239 */ // Label 8371: @406239
     /* 406239 */ GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(406293),
     /* 406244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406262 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(406277), // Rule ID 1879 //
     /* 406267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406270 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 406275 */     GIR_RootConstrainSelectedInstOperands,
     /* 406276 */     // GIR_Coverage, 1879,
     /* 406276 */     GIR_Done,
     /* 406277 */   // Label 8395: @406277
     /* 406277 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(406292), // Rule ID 5454 //
     /* 406282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406285 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 406290 */     GIR_RootConstrainSelectedInstOperands,
     /* 406291 */     // GIR_Coverage, 5454,
     /* 406291 */     GIR_Done,
     /* 406292 */   // Label 8396: @406292
     /* 406292 */   GIM_Reject,
     /* 406293 */ // Label 8394: @406293
     /* 406293 */ GIM_Reject,
     /* 406294 */ // Label 8372: @406294
     /* 406294 */ GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(406348),
     /* 406299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 406305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406317 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(406332), // Rule ID 1882 //
     /* 406322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406325 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 406325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 406330 */     GIR_RootConstrainSelectedInstOperands,
     /* 406331 */     // GIR_Coverage, 1882,
     /* 406331 */     GIR_Done,
     /* 406332 */   // Label 8398: @406332
     /* 406332 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(406347), // Rule ID 5457 //
     /* 406337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406340 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 406345 */     GIR_RootConstrainSelectedInstOperands,
     /* 406346 */     // GIR_Coverage, 5457,
     /* 406346 */     GIR_Done,
     /* 406347 */   // Label 8399: @406347
     /* 406347 */   GIM_Reject,
     /* 406348 */ // Label 8397: @406348
     /* 406348 */ GIM_Reject,
     /* 406349 */ // Label 8373: @406349
     /* 406349 */ GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(406382), // Rule ID 1877 //
     /* 406354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406375 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 406380 */   GIR_RootConstrainSelectedInstOperands,
     /* 406381 */   // GIR_Coverage, 1877,
     /* 406381 */   GIR_Done,
     /* 406382 */ // Label 8400: @406382
     /* 406382 */ GIM_Reject,
     /* 406383 */ // Label 8374: @406383
     /* 406383 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(406437),
     /* 406388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406406 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(406421), // Rule ID 1880 //
     /* 406411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406414 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 406419 */     GIR_RootConstrainSelectedInstOperands,
     /* 406420 */     // GIR_Coverage, 1880,
     /* 406420 */     GIR_Done,
     /* 406421 */   // Label 8402: @406421
     /* 406421 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(406436), // Rule ID 5455 //
     /* 406426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406429 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 406434 */     GIR_RootConstrainSelectedInstOperands,
     /* 406435 */     // GIR_Coverage, 5455,
     /* 406435 */     GIR_Done,
     /* 406436 */   // Label 8403: @406436
     /* 406436 */   GIM_Reject,
     /* 406437 */ // Label 8401: @406437
     /* 406437 */ GIM_Reject,
     /* 406438 */ // Label 8375: @406438
     /* 406438 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(406471), // Rule ID 1878 //
     /* 406443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 406452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406464 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 406469 */   GIR_RootConstrainSelectedInstOperands,
     /* 406470 */   // GIR_Coverage, 1878,
     /* 406470 */   GIR_Done,
     /* 406471 */ // Label 8404: @406471
     /* 406471 */ GIM_Reject,
     /* 406472 */ // Label 8376: @406472
     /* 406472 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(406497), // Rule ID 8915 //
     /* 406477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406490 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 406495 */   GIR_RootConstrainSelectedInstOperands,
     /* 406496 */   // GIR_Coverage, 8915,
     /* 406496 */   GIR_Done,
     /* 406497 */ // Label 8405: @406497
     /* 406497 */ GIM_Reject,
     /* 406498 */ // Label 8377: @406498
     /* 406498 */ GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(406523), // Rule ID 8898 //
     /* 406503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406516 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406521 */   GIR_RootConstrainSelectedInstOperands,
     /* 406522 */   // GIR_Coverage, 8898,
     /* 406522 */   GIR_Done,
     /* 406523 */ // Label 8406: @406523
     /* 406523 */ GIM_Reject,
     /* 406524 */ // Label 8378: @406524
     /* 406524 */ GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(406549), // Rule ID 8899 //
     /* 406529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406542 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406547 */   GIR_RootConstrainSelectedInstOperands,
     /* 406548 */   // GIR_Coverage, 8899,
     /* 406548 */   GIR_Done,
     /* 406549 */ // Label 8407: @406549
     /* 406549 */ GIM_Reject,
     /* 406550 */ // Label 8379: @406550
     /* 406550 */ GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(406596),
     /* 406555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 406561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406565 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(406580), // Rule ID 8894 //
     /* 406570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406573 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 406573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406578 */     GIR_RootConstrainSelectedInstOperands,
     /* 406579 */     // GIR_Coverage, 8894,
     /* 406579 */     GIR_Done,
     /* 406580 */   // Label 8409: @406580
     /* 406580 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(406595), // Rule ID 8900 //
     /* 406585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406588 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 406588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406593 */     GIR_RootConstrainSelectedInstOperands,
     /* 406594 */     // GIR_Coverage, 8900,
     /* 406594 */     GIR_Done,
     /* 406595 */   // Label 8410: @406595
     /* 406595 */   GIM_Reject,
     /* 406596 */ // Label 8408: @406596
     /* 406596 */ GIM_Reject,
     /* 406597 */ // Label 8380: @406597
     /* 406597 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(406622), // Rule ID 8914 //
     /* 406602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 406608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 406611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406615 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 406615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 406620 */   GIR_RootConstrainSelectedInstOperands,
     /* 406621 */   // GIR_Coverage, 8914,
     /* 406621 */   GIR_Done,
     /* 406622 */ // Label 8411: @406622
     /* 406622 */ GIM_Reject,
     /* 406623 */ // Label 8381: @406623
     /* 406623 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(406648), // Rule ID 8896 //
     /* 406628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 406634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 406637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406641 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 406646 */   GIR_RootConstrainSelectedInstOperands,
     /* 406647 */   // GIR_Coverage, 8896,
     /* 406647 */   GIR_Done,
     /* 406648 */ // Label 8412: @406648
     /* 406648 */ GIM_Reject,
     /* 406649 */ // Label 8382: @406649
     /* 406649 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(406695),
     /* 406654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406664 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(406679), // Rule ID 8893 //
     /* 406669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406672 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 406677 */     GIR_RootConstrainSelectedInstOperands,
     /* 406678 */     // GIR_Coverage, 8893,
     /* 406678 */     GIR_Done,
     /* 406679 */   // Label 8414: @406679
     /* 406679 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(406694), // Rule ID 8897 //
     /* 406684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406687 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 406687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 406692 */     GIR_RootConstrainSelectedInstOperands,
     /* 406693 */     // GIR_Coverage, 8897,
     /* 406693 */     GIR_Done,
     /* 406694 */   // Label 8415: @406694
     /* 406694 */   GIM_Reject,
     /* 406695 */ // Label 8413: @406695
     /* 406695 */ GIM_Reject,
     /* 406696 */ // Label 8383: @406696
     /* 406696 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(406721), // Rule ID 8913 //
     /* 406701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 406707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 406710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406714 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 406714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 406719 */   GIR_RootConstrainSelectedInstOperands,
     /* 406720 */   // GIR_Coverage, 8913,
     /* 406720 */   GIR_Done,
     /* 406721 */ // Label 8416: @406721
     /* 406721 */ GIM_Reject,
     /* 406722 */ // Label 8384: @406722
     /* 406722 */ GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(406768),
     /* 406727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 406730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 406733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406737 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(406752), // Rule ID 8892 //
     /* 406742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406745 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 406745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 406750 */     GIR_RootConstrainSelectedInstOperands,
     /* 406751 */     // GIR_Coverage, 8892,
     /* 406751 */     GIR_Done,
     /* 406752 */   // Label 8418: @406752
     /* 406752 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(406767), // Rule ID 8895 //
     /* 406757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406760 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 406760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 406765 */     GIR_RootConstrainSelectedInstOperands,
     /* 406766 */     // GIR_Coverage, 8895,
     /* 406766 */     GIR_Done,
     /* 406767 */   // Label 8419: @406767
     /* 406767 */   GIM_Reject,
     /* 406768 */ // Label 8417: @406768
     /* 406768 */ GIM_Reject,
     /* 406769 */ // Label 8385: @406769
     /* 406769 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(406794), // Rule ID 2418 //
     /* 406774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406787 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 406792 */   GIR_RootConstrainSelectedInstOperands,
     /* 406793 */   // GIR_Coverage, 2418,
     /* 406793 */   GIR_Done,
     /* 406794 */ // Label 8420: @406794
     /* 406794 */ GIM_Reject,
     /* 406795 */ // Label 8386: @406795
     /* 406795 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(406820), // Rule ID 8891 //
     /* 406800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406813 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 406818 */   GIR_RootConstrainSelectedInstOperands,
     /* 406819 */   // GIR_Coverage, 8891,
     /* 406819 */   GIR_Done,
     /* 406820 */ // Label 8421: @406820
     /* 406820 */ GIM_Reject,
     /* 406821 */ // Label 8387: @406821
     /* 406821 */ GIM_Reject,
     /* 406822 */ // Label 146: @406822
     /* 406822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8428*/ GIMT_Encode4(407027),
     /* 406833 */ /*GILLT_s64*//*Label 8422*/ GIMT_Encode4(406865), GIMT_Encode4(0),
     /* 406841 */ /*GILLT_v2s32*//*Label 8423*/ GIMT_Encode4(406892),
     /* 406845 */ /*GILLT_v2s64*//*Label 8424*/ GIMT_Encode4(406919),
     /* 406849 */ /*GILLT_v4s16*//*Label 8425*/ GIMT_Encode4(406946),
     /* 406853 */ /*GILLT_v4s32*//*Label 8426*/ GIMT_Encode4(406973), GIMT_Encode4(0),
     /* 406861 */ /*GILLT_v8s16*//*Label 8427*/ GIMT_Encode4(407000),
     /* 406865 */ // Label 8422: @406865
     /* 406865 */ GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(406891), // Rule ID 1069 //
     /* 406870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406884 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 406884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 406889 */   GIR_RootConstrainSelectedInstOperands,
     /* 406890 */   // GIR_Coverage, 1069,
     /* 406890 */   GIR_Done,
     /* 406891 */ // Label 8429: @406891
     /* 406891 */ GIM_Reject,
     /* 406892 */ // Label 8423: @406892
     /* 406892 */ GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(406918), // Rule ID 1065 //
     /* 406897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406911 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 406911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 406916 */   GIR_RootConstrainSelectedInstOperands,
     /* 406917 */   // GIR_Coverage, 1065,
     /* 406917 */   GIR_Done,
     /* 406918 */ // Label 8430: @406918
     /* 406918 */ GIM_Reject,
     /* 406919 */ // Label 8424: @406919
     /* 406919 */ GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(406945), // Rule ID 1071 //
     /* 406924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406938 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 406938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 406943 */   GIR_RootConstrainSelectedInstOperands,
     /* 406944 */   // GIR_Coverage, 1071,
     /* 406944 */   GIR_Done,
     /* 406945 */ // Label 8431: @406945
     /* 406945 */ GIM_Reject,
     /* 406946 */ // Label 8425: @406946
     /* 406946 */ GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(406972), // Rule ID 1061 //
     /* 406951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406965 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 406965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 406970 */   GIR_RootConstrainSelectedInstOperands,
     /* 406971 */   // GIR_Coverage, 1061,
     /* 406971 */   GIR_Done,
     /* 406972 */ // Label 8432: @406972
     /* 406972 */ GIM_Reject,
     /* 406973 */ // Label 8426: @406973
     /* 406973 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(406999), // Rule ID 1067 //
     /* 406978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406992 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 406992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 406997 */   GIR_RootConstrainSelectedInstOperands,
     /* 406998 */   // GIR_Coverage, 1067,
     /* 406998 */   GIR_Done,
     /* 406999 */ // Label 8433: @406999
     /* 406999 */ GIM_Reject,
     /* 407000 */ // Label 8427: @407000
     /* 407000 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(407026), // Rule ID 1063 //
     /* 407005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407019 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 407019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 407024 */   GIR_RootConstrainSelectedInstOperands,
     /* 407025 */   // GIR_Coverage, 1063,
     /* 407025 */   GIR_Done,
     /* 407026 */ // Label 8434: @407026
     /* 407026 */ GIM_Reject,
     /* 407027 */ // Label 8428: @407027
     /* 407027 */ GIM_Reject,
     /* 407028 */ // Label 147: @407028
     /* 407028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8437*/ GIMT_Encode4(407894),
     /* 407039 */ /*GILLT_v2s64*//*Label 8435*/ GIMT_Encode4(407051), GIMT_Encode4(0),
     /* 407047 */ /*GILLT_v4s32*//*Label 8436*/ GIMT_Encode4(407345),
     /* 407051 */ // Label 8435: @407051
     /* 407051 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(407133), // Rule ID 5829 //
     /* 407056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407071 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407074 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407079 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407083 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407090 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 407090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407102 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407122 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407132 */   // GIR_Coverage, 5829,
     /* 407132 */   GIR_EraseRootFromParent_Done,
     /* 407133 */ // Label 8438: @407133
     /* 407133 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(407207), // Rule ID 5828 //
     /* 407138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407153 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407164 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 407164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407206 */   // GIR_Coverage, 5828,
     /* 407206 */   GIR_EraseRootFromParent_Done,
     /* 407207 */ // Label 8439: @407207
     /* 407207 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(407266), // Rule ID 5838 //
     /* 407212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407223 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 407223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 407230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407235 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 407255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407265 */   // GIR_Coverage, 5838,
     /* 407265 */   GIR_EraseRootFromParent_Done,
     /* 407266 */ // Label 8440: @407266
     /* 407266 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(407344), // Rule ID 5966 //
     /* 407271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407282 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 407282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 407289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407294 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 407300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 407303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 407307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 407317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 407328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407338 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407343 */   // GIR_Coverage, 5966,
     /* 407343 */   GIR_EraseRootFromParent_Done,
     /* 407344 */ // Label 8441: @407344
     /* 407344 */ GIM_Reject,
     /* 407345 */ // Label 8436: @407345
     /* 407345 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(407427), // Rule ID 5831 //
     /* 407350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407365 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407368 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 407377 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407384 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 407384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 407391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407396 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407426 */   // GIR_Coverage, 5831,
     /* 407426 */   GIR_EraseRootFromParent_Done,
     /* 407427 */ // Label 8442: @407427
     /* 407427 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(407509), // Rule ID 5833 //
     /* 407432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407447 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407450 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407455 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407466 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 407466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407478 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407508 */   // GIR_Coverage, 5833,
     /* 407508 */   GIR_EraseRootFromParent_Done,
     /* 407509 */ // Label 8443: @407509
     /* 407509 */ GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(407583), // Rule ID 5830 //
     /* 407514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407529 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407533 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407540 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 407540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 407547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407552 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407572 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407582 */   // GIR_Coverage, 5830,
     /* 407582 */   GIR_EraseRootFromParent_Done,
     /* 407583 */ // Label 8444: @407583
     /* 407583 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(407657), // Rule ID 5832 //
     /* 407588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407603 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407614 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 407614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407656 */   // GIR_Coverage, 5832,
     /* 407656 */   GIR_EraseRootFromParent_Done,
     /* 407657 */ // Label 8445: @407657
     /* 407657 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(407716), // Rule ID 5834 //
     /* 407662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407673 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 407673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407715 */   // GIR_Coverage, 5834,
     /* 407715 */   GIR_EraseRootFromParent_Done,
     /* 407716 */ // Label 8446: @407716
     /* 407716 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(407775), // Rule ID 5835 //
     /* 407721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407732 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 407732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 407739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407744 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407774 */   // GIR_Coverage, 5835,
     /* 407774 */   GIR_EraseRootFromParent_Done,
     /* 407775 */ // Label 8447: @407775
     /* 407775 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(407834), // Rule ID 5836 //
     /* 407780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407791 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 407791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 407798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407833 */   // GIR_Coverage, 5836,
     /* 407833 */   GIR_EraseRootFromParent_Done,
     /* 407834 */ // Label 8448: @407834
     /* 407834 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(407893), // Rule ID 5837 //
     /* 407839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407850 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 407850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407892 */   // GIR_Coverage, 5837,
     /* 407892 */   GIR_EraseRootFromParent_Done,
     /* 407893 */ // Label 8449: @407893
     /* 407893 */ GIM_Reject,
     /* 407894 */ // Label 8437: @407894
     /* 407894 */ GIM_Reject,
     /* 407895 */ // Label 148: @407895
     /* 407895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8454*/ GIMT_Encode4(408264),
     /* 407906 */ /*GILLT_v2s32*//*Label 8450*/ GIMT_Encode4(407966), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407918 */ /*GILLT_v4s32*//*Label 8451*/ GIMT_Encode4(408086), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407950 */ /*GILLT_nxv2s64*//*Label 8452*/ GIMT_Encode4(408206), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407962 */ /*GILLT_nxv4s32*//*Label 8453*/ GIMT_Encode4(408235),
     /* 407966 */ // Label 8450: @407966
     /* 407966 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(408085),
     /* 407971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 407980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407992 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(408065), // Rule ID 28 //
     /* 407997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408041 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408045 */     // MIs[3] Operand 1
     /* 408045 */     // No operand predicates
     /* 408045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408047 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 408050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408063 */     GIR_RootConstrainSelectedInstOperands,
     /* 408064 */     // GIR_Coverage, 28,
     /* 408064 */     GIR_EraseRootFromParent_Done,
     /* 408065 */   // Label 8456: @408065
     /* 408065 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(408084), // Rule ID 24 //
     /* 408070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408077 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 408082 */     GIR_RootConstrainSelectedInstOperands,
     /* 408083 */     // GIR_Coverage, 24,
     /* 408083 */     GIR_Done,
     /* 408084 */   // Label 8457: @408084
     /* 408084 */   GIM_Reject,
     /* 408085 */ // Label 8455: @408085
     /* 408085 */ GIM_Reject,
     /* 408086 */ // Label 8451: @408086
     /* 408086 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(408205),
     /* 408091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 408100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408112 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(408185), // Rule ID 29 //
     /* 408117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408161 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408165 */     // MIs[3] Operand 1
     /* 408165 */     // No operand predicates
     /* 408165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408167 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 408170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408183 */     GIR_RootConstrainSelectedInstOperands,
     /* 408184 */     // GIR_Coverage, 29,
     /* 408184 */     GIR_EraseRootFromParent_Done,
     /* 408185 */   // Label 8459: @408185
     /* 408185 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(408204), // Rule ID 25 //
     /* 408190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408197 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 408202 */     GIR_RootConstrainSelectedInstOperands,
     /* 408203 */     // GIR_Coverage, 25,
     /* 408203 */     GIR_Done,
     /* 408204 */   // Label 8460: @408204
     /* 408204 */   GIM_Reject,
     /* 408205 */ // Label 8458: @408205
     /* 408205 */ GIM_Reject,
     /* 408206 */ // Label 8452: @408206
     /* 408206 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(408234), // Rule ID 7602 //
     /* 408211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 408217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 408220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 408223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408227 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 408227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 408232 */   GIR_RootConstrainSelectedInstOperands,
     /* 408233 */   // GIR_Coverage, 7602,
     /* 408233 */   GIR_Done,
     /* 408234 */ // Label 8461: @408234
     /* 408234 */ GIM_Reject,
     /* 408235 */ // Label 8453: @408235
     /* 408235 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(408263), // Rule ID 7601 //
     /* 408240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 408246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 408252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408256 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 408256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 408261 */   GIR_RootConstrainSelectedInstOperands,
     /* 408262 */   // GIR_Coverage, 7601,
     /* 408262 */   GIR_Done,
     /* 408263 */ // Label 8462: @408263
     /* 408263 */ GIM_Reject,
     /* 408264 */ // Label 8454: @408264
     /* 408264 */ GIM_Reject,
     /* 408265 */ // Label 149: @408265
     /* 408265 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8466*/ GIMT_Encode4(408381),
     /* 408276 */ /*GILLT_s16*//*Label 8463*/ GIMT_Encode4(408288),
     /* 408280 */ /*GILLT_s32*//*Label 8464*/ GIMT_Encode4(408319),
     /* 408284 */ /*GILLT_s64*//*Label 8465*/ GIMT_Encode4(408350),
     /* 408288 */ // Label 8463: @408288
     /* 408288 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(408318), // Rule ID 1669 //
     /* 408293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 408296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 408299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408307 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 408307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 408312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408316 */   GIR_RootConstrainSelectedInstOperands,
     /* 408317 */   // GIR_Coverage, 1669,
     /* 408317 */   GIR_Done,
     /* 408318 */ // Label 8467: @408318
     /* 408318 */ GIM_Reject,
     /* 408319 */ // Label 8464: @408319
     /* 408319 */ GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(408349), // Rule ID 1668 //
     /* 408324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 408327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 408330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408338 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 408338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 408343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408347 */   GIR_RootConstrainSelectedInstOperands,
     /* 408348 */   // GIR_Coverage, 1668,
     /* 408348 */   GIR_Done,
     /* 408349 */ // Label 8468: @408349
     /* 408349 */ GIM_Reject,
     /* 408350 */ // Label 8465: @408350
     /* 408350 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(408380), // Rule ID 1667 //
     /* 408355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 408358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 408361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408369 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 408369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 408374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408378 */   GIR_RootConstrainSelectedInstOperands,
     /* 408379 */   // GIR_Coverage, 1667,
     /* 408379 */   GIR_Done,
     /* 408380 */ // Label 8469: @408380
     /* 408380 */ GIM_Reject,
     /* 408381 */ // Label 8466: @408381
     /* 408381 */ GIM_Reject,
     /* 408382 */ // Label 150: @408382
     /* 408382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8473*/ GIMT_Encode4(409614),
     /* 408393 */ /*GILLT_v2s64*//*Label 8470*/ GIMT_Encode4(408413), GIMT_Encode4(0),
     /* 408401 */ /*GILLT_v4s32*//*Label 8471*/ GIMT_Encode4(408974), GIMT_Encode4(0),
     /* 408409 */ /*GILLT_v8s16*//*Label 8472*/ GIMT_Encode4(409535),
     /* 408413 */ // Label 8470: @408413
     /* 408413 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(408973),
     /* 408418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408428 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(408520), // Rule ID 2106 //
     /* 408433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408477 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408481 */     // MIs[3] Operand 1
     /* 408481 */     // No operand predicates
     /* 408481 */     // MIs[1] Operand 2
     /* 408481 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 408492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408501 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 408504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408518 */     GIR_RootConstrainSelectedInstOperands,
     /* 408519 */     // GIR_Coverage, 2106,
     /* 408519 */     GIR_EraseRootFromParent_Done,
     /* 408520 */   // Label 8475: @408520
     /* 408520 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(408612), // Rule ID 13459 //
     /* 408525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408573 */     // MIs[3] Operand 1
     /* 408573 */     // No operand predicates
     /* 408573 */     // MIs[1] Operand 2
     /* 408573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 408584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408593 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 408596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408610 */     GIR_RootConstrainSelectedInstOperands,
     /* 408611 */     // GIR_Coverage, 13459,
     /* 408611 */     GIR_EraseRootFromParent_Done,
     /* 408612 */   // Label 8476: @408612
     /* 408612 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(408698), // Rule ID 13457 //
     /* 408617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408661 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408665 */     // MIs[3] Operand 1
     /* 408665 */     // No operand predicates
     /* 408665 */     // MIs[1] Operand 2
     /* 408665 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 408676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408682 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 408685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408696 */     GIR_RootConstrainSelectedInstOperands,
     /* 408697 */     // GIR_Coverage, 13457,
     /* 408697 */     GIR_EraseRootFromParent_Done,
     /* 408698 */   // Label 8477: @408698
     /* 408698 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(408784), // Rule ID 2104 //
     /* 408703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408755 */     // MIs[3] Operand 1
     /* 408755 */     // No operand predicates
     /* 408755 */     // MIs[1] Operand 2
     /* 408755 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 408766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408768 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 408771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408782 */     GIR_RootConstrainSelectedInstOperands,
     /* 408783 */     // GIR_Coverage, 2104,
     /* 408783 */     GIR_EraseRootFromParent_Done,
     /* 408784 */   // Label 8478: @408784
     /* 408784 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(408823), // Rule ID 1831 //
     /* 408789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408806 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 408806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 408809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 408821 */     GIR_RootConstrainSelectedInstOperands,
     /* 408822 */     // GIR_Coverage, 1831,
     /* 408822 */     GIR_EraseRootFromParent_Done,
     /* 408823 */   // Label 8479: @408823
     /* 408823 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(408886), // Rule ID 13458 //
     /* 408828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408864 */     // MIs[2] Operand 1
     /* 408864 */     // No operand predicates
     /* 408864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408870 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 408873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408884 */     GIR_RootConstrainSelectedInstOperands,
     /* 408885 */     // GIR_Coverage, 13458,
     /* 408885 */     GIR_EraseRootFromParent_Done,
     /* 408886 */   // Label 8480: @408886
     /* 408886 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(408949), // Rule ID 2105 //
     /* 408891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408931 */     // MIs[2] Operand 1
     /* 408931 */     // No operand predicates
     /* 408931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408933 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 408936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408947 */     GIR_RootConstrainSelectedInstOperands,
     /* 408948 */     // GIR_Coverage, 2105,
     /* 408948 */     GIR_EraseRootFromParent_Done,
     /* 408949 */   // Label 8481: @408949
     /* 408949 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(408972), // Rule ID 1830 //
     /* 408954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408965 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 408965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 408970 */     GIR_RootConstrainSelectedInstOperands,
     /* 408971 */     // GIR_Coverage, 1830,
     /* 408971 */     GIR_Done,
     /* 408972 */   // Label 8482: @408972
     /* 408972 */   GIM_Reject,
     /* 408973 */ // Label 8474: @408973
     /* 408973 */ GIM_Reject,
     /* 408974 */ // Label 8471: @408974
     /* 408974 */ GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(409534),
     /* 408979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 408985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408989 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(409081), // Rule ID 2103 //
     /* 408994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409038 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409042 */     // MIs[3] Operand 1
     /* 409042 */     // No operand predicates
     /* 409042 */     // MIs[1] Operand 2
     /* 409042 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409062 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 409065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409079 */     GIR_RootConstrainSelectedInstOperands,
     /* 409080 */     // GIR_Coverage, 2103,
     /* 409080 */     GIR_EraseRootFromParent_Done,
     /* 409081 */   // Label 8484: @409081
     /* 409081 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(409173), // Rule ID 13456 //
     /* 409086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409130 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409134 */     // MIs[3] Operand 1
     /* 409134 */     // No operand predicates
     /* 409134 */     // MIs[1] Operand 2
     /* 409134 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409154 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 409157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409171 */     GIR_RootConstrainSelectedInstOperands,
     /* 409172 */     // GIR_Coverage, 13456,
     /* 409172 */     GIR_EraseRootFromParent_Done,
     /* 409173 */   // Label 8485: @409173
     /* 409173 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(409259), // Rule ID 13454 //
     /* 409178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409222 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409226 */     // MIs[3] Operand 1
     /* 409226 */     // No operand predicates
     /* 409226 */     // MIs[1] Operand 2
     /* 409226 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409243 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409257 */     GIR_RootConstrainSelectedInstOperands,
     /* 409258 */     // GIR_Coverage, 13454,
     /* 409258 */     GIR_EraseRootFromParent_Done,
     /* 409259 */   // Label 8486: @409259
     /* 409259 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(409345), // Rule ID 2101 //
     /* 409264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409312 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409316 */     // MIs[3] Operand 1
     /* 409316 */     // No operand predicates
     /* 409316 */     // MIs[1] Operand 2
     /* 409316 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409329 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409343 */     GIR_RootConstrainSelectedInstOperands,
     /* 409344 */     // GIR_Coverage, 2101,
     /* 409344 */     GIR_EraseRootFromParent_Done,
     /* 409345 */   // Label 8487: @409345
     /* 409345 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(409384), // Rule ID 1829 //
     /* 409350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409367 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 409370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409382 */     GIR_RootConstrainSelectedInstOperands,
     /* 409383 */     // GIR_Coverage, 1829,
     /* 409383 */     GIR_EraseRootFromParent_Done,
     /* 409384 */   // Label 8488: @409384
     /* 409384 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(409447), // Rule ID 13455 //
     /* 409389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409421 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409425 */     // MIs[2] Operand 1
     /* 409425 */     // No operand predicates
     /* 409425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409431 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409445 */     GIR_RootConstrainSelectedInstOperands,
     /* 409446 */     // GIR_Coverage, 13455,
     /* 409446 */     GIR_EraseRootFromParent_Done,
     /* 409447 */   // Label 8489: @409447
     /* 409447 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(409510), // Rule ID 2102 //
     /* 409452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409488 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409492 */     // MIs[2] Operand 1
     /* 409492 */     // No operand predicates
     /* 409492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409494 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409508 */     GIR_RootConstrainSelectedInstOperands,
     /* 409509 */     // GIR_Coverage, 2102,
     /* 409509 */     GIR_EraseRootFromParent_Done,
     /* 409510 */   // Label 8490: @409510
     /* 409510 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(409533), // Rule ID 1828 //
     /* 409515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409526 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 409531 */     GIR_RootConstrainSelectedInstOperands,
     /* 409532 */     // GIR_Coverage, 1828,
     /* 409532 */     GIR_Done,
     /* 409533 */   // Label 8491: @409533
     /* 409533 */   GIM_Reject,
     /* 409534 */ // Label 8483: @409534
     /* 409534 */ GIM_Reject,
     /* 409535 */ // Label 8472: @409535
     /* 409535 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(409613),
     /* 409540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409550 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(409589), // Rule ID 1827 //
     /* 409555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 409565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 409572 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 409575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409587 */     GIR_RootConstrainSelectedInstOperands,
     /* 409588 */     // GIR_Coverage, 1827,
     /* 409588 */     GIR_EraseRootFromParent_Done,
     /* 409589 */   // Label 8493: @409589
     /* 409589 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(409612), // Rule ID 1826 //
     /* 409594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409605 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 409610 */     GIR_RootConstrainSelectedInstOperands,
     /* 409611 */     // GIR_Coverage, 1826,
     /* 409611 */     GIR_Done,
     /* 409612 */   // Label 8494: @409612
     /* 409612 */   GIM_Reject,
     /* 409613 */ // Label 8492: @409613
     /* 409613 */ GIM_Reject,
     /* 409614 */ // Label 8473: @409614
     /* 409614 */ GIM_Reject,
     /* 409615 */ // Label 151: @409615
     /* 409615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8513*/ GIMT_Encode4(410394),
     /* 409626 */ /*GILLT_v2s32*//*Label 8495*/ GIMT_Encode4(409702),
     /* 409630 */ /*GILLT_v2s64*//*Label 8496*/ GIMT_Encode4(409757),
     /* 409634 */ /*GILLT_v4s16*//*Label 8497*/ GIMT_Encode4(409812),
     /* 409638 */ /*GILLT_v4s32*//*Label 8498*/ GIMT_Encode4(409867),
     /* 409642 */ /*GILLT_v8s8*//*Label 8499*/ GIMT_Encode4(409922),
     /* 409646 */ /*GILLT_v8s16*//*Label 8500*/ GIMT_Encode4(409956),
     /* 409650 */ /*GILLT_v16s8*//*Label 8501*/ GIMT_Encode4(410011), GIMT_Encode4(0),
     /* 409658 */ /*GILLT_nxv2s1*//*Label 8502*/ GIMT_Encode4(410045),
     /* 409662 */ /*GILLT_nxv2s16*//*Label 8503*/ GIMT_Encode4(410071),
     /* 409666 */ /*GILLT_nxv2s32*//*Label 8504*/ GIMT_Encode4(410097),
     /* 409670 */ /*GILLT_nxv2s64*//*Label 8505*/ GIMT_Encode4(410123),
     /* 409674 */ /*GILLT_nxv4s1*//*Label 8506*/ GIMT_Encode4(410170),
     /* 409678 */ /*GILLT_nxv4s16*//*Label 8507*/ GIMT_Encode4(410196),
     /* 409682 */ /*GILLT_nxv4s32*//*Label 8508*/ GIMT_Encode4(410222),
     /* 409686 */ /*GILLT_nxv8s1*//*Label 8509*/ GIMT_Encode4(410269),
     /* 409690 */ /*GILLT_nxv8s16*//*Label 8510*/ GIMT_Encode4(410295),
     /* 409694 */ /*GILLT_nxv16s1*//*Label 8511*/ GIMT_Encode4(410342),
     /* 409698 */ /*GILLT_nxv16s8*//*Label 8512*/ GIMT_Encode4(410368),
     /* 409702 */ // Label 8495: @409702
     /* 409702 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(409756),
     /* 409707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409725 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(409740), // Rule ID 1888 //
     /* 409730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409733 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 409738 */     GIR_RootConstrainSelectedInstOperands,
     /* 409739 */     // GIR_Coverage, 1888,
     /* 409739 */     GIR_Done,
     /* 409740 */   // Label 8515: @409740
     /* 409740 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(409755), // Rule ID 5461 //
     /* 409745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409748 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 409748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 409753 */     GIR_RootConstrainSelectedInstOperands,
     /* 409754 */     // GIR_Coverage, 5461,
     /* 409754 */     GIR_Done,
     /* 409755 */   // Label 8516: @409755
     /* 409755 */   GIM_Reject,
     /* 409756 */ // Label 8514: @409756
     /* 409756 */ GIM_Reject,
     /* 409757 */ // Label 8496: @409757
     /* 409757 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(409811),
     /* 409762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 409768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409780 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(409795), // Rule ID 1890 //
     /* 409785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409788 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 409788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 409793 */     GIR_RootConstrainSelectedInstOperands,
     /* 409794 */     // GIR_Coverage, 1890,
     /* 409794 */     GIR_Done,
     /* 409795 */   // Label 8518: @409795
     /* 409795 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(409810), // Rule ID 5463 //
     /* 409800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409803 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 409803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 409808 */     GIR_RootConstrainSelectedInstOperands,
     /* 409809 */     // GIR_Coverage, 5463,
     /* 409809 */     GIR_Done,
     /* 409810 */   // Label 8519: @409810
     /* 409810 */   GIM_Reject,
     /* 409811 */ // Label 8517: @409811
     /* 409811 */ GIM_Reject,
     /* 409812 */ // Label 8497: @409812
     /* 409812 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(409866),
     /* 409817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409835 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(409850), // Rule ID 1886 //
     /* 409840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409843 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 409848 */     GIR_RootConstrainSelectedInstOperands,
     /* 409849 */     // GIR_Coverage, 1886,
     /* 409849 */     GIR_Done,
     /* 409850 */   // Label 8521: @409850
     /* 409850 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(409865), // Rule ID 5459 //
     /* 409855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409858 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 409858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 409863 */     GIR_RootConstrainSelectedInstOperands,
     /* 409864 */     // GIR_Coverage, 5459,
     /* 409864 */     GIR_Done,
     /* 409865 */   // Label 8522: @409865
     /* 409865 */   GIM_Reject,
     /* 409866 */ // Label 8520: @409866
     /* 409866 */ GIM_Reject,
     /* 409867 */ // Label 8498: @409867
     /* 409867 */ GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(409921),
     /* 409872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 409878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409890 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(409905), // Rule ID 1889 //
     /* 409895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409898 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 409903 */     GIR_RootConstrainSelectedInstOperands,
     /* 409904 */     // GIR_Coverage, 1889,
     /* 409904 */     GIR_Done,
     /* 409905 */   // Label 8524: @409905
     /* 409905 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(409920), // Rule ID 5462 //
     /* 409910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409913 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 409913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 409918 */     GIR_RootConstrainSelectedInstOperands,
     /* 409919 */     // GIR_Coverage, 5462,
     /* 409919 */     GIR_Done,
     /* 409920 */   // Label 8525: @409920
     /* 409920 */   GIM_Reject,
     /* 409921 */ // Label 8523: @409921
     /* 409921 */ GIM_Reject,
     /* 409922 */ // Label 8499: @409922
     /* 409922 */ GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(409955), // Rule ID 1884 //
     /* 409927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409948 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 409953 */   GIR_RootConstrainSelectedInstOperands,
     /* 409954 */   // GIR_Coverage, 1884,
     /* 409954 */   GIR_Done,
     /* 409955 */ // Label 8526: @409955
     /* 409955 */ GIM_Reject,
     /* 409956 */ // Label 8500: @409956
     /* 409956 */ GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(410010),
     /* 409961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 409967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409979 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(409994), // Rule ID 1887 //
     /* 409984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409987 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 409992 */     GIR_RootConstrainSelectedInstOperands,
     /* 409993 */     // GIR_Coverage, 1887,
     /* 409993 */     GIR_Done,
     /* 409994 */   // Label 8528: @409994
     /* 409994 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(410009), // Rule ID 5460 //
     /* 409999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410002 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 410007 */     GIR_RootConstrainSelectedInstOperands,
     /* 410008 */     // GIR_Coverage, 5460,
     /* 410008 */     GIR_Done,
     /* 410009 */   // Label 8529: @410009
     /* 410009 */   GIM_Reject,
     /* 410010 */ // Label 8527: @410010
     /* 410010 */ GIM_Reject,
     /* 410011 */ // Label 8501: @410011
     /* 410011 */ GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(410044), // Rule ID 1885 //
     /* 410016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410037 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 410042 */   GIR_RootConstrainSelectedInstOperands,
     /* 410043 */   // GIR_Coverage, 1885,
     /* 410043 */   GIR_Done,
     /* 410044 */ // Label 8530: @410044
     /* 410044 */ GIM_Reject,
     /* 410045 */ // Label 8502: @410045
     /* 410045 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(410070), // Rule ID 8906 //
     /* 410050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410063 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 410068 */   GIR_RootConstrainSelectedInstOperands,
     /* 410069 */   // GIR_Coverage, 8906,
     /* 410069 */   GIR_Done,
     /* 410070 */ // Label 8531: @410070
     /* 410070 */ GIM_Reject,
     /* 410071 */ // Label 8503: @410071
     /* 410071 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(410096), // Rule ID 8868 //
     /* 410076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410089 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410094 */   GIR_RootConstrainSelectedInstOperands,
     /* 410095 */   // GIR_Coverage, 8868,
     /* 410095 */   GIR_Done,
     /* 410096 */ // Label 8532: @410096
     /* 410096 */ GIM_Reject,
     /* 410097 */ // Label 8504: @410097
     /* 410097 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(410122), // Rule ID 8869 //
     /* 410102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410115 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410120 */   GIR_RootConstrainSelectedInstOperands,
     /* 410121 */   // GIR_Coverage, 8869,
     /* 410121 */   GIR_Done,
     /* 410122 */ // Label 8533: @410122
     /* 410122 */ GIM_Reject,
     /* 410123 */ // Label 8505: @410123
     /* 410123 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(410169),
     /* 410128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410138 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(410153), // Rule ID 8864 //
     /* 410143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410146 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410151 */     GIR_RootConstrainSelectedInstOperands,
     /* 410152 */     // GIR_Coverage, 8864,
     /* 410152 */     GIR_Done,
     /* 410153 */   // Label 8535: @410153
     /* 410153 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(410168), // Rule ID 8870 //
     /* 410158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410161 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410166 */     GIR_RootConstrainSelectedInstOperands,
     /* 410167 */     // GIR_Coverage, 8870,
     /* 410167 */     GIR_Done,
     /* 410168 */   // Label 8536: @410168
     /* 410168 */   GIM_Reject,
     /* 410169 */ // Label 8534: @410169
     /* 410169 */ GIM_Reject,
     /* 410170 */ // Label 8506: @410170
     /* 410170 */ GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(410195), // Rule ID 8905 //
     /* 410175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410188 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 410193 */   GIR_RootConstrainSelectedInstOperands,
     /* 410194 */   // GIR_Coverage, 8905,
     /* 410194 */   GIR_Done,
     /* 410195 */ // Label 8537: @410195
     /* 410195 */ GIM_Reject,
     /* 410196 */ // Label 8507: @410196
     /* 410196 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(410221), // Rule ID 8866 //
     /* 410201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410214 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410219 */   GIR_RootConstrainSelectedInstOperands,
     /* 410220 */   // GIR_Coverage, 8866,
     /* 410220 */   GIR_Done,
     /* 410221 */ // Label 8538: @410221
     /* 410221 */ GIM_Reject,
     /* 410222 */ // Label 8508: @410222
     /* 410222 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(410268),
     /* 410227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 410230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 410233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410237 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(410252), // Rule ID 8863 //
     /* 410242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410245 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 410245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410250 */     GIR_RootConstrainSelectedInstOperands,
     /* 410251 */     // GIR_Coverage, 8863,
     /* 410251 */     GIR_Done,
     /* 410252 */   // Label 8540: @410252
     /* 410252 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(410267), // Rule ID 8867 //
     /* 410257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410260 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 410260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410265 */     GIR_RootConstrainSelectedInstOperands,
     /* 410266 */     // GIR_Coverage, 8867,
     /* 410266 */     GIR_Done,
     /* 410267 */   // Label 8541: @410267
     /* 410267 */   GIM_Reject,
     /* 410268 */ // Label 8539: @410268
     /* 410268 */ GIM_Reject,
     /* 410269 */ // Label 8509: @410269
     /* 410269 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(410294), // Rule ID 8904 //
     /* 410274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 410280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 410283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410287 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 410287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 410292 */   GIR_RootConstrainSelectedInstOperands,
     /* 410293 */   // GIR_Coverage, 8904,
     /* 410293 */   GIR_Done,
     /* 410294 */ // Label 8542: @410294
     /* 410294 */ GIM_Reject,
     /* 410295 */ // Label 8510: @410295
     /* 410295 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(410341),
     /* 410300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 410303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 410306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410310 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(410325), // Rule ID 8862 //
     /* 410315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410318 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 410318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 410323 */     GIR_RootConstrainSelectedInstOperands,
     /* 410324 */     // GIR_Coverage, 8862,
     /* 410324 */     GIR_Done,
     /* 410325 */   // Label 8544: @410325
     /* 410325 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(410340), // Rule ID 8865 //
     /* 410330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410333 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 410333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 410338 */     GIR_RootConstrainSelectedInstOperands,
     /* 410339 */     // GIR_Coverage, 8865,
     /* 410339 */     GIR_Done,
     /* 410340 */   // Label 8545: @410340
     /* 410340 */   GIM_Reject,
     /* 410341 */ // Label 8543: @410341
     /* 410341 */ GIM_Reject,
     /* 410342 */ // Label 8511: @410342
     /* 410342 */ GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(410367), // Rule ID 2406 //
     /* 410347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 410353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 410356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410360 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 410360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 410365 */   GIR_RootConstrainSelectedInstOperands,
     /* 410366 */   // GIR_Coverage, 2406,
     /* 410366 */   GIR_Done,
     /* 410367 */ // Label 8546: @410367
     /* 410367 */ GIM_Reject,
     /* 410368 */ // Label 8512: @410368
     /* 410368 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(410393), // Rule ID 8861 //
     /* 410373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 410379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 410382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410386 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 410386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 410391 */   GIR_RootConstrainSelectedInstOperands,
     /* 410392 */   // GIR_Coverage, 8861,
     /* 410392 */   GIR_Done,
     /* 410393 */ // Label 8547: @410393
     /* 410393 */ GIM_Reject,
     /* 410394 */ // Label 8513: @410394
     /* 410394 */ GIM_Reject,
     /* 410395 */ // Label 152: @410395
     /* 410395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8566*/ GIMT_Encode4(411174),
     /* 410406 */ /*GILLT_v2s32*//*Label 8548*/ GIMT_Encode4(410482),
     /* 410410 */ /*GILLT_v2s64*//*Label 8549*/ GIMT_Encode4(410537),
     /* 410414 */ /*GILLT_v4s16*//*Label 8550*/ GIMT_Encode4(410592),
     /* 410418 */ /*GILLT_v4s32*//*Label 8551*/ GIMT_Encode4(410647),
     /* 410422 */ /*GILLT_v8s8*//*Label 8552*/ GIMT_Encode4(410702),
     /* 410426 */ /*GILLT_v8s16*//*Label 8553*/ GIMT_Encode4(410736),
     /* 410430 */ /*GILLT_v16s8*//*Label 8554*/ GIMT_Encode4(410791), GIMT_Encode4(0),
     /* 410438 */ /*GILLT_nxv2s1*//*Label 8555*/ GIMT_Encode4(410825),
     /* 410442 */ /*GILLT_nxv2s16*//*Label 8556*/ GIMT_Encode4(410851),
     /* 410446 */ /*GILLT_nxv2s32*//*Label 8557*/ GIMT_Encode4(410877),
     /* 410450 */ /*GILLT_nxv2s64*//*Label 8558*/ GIMT_Encode4(410903),
     /* 410454 */ /*GILLT_nxv4s1*//*Label 8559*/ GIMT_Encode4(410950),
     /* 410458 */ /*GILLT_nxv4s16*//*Label 8560*/ GIMT_Encode4(410976),
     /* 410462 */ /*GILLT_nxv4s32*//*Label 8561*/ GIMT_Encode4(411002),
     /* 410466 */ /*GILLT_nxv8s1*//*Label 8562*/ GIMT_Encode4(411049),
     /* 410470 */ /*GILLT_nxv8s16*//*Label 8563*/ GIMT_Encode4(411075),
     /* 410474 */ /*GILLT_nxv16s1*//*Label 8564*/ GIMT_Encode4(411122),
     /* 410478 */ /*GILLT_nxv16s8*//*Label 8565*/ GIMT_Encode4(411148),
     /* 410482 */ // Label 8548: @410482
     /* 410482 */ GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(410536),
     /* 410487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410505 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(410520), // Rule ID 1895 //
     /* 410510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410513 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 410518 */     GIR_RootConstrainSelectedInstOperands,
     /* 410519 */     // GIR_Coverage, 1895,
     /* 410519 */     GIR_Done,
     /* 410520 */   // Label 8568: @410520
     /* 410520 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(410535), // Rule ID 5466 //
     /* 410525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410528 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 410533 */     GIR_RootConstrainSelectedInstOperands,
     /* 410534 */     // GIR_Coverage, 5466,
     /* 410534 */     GIR_Done,
     /* 410535 */   // Label 8569: @410535
     /* 410535 */   GIM_Reject,
     /* 410536 */ // Label 8567: @410536
     /* 410536 */ GIM_Reject,
     /* 410537 */ // Label 8549: @410537
     /* 410537 */ GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(410591),
     /* 410542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410560 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(410575), // Rule ID 1897 //
     /* 410565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410568 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 410573 */     GIR_RootConstrainSelectedInstOperands,
     /* 410574 */     // GIR_Coverage, 1897,
     /* 410574 */     GIR_Done,
     /* 410575 */   // Label 8571: @410575
     /* 410575 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(410590), // Rule ID 5468 //
     /* 410580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410583 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 410588 */     GIR_RootConstrainSelectedInstOperands,
     /* 410589 */     // GIR_Coverage, 5468,
     /* 410589 */     GIR_Done,
     /* 410590 */   // Label 8572: @410590
     /* 410590 */   GIM_Reject,
     /* 410591 */ // Label 8570: @410591
     /* 410591 */ GIM_Reject,
     /* 410592 */ // Label 8550: @410592
     /* 410592 */ GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(410646),
     /* 410597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410615 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(410630), // Rule ID 1893 //
     /* 410620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410623 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 410628 */     GIR_RootConstrainSelectedInstOperands,
     /* 410629 */     // GIR_Coverage, 1893,
     /* 410629 */     GIR_Done,
     /* 410630 */   // Label 8574: @410630
     /* 410630 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(410645), // Rule ID 5464 //
     /* 410635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410638 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 410643 */     GIR_RootConstrainSelectedInstOperands,
     /* 410644 */     // GIR_Coverage, 5464,
     /* 410644 */     GIR_Done,
     /* 410645 */   // Label 8575: @410645
     /* 410645 */   GIM_Reject,
     /* 410646 */ // Label 8573: @410646
     /* 410646 */ GIM_Reject,
     /* 410647 */ // Label 8551: @410647
     /* 410647 */ GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(410701),
     /* 410652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410670 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(410685), // Rule ID 1896 //
     /* 410675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410678 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 410683 */     GIR_RootConstrainSelectedInstOperands,
     /* 410684 */     // GIR_Coverage, 1896,
     /* 410684 */     GIR_Done,
     /* 410685 */   // Label 8577: @410685
     /* 410685 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(410700), // Rule ID 5467 //
     /* 410690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410693 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 410693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 410698 */     GIR_RootConstrainSelectedInstOperands,
     /* 410699 */     // GIR_Coverage, 5467,
     /* 410699 */     GIR_Done,
     /* 410700 */   // Label 8578: @410700
     /* 410700 */   GIM_Reject,
     /* 410701 */ // Label 8576: @410701
     /* 410701 */ GIM_Reject,
     /* 410702 */ // Label 8552: @410702
     /* 410702 */ GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(410735), // Rule ID 1891 //
     /* 410707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410728 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 410733 */   GIR_RootConstrainSelectedInstOperands,
     /* 410734 */   // GIR_Coverage, 1891,
     /* 410734 */   GIR_Done,
     /* 410735 */ // Label 8579: @410735
     /* 410735 */ GIM_Reject,
     /* 410736 */ // Label 8553: @410736
     /* 410736 */ GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(410790),
     /* 410741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410759 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(410774), // Rule ID 1894 //
     /* 410764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410767 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 410772 */     GIR_RootConstrainSelectedInstOperands,
     /* 410773 */     // GIR_Coverage, 1894,
     /* 410773 */     GIR_Done,
     /* 410774 */   // Label 8581: @410774
     /* 410774 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(410789), // Rule ID 5465 //
     /* 410779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410782 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 410787 */     GIR_RootConstrainSelectedInstOperands,
     /* 410788 */     // GIR_Coverage, 5465,
     /* 410788 */     GIR_Done,
     /* 410789 */   // Label 8582: @410789
     /* 410789 */   GIM_Reject,
     /* 410790 */ // Label 8580: @410790
     /* 410790 */ GIM_Reject,
     /* 410791 */ // Label 8554: @410791
     /* 410791 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(410824), // Rule ID 1892 //
     /* 410796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410817 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 410822 */   GIR_RootConstrainSelectedInstOperands,
     /* 410823 */   // GIR_Coverage, 1892,
     /* 410823 */   GIR_Done,
     /* 410824 */ // Label 8583: @410824
     /* 410824 */ GIM_Reject,
     /* 410825 */ // Label 8555: @410825
     /* 410825 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(410850), // Rule ID 8909 //
     /* 410830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410843 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 410848 */   GIR_RootConstrainSelectedInstOperands,
     /* 410849 */   // GIR_Coverage, 8909,
     /* 410849 */   GIR_Done,
     /* 410850 */ // Label 8584: @410850
     /* 410850 */ GIM_Reject,
     /* 410851 */ // Label 8556: @410851
     /* 410851 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(410876), // Rule ID 8878 //
     /* 410856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410869 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 410874 */   GIR_RootConstrainSelectedInstOperands,
     /* 410875 */   // GIR_Coverage, 8878,
     /* 410875 */   GIR_Done,
     /* 410876 */ // Label 8585: @410876
     /* 410876 */ GIM_Reject,
     /* 410877 */ // Label 8557: @410877
     /* 410877 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(410902), // Rule ID 8879 //
     /* 410882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410895 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 410900 */   GIR_RootConstrainSelectedInstOperands,
     /* 410901 */   // GIR_Coverage, 8879,
     /* 410901 */   GIR_Done,
     /* 410902 */ // Label 8586: @410902
     /* 410902 */ GIM_Reject,
     /* 410903 */ // Label 8558: @410903
     /* 410903 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(410949),
     /* 410908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410918 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(410933), // Rule ID 8874 //
     /* 410923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410926 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 410931 */     GIR_RootConstrainSelectedInstOperands,
     /* 410932 */     // GIR_Coverage, 8874,
     /* 410932 */     GIR_Done,
     /* 410933 */   // Label 8588: @410933
     /* 410933 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(410948), // Rule ID 8880 //
     /* 410938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410941 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 410946 */     GIR_RootConstrainSelectedInstOperands,
     /* 410947 */     // GIR_Coverage, 8880,
     /* 410947 */     GIR_Done,
     /* 410948 */   // Label 8589: @410948
     /* 410948 */   GIM_Reject,
     /* 410949 */ // Label 8587: @410949
     /* 410949 */ GIM_Reject,
     /* 410950 */ // Label 8559: @410950
     /* 410950 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(410975), // Rule ID 8908 //
     /* 410955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410968 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 410973 */   GIR_RootConstrainSelectedInstOperands,
     /* 410974 */   // GIR_Coverage, 8908,
     /* 410974 */   GIR_Done,
     /* 410975 */ // Label 8590: @410975
     /* 410975 */ GIM_Reject,
     /* 410976 */ // Label 8560: @410976
     /* 410976 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(411001), // Rule ID 8876 //
     /* 410981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410994 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 410999 */   GIR_RootConstrainSelectedInstOperands,
     /* 411000 */   // GIR_Coverage, 8876,
     /* 411000 */   GIR_Done,
     /* 411001 */ // Label 8591: @411001
     /* 411001 */ GIM_Reject,
     /* 411002 */ // Label 8561: @411002
     /* 411002 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(411048),
     /* 411007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411017 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(411032), // Rule ID 8873 //
     /* 411022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411025 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411030 */     GIR_RootConstrainSelectedInstOperands,
     /* 411031 */     // GIR_Coverage, 8873,
     /* 411031 */     GIR_Done,
     /* 411032 */   // Label 8593: @411032
     /* 411032 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(411047), // Rule ID 8877 //
     /* 411037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411040 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411045 */     GIR_RootConstrainSelectedInstOperands,
     /* 411046 */     // GIR_Coverage, 8877,
     /* 411046 */     GIR_Done,
     /* 411047 */   // Label 8594: @411047
     /* 411047 */   GIM_Reject,
     /* 411048 */ // Label 8592: @411048
     /* 411048 */ GIM_Reject,
     /* 411049 */ // Label 8562: @411049
     /* 411049 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(411074), // Rule ID 8907 //
     /* 411054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411067 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 411072 */   GIR_RootConstrainSelectedInstOperands,
     /* 411073 */   // GIR_Coverage, 8907,
     /* 411073 */   GIR_Done,
     /* 411074 */ // Label 8595: @411074
     /* 411074 */ GIM_Reject,
     /* 411075 */ // Label 8563: @411075
     /* 411075 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(411121),
     /* 411080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411090 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(411105), // Rule ID 8872 //
     /* 411095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411098 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411103 */     GIR_RootConstrainSelectedInstOperands,
     /* 411104 */     // GIR_Coverage, 8872,
     /* 411104 */     GIR_Done,
     /* 411105 */   // Label 8597: @411105
     /* 411105 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(411120), // Rule ID 8875 //
     /* 411110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411113 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411118 */     GIR_RootConstrainSelectedInstOperands,
     /* 411119 */     // GIR_Coverage, 8875,
     /* 411119 */     GIR_Done,
     /* 411120 */   // Label 8598: @411120
     /* 411120 */   GIM_Reject,
     /* 411121 */ // Label 8596: @411121
     /* 411121 */ GIM_Reject,
     /* 411122 */ // Label 8564: @411122
     /* 411122 */ GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(411147), // Rule ID 2410 //
     /* 411127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411140 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 411145 */   GIR_RootConstrainSelectedInstOperands,
     /* 411146 */   // GIR_Coverage, 2410,
     /* 411146 */   GIR_Done,
     /* 411147 */ // Label 8599: @411147
     /* 411147 */ GIM_Reject,
     /* 411148 */ // Label 8565: @411148
     /* 411148 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(411173), // Rule ID 8871 //
     /* 411153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411166 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 411171 */   GIR_RootConstrainSelectedInstOperands,
     /* 411172 */   // GIR_Coverage, 8871,
     /* 411172 */   GIR_Done,
     /* 411173 */ // Label 8600: @411173
     /* 411173 */ GIM_Reject,
     /* 411174 */ // Label 8566: @411174
     /* 411174 */ GIM_Reject,
     /* 411175 */ // Label 153: @411175
     /* 411175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8609*/ GIMT_Encode4(411872),
     /* 411186 */ /*GILLT_s64*//*Label 8601*/ GIMT_Encode4(411222), GIMT_Encode4(0),
     /* 411194 */ /*GILLT_v2s32*//*Label 8602*/ GIMT_Encode4(411333),
     /* 411198 */ /*GILLT_v2s64*//*Label 8603*/ GIMT_Encode4(411410),
     /* 411202 */ /*GILLT_v4s16*//*Label 8604*/ GIMT_Encode4(411487),
     /* 411206 */ /*GILLT_v4s32*//*Label 8605*/ GIMT_Encode4(411564),
     /* 411210 */ /*GILLT_v8s8*//*Label 8606*/ GIMT_Encode4(411641),
     /* 411214 */ /*GILLT_v8s16*//*Label 8607*/ GIMT_Encode4(411718),
     /* 411218 */ /*GILLT_v16s8*//*Label 8608*/ GIMT_Encode4(411795),
     /* 411222 */ // Label 8601: @411222
     /* 411222 */ GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(411332),
     /* 411227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 411230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411238 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(411263), // Rule ID 5238 //
     /* 411243 */     // MIs[0] Operand 2
     /* 411243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 411254 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 411254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 411257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411261 */     GIR_RootConstrainSelectedInstOperands,
     /* 411262 */     // GIR_Coverage, 5238,
     /* 411262 */     GIR_EraseRootFromParent_Done,
     /* 411263 */   // Label 8611: @411263
     /* 411263 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(411297), // Rule ID 2120 //
     /* 411268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411271 */     // MIs[0] imm
     /* 411271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411283 */     // MIs[1] Operand 1
     /* 411283 */     // No operand predicates
     /* 411283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411285 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 411288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411295 */     GIR_RootConstrainSelectedInstOperands,
     /* 411296 */     // GIR_Coverage, 2120,
     /* 411296 */     GIR_EraseRootFromParent_Done,
     /* 411297 */   // Label 8612: @411297
     /* 411297 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(411331), // Rule ID 6262 //
     /* 411302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411305 */     // MIs[0] imm
     /* 411305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411317 */     // MIs[1] Operand 1
     /* 411317 */     // No operand predicates
     /* 411317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411319 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 411319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 411322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411329 */     GIR_RootConstrainSelectedInstOperands,
     /* 411330 */     // GIR_Coverage, 6262,
     /* 411330 */     GIR_EraseRootFromParent_Done,
     /* 411331 */   // Label 8613: @411331
     /* 411331 */   GIM_Reject,
     /* 411332 */ // Label 8610: @411332
     /* 411332 */ GIM_Reject,
     /* 411333 */ // Label 8602: @411333
     /* 411333 */ GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(411409),
     /* 411338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411349 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(411374), // Rule ID 4882 //
     /* 411354 */     // MIs[0] Operand 2
     /* 411354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 411365 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 411365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 411368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411372 */     GIR_RootConstrainSelectedInstOperands,
     /* 411373 */     // GIR_Coverage, 4882,
     /* 411373 */     GIR_EraseRootFromParent_Done,
     /* 411374 */   // Label 8615: @411374
     /* 411374 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(411408), // Rule ID 2227 //
     /* 411379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411382 */     // MIs[0] imm
     /* 411382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 411394 */     // MIs[1] Operand 1
     /* 411394 */     // No operand predicates
     /* 411394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411396 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 411399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411406 */     GIR_RootConstrainSelectedInstOperands,
     /* 411407 */     // GIR_Coverage, 2227,
     /* 411407 */     GIR_EraseRootFromParent_Done,
     /* 411408 */   // Label 8616: @411408
     /* 411408 */   GIM_Reject,
     /* 411409 */ // Label 8614: @411409
     /* 411409 */ GIM_Reject,
     /* 411410 */ // Label 8603: @411410
     /* 411410 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(411486),
     /* 411415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411426 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(411451), // Rule ID 4886 //
     /* 411431 */     // MIs[0] Operand 2
     /* 411431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 411442 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 411442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 411445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411449 */     GIR_RootConstrainSelectedInstOperands,
     /* 411450 */     // GIR_Coverage, 4886,
     /* 411450 */     GIR_EraseRootFromParent_Done,
     /* 411451 */   // Label 8618: @411451
     /* 411451 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(411485), // Rule ID 2229 //
     /* 411456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411459 */     // MIs[0] imm
     /* 411459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411471 */     // MIs[1] Operand 1
     /* 411471 */     // No operand predicates
     /* 411471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411473 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 411476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411483 */     GIR_RootConstrainSelectedInstOperands,
     /* 411484 */     // GIR_Coverage, 2229,
     /* 411484 */     GIR_EraseRootFromParent_Done,
     /* 411485 */   // Label 8619: @411485
     /* 411485 */   GIM_Reject,
     /* 411486 */ // Label 8617: @411486
     /* 411486 */ GIM_Reject,
     /* 411487 */ // Label 8604: @411487
     /* 411487 */ GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(411563),
     /* 411492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411503 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(411528), // Rule ID 4881 //
     /* 411508 */     // MIs[0] Operand 2
     /* 411508 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 411519 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 411519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 411522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411526 */     GIR_RootConstrainSelectedInstOperands,
     /* 411527 */     // GIR_Coverage, 4881,
     /* 411527 */     GIR_EraseRootFromParent_Done,
     /* 411528 */   // Label 8621: @411528
     /* 411528 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(411562), // Rule ID 2225 //
     /* 411533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411536 */     // MIs[0] imm
     /* 411536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 411548 */     // MIs[1] Operand 1
     /* 411548 */     // No operand predicates
     /* 411548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411550 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 411553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411560 */     GIR_RootConstrainSelectedInstOperands,
     /* 411561 */     // GIR_Coverage, 2225,
     /* 411561 */     GIR_EraseRootFromParent_Done,
     /* 411562 */   // Label 8622: @411562
     /* 411562 */   GIM_Reject,
     /* 411563 */ // Label 8620: @411563
     /* 411563 */ GIM_Reject,
     /* 411564 */ // Label 8605: @411564
     /* 411564 */ GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(411640),
     /* 411569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411580 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(411605), // Rule ID 4885 //
     /* 411585 */     // MIs[0] Operand 2
     /* 411585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 411596 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 411596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 411599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411603 */     GIR_RootConstrainSelectedInstOperands,
     /* 411604 */     // GIR_Coverage, 4885,
     /* 411604 */     GIR_EraseRootFromParent_Done,
     /* 411605 */   // Label 8624: @411605
     /* 411605 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(411639), // Rule ID 2228 //
     /* 411610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411613 */     // MIs[0] imm
     /* 411613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 411625 */     // MIs[1] Operand 1
     /* 411625 */     // No operand predicates
     /* 411625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411627 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 411630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411637 */     GIR_RootConstrainSelectedInstOperands,
     /* 411638 */     // GIR_Coverage, 2228,
     /* 411638 */     GIR_EraseRootFromParent_Done,
     /* 411639 */   // Label 8625: @411639
     /* 411639 */   GIM_Reject,
     /* 411640 */ // Label 8623: @411640
     /* 411640 */ GIM_Reject,
     /* 411641 */ // Label 8606: @411641
     /* 411641 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(411717),
     /* 411646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411657 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(411682), // Rule ID 4880 //
     /* 411662 */     // MIs[0] Operand 2
     /* 411662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 411673 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 411673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 411676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411680 */     GIR_RootConstrainSelectedInstOperands,
     /* 411681 */     // GIR_Coverage, 4880,
     /* 411681 */     GIR_EraseRootFromParent_Done,
     /* 411682 */   // Label 8627: @411682
     /* 411682 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(411716), // Rule ID 2223 //
     /* 411687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411690 */     // MIs[0] imm
     /* 411690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 411702 */     // MIs[1] Operand 1
     /* 411702 */     // No operand predicates
     /* 411702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411704 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 411707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411714 */     GIR_RootConstrainSelectedInstOperands,
     /* 411715 */     // GIR_Coverage, 2223,
     /* 411715 */     GIR_EraseRootFromParent_Done,
     /* 411716 */   // Label 8628: @411716
     /* 411716 */   GIM_Reject,
     /* 411717 */ // Label 8626: @411717
     /* 411717 */ GIM_Reject,
     /* 411718 */ // Label 8607: @411718
     /* 411718 */ GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(411794),
     /* 411723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411734 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(411759), // Rule ID 4884 //
     /* 411739 */     // MIs[0] Operand 2
     /* 411739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 411750 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 411750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 411753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411757 */     GIR_RootConstrainSelectedInstOperands,
     /* 411758 */     // GIR_Coverage, 4884,
     /* 411758 */     GIR_EraseRootFromParent_Done,
     /* 411759 */   // Label 8630: @411759
     /* 411759 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(411793), // Rule ID 2226 //
     /* 411764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411767 */     // MIs[0] imm
     /* 411767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 411779 */     // MIs[1] Operand 1
     /* 411779 */     // No operand predicates
     /* 411779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411781 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 411784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411791 */     GIR_RootConstrainSelectedInstOperands,
     /* 411792 */     // GIR_Coverage, 2226,
     /* 411792 */     GIR_EraseRootFromParent_Done,
     /* 411793 */   // Label 8631: @411793
     /* 411793 */   GIM_Reject,
     /* 411794 */ // Label 8629: @411794
     /* 411794 */ GIM_Reject,
     /* 411795 */ // Label 8608: @411795
     /* 411795 */ GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(411871),
     /* 411800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411811 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(411836), // Rule ID 4883 //
     /* 411816 */     // MIs[0] Operand 2
     /* 411816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 411827 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 411827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 411830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411834 */     GIR_RootConstrainSelectedInstOperands,
     /* 411835 */     // GIR_Coverage, 4883,
     /* 411835 */     GIR_EraseRootFromParent_Done,
     /* 411836 */   // Label 8633: @411836
     /* 411836 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(411870), // Rule ID 2224 //
     /* 411841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411844 */     // MIs[0] imm
     /* 411844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 411856 */     // MIs[1] Operand 1
     /* 411856 */     // No operand predicates
     /* 411856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411858 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 411861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411868 */     GIR_RootConstrainSelectedInstOperands,
     /* 411869 */     // GIR_Coverage, 2224,
     /* 411869 */     GIR_EraseRootFromParent_Done,
     /* 411870 */   // Label 8634: @411870
     /* 411870 */   GIM_Reject,
     /* 411871 */ // Label 8632: @411871
     /* 411871 */ GIM_Reject,
     /* 411872 */ // Label 8609: @411872
     /* 411872 */ GIM_Reject,
     /* 411873 */ // Label 154: @411873
     /* 411873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8643*/ GIMT_Encode4(412328),
     /* 411884 */ /*GILLT_s64*//*Label 8635*/ GIMT_Encode4(411920), GIMT_Encode4(0),
     /* 411892 */ /*GILLT_v2s32*//*Label 8636*/ GIMT_Encode4(412006),
     /* 411896 */ /*GILLT_v2s64*//*Label 8637*/ GIMT_Encode4(412052),
     /* 411900 */ /*GILLT_v4s16*//*Label 8638*/ GIMT_Encode4(412098),
     /* 411904 */ /*GILLT_v4s32*//*Label 8639*/ GIMT_Encode4(412144),
     /* 411908 */ /*GILLT_v8s8*//*Label 8640*/ GIMT_Encode4(412190),
     /* 411912 */ /*GILLT_v8s16*//*Label 8641*/ GIMT_Encode4(412236),
     /* 411916 */ /*GILLT_v16s8*//*Label 8642*/ GIMT_Encode4(412282),
     /* 411920 */ // Label 8635: @411920
     /* 411920 */ GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(412005),
     /* 411925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 411928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411936 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(411970), // Rule ID 2129 //
     /* 411941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411944 */     // MIs[0] imm
     /* 411944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411956 */     // MIs[1] Operand 1
     /* 411956 */     // No operand predicates
     /* 411956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411958 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 411961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411968 */     GIR_RootConstrainSelectedInstOperands,
     /* 411969 */     // GIR_Coverage, 2129,
     /* 411969 */     GIR_EraseRootFromParent_Done,
     /* 411970 */   // Label 8645: @411970
     /* 411970 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(412004), // Rule ID 6265 //
     /* 411975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411978 */     // MIs[0] imm
     /* 411978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411990 */     // MIs[1] Operand 1
     /* 411990 */     // No operand predicates
     /* 411990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411992 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 411992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 411995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412002 */     GIR_RootConstrainSelectedInstOperands,
     /* 412003 */     // GIR_Coverage, 6265,
     /* 412003 */     GIR_EraseRootFromParent_Done,
     /* 412004 */   // Label 8646: @412004
     /* 412004 */   GIM_Reject,
     /* 412005 */ // Label 8644: @412005
     /* 412005 */ GIM_Reject,
     /* 412006 */ // Label 8636: @412006
     /* 412006 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(412051), // Rule ID 2286 //
     /* 412011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412025 */   // MIs[0] imm
     /* 412025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412033 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412037 */   // MIs[1] Operand 1
     /* 412037 */   // No operand predicates
     /* 412037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412039 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 412042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412046 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412049 */   GIR_RootConstrainSelectedInstOperands,
     /* 412050 */   // GIR_Coverage, 2286,
     /* 412050 */   GIR_EraseRootFromParent_Done,
     /* 412051 */ // Label 8647: @412051
     /* 412051 */ GIM_Reject,
     /* 412052 */ // Label 8637: @412052
     /* 412052 */ GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(412097), // Rule ID 2288 //
     /* 412057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412071 */   // MIs[0] imm
     /* 412071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412079 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412083 */   // MIs[1] Operand 1
     /* 412083 */   // No operand predicates
     /* 412083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412085 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 412088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412090 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412092 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412095 */   GIR_RootConstrainSelectedInstOperands,
     /* 412096 */   // GIR_Coverage, 2288,
     /* 412096 */   GIR_EraseRootFromParent_Done,
     /* 412097 */ // Label 8648: @412097
     /* 412097 */ GIM_Reject,
     /* 412098 */ // Label 8638: @412098
     /* 412098 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(412143), // Rule ID 2284 //
     /* 412103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412117 */   // MIs[0] imm
     /* 412117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412125 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412129 */   // MIs[1] Operand 1
     /* 412129 */   // No operand predicates
     /* 412129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412131 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 412134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412136 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412138 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412141 */   GIR_RootConstrainSelectedInstOperands,
     /* 412142 */   // GIR_Coverage, 2284,
     /* 412142 */   GIR_EraseRootFromParent_Done,
     /* 412143 */ // Label 8649: @412143
     /* 412143 */ GIM_Reject,
     /* 412144 */ // Label 8639: @412144
     /* 412144 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(412189), // Rule ID 2287 //
     /* 412149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412163 */   // MIs[0] imm
     /* 412163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412171 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412175 */   // MIs[1] Operand 1
     /* 412175 */   // No operand predicates
     /* 412175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412177 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 412180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412182 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412184 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412187 */   GIR_RootConstrainSelectedInstOperands,
     /* 412188 */   // GIR_Coverage, 2287,
     /* 412188 */   GIR_EraseRootFromParent_Done,
     /* 412189 */ // Label 8650: @412189
     /* 412189 */ GIM_Reject,
     /* 412190 */ // Label 8640: @412190
     /* 412190 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(412235), // Rule ID 2282 //
     /* 412195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412209 */   // MIs[0] imm
     /* 412209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412217 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412221 */   // MIs[1] Operand 1
     /* 412221 */   // No operand predicates
     /* 412221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412223 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 412226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412233 */   GIR_RootConstrainSelectedInstOperands,
     /* 412234 */   // GIR_Coverage, 2282,
     /* 412234 */   GIR_EraseRootFromParent_Done,
     /* 412235 */ // Label 8651: @412235
     /* 412235 */ GIM_Reject,
     /* 412236 */ // Label 8641: @412236
     /* 412236 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(412281), // Rule ID 2285 //
     /* 412241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412255 */   // MIs[0] imm
     /* 412255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412263 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412267 */   // MIs[1] Operand 1
     /* 412267 */   // No operand predicates
     /* 412267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412269 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 412272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412276 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412279 */   GIR_RootConstrainSelectedInstOperands,
     /* 412280 */   // GIR_Coverage, 2285,
     /* 412280 */   GIR_EraseRootFromParent_Done,
     /* 412281 */ // Label 8652: @412281
     /* 412281 */ GIM_Reject,
     /* 412282 */ // Label 8642: @412282
     /* 412282 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(412327), // Rule ID 2283 //
     /* 412287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412301 */   // MIs[0] imm
     /* 412301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412309 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412313 */   // MIs[1] Operand 1
     /* 412313 */   // No operand predicates
     /* 412313 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412315 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 412318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412320 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412322 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412325 */   GIR_RootConstrainSelectedInstOperands,
     /* 412326 */   // GIR_Coverage, 2283,
     /* 412326 */   GIR_EraseRootFromParent_Done,
     /* 412327 */ // Label 8653: @412327
     /* 412327 */ GIM_Reject,
     /* 412328 */ // Label 8643: @412328
     /* 412328 */ GIM_Reject,
     /* 412329 */ // Label 155: @412329
     /* 412329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8672*/ GIMT_Encode4(413108),
     /* 412340 */ /*GILLT_v2s32*//*Label 8654*/ GIMT_Encode4(412416),
     /* 412344 */ /*GILLT_v2s64*//*Label 8655*/ GIMT_Encode4(412471),
     /* 412348 */ /*GILLT_v4s16*//*Label 8656*/ GIMT_Encode4(412526),
     /* 412352 */ /*GILLT_v4s32*//*Label 8657*/ GIMT_Encode4(412581),
     /* 412356 */ /*GILLT_v8s8*//*Label 8658*/ GIMT_Encode4(412636),
     /* 412360 */ /*GILLT_v8s16*//*Label 8659*/ GIMT_Encode4(412670),
     /* 412364 */ /*GILLT_v16s8*//*Label 8660*/ GIMT_Encode4(412725), GIMT_Encode4(0),
     /* 412372 */ /*GILLT_nxv2s1*//*Label 8661*/ GIMT_Encode4(412759),
     /* 412376 */ /*GILLT_nxv2s16*//*Label 8662*/ GIMT_Encode4(412785),
     /* 412380 */ /*GILLT_nxv2s32*//*Label 8663*/ GIMT_Encode4(412811),
     /* 412384 */ /*GILLT_nxv2s64*//*Label 8664*/ GIMT_Encode4(412837),
     /* 412388 */ /*GILLT_nxv4s1*//*Label 8665*/ GIMT_Encode4(412884),
     /* 412392 */ /*GILLT_nxv4s16*//*Label 8666*/ GIMT_Encode4(412910),
     /* 412396 */ /*GILLT_nxv4s32*//*Label 8667*/ GIMT_Encode4(412936),
     /* 412400 */ /*GILLT_nxv8s1*//*Label 8668*/ GIMT_Encode4(412983),
     /* 412404 */ /*GILLT_nxv8s16*//*Label 8669*/ GIMT_Encode4(413009),
     /* 412408 */ /*GILLT_nxv16s1*//*Label 8670*/ GIMT_Encode4(413056),
     /* 412412 */ /*GILLT_nxv16s8*//*Label 8671*/ GIMT_Encode4(413082),
     /* 412416 */ // Label 8654: @412416
     /* 412416 */ GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(412470),
     /* 412421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 412427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412439 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(412454), // Rule ID 1902 //
     /* 412444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412447 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 412447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 412452 */     GIR_RootConstrainSelectedInstOperands,
     /* 412453 */     // GIR_Coverage, 1902,
     /* 412453 */     GIR_Done,
     /* 412454 */   // Label 8674: @412454
     /* 412454 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(412469), // Rule ID 5471 //
     /* 412459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412462 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 412462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 412467 */     GIR_RootConstrainSelectedInstOperands,
     /* 412468 */     // GIR_Coverage, 5471,
     /* 412468 */     GIR_Done,
     /* 412469 */   // Label 8675: @412469
     /* 412469 */   GIM_Reject,
     /* 412470 */ // Label 8673: @412470
     /* 412470 */ GIM_Reject,
     /* 412471 */ // Label 8655: @412471
     /* 412471 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(412525),
     /* 412476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 412482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412494 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(412509), // Rule ID 1904 //
     /* 412499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412502 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 412502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 412507 */     GIR_RootConstrainSelectedInstOperands,
     /* 412508 */     // GIR_Coverage, 1904,
     /* 412508 */     GIR_Done,
     /* 412509 */   // Label 8677: @412509
     /* 412509 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(412524), // Rule ID 5473 //
     /* 412514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412517 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 412522 */     GIR_RootConstrainSelectedInstOperands,
     /* 412523 */     // GIR_Coverage, 5473,
     /* 412523 */     GIR_Done,
     /* 412524 */   // Label 8678: @412524
     /* 412524 */   GIM_Reject,
     /* 412525 */ // Label 8676: @412525
     /* 412525 */ GIM_Reject,
     /* 412526 */ // Label 8656: @412526
     /* 412526 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(412580),
     /* 412531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 412537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412549 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(412564), // Rule ID 1900 //
     /* 412554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412557 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 412557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 412562 */     GIR_RootConstrainSelectedInstOperands,
     /* 412563 */     // GIR_Coverage, 1900,
     /* 412563 */     GIR_Done,
     /* 412564 */   // Label 8680: @412564
     /* 412564 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(412579), // Rule ID 5469 //
     /* 412569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412572 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 412577 */     GIR_RootConstrainSelectedInstOperands,
     /* 412578 */     // GIR_Coverage, 5469,
     /* 412578 */     GIR_Done,
     /* 412579 */   // Label 8681: @412579
     /* 412579 */   GIM_Reject,
     /* 412580 */ // Label 8679: @412580
     /* 412580 */ GIM_Reject,
     /* 412581 */ // Label 8657: @412581
     /* 412581 */ GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(412635),
     /* 412586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 412592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412604 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(412619), // Rule ID 1903 //
     /* 412609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412612 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 412612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 412617 */     GIR_RootConstrainSelectedInstOperands,
     /* 412618 */     // GIR_Coverage, 1903,
     /* 412618 */     GIR_Done,
     /* 412619 */   // Label 8683: @412619
     /* 412619 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(412634), // Rule ID 5472 //
     /* 412624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412627 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 412627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 412632 */     GIR_RootConstrainSelectedInstOperands,
     /* 412633 */     // GIR_Coverage, 5472,
     /* 412633 */     GIR_Done,
     /* 412634 */   // Label 8684: @412634
     /* 412634 */   GIM_Reject,
     /* 412635 */ // Label 8682: @412635
     /* 412635 */ GIM_Reject,
     /* 412636 */ // Label 8658: @412636
     /* 412636 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(412669), // Rule ID 1898 //
     /* 412641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 412650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412662 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 412662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 412667 */   GIR_RootConstrainSelectedInstOperands,
     /* 412668 */   // GIR_Coverage, 1898,
     /* 412668 */   GIR_Done,
     /* 412669 */ // Label 8685: @412669
     /* 412669 */ GIM_Reject,
     /* 412670 */ // Label 8659: @412670
     /* 412670 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(412724),
     /* 412675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 412681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412693 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(412708), // Rule ID 1901 //
     /* 412698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412701 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 412701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 412706 */     GIR_RootConstrainSelectedInstOperands,
     /* 412707 */     // GIR_Coverage, 1901,
     /* 412707 */     GIR_Done,
     /* 412708 */   // Label 8687: @412708
     /* 412708 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(412723), // Rule ID 5470 //
     /* 412713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412716 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 412716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 412721 */     GIR_RootConstrainSelectedInstOperands,
     /* 412722 */     // GIR_Coverage, 5470,
     /* 412722 */     GIR_Done,
     /* 412723 */   // Label 8688: @412723
     /* 412723 */   GIM_Reject,
     /* 412724 */ // Label 8686: @412724
     /* 412724 */ GIM_Reject,
     /* 412725 */ // Label 8660: @412725
     /* 412725 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(412758), // Rule ID 1899 //
     /* 412730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 412739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412751 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 412751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 412756 */   GIR_RootConstrainSelectedInstOperands,
     /* 412757 */   // GIR_Coverage, 1899,
     /* 412757 */   GIR_Done,
     /* 412758 */ // Label 8689: @412758
     /* 412758 */ GIM_Reject,
     /* 412759 */ // Label 8661: @412759
     /* 412759 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(412784), // Rule ID 3348 //
     /* 412764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 412770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 412773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412777 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 412777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 412782 */   GIR_RootConstrainSelectedInstOperands,
     /* 412783 */   // GIR_Coverage, 3348,
     /* 412783 */   GIR_Done,
     /* 412784 */ // Label 8690: @412784
     /* 412784 */ GIM_Reject,
     /* 412785 */ // Label 8662: @412785
     /* 412785 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(412810), // Rule ID 2879 //
     /* 412790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 412796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 412799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412803 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 412803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 412808 */   GIR_RootConstrainSelectedInstOperands,
     /* 412809 */   // GIR_Coverage, 2879,
     /* 412809 */   GIR_Done,
     /* 412810 */ // Label 8691: @412810
     /* 412810 */ GIM_Reject,
     /* 412811 */ // Label 8663: @412811
     /* 412811 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(412836), // Rule ID 2880 //
     /* 412816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 412822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 412825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412829 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 412829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 412834 */   GIR_RootConstrainSelectedInstOperands,
     /* 412835 */   // GIR_Coverage, 2880,
     /* 412835 */   GIR_Done,
     /* 412836 */ // Label 8692: @412836
     /* 412836 */ GIM_Reject,
     /* 412837 */ // Label 8664: @412837
     /* 412837 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(412883),
     /* 412842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 412845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 412848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412852 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(412867), // Rule ID 2875 //
     /* 412857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412860 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 412860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 412865 */     GIR_RootConstrainSelectedInstOperands,
     /* 412866 */     // GIR_Coverage, 2875,
     /* 412866 */     GIR_Done,
     /* 412867 */   // Label 8694: @412867
     /* 412867 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(412882), // Rule ID 2881 //
     /* 412872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412875 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 412875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 412880 */     GIR_RootConstrainSelectedInstOperands,
     /* 412881 */     // GIR_Coverage, 2881,
     /* 412881 */     GIR_Done,
     /* 412882 */   // Label 8695: @412882
     /* 412882 */   GIM_Reject,
     /* 412883 */ // Label 8693: @412883
     /* 412883 */ GIM_Reject,
     /* 412884 */ // Label 8665: @412884
     /* 412884 */ GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(412909), // Rule ID 3347 //
     /* 412889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 412895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 412898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412902 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 412902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 412907 */   GIR_RootConstrainSelectedInstOperands,
     /* 412908 */   // GIR_Coverage, 3347,
     /* 412908 */   GIR_Done,
     /* 412909 */ // Label 8696: @412909
     /* 412909 */ GIM_Reject,
     /* 412910 */ // Label 8666: @412910
     /* 412910 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(412935), // Rule ID 2877 //
     /* 412915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 412921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 412924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412928 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 412928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 412933 */   GIR_RootConstrainSelectedInstOperands,
     /* 412934 */   // GIR_Coverage, 2877,
     /* 412934 */   GIR_Done,
     /* 412935 */ // Label 8697: @412935
     /* 412935 */ GIM_Reject,
     /* 412936 */ // Label 8667: @412936
     /* 412936 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(412982),
     /* 412941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 412944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 412947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412951 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(412966), // Rule ID 2874 //
     /* 412956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412959 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 412959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 412964 */     GIR_RootConstrainSelectedInstOperands,
     /* 412965 */     // GIR_Coverage, 2874,
     /* 412965 */     GIR_Done,
     /* 412966 */   // Label 8699: @412966
     /* 412966 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(412981), // Rule ID 2878 //
     /* 412971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412974 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 412974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 412979 */     GIR_RootConstrainSelectedInstOperands,
     /* 412980 */     // GIR_Coverage, 2878,
     /* 412980 */     GIR_Done,
     /* 412981 */   // Label 8700: @412981
     /* 412981 */   GIM_Reject,
     /* 412982 */ // Label 8698: @412982
     /* 412982 */ GIM_Reject,
     /* 412983 */ // Label 8668: @412983
     /* 412983 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(413008), // Rule ID 3346 //
     /* 412988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 412994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 412997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413001 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 413001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 413006 */   GIR_RootConstrainSelectedInstOperands,
     /* 413007 */   // GIR_Coverage, 3346,
     /* 413007 */   GIR_Done,
     /* 413008 */ // Label 8701: @413008
     /* 413008 */ GIM_Reject,
     /* 413009 */ // Label 8669: @413009
     /* 413009 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(413055),
     /* 413014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 413017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413024 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(413039), // Rule ID 2873 //
     /* 413029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413032 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 413032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413037 */     GIR_RootConstrainSelectedInstOperands,
     /* 413038 */     // GIR_Coverage, 2873,
     /* 413038 */     GIR_Done,
     /* 413039 */   // Label 8703: @413039
     /* 413039 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(413054), // Rule ID 2876 //
     /* 413044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413047 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 413047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413052 */     GIR_RootConstrainSelectedInstOperands,
     /* 413053 */     // GIR_Coverage, 2876,
     /* 413053 */     GIR_Done,
     /* 413054 */   // Label 8704: @413054
     /* 413054 */   GIM_Reject,
     /* 413055 */ // Label 8702: @413055
     /* 413055 */ GIM_Reject,
     /* 413056 */ // Label 8670: @413056
     /* 413056 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(413081), // Rule ID 2398 //
     /* 413061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 413067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 413070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413074 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 413074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 413079 */   GIR_RootConstrainSelectedInstOperands,
     /* 413080 */   // GIR_Coverage, 2398,
     /* 413080 */   GIR_Done,
     /* 413081 */ // Label 8705: @413081
     /* 413081 */ GIM_Reject,
     /* 413082 */ // Label 8671: @413082
     /* 413082 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(413107), // Rule ID 2872 //
     /* 413087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 413093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413100 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 413100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 413105 */   GIR_RootConstrainSelectedInstOperands,
     /* 413106 */   // GIR_Coverage, 2872,
     /* 413106 */   GIR_Done,
     /* 413107 */ // Label 8706: @413107
     /* 413107 */ GIM_Reject,
     /* 413108 */ // Label 8672: @413108
     /* 413108 */ GIM_Reject,
     /* 413109 */ // Label 156: @413109
     /* 413109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8725*/ GIMT_Encode4(413888),
     /* 413120 */ /*GILLT_v2s32*//*Label 8707*/ GIMT_Encode4(413196),
     /* 413124 */ /*GILLT_v2s64*//*Label 8708*/ GIMT_Encode4(413251),
     /* 413128 */ /*GILLT_v4s16*//*Label 8709*/ GIMT_Encode4(413306),
     /* 413132 */ /*GILLT_v4s32*//*Label 8710*/ GIMT_Encode4(413361),
     /* 413136 */ /*GILLT_v8s8*//*Label 8711*/ GIMT_Encode4(413416),
     /* 413140 */ /*GILLT_v8s16*//*Label 8712*/ GIMT_Encode4(413450),
     /* 413144 */ /*GILLT_v16s8*//*Label 8713*/ GIMT_Encode4(413505), GIMT_Encode4(0),
     /* 413152 */ /*GILLT_nxv2s1*//*Label 8714*/ GIMT_Encode4(413539),
     /* 413156 */ /*GILLT_nxv2s16*//*Label 8715*/ GIMT_Encode4(413565),
     /* 413160 */ /*GILLT_nxv2s32*//*Label 8716*/ GIMT_Encode4(413591),
     /* 413164 */ /*GILLT_nxv2s64*//*Label 8717*/ GIMT_Encode4(413617),
     /* 413168 */ /*GILLT_nxv4s1*//*Label 8718*/ GIMT_Encode4(413664),
     /* 413172 */ /*GILLT_nxv4s16*//*Label 8719*/ GIMT_Encode4(413690),
     /* 413176 */ /*GILLT_nxv4s32*//*Label 8720*/ GIMT_Encode4(413716),
     /* 413180 */ /*GILLT_nxv8s1*//*Label 8721*/ GIMT_Encode4(413763),
     /* 413184 */ /*GILLT_nxv8s16*//*Label 8722*/ GIMT_Encode4(413789),
     /* 413188 */ /*GILLT_nxv16s1*//*Label 8723*/ GIMT_Encode4(413836),
     /* 413192 */ /*GILLT_nxv16s8*//*Label 8724*/ GIMT_Encode4(413862),
     /* 413196 */ // Label 8707: @413196
     /* 413196 */ GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(413250),
     /* 413201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413219 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(413234), // Rule ID 1909 //
     /* 413224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413227 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 413227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 413232 */     GIR_RootConstrainSelectedInstOperands,
     /* 413233 */     // GIR_Coverage, 1909,
     /* 413233 */     GIR_Done,
     /* 413234 */   // Label 8727: @413234
     /* 413234 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(413249), // Rule ID 5476 //
     /* 413239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413242 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 413247 */     GIR_RootConstrainSelectedInstOperands,
     /* 413248 */     // GIR_Coverage, 5476,
     /* 413248 */     GIR_Done,
     /* 413249 */   // Label 8728: @413249
     /* 413249 */   GIM_Reject,
     /* 413250 */ // Label 8726: @413250
     /* 413250 */ GIM_Reject,
     /* 413251 */ // Label 8708: @413251
     /* 413251 */ GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(413305),
     /* 413256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413274 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(413289), // Rule ID 1911 //
     /* 413279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413282 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 413282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 413287 */     GIR_RootConstrainSelectedInstOperands,
     /* 413288 */     // GIR_Coverage, 1911,
     /* 413288 */     GIR_Done,
     /* 413289 */   // Label 8730: @413289
     /* 413289 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(413304), // Rule ID 5478 //
     /* 413294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413297 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 413302 */     GIR_RootConstrainSelectedInstOperands,
     /* 413303 */     // GIR_Coverage, 5478,
     /* 413303 */     GIR_Done,
     /* 413304 */   // Label 8731: @413304
     /* 413304 */   GIM_Reject,
     /* 413305 */ // Label 8729: @413305
     /* 413305 */ GIM_Reject,
     /* 413306 */ // Label 8709: @413306
     /* 413306 */ GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(413360),
     /* 413311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413329 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(413344), // Rule ID 1907 //
     /* 413334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413337 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 413342 */     GIR_RootConstrainSelectedInstOperands,
     /* 413343 */     // GIR_Coverage, 1907,
     /* 413343 */     GIR_Done,
     /* 413344 */   // Label 8733: @413344
     /* 413344 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(413359), // Rule ID 5474 //
     /* 413349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413352 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 413357 */     GIR_RootConstrainSelectedInstOperands,
     /* 413358 */     // GIR_Coverage, 5474,
     /* 413358 */     GIR_Done,
     /* 413359 */   // Label 8734: @413359
     /* 413359 */   GIM_Reject,
     /* 413360 */ // Label 8732: @413360
     /* 413360 */ GIM_Reject,
     /* 413361 */ // Label 8710: @413361
     /* 413361 */ GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(413415),
     /* 413366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413384 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(413399), // Rule ID 1910 //
     /* 413389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413392 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 413397 */     GIR_RootConstrainSelectedInstOperands,
     /* 413398 */     // GIR_Coverage, 1910,
     /* 413398 */     GIR_Done,
     /* 413399 */   // Label 8736: @413399
     /* 413399 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(413414), // Rule ID 5477 //
     /* 413404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413407 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 413407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 413412 */     GIR_RootConstrainSelectedInstOperands,
     /* 413413 */     // GIR_Coverage, 5477,
     /* 413413 */     GIR_Done,
     /* 413414 */   // Label 8737: @413414
     /* 413414 */   GIM_Reject,
     /* 413415 */ // Label 8735: @413415
     /* 413415 */ GIM_Reject,
     /* 413416 */ // Label 8711: @413416
     /* 413416 */ GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(413449), // Rule ID 1905 //
     /* 413421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413442 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 413447 */   GIR_RootConstrainSelectedInstOperands,
     /* 413448 */   // GIR_Coverage, 1905,
     /* 413448 */   GIR_Done,
     /* 413449 */ // Label 8738: @413449
     /* 413449 */ GIM_Reject,
     /* 413450 */ // Label 8712: @413450
     /* 413450 */ GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(413504),
     /* 413455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413473 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(413488), // Rule ID 1908 //
     /* 413478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413481 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 413486 */     GIR_RootConstrainSelectedInstOperands,
     /* 413487 */     // GIR_Coverage, 1908,
     /* 413487 */     GIR_Done,
     /* 413488 */   // Label 8740: @413488
     /* 413488 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(413503), // Rule ID 5475 //
     /* 413493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413496 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 413501 */     GIR_RootConstrainSelectedInstOperands,
     /* 413502 */     // GIR_Coverage, 5475,
     /* 413502 */     GIR_Done,
     /* 413503 */   // Label 8741: @413503
     /* 413503 */   GIM_Reject,
     /* 413504 */ // Label 8739: @413504
     /* 413504 */ GIM_Reject,
     /* 413505 */ // Label 8713: @413505
     /* 413505 */ GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(413538), // Rule ID 1906 //
     /* 413510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413531 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 413536 */   GIR_RootConstrainSelectedInstOperands,
     /* 413537 */   // GIR_Coverage, 1906,
     /* 413537 */   GIR_Done,
     /* 413538 */ // Label 8742: @413538
     /* 413538 */ GIM_Reject,
     /* 413539 */ // Label 8714: @413539
     /* 413539 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(413564), // Rule ID 8903 //
     /* 413544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413557 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 413562 */   GIR_RootConstrainSelectedInstOperands,
     /* 413563 */   // GIR_Coverage, 8903,
     /* 413563 */   GIR_Done,
     /* 413564 */ // Label 8743: @413564
     /* 413564 */ GIM_Reject,
     /* 413565 */ // Label 8715: @413565
     /* 413565 */ GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(413590), // Rule ID 8858 //
     /* 413570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 413576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 413579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413583 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 413583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413588 */   GIR_RootConstrainSelectedInstOperands,
     /* 413589 */   // GIR_Coverage, 8858,
     /* 413589 */   GIR_Done,
     /* 413590 */ // Label 8744: @413590
     /* 413590 */ GIM_Reject,
     /* 413591 */ // Label 8716: @413591
     /* 413591 */ GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(413616), // Rule ID 8859 //
     /* 413596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 413602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 413605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413609 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 413609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413614 */   GIR_RootConstrainSelectedInstOperands,
     /* 413615 */   // GIR_Coverage, 8859,
     /* 413615 */   GIR_Done,
     /* 413616 */ // Label 8745: @413616
     /* 413616 */ GIM_Reject,
     /* 413617 */ // Label 8717: @413617
     /* 413617 */ GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(413663),
     /* 413622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 413628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413632 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(413647), // Rule ID 8854 //
     /* 413637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413640 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 413640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413645 */     GIR_RootConstrainSelectedInstOperands,
     /* 413646 */     // GIR_Coverage, 8854,
     /* 413646 */     GIR_Done,
     /* 413647 */   // Label 8747: @413647
     /* 413647 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(413662), // Rule ID 8860 //
     /* 413652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413655 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 413655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413660 */     GIR_RootConstrainSelectedInstOperands,
     /* 413661 */     // GIR_Coverage, 8860,
     /* 413661 */     GIR_Done,
     /* 413662 */   // Label 8748: @413662
     /* 413662 */   GIM_Reject,
     /* 413663 */ // Label 8746: @413663
     /* 413663 */ GIM_Reject,
     /* 413664 */ // Label 8718: @413664
     /* 413664 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(413689), // Rule ID 8902 //
     /* 413669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 413675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 413678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413682 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 413682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 413687 */   GIR_RootConstrainSelectedInstOperands,
     /* 413688 */   // GIR_Coverage, 8902,
     /* 413688 */   GIR_Done,
     /* 413689 */ // Label 8749: @413689
     /* 413689 */ GIM_Reject,
     /* 413690 */ // Label 8719: @413690
     /* 413690 */ GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(413715), // Rule ID 8856 //
     /* 413695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 413701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 413704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413708 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 413708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 413713 */   GIR_RootConstrainSelectedInstOperands,
     /* 413714 */   // GIR_Coverage, 8856,
     /* 413714 */   GIR_Done,
     /* 413715 */ // Label 8750: @413715
     /* 413715 */ GIM_Reject,
     /* 413716 */ // Label 8720: @413716
     /* 413716 */ GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(413762),
     /* 413721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 413727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413731 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(413746), // Rule ID 8853 //
     /* 413736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413739 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 413739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 413744 */     GIR_RootConstrainSelectedInstOperands,
     /* 413745 */     // GIR_Coverage, 8853,
     /* 413745 */     GIR_Done,
     /* 413746 */   // Label 8752: @413746
     /* 413746 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(413761), // Rule ID 8857 //
     /* 413751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413754 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 413754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 413759 */     GIR_RootConstrainSelectedInstOperands,
     /* 413760 */     // GIR_Coverage, 8857,
     /* 413760 */     GIR_Done,
     /* 413761 */   // Label 8753: @413761
     /* 413761 */   GIM_Reject,
     /* 413762 */ // Label 8751: @413762
     /* 413762 */ GIM_Reject,
     /* 413763 */ // Label 8721: @413763
     /* 413763 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(413788), // Rule ID 8901 //
     /* 413768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 413774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 413777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413781 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 413781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 413786 */   GIR_RootConstrainSelectedInstOperands,
     /* 413787 */   // GIR_Coverage, 8901,
     /* 413787 */   GIR_Done,
     /* 413788 */ // Label 8754: @413788
     /* 413788 */ GIM_Reject,
     /* 413789 */ // Label 8722: @413789
     /* 413789 */ GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(413835),
     /* 413794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 413797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413804 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(413819), // Rule ID 8852 //
     /* 413809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413812 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 413812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 413817 */     GIR_RootConstrainSelectedInstOperands,
     /* 413818 */     // GIR_Coverage, 8852,
     /* 413818 */     GIR_Done,
     /* 413819 */   // Label 8756: @413819
     /* 413819 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(413834), // Rule ID 8855 //
     /* 413824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413827 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 413827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 413832 */     GIR_RootConstrainSelectedInstOperands,
     /* 413833 */     // GIR_Coverage, 8855,
     /* 413833 */     GIR_Done,
     /* 413834 */   // Label 8757: @413834
     /* 413834 */   GIM_Reject,
     /* 413835 */ // Label 8755: @413835
     /* 413835 */ GIM_Reject,
     /* 413836 */ // Label 8723: @413836
     /* 413836 */ GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(413861), // Rule ID 2402 //
     /* 413841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 413847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 413850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413854 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 413854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 413859 */   GIR_RootConstrainSelectedInstOperands,
     /* 413860 */   // GIR_Coverage, 2402,
     /* 413860 */   GIR_Done,
     /* 413861 */ // Label 8758: @413861
     /* 413861 */ GIM_Reject,
     /* 413862 */ // Label 8724: @413862
     /* 413862 */ GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(413887), // Rule ID 8851 //
     /* 413867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 413873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413880 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 413880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 413885 */   GIR_RootConstrainSelectedInstOperands,
     /* 413886 */   // GIR_Coverage, 8851,
     /* 413886 */   GIR_Done,
     /* 413887 */ // Label 8759: @413887
     /* 413887 */ GIM_Reject,
     /* 413888 */ // Label 8725: @413888
     /* 413888 */ GIM_Reject,
     /* 413889 */ // Label 157: @413889
     /* 413889 */ GIM_Reject,
     /* 413890 */ }; // Size: 413890 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
